// DrawDoc.cpp : implementation of the CDrawDoc class
//

#include "stdafx.h"
#include "Draw.h"

#include <time.h>
#include <sys/timeb.h>
#include "DrawDoc.h"
#include "DrawView.h"
#include "TreeViewObj.h"
#include "DrawObj.h"
#include "CntrItem.h"



#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
/////////////////////////////////////////////////////////////////////////////
// CDrawDoc
IMPLEMENT_DYNCREATE(CDrawDoc, COleDocument)

BEGIN_MESSAGE_MAP(CDrawDoc, COleDocument)
	//{{AFX_MSG_MAP(CDrawDoc)
	ON_COMMAND(ID_GDDBASE, OnGddbase)
	ON_COMMAND(ID_EDIT_UNDO, OnEditUndo)
	ON_UPDATE_COMMAND_UI(ID_EDIT_UNDO, OnUpdateEditUndo)
	//}}AFX_MSG_MAP
	// Enable default OLE container implementation
	ON_UPDATE_COMMAND_UI(ID_EDIT_PASTE, COleDocument::OnUpdatePasteMenu)
	ON_UPDATE_COMMAND_UI(ID_EDIT_PASTE_LINK, COleDocument::OnUpdatePasteLinkMenu)
	ON_UPDATE_COMMAND_UI(ID_OLE_EDIT_CONVERT, COleDocument::OnUpdateObjectVerbMenu)
	ON_COMMAND(ID_OLE_EDIT_CONVERT, COleDocument::OnEditConvert)
	ON_UPDATE_COMMAND_UI(ID_OLE_EDIT_LINKS, COleDocument::OnUpdateEditLinksMenu)
	ON_COMMAND(ID_OLE_EDIT_LINKS, COleDocument::OnEditLinks)
	ON_UPDATE_COMMAND_UI_RANGE(ID_OLE_VERB_FIRST, ID_OLE_VERB_LAST, COleDocument::OnUpdateObjectVerbMenu)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDrawDoc construction/destruction

CDrawDoc::CDrawDoc()
{
	// Use OLE compound files
	EnableCompoundFile();
	icount=25425;
    ((CDrawApp*)(::AfxGetApp()))->m_pDoc=this;
	///add by hou
	Font.CreateFont(-15,10,0,0,400,FALSE,FALSE,0,ANSI_CHARSET,
		OUT_DEFAULT_PRECIS,CLIP_DEFAULT_PRECIS,DEFAULT_QUALITY,
		DEFAULT_PITCH,"Courier New");
	Font1.CreateFont(-15,10,0,0,400,FALSE,FALSE,0,ANSI_CHARSET,
		OUT_DEFAULT_PRECIS,CLIP_DEFAULT_PRECIS,DEFAULT_QUALITY,
		DEFAULT_PITCH,"Symbol");
	// TODO: add one-time construction code here
	m_nMapMode = MM_ANISOTROPIC;
	m_paperColor = RGB(255, 255, 255);
#if !defined(_MAC)
	m_pSummInfo = NULL;
#endif
	ComputePageSize();	
}

CDrawDoc::~CDrawDoc()
{
	POSITION pos1,pos2;
	CDrawObj* pObj;
    for( pos1 = m_objects.GetHeadPosition(); ( pos2 = pos1 ) != NULL; )
    {
           m_objects.GetNext(pos1);   
           pObj = m_objects.GetAt( pos2 ); 
           m_objects.RemoveAt( pos2 );
           delete pObj;
    }	
#if !defined(_MAC)
	delete m_pSummInfo;
#endif
}

BOOL CDrawDoc::OnNewDocument()
{
	if (!COleDocument::OnNewDocument())
		return FALSE;

		// reinitialization code 
	// (SDI documents will reuse this document)
#if !defined(_MAC)
	if(m_pSummInfo != NULL)
		delete m_pSummInfo;
	m_pSummInfo = new CSummInfo;
	// Title, Subject, Author, Keywords default to empty string
	// Comments, Template, SavedBy default to empty string
	// LastSave, LastPrint, EditTime, RevNum default to 0
	m_pSummInfo->StartEditTimeCount();
	m_pSummInfo->RecordCreateDate();
	m_pSummInfo->SetNumPages(1);
	// NumWords, NumChars default to 0
	m_pSummInfo->SetAppname( _T("Draw") );
	// Security defaults to 0 
#endif
	return TRUE;
}

///*************************************************///
void CDrawDoc::ComputePageSize()
{
	CSize new_size(850, 1100);  // 8.5" x 11" default

	CPrintDialog dlg(FALSE);
	if (AfxGetApp()->GetPrinterDeviceDefaults(&dlg.m_pd))
	{
		// GetPrinterDC returns a HDC so attach it
		CDC dc;
		HDC hDC= dlg.CreatePrinterDC();
		ASSERT(hDC != NULL);
		dc.Attach(hDC);

		// Get the size of the page in loenglish
		new_size.cx = MulDiv(dc.GetDeviceCaps(HORZSIZE), 1000, 254);
		new_size.cy = MulDiv(dc.GetDeviceCaps(VERTSIZE), 1000, 254);
	}

	// if size changed then iterate over views and reset
	if (new_size != m_size)
	{
		m_size = new_size;
		POSITION pos = GetFirstViewPosition();
		while (pos != NULL)
			((CDrawView*)GetNextView(pos))->SetPageSize(m_size);
	}
}


/////////////////////////////////////////////////////////////////////////////
// CDrawDoc serialization

void CDrawDoc::Serialize(CArchive& ar)
{
	if (ar.IsStoring())
	{
		POSITION pos;
		CDrawObj *pObj;	
		pos = m_objects.GetHeadPosition();
	    int i=0;
	    while (pos != NULL)
		{
		    i++;
		    pObj = m_objects.GetNext(pos);
            if(pObj!=NULL&&pObj->type==G_POINT)
			{
		        pObj->m_serialno[0]=i;
			}
		    else if(pObj!=NULL&&pObj->type==G_LINE)
			{
		        pObj->m_serialno[0]=((CMyLine*)pObj)->my_startpoint->m_serialno[0];
                pObj->m_serialno[1]=((CMyLine*)pObj)->my_endpoint->m_serialno[0];

			}
			else if(pObj!=NULL&&pObj->type==G_CIRCLE)
			{
			    pObj->m_serialno[0]=((CMyCircle*)pObj)->my_startpoint->m_serialno[0];
				pObj->m_serialno[1]=((CMyCircle*)pObj)->my_startpoint->m_serialno[1];
			}
		}		
		ar << m_paperColor;		
		m_objects.Serialize(ar);		
		m_ObjDriveList.Serialize(ar);
		m_LocusList.Serialize(ar);
		m_RelationList.Serialize(ar);
		r_CO.Serialize(ar);
		ar<<m_size;	
		
#if !defined(_MAC)
		m_pSummInfo->WriteToStorage(m_lpRootStg);
#endif
	}
	else
	{
		ar >> m_paperColor;		
		m_objects.Serialize(ar);		
		m_ObjDriveList.Serialize(ar);
		m_LocusList.Serialize(ar);
		m_RelationList.Serialize(ar);
		r_CO.Serialize(ar);
		ar>>m_size;	
		/////////////////////////////////////
		POSITION pos,pos1,pos2;
		RELATION *rel;
		CDrawObj*pObj,*pObj1;
		int ii(0);
         
		m_RelationList.RemoveAll();
		pos=m_objects.GetHeadPosition();
		while(pos!=NULL)
		{
		    pObj=m_objects.GetNext(pos);
			pos1=pObj->Nlink.GetHeadPosition();
			while(pos1!=NULL)
			{
			    rel=pObj->Nlink.GetNext(pos1);
                rel->pObjList.RemoveAll();
				for(ii=0;ii<4;ii++)
				{
				    if(rel->m_listindex[ii]>=0)
					{
					   pos2=m_objects.GetHeadPosition();
					   while(pos2!=NULL)
					   {
					      pObj1=m_objects.GetNext(pos2);
						  if(pObj1->m_listindex==rel->m_listindex[ii])
						  {
						      rel->pObjList.AddTail(pObj1);
							  break;
						  }
					   }
					}
				}
               if(m_RelationList.Find(rel)==NULL)
    				m_RelationList.AddTail(rel);
			}
			pos1=pObj->NlinkB.GetHeadPosition();
			while(pos1!=NULL)
			{
			    rel=pObj->NlinkB.GetNext(pos1);
				rel->pObjList.RemoveAll();
				for(ii=0;ii<4;ii++)
				{
				    if(rel->m_listindex[ii]>=0)
					{
					   pos2=m_objects.GetHeadPosition();
					   while(pos2!=NULL)
					   {
					      pObj1=m_objects.GetNext(pos2);
						  if(pObj1->m_listindex==rel->m_listindex[ii])
						  {
						      rel->pObjList.AddTail(pObj1);
							  break;
						  }
					   }
					}
				}
			}
		}
///////////////////////////////////////////////////
		
#if !defined(_MAC)
		m_pSummInfo->ReadFromStorage(m_lpRootStg);
#endif
	}

	// By calling the base class COleDocument, we enable serialization
	//  of the container document's COleClientItem objects automatically.
	COleDocument::Serialize(ar);
}

/////////////////////////////////////////////////////////////////////////////
// CDrawDoc diagnostics

#ifdef _DEBUG
void CDrawDoc::AssertValid() const
{
	COleDocument::AssertValid();
}

void CDrawDoc::Dump(CDumpContext& dc) const
{
	COleDocument::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CDrawDoc commands
///qlin have add code in this place///
void CDrawDoc::Add(CDrawObj* pObj)
{
	///˴ơ
    ///һ㣬СУһֳ
	///////////////////////////////////////////////////
	int iTemp;
	CString sTemp;
    iTemp=0;
	for(iTemp=0;iTemp<m_objects.GetCount()+1;iTemp++)
	{
	    switch (pObj->type)
		{
		    case 1:
		        sTemp.Format("P%d",iTemp);
				break;
			case 2:
				sTemp.Format("L%d",iTemp);
				break;
			case 3:
				sTemp.Format("C%d",iTemp);
				break;           
		}
		int iJudge(0);
		POSITION Gaop=m_objects.GetHeadPosition();
        while(Gaop!=NULL)
		{
            CDrawObj*ppObj=m_objects.GetNext(Gaop);
			if(sTemp==ppObj->sName)
				iJudge=1;
		}
		if(iJudge==0)
		{
			pObj->sName=sTemp;
		    break;
		}
	}   
	///////////////////////////////////////////////////
	m_objects.AddTail(pObj);
	pObj->m_Document = this;
	SetModifiedFlag();
	pObj->m_listindex=m_objects.GetCount()-1;
}
CDrawObj* CDrawDoc::ObjectAt(const CPoint& point)
{
	CDrawObj* pObjPoint=PointObjectAt(point);
    if(NULL == pObjPoint)
	{
	    CRect rect(point, CSize(1, 1));
	    POSITION pos = m_objects.GetHeadPosition();
	    while (pos != NULL)
		{
		    CDrawObj* pObj = m_objects.GetNext(pos);
		    if (pObj->Intersects(rect))
			    return pObj;
		}

	    return NULL;
	}
	return pObjPoint;
}
CDrawObj* CDrawDoc::PointObjectAt(const CPoint& point)
{
	CRect rect(point, CSize(1, 1));
	POSITION pos = m_objects.GetHeadPosition();//should be tail
	while (pos != NULL)
	{
		CDrawObj* pObj = m_objects.GetNext(pos);
		if(pObj->type==G_POINT)
		{
			if(((CMyPoint* )pObj)->MyIntersects(rect))
			{  
				return pObj;				
			}
		}
	}
	///by qlin begin in 2001/9/5/...ҪԵֱཻ
	pos=m_objects.GetHeadPosition();
	while(pos!=NULL)
	{
	    CDrawObj*pObj=m_objects.GetNext(pos);
		if(pObj->type==G_LINE)
		{
			if(((CMyLine*)pObj)->Intersects(rect))
			{
				return pObj;
			}
		}
	}
	pos=m_objects.GetHeadPosition();
	while(pos!=NULL)
	{
	    CDrawObj*pObj=m_objects.GetNext(pos);
		if(pObj->type==G_CIRCLE)
		{
			if(((CMyCircle*)pObj)->Intersects(rect))
			{
				return pObj;
			}
		}
	}
    ///by qlin end.
	return NULL;
}

///úǴ϶һֱߵһ㣬һߣһԲϣ
CDrawObj*CDrawDoc::LineObjectAt(const CPoint&point,CDrawObj*pObj2,CDrawObj*pObj3)
{
	CDrawObj *pObj;
	POSITION pos;
    int a(0);

    CRect rect(point, CSize(1, 1));
	pos = m_objects.GetHeadPosition();//should be tail	
	while (pos != NULL)
	{
	    pObj = m_objects.GetNext(pos);
		if ((pObj->type==G_POINT)&&((CMyPoint* )pObj)->MyIntersects(rect))
		{  
			if(pObj->m_listindex!=pObj2->m_listindex)
			{
				a=1;
			    return pObj;
			}				
		}
	}
	///by qlin begin in 2001/9/5/...ҪԵֱཻ
	pos=m_objects.GetHeadPosition();
	while(pos!=NULL)
	{
	    pObj=m_objects.GetNext(pos);
		if((pObj->type==G_LINE)&&((CMyLine*)pObj)->Intersects(rect))
		{
			if(pObj->m_listindex!=pObj3->m_listindex)
			{
				a=2;
			    return pObj;
			}
			
		}
	}
    ///by qlin end.
	if(a==0)
		return pObj2;
	return NULL;
}
void CDrawDoc::Draw(CDC* pDC, CDrawView* pView)
{
	POSITION pos = m_objects.GetHeadPosition();
	while (pos != NULL)
	{
		CDrawObj* pObj = m_objects.GetNext(pos);
		///////////////////////////////////////////////////////
		/*if(pObj->type==G_POINT)
		{            
			switch (((CMyPoint*) pObj)->ptype)
			{
				///ptype=:һֱֱߵĽ㣬ʾֱϰɵ㣬ʾƽֱϵ㣬
			    ///	Ĵֱֱϵ㣬ֱе㡣㡣
	            case 0:
					{}
					break;
	            case 1:
					{					
						pView->Intersection1(((CMyPoint*) pObj)->m_conect1,
												 ((CMyPoint*) pObj)->m_conect2);
						if(pView->m_intersection!=NULL)				
						{
							((CMyPoint*) pObj)->m_startpoint=*(pView->intersection);
						}
					}
					break;

	            case 2:
					{
						((CMyPoint*) pObj)->m_startpoint
						=((CMyPoint*) pObj)->m_conect1->getPointByScale(((CMyPoint*) pObj)->m_scale);
					}
					break;
	            case 3:
					{
						//((CMyPoint*) pObj)->m_conect1->ChangeDirectionOn(((CMyPoint*) pObj)->m_conect2->getDirection());
						///////////////////////////õƽʱ״̬///////////////////////
						((CMyPoint*) pObj)->m_startpoint
						=((CMyPoint*) pObj)->m_conect1->my_startpoint->m_startpoint
						+((CMyPoint*) pObj)->m_conect2->my_startpoint->m_startpoint
						-((CMyPoint*) pObj)->m_conect2->my_endpoint->m_startpoint;
						((CMyPoint*) pObj)->m_conectrecord->my_startpoint->m_startpoint
						=((CMyPoint*) pObj)->m_conect1->my_startpoint->m_startpoint;
						((CMyPoint*) pObj)->m_conectrecord->my_endpoint->m_startpoint
						=((CMyPoint*) pObj)->m_conect1->my_endpoint->m_startpoint;
						//////////////////õƽʱ״̬////////////////////////////////
						((CMyPoint*) pObj)->m_startpoint
						=((CMyPoint*) pObj)->m_conect1->getPointByScale(((CMyPoint*) pObj)->m_scale);
						//((CMyPoint*) pObj)->m_conectrecord=((CMyPoint*) pObj)->m_conect1;
					}
					break;
				case 4:
					{
						CPoint2 unit(0,1);
					    ((CMyPoint*) pObj)->m_startpoint
                        =((CMyPoint*) pObj)->m_conect1->my_startpoint->m_startpoint
				    	+unit*(((CMyPoint*) pObj)->m_conect2->my_startpoint->m_startpoint
				    	-((CMyPoint*) pObj)->m_conect2->my_endpoint->m_startpoint);
					    ((CMyPoint*) pObj)->m_conectrecord->my_startpoint->m_startpoint
					    =((CMyPoint*) pObj)->m_conect1->my_startpoint->m_startpoint;
                        ((CMyPoint*) pObj)->m_conectrecord->my_endpoint->m_startpoint
				    	=((CMyPoint*) pObj)->m_conect1->my_endpoint->m_startpoint;
					    ((CMyPoint*) pObj)->m_startpoint
				    	=((CMyPoint*) pObj)->m_conect1->getPointByScale(((CMyPoint*) pObj)->m_scale);
					}
					break;
				case 5:///Ϊһֱߵе㡣					
                    ((CMyPoint*) pObj)->m_startpoint
					=((CMyPoint*) pObj)->m_conect1->getPointByScale(0.5);					
					break;
				case 6:
                    {
						CPoint2 temp1,temp2;
					    temp1=((CMyPoint*) pObj)->m_conect1->my_startpoint->m_startpoint;
					    temp2=((CMyPoint*) pObj)->m_conect2->my_startpoint->m_startpoint;
					    CPoint2 * footpoint=pView->Intersection_Paral_Verti(temp2,((CMyPoint*) pObj)->m_conect2,temp1, ((CMyPoint*) pObj)->m_conect2,6);
					    ((CMyPoint*) pObj)->m_startpoint=(*footpoint);
					}
					break;
				case 7:
					break;
				case 8:
					break;
			}
		}
		*/
		/////////////////////õԿõm_position/////////////////////////////////
        if((pObj->m_listindex>=0)&&(pObj->m_listindex<m_objects.GetCount()+5))
		{
           pObj->m_Document=this;
		   pObj->Draw(pDC);
		   if (pView->m_bActive && !pDC->IsPrinting() && pView->IsSelected(pObj))
		    	pObj->DrawTracker(pDC, CDrawObj::selected);
		}
		
	}
}
void CDrawDoc::Remove(CDrawObj* pObj)
{
	// Find and remove from document
	int ijudge=pObj->m_listindex;///get the listindex of the deleted obj;
	POSITION pos = m_objects.Find(pObj);
	if (pos != NULL)
		m_objects.RemoveAt(pos);
	// set document modified flag
	SetModifiedFlag();

	// call remove for each view so that the view can remove from m_selection
	pos = GetFirstViewPosition();
	while (pos != NULL)
		((CDrawView*)GetNextView(pos))->Remove(pObj);
	///delete one Obj from the list,
	pos=m_objects.GetHeadPosition();
	while(pos!=NULL)
	{
	    CDrawObj*ptempObj=m_objects.GetNext(pos);
		if(ptempObj->m_listindex>ijudge)
			ptempObj->m_listindex--;
		POSITION ppos=ptempObj->Nlink.GetHeadPosition();
		while(ppos!=NULL)
		{
		   RELATION*rel=ptempObj->Nlink.GetNext(ppos);
		   if(rel->Nserialno>ijudge)
			   rel->Nserialno--;
		}
	}
}
CDrawObj* CDrawDoc::FindPoint(int Index)
{
    POSITION pos = m_objects.GetHeadPosition();
	while (pos != NULL)
	{	
		m_pDrawObj = m_objects.GetNext(pos);
		if(m_pDrawObj!=NULL&&(m_pDrawObj->m_serialno[0]!=-1)
		   &&m_pDrawObj->IsKindOf( RUNTIME_CLASS(CMyPoint)))
		{
		    if( m_pDrawObj->m_serialno[0] == Index)
			{
			    return m_pDrawObj;
			}
		}
	}
	return NULL;
}

BOOL CDrawDoc::OnOpenDocument(LPCTSTR lpszPathName)
{
#if !defined(_MAC)
	if( m_pSummInfo != NULL)
		delete m_pSummInfo;	
	m_pSummInfo = new CSummInfo;
	m_pSummInfo->StartEditTimeCount();
#endif
	//CDrawTool::c_drawShape = selection;
	return COleDocument::OnOpenDocument(lpszPathName);
}

BOOL CDrawDoc::OnSaveDocument(LPCTSTR lpszPathName)
{
#if !defined(_MAC)
	m_pSummInfo->RecordSaveDate();
	m_pSummInfo->IncrRevNum();
	m_pSummInfo->SetLastAuthor(m_pSummInfo->GetAuthor());
	m_pSummInfo->AddCountToEditTime();
	m_pSummInfo->StartEditTimeCount();
#endif
	return COleDocument::OnSaveDocument(lpszPathName);
}
///ǽӵݿ
extern dbase thedbase;
void CDrawDoc::Add_db0()
{

}
///ĺݿǷиֱߣûеĻֱ߼ӵݿС
db_line* CDrawDoc::FindLine(CMyLine * line)
{
 db_line *ln;

  ln=thedbase.all_ln.nx;
  while(ln!=NULL)
	 { if(ln->ln == line)
	      return ln;
		ln = ln->nx;
		}
  ln = new db_line();
  ln->ln = line;
  thedbase.last_ln->nx = ln;  
  thedbase.last_ln = ln;
  thedbase.new_pr(CO_COLL);
  thedbase.last_nd->u.ln=ln;
  return ln;
}

void CDrawDoc::OnGddbase() 
{
	db_midpt* midpt[20];
	db_pline* pline[20];
	db_tline* tline[20];
	db_a_cir* cir[20];
    int im(0),ip(0),it(0),ic(0);
	Gout_file=fopen("dbase.txt","w");
    POSITION pos,pos1;
    thedbase.init_dbase();
    ///Ϊ֤Ľ۸
	 CDrawObj*p1,*p2,*p3;
	 pos=r_CO.pObjList.GetHeadPosition();
	 while(pos!=NULL)
	 {
	    p1=r_CO.pObjList.GetNext(pos);
		p2=r_CO.pObjList.GetNext(pos);
		p3=r_CO.pObjList.GetNext(pos);
		thedbase.conc.pred=CO_MIDP;
	    thedbase.conc.p[0]=p2->m_listindex+10;
	    thedbase.conc.p[1]=p1->m_listindex+10;
	    thedbase.conc.p[2]=p3->m_listindex+10;
	 }
	 /////////////////////////////////////
     pos=m_objects.GetHeadPosition();
	 db_line *l1;
	 while(pos!=NULL)
	 {
	     CDrawObj* pobj=m_objects.GetNext(pos);
		 switch(pobj->type)
		 {
		 case G_POINT:   ///ڵ㣬Ȳ
			 {
			     db_line *ln = FindLine((CMyLine*)pobj);			  
			     pos1=pobj->Nlink.GetHeadPosition();
			     while(pos1!=NULL)
				 {
			         RELATION *rel=pobj->Nlink.GetNext(pos1);
					 if(rel->pObjList.GetCount()==3)
					 {
					     POSITION ppp=rel->pObjList.GetHeadPosition();
				         while(ppp!=NULL)
						 {
						     CDrawObj*ptempObj=rel->pObjList.GetNext(ppp);
					         CDrawObj*ptempObj1=rel->pObjList.GetNext(ppp);
							 CDrawObj*ptempObj2=rel->pObjList.GetNext(ppp);
							 if((rel->Nconstraintype==SS_DIS)&&(rel->N_dis_clamp==1)&&(ptempObj->type==G_POINT))
							 {
								 if(pobj->m_listindex==ptempObj1->m_listindex)
								 {
									  db_midpt *pl1=new db_midpt;
									  thedbase.last_md->nx=pl1;  
									  thedbase.last_md = pl1;
									  pl1->m=ptempObj1->m_listindex+10;
									  pl1->a=ptempObj->m_listindex+10;
									  pl1->b=ptempObj2->m_listindex+10;								 
									  thedbase.new_pr(CO_MIDP); thedbase.last_nd->u.md=pl1;
									  midpt[im]=pl1;
									  im++;
								 }
							 }
						 }
					 }					
				 }		 
			 }			 
			 break;
		 case G_LINE:
			 {
			     db_line *ln = FindLine((CMyLine*)pobj);			  
			     pos1=pobj->Nlink.GetHeadPosition();
			     while(pos1!=NULL)
				 {
			         RELATION *rel=pobj->Nlink.GetNext(pos1);
				     POSITION ppp=rel->pObjList.GetHeadPosition();
				     while(ppp!=NULL)
					 {
				         CDrawObj*ptempObj=rel->pObjList.GetNext(ppp);
					     if((ptempObj!=pobj)&&(ptempObj->type==G_POINT))
						 {
					        ln->add_pt(ptempObj->m_listindex+10);
						  	   break;
						 }
					     else if((ptempObj!=pobj)&&(ptempObj->type==G_LINE))
						 {
					         l1=FindLine((CMyLine*)ptempObj);
						     if((rel->Nconstraintype==LL_PARA)&&(ptempObj->m_listindex<pobj->m_listindex))
							 {
								////ֱߵƽйϵ
								db_pline *pl1=new db_pline;
								thedbase.last_pn->nx=pl1;  
								thedbase.last_pn = pl1;
								pl1->no=1;
								pl1->ln[0]=l1;
								pl1->ln[1]=ln;
								thedbase.new_pr(CO_PARA); 
								thedbase.last_nd->u.pn=pl1;
								pline[ip]=pl1;
								ip++;
							 }
							 else if((rel->Nconstraintype==LL_PERP)&&(ptempObj->m_listindex<pobj->m_listindex))
							 {
							     ///ֱߵĴֱϵ
								 db_tline *pl1=new db_tline;
								 thedbase.last_tn->nx=pl1;  
								 thedbase.last_tn = pl1;
								 pl1->l1=l1;
								 pl1->l2=ln;
								 thedbase.new_pr(CO_PERP);
								 thedbase.last_nd->u.tn=pl1;
								 tline[it]=pl1;
								 it++;
							 }
							 else
							 {}
						 }
					 }
				 }
			 }
			 break;
		 case G_CIRCLE:
			 {
			     db_line *ln=FindLine((CMyLine*)pobj);
				 db_a_cir *pCir=new db_a_cir;
				 thedbase.last_cir->nx=pCir;
				 thedbase.last_cir=pCir;
				 int i(0);
				 pos1=pobj->Nlink.GetHeadPosition();
				 while(pos1!=NULL)
				 {
				     RELATION* rel=pobj->Nlink.GetNext(pos1);
					 POSITION ppp=rel->pObjList.GetHeadPosition();
					 while(ppp!=NULL)
					 {
					     CDrawObj*ptempObj=rel->pObjList.GetNext(ppp);
                         if((ptempObj!=pobj)&&(ptempObj->type==G_POINT)) 
                         {
						    l1=FindLine((CMyLine*)ptempObj);
							if((rel->Nconstraintype==PC_DIS)||(rel->Nconstraintype==PC_CEN))
							{
								if(rel->Nconstraintype==PC_CEN)
								{
								   pCir->o=ptempObj->m_listindex+10;
								}
								else if((rel->Nconstraintype==PC_DIS)&&(rel->N_dis_clamp<0.0000001))
								{
								    pCir->pt[i]=ptempObj->m_listindex+10;
									i++;
									pCir->no=i;
								}			                       				    
							}
						 }
					 }				 
				 }
				 thedbase.new_pr(CO_CYCLIC); thedbase.last_nd->u.cr=pCir;				
				 cir[ic]=pCir;
				 ic++;
			 }
		 }
	 }	 
     struct timeb e,s;    
     //////////ѭʼӡ
	 thedbase.show_all_nd(this); ///ʾֹϵ
     ftime(&s);
	 thedbase.prove_fixp(this);  ///֤ݿ 
	 ftime(&e);
     double u;
	 u= ( (e.time-s.time)*1000 + e.millitm - s.millitm ) / 1000.0;    
	 CString str,str1;
	 str.Format("%f",u);
     str1="the time is ==="+str;
	 fprintf(Gout_file,"%s",str1);
	 //gprint(str1);
     thedbase.show_dbase(this,0);///ʾݿ⡣	
	 fclose(Gout_file);
	 ///////////////////////////////
	 int i;
	 if(im>0)
	 {
		 for(i=0;i<im;i++)
		 {
			 db_midpt *p=midpt[i];
			 delete p;		 
		 }
	 }
	 if(ip>0)
	 {
		 for(i=0;i<ip;i++)
		 {
			 db_pline *p=pline[i];
			 delete p;		 
		 }
	 }
	 if(it>0)
	 {
		 for(i=0;i<it;i++)
		 {
			 db_tline *p=tline[i];
			 delete p;		 
		 }
	 }
	 if(ic>0)
	 {
		 for(i=0;i<ic;i++)
		 {
			 db_a_cir *p=cir[i];
			 delete p;		 
		 }
	 }
}

void CDrawDoc::OnEditUndo()///ȡ 
{
	// TODO: Add your command handler code here
	POSITION pos=m_objects.GetTailPosition();
	if(pos!=NULL)
	{
		///////////////////////////////////
		CDrawObj*pObjTemp=m_objects.GetAt(pos);
		POSITION pPos,pPos2,pPos3;
		pPos=m_objects.GetHeadPosition();
		while(pPos!=NULL)
		{
			  CDrawObj* pObj1=m_objects.GetNext(pPos);
			  pPos2=pObj1->NlinkB.GetHeadPosition();
			  while(pPos2!=NULL)
			  {
					pPos3=pPos2;
					RELATION*pRel=pObj1->NlinkB.GetNext(pPos2);
					int iJudge(0);
					POSITION ppp=pRel->pObjList.GetHeadPosition();
					while(ppp!=NULL)
					{
					    CDrawObj* ppObj=pRel->pObjList.GetNext(ppp);
						if(ppObj->m_listindex==pObjTemp->m_listindex)
						{
							iJudge=1;
						    break;
						}
					}
					if(iJudge==1)					
					{
						 pObj1->NlinkB.RemoveAt(pPos3);						
					}
			  }			  
			  pPos2=pObj1->Nlink.GetHeadPosition();
			  while(pPos2!=NULL)
			  {
					pPos3=pPos2;
					RELATION*pRel=pObj1->Nlink.GetNext(pPos2);
					int iJudge(0);
					POSITION ppp=pRel->pObjList.GetHeadPosition();
					while(ppp!=NULL)
					{
					    CDrawObj* ppObj=pRel->pObjList.GetNext(ppp);
						if(ppObj->m_listindex==pObjTemp->m_listindex)
						{
							iJudge=1;
						    break;
						}
					}
					if(iJudge==1)					
					{
						 pObj1->Nlink.RemoveAt(pPos3);					
					}
			  }			  
		}
		////////////////////////////////////////
		POSITION pGao1,pGao2;
		pGao1=pObjTemp->NlinkB.GetHeadPosition();
		while(pGao1!=NULL)
		{
			pGao2=pGao1;
			RELATION *pR=pObjTemp->NlinkB.GetNext(pGao1);
			pObjTemp->NlinkB.RemoveAt(pGao2);  
		}
		pGao1=pObjTemp->Nlink.GetHeadPosition();
		while(pGao1!=NULL)
		{
			pGao2=pGao1;
			RELATION *pR=pObjTemp->Nlink.GetNext(pGao1);
			pObjTemp->Nlink.RemoveAt(pGao2);  		
		}	  
		//////////////////////////////////
		POSITION pG1,pG2;
		pG1=m_RelationList.GetHeadPosition();
		while(pG1!=NULL)
		{
			pG2=pG1;
		     RELATION*rel=m_RelationList.GetNext(pG1);
			 POSITION pjjj=rel->pObjList.GetHeadPosition();
			 while(pjjj!=NULL)
			 {
			     CDrawObj*ppObj=rel->pObjList.GetNext(pjjj);
				 if(ppObj->m_listindex==pObjTemp->m_listindex)
				 {
                    m_RelationList.RemoveAt(pG2);
					delete rel;
				    break;
				 }
			 }
		}
		///////////////////////////////////
		delete m_objects.GetAt(pos);
		m_objects.RemoveAt(pos);
	}
	UpdateAllViews(0);
}


void CDrawDoc::OnUpdateEditUndo(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	pCmdUI->Enable (m_objects.GetCount());
}

///úΪҵһͨõֱߡ
///ڸֱߣظֱߵm_listindex,ڣ-1;
int CDrawDoc::FindLine(CDrawObj *pObj1, CDrawObj *pObj2)
{
 int iJudge(0),ireturn;
 POSITION pos,pos1,pos2,pos3;
 RELATION *rel,*rel2;
 pos=pObj1->Nlink.GetHeadPosition();
  while(pos!=NULL)
  {
     rel=pObj1->Nlink.GetNext(pos);
	 if((rel->Nconstraintype==PL_DIS)&&(rel->N_dis_clamp<0.000001))
	 {
	     pos1=rel->pObjList.GetHeadPosition();
         while(pos1!=NULL)
		 {
		     CDrawObj*ptempObj=rel->pObjList.GetNext(pos1);
			 if(ptempObj->type==G_LINE)
			 {
			     pos2=ptempObj->Nlink.GetHeadPosition();
				 while(pos2!=NULL)
				 {
				      rel2=ptempObj->Nlink.GetNext(pos2);
                      if((rel2->Nconstraintype==PL_DIS)&&(rel->N_dis_clamp<0.000001))
					  {
					      pos3=rel2->pObjList.GetHeadPosition();
						  while(pos3!=NULL)
						  {
						      CDrawObj *ptempObj1=rel2->pObjList.GetNext(pos3);
							  if(ptempObj1->m_listindex==pObj2->m_listindex)
                              {
							       ireturn=ptempObj->m_listindex;
								   iJudge=1;
								   break;
							  }
						  }
					  }
					  if(iJudge==1)
						  break;
				 }
			 }
			 if(iJudge==1)
				 break;
		 }
	 }
	 if(iJudge==1)
		 break;
  }
  if(iJudge==1)
  {          
  }
  else
  {
     ireturn=-1;
  }
	  return ireturn;
}
void CDrawDoc::DeleteRelation(RELATION *rel)
{
	///úҪɾһRELATIONby qlin;
	///first found the pobj,then delete his rel;
	///second from the m_RelationList,delete his rel;
   	// TODO: Add your command handler code here

	RELATION *temprel1,*temprel2;
    POSITION pos,pos1,pos2,pos3,pos4;
	CDrawObj *pObj;
	pos=rel->pObjList.GetHeadPosition();
	while(pos!=NULL)
	{
	    pObj=rel->pObjList.GetNext(pos);///get the obj who has the rel;
		///remove the pObj's Nlink and NlinkB;
		pos1=pObj->NlinkB.GetHeadPosition();
		while(pos1!=NULL)
		{
		   pos2=pos1;
		   temprel1=pObj->NlinkB.GetNext(pos1);
		   if(temprel1==rel)
		   {
		       pObj->NlinkB.RemoveAt(pos2);
			   break;
		   }
		}
		pos1=pObj->Nlink.GetHeadPosition();
		while(pos1!=NULL)
		{
		    pos2=pos1;
			temprel2=pObj->Nlink.GetNext(pos1);
			if(temprel2==rel)
			{
			     pObj->Nlink.RemoveAt(pos2);
				 break;
			}
		}
	}
    ///the second step;
    pos3=m_RelationList.GetHeadPosition();
	while(pos3!=NULL)
	{
	    pos4=pos3;
		temprel1=m_RelationList.GetNext(pos3);
		if(temprel1==rel)
		{
		    m_RelationList.RemoveAt(pos4);
			delete temprel1;
			break;
		}
	}
	UpdateAllViews(0);
}
