// #include "poly.h"
#include "db_para.h"
#include "drawobj.h"
/* the database */


typedef CMyPoint* OBJPT;
typedef CMyLine*  OBJLN;

typedef int  PT ;


#define MAX_GEO 29

#define MD  db_midpt
#define LN  db_line
#define PN  db_pline
#define TN  db_tline
#define CIR db_a_cir
#define CONG db_cong_seg
#define STRI db_sim_tri
#define CTRI db_sim_tri
#define RATIO db_ratio_seg
//#define ANG db_angle
#define ANS db_angles


#define FPT struct fpt
#define VVAL struct vval


class geom_cond;
class CDrawDoc;

//typedef geom_cond CO;
//typedef geom_cond NEWD;
//typedef geom_cond PRED;

#define CO   geom_cond
#define NEWD geom_cond
#define PRED geom_cond

#define PTY(x)  ((x->u.d)->type)
#define PLM(x)  ((x->u.d)->lemma)
#define PCO(x)  ((x->u.d)->co)
#define PNO(x)  ((x->u.d)->no)


/* the information base */
struct dumy
{ int type;
  int lemma;
  CO *co;
  int no;
};

class db_line
{
public:
  int type;
  int lemma;
  CO *co;
  int no;
  PT pt[MAX_GEO];
  OBJLN ln;
  db_line *nx;
public:
	db_line()
	{		  
		  type=1; 
		  lemma=0;
		  co=NULL;
		  no=-1;
		  nx = NULL;		  	
		  ln=NULL;
	};	
	~db_line()
	{
	    		  
	};
	
	void add_pt(PT);
};

class db_pline
{
public:
  int type;
  int lemma;
  CO *co;
  
  int no;
  db_line  *ln[MAX_GEO];
  db_pline *nx;
  public:
	db_pline()
	{		  
		  type=1; 
		  lemma=0;
		  co=NULL;
		  no=-1;
		  nx = NULL;		  	

	};
	~db_pline()
	{}

};

class db_tline
{
public:
  int type;
  int lemma;
  CO *co;
  db_line *l1,*l2;
  db_tline *nx;
  public:
	db_tline()
	{		  
		  type=1; 
		  lemma=0;
		  co=NULL;
		  nx = NULL;		  	

	};
	~db_tline()
	{
	   
	}

};


class db_midpt
{
 public:
  int type;
  int lemma;
  CO *co;
  
  PT m,a,b;
  db_midpt *nx;
  public:
	db_midpt()
	{		  
		  type=1; 
		  lemma=0;
		  co=NULL;
		  m=a=b=0;
		  nx = NULL;		  	

	};
 	~db_midpt()
	{
	   
	}

};


struct incenter
{ int type;
  int lemma;
  CO *co;
  int i,a,b,c;
  struct incenter *nx;
};
class db_a_cir
{
public:
  int type;
  int lemma;
  CO *co;
  int no;///ĸ
  int o,pt[MAX_GEO];//////oΪԲģpt[MAX_GEO]ΪԲϵĸ㡣
  db_a_cir *nx;
  public:
	db_a_cir()
	{		  
		  type=1; 
		  lemma=0;
		  co=NULL;
		  nx = NULL;		  	

	};

};
class db_angles
{
public:
  int type;
  int lemma;
  CO *co;
  int sa;
  db_line *l1,*l2, *l3, *l4;
  db_angles *nx;
  public:
	db_angles()
	{		  
		  type=1; 
		  lemma=0;
		  co=NULL;
		  sa=1;
		  nx = NULL;		  	

	};
	~db_angles()
	{}
};
class db_cong_seg
{
public:
  int type;
  int lemma;
  CO *co;
  int no;
  int p1[MAX_GEO];
  int p2[MAX_GEO];
  db_cong_seg *nx;
    public:
	db_cong_seg()
	{		  
		  type=1; 
		  lemma=0;
		  co=NULL;
		  nx = NULL;		  	
		  no=0;

	};
	~db_cong_seg()
	{}

};

class db_sim_tri
{
public:
  int type;
  int lemma;
  CO *co;
  int no;
  int dr[MAX_GEO];
  int p1[MAX_GEO];
  int p2[MAX_GEO];
  int p3[MAX_GEO];
  db_sim_tri *nx;
    public:
	db_sim_tri()
	{		  
		  type=1; 
		  lemma=0;
		  co=NULL;
		  nx = NULL;		  	
		  no=0;

	};
	~db_sim_tri()
	{}

};

class db_ratio_seg
{
public:
  int type;
  int lemma;
  CO *co;
  int r[9];
  db_ratio_seg *nx;
    public:
	db_ratio_seg()
	{		  
		  type=1; 
		  lemma=0;
		  co=NULL;
		  nx = NULL;		  	

	};
	~db_ratio_seg()
	{}

};

class geom_cond
{ 
public:	
  int pred;					//prdicate type
  int  no;					//
  PT p[8];					// 
  union						// data pointer
	 {
		struct dumy *d;
		MD *md;
		LN *ln;
		PN *pn;
		TN *tn;
		CIR *cr;
		ANS *as;
		STRI *st;
		CONG *cg;
		RATIO *ra;
	 } u;
  geom_cond *nx;

public:
	geom_cond()
	{ pred = CO_NO;
	  no = 0;
	  nx=0;
	}
	~geom_cond()
	{}
};

class dbase
{
public:
	dbase()
	{
		d_base=1;
		show_dtype=1;
		pr_coll=0;
	}
	int  d_base;
	int show_dtype;
	int pr_coll;
 	char txt[2000];
	/////////////////

	MD	 all_md, *last_md;
	LN	 all_ln, *last_ln;
	PN	 all_pn, *last_pn;
	TN	 all_tn, *last_tn;
	CIR  all_cir, *last_cir;
	ANS  all_as, *last_as;
	CONG all_cg,  *last_cg;
	STRI all_st,  *last_st;
	STRI all_ct,  *last_ct;
	RATIO all_ra, *last_ra;

	NEWD all_nd, *last_nd;
	CO  co_db, co_xy;
	PRED conc;

	char tri_type;
	char *lang_name;

public:
	void main_info(CDrawDoc* pDdoc,int argc, char *argv[]);
	void prove_fixp(CDrawDoc* pDdoc);
	void fixpoint(CDrawDoc* pDdoc);
	PT ind_3(PT p, PT p1, PT p2, PT p3);
	int ycoll(PT a, PT b, PT c);
	int ypara(PT a, PT b, PT p, PT q);
	int yperp(PT a, PT b, PT p, PT q);
	int ycong(PT a, PT b, PT p, PT q);
	int yacong(PT a, PT b, PT c, PT p, PT q, PT r);
	int ycir2(PT o, PT a, PT b);
	void add_type1(CDrawDoc* pDdoc,PT o, PT p1, PT p2, PT m);
	void add_type2(CDrawDoc* pDdoc,PT m1, PT p1, PT m2, PT p2);
	void add_type3(CDrawDoc* pDdoc,PT m, PT m2, PT p2, PT m3, PT p3);
	void add_type4(CDrawDoc* pDdoc,PT m, PT m1, PT p1, PT m2, PT p2);
	void search_pn(CDrawDoc* pDdoc,PN *pn);
	void search_pn_0(CDrawDoc* pDdoc,PN *pn);
	void search_pn_1(CDrawDoc* pDdoc,LN *ln1, LN *ln2);
	void search_pn_md(CDrawDoc* pDdoc,PN *pn1, LN *ln1, LN *ln2);
	void search_pn_tn(CDrawDoc* pDdoc,PN *pn);
	void search_tn(CDrawDoc* pDdoc,TN *tn);
	void search_tn_cr(CDrawDoc* pDdoc,LN *ln1, LN *ln2, PT m);
	void search_tn_as(CDrawDoc* pDdoc,LN *ln1, LN *ln2, PT m);
	void search_tn_md(CDrawDoc* pDdoc,LN *ln1, LN *ln2, PT m);
	void search_tn_pn(CDrawDoc* pDdoc,TN *tn);
	void search_tn_tn(CDrawDoc* pDdoc,TN *tn, LN *ln1, LN *ln2, PT p1);
	void search_cr(CDrawDoc* pDdoc,CIR *cr1);
	void search_cr_pn(CDrawDoc* pDdoc,CIR *cr1, PT p1, PT p2);
	void search_cr_tan(CDrawDoc* pDdoc,CIR *cr1);
	void search_cr_cr(CDrawDoc* pDdoc,CIR *cr1);
	void search_cr_iso(CDrawDoc* pDdoc,CIR *cr1, PT p1, PT p2);
	void search_cr_cg(CIR *cr1);
	void search_md(CDrawDoc* pDdoc,MD *md);
	void search_md_md(CDrawDoc* pDdoc,MD *md);
	void search_md_pn(CDrawDoc* pDdoc,MD *md);
	void search_as(CDrawDoc* pDdoc,ANS *as1);
	void search_as_0(CDrawDoc* pDdoc,ANS *as, LN *l1, LN *l2, LN *l3, LN *l4);
	void search_as_1(CDrawDoc* pDdoc,PT p1, PT p2, LN *l1, LN *l2, LN *l3);
	void search_as_2(CDrawDoc* pDdoc,PT p1, PT p2, LN *l1, LN *l2, LN *l3, LN *l4);
	void search_as_3(CDrawDoc* pDdoc,PT p1, PT p2, LN *l1, LN *l2, LN *l3, LN *l4);
	void lm_43(CDrawDoc* pDdoc,PT p1, PT p2, LN *l1, LN *l2, LN *l3, LN *l4);
	void search_as_sim(CDrawDoc* pDdoc,PT p1, PT p2, LN *l1, LN *l2, LN *l3, LN *l4);
	int tri_sim(PT p1, PT p2, PT p3, PT p4, PT p5, PT p6);
	void search_as_pt(CDrawDoc* pDdoc);
	void search_st(STRI *st);
	void search_ct(STRI *st);
	void search_cg(CDrawDoc* pDdoc,CONG *cg);
	void search_cg_st(CDrawDoc* pDdoc,PT p1, PT p2, PT p3, PT p4);
	void search_ra(CDrawDoc* pDdoc,RATIO *ra);
	void search_ra_cg(void);
	void lm_3(CDrawDoc* pDdoc,PN *pn, TN *tn);
	void lm_21(CDrawDoc* pDdoc,MD *md, LN *l1, LN *l2);
	void lm_37(CDrawDoc* pDdoc,MD *md, LN *l1, LN *l2);
	void lm_73(CDrawDoc* pDdoc,PT p1, PT p2, PT p3, PT p4);
	void nf_as(void);


	/*  pred.c */
	void copy_pred(PRED *p1, PRED *p2);
	void  show_nds(CDrawDoc* pDdoc);
	int new_eq(NEWD *n1, NEWD *n2);
	void new_pr(int pred);
	void new_ot(void);
	CO *add_codb(int n, PT p1, PT p2, PT p3, PT p4, PT p5, PT p6, PT p7, PT p8);
	void pop_codb(void);
	CO *add_coxy(int n);
	void add_codx(int n, PT p1, PT p2, PT p3, PT p4, PT p5, PT p6, PT p7, PT p8);
	void new_para(PN *pn);

	int xcoll (PT p1, PT p2, PT p3);
	LN *fo_ln3(PT p1, PT p2, PT p3);
	LN *fo_ln(PT ps[], int n);
	int xcoll4 (PT p1, PT p2, PT p3, PT p4);
	int xpara (PT p1, PT p2, PT p3, PT p4);
	int ln_para(LN *l1, LN *l2);
	PN *fo_pn (PT p1, PT p2, PT p3, PT p4);
	int xperp (PT p1, PT p2, PT p3, PT p4);
	int ln_perp(LN *l1, LN *l2);
	TN *fo_tn(PT p1, PT p2, PT p3, PT p4);
	CIR *xcir(CIR *c1);
	CIR *fo_cr(PT o, PT p1, PT p2, PT p3, PT p4);
	int xcir2(PT o, PT p1, PT p2);
	int xcir3(PT o, PT p1, PT p2, PT p3);
	int xcir4(PT o, PT p1, PT p2, PT p3, PT p4);
	int xcir5(PT o, PT p1, PT p2, PT p3, PT p4, PT p5);
	int xmid (int m, int a, int b);
	MD *fo_md(int m, int a, int b);
	//int xacong(PT a, PT b, PT c, PT p, PT q, PT r);
	int xacong(PT a, PT b, PT c, PT p, PT q, PT r);
	ANS *fo_las(LN *l1, LN *l2, LN *l3, LN *l4);
	ANS *fo_las1(CDrawDoc* pDdoc,LN *l1, LN *l2, LN *l3, LN *l4);
	ANS *fo_as(PT a, PT b, PT c, PT d, PT p, PT q, PT r, PT s);
	int ln_acong(LN *l1, LN *l2, LN *l3, LN *l4);
	//int ln_acong(LN *l1, LN *l2, LN *l3, LN *l4);
	int xcong(PT a, PT b, PT p, PT q);
	//int xcong(PT a, PT b, PT p, PT q);
	CONG *fo_cg(PT a, PT b, PT p, PT q);
	int xsim_tri(PT a, PT b, PT c, PT p, PT q, PT r);
	int xcon_tri(PT a, PT b, PT c, PT p, PT q, PT r);
	STRI *fo_st(int a, int b, PT c, PT p, PT q, PT r, PT xsim_1, PT xsim_2);
	int xeq_ratio(PT a, PT b, PT c, PT d, PT p, PT q, PT r, PT s);
	//int xeq_ratio(PT a, PT b, PT c, PT d, PT p, PT q, PT r, PT s);
	RATIO *fo_ra(PT a, PT b, PT c, PT d, PT p, PT q, PT r, PT s);
	int ln_less(LN *l1, LN *l2);
	int l2_less(LN *l1, LN *l2, LN *l3, LN *l4);
	void show_dbase(CDrawDoc* pDdoc,char mk);
	void show_mds (CDrawDoc* pDdoc,char mk);
	CString show_md(CDrawDoc* pDdoc,MD *md,bool);
	void show_lns (CDrawDoc* pDdoc,char mk);
	///void show_ln(LN *ln,bool);///add by qlin in 2001/12/3///
	CString show_ln(CDrawDoc* pDdoc,LN *ln,bool);///add by qlin in 2001/12/3////
	void show_pns (CDrawDoc* pDdoc,char mk);
	///void show_pn(PN *pn);
	CString show_pn(CDrawDoc* pDdoc,PN *pn,bool);
	void show_tns (CDrawDoc* pDdoc,char mk);
	void show_tn(CDrawDoc* pDdoc,TN *tn,bool);
	void show_crs (CDrawDoc* pDdoc,char mk);
	void show_cr(CDrawDoc* pDdoc,CIR *cr,bool);
	void show_ass (CDrawDoc* pDdoc,char mk);
	CString show_as (CDrawDoc* pDdoc,ANS *as,bool);
	CString Find_Name(CDrawDoc* pDdoc,int mk);
	CString Find_Line(CDrawDoc* pDdoc,int iIndex1,int iIndex2);
	CString show_ang(CDrawDoc* pDdoc,LN *l1, LN *l2);
	void show_sts (CDrawDoc* pDdoc,char mk);
	void show_st(CDrawDoc* pDdoc,STRI *st,bool);
	void show_cts (CDrawDoc* pDdoc,char mk);
	void show_ct(CDrawDoc* pDdoc,STRI *st,bool);
	void show_cgs (CDrawDoc* pDdoc,char mk);
	CString show_cg(CDrawDoc* pDdoc,CONG *cg,bool);
	void show_ras (CDrawDoc* pDdoc,char mk);
	CString show_ra(CDrawDoc* pDdoc,RATIO *ra,bool);
	CString show_cos(CDrawDoc* pDdoc,CO *co);
	CString show_co(CDrawDoc* pDdoc,CO *co);
	void show_all_nd(CDrawDoc* pDdoc);	
	void size_of_dbase(char mk);


	/*  gib.c */

	void gdd_proc1(int);
	void gdb_help(void);
	PRED *cp_pred(PRED *co);
	PRED *fd_pred(CDrawDoc* pDdoc,PRED *co);
	PRED *fd_prep(PRED *co);
	void add_pred(CDrawDoc* pDdoc,int m, int n, PT p1, PT p2, PT p3, PT p4, PT p5, PT p6, PT p7, PT p8);
	PT finter_ll(LN *l1, LN *l2);
	PT finter_ll1(LN *l1, LN *l2, PT p1);
	void save_fproof (char mk);
	void show_fproof(char mk);
	void show_aux(void);
	void forw_pred (CDrawDoc* pDdoc,PRED *co);
	void for_c4(CDrawDoc* pDdoc,PT p1, PT p2, PT p3, PT p4);
	void for_c6(CDrawDoc* pDdoc,PT p1, PT p2, PT p3, PT p4, PT p5, PT p6);
	void show_nco(CDrawDoc* pDdoc,CO *co);
	int do_pred(CDrawDoc* pDdoc,PRED *co, PRED *pr, int n,CString& sCstr);
	CString show_copt(CDrawDoc* pDdoc,CO *co, PT n);
	int  eq_chs(PT *ch1, int n1, PT *ch2, int n2);
	int  sdiff(PT a, PT b, PT c, PT d, PT ps[]);
	void geti81 (PT a, PT b, PT c, PT d, ANS *as, LN **k1, LN **k2);
	void geti82 (PT a, PT b, PT c, PT d, ANS *as, LN **k1, LN **k2);


	/*  base.c */

	void init_dbase(void);
	PT get_lpt1(LN *l1, PT p1);
	PT get_lpt2(LN *l1, PT p1, PT p2);
	PT get_cpt2(CIR *c1, PT p1, PT p2);
	PT get_cpt3(CIR *c1, PT p1, PT p2, PT p3);
	PT inter_ll(LN *l1, LN *l2);
	PT inter_ll1(LN *l1, LN *l2, PT p1);
	PT inter_lc(LN *l1, CIR *c1);
	PT inter_lc1(LN *l1, CIR *c1, PT p1);
	PT inter_cc(CIR *c1, CIR *c2);
	PT inter_cc1(CIR *c1, CIR *c2, PT p1);
	PT fd_pt_la(PT o, PT p1, PT p2);
	int common_pp(PN *pl1, PN *pl2);
	int mv_pn(PN *pl1, PN *pl2);
	PT fd_pt_md (PT a, PT b);
	PT fd_pt_ref (PT a, PT o);
	MD *fd_md_ml(PT m, LN *l);
	void add_mid(CDrawDoc* pDdoc,PT lm, PT pt, PT p1, PT p2);
	bool on_ln(PT p, LN *ln);
	bool sub_ln(LN *l1, LN *l2);
	void add_pt2l(PT p, LN *ln);
	LN *fd_ln (PT p1, PT p2);
	LN *fd_ln3 (PT p1, PT p2, PT p3);
	LN *fd_pline (PT p1, PT p2, PT p3);
	LN *fd_tline (PT p1, PT p2, PT p3);
	LN *fd_ln_pn1 (PN *pn, PT p);
	LN *fd_ln1 (PT p1);
	LN *fd_lnl (LN *l1);
	LN *add_ln (PT p1, PT p2);
	LN *fadd_ln (PT p1, PT p2);
	LN *cp_ln (LN *ln);
	void ch_ln(LN *ln1, LN *ln2);
	void add_line(CDrawDoc* pDdoc,PT lm, PT p1, PT p2, PT p3);
	int on_pn(LN *ln, PN *pn);
	int on_ppn(PT p1, PT p2, PN *pn);
	PN *fd_pnl (LN *ln);
	PN *fd_pn (PT p1, PT p2);
	PN *fd_pnp (PN *pn, LN *ln);
	PN *cp_pn (PN *pn);
	void pn_un(PN *pn1, PN *pn2);
	void adj_pn(PN *pn);
	void add_pline (CDrawDoc* pDdoc,PT lm, PT p1, PT p2, PT p3, PT p4);
	PN *add_px (CDrawDoc* pDdoc,PT lm, LN *ln1, LN *ln2);
	int on_tn(LN *ln, TN *tn);
	TN *fd_tn(LN *ln);
	TN *add_tn(LN *ln1, LN *ln2);
	void add_tline (CDrawDoc* pDdoc,PT lm, PT p1, PT p2, PT p3, PT p4);
	void add_tx (PT lm, LN *l1, LN *l2);
	int on_cir(PT a, CIR *cr);
	int eq_cir(PT o, PT a, CIR *cr);
	int sub_cir(CIR *c1, CIR *c2);
	int circle_p(char ptn);
	char fd_co(char p1, char p2, char p3);
	CIR *fd_cr_op(PT o, PT p);
	CIR *fd_cr_p3(PT p1, PT p2, PT p3);
	CIR *fd_cir(CIR *c1);
	void add_pt2c(PT p, CIR *cr);
	CIR *add_c2(PT lm, PT o, PT a, PT b);
	CIR *cp_cr (CIR *cir);
	void adj_cir(CIR *cr);
	void add_cir2(CDrawDoc* pDdoc,PT lm, PT o, PT a, PT b);
	void add_cir3(CDrawDoc* pDdoc,PT lm, PT o, PT a, PT b, PT c);
	void add_cir4(CDrawDoc* pDdoc,PT lm, PT o, PT a, PT b, PT c, PT d);
	int onl_as(LN *l1, LN *l2, ANS *as);
	ANS *fd_as(LN *l1, LN *l2);
	ANS *add_as(CDrawDoc* pDdoc,PT lm, LN *l1, LN *l2, LN *l3, LN *l4);
	void ck_as(CDrawDoc* pDdoc,ANS *as, LN *l1, LN *l2, LN *l3, LN *l4);
	void adj_as(CDrawDoc* pDdoc,ANS *as);
	void adj_as1(CDrawDoc* pDdoc,LN *l1, LN *l2, LN *l3, LN *l4, ANS *r1, ANS *r2);
	void adj_as2(CDrawDoc* pDdoc,LN *l1, LN *l2, LN *l3, LN *l4, ANS *r1, ANS *r2);
	void add_ea_pt(CDrawDoc* pDdoc,PT lm, PT a, PT b, PT c, PT p, PT q, PT r);
	void add_ea_ln(CDrawDoc* pDdoc,PT lm, LN *l1, LN *l2, LN *l3, LN *l4);
	void add_ea_sa(CDrawDoc* pDdoc,unsigned char n, PT p, PT q, PT r);
	int on_st(PT p1, PT p2, PT p3, STRI *st);
	int pt_sim(PT p1, PT p2, PT p3, PT p4, PT p5, PT p6);
	int move_st(PT dr, PT p1, PT p2, PT p3, STRI *st1);
	STRI *fd_st(PT dr, PT p1, PT p2, PT p3);
	STRI *cp_st(STRI *st);
	void st_rev(STRI *st);
	void st_sign(STRI *st);
	void st_mv(STRI *st);
	void st_un(STRI *st1, STRI *st2);
	void add_stri(PT lm, PT dr, PT a, PT b, PT c, PT p, PT q, PT r);
	int on_cg(PT p1, PT p2, CONG *cg);
	int sub_cg(CONG *cg1, CONG *cg2);
	CONG *fd_cg(PT p1, PT p2);
	CONG *fd_cg1(CONG *cg);
	CONG *cp_cg(CONG *cg);
	void add_pt2cg(PT p1, PT p2, CONG *cg);
	void adj_cg(CONG *cg);
	void add_cong(char lm, char l_no,  PT a, PT b, PT p, PT q);
	void add_cong1(PT lm, PT p1, PT p2, PT p3, PT p4, PT a, PT b, PT p, PT q);
	PT ind_ra(PT a, PT b, RATIO *ra, PT m);
	RATIO *add_ra(PT lm, PT o, PT a, PT b, PT c, PT d, PT p, PT q, PT r, PT s);
	void adj_ra(CDrawDoc* pDdoc,RATIO *ra);
	void adj_ra1(CDrawDoc* pDdoc,PT a, PT b, PT c, PT d, PT i1, PT i2, RATIO *r1, RATIO *r2);
	void adj_ra2(CDrawDoc* pDdoc,PT a, PT b, PT c, PT d, PT i1, RATIO *r1, RATIO *r2);
	void add_ratio(CDrawDoc* pDdoc,PT lm, PT o, PT a, PT b, PT c, PT d, PT p, PT q, PT r, PT s);
	void add_ratiot(CDrawDoc* pDdoc,PT lm, PT o, PT a, PT b, PT c, PT p, PT q, PT r);
	void add_ratioo(CDrawDoc* pDdoc,PT o, PT a, PT b, PT c, PT d);
	void free_dbase(void);
    ///db_conc.cpp
	

/*  me.c */

/*
void gen_model (void);
void show_mpt(char p);
number NUM_m1(number a, number b, number c, number p, number q, number r);
number NUM_m2(number a, number b, number c, number p, number q, number r);
number NUM_m3(number a, number b, number p, number q);
number NUM_m4(number a, number b, number p, number q);
void msol_l (char po, number a, number b, number c, number a1, number b1, number c1);
void mgen_mid (char po, char p1, char p2);
void mgen_sym (char po, char p1, char p2);
void mgen_pp (char po, char p1, char p2, char p3, char p4, char p5, char p6);
void mgen_pt (char po, char p1, char p2, char p3, char p4, char p5, char p6);
void mgen_tt (char po, char p1, char p2, char p3, char p4, char p5, char p6);
void mgen_pc (char po, char p1, char p2, char p3, char p4);
void mgen_tc (char po, char p1, char p2, char p3, char p4);
void mgen_cc (char po, char p1, char p2, char p3);
number msl (char p1, char p2);
number  mksl (char a, char b, char c);
void mgen_al (char po, char p1, char p2, char p3, char p4, char p5);
void mgen_incenter (char po, char a, char b, char i);
void mgen_harmonic (char po, char c, char b, char a);
void mgen_psim (char po, char p1, char p2, char p3, char p4, char p5);
void mgen_nsim (char po, char p1, char p2, char p3, char p4, char p5);
int meq_pt (char p1, char p2);
int mcoll (char p1, char p2, char p3);
number me1_para (char p1, char p2, char p3, char p4);

number me1_perp (char p1, char p2, char p3, char p4);
int mperp (char p1, char p2, char p3, char p4);
int mmid (char p1, char p2, char p3);
number  mdis(char p1, char p2);
int mcong (char p1, char p2, char p3, char p4);
int macong (char p1, char p2, char p3, char p4, char p5, char p6);
int meq_ratio (char p1, char p2, char p3, char p4, char p5, char p6, char p7, char p8);
*/
	int mpara (char p1, char p2, char p3, char p4);
    int mcoll(PT p1,PT p2,PT p3);
/*  aux.c */

	void aux_pt (CDrawDoc* pDdoc,int aux, int type);
	PT aux_tline(CDrawDoc* pDdoc,int aux, PT p1, PT p2, PT p3);
	PT aux_mid(CDrawDoc* pDdoc,int aux, PT p1, PT p2);
	PT aux_ill(CDrawDoc* pDdoc,int aux, PT p1, PT p2, PT p3, PT p4);
	PT aux_ilp(CDrawDoc* pDdoc,int aux, PT p1, PT p2, PT p3, PT p4, PT p5);
	PT aux_ilt(int aux, PT p1, PT p2, PT p3, PT p4, PT p5);
	PT aux_foot(CDrawDoc* pDdoc,int aux, PT p1, PT p2, PT p3);
	PT aux_ilc(CDrawDoc* pDdoc,int aux, PT pt, PT p1, CIR *cr);
	PT aux_ipc(CDrawDoc* pDdoc,int aux, PT p1, PT p2, PT p3, CIR *cr);
	PT aux_co(CDrawDoc* pDdoc,int aux, CIR *cr);
	void add_aux(CDrawDoc* pDdoc);
	void ax_md(CDrawDoc* pDdoc);
	void ax_mdpn(CDrawDoc* pDdoc,MD *md);
	void ax_p3m(CDrawDoc* pDdoc,PN *pn, PT p1, PT p2, PT p3, LN *ln1, LN *ln2, LN *ln3);
	void ax_mml(CDrawDoc* pDdoc,MD *md, MD *md1, LN *l1);
	void ax_mm(CDrawDoc* pDdoc,MD *md, MD *md1);
	void ax_orth(CDrawDoc* pDdoc);
	void ax_orth1(CDrawDoc* pDdoc,TN *tn1, LN *ln1, LN *ln2);
	void ax_tn(CDrawDoc* pDdoc);
	void ax_tn_cr(CDrawDoc* pDdoc,LN *ln1, LN *ln2);
	void ax_tn_as(CDrawDoc* pDdoc,LN *ln1, LN *ln2);
	void ax_tn_md(CDrawDoc* pDdoc,LN *ln1, LN *ln2);
	void ax_tn_1(CDrawDoc* pDdoc);
	void ax_tn_ln(CDrawDoc* pDdoc,LN *ln1, LN *ln2);
	void ax_tn_21(CDrawDoc* pDdoc,LN *ln1, LN *ln2);
	void ax_as(CDrawDoc* pDdoc);
	void ax_as_1(CDrawDoc* pDdoc,LN *l1, LN *l2, LN *l3);
	void ax_at(CDrawDoc* pDdoc,PT o, PT p1, PT p3, LN *l2);
	void ax_as_2(CDrawDoc* pDdoc,LN *l1, LN *l2, LN *l3, LN *l4);
	void ax_as_21(CDrawDoc* pDdoc,PT p1, PT p2, LN *l1, LN *l2, LN *l3, LN *l4);
	void ax_cr(CDrawDoc* pDdoc);
	void ax_tan(CDrawDoc* pDdoc,CIR *cr1);
	int in_conc(PT p);
	void ax_cr_cr(CDrawDoc* pDdoc,CIR *cr1);
	void ax_cr_cr1(CDrawDoc* pDdoc,CIR *cr1, CIR *cr2, PT p1, PT p2);
	void ax_cr1(CDrawDoc* pDdoc,CIR *cr);
	void ax_cr2(CDrawDoc* pDdoc,CIR *cr);
	void ax_center(CDrawDoc* pDdoc,CIR *cr);
	void ax_pn(CDrawDoc* pDdoc);
    ///////////////////////////////////////////////
	bool search_st_ct(char dr, PT p1,PT p2,PT p3,PT p4,PT p5,PT p6);
	const char* ANAME( CDrawDoc* pDdoc,int p);  
	CString PDSTR(int i);
	//////////////////////////////////////////////////////////////
	///db_conc.cpp/////////////
	int conc_xtrue(CDrawDoc* pDdoc);
    int conc_mtrue(CDrawDoc* pDdoc);
    int conc_gtrue(CDrawDoc* pDdoc);
	int docc(CDrawDoc* pDdoc,char cgeo_key);
};

///////////////////////////////////////////////////////


///////////////////////////////////////////////////
#define ex_ch(tmv,x,y)  tmv=x;x=y;y=tmv;
#define gexit(n) { printf("exit: %d\n",n); exit(1); }



//#define PDSTR(i) ("1")
//#define APT(p)    (allpts)[p]


typedef int number;

extern char mv_pn1;
extern FILE *out_st;
extern char ps_flag, qerror;
extern PRED conc, conf, conb;
extern RATIO *test_ra;



//int docc(CDrawObjList &m_objects,char cgeo_key);
void print_fang(PT,PT,PT,PT);
void gprint(const char*, bool sf=false);

char *pt_name(PT p);

class TTIME
 { public:
	TTIME() { set = 0
	; }
	bool set;
	long i_time;
 };

extern long max_time;
extern MD all_md, *last_md;

//extern TTIME _ttime;
void gerror (const char *ch);
int  num_compare(number x, number y);
int doall(char, PT);
void do_cons(char, PT ptn);
extern FILE*Gout_file;
