// drawobj.h - interface for CDrawObj and derivatives
//
// This is a part of the Microsoft Foundation Classes C++ library.
// Copyright (C) 1992-1997 Microsoft Corporation
// All rights reserved.
//
// This source code is only intended as a supplement to the
// Microsoft Foundation Classes Reference and related
// electronic documentation provided with the library.
// See these sources for detailed information regarding the
// Microsoft Foundation Classes product.
#include <fstream.h>
#ifndef __Point2_H
#define __Point2_H
class CMyPoint;
class CMyLine;

class RELATION;
class CDrawObj;

typedef CTypedPtrList<CObList, CDrawObj*> CDrawObjList;



class CPoint2//:public CObject
{
	//DECLARE_SERIAL(CPoint2)
public:   
	double x,y;
public:
	double squareLength();
	virtual CMyPoint* CompareDtoGetminfrom(CMyPoint* temp1,CMyPoint* temp2);
	//virtual  CPoint2();
	CPoint2();
	CPoint2(double InitX,double InitY);
	CPoint2 CPoint2::operator-(const CPoint2 &temp);//ֻ=&
	CPoint2 CPoint2::operator-(const CPoint &temp);
	CPoint2 CPoint2::operator-();
	CPoint2 CPoint2::operator+(const CPoint2 &temp);
    CPoint2 CPoint2::operator+(const CPoint &temp);
	CPoint2 CPoint2::operator*(const double temp);
	CPoint2 CPoint2::operator*(const CPoint2 temp);
	friend CPoint2 operator*(const double temp1,const CPoint2 &temp2);
	CPoint2 &CPoint2::operator=(const CPoint2 &temp);
	CPoint2 &CPoint2::operator=(const CPoint &temp);

	BOOL CPoint2::operator==(CPoint2 &temp);
	CPoint CPoint2::sw();
	double Length();
	CPoint2 &CPoint2::Unit();
	CPoint2 CPoint2::getPoint(CPoint2 direction,const double length);
	CPoint2 CPoint2::projection(CPoint2 direction);
};
#endif
/////////////////////from lhuang////////////////////////////////////
#ifndef __ELATION_H__
#define __ELATION_H__
class RELATION : public CObject
{
public:
	CString GetName();
	
	DECLARE_SERIAL(RELATION);
	int N_para_perp;  // 1ʾƽУ0ʾֱ2ʾǶ
	                  //ñרΪֱߵĹϵ
	double N_dis_clamp;// record the distance or clamp
	                   // between the relation
	///add by gao,in order to add the list;
	///ÿNlink,ǶpObjList;
	int cDeg;///Լȡ
	CDrawObjList pObjList;
	////////////////////////qlin Begin//////////////////////
	double dAngle;///ҪΪ˴ûĽǶ,ǻ
	///ô200120ӵġ
	BOOL bAdjust;      ///ùϵǺϵġNNʱýڵӦɾ
	BOOL bSAS;             ////þǷΪSASȥġ
	BOOL bSJudge;      ///SASɾ󱣴汻ɾλá 
   ///////////////////////////qlin End//////////////////////////
	int Nserialno;// number  position in list
    int Nconstraintype;//-1ʾԲԲĹϵ 0ʾ naturerelation 1ʾdistance  2ʾangle
	///Nconstraintype=3ֱߺԲлԲԲ,Nconstraintype=4ԲԲ.
	///Nconstraintype=5Ƕȵıϵ///Nconstrainttype=6߶εıϵ
	int Ntype;//ʾǰϵΪ㣬ֱߣԲ1㣬2ֱߡ3Բ,4Ρ
	int iPLtype;///ʾǰϵߵĹϵ1Ϊߵе㡣
	int iPTtype;///ʾεĹϵ1ģ2ģ3ģ4ġ5
	            ///һ㣬6ȱΡ
	int m_listindex[4];///add by qlin;Ϊ˱p_Objlistеĸm_listindex;
	RELATION();
	~RELATION();
	RELATION &RELATION::operator=(const RELATION &temp);
	virtual void Serialize(CArchive & ar);
};
#endif

typedef CTypedPtrList<CObList, RELATION*> CRelationlist;

////////////////////////////////////////////////////////////////////////
#ifndef __DRAWOBJ_H__
#define __DRAWOBJ_H__

class CDrawView;
class CDrawDoc;
class CMyPoint;
class CMyLine;//һҪӣʹCMyPointĶгCMyLineϷ
class CMyCircle;
/////////////////////////////////////////////////////////////////////////////
// CDrawObj - base class for all 'drawable objects'



/////////////////////////////////////////////////////////
class CDrawObj : public CObject
{
protected:
	DECLARE_SERIAL(CDrawObj);
	CDrawObj();

// Constructors
public:
	CDrawObj(const CRect& position);
    CDrawObj(CPoint2 &p1,CPoint2 &p2);
// Attributes
	CRect m_position;	
	//CPoint2 m_startpoint,m_endpoint;

	CDrawDoc* m_Document;
	//CDrawObj* m_pDrawObj;   

	void CDrawObj::InitiateDate();
	virtual int GetHandleCount();

	virtual CPoint GetHandle(int nHandle);
	CRect GetHandleRect(int nHandleID, CDrawView* pView);
	virtual HCURSOR GetHandleCursor(int nHandle);
	virtual void SetLineColor(COLORREF color);
	virtual void SetFillColor(COLORREF color);

// Operations
	virtual void Draw(CDC* pDC);
	enum TrackerState { normal, selected, active };
	virtual void DrawTracker(CDC* pDC, TrackerState state);
	virtual void MoveTo(const CRect& positon, CDrawView* pView = NULL);
	virtual void MoveTo(CPoint2 p1, CPoint2 p2,CDrawView* pView);

	virtual int HitTest(CPoint point, CDrawView* pView, BOOL bSelected);
	virtual BOOL Intersects(const CRect& rect);
	virtual void MoveHandleTo(int nHandle, CPoint point, CDrawView* pView = NULL);
	//virtual void MoveHandleTo(int nHandle, CPoint2 point2, CDrawView* pView);
	virtual void OnOpen(CDrawView* pView);
	virtual void OnEditProperties();
	virtual CDrawObj* Clone(CDrawDoc* pDoc = NULL);
	virtual void Remove();
	void Invalidate();
    CDrawObj &CDrawObj::operator=(const CDrawObj &temp);

// Implementation
public:
/////////////////////////from lhuang//////////////////////////////
	int type;//(type=1)(type=2ֱ)(type=3Բ)(type=4)(type=5)(type=6߶)
	int Ndof;                          // degreeof freedom
	int Ndoc;                          // degree of constrain ҲRELATION鳤
	CRelationlist Nlink;                  // link[].serialno,link[].constraintype
	BOOL NFlag;                       // node visited flag
	//////////////////from qlin//////////////////
	CRelationlist NlinkB;  ///ݡ 
	int bMark;  ///ʼΪ㣬1ѭɾ2SASɾ3ƽɾ
	///****************************************************///
	CString sName;   ///Obj.
	BOOL bName;      ///ΪObjû,ΪһObjѾ.
	int bDraw; ////ΪһΪߡ
	int iStep;  ///ö󶯻ʱΪٶȡ
	int iCount;
    BOOL On;
	///***************************************************///
	//////////////////from qlin/////////////////////////
	BOOL bStatic;///һǷ̶
	int m_listindex;  ///from lhuang/////////
	void CDrawObj::NaturalRelation(CDrawView*pView);
	RELATION* CDrawObj::PrepareConstruction(CDrawObj * temp);
	RELATION* m_relation;//ȫ溯ķ
///////////////////////////////////////////////////////
	int m_serialno[6];//:m_serialno[0];
	                  //ֱ:m_serialno[0],m_serialno[1];
	                  //m_serialno¼m_objects е
	
	virtual ~CDrawObj();
	virtual void Serialize(CArchive& ar);
	
	CPoint my_point;
	CPoint my_point1;
	int choosedhandle;
	int iDriveTrace;
#ifdef _DEBUG
	void AssertValid();
#endif
	// implementation data
public:
	BOOL m_bPen;
	LOGPEN m_logpen;
	BOOL m_bBrush;
	LOGBRUSH m_logbrush;
};

// special 'list' class for this application (requires afxtempl.h)

////////////////////////////////////////////////////////////////////////
/////////////////////////////////add by wqyang////
#ifndef __LPoint_H__
#define __LPoint_H__
class CLPoint : public CDrawObj
{
public:
	
	DECLARE_SERIAL(CLPoint);
	CPoint2 lpoint;
	CLPoint();
	virtual void Serialize(CArchive& ar);
    virtual void Draw(CDC* pDC);
	CLPoint(CMyPoint* tempdc);
	~CLPoint();

	//virtual void Serialize(CArchive & ar);
};
#endif

typedef CTypedPtrList<CObList, CLPoint*> CLPointList;
///////////////////////////////////add by wqyang///////////////////
/////////////////////////////////add by wqyang////
#ifndef __ALine_H__
#define __ALine_H__
class CALine: public CObject
{
public:
	
	DECLARE_SERIAL(CALine);
	CPoint2 FirstPoint;
	CPoint2 SecondPoint;
	CALine();
	virtual void Serialize(CArchive& ar);
    Draw(CDC*pDC);
	CALine(CMyLine* tempdc);
	~CALine();

	//virtual void Serialize(CArchive & ar);
};
#endif

typedef CTypedPtrList<CObList, CALine*> CALineList;
///////////////////////////////////add by wqyang///////////////////
////////////////////////my code//////////////////////
class CMyPoint : public CDrawObj
{
protected:
	DECLARE_SERIAL(CMyPoint);
	CMyPoint();
public:
    CMyPoint(const CRect& position);
    CMyPoint(CPoint2 &p1);
	CMyPoint(CPoint2 *p1);
	CMyPoint(CPoint &p1);
	CMyPoint(double x,double y);
	CMyPoint::~CMyPoint();

//Implementation
public:
	CMyPoint* CompareDtoGetminfrom (CMyPoint* temp1,CMyPoint* temp2);
	double m_scale;
	double x();
	double y();
    virtual void Serialize(CArchive& ar);
	virtual void Draw(CDC* pDC);
    virtual int GetHandleCount();
	virtual CPoint GetHandle(int nHandle);
	virtual HCURSOR GetHandleCursor(int nHandle);
	virtual void MoveHandleTo(int nHandle, CPoint2 point, CDrawView* pView = NULL);
	virtual BOOL Intersects(const CRect& rect);
	virtual BOOL MyIntersects(const CRect& rect);
	virtual CDrawObj* Clone(CDrawDoc* pDoc);
	CMyPoint &CMyPoint::operator=(const CMyPoint &temp);
	CMyPoint *CMyPoint::operator=(const CMyPoint *temp);
	BOOL CMyPoint::operator==(CMyPoint &temp);

//	CString my_objname;

	int ptype;
	///ptype=:һֱֱߵĽ㣬ʾֱϰɵ㣬ʾƽֱϵ㣬Ĵֱֱϵ㣬
	///ֱе㡣㡣
	BOOL commonflag;
	CMyLine* m_conect1;
	CMyLine* m_conect2;
	CMyLine* m_conectrecord;//¼ƽ߶Աgetbyscale() ʹ
	CPoint2 m_startpoint;
	///˴Ϊֲרң˻ԣÿ㶼һص㡣
	BOOL bShowName;            ///Ƿʾõơ
	CString sShowPointColor;   ///õɫ
	CString sPointSize;            ///õĴС 
	CString sPointStyle;       ///õʵĻǿġ
	int m_Speed;///ʱõΪʱĶٶȡΪ161졣
	///
	BOOL bSqrt;///һλãͨ㣬С㣬ΪһΪ㣻
	CLPointList lpoints;//containing all locus points while moving
    friend class CPointTool;	
};

class CMyLine : public CDrawObj
{
protected:
	DECLARE_SERIAL(CMyLine);
public:
	CMyLine();
    CMyLine(const CRect& position);
    CMyLine::CMyLine(CMyPoint *p1,CMyPoint *p2) ;
	CMyLine::~CMyLine();
//Implementation
public:
    virtual void Serialize(CArchive& ar);
	virtual void Draw(CDC* pDC);
    virtual int GetHandleCount();
	virtual CPoint GetHandle(int nHandle);
	virtual CMyPoint* GetHandlePoint(int nHandle);

	virtual HCURSOR GetHandleCursor(int nHandle);
    virtual void MoveHandleTo(int nHandle, CPoint point, CDrawView* pView);
    virtual void MoveHandleTo(int nHandle, CMyPoint *point, CDrawView* pView);
	virtual void MoveTo(CMyPoint *p1,CMyPoint *p2, CDrawView* pView);
    virtual BOOL Intersects(const CRect& rect);
	virtual CDrawObj* Clone(CDrawDoc* pDoc);
	CMyLine &CMyLine::operator=(const CMyLine &temp);
	CMyLine *CMyLine::operator=(const CMyLine *temp);
	void CMyLine::SetBottomRight(CMyPoint *bottomright);
	void CMyLine::SetTopLeft(CMyPoint *topleft);
	CMyPoint *CMyLine::getTopLeft();
    CMyPoint *CMyLine::getBottomRight();
	double CMyLine::getScale(CPoint2 temp);
    double CMyLine::getScale(CPoint temp);
	double CMyLine::getSlope();
	double CMyLine::getLength();
	CPoint2 CMyLine::getPointByScale(double scale);
	void CMyLine::ChangeDirectionOn(CPoint2 Direction , BOOL onstartpoint=TRUE);
	void CMyLine::MoveTowardDirection(CPoint2 Direction);
	CPoint2 CMyLine::getDirection(BOOL onstartpoint=TRUE);
	CPoint2 CMyLine::getDirectionPoint(CPoint2 Direction, BOOL onstartpoint=TRUE);
	CPoint2 CMyLine::getMidPoint();
	
public:
	void ChangeTwoPoint();
	void computeABC(CMyPoint * temp1, CMyPoint * temp2);
	void computeABC(CPoint2 temp1,CPoint2 temp2);
	void computeABC(double a,double b,CPoint2 temp);
	void computeABC(CPoint2 temp);
	void computeABC(CMyPoint * temp);
	void computeABC();
	double ABC[3];
	int ifBasePoint(CMyPoint * temp);//0ʾbase㣬1ʾ㣬2ʾend 
	CMyPoint* getCommonPoint(CMyLine* temp);
	
	CMyPoint* my_startpoint;
    CMyPoint* my_endpoint;	
    CMyPoint* p_startpoint;
	CMyPoint* p_endpoint;
	///come from qlin begin
	int iGrade;               ///õȼ༶Ρ޽Ƕȹϵ	                     
	double fAngle;             ///ͬ丸ԪĽǶȹϵ  
	int iClass;               ///һȼࡣκεȼࡣ
	CDrawObj* LineFather;      ///丸Ԫm_ListIndex
	//////˴Ϊֲרң˻ߵԡ
    BOOL bShowLine;             ///ʾֱ 
	BOOL bShowName;             ///ʾֱ
	CString sLineColor;         ///ֱߵɫ
	CString sLineStyle;         ///ֱߵ͡
	CString sLineThickness;     ///ֱߵĴϸ
	///come from qlin end
	CALineList Alines;//containing all locus points while moving
    friend class CLineTool;	
};
typedef CTypedPtrList<CObList,CMyLine*>AngleLineList;
class CAngleLine: public CMyLine
{
protected:
	DECLARE_SERIAL(CAngleLine);
public:
	CAngleLine();
	~CAngleLine();	
	CAngleLine &CAngleLine::operator=(const CAngleLine &temp);
	CAngleLine *CAngleLine::operator=(const CAngleLine *temp);
	void Add(AngleLineList &temp,CMyLine* temp2,CMyLine* temp3,double tempAngle);
	BOOL bFound(AngleLineList &temp1,CMyLine *temp2,CMyLine* temp3); ///ֱǷмнǹϵ 
	double ComputeAngle(AngleLineList &temp1,CMyLine* temp2,CMyLine* temp3); ///ԪĽǶȹϵ  
	void InitialUpdate(CDrawObjList &temp1,AngleLineList &temp2);
	void DeleteList(AngleLineList &temp);   ///ɾ
	CMyLine* CAngleLine::GetLine(AngleLineList &temp1,CDrawObj &temp2);
};
class CMyCircle : public CDrawObj
{
protected:
	DECLARE_SERIAL(CMyCircle);
public:
	CMyCircle();
    CMyCircle(const CRect& position);
    CMyCircle::CMyCircle(CMyPoint *p1,CMyPoint *p2);
    CMyCircle::CMyCircle(CMyPoint *pp,CMyPoint *pPoint,double r);
	CMyCircle::CMyCircle(double abc[3]);
	CMyCircle::~CMyCircle();
//Implementation
public:
    virtual void Serialize(CArchive& ar);
	virtual void Draw(CDC* pDC);
    virtual int GetHandleCount();
	virtual CPoint GetHandle(int nHandle);
	virtual CMyPoint* GetHandlePoint(int nHandle);

	virtual HCURSOR GetHandleCursor(int nHandle);
    virtual void MoveHandleTo(int nHandle, CPoint point, CDrawView* pView);
    virtual void MoveHandleTo(int nHandle, CMyPoint *point, CDrawView* pView);
	virtual void MoveTo(CMyPoint *p1,CMyPoint *p2, CDrawView* pView);
    virtual BOOL Intersects(const CRect& rect);
	virtual CDrawObj* Clone(CDrawDoc* pDoc);
	CMyCircle &CMyCircle::operator=(const CMyCircle &temp);
	CMyCircle *CMyCircle::operator=(const CMyCircle *temp);
	void CMyCircle::SetBottomRight(CMyPoint *bottomright);
	void CMyCircle::SetTopLeft(CMyPoint *topleft);
	CMyPoint *CMyCircle::getTopLeft();
    CMyPoint *CMyCircle::getBottomRight();
	double CMyCircle::getScale(CPoint2 temp);
    double CMyCircle::getScale(CPoint temp);
	double CMyCircle::getSlope();
	double CMyCircle::getLength();
	CPoint2 CMyCircle::getPointByScale(double scale);
	void CMyCircle::ChangeDirectionOn(CPoint2 Direction , BOOL onstartpoint=TRUE);
	void CMyCircle::MoveTowardDirection(CPoint2 Direction);
	CPoint2 CMyCircle::getDirection(BOOL onstartpoint=TRUE);
	CPoint2 CMyCircle::getDirectionPoint(CPoint2 Direction, BOOL onstartpoint=TRUE);
	//CPoint2 CMyCircle::getMidPoint();
	
public:
	double m_radius;
	double ABC[3];//////ABC[0] and ABC[1] symble the x,y of the circle point.ABC[2] simble the radius. 
	int ifBasePoint(CMyPoint * temp);//0ʾbase㣬1ʾ㣬2ʾend 
	CMyPoint* getCommonPoint(CMyCircle* temp);
	
	CMyPoint* my_startpoint;
    CMyPoint* my_endpoint;
    friend class CCircleTool;
	
};

//////////////////////////my code/////////////////////
class CDrawRect : public CDrawObj
{
protected:
	DECLARE_SERIAL(CDrawRect);
	CDrawRect();

public:
	CDrawRect(const CRect& position);

// Implementation
public:
	virtual void Serialize(CArchive& ar);
	virtual void Draw(CDC* pDC);
	virtual int GetHandleCount();
	virtual CPoint GetHandle(int nHandle);
	virtual HCURSOR GetHandleCursor(int nHandle);
	virtual void MoveHandleTo(int nHandle, CPoint point, CDrawView* pView = NULL);
	virtual BOOL Intersects(const CRect& rect);
	virtual CDrawObj* Clone(CDrawDoc* pDoc);

protected:
	enum Shape { rectangle, roundRectangle, ellipse, line };
	Shape m_nShape;
	CPoint m_roundness; // for roundRect corners

	friend class CRectTool;
};

/////////////////////////////////////////////////////////////////////////////

class CDrawPoly;

class CDrawPoly : public CDrawObj
{
protected:
	DECLARE_SERIAL(CDrawPoly);
	CDrawPoly();

public:
	CDrawPoly(const CRect& position);

// Operations
	void AddPoint(const CPoint& point, CDrawView* pView = NULL);
	BOOL RecalcBounds(CDrawView* pView = NULL);

// Implementation
public:
	virtual ~CDrawPoly();
	virtual void Serialize(CArchive& ar);
	virtual void Draw(CDC* pDC);
	virtual void MoveTo(const CRect& position, CDrawView* pView = NULL);
	virtual int GetHandleCount();
	virtual CPoint GetHandle(int nHandle);
	virtual HCURSOR GetHandleCursor(int nHandle);
	virtual void MoveHandleTo(int nHandle, CPoint point, CDrawView* pView = NULL);
	virtual BOOL Intersects(const CRect& rect);
	virtual CDrawObj* Clone(CDrawDoc* pDoc);

protected:
	int m_nPoints;
	int m_nAllocPoints;
	CPoint* m_points;
	CDrawPoly* m_pDrawObj;

	friend class CPolyTool;
};

class CDrawItem;    // COleClientItem derived class

class CDrawOleObj : public CDrawObj
{
protected:
	DECLARE_SERIAL(CDrawOleObj);
	CDrawOleObj();

public:
	CDrawOleObj(const CRect& position);

// Implementation
public:
	virtual void Serialize(CArchive& ar);
	virtual void Draw(CDC* pDC);
	virtual CDrawObj* Clone(CDrawDoc* pDoc);
	virtual void OnOpen(CDrawView* pView);
	virtual void MoveTo(const CRect& positon, CDrawView* pView = NULL);
	virtual void OnEditProperties();
	virtual void Remove();
	virtual ~CDrawOleObj();

	static BOOL c_bShowItems;

	CDrawItem* m_pClientItem;
	CSize m_extent; // current extent is tracked separate from scaled position
};

#endif // __DRAWOBJ_H__
