// drawtool.h - interface for CDrawTool and derivatives
//
// This is a part of the Microsoft Foundation Classes C++ library.
// Copyright (C) 1992-1997 Microsoft Corporation
// All rights reserved.
//
// This source code is only intended as a supplement to the
// Microsoft Foundation Classes Reference and related
// electronic documentation provided with the library.
// See these sources for detailed information regarding the
// Microsoft Foundation Classes product.


#ifndef __DRAWTOOL_H__
#define __DRAWTOOL_H__

#include "drawobj.h"

class CDrawView;

enum DrawShape
{
	mypoint,
	myline,
	mycircle,
	selection,
	line,
	rect,
	roundRect,
	ellipse,
	poly
};

class CDrawTool
{
// Constructors
public:
	CDrawTool(DrawShape nDrawShape);

// Overridables
	virtual void OnLButtonDown(CDrawView* pView, UINT nFlags,  CPoint& point);
	virtual void OnLButtonDblClk(CDrawView* pView, UINT nFlags, const CPoint& point);
	virtual void OnLButtonUp(CDrawView* pView, UINT nFlags,  CPoint& point);
	virtual void OnMouseMove(CDrawView* pView, UINT nFlags, const CPoint& point);
	virtual void OnEditProperties(CDrawView* pView);
	virtual void OnCancel();

// Attributes
	DrawShape m_drawShape;

	static CDrawTool* FindTool(DrawShape drawShape);
	static CPtrList c_tools;
	static CPoint c_down;
	static UINT c_nDownFlags;
	static CPoint c_last;
	static DrawShape c_drawShape;
//my code
};

class CSelectTool : public CDrawTool
{
// Constructors
public:
	void movecirclecenter(CDrawView* pView,CMyPoint* pObj,CPoint2 delta);
	CSelectTool();
	//CDrawObjList m_combineobject;//no use
	CDrawObjList CommonPoints;
//	CPoint m_startpoint,m_endpoint;
	void CSelectTool::ObjectsAt(CDrawView* pView, UINT nFlags,const CPoint& point);
   // void CSelectTool::ObjectsAt1(CDrawView* pView, UINT nFlags,const CPoint& point);//no use
// Implementation
	virtual void OnLButtonDown(CDrawView* pView, UINT nFlags, CPoint& point);
	virtual void OnLButtonDblClk(CDrawView* pView, UINT nFlags, const CPoint& point);
	virtual void OnLButtonUp(CDrawView* pView, UINT nFlags,  CPoint& point);
	virtual void OnMouseMove(CDrawView* pView, UINT nFlags, const CPoint& point);
	virtual void OnEditProperties(CDrawView* pView);
public: 
	int iListindex;///һ϶ʱ϶Ķm_listindex;
	int iCount;///һ϶ʱж

};

class CRectTool : public CDrawTool
{
// Constructors
public:
	CRectTool(DrawShape drawShape);

// Implementation
	virtual void OnLButtonDown(CDrawView* pView, UINT nFlags, CPoint& point);
	virtual void OnLButtonDblClk(CDrawView* pView, UINT nFlags, const CPoint& point);
	virtual void OnLButtonUp(CDrawView* pView, UINT nFlags,  CPoint& point);
	virtual void OnMouseMove(CDrawView* pView, UINT nFlags, const CPoint& point);
};
///////////////////////////////myline///////////////////////////////////
class CLineTool : public CDrawTool
{
// Constructors
public:
	void Delete(CDrawView*pView,CDrawObj*pObj);
	
	CLineTool(DrawShape drawShape);
    ~CLineTool();
// Implementation
	virtual void OnLButtonDown(CDrawView* pView, UINT nFlags, CPoint& point);
	virtual void OnLButtonDblClk(CDrawView* pView, UINT nFlags, const CPoint& point);
	virtual void OnLButtonUp(CDrawView* pView, UINT nFlags,  CPoint& point);
	virtual void OnMouseMove(CDrawView* pView, UINT nFlags, const CPoint& point);
	
	
	CMyLine* pObjline;
	CMyPoint* pObj1;
    CMyPoint* pObj2;
	CPoint m_PointOld;
	
	//BOOL m_movetopoint;
};

///////////////////////////////mycircle///////////////////////////////////
class CCircleTool : public CDrawTool
{
// Constructors
public:
	
	CCircleTool(DrawShape drawShape);

// Implementation
	virtual void CCircleTool::OnLButtonDown1(CDrawView* pView, UINT nFlags, CPoint& point);
	virtual void OnLButtonDown(CDrawView* pView, UINT nFlags, CPoint& point);
	virtual void OnLButtonDblClk(CDrawView* pView, UINT nFlags, const CPoint& point);
	virtual void OnLButtonUp(CDrawView* pView, UINT nFlags,  CPoint& point);
	virtual void OnMouseMove(CDrawView* pView, UINT nFlags, const CPoint& point);
	
	CMyCircle* pObjline;
	CMyPoint* pObj1;
    CMyPoint* pObj2;
	//BOOL m_movetopoint;
};
class CPointTool : public CDrawTool
{
// Constructors
public:
	CMyPoint* m_pickpointfromline;
	CPointTool(DrawShape drawShape);


// Implementation
	virtual void OnLButtonDown(CDrawView* pView, UINT nFlags, CPoint& point);
	virtual void OnLButtonDblClk(CDrawView* pView, UINT nFlags, const CPoint& point);
	virtual void OnLButtonUp(CDrawView* pView, UINT nFlags,  CPoint& point);
	virtual void OnMouseMove(CDrawView* pView, UINT nFlags, const CPoint& point);
};
////////////////////////////////myline///////////////////////////
class CPolyTool : public CDrawTool
{
// Constructors
public:
	CPolyTool();

// Implementation
	virtual void OnLButtonDown(CDrawView* pView, UINT nFlags, CPoint& point);
	virtual void OnLButtonDblClk(CDrawView* pView, UINT nFlags, const CPoint& point);
	virtual void OnLButtonUp(CDrawView* pView, UINT nFlags,  CPoint& point);
	virtual void OnMouseMove(CDrawView* pView, UINT nFlags, const CPoint& point);
	virtual void OnCancel();

	CDrawPoly* m_pDrawObj;
};

////////////////////////////////////////////////////////////////////////////

#endif // __DRAWTOOL_H__
