//Poly_solver.cpp : To compute all roots of a polynomial over the field of complex numbers.
//

#include "pol.h"
#include "lists.h"
#include "check.h"

#ifdef _WINDOWS
#include "..\gui\index.h"
#endif

/*
int main(int argc, char* argv[])
{
		// (x-2)*(x-3)*(x-7)*(x-13)*(3x-17)=3*x^5-92*x^4+1016*x^3-5074*x^2+11413*x-9282
        TDouble Poly[] = {3,-92,1016,-5074,11413,-9282};
		int DEGREE = sizeof(Poly)/sizeof(*Poly)-1;

		//cout << "DEGREE = " << DEGREE << endl;

		TDouble Roots[Max_DEGREE*2];

		Poly_Solver(Poly,Roots,DEGREE);

		for (int i = 0; i < DEGREE; i++)
		{
			printf("\n%f\t%f\n",Roots[2*i],Roots[2*i+1]);
		}

		return 0;
}
*/

void Poly_Solver_sub(TDouble * Poly, TDouble * Roots, int DEGREE)
{
		TDouble pRoots[Max_DEGREE*2+2];
		TDouble SEG, SS, SUG, GPG, GP, GQ;
		TDouble X, Y, X1, Y1, S, DX, DY, U, V, W1, W2, S1, U1, V1, T, DD, DC, C, P, Q, QP;
		int M, i;

		for (i = 0; i < DEGREE+1; i++)
		{
//			printf("\n%f\n", Poly[i]);
		}

		M = DEGREE;
		SEG = 0;
		SS = 0;
		SUG = 1;
		GPG = 1;
		for (i = 0; i < DEGREE+1; i++)
		{
			pRoots[i] = Poly[i]/Poly[0];		//һ
		}
L020:	GP = fabs(pRoots[M]);
		if(GP > 1E-12)	 goto L040;				//
		{
			X = 0;
			Y = 0;
			goto L350;
		}
L040:	GQ = pow(GP, TDouble(1)/TDouble(M));
		GP = GQ;
		GPG = GPG*GP;
		for(i = 0; i < M; i++)
		{
			pRoots[i+1] = pRoots[i+1]/GQ;
			GQ = GP*GQ;
		}
		X = 0.001;
		X1 = X;
		Y = 0;
		Y1 = Y;
		S = 1E+38;
		DX = 1;
L070:	U = pRoots[0];
		V = 0;
		for(i = 0; i < M; i++)
		{
			W1 = U*X1-V*Y1+pRoots[i+1];
			V = U*Y1+V*X1;
			U = W1;
		}
		S1 = pow(U,2)+pow(V,2);
		if(S1 >=S ) goto L280;		//
		S = S1;
		X = X1;
		Y = Y1;
		SS = 0;
		if(S <= 1E-22) goto L330;
		U1 = M*pRoots[0];
		V1 = 0;
		for(i = 1; i < M; i++)
		{
			W1 = U1*X-V1*Y+pRoots[i]*(M-i+1);
			V1 = U1*Y+V1*X;
			U1 = W1;
		}
		W2 = pow(U1,2)+pow(V1,2);
		if(W2 <= 1E-22) goto L240;
		DX = (U*U1+V*V1)/W2;
		DY = (U1*V-V1*U)/W2;
		T = 1+4/M;
L190:	T = T/1.67;
		X1 = X-T*DX;
		Y1 = Y-T*DY;
		if(M < 50) goto L220;
		if(sqrt(pow(X1,2)+pow(Y1,2)) >= exp(85/M)) goto L190;
L220:	if(T >= 0.001) goto L070;
		if(S <= 1E-18) goto L330;
L240:	SS = 1;
		DD = sqrt(pow(DX,2)+pow(DY,2));
		if(DD > 1)
		{
			DD = 1;
		}
		DC = 6.28/(M+4.5);
L270:	C = 0;
L280:	if(SS != 1) goto L190;
		C = C+DC;
		DX = cos(C)*DD;
		DY = sin(C)*DD;
		X1 = X+DX;
		Y1 = Y+DX;
		if(C <= 6.29) goto L070;
		DD = DD/1.67;
		if(DD <= 1E-8) goto L330;
		goto L270;
L330:	if(fabs(Y) <= 0.000001) goto L350;
		P = -2*X;
		Q = pow(X,2)+pow(Y,2);
		pRoots[2*M] = X*GPG;
		pRoots[2*M+1] = -Y * GPG;
		QP = Q * GPG;
		M = M - 1;
		goto L360;
L350:	QP = -X;
		P = -X;
		Y = 0;
		Q = 0;
L360:	for(i=0; i<M; i++)
		{
			pRoots[i+1] = pRoots[i+1]-pRoots[i]*P;
			pRoots[i+2] = pRoots[i+2]-pRoots[i]*Q;
		}
		pRoots[2*M] = X*GPG;
		pRoots[2*M+1] = Y*GPG;
		SEG = SEG+P*GPG;
		SUG = SUG*QP*GPG;
		M = M-1;
		if(M == 0) goto L410;
		if(M == 1) goto L400;
		if(M >= 2) goto L020;
L400:	X = -pRoots[1]/pRoots[0];
		goto L350;
L410:	pRoots[0] = SEG*Poly[0];
		pRoots[1] = SUG*Poly[0];

		for (i = 0; i < DEGREE*2; i++)
		{
			Roots[i] = pRoots[i+2];
		}

		return;
}

//PolyһԪߴ˫ȸϵʽϵӸߵͳУ
//ظöʽи(ʵ鲿TDouble)
//Note: the input list Poly must be a list of TDouble
TList * Poly_Solver(TList * Poly)
{
	int l=Poly->length();
	int DEGREE=l-1;
	int i;

	TList * Res = new TList();

	TDouble Roots[Max_DEGREE*2];
	TDouble pp[Max_DEGREE+1];
	 
    for(i=1;i<=l;i++)
		pp[i-1]=*((TDouble *)(Poly->Part(i)));
    
	Poly_Solver_sub(pp,Roots,DEGREE);

	for(i=0;i<DEGREE;i++)
	{
		//Res->append((TAtom *)(new TDouble(Roots[2*i])));
		//Res->append((TAtom *)(new TDouble(Roots[2*i+1])));
		Res->append((TAtom *)(new TComplex(Roots[2*i],Roots[2*i+1])));
	}

	return Res;
}