
#ifdef _WINDOWS
#include "..\gui\index.h"
#endif
//#include "stdafx.h"

#include "basetype.h"
#include "SListPState.h"
#include "global.h"
#include "express.h"

class TVariable;
  
SListPState::SListPState()
{
 Total=0;
 head=0;
 tail=0;
}

  
SListPState::~SListPState()
{
 SListNodePState *nx,*tmp=head;
 while(tmp!=NULL)
  	{
	nx=tmp->next;
	delete tmp;
	tmp=nx;
  	}
};
 
void SListPState::show(outtype& out)const
{
 SListNodePState *ln=first();
 while(ln) 
 {ln->show(out); out<<" ";
  ln=ln->next;
 }
};
 
void SListPState::print(outtype& out)const
{
 SListNodePState *ln=first();
 while(ln) 
 {ln->print(out); out<<" ";
  ln=ln->next;
 }
}
 
void SListPState::display(outtype& out)const
{
 SListNodePState *ln=first();
 while(ln) 
 {ln->display(out); out<<" ";
  ln=ln->next;
 }
}

 
SListPState *SListPState::Clone()
{
 return Copy();
}

 
SListPState *SListPState::Copy()
{
 SListPState *nl=new SListPState();
 SListNodePState * nn=0, *tmp=head;
 while(tmp) 
  {
	nn=tmp->Clone();
	nl->append(nn);
	tmp= tmp->next;
 }
return nl;
}
//========================================================

//***************************************************************
// *  Three append functions
//======================================================

  
void SListPState::append(SListNodePState *data)
{
 if(data==0) return;
 if(tail==NULL)
  	{
	head=tail=data;
   	data->next=NULL;
	Total=1;
  	}
 else {
      	Total++;
 	tail->next=data;
        tail=data;
	tail->next=NULL;
      	}
 return;
}

  
void SListPState::append(PState *data)
{
 if(data==0) return;
 SListNodePState *ln=new SListNodePState(data);
 append(ln);
 return;
}

//=========== ================================
//== Merge two list into one ================
//===========================================
 
void SListPState::append(SListPState *mlist)
{
 if(! mlist ) return;
 if(mlist->tail==NULL) {
	delete mlist;
	return;
	}

 if(tail==NULL)
  	{
	head=mlist->head;
   	tail=mlist->tail;
   	Total=mlist->Total;
  	}
 else {
	Total +=mlist->Total;
	tail->next=mlist->head;
        tail=mlist->tail;
	}
 mlist->head=mlist->tail=0;
 delete mlist;
 return;
}


  
void SListPState::cleardata()
{
 SListNodePState *tn1,*tn=head;
 while(tn)
 {
  tn1= tn->next;
 //PState*nd=tn->getdata(); nd=0; nt->next=0; 
  delete tn;
  tn=tn1;
 } 
 head=0;
 tail=0; 
 Total=0;
}

//*********************************************************
//**  three remove functions below
//========================================================
 
  
void SListPState::remove(SListNodePState *data)
{
 if(data==0) return;
 SListNodePState *tn=head;
 if (tn==data) {
	Total--;
	head=tn->next;
	if ( !head ) tail=0;
	delete data; // added 2.26
	return;
	}
 while (tn->next != NULL) 
	{
	if (tn->next != data ) {
		tn=tn->next;
		continue;
		}
	Total--;
	tn->next=tn->next->next;
	if (tail==data) tail=tn;
	delete data; // added 2.26
	}
 return;
}

 
void SListPState::insert(SListPState *ilist, SListNodePState *pos)
{
 if(!ilist) return;
 SListNodePState *tmp1,*tmp2,  *tmp;
 if(ilist==0) return;
 if(!pos|| pos==first() )
  {
   Total +=ilist->Total;
   tmp2=ilist->last();
   tmp2->next= head;
   head=ilist->first();
 }
 tmp1=first();
 tmp=tmp1->next;
 while(tmp)
  {
   if(tmp==pos) break; 
   tmp1=tmp;
   tmp=tmp->next;
  }
 if(!tmp) return;
 tmp2=ilist->last();
 tmp2->next=tmp;
 tmp1->next=ilist->first();
 return;
   
}

 
void SListPState::insert(SListNodePState *data, SListNodePState *pos)
{
 if(data==0) return;
 SListNodePState *tmp1,*tmp;

 //if(!pos|| pos==first() )
 if(head==0 || pos==head)
  {
   Total ++;
   data->next= head;
   head=data;
   if (tail==0) tail=data;
   return;
 }

 if (pos==0) {
	tail->next=data;
	data->next=0;
	tail=data;
	Total++;
 	return;
	}

 tmp1=first();
 tmp=tmp1->next;
 while(tmp)
  {
   if(tmp==pos) break; 
   tmp1=tmp;
   tmp=tmp->next;
  }
 if(!tmp) return;
 data->next=tmp;
 tmp1->next=data;
 Total++;
 return;
}

 
void SListPState::insert(PState *data, SListNodePState *pos)
{
 if(data==0) return;
 SListNodePState   *ln=new SListNodePState(data);
 insert(ln,pos);

}

 
void *SListPState::operator new(size_t)
{
 return  (SListPState *)StarMem->alloc();
};
 
void SListPState::operator delete(void *p)
{
 (StarMem->free(p));
};

//////////////////////////////////////////
//     end of SList.cpp
////////////////////////////////////////
//     	begin of slistnode.cpp
////////////////////////////////////

  
SListNodePState::SListNodePState(PState *h)
{
 data=h;
 next=0;

 if(h)
 RefCount=new unsigned long(1);
   else
 	RefCount=new unsigned long(0);
}

  
SListNodePState::~SListNodePState()
{
// if(data) delete data;

 if(data)
  {
    if((*RefCount)>1)
          RefDec();
     else
       {
//------------
if (data->TypeID() != Variable)
	 delete data;
         delete RefCount;
       }
  }
 else if(RefCount) delete RefCount;	

}
 

  
void SListNodePState::ClearMem()
 {
   if(data)
       if( (*RefCount)==1)
		delete data;
           else RefDec();
   data=0;
 }

  
unsigned long SListNodePState::SetRef(unsigned long *n)
{
         if(n==RefCount) return *n;
             else
              {
                if( !(*RefCount) )
                  delete RefCount;
                //else RefDec();
                 (RefCount=n);
                 return *n;
               }
};

  
int SListNodePState::SetMem(PState *i )
{
 //====== W==1: Set new memory
 //             not set new memory
 int w=1;
 if(i !=data)
   {
    ClearMem();
    data=i;
   }
   else w=0;
 return w;
}


  
SListNodePState* SListNodePState::Clone()
{
 SListNodePState *cb;
 cb=new SListNodePState(data);
 cb->SetRef(RefCount);
 RefInc();
// cb->next=0;
 return cb;
};

 
void SListNodePState::display(outtype& out)const
{
 if(data) data->display(out);
};

  
void SListNodePState::show(outtype& out)const
{
 if(data) data->show(out);
};

  
void SListNodePState::print(outtype& out)const
{
 if(data) data->print(out);
};

 
int SListNodePState::compare(SListNodePState *n)
{
 return data->compare(n->data);
}

 
PState*SListNodePState::getdata()
{ return data;};

 
void *SListNodePState::operator new(size_t)
{
 return  (SListNodePState *)StarMem->alloc();
};
 
void SListNodePState::operator delete(void *p)
{
 (StarMem->free(p));
};

