
#ifndef __SListPState_H__
#define __SListPState_H__

#include "basetype.h"

class SListPState
{
 protected:
	friend class SListNodePState;
	SListNodePState   *head, *tail;
	int Total;
 public:
	SListPState();
	virtual ~SListPState();

	virtual void append(PState   *data);
	virtual void append(SListNodePState *data);
	virtual void append(SListPState *list);

	virtual void insert(PState  *data, SListNodePState *pos=0);
	virtual void insert(SListNodePState * data, SListNodePState *pos=0);
	virtual void insert(SListPState  *list, SListNodePState *pos=0);
	virtual void remove(SListNodePState *data);           //removing a 'data'

	SListNodePState *first()const {return head;}
	SListNodePState *last()const  {return tail;}
	virtual int   length() {return Total;}

	SListPState * Clone() ;
	SListPState * Copy() ;

	virtual void cleardata(); 
	   //clear data in node, delete all nodes except data

    virtual void display(outtype& out =wout) const;
    virtual void show(outtype& out =wout) const;
    virtual void print(outtype& out =wout) const;
 
    void* operator new(size_t);
    void  operator delete(void *);
 
};

  class SListNodePState
{
 friend class TVarList;
 protected: 
 PState*data;
  unsigned long * RefCount;
 public:
  SListNodePState * next;

  SListNodePState(PState *h=NULL);
  virtual ~SListNodePState();

  virtual PState  *getdata();
  virtual int  compare(SListNodePState *);

  virtual void display(outtype& out =wout) const;
  virtual void show(outtype& out =wout) const;
  virtual void print(outtype& out =wout) const;
 
  void* operator new(size_t);
  void  operator delete(void *);

   unsigned long& Ref()const { return *RefCount; };
   unsigned long SetRef(unsigned long *n);
   unsigned long RefInc() { return ++(*RefCount); };
   unsigned long RefDec() { return --(*RefCount); };

   SListNodePState* Clone();
   virtual void  ClearMem();
   virtual int   SetMem(PState*);
//=====================================================================
//    friend  bool  SameData(const SListNodePState*,const SListNodePState*);

};

#endif



