#include <stdlib.h>
#include <iostream.h>

#include "atom.h"
#include "global.h"
//#include "number0.h"
#include "num_number.h"
#include "poly.h"
#include "trpoly.h"
#include "pol.h"
#include "express.h"
#include "vectors.h"
#include "matrix.h"
#ifdef _WINDOWS
#include "../gui/index.h"
#endif
extern "C" {
#include <time.h>
}
//int t,t1;
/*
void* TAtom::operator new(size_t)
{
  return  (TAtom*)StarMem->alloc();
};
void  TAtom::operator delete(void *p)
 {
  (StarMem->free(p));
 };
void* TRun::operator new(size_t)
 {
 return  (TRun*)StarMem->alloc();
 };
void  TRun::operator delete(void *p)
 {
(StarMem->free(p));
 };
 
*/ 

int IsZero(TAtom *s)
{
 if (!s) return 1;

 DataType dt = s->TypeID();
 
 switch ( dt ) {
    case RIPolyType:
		return ((TRIPoly *)s)->IsZero();
		break;
	case BaseNumber:
		if((*(TBigInt *)s) == 0)
		return 1;
		else return 0;
		break;
	case RationalType:
		return ((TRational *)s)->IsZero();
		break;
	default: 
		wout << "TAtom: IsZero: Type error.";
        return 0;
		break;
	}
}
 

TAtom *add(TAtom *s1, TAtom *s2)
{ 
 TBigInt *n;
 TNumber b;
 TAtom *a;
 TPoly p;
 //TRPoly rp;
 TRIPoly rp;
 TRIPoly rip;
 TExpression *ne;
 TExpTerm *nt;
 TMatrix *m;
 TRational *r;
// wout<<"calling function add of basetype.cc\n";
 if ( !s1 && !s2) return 0;
 if ( !s1 ) return s2;
 if ( !s2 ) return s1;

 DataType dt,dt1=s1->TypeID();
 DataType dt2=s2->TypeID();
// if(dt1 != dt2)
//     {
//       if( dt1== Reciprocal){ dt=dt1; dt1=dt2; dt2=dt; a=s1; s1=s2; s2=a;}
//     }
/* if (dt1== Reciprocal) {
	a=((TReciprocal *)s1)->add((TReciprocal *)s2);
	delete s1;
	delete s2;
 	return a;
	}
*/

 if(dt1 != MatrixType && dt2 == MatrixType)
 {
	dt = dt1; dt1 = dt2; dt2 = dt;
	a = s1; s1 = s2; s2 = a;
 }
 if(dt1 != RationalType && dt2 == RationalType)
 {
	dt = dt1; dt1 = dt2; dt2 = dt;
	a = s1; s1 = s2; s2 = a; 
 }
 if(dt1 != RationalExpType && dt2 == RationalExpType)
 {
	dt = dt1; dt1 = dt2; dt2 = dt;
	a = s1; s1 = s2; s2 = a; 
 }
 if(dt1 != ArrayType && dt2 == ArrayType)
 {
	dt = dt1; dt1 = dt2; dt2 = dt;
	a = s1; s1 = s2; s2 = a; 
 }

 switch ( dt1 ) {
	case BaseNumber:
		switch (dt2) {
			case BaseNumber:
				b=((*(TNumber *)s1)+(*(TNumber *)s2)); 
				delete s1;
				delete s2;
				return new TNumber(b);
				break;
			case PolyType: 
				p=TPoly(*(TNumber *)s1)+(*(TPoly *)s2);
				delete s1;
				delete s2;
				return new TPoly(p);
				break;
			/*case RPolyType: 
				rp=TRPoly(*(TNumber *)s1)+(*(TRPoly *)s2);
				delete s1;
				delete s2;
				return new TRPoly(rp);
				break;*/
             
			case RIPolyType: 
                rp=TRIPoly(*(TNumber *)s1)+(*(TRIPoly *)s2);
				delete s1;
				delete s2;
				return new TRIPoly(rp);
				break;
            
            /*case RIPolyType:
				if(((TNumber *)s1)->GetPtr()->TypeID()!=BigNumberType)
				{
				wout<<"Type is wrong;"<<endl;
				delete s1;
				delete s2;
				return 0;
				break;
				}
				n=(TBigInt *)((TNumber *)s1)->GetPtr();
//wout<<"nnnnn="<<*n<<endl;
//wout<<"p=";
//s2->display();
//wout<<endl;          
//wout<<"p2=";
//s2->display();
//wout<<endl;
                                rip=TRIPoly(*(TBigInt *)n)+(*(TRIPoly *)s2);
//wout<<"rip1=";rip.display();wout<<endl;
                                delete s1;
                                delete s2;
                                return new TRIPoly(rip);
                                break;*/
//			case Reciprocal:
			case Factorial:
			case ProcCall:
			case Variable: 
                		nt=new TExpTerm();
                		nt->insert(new TExpTermCell(s2));
                		ne=new TExpression();
                		ne->insert(nt);
				s2=ne;
			case Expression: 
				nt=new TExpTerm();
				nt->insert(new TExpTermCell(s1));
				ne=new TExpression();
				ne->insert(nt);
				ne->add((TExpression *)s2);
				delete s2;
				return ne;
				break;
			default: break;
			}
		break;
	case PolyType:
		switch (dt2) {
                        case BaseNumber:
                                p=TPoly(*(TNumber *)s2)+(*(TPoly *)s1);
				delete s1;
				delete s2;
                                return new TPoly(p);
                        case PolyType:
                                p=(*(TPoly *)s1)+(*(TPoly *)s2);
				delete s1;
				delete s2;
                                return new TPoly(p);
//			case Reciprocal:
			case Factorial:
			case ProcCall:
			case Variable: 
                		nt=new TExpTerm();
						//nt->sign=simplify(s2);
                		nt->insert(new TExpTermCell(s2));
                		ne=new TExpression();
                		ne->insert(nt);
				s2=ne;
                        case Expression:
                                nt=new TExpTerm();
                                nt->insert(new TExpTermCell(s1));
                                ne=new TExpression();
                                ne->insert(nt);
				ne->add((TExpression *)s2);
				delete s2;
                                return ne;
                        default: break;
                        }
		break;
/*	case RPolyType:
		switch (dt2) {
                        case BaseNumber:
                                rp=TRPoly(*(TNumber *)s2)+(*(TRPoly *)s1);
				delete s1;
				delete s2;
                                return new TRPoly(rp);
                        case RPolyType:
				clock();
//				t1=clock();
                                rp=(*(TRPoly *)s1)+(*(TRPoly *)s2);
//				t=clock();
 //                               wout<<"\ntime is:"<<t-t1<<endl;
				delete s1;
				delete s2;
                                return new TRPoly(rp);
//			case Reciprocal:
			case Factorial:
			case ProcCall:
			case Variable: 
                		nt=new TExpTerm();
                		nt->insert(new TExpTermCell(s2));
                		ne=new TExpression();
                		ne->insert(nt);
				s2=ne;
                        case Expression:
                                nt=new TExpTerm();
                                nt->insert(new TExpTermCell(s1));
                                ne=new TExpression();
                                ne->insert(nt);
				ne->add((TExpression *)s2);
				delete s2;
                                return ne;
                        default: break;
                        }
		break;
*/
		case RIPolyType:
                switch (dt2) {
                        /*case BaseNumber:
				if(((TNumber *)s2)->GetPtr()->TypeID()!=BigNumberType)
                                {
                                wout<<"Type is wrong;"<<endl;
				delete s1;
                                delete s2;
                                return 0;
                                break;
                                }	
				n=(TBigInt *)((TNumber *)s2)->GetPtr();
//wout<<"n="<<*n<<endl;
//wout<<"p=";(*(TRIPoly *)s1).display();wout<<endl;
				rip=TRIPoly(*(TBigInt *)n)+(*(TRIPoly *)s1);
//wout<<"rip=";rip.display();wout<<endl;
                                delete s1;
                                delete s2;
                                return new TRIPoly(rip);*/
				        case BaseNumber:
							    rp=TRIPoly(*(TNumber *)s2)+(*(TRIPoly *)s1);
				                delete s1;
				                delete s2;
                                return new TRIPoly(rp);
                        case RIPolyType:
//                                clock();
//                                t1=clock();
//wout<<"s1=";((TRIPoly *)s1)->display();wout<<endl;
//wout<<"s2=";((TRIPoly *)s2)->display();wout<<endl; 
                                rip=(*(TRIPoly *)s1)+(*(TRIPoly *)s2);
//                                t=clock();
                                //wout<<"\ntime is:"<<t-t1<<endl;
                                delete s1;
                                delete s2;
                                return new TRIPoly(rip);
//                        case Reciprocal:
                        case Factorial:
                        case ProcCall:
                        case Variable:
                                nt=new TExpTerm();
                                nt->insert(new TExpTermCell(s2));
                                ne=new TExpression();
                                ne->insert(nt);
                                s2=ne;
                        case Expression:
                                nt=new TExpTerm();
                                nt->insert(new TExpTermCell(s1));
                                ne=new TExpression();
                                ne->insert(nt);
                                ne->add((TExpression *)s2);
                                delete s2;
                                return ne;
                        default: break;
                        }
                break;
	case Factorial:
	case ProcCall:
	case Variable: 
                nt=new TExpTerm();
                nt->insert(new TExpTermCell(s1));
                ne=new TExpression();
                ne->insert(nt);
		s1=ne;
	case Expression:
		switch (dt2) {
                        case BaseNumber:
                        case PolyType:
                                nt=new TExpTerm();
                                nt->insert(new TExpTermCell(s2));
                                ne=new TExpression();
                                ne->insert(nt);
                                ne->add((TExpression *)s1);
				delete s1;
                                return ne;
/*                        case RPolyType:
                                nt=new TExpTerm();
                                nt->insert(new TExpTermCell(s2));
                                ne=new TExpression();
                                ne->insert(nt);
                                ne->add((TExpression *)s1);
				delete s1;
                                return ne;
*/
			case RIPolyType:
                                nt=new TExpTerm();
                                nt->insert(new TExpTermCell(s2));
                                ne=new TExpression();
                                ne->insert(nt);
                                ne->add((TExpression *)s1);
                                delete s1;
                                return ne;
//			case Reciprocal:
			case Factorial:
			case ProcCall:
			case Variable: 
                		nt=new TExpTerm(); // NO.1
                		nt->insert(new TExpTermCell(s2));//NO .2
                		ne=new TExpression(); //NO .3
                		ne->insert(nt); //NO .4
				s2=ne;
                        case Expression:
				((TExpression *)s2)->add((TExpression *)s1);
				delete s1;
				return s2;
                        default: break;
                        }
		break;
	case VectorType:
		switch (dt2) {
			case VectorType: {
				TVector *nv=((TVector *)s1)->add((TVector *)s2);
				delete s1;
				delete s2;
				return nv;
				}
			default: break;
			}
		break;
	case MatrixType:
		switch (dt2) {
		case MatrixType: {
			m = ((TMatrix *)s1)->add((TMatrix *)s2);
			delete s1;
			delete s2;
			return m;
			}
		default: break;
		}
		break;
	case RationalType:
		switch(dt2){
		case BaseNumber:
			{
				TRIPoly * n1,*d1;
				TRational r1(((TRational *)s1)->GetNu(),((TRational *)s1)->GetDe());				
				n1 = new TRIPoly(((TNumber *)s2)->Ceil());
				d1 = new TRIPoly(TBigInt(1));
				TRational r2(n1,d1);
				TRational rat = r1 + r2;
				delete s1;
				delete s2;
				delete n1;
				delete d1;
				r = new TRational(rat.GetNu(),rat.GetDe());
				return r;
				break;
			}
		case Variable:
			{
				TRIPoly * n1,*d1;
				TRational r1(((TRational *)s1)->GetNu(),((TRational *)s1)->GetDe());
				n1 = new TRIPoly(TV(s2),1);
				d1 = new TRIPoly(TBigInt(1));
				TRational r2(n1,d1);
				TRational rat = r1 + r2;
				delete s1;
				delete n1;
				delete d1;
				r = new TRational(rat.GetNu(),rat.GetDe());
				return r;
				break;
			}
		case Expression:
			{
				TRIPoly * n1,*d1;
				TRational r1(((TRational *)s1)->GetNu(),((TRational *)s1)->GetDe());
				n1 = TP(((TExpression *)s2)->eval());
				d1 = new TRIPoly(TBigInt(1));
				TRational r2(n1,d1);
				TRational rat = r1 + r2;
				delete s1;
				delete s2;
				delete n1;
				delete d1;
				r = new TRational(rat.GetNu(),rat.GetDe());
				return r;
				break;
			}
		case RIPolyType:
			{
				TRIPoly * d1;
				TRational r1(((TRational *)s1)->GetNu(),((TRational *)s1)->GetDe());
				d1 = new TRIPoly(TBigInt(1));
				TRational r2(TP(s2),d1);
				TRational rat = r1 + r2;
				delete s1;
				delete s2;
				delete d1;
				r = new TRational(rat.GetNu(),rat.GetDe());
				return r;
				break;
			}
		case RationalType:
			{
				TRational r1(((TRational *)s1)->GetNu(),((TRational *)s1)->GetDe());
				TRational r2(((TRational *)s2)->GetNu(),((TRational *)s2)->GetDe());
				TRational rat = r1 + r2;
				delete s1;
				delete s2;
				r = new TRational(rat.GetNu(),rat.GetDe());
				return r;
				break;
			}
		default:
			break;			
		}
		break;
	case RationalExpType:
		switch (dt2){
		case Expression:
			{

				break;
			}
		case RationalExpType:
			{
				break;
			}
		default:
			break;
		}
		break;
	case ArrayType:
		switch (dt2){
		case ArrayType:
			{
				Tarray * s;
				s=(Tarray*) ((Tarray *)s1)->add((Tarray *)s2);
				delete s1;
				delete s2;
				return s;
				break;
			}
		default:
			break;
		}
		break;
	default: break;
		}
 wout<<"Add Error: Wrong Type!!!!\n";
 return 0;
}


TAtom *minus(TAtom *s1, TAtom *s2)
{
	int a = 1;
	return add(s1,uminus(s2));
}

TAtom *mul(TAtom *s1, TAtom *s2)
{
 TBigInt *n;
 TNumber b;
 TAtom *a;
// TReciprocal *r;
 TPoly p;
// TRPoly rp;
 TRIPoly rp;
 TRIPoly rip;
 TExpression *ne;
 TExpTerm *nt;
 TMatrix *m;
 TRational * ra;
// wout<<"calling function mul of basetype.cc\n";
// if ( !s1 || !s2) {
	//wout<<"Mul Error: Wrong Type!!!!\n";
//	return 0;
//	}

 if ( !s1 && !s2) return 0;
 if ( !s1 ) {delete s2; return 0;}
 if ( !s2 ) {delete s1; return 0;}

 DataType dt,dt1=s1->TypeID();
 DataType dt2=s2->TypeID();
// if(dt1 != dt2)
//     {
//       if( dt1== Reciprocal){ dt=dt1; dt1=dt2; dt2=dt; a=s1; s1=s2; s2=a;}
//     }
/* if (dt1== Reciprocal) {
	r=((TReciprocal *)s1)->mul((TReciprocal *)s2);
	delete s1;
	delete s2;
 	return r;
	}
	*/
 if(dt1 != MatrixType && dt2 == MatrixType)
 {
	dt = dt1; dt1 = dt2; dt2 = dt;
	a = s1; s1 = s2; s2 = a;
 }
 if(dt1 != RationalType && dt2 == RationalType)
 {
	dt = dt1; dt1 = dt2; dt2 = dt;
	a = s1; s1 = s2; s2 = a; 
 }
 if(dt1 != ArrayType && dt2 == ArrayType)
 {
	dt = dt1; dt1 = dt2; dt2 = dt;
	a = s1; s1 = s2; s2 = a; 
 }

 switch ( dt1 ) {
	case BigNumberType:
		switch (dt2){
		case RIPolyType:
			TRIPoly *tmp = new TRIPoly((TBigInt *)s1);
			rip = (*tmp)*(*(TRIPoly *)s2);
			TRIPoly *tmp2 = new TRIPoly(rip);
			delete tmp;
			delete s2;
			return tmp2;
		}
		break;
	case BaseNumber:
		switch (dt2) {
			case BaseNumber:
				b=(*(TNumber *)s1)*(*(TNumber *)s2);
				delete s1;
				delete s2;
				return new TNumber(b);
			case PolyType: 
				p=TPoly(*(TNumber *)s1)*(*(TPoly *)s2);
				delete s1;
				delete s2;
				return new TPoly(p);
/*			case RPolyType: 
				rp=TRPoly(*(TNumber *)s1)*(*(TRPoly *)s2);
				delete s1;
				delete s2;
				return new TRPoly(rp);
*/
			case RIPolyType: 
				rp=TRIPoly(*(TNumber *)s1)*(*(TRIPoly *)s2);
				delete s1;
				delete s2;
				return new TRIPoly(rp);

			/*case RIPolyType:
				if(((TNumber *)s1)->GetPtr()->TypeID()!=BigNumberType)
                                {
                                wout<<"Type is wrong;"<<endl;
                                delete s1;
                                delete s2;
                                return 0;
                                break;
                                }
                                n=(TBigInt *)(((TNumber *)s1)->GetPtr());
                                rip=TRIPoly((*(TBigInt *)n))*(*(TRIPoly *)s2);
                                delete s1;
                                delete s2;
                                return new TRIPoly(rip);*/
//			case Reciprocal:
//				a=::mul(s1,((TReciprocal *)s2)->GetD()->Copy());	
//				r=new TReciprocal (a,((TReciprocal *)s2)->GetN()->Copy() );
//				delete s2;
//				return r;	
			case Factorial:
			case ProcCall:
			case Variable:
				nt=new TExpTerm();
				nt->insert(new TExpTermCell(s2));
				ne=new TExpression();
				ne->insert(nt);
				s2=ne;
			case Expression: 
				nt=new TExpTerm();
				nt->insert(new TExpTermCell(s1));
				ne=new TExpression();
				if (s2->length()==1) {
					TExpTerm *t;
					t=((TExpression *)s2)->first()
						->getdata();
					nt->mul(t);
					ne->insert(nt);
					delete s2;
					}
				else {
					TExpTerm *t=new TExpTerm();
					t->insert(new TExpTermCell(s2));
					t->mul(nt);
					delete nt;
					ne->insert(t);
					}
				return ne;
			case MatrixType:
			default: break;
			}
		break;
	case PolyType:
		switch (dt2) {
                        case BaseNumber:
                                p=TPoly(*(TNumber *)s2)*(*(TPoly *)s1);
				delete s1;
				delete s2;
                                return new TPoly(p);
                        case PolyType:
                                p=(*(TPoly *)s1)*(*(TPoly *)s2);
				delete s1;
				delete s2;
                                return new TPoly(p);
//			case Reciprocal:
//				a=::mul(s1,((TReciprocal *)s2)->GetD()->Copy());	
//				r=new TReciprocal (a,((TReciprocal *)s2)->GetN()->Copy() );
//				delete s2;
//				return r;	
			case Factorial:
			case ProcCall:
			case Variable:
				nt=new TExpTerm();
				nt->insert(new TExpTermCell(s2));
				ne=new TExpression();
				ne->insert(nt);
				s2=ne;
			case Expression: 
				nt=new TExpTerm();
				nt->insert(new TExpTermCell(s1));
				ne=new TExpression();
				if (s2->length()==1) {
					TExpTerm *t;
					t=(TExpTerm *)(((TExpression *)s2)->first()
						->getdata()->Copy());
					nt->mul(t);
					ne->insert(nt);
					delete s2;
					}
				else {
					TExpTerm *t=new TExpTerm();
					t->insert(new TExpTermCell(s2));
					t->mul(nt);
					delete nt;
					ne->insert(t);
					}
				return ne;
                        default: break;
                        }
		break;
/*	case RPolyType:
		switch (dt2) {
                        case BaseNumber:
                                rp=TRPoly(*(TNumber *)s2)*(*(TRPoly *)s1);
				delete s1;
				delete s2;
                                return new TRPoly(rp);
                        case RPolyType:
				clock();
//				t1=clock();
                                rp=(*(TRPoly *)s1)*(*(TRPoly *)s2);
//			 	t=clock();
//				wout<<"\ntime is:"<<t-t1<<endl;	
				delete s1;
				delete s2;
                                return new TRPoly(rp);
//			case Reciprocal:
//				a=::mul(s1,((TReciprocal *)s2)->GetD()->Copy());	
//				r=new TReciprocal (a,((TReciprocal *)s2)->GetN()->Copy() );
//				delete s2;
//				return r;	
			case Factorial:
			case ProcCall:
			case Variable:
				nt=new TExpTerm();
				nt->insert(new TExpTermCell(s2));
				ne=new TExpression();
				ne->insert(nt);
				s2=ne;
			case Expression: 
				nt=new TExpTerm();
				nt->insert(new TExpTermCell(s1));
				ne=new TExpression();
				if (s2->length()==1) {
					TExpTerm *t;
					t=(TExpTerm *)(((TExpression *)s2)->first()
						->getdata()->Copy());
					nt->mul(t);
					ne->insert(nt);
					delete s2;
					}
				else {
					TExpTerm *t=new TExpTerm();
					t->insert(new TExpTermCell(s2));
					t->mul(nt);
					delete nt;
					ne->insert(t);
					}
				return ne;
                        default: break;
                        }
		break;
*/
	case RIPolyType:
                switch (dt2) {
                        /*case BaseNumber:
				if(((TNumber *)s2)->GetPtr()->TypeID()!=BigNumberType)
                                {
                                wout<<"Type is wrong;"<<endl;
                                delete s1;
                                delete s2;
                                return 0;
                                break;
                                }
                                n=(TBigInt *)((TNumber *)s2)->GetPtr();
                                rip=TRIPoly((*(TBigInt *)n))*(*(TRIPoly *)s1);
                                delete s1;
                                delete s2;
                                return new TRIPoly(rip);*/
				        case BaseNumber:
					            rp=TRIPoly(*(TNumber *)s2)*(*(TRIPoly *)s1);
				                delete s1;
				                delete s2;
                                return new TRIPoly(rp);
                        case RIPolyType:
                                clock();
  //                              t1=clock();
                                rip=(*(TRIPoly *)s1)*(*(TRIPoly *)s2);
//                                t=clock();
//                                wout<<"time is:"<<t-t1<<endl;
                                delete s1;
                                delete s2;
                                return new TRIPoly(rip);
//                      case Reciprocal:
//                                a=::mul(s1,((TReciprocal *)s2)->GetD()->Copy());

//                                r=new TReciprocal (a,((TReciprocal *)s2)->GetN()
//->Copy() );
//                                delete s2;
//                                return r;
                        case Factorial:
                        case ProcCall:
                        case Variable:
                                nt=new TExpTerm();
                                nt->insert(new TExpTermCell(s2));
                                ne=new TExpression();
                                ne->insert(nt);
                                s2=ne;
                        case Expression:
                                nt=new TExpTerm();
                                nt->insert(new TExpTermCell(s1));
                                ne=new TExpression();
                                if (s2->length()==1) {
                                        TExpTerm *t;
                                        t=(TExpTerm *)(((TExpression *)s2)->first()
                                                ->getdata()->Copy());
                                        nt->mul(t);
                                        ne->insert(nt);
                                        delete s2;
                                        }
                                else {
                                        TExpTerm *t=new TExpTerm();
                                        t->insert(new TExpTermCell(s2));
                                        t->mul(nt);
                                        delete nt;
                                        ne->insert(t);
                                        }
                                return ne;
                        default: break;
                        }
                break;
	case Factorial:
	case ProcCall:
	case Variable:
		nt=new TExpTerm();
		nt->insert(new TExpTermCell(s1));
		ne=new TExpression();
		ne->insert(nt);
		s1=ne;
	case Expression:
		switch (dt2) {
//			case Reciprocal:
//				a=::mul(s1->Copy(),((TReciprocal *)s2)->GetD()->Copy());	
//				r=new TReciprocal (a,((TReciprocal *)s2)->GetN()->Copy() );
//				delete s1; delete s2;
//				return r;	
                        case BaseNumber:
			case Factorial:
                        case PolyType:
//			case RPolyType:
			case RIPolyType:
			case ProcCall:
			case Variable:
                                nt=new TExpTerm();
                                nt->insert(new TExpTermCell(s2));
                                ne=new TExpression();
                                ne->insert(nt);
								s2=ne;
                        case Expression:
					//*
					TExpTerm * nt1;
							if (s1->length()==1) {
					nt1=(TExpTerm *)(((TExpression *)s1)->first()
						->getdata()->Copy());
					delete s1;
					}
				else {
					nt1=new TExpTerm();
					nt1->insert(new TExpTermCell(s1));
					}
				if (s2->length()==1) {
					nt=(TExpTerm *)(((TExpression *)s2)->first()
						->getdata()->Copy());
					delete s2;
					}
				else {
					nt=new TExpTerm();
					nt->insert(new TExpTermCell(s2));
					}
				nt->mul(nt1);
				delete nt1;
				ne=new TExpression();
				ne->insert(nt);
				//*/
				//ne = ((TExpression *)s2)->mul((TExpression *)s1);
				//ne = mul((TExpression *)s2,(TExpression *)s1);
				return ne;
                        default: break;
                        }
		break;
	case VectorType:
		switch (dt2) {
			case VectorType: {
				TAtom *nv=((TVector *)s1)->mul((TVector *)s2);
				delete s1;
				delete s2;
				return nv;
				}
			default: break;
			}
		break;
	case MatrixType:
		{
			TAtom *ss2 = s2->eval();
			dt2 = ss2->TypeID();
		switch (dt2) {
			case MatrixType:
				m = ((TMatrix *)s1)->mul((TMatrix *)ss2);
				delete s1;
				delete s2;
				delete ss2;
				return m;
			case BaseNumber:
			case RIPolyType:
			{
				TMatrix *tmp = new TMatrix(((TMatrix *)s1)->HSize(),((TMatrix *)s1)->HSize());
				for(int i = 0;i < ((TMatrix *)s1)->HSize();i ++)
						tmp->SetVal(i,i,ss2->eval());
				m = ((TMatrix *)s1)->mul(tmp);
				delete s1;
				delete s2;
				delete ss2;
				delete tmp;
				return m;
			}

			default: break;
		}
		}
		break;
	case RationalType:
		{
			switch(dt2){
				case BaseNumber:
					{
					TRIPoly * n1,*d1;
					TRational r1(((TRational *)s1)->GetNu(),((TRational *)s1)->GetDe());				
					n1 = new TRIPoly(((TNumber *)s2)->Ceil());
					d1 = new TRIPoly(TBigInt(1));
					TRational r2(n1,d1);
					TRational rat = r1 * r2;
					delete s1;
					delete s2;
					delete n1;
					delete d1;
					ra = new TRational(rat.GetNu(),rat.GetDe());
					return ra;
					break;
					}
				case Variable:
					{
					TRIPoly * n1,*d1;
					TRational r1(((TRational *)s1)->GetNu(),((TRational *)s1)->GetDe());
					n1 = new TRIPoly(TV(s2),1);
					d1 = new TRIPoly(TBigInt(1));
					TRational r2(n1,d1);
					TRational rat = r1 * r2;
					delete s1;
					delete n1;
					delete d1;
					ra = new TRational(rat.GetNu(),rat.GetDe());
					return ra;
					break;
					}
				case Expression:
					{
					TRIPoly * n1,*d1;
					TRational r1(((TRational *)s1)->GetNu(),((TRational *)s1)->GetDe());
					n1 = TP(((TExpression *)s2)->eval());
					d1 = new TRIPoly(TBigInt(1));
					TRational r2(n1,d1);
					TRational rat = r1 * r2;
					delete s1;
					delete s2;
					delete n1;
					delete d1;
					ra = new TRational(rat.GetNu(),rat.GetDe());
					return ra;
					break;
					}
				case RIPolyType:
					{
					TRIPoly * d1;
					TRational r1(((TRational *)s1)->GetNu(),((TRational *)s1)->GetDe());
					d1 = new TRIPoly(TBigInt(1));
					TRational r2(TP(s2),d1);
					TRational rat = r1 * r2;
					delete s1;
					delete s2;
					delete d1;
					ra = new TRational(rat.GetNu(),rat.GetDe());
					return ra;
					break;
					}
				case RationalType:
					{
					TRational r1(((TRational *)s1)->GetNu(),((TRational *)s1)->GetDe());
					TRational r2(((TRational *)s2)->GetNu(),((TRational *)s2)->GetDe());
					TRational rat = r1 * r2;
					delete s1;
					delete s2;
					ra = new TRational(rat.GetNu(),rat.GetDe());
					return ra;
					break;
					}
				default: break;
			}
		}
		break;
		case ArrayType:
		switch (dt2){
			case ArrayType:
			{
				Tarray * s;
				s = (Tarray *)(((Tarray *)s1)->OuterProduct((Tarray *)s2));
				delete s1;
				delete s2;
				return s;
				break;
			}
			case BaseNumber:
			case Expression:
			case RIPolyType:
			{
				Tarray * s;
				s = (Tarray *)(((Tarray *)s1)->NumberProduct(s2));
				delete s1;
				delete s2;
				return s;
				break;
			}
			case Variable:
			{
				nt=new TExpTerm();
                nt->insert(new TExpTermCell(s2));
                ne=new TExpression();
                ne->insert(nt);
				s2=ne;
				Tarray * s;
				s = (Tarray *)(((Tarray *)s1)->NumberProduct(s2));
				delete s1;
				delete s2;
				return s;
				break;
			}
		default:
			break;
		}
		break;
	default: break;
		}
 wout<<"Mul Error: Wrong Type!!!!\n";
 return 0;
}

TAtom *uminus(TAtom *s)
{
 TAtom *tmp;
 TExpression *ne;
 TExpTerm *nt,*nt1;
 TMatrix *m;
 TRational *r;
 Tarray * a;
 //wout<<"calling function uminus of basetype.cc\n";
 
 if ( !s ) {
	//wout<<"Uminus Error: Wrong Type!!!!\n";
	return 0;
	}

 DataType dt=s->TypeID();
 switch ( dt ) {
	case BaseNumber:
	case PolyType: 
//	case RPolyType: 
	case RIPolyType:
    case DoubleType:
	case Expression: 
		tmp=s->uminus(); // default is make a copy
		delete s;
		return tmp;
	case MatrixType:
		m = ((TMatrix *)s)->uminus();
		delete s;
		return m;
//	case Reciprocal:
	case ProcCall:
	case Variable:
		nt=new TExpTerm();
		nt->insert(new TExpTermCell(s));
		nt1=(TExpTerm *)(nt->uminus(0));
		ne=new TExpression();
		ne->insert(nt);
		return ne;
	case RationalType:
		tmp = ((TRational *)s)->uminus();
		delete s;
		return tmp;	
	case ArrayType:
		a = ((Tarray *)s)->uminus();
		delete s;
		return a;
		break;
	default: 
		delete s;
		break;
		}
 wout<<"Uminus Error: Wrong Type!!!!\n";
 return 0;
}

TAtom *exp(TAtom *s1, TAtom *s2)
{
 TBigInt *n;
 TNumber b;
 TPoly p;
// TRPoly rp;
 TRIPoly rip;
 TAtom *a,*a1,*a2;
// TReciprocal *r;
 TExpression *ne;
 TExpTerm *nt;
 TMatrix *m;
// wout<<"calling function exp of basetype.cc\n";
 //if ( !s1 || !s2) {
//	wout<<"Exp Error: Wrong Type!!!!\n";
//	return 0;
//	}
 if ( !s2) {
	 if (s1)
		 delete s1;
	 return (new TBigInt(1));
 }
 if( !s1){
	delete s2;
	return 0;
 }

 DataType dt,dt1=s1->TypeID();
 DataType dt2=s2->TypeID();
 if(dt1 != ArrayType && dt2 == ArrayType)
 {
	dt = dt1; dt1 = dt2; dt2 = dt;
	a = s1; s1 = s2; s2 = a; 
 }

 switch ( dt1 ) {
	case BaseNumber:
		switch (dt2) {
			case BaseNumber:
				if(((TNumber*)s2)->GetPtr()->TypeID() == BigNumberType)
               			{ 
//					t=clock();
			 	 b=(*(TNumber *)s1)^(*(TNumber *)s2);
//				 t1=clock();wout<<"time is"<<t1-t<<endl;
				 delete s1;
				 delete s2;
				 return new TNumber(b);
				}
//			case Reciprocal:
			case PolyType: 
//			case RPolyType: 
			case RIPolyType:
			case ProcCall:
			case Variable:
				nt=new TExpTerm();
				nt->insert(new TExpTermCell(s1,s2));
				ne=new TExpression();
				ne->insert(nt);
				return ne;
			case Expression: 
				nt=new TExpTerm();
				nt->insert(new TExpTermCell(s1,s2));
				ne=new TExpression();
				ne->insert(nt);
				return ne;
			default: break;
			}
		break;
	case PolyType:
		switch (dt2) {
                        case BaseNumber:
				if(((TNumber*)s2)->GetPtr()->TypeID() == BigNumberType)
               			{ 
                                p=(*(TPoly *)s1)^(*(TNumber *)s2);
				delete s1;
				delete s2;
                                return new TPoly(p);
 				}
//			case Reciprocal:
                        case PolyType:
			case ProcCall:
			case Variable:
				nt=new TExpTerm();
				nt->insert(new TExpTermCell(s1,s2));
				ne=new TExpression();
				ne->insert(nt);
				return ne;
			case Expression: 
				nt=new TExpTerm();
				nt->insert(new TExpTermCell(s1,s2));
				ne=new TExpression();
				ne->insert(nt);
				return ne;
                        default: break;
                        }
		break;
/*	case RPolyType:
		switch (dt2) {

                        case BaseNumber:
				if(((TNumber*)s2)->GetPtr()->TypeID() == BigNumberType)
               			{ 
//					t1=clock();wout<<"time is:"<<t-t1<<endl;
				rp=(*(TRPoly *)s1)^(*(TNumber *)s2);
//				t=clock();
				delete s1;
				delete s2;
                                return new TRPoly(rp);
 				}
//			case Reciprocal:
                        case RPolyType:
			case ProcCall:
			case Variable:
				nt=new TExpTerm();
				nt->insert(new TExpTermCell(s1,s2));
				ne=new TExpression();
				ne->insert(nt);
				return ne;
			case Expression: 
				nt=new TExpTerm();
				nt->insert(new TExpTermCell(s1,s2));
				ne=new TExpression();
				ne->insert(nt);
				return ne;
                        default: break;
                        }
		break;
*/
	case RIPolyType:
                switch (dt2) {
                        case BaseNumber:
                         if(((TNumber*)s2)->GetPtr()->TypeID() == BigNumberType)
                                {
				n=(TBigInt *)((TNumber *)s2)->GetPtr();

	//					t=clock();

                                rip=(*(TRIPoly *)s1)^(n->GetShort(0));
	//						t1=clock();wout<<"time is:"<<t1-t<<endl;
				                delete s1;
                                delete s2;
                                return new TRIPoly(rip);
                                }
//                        case Reciprocal:
                        case RIPolyType:
                        case ProcCall:
                        case Variable:
                                nt=new TExpTerm();
                                nt->insert(new TExpTermCell(s1,s2));
                                ne=new TExpression();
                                ne->insert(nt);
                                return ne;
                        case Expression:
                                nt=new TExpTerm();
                                nt->insert(new TExpTermCell(s1,s2));
                                ne=new TExpression();
                                ne->insert(nt);
                                return ne;
                        default: break;
                        }
                break;
//        case Reciprocal:
//		a1=::exp(((TReciprocal*)s1)->GetD()->Copy(),s2->Copy());
//		a2=::exp(((TReciprocal*)s1)->GetN()->Copy(),s2->Copy());
//	 	r=new TReciprocal(a1,a2);
//		delete s1;
//		delete s2;	
//		return r;
	case ProcCall:
	case Variable:
	case Expression:
		switch (dt2) {
                        case BaseNumber:
                        case PolyType:
//			case RPolyType:
			case RIPolyType:
//			case Reciprocal:
			case ProcCall:
			case Variable:
                        case Expression:
				nt=new TExpTerm();
				nt->insert(new TExpTermCell(s1,s2));
				ne=new TExpression();			
				ne->insert(nt);
				return ne;
                        default: break;
                        }
		break;
	case MatrixType:
		switch (dt2) {
		case BaseNumber:{
			TNumber *num=(TNumber*)s2;
			TBigInt *n=(TBigInt *)num->GetPtr();
			int p = n->GetShort(0);
			m = ((TMatrix *)s1)->exp(p);
			delete s1;
			delete s2;
			return m;
			}
			break;
		default: break;
		}
		break;
	case RationalType:
		switch(dt2) {
		case BaseNumber:{
			TNumber *num=(TNumber*)s2;
			TBigInt *n=(TBigInt *)num->GetPtr();
			int p = n->GetShort(0);
			TRational *ra = ((TRational *)s1)->exp(p);
			delete s1;
			delete s2;
			return ra;
		}
		break;

		default: break;
		}
		break;

	default: break;
		}
 wout<<"Exp Error: Wrong Type!!!!\n";
 return 0;
}

TAtom *div(TAtom *s1, TAtom *s2)
{
 TBigInt *n;
 TNumber b;
 TAtom *a;
// TReciprocal *r;
 TPoly p;
// TRPoly rp;
 TRIPoly rp;
 TRIPoly rip;
 TExpTerm * nt;
 TExpression * ne;
 TRational * ra;
 TRationalExp * re;
 int change = 0;
// wout<<"calling function mul of basetype.cc\n";
// if ( !s1 || !s2) {
//	wout<<"Div Error: Wrong Type!!!!\n";
//	return 0;
//	}
 if( !s2)
 {
	 wout<<"Div Error: Wrong Type!!!!\n";
	 if(!s1)
		delete s1;
	 return 0;}
 if(! s1) {delete s2;return 0;}


 DataType dt,dt1=s1->TypeID();
 DataType dt2=s2->TypeID();
// if(dt1 != dt2)
//     {
//       if( dt1== Reciprocal){ dt=dt1; dt1=dt2; dt2=dt; a=s1; s1=s2; s2=a;}
 //    }
// if (dt1== Reciprocal) {
//	r=((TReciprocal *)s1)->div((TReciprocal *)s2);
//	delete s1;
//	delete s2;
//	return r;
//	}
 if(dt1 == BaseNumber)
 {
	 int a = 1;
 }
 if(dt2 == Variable)
 {
	int b = 2;
 }
 if((dt1 != Expression && dt1 != Factorial && dt1 != ProcCall && dt1 != Variable)
	 && (dt2 == Expression || dt2 == Factorial || dt2 == ProcCall || dt2 == Variable))
 {
	dt = dt1; dt1 = dt2; dt2 = dt;
	a = s1; s1 = s2; s2 = a; 
	change = 1;
 }

 if(dt1 != RationalType && dt2 == RationalType)
 {
	dt = dt1; dt1 = dt2; dt2 = dt;
	a = s1; s1 = s2; s2 = a; 
 }

 switch ( dt1 ) {
	case BaseNumber:
		switch (dt2) {
			case BaseNumber:
				b=::div((*(TNumber *)s1),(*(TNumber *)s2));
				delete s1;
				delete s2;
				return new TNumber(b);
			case PolyType: 
				/*p=TPoly(*(TNumber *)s1)*(*(TPoly *)s2);
				delete s1;
				delete s2;
				return new TPoly(p);*/
			/*case RPolyType: 
				rp=TRPoly(*(TNumber *)s1)/(*(TRPoly *)s2);
				delete s1;
				delete s2;
				return new TRPoly(rp);*/

			case RIPolyType: 
				rp=TRIPoly(*(TNumber *)s1)/(*(TRIPoly *)s2);
				delete s1;
				delete s2;
				return new TRIPoly(rp);

			/*case RIPolyType:
                                if(((TNumber *)s1)->GetPtr()->TypeID()!=BigNumberType)
                                {
                                wout<<"Type is wrong;"<<endl;
                                delete s1;
                                delete s2;
                                return 0;
                                break;
                                }
                                n=(TBigInt *)((TNumber *)s1)->GetPtr();
                                rip=TRIPoly(*(TBigInt *)n)/(*(TRIPoly *)s2);
                                delete s1;
                                delete s2;
                                return new TRIPoly(rip);*/
//			case Reciprocal:
//				a=::div(s1,((TReciprocal *)s2)->GetD()->Copy());	
//				r=new TReciprocal (a,((TReciprocal *)s2)->GetN()->Copy() );
//				delete s2;
//				return r;	
			case Factorial:
			case ProcCall:
			case Variable:
			/*	nt=new TExpTerm();
				nt->insert(new TExpTermCell(s2));
				ne=new TExpression();
				ne->insert(nt);
				s2=ne;*/
			case Expression: 
			/*	nt=new TExpTerm();
				nt->insert(new TExpTermCell(s1));
				ne=new TExpression();
				if (s2->length()==1) {
					TExpTerm *t;
					t=((TExpression *)s2)->first()
						->getdata();
					nt->mul(t);
					ne->insert(nt);
					delete s2;
					}
				else {
					TExpTerm *t=new TExpTerm();
					t->insert(new TExpTermCell(s2));
					t->mul(nt);
					delete nt;
					ne->insert(t);
					}
				return ne;*/
			default: break;
			}
		break;
	case PolyType:
	/*	switch (dt2) {
                        case BaseNumber:
                                p=TPoly(*(TNumber *)s2)*(*(TPoly *)s1);
				delete s1;
				delete s2;
                                return new TPoly(p);
                        case PolyType:
                                p=(*(TPoly *)s1)*(*(TPoly *)s2);
				delete s1;
				delete s2;
                                return new TPoly(p);
			case Reciprocal:
				a=::mul(s1,((TReciprocal *)s2)->GetD()->Copy());	
				r=new TReciprocal (a,((TReciprocal *)s2)->GetN()->Copy() );
				delete s2;
				return r;	
			case Factorial:
			case ProcCall:
			case Variable:
				nt=new TExpTerm();
				nt->insert(new TExpTermCell(s2));
				ne=new TExpression();
				ne->insert(nt);
				s2=ne;
			case Expression: 
				nt=new TExpTerm();
				nt->insert(new TExpTermCell(s1));
				ne=new TExpression();
				if (s2->length()==1) {
					TExpTerm *t;
					t=((TExpression *)s2)->first()
						->getdata()->Copy();
					nt->mul(t);
					ne->insert(nt);
					delete s2;
					}
				else {
					TExpTerm *t=new TExpTerm();
					t->insert(new TExpTermCell(s2));
					t->mul(nt);
					delete nt;
					ne->insert(t);
					}
				return ne;
                        default: break;
                        }
		break;*/

/*	case RPolyType:
		switch (dt2) {
                        case BaseNumber:
                                rp=TRPoly(*(TRPoly *)s1)/(*(TNumber *)s2);
				delete s1;
				delete s2;
                                return new TRPoly(rp);
                        case RPolyType:
				clock();
//				t1=clock();
                                rp=(*(TRPoly *)s1)/(*(TRPoly *)s2);
//			 	t=clock();
//				wout<<"\ntime is:"<<t-t1<<endl;	
				delete s1;
				delete s2;
                                return new TRPoly(rp);
//			case Reciprocal:
//				a=::div(s1,((TReciprocal *)s2)->GetD()->Copy());	
//				r=new TReciprocal (a,((TReciprocal *)s2)->GetN()->Copy() );
//				delete s2;
//				return r;	
			case Factorial:
			case ProcCall:
			case Variable:
//				nt=new TExpTerm();
//				nt->insert(new TExpTermCell(s2));
//				ne=new TExpression();
//				ne->insert(nt);
//				s2=ne;
			case Expression: 
				nt=new TExpTerm();
				nt->insert(new TExpTermCell(s1));
				ne=new TExpression();
				if (s2->length()==1) {
					TExpTerm *t;
					t=((TExpression *)s2)->first()
						->getdata()->Copy();
					nt->mul(t);
					ne->insert(nt);
					delete s2;
					}
				else {
					TExpTerm *t=new TExpTerm();
					t->insert(new TExpTermCell(s2));
					t->mul(nt);
					delete nt;
					ne->insert(t);
					}
				return ne;
                        default: break;
                        }
		break;
*/
	case RIPolyType:
                switch (dt2) {
                        /*case BaseNumber:
				if(((TNumber *)s2)->GetPtr()->TypeID()!=BigNumberType)
                                {
                                wout<<"Type is wrong;"<<endl;
                                delete s1;
                                delete s2;
                                return 0;
                                break;
                                }
                                n=(TBigInt *)((TNumber *)s2)->GetPtr();
                                rip=TRIPoly(*(TRIPoly *)s1)/(*(TBigInt *)n);
                                delete s1;
                                delete s2;
                                return new TRIPoly(rip);*/
					    case BaseNumber:
                                rp=TRIPoly(*(TRIPoly *)s1)/(*(TNumber *)s2);
				                delete s1;
				                delete s2;
                                return new TRIPoly(rp);
                        case RIPolyType:
                                clock();
                            //    t1=clock();
                                rip=(*(TRIPoly *)s1)/(*(TRIPoly *)s2);
//                                t=clock();
                                //wout<<"\ntime is:"<<t-t1<<endl;
                                delete s1;
                                delete s2;
                                return new TRIPoly(rip);
//                        case Reciprocal:
//                                a=::div(s1,((TReciprocal *)s2)->GetD()->Copy());

//                                r=new TReciprocal (a,((TReciprocal *)s2)->GetN()
//->Copy() );
//                                delete s2;
//                                return r;
                        case Factorial:
                        case ProcCall:
                        case Variable:
                        /*      nt=new TExpTerm();
                                nt->insert(new TExpTermCell(s2));
                                ne=new TExpression();
                                ne->insert(nt);
                                s2=ne;*/
                        case Expression:
                        /*      nt=new TExpTerm();
                                nt->insert(new TExpTermCell(s1));
                                ne=new TExpression();
                                if (s2->length()==1) {
                                        TExpTerm *t;
                                        t=((TExpression *)s2)->first()
                                                ->getdata()->Copy();
                                        nt->mul(t);
                                        ne->insert(nt);
                                        delete s2;
                                        }
                                else {
                                        TExpTerm *t=new TExpTerm();
                                        t->insert(new TExpTermCell(s2));
                                        t->mul(nt);
                                        delete nt;
                                        ne->insert(t);
                                        }
                                return ne;*/
                        default: break;
                        }
                break;
	case Factorial:
	case ProcCall:
	case Variable:
		nt=new TExpTerm();
		nt->insert(new TExpTermCell(s1));
		ne=new TExpression();
		ne->insert(nt);
		s1=ne;
	case Expression:
		switch (dt2){
		case BaseNumber:
		case Factorial:
		case ProcCall:
		case Variable:
			nt=new TExpTerm();
			nt->insert(new TExpTermCell(s2));
			ne=new TExpression();
			ne->insert(nt);
			s2=ne;
			//s2->display();wout<<"s2"<<endl;
		case Expression:
			if(change == 0)
				re = new TRationalExp((TExpression *)s1,(TExpression *)s2);
			else re = new TRationalExp((TExpression *)s2,(TExpression *)s1);
			nt=new TExpTerm();
			nt->insert(new TExpTermCell((TAtom *)re));
			ne=new TExpression();
			ne->insert(nt);
			return ((TAtom *)ne);
			break;
		default: break;
		}

	/*	switch (dt2) {
			case Reciprocal:
				a=::mul(s1->Copy(),((TReciprocal *)s2)->GetD()->Copy());	
				r=new TReciprocal (a,((TReciprocal *)s2)->GetN()->Copy() );
				delete s1; delete s2;
				return r;	
                        case BaseNumber:
			case Factorial:
                        case PolyType:
			case RPolyType:
			case RIPolyType:
			case ProcCall:
			case Variable:
                                nt=new TExpTerm();
                                nt->insert(new TExpTermCell(s2));
                                ne=new TExpression();
                                ne->insert(nt);
				s2=ne;
                        case Expression:
				if (s1->length()==1) {
					nt1=((TExpression *)s1)->first()
						->getdata()->Copy();
					delete s1;
					}
				else {
					nt1=new TExpTerm();
					nt1->insert(new TExpTermCell(s1));
					}
				if (s2->length()==1) {
					nt=((TExpression *)s2)->first()
						->getdata()->Copy();
					delete s2;
					}
				else {
					nt=new TExpTerm();
					nt->insert(new TExpTermCell(s2));
					}
				nt->mul(nt1);
				delete nt1;
				ne=new TExpression();
				ne->insert(nt);
				return ne;
                        default: break;
                        }*/
		break;
	case VectorType:
	/*	switch (dt2) {
			case VectorType: {
				TAtom *nv=((TVector *)s1)->mul((TVector *)s2);
				delete s1;
				delete s2;
				return nv;
				}
			default: break;
			}*/
		break;
	case MatrixType:
		break;
	case RationalType:
		{
			switch(dt2){
				case BaseNumber:
					{
					TRIPoly * n1,*d1;
					TRational r1(((TRational *)s1)->GetNu(),((TRational *)s1)->GetDe());				
					n1 = new TRIPoly(((TNumber *)s2)->Ceil());
					d1 = new TRIPoly(TBigInt(1));
					TRational r2(n1,d1);
					TRational rat = r1 / r2;
					delete s1;
					delete s2;
					delete n1;
					delete d1;
					ra = new TRational(rat.GetNu(),rat.GetDe());
					return ra;
					break;
					}
				case Variable:
					{
					TRIPoly * n1,*d1;
					TRational r1(((TRational *)s1)->GetNu(),((TRational *)s1)->GetDe());
					n1 = new TRIPoly(TV(s2),1);
					d1 = new TRIPoly(TBigInt(1));
					TRational r2(n1,d1);
					TRational rat = r1 / r2;
					delete s1;
					delete n1;
					delete d1;
					ra = new TRational(rat.GetNu(),rat.GetDe());
					return ra;
					break;
					}
				case Expression:
					{
					TRIPoly * n1,*d1;
					TRational r1(((TRational *)s1)->GetNu(),((TRational *)s1)->GetDe());
					n1 = TP(((TExpression *)s2)->eval());
					d1 = new TRIPoly(TBigInt(1));
					TRational r2(n1,d1);
					TRational rat = r1 / r2;
					delete s1;
					delete s2;
					delete n1;
					delete d1;
					ra = new TRational(rat.GetNu(),rat.GetDe());
					return ra;
					break;
					}
				case RIPolyType:
					{
					TRIPoly * d1;
					TRational r1(((TRational *)s1)->GetNu(),((TRational *)s1)->GetDe());
					d1 = new TRIPoly(TBigInt(1));
					TRational r2(TP(s2),d1);
					TRational rat = r1 / r2;
					delete s1;
					delete s2;
					delete d1;
					ra = new TRational(rat.GetNu(),rat.GetDe());
					return ra;
					break;
					}
				case RationalType:
					{
					TRational r1(((TRational *)s1)->GetNu(),((TRational *)s1)->GetDe());
					TRational r2(((TRational *)s2)->GetNu(),((TRational *)s2)->GetDe());
					TRational rat = r1 / r2;
					delete s1;
					delete s2;
					ra = new TRational(rat.GetNu(),rat.GetDe());
					return ra;
					break;
					}
				default: break;		
			}
		}
		break;
	default: break;
		}
 wout<<"Div Error: Wrong Type!!!!\n";
 return 0;
}


int equal(TAtom *v,TAtom *b)
//if v==b return 1,else return 0;
{
  DataType DT1,DT2;

  DT1=v->TypeID();
  DT2=b->TypeID();

  if (DT1 != DT2) return 0; 

  int judge=0;

  TAtom *tmp1,*tmp2;
  
  tmp1=v;
  tmp2=b;
  
  TNumber tn1,tn2;
  TBigInt bn1,bn2;
  TFloatNum fn1,fn2;
  TFraction ft1,ft2;
  TRIPoly ptp1,ptp2;

  switch(DT1)
  {
   case Variable:
         if(((TVariable *)tmp1)->equal((TVariable *)tmp2))
           judge=1;
         break;
   case ListType:
         if(((TList *)tmp1)->equal((TList *)tmp2))
           judge=1;
         break;
   case BaseNumber:
         tn1=(*((TNumber *)tmp1));
         tn2=(*((TNumber *)tmp2));
         //if((tn1-tn2)==0)
		 if(tn1 == tn2)
           judge=1;
         break;
   case BigNumberType:
         bn1=(*((TBigInt *)tmp1));
         bn2=(*((TBigInt *)tmp2));
         //if((bn1-bn2)==0)
		 if(bn1 == bn2)
           judge=1;
         break;
   case FloatNumberType:
         fn1=(*((TFloatNum *)tmp1));
         fn2=(*((TFloatNum *)tmp2));
         //if((fn1-fn2)==0)
		 if(fn1 == fn2)
           judge=1;
         break;
   case FractionType:
         ft1=(*((TFraction *)tmp1));
         ft2=(*((TFraction *)tmp2));
         //if((ft1-ft2)==0)
		 if(ft1 == ft2)
           judge=1;
         break;
   case RIPolyType:
         ptp1=(*((TRIPoly *)tmp1));
         ptp2=(*((TRIPoly *)tmp2));
         if(ptp1 == ptp2)
           {judge=1;}
         break;
   case Expression:
         if(((TExpression *)tmp1)->compare((TExpression *)tmp2))
           judge=1;
         break;
   default:
         if(tmp1==tmp2)
           judge=1;
         break;
  }

  return judge;

}

/*
//leave it temporarily
int pequal(TAtom *v,TAtom *b)
{
  int m=1;
  int judge=0;
  TAtom * tmp1,*tmp2;
  DataType DT1,DT2;
  DT1=v->TypeID();
  tmp1=v;
  DT2=b->TypeID();
  tmp2=b;
  if (DT1 != DT2) return judge; 
	  
  TNumber tn1,tn2;
  TBigInt bn1,bn2;
  TFloatNum fn1,fn2;
  TFraction ft1,ft2;
  TRIPoly ptp1,ptp2,ptp3;

  switch(DT1)
  {
    case Variable:
         if(((TVariable *)tmp1)->equal((TVariable *)tmp2))
           judge=m;
         break;
   case ListType:
         if(((TList *)tmp1)->equal((TList *)tmp2))
           judge=m;
         break;
   case BaseNumber:
         tn1=(*((TNumber *)tmp1));
         tn2=(*((TNumber *)tmp2));
         if((tn1-tn2)==0)
           judge=m;
         break;
   case BigNumberType:
         bn1=(*((TBigInt *)tmp1));
         bn2=(*((TBigInt *)tmp2));
         if((bn1-bn2)==0)
           judge=m;
         break;
   case FloatNumberType:
         fn1=(*((TFloatNum *)tmp1));
         fn2=(*((TFloatNum *)tmp2));
         if((fn1-fn2)==0)
           judge=m;
         break;
   case FractionType:
         ft1=(*((TFraction *)tmp1));
         ft2=(*((TFraction *)tmp2));
         if((ft1-ft2)==0)
           judge=m;
         break;
   case RIPolyType:
         ptp1=(*((TRIPoly *)tmp1));
         ptp2=(*((TRIPoly *)tmp2));
         if(ptp1==ptp2)
           {judge=m;}
		 if(ptp1==-ptp2)
		 {
			 judge=m;
		 }
         break;
   case Expression:
         if(((TExpression *)tmp1)->compare((TExpression *)tmp2))
           judge=m;
         break;
   default:
        if(tmp1==tmp2)
           judge=m;
        break;
  }

return judge;
}
*/
TAtom * ip(TAtom * s1,TAtom * s2)
{
	if(s1->TypeID() != ArrayType || s2->TypeID() != ArrayType)
	{
		wout<<"IP error!"<<endl;
		return 0;
	}
	TAtom * t;
	t = ((Tarray *)s1)->InnerProduct((Tarray *)s2);
	delete s1;
	delete s2;
	return t;
}

void TAtom::display(outtype& out) const
{
	wout<<"base"<<endl;
}

int  TAtom::length()
{
 wout<<"IN atom length()"<<endl;
 return 1;
}
void TAtom::print(outtype& out) const
{
  display(out);
}
void TAtom::show(outtype& out) const
{
  display(out);
}
void TRun::print(outtype& out) const
{
 display(out);
}
void TRun::show(outtype& out) const
{
 display(out);
}
