#include "atom.h"
#include "stacks.h"
#include "global.h"
#include "lists.h"
#include "poly.h"
#include "pol.h"
#include "sysfunc.h"
#include "express.h"
#include "projection.h"
#include <stdio.h>
#include <iostream.h>
#include <string.h>
#include <new.h>
#include "number.h"
#include "lists.h"
#include "vectors.h"
#include "trpoly.h"
#include "pol.h"
#include "matrix.h"
#include "geometry.h"


#ifdef _WINDOWS
#include "..\gui\index.h"
#endif


void gerror(TAtom * a, char *ch) 
{   wout <<"Syntax Error!" << endl;
	if (a) a->display();
	wout << " " << ch << endl;
	wout << endl;
	qerror = true;
};

TList * toTList(TAtom * p)
{
	if(p->TypeID() == ListType)
		return ((TList *)p->Copy());
	else
	{
		gerror((TAtom *)p, "should be a list."); return 0;
	}
}

bool var_list(TList *vs, char ct)
{
  if (vs) 
  {
    if (vs->TypeID()== ListType)
	{ 
	 for(int i=1;i<=vs->length(); i++)
		 if      (vs->Part(i)->TypeID()==Variable) {}
		 else if (ct==1 && vs->Part(i)->TypeID()==BigNumberType) {}
		 else if (ct==1 && vs->Part(i)->TypeID()==BaseNumber) {}
		 else {
			 gerror((TAtom *)vs, "should be a variable list."); 
			 return false;
		 }
	}
    else {
		gerror((TAtom *)vs, "should be a variable list."); 
		return false;
	}
  }
 return true;
}

bool poly_list(TList *vs)
{
  if (vs) 
  {
    if (vs->TypeID()== ListType)
	{ 
	 for(int i=1;i<=vs->length(); i++)
		 if (vs->Part(i)->TypeID()!=RIPolyType) 
		 {
			gerror((TAtom *)vs, "should be a polynomial list."); 
			 return false;
		 }
	}
    else{
		gerror((TAtom *)vs, "should be a polynomial list."); 
		return false;
	}
  }
 return true;
}

TList * expandinternal(TList * l)
{
   int ll=((TList *)l)->length();
   TList * return_list=new TList();
   for (int i=1; i<=ll;i++)
      return_list->append((TAtom *)((l)->Part(i)->eval()));
	return return_list;
}

TRIPoly * toTRIPoly(TAtom * a)
{
  TRIPoly * p =0;
  TAtom * c = a->eval();

  if(c->TypeID() == RIPolyType) { return (TRIPoly *)c; }
  else if(c->TypeID() == BaseNumber) {
	TNumber *  num=(TNumber *)c;
	if((num)->GetPtr()->TypeID()==BigNumberType)
		p= new TRIPoly(*((TBigInt *)num->GetPtr()));
	else
		gerror(a, "should be a big integer."); 
  }
  else if(c->TypeID()==Variable)
  {
	  return new TRIPoly((TVariable *) c,1);
  }
  else
  {
	 gerror(a,"should be a polynomial.");
  }

  delete c;
  return p;
}

TList * toTRIPolyList(TList * a)
{ int k;
  TList *l;
  TRIPoly *p;
  if(a->TypeID() == ListType) 
  { l = new TList();
    k = a->length();
    for (int i = 1; i<=k;i++)
	{ p = toTRIPoly(a->Part(i));
	  if (p) l->append((TAtom*) p);
	  else 
	  { delete l; 
	    gerror((TAtom *)a, "should be a polynomial list.");
	    return 0;   
	  }
	}
	return l;
  }
  else 
  {  gerror((TAtom *)a, "should be a polynomial list.");
	 return 0;   
  }
}

TMatrix * toMatrix(TAtom * a)
{
	if(a->TypeID() == MatrixType)
		return ((TMatrix *)a);
	else return 0;
}

//====================================================


TNumber * toTNumber(TAtom * a)
{
  TNumber * n =0;
  TAtom * c = a->eval();
   
  if(c->TypeID() == BaseNumber) 
	 n= new TNumber(*(TNumber *)c);
  else
     gerror(a,"should be a number(TNumber).");
  
  delete c;
  return n;

}


TList * toTNumberList(TList * a)
{ 
  int k;
  TList *l;
  TNumber *p;

  if(a->TypeID() == ListType) 
  {
	l = new TList();
    k = a->length();
    for (int i = 1; i<=k;i++)
	{ 
	  p = toTNumber(a->Part(i));
	  if (p) l->append((TAtom*) p);
	  else 
	  {
		delete l; 
	    gerror((TAtom *)a, "should be a list of TNumber.");
	    return 0;   
	  }
	}
	return l;
  }
  else 
  {  
	 gerror((TAtom *)a, "should be a list.");
	 return 0;   
  }
}


TBigInt * toTBigInt(TAtom * a)
{
  TBigInt * bn =0;
  TAtom * c = a->eval();
   
  if(c->TypeID() == BaseNumber) {
	TNumber *  num=(TNumber *)c;
	if((num)->GetPtr()->TypeID()==BigNumberType)
	    bn= new TBigInt(*((TBigInt *)num->GetPtr()));
	else
	    gerror(a, "should be an integer(TBigInt).");
  }
  else
      gerror(a,"should be a number(TNumber).");
  
  delete c;
  return bn;

}

int   toInt(TAtom * a)
{
  int  bn =0;
  TAtom * c = a->eval();
   
  if(c->TypeID() == BaseNumber) {
	TNumber *  num=(TNumber *)c;
	if((num)->GetPtr()->TypeID()==BigNumberType)
	    bn= ((TBigInt *)num->GetPtr())->GetInt();
	else
	    gerror(a, "should be an integer(int).");
  }
  else
      gerror(a,"should be a number(TNumber).");
  
  delete c;
  return bn;

}

TList * toTBigIntList(TList * a)
{ 
  int k;
  TList *l;
  TBigInt *p;

  if(a->TypeID() == ListType) 
  {
	l = new TList();
    k = a->length();
    for (int i = 1; i<=k;i++)
	{ 
	  p = toTBigInt(a->Part(i));
	  if (p) l->append((TAtom*) p);
	  else 
	  {
		delete l; 
	    gerror((TAtom *)a, "should be a list of TBigInt.");
	    return 0;   
	  }
	}
	return l;
  }
  else 
  {  
	 gerror((TAtom *)a, "should be a list.");
	 return 0;   
  }
}


TDouble * toTDouble(TAtom * a)
{
  TDouble * bn =0;
  TAtom * c = a->eval();
   
  if(c->TypeID() == BaseNumber) {
    TNumber *  num=(TNumber *)c;
	if((num)->GetPtr()->TypeID()==DoubleType)
		bn= new TDouble(*((TDouble *)num->GetPtr()));
	else
	    gerror(a, "should be a double(TDouble).");
  }
  else
      gerror(a,"should be a number(TNumber).");
  
  delete c;
  return bn;

}

TList * toTDoubleList(TList * a)
{ 
  int k;
  TList *l;
  TDouble *p;

  if(a->TypeID() == ListType) 
  {
	l = new TList();
    k = a->length();
    for (int i = 1; i<=k;i++)
	{ 
	  p = toTDouble(a->Part(i));
	  if (p) l->append((TAtom*) p);
	  else 
	  {
		delete l; 
	    gerror((TAtom *)a, "should be a list of TDouble.");
	    return 0;   
	  }
	}
	return l;
  }
  else 
  {  
	 gerror((TAtom *)a, "should be a list.");
	 return 0;   
  }
}


TFloatNum * toTFloatNum(TAtom * a)
{
  TFloatNum * bn =0;
  TAtom * c = a->eval();
   
  if(c->TypeID() == BaseNumber) {
	TNumber *  num=(TNumber *)c;
	if((num)->GetPtr()->TypeID()==FloatNumberType)
	    bn= new TFloatNum(*((TFloatNum *)num->GetPtr()));
	else
	    gerror(a, "should be a float number(TFloatNum).");
  }
  else
      gerror(a,"should be a number(TNumber).");
  
  delete c;
  return bn;

}


TList * toTFloatNumList(TList * a)
{ 
  int k;
  TList *l;
  TFloatNum *p;

  if(a->TypeID() == ListType) 
  {
	l = new TList();
    k = a->length();
    for (int i = 1; i<=k;i++)
	{ 
	  p = toTFloatNum(a->Part(i));
	  if (p) l->append((TAtom*) p);
	  else 
	  {
		delete l; 
	    gerror((TAtom *)a, "should be a list of TFloatNum.");
	    return 0;   
	  }
	}
	return l;
  }
  else 
  {  
	 gerror((TAtom *)a, "should be a list.");
	 return 0;   
  }
}

TFraction * toTFraction(TAtom * a)
{
  TFraction * bn =0;
  TAtom * c = a->eval();
   
  if(c->TypeID() == BaseNumber) {
	TNumber *  num=(TNumber *)c;
	if((num)->GetPtr()->TypeID()==FractionType)
	    bn= new TFraction(*((TFraction *)num->GetPtr()));
	else
	    gerror(a, "should be a fraction(TFraction).");
  }
  else
      gerror(a,"should be a number(TNumber).");
  
  delete c;
  return bn;

}

TList * toTFractionList(TList * a)
{ 
  int k;
  TList *l;
  TFraction *p;

  if(a->TypeID() == ListType) 
  {
	l = new TList();
    k = a->length();
    for (int i = 1; i<=k;i++)
	{ 
	  p = toTFraction(a->Part(i));
	  if (p) l->append((TAtom*) p);
	  else 
	  {
		delete l; 
	    gerror((TAtom *)a, "should be a list of TFraction.");
	    return 0;   
	  }
	}
	return l;
  }
  else 
  {  
	 gerror((TAtom *)a, "should be a list.");
	 return 0;   
  }
}



TComplex * toTComplex(TAtom * a)
{
  TComplex * bn =0;
  TAtom * c = a->eval();
   
  if(c->TypeID() == BaseNumber) {
	TNumber *  num=(TNumber *)c;
	if((num)->GetPtr()->TypeID()==ComplexType)
	    bn= new TComplex(*((TComplex *)num->GetPtr()));
	else
	    gerror(a, "should be a complex number(TComplex).");
  }
  else
      gerror(a,"should be a number(TNumber).");
  
  delete c;
  return bn;

}


TList * toTComplexList(TList * a)
{ 
  int k;
  TList *l;
  TComplex *p;

  if(a->TypeID() == ListType) 
  {
	l = new TList();
    k = a->length();
    for (int i = 1; i<=k;i++)
	{ 
	  p = toTComplex(a->Part(i));
	  if (p) l->append((TAtom*) p);
	  else 
	  {
		delete l; 
	    gerror((TAtom *)a, "should be a list of TComplex.");
	    return 0;   
	  }
	}
	return l;
  }
  else 
  {  
	 gerror((TAtom *)a, "should be a list.");
	 return 0;   
  }
}

//====================================================