#include "atom.h"
#include "memory.h"
#include "stacks.h"
#include "global.h"
#include "lists.h"
#include "poly.h"
#include "pol.h"
#include "sysfunc.h"
#include "charset.h"
//#include "fwang.h"
//#include "lists_cs.h"
#include "basecs.h"
#include "wsolve.h"
//========================================================================

//The charset of poly set ps -- basic algorithm
//If the charset dosen't exit,return [].
 
TList * charset_base(TList * psIn, TList * ord)
{
    TList * cs, * rs,* ps,* res, * ulist,*tmp_list;
    int i,l;

    
    
    l = psIn->length();

    if (l == 0) { return new TList(); }

    ps = psIn->Clone();

    if(l < 2)
    {
      return ps;
    }
    else
    {
       cs = basicset_wdk(ps,ord);

       //printf("\ncs:= ");
       //cs->display();
       //printf("\n");

       if(cs->length() == 0)
       {  

          delete cs; //**
          delete ps;

          return new TList();
       }

       if(class_wdk((TRIPoly *)(cs->Part(1)),ord) > 0)
       {
            
	    tmp_list=ps->Minus(cs);
            rs = remainderset_wdk(tmp_list,cs,ord);
	    delete tmp_list;
            //printf("\nrs: ");
            //rs->display();
       }
       else
       {  

          delete cs; //**
          delete ps;

          return new TList();
       }
       
       if(rs->length() == 0)
       {

         delete rs;
         delete ps;

         return cs;
       }

       for(i=1; i<=rs->length();i++)
       {
          if(class_wdk((TRIPoly *)(rs->Part(i)),ord) == 0 &&
            ((TRIPoly *)(rs->Part(i)))->IsZero() == 0)
          {

              delete rs;
              delete ps;
              delete cs; //**

              return new TList();
          }
       }

       ulist = ps->Union(rs);

       res = charset_base(ulist,ord);

       delete ulist;

       delete ps;
       delete rs; 
       delete cs; //**

       return res;
    
    }

}
       



//The charseries of poly set ps -- basic algorithm

TList * charser_base(TList * ps, TList * ord)
{
   TList * psl = new TList();
   TList * initset, * series, *  cs, * psli;
   TList * seriestmp, *useries;
   TRIPoly * init;
   int i;
   

   cs = charsersub(ps,ord,psl);   

  
   if(cs->length() == 0) 
   {
      delete cs;
      delete psl;

      return new TList();
   }

   series = new TList();
   series->append((TAtom *)cs);

   //The list of non-constant initials in cs: initset
   initset = new TList();

   for(i=1; i<=cs->length(); i++)
   {
       init = initial_wdk((TRIPoly *)(cs->Part(i)),ord);
       if(class_wdk(init,ord) > 0)
          initset->append((TAtom *)init);
       else delete init;
   }

   if(initset->length() == 0) 
   {
      delete initset;
      delete psl;

      return series;
   }

   for(i=1; i<=initset->length(); i++)
   {
     psli = psl->Clone();
     psli->append((TAtom *)(((TRIPoly *)(initset->Part(i)))->Copy()));

     //series = series->Union(charser_base(psli,ord));

     seriestmp = charser_base(psli,ord);
     useries = series->Union(seriestmp);
     delete series;
     delete seriestmp;
     series = useries;

     delete psli;
   }

   delete initset;
   delete psl;

   return series;


}



//--Sub function for charser_base
//--Same as charset_base, except for adding an output argument psl
//--psl is the last poly set (psl=ps(l-1) union rs(l-1)),
//  and it is used in charser_base

TList * charsersub(TList * psIn, TList * ord,TList * psl)
{
    TList * cs, * rs,* ps,* res, * ulist,*tmp_list;
    int i,l,j;
   
    
    l = psIn->length();

    if (l == 0) 
    { 
      //psl = psIn->Clone(); 

      for(j=1;j<=psIn->length();j++)
        psl->append((TAtom *)(((TRIPoly *)(psIn->Part(j)))->Clone()));

      return new TList(); 
    }

    ps = psIn->Clone();

    if(l < 2)
    {
      
      //psl = ps->Clone();

      for(j=1;j<=ps->length();j++)
          psl->append((TAtom *)(((TRIPoly *)(ps->Part(j)))->Clone()));
        
      return ps;
    }
    else
    {
       cs = basicset_wdk(ps,ord);

       //printf("\ncs:= ");
       //cs->display();
       //printf("\n");

       if(cs->length() == 0)
       {  
          //psl = ps->Clone();

          for(j=1;j<=ps->length();j++)
              psl->append((TAtom *)(((TRIPoly *)(ps->Part(j)))->Clone()));


          delete cs; //**
          delete ps;

          return new TList();
       }

       if(class_wdk((TRIPoly *)(cs->Part(1)),ord) > 0)
       {
            //rs = remset_wdk(ps->Minus(cs),cs,ord);
	    tmp_list=ps->Minus(cs);
            rs = remainderset_wdk(tmp_list,cs,ord);
	    delete tmp_list;

            //printf("\nrs: ");
            //rs->display();
       }
       else
       {  
          //psl = ps->Clone();

          for(j=1;j<=ps->length();j++)
             psl->append((TAtom *)(((TRIPoly *)(ps->Part(j)))->Clone()));


          delete cs; //**
          delete ps;

          return new TList();
       }
       
       if(rs->length() == 0)
       {

         //psl = ps->Clone();

         for(j=1;j<=ps->length();j++)
           psl->append((TAtom *)(((TRIPoly *)(ps->Part(j)))->Clone()));

         delete rs;
         delete ps;
          
         return cs;
       }

       for(i=1; i<=rs->length();i++)
       {
          if(class_wdk((TRIPoly *)(rs->Part(i)),ord) == 0 &&
            ((TRIPoly *)(rs->Part(i)))->IsZero() == 0)
          {
             //psl = ps->Clone();

             for(j=1;j<=ps->length();j++)
                 psl->append((TAtom *)(((TRIPoly *)(ps->Part(j)))->Clone()));

              delete rs;
              delete ps;
              delete cs; //**

              return new TList();
          }
       }

       ulist = ps->Union(rs);
       res = charsersub(ulist,ord,psl);
       delete ulist;

       delete ps;
       delete rs; 
       delete cs; //**

       return res;
    
    }

}




