#include "atom.h"
#include "memory.h"
#include "stacks.h"
#include "global.h"
#include "lists.h"
#include "poly.h"
#include "pol.h"
#include "sysfunc.h"
#include "charset.h"
//#include "fwang.h"
//#include "lists_cs.h"
#include "basecs_mod.h"
#include "wsolve.h"


//========================================================================

//The charset of poly set ps -- basic algorithm
//If the charset dosen't exit,return [].
 
TList * charset_mod(TList * psIn, TList * ord,TBigInt prime)
{
    TList * cs, * rs,* ps,* res, * ulist,*tmp_list;
    int i,l;

    
    
    l = psIn->length();

    if (l == 0) { return new TList(); }

    ps = psIn->Clone();

    if(l < 2)
    {
      return ps;
    }
    else
    {
       cs = basicset_wdk(ps,ord);

       if(cs->length() == 0)
       {  

          delete cs; //**
          delete ps;

          return new TList();
       }

       if(class_wdk((TRIPoly *)(cs->Part(1)),ord) > 0)
       {
            
	    tmp_list=ps->Minus(cs);
            rs = remainderset_mod(tmp_list,cs,ord,prime);
	    delete tmp_list;
            //printf("\nrs: ");
            //rs->display();
       }
       else
       {  

          delete cs; //**
          delete ps;

          return new TList();
       }
       
       if(rs->length() == 0)
       {

         delete rs;
         delete ps;

         return cs;
       }

       for(i=1; i<=rs->length();i++)
       {
          if(class_wdk((TRIPoly *)(rs->Part(i)),ord) == 0 &&
            ((TRIPoly *)(rs->Part(i)))->IsZero() == 0)
          {

              delete rs;
              delete ps;
              delete cs; //**

              return new TList();
          }
       }

       ulist = ps->Union(rs);

       res = charset_mod(ulist,ord,prime);

       delete ulist;

       delete ps;
       delete rs; 
       delete cs; //**

       return res;
    
    }

}
       



//The charseries of poly set ps -- basic algorithm

TList * charser_mod(TList * ps, TList * ord,TBigInt prime)
{
   TList * psl = new TList();
   TList * initset, * series, *  cs, * psli;
   TList * seriestmp, *useries;
   TRIPoly * init;
   int i;
   

   cs = charsersub_mod(ps,ord,psl,prime);   

  
   if(cs->length() == 0) 
   {
      delete cs;
      delete psl;

      return new TList();
   }

   series = new TList();
   series->append((TAtom *)cs);

   //The list of non-constant initials in cs: initset
   initset = new TList();

   for(i=1; i<=cs->length(); i++)
   {
       init = initial_wdk((TRIPoly *)(cs->Part(i)),ord);
       if(class_wdk(init,ord) > 0)
          initset->append((TAtom *)init);
       else delete init;
   }

   if(initset->length() == 0) 
   {
      delete initset;
      delete psl;

      return series;
   }

   for(i=1; i<=initset->length(); i++)
   {
     psli = psl->Clone();
     psli->append((TAtom *)(((TRIPoly *)(initset->Part(i)))->Copy()));

     //series = series->Union(charser_base(psli,ord));

     seriestmp = charser_mod(psli,ord,prime);
     useries = series->Union(seriestmp);
     delete series;
     delete seriestmp;
     series = useries;

     delete psli;
   }

   delete initset;
   delete psl;

   return series;


}



//--Sub function for charser_base
//--Same as charset_base, except for adding an output argument psl
//--psl is the last poly set (psl=ps(l-1) union rs(l-1)),
//  and it is used in charser_base

TList * charsersub_mod(TList * psIn, TList * ord,TList * psl,TBigInt prime)
{
    TList * cs, * rs,* ps,* res, * ulist,*tmp_list;
    int i,l,j;
   
    
    l = psIn->length();

    if (l == 0) 
    { 
      //psl = psIn->Clone(); 

      for(j=1;j<=psIn->length();j++)
        psl->append((TAtom *)(((TRIPoly *)(psIn->Part(j)))->Clone()));

      return new TList(); 
    }

    ps = psIn->Clone();

    if(l < 2)
    {
      
      //psl = ps->Clone();

      for(j=1;j<=ps->length();j++)
          psl->append((TAtom *)(((TRIPoly *)(ps->Part(j)))->Clone()));
        
      return ps;
    }
    else
    {
       cs = basicset_wdk(ps,ord);

       printf("\ncs:= ");
       cs->display();
       printf("\n");

       if(cs->length() == 0)
       {  
          //psl = ps->Clone();

          for(j=1;j<=ps->length();j++)
              psl->append((TAtom *)(((TRIPoly *)(ps->Part(j)))->Clone()));


          delete cs; //**
          delete ps;

          return new TList();
       }

       if(class_wdk((TRIPoly *)(cs->Part(1)),ord) > 0)
       {
            //rs = remset_wdk(ps->Minus(cs),cs,ord);
	    tmp_list=ps->Minus(cs);
            rs = remainderset_mod(tmp_list,cs,ord,prime);
	    delete tmp_list;

            //printf("\nrs: ");
            //rs->display();
       }
       else
       {  
          //psl = ps->Clone();

          for(j=1;j<=ps->length();j++)
             psl->append((TAtom *)(((TRIPoly *)(ps->Part(j)))->Clone()));


          delete cs; //**
          delete ps;

          return new TList();
       }
       
       if(rs->length() == 0)
       {

         //psl = ps->Clone();

         for(j=1;j<=ps->length();j++)
           psl->append((TAtom *)(((TRIPoly *)(ps->Part(j)))->Clone()));

         delete rs;
         delete ps;
          
         return cs;
       }

       for(i=1; i<=rs->length();i++)
       {
          if(class_wdk((TRIPoly *)(rs->Part(i)),ord) == 0 &&
            ((TRIPoly *)(rs->Part(i)))->IsZero() == 0)
          {
             //psl = ps->Clone();

             for(j=1;j<=ps->length();j++)
                 psl->append((TAtom *)(((TRIPoly *)(ps->Part(j)))->Clone()));

              delete rs;
              delete ps;
              delete cs; //**

              return new TList();
          }
       }

       ulist = ps->Union(rs);
       res = charsersub_mod(ulist,ord,psl,prime);
       delete ulist;

       delete ps;
       delete rs; 
       delete cs; //**

       return res;
    
    }

}

// ps is a polynomial set, as is an ascending set, ord is a variable list;
// return the remainder set;
// if there exist a polynomial p in ps, r is the remainder of p respect to as,
// and class(r,ord) =0 and r !=0, then return a list [1];
// if  class(r,ord) >0 then append the polynomial r into the poly set.
// if  r=0, do NOT append 0 to the remainder set

TList * remainderset_mod(TList *ps, TList *as, TList  *ord,TBigInt prime)
{
  TList * rs =new TList();
  TRIPoly *p;
  int i,l=ps->length();
  if (l==0) return rs;
  for (i=1;i<=l;i++)
    {
    p=premas_mod((TRIPoly *) (ps->Part(i)),as,ord,prime);
    if (! (p->IsZero())) {
      if (class_wdk(p,ord)==0) {delete p;delete rs; return Getp1list();}
      rs->append((TAtom *)(p->Copy()));
      delete p;
    }
    else
      delete p;
  }
  return rs;
}   

// p is the polynomial
// as is an ascending set
// ord is a variable list
// return the remainder of p w.r.t. as
 
TRIPoly * premas_mod(TRIPoly *p, TList * as, TList *ord,TBigInt prime)
{
  int i,l=as->length();
  TVariable * var;
  TRIPoly *pol,*p1,*p2;
  p1=(TRIPoly *)p->Copy();
  for(i=1;i<=l;i++)
    { pol=(TRIPoly *) (as->Part(i));
      var=mainvar_wdk(pol,ord);
      p2=p1->mprem(*pol,var,prime);
      delete p1;
      p1=p2;
    }
  return p1;
}
 

