
#include "typedef.h"
//#include "template.h"
#include "memory.h"
#include "stacks.h"
#include "global.h"
#include "const.h"
#include "lists.h"
#include "poly.h"
#include "tripoly.h"
#include "sysfunc.h"
#include "charset.h"
//#include "cs.h"
#include "fwang.h"
//#include "factorrs.h"
#include "shortlist.h"
//#include "dcs.h"
//#include "dcw.h"
//#include "dfactorrs.h"
#include "nvar.h"

#include "wsolve.h"
//extern TList  *depend_relation;

/*
#The following program  is written in  Maple V realease 3. 
#The following package <<wsolve>> is for solving systems of polynomial equations.
#The main algorithm  is based on Wu's method. 
#Polynomial factorization over rational field is used to reduce the sizes of the polynomials produced in the Well-Ordering process.


#------------------------------------------------------------
#Part I: <<wsolve>> for solving systems of polynomial equations
#------------------------------------------------------------

readlib(factors):
*/

// if dp is a constant or dclass(dp)=0; should be tested;
TRIPoly * dDiff_wdk(TRIPoly *dp, TVariable *var,int n)
{ TRIPoly * dq1, *dq;
  dq=(TRIPoly *)(dp->Copy());
  if (n==0) {return dq;}
  for (int i=1;i<=n;i++) {
	dq1= DF_wdk(dq,var);
	delete dq;
	dq=dq1;
  }
  return dq;
}


// if dp is a constant or dclass(dp)=0; should be tested;
/*
dp is a polynomial
return the variable list
for example dp=x+x[1]+x[2]+y[3];
then return [x,y] , x,y is class of TVariable
*/

TList * dIndets_wdk(TRIPoly * dp)
{
	TList *vlist1,*vlist2=new TList(),*vlist3;
    vlist1=dp->getVL();


	int vlen=vlist1->length();
//	vlist3=vlist2;
	for (int i=1;i<=vlen;i++)
	{
//	   TVariable *vv= ((TVariable *) (vlist1->Part(i)))->GetVar() ;
       //TVariable *vv1=new TVariable(vv);
		TVariable *vv1=getname( (TVariable *) (vlist1->Part(i)));
//	   vlist2=vlist3;
	   vlist2->append( (TAtom *) vv1);
//	   delete vlist2;
	   //delete vv1;


	}
	vlist3=vlist2->lunion();
	delete vlist2;
	delete vlist1;


    return vlist3;
}

// if dp is a constant or dclass(dp)=0; should be tested;
TList *AIndets_wdk(TRIPoly *dp)
{
	return dp->getVL();
}

// if dp is a constant or dclass(dp)=0; should be tested;
int dClass_wdk(TRIPoly * dp, TList * ord)
{

	TList * indet_d;
	int ord_l=ord->length();
    int cls=0;
    if (dp->IsZero() || dp->IsBigInt()) {return 0;}
	indet_d=dIndets_wdk(dp);

	for (int i=1;i<=ord_l;i++)
	{ if (member( (TAtom *) ord->Part(i), indet_d)) { cls= ord_l-i+1;delete indet_d;return cls;}
	}
	delete indet_d;
	return cls;

}

// if dp is a constant or dclass(dp)=0; should be tested;
int dClass_wdk(TVariable *mvar,TList *ord)
{
//	int pol;
	int cls;
//	TRIPoly  pol=TRIPoly(mvar,TBigInt(1));
	TRIPoly  pol=TRIPoly(mvar,1);
	TRIPoly *dp=new TRIPoly(pol);
//	pos=member((TAtom *)mvar,ord);
//	if (pos==0) { return 0; } else {return ord->length()-pos+1;}
	cls=dClass_wdk(dp,ord);
	delete dp;
	return cls;

}


// if dp is a constant or dclass(dp)=0; should be tested;
// if l1=l2, return 0;
// if l1<l2, return -1;
// if l1>l2,return 1;

int dRanklist_wdk(TShortList *l1,TShortList *l2)
{   int d;
	d=0;
    if (l1==NULL &&l2==NULL) d= 0;
		else if (l1==NULL) d= -1;
		else if (l2==NULL) d= 1;
	    else 
	    for(int i=1;i<=l1->length();i++){
		  if (l1->get(i) > l2->get(i)) {d=1;break;}
		  if (l1->get(i) < l2->get(i)) {d=-1;break;}		
		}
		return d;
}
	
		   
		  
// if dp is a constant or dclass(dp)=0; should be tested;
//if the main variable of dvar1, dvar2 is the same,
//then call this function to compare the diff part.
// if dvar1=dvar2, return 0;
// if dvar1<dvar2, 
int dRankvar_wdk(TVariable *dvar1, TVariable *dvar2)
{
	TShortList *l1,*l2;
//	l1=dvar1->GetDL();
//	l2=dvar2->GetDL();
	l1=getlist(dvar1);
	l2=getlist(dvar2);
	return dRanklist_wdk(l1,l2);


}

// if dp is a constant or dclass(dp)=0; should be tested;
TVariable *dMainvar_wdk(TRIPoly *dp,TList *ord)
{   TVariable *mvar;
	int dcls=dClass_wdk(dp,ord);
	mvar= (TVariable *) ord->Part(ord->length()-dcls+1);
	return (TVariable *)( mvar->Copy());
}

// if dp is a constant or dclass(dp)=0; should be tested;
// 
TVariable * dLeader_wdk(TRIPoly * dp, TList * ord)
{	int cls;
	TShortList * l1,*l2;
	int len;
	TVariable *mvar,*var,*mainv;
/*	
	cout<<"dp=";
	dp->display();
	cout<<endl;
	cout<<"ord=";
	ord->display();
	cout<<endl;
 */  
	TList * idt=AIndets_wdk(dp);
/*
    cout<<"idt=";
	idt->display();
	cout<<endl;
*/
	mvar=(TVariable *)idt->Part(1);
	cls=dClass_wdk(mvar,ord);

//	l1=mvar->GetDL();
	l1=getlist(mvar);
	len=idt->length();

    for (int i =1;i<=len;i++)
	{ 
/*		cout<<"mvar=";
		mvar->display();
		cout<<endl;
		*/
		var=(TVariable *) idt->Part(i);
//		l2=var->GetDL();
		l2=getlist(var);
/*
		cout<<"var=";
	    var->display();
		cout<<endl;
*/
	    int vcls=dClass_wdk(var,ord);
		if (vcls > cls )		
		{mvar=var;
//		 l1=mvar->GetDL();
		l1=getlist(mvar);
		cls=vcls;}
	    else if (vcls==cls && dRanklist_wdk(l2,l1)==1)
		{	mvar=var;
//		l1=mvar->GetDL();
		l1=getlist(mvar);
		cls=vcls;}
		else {}
					    
	}

	mainv=(TVariable *)mvar->Copy();

delete idt;

return mainv;

}
	




int dOrder_wdk(TRIPoly *dp,TVariable *var)
{ int order=-1;
	  TList * inds;
	  TVariable * mvar;
	  TVariable *der,*var0;
	  TShortList *sl1,*sl0;
      if( degree_wdk(dp,var) !=0) {order=0;}

//	  var0=var->GetVar();
	  var0=getname(var);
//	  sl0=var->GetDL();
	  sl0=getlist(var);


	  inds=AIndets_wdk(dp);
	  
	  int l=inds->length();

//	  cout<<"inds=";inds->display();cout<<endl;

	  for(int i =1;i<=l;i++)
	  { mvar=(TVariable *) inds->Part(i);
//	    der=mvar->GetVar();
//		sl1=mvar->GetDL();
	    der=getname(mvar);
		sl1=getlist(mvar);

		if (der==var0 && dRanklist_wdk(sl1,sl0)==1) 
		{    var0=der;
			 sl0=sl1;
			 order=sl0->get(1);
		}
	  }
	  delete inds;
return order;
}





  

TRIPoly * lcoeff_wdk(TRIPoly *p, TVariable *mvar)
{
  
  return p->Coefficient(mvar,p->Degree(mvar));
} 	


TRIPoly * dInitial_wdk(TRIPoly *dp, TList * ord)
{ 
  TRIPoly * dq;
  TVariable *mvar;
  if (dClass_wdk(dp,ord)==0)  {dq=new TRIPoly(TBigInt (1));return dq;}
  mvar=dLeader_wdk(dp,ord);
  dq=lcoeff_wdk(dp,mvar);
//  delete mvar;

  return dq;
}

TRIPoly * Sept_wdk(TRIPoly * f, TList *ord)
{   TRIPoly * dq;
	TVariable * mvar;

    if (dClass_wdk(f,ord)==0) {dq=new TRIPoly(TBigInt (1));return dq;}    
    mvar=dMainvar_wdk(f,ord);
	dq=new TRIPoly (f->derivative(mvar));
//	delete mvar;
	return dq;
}
 
 
// bs is an ascending set
// ord is a variable list
// return the non-constant factors of the initials of the polynomials in bs

TList *asseptlist_wdk(TList *bs, TList *ord)
{
  TList * returnlist=new TList(),*initlist,*tmplist;
  TRIPoly *p;
  int i,l;
  l=bs->length();
  for(i=1;i<=l;i++)
    { p=Sept_wdk( (TRIPoly *) bs->Part(i),ord);
      if (class_wdk(p,ord) !=0) 
	{ initlist=nonumfactors_wdk(p,ord);
	  tmplist=returnlist;
	  returnlist=tmplist-> Union (initlist);
	  delete initlist;
	  delete tmplist;
	}
      delete p;
    }
  return returnlist;
}
      
   


TList * Septs_wdk(TList * as,TList *ord)
{	int l;
	TRIPoly *sp;
    TList *septs_m=new TList(),*list;
	

	l=as->length();
	for (int i=1;i<=l;i++)
	{ sp=Sept_wdk((TRIPoly *)as->Part(i),ord);
	if (dClass_wdk(sp,ord) >0) {septs_m->append((TAtom *)sp);}
	   else {delete sp;}
	   }
	list=septs_m->lunion();
	delete septs_m;

	return list;
}





///
////
// if f<=g then return 1;
// if f>g  then return 0;


int dRank_wdk(TRIPoly *f, TRIPoly *g, TList *ord)
{   
	TRIPoly * initf,*initg;

	int initlen_f, initlen_g, sub_result;


    sub_result=dSubrank_wdk(f,g,ord);

	   if (sub_result ==-1) { return 1;}
	   else if (sub_result==1) {return 0;}
	   else if (sub_result==2) {return 1;}
	   else {
		   initf=dInitial_wdk(f,ord);
		   initg=dInitial_wdk(g,ord);
				 initlen_f=initf->length();
				 initlen_g=initg->length();
			     delete initf;
				 delete initg;
				 if (initlen_f <initlen_g) {return 1;}
				 else if (initlen_f==initlen_g) {
					  if (f->length()<=g->length()) {return 1;} else {return 0;}}
				 else return 0;
		 }
		
		
}

// if dClass(f)=dClass(g)=0 then return 2;
// if f < g then return -1;
// if f > g then return 1;
// if f=g then return 0;

int dSubrank_wdk(TRIPoly *f, TRIPoly *g, TList * ord)
{
 int cf,cg,result;
 TBigInt degf,degg;
 TVariable *dmf,*dmg;
 TRIPoly *initf, *initg;


     cf=dClass_wdk(f,ord);
	 cg=dClass_wdk(g,ord);
//	 cout<<"cf="<<cf<<endl;
//	 cout<<"cg="<<cg<<endl;

	 if (cf==0) { //printf(" in dsubarank a\n");
		          if (cg==0) { result=2;} else {result = -1;} }
	 else if (cf <cg) {//printf(" in dsubrank b\n"); 
						result=-1;}
	 else if (cf==cg) { //printf(" in dsubrank c\n");
		 dmf=dLeader_wdk(f,ord);
		 dmg=dLeader_wdk(g,ord);
		 if (dRankvar_wdk(dmf,dmg)==-1) {result=-1;}
		 else if (dRankvar_wdk(dmf,dmg)==1) {result=1;}
		 else {
			 degf=degree_wdk(f,dmf);
			 degg=degree_wdk(g,dmg);

			 if (degf<degg) {result=-1;}
			 else if (degf==degg) { 
									initf=dInitial_wdk(f,ord);
									initg=dInitial_wdk(g,ord);
									result=dSubrank_wdk(initf,initg,ord);
									delete initf;
									delete initg;
			 }									
			 else {result=1;}
			 }
//		 delete dmf;
//		 delete dmg;
	 }			 
	 else {//printf("in dsubrank d\n"); 
		    result=1;}

	 return result;

}




//l is a d-polynomial list
//ord is a variable list
//return the least polynomial in list l;

TRIPoly * dLeast_wdk(TList * l,TList * ord)
{
    int i,len;
    TRIPoly *p,*p2;
    p= (TRIPoly *) l->Part(1);
//	p->display();
    len=l->length();
    if (len==1) { return (TRIPoly *)p->Copy();}
    for(i=2;i<=len;i++)
      { p2=(TRIPoly *)l->Part(i);
	if (dRank_wdk(p2,p,ord)) p=p2;
      }
    return (TRIPoly *)p->Copy();
}    

// p , q are two d-polynomials;
//ord is a variable list;
//if p is reduced to q then return 1 otherwise 0;

int dReduced_wdk(TRIPoly * p,TRIPoly * q,TList * ord)
{  TVariable * mvar,*mvarq;
   int cls,ordq,ordp;
   cls=dClass_wdk(q,ord); 
   mvar= (TVariable *) ord->Part(ord->length()-cls+1);
   ordq=dOrder_wdk(q, mvar);
   ordp=dOrder_wdk(p,mvar);
   if ( ordp <ordq)  return 1;
   if (ordp >ordq) return 0;
   mvarq=dLeader_wdk(q,ord);
   if (degree_wdk(p,mvarq) < degree_wdk(q,mvarq)) {
//	   delete mvarq; 
	   return 1;}
   else {
//	   delete mvarq;
	   return 0;}
}

    

// ps is a polynomial set
// q is a polynomial
// ord is a variable list
// return a polynomial list which is composed by all  polynomials in ps
// reduced to q


TList * dReducedset_wdk(TList *ps, TRIPoly * q, TList * ord)
{
  TList * reducedset =new TList();
  TRIPoly * pol;
  int j,l=ps->length();
  if (l==0) return reducedset;
  for (j=1;j<=l;j++)
    { pol= (TRIPoly *) (ps->Part(j));
    if (dReduced_wdk(pol,q,ord)) reducedset->append( (TAtom *) pol->Copy());
    }
  return reducedset;
}


// ps is a polynomial set
// ord is a variable list
// return the basic set of ps

TList * dBasicset_wdk(TList * ps,TList * ord)
{
  TList * bs1 = new TList(), *bs2,*bs, * reducedset;
  TRIPoly * pol;
  int l;
  l=ps->length();
  if (l==0) return bs1;
  pol=dLeast_wdk(ps,ord);
  bs1->append( (TAtom *) (pol->Copy()));
  reducedset = dReducedset_wdk(ps,pol, ord);
  bs2=dBasicset_wdk(reducedset,ord);
  bs=conc_cs(bs2,bs1);
  //cout<<"after recursive";
   delete pol;
   delete bs1;
   delete bs2;
   delete reducedset;
   return bs;
}


TRIPoly * lcoeff(TRIPoly *p, TVariable *mvar)
{
  
  return p->Coefficient(mvar,p->Degree(mvar));
} 

TRIPoly * lterm(TRIPoly *p, TVariable *x)
{	TRIPoly * pxd,*l;
//	TBigInt degp;
	int degp;
	degp=degree_wdk(p,x);

	pxd=new TRIPoly(x,degp);
	TRIPoly pol=(*lcoeff(p,x))*(*pxd);
	l=new TRIPoly( pol );
	return l;
}




//please notice that the third parameter is type of TList *;
//this is different from the function prem_wdk where the
// third variable is type of TVariable *; this will be convenient.
TRIPoly * dPrem_wdk(TRIPoly * uu, TRIPoly *vv, TVariable *y)
{	TRIPoly *u,*u1,*diffv,*remd;  
	TVariable *xu,*xv,*t;
	TList *vars=new TList();
	int  du,dv,d ;

	t=(TVariable *) ((TList *) depend_relation->Part(2))->Part(1);
	vars->append((TAtom *) y->Copy());
	if (dClass_wdk(uu,vars)==0) { delete vars;return (TRIPoly *) uu->Copy();}

//		cout<<"y=";
//		y->display();
//		cout<<endl;

//   t= (TVariable *) ((TList *) depend_relation->Part(2))->Part(1);
//   var=(TList *) depend_relation->Part(1);
	u=(TRIPoly *)uu->Copy();

//	cout<<"u=";
//	u->display();
//	cout<<endl;

	xu=dLeader_wdk(u,vars);
    xv=dLeader_wdk(vv,vars);
	
	du=dOrder_wdk(u,y);
	dv=dOrder_wdk(vv,y);
    
/*	cout <<"in dPrem_wdk     "<<endl;
	cout<<"xu=";
	xu->display();
	cout<<endl;
	cout<<"xv=";
	xv->display();
	cout<<endl;
*/

	d=du-dv;



//	cout<<"d="<<d<<endl;

	while ( d>0) {
//	cout<<"d="<<d<<endl;
	
		diffv=dDiff_wdk(vv,t,d);
//		cout<<"xu=";
//        xu->display();
//		cout<<endl;

		u1=prem_wdk(u,diffv,xu);
		delete diffv;
		delete u;


// if u1 is a constant or dclass(u1,vars)=0; should be tested;
		if (dClass_wdk(u1,vars)==0) { u=u1; break;}
//		cout<<"ddd"<<endl;


		u=u1;
//		delete xu;
//		cout<<"u=";
//		u->display();
//		cout<<endl;
		xu=dLeader_wdk(u,vars);
//		cout<<"xu=";
//		xu->display();
//		cout<<"y=";
//		y->display();
//		cout<<endl;
		du=dOrder_wdk(u,y);
		d=du-dv;
	}

//   cout<<"the end"<<endl;
   u1=prem_wdk(u,vv,xv);
   delete u;
   u=u1;
//   delete xu;
//   delete xv;
   delete vars;
//	if (d <0) {remd=u;}
   remd=u;
   return remd;
}




/*      
dNPrem:=

   proc(uu,vv,y)
    local u,x,dv,du,d,t,var;
   global depend_relation;
   t:=depend_relation[2][1];
   var:=depend_relation[1];   
#        if dClass(uu,var)=0 then RETURN(uu) fi;
        u:=uu;
       if type(y,symbol) then x:=y else         x:=op(0,y)  fi;               
        dv:=dOrder(vv,x);
        du:=dOrder(u,x);
        d:=du-dv;
        if d<0 then RETURN(uu) fi;
#the following program is for ordinary differential case                
        while d>0 do
        	u:=NPremO(u,dDiff(vv,t,d), x[du]);
        	du:=dOrder(u,x);
        	d:=du-dv;
        od;
#        
       if dv =0 then NPremO(u,vv,x) else NPremO(u,vv,x[dv]) fi;	        	        
    end:    
    
*/

///--------------------------
//The following are NOT tested 
//----------------------------

// p is the d-polynomial
// as is an d-ascending set
// ord is a variable list
// return the remainder of p w.r.t. as

TRIPoly * dPremas_wdk(TRIPoly *p, TList * as, TList *ord)
{ 
  int i,l=as->length();
  TVariable * var;
  TRIPoly *pol,*p1,*p2;
  p1=(TRIPoly *)(p->Copy());
  for(i=1;i<=l;i++)
    { pol=(TRIPoly *) (as->Part(i));
      var=dMainvar_wdk(pol,ord);
      p2=dPrem_wdk(p1,pol,var);
      delete p1;
//	  delete var;
      p1=p2;
    }
  return p1;
}


// ps is a polynomial set, as is an ascending set, ord is a variable list;
// return the remainder set;
// if there exist a polynomial p in ps, r is the remainder of p respect to as, 
// and class(r,ord) =0 and r !=0, then return a list [1];
// if  class(r,ord) >0 then append the polynomial r into the poly set.
// if  r=0, do NOT append 0 to the remainder set

TList * dRemainderset_wdk(TList *ps, TList *as, TList  *ord)
{
  TList * rs =new TList();
  TRIPoly *p;
  int i,l=ps->length();
  if (l==0) return rs;
  for (i=1;i<=l;i++)
    {
    p=dPremas_wdk((TRIPoly *) (ps->Part(i)),as,ord);
    if (! (p->IsZero())) {
      if (dClass_wdk(p,ord)==0) {delete p;delete rs; return Getp1list();}
      rs->append((TAtom *)(p->Copy()));
      delete p;
    }
    else 
      delete p;
  }
  return rs;
}
  


