
#include "typedef.h"
//#include "template.h"
#include "memory.h"
#include "stacks.h"
#include "global.h"
#include "const.h"
#include "lists.h"
#include "poly.h"
#include "tripoly.h"
#include "sysfunc.h"
#include "charset.h"
//#include "cs.h"
#include "fwang.h"
//#include "factorrs.h"
#include "shortlist.h"
#include "wsolve.h"
//#include "dcs.h"
//#include "dcw.h"
//#include "dcw2.h"
//#include "dfactorrs.h"


#ifdef _WINDOWS
#include "..\gui\index.h"
#endif
//ps is a polynomial set
//ord is a variable list
//nonzero is a polynomial set
// here we suppose every polynomial is irreducible over rational field Q.
// if there are more than one polynomial with class = 1 , then return empty set;
// if the intersection of ps and nonzero is NOT empty, then return empty set;
// if remainder set is empty, then return basic set;
// if remainder set is a set with one polynomial =1 , then return empty set;
// if remainder set is not empty, then give all possible combinations rset=rs1,rs2,...,rsn.
// and for each ps= bs union rs_i , return union ( csa_wdk(ps) );    


TList * dCsa_wdk(TList * ps, TList *ord, TList * nonzero)
{
  TList * returnlist=new TList (),* checklist, *bset,*rset, *ulist,*rsets,*csets,*tmp_returnlist;
  int i,l;
	wout<<"\n in dCsa------------------\n";
  if (dNums_wdk(ps,ord) >1) { wout<<"\n numbers of class 1 >1\n"; ps->display();wout<<endl;} 
  if (dNums_wdk(ps,ord) >1) return returnlist;
  checklist=ps->Intersect(nonzero);
  if (checklist->length() !=0) {delete checklist; return returnlist;}
  delete checklist;
  bset=dBasicset_wdk(ps,ord);
  rset=dRemainderset_wdk(ps,bset,ord);
/*
  wout<<"\n ps="<<endl;
  ps->display();
  wout<<"\n bs="<<endl;
  bset->display();
  wout<<"\n rs="<<endl;
  rset->display();
  wout<<endl;
*/
//  wout<<"before if";
  if (rset->length() ==0)  { 
    wout<< " (in dcw2.cpp)A New Component !\n"; 
    delete rset; 
    returnlist->append((TAtom *) bset); 
//    returnlist->display();
    return returnlist;
    }
  if (Listisp1(rset)) {
	wout<<" \n Contradiction Set \n";wout<<endl;
    	delete rset; delete bset; return returnlist;}
  //  wout<<"rset=";
  //  rset->display();
  //  wout<<endl;

  rsets=dNrs_wdk(rset,ord);
/*  wout<<"\n rsets="<<endl;
  rsets->display();
  wout<<endl;  
*/  
  //  wout<<"length="<<rsets->length()<<endl<<"rsets=";
  //  rsets->display();
  //  wout<<endl;
  delete rset;
  l=rsets->length();
 // for (i=1;i<=1;i++)
  for (i=1;i<=l;i++)
    { 
      ulist=bset ->Union( (TList *) (rsets->Part(i)));
      csets=dCsa_wdk(ulist,ord,nonzero);
      delete ulist;
      tmp_returnlist=returnlist;
      returnlist=tmp_returnlist->Union(csets);
      delete tmp_returnlist;
      delete csets;
    }

  delete bset;
  delete rsets;
  
//  wout<<"end if";
  return returnlist;
}


//ps is a polynomial set;
//ord is a variable list;
//nonzero is a polynomial set;
// To set the returnlist to empty;
// cset1= csa_wdk(ps);
// for every ascending set as, compute rs= RS(ps,as), if rs is empty, then append as to the returnlist;
// if  rs is NOT empty, then form a list of polynomial set, psets=pnrs(ps,rs,ord);
// append csc_(pset,ord,nonzero) to the returnlist;
// return the result=returnlist; 

TList *  dCsb_wdk(TList * ps, TList *ord, TList *nonzero)
{
  TList * csets1,*csets2,*bs, *rs,*psets,*tmplist, *pstmp, *returnlist=new TList();
  int i,l;
  //  wout<<"inside cssub2 \n";

  csets1=dCsa_wdk(ps,ord,nonzero);
  //  wout<<"csets1=";
  //  csets1->display();
  l=csets1->length();
  //  wout<<"l="<<l<<endl;
  if (l==0) {delete csets1;return returnlist;}
  for (i=1;i<=l;i++){
    bs=(TList *) (csets1->Part(i));
    rs=dRemainderset_wdk(ps,bs,ord);
    //    wout<<"rs=";
    //    rs->display();
    
    if (rs->length() ==0) { 
      returnlist -> append( (TAtom *) bs->Copy()); 
      //      wout<<"inside if \n";
      //      returnlist->display();
      delete rs;}
    else{
    //    wout<<"outside if\n";
    pstmp=ps->Union(bs);
    psets=dPnrs_wdk(pstmp,rs,ord);
    delete pstmp;
    delete rs;
    csets2=dCsc_wdk(psets,ord,nonzero);
    tmplist=returnlist;
    returnlist = tmplist->Union(csets2);
    delete psets;
    delete csets2;
    delete tmplist;
    }
  }
  delete csets1;
  return returnlist;
}

// pss is a list of polynomial set;
// ord is a variable list 
// nonzero is polynomial set;
// for every polynomial set in pss, call dCsb_wdk to get the result
// return the union dCsb_wdk(pss)

TList * dCsc_wdk( TList *pss,TList *ord, TList *nonzero)
{
  TList *csets,*tmplist, *returnlist=new TList();
  int i,l;
  l=pss->length();
  if (l==0) return returnlist;
  for(i=1;i<=l;i++){
    csets=dCsb_wdk(((TList *) (pss->Part(i))) ,ord,nonzero);
    tmplist=returnlist;
    returnlist=tmplist->Union (csets);
    delete csets;
    delete tmplist;
  }
  return returnlist;
}

// ps is a polynomial set;
// ord is a variable list;
// nonzero is a polynomial set;
// let pss= nrs(ps,ord);  // nrs will factor all the polynmial in ps over Q,
//			  // delete all the constant factors
//			  // form a list of polynomial set;
// return csc_wdk(pss,ord,nonzero)

TList * dCs_wdk( TList *ps, TList *ord, TList * nonzero)
{
  TList *pss,*csets;
  pss=dNrs_wdk(ps,ord);
  csets=dCsc_wdk(pss,ord,nonzero);
  delete pss;
  return csets;
}
  

						   
// ps is a polynomial set;
// as is an ascending set;
// ord is a variable list;
// nonzero is a polynomial set;
// since RS(ps,as,ord)=NULL, for each I_i in as we will to get the zero decompostion
// zero({ps,as,I_i} /nonzero)
// return Union zero({ps,as,I_i} /nonzero) for I_i is the factor of the initials in as

TList * dCssa_wdk(TList *ps,TList *as, TList *ord, TList *nonzero)
{
  TList *initlist0,*septlist0,*initlist,*pset1,*pset,*css,*tmplist,*nonzeros,*nontmp,*returnlist=new TList();
  TRIPoly *p;
  int i,l;
//  wout<<"in CSSA----------------*\n";
//  wout<<"before asinitlist\n";
  initlist0=asinitlist_wdk(as,ord);
  septlist0=asseptlist_wdk(as,ord);
  initlist=initlist0->PUnion(septlist0);
  delete initlist0;
  delete septlist0;

  initlist->display();
//  wout<<"\n after asinitlist\n";
  l=initlist->length();
  if(l==0) {delete initlist;return returnlist;}
  nonzeros=(TList *)(nonzero->Copy());
  pset1=ps->Union(as);
  for (i=1;i<=l;i++){
    p=(TRIPoly *) initlist->Part(i);
    pset=pset1->sappend((TAtom *) p);
    //    wout<<"ps=";pset->display();wout<<endl;
    tmplist=returnlist;
    css=dCssb_wdk(pset,ord,nonzero);
    delete pset;
    returnlist=tmplist->Union (css);
    delete tmplist;
    delete css;
    nontmp=nonzeros;
    nonzeros=nonzeros->sappend(p);
    delete nontmp;
  }
  delete initlist;
  delete pset1;
  delete nonzeros; 
//  wout<<"out CSSA--------------*\n";
  return returnlist;
}
    
//ps is a polynomial set (every polynomial in ps is irreducible over Q)
//ord is a list of variable
//nonzero is a polynomial set;
//        //call csets=dCsb_wdk(ps)  to get a list of ascending set;
// for polynomial set ps, to get the zero decomposition Zero(ps/nonzero) = Union (as_i/{I_i,nonzero}) 
//                                                      as_i is in returnlist;
TList * dCssb_wdk(TList *ps, TList *ord, TList *nonzero)
{
  TList *csets,*css,*as,*tmplist,*returnlist;
  int i,l;
//  wout<<"**********in CSSB\n";
  csets=dCsb_wdk(ps,ord,nonzero);
//  wout<<"AFTER dCsb_wdk";
  returnlist=(TList *)(csets->Copy());
  l=csets->length();
  if(l==0) {delete csets;return returnlist;}
  for(i=1;i<=l;i++){
    as=(TList *) csets->Part(i);
    tmplist=returnlist;
    css=dCssa_wdk(ps,as,ord,nonzero);
    returnlist=tmplist->Union(css);
    delete tmplist;
    delete css;
  }
  delete csets;
//  wout<<"************out CSSB\n";
  return returnlist;
}
    

// pss is a list of polynomial set;
// ord is a variable list 
// nonzero is a polynomial set;
// for every polynomial set in pss, call dCsb_wdk to get the result
// return the union cssb(pss)

TList * dCssc_wdk( TList *pss,TList *ord, TList *nonzero)
{
  TList *csets,*tmplist, *returnlist=new TList();
  int i,l;
  l=pss->length();
  if (l==0) return returnlist;
  for(i=1;i<=l;i++){
    csets=dCssb_wdk(((TList *) (pss->Part(i))) ,ord,nonzero);
    tmplist=returnlist;
    returnlist=tmplist->Union (csets);
    delete csets;
    delete tmplist;
  }
  return returnlist;
}


// ps is a polynomial set;
// ord is a variable list;
// nonzero is a polynomial set;
// let pss= nrs(ps,ord);  // nrs will factor all the polynmial in ps over Q,
//			  // in nrs, all the constant factors are deleted.
//			  // form a list of polynomial set;
// return csc_wdk(pss,ord,nonzero)

TList * dCss_wdk( TList *ps, TList *ord, TList * nonzero)
{
  TList *pss,*csets;
  pss=dNrs_wdk(ps,ord);
  csets=dCssc_wdk(pss,ord,nonzero);
  delete pss;
  return csets;
}
  

