
#ifndef __DListTExpTermCell_H__
#define __DListTExpTermCell_H__

#include "basetype.h"

class DListTExpTermCell
{
 protected:
	friend class DListNodeTExpTermCell;
	DListNodeTExpTermCell   *head, *tail;
	int Total;
 public:
	DListTExpTermCell();
	virtual ~DListTExpTermCell();

	virtual void append(TExpTermCell   *data);
	virtual void append(DListNodeTExpTermCell *data);
	virtual void append(DListTExpTermCell *list);
	virtual void insert(TExpTermCell  *data, DListNodeTExpTermCell *pos=0);
	virtual void insert(DListNodeTExpTermCell * data, DListNodeTExpTermCell *pos=0);
	virtual void insert(DListTExpTermCell  *list, DListNodeTExpTermCell *pos=0);
	virtual void remove(DListNodeTExpTermCell *data);          //removing a 'data'
	DListNodeTExpTermCell *first()const {return head;}
	DListNodeTExpTermCell *last()const  {return tail;}
	int        length() {return Total;}
	virtual int compare(TAtom *) { return 0;}
					//cout<<"calling compare of dlist"<<endl;
	DListTExpTermCell* Clone() ;
	DListTExpTermCell* Copy() ;
	virtual void cleardata();  
			   //clear data in node, delete all nodes except data

        virtual void display(outtype& out =wout) const;
        virtual void show(outtype& out =wout) const;
        virtual void print(outtype& out =wout) const;
 
        void* operator new(size_t);
        void  operator delete(void *);
 
};

 class DListNodeTExpTermCell
{
    TExpTermCell   *data;
        unsigned long *RefCount;
 public:
	DListNodeTExpTermCell    *prev;
	DListNodeTExpTermCell    *next;
 public:
	DListNodeTExpTermCell(TExpTermCell *h=NULL);
	virtual ~DListNodeTExpTermCell();
    virtual int compare(DListNodeTExpTermCell *);
	virtual TExpTermCell *getdata();

        virtual void display(outtype& out =wout) const;
        virtual void show(outtype& out =wout) const;
        virtual void print(outtype& out =wout) const;
 
        void* operator new(size_t);
        void  operator delete(void *);
 
//   DListNode(const SListNodeTExpTermCell &bn);             // copy a bigint
//   DListNode & operator = (const DListNode & bn);
   unsigned long& Ref()const { return *RefCount; };
   unsigned long SetRef(unsigned long *n);
    unsigned long RefInc() { return ++(*RefCount); };
    unsigned long RefDec() { return --(*RefCount); };

    DListNodeTExpTermCell* Clone();
    virtual void  ClearMem();
    virtual int   SetMem( TExpTermCell *);
//=====================================================================
//    friend  bool  SameData(const DListNodeTExpTermCell*,const DListNodeTExpTermCell*);

};

#endif