#include <stdio.h>
#include <stdlib.h>
#include <malloc.h>
#include <iostream.h>
#include <string.h>

#include "atom.h"
#include "global.h"
#include "express.h"
#include "poly.h"
#include "trpoly.h"
#include "pol.h"
#include "nvar.h"
#include "check.h"
#ifdef _WINDOWS
#include "..\gui\index.h"
#endif 
#include "stacks.h"
#include "lists.h"

//==============================
TFactorial::TFactorial(TAtom* v)
{
 var=v;
}
TFactorial::~TFactorial()
{
 if(var && var->TypeID() != Variable)
     delete var;
};
int TFactorial::compare(TAtom *v)
{
	return 0;
};
TAtom* TFactorial::GetVar()
{
 return var;
};
TAtom *TFactorial::SetVar(TAtom* v)
{
 if(var && var !=v) delete var;
 var=v;
 return var;
};
TRunType TFactorial::Run()
{
 TRunType rt=TNORMAL;
 eval();
 if(ReturnValue==0) 
    ReturnValue=Copy();
 return rt; 
};
TAtom * TFactorial::eval()
{
 if (!var) return 0;
 TAtom *v=var->eval();
 if (IsNum(v)) {
        TNumber *num= ( (TNumber*)v)->GetPtr();
        if(num->TypeID() != BigNumberType)
	  {
           delete v;
	   return Copy();
         }
        TAtom *v1=new TNumber(FactorialOP(*(TBigInt*)num));
        delete v;
        return v1;
	}
 delete v;
 return Copy();
};
TAtom * TFactorial::Copy()
{
 return Clone();
}
TAtom* TFactorial::Clone()
{
  if(var) return new TFactorial(var->Copy() );
  else return new TFactorial(0);
};


void TFactorial::show(outtype& out) const
{
 display();
}
void TFactorial::print(outtype& out) const
{
 display();
}
void TFactorial::display(outtype& out) const
  {
   if(var)
     {
      if (var->length() !=1) out<<"(";
      var->display(); 
      if (var->length() !=1) out<<")";
	out<<"!";
    }
 };

void *TFactorial::operator new(size_t)
{
 return  (TFactorial*)StackMem->alloc();
};
void TFactorial::operator delete(void *p)
{
 (StackMem->free(p));
};
