#include <stdio.h>
#include <iostream.h>
#include <string.h>
#include <new.h>
#include "basetype.h"
#include "num_integer.h"
#include "number.h"
#include "lists.h"
#include "vectors.h"
#include "pol.h"
#include "matrix.h"
#include "convert.h"
#include "check.h"
#include "gbas.h"
#include "wsolve.h"
#include "geometry.h"


extern "C"{
#include <time.h>
#include <sys/timeb.h>
}

extern int primelist[];

#ifdef _WINDOWS
#include "..\gui\index.h"
#endif

//==================================================
//    Implementation for Buchberger's GB Algorithm
//==================================================      

//
// Functions for Groebner basis
// Could be included in poly.h
//


static PSS gb_pss;
static char gred_type = 1;
/* 
  1: normal reduce
  2: initial reduce
*/

#define NX(p) (p=p->nx)

//#define SHOW_G 0
//#ifdef SHOW_G
//#define G_OUT(n,m) (wout << (n), (m)->display(), wout << endl)
//#define G_OUT(n,m) ()
//#endif

//
// Input: poly set ps
// output gb_bas
// DESTRUCTIVE for ps
// type = 1: 
//      = 

TList *g_basis(TList *ps,  int type)
{ POLS *ps1, *bs, *ps2, rs;
  POLY *p1;
  gred_type = type;
 // ps->display(); wout<<endl;

  if (ps==0) return NULL;
  if (ps->length()<=1) return ps->Clone();

  ps1=list2ps(ps);
  for(bs=ps1;bs;NX(bs)) { bs->p = uprim(bs->p); }

 lp1:
//  wout << "gbase  ps:\n";   ps_print(ps1);
  g_bs(ps1);  
  bs  = gb_pss.ps1;  
  ps1 = gb_pss.ps2;

//  wout << "gbase  bs:\n"; ps_print(bs);

  rs.nx = NULL;
  while(ps1!=NULL)
  { p1 = rem_gpc(ps1->p,bs);
    if (pzerop(p1))   { put_p(p1); }
    else { rs.nx = get_dt(1,p1,rs.nx); }
    ps2=ps1; ps1=ps1->nx; put_d(ps2);
  }

//  wout <<" rs: \n";  ps_print(rs.nx);
  if (rs.nx!=NULL)
	 { /*rs.nx = ps_el(re.nx);  */
		ps1 = ps_union(bs,rs.nx);
		goto lp1;
	 }

  ps1 = s_pols(bs);
//  wout <<" sp: \n";  ps_print(ps1);
  if (ps1!=NULL)
	 {  ps1 = ps_union(bs,ps1);
		goto lp1;
	 }
// end of loo[
  TList *l = ps2list(bs);
  put_ps(bs);
  return(l);
}

TList *f_g_basis(TList *ps, int type)
{ POLS *ps1, *bs, *ps2, *rs;
  POLS *pss,*pss1;
  POLY *p1;
  POLS *ls;
  ls = 0;
  gred_type = type;
  if (ps==0) return NULL;
  if (ps->length()<=1) return ps->Clone();
  ps1=list2ps(ps);
  for(bs=ps1;bs;NX(bs)) { bs->p = uprim(bs->p); }
  pss1 = split_ps(ps1,0);
//  wout << "1:\n";   
//  for(ps1=pss1;ps1;ps1=ps1->nx) { wout << "0:";ps_print(ps1->p->ups); }

  pss = pss_simp(pss1);
//  wout << "2:\n";  
//  for(ps1=pss;ps1;ps1=ps1->nx) { wout << "0:"; ps_print(ps1->p->ups); }


 lp1:
  if (pss==0) 
  { pss = pss_simp(ls);
    TList *ll = new TList();
    for(ps1=pss;ps1;ps1=ps1->nx) 
		ll->append((TAtom*)ps2list(ps1->p->ups));
	put_ps(pss);
	return ll;    
  }
  ps1 = pss->p->ups;
  put_x(pss->p);
  pss1 = pss->nx;
  put_d(pss);
  pss = pss1;

//  wout << "gbase  ps:\n";   ps_print(ps1);
  g_bs(ps1);  
  bs = gb_pss.ps1;  ps1 = gb_pss.ps2;

  //wout << "gbase  bs:\n"; ps_print(bs);

  rs = NULL;
  while(ps1!=NULL)
  { p1 = rem_gpc(ps1->p,bs);
    if (pzerop(p1))   { put_p(p1); }
    else { rs = get_dt(1,p1,rs); }
    ps2=ps1; ps1=ps1->nx; put_d(ps2);
  }
//  wout <<" rs: \n";  ps_print(rs);
  if (rs!=NULL)
	 {  pss1 = split_ps(rs,bs);
        pss = ps_append(pss1,pss);  
		pss = pss_simp(pss);
		goto lp1;
	 }
  ps1 = s_pols(bs);
  //wout <<" sp: \n";  ps_print(ps1);
  if (ps1!=NULL)
	 {  pss1 = split_ps(ps1,bs);
        pss = ps_append(pss1,pss);
		pss = pss_simp(pss);
		goto lp1;
	 }
  wout << "A new gb basis\n";
  ls = get_dt(1,get_xt(0,bs),ls);
  goto lp1;
}

//
// basic set
// output: gb_pss.ps1: basic set
// output: gb_pss.ps2: remaining pols
//
void g_bs (POLS *ps)
{ POLY *p1;
  POLS *ps1, *ps2, pt;

  gb_pss.ps1=NULL; 
  gb_pss.ps2=NULL;
  pt.nx = ps;
  while(pt.nx!=NULL)
	 { p1 = min_pol(pt.nx);
       //G_OUT("min:",p1);
	   	gb_pss.ps1 = get_dt(1,p1,gb_pss.ps1);
		ps1=pt.nx; 
		pt.nx=NULL;
		while (ps1!=NULL)
		{
			if (ps1->p==p1)
			{ ps2=ps1; ps1=ps1->nx; put_d(ps2); }
			else if (gred_ps(ps1->p,gb_pss.ps1))
			{ ps2=ps1; ps1=ps1->nx;
			  ps2->nx = pt.nx; pt.nx = ps2;
			}
			else
			{ ps2=ps1; ps1=ps1->nx;
			  ps2->nx=gb_pss.ps2;  gb_pss.ps2 = ps2;
			}
		}
	 }
}

POLY *min_pol(POLS *ps)
{ POLS *ps1;
  POLY *p1;
  p1 = ps->p;
  ps1=ps->nx;
  while(ps1!=NULL)
	 { if (gless_p(ps1->p,p1)) p1 = ps1->p;
		ps1 = ps1->nx;
	 }
  return(p1);
}

POLY *max_pol(POLS *ps)
{ POLS *ps1;
  POLY *p1;
  p1 = ps->p;
  ps1=ps->nx;
  while(ps1!=NULL)
	 { if (gless_p(p1,ps1->p)) p1 = ps1->p;
		ps1 = ps1->nx;
	 }
  return(p1);
}

int gless_p(POLY *p1,POLY *p2)
{
  if (upol(p1))        return(1);
  else if (upol(p2))   return(0);
  else if (p1->var==p2->var)
	 {
		if      (ldeg(p1)<ldeg(p2)) return(1);
		else if (ldeg(p1)>ldeg(p2)) return(0);
		else return(gless_p(init(p1),init(p2)));
	 }
  else if (vless(p1->var,p2->var)) return(1);
  else return(0);
}

int gred_ps (POLY *p,POLS *bs)
{ POLY *p1;
  if      (gred_type==1) p1 = p;
  else if (gred_type==2) p1 = p_term(p);
  else gerror(0, "gred_ps");
  while (bs!=NULL)
	 { if (gsub_p(p1,bs->p)) return(0);
		bs = bs->nx;
	 }
  if (gred_type==2) put_p(p1);
  return(1);
}

int gsub_p(POLY *p1,POLY *p2)
{ POLS *ps;
  int d2;

  if (upol(p2))   return(1);
  if (upol(p1))   return(0);
  if (p1->var==p2->var)
	 {
		if (ldeg(p1)>=ldeg(p2))
	{ ps=p1->ups; d2 = ldeg(p2);
	  while(ps!=NULL && ps->deg >= d2)
		 { if (gsub_p(ps->p,init(p2))) return(1);
			ps=ps->nx;
		 }
	}
		return(0);
	 }
  if (vless(p1->var,p2->var)) return(0);
  {
	 ps=p1->ups;
	 while(ps!=NULL)
		{ if (gsub_p(ps->p,p2)) return(1);
	ps=ps->nx;
		}
	 return(0);
  }
}

/*  */
POLY *rem_gpc (POLY *p, POLS *asc)
{ POLY *p1 = rem_gc(p,asc);
  return(p1);
}

/*
POLY *rem_gb (POLY *p, TList *asc)
{ int len = asc->length();
  for(int i=1;i<=len; i++)
	 { p=grem(p,asc->p);
		if (upol(p)) return(p);
	 }
  return(p);
}
*/

POLY *rem_gc (POLY *p, POLS *asc)
{ for(;asc != NULL; asc=asc->nx)
	 { p=grem(p,asc->p);
		if (upol(p)) return(p);
	 }
  return(p);
}


// destrucetive for p1
// preerve p2
POLY *grem (POLY *p1, POLY *p2)
{  POLY *ip1, *ip2;

    if (upol(p2))	
	{ 
		put_p(p1);	return get_n(0); 
	}
	if (pzerop(p1))   return(p1);
	if (upol(p1))     {put_p(p1); return(get_n(1)); }
	if (vless(p1->var,p2->var)) return(p1);
 lp1:
   //G_OUT("1:",p1);
   //G_OUT("2:",p2);
	if (gred_type==1)        ip1 = div_lt(cp_TRIPoly(p1),p2);
	else if (plength(p2)<=2) ip1 = div_lt(cp_TRIPoly(p1),p2);
	else if (gred_type==2)   ip1 = div_lt(pu_term(p1),p2);

	wout<<"ip1: ";ip1->display();wout<<endl;	
	if (pzerop(ip1)) { put_p(ip1);
				/* printf("\r\ngremout: \r\n");pprint(p1); */
				return(p1); }

	ip2 = u_term(p2);
	wout<<"ip2: ";ip2->display();wout<<endl;	
	p1 = pminus(ptimes(p1,ip2),ptimes(cp_TRIPoly(p2),ip1));
	wout<<"p1: ";p1->display();wout<<endl;	
//	p1 = uprim(p1);
	goto lp1;
 }

POLY *div_lt(POLY *p1,POLY *p2)
{ POLS *ps, *ps1, *ps0, dt;
  int d2;

/*  printf("div_lt: ");pprint(p1);pprint(p2);  */
  if (upol(p2))   return(p1);
  if (upol(p1))  { put_p(p1);  return(get_n(0)); }
  if (p1->var==p2->var && (ldeg(p1)<ldeg(p2))) { put_p(p1); return(get_n(0)); }
  if (p1->var==p2->var)
	 { ps = p1->ups; d2 = ldeg(p2);
		ps0 = &dt;
		while(ps!=NULL && ps->deg >= d2)
	{ ps->deg -= d2;
	  ps->p = div_lt(ps->p,init(p2));
	  if (pzerop(ps->p))
		 { ps1=ps; ps=ps->nx; put_p(ps1->p); put_d(ps1); }
	  else
		 { ps0->nx = ps; ps0=ps; ps=ps->nx; }
	}
		ps0->nx = NULL;
		return(psimp(p1,dt.nx));
	 }
  if (vless(p1->var,p2->var)) { put_p(p1);  return(get_n(0)); }
  ps = p1->ups; ps0 = &dt;
  while (ps != NULL)
	 { ps->p = div_lt(ps->p,p2);
		if (pzerop(ps->p))
	{ ps1=ps; ps=ps->nx; put_p(ps1->p); put_d(ps1); }
		else
	{ ps0->nx = ps; ps0=ps; ps=ps->nx; }
	 }
  ps0->nx = NULL;
  return(psimp(p1,dt.nx));
}

POLS *s_pols(POLS *ps)
{ POLY *p1;
  POLS *ps1, dt;
  
//  wout<<"s_pols:"<<endl;ps_print(ps);
  dt.nx = NULL;
  for(; ps->nx!=NULL; ps = ps->nx)
	 { for(ps1 = ps->nx;ps1!=NULL;ps1 = ps1->nx)
		{
		if (undos1(ps->p,ps1->p)) {}
		else {
				 /*printf("spol in (%d) (%d)\r\n",plength(ps->p),plength(ps1->p)); */
				p1 = s_pol(cp_TRIPoly(ps->p),cp_TRIPoly(ps1->p));
				/*printf("spol out \r\n"); */
				p1 = rem_gpc(p1,ps);
				if (pzerop(p1)) {put_p(p1); }
				else  { dt.nx = get_dt(1,p1,dt.nx); }
			 }
		}
	 }
  return(dt.nx);
}

int undos1(POLY *p1,POLY *p2)
{ if (upol(p1)) return(1);
  if (upol(p2)) return(1);
  if (p1->var == p2->var) return(0);
  if (vless(p1->var,p2->var)) return(undos1(p1,init(p2)));
  return(undos1(init(p1),p2));
}

POLY *s_pol(POLY *p1,POLY *p2)
{ PP pp;
  POLY *u1, *u2;
  POLY *q1, *q2;
  pp = gfact(p_term(p1),p_term(p2));
  u1 =  u_term(p1); u2 = u_term(p2);
  q1 = ptimes3(p1,u2,pp.p2);
  q2 = ptimes3(p2,u1,pp.p1);
  q1=pminus(q1,q2);
  return (q1);
}
/*  return(pminus(ptimes3(p1,u2,pp.p2),ptimes3(p2,u1,pp.p1)));  */

/*
POLY *s_pol1(p1,p2)
POLY *p1, *p2;
{ PP pp;
  POLY *u1, *u2;
  printf("s_pol:\r\n");pprint(p1);pprint(p2);
  pp = gfact(p_term(p1),p_term(p2));
  printf("s_pol2:\r\n");pprint(pp.p1);pprint(pp.p2);
  printf("s_pol2:\r\n");pprint(p1);pprint(p2);
  u1 =  u_term(p1); u2 = u_term(p2);
  printf("s_pol3:\r\n");pprint(u1);pprint(u2);
  return(pminus(ptimes3(p1,u2,pp.p2),ptimes3(p2,u1,pp.p1)));
} */

PP gfact(POLY *p1,POLY *p2)
{ PP pp;
  NUM d;
  pp.p1 = get_n(1L);
  pp.p2 = get_n(1L);
  while(!(npoly(p1)) || !(npoly(p2)))
	 {
		if (!npoly(p1) && npoly(p2))
		{ pp.p1 = ptimes(pp.p1,get_v(p1->var,ldeg(p1),get_n(1L)));
		  p1 = init(p1);
		}
		else if (npoly(p1) && !npoly(p2))
		{ pp.p2 = ptimes(pp.p2,get_v(p2->var,ldeg(p2),get_n(1L)));
		  p2 = init(p2);
		}
		else if (p1->var == p2->var)
		{
		  if (ldeg(p1) > ldeg(p2))
		  { pp.p1 = ptimes(pp.p1,get_v(p1->var,ldeg(p1)-ldeg(p2),get_n(1L))); }
		  else if (ldeg(p1) < ldeg(p2))
		  { pp.p2 = ptimes(pp.p2,get_v(p2->var,ldeg(p2)-ldeg(p1),get_n(1L))); }
	      p1 = init(p1); p2 = init(p2);
		}
		else  if (vless(p1->var,p2->var))
			{ pp.p2 = ptimes(pp.p2,get_v(p2->var,ldeg(p2),get_n(1L)));
			  p2 = init(p2);
			}
		else
		{ pp.p1 = ptimes(pp.p1,get_v(p1->var,ldeg(p1),get_n(1L)));
		  p1 = init(p1);
		}
	 }
  d = num_gcd(p1->c,p2->c);
  pp.p1 = ptimes(get_n(num_d(p1->c,d)),pp.p1);
  pp.p2 = ptimes(get_n(num_d(p2->c,d)),pp.p2);

  return(pp);
}

/* */
int upol (POLY *p)
{
  if (p->var==NULL) return(1);
  /*
  VAR *v;
   v = p->var;
   if (v->nm==0) return(1);
   return(v->nm==-100);
  */
  return 0;
}

POLY *p_term(POLY *p)
{ POLY *p1;
  p1=get_n(1L);
  while (!(upol(p)))
	 { p1 = ptimes(get_v(p->var,ldeg(p),get_n(1L)),p1);
	   p = init(p);
	 }
  return(p1);
}

POLY *u_term(POLY *p)
{
  while (!(upol(p))) {  p = init(p); }
  return(cp_TRIPoly(p));
}

POLY *pu_term(POLY *p)
{ POLY *p1;
  p1=get_n(1L);
  while (!(upol(p)))
	 { p1 = ptimes(get_v(p->var,ldeg(p),get_n(1L)),p1);
		p = init(p);
	 }
  return(ptimes(cp_TRIPoly(p),p1));
}

//presevrve p
POLY* ucontent(POLY* p)
{ POLY *p1, p2; 
  if (upol(p)) { return cp_TRIPoly(p); }
  int  sg = (p->IPlbcf()>0)?1:-1; 
  POLY *c = new TRIPoly();
  //G_OUT("0:",p);
  for(POLS *ps=p->ups;ps;ps=ps->nx)
  { p1 = ucontent(ps->p);
    //G_OUT("p1:",p1); G_OUT("c:",c);
    c = new TRIPoly(c->mipgcd(*p1));
	//G_OUT("c:",c);
    delete p1;
    if (c->pis1()) goto tout;
  }
tout:
  return (sg==1)?c:neg_TRIPoly(c);
}

POLY *uprim(POLY *p)
{ POLY * c;
 if (pzerop(p)) return(p);
 if (upol(p)) { put_p(p); return(get_n(1L)); }
 //G_OUT("p:",p);
 c = ucontent(p);
 //G_OUT("c",c);
 p = pdiv(p,c);
 delete c;
 return p;

//  pprint(p);
//  sprintf(txt,"upol(%d)(%d)\r\n",upol(p),(p->var)->nm);
//  gprint(txt);

 
  /*
  POLY *p1,*p2, *u1;
  POLS *ps1,*ps2;
  int d1;
 u1 = u_term(p);
  p1 = vars_in_p(u1);

  while (p1 != NULL)
	 { d1 = mdeg(p,p1->var);
	   if (d1 > 0)
		{ p2 = get_v(p1->var,d1,get_n(1L));
		  p = pdiv(p,p2);
	      put_p(p2);
		}
		p2=p1; p1=p1->u.p; put_x(p2);
	 }
  u1 = mv_nfact(u1);
  //{ gprint("uuu1\r\n");  pprint(u1);  pprint(p); }
  p1 = pdiv(cp_TRIPoly(p),u1);
  if (p1!=NULL) { put_p(p); p = p1; }

  ps1 = ufactor(u1);
  while(ps1!=NULL)
	 { p1 = pdiv(cp_TRIPoly(p),ps1->p);
		if (p1!=NULL) { put_p(p); p = p1; }
		ps2=ps1; ps1=ps1->nx;
		put_p(ps2->p); put_d(ps2);
	 }
  return(p);
  */
}


POLS *ufactor(POLY *p)
{ POLS pt;
  return 0;
/*
  if (npoly(p)) return(NULL);
  d1 = mdeg(p,p->var);
  if (d1> 0) for(ps = p->ups;ps!=NULL;ps=ps->nx)  { ps->deg -= d1; }
 lp1:
  if (npoly(p)) return(NULL);
  if (plength(p) < 2) return(NULL);
  if (!opoly(p))
	 { p = mv_nfact(p);
		return(get_dt(1,p,NULL));
	 }
  while(tlength(p)==1)
	 { ps = p->ups;
		put_x(p); p = ps->p;
		put_d(ps);
		goto lp1;
	 }
  pt.nx = NULL;
  for(ps = p->ups; ps!=NULL; ps = ps->nx)
	 { ps1 = ufactor(cp_TRIPoly(ps->p));
		pt.nx = ps_union(pt.nx,ps1);
	 }

  ps1 = &pt; ps2 = pt.nx;
  while(ps2!=NULL)
	 {
		p1=cp_TRIPoly(p);
		p1 = pdiv(cp_TRIPoly(p),ps2->p);
		if (p1==NULL)
	{ ps1->nx = ps2->nx;
	  put_p(ps2->p); put_d(ps2);
	  ps2 = ps1->nx;
	}
		else { ps1 = ps2; ps2 = ps1->nx; put_p(p); p = p1; }
	 }

  pt.nx = get_dt(1,p,pt.nx);
  return(pt.nx);
  */
}

int opoly(POLY *p)
{ POLS *ps;
  ps = p->ups;
  while (ps!=NULL) { if (plength(ps->p) == 1) return(0); else ps = ps->nx; }
  return(1);
}

//
// Remove those sets that contain some other set
// e.g: [x],[xy] -> [x]
//
//destructive for ps
//
POLS* pss_simp(POLS *ps)
{  POLS allps, *ps1, *ps2;
   POLY *p1;
   allps.nx = ps;
   for(ps1=&allps,ps2=ps1->nx;ps2;)
	{ 
	  p1  = ps2->p; 
	  ps1->nx = ps2->nx;
	  if (pss_cont(p1->ups,allps.nx))
	  { put_p(p1); put_d(ps2);}
	  else
	  { ps2->nx = ps1->nx;
	    ps1->nx = ps2;
		ps1 = ps2;
	  }
	  ps2 = ps1->nx;
	}
  return(allps.nx);
}


POLS* split_ps(POLS *ps,POLS *bs)
{   int i, len;
    bool r;
    TList *ls1;
	POLS  *ps0,*ps1,*allps,*newps;
    POLY* p1 = new TRIPoly(),*p2,*p3;
    p1->ups=bs;
    allps = get_dt(1,p1,0);

	for(ps0=ps;ps0;ps0=ps0->nx)
	{	newps = 0;
		ls1 = factorlist_wdk(ps0->p);
		len = ls1->length();
		//G_OUT("ls1:",ls1);
		for(ps1=allps;ps1;ps1=ps1->nx)
		{	p1  = ps1->p;
		    //wout << "01:"; ps_print(p1->ups);
		    r=true;
			for(i=1;i<=len;i++)
			{  p2 = (TRIPoly*)ls1->Part(i);
			   if (!ps_member(p2,p1->ups))
			   {   
				   p3 = get_xt(0,cp_TDITerm(p1->ups));
			       //wout << "03:"; ps_print(p3->ups);
				   p3->ups = get_dt(1,cp_TRIPoly(p2),p3->ups);
				   newps = get_dt(1,p3,newps);	   
			   }
			   else if(r)
			   {   newps = get_dt(1,get_xt(0,cp_TDITerm(p1->ups)),newps);	   
				   r = false;
			   }
			}
		}
   //wout << "3:\n";  
   //for(ps1=newps;ps1;ps1=ps1->nx) { wout << "0:"; ps_print(ps1->p->ups); }

		delete ls1;
		put_ps(allps);
		allps = newps;
	}
	return allps;
}

///////////////////////////////////////////////////////////////////////////////
//******************************added by xwang*******************************//
//Syzygy
TRIPoly *S_poly(TRIPoly *g_i,TRIPoly *g_j,TList *vl)
{
//	vl->display();wout<<endl;
	TList *temp = new TList();
	int l = vl->length();
	for(;l > 0;l --)
		temp->append(vl->Part(l));
//	temp->display();wout<<endl;
	TRIPoly g_i_firstterm = g_i->IPldt(temp);
//	g_i_firstterm.display();wout<<endl;
	TRIPoly g_j_firstterm = g_j->IPldt(temp);
//	g_j_firstterm.display();wout<<endl;
	TRIPoly gcd = g_i_firstterm.mipgcd(g_j_firstterm);
//	gcd.display();wout<<endl;
	TRIPoly lcm = g_i_firstterm * g_j_firstterm / gcd;
//	lcm.display();wout<<endl;
	delete temp;

	TRIPoly Spoly = (lcm / g_i_firstterm) * (*g_i) - (lcm / g_j_firstterm) * (*g_j);
	TRIPoly *re = new TRIPoly(Spoly);
	return re;
}

TList *gbasis(TList *ps,TList *vl)
{
	int record[200][2];//¼ݶǷѾԹ
	int length1,length2;
	length1 = length2 = ps->length();
	int flag1 = 0;
	int flag2 = 0;
	for(int i = 1;i <=length2;i ++)
		for(int j = i + 1;j <= length2;j ++)
		{
			record[flag1][0] = i;
			record[flag1][1] = j;
			flag1 ++;
		}

	TList * g = (TList *)(ps->Copy());

	for(;flag2 < flag1;flag2 ++)
	{
//		wout<<"record[flag2][0]: "<<record[flag2][0]<<"   record[flag2][1]:"<<record[flag2][1]<<endl;
//		TP(g->Part(record[flag2][0]))->display();wout<<endl;
//		TP(g->Part(record[flag2][1]))->display();wout<<endl;
		TRIPoly * Sij = S_poly(TP(g->Part(record[flag2][0])),TP(g->Part(record[flag2][1])),vl);
//		wout<<"Sij: ";Sij->display();wout<<endl;
		TList * re = div_var(*Sij,g,vl);
//		wout<<"re:";re->display();wout<<endl;
		if(!TP(re->Part(length1 + 1))->IsZero())
		{
			length1 ++;
			g->append(Sij);
//			wout<<"g:";g->display();wout<<endl;
			for(i = 1;i < length1;i ++)
			{
				record[flag1][0] = i;
				record[flag1][1] = length1;
				flag1 ++;
			}
		}
		else delete Sij;
		delete re;
	}

	return g;
}

TMatrix *grem_for_syzygy(TList *ps,TList *g,TList *vl)
{
	int row = g->length();
	int col = ps->length();
	TMatrix *B = new TMatrix(row,col);
	int i = 0;
	for(TListNode * tmp=FIRSTNODE(ps);tmp;RNEXT(tmp))
	{
		TRIPoly *a = TP(DATA(tmp));
		TRIPoly *b = a->Clone();
		//TList *tmp1 = (TList *)(g->Copy());
//		g->display();wout<<endl;
//		b->display();wout<<endl;
		TList *coeff = div_var(*b,g,vl);
		for(int j = 0;j < row;j ++)
			B->SetVal(j,i,coeff->Part(j + 1)->Copy());
		delete b;
		//delete tmp1;
//		g->display();wout<<endl;
		delete coeff;
		i ++;
	}
	return B;
}

TMatrix *simplify(TMatrix *m,TList *vl)
{
	int row = m->VSize();
	int col = m->HSize();
	TMatrix * m1 = (TMatrix *)(m->Copy());
	TMatrix * m2;
	int i,j;
	int k = 0;
	for(i = 0;i < col;i ++)
	{
		int f = 1;
		for(j = 0;j < row;j ++)
		{
			if(!IsZero(m->GetVal(j,i)))
			{
				f = 0;
				break;
			}
		}
		if(f == 1)
		{
			m2 = m1->delcol(i - k);
			delete m1;
			m1 = m2;
			k ++;
		}
	}
	//m1->display();wout<<endl;
	//ȫΪ0

	row = m1->VSize();
	col = m1->HSize();

	for(i = 0;i < col;i ++)
	{
		int f = 1;
		TRIPoly *g = TP(m1->CopyVal(0,i));
		TRIPoly gg(*g);
		delete g;
		//gg.display();wout<<endl;

		for(j = 1;j < row;j ++)
		{
			TRIPoly *flag = TP(m1->CopyVal(j,i));
			TRIPoly gcd = flag->ipgcd(gg);
			gg = gcd;
			delete flag;
			//gg.display();wout<<endl;
		}
		if(!(gg == TRIPoly(TBigInt(1))))
		{
			for(j = 0;j < row;j ++)
			{
				TRIPoly *tmp = TP(m1->GetVal(j,i));
				TRIPoly tmp1 = *tmp / gg;
				TRIPoly *tmp2 = new TRIPoly(tmp1);
				m1->SetVal(j,i,tmp2);
			}
		}
	}
	//m1->display();wout<<endl;
	//return m1;
	//ÿһжԼ

	int grem = 1;
	while(grem)
	{
		grem = 0;
		col = m1->HSize();
		for(i = 0;i < col;i ++)
		{
			for(j = i + 1;j < col;j ++)
			{
				int grem1 = 1;
				int grem2 = 1;
				for(int k = 0;k < row;k ++)
				{
					TRIPoly *flag1 = TP(m1->CopyVal(k,i));
					//flag1->display();wout<<endl;
					TRIPoly *flag2 = TP(m1->CopyVal(k,j));
					//flag2->display();wout<<endl;
					if(!(*flag1 == *flag2))
						grem1 = 0;
					if(!(*flag1 == *flag2 * TBigInt(-1)))
						grem2 = 0;
					delete flag1;
					delete flag2;
				}
				if(grem1 == 1 || grem2 == 1)
				{
					m2 = m1->delcol(j);
					delete m1;
					m1 = m2;
					//m1->display();wout<<endl;
					grem = 1;
					break;
				}
			}
			if(grem == 1) break;
		}
	}
	//m1->display();wout<<endl;
	//ͬУ-1У
	return m1;
}

TMatrix *get_syzygy(TList *ps,TList *vl)
{
	TList *G_and_A = gbasis_for_syzygy(ps,vl);
	TList *G = (TList *)(G_and_A->Part(1));
	TMatrix *A = (TMatrix *)(G_and_A->Part(2));
//	ps->display();wout<<endl;
//	G->display();wout<<endl;
//	A->display();wout<<endl;
	TList *l = (TList *)(G->Clone());
//	wout<<"l:";l->display();wout<<endl;
	TMatrix *B = grem_for_syzygy(ps,l,vl);
//	wout<<"G:";G->display();wout<<endl;
//	wout<<"A:";A->display();wout<<endl;
//	wout<<"B:";B->display();wout<<endl;
	TMatrix * AB = A->mul(B);
//	wout<<"AB:";AB->display();wout<<endl;
	for(int i = 0;i < AB->VSize();i ++)
	{
		TRIPoly *diag = TP(AB->GetVal(i,i));
		TRIPoly temp = TRIPoly(1) - *diag;
		TRIPoly *diag1 = new TRIPoly(temp);
		AB->SetVal(i,i,diag1);
	}

//	AB->display();wout<<endl;
//	G->display();wout<<endl;
	TList * GG = Syzygy(G,vl);
//	GG->display();wout<<endl;

	int leng1 = G->length();
	int leng2 = GG->length();
	TList * Zero = new TList();
	for(i = 0;i < leng1;i ++)
		Zero->append(new TRIPoly(TBigInt(0)));
//	Zero->display();wout<<endl;
	for(i = 0;i < leng2;)
	{
		if(((TList *)(GG->Part(i + 1)))->equal(Zero))
		{
			GG->dremove(i + 1);
			leng2 --;
		}
		else
			i ++;
	}
	delete Zero;
//	GG->display();wout<<endl;
	TMatrix *GGG = new TMatrix(G->length(),GG->length());
	for(i = 0;i < G->length();i ++)
		for(int j = 0;j < GG->length();j ++)
			GGG->SetVal(i,j,((TList *)(GG->Part(j + 1)))->Part(i + 1)->Copy());

//	GGG->display();wout<<endl;
//	A->display();wout<<endl;
	TMatrix *AG = A->mul(GGG);
//	AG->display();wout<<endl;
//	return AG;
	TMatrix *s = simplify(AG,vl);

	delete l;
	delete B;
	delete GG;
	delete AB;
	delete AG;
	delete GGG;
	delete G_and_A;
//  s->display();wout<<endl;
return s;
}

TList *gbasis_for_syzygy(TList *ps,TList *vl)
{
	int record[3000][2];//¼ݶǷѾԹ
	int length1,length2;
	length1 = length2 = ps->length();
	int flag1 = 0;
	int flag2 = 0;
	for(int i = 1;i <=length2;i ++)
		for(int j = i + 1;j <= length2;j ++)
		{
			record[flag1][0] = i;
			record[flag1][1] = j;
			flag1 ++;
		}

	TList * g = (TList *)(ps->Copy());
	TList * check = new TList();
	TList *templist = new TList();
	int l = vl->length();
	for(;l > 0;l --)
		templist->append(vl->Part(l));

	for(;flag2 < flag1;flag2 ++)
	{
//		wout<<"record: ";
//		for(int t = 0;t < flag1;t ++)
//			wout<<"["<<record[t][0]<<","<<record[t][1]<<"],";
//		wout<<endl;
//		wout<<"g: ";g->display();wout<<endl;
//		wout<<"record[flag2][0]: "<<record[flag2][0]<<"   record[flag2][1]:"<<record[flag2][1]<<endl;
//		TP(g->Part(record[flag2][0]))->display();wout<<endl;
//		TP(g->Part(record[flag2][1]))->display();wout<<endl;
//*********from this, is the same with function of S_poly*********//
		TRIPoly * g_i = TP(g->Part(record[flag2][0]));
		TRIPoly * g_j = TP(g->Part(record[flag2][1]));
		
		TRIPoly g_i_firstterm = g_i->IPldt(templist);
//		g_i_firstterm.display();wout<<endl;
		TRIPoly g_j_firstterm = g_j->IPldt(templist);
//		g_j_firstterm.display();wout<<endl;
		TRIPoly gcd = g_i_firstterm.mipgcd(g_j_firstterm);
//		gcd.display();wout<<endl;
		TRIPoly lcm = g_i_firstterm * g_j_firstterm / gcd;
//		lcm.display();wout<<endl;
		
		TRIPoly g_ii = lcm / g_i_firstterm;
		TRIPoly g_jj = lcm / g_j_firstterm;
		TRIPoly Sij = g_ii * (*g_i) - g_jj * (*g_j);
//*************************end at this place***********************//

//		wout<<"Sij: ";Sij.display();wout<<endl;
		//TRIPoly * S = new TRIPoly(Sij);
		TList * re = div_var(Sij,g,vl);
//		wout<<"re:";re->display();wout<<endl;
		TRIPoly * S0 = TP(re->Part(length1 + 1)->Copy());
		if(!S0->IsZero())
		{
			length1 ++;
//			g->display();wout<<endl;
//			S->display();wout<<endl;
			g->append(S0);
//			g->display();wout<<endl;
//			wout<<"g:";g->display();wout<<endl;
			TList * t = new TList();
			for(int k = 1;k < re->length();k ++)
			{
				TRIPoly * tmp = TP(re->Part(k));
				t->append(new TBigInt(k));
				if(k == record[flag2][0])
				{
					TRIPoly tmp1 = g_ii - *tmp;
					TRIPoly *tmp2 = new TRIPoly(tmp1);
					t->append(tmp2);
				}
				else if(k == record[flag2][1])
				{
					TRIPoly tmp1 = - g_jj - *tmp;
					TRIPoly *tmp2 = new TRIPoly(tmp1);
					t->append(tmp2);
				}
				else
				{
					TRIPoly tmp1 = - *tmp;
					TRIPoly *tmp2 = new TRIPoly(tmp1);
					t->append(tmp2);
				}
			}
			//t->append(new TBigInt(record[flag2][0]));
			//t->append(gi);
			//t->append(new TBigInt(record[flag2][1]));
			//t->append(gj);
			check->append(t);
//			wout<<"check: ";check->display();wout<<endl;
			for(i = 1;i < length1;i ++)
			{
				record[flag1][0] = i;
				record[flag1][1] = length1;
				flag1 ++;
			}
		}
		else delete S0;
		//delete S;
		delete re;
	}
	delete templist;

//	wout<<"last g:";g->display();wout<<endl;
//	wout<<"last check:";check->display();wout<<endl;

	int row = ps->length();
	int col = g->length();
	TMatrix * A = new TMatrix(row,col);
	for(int a = 0;a < row;a ++)
		for(int b = 0;b < col;b ++)
			A->SetVal(a,b,new TRIPoly(TBigInt(0)));
//	A->display();wout<<endl;

	for(a = 0;a < row;a ++)
		A->SetVal(a,a,new TRIPoly(TBigInt(1)));
//	A->display();wout<<endl;

	for(a = 0;a < check->length();a ++)
	{
		TList * list = ((TList *)(check->Part(a + 1)));
		for(int b = 1;b <= list->length();b = b + 2)
		{
			int c = ((TBigInt *)(list->Part(b)))->GetShort(0);
			if(c <= row)
				A->SetVal(c - 1,a + row,list->Part(b + 1)->Copy());
			else
			{
				for(int m = 0;m < row;m ++)
				{
					TRIPoly *tr = TP(A->CopyVal(m,c - 1));
//					tr->display();wout<<endl;
					TRIPoly *tr1 = TP(list->Part(b + 1)->Copy());;
//					tr1->display();wout<<endl;
					TRIPoly tr2 = (*tr1) * (*tr);
//					tr2.display();wout<<endl;
					TRIPoly *tr3 = TP(A->CopyVal(m,a + row));
//					tr3->display();wout<<endl;
					TRIPoly tr4 = tr2 + *tr3;
//					tr4.display();wout<<endl;
					TRIPoly *tr5 = new TRIPoly(tr4);
//					tr5->display();wout<<endl;
					A->SetVal(m,a + row,tr5);
					delete tr;
					delete tr1;
					delete tr3;
				}
			}
		}
//		A->display();wout<<endl;
/*		int c = ((TBigInt *)(list->Part(1)))->GetShort(0);
		if(c > row)
		{
			for(int m = 0;m < row;m ++)
			{
				TRIPoly *tr = TP(A->CopyVal(m,c - 1));
				TRIPoly *tr1 = TP(list->Part(2)->Copy());;
				TRIPoly trr = (*tr1) * (*tr);
				TRIPoly * trrr = new TRIPoly(trr);
				A->SetVal(m,a + row,trrr);
//				A->display();wout<<endl;
				delete tr;
				delete tr1;
			}
		}
		else
		{
			A->SetVal(c - 1,a + row,list->Part(2)->Copy());
//			A->display();wout<<endl;
		}
		c = ((TBigInt *)(list->Part(3)))->GetShort(0);
		if(c > row)
		{
			for(int m = 0;m < row;m ++)
			{
				TRIPoly *tr = TP(A->CopyVal(m,c - 1));
//				tr->display();wout<<endl;
				TRIPoly *tr1 = TP(list->Part(4)->Copy());;
				TRIPoly trr = (*tr1) * (*tr);
//				trr.display();wout<<endl;
				TRIPoly *tr2 = TP(A->CopyVal(m,a + row));
				trr = trr + (*tr2);
//				trr.display();wout<<endl;
				TRIPoly * trrr = new TRIPoly(trr);
				A->SetVal(m,a + row,trrr);
//				A->display();wout<<endl;
				delete tr;
				delete tr1;
				delete tr2;
			}
		}
		else
		{
			A->SetVal(c - 1,a + row,list->Part(4)->Copy());
//			A->display();wout<<endl;
		}
		*/
	}
	
//	A->display();wout<<endl;
	delete check;
//	delete A;
	TList * G_and_A = new TList();
	G_and_A->append(g);
	G_and_A->append(A);
	return G_and_A;
}

TList * Syzygy(TList * G,TList * vl)
{
	int l = G->length();
    TList * Syz = new TList();
	for(int i = 1;i <= l;i ++)
	{
		for(int j = 1;j < i;j ++)
		{
			if(j == i)
				continue;
			TRIPoly * g_i = (TRIPoly *)(G->Part(i)->Copy());
			TRIPoly * g_j = (TRIPoly *)(G->Part(j)->Copy());
		
			TList *templist = new TList();
			int length = vl->length();
			for(;length > 0;length --)
				templist->append(vl->Part(length));
			TRIPoly g_i_firstterm = g_i->IPldt(templist);
//			g_i_firstterm.display();wout<<endl;
			TRIPoly g_j_firstterm = g_j->IPldt(templist);
//			g_j_firstterm.display();wout<<endl;
			
			TRIPoly gcd = g_i_firstterm.mipgcd(g_j_firstterm);
//			wout<<"gcd: ";gcd.display();wout<<endl;
			TRIPoly lcm = g_i_firstterm * g_j_firstterm / gcd;
//			wout<<"lcm: ";lcm.display();wout<<endl;

			TRIPoly Sij = (lcm / g_i_firstterm) * (*g_i) - (lcm / g_j_firstterm) * (*g_j);
//			wout<<"Sij: ";Sij.display();wout<<endl;

			delete templist;
			delete g_i;
			delete g_j;

			//TList * aijk = new TList();
			TList * sijk = new TList();
			if(Sij.IsZero())
			{
				for(int k = 1;k <= l;k ++)
					sijk->append(new TRIPoly(TBigInt(0)));
			}
			else
			{
//				wout<<"Sij: ";Sij.display();wout<<endl;
//				wout<<"G: ";G->display();wout<<endl;
//				wout<<"vl: ";vl->display();wout<<endl;
				TList * aijk = div_var(Sij,G,vl);
//				wout<<"aijk: ";aijk->display();wout<<endl;
				for(int k = 1;k <= l; k ++)
				{
					TRIPoly tmp,* temp;
					if(k == i)
					{
						tmp = (lcm / g_i_firstterm) - (*TP(aijk->Part(k)));
						temp = new TRIPoly(tmp);
						sijk->append(temp);
					}
					else if(k == j)
					{
						tmp = - (lcm / g_j_firstterm) - (*TP(aijk->Part(k)));
						temp = new TRIPoly(tmp);
						sijk->append(temp);
					}
					else 
					{
						tmp = - (*TP(aijk->Part(k)));
						temp = new TRIPoly(tmp);
						sijk->append(temp);
					}
				}
				delete aijk;
			}
//			wout<<"sijk: ";sijk->display();wout<<endl;
			Syz->append(sijk);
		}
	}
	
	return Syz;
}
//******************************end of addition**********************************//..... 