#include "geometry.h"

#ifdef _WINDOWS
#include "..\gui\index.h"
#endif


//
// Genration functions for GEOMETRY
// 
GEOMETRY::geom() 
{ 
	//mvars = new TList();
	//pvars = new TList();
	//vars = new TList();
	pred_set=deg_set=conc_set=cs_set=0;text=0;
   ptset=pvars=mvars=0;cset=pset=dset=0; 
}
GEOMETRY::geom(TList * example, int gtype) 
{
 qerror = false;
 pred_set=deg_set=conc_set=cs_set=0;
 text=0;
 ptset=pvars=mvars=0;cset=pset=dset=0; 

 int k = example->length();
 if (k==5) //algebraic
 {
	mvars=(TList *)(example->Part(1));
	pvars=(TList *)(example->Part(2));
	pvars = pvars->Clone();
	mvars = mvars->Clone();
    pset =toTRIPolyList((TList *)(example->Part(3)));
    if (!pset) gerror((TList *)(example->Part(3)),"should be a polynomial list.");
    dset =toTRIPolyList((TList *)(example->Part(4)));
	if (!dset) gerror((TList *)(example->Part(4)),"should be a polynomial list.");
	cset =toTRIPolyList((TList *)(example->Part(5)));
	if (!cset) gerror((TList *)(example->Part(5)),"should be a polynomial list.");
	geom_check();
 }
 else if (k==6)//predicate
 {
	mvars=(TList *)(example->Part(1));
	pvars=(TList *)(example->Part(2));
	ptset=(TList *)(example->Part(3));
    pred_set=(TList *)(example->Part(4));
    deg_set= (TList *)(example->Part(5));
    conc_set= (TList *)(example->Part(6));
	geom_check();
    if (qerror) return;

	pvars = pvars->Clone();
	mvars = mvars->Clone();
	ptset = ptset->Clone();
	pred_set = pred_set->Clone();
	deg_set  = deg_set->Clone();
	//conc_set = conc_set->Clone();
    //G_OUT("c",conc_set);
	if (gtype==SCURVE) init_scurve(false);
   	GetPSAndDS(Cs2Pd(pred_set),Cs2Pd(deg_set),Cs2Pd(conc_set));
//    G_OUT("cset",cset);
 }
 else if (k==2)//constructive
 {
   cs_set =  (TList *)(example->Part(1));
   conc_set= (TList *)(example->Part(2));
   cs_set  = cs_set->Clone();
   conc_set= conc_set->Clone();
   geom_check();

   GenCoor(cs_set);
   //pvars->display(); wout <<"11"<<endl;
   //mvars->display(); wout <<"22"<<endl;
   //ptset->display(); wout <<"33"<<endl;
   
   pred_set = Cs2Pd(cs_set);
   if (qerror) return;
   deg_set  = CsNdg(cs_set);
   if (qerror) return;
   // wout <<"Non-Degenerate Conditions:"; deg_set->display(); wout <<endl;
   GetPSAndDS(pred_set,deg_set,Cs2Pd(conc_set));
 }
 else
 { 
   gerror(0,"Geometric statement syntax error(geom)."); 
 }
}

GEOMETRY::geom(char *cst) 
{ 
//  qerror = false;
  text=cst;
  pred_set=deg_set=conc_set=cs_set=0;
  ptset=pvars=mvars=0;
  cset=pset=dset=0; 
  read_lang(text);
  if (qerror) return;

  GenCoor(cs_set);
 //pvars->display(); wout <<"11"<<endl;
 //mvars->display(); wout <<"22"<<endl;
 //ptset->display(); wout <<"33"<<endl;
  pred_set = Cs2Pd(cs_set);
 //wout <<"144:"; pvars->display(); wout <<endl;
 //wout <<"244:"; mvars->display(); wout <<endl;
 //wout <<"344:"; ptset->display(); wout <<endl;
 //wout <<"444:"; pred_set->display(); wout <<endl;
  deg_set = CsNdg(cs_set);
 //wout <<"55:"; deg_set->display(); wout <<endl;
  GetPSAndDS(pred_set,deg_set,Cs2Pd(conc_set));
}

GEOMETRY::~geom()
{
	/*
	if (pvars) delete pvars;
   	if (mvars) delete mvars;
   	if (ptset) delete ptset;	
   	if (pset) delete pset;   
   	if (dset) delete dset;   
   	if (cset) delete cset;
		*/

}

TList *GEOMETRY::AlgForm() 
{

 TList *l = new TList((TAtom*)mvars,(TAtom*)pvars,
	                  (TAtom*)pset,(TAtom*)dset,(TAtom*)cset);
 return l;
}

TList *GEOMETRY::PdForm() 
{

 TList *l = new TList((TAtom*)mvars,(TAtom*)pvars,(TAtom*)ptset,
				(TAtom*)pred_set,(TAtom*)deg_set,(TAtom*)conc_set);
 return l;
}
TList *GEOMETRY::CsForm() 
{

 TList *l = new TList((TAtom*)cs_set,(TAtom*)conc_set);
 return l;
}


bool ispred(TList* o)
{
  char *nm;
  TVariable *c0;
  TList *p =0;

  if (!o) return false;
  if (o->TypeID()!= ListType) return false;
  c0 = (TVariable*)o->Part(1);
  if (c0->TypeID()!=Variable) return false;
  nm = c0->GetName();
  if (GetFunctionNumber(nm)>=0)	 return var_list(o->Rest());
  return false;
}

bool isobj(TList* o)
{
  char *nm;
  TVariable *c0;
  TList *p =0;

  if (!o) return false;
  if (o->TypeID()!= ListType) return false;
  c0 = (TVariable*)o->Part(1);
  if (c0->TypeID()!=Variable) return false;
  nm = c0->GetName();
  if (strcmp(nm,"LINE")==0 || strcmp(nm,"PLINE")==0
	  || strcmp(nm,"TLINE")==0 || strcmp(nm,"BLINE")==0
	  || strcmp(nm,"CIR")==0)
	  return var_list(o->Rest());
   return false;
}

bool iscons(TList *c)
{ 
  TVariable *v;
  char *nm;
  bool re = false;
  if (c) 
  {
    if (c->TypeID()== ListType)
	{ 
        v = (TVariable*)c->Part(1);
		if (v->TypeID()!=Variable) return false;
        nm = v->GetName();
	   if (strcmp(nm,"ON")==0)
	   { TList * pt = (TList*)c->Part(2); 
	     if (pt->TypeID()!=Variable) return false;
	     TList * o = (TList*)c->Part(3);
		 return isobj(o);
		}
	   else if (strcmp(nm,"INTER")==0) 
	   { TList * pt = (TList*)c->Part(2); 
	     if (pt->TypeID()!=Variable) return false;
	     TList * o = (TList*)c->Part(3);
		 if (!isobj(o)) return false;
         o = (TList*)c->Part(4);
		 return isobj(o);
		}
      else if (strcmp(nm,"MIDPOINT")==0 || strcmp(nm,"REF")==0 
		    || strcmp(nm,"FOOT")==0 || strcmp(nm,"CIRCUMCENTER")==0
			|| strcmp(nm,"INCENTER")==0 || strcmp(nm,"POINT")==0) 
	   return var_list(c->Rest());
	 else return false;
	}
  }
 return re;
}

void GEOMETRY::geom_check()
{ int i;
  TList * ci;

  if (!var_list(pvars))
	{  gerror(pvars, "should be a variable list."); return;}
  if (!var_list(mvars))
	{  gerror(mvars, "should be a variable list."); return;}
  
  if (ptset) 
  {
	if (ptset->TypeID()== ListType)
	{  
		for(i=1;i<=ptset->length(); i++)
		{ TAtom * ci = ptset->Part(i);
		  if ((i%2)==1)
		  { 
			  if (ci->TypeID()!=Variable) 
			  { gerror(ptset, "should be a point-coordiante list."); return;}
		  }
		  else //i%2==0 
		  {	if (!var_list((TList *) ci,1))				
				{  gerror(ptset, "should be a point-coordiante list."); return;}
		  }
		}
	}
    else {  gerror(ptset,"should be a variable list."); return;}
  }

  if (!poly_list(pset))
	{  gerror(pset, "should be a polynomial list."); return;}
  if (!poly_list(dset))
	{  gerror(dset, "should be a polynomial list."); return;}
  if (!poly_list(cset))
	{  gerror(cset, "should be a polynomial list."); return;}

  if (cs_set) 
  {
	if (cs_set->TypeID()== ListType)
	{  
		for(i=1;i<=cs_set->length(); i++)
		{ ci = (TList*)cs_set->Part(i);
		  if (!iscons(ci)) 
			  { gerror(ci,"should be a construction."); return;}
		}
	}
    else {  gerror(cs_set,"should be a construction list."); return;}
  }
/*
  if (pred_set) 
  {
	if (pred_set->TypeID()== ListType)
	{  
		for(i=1;i<=pred_set->length(); i++)
		{ ci = (TList*)pred_set->Part(i);
		  if (!iscons(ci) && !ispred(ci) && is) 
			  { gerror(ci,"should be a construction or a predicate."); return;}
		}
	}
    else {  gerror(pred_set,"should be a construction list."); return;}
  }
  
  if (deg_set) 
  {
	if (deg_set->TypeID()== ListType)
	{  
		for(i=1;i<=deg_set->length(); i++)
		{ ci = (TList*)deg_set->Part(i);
		  if (!ispred(ci) && !iscons(ci)) 
			  { gerror(ci,"should be a predicate."); return;}
		}
	}
    else {  gerror(deg_set,"should be a construction list."); return;}
  }
  if (conc_set) 
  {
	if (conc_set->TypeID()== ListType)
	{  
		for(i=1;i<=conc_set->length(); i++)
		{ ci = (TList*)conc_set->Part(i);
		  if (!ispred(ci) && !iscons(ci)) 
			  { gerror(ci,"should be a predicate."); return;}
		}
	}
    else {  gerror(conc_set,"should be a construction list."); return;}
  }
*/

}

//
//Treat constructive form
//

//Generate coordaintes for points in CS
void GEOMETRY::GenCoor(TList * css)
{
  TList *c1,*c2;
  char *nm;
  TVariable *c0;
//  wout<<"css:"; css->display(); wout<<endl;

  pvars = new TList();
  mvars = new TList();
  ptset = new TList();
  
  for(int i=css->length();i>=1;i--)
  {
   c1 = (TList *) css->Part(i);
   //wout<<"yy:";c1->display(); wout <<"xx"<<endl;

   c0 = (TVariable*)c1->Part(1);
   nm = c0->GetName();
   if (strcmp(nm,"POINT")==0 ||
	   strcmp(nm,"CIRCLE")==0)
   {
	for (int j = c1->length();j>=2; j--)
	{
	  AddCoor((TVariable*)c1->Part(j),1);
	}
   }
   else if (strcmp(nm,"ON")==0)
   {
     AddCoor((TVariable*)c1->Part(2),2);
   }
   else if (strcmp(nm,"CONSTANT")) //INTER, MIDP, FOOT, CIRCUM
   { AddCoor((TVariable*)c1->Part(2),3); }
  }
  
  ptset= ptset->Inverse();
  if (ptset->length()>4)
  { 
    TBigInt *p1 = new TBigInt(0);
	TList *l1 = new TList();
	l1->append((TAtom*)p1);
	p1 = new TBigInt(0);
	l1->append((TAtom*)p1);
    c1 = ptset->replace(2,(TAtom*)l1);
	delete l1;
	delete ptset;

	c2 = (TList*)c1->Part(4);
    p1 = new TBigInt(0);
    l1 = c2->replace(1,(TAtom*)p1);
    ptset = c1->replace(4,(TAtom*)l1);
	//delete p1;
	//delete c2;
	//delete l1;
	//delete c1;
  }
}

void GEOMETRY::AddCoor(TVariable *vn, int k)
{ char tx[10];
  TVariable *x, *y;
  TList *vs;
  char *nm = vn->GetName();

   switch(k)
   {
   case 1:
     sprintf(tx,"v_%s",nm);
     y = GenVar(tx);
	 sprintf(tx,"u_%s",nm);
     x = GenVar(tx);
	 pvars->append((TAtom*) y);
     pvars->append((TAtom*) x);
	 break;
   case 2:
     sprintf(tx,"y_%s",nm);
     y = GenVar(tx);
     sprintf(tx,"x_%s",nm);
     x = GenVar(tx);
	 mvars->append((TAtom*) y);
     mvars->append((TAtom*) x);
	 break;
   case 3:
     sprintf(tx,"y_%s",nm);
     y = GenVar(tx);
     sprintf(tx,"x_%s",nm);
     x = GenVar(tx);
	 mvars->append((TAtom*) y);
     mvars->append((TAtom*) x);
	 break;
   }
  vs = new TList((TAtom*) x,(TAtom*) y);
  ptset->append((TAtom*)vs);
  ptset->append((TAtom*) vn);
}

//Genrate predicate form of CS
TList*GEOMETRY::Cs2Pd(TList *cs)
{
  TAtom *p1,*p2,*p3,*p4;
  TList *c1;
  char *nm;
  TVariable *c0, *pt;
  TList *p, *pdl = new TList();

  int n = cs->length();
  for(int i=1;i<=n;i++)
  {
   c1 = (TList *) cs->Part(i);
   //G_OUT("t",c1);
   if (!iscons(c1)) { pdl->append((TAtom*)c1);  }
   else
   {
     pt = (TVariable*)c1->Part(2);
	 p1 = c1->Part(3);
	 p2 = c1->Part(4);
	 p3 = c1->Part(5);
	 p4 = c1->Part(6);

	 c0 = (TVariable*)c1->Part(1);
	 nm = c0->GetName();
	 if (strcmp(nm,"ON")==0)
	 { p = GetPd((TVariable*)c1->Part(2),(TList*)c1->Part(3));
		if (p) pdl->append((TAtom*)p);
	 }
	else if (strcmp(nm,"INTER")==0) 
	{ p = GetPd((TVariable*)c1->Part(2),(TList*)c1->Part(3));
	  if (p) pdl->append((TAtom*)p);
	  p = GetPd((TVariable*)c1->Part(2),(TList*)c1->Part(4));
	  pdl->append((TAtom*)p);
    }
    else if (strcmp(nm,"MIDPOINT")==0) 
    {
 	 pdl->append((TAtom*)GenPd("midx",pt,(TVariable*)p1,(TVariable*)p2,0,0,0));
	 pdl->append((TAtom*)GenPd("midy",pt,(TVariable*)p1,(TVariable*)p2,0,0,0));
   }
   else if (strcmp(nm,"REF")==0) 
   {
	 pdl->append((TAtom*)GenPd("midx",(TVariable*)p1,pt,(TVariable*)p2,0,0,0));
	 pdl->append((TAtom*)GenPd("midy",(TVariable*)p1,pt,(TVariable*)p2,0,0,0));
   }
   else if (strcmp(nm,"FOOT")==0) 
   {
	 pdl->append((TAtom*)GenPd("coll",pt,(TVariable*)p2,(TVariable*)p3,0,0,0));
	 pdl->append((TAtom*)GenPd("perp",pt,(TVariable*)p1,(TVariable*)p2,(TVariable*)p3,0,0));
   }
   else if (strcmp(nm,"CIRCUMCENTER")==0) 
   {
	 pdl->append((TAtom*)GenPd("cong",pt,(TVariable*)p1,pt,(TVariable*)p2,0,0));
	 pdl->append((TAtom*)GenPd("cong",pt,(TVariable*)p1,pt,(TVariable*)p3,0,0));
   }
   else if (strcmp(nm,"INCENTER")==0) 
   {
	 pdl->append((TAtom*)GenPd("acong",
		 (TVariable*)p2,(TVariable*)p1,(TVariable*)p3,
		 (TVariable*)p3,(TVariable*)p1,pt));
	 pdl->append((TAtom*)GenPd("acong",
		 (TVariable*)p1,(TVariable*)p2,(TVariable*)p3,
		 (TVariable*)p3,(TVariable*)p2,pt));
   }
   else if (strcmp(nm,"EQ_POINT")==0) 
   {
	 pdl->append((TAtom*)GenPd("eqx",pt,(TVariable*)p1,0,0,0,0));
	 pdl->append((TAtom*)GenPd("eqy",pt,(TVariable*)p1,0,0,0,0));
   }
   else 
   { pdl->append((TAtom*)c1); }
   }
  }
  return pdl;
}

TList * GEOMETRY::GenPd(char *nm,TVariable* p1,TVariable* p2,TVariable* p3,
						         TVariable* p4,TVariable* p5,TVariable* p6)
{
  TList *p = new TList();
  p->append((TAtom*)GenVar(nm));
  p->append((TAtom*)p1);
  if (p2) p->append((TAtom*)p2);
  if (p3) p->append((TAtom*)p3);
  if (p4) p->append((TAtom*)p4);
  if (p5) p->append((TAtom*)p5);
  if (p6) p->append((TAtom*)p6);
  return p;
}

TList * GEOMETRY::GetPd(TVariable* v, TList* c)
{
  
  char *nm, tx[10];
  TVariable *c0, *v1;
  TList *p =0;

  c0 = (TVariable*)c->Part(1);
  nm = c0->GetName();
  if (strcmp(nm,"LINE")==0)
  {  
	  v1 = GenVar("coll");
      p = new TList((TAtom*)v1,(TAtom*)v,(TAtom*)c->Part(2),(TAtom*)c->Part(3));
  }
  else if (strcmp(nm,"PLINE")==0)
  { 
	  v1 = GenVar("para");
      p = new TList((TAtom*)v1,(TAtom*)v,(TAtom*)c->Part(2),
		  (TAtom*)c->Part(3),(TAtom*)c->Part(4));
  }
  else if (strcmp(nm,"TLINE")==0)
  { 
	  v1 = GenVar("perp");
      p = new TList((TAtom*)v1,(TAtom*)v,(TAtom*)c->Part(2),
		  (TAtom*)c->Part(3),(TAtom*)c->Part(4));
  }
  else if (strcmp(nm,"BLINE")==0)
  { 
	 v1= GenVar("cong");
     p = new TList((TAtom*)v1,(TAtom*)v,(TAtom*)c->Part(2),v,(TAtom*)c->Part(3));
  }
  else if (strcmp(nm,"CIR")==0)
  { 
	  v1= GenVar("cong");
      p = new TList((TAtom*)v1,(TAtom*)c->Part(2),(TAtom*)v,
			(TAtom*)c->Part(2),(TAtom*)c->Part(3));
  }
  else 
  { sprintf(tx,"(%s) is not a propero geometric object",nm);
    gerror(0,tx); 
  }
 return p;
}

TList* GEOMETRY::CsNdg(TList *cs)
{
  TAtom *p1,*p2,*p3,*p4;
  TList *c1;
  char *nm;
  TVariable *c0, *pt;
  TList *l, *pdl = new TList();

  int n = cs->length();
  for(int i=1;i<=n;i++)
  {
   c1 = (TList *) cs->Part(i);
   if (!iscons(c1)) return pdl;
  //wout<<"dd:";c1->display(); wout <<"xx"<<endl;
   pt = (TVariable*)c1->Part(2);
   p1 = c1->Part(3);
   p2 = c1->Part(4);
   p3 = c1->Part(5);
   p4 = c1->Part(6);

   c0 = (TVariable*)c1->Part(1);
   nm = c0->GetName();
   if (strcmp(nm,"ON")==0)
   { l = GenNdg((TList*)c1->Part(3),0);
     if (l) pdl->append((TAtom*)l);
   }
   else if (strcmp(nm,"INTER")==0) 
   { l = GenNdg((TList*)c1->Part(3),(TList*)c1->Part(4));
	 if (l) pdl->append((TAtom*)l);
   }
   else if (strcmp(nm,"FOOT")==0) 
   {
	 pdl->append((TAtom*)GenPd("sqdis",(TVariable*)p2,(TVariable*)p3,0,0,0,0));
   }
   else if (strcmp(nm,"CIRCUMCENTER")==0) 
   {
	 pdl->append((TAtom*)GenPd("coll",(TVariable*)p1,(TVariable*)p2,(TVariable*)p3,0,0,0));
   }
   else if (strcmp(nm,"INCENTER")==0) 
   {
	 pdl->append((TAtom*)GenPd("perp",(TVariable*)p1,(TVariable*)p3,(TVariable*)p3,(TVariable*)p2,0,0));
   }
  }
  return pdl;
}

TList * GEOMETRY::GenNdg(TList* o1,TList* o2)
{
  char *nm1, *nm2, tx[10], s1=1,s2=1;
  TVariable *c1, *c2;
  TAtom *p1=0,*p2=0,*p3=0,*p4=0; 
  TList *l=0;

  c1 = (TVariable*)o1->Part(1);
  nm1 = c1->GetName();
  if (strcmp(nm1,"LINE")==0)
  { 
	  p1 = o1->Part(2);
	  p2 = o1->Part(3);
  }
  else if (strcmp(nm1,"PLINE")==0)
  {   
	  p1 = o1->Part(3);
	  p2 = o1->Part(4);
  }
  else if (strcmp(nm1,"TLINE")==0)
  {   s1=-1;
	  p1 = o1->Part(3);
	  p2 = o1->Part(4);
  }
  else if (strcmp(nm1,"BLINE")==0)
  {   s1=-1;
	  p1 = o1->Part(2);
	  p2 = o1->Part(3);
  }
  else if (strcmp(nm1,"CIR")==0)
  {   s1=0;
	  p1 = o1->Part(2);
	  p2 = o1->Part(3);
  }
  else 
  { sprintf(tx,"(%s) is not a propero geometric object (GetNdg)",nm1);
    gerror(0,tx); 
    return (l);
  }

  if (!o2) //ON-construction
  {
    if (s1 && p1) l = new TList((TAtom*)GenVar("sqdis"),p1,p2);
    return(l);
  }
 c2 = (TVariable*)o2->Part(1);
 nm2 = c2->GetName();
 if (strcmp(nm2,"LINE")==0)
  { 
	  p3 = o2->Part(2);
	  p4 = o2->Part(3);
  }
  else if (strcmp(nm2,"PLINE")==0)
  {   
	  p3 = o2->Part(3);
	  p4 = o2->Part(4);
  }
  else if (strcmp(nm2,"TLINE")==0)
  {   s2=-1;
	  p3 = o2->Part(3);
	  p4 = o2->Part(4);
  }
  else if (strcmp(nm2,"BLINE")==0)
  {   s2=-1;
	  p3 = o2->Part(2);
	  p4 = o2->Part(3);
  }
  else if (strcmp(nm2,"CIR")==0)
  {   s2=0;
	  p3 = o2->Part(2);
	  p4 = o2->Part(3);
  }
  else 
  { sprintf(tx,"(%s) is not a propero geometric object (GetNdg)",nm2);
    gerror(0,tx); 
    return (l);
  }

  if (s1 && s2 && p1 && p3)
  { 
	if((s1*s2)>0) l = new TList((TAtom*)GenVar("para"),p1,p2,p3,p4);
	else l = new TList((TAtom*)GenVar("perp"),p1,p2,p3,p4);
	return(l);
  }
  if (s1 && s2 && p1) l = new TList((TAtom*)GenVar("sqdis"),p1,p2);
  if (s1 && s2 && p3) l = new TList((TAtom*)GenVar("sqdis"),p3,p4);
  if (s1 && s2)  return l;
  if (!s1 && !s2)  l = new TList((TAtom*)GenVar("sqdis"),p1,p3);
  if (!s1)   l = new TList((TAtom*)GenVar("sqdis"),p3,p4);
  if (!s2)   l = new TList((TAtom*)GenVar("sqdis"),p1,p2);
  return 0;
}


TList *GEOMETRY::AllPts()
{
	TList *c1, *l1, *ps = new TList();
	VAR *v1;
	char *nm;
	int k;

	for(TListNode * tmp=FIRSTNODE(pred_set);tmp;RNEXT(tmp))
	{
		c1 = TL(DATA(tmp));  // predicate
		v1 = (TVariable*)(FIRST(c1));
		nm = v1->GetName();
		k = GetFunctionNumber(nm);
		if ( (k>=0) && (k<=19)) 
		{  l1 = c1->Rest();
			ps->gunion(l1);
			delete l1;
		}
		else if ( (k>=20) && (k<=26)) 
		{
			l1 = c1->Rest();
			TListNode * a1 = l1->last();
			l1->dremove(a1);
			ps->gunion(l1);
			delete l1;
		}
	}
	return ps;
}

TList *geom_sysfun(TAtom *e1,int ftype) 
{ 
  GEOMETRY *g=0;
  qerror = false;

  if (ftype==41)
  {
    g = new GEOMETRY(); 
	g->init_scurve(true); 
    return g->AlgForm();
  }
 
   if   (e1->TypeID() == ListType) 
   {  
	  if (ftype==SCURVE) g = new GEOMETRY((TList *) e1,SCURVE); 
	  else g = new GEOMETRY((TList *) e1); 
   }
   else if(e1->TypeID() == Strings) 
   {  g = new GEOMETRY(((TString*)e1)->GetStr()); }
   else
   {
     wout <<"Error! First parameter should be a polynomial set or a string\n";
	 goto tout;
   }

   if (qerror) goto tout;
   switch(ftype)
   {
   case 1:
	   g->wu_prove(1);
	break;
   case 2:
	   return (g->wu_prove(2));
	 break;
   case 3:
	   g->wuc_prove();
	break;
   case 4:
	   area_prove(g);
	break;

   case 10:
	   /*{ TList *l = g->AlgForm();
	     l = l->Clone();
		 return l;
	   }*/
	   return g->AlgForm();
	break;
   case 11: //cs
	   return g->CsForm();
	break;
   case 12: //pd
	   return g->PdForm();
	break;
   case 13: //ndg
	   return g->deg_set;
   case SCURVE:
	   g->wu_prove(3);
	break;
   case 30:
	   g->wu_prove(3);
	break;
   }
 tout:

   if (g) delete g;
   return new TList();
}

//
TList *Gen_Equation(TAtom *e1,int ftype) 
{ 
  GEOMETRY *g=0;
  qerror = false;
  TList *p, *ps, *hyp_list = new TList();
  TVariable *v1;
  

  v1 = GenVar("coll");
  p = new TList((TAtom*)v1,TA(GenVar("P1")),TA(GenVar("P2")),TA(GenVar("P3")));
  hyp_list->append(TA(p));
  

  TList *geom_stat = new TList(TA(new TList()),TA(new TList()),
           TA(new TList()),TA(hyp_list),TA(new TList()),TA(new TList()));
  
  g = new GEOMETRY(geom_stat); 

  ps = g->pset;
  if (g) delete g;
  return ps;
}


//end of file

