#include "geometry.h"


static ELIM radius_e;

ELIM *rcir (VAR* a,VAR* b,VAR* c)
{
  radius_e.v = GenVar("x");
  radius_e.p1 = ptimes3(trim_g(a,b,b,a),trim_g(a,c,c,a),trim_g(b,c,c,b));
  radius_e.p2 = ptimes3(get_n(64L),trim_a(a,b,c,c),trim_a(a,b,c,c));
  return(&radius_e);
}

ELIM *pe_v_cent (VAR *var,VAR* y,VAR* a,VAR* b,VAR* c)
{ VAR* n;
  POLY *p;
  int nm = var->GetFuncId();

  if (nm == 2 ||
		(nm==3 && var->GetPt(0) == y && var->GetPt(1) != y) || nm == 4)
	 { return(mk_elim(var,pplus(geval(var,y,a),
					 pplus(geval(var,y,b),geval(var,y,c))), get_n(3)));
	 }
  else if (nm==3 && var->GetPt(1) == y && var->GetPt(2) == y)
	 {  p = pplus(geval(var,y,a),pplus(geval(var,y,b),geval(var,y,c)));
		p = ptimes(get_n(3),p);
		p = pplus(p,pplus3(trim_g(a,a,b,b),trim_g(a,a,c,c),trim_g(b,b,c,c)));
		return(mk_elim(var,p,get_n(9)));
	 }
  else if (nm ==1)
	 { if (var->GetPt(0) == y && var->GetPt(2) == y)
	{ if (xcoll(c,y,var->GetPt(1))) { n=c;c=b;b=n; }
	  if (xcoll(c,y,var->GetPt(1))) { n=c;c=a;a=n; }
	  return(mk_elim(var,
			 pplus(trim_a(a,a,c,var->GetPt(1)),trim_a(b,b,c,var->GetPt(1))),
			 pplus(trim_a(a,a,c,var->GetPt(3)),trim_a(b,b,c,var->GetPt(3)))));
	}
		else if (var->GetPt(0) == y)
	{ return(mk_elim(var,
			 pplus(trim_a(a,a,c,var->GetPt(1)),trim_a(b,b,c,var->GetPt(1))),
			 ptimes(get_n(3L),trim_a(c,c,var->GetPt(2),var->GetPt(3)))));
	}
		else if (var->GetPt(2) == y)
	{ return(mk_elim(var,
			 ptimes(get_n(3),trim_a(c,c,var->GetPt(0),var->GetPt(1))),
			 pplus(trim_a(a,a,c,var->GetPt(3)),trim_a(b,b,c,var->GetPt(3)))));
	}
  }
  gerror(0,"pe_v_cent"); return (NULL);
}


ELIM *orth_md (VAR *var,VAR* y,VAR* a,VAR* b,VAR* c)
{ return(mk_elim(var,
		 pplus3(ptimes3(geval(var,y,a),trim_g(a,b,b,c),trim_g(a,c,c,b)),
				  ptimes3(geval(var,y,b),trim_g(b,a,a,c),trim_g(b,c,c,a)),
				  ptimes3(geval(var,y,c),trim_g(c,a,a,b),trim_g(c,b,b,a))),
		 ptimes3(get_n(16L),trim_a(a,b,c,c),trim_a(a,b,c,c))));
}

/*
ELIM *pe_r_orth (var,n1,n2,n3,n4,y,a,b,c)
VAR *var;
VAR* n1,n2,n3,n4,y,a,b,c;
{ gerror("pe_r_orth"); return(NULL);}

*/

ELIM *pe_a_orth (VAR *var,VAR* n1,VAR* n2,VAR* n3,VAR* n4,VAR* y,VAR* a,VAR* b,VAR* c)
{ if (n1!= y) gerror(0,"pe_a_orth");
  if      (xperp(n2,n4,a,b)) return(mk_elim(var,trim_a(c,n2,n3,n4),get_n(1L)));
  else if (xperp(n2,n4,a,c)) return(mk_elim(var,trim_a(b,n2,n3,n4),get_n(1L)));
  else if (xperp(n2,n4,b,c)) return(mk_elim(var,trim_a(a,n2,n3,n4),get_n(1L)));
  else return(orth_md(var,y,a,b,c));
}

ELIM *pe_g_orth (VAR *var,VAR* n1,VAR* n2,VAR* n3,VAR* n4,VAR* y,VAR* a,VAR* b,VAR* c)
{ ELIM *e1,*rr;
  VAR* n;
  POLY *r1,*r2,*r3,*r4;

  if (n1==y && n2!=y)
	 { if      (xpara(n2,n4,a,b)) e1=mk_elim(var,trim_g(c,n2,n3,n4),get_n(1L));
		else if (xpara(n2,n4,a,c)) e1=mk_elim(var,trim_g(b,n2,n3,n4),get_n(1L));
		else if (xpara(n2,n4,b,c)) e1=mk_elim(var,trim_g(a,n2,n3,n4),get_n(1L));
		else e1 = orth_md(var,y,a,b,c);
	 }
  else if (n2==y && n3==y)
	 { if (n1==n4 && (n1==a || n1==b || n1==c))
		{ if (n1==b) {n=a;a=b;b=n;}
		  if (n1==c) {n=a;a=c;c=n;}
		  e1=mk_elim(var,
			  ptimes3(trim_g(b,b,c,c),trim_g(b,a,a,c),trim_g(b,a,a,c)),
			  ptimes3(get_n(-16L),trim_a(a,b,c,c),trim_a(a,b,c,c)));
		}
		else if (n1==n4 && xcir3(n1,a,b,c))
		{ rr = rcir(a,b,c);
		  e1 = mk_elim(var,
				 pplus4(ptimes(get_n(9L),rr->p1),
						  ptimes(trim_g(a,a,b,b),cp_poly(rr->p2)),
						  ptimes(trim_g(b,b,c,c),cp_poly(rr->p2)),
						  ptimes(trim_g(a,a,c,c),cp_poly(rr->p2))),
				 rr->p2);
		}
		else if ((n1==a || n1==b || n1==c) && (n4==a || n4==b || n4==c))
		{ e1=mk_elim(var,
			  ptimes3(trim_g(a,b,b,c),trim_g(a,c,c,b),trim_g(b,a,a,c)),
			  ptimes3(get_n(-16L),trim_a(a,b,c,c),trim_a(a,b,c,c)));
		}
		else
	{ r1=ptimes(trim_g(c,b,b,a),trim_g(c,a,a,b));
	  r2=ptimes(trim_g(b,a,a,c),trim_g(b,c,c,a));
	  r3=ptimes(trim_g(a,b,b,c),trim_g(a,c,c,b));
	  r4=ptimes3(get_n(16L),trim_a(a,b,c,c),trim_a(a,b,c,c));
	  e1=mk_elim(var,pplus(pplus3(ptimes3(cp_poly(r1),cp_poly(r3),trim_g(a,a,c,c)),
											ptimes3(cp_poly(r2),cp_poly(r3),trim_g(a,a,b,b)),
											ptimes3(cp_poly(r1),cp_poly(r2),trim_g(b,b,c,c))),
								  pplus3(ptimes3(cp_poly(r1),cp_poly(r4),trim_g(n1,c,c,n4)),
											ptimes3(cp_poly(r2),cp_poly(r4),trim_g(n1,b,b,n4)),
											ptimes3(cp_poly(r3),cp_poly(r4),trim_g(n1,a,a,n4)))),
					 ptimes(cp_poly(r4),cp_poly(r4)));
	}
  }
  else gerror(0,"pe_g_orth");
  return(e1);
}


ELIM *circum_md (VAR *var,VAR* y,VAR* a,VAR* b,VAR* c)
{ return(mk_elim(var,
		 pplus3(ptimes3(geval(var,y,a),trim_g(b,c,c,b),trim_g(b,a,a,c)),
			ptimes3(geval(var,y,b),trim_g(a,c,c,a),trim_g(a,b,b,c)),
			ptimes3(geval(var,y,c),trim_g(a,b,b,a),trim_g(a,c,c,b))),
		 ptimes3(get_n(32L),trim_a(a,b,c,c),trim_a(a,b,c,c))));
}

ELIM *pe_a_circum (VAR *var,VAR* n1,VAR* n2,VAR* n3,VAR* n4,VAR* y,VAR* a,VAR* b,VAR* c)
{ VAR* n;
  if (xperp(n2,n4,b,c)) {n=a;a=c;c=n;}
  if (xperp(n2,n4,a,c)) {n=b;b=c;c=n;}
  if (xperp(n2,n4,a,b))
	 return(mk_elim(var,pplus(trim_a(a,n2,n3,n4),trim_a(b,n2,n3,n4)),get_n(2L)));
  if (n3==n4 && (xcir5(y,n2,n3,a,b,c)))
		{ if (a!=n2 && a!=n3) n=a;
		  else if (b!=n2 && b!=n3) n=b;
	else n=c;
	return(mk_elim(var,
				 ptimes(trim_g(n2,n3,n3,n2),trim_g(n2,n,n,n3)),
				 ptimes(get_n(32L),trim_a(n,n2,n3,n4))));
		}
  return(circum_md(var,y,a,b,c));
}

ELIM *pe_g_circum (VAR *var,VAR* n1,VAR* n2,VAR* n3,VAR* n4,VAR* y,VAR* a,VAR* b,VAR* c)
{ ELIM *e1;
  POLY *r1,*r2,*r3,*r4;

  if (n1==y && n2!=y)
	 { if (xcir2(y,n2,n4))
	{ e1 = mk_elim(var,pplus(trim_g(n2,n2,n3,n4),trim_g(n4,n2,n3,n4)),get_n(2L));
	}
		else e1 = circum_md(var,y,a,b,c);
	 }
  else if (n2==y && n3==y)
	 { if (n1==n4 && xcir4(y,n1,a,b,c))
		{ e1 = rcir(a,b,c);
		  e1 = mk_elim(var,e1->p1,e1->p2);
		}
		else if (xcir5(y,n1,n4,a,b,c))
		{ r1= ptimes3(trim_g(a,b,b,a),trim_g(a,c,c,a),trim_g(b,c,c,b));
		  r2= ptimes3(get_n(64L),trim_a(a,b,c,c),trim_a(a,b,c,c));
		  e1 = mk_elim(var,
				 pplus(ptimes(get_n(2L),r1),
						 ptimes(trim_g(n1,n1,n4,n4),r2)),
				 ptimes(get_n(2L),cp_poly(r2)));
		}
		else
		{ r1=ptimes(trim_g(a,b,b,a),trim_g(a,c,c,b));
		  r2=ptimes(trim_g(a,c,c,a),trim_g(a,b,b,c));
		  r3=ptimes(trim_g(b,c,c,b),trim_g(b,a,a,c));
		  r4=ptimes3(get_n(32L),trim_a(a,b,c,c),trim_a(a,b,c,c));
		  e1=mk_elim(var,
			  pplus(pplus3(ptimes3(cp_poly(r1),cp_poly(r3),trim_g(a,a,c,c)),
								ptimes3(cp_poly(r2),cp_poly(r3),trim_g(a,a,b,b)),
								ptimes3(cp_poly(r1),cp_poly(r2),trim_g(b,b,c,c))),
					  pplus3(ptimes3(cp_poly(r1),cp_poly(r4),trim_g(n3,c,c,n4)),
								ptimes3(cp_poly(r2),cp_poly(r4),trim_g(n3,b,b,n4)),
							  ptimes3(cp_poly(r3),cp_poly(r4),trim_g(n3,a,a,n4)))),
					  ptimes(cp_poly(r4),cp_poly(r4)));
	}
	 }
  else gerror(0,"pe-g-circum2");
  return(e1);
}


ELIM *pe_r_circum (VAR *var,VAR* n1,VAR* n2,VAR* d1,VAR* d2,VAR* y,
				   VAR* a, VAR* b, VAR* c)
{  VAR* a1=0, * b1=0, * c1=0;

	if ( a==n1 || a==n2 || a==d1 || a==d2) a1=a;
	if ( b==n1 || b==n2 || b==d1 || b==d2) b1=b; 
	if ( c==n1 || c==n2 || c==d1 || c==d2) c1=c;
	if (c1&&!a1) { a1 = c; b1=b;}
	else if (c1&&!b1) { a1 = c; b1 =a;}
	else { a1=a;b1=b;} 


	if (n2==y)
	 { if (d2==y)
	return(mk_elim(var,
				 pplus(trim_g(n1,a1,a1,b1),trim_g(n1,a1,b1,b1)),
				 pplus(trim_g(d1,a1,a1,b1),trim_g(d1,a1,b1,b1))));
		else
	return(mk_elim(var,
						pplus(trim_g(n1,a1,a1,b1),trim_g(n1,a1,b1,b1)),
						ptimes(get_n(2L),trim_g(d1,a1,d2,b1))));
	 }
  else if (d2==y)
	 return(rev_elim(pe_r_circum(var,d1,d2,n1,n2,y,a,b,c)));
  else gerror(0,"pe-r-circum1");
  return(NULL);
}


ELIM *incent_md (VAR *var,VAR* y,VAR* i,VAR* a,VAR* b)
{ return(mk_elim(var,
		 pplus3(ptimes4(get_n(-2L),geval(var,y,i),trim_g(i,a,a,b),trim_g(i,b,b,a)),
			ptimes3(geval(var,y,a),trim_g(i,a,a,b),trim_g(b,i,i,b)),
			ptimes3(geval(var,y,b),trim_g(i,b,b,a),trim_g(a,i,i,a))),
		 ptimes(trim_g(a,i,i,b),trim_g(a,b,b,a))));
}

ELIM *pe_a_incent (VAR *var,VAR* n1,VAR* n2,VAR* n3,VAR* n4,VAR* y,VAR* i,VAR* a,VAR* b)
{ return(incent_md(var,y,i,a,b)); }

ELIM *pe_g_incent (VAR *var,VAR* n1,VAR* n2,VAR* n3,VAR* n4,VAR* y,VAR* i,VAR* a,VAR* b)
{ ELIM *e1;
  VAR * n;
  int sn;
  POLY *r1,*r2,*r3,*r4,*r5,*r6,*ar;

  sn=1;
  if (n1==y && n2!=y)
	 { if (n3==n4) { n=n2;n2=n4;n4=n; sn=-1; }
		if (n2==n3 && n4==b) { n=a;a=b;b=n; }
		if (n2==n3 && n2==i && n4==a)
	{ e1=mk_elim(var,
			  ptimes4(get_n(16L),trim_g(i,a,a,i),trim_a(i,a,a,b),trim_a(i,a,a,b)),
			  ptimes(trim_g(a,b,b,a),trim_g(a,i,i,b)));
	  if (sn==-1) e1->p1 = neg_TRIPoly(e1->p1);
	}
		else
	e1=incent_md(var,y,i,a,b);
	 }
  else if (n2==y && n3==y)
	 { r1 = trim_g(i,a,a,b);
		r2 = trim_g(i,b,b,a);
		r3 = trim_g(a,i,i,b);
		r4 = trim_g(i,a,a,i);
		r5 = trim_g(i,b,b,i);
		r6 = trim_g(a,b,b,a);
		ar = trim_a(a,i,i,b);
		if (n1==i && n4==i)
		{ e1 = mk_elim(var,
				 ptimes4(ptimes(get_n(16L),r4),r5,ar,cp_poly(ar)),
				 ptimes3(r3,cp_poly(r3),r6));
		  put_p(r1);put_p(r2);
		}
		else if (n1==a && n4==a)
		{ e1 = mk_elim(var,ptimes4(r4,cp_poly(r4),r2,cp_poly(r2)),
								 ptimes4(get_n(1L),r6,r3,cp_poly(r3)));
		  put_p(r1);put_p(r5);
		}
		else if (n1==b && n4==b)
		{ e1 = mk_elim(var,ptimes4(r5,cp_poly(r5),r1,cp_poly(r1)),
								 ptimes4(get_n(1L),r6,r3,cp_poly(r3)));
		  put_p(r2);put_p(r4);
		}
		else if ((n1==a && n4==b) || (n1==b && n4==a))
		{ e1=mk_elim(var,
			  ptimes3(r1,r2,pminus(ptimes(r4,r5),ptimes3(get_n(2L),r3,cp_poly(r3)))),
			  ptimes3(cp_poly(r3),cp_poly(r3),r6));
		}
		else if ((n1==a &&n4==i) || (n1==i && n4==a))
		{ e1 = mk_elim(var,ptimes4(ptimes(get_n(-16L),r4),r2,ar,cp_poly(ar)),
				 ptimes3(r6,r3,cp_poly(r3)));
		  put_p(r1);put_p(r5);
		}
		else if ((n1==b &&n4==i) || (n1==i && n4==b))
		{ e1 = mk_elim(var,ptimes4(ptimes(get_n(16L),r5),r1,ar,cp_poly(ar)),
				 ptimes3(r6,r3,cp_poly(r3)));
		  put_p(r2);put_p(r4);
		}
		else
		{ e1=mk_elim(var,
			  pminus(pplus3(ptimes(ptimes3(get_n(-2L),r1,r2),
										  ptimes3(cp_poly(r1),r5,trim_g(a,i,i,a))),
								ptimes(ptimes3(cp_poly(r1),cp_poly(r5),cp_poly(r2)),
										  ptimes(r4,trim_g(a,b,b,a))),
								ptimes(ptimes3(get_n(-2L),cp_poly(r1),cp_poly(r2)),
										 ptimes3(cp_poly(r2),cp_poly(r4),trim_g(b,i,i,b)))),
				 pplus3(ptimes(ptimes3(get_n(-2L),cp_poly(r1),cp_poly(r2)),
					  ptimes3(r3,r6,trim_g(n1,i,i,n1))), /* check trig_g */
					ptimes(ptimes3(cp_poly(r1),cp_poly(r5),cp_poly(r3)),
					  ptimes(cp_poly(r6),trim_g(n1,a,a,n1))),
					ptimes(ptimes3(cp_poly(r2),cp_poly(r4),cp_poly(r3)),
					  ptimes(cp_poly(r6),trim_g(n1,b,b,n1))))),
			  ptimes4(cp_poly(r3),cp_poly(r3),cp_poly(r6),cp_poly(r6)));
			e1->p1 = neg_TRIPoly(e1->p1);
		}
	 }
  else gerror(0,"pe-g-incent2");

  return(e1);
}


ELIM *pe_r_incent (VAR *var,VAR* n1,VAR* n2,VAR* d1,VAR* d2,VAR* y,VAR* i,VAR* a,VAR* b)
{
  if (n2==y && d2==y)
	 { return(mk_elim(var,
			  pminus(ptimes(get_n(2L),trim_g(n1,a,a,b)),trim_g(a,b,b,a)),
			  pminus(ptimes(get_n(2L),trim_g(d1,a,a,b)),trim_g(a,b,b,a))));
	 }
  else if (n2==y)
	 { return(mk_elim(var,
			  pminus(ptimes(get_n(2L),trim_g(n1,a,a,b)),trim_g(a,b,b,a)),
			  trim_g(d1,a,d2,b)));
	 }
  else if (d2==y)
	 { return(rev_elim(pe_r_incent(var,d1,d2,n1,n2,y,i,a,b))); }
  else gerror(0,"pe_r_incenter");
  return(NULL);
  }


//end of file
