#include "geometry.h"

// destructicve for ratios 

ELIM *lratio_md1 (VAR *var,VAR* y,VAR* u,VAR* v,POLY *p1,POLY *p2,POLY *q1,POLY *q2)
{
  if  (eq_poly(p2,q2))
	 { /*put_p(q2); */
		return(mk_elim(var,pplus(ptimes(geval(var,y,v),p1),
					             ptimes(geval(var,y,u),q1)),p2));
	 }
  else
	 { return(mk_elim(var,pplus(ptimes3(geval(var,y,v),p1,cp_poly(q2)),
					            ptimes3(geval(var,y,u),q1,cp_poly(p2))),
			              ptimes(cp_poly(p2),cp_poly(q2))));
	 }
}

ELIM *lratio_md11 (VAR *var,VAR* y,VAR* u,VAR* v,POLY *p1,POLY *q1,POLY *r)
{
 return(mk_elim(var,pplus(ptimes(geval(var,y,v),p1),ptimes(geval(var,y,u),q1)),r));
}

//
//var = (py a y y c)
//
ELIM *lratio_md2 (VAR *var,VAR* y,VAR* u,VAR* v,POLY *p1,POLY *p2,POLY *q1,POLY *q2)
{
  return(mk_elim(var,
			   pplus3(ptimes(geval(var,y,v), ptimes(cp_poly(p1),cp_poly(q2))),
					  ptimes(geval(var,y,u), ptimes(cp_poly(q1),cp_poly(p2))),
					  ptimes(trim_g(v,v,u,u),ptimes(cp_poly(p1),cp_poly(q1)))),
		       ptimes(cp_poly(p2),cp_poly(q2))));
}


ELIM *pratio_md1 (VAR *var,VAR* y,VAR* w,VAR* u,VAR* v,POLY *p1,POLY *p2)
{

  return(mk_elim(var,
		 pplus(ptimes(geval(var,y,w),cp_poly(p2)),
			   ptimes(cp_poly(p1),geval1(var,y,v,u))),
		 cp_poly(p2)));
}

POLY *geval1(VAR *var,VAR* y,VAR* v,VAR* u)
{
  if (var->GetType() != TFUNCTION) return NULL;

  G_OUT("eval1: var=",var);
  switch(var->GetFuncId())
  {
	 case 2:
       return(trim_a(v,var->GetPt(1),u,var->GetPt(3)));
	 case 3:
       return(trim_g(v,var->GetPt(1),u,var->GetPt(3)));
	 case 4:
	   return(trim_vec(v,u));
	default:
      gerror(var, "should be an area, pyth, or vector");
      return(NULL);
  }
}

/*
	switch (var->nm)
	 {
	 case 2: case -2: return(trim_a(v,var->GetPt(1),u,var->GetPt(3)));
	 case 3: case -3: return(trim_g(v,var->GetPt(1),u,var->GetPt(3)));
	 case 4: case -4: return(trim_vec(v,u));
	 default: printf("geval11\n"); exit(1);
	 }
	 */
 

ELIM *pratio_md2 (VAR *var,VAR* y,VAR* w,VAR* u,VAR* v,POLY *p1,POLY *p2)
{
  return(mk_elim(var,
	 pplus4(ptimes3(geval(var,y,w),cp_poly(p2),cp_poly(p2)),
			  pminus(ptimes3(geval(var,y,v),cp_poly(p1),cp_poly(p2)),
						ptimes3(geval(var,y,u),cp_poly(p1),cp_poly(p2))),
			  ptimes4(get_n(2L),trim_g(w,u,u,v),cp_poly(p1),cp_poly(p2)),
			  ptimes3(trim_g(v,v,u,u),cp_poly(p1),pminus(cp_poly(p2),cp_poly(p1)))),
		 ptimes(cp_poly(p2),cp_poly(p2))));
}


ELIM *pe_v_pratio (VAR *var,VAR* y,VAR* w,VAR* u,VAR* v,POLY *p1,POLY *p2)
{
  //if (print_geo) { printf("pratio: \n"); pprint(p1);pprint(p2);}
  switch(var->GetFuncId())
	 { case 1:
	       return(pe_r_pratio(var,var->GetPt(0),var->GetPt(1),var->GetPt(2),var->GetPt(3),y,w,u,v,p1,p2));
		case 2:
	       return(pe_a_pratio(var,var->GetPt(0),var->GetPt(1),var->GetPt(2),var->GetPt(3),y,w,u,v,p1,p2));
		case 3:
	       return(pe_g_pratio(var,var->GetPt(0),var->GetPt(1),var->GetPt(2),var->GetPt(3),y,w,u,v,p1,p2));
		case 4: //?
	if (w==u)
	  return(lratio_md1(var,y,u,v,p1,p2,pminus(cp_poly(p2),cp_poly(p1)),cp_poly(p2)));
	else
	  return(pratio_md1(var,y,w,u,v,p1,p2));
	default:
	gerror(0, "pe_v_ratio: is not a proper variable.\n");
	
		}
	return(NULL);
		}

ELIM *pe_r_pratio(VAR *var,VAR* n2,VAR* n1,VAR* d2,VAR* d1,VAR* y,VAR* w,VAR* u,VAR* v,POLY *p1,POLY *p2)
{
  //if (print_geo) printf("pe_r_pratio: %d %d %d %d %d %d %d %d\n",n1,n2,d1,d2,y,w,u,v);
  if ((n2 == y) && (d2 == y))
	 { if (xcoll(n1,w,y))
	return(mk_elim(var,
				 pplus(ptimes(cp_poly(p2),trim_r(n1,w,u,v)),cp_poly(p1)),
				 pplus(ptimes(cp_poly(p2),trim_r(d1,w,u,v)),cp_poly(p1))));
	 else if (xcoll(w,u,v))
		return(mk_elim(var,trim_a(n1,n1,u,v),trim_a(d1,d1,u,v)));
	 else return(mk_elim(var,trim_a(n1,u,w,v),trim_a(d1,u,w,v)));
	 }
  else if (n2 == y)
	 { if (xcoll(n1,w,y))
	return(mk_elim(var,
				 pplus(ptimes(cp_poly(p2),trim_r(n1,w,u,v)),cp_poly(p1)),
				 ptimes(cp_poly(p2),trim_r(d1,d2,u,v))));
		else if (xcoll(w,u,v))
	return(mk_elim(var,trim_a(n1,n1,u,v),trim_a(d1,u,d2,v)));
		else return(mk_elim(var,trim_a(n1,u,w,v),trim_a(d1,u,d2,v)));
	 }
  else if (d2 == y)
	 { return(rev_elim(pe_r_pratio(var,d2,d1,n2,n1,y,w,u,v,p1,p2))); }
  else { exit(1); }
  return(NULL);
  }

ELIM *pe_a_pratio(VAR *var,VAR* n1,VAR* n2,VAR* n3,VAR* n4,VAR* y,VAR* w,VAR* u,VAR* v,POLY *p1,POLY *p2)
{ ELIM * e1;

  if (xpara(n2,n4,u,v)) { return(mk_elim(var,trim_a(w,n2,n3,n4),get_n(1L))); }

  if (n3 == n4 && xpara(y,n2,u,v)) {n3=n2;}
  if (xpara(y,n3,u,v))
	 { return(mk_elim(var,ptimes(trim_a(u,n2,v,n4),
				pminus(ptimes(trim_r(n3,w,v,u),cp_poly(p2)),
						 cp_poly(p1))),
			  p2));
	 }

  if ((w == u) && ((p1->var ==0 && p2->var==0)))
	 { e1 = lratio_md1(var,y,u,v,p1,p2,c_pminus(p2,p1),cp_poly(p2)); }
  else e1 = pratio_md1(var,y,w,u,v,p1,p2);
  return(e1);
}

ELIM *pe_g_pratio(VAR *var,VAR* n1,VAR* n2,VAR* n3,VAR* n4,VAR* y,VAR* w,VAR* u,VAR* v,POLY  *p1,POLY *p2)
{ ELIM * e1;
  VAR* n;
  POLY *q1,*q2;
  VAR *v1;

  q1 = get_n(1L); q2 = get_n(1L);
  if (n1 == y && xperp(n2,n4,u,v)) { n1=n2;n2=w; n=n3;n3=n4;n4=n; }
  if (n1 == y && xperp(n2,n4,u,v)) { n1=n2;n2=w; n=n3;n3=n4;n4=n; }

  if (n2 == y && xpara(n2,n4,u,v))  { n=n1;n1=n2;n2=n; n=n3;n3=n4;n4=n; }
  if (n1 == y && xpara(n1,n3,u,v))
	 { q1 = ptimes(q1,pminus(ptimes(trim_r(n3,w,v,u),cp_poly(p2)),cp_poly(p1)));
		q2 = ptimes(q2,cp_poly(p2));
		n1=n2;n3=n4;n2=u,n4=v;
	  }
  if (n1 == y && xpara(n1,n3,u,v))
	 { q1 = ptimes(q1,pminus(ptimes(trim_r(n3,w,v,u),cp_poly(p2)),cp_poly(p1)));
		q2 = ptimes(q2,cp_poly(p2));
		n1=n2;n3=n4;n2=u,n4=v;
	  }

  if (n2 == y && n3 == y)
	 { if (w == u)
			 e1 = lratio_md2(var,y,u,v,p1,p2,c_pminus(p2,p1),cp_poly(p2));
		else e1 = pratio_md2(var,y,w,u,v,p1,p2);
	 }
  else if (n1 == y)
	 {   v1 = mk_var(3,n1,n2,n3,n4);
		 if (w == u) e1 = lratio_md1(v1,y,u,v,p1,p2,c_pminus(p2,p1),cp_poly(p2));
		 else e1 = pratio_md1(v1,y,w,u,v,p1,p2);
		 e1->v=var;
	  }
  else { e1 = mk_elim(var,trim_g(n1,n2,n3,n4),get_n(1L)); }

  e1->p1 = ptimes(e1->p1,q1);
  e1->p2 = ptimes(e1->p2,q2);
  return(e1);
}

ELIM *pe_v_ipp(VAR *var,VAR* y,VAR* w,VAR* u,VAR* v,VAR* r,VAR* p,VAR* q)
{ VAR* n;
  if (w==v) { n=u;u=v;v=n; }
  if (r==q) { n=p;p=q;q=n; }
  if (w==u && w>v) { w=v;v=u;u=w; }
  if (r==p && r>q) {r=q;q=p;p=r; }
  if (r > w) { n=w;w=r;r=n; n=u;u=p;p=n; n=v;v=q;q=n; }
  switch(var->GetFuncId())
	{
	case 1:
		return(pe_r_ipp(var,var->GetPt(1),var->GetPt(0),var->GetPt(3),var->GetPt(2),y,w,u,v,r,p,q));
	case 2:
		return(pe_a_ipp(var,var->GetPt(0),var->GetPt(1),var->GetPt(2),var->GetPt(3),y,w,u,v,r,p,q));
	case 3:
		return(pe_g_ipp(var,var->GetPt(0),var->GetPt(1),var->GetPt(2),var->GetPt(3),y,w,u,v,r,p,q));
	case 4: //?
	  if (w==u)
		 return(lratio_md1(var,y,u,v,
						 trim_a(u,p,r,q),trim_a(u,p,v,q),
			 trim_a(v,q,r,p),trim_a(u,p,v,q)));
	  else
	  return(pratio_md1(var,y,w,u,v,trim_a(w,p,r,q),trim_a(u,p,v,q)));
	default:
	gerror(var,"pe_v_ipp:  is not a proper variable.");
	}
	return(NULL);
}

ELIM *pe_r_ipp (VAR *var,VAR* n1,VAR* n2,VAR* d1,VAR* d2,
				VAR* y,VAR* w,VAR* u,VAR* v,
				VAR* r,VAR* p,VAR* q)
{ VAR* n;
  G_OUT("var=",var); 
  G_OUT("n1=",n1);G_OUT("n2=",n2);G_OUT("d1=",d1);G_OUT("d2=",d2);
  if (xpara(n1,n2,u,v)) { n=w;w=r;r=n; n=u;u=p;p=n; n=v;v=q;q=n; }
  if ((n2==y) && d2==y)
	 return(mk_elim(var,trim_a(n1,u,w,v),trim_a(d1,u,w,v)));
  else if (n2 == y)
	 return(mk_elim(var,trim_a(n1,u,w,v),trim_a(d1,u,d2,v)));
  else if (d2 == y)
	 return(mk_elim(var,trim_a(n1,u,n2,v),trim_a(d1,u,w,v)));
  else exit(1);
  return(NULL);
}

ELIM *pe_a_ipp (VAR *var,VAR* n1,VAR* n2,VAR* n3,VAR* n4,
				VAR* y,
				VAR* w,VAR* u,VAR* v,
				VAR* r,VAR* p,VAR* q)
{ VAR* n;

  if (r==n2 || r == n3 || r == n4) { n=w;w=r;r=n; n=u;u=p;p=n; n=v;v=q;q=n; }

  if (xpara(n2,n4,u,v)) { return(mk_elim(var,trim_a(w,n2,n3,n4),get_n(1L))); }
  if (xpara(n2,n4,p,q)) { return(mk_elim(var,trim_a(r,n2,n3,n4),get_n(1L))); }

  if (n3 == n4 && xpara(y,n2,u,v)) {n3=n2;}
  if (xpara(y,n3,u,v))
	 { return(mk_elim(var,ptimes(trim_a(u,n2,v,n4),trim_a(n3,q,r,p)),trim_a(v,q,u,p))); }
  if (n3 == n4 && xpara(y,n2,p,q)) {n3=n2;}
  if (xpara(y,n3,p,q))
	 { return(mk_elim(var,ptimes(trim_a(p,n2,q,n4),trim_a(n3,u,w,v)),trim_a(q,u,p,v))); }

  if (xcoll(w,u,v) && (xpara(u,n3,n2,n4) || xpara(v,n3,n2,n4)))
	 return(lratio_md1(var,y,u,v,
				trim_a(u,p,r,q),trim_a(u,p,v,q),
				trim_a(v,q,r,p),trim_a(u,p,v,q)));
  if (xcoll(r,p,q) && (xpara(p,n3,n2,n4) || xpara(q,n3,n2,n4)))
	 return(lratio_md11(var,y,p,q,
				trim_a(p,u,w,v),
				trim_a(q,v,w,u),trim_a(p,u,q,v)));
  if (w==u)
	 return(lratio_md11(var,y,u,v,
				trim_a(u,p,r,q),trim_a(v,q,r,p),trim_a(u,p,v,q)));
  return(pratio_md1(var,y,w,u,v,trim_a(w,p,r,q),trim_a(u,p,v,q)));
}

ELIM *pe_g_ipp (VAR *var,VAR* n1,VAR* n2,VAR* n3,VAR* n4,VAR* y,
				VAR* w,VAR* u,VAR* v,
				VAR* r,VAR* p,VAR* q)
{ VAR* n;
  VAR *v1;
  ELIM *e1;
  POLY *p1, *p2;

  p1 = get_n(1); p2 = get_n(1);
  if (n1 == y && xperp(n2,n4,u,v)) { n1=n2;n2=w; n=n3;n3=n4;n4=n; }
  else if (n2==y && xperp(n1,n3,u,v)) { n2=w; }
  if (n1 == y && xperp(n2,n4,u,v)) { n1=n2;n2=w; n=n3;n3=n4;n4=n; }
  if (n1 == y && xperp(n2,n4,p,q)) { n1=n2;n2=r; n=n3;n3=n4;n4=n; }
  else   if (n2 == y && xperp(n1,n3,p,q)) { n2=r; }
  if (n1 == y && xperp(n2,n4,p,q)) { n1=n2;n2=r; n=n3;n3=n4;n4=n; }

  if (n2 == y && xpara(n2,n4,u,v)) {n=n1;n1=n2;n2=n; n=n3;n3=n4;n4=n; }
  if (n1 == y && xpara(n1,n3,u,v))
	 { p1 = ptimes(p1,trim_a(n3,p,r,q));
		p2 = ptimes(p2,trim_a(v,p,u,q));
		n1=n2;n3=n4;n2=u,n4=v;
	 }
  if (n1 == y && xpara(n1,n3,u,v))
	 { p1 = ptimes(p1,trim_a(n3,p,r,q));
		p2 = ptimes(p2,trim_a(v,p,u,q));
		n1=n2;n3=n4;n2=u,n4=v;
	 }
  if (n2 == y && xpara(n2,n4,p,q)) {n=n1;n1=n2;n2=n; n=n3;n3=n4;n4=n; }
  if (n1 == y && xpara(n1,n3,p,q))
	 { p1 = ptimes(p1,trim_a(n3,u,w,v));
		p2 = ptimes(p2,trim_a(q,u,p,v));
		n1=n2;n3=n4;n2=p,n4=q;
	 }
  if (n1 == y && xpara(n1,n3,p,q))
	 { p1 = ptimes(p1,trim_a(n3,u,w,v));
		p2 = ptimes(p2,trim_a(q,u,p,v));
		n1=n2;n3=n4;n2=p,n4=q;
	 }

  if (n2 == y && n3 == y)
	 { if (w==u)
		e1 = lratio_md2(var,y,u,v,
			trim_a(u,p,r,q),trim_a(u,p,v,q),
			trim_a(v,q,r,p),trim_a(u,p,v,q));
		else
		e1 = pratio_md2(var,y,w,u,v,trim_a(w,p,r,q),trim_a(u,p,v,q));
	 }
  else if (n1 == y)
	 {  //v1 = mk_var(-3,n1,n2,n3,n4); gao, 2002
	    v1 = mk_var(3,n1,n2,n3,n4);
		if (w==u)
		{ e1 = lratio_md11(v1,y,u,v,
				  trim_a(u,p,r,q),trim_a(v,q,r,p),trim_a(u,p,v,q));
		}
		else
		{ e1 = pratio_md1(v1,y,w,u,v,trim_a(w,p,r,q),trim_a(u,p,v,q)); }
		  e1->v = var;
		 }
  else {  //gerror(var,"is not proper."); return 0; 
          e1 = mk_elim(var,trim_g(n1,n2,n3,n4),get_n(1L)); 
		}

  e1->p1 = ptimes(e1->p1,p1);
  e1->p2 = ptimes(e1->p2,p2);
  return(e1);
}


/* ill ilp */
ELIM *pe_r_ill (VAR *var,VAR* n1,VAR* n2,VAR* d1,VAR* d2,VAR* y,VAR* u,VAR* v,VAR* i,VAR* j)
{ VAR* n0;

  if (n2 == y)
	 { if (xcoll(n1,u,v)) { n0=i;i=u;u=n0; n0=j;j=v;v=n0; }
		if (d2 == y) return(mk_elim(var,trim_a(n1,u,v,v),trim_a(d1,u,v,v)));
		else         return(mk_elim(var,trim_a(n1,u,v,v),trim_a(d1,u,d2,v)));
	 }
  else if (d2 == y)
	 { return(rev_elim(pe_r_ill(var,d1,d2,n1,n2,y,u,v,i,j))); }
  else { exit(1); }
  return(NULL);
  }

ELIM *pe_a_ill (VAR *var,VAR* n1,VAR* n2,VAR* n3,VAR* n4,VAR* y,VAR* u,VAR* v,VAR* i,VAR* j)
{ VAR* n;
  if (aless(v, u)) {n=u;u=v;v=n;}
  if (aless(j, i)) {n=i;i=j;j=n;}
  if (aless(j, v)) {n=u;u=i;i=n; n=v;v=j;j=n;}

  if (xpara(n2,n4,u,v)) { return(mk_elim(var,trim_a(u,n2,n3,n4),get_n(1L))); }
  if (xpara(n2,n4,i,j)) { return(mk_elim(var,trim_a(i,n2,n3,n4),get_n(1L))); }

  if (n3 == n4 && xcoll(u,v,n2)) {n3=n2;}
  if (xcoll(u,v,n3))
	 { return(mk_elim(var,ptimes(trim_a(u,n2,v,n4),trim_a(n3,i,j,j)),trim_a(v,i,u,j))); }
  if (n3 == n4 && xcoll(i,j,n2)) {n3=n2;}
  if (xcoll(i,j,n3))
	 { return(mk_elim(var,ptimes(trim_a(i,n2,j,n4),trim_a(n3,u,v,v)),trim_a(j,u,i,v))); }

  if (xpara(u,n3,n2,n4) || xpara(v,n3,n2,n4))
	 { return(lratio_md1(var,y,u,v,
				 trim_a(u,i,j,j),trim_a(u,i,v,j),
				 trim_a(v,j,i,i),trim_a(u,i,v,j)));
	 }
  if (xpara(i,n3,n2,n4) || xpara(j,n3,n2,n4))
	 { return(lratio_md1(var,y,i,j,
			trim_a(i,u,v,v),trim_a(i,u,j,v),
			trim_a(j,v,u,u),trim_a(i,u,j,v)));
	 }
  return(lratio_md1(var,y,u,v,
			 trim_a(u,i,j,j),trim_a(u,i,v,j),
			 trim_a(v,j,i,i),trim_a(u,i,v,j)));
}

ELIM *pe_g_ill (VAR *var,VAR* n1,VAR* n2,VAR* n3,VAR* n4,VAR* y,VAR* u,VAR* v,VAR* i,VAR* j)
{ VAR* n;
  ELIM *e1;
  POLY *p1, *p2;
  VAR *v1;

  if (aless(v , u)) {n=u;u=v;v=n;}
  if (aless(j , i)) {n=i;i=j;j=n;}
  if (aless(j , v)) {n=u;u=i;i=n; n=v;v=j;j=n;}

  p1 = get_n(1L); p2 = get_n(1L);
  if (n1 == y && xperp(n2,n4,u,v)) { n1=n2;n2=u; n=n3;n3=n4;n4=n; }
  if (n1 == y && xperp(n2,n4,u,v)) { n1=n2;n2=u; n=n3;n3=n4;n4=n; }
  if (n1 == y && xperp(n2,n4,i,j)) { n1=n2;n2=i; n=n3;n3=n4;n4=n; }
  if (n1 == y && xperp(n2,n4,i,j)) { n1=n2;n2=i; n=n3;n3=n4;n4=n; }


  if (n2 == y && xcoll(u,v,n4)) {n=n1;n1=n2;n2=n; n=n3;n3=n4;n4=n; }
  if (n1 == y && xcoll(u,v,n3))
	 { p1 = ptimes(p1,trim_a(n3,i,j,j));
		p2 = ptimes(p2,trim_a(v,i,u,j));
		n1=n2;n3=n4;n2=u,n4=v;
	 }
  if (n1 == y && xcoll(u,v,n3))
	 { p1 = ptimes(p1,trim_a(n3,i,j,j));
		p2 = ptimes(p2,trim_a(v,i,u,j));
		n1=n2;n3=n4;n2=u,n4=v;
	 }

  if (n2 == y && xcoll(i,j,n4)) {n=n1;n1=n2;n2=n; n=n3;n3=n4;n4=n; }
  if (n1 == y && xcoll(i,j,n3))
	 { p1 = ptimes(p1,trim_a(n3,u,v,v));
		p2 = ptimes(p2,trim_a(j,u,i,v));
		n1=n2;n3=n4;n2=i,n4=j;
	 }
  if (n1 == y && xcoll(i,j,n3))
	 { p1 = ptimes(p1,trim_a(n3,u,v,v));
		p2 = ptimes(p2,trim_a(j,u,i,v));
		n1=n2;n3=n4;n2=i,n4=j;
	 }

  if (n2 == y && n3 == y)
	 { e1 = lratio_md2(var,y,u,v,
				trim_a(u,i,j,j),trim_a(u,i,v,j),
				trim_a(v,j,i,i),trim_a(u,i,v,j));
	 }
  else if (n1 == y)
	 { if (n3==i || n3==j || xperp(i,n3,n2,n4) || xperp(j,n3,n2,n4))
	{n=u;u=i;i=n; n=v;v=j;j=n;}
		v1 = mk_var(3,n1,n2,n3,n4);
		e1 = lratio_md1(v1,y,u,v,
				trim_a(u,i,j,j),trim_a(u,i,v,j),
				trim_a(v,j,i,i),trim_a(u,i,v,j));
		e1->v = var;
	 }
  else { e1 = mk_elim(var,trim_g(n1,n2,n3,n4),get_n(1L)); }

  e1->p1 = ptimes(e1->p1,p1);
  e1->p2 = ptimes(e1->p2,p2);
  return(e1);
}


ELIM *pe_vec_ill (VAR *var,VAR* n1,VAR* n2,VAR* y,VAR* u,VAR* v,VAR* i,VAR* j)
{ VAR* n;

  if (aless(v , u)) {n=u;u=v;v=n;}
  if (aless(j , i)) {n=i;i=j;j=n;}
  if (aless(j , v)) {n=u;u=i;i=n; n=v;v=j;j=n;}

  return(lratio_md1(var,y,u,v,
			 trim_a(u,i,j,j),trim_a(u,i,v,j),
			 trim_a(v,j,i,i),trim_a(u,i,v,j)));
}

ELIM *pe_r_ilp (VAR *var,VAR* n1,VAR* n2,VAR* d1,VAR* d2,VAR* y,VAR* u,VAR* v,VAR* r,VAR* p,VAR* q)
{

  if ((n2 == y) && (d2 == y))
	 { if (xcoll(n1,u,v))
	 return(mk_elim(var,trim_a(n1,p,r,q),trim_a(d1,p,r,q)));
	 else return(mk_elim(var,trim_a(n1,u,v,v),trim_a(d1,u,v,v)));
	 }
  if (n2 == y)
	 { if (xcoll(n1,u,v))
	 return(mk_elim(var,trim_a(n1,p,r,q),trim_a(d1,p,d2,q)));
		else if (xcoll(d2,u,v))
	 return(mk_elim(var,trim_a(n1,u,v,v),trim_a(d1,u,v,v)));
		else if (xcoll(d1,u,v))
	 return(mk_elim(var,trim_a(n1,u,v,v),trim_a(d2,v,u,u)));
		else return(mk_elim(var,trim_a(n1,u,v,v),trim_a(d1,u,d2,v)));
	 }
  else if (d2 == y)
	 { return(rev_elim(pe_r_ilp(var,d1,d2,n1,n2,y,u,v,r,p,q))); }
  else { exit(1); }
  return(NULL);
  }

ELIM *pe_a_ilp (VAR *var,VAR* n1,VAR* n2,VAR* n3,VAR* n4,VAR* y,VAR* u,VAR* v,VAR* r,VAR* p,VAR* q)
{ VAR* n;
  if (aless(v , u)) {n=u;u=v;v=n;}
  if (xpara(n2,n4,u,v)) { return(mk_elim(var,trim_a(u,n2,n3,n4),get_n(1L))); }
  if (xpara(n2,n4,p,q)) { return(mk_elim(var,trim_a(r,n2,n3,n4),get_n(1L))); }

  if (n3 == n4 && xcoll(u,v,n2)) {n3=n2;}
  if (xcoll(u,v,n3))
	 { return(mk_elim(var,ptimes(trim_a(u,n2,v,n4),trim_a(n3,p,r,q)),trim_a(v,p,u,q))); }
  if (xpara(u,n3,n2,n4) || xpara(v,n3,n2,n4))
	 { return(lratio_md1(var,y,u,v,
				 trim_a(u,p,r,q),trim_a(u,p,v,q),
				 trim_a(v,q,r,p),trim_a(u,p,v,q)));
	 }

  if (n3 == n4 && xpara(y,n2,p,q)) {n3=n2;}
  if (xpara(y,n3,p,q))
	 { return(mk_elim(var,ptimes(trim_a(p,n2,q,n4),trim_a(n3,u,v,v)),trim_a(q,u,p,v))); }
  return(lratio_md11(var,y,u,v,
			 trim_a(u,p,r,q),
			 trim_a(v,q,r,p),trim_a(u,p,v,q)));
}

ELIM *pe_g_ilp (VAR *var,VAR* n1,VAR* n2,VAR* n3,VAR* n4,VAR* y,VAR* u,VAR* v,VAR* r,VAR* p,VAR* q)
{ VAR* n;
  VAR *v1;
  ELIM *e1;
  POLY *p1, *p2;
  if (aless(v , u)) {n=u;u=v;v=n;}
  p1 = get_n(1L); p2 = get_n(1L);
  if (n1 == y && xperp(n2,n4,u,v)) { n1=n2;n2=u; n=n3;n3=n4;n4=n; }
  if (n1 == y && xperp(n2,n4,u,v)) { n1=n2;n2=u; n=n3;n3=n4;n4=n; }
  if (n1 == y && xperp(n2,n4,p,q)) { n1=n2;n2=r; n=n3;n3=n4;n4=n; }
  if (n1 == y && xperp(n2,n4,p,q)) { n1=n2;n2=r; n=n3;n3=n4;n4=n; }
  if (n1 == y && xcoll(u,v,n3))
	 { p1 = ptimes(p1,trim_a(n3,p,r,q));
		p2 = ptimes(p2,trim_a(v,p,u,q));
		n1=n2;n3=n4;n2=u,n4=v;
	 }
  if (n1 == y && xcoll(u,v,n3))
	 { p1 = ptimes(p1,trim_a(n3,p,r,q));
		p2 = ptimes(p2,trim_a(v,p,u,q));
		n1=n2;n3=n4;n2=u,n4=v;
	 }
  if (n1 == y && xpara(n1,n3,p,q))
	 { p1 = ptimes(p1,trim_a(n3,u,v,v));
		p2 = ptimes(p2,trim_a(q,u,p,v));
		n1=n2;n3=n4;n2=p,n4=q;
	 }
  if (n1 == y && xpara(n1,n3,p,q))
	 { p1 = ptimes(p1,trim_a(n3,u,v,v));
		p2 = ptimes(p2,trim_a(q,u,p,v));
		n1=n2;n3=n4;n2=p,n4=q;
	 }
  if (n2 == y && n3 == y)
	 { e1 = lratio_md2(var,y,u,v,
				trim_a(u,p,r,q),trim_a(u,p,v,q),
				trim_a(v,q,r,p),trim_a(u,p,v,q));
	 }
  else if (n1 == y)
	 { v1 = mk_var(3,n1,n2,n3,n4);
		e1 = lratio_md11(v1,y,u,v,
				trim_a(u,p,r,q),
				trim_a(v,q,r,p),trim_a(u,p,v,q));
		e1->v = var;
	 }
  else { e1 = mk_elim(var,trim_g(n1,n2,n3,n4),get_n(1L)); }

  e1->p1 = ptimes(e1->p1,p1);
  e1->p2 = ptimes(e1->p2,p2);
  return(e1);
}

// end of file
