
#include "geometry.h"

void ELIM::display()
{

  wout<<"ELIM[";  
  v->display(); 
  wout<<",";  
  p1->display(); 
  wout<<",";  
  p2->display(); 
  wout<<"]"<<endl; 
}

ELIM *rev_elim(ELIM *v)
{ POLY *p;
  p = v->p1; v->p1 = v->p2; v->p2 = p;
  return(v);
}

void GR::display()
{
  wout<<"GR[";  
  c1.display(); 
  wout<<",";  
  ps_display(ps1); 
  wout<<",";  
  c2.display(); 
  wout<<",";  
  ps_display(ps2); 
  wout<<"]"<<endl; 
}

void put_gr(GR *gr)
{ POLS *ps, *ps1;
  ps = gr->ps1;
  while(ps!=NULL) { ps1=ps; ps=ps->nx; put_p(ps1->p); put_d(ps1); }
  ps = gr->ps2;
  while(ps!=NULL) { ps1=ps; ps=ps->nx; put_p(ps1->p); put_d(ps1); }
  if (gr->c ==-1)
	 { ps = gr->u.ps;
		while(ps!=NULL) { ps1=ps; ps=ps->nx; put_p(ps1->p); put_d(ps1); }
	 }
  else if (gr->c >0)
	 { ELIM *el, *e1;
		el = gr->u.el;
		while(el!=NULL)
	{ put_p(el->p1); put_p(el->p2);
	  e1 = el; el=el->nx;
	  free((ELIM *)e1);
	}
	 }
  free((GR *)gr);
}

GR* cp_gr(GR *gr)
{ GR *gr1 = mk_gr(gr->c1,gr->ps1,gr->c2,gr->ps2,gr->c,gr->nx);
  if (gr->c == 0) gr1->u.ps = gr->u.ps;
  else            gr1->u.el = gr->u.el;
  return(gr1);
}

GR *mk_gr(NUM c1,POLS *ps1,NUM c2,POLS *ps2, int c,GR *nx)
{
	return new GR(c1,ps1,c2,ps2,c,nx);
	/*GR *gr=(GR *)calloc(1,sizeof(GR));
  gr->c1 = c1; gr->c2 = c2;
  gr->ps1 = ps1; gr->ps2 = ps2;
  gr->c = c;
  gr->nx = nx;
  return(gr);
*/
}

GR *mk_gr1(NUM c1,POLY *p1,NUM c2,POLY *p2)
{ GR *gr = new GR(c1,0,c2,0,0,0);
  if (p1 == NULL) gr->ps1 = NULL;
  else            gr->ps1 = get_dt(1,p1,NULL);
  if (p2 == NULL) gr->ps2 = NULL;
  else            gr->ps2 = get_dt(1,p2,NULL);
  gr->c = 0;
  gr->u.ps = NULL;
  return(gr);
}

int gr_length(GR *gr)
{ POLS *ps;
  int k, m=0;
  for(ps = gr->ps1; ps!=NULL; ps=ps->nx)
	 { k = plength(ps->p); if (k > m) m = k; }
  for(ps = gr->ps2; ps!=NULL; ps=ps->nx)
	 { k = plength(ps->p); if (k > m) m = k; }
  return(m);
}



/* simplification  */

GR *simp_gr(GR *gr)
{ POLS *ps0,*ps1,*ps2,*ps3;
  POLSPT ps_d1, ps_d2;
  POLY *p1,*p2;
  GR *gr0;

  if (num_zop(gr->c1) && num_zop(gr->c2)) return (NULL);

  ps1 = ps_simp(cp_TDITerm(gr->ps1));
  wout << "ps1:"; ps_display(ps1);
  ps2 = ps_simp(cp_TDITerm(gr->ps2));
  wout << "ps2:"; ps_display(ps2);

  ps0 = NULL;
  if ((num_zop(gr->c1) || pzerop(ps1->p)) &&
	  (num_zop(gr->c2) || pzerop(ps2->p)))
	 { put_ps(ps1); put_ps(ps2);
		gr0 = mk_gr(mk_num(0),NULL,mk_num(0),NULL,-2,NULL);
		gr0->u.ps = NULL;
	 }
  else if (num_zop(gr->c1) || pzerop(ps1->p))
	 {  put_ps(ps1);
		gr0 = mk_gr(mk_num(0),NULL,mk_num(1),ps2,-2,NULL);
		gr0->u.ps = NULL;
		if (ps_term1(ps2) <= ps_term1(gr->ps2))
			{ put_ps(ps2); return(NULL); }
	 }
  else if (num_zop(gr->c2) || pzerop(ps2->p))
	 {  put_ps(ps2);
		if (ps_term1(ps1) <= ps_term1(gr->ps1))
		{put_ps(ps1); return(NULL);}
		gr0 = mk_gr(mk_num(1),ps1,mk_num(0),NULL,-2,NULL);
		gr0->u.ps = NULL;
	 }
  else
	 {  ps1 = get_dt(1,get_n(gr->c1),ps1);
		ps2 = get_dt(1,get_n(gr->c2),ps2);
		ps3=ps_div(ps1,ps2, &ps_d1, &ps_d2);
        //wout << "ps3:"; ps_display(ps3);
        ps1 = ps_d1; ps2 = ps_d2;

		if (ps3!=NULL)
		{ 
		  ps0 = ps_append(ps0,ps3);
		}
		ps3=ps_div(ps2,ps1, &ps_d1, &ps_d2);
		//wout << "ps3:"; ps_display(ps3);
        ps1 = ps_d2; ps2 = ps_d1;
		if (ps3!=NULL)
		{ 
		  ps0 = ps_append(ps0,ps3);
		}
		if (ps0==NULL) { put_ps(ps1); put_ps(ps2);  return(NULL); }
		p1=ps1->p; p2=ps2->p;
		gr0 = mk_gr(p1->c,ps1->nx,p2->c,ps2->nx,-1,NULL);
		gr0->u.ps = ps0;
	 }
 
  return(gr0);
}





/* */


void free_mem() 
{ 
	free_proof(); 
//	free_all_vars(); 
}

void free_proof ()
{ GR *gr, *g1;
  ELIM *el,*e1;
  gr = proof.nx;
  while (gr!=NULL)
	 { put_ps(gr->ps1); put_ps(gr->ps2);
		if (gr->c == 0) { }
		else if (gr->c == -1) { put_ps(gr->u.ps); }
		else { 
			el=gr->u.el;
		    while (el!=NULL)
			 { // printf("000\n");print_elim(el);printf("\n"); 
				put_p(el->p1); put_p(el->p2);
				e1=el; el=el->nx;
				free((ELIM *)e1);
			}
		}
		g1=gr; gr=gr->nx;
		free((GR *)g1);
	 }
}

