#include "geometry.h"


ELIM *tratio_a_md1 (VAR *var,VAR * y,VAR * w,VAR * u,VAR * v,POLY *p1,POLY *p2)
{ return(mk_elim(var,
		 pplus(ptimes3(get_n(4L),cp_poly(p2),geval(var,y,w)),
				 ptimes(cp_poly(p1),trim_g(v,var->GetPt(1),u,var->GetPt(3)))),
		 ptimes(get_n(4L),cp_poly(p2))));
}

ELIM *tratio_g_md1 (VAR *var,VAR * y,VAR * w,VAR * u,VAR * v,POLY *p1,POLY *p2)
{
  return(mk_elim(var,
		 pplus(ptimes(cp_poly(p2),geval(var,y,w)),
				 ptimes3(get_n(4L),cp_poly(p1),trim_a(u,var->GetPt(1),v,var->GetPt(3)))),
		 cp_poly(p2)));
}

ELIM *tratio_md2 (VAR *var,VAR * n3,VAR * n4,VAR * y,VAR * w,VAR * u,VAR * v,POLY *p1,POLY *p2)
{ return(mk_elim(var,
			pplus3(ptimes3(cp_poly(p2),cp_poly(p2),geval(var,y,w)),
					 ptimes4(get_n(-4L),cp_poly(p1),cp_poly(p2),
								pplus(trim_a(n3,u,w,v),trim_a(n4,u,w,v))),
					 ptimes3(cp_poly(p1),cp_poly(p1),trim_g(v,u,u,v))),
			ptimes(cp_poly(p2),cp_poly(p2))));
}

ELIM *pe_v_tratio(VAR *var,VAR * y,VAR * w,VAR * u,VAR * v,POLY *p1,POLY *p2)
{
  switch(var->GetFuncId())
	 {  case 1:
		return(pe_r_tratio(var,var->GetPt(1),var->GetPt(0),var->GetPt(3),var->GetPt(2),y,w,u,v,p1,p2));
		case 2:
		return(pe_a_tratio(var,var->GetPt(0),var->GetPt(1),var->GetPt(2),var->GetPt(3),y,w,u,v,p1,p2));
		case 3:
		return(pe_g_tratio(var,var->GetPt(0),var->GetPt(1),var->GetPt(2),var->GetPt(3),y,w,u,v,p1,p2));
		default:
		
		gerror(var, "pe_v_tratio: is not a proper variable.");
		}
	 return(NULL);
		}

ELIM *pe_r_tratio (VAR *var,VAR * n1,VAR * n2,VAR * n3,VAR * n4,VAR * y,VAR * r,VAR * p,VAR * q,POLY *p1,POLY *p2)
{ if (n2==y && n4== y)
	 { if (xcoll(n1,r,y))
	return(mk_elim(var,
				 pplus(ptimes3(get_n(4L),cp_poly(p2),trim_a(n1,p,r,q)),
				  ptimes(cp_poly(p1),trim_g(p,p,q,q))),
				 pplus(ptimes3(get_n(4L),p2,trim_a(n3,p,r,q)),
				  ptimes(p1,trim_g(p,p,q,q)))));
		else
	return(mk_elim(var,trim_g(n1,p,r,q),trim_g(n3,p,r,q)));
	 }
  else if (n2==y)
	 { if (xcoll(n1,r,y))
	return(mk_elim(var,
				 pplus(ptimes3(get_n(4L),cp_poly(p2),trim_a(n1,p,r,q)),
				  ptimes(cp_poly(p1),trim_g(p,p,q,q))),
				 ptimes3(get_n(4L),p2,trim_a(n3,p,n4,q))));
		else
	return(mk_elim(var,trim_g(n1,p,r,q),trim_g(n3,p,n4,q)));
	 }
  else if (n3==y)
	 { return(rev_elim(pe_r_tratio(var,n3,n4,n1,n2,y,r,p,q,p1,p2))); }
  else gerror(0,"pe_r_taio");
  return(NULL);
}

ELIM *pe_a_tratio (VAR *var,VAR * n1,VAR * n2,VAR * n3,VAR * n4,VAR * y,VAR * w,VAR * u,VAR * v,POLY *p1,POLY *p2)
{
  if (xperp(n2,n4,u,v)) return(mk_elim(var,trim_a(w,n2,n3,n4),get_n(1L)));
  return(tratio_a_md1(var,y,w,u,v,p1,p2));
}

ELIM *pe_g_tratio (VAR *var,VAR * n1,VAR * n2,VAR * n3,VAR * n4,VAR * y,VAR * w,VAR * u,VAR * v,POLY *p1,POLY *p2)
{ ELIM *e;
  if (n1==y && n2!=y)
	 { if (xpara(n2,n4,u,v)) return(mk_elim(var,trim_g(w,n2,n3,n4),get_n(1L)));
		return(tratio_g_md1(var,y,w,u,v,p1,p2));
	 }


  if (n2==y && n3==y)
	 { if (n1==w && n4==w)
			e = mk_elim(var,ptimes3(cp_poly(p1),cp_poly(p1),trim_g(v,u,u,v)),ppower(p2,2));
		else
			e = tratio_md2(var,n1,n4,y,w,u,v,p1,p2);
	 }
  return(e);
}


ELIM *pe_a_itt1(VAR *var,VAR * n1,VAR * n2,VAR * n3,VAR * y,VAR * o,VAR * u,VAR * v)
{ VAR * n;
 if ((n1==u && n2==v) || (n1==v && n2==u))
	 return(mk_elim(var,ptimes(trim_g(o,n1,n1,n2),trim_g(o,n2,n2,n1)),
			ptimes(get_n(-16L),trim_a(n1,n2,o,o))));
  if ((n1==o && n2==v) || (n1==v && n2==o)) {n=u;u=v;v=n;}
  if ((n1==o && n2==u) || (n1==u && n2==o))
	 return(mk_elim(var,ptimes(trim_g(n1,n2,n2,n1),trim_g(n1,v,v,n2)),
			ptimes(get_n(16L),trim_a(n1,n2,v,v))));
  return(NULL);
}

ELIM *pe_a_itt (VAR *var,VAR * n1,VAR * n2,VAR * n3,VAR * n4,VAR * y,VAR * w,VAR * u,VAR * v,VAR * r,VAR * p,VAR * q)
{ VAR * n;
  ELIM *e1;
  if (xperp(n2,n4,u,v)) return(mk_elim(var,trim_a(w,n2,n3,n4),get_n(1L)));
  if (xperp(n2,n4,p,q)) return(mk_elim(var,trim_a(r,n2,n3,n4),get_n(1L)));

  if (w==v) { n=u;u=v;v=n; }
  if (r==q) { n=p;p=q;q=n; }
  if (n3==n4 && w==r && w==u && r==p)
	 { e1 =pe_a_itt1(var,n2,n3,n1,y,w,v,q);
		if (e1!=NULL) return(e1); }

  if (n3==n4 && xcoll(r,n2,n3)) { n3=n2; }
  if (xpara(r,n3,n2,n4))
	 return(tratio_a_md1(var,y,r,p,q,trim_g(r,u,w,v),ptimes(get_n(-4L),trim_a(p,u,q,v))));
	 return(tratio_a_md1(var,y,w,u,v,trim_g(w,p,r,q),ptimes(get_n(-4L),trim_a(u,p,v,q))));
}


ELIM *pe_g_itt1(VAR *var,VAR * n1,VAR * n2,VAR * n3,VAR * y,VAR * o,VAR * u,VAR * v)
{ VAR * n;
  if ((n1==u && n3==v) || (n1==v && n3==u))
	 { return(mk_elim(var,ptimes3(trim_g(u,o,o,v),trim_g(o,u,u,v),trim_g(o,v,v,u)),
			  ptimes3(get_n(-16L),trim_a(o,u,u,v),trim_a(o,u,u,v))));
	 }
  if ((n1==o && n3==v) || (n1==v && n3==o) || (n1==v && n3==v)) {n=u;u=v;v=n;}
  if ((n1==o && n3==u) || (n1==u && n3==o) || (n1==u && n3==u))
	 { return(mk_elim(var,ptimes3(trim_g(u,o,o,u),trim_g(o,v,v,u),trim_g(o,v,v,u)),
			  ptimes3(get_n(16L),trim_a(o,u,u,v),trim_a(o,u,u,v))));
	 }
  if (n1==o && n3==o)
	 { return(mk_elim(var,ptimes3(trim_g(v,o,o,v),trim_g(u,o,o,u),trim_g(v,u,u,v)),
			  ptimes3(get_n(16L),trim_a(o,u,u,v),trim_a(o,u,u,v))));
	 }
  return(NULL);
}

ELIM *pe_g_itt (VAR *var,VAR * n1,VAR * n2,VAR * n3,VAR * n4,VAR * y,VAR * w,VAR * u,VAR * v,VAR * r,VAR * p,VAR * q)
{ ELIM *e1;
  VAR * n;

  if (n1==y)
	 { if (xpara(n2,n4,u,v)) return(mk_elim(var,trim_g(w,n2,n3,n4),get_n(1L)));
		if (xpara(n2,n4,p,q)) return(mk_elim(var,trim_g(r,n2,n3,n4),get_n(1L)));
		if (xperp(r,n3,n2,n4))
		return(tratio_g_md1(var,y,r,p,q,trim_g(r,u,w,v),ptimes(get_n(-4L),trim_a(p,u,q,v))));
		return(tratio_g_md1(var,y,w,u,v,trim_g(w,p,r,q),ptimes(get_n(-4L),trim_a(u,p,v,q))));
	 }
  if (w==v) { n=u;u=v;v=n; }
  if (r==q) { n=p;p=q;q=n; }

  int sn = 1;
//  if (n2==y && n3==y) { n3 = n1; n1 = n2; sn = -1; }


  if (n2==y && n3==y && w==r && w==u && r==p)
	 { return(pe_g_itt1(var,n1,n2,n4,y,w,v,q)); }

  if (n2==y && n3==y)
	 e1=tratio_md2(var,n1,n4,y,w,u,v,trim_g(w,p,r,q),ptimes(get_n(-4L),trim_a(u,p,v,q)));
  else return(NULL);
  return e1;

}

ELIM *pe_v_ipt(VAR *var,VAR * y,VAR * w,VAR * u,VAR * v,VAR * r,VAR * p,VAR * q)
{ VAR * n;
  if (w==v) { n=u;u=v;v=n; }
  if (r==q) { n=p;p=q;q=n; }
  if (w==u && w>v) { w=v;v=u;u=w; }
  switch(var->GetFuncId())
	 {  case 1:
	      return(pe_r_ipt(var,var->GetPt(1),var->GetPt(0),var->GetPt(3),var->GetPt(2),y,w,u,v,r,p,q));

		case 2:
    	  return(pe_a_ipt(var,var->GetPt(0),var->GetPt(1),var->GetPt(2),var->GetPt(3),y,w,u,v,r,p,q));
		case 3:
	      return(pe_g_ipt(var,var->GetPt(0),var->GetPt(1),var->GetPt(2),var->GetPt(3),y,w,u,v,r,p,q));
	    case 4:
		  if (w==u)
		    return(lratio_md1(var,y,u,v,
				 trim_g(u,p,r,q),trim_g(u,p,v,q),
				 trim_g(r,p,v,q),trim_g(u,p,v,q)));
			return(pratio_md1(var,y,w,u,v,trim_g(w,p,r,q),trim_g(u,p,v,q)));
		
		 default: gerror(var, "pe_v_ipt: is not a proper variable");
		}
	 return(NULL);
		}

ELIM *pe_r_ipt (VAR *var,VAR * n1,VAR * n2,VAR * d1,VAR * d2,VAR * y,VAR * w,VAR * u,VAR * v,VAR * r,VAR * p,VAR * q)
{ if (n2==y && d2==y)
	 { if (xcoll(n1,w,y))
	return(mk_elim(var,trim_g(n1,p,r,q),trim_g(d1,p,r,q)));
		else return(mk_elim(var,trim_a(n1,u,w,v),trim_a(d1,u,w,v)));
	 }
  else if (n2 == y)
	 { if (xcoll(n1,w,y))
	return(mk_elim(var,trim_g(n1,p,r,q),trim_g(d1,p,d2,q)));
		else if (xcoll(n2,p,q) && xcoll(d2,p,q))
	{ return(mk_elim(var,trim_a(n1,p,p,q),trim_a(d1,p,p,q))); }
		else if (xcoll(n2,p,q) && d2!=y && xcoll(d1,p,q))
	{ return(mk_elim(var,trim_a(n1,p,p,q),trim_a(d2,q,q,p))); }
		else return(mk_elim(var,trim_a(n1,u,w,v),trim_a(d1,u,d2,v)));
	 }
  else if (d2 == y)
	 { return(rev_elim(pe_r_ipt(var,d1,d2,n1,n2,y,w,u,v,r,p,q))); }
  else exit(1);
  return(NULL);
  }

ELIM *pe_a_ipt (VAR *var,VAR * n1,VAR * n2,VAR * n3,VAR * n4,VAR * y,VAR * w,VAR * u,VAR * v,VAR * r,VAR * p,VAR * q)
{
  if (xpara(n2,n4,u,v)) { return(mk_elim(var,trim_a(w,n2,n3,n4),get_n(1L))); }
  if (xperp(n2,n4,p,q)) { return(mk_elim(var,trim_a(r,n2,n3,n4),get_n(1L))); }

  if (n3 == n4 && xpara(y,n2,u,v)) {n3=n2;}
  if (xpara(y,n3,u,v))
	 { return(mk_elim(var,ptimes(trim_a(u,n2,v,n4),trim_g(n3,q,r,p)),trim_g(v,q,u,p))); }
  if (w==u || (xcoll(y,u,v) && (xpara(u,n3,n2,n4) || xpara(v,n3,n2,n4))))
	 return(lratio_md1(var,y,u,v,
				trim_g(u,p,r,q),trim_g(u,p,v,q),
				trim_g(r,p,v,q),trim_g(u,p,v,q)));
  return(pratio_md1(var,y,w,u,v,trim_g(w,p,r,q),trim_g(u,p,v,q)));
}

ELIM *pe_g_ipt (VAR *var,VAR * n1,VAR * n2,VAR * n3,VAR * n4,VAR * y,VAR * w,VAR * u,VAR * v,VAR * r,VAR * p,VAR * q)
{ VAR * n;
  ELIM *e1;
  POLY *p1, *p2;
  VAR *v1;

//  int sn = 1;
//  if (n2==y && n3==y) { n3 = n1; n1 = n2; sn = -1; }


  if (xcoll(y,p,q) && n2==y && n3==y && n1==r && n4==r)
	 { e1=mk_elim(var,ptimes3(get_n(16L),trim_a(r,p,q,q),trim_a(r,p,q,q)),trim_g(p,q,q,p));
		return e1;
	 }
  p1 = get_n(1L); p2 = get_n(1L);
  if (n1 == y && xperp(n2,n4,u,v)) { n1=n2;n2=w; n=n3;n3=n4;n4=n; }
  else if (n2 == y && xperp(n1,n3,u,v)) { n2=w; }
  if (n1 == y && xperp(n2,n4,u,v)) { n1=n2;n2=w; n=n3;n3=n4;n4=n; }
  else if (n2 == y && xperp(n1,n3,u,v)) { n2=w; }

  if (n1 == y && xpara(n2,n4,p,q)) { n1=n2;n2=r; n=n3;n3=n4;n4=n; }
  else if (n2 == y && xpara(n1,n3,p,q)) { n2 = r; }
  if (n1 == y && xpara(n2,n4,p,q)) { n1=n2;n2=r; n=n3;n3=n4;n4=n; }
  else if (n2 == y && xpara(n1,n3,p,q)) { n2 = r; }


  if (n2 == y && xpara(n2,n4,u,v)) {n=n1;n1=n2;n2=n; n=n3;n3=n4;n4=n; }
  if (n1 == y && xpara(n1,n3,u,v))
	 { p1 = ptimes(p1,trim_g(n3,p,r,q));
		p2 = ptimes(p2,trim_g(v,p,u,q));
		n1=n2;n3=n4;n2=u,n4=v;
	 }
  if (n1 == y && xpara(n1,n3,u,v))
	 { p1 = ptimes(p1,trim_g(n3,p,r,q));
		p2 = ptimes(p2,trim_g(v,p,u,q));
		n1=n2;n3=n4;n2=u,n4=v;
	 }

  if (n2 == y && n3 == y)
	 { if (xperp(n1,n3,p,q) && xperp(n2,n4,p,q))
		{
		  e1=mk_elim(var,
				ptimes4(get_n(-16L),trim_a(n3,u,w,v),trim_a(n4,u,w,v),trim_g(p,p,q,q)),
				ptimes(trim_g(p,u,q,v),trim_g(p,u,q,v)));
		}
		else
		e1 = pratio_md2(var,y,w,u,v,trim_g(w,p,r,q),trim_g(u,p,v,q));
	 }
  else if (n1 == y)
	 {  v1 = mk_var(3,n1,n2,n3,n4);
		 if (w==u || (xcoll(y,u,v) && (xpara(u,n3,n2,n4) || xpara(v,n3,n2,n4))))
		 e1 = lratio_md1(v1,y,u,v,
			 trim_g(u,p,r,q),trim_g(u,p,v,q),
			 trim_g(r,p,v,q),trim_g(u,p,v,q));
		 else e1 = pratio_md1(v1,y,w,u,v,trim_g(w,p,r,q),trim_g(u,p,v,q));
		 e1->v = var;
	 }
  else { e1 = mk_elim(var,trim_g(n1,n2,n3,n4),get_n(1L)); }
  e1->p1 = ptimes(e1->p1,p1);
  e1->p2 = ptimes(e1->p2,p2);
//  if (e1 && sn==-1) e1->p2 = neg_poly(e1->p2);
  return(e1);
}

ELIM *pe_v_ipc(VAR *var,VAR * y,VAR * w,VAR * u,VAR * v,VAR * o,VAR * p)
{
    switch(var->GetFuncId())
	{   case 1:
			return(pe_r_ipc(var,var->GetPt(1),var->GetPt(0),var->GetPt(3),var->GetPt(2),y,w,u,v,o,p));
		case 2:
			return(pe_a_ipc(var,var->GetPt(0),var->GetPt(1),var->GetPt(2),var->GetPt(3),y,w,u,v,o,p));
		case 3:
			return(pe_g_ipc(var,var->GetPt(0),var->GetPt(1),var->GetPt(2),var->GetPt(3),y,w,u,v,o,p));
		case 4:
			if (w==u)
			return(lratio_md1(var,y,u,v,
				 ptimes(get_n(2L),trim_g(u,u,o,v)),trim_g(u,u,v,v),
				 pminus(trim_g(u,o,o,u),trim_g(v,o,o,v)),trim_g(u,u,v,v)));
			return(pratio_md1(var,y,w,u,v,pplus(trim_g(w,u,o,v),trim_g(w,u,o,v)),trim_g(u,u,v,v)));
		default:
			gerror(var,"pe_v_ipc: is not a proper variable.");
		}
	  return(NULL);
		}

ELIM *pe_r_ipc (VAR *var,VAR * n1,VAR * n2,VAR * d1,VAR * d2,VAR * y,VAR * w,VAR * u,VAR * v,VAR * o,VAR * p)
{
  if (w != p) gerror(0,"pe_r_ipc");
  if (n2==y && d2==y)
	 { if (xcoll(n1,w,y))
	return(mk_elim(var,
				 pplus(trim_g(n1,u,o,v),trim_g(w,u,o,v)),
				 pplus(trim_g(d1,u,o,v),trim_g(w,u,o,v))));
		else return(mk_elim(var,trim_a(n1,u,w,v),trim_a(d1,u,w,v)));
	 }
  else if (n2 == y)
	 { if (xcoll(n1,w,y))
	return(mk_elim(var,pplus(trim_g(n1,u,o,v),trim_g(w,u,o,v)),trim_g(d1,u,d2,v)));
		else return(mk_elim(var,trim_a(n1,u,w,v),trim_a(d1,u,d2,v)));
	 }
  else if (d2 == y)
	 { return(rev_elim(pe_r_ipc(var,d1,d2,n1,n2,y,w,u,v,o,p))); }
  else exit(1);
  return(NULL);
  }

ELIM *pe_a_ipc (VAR *var,VAR * n1,VAR * n2,VAR * n3,VAR * n4,VAR * y,VAR * w,VAR * u,VAR * v,VAR * o,VAR * p)
{ if (w!=p) { gerror(0,"pe_r_ipc"); }

  if (xpara(n2,n4,u,v)) { return(mk_elim(var,trim_a(w,n2,n3,n4),get_n(1L))); }

  if (n3==n4 && n2==w) {n3=n2;}
  if (n3==w)
	 return(mk_elim(var,
			ptimes3(get_n(2),trim_g(w,v,o,u),trim_a(u,n2,v,n4)),
			trim_g(u,u,v,v)));
  if (n3==n4 && xpara(n1,n2,u,v)) { n3=n2; }
  if (n1 == y && xpara(n1,n3,u,v))
	 { return(mk_elim(var,
			  ptimes(pminus(trim_g(n3,o,o,n3),trim_g(w,o,o,w)),trim_a(u,n2,v,n4)),
			  trim_g(u,n3,v,w)));
	 }
  if (w==u)
	 return(lratio_md1(var,y,u,v,
				ptimes(get_n(2L),trim_g(u,u,o,v)),trim_g(u,u,v,v),
				pminus(trim_g(u,o,o,u),trim_g(v,o,o,v)),trim_g(u,u,v,v)));
  return(pratio_md1(var,y,w,u,v,pplus(trim_g(w,u,o,v),trim_g(w,u,o,v)),trim_g(u,u,v,v)));
}


ELIM *pe_g_ipc (VAR *var,VAR * n1,VAR * n2,VAR * n3,VAR * n4,VAR * y,VAR * w,VAR * u,VAR * v,VAR * o,VAR * p)
{ VAR * n;
  VAR *v1;
  ELIM *e1;
  POLY *p1, *p2;
  //  int sn = 1;
  //  if (n2==y && n3==y) { n3 = n1; n1 = n2; sn = -1; }

  if (n2==y && n3==y && n1==o && n4==o)
	{ e1=mk_elim(var,trim_g(n3,p,p,n4),get_n(1L));
	  return(e1);
	}

  p1 = get_n(1L); p2 = get_n(1L);
  if (n1 == y && xperp(n2,n4,u,v)) { n1=n2;n2=w; n=n3;n3=n4;n4=n; }
  else if (n2 == y && xperp(n1,n3,u,v)) { n2=w; }
  if (n1 == y && xperp(n2,n4,u,v)) { n1=n2;n2=w; n=n3;n3=n4;n4=n; }

  if (n2==y && n4==w) {n=n1;n1=n2;n2=n; n=n3;n3=n4;n4=n; }
  if (n1==y && n3==w)
	 { p1 = ptimes3(p1,get_n(2),trim_g(w,v,o,u));
		p2 = ptimes(p2,trim_g(u,u,v,v));
		n1=n2;n3=n4;n2=u,n4=v;
	 }
  if (n1==y && n3==w)
	 { p1 = ptimes3(p1,get_n(2),trim_g(w,v,o,u));
		p2 =  ptimes(p2,trim_g(u,u,v,v));
		n1=n2;n3=n4;n2=u,n4=v;
	 }
/*  if (n2 == y && xpara(n2,n4,u,v)) {n=n1;n1=n2;n2=n; n=n3;n3=n4;n4=n; }
  if (n1 == y && xpara(n1,n3,u,v))
	 { p1 = ptimes(p1,pminus(trim_g(n3,o,o,n3),trim_g(w,o,o,w)));
		p2 = ptimes(p2,trim_g(u,n3,v,w));
		n1=n2;n3=n4;n2=u,n4=v;
	 }
  if (n1 == y && xpara(n1,n3,u,v))
	 { p1 = ptimes(p1,pminus(trim_g(n3,o,o,n3),trim_g(w,o,o,w)));
		p2 = ptimes(p2,trim_g(u,n3,v,w));
		n1=n2;n3=n4;n2=u,n4=v;
	 }
*/
  if (n2==y && n3==y)
	 { if (w==u)
		e1=lratio_md2(var,y,u,v,
				ptimes(get_n(2L),trim_g(u,u,o,v)),trim_g(u,u,v,v),
				pminus(trim_g(u,o,o,u),trim_g(v,o,o,v)),trim_g(u,u,v,v));
		else
		e1=pratio_md2(var,y,w,u,v,ptimes(get_n(2L),trim_g(w,u,o,v)),trim_g(u,u,v,v));
	 }
  else if (n1==y)
	 { v1 = mk_var(3,n1,n2,n3,n4);
		if (w==u)
		e1=lratio_md1(v1,y,u,v,
				ptimes(get_n(2L),trim_g(u,u,o,v)),      trim_g(u,u,v,v),
				pminus(trim_g(u,o,o,u),trim_g(v,o,o,v)),trim_g(u,u,v,v));
		else e1=pratio_md1(v1,y,w,u,v,ptimes(get_n(2L),trim_g(w,u,o,v)),trim_g(u,u,v,v));
		e1->v = var;
	  }
  else { e1 = mk_elim(var,trim_g(n1,n2,n3,n4),get_n(1L)); }

  e1->p1 = ptimes(e1->p1,p1);
  e1->p2 = ptimes(e1->p2,p2);
//  if (e1 && sn==-1) e1->p2 = neg_poly(e1->p2);
  return(e1);
}


ELIM *pe_r_foot (VAR *var,VAR * n1,VAR * n2,VAR * d1,VAR * d2,
				 VAR * y,VAR * p,VAR * u,VAR * v)
{ VAR * n;
  ELIM *e1;
  if (aless(v , u)) {n=u;u=v;v=n;}
  if (print_geo) printf("pe_r_foot: %d %d %d %d %d %d %d %d\n",n1,n2,d1,d2,y,p,u,v);
  if (n2 == y)
	 { if (xcoll(d2,u,v) && xperp(d1,d2,u,v))
	e1 = mk_elim(var,trim_a(n1,u,v,v),trim_a(d1,u,v,v));
		else if (d2 == y)
	{ if (xcoll(n1,u,v))
		 { if (u > n1 && u > d1)
		 e1 = mk_elim(var,trim_g(n1,n1,p,d1),trim_g(d1,n1,p,d1));
				else e1 = mk_elim(var,trim_g(n1,u,p,v),trim_g(d1,u,p,v));
		 }
	  else e1 = mk_elim(var,trim_a(n1,u,v,v),trim_a(d1,u,v,v));
	}
		else if (xcoll(n1,u,v))
	{ e1 = mk_elim(var,trim_g(n1,u,p,v),trim_g(d1,u,d2,v)); }
		else
	{ e1 = mk_elim(var,trim_a(n1,u,v,v),trim_a(d1,u,d2,v)); }
	 }
  else if (d2 == y)
	 { e1 = rev_elim(pe_r_foot(var,d1,d2,n1,n2,y,p,u,v)); }
  else gerror(0, "pe_r_foot");
  return(e1);
}

ELIM *pe_a_foot (VAR *var,VAR * n1,VAR * n2,VAR * n3,VAR * n4,VAR * y,VAR * p,VAR * u,VAR * v)
{ VAR * n;
  if (aless(v , u)) {n=u;u=v;v=n;}
  if (xperp(n2,n4,u,v)) { return(mk_elim(var,trim_a(p,n2,n3,n4),get_n(1L))); }
  if (xpara(n2,n4,u,v)) { return(mk_elim(var,trim_a(u,n2,n3,n4),get_n(1L))); }
  if (n3 == n4 && xcoll(u,v,n2)) {n3=n2;}
  if (xcoll(u,v,n3))
	 { return(mk_elim(var,ptimes(trim_a(u,n2,v,n4),trim_g(n3,u,p,v)),trim_g(v,u,u,v))); }
  return(lratio_md1(var,y,u,v,
			 trim_g(p,u,u,v),trim_g(u,v,v,u),
			 trim_g(p,v,v,u),trim_g(u,v,v,u)));
}

ELIM *pe_g_foot (VAR *var,VAR * n1,VAR * n2,VAR * n3,VAR * n4,
				 VAR * y,VAR * p,VAR * u,VAR * v)
{ VAR * n;
  VAR *v1;
  ELIM *e1;
  POLY *p1, *p2;

//  int sn = 1;
//  if (n2==y && n3==y) { n3 = n1; n1 = n2; sn = -1; }

  if (print_geo)  printf("pe_g_foot: %d %d %d %d %d %d %d %d\n",n1,n2,n3,n4,y,p,u,v);
  if (aless(v , u)) { n=u;u=v;v=n; }

  if (n2==y && n3==y && n1==p && n4==p)
	{ e1=mk_elim(var,ptimes(get_n(-16L),ptimes(trim_a(p,u,v,v),trim_a(p,u,v,v))),
			trim_g(u,u,v,v));
	  return(e1);
	}

  p1 = get_n(1L); p2 = get_n(1L);
  if (n1 == y && xperp(n2,n4,u,v)) { n1=n2;n2=u; n=n3;n3=n4;n4=n; }
  else if (n2 == y && xperp(n1,n3,u,v)) { n2=u; }
  if (n1 == y && xperp(n2,n4,u,v)) { n1=n2;n2=u; n=n3;n3=n4;n4=n; }
  if (n1 == y && xpara(n2,n4,u,v)) { n1=n2;n2=p; n=n3;n3=n4;n4=n; }
	 else if (n2 == y && xpara(n1,n3,u,v)) { n2=p; }
  if (n1 == y && xpara(n2,n4,u,v)) { n1=n2;n2=p; n=n3;n3=n4;n4=n; }
  if (print_geo)  printf("pe_g_foot: %d %d %d %d %d %d %d %d\n",n1,n2,n3,n4,y,p,u,v);

  if (n1 == y && xcoll(u,v,n3))
	 { p1 = ptimes(p1,trim_g(n3,v,p,u));
		p2 = ptimes(p2,trim_g(u,u,v,v));
		n1=n2;n3=n4;n2=u,n4=v;
	 }
  if (n1 == y && xcoll(u,v,n3))
	 { p1 = ptimes(p1,trim_g(n3,v,p,u));
		p2 = ptimes(p2,trim_g(u,u,v,v));
		n1=n2;n3=n4;n2=u,n4=v;
	 }

  if (n2 == y && n3 == y)
	 { e1 = lratio_md2(var,y,u,v,
				trim_g(p,u,u,v),trim_g(u,v,v,u),
				trim_g(p,v,v,u),trim_g(u,v,v,u));
	 }
  else if (n1 == y)
	 { v1 = mk_var(3,n1,n2,n3,n4);
		e1 = lratio_md1(v1,y,u,v,
				trim_g(p,u,u,v),trim_g(u,v,v,u),
				trim_g(p,v,v,u),trim_g(u,v,v,u));
		e1->v = var;
	 }
  else { e1 = mk_elim(var,trim_g(n1,n2,n3,n4),get_n(1L)); }

  e1->p1 = ptimes(e1->p1,p1);
  e1->p2 = ptimes(e1->p2,p2);
//  if(e1 && sn==-1) e1->p2 = neg_poly(e1->p2);
  return(e1);
}

//////////////////////
// end of file
/////////////////////////
