#include "geom_dbase.h"



//static CIR test_c;


void dbase::gen_base(GEOMETRY *gs)
{
 all_pts = gs->AllPts();
 G_OUT("allpts=",all_pts);
 init_dbase();

 TList *c1, *l1, *ps = new TList();
 VAR *v1;
 char *nm;
 int k;
 PT p1,p2,p3,p4,p5,p6,p7,p8;

 for(TListNode * tmp=FIRSTNODE(gs->pred_set);tmp;RNEXT(tmp))
 {
	c1 = TL(DATA(tmp));  // predicate
	v1 = (TVariable*)(FIRST(c1));
	nm = v1->GetName();
	k = GetFunctionNumber(nm);
	p1 = var2pt(TV(c1->Part(2)));
	p2 = var2pt(TV(c1->Part(3)));
	p3 = var2pt(TV(c1->Part(4)));
	p4 = var2pt(TV(c1->Part(5)));
	p5 = var2pt(TV(c1->Part(6)));
	p6 = var2pt(TV(c1->Part(7)));
	p7 = var2pt(TV(c1->Part(8)));
	p8 = var2pt(TV(c1->Part(9)));

	switch(k)
	{
	  case 0: case 10: add_line(0,p1,p2,p3); break;
	  case 1: case 11: add_pline(0,p1,p2,p3,p4); break;
	  case 2: case 12: add_tline(0,p1,p2,p3,p4); break;
	  case 3: case 13: add_cong(0,0,p1,p2,p3,p4); break;
	  case 4: case 14: add_ea_pt(0,p1,p2,p3,p4,p5,p6); break;
	  case 5: case 15: add_cir4(0,0,p1,p2,p3,p4); break;
	  case 6: case 16: 
	  case 7: case 17: add_mid(0,p1,p2,p3); break;
	  case 8: case 18: break;
	  case 9: case 19: add_ratio(0,0,p1,p2,p3,p4,p5,p6,p7,p8); break;
	}
	}
}

PT dbase::var2pt(VAR *v)
{
 return all_pts->findindex(TA(v));
}

VAR* dbase::pt2var(PT p)
{
  if (p<=0) return NULL;
  TAtom *a = all_pts->Part(p);
  return (TV(a));
}


///
void dbase::copy_pred(PRED *p1,PRED *p2)
{ char i;
  p2->pred = p1->pred;
  p2->u.d=p1->u.d;
  for (i=0;i<=7;i++) p2->p[i] = p1->p[i];
}


int dbase::new_eq(NEWD *n1,NEWD *n2)
{ return(n1->pred==n2->pred && n1->u.ln==n2->u.ln); }

void dbase::new_pr(int pred)
{ 
  int i;
 // NEWD *nd = (NEWD *)calloc(1,sizeof(NEWD));
  NEWD *nd = new NEWD();
  nd->pred=pred;
  nd->no=0;
  nd->nx=NULL;
  for(i=0;i<=7;i++) 
  {
	  nd->p[i]=NULL;
  }
  if (all_nd.nx==NULL)  
	{ last_nd=&all_nd; }
  last_nd->nx=nd; last_nd=nd;
}

void dbase::new_ot()
{ 
	int i=0;
  NEWD *nd1, *nd = all_nd.nx;
  if (nd==NULL) return;
  while(nd->nx!=NULL)
	 { if (new_eq(nd,last_nd)) i=1;
		nd1=nd;  nd=nd->nx;
	 }
  if (i==1) { last_nd=nd1; }
}

CO * dbase::add_codb(int n,PT p1,PT p2,PT p3,PT p4,PT p5,PT p6,PT p7,PT p8)
{ 
//  CO *co =(CO *)calloc(1,sizeof(CO));
   CO *co = new CO();
// long t1 = clock() - _ttime.i_time;
//  if ( (_ttime.set) && (t1 > max_time)) throw (_ttime);

//  if (print_geo) printf("add_codb %d %s %s %s %s %s %s %s %s\n",n,
//			ANAME(p1),ANAME(p2),ANAME(p3),ANAME(p4),
//			ANAME(p5),ANAME(p6),ANAME(p7),ANAME(p8));
  co->pred = n; co->no = 0;
  co->u.ln = NULL;
  co->p[0]=p1; co->p[1]=p2; co->p[2]=p3; co->p[3]=p4;
  co->p[4]=p5; co->p[5]=p6; co->p[6]=p7; co->p[7]=p8;

//  if (n==CO_PARA && xcoll4(p1,p2,p3,p4)) n=CO_COLL;
//  if (n==CO_COLL)
	{
		char i,j,k=0;
	    for(i=1;i<=5;i++)
		{ 
	    	for(j=0;j<=k;j++) 
		    if (co->p[j]==co->p[i])
			 	goto l1;
	        if (co->p[i]!=0) 
			{
			    k++;
			    co->p[k] = co->p[i];
			}
	        l1: j=1;
		}
		for(i=k+1;i<=5;i++)
			co->p[i]=0;
		if (k<=1)
			co->pred=0;
	 }
     co->nx=co_db.nx; co_db.nx=co;
  return(co);
}
void dbase::pop_codb()
{ CO *co = co_db.nx;
  if (co!=NULL) { co_db.nx = co->nx; } 
  // free((CO *)co);  
}

CO * dbase::add_coxy(int n)
{ //CO *co =(CO *)calloc(1,sizeof(CO));
	CO * co = new CO();

  co->pred = n;
  co->p[0]=0;co->p[1]=0;co->p[2]=0;co->p[3]=0;
  co->p[4]=0;co->p[5]=0;co->p[6]=0;co->p[7]=0;
  co->nx=co_xy.nx; co_xy.nx=co;
  return(co);
}
void dbase::add_codx(int n,PT p1,PT p2,PT p3,PT p4,PT p5,PT p6,PT p7,PT p8)
{ CO *co=add_codb(n,p1,p2,p3,p4,p5,p6,p7,p8);
  co_db.nx= co->nx;
  co->nx=co_xy.nx; co_xy.nx=co;
}


void dbase::new_para(PN *pn)
{ int i;
 // NEWD *nd = (NEWD *)calloc(1,sizeof(NEWD));
  NEWD *nd = new NEWD();
  nd->pred=CO_PARA;
  nd->u.pn=pn;
  for(i=0;i<=7;i++)  nd->p[i]=0;
  nd->nx=all_nd.nx;  
  all_nd.nx=nd;
  if (nd->nx==NULL)  { last_nd=nd; }
}

//  geometry predictaes 
bool dbase::xcoll (PT p1, PT p2, PT p3)
{ LN *ln;
  if (p1 == p2 || p1 == p3 || p2 == p3)  return(1);
  ln=fo_ln3(p1,p2,p3);
  return(ln != NULL);
}

//point p is on line ln
bool dbase::on_ln(PT p,LN *ln)
{ int i;
  if (ln==NULL) return(0);
  for (i=0;i<=ln->no;i++) if (ln->pt[i] == p)  return(1);
  return(0);
}

// l1 is contained in l2
bool dbase::sub_ln(LN *l1,LN *l2)
{ int i;
  for (i=0;i<=l1->no;i++) if (!on_ln(l1->pt[i],l2))  return(0);
  return(1);
}

LN * dbase::fo_ln3(PT p1,PT p2,PT p3)
{ LN *ln;
  ln = all_ln.nx;
  while (ln != NULL)
	 {
	  if (ln->no> 1 && on_ln(p1,ln) && on_ln(p2,ln) && on_ln(p3,ln))  { return(ln); }
			 ln = ln->nx;
	 }
  return(NULL);
}

LN * dbase::fo_ln(PT ps[],int n)
{ LN *ln;
  int i;
  ln = all_ln.nx;
  while (ln != NULL)
	 { if (ln->no <=1) goto l1;
		for (i=0;i<=n;i++)
		{
			if (ps[i]==0) 
			{}
		    else if(!on_ln(ps[i],ln))
				goto l1;
		}
		return(ln);
	    l1: ln = ln->nx;
	 }
  return(NULL);
}

bool dbase::xcoll4 (PT p1,PT p2,PT p3,PT p4)
{ if (p1 == p2) return(xcoll(p2,p3,p4));
  return(xcoll(p1,p2,p3) && xcoll(p1,p2,p4));
}

// find lines in the data base
//
LN *dbase::fd_ln (PT p1,PT p2)
{ LN *ln = all_ln.nx;
  while (ln!=NULL && !(ln->type && on_ln(p1,ln) && on_ln(p2,ln)))
	 { ln = ln->nx; }
  return(ln);
}

LN *dbase::fd_ln3 (PT p1,PT p2,PT p3)
{ LN *ln = all_ln.nx;
  while (ln!=NULL)
	 { if (ln->type==0) goto m1;
		if     (on_ln(p3,ln))
	{ if (on_ln(p1,ln) || on_ln(p2,ln)) return(ln); }
		else if (on_ln(p1,ln) && on_ln(p2,ln)) return(ln);
	 m1:ln = ln->nx;
	 }
  return(NULL);
}
LN *dbase::fd_pline (PT p1,PT p2,PT p3)
{ PT i;
  PN *pn;
  pn=fd_pn(p2,p3); if (pn==NULL) return(NULL);
  for (i=0;i<=pn->no;i++)
	 if (on_ln(p1,pn->ln[i])) return(pn->ln[i]);
  return(NULL);
}
LN *dbase::fd_tline (PT p1,PT p2,PT p3)
{ LN *ln;
  TN *tn;
  ln=fd_ln(p2,p3); if (ln==NULL) return(NULL);
  tn=all_tn.nx;
  while(tn!=NULL)
	 { if (tn->type)
	{ if (tn->l1==ln && on_ln(p1,tn->l2)) return(tn->l2);
	  if (tn->l2==ln && on_ln(p1,tn->l1)) return(tn->l1);
	}
		tn=tn->nx;
	 }
  return(NULL);
}
LN *dbase::fd_ln_pn1 (PN *pn,PT p)
{ PT i;
  if (pn==NULL) return(NULL);
  for (i=0;i<=pn->no;i++) if (on_ln(p,pn->ln[i])) return(pn->ln[i]);
  return(NULL);
}

LN *dbase::fd_ln1 (PT p1)
//PT p1;
{ LN *ln = all_ln.nx;
  while (ln != NULL)
	 { if (on_ln(p1,ln) && ln->type && ln->no > 1) return(ln);
		ln = ln->nx;
	 }
  return(NULL);
}

LN *dbase::fd_lnl (LN *l1)
{ LN *ln = all_ln.nx;
  PT p1,p2;
  while (ln != NULL)
	 { 
	  if (ln!=l1 && ln->type)
		{ 
			p1=inter_ll(l1,ln);
			p2=inter_ll1(l1,ln,p1);
			if (p1!=0 && p2 !=0) return(ln);
		}
		ln = ln->nx;
	 }
  return(NULL);
}

////////////////////////////
// parallel
////////////////////////////

bool dbase::xpara (PT p1,PT p2,PT p3,PT p4)
{ if (p1==p2 || p3==p4 || xcoll4(p1,p2,p3,p4)) return(1);
  return(fo_pn(p1,p2,p3,p4)!=NULL);
}
bool dbase::ln_para(LN *l1,LN *l2)
{ PN *pn;
  if (l1==l2) return(1);
  pn = all_pn.nx;
  while (pn != NULL)
	 { if (on_pn(l1,pn) && on_pn(l2,pn)) return(1);
		pn = pn->nx;
	 }
  return(0);
}

bool dbase::on_pn(LN *ln,PN *pn)
{ int i;
  for (i=0;i<=pn->no;i++) if (pn->ln[i] == ln) return(1);
  return(0);
}
bool dbase::on_ppn(PT p1,PT p2,PN *pn)
{ int i;
  for (i=0;i<=pn->no;i++)
	 if (on_ln(p1,pn->ln[i]),on_ln(p2,pn->ln[i])) return(1);
  return(0);
}

PN * dbase::fo_pn (PT p1,PT p2,PT p3,PT p4)
{ PN *pn;
  char i,j;
  pn=all_pn.nx;
  while(pn!=NULL)
	 { if (pn->no==0) goto m1;
		for (i=0;i<=pn->no;i++)
	{ if      (on_ln(p1,pn->ln[i]) && on_ln(p2,pn->ln[i]))
		 { for (j=i+1;j<=pn->no;j++)
		if (on_ln(p3,pn->ln[j]) && on_ln(p4,pn->ln[j])) return(pn);
			if (pn->type) return(NULL);
		 }
	  else if (on_ln(p3,pn->ln[i]) && on_ln(p4,pn->ln[i]))
		 { for (j=i+1;j<=pn->no;j++)
		if (on_ln(p1,pn->ln[j]) && on_ln(p2,pn->ln[j])) return(pn);
			if (pn->type) return(NULL);
		 }
	}
	 m1: pn=pn->nx;
	 }
  return(NULL);
}

PN *dbase::fd_pnl (LN *ln)
{ PN *pn;
  pn = all_pn.nx;
  while (pn!=NULL && !(pn->type==1 && on_pn(ln,pn))) { pn = pn->nx; }
  return(pn);
}
PN *dbase::fd_pn (PT p1,PT p2)
{ LN *ln = fd_ln(p1,p2);
  if (ln == NULL) return(NULL);
  return(fd_pnl(ln));
}
PN *dbase::fd_pnp (PN *pn,LN *ln)
{ PN *pn1;
  pn1 = all_pn.nx;
  while (pn1!=NULL)
	 if (pn1!=pn && pn1->type && on_pn(ln,pn1)) return(pn1); else pn1 = pn1->nx;
  return(NULL);
}


////////////////////////////

bool dbase::xperp (PT p1,PT p2,PT p3,PT p4)
{ LN *ln1,*ln2;
  if (p1 == p2 || p3 == p4) return(1);
  ln1 = fd_ln(p1,p2);
  ln2 = fd_ln(p3,p4);
  if ((ln1 == NULL) || (ln2 == NULL)) return(0);
  return(ln_perp(ln1,ln2));
}

bool dbase::ln_perp(LN *l1,LN *l2)
{ TN *tn;
  if (l1==l2) return 0;
  tn = all_tn.nx;
  while (tn != NULL)
	 { if ((l1==tn->l1 && l2==tn->l2) || (l1==tn->l2 && l2==tn->l1)) return(1);
		tn = tn->nx;
	 }
  return(0);
}

TN * dbase::fo_tn(PT p1,PT p2,PT p3,PT p4)
{ LN *ln1,*ln2;
  TN *tn;
  if (p1 == p2 || p3 == p4) return(NULL);
  ln1=fd_ln(p1,p2); if (ln1==NULL) return(NULL);
  ln2=fd_ln(p3,p4); if (ln2==NULL) return(NULL);
  tn = all_tn.nx;
  while (tn != NULL)
	 { if ((tn->l1==ln1 && tn->l2==ln2) || (tn->l1==ln2 && tn->l2==ln1)) return(tn);
		tn = tn->nx;
	 }
  return(NULL);
}

//// congruent
bool dbase::on_cg(PT p1,PT p2,CONG *cg)
{ PT i;
  if (p2<p1) { i=p1; p1=p2; p2=i; }
  for (i=0;i<=cg->no;i++)
	 if (p1==cg->p1[i] && p2==cg->p2[i]) return(1);
  return(0);
}
bool dbase::sub_cg(CONG *cg1,CONG *cg2)
{ PT i;
  for (i=0;i<=cg1->no;i++)
	 { if (!on_cg(cg1->p1[i],cg1->p2[i],cg2)) return(0); }
  return(1);
}

//////////////////////////
// circles
////////////////////////
CIR * dbase::xcir(CIR *c1)
{ CIR *c2;
  c2=all_cir.nx;
  while(c2!=NULL)
	 { if (sub_cir(c1,c2))  return(c2);
		c2=c2->nx;
	 }
  return(NULL);
}

CIR * dbase::fo_cr(PT o,PT p1,PT p2,PT p3,PT p4)
{
//	  test_c.o = o;
//    test_c.no = 3;
//    test_c.pt[0]=p1;test_c.pt[1]=p2;test_c.pt[2]=p3;test_c.pt[3]=p4;
//    return(xcir(&test_c));
	return NULL;
}
bool dbase::xcir2(PT o,PT p1,PT p2)
{ 
//	test_c.o = o;
//    test_c.no = 1;
//    test_c.pt[0]=p1;test_c.pt[1]=p2;
//    return(xcir(&test_c)!=NULL);
	return NULL;
}
bool dbase::xcir3(PT o,PT p1,PT p2,PT p3)
{ 
//  test_c.o = o;
//  test_c.no = 2;
//  test_c.pt[0]=p1;test_c.pt[1]=p2;test_c.pt[2]=p3;
//  return(xcir(&test_c)!=NULL);

	return NULL;
}
bool dbase::xcir4(PT o,PT p1,PT p2,PT p3,PT p4)
{ 
//	test_c.o = o;
//  test_c.no = 3;
//  test_c.pt[0]=p1;test_c.pt[1]=p2;test_c.pt[2]=p3;test_c.pt[3]=p4;
//  return(xcir(&test_c)!=NULL);
  
	return NULL;
}
bool dbase::xcir5(PT o,PT p1,PT p2,PT p3,PT p4,PT p5)
{ 
//  test_c.o = o;
//  test_c.no = 4;
//  test_c.pt[0]=p1;test_c.pt[1]=p2;test_c.pt[2]=p3;test_c.pt[3]=p4;test_c.pt[4]=p5;
//  return(xcir(&test_c)!=NULL);
  
	return NULL;
}

bool dbase::on_cir(PT a,CIR *cr)
{ char i;
  if (a==0) return(1);
  for (i=0;i<=cr->no;i++) if (cr->pt[i]==a) return(1);
  return(0);
}
bool dbase::eq_cir(PT o,PT a,CIR *cr)
{ char i;
  if (cr->o != o) return(0);
  for (i=0;i<=cr->no;i++) if (cr->pt[i]==a) return(1);
  return(0);
}
bool dbase::sub_cir(CIR *c1,CIR *c2)
{ char i;
  if (c1->o == c2->o || c1->o==0)
	 { for (i=0;i<=c1->no;i++) { if (!on_cir(c1->pt[i],c2)) return(0); }
		return(1);
	 }
  return(0);
}


//////////////////
// midpoints
////////////////////
bool dbase::xmid (int m,int a,int b)
{
	return(fo_md(m,a,b)!=NULL); 
}

MD *dbase::fo_md(int m,int a,int b)
{
	MD *md = all_md.nx;
    while (md != NULL)
	{ 
		  if (m==md->m &&((a==md->a && b==md->b) || (a==md->b && b==md->a)))
		  {
			  return(md); 
		  }
		  md = md->nx;
	}
    return(NULL);
}


bool dbase::xacong(PT a,PT b,PT c,PT p,PT q,PT r)
{ LN *l1,*l2,*l3,*l4;
  l1=fd_ln(a,b);l2=fd_ln(b,c);l3=fd_ln(p,q);l4=fd_ln(q,r);
  if (l1==NULL || l2==NULL || l3==NULL || l4==NULL) return(0);
  return(ln_acong(l1,l2,l3,l4));
}

ANS * dbase::fo_las(LN *l1,LN *l2,LN *l3,LN *l4)
{ LN *n1,*n2;
  ANS *as;
  if (l1==l2 || l3==l4)
  {
//	  ex_ch(n1,l2,l3) 
  }
  if (l1==l4) 
  {
//	  ex_ch(n1,l1,l3) ex_ch(n1,l2,l4) 
  }
  if (l2==l3)  { if (l1>l4) { n1=l4;l4=l1;l1=n1; }}
  else if (l1==l3)
	 { if (l2>l4) { n1=l2;l2=l4;l4=n1;} }
  else if (l2==l4)
	 { n1=l1;l1=l2;l2=n1; n1=l3;l3=l4;l4=n1;
		if (l2>l4) { n1=l2;l2=l4;l4=n1;}
	 }
  else
	 { if (l1<l2) n1=l1; else n1=l2;
		if (l3<l4) n2=l3; else n2=l4;
		if (n1>n2) { n1=l3;l3=l1;l1=n1; n1=l2;l2=l4;l4=n1; }
		if (l1>l2) { n1=l1;l1=l2;l2=n1; n1=l3;l3=l4;l4=n1; }
	 }
  as=all_as.nx;
  while(as!=NULL)
	 { if (l1==as->l1 && l4==as->l4 &&
	  ((l2==as->l2&&l3==as->l3) || (l2==as->l3&&l3==as->l2))) return(as);
		as=as->nx;
	 }
  return(NULL);
}

ANS * dbase::fo_las1(LN *l1,LN *l2,LN *l3,LN *l4)
{ ANS *as1 = fo_las1(l1,l2,l3,l4);
//  printf("%s = %d\n",PDSTR(2701),as1);
//  show_as(pDdoc,as1,false); printf("1111\n");
  return(as1);
}

ANS * dbase::fo_as(PT a,PT b,PT c,PT d,PT p,PT q,PT r,PT s)
{ LN *l1,*l2,*l3,*l4;
  l1=fd_ln(a,b);l2=fd_ln(c,d);l3=fd_ln(p,q);l4=fd_ln(r,s);
  if (l1==NULL || l2==NULL || l3==NULL || l4==NULL) return(NULL);
  return(fo_las(l1,l2,l3,l4));
}

bool dbase::ln_acong(LN *l1,LN *l2,LN *l3,LN *l4)
//LN *l1,*l2,*l3,*l4;
{   if (l1==l3 && l2==l4) return(1);
  if (ln_para(l1,l2) && ln_para(l3,l4)) return(1);
//  if (ln_para(l1,l3) && ln_para(l2,l4)) return(1); 
  if (ln_perp(l1,l2) && ln_perp(l3,l4)) return(1);
//  if (ln_perp(l1,l3) && ln_perp(l2,l4)) return(1); 
	 return (fo_las(l1,l2,l3,l4)!=NULL);
}

bool dbase::xcong(PT a,PT b,PT p,PT q)
//PT a,b,p,q;
{ CONG *cg;
  PT o;
  if (a>b) { o=a;a=b;b=o;}
  if (p>q) { o=p;p=q;q=o;}
  if (a==p && b==q) return(1);
  cg=all_cg.nx;
  while(cg!=NULL)
	 { if(cg->type && on_cg(a,b,cg) && on_cg(p,q,cg)) return(1);
		cg=cg->nx;
	 }
  return(0);
}

CONG * dbase::fo_cg(PT a,PT b,PT p,PT q)
//PT a,b,p,q;
{ CONG *cg;
  PT o;
  if (a>b) { o=a;a=b;b=o;}
  if (p>q) { o=p;p=q;q=o;}
  if (a==p && b==q) return(NULL);
  cg=all_cg.nx;
  while(cg!=NULL)
	 { if(on_cg(a,b,cg) && on_cg(p,q,cg)) return(cg);
		cg=cg->nx;
	 }
  return(NULL);
}

//

bool dbase::xsim_tri(PT a,PT b,PT c,PT p,PT q,PT r)
{
  return (fo_st(1,0,a,b,c,p,q,r)!=NULL);
}

bool dbase::xcon_tri(PT a,PT b,PT c,PT p,PT q,PT r)
{
  return (fo_st(0,0,a,b,c,p,q,r)!=NULL);
}

bool dbase::on_st(PT p1, PT p2, PT p3, STRI *st)
{ PT i;
  if (xcong(p1,p2,p1,p3))
	 { for (i=0;i<=st->no;i++)
	if (p1==st->p1[i] &&
		 ((p2==st->p2[i] && p3==st->p3[i]) || (p2==st->p3[i] && p3==st->p2[i])))
	  return(1);
		return(0);
	 }
  if (xcong(p2,p1,p2,p3))
	 { for (i=0;i<=st->no;i++)
	if (p2==st->p2[i] &&
		 ((p1==st->p1[i] && p3==st->p3[i]) || (p1==st->p3[i] && p3==st->p1[i])))
	  return(1);
		return(0);
	 }
  if (xcong(p3,p2,p3,p1))
	 { for (i=0;i<=st->no;i++)
	if (p3==st->p3[i] &&
		 ((p1==st->p1[i] && p2==st->p2[i]) || (p1==st->p2[i] && p2==st->p1[i])))
	  return(1);
		return(0);
	 }
  for (i=0;i<=st->no;i++)
	 if (p1==st->p1[i] && p2==st->p2[i] && p3==st->p3[i]) return(1);
  return(0);
}

STRI * dbase::fo_st(int xsim_2,int xsim_1,PT a,PT b,PT c,PT p,PT q,PT r)
{ STRI *st = (xsim_2)?all_st.nx:all_ct.nx;
  while(st!=NULL)
	 { if((xsim_1 || st->type )&&
	 ((on_st(a,b,c,st) && on_st(p,q,r,st)) ||
	  (on_st(b,c,a,st) && on_st(q,r,p,st)) ||
	  (on_st(c,a,b,st) && on_st(r,p,q,st)) ||
	  (on_st(a,c,b,st) && on_st(p,r,q,st)) ||
	  (on_st(c,b,a,st) && on_st(r,q,p,st)) ||
	  (on_st(b,a,c,st) && on_st(q,p,r,st))))
	return(st);
		st=st->nx;
	 }
  return(NULL);
}

bool  dbase::xeq_ratio(PT a,PT b,PT c,PT d,PT p,PT q,PT r,PT s)
//PT a,b,c,d,p,q,r,s;
{
  if ((xcong(a,b,p,q) && xcong(c,d,r,s)) ||
		(xcong(a,b,c,d) && xcong(p,q,r,s)) ||
		(xcong(a,b,r,s) && xcong(c,d,p,q))) return(1);
  return(fo_ra(a,b,c,d,p,q,r,s)!=NULL);
}

RATIO * dbase::fo_ra(PT a,PT b,PT c,PT d,PT p,PT q,PT r,PT s)
//	  PT a,b,c,d,p,q,r,s;
{ RATIO *ra=all_ra.nx;
  for(; ra!=NULL; ra=ra->nx)
	 { if ((((xcong(a,b,ra->r[1],ra->r[2]) && xcong(r,s,ra->r[7],ra->r[8])) ||
		 (xcong(a,b,ra->r[7],ra->r[8]) && xcong(r,s,ra->r[1],ra->r[2]))) &&
		((xcong(c,d,ra->r[3],ra->r[4]) && xcong(p,q,ra->r[5],ra->r[6])) ||
		 (xcong(c,d,ra->r[5],ra->r[6]) && xcong(p,q,ra->r[3],ra->r[4])))) ||
	  (((xcong(a,b,ra->r[3],ra->r[4]) && xcong(r,s,ra->r[5],ra->r[6])) ||
		 (xcong(a,b,ra->r[5],ra->r[6]) && xcong(r,s,ra->r[3],ra->r[4]))) &&
		((xcong(c,d,ra->r[1],ra->r[2]) && xcong(p,q,ra->r[7],ra->r[8])) ||
		 (xcong(c,d,ra->r[7],ra->r[8]) && xcong(p,q,ra->r[1],ra->r[2])))))
	return(ra);
	 }
  return(NULL);
}


bool dbase::ln_less(LN *l1,LN *l2)
{ if (l1==l2) return(0);
  if (l1->pt[1] < l2->pt[1]) return(1);
  if (l1->pt[1] > l2->pt[1]) return(0);
  if (l1->pt[0] < l2->pt[0]) return(1);
  return(0);
}
bool dbase::l2_less(LN *l1,LN *l2,LN *l3,LN *l4)
{ LN *ln;
  if (ln_less(l2,l1)) { ln=l1;l1=l2;l2=ln; }
  if (ln_less(l4,l3)) { ln=l3;l3=l4;l4=ln; }
  if (ln_less(l2,l4)) return(1);
  if (l2==l4  && ln_less(l1,l3)) return(1);
  return(0);
}


//endf f file