
#include <iostream.h>
#include <conio.h>
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <string.h>
#include <time.h>
#include <dos.h>

#include "draw.rh"
#include "para.h"
#include "ttime.h"
#include "proapp.rh"

#include <owl\inputdia.rh>

extern TApplication * draw_app;
#define PDSTR(i) ((draw_app->LoadString(i)).c_str())

#pragma warn -cln
#pragma warn -sig
#pragma warn -rpt*
#pragma warn -weff*

void alg_form();

//For separate use of proofs
/* void pro_main ()
{
	char tnm[100];

	prov_init();

	printf("The Geometry Theorem:");
	gets(tnm);
	printf("txt = %s\n",tnm);

	printf("proving method:");
	scanf("%d",&pro_type);
	printf("pro_type = %d\n",pro_type);

//	read_cons(tnm);

	printf("NULL=(%d),(%ld)\n",NULL,NULL);

  if (qerror) { return; }
  pro_thm();

}  */

void prov_init()
{
  init_gvars();
  init_poly();
  init_num();
  init_wu();
//  init_dbase();

  pro_type = PRO_GDD;
  out_st=NULL;
  cons_no = 0;
  conc.pred = CO_NO;
  for (int i=0;i<=7;i++) conc.p[i]=0;
  qerror =0;
  lang_type=2;
  lang_mod=0;
  in_figure=0;
  pr_save = 1;
  pr_tex =0;
  print_geo=0;
  max_termp=1;
}

void pro_thm ()
{
  POLS *dp1;
  int count,i;
  long t1,t2;

  clear_res();
  qerror =0;
  in_figure=0;
  pro_time=0;
  l_set.nx = NULL;
  max_term = 0;
  if (pro_type == PRO_GDD) max_termp=0;
  else max_termp = 1;

 /*
#ifndef DEBUG
  clear_res();
  if (lang_type==0) { all_to_txt(); }
  lang_mod=0;
  if (txtcon[0]=='\0') return;
  if (lang_type==1) read_lang();
  else              read_cons("");
  if (qerror) goto ext;
#endif
*/

 if ((!conc.pred || conc.pred==CO_NO) && pro_type!=PRO_GDD)
	 {
		gprint(PDSTR(2800));
		gprint(PDSTR(2801));
		return;
	 }
 for (i=1;i<=cons_no;i++)
	if (ATYPE(i)==C_ICENT1)
	{ gprint(PDSTR(2311)); gprint(PDSTR(2312)); return; }

 // find algebraic equations
try {
 _ttime.set = 1;
 _ttime.i_time = clock();


 if (pro_type==PRO_AREA || pro_type==PRO_VEC)
 {	Pro_point ppt;
	int j=2,k,l;
	for (int i=2;i<=cons_no;i++)
	{ if (ATYPE(i)!=C_POINT) continue;
	  if (i==j) { j++; continue; }
	  ppt = allpts[i];
	  for (k=i;k>j;k--) allpts[k]=allpts[k-1];
	  allpts[j]=ppt;
	  for (k=j+1;k<=cons_no;k++)
	  {
		for (l=0;l<PS_NO;l++)
		{ if (APTS(k,l)==i) APTS(k,l)=j;
		  else if (APTS(k,l)==j)APTS(k,l)=i;
		}
	  }
	  for (k=0;k<PS_NO;k++)
		{ if (conc.p[k]==i)conc.p[k]=j;
		  else if (conc.p[k]==j)conc.p[k]=i;
		}
	  j++;
	}
 }

//	 doall(6, 1 );      docc(4);

 doall(5,1);

 if (pro_type==PRO_WU || pro_type==PRO_GB)
	{
	  doall(1,1);
	  docc(1);
	  t1=clock();
	  tri_set.nx = NULL;
	  for (i=1;i<=cons_no;i++)
		if (ATYPE(i)==C_PETRIANGLE)
		{ tri_set.nx = get_dt(0,pminus(ptimes(get_m(mk_cvar("w")),get_m(mk_cvar("w"))),get_n(3L)),
									 tri_set.nx);
		  //sprintf(txt,"ddd(%d)\r\n",(mk_cvar("w"))->nm);gprint(txt);
		  break;
		}

	  if      (pro_type==PRO_WU)
		 {  doall(2,1); }
	  else if (pro_type==PRO_GB)
		 {
			for (i=1;i<=cons_no ;i++)
			 { if (hyp_set[i].p1!=NULL)
				tri_set.nx = get_dt(1,cp_poly(hyp_set[i].p1),tri_set.nx);
				if (hyp_set[i].p2!=NULL)
				tri_set.nx = get_dt(1,cp_poly(hyp_set[i].p2),tri_set.nx);
			 }
			gred_type=1;
			tri_set.nx = g_basis(tri_set.nx);
		 }
		t2=clock();
		pro_time += t2-t1;
		if (max_termp)
		{ for(dp1=tri_set.nx; dp1 != NULL; dp1=dp1->nx)
		 { count=plength(dp1->p);
			if (count > max_term) max_term=count;
		 }
		 for(dp1=conc_set.nx; dp1 != NULL; dp1=dp1->nx)
		 { count=plength(dp1->p);
			if (count > max_term) max_term=count;
		 }
		}
	 }
 //do it at an early stage
 //1. when from diagram editor
 //2. when from text constructor
 switch(pro_type)
	{
	case PRO_FULL:
	  t1=clock();
	  prove_full();
	  if (qerror) goto ext;
	  t2=clock(); pro_time = pro_time + t2-t1;
	  if (pro_result==1)
		{ print_proof(0);
		  if (pr_save)   print_save();
		}
	  break;
	case PRO_AREA:
	case PRO_VEC:

	  t1=clock();
	  prove_area();
	  t2=clock(); pro_time = pro_time + t2-t1;
	  if (qerror) goto ext;
	  if (pro_result==1)
	  {	  print_proof(0); }
	  if (pr_save)   print_save();
	  if (pr_tex)
		{ if (!pr_save) print_save();
		  print_tex(1);
		}
	  break;
	case PRO_WU:
	  alg_form();
	  prove_wu();
	  /*  print_all_vars(); */
	  if (qerror) goto ext;
	  //free_wu();
	  /*  pool_len(); */
	  break;
	case PRO_GB:
	  alg_form();
	  prove_gbas();
	  /*  print_all_vars(); */
	  if (qerror) goto ext;
	 // free_wu();
	  /*  pool_len(); */
	  break;
	case PRO_GDD:
	 // cgeo_key = 5; doall(1);
	  prove_fixp();
	  if (qerror) goto ext;
	  conc_xtrue();
	  if (pr_save) save_fproof(1);
	  if (pr_tex)
	  { if (!pr_save) save_fproof(1);
		  print_tex(1);
	  }
	  break;
  }
 ext:
	_ttime.set = 0;
	return;
 }  //try
 catch(...)
  {
	clear_res();
	_ttime.set = 0;
	int penSize = max_time/CLK_TCK;
	wsprintf(txt,"\r\n\r\n%s %d(%s).\r\n",PDSTR(2802),penSize,PDSTR(2806));
	gprint(txt);
	gprint(PDSTR(2804));
	gprint(PDSTR(2805));
  }
}

void print_cc()
{ POLS *ps;
  ps = conc_cp.nx;
  while(ps!=NULL) { eprint(ps->p); ps = ps->nx; }
}

int in_str(char c,char *ch)
{ while(*ch!='\0' && *ch!='\n')
	 if (*ch==c) return(1); else ch++;
  return(0);
}
           



