#include "geometry.h"

//
// polynomial set operations
//
//Preserve ps
TList *ps2list(POLS *ps)
{ 
  if (ps==0) return NULL;
  TList *l = new TList();
  while(ps)
  { l->append((TAtom*)cp_TRIPoly(ps->p)); 
    ps = ps->nx;
  }
  return l;
 }

//Preserve ps
POLS *list2ps(TList *ps)
{ POLS rs;
  if (ps==0) return NULL;
  rs.nx = 0;
  int len = ps->length();
  for(int i=1; i<=len;i++)
     rs.nx = get_dt(1,cp_TRIPoly((POLY *)ps->Part(i)),rs.nx); 
  return rs.nx;
}


POLS *ps_member(POLY*p, POLS*ps)
{ for(;ps != NULL;ps = ps->nx)
    { if (eq_TRIPoly(p,ps->p)) return(ps); }
  return(NULL);
}

//presevre ps1 and ps2
bool ps_subset(POLS *ps1, POLS *ps2)
{ 
  for (;ps1; ps1=ps1->nx)
	if (ps_member(ps1->p,ps2)==NULL) return false;
  return true;
}
bool pss_cont(POLS *ps1, POLS *ps2)
{ 
  for (;ps2; ps2=ps2->nx)
	if (ps_subset((ps2->p)->ups,ps1)) return true;
  return false;
}

//destructive for ps1 and ps2
POLS *ps_union(POLS *ps1, POLS *ps2)
{ 
  if (ps1 == NULL) return(ps2);
  if (ps2 == NULL) return(ps1);
  ps2 = ps_diff(ps2,ps1);
  return(ps_append(ps1,ps2));
}

//destructive for ps1 and ps2
POLS *ps_append(POLS *ps1, POLS *ps2)
{ POLS *ps;
  if (ps1 == NULL) return(ps2);
  else if (ps2 == NULL) return(ps1);
  else { for(ps = ps1;ps->nx != NULL; ps = ps->nx) {}
	 ps->nx = ps2;
	 return(ps1);
       }
}

//destructive for ps1
//keep ps2
POLS *ps_diff(POLS *ps1, POLS *ps2)
{ POLS ps, *ps0;

  if (ps1 == NULL) return(NULL);
  if (ps2 == NULL) return(ps1);
  { ps.nx = ps1; ps0 = &ps;
    while (ps1 != NULL)
      { if (ps_member(ps1->p,ps2)!=NULL)
	  { ps0->nx = ps1->nx;
	    put_p(ps1->p); put_d(ps1);
	    ps1 = ps0->nx;
	  }
      else { ps0=ps1; ps1=ps0->nx; }
      }
    return(ps.nx);
  }
}

/*
POLS *ps_diff2(POLS *ps1,POLS *ps2)   //destructive for ps1 
{ POLS ps, *ps0,*ps3;

  if (ps1 == NULL) return(NULL);
  else if (ps2 == NULL) return(ps1);
  else { ps.nx = ps1;
	 while (ps2 != NULL)
		{ ps0 = &ps; ps3=ps0->nx;
		  while ((ps3 != NULL) && !(eq_poly(ps2->p,ps3->p)))
			 { ps0 = ps3; ps3 = ps3->nx;}
		  if (ps3 != NULL)
			 { ps3->deg -= ps2->deg;
		 if (ps3->deg <= 0)
			{ ps0->nx = ps3->nx;
			  put_p(ps3->p); put_d(ps3);
			}
			 }
		  ps2 = ps2->nx;
		}
	 return(ps.nx);
		 }
}
*/

//preserve ps1 and ps2
POLS *ps_inter(POLS *ps1,POLS *ps2)
{ POLS ps, *ps0,*ps3;

  if (ps1 == NULL) return(NULL);
  else if (ps2 == NULL) return(NULL);
  else { ps.nx = NULL; ps0 = &ps;
	 while (ps1 != NULL)
		{ ps3=ps_member(ps1->p,ps2);
		  if (ps3 != NULL)
			 { ps0->nx = get_dt(min((ps1->deg),(ps3->deg)),cp_TRIPoly(ps1->p),NULL);
		       ps0 = ps0->nx;
			 }
		  ps1 = ps1->nx;
		}
	 return(ps.nx);
  }
}


int ps_term1 (POLS *dp)
{
 int k = 0;
 for(POLS* ps = dp; ps!=NULL; ps=ps->nx)
 { if (!npoly(ps->p)) k++; }
 return k;
}

//destructive for dp
POLY *ps_plus  (POLS *dp)
{ POLY *p1; POLS *dp1;
  p1 = get_n(0);
  while (dp != NULL)
	 { if      (dp->deg <= 0) { put_p(dp->p); }
		else if (dp->deg == 1) p1 = pplus(p1,dp->p);
		else p1 = pplus(p1,ppower(dp->p,dp->deg));
		dp1 = dp; dp = dp->nx;
		put_d(dp1);
	 }
  return(p1);
}

//destructive for dp
POLY *ps_times  (POLS *dp)
{ POLY *p1; POLS *dp1;

  p1 = get_n(1L);
  while (dp != NULL)
	 { if (dp->deg <= 0) { put_p(dp->p); }
		else if (dp->deg == 1) p1 = ptimes(p1,dp->p);
		else p1 = ptimes(p1,ppower(dp->p,dp->deg));
		dp1 = dp; dp = dp->nx;
		put_d(dp1);
	 }
  return(p1);
}

// ps1/ps2
//
POLS *ps_div(POLS *ps1,POLS *ps2, POLSPT *ps_d1,POLSPT *ps_d2)
{ POLS ps_1,ps_0,*ps00,*ps02,*ps3,*ps4;
  POLY *p1,*p2;
  DEG d;
  NUM c, n1, n2;
  bool did;

  wout << "ps1:"; ps_display(ps1);
  wout << "ps2:"; ps_display(ps2);

  if (ps1==NULL || ps2==NULL) return(NULL);
  ps_0.nx=NULL; ps00=&ps_0;

  ps4=ps2;
  while(ps4)
	 {  
	  if (!npoly(ps4->p)) 
		{
			ps3=ps1;
			ps_1.nx=NULL;
			while(ps3)
			{ 
				if (!npoly(ps3->p)) 
				{
					p1=pdiv(cp_TRIPoly(ps3->p),ps4->p);
					if (p1!=NULL)
					{   did=true;
						d=min(ps4->deg,ps3->deg);
						ps4->deg -= d; 
						ps3->deg -= d;
						ps00->nx=get_dt(d,cp_TRIPoly(ps4->p),NULL); 
						ps00=ps00->nx;
						ps_1.nx=get_dt(d,p1,ps_1.nx);
					}
				}
				ps3=ps3->nx;
			}
	  		if (ps_1.nx != NULL) { ps1=ps_red(ps_append(ps_1.nx,ps1)); }
	  } // if (p4)
	  ps4=ps4->nx;
  }

  // deal the number
  ps1 = ps_red(ps1);
  ps2 = ps_red(ps2);

  p1=ps1->p; 
  p2=ps2->p;
  c=num_gcd(p1->c,p2->c);
  if (!num_unit(c))
  { 
	  ps00->nx=get_dt(d,get_n(c),NULL); 
	  ps00=ps00->nx;
	  n1 = num_d(p1->c,c);
	  n2 = num_d(p2->c,c);
	  put_p(ps1->p); ps1->p = get_n(n1);
	  put_p(ps2->p); ps2->p = get_n(n2);
  }
  if (num_negp(p1->c)) 
  { p1->c = -(p1->c);  p2->c = -(p2->c); }
  *ps_d1 = ps1;
  *ps_d2 = ps2;
  wout << "dps1:"; ps_display(ps1);
  wout << "dps2:"; ps_display(ps2);
  return ps_0.nx;

//  return(new TList(ps_0.nx,ps1,ps2));
}

/*destructive for p*/
POLS *vfactor(POLY *p)
{ POLS ps,*ps1,*ps2;
  POLY *p1;
  DEG d1;
  NUM c=TNumber(1L);

  ps.nx = NULL; 
  ps1 = &ps;
  p1 = p;
  while (p1->var != NULL)
	 { d1 = mdeg(p,p1->var);
	   if (d1 > 0) { ps1->nx = get_dt(d1,get_m(p1->var),NULL); ps1 = ps1->nx; }
	   ps2 = p1->ups; p1 = ps2->p;
  }
  if (ps.nx != NULL)
	 { p1 = ps_times(cp_pols(ps.nx));
		p = pdiv(p,p1); put_p(p1);
	 }
  if (p->var == NULL)  { c = p->c;   put_x(p); }
  else
	 { //c = lcontent(p);
	    c = p->icont();
		if (num_nunit(c)) 
			{ p1=get_n(-1L); p = ptimes(p,p1); }
		else if (!num_unit(c))
			{ p1=get_n(c); p = pcdiv(p,p1); put_x(p1); }
		ps1->nx = get_dt(1,p,NULL); ps1 = ps1->nx;
	 }
  ps2 = get_dt(1,get_n(c),ps.nx);
  ps.nx = ps2;
  return(ps.nx);
}

POLS *ps_simp (POLS *ps)
{ POLS ps_t, *ps0,*ps1,*ps2,*ps3;
  POLY *p1;
  PT sn=1;
  ps_t.nx = NULL; 
  ps1 = &ps_t;
  while (ps != NULL)
	 {  ps2 = vfactor(ps->p);
		p1 = ps2->p;
		if (num_zop(p1->c))     { ps3=ps2->nx; put_x(p1); put_d(ps2); sn=0; }
		else if (num_unit(p1->c)) { ps3=ps2->nx; put_x(p1); put_d(ps2); }
		else { ps3=ps2; }
		while(ps3 != NULL)
		{ 
			ps3->deg *= ps->deg;
			ps2 = ps_t.nx;
			while ((ps2 != NULL) && !(eq_TRIPoly(ps2->p,ps3->p))) ps2 = ps2->nx;
			if (ps2 != NULL)
			{ put_p(ps3->p);
			  ps2->deg += ps3->deg;
			  ps0 = ps3; ps3 = ps3->nx; put_d(ps0);
			}
			else
			{ ps1->nx = ps3; ps1 = ps3; ps3 = ps3->nx; ps1->nx = NULL;}
		}
		ps2 = ps; ps = ps->nx; put_d(ps2);
	 }

  if (sn==0)
  { put_ps(ps_t.nx); return(get_dt(1,get_n(0),NULL)); }
  if (ps_t.nx==NULL) ps_t.nx= get_dt(1,get_n(1),NULL);
  return(ps_t.nx);
}


//
//destructive for ps
//
POLS *ps_red (POLS *ps)
{ POLS ps_t, *ps1,*ps2, *ps3;
  POLY *p1;
  NUM c=TNumber(1L);
  ps_t.nx=ps; ps1=&ps_t; ps2=ps1->nx;
  while(ps2!= NULL)
	 { 
		if (ps2->deg <=0)
			{ ps3=ps2; ps2=ps2->nx; ps1->nx=ps2; put_p(ps3->p);put_d(ps3); }
		else if (npoly(ps2->p))
			{ p1=ps2->p;
			  c = num_t(c, num_pow(p1->c, TNumber(ps2->deg))); //QZY 2002
			  ps3=ps2; ps2=ps2->nx; ps1->nx=ps2; 
			  put_p(ps3->p); put_d(ps3);
			}
		else { ps1=ps2; ps2 = ps2->nx; }
	 }
  return(get_dt(1,get_n(c),ps_t.nx));
}

//
//
void  ps_display(POLS *dp)
{ 
 wout <<endl;
 while (dp != 0)
 { 
   wout << dp->deg << "ps:"; (dp->p)->display(); 
   wout << endl;
   dp =dp ->nx;
 }

}

