#include "basetype.h"
#include "stacks.h"
#include "global.h"
#include "lists.h"
#include "poly.h"
#include "pol.h"
#include "sysfunc.h"
#include "express.h"
#include "projection.h"
#include <stdio.h>
#include <iostream.h>
#include <string.h>
#include <new.h>
#include "number.h"
#include "lists.h"
#include "trpoly.h"
#include "pol.h"

#include "matrix.h"
#include "wsolve.h"
#include "geometry.h"
#include "check.h"

#ifdef _WINDOWS
#include "..\gui\index.h"
#endif

#define PO(x)     TRIPoly((x),1)
#define PP(x)     TRIPoly((x),2)
#define DR(x,d)    dDiff_wdk(new TRIPoly((x),1),s,(d))
#define DP(x,d)    (*(dDiff_wdk(new TRIPoly((x),1),s,(d))))
#define DPP(x,d)  ((*(dDiff_wdk(new TRIPoly((x),1),s,(d))))^2)
#define NP(d)  TRIPoly(TBigInt((d)))

//
// Genration functions for GEOMETRY
// 
void GEOMETRY::init_scurve(bool first) 
{
  TVariable *x, *y, *z, *k,*t, *r, *n1, *n2, *n3, *b1, *b2, *b3, *o1, *o2, *o3, 
	  *C, *T, *N, *B, *O, *s;
  
  TList *vs, *ss;
  
 //  if (first) restart();

  O = GenVar("O"); 
  B = GenVar("B"); 
  N = GenVar("N"); 
  T = GenVar("T"); 
  C = GenVar("C"); 
  
  if (!mvars) mvars = new TList();
  if (!pvars) pvars = new TList();
  t = GenVar("t");   mvars->append((TAtom*)t);
  o3 = GenVar("o3"); mvars->append((TAtom*)o3);
  o2 = GenVar("o2"); mvars->append((TAtom*)o2);
  o1 = GenVar("o1"); mvars->append((TAtom*)o1);
  b3 = GenVar("b3"); mvars->append((TAtom*)b3);
  b2 = GenVar("b2"); mvars->append((TAtom*)b2);
  b1 = GenVar("b1"); mvars->append((TAtom*)b1);
  n3 = GenVar("n3"); mvars->append((TAtom*)n3);
  n2 = GenVar("n2"); mvars->append((TAtom*)n2);
  n1 = GenVar("n1"); mvars->append((TAtom*)n1);
  r = GenVar("r"); mvars->append((TAtom*)r);
  k = GenVar("k"); mvars->append((TAtom*)k);
  z = GenVar("z"); mvars->append((TAtom*)z);
  y = GenVar("y"); mvars->append((TAtom*)y);
  x = GenVar("x"); mvars->append((TAtom*)x);
  s = GenVar("s"); 

  if (first)
  {
   ss = new TList(TA(s));
   vs = mvars->Clone();
   vs->dmerge(pvars->Clone());
   depend_wdk(vs,ss);
   delete vs;
  }
   mvars->append((TAtom*)s);

  if (!pset) pset=new TList();
 //#define DP(x,d)    (*(dDiff_wdk(new TRIPoly((x)),s,(d))))
 
  pset->append(TA(new TRIPoly(TRIPoly(DPP(x,1) + DPP(y,1) + DPP(z,1) - NP(1)))));
  pset->append(TA(new TRIPoly(PP(k) - DPP(x,2) - DPP(y,2) - DPP(z,2))));
  pset->append(TA(new TRIPoly(PO(k) * PO(r) - NP(1))));
  pset->append(TA(new TRIPoly(PO(k) * PO(n1) - DP(x,2))));
  pset->append(TA(new TRIPoly(PO(k) * PO(n2) - DP(y,2))));
  pset->append(TA(new TRIPoly(PO(k) * PO(n3) - DP(z,2))));

  pset->append(TA(new TRIPoly(PO(k) * PO(b1) - DP(y,1)*DP(z,2) + DP(y,2)*DP(z,1))));
  pset->append(TA(new TRIPoly(PO(k) * PO(b2) + DP(x,1)*DP(z,2) - DP(x,2)*DP(z,1))));
  pset->append(TA(new TRIPoly(PO(k) * PO(b3) - DP(x,1)*DP(y,2) + DP(x,2)*DP(y,1))));

  pset->append(TA(new TRIPoly(PO(o1) - PO(r)*PO(n1) - PO(x))));
  pset->append(TA(new TRIPoly(PO(o2) - PO(r)*PO(n2) - PO(y))));
  pset->append(TA(new TRIPoly(PO(o3) - PO(r)*PO(n3) - PO(z))));

  pset->append(TA(new TRIPoly(PO(t) + PO(n3)*DP(b3,1)+ PO(n2)*DP(b2,1)+ PO(n1)*DP(b1,1))));

  if (!ptset) ptset=new TList();
  ptset->append(TA(C));
  ptset->append(TA(new TList(TA(x),TA(y),TA(z))));
  ptset->append(TA(T));
  ptset->append(TA(new TList(TA(DR(x,1)),TA(DR(y,1)),TA(DR(z,1)))));
  ptset->append(TA(N));
  ptset->append(TA(new TList(TA(n1),TA(n2),TA(n3))));
  ptset->append(TA(B));
  ptset->append(TA(new TList(TA(b1),TA(b2),TA(b3))));
  ptset->append(TA(O));
  ptset->append(TA(new TList(TA(o1),TA(o2),TA(o3))));


  //G_OUT("cu:",pset);
  //G_OUT("pt:",ptset);
}

TRIPoly *wronskian(TList *ps,TVariable *v)
{ TVariable *v1;
  int n = ps->length();
  if (n==0) return new TRIPoly();
  if (n==1) return TP(ps->Part(1)->Copy());
  if (!v)
  {
   TList *vs= TL(depend_relation->Part(2));
   if (!vs) return new TRIPoly();
   v1 = TV(vs->Part(1));
   if (!v1) return new TRIPoly();
  }
  else v1 =v;

  TMatrix * m = new TMatrix(n,n);
  TRIPoly *p;
  for(int i = 0;i < n;i ++)
  {   p = TP(ps->Part(i+1));
	  for(int j = 0;j < n;j ++)
		{
		  m->SetVal(j,i,TA(dDiff_wdk(p,v1,j)));
		}
	}
 // G_OUT("m:",m);
  p = TP(m->det());
  delete m;  
  return p;
}

// the default value of 't' is 0, and 1 for 'n' 
TRIPoly *dDiff_chen(TRIPoly *dp, int n,TVariable *t)
{
	TVariable *v1;
	if(!t)
	{
		TList *vs= TL(depend_relation->Part(2));
		if (!vs) return new TRIPoly();
		v1 = TV(vs->Part(1));
        if (!v1) return new TRIPoly();
        return dDiff_wdk(dp,v1,n);
	}
	return dDiff_wdk(dp,t,n);
}