#include "basetype.h"
#include "stacks.h"
#include "global.h"
#include "lists.h"
#include "poly.h"
#include "pol.h"
#include "sysfunc.h"
#include "express.h"
#include "projection.h"
#include <stdio.h>
#include <iostream.h>
#include <string.h>
#include <new.h>
#include "number.h"
#include "lists.h"
#include "vectors.h"
#include "trpoly.h"
#include "pol.h"
#include "wsolve.h"
#include "geometry.h"

#ifdef _WINDOWS
#include "..\gui\index.h"
#endif

static char div_factor =1;
static char del_linear =0;
static char pri_ind;
static POLY *inits[50];

//
// Provers
//

TList * GEOMETRY::wu_prove(int wtype)
{  TList  *as;
  TRIPoly *ci,*r;
  bool valid = true;
  int i,j,n,k, cn=0;
  TList *res, *vlist;

//wout<<"ps:"; pset->display(); wout << endl;
//wout<<"ds:"; dset->display(); wout << endl;
//wout<<"ps:"; pvars->display(); wout << endl; 
//wout<<"vs:"; mvars->display(); wout << endl;
//wout<<"conc:"; cset->display(); wout << endl;
  
  wout <<endl;
   switch (wtype)
  { 
  case 1: //prove decomposition
  case 3:  //prove decomposition, differential

   vlist = mvars->Clone();
   if (cs_set) vlist->dmerge(pvars->Clone());
 // G_OUT("pset:", pset);
//  G_OUT("vset:", vlist);
   if (wtype==1) res = css_wdk(pset,vlist,dset);
   else          res = dCss_wdk(pset,vlist,dset,0);
   //wout<<"res:"; res->display(); wout << endl;
   //G_OUT("conc:", cset);
   n = cset->length();
   k = res->length();
   cn=0;
   for (j =1; j<= k; j++)
   {  
	 as = (TList*)res->Part(j);
//the following line is added by D.K.Wang and X.F. Chen
//we should set valid to true, otherwise the following
// program is NOT correct after this line.
	 valid=true;
//====================================================

	 // wout<<"as:"; as->display(); wout << endl;
	 for (i = 1; i<= n && valid; i++)
	 {
		 ci = (TRIPoly *)cset->Part(i); 
	     //wout<<"ci:"; ci->display(); wout << endl;
		  if (wtype==1) r = premas_wdk(ci,as,vlist);
		  else     r = dPremas_wdk(ci,as,vlist);
		  if (!(r->IsZero())) valid = false; 
		  delete r;
	 }
	if (valid) cn++;
   }
//the following line is changed by D.K.Wang and X.F. Chen
// the old line is : if (valid) and now is:
   if (cn==k)
//=======================================================
   { wout << "The geometric Statement is valid!"<<endl;
     wout << cn << " components checked."<<endl;
   }
   else
   {
   	wout << "The geometric statement is not confirmed"<<endl;
 	wout << k << " components checked."<<endl;
    wout << "The statement is valid on "<< cn <<" components."<<endl;
   }
  break;
  case 2: //derive
	 if (mvars)
	 { res = css_wdk(pset,mvars,dset);
       //wout<<"res:"; res->display(); wout << endl;
	   TVariable * v1 = (TVariable*)mvars->TAIL();
	   cn=0;
	   k = res->length();
	   for (j =1; j<= k; j++)
	   {    wout << endl;
			as = (TList*)res->Part(j);
			r = (TRIPoly*)as->TAIL();
			if (v1==mainvar_wdk(r,mvars))
			{ cn++;
			  wout <<"Formula " << cn << " :";
			  r->display();
			  wout << endl;
			}
	   }
	   if (cn) 
			{ wout << cn << " formulas found."<<endl<<endl; }
	   else 
			{ wout << " No formulas found."<<endl<<endl; }
	   return res;
	 } 
	 else {wout << "No main variable given."<<endl; }
  break;
 }
  return 0;
}

void GEOMETRY::wuc_prove ()
{   POLS *dp1, *dp2, *wl_set, *wc_set;

    //free_wu();
    //resta();
    init_wu();
	
//  wout<<"ps:"; pset->display(); wout << endl;
//  wout<<"ds:"; dset->display(); wout << endl;
//  wout<<"ps:"; pvars->display(); wout << endl; 
//  wout<<"vs:"; mvars->display(); wout << endl;

	if (!tri_cs(pset))
	{ wout << "The statement is conflict"<<endl;
	  return;
	}
//    wout<<endl << "The triangular set:" ;
//	ps_print(tri_set.nx);

	get_divs();
	wl_set = lt_set();
//	wout <<endl<< "The linear polynomials in the hypotheses:";
//	ps_print(wl_set);

	tri_set.nx=prem_ps_asc(tri_set.nx,wl_set);
//    wout <<endl<< "The modified triangular set:";
//	ps_print(tri_set.nx);

	wc_set = list2ps(cset);
//  wout  <<endl << "The conslusion set:";
//	ps_print(wc_set);
	wc_set = prem_ps_asc(wc_set,wl_set);
//    wout  <<endl << "The modified conslusion set:";
//	ps_print(wc_set);

	pri_ind = 1;
	dp1=wc_set;
	print_ind(dp1->p); wout <<endl;
	for(;dp1 != NULL;dp1=dp1->nx)
	{  dp1->deg=1;
	   //G_OUT("1->p:", dp1->p);
	   dp2=prem_asc_p(dp1->p,tri_set.nx, wl_set);
	   dp1->p = NULL;
	   if (dp2 == NULL) { dp1->deg=1; }
	   else             { dp1->deg=0; put_ps(dp2); }
	  }
 // show conclusion
 dp1=wc_set;
 int count=1;
 while (dp1 != NULL) { if (dp1->deg==0) count=0; dp1=dp1->nx; }

 wout << "\n***************The results****************\n";
 if (count)
	{ //o_result = 1;
	  wout <<" The statement is valid!" << endl;
	}
 else
	{ //pro_result = -1;
	  if (irr_thm()) 
	  { wout <<" The statement is false!" << endl; }
	  else  { wout <<" The statement is not confirmed." << endl; }

	}
}


void GEOMETRY::get_divs()
{ char i,k;
  POLS *dp1,*dp2;

  for (i=0;i<50;i++) inits[i]=NULL;
  k=2;
  dp1=tri_set.nx;
  if (dp1==0) return;
  dp2=dp1->nx;
  while(dp2 != NULL)
  {
	if ( (dp1->deg==1) && (dp2->deg==2))
	  {  inits[++k]=cp_init(dp1->p); dp2->deg=k; }
	else dp2->deg=0;
	dp1=dp2;
	dp2=dp2->nx;
  }

  /*  printf("divisors(%d)\n",k);
    for (i=3;i<=k;i++) {printf("%d:",i); pprint(inits[i]);} 
  */
}

POLS * GEOMETRY::lt_set ()
{   POLS l_set, *dp1, *dp2, *dp3;
	dp1 = &tri_set;   
	dp2=dp1->nx;
	l_set.nx = NULL; 
	dp3 = &l_set;
	while (dp2 != NULL)
	  { if ((ldeg(dp2->p) == 1) && (npoly(init(dp2->p))))
		{ 
			dp1->nx=dp2->nx;
			dp3->nx=dp2;
			dp3=dp3->nx;
			dp2=dp1->nx;
		}
		 else if (plength(dp2->p) > 2)  { dp1=dp2; dp2=dp1->nx; }
		 else if (ldeg(dp2->p) != 1)    { dp1=dp2; dp2=dp1->nx; }
         else { dp1->nx=dp2->nx;
				dp3->nx=dp2;
				dp3=dp2;
				dp2=dp1->nx;
		 }
	  }
	dp3->nx= NULL;
	return l_set.nx;
}


//
// destrucetive for p1
//

TRIPoly *prem(TRIPoly *p1,TRIPoly *p2)
{
  if (p2->var == NULL )	   { put_p(p1); return(get_n(0)); }
  TRIPoly * p0 = prem_wdk(p1,p2,p2->var);
  delete p1;
  return p0;
}

//destructive for p
POLY *GEOMETRY::prem_asc (POLY *p,POLS *asc)
{ POLS *dp1;
  for(dp1=asc;dp1 != NULL;  dp1=dp1->nx)
	 {  
	   p=prem(p,dp1->p); 
  
  }
  return(p);
}

//destructive for ps
POLS *GEOMETRY::prem_ps_asc (POLS *ps,POLS *asc)
{ POLS dt1, *dp1, *dp2;
  POLY * p1;
  if (asc==NULL) return(ps);
  dt1.nx=ps;
  dp1= &dt1; dp2=dp1->nx;
  while (dp2 != NULL)
	 { p1 = prem_asc(dp2->p,asc);       
//	   G_OUT("111:",p1);
       //dp2->p = poly_prim(p1);
       dp2->p = new TRIPoly(p1->ipipp());
	   delete p1;
	   if (pzerop(dp2->p))
		{ dp1->nx=dp2->nx; put_x(dp2->p); put_d(dp2); dp2=dp1->nx; }
	   else { dp1=dp2; dp2=dp1->nx; }
	 }
  return(dt1.nx);
}

// prem-asc_p: the branching version 
POLS *GEOMETRY::prem_asc_p (POLY *p, POLS *asc, POLS * l_set)
{ POLY *a1, *p1, *p2;
  POLS dt1, *dp1, *dp2, *dp3;

  if (p==NULL) return(NULL);
  if (pzerop(p)) { put_p(p); return(NULL); }
  else if (p->var == NULL) { return(get_dt(0,p,NULL)); }

  dt1.nx=get_dt(1,p,NULL);
  /*at.deg=0;  at.nx=asc;  asc0= &at; */
  for (; asc != NULL; asc=asc->nx)
	 { a1=asc->p;
//       G_OUT("a1:",a1);
	   dp1= &dt1; dp2=dp1->nx;
	   while (dp2 != NULL)
	   { p1=dp2->p;
		 if (pzerop(p1))
		 { dp1->nx=dp2->nx;
		   put_x(p1);put_d(dp2); dp2=dp1->nx;
		 }
		 else if (p1->var == NULL) {  dp1=dp2; dp2=dp1->nx; }
		 else if (p1->var == a1->var)
		 {
			/*printf("prem-asc-p1(%d)\n",plength(p1));  */
			p2=prem_ev(p1,a1);
			/*printf("prem-asc-p2(%d)\n",plength(p2));  */
			dp2->p=new TRIPoly(p2->ipipp());
			delete p2;
			/*printf("prem-asc-p3(%d)\n",plength(dp2->p));  */
			/*dp2->p=cprim(prem_ev(p1,a1)); */
			/* printf("prem-asc-p1\n"); pprint(dp2->p);pprint(a1);   */
			if ( dp2->deg==1)
			{ if (pzerop(dp2->p))
				{ if (pri_ind == 1)
					{ print_ind(dp2->p); 
						pri_ind = 0; }}
				  else { print_ind(dp2->p);   }
				}
				if (pzerop(dp2->p))
				{ dp1->nx=dp2->nx;
				put_x(dp2->p);put_d(dp2); dp2=dp1->nx;
				}
			else
			{ 
//			 if (max_termp)
//		  { tem=plength(dp2->p);//
//			 if (tem > max_term) max_term = tem;
//		  }
				if (div_factor && asc->deg > 2)
			{
/*		    printf("1111(%d)\n",asc->deg); pprint(inits[asc->deg]);  */
				 p2 = mv_mfact(prem_asc(cp_poly(inits[asc->deg]),l_set));
				 dp2->p=ppdiv(dp2->p,p2);
				 put_p(p2);
				}
			dp1=dp2; dp2=dp1->nx;
			}
		 }
       else if (vless(a1->var,p1->var))
		{ dp3=p1->ups;  
	      dp3->deg = 1;
		  while (dp3->nx != NULL) { dp3=dp3->nx; dp3->deg = 1; }
		  dp3->nx=dp2->nx;
		  dp1->nx=p1->ups;
		  put_d(dp2);
		  dp2=dp1->nx;
		  put_x(p1);
	   }
		else { dp1=dp2; dp2=dp1->nx; } 
	   }
	} 
  return(dt1.nx);
}

POLS *GEOMETRY::nonzerops (POLS *dp)
{ POLS	dt1, *dp1, *dp2;
  dt1.nx=dp;
  dp1= &dt1; dp2=dp1->nx;
  while (dp2 != NULL)
	{ if (pzerop(dp2->p))
	  { dp1->nx=dp2->nx; put_x(dp2->p); put_d(dp2); dp2=dp1->nx; }
	  else { dp1=dp2; dp2=dp1->nx; }
	}
  return(dt1.nx);
}


POLY *GEOMETRY::mv_mfact(POLY *p1)
{ POLY pp1;

/*  if (pzerop(p1)) return(p1);
  else if (p1->var == NULL) { put_p(p1); return(get_n(1L)); }
  else
	 {  pp1 = p1->ippp(p1->var); 
		delete p1;
		p1 = new TRIPoly(pp1);
		return p1;
	 }
*/
return p1;	
}



//
// Triangilization Procedure for equations from a CS
//

bool GEOMETRY::tri_cs(TList * ps)
{
  TVariable *v1, *v2;
  TList * bs = new TList(), *ps1;
  TRIPoly *p0, *p1, *p2, *p3, *p4;
//  G_OUT("ps:",ps);
  TList * v_set = mvars->Inverse();

  for (int i=1;i<=v_set->length();)
  {   
	  v1 = (TVariable *)v_set->Part(i);
//	  G_OUT("v1:",v1);
//	  G_OUT("ps:",ps);
	  ps1 = ps_in_var(ps,v1,mvars);
//	  G_OUT("ps1:",ps1);
	  switch(ps1->length())
	  {
		 case 0: break;
		 case 1:
			 p1 = (TRIPoly*)ps1->Part(1);
			 if (!eq_l(cp_poly(p1),v2)) goto ext;
		     break;
	     case 2:			 
	         //G_OUT("v2:",v2);
			 p1 = (TRIPoly*)ps1->Part(1);
			 p2 = (TRIPoly*)ps1->Part(2);
			 // ax + by +c 
			 if (p2->Degree(v1)!=1) { p0=p1;p1=p2;p2=p0;}
			 if (p1->Degree(v1) ==1 && p2->Degree(v1)==1) 
			 {
				if(!eq_ll(p1,p2)) goto ext;
			 }
			 else if (p1->Degree(v1) ==1 && p2->Degree(v1)==2) 
			 {
				if(!eq_lq(p1,p2)) goto ext;
			 }
			else if (p1->Degree(v1) ==2 && p2->Degree(v1)==2) 
			 {
				if(!eq_qq(p1,p2)) goto ext;
			 }
			else { goto ext;}
			break;
		default:
			 goto ext; break;
	  }
	  v2 = v1; i++;
	  //G_OUT("bs:",bs);
  }
  return true;

ext:
  //delete tri>-set;
  return false;
}

// one equation
bool GEOMETRY::eq_l (POLY *q1,TVariable * v2)
{ POLS *dp1;
  POLY *pp1;
  POLY *p1 = q1;

  pp1 = prem_asc(cp_init(p1),tri_set.nx);
  if (!pzerop(pp1))
	 {  dp1=tri_set.nx;
		tri_set.nx = get_dt(0,mv_mfact(p1),dp1);
		return true;
	 }
  put_p(pp1);
  p1=rem(p1);
  if (p1->Degree(v2) == 0)
  { put_p(p1);
    return false;
  }
  pp1 = prem_asc(cp_init(p1),tri_set.nx);
  if (!pzerop(pp1))
	 { dp1=tri_set.nx;
		tri_set.nx = get_dt(0,mv_mfact(p1),dp1);
		return true;
	 }
  put_p(pp1);
  return false;
}

bool GEOMETRY::eq_ll (POLY *q1,POLY *q2)
{ POLY *p3,*p4;
  POLY *p1 = cp_poly(q1);
  POLY *p2 = cp_poly(q2);
/*
  printf("\eqll1(%ld)(%ld)\n",p1->var,p2->var);
  printf("\neqll2(%d)\n",p1->var==p2->var);
  pprint(p1);pprint(p2);
*/
//  if (p1->var == p2->var)
  if (pls(p2,p1)) { p3=p1;p1=p2;p2=p3;}
  p4 = prem_asc(cp_init(p1), tri_set.nx);
  if (pzerop(p4))
  { p1=prem(p1,p2);
	if (pzerop(p1)) {gerror(0,"eq_ll: two intersection lines are parallel\n"); return false;}
	tri_set.nx = get_dt(2,mv_mfact(p1),tri_set.nx);
	tri_set.nx = get_dt(1,mv_mfact(p2),tri_set.nx);
  }
  else
  { p2=prem(p2,p1);
	if (pzerop(p2)) {gerror(0,"eq_ll: two intersection lines are parallel\n"); return false; }
    tri_set.nx = get_dt(2,mv_mfact(p2),tri_set.nx);
	tri_set.nx = get_dt(1,mv_mfact(p1),tri_set.nx);
  }
  put_p(p4);
  return true;
}
 
/*  else if (vless(p2->var,p1->var))
	 {  tri_set.nx = get_dt(0,mv_mfact(p2),tri_set.nx);
		tri_set.nx = get_dt(0,mv_mfact(p1),tri_set.nx);
	 }
  else
	 { tri_set.nx = get_dt(0,mv_mfact(p1),tri_set.nx);
	   tri_set.nx = get_dt(0,mv_mfact(p2),tri_set.nx);
	 }
	 */

bool GEOMETRY::eq_lq (POLY *q1,POLY *q2)
{ POLY *p3;
  POLY *p1 = cp_poly(q1);
  POLY *p2 = cp_poly(q2);
  p3 = prem_asc(cp_init(p1),tri_set.nx);
  if (pzerop(p3))
  { p1=rem(p1);
	tri_set.nx = get_dt(0,mv_mfact(p1),tri_set.nx);
	tri_set.nx = get_dt(0,mv_mfact(p2),tri_set.nx);
  }
  else
  { p2=prem(p2,p1); //factorization
	 if (pzerop(p2)) {gerror(0,"eq_lq: two intersection lines are parallel\n"); return false; }
	 tri_set.nx = get_dt(2,mv_mfact(p2),tri_set.nx);
	 tri_set.nx = get_dt(1,mv_mfact(p1),tri_set.nx);
  }
 put_p(p3);
 return true;
}

bool GEOMETRY::eq_qq (POLY *q1,POLY *q2)
{ POLY *pp1;
  POLY *p1 = cp_poly(q1);
  POLY *p2 = cp_poly(q2);
  pp1=pminus(p2,cp_poly(p1));
  p2=prem(p1,pp1);
  tri_set.nx = get_dt(2,p2,tri_set.nx);
  tri_set.nx = get_dt(1,pp1,tri_set.nx);
  return true;
}

//
void GEOMETRY::init_wu()
{
int i;
tri_set.nx  = NULL;
div_set.nx  = NULL;
for(i=0;i<50;i++)inits[i] = NULL;
}

void GEOMETRY::free_wu()
{ POLS *ps1,*ps2;
  int i;

  put_ps(tri_set.nx);
  tri_set.nx  = NULL;

 {  for (i=0;i<50;i++)
		{ /*printf("(%d)\n", inits[i]); */
		  if (inits[i] != NULL)
			{ put_p(inits[i]);
			  inits[i] = NULL;
			}
		}
	 }
}


bool GEOMETRY::irr_thm ()
{ PT p[9];
  int j;
  bool th_p = false;
/*
  for (int ptn=1;ptn<=cons_no;ptn++)
  { for (j=0;j<=5;j++) p[j+1]=APTS(ptn,j);
	 switch(ATYPE(ptn))
	 { case C_I_LC:
		 if (p[2]==p[4] || p[1]==p[4]) { th_p=true; break; }
		 break;
		case C_I_PC:
		case C_I_TC:
		 if (p[1]==p[5]) { th_p=true; break; }
		 break;
		case C_I_CC:
		 if (p[2]!=p[4]) { th_p=true; break; }
		 break;
		case C_I_LR:
		case C_I_CR:
		case C_I_RR:
			 th_p=true; break;
	 }
  }
  */
  return th_p;
}



void print_ind (POLY *p)
{ VAR *v;
  if (p == NULL) wout << "()";
  else if (pzerop(p))   { wout<< "(0,0,0)"; }
  else if (p->var == 0) { wout<< "(0,0,1)"; }
  else { v=p->var;
		{ 
		  wout << "(";
		  v->display();
		  wout << ", " << ldeg(p) << "," << plength(p) << ")" << endl;
		}
	 }
}

// end of the file