#ifndef __GEOMETRY__
#define __GEOMETRY__

#include <stdio.h>
#include <iostream.h>
#include <string.h>
#include <new.h>

#include "atom.h"
#include "stacks.h"
#include "global.h"
#include "express.h"
#include "number.h"
#include "lists.h"
#include "pol.h"
#include "wsolve.h"
#include "projection.h"
#include "sysfunc.h"

#ifdef _WINDOWS
#include "../gui/index.h"
#endif

#define PT int
#define GEOMETRY geom
#define POINT    gpoint
#define SCURVE  40

typedef TDITerm* POLSPT;

//
// For the area method
//

class ELIM
{
public:
  VAR  *v;
  POLY *p1, *p2;
//  CO  *co;
  class ELIM *nx;
public:
    ELIM() { v=0; p1=p2=0;nx=0; }
    ELIM(VAR *v1, POLY *a1, POLY *a2) {v=v1; p1=a1; p2=a2; nx=NULL; }

	~ELIM() { if(p1) put_p(p1); if (p2) put_p(p2) ; }

    void display();

//	virtual TAtom* Copy() { return NULL;};
//	virtual DataType TypeID() const { return ELIMType; } ;
//	virtual TAtom* 	eval() { return NULL; };

};


class GR // gr_term
{
public:
  NUM  c1;
  POLS *ps1;
  NUM  c2;
  POLS *ps2;
  int c;    /* = -1: 
               = 0construction */
  union
    {
      ELIM *el;       /* eliminatns */
      POLS *ps;                 /* simplicifiers*/
    } u;
  GR *nx;
public:
	GR() {ps1=ps2=0; nx = 0;}
	GR(NUM n1,  POLS *p1,  NUM n2, POLS *p2, int i, GR *n=0) 
	{ c1 = n1; c2 = n2; ps1 = p1; ps2 = p2; c = i; nx =n; }
   ~GR() {}


	void display();
//	void delete();
	
};

/*  gr.c */
ELIM *rev_elim(ELIM *v);
GR *cp_gr(GR *gr);
GR *mk_gr(NUM c1,  POLS *ps1, NUM c2, POLS *ps2, int c, GR *nx);
GR *mk_gr1(NUM c1,  POLY *p1, NUM c2, POLY *p2);
int gr_length(GR *gr);
GR *simp_gr(GR *gr);


class geom {
  public:
   //char diff;
   char *text;
   TList *pred_set;     // predicate lists in geometric form
   TList *deg_set;      // ndg lists in geometric form
   TList *conc_set;     // conslusion list in geometric form
   TList *cs_set;       // construction list in geometric form
   TList *pvars;        // Free Parameters 
   TList *mvars;        // Dependent variebles
   TList *ptset;        // point list   : A (x, y)
   TList *pset;         // Equation part IS FROM pred-Set
   TList *dset;         // Non-degenarte part IS FROM deg_set
   TList *cset;         // conclusion polynomials IS FROM conc_set
   public:
     geom();
     geom(TList *,int gtype=0);
     geom(char *);    
     ~geom();

  public:

  //geom.cpp
    void GenCoor(TList * css);
    void AddCoor(TVariable *v1, int k);
    TList * Cs2Pd(TList *);
    TList * GenPd(char *nm,TVariable* p1,TVariable* p2,TVariable* p3,TVariable* p4,TVariable*,TVariable*);
    TList * CsNdg(TList *cs);
	TList * GenNdg(TList* o1,TList* o2);
	TList * wu_prove(int);
    void geom_check();

    TList *PdForm();
    TList *CsForm();
	TList * GetPd(TVariable* v, TList* c);

    TList *AllPts();


  //geom_n
	void ger1 (char *ch, int no);
	int charp (char ch);
	int nump (char ch);
	int textp (char ch);
	int verb(char *ch);
	void get_np(char nm[]);
	void get_tri(char nm[]);
	void file_to_gl ();
	void buffer_to_gl (char *nm);
	void aux_words(int nl0);
	int spoint (char *ch);
	int mpoint (char *ch);
	int tpoint (char *ch);
	int fpoint (char *ch);
	void write_sline(char *ch);
	void write_gline(char *ch, int mk);
	int line (int k, int ti);
	void look_triangle(int gn);
	int find_cir(char *o, char *p);
	void add_cir0(char *o, char *p);
	void add_cir1(char *p1, char *o, char *p);
	int on_cir_op(char *o, char *p1, char *p2);
	int circle(int k, int ti);
	int cccircle (int k, int ti);
	int incircle (int k, int ti);
	int npcircle (int k, int ti);
	int inter(int k, int ti);
	int cinter_lc (int k, int gn1);
	int on_line(int k, int no1, int gn1);
	int	on_bline(int k, int no1, int gn1);
	int on_circle(int k, int no1, int gn1);
	int on_circum(int k, int no1, int gn1);
	int sta_to_cons ();
	void lang_to_cons (char *);
	void read_lang(char *);

	void gterm_to_tlist ();
	TList * cs_obj(char *nm,int gn,int no);
	void add_to_cs(int gn,int no, TList *cs);
	void add_to_cs1(char *nm1, char *nm2,TList *o,TList *cs);
	void add_to_cs2(char *nm1, char *nm2,TList *o1,TList *o2,TList *cs);


// cons.cpp
	void save_cons ();


/*
void read_cons (char *ch);
void show_cons();

void print_gterm ();
void print_cons ();
char in_ps(PT pt, PT pt1);
PT in_ls(PT p1, PT p2, PT pt2);
PT in_ss(PT pt1, PT pt2);
char *pt_name(PT p);
void proof_file ();
int test_read(char rline[]);
void file_to_term (char *ch);
void buffer_to_gterm (char *rpt);
int fptno(int no);
float c2num(int no);
void new_pt(int type, char *nm);
void new_apt(int type, char *nm, PT p1, PT p2, PT p3, PT p4, PT p5, PT p0);
void prog (int type);
void prog1(int type, int n1);
int ch2no (char* ch);
void prog2(int n1);
void prog20(int n1);
void prog3(int type, int n1);
void prog4(int type, int n1);
void prog5(int type, int n1);
void gterm_to_inner();
void gterm_conc(); 
*/

/*  conc.c */
	int  cong_conc(int gn1);
	int  eq_conc(int gn, int gn1);
	int  eqs_conc(int gn, int gn1);
	int  eqs_comp(int gn, int ti);
	int  conc_tang(int gn, int gn1);
	void tang_lc(char *lp[], char *cp[]);
	int  verb_conc(int k);
	int  lang_conc(int gn);


	//geom_p.cpp
/*TRIPoly*Coll (POINT *p1, POINT *p2, POINT *p3);
TRIPoly*Para (POINT *p1, POINT *p2, POINT *p3, POINT *p4);
TRIPoly*Perp (POINT *p1, POINT *p2, POINT *p3, POINT *p4);
TRIPoly*Yratio (POINT *p1, POINT *p2, POINT *p3, POINT *p4, POINT *p5, POINT *p6, POINT *p7, POINT *p8);
TRIPoly*Xratio (POINT *p1, POINT *p2, POINT *p3, POINT *p4, POINT *p5, POINT *p6, POINT *p7, POINT *p8);
TRIPoly*Eqptx (POINT *p1, POINT *p2);
TRIPoly*Eqpty (POINT *p1, POINT *p2);
TRIPoly*Midx (POINT *p1, POINT *p2, POINT *p3);
TRIPoly*Midy (POINT *p1, POINT *p2, POINT *p3);
TRIPoly*Cong (POINT *p1, POINT *p2, POINT *p3, POINT *p4);
TRIPoly*Acong (POINT *p1, POINT *p2, POINT *p3, POINT *p4, POINT *p5, POINT *p6);
TRIPoly*Tcc (POINT *o1, POINT *p1, POINT *o2, POINT *p2);
TRIPoly*Pratiox (POINT *y, POINT *w, POINT *u, POINT *v, TRIPoly*p1, TRIPoly*p2);
TRIPoly*Pratioy (POINT *y, POINT *w, POINT *u, POINT *v, TRIPoly*p1, TRIPoly*p2);
TRIPoly*Tratioc (POINT *y, POINT *w, POINT *u, POINT *v, TRIPoly*p1, TRIPoly*p2);

TRIPoly *Cratio(TRIPoly *var,POINT *p1,POINT *p2,POINT *p3,POINT *p4);
TRIPoly *Xratio(TRIPoly *r,POINT *p1,POINT *p2,POINT *p3,POINT *p4);
TRIPoly *Yratio(TRIPoly *r,POINT *p1,POINT *p2,POINT *p3,POINT *p4);
TRIPoly *Sqdis(POINT *p1, POINT *p2);
TRIPoly *Dist(TList * points);
TRIPoly *Area(POINT *n1,POINT *n2,POINT *n3);
TRIPoly *GetArea(TRIPoly *var,POINT *p1,POINT *p2,POINT *p3);
TRIPoly *Areas(TList *points);
TRIPoly *GetAreas(TList * points);
TRIPoly *Pointlinedis(POINT *p1,POINT *p2,POINT *p3,TRIPoly *d);
*/
TList *EqProd(TList *p1,TList *p2,TList *p3,TList *p4,
				TList *p5,TList *p6,TList *p7,TList *p8);

TList *Eqx(TList *p1,TList *p2);
TList *Eqy(TList *p1,TList *p2);


TAtom *TreatVariable(TVariable *var,TList *pointList);
TList *GetParameterList(TList *para,TList *pointList);
TList * GetPoly(TList *nList,TList *pointList);
void	 GetPSAndDS(TList *,TList *,TList *);
TList *AlgForm();

TList *GetArea(TList *p1,TList *p2,TList *p3);
TList *OneArea(TRIPoly *var,TList *p1,TList *p2,TList *p3);
TList *MultiArea(TList *points);
TList * Area(TList * points);
TList * Collinear(TList *p1,TList *p2,TList *p3);
TList *Cocyclic(TList *p1,TList *p2,TList *p3,TList *p4);
TList * Cratio(TRIPoly *var,TList *p1,TList *p2,TList *p3,TList *p4);
TList *Sqdistance(TList *p1,TList *p2);
TList *Distance(TList * points);
TList *Perpendicular(TList *p1,TList *p2,TList *p3,TList *p4);
TList *Eqangle(TList *p1,TList *p2,TList *p3,TList *p4);
TList *Eqdistance(TList *p1,TList *p2,TList *p3,TList *p4);
TList *Eqtangent(TList *p1,TList *p2,TList *p3,TList *p4);
TList *Midx(TList *p1,TList *p2,TList *p3);
TList *Midy(TList *p1,TList *p2,TList *p3);
TList *MultiMinus(TList *points);
TList *MultiProduct(TList *points);
TList *MultiSum(TList *points);
TList *NPower(TRIPoly *poly,int num);
TList *Parallel(TList *p1,TList *p2,TList *p3,TList *p4);
TList *Pointlinedis(TList *p1,TList *p2,TList *p3,TRIPoly *d);
TList *Xratio(TRIPoly *r,TList *p1,TList *p2,TList *p3,TList *p4);
TList *Yratio(TRIPoly *r,TList *p1,TList *p2,TList *p3,TList *p4);
TList *sc_pla(TList *p1);
TList *sc_cir(TList *p1);
TList *sc_sph(TList *p1);
TList *sc_hel(TList *p1);
// added predicates for diff. according to MMRP 1991,6 P38.
TList *vecplus(TList *v1,TList *v2);
TList *multivecplus(TList *veclist);
TList *vecminus(TList *v1,TList *v2);
TList *multivecminus(TList *veclist);
TList *vecneg(TList *v1);
TList *vecnumprod(TList *v1,TRIPoly *poly);
TRIPoly *vecinprod(TList *v1,TList *v2);
TList *vecexprod(TList *v1,TList *v2);
TRIPoly *vecmixprod(TList *v1,TList *v2,TList *v3);
TRIPoly *dDiff_chen(TRIPoly *dp, int n=1,TVariable *t=0);
TList *pDiff_chen(TList *point,int n=1,TVariable *t=0);
TList *v_para(TList *v1,TList *v2);
TList *cons_dir(TList *v1);
TList *v_norm(TList *v1,TRIPoly *p);
TList *cons_len(TList *v1);
TList *cons_v(TList *v1);
TList *cons_var(TList *v1);
TList *v_perp(TList *v1, TList *v2);
TList *perp_fix_line(TList *v1);
TList *co2_linear(TList *n,TList *v1,TList *v2);
TList *fix_co2_linear(TList *n,TList *v1);
TList *co3_linear(TList *v1,TList *v2,TList *v3);
TList *fix_co3_linear(TList *v1,TList *v2);
TList *co2_plane(TList *n,TList *v1,TList *v2);
TList *fix_co2_plane(TList *n,TList *v1);
TList *co3_plane(TList *v1,TList *v2,TList *v3);
TList *fix_co3_plane(TList *v1,TList *v2);
TList *co4_plane(TList *v1,TList *v2,TList *v3,TList *v4);
TList *fix_co4_plane(TList *v1,TList *v2,TList *v3);
TList *angle(TList *v1,TList *v2,TRIPoly *poly);
TList *fix_angle(TList *v1);
//space curves
TList *curve(TList *v1,TRIPoly *k0,TRIPoly *k1,TRIPoly *t1);
TList *curve_arc(TList *v1,TRIPoly *k1,TRIPoly *t1);
TList *curve_norm(TList *v1);
TList *curve_binorm(TList *v1);
TList *fix_line(TList *v1);
TList *fix_plane(TList *v1);
TList *fix_plane_o(TList *v1);
TList *fix_sph(TList *v1);
TList *fix_helix(TList *v1);
		
//wu's method
POLS div_set,tri_set;

void wuc_prove();
bool tri_cs(TList * ps);
bool eq_l (POLY *p1,TVariable *v);
bool eq_ll (POLY *p1, POLY *p2);
bool eq_lq (POLY *p1, POLY *p2);
bool eq_qq (POLY *p1, POLY *p2);

void get_divs(void);
POLS *lt_set ();
POLY *prem_asc (POLY *p, POLS *asc);
POLS *prem_ps_asc (POLS *ps, POLS *asc);
POLS *prem_asc_p (POLY *p, POLS *g21,POLS *f21);
POLS *nonzerops (POLS *dp);
POLY *mv_mfact(POLY *p1);
void init_wu();
void free_wu();
bool irr_thm ();


//scurve
void init_scurve(bool firt);
};

TRIPoly *wronskian(TList *p1, TVariable *v=0);

TRIPoly *dDiff_chen(TRIPoly *dp, int n=1,TVariable *t=0);

int strlen1 (char *sp);
int strlen2 (char *sp);
void strcpy1 (char *s1, char *s2);
void strcpy2 (char *s1, char *s2);

void prove(TList *stat);
void prove(char *stat);
void derive(TList *stat);

int GetFunctionNumber(char *function);
bool ispred(TList* o);
bool isobj(TList* o);
bool iscons(TList *c);

TList *geom_sysfun(TAtom *example,int);
TList * expandinternal(TList * l);


TList *ps2list(POLS *ps);
POLS *list2ps(TList *ls);

POLS *ps_member(POLY *p, POLS *ps);
bool ps_subset(POLS *ps1, POLS *ps2);
bool pss_cont(POLS *ps1, POLS *ps2);
POLS *ps_union(POLS *ps1, POLS *ps2);
POLS *ps_diff(POLS *ps1, POLS *ps2);
POLS *ps_append(POLS *ps1, POLS *ps2);
POLS *ps_inter(POLS *ps1, POLS *ps2);
//POLS *ps_diff2(POLS *ps1, POLS *ps2);
POLY *ps_plus  (POLS *dp);
POLY *ps_times  (POLS *dp);
POLS *ps_div(POLS *ps1,POLS *ps2, POLSPT *ps_d1, POLSPT *ps_d2);
POLS *ps_red (POLS *ps);
int ps_term1 (POLS *dp);
POLS *ps_simp (POLS *ps);
POLS *vfactor(POLY *p);
void ps_print(POLS *ps); 
void print_ind (POLY *p);

void free_p (POLY *p1);
void free_ps (POLS *dp0);

///////////////////////////////////
// The area method
//////////////////////////////////

extern GR proof, *last_pr;

bool aless(VAR* v1, VAR* v2);

void free_mem(void);
void free_proof (void);

//geom_a.cpp

void area_prove (GEOMETRY *);
int end_pr (void);
void print_end (void);
void print_t(void);
void print_f(void);
int area_gr(GR *gr);
int area_p(POLY *p);
int vec_gr(GR *gr);
int vec_p(POLY *p);
int str_p(POLY *p);
void conc_gr(int c1,  POLY *p1, int c2, POLY *p2);
void pconc (GEOMETRY *);

void conc_coll(VAR *p1,VAR *p2,VAR *p3);
void conc_eqproduct(VAR *p1, VAR *p2,VAR *p5,VAR *p6,
					VAR *p7,VAR *p8,VAR *p3,VAR *p4);
void pconc_11(VAR * p0, VAR * p1, VAR * p2, VAR * p3);
ELIM *mk_elim(VAR *v, POLY *p1, POLY *p2);

void pe_gr (TList * ptn, int c=0);
POLY *pe_p(POLY *p, TList * c, int ct, PT d);
ELIM * pe_v_c (VAR *v, TList *c);
ELIM * pe_v_on (VAR *v, TList *c,TList *o);
ELIM * pe_v_inter (VAR *v, TList *c, TList *o1, TList *o2);

int test_pt(TList * ptn, int);
int elim_varp (VAR *v, TList* pt);
int c_pt(PT pt, PT c);

POLY *eprem (POLY *p, ELIM *e);


POLY *pe_pv(POLY *p, PT c, PT d);
int test_pv(VAR *v, PT c);
ELIM *pe_v_nc (VAR *v, int ptn);

POLY *mk_trim (VAR *v);

TVariable * mk_var(int nm, TVariable *p1,TVariable *p2,TVariable *p3,TVariable *p4);
POLY *geval(VAR *var, TVariable * y, TVariable * p);
TRIPoly *trim_r (TVariable * p1, TVariable * p2, TVariable * p3, TVariable * p4);
TRIPoly *trim_a (TVariable * p1, TVariable * p2, TVariable * p3, TVariable * p4);
TRIPoly *trim_g (TVariable * p1, TVariable * p2, TVariable * p3, TVariable * p4);
TRIPoly *trim_f(TVariable * p1, TVariable * p2, TVariable * p3, TVariable * p4);
TRIPoly *trim_vec (TVariable * p1, TVariable * p2);
TRIPoly *trim_l (TVariable * p1, TVariable * p2);
TRIPoly *trim_s (TVariable * p1, TVariable * p2);
TRIPoly *trim_c (TVariable * p1, TVariable * p2);


/*  elima.c */

ELIM *rcir (PT a, PT b, PT c);
ELIM *pe_v_cent (VAR *var, PT y, PT a, PT b, PT c);
ELIM *orth_md (VAR *var, PT y, PT a, PT b, PT c);
ELIM *pe_r_orth (VAR *var, PT n1, PT n2, PT n3, PT n4, PT y, PT a, PT b, PT c);
ELIM *pe_a_orth (VAR *var, PT n1, PT n2, PT n3, PT n4, PT y, PT a, PT b, PT c);
ELIM *pe_g_orth (VAR *var, PT n1, PT n2, PT n3, PT n4, PT y, PT a, PT b, PT c);
ELIM *circum_md (VAR *var, PT y, PT a, PT b, PT c);
ELIM *pe_a_circum (VAR *var, PT n1, PT n2, PT n3, PT n4, PT y, PT a, PT b, PT c);
ELIM *pe_g_circum (VAR *var, PT n1, PT n2, PT n3, PT n4, PT y, PT a, PT b, PT c);
ELIM *pe_r_circum (VAR *var, PT n1, PT n2, PT d1, PT d2, PT y, PT a, PT b, PT c);
ELIM *incent_md (VAR *var, PT y, PT i, PT a, PT b);
ELIM *pe_a_incent (VAR *var, PT n1, PT n2, PT n3, PT n4, PT y, PT i, PT a, PT b);
ELIM *pe_g_incent (VAR *var, PT n1, PT n2, PT n3, PT n4, PT y, PT i, PT a, PT b);
ELIM *pe_r_incent (VAR *var, PT n1, PT n2, PT d1, PT d2, PT y, PT i, PT a, PT b);


/*  eliml.c */

ELIM *lratio_md11 (VAR *var,VAR* y,VAR* u,VAR* v,POLY *p1,POLY *q1,POLY *r);
ELIM *lratio_md1 (VAR *var, TVariable * y, TVariable * u, TVariable * v, POLY *p1, POLY *p2, POLY *q1, POLY *q2);
ELIM *lratio_md2 (VAR *var, TVariable * y, TVariable * u, TVariable * v, POLY *p1, POLY *p2, POLY *q1, POLY *q2);
ELIM *pratio_md1 (VAR *var, TVariable * y, TVariable * w, TVariable * u, TVariable * v, POLY *p1, POLY *p2);
POLY *geval1(VAR *var, TVariable * y, TVariable * v, TVariable * u);
ELIM *pratio_md2 (VAR *var, TVariable * y, TVariable * w, TVariable * u, TVariable * v, POLY *p1, POLY *p2);

ELIM *pe_v_pratio (VAR *var, TVariable* y, TVariable* w, TVariable* u, TVariable* v, POLY *p1, POLY *p2);
ELIM *pe_r_pratio(VAR *var, TVariable * n2, TVariable * n1, TVariable * d2, TVariable * d1, TVariable * y, TVariable * w, TVariable * u, TVariable * v, POLY *p1, POLY *p2);
ELIM *pe_a_pratio(VAR *var, TVariable * n1, TVariable * n2, TVariable * n3, TVariable * n4, TVariable * y, TVariable * w, TVariable * u, TVariable * v, POLY *p1, POLY *p2);
ELIM *pe_g_pratio(VAR *var, TVariable * n1, TVariable * n2, TVariable * n3, TVariable * n4, TVariable * y, TVariable * w, TVariable * u, TVariable * v, POLY *p1, POLY *p2);
ELIM *pe_v_ipp(VAR *var, TVariable * y, TVariable * w, TVariable * u, TVariable * v, TVariable * r, TVariable * p, TVariable * q);
ELIM *pe_r_ipp (VAR *var, TVariable * n1, TVariable * n2, TVariable * d1, TVariable * d2, TVariable * y, TVariable * w, TVariable * u, TVariable * v, TVariable * r, TVariable * p, TVariable * q);
ELIM *pe_a_ipp (VAR *var, TVariable * n1, TVariable * n2, TVariable * n3, TVariable * n4, TVariable * y, TVariable * w, TVariable * u, TVariable * v, TVariable * r, TVariable * p, TVariable * q);
ELIM *pe_g_ipp (VAR *var, TVariable * n1, TVariable * n2, TVariable * n3, TVariable * n4, TVariable * y, TVariable * w, TVariable * u, TVariable * v, TVariable * r, TVariable * p, TVariable * q);
ELIM *pe_r_ill (VAR *var, TVariable * n1, TVariable * n2, TVariable * d1, TVariable * d2, TVariable * y, TVariable * u, TVariable * v, TVariable * i, TVariable * j);
ELIM *pe_a_ill (VAR *var, TVariable * n1, TVariable * n2, TVariable * n3, TVariable * n4, TVariable * y, TVariable * u, TVariable * v, TVariable * i, TVariable * j);
ELIM *pe_g_ill (VAR *var, TVariable * n1, TVariable * n2, TVariable * n3, TVariable * n4, TVariable * y, TVariable * u, TVariable * v, TVariable * i, TVariable * j);
ELIM *pe_vec_ill (VAR *var, TVariable * n1, TVariable * n2, TVariable * y, TVariable * u, TVariable * v, TVariable * i, TVariable * j);
ELIM *pe_r_ilp (VAR *var, TVariable * n1, TVariable * n2, TVariable * d1, TVariable * d2, TVariable * y, TVariable * u, TVariable * v, TVariable * r, TVariable * p, TVariable * q);
ELIM *pe_a_ilp (VAR *var, TVariable * n1, TVariable * n2, TVariable * n3, TVariable * n4, TVariable * y, TVariable * u, TVariable * v, TVariable * r, TVariable * p, TVariable * q);
ELIM *pe_g_ilp (VAR *var, TVariable * n1, TVariable * n2, TVariable * n3, TVariable * n4, TVariable * y, TVariable * u, TVariable * v, TVariable * r, TVariable * p, TVariable * q);


/*  elimm.c */

ELIM *pe_v_fpt(VAR *v, TVariable * pt);


POLY *trim_fa(TVariable * p1, TVariable * p2, TVariable * p3);
POLY *fpt_a(TVariable * n1, TVariable * n2, TVariable * n3);
ELIM *pe_a_fpt(VAR *var, TVariable * n1, TVariable * n2, TVariable * n3, TVariable * n4);


POLY *x(TVariable * n);
POLY *y(TVariable * n);
POLY *area_t(TVariable * n1, TVariable * n2, TVariable * n3);
POLY *area_q(TVariable * n1, TVariable * n2, TVariable * n3, TVariable * n4);
POLY *dis_xy(TVariable * n1, TVariable * n2);
POLY *py_q(TVariable * n1, TVariable * n2, TVariable * n3, TVariable * n4);
POLY *oarea(TVariable * p1, TVariable * p2, TVariable * p3);
POLY *opy(TVariable * p1, TVariable * p2, TVariable * p3);
ELIM *pe_circle (VAR *var, TVariable * p1, TVariable * p2, TVariable * p3, TVariable * p4);
POLY *sc(TVariable * n);
POLY *cc(TVariable * n);
ELIM *pe_sc (VAR *var, TVariable * p1, TVariable * p2);
ELIM *pe_v_bline(VAR *var, TVariable * y, TVariable * u, TVariable * v);
ELIM *pe_g_3bline(VAR *var, TVariable * n1, TVariable * n2, TVariable * n3, TVariable * n4, TVariable * y, TVariable * u, TVariable * v);
ELIM *pe_v_square(VAR *var, TVariable * p1, TVariable * p2, TVariable * p3, TVariable * sn);
ELIM *pe_v_ptri(VAR *var, TVariable * p1, TVariable * p2, TVariable * p3);
ELIM *pe_v_ntri(VAR *var, TVariable * p1, TVariable * p2, TVariable * p3);
ELIM *pe_v_sim(VAR *var, TVariable * p1, TVariable * p2, TVariable * p3, TVariable * q1, TVariable * q2, TVariable * q3);


/*  elimt.c */

ELIM *tratio_a_md1 (VAR *var, TVariable * y, TVariable * w, TVariable * u, TVariable * v, POLY *p1, POLY *p2);
ELIM *tratio_g_md1 (VAR *var, TVariable * y, TVariable * w, TVariable * u, TVariable * v, POLY *p1, POLY *p2);
ELIM *tratio_md2 (VAR *var, TVariable * n3, TVariable * n4, TVariable * y, TVariable * w, TVariable * u, TVariable * v, POLY *p1, POLY *p2);
ELIM *pe_v_tratio(VAR *var, TVariable * y, TVariable * w, TVariable * u, TVariable * v, POLY *p1, POLY *p2);
ELIM *pe_r_tratio (VAR *var, TVariable * n1, TVariable * n2, TVariable * n3, TVariable * n4, TVariable * y, TVariable * r, TVariable * p, TVariable * q, POLY *p1, POLY *p2);
ELIM *pe_a_tratio (VAR *var, TVariable * n1, TVariable * n2, TVariable * n3, TVariable * n4, TVariable * y, TVariable * w, TVariable * u, TVariable * v, POLY *p1, POLY *p2);
ELIM *pe_g_tratio (VAR *var, TVariable * n1, TVariable * n2, TVariable * n3, TVariable * n4, TVariable * y, TVariable * w, TVariable * u, TVariable * v, POLY *p1, POLY *p2);
ELIM *pe_a_itt1(VAR *var, TVariable * n3, TVariable * n2, TVariable * n1, TVariable * y, TVariable * o, TVariable * u, TVariable * v);
ELIM *pe_a_itt (VAR *var, TVariable * n1, TVariable * n2, TVariable * n3, TVariable * n4, TVariable * y, TVariable * w, TVariable * u, TVariable * v, TVariable * r, TVariable * p, TVariable * q);
ELIM *pe_g_itt1(VAR *var, TVariable * n3, TVariable * n2, TVariable * n1, TVariable * y, TVariable * o, TVariable * u, TVariable * v);
ELIM *pe_g_itt (VAR *var, TVariable * n1, TVariable * n2, TVariable * n3, TVariable * n4, TVariable * y, TVariable * w, TVariable * u, TVariable * v, TVariable * r, TVariable * p, TVariable * q);
ELIM *pe_r_itt (VAR *var, TVariable * n1, TVariable * n2, TVariable * n3, TVariable * n4, TVariable * y, TVariable * w, TVariable * u, TVariable * v, TVariable * r, TVariable * p, TVariable * q);
ELIM *pe_v_ipt(VAR *var, TVariable * y, TVariable * w, TVariable * u, TVariable * v, TVariable * r, TVariable * p, TVariable * q);
ELIM *pe_r_ipt (VAR *var, TVariable * n1, TVariable * n2, TVariable * d1, TVariable * d2, TVariable * y, TVariable * w, TVariable * u, TVariable * v, TVariable * r, TVariable * p, TVariable * q);
ELIM *pe_a_ipt (VAR *var, TVariable * n1, TVariable * n2, TVariable * n3, TVariable * n4, TVariable * y, TVariable * w, TVariable * u, TVariable * v, TVariable * r, TVariable * p, TVariable * q);
ELIM *pe_g_ipt (VAR *var, TVariable * n1, TVariable * n2, TVariable * n3, TVariable * n4, TVariable * y, TVariable * w, TVariable * u, TVariable * v, TVariable * r, TVariable * p, TVariable * q);
ELIM *pe_v_ipc(VAR *var, TVariable * y, TVariable * w, TVariable * u, TVariable * v, TVariable * o, TVariable * p);
ELIM *pe_r_ipc (VAR *var, TVariable * n1, TVariable * n2, TVariable * d1, TVariable * d2, TVariable * y, TVariable * w, TVariable * u, TVariable * v, TVariable * o, TVariable * p);
ELIM *pe_a_ipc (VAR *var, TVariable * n1, TVariable * n2, TVariable * n3, TVariable * n4, TVariable * y, TVariable * w, TVariable * u, TVariable * v, TVariable * o, TVariable * p);
ELIM *pe_g_ipc (VAR *var, TVariable * n1, TVariable * n2, TVariable * n3, TVariable * n4, TVariable * y, TVariable * w, TVariable * u, TVariable * v, TVariable * o, TVariable * p);
ELIM *pe_r_foot (VAR *var, TVariable * n1, TVariable * n2, TVariable * d1, TVariable * d2, TVariable * y, TVariable * p, TVariable * u, TVariable * v);
ELIM *pe_a_foot (VAR *var, TVariable * n1, TVariable * n2, TVariable * n3, TVariable * n4, TVariable * y, TVariable * p, TVariable * u, TVariable * v);
ELIM *pe_g_foot (VAR *var, TVariable * n1, TVariable * n2, TVariable * n3, TVariable * n4, TVariable * y, TVariable * p, TVariable * u, TVariable * v);
ELIM *pe_v_ipb(VAR *var, TVariable * y, TVariable * w, TVariable * u, TVariable * v, TVariable * p, TVariable * q);
ELIM *pe_r_ipb (VAR *var, TVariable * n1, TVariable * n2, TVariable * d1, TVariable * d2, TVariable * y, TVariable * w, TVariable * u, TVariable * v, TVariable * p, TVariable * q);
ELIM *pe_a_ipb(VAR *var, TVariable * n1, TVariable * n2, TVariable * n3, TVariable * n4, TVariable * y, TVariable * w, TVariable * u, TVariable * v, TVariable * p, TVariable * q);
ELIM *pe_g_ipb (VAR *var, TVariable * n1, TVariable * n2, TVariable * n3, TVariable * n4, TVariable * y, TVariable * w, TVariable * u, TVariable * v, TVariable * p, TVariable * q);

//
bool xpara(TVariable *p1,TVariable *p2,TVariable *p3,TVariable *p4);
bool xcoll(TVariable *p1,TVariable *p2,TVariable *p3);
bool xcoll4(TVariable *p1,TVariable *p2,TVariable *p3,TVariable *p4);
bool xperp(TVariable *p1,TVariable *p2,TVariable *p3,TVariable *p4);
bool xcir2(TVariable *p1,TVariable *p2,TVariable *p3);
bool xcir3(TVariable *p1,TVariable *p2,TVariable *p3,TVariable *p4);
bool xcir4(TVariable *p1,TVariable *p2,TVariable *p3,TVariable *p4, VAR*);
bool xcir5(TVariable *p1,TVariable *p2,TVariable *p3,TVariable *p4, VAR*, VAR*);


#endif
