/////////////////////////////////////////////////////////////
// File: head0.h
// Basic definitions for Memory, BigInt, Poly etc. packages
/////////////////////////////////////////////////////////////

#ifndef INTHEAD0
#define INTHEAD0

//#define TEST 1
//#define COMPACT 

#ifdef TEST
#include <iostream.h>
#else
#define NODEBUG 1
#endif

typedef unsigned BBUNIT;
typedef unsigned BBCELL, *BBCELLP;	// basic Big Int cell
typedef unsigned short IUNIT, *IUNITP;

// only for variable-length block
enum vlengthcell_const {
	BIGGEST_SMALL_INTEGER_ = 8,

	VBASELEN	= (sizeof(IUNIT) * 8),	// how many bits in a IUNIT
	VBASESHIFT	= 1,	// coverse the bbcell to iunit, to shift 1.
	VCELL_LEN   = 0x00ffffff,
	VCELL_TYPE  = 0xff000000,
	VCELL_CLEAR = 0x00ffffff,
	VCELL_INUSE = 0x80000000
};

// for every expr value
enum exprcell_const {
	REFCOUNT = 0x00ffffff,
	EXPR_TYP = 0x7f000000,
	SIGN_BIT = 0x80000000,

	SEXP_INT = 0x01000000,
	SEXP_FRAC = 0X02000000
};



#endif