// intbb.h ڲʾйضļ
// 
//  Tintbb ΪĻʾ
// head м¼ȺϢ
// num ̬ͨ䣬ʵʱʾ

#ifndef _BIGINTBB
#define _BIGINTBB

#include <assert.h>

static const unsigned int _INTBBTMP_NUM = 10; // ܹŵĶ

class TBigInt::B0 {
public:
	BBUNIT head;
	BBCELL num[1];

	inline void setbb(BBUNIT hd, BBCELL n) { head = hd; num[0] = n; }
	inline BBUNIT len() { return (head & VCELL_LEN); }
	inline BBUNIT type() { return (head & VCELL_TYPE); }
	unsigned blength() const;
};

typedef TBigInt::B0 * Tintbbp;

extern Tintbbp tmpintbbp[_INTBBTMP_NUM];	// temp-variables used in functions, GC-related

inline unsigned intbbLen(const Tintbbp a) {
	BBUNIT l = a->head & VCELL_LEN;
	return ((a->num[l-1] & 0xffff0000) == 0) ? ((l << 1) - 1) : (l << 1);
}

inline unsigned short intbbUnit(const Tintbbp a, unsigned n) {
	assert(n >= 0 && n < intbbLen(a));
	return (n & 0x01) ?
		(a->num[n >> 1] & 0x0ffff0000)>>16 : (a->num[n >> 1] & 0x0ffff);
}

inline void deletep0 (Tintbbp & p) {
	p->head &= VCELL_LEN;
}

inline void deletep (Tintbbp & p) {
	p->head &= VCELL_LEN; p = 0;
}

void intbbprint (outtype& out, const Tintbbp a);

//====================================================
// create an internal-big-int from a digital string s end with '\0'
Tintbbp intbbcreate(const char s[]);

// create an internal-big-int from n
Tintbbp intbbcreate(const unsigned n);

Tintbbp intbbcopy(const Tintbbp a);

//====================================================
// basic arithematic functions

//---------two plus functions-------return a + b
Tintbbp intbbplus(Tintbbp a, Tintbbp b);
Tintbbp intbbplus(Tintbbp a, unsigned b);

//---------two subs functions-------pp = a - b, return a < b ? 1 : 0
int intbbsubs(Tintbbp a, Tintbbp b, Tintbbp * pp);
int intbbsubs(Tintbbp a, unsigned b, Tintbbp * pp);

Tintbbp intbbprod(Tintbbp a, Tintbbp b);
Tintbbp intbbprod(Tintbbp a, unsigned b);

Tintbbp intbbdivid(Tintbbp a, Tintbbp b);
Tintbbp intbbdivid(Tintbbp a, unsigned b);

Tintbbp intbbmod(Tintbbp a, Tintbbp b);
Tintbbp intbbmod(Tintbbp a, unsigned b);


Tintbbp intbbadd1(Tintbbp a);
Tintbbp intbbsub1(Tintbbp a);

Tintbbp intbbsquare(Tintbbp a);

Tintbbp intbbpower(Tintbbp a, unsigned b);

//-------------2001.5-------------------------------------
unsigned intbbLen(const Tintbbp a); 
unsigned ibblength(const Tintbbp a);
void intbbHighUnit(const Tintbbp a, int res[]);
unsigned short intbbUnit(const Tintbbp a, int n);
char * ibbToString(const Tintbbp a, char s[]);

Tintbbp intbbleft(Tintbbp a, unsigned n);
Tintbbp intbbright(Tintbbp a, unsigned n);
Tintbbp intbbleft1(Tintbbp a);
int intbbnum2(Tintbbp a);
Tintbbp intbbdiv2(Tintbbp a);
//-------------2001.5-------------------------------------

// basic comparision operations
// intbbsign returns -1, 0, 1 when a > b, a == b, a < b
int intbbcmp(Tintbbp a, Tintbbp b);

inline bool intbbequal(Tintbbp a, Tintbbp b) { return intbbcmp(a, b) == 0; }
inline bool intbbnoequal(Tintbbp a, Tintbbp b) { return intbbcmp(a, b) != 0; }
inline bool intbbgreater(Tintbbp a, Tintbbp b) { return intbbcmp(a, b) > 0; }
inline bool intbbgreatereq(Tintbbp a, Tintbbp b) { return intbbcmp(a, b) >= 0; }
inline bool intbbless(Tintbbp a, Tintbbp b) { return intbbcmp(a, b) < 0; }
inline bool intbblesseq(Tintbbp a, Tintbbp b) { return intbbcmp(a, b) <= 0; }

// predicates on intbb
// should be inline as possible
inline bool intbbzero(Tintbbp a) { return a->len() == 1 && a->num[0] == 0; } // ????
inline bool intbbone(Tintbbp a) { return a->len() == 1 && a->num[0] == 1; } // ????

inline bool intbbodd(Tintbbp a) { return a->num[0] & 1; }
inline bool intbbeven(Tintbbp a) { return (a->num[0] & 1) == 0; }

// max and min
inline Tintbbp intbbmax(Tintbbp a, Tintbbp b) { return intbbcmp(a,b) >= 0 ? a : b; }
inline Tintbbp intbbmin(Tintbbp a, Tintbbp b) { return intbbcmp(a,b) <= 0 ? a : b; }

unsigned sqrt_unsigned (unsigned n); // sqrt for unsigned
Tintbbp intbbhalf (Tintbbp ia); // aux function for bigint sqrt

#endif