// intbb.cpp: ڲʾʵļ

#include <iostream.h>
#include <ctype.h>

// Global variables 
Tintbbp tmpintbbp[10] = {0};	// temp-variables used in functions, GC-related

inline Tintbbp intconstbb0(unsigned n) { return intbbcreate(n); }

//===========Macros for define functions================
// Clear bits p ~~ endp
#define clearBits(p, endp) while (p < endp) *p++ = 0; 
// Copy bits p ~~ endp to position begin at q
#define copyBits(p, endp, q) while (p < endp) *q++ = *p++; 
// Add bits p ~~ endp to position begin at q
#define addInPlace(p, endp, q) c = 0; \
	while (p < endp) { \
		c += *p++ + *q; *q++ = (c & 0xFFFF); \
		c >>= VBASELEN; }
// Substract bits p ~~ endp from position begin at q
#define subInPlace(p, endp, q) c = 0; \
	while (p < endp) { \
		c = *q - *p++ - c; *q++ = (c & 0xFFFF); \
		c = (c >> VBASELEN) & 1; }
// Get complement of bits p ~~ endp
#define compInPlace(p, endp) c = 1; \
	while (p < endp) { \
			c += (*p ^ 0xFFFF); *p++ = (c & 0xFFFF); \
			c >>= VBASELEN; }
// Add bits p ~~ endp and r ~~, put the result into position begin at q
#define addBits(p, endp, r, q) c = 0; \
	while (p < endp) { \
			c += *p++ + *r++; *q++ = (c & 0xFFFF); \
			c >>= VBASELEN; }
// Substract from r~~ the bits p ~~ endp, put the result into position begin at q
#define substBits(p, endp, r, q) c = 0; \
	while (p < endp) { \
			c = *r++ - *p++ - c; *q++ = (c & 0xFFFF); \
			c = (c >> VBASELEN) & 1; }

// Copy remained Bits with the carry bit
#define copy_carryBits(p, endp, q) \
	while (p < endp) \
		{ c += *p++; *q++ = (c & 0xffff); c >>= VBASELEN; }
#define copy_borrowBits(p, endp, q) \
	while (p < endp) \
		{ c = *p++ - c; *q++ = (c & 0xffff); c = ((c>>VBASELEN) & 1); }
//==================End of Macros======================

static inline void ialloc(Tintbbp &p, size_t n) {
	p = (Tintbbp) TVMM::alloc(n + 1); // add a head
	p->head = n | VCELL_INUSE;
}

static inline void desize(void *p, size_t n) {
	TVMM::reducesize(p, n);
}

//========================================================
// aux function: intbbtostr.
// begin, end: begin and end of the number cells
// r: end of a buffer, which is enough to hold the result string reversely
char * intbbtostr(IUNITP begin, IUNITP end, char * r) {
	register IUNITP q;
    register unsigned d, n;

	*(--r) = '\0'; 
	end--; // end points to the last digit.
	if (*end == 0) end--;

	while (end >= begin) {
		for (d = 0, q = end; q >= begin; q--) {
			d = (d << VBASELEN) | *q;
			*q = d/10000;
			d %= 10000;
		}
		if (*end == 0) end--;

		// d: number of next 4 decimals, put them into place.
		for (n = 0; n < 4; n++) {
			*(--r) = d % 10 + '0';
			d /= 10;
			if (d == 0 && end < begin) break;
		}
	}
	
	if (*r == '\0') *(--r) = '0';

	return r;
}

// print the integer
void intbbprint (outtype& out, const Tintbbp a) {
	size_t alen = a->len(),
		ilen = (size_t)(alen * 2.42) + 2; // (ilen << 1) + (ilen >> 1) + 3;

	tmpintbbp[0] = a;
	IUNITP begin = (IUNITP)valloc(ilen);
	IUNITP p = (IUNITP)(tmpintbbp[0]->num), q = (p + (alen << 1));
	IUNITP end = begin;

	copyBits(p, q, end);
	char * s = (char*)(begin + (ilen << 1));

	s = intbbtostr(begin, end, s);

	out << s;

	TVMM::release(begin, ilen);
}

// -------------------2001.5 begin-----------------------
void intbbHighUnit(const Tintbbp a, int res[]) {
	BBUNIT l = a->head & VCELL_LEN;
	BBCELL * p = a->num;
	if ((p[l-1] & 0xffff0000) == 0)	{
		res[0] = (l << 1) - 1;
		res[1] = (p[l - 1] & 0x0ffff);
	}
	else {
		res[0] = (l << 1);
		res[1] = (p[l - 1] & 0xffff0000) >> 16;
	}
}

unsigned ibblength (const Tintbbp a)
{
	BBUNIT alen = a->head & VCELL_LEN,
		ilen = (size_t)(alen * 2.42) + 2; // (ilen << 1) + (ilen >> 1) + 3;

	tmpintbbp[0] = a;
	IUNITP begin = (IUNITP)valloc(ilen);
	IUNITP p = (IUNITP)(tmpintbbp[0]->num), q = (p + (alen << 1));
	IUNITP end = begin;
	copyBits(p, q, end);
	char * s = (char*)(begin + (ilen << 1));

	s = intbbtostr(begin, end, s);
	size_t l = strlen(s);

	TVMM::release(begin, ilen);

	return l;
}

unsigned TBigInt::B0::blength() const
{
	BBUNIT ilen = head & VCELL_LEN;
	unsigned n = num[ilen-1], i = 0;

	// count nozero-bits in the highest cell
	if ( n & 0xffff0000 ) { n >>= 16; i += 16; }
	if ( n & 0xffffff00 ) { n >>= 8; i += 8; }
	for(; n; i++, n >>= 1) 
		;
	return ((ilen-1) << 5) + i;
}
	
char * ibbToString(const Tintbbp ia, char buffer[]) {
	size_t ilen = ia->len();
	tmpintbbp[0] = ia;
	IUNITP begin = (IUNITP)valloc(ilen);
	IUNITP p = (IUNITP)(tmpintbbp[0]->num), q = (p + (ilen << 1));	
	IUNITP end = begin;
	copyBits(p, q, end);
	char* s = (char*)((int*)buffer + (size_t)(ilen * 2.42) + 1);

	s = intbbtostr(begin, end, s);
	TVMM::release(begin, ilen);
	tmpintbbp[0] = 0;
	return s;
}

// -----------------------2001.5 end----------------------------

inline Tintbbp intconstb0(unsigned n) { return intbbcreate(n); }

//========================================================
// creation of integer internal representations
//========================================================
Tintbbp intbbcreate(const unsigned n) {
	Tintbbp p;
	ialloc(p, 1);
	p->num[0] = n;
	return p;
}

Tintbbp intbbcreate(const char *ip) {
	const char *end = ip;
	while (isdigit(*end)) end++;

	size_t slen = end - ip, ilen = (slen + 8) / 9;
	if (slen == 0) return intconstbb0(0); // the number is 0

	Tintbbp vcellp;
	ialloc(vcellp, ilen);

	register unsigned c, i;
	unsigned n = 0;
	register IUNITP p = (IUNITP)vcellp->num;	// use a unsigned short pointer p

    if (n = (slen & 0x0003)) {
		for (c = 0, i = 0; i < n; i++) 
			c = (c * 10) + (*ip++ - '0');
		*p = c;
	}
	else *p = 0;

	slen >>= 2; n = 1;
	while (ip < end) {
		for (c = 0, i = 0; i < 4; i++)
			c = (c * 10) + (*ip++ - '0');
		// c is the number of next 4 digits
		i = 0;
		do {
			c += (*(p + i) * 10000);
			*(p + i) = (c & 0xffff);
			c >>= VBASELEN;
		} while (++i < n);

		if ( c ) *(p + n++) = c; // Carry is not 0, extend and set.
	}

	if (n % 2) *(p + n++) = 0;	// use odd cell of short, adjust to even

	desize(vcellp, ilen - n/2);

	return vcellp; 
}

Tintbbp intbbcopy(Tintbbp ia) {
	size_t len = ia->len();
	BBCELL * p, * end, * q;

	tmpintbbp[0] = ia;
	ialloc(ia, len);
	p = tmpintbbp[0]->num, end = p + len, q = ia->num; 
	while (p < end ) *q++ = *p++;

	return ia;
}

//=============================================================

//=========================================================
// Arithmetic functions

//---------two plus functions-------------------
// return a + b, while a, b are unsigned big ints

// 32-bit version of plus function
Tintbbp intbbplus(Tintbbp ia, Tintbbp ib) {
	size_t alen = ia->len(), blen = ib->len(), 
		ilen = (alen > blen ? alen : blen);
	tmpintbbp[0] = ia; tmpintbbp[1] = ib;
	ialloc(ia, ilen + 1);	// extra 1 int for carrying

	BBCELLP a, b, enda, endb;
	if (alen >= blen) {  // ensure that len(a) > len(b)
		a = tmpintbbp[0]->num; b = tmpintbbp[1]->num;
		enda = a + alen; endb = b + blen;
	}
	else {
		a = tmpintbbp[1]->num; b = tmpintbbp[0]->num;
		enda = a + blen; endb = b + alen;
	}

	unsigned c, n;
	BBCELLP q = ia->num;
	for (c = 0; b < endb; a++) { // add units
		n = *a + *b++ + c;
		*q++ = n;
		c = (*a > n ? 1 : 0);
	}
	if (c)
		for (; a < enda; a++) {
			*q++ = *a + 1;
			if (*a != 0xffffffff) {
				c = 0;	// no carry further
				a++;
				break;
			}
		}
	while (a < enda) *q++ = *a++;

	if (c) *q++ = c;
	else desize(ia, 1);	// no carrying, decrease size by 1.

	return ia;
}
//end of 32-bit version of intbbplus */

/* 16-bit version of plus function
Tintbbp intbbplus(Tintbbp ia, Tintbbp ib) {
	size_t alen = ia->len(), blen = ib->len();

	IUNITP a, b, enda, endb;
	register unsigned c;

	if (alen >= blen) {  // ensure that len(a) > len(b)
		a = (IUNITP)ia->num; b = (IUNITP)ib->num;
		enda = a + (alen << VBASESHIFT); endb = b + (blen << VBASESHIFT);
	}
	else {
		a = (IUNITP)ib->num; b = (IUNITP)ia->num;
		enda = a + (blen << VBASESHIFT); endb = b + (alen << VBASESHIFT);
		alen = blen;
	}	// alen is length of the longer big-int

	Tintbbp ic;
	ialloc(ic, alen + 1);	// extra 1 int for carrying
	IUNITP q = (IUNITP)ic->num;
	addBits(b, endb, a, q)
	copy_carryBits(a, enda, q)

	if (c) *q++ = c;
	else desize(ic, 1);	// no carrying, decrease size by 1.

	return ic;
}
//*/

// created 2001.5.22
Tintbbp intbbplus(Tintbbp ia, unsigned c) {
	unsigned n;
	size_t alen = ia->len();
	tmpintbbp[0] = ia;
	ialloc(ia, alen + 1);	// extra 1 int for carrying
	BBCELLP a = tmpintbbp[0]->num, enda = a + alen, q = ia->num;

	*q++ = n = *a + c;
	if (*a++ >= n) {
		c = 1;
		while ( a < enda ) {
			*q++ = *a + 1;
			if (*a++ != 0xffffffff) {	// no carry further
				c = 0; break;
			}
		}
	}
	else c = 0;

	while (a < enda) *q++ = *a++;

	if (c) *q++ = c;
	else desize(ia, 1);	// no carrying, decrease size by 1.

	return 0;
}

//---------two subs functions---------------------
//  *pp = a - b, return a < b ? 1 : 0

//*/ 32-bit version needs to create
int intbbsubs(Tintbbp ia, Tintbbp ib, Tintbbp * pp) {
	int sign = 0;
	size_t alen = ia->len(), blen = ib->len();
	BBCELLP a, b, enda, endb;

	tmpintbbp[0] = ia; tmpintbbp[1] = ib;
	ialloc(ia, (alen < blen ? blen : alen));	// no carrying

	if (alen >= blen) {  // ensure that len(a) > len(b)
		a = tmpintbbp[0]->num; b = tmpintbbp[1]->num;
		enda = a + alen; endb = b + blen;
	}
	else {
		a = tmpintbbp[1]->num; b = tmpintbbp[0]->num;
		enda = a + blen; endb = b + alen;
		sign = 1;
	}	// alen is length of the longer big-int

	BBCELLP q = ia->num;
	unsigned c, n;
	for (c = 0; b < endb; a++, b++) { // subs units
		n = *a - *b - c;
		*q++ = n;
		c = (*a < n ? 1 : 0);
	}

	if (c) {// there is borrowing after substraction all unit from b
		while ( a < enda ) {
			*q++ = *a - 1;
			if (*(a++) != 0) { // must ++, in either cases
				c = 0;	// no carry further
				break;
			}
		}
	}
	
	if (c == 0)
		while (a < enda) *q++ = *a++;
	else {	// there is borrowing in highest sub, get the complement
		a = ia->num;

		while (a < q) {
			if ((*a = ~(*a) + 1) != 0) {
				a++;
				break;
			}
			a++;
		}

		while (a < q) {
			*a = ~(*a); // reverse every bit
			a++;
		}

		sign = !sign;
	}

	// cut out leading 0s, desize int cells
	a = q - 1;
	while (*a == 0) a--;

	if (a < ia->num) a +=2;
	else a++;
	
	desize(ia, q - a);

	*pp = ia;	// set the result
	return sign;
}
//end of 32-bit version of intbbsubs */

/*/ 16-bit version of subs func
int intbbsubs(Tintbbp ia, Tintbbp ib, Tintbbp * pp) {
	int sign = 0;
	size_t alen = ia->len(), blen = ib->len();

	tmpintbbp[0] = ia; tmpintbbp[1] = ib;
	ialloc(ia, (alen < blen ? blen : alen));	// no carrying

	IUNITP a, b, enda, endb;
	register unsigned c;

	if (alen >= blen) {  // ensure that len(a) > len(b)
		a = (IUNITP)tmpintbbp[0]->num; b = (IUNITP)tmpintbbp[1]->num;
		enda = a + (alen << VBASESHIFT); endb = b + (blen << VBASESHIFT);
	}
	else {
		a = (IUNITP)tmpintbbp[1]->num; b = (IUNITP)tmpintbbp[0]->num;
		enda = a + (blen << VBASESHIFT); endb = b + (alen << VBASESHIFT);
		alen = blen;
		sign = 1;
	}	// alen is length of the longer big-int

	IUNITP q = (IUNITP)ia->num, q0 = q;
	substBits(b, endb, a, q)
	copy_borrowBits(a, enda, q)
	
	if (c) {	// there is borrowing, get the complement
		a = q0;
		compInPlace(a, q)
		sign = !sign;
	}

	// cut out leading 0s, desize int cells
	for (a = q - 1; *a == 0; a--) 
		;
	if ((q - ++a) % 2) a++;
	desize(ia, (q-a) >> 1);

	*pp = ia;	// set the result

	return sign;
}
//*/

int intbbsubs(Tintbbp ia, unsigned c, Tintbbp * pp) {
	unsigned n;
	size_t alen = ia->len();

	if (alen == 1) {
		n = ia->num[0]; ialloc(ia, 1); *pp = ia;
		if (n >= c) {
			ia->num[0] = n - c; return 0;
		} else {
			ia->num[0] = c - n; return 1;
		}			
	}

	tmpintbbp[0] = ia;
	ialloc(ia, alen);	// no carrying
	BBCELLP a = tmpintbbp[0]->num, enda = a + alen, q = ia->num;

	*q++ = *a - c;
	if (*a++ >= c) {
		while (a < enda) { // subs borrow-bit
			*q++ = *a - 1;
			if (*a++ != 0) break;
		}
	}

	while (a < enda) *q++ = *a++;

	// cut out leading 0s, desize int cells
	if (*(a - 1) == 0) 
		desize(ia, 1);

	*pp = ia;	// set the result
	return 0;
}

//---------two product functions-------------------
//  return a * b
#define SHORTMUL 32
#define MULTUNIT (SHORTMUL / 2)

static void intMulti0 (IUNITP a, IUNITP enda, IUNITP b,
					IUNITP endb, IUNITP d);
static void intMulti2 (IUNITP a, IUNITP b, unsigned len, 
					IUNITP d, IUNITP space);
static void intMulti1 (IUNITP a, unsigned alen, IUNITP b, 
					unsigned blen, IUNITP d, IUNITP space, unsigned n);

Tintbbp intbbprod(Tintbbp ia, Tintbbp ib) {
	size_t alen = (ia->len()) << VBASESHIFT, blen = (ib->len()) << VBASESHIFT, tlen;
	IUNITP a, b, enda, endb, q, r, q0;

	tmpintbbp[0] = ia; tmpintbbp[1] = ib;
	if (blen < SHORTMUL || alen < SHORTMUL) { // short, use simple method.
		ialloc(ia, (alen + blen) >> VBASESHIFT);// unit converse
		a = (IUNITP)tmpintbbp[0]->num; b = (IUNITP)tmpintbbp[1]->num;
		enda = a + alen; endb = b + blen;
		q0 = q = (IUNITP)ia->num;
		r = q + alen + blen;
		clearBits(q, r) // macro, clear blen+alen units for d.
		intMulti0(a, a + alen, b, b + blen, q0);
		q--;
		if (*q == 0 && *(q-1) == 0)
			desize(ia, 1);
		return ia;
	}
	
	tlen = (alen > blen ? blen : alen);
	// make tlen the biggest 2^k <= min(alen, blen)
	size_t n = 1;
	if (tlen & 0xffff0000) { tlen >>= 16; n <<= 16; }
	if (tlen & 0xffffff00) { tlen >>= 8; n <<= 8; }
	if (tlen & 0xfffffff0) { tlen >>= 4; n <<= 4; }
	if (tlen & 0xfffffffc) { tlen >>= 2; n <<= 2; }
	if (tlen & 0x00000002) n <<= 1;

	tlen = 3 * n;	

	ialloc(ia, ((alen + blen) >> VBASESHIFT) + tlen);// extra space for temporary use
	a = (IUNITP)tmpintbbp[0]->num; b = (IUNITP)tmpintbbp[1]->num;
	enda = a + alen; endb = b + blen;
	q0 = q = (IUNITP)ia->num;
	r = q + (alen + blen);
	clearBits(q, r) // macro, clear blen+alen units for d.
	if (blen > alen)
		intMulti1(b, blen, a, alen, q0, r, n);
	else
		intMulti1(a, alen, b, blen, q0, r, n);

	q--;
	if (*q == 0 && *(q-1) == 0)
		desize(ia, tlen + 1);
	else
		desize(ia, tlen);

	return ia;
}

static void intMulti0 (register IUNITP a, IUNITP enda, register IUNITP b, 
				register IUNITP endb, register IUNITP d) {
	register unsigned c;
	IUNITP tmpd, bbegin = b;
	while (a < enda) {
		tmpd = d;
		c = 0;
		while (b < endb) {
			c += (*a) * (*b) + *d;
			*d = (c & 0xffff);
			c >>= VBASELEN; b++; d++;
		}
		while (c) {	// There may be carrying more than once.
			c += *d; *d = (c & 0xffff); 
			c >>= VBASELEN; d++;
		}
		d = tmpd + 1;	// d goes back to next begining position.
		a++; b = bbegin;
	}
}

static void intMulti2 (IUNITP a, IUNITP b, unsigned len, IUNITP d, IUNITP space) {
	unsigned sign, ulen = MULTUNIT, ulen2 = SHORTMUL;
    IUNITP ab, bb, db;
	register unsigned c;
    register IUNITP p, endp, r, q;

	p = a; q = b; r = d; endp = a+len;
	do {	// set d(2i, 2i+1) = ai*bi
		intMulti0(p, p+MULTUNIT, q, q+MULTUNIT, r);
		p += MULTUNIT; 
		q += MULTUNIT;
		r += SHORTMUL;
	} while (p < endp);

	do {
		ab = a;
		bb = b; 
		db = d;

		do {
			// build x1 = (a1 - a2) at space.
			p = ab;	
			r = endp = p+ulen; 
			q = space; 
			substBits(p, endp, r, q)	// minus a2 from a1, put into space
			if (sign = c) {			// deal with negative
				p = space; 
				compInPlace(p, q)
			}

			// build x2 = (b2 - b1) at space+ulen
			r = bb; 
			p = bb+ulen; 
			endp = p+ulen;
			substBits(p, endp, r, q)	// minus b1 from b2, put into space+ulen
			if (c) {				// deal with negative
				sign = !sign; 
				p = space+ulen; 
				compInPlace(p, q) 
			}

			// calculate x = x1*x2, at space+2*ulen
			p = space + ulen2; 
			endp = p + ulen2; 
			clearBits(p, endp)
			if (ulen > MULTUNIT)
				intMulti2(space, space+ulen, ulen, space+ulen2, space+(ulen2<<1));
			else 
				intMulti0(space, space+ulen, space+ulen, space+ulen2, space+ulen2);

			// compute a1*b1 + a2*b2 + x, at space+2*ulen
			p = db;
			r = endp = p+ulen2; 
			q = space + ulen2;
			c = 0; 
			if (sign) { // x is negative
				sign = 0;
				while (p < endp) {
					if (sign)
						c = *p + *r - *q - c;
					else
						c = *p + *r - *q + c; 
					*q = c & 0xFFFF; 
					if ((c >>= VBASELEN) > 1) 
						sign = c = 1;
					else
						sign = 0;
					p++; q++; r++;
				}
			}
			else		// x is positive
				while (p < endp) { 
					c += *p + *q + *r; 
					*q = c & 0xFFFF; 
					c >>= VBASELEN; 
					p++; q++; r++;
				}

			sign = c;
			p = space+ulen2;
			endp = p+ulen2; 
			q = db+ulen; 
			addInPlace(p, endp, q)	// add result to db+ulen

			c += sign;
			while (c) {		// deal with carrying
				c += *q; 
				*q = c & 0xFFFF; 
				c >>= VBASELEN; 
				q++;
			}

			ab += ulen2; bb += ulen2; 
			db += ulen << 2; // next segment.
		} while (ab < a + len);

		ulen <<= 1; ulen2 <<= 1; // double the segment length.

	} while (ulen < len);
}

// len is the biggest 2^k where n <= blen
static void intMulti1 (IUNITP a, unsigned alen, IUNITP b,
				unsigned blen, IUNITP d, IUNITP space, unsigned len) {
	unsigned c, nextai, nextbi = 0, m, mm;
    IUNITP endp, p, q;
    
    while (len) {
		if (len < SHORTMUL) {
			intMulti0(a, a+alen, b+nextbi, b+blen, d+nextbi);
			break;
		}
		nextai = 0;
		do {
			p = space; 
			endp = space+(len<<1); 
			clearBits(p, endp)
			intMulti2(a+nextai, b+nextbi, len, space, endp);
			p = space; 
			q = d+nextai+nextbi; 
			addInPlace(p, endp, q)
			while (c) {	// deal with carrying
				c += *q; 
				*q = c & 0xFFFF; 
				c >>= VBASELEN; 
				q++;
			}
			nextai += len;
		} while (nextai <= alen - len);
		if (nextai != alen) { // deal with remained bits of a.
			m = alen - nextai;
			if (m < SHORTMUL)
				intMulti0(b+nextbi, b+nextbi+len, a+nextai,
						a+alen, d+nextai+nextbi);	//use simple method.
			else {
				for (mm = len >> 1; (mm & m) == 0; mm >>=1) // find the next 1 in m
					;
				intMulti1(b+nextbi, len, a+nextai, m,
						d+nextai+nextbi, space, mm);	// recursive, exchange positions a and b.
			}
		}
		nextbi += len;
		do {
			len >>= 1;
		} while (len && (len & blen) == 0); // find next bit==1 in blen
	}
}


Tintbbp intbbprod(Tintbbp a, unsigned b) {
	return 0;
}

//---------two divid functions---------------------
//  return a / b
static IUNITP IntDiv0 (IUNITP a, unsigned alen, IUNITP b, unsigned blen, IUNITP space);

Tintbbp intbbdivid(Tintbbp ia, Tintbbp ib) {
	size_t alen = (ia->len()) << VBASESHIFT, blen = (ib->len()) << VBASESHIFT;
	IUNITP a = (IUNITP)ia->num, b = (IUNITP)ib->num;

	if (*(a + alen - 1) == 0) alen--;
	if (*(b + blen - 1) == 0) blen--;

    if (alen < blen || ( (alen==blen) && (*(a + alen -1) < *(b + blen - 1)) )) {
        return intconstbb0(0);
    }

	size_t vlen = ((alen + blen) >> 1) + 2;
	tmpintbbp[0] = ia; tmpintbbp[1] = ib;
	ialloc(ia, vlen);
	IUNITP q = (IUNITP)ia->num;
	a = (IUNITP)tmpintbbp[0]->num, b = (IUNITP)tmpintbbp[1]->num;

	a = IntDiv0(a, alen, b, blen, q); // IntDiv returns the end position

	if ((a - q) % 2)
		if (*(a-1) == 0) a--;
		else *(a++) = 0;
	desize(ia, vlen - ((a - q) >> 1));

	return ia;
}

static IUNITP IntDiv0 (IUNITP a, unsigned alen, IUNITP b, unsigned blen, IUNITP space) {
	unsigned m, n, c, dd, bm, len = 0;
	IUNITP d, r, p, endp, q, endA;

	// Pre-step: normalize b and a in the free space.
	c = b[blen-1];
	for (n = 0; (c & 0x8000) == 0; n++) // count leading 0's
		c <<= 1;

	if (n > 0) {	// normalize b, and also a.
		n = VBASELEN - n;

		// normalize b in space+alen+4.
		p = b + blen - 1; 
		q = space + alen + blen + 3; 
		c = *p; 
		p--;
		while (p >= b) {
			c = (c << VBASELEN) | *p;
			*q = (c >> n) & 0xFFFF; 
			p--; q--;
		} 
		*q = (c << (VBASELEN - n)) & 0xFFFF;
		b = space + alen + 4;

		// normalize a in space.
		p = a + alen - 1; 
		q = space + alen - 1; 
		c = *p; 
		p--;
		if (c >> n) {	// a[alen-1] Чbit b[blen-1]һµλ
			*(q + 1) = c >> n; 
			alen++;
		}
		while (p >= a) {
			c = (c << VBASELEN) | *p;
			*q = (c >> n) & 0xFFFF; 
			p--; q--;
		}
		*q = (c << (VBASELEN-n)) & 0xFFFF;

		a = space;
	}
	else {	// b is in normal form originally, make a copy of a.
		p = a; 
		endp = a + alen; 
		q = space; 
		copyBits(p, endp, q)
		a = space; 
	}

	// b, a are normalized.
	*(a + alen) = 0;
	endA = a + alen - 1;
	d = endA + 2;
	*d = *(d+1) = 0;	// added 2001.6.4
	bm = b[blen-1];		// bm: the most sig. bit-value of b

	c = 0;
	while (endA >= a + blen - 1) {
		c = (c << VBASELEN) + *endA;
		if ((dd = c / bm) == 0)		// dd is the testing quotient.
		{	*d = 0; d--; endA--; continue; } //	too small, test in next place

		if (dd > 0x0ffff) dd = 0xffff; // can't be quotient great than 65535, 2001.6.4

		p = r = endA - blen + 1;
		q = b; 

		c = 0; 
		n = *p;
		while (p <= endA) {
			n += (*(p+1) << 16);
			m = *q * dd + c;
			c = (n < m) ? 0x10000 : 0; // borrow?
			n -= m; 
			*p = n & 0xFFFF;
			n >>= 16; 
			p++; q++;
		}

		*p = 0;

		if (c > 0) // borrow-bit in highest place, decrease trial-quotient
			do {
				p = b; 
				endp = p + blen; 
				q = r; 
				addInPlace(p, endp, q)
				dd--;
			} while (c == 0);

		*d = dd;

		if (len == 0) len = d - a - blen;
		c = *endA;
		d--; endA--;
	}

	p = d + 1; 
	endp = p + len; 
	q = space; 
	copyBits(p, endp, q)

	return q;
}

Tintbbp intbbdivid(Tintbbp a, unsigned b) {
	return 0;
}

//---------two mod functions-----------------------
//  return a % b
static IUNITP IntRem0 (IUNITP a, unsigned alen, IUNITP b, unsigned blen, IUNITP space);

Tintbbp intbbmod(Tintbbp ia, Tintbbp ib) {
	size_t alen = (ia->len()) << VBASESHIFT, blen = (ib->len()) << VBASESHIFT;
	IUNITP a = (IUNITP)ia->num, b = (IUNITP)ib->num;

	if (*(a + alen - 1) == 0) alen--;
	if (*(b + blen - 1) == 0) blen--;

	size_t vlen = ((alen + blen) >> 1) + 2;
	tmpintbbp[0] = ia; tmpintbbp[1] = ib;
	ialloc(ia, vlen);
	IUNITP q = (IUNITP)ia->num;
	a = (IUNITP)tmpintbbp[0]->num, b = (IUNITP)tmpintbbp[1]->num;

	a = IntRem0(a, alen, b, blen, q);	// IntDev returns the end pos

	if ((a - q) % 2)
		if (*(a-1) == 0 && a - q != 1) a--;
		else *(a++) = 0;
	
	desize(ia, vlen - ((a - q) >> 1));

	return ia;
}

static IUNITP IntRem0 (IUNITP a, unsigned alen, IUNITP b, unsigned blen, IUNITP space) {
	unsigned m, n, n0, c, dd, bm, len = 0;
	IUNITP d, r, p, endp, q, endA;

	// Pre-step: normalize b and a in the free space.
	c = b[blen-1];
	for (n0 = 0; (c & 0x8000) == 0; n0++) // count leading 0's
		c <<= 1;

	if (n0 > 0) {	// normalize b, and also a.
		n = VBASELEN - n0;

		// normalize b in space+alen+4.
		p = b + blen - 1; 
		q = space + alen + blen + 3; 
		c = *p; 
		p--;
		while (p >= b) {
			c = (c << VBASELEN) | *p;
			*q = (c >> n) & 0xFFFF; 
			p--; q--;
		} 
		*q = (c << (VBASELEN-n)) & 0xFFFF;
		b = space + alen + 4;

		// normalize a in space.
		p = a + alen - 1; 
		q = space + alen - 1; 
		c = *p; 
		p--;
		if (c >> n) {	// a[alen-1] Чbit b[blen-1]һµλ
			*(q + 1) = c >> n; 
			alen++;
		}
		while (p >= a) {
			c = (c << VBASELEN) | *p;
			*q = (c >> n) & 0xFFFF; 
			p--; q--;
		}
		*q = (c << (VBASELEN - n)) & 0xFFFF;

		a = space; // save a place for head cell
	}
	else {	// b is in normal form originally, make a copy of a.
		p = a; 
		endp = a+alen; 
		q = space; 
		copyBits(p, endp, q)
		a = space; 
	}

	// b, a are normalized.
	*(a + alen) = 0;
	endA = a + alen - 1;
	d = endA + 2;
	*d = *(d+1) = 0;	// added 2001.6.4
	bm = b[blen-1];		// bm: the most sig. bit-value of b

	c = 0;
	while (endA >= a + blen - 1) {
		c = (c << VBASELEN) + *endA;
		if ((dd = c / bm) == 0)		// dd is the testing quotient.
		{	*d = 0; d--; endA--; continue; } //	too small, test in next place

		if (dd > 0x0ffff) dd = 0xffff; // can't be quotient great than 65535, 2001.6.4 

		p = r = endA - blen + 1;
		q = b; 

		c = 0; 
		n = *p;
		while (p <= endA) {
			n += (*(p+1) << 16);
			m = *q * dd + c;
			c = (n < m) ? 0x10000 : 0; 
			n -= m; 
			*p = n & 0xFFFF;
			n >>= 16; 
			p++; q++;
		}

		*p = 0;

		if (c > 0)		// decrease trial-quotient
			do {
				p = b; 
				endp = p + blen; 
				q = r; 
				addInPlace(p, endp, q)
				dd--;
			} while (c == 0);

		*d = dd;

		if (len == 0) len = d - a - blen;
		c = *endA;
		d--; 
		endA--;
	}
	
    q = space + blen - 1;
    while (*q == 0 && q > space)
        q--;
	q++;

	if (n0 != 0) {
		p = space;
		q++;
		c = *p;
		p++;
		while (p < q) {
			c |= (*p << VBASELEN);
			*(p-1) = (c >> n0) & 0xFFFF; 
			c >>= VBASELEN;
			p++;
		}

		*(p-1) = (c >> n0) & 0xFFFF;
		if (*(q-1) == 0) q--;
	}

    return q;
}


Tintbbp intbbmod(Tintbbp a, unsigned b) {
	return 0;
}

//--------square function----------

Tintbbp intbbsquare(Tintbbp ia) {
	size_t alen = (ia->len()) << VBASESHIFT;
	IUNITP q, r, q0, a, enda;

	tmpintbbp[0] = ia;

    if (alen < SHORTMUL) { // short, use simple method.
		ialloc(ia, alen);  // alen int for 2*alen short

		a = (IUNITP)(tmpintbbp[0])->num; enda = a + alen;
		q0 = q = (IUNITP)ia->num;
		r = q + (alen << VBASESHIFT);
		clearBits(q, r) // macro, clear blen+alen elements for d.
		intMulti0(a, a + alen, a, a + alen, q0);
		q--;
		if (*q == 0 && *(q-1) == 0)
			desize(ia, 1);
		return ia;
	}
	
	size_t tlen = alen, n = 1;
	// make tlen the biggest 2^k <= min(alen, blen)
	if (tlen & 0xffff0000) { tlen >>= 16; n <<= 16; }
	if (tlen & 0xffffff00) { tlen >>= 8; n <<= 8; }
	if (tlen & 0xfffffff0) { tlen >>= 4; n <<= 4; }
	if (tlen & 0xfffffffc) { tlen >>= 2; n <<= 2; }
	if (tlen & 0x00000002) n <<= 1;
	tlen = 3 * n;

	ialloc(ia, tlen + alen);
	a = (IUNITP)(tmpintbbp[0])->num; enda = a + alen;

	q0 = q = (IUNITP)ia->num;
	r = q + (alen * 2);
	clearBits(q, r) // macro, clear blen+alen elements for d.
		
	intMulti1(a, alen, a, alen, q0, r, n);
	q--;
	if (*q == 0 && *(q-1) == 0)
		desize(ia, tlen + 1);
	else
		desize(ia, tlen);

	return ia;
}

//--------- power function ----  return a^b
/*  intPower, basic algorithm: 
    while ((n & 1) == 0) {
        a = a*a; b >>= 1;
    }
    x = a;
    while (b >>= 1) {
        a = a*a;
        if (b & 1) x = a*x;
    }
    return x;
*/

Tintbbp intbbpower(Tintbbp ia, unsigned n) {
	tmpintbbp[9] = intbbcopy(ia);
	while ((n & 1) == 0) {
		ia = intbbsquare(tmpintbbp[9]);
		deletep0(tmpintbbp[9]);
		tmpintbbp[9] = ia;
		n >>= 1;
	}
	tmpintbbp[8] = intbbcopy(tmpintbbp[9]);
	while (n >>= 1) {
		ia = intbbsquare(tmpintbbp[8]);
		deletep0(tmpintbbp[8]);
		tmpintbbp[8] = ia;
		if (n & 1) {
			ia = intbbprod(tmpintbbp[8], tmpintbbp[9]);
			deletep0(tmpintbbp[9]);
			tmpintbbp[9] = ia;
		}
	}

	ia = tmpintbbp[9];
	deletep(tmpintbbp[8]);
	tmpintbbp[9] = 0;
	return ia;
}

//=======================================================

int intbbcmp(Tintbbp ia, Tintbbp ib) {
	size_t alen = (ia->len()), blen = (ib->len());
    if (alen < blen)
		return -1;
	else if (alen > blen)
		return 1;

	BBCELLP a = ia->num, b = ib->num, abegin = a;
	for (a += (alen-1), b += (alen-1); a >= abegin; a--, b--)
		if (*a > *b) return 1;
		else if (*a < *b) return -1;

	return 0;
}

//-----------------2001.5-------------------
Tintbbp intbbleft(Tintbbp a, unsigned n)
{
	unsigned r = n & 0x01f, l = n >> 5;
	BBCELL * p, * end, * q;
	size_t len = a->len();
	
	p = a->num;
	end = p + len;

	if (r) len++;
	len += l;

	Tintbbp b;
	ialloc(b, len);

	q = b->num;

	for (unsigned int i = 0 ; i < l ; i++)
		*(q++) = 0;

	if (r) {
		for (l = 32 - r, n = 0; p < end; p++, q++) {
			*q = ((*p) << r) | n;
			n = (*p) >> l;
		}

		if (n == 0) desize(b, 1);
		else *q = n;
	}
	else {
		while (p < end) *q++ = *p++;
	}

	return b;
}

Tintbbp intbbright(Tintbbp a, unsigned n)
{
	unsigned r = n & 0x1f, l = n >> 5;
	BBCELL * p, * end, * q;
	size_t len = a->len();
	
	Tintbbp b;

	if (len <= l) {
		ialloc(b, 1); b->num[0] = 0; return b;
	}

	p = a->num;
	end = p + len;

	len -= l;
	ialloc(b, len);

	q = b->num;
	p += l;

	if (r) {
		for (l = 32-r, n = (*p) >> r, p++; p < end; p++, q++) {
			*q = (*p << l) | n;
			n = (*p) >> r;
		}
		*q = n;
		if (n == 0 && len != 1) desize(b, 1);
	}
	else
		while (p < end) *q++ = *p++;

	return b;
}

Tintbbp intbbleft1(Tintbbp a)
{
	if (a->len() > 1) return 0;
	unsigned n = a->num[0];
//	if (n>=(1u<<24)) return 0;

	unsigned len = (n >> 5);
	unsigned r = n & 0x01f;
	ialloc(a, len + 1);

	for(unsigned i = 0; i < len ; i++ ) 
		a->num[i] = 0;
	if (r) a->num[i] = 1u << r;
	else a->num[i] = 1;
	return a;
}

int intbbnum2 (Tintbbp a)
{
	BBCELL *p, *q;
	if ((a->len() == 1 && a->num[0]==0)) return -1;

	for(q = p = a->num; *p == 0 ; p++) 
		;

/*	work correct
	unsigned n = *p;
	_asm
	{
		bsf EAX, n
		mov n, EAX
	}
	return n + 32 * (p - q);
/*/
	int count = 32 * (p - q);	
	unsigned n = *p;
	if ((n & 0xffff) == 0) { count += 16; n >>= 16; }
	if ((n & 0xff)   == 0) { count += 8; n >>= 8; }
	if ((n & 0xf)    == 0) { count += 4; n >>= 4; }
	if ((n & 0x3)    == 0) { count += 2; n >>= 2; }
	if ((n & 0x1)    == 0) count++;
	return count;
//*/
}

Tintbbp intbbdiv2 (Tintbbp a)
{
	int n = intbbnum2(a);
	return n < 0 ? a : intbbright(a, n);
}

// in-place add1
Tintbbp intbbadd1(Tintbbp ia) {
	size_t alen = ia->len();
	BBCELLP a = ia->num, enda = a + alen;
	for (; a < enda; a++) {
		if (++(*a) != 0) return ia; // if no-carry, finish
	}
	// carry in the last, should build an "alen+1 cell" with 1 in the last cell

	Tintbbp ib;
	ialloc(ib, alen + 1);
	for (a = ib->num, enda = a + alen; a < enda; a++)
		*a = 0;
	*enda = 1;

	deletep0(ia);	// mark old intbb unused;
	return ib;
}

Tintbbp intbbsub1(Tintbbp ia) {
	size_t alen = ia->len();
	BBCELLP a = ia->num, enda = a + alen - 1;
	for (; a <= enda; a++) {
		if ((--(*a) != 0xffffffff) && (a != enda)) return ia; // if no-borrow, finish
	}

	if (*enda == 0 && alen != 1) { // highest cell is 0;
		Tintbbp ib;
		ialloc(ib, alen - 1);
		for (a = ib->num, enda = a + alen - 1; a < enda; a++)
			*a = 0xffffffff;
		deletep0(ia);
		return ib;
	}

	return ia;
}

unsigned sqrt_unsigned (unsigned n) {
	unsigned x = n, y;

	y = n >> (n > 1 ? 1 : 0); // n shift 1-bit right when n > 1

	while (y < x) {
		x = y;
		y = (x + n / x) >> 1;
	}

	return x;
}

Tintbbp intbbhalf (Tintbbp ia) {
	int len = ia->len(); 
	BBCELLP p, q;
	unsigned sq = sqrt_unsigned(ia->num[len-1]);

	if (len % 2) {	// len: odd
		len = (len >> 1) + 1;
		ialloc(ia, len);
		for (p = ia->num, q = p + len - 1; p < q; p++)
			*p = 0xffffffff;
		*p = sq;
	}
	else {
		len = len >> 1;
		ialloc(ia, len);
		for (p = ia->num, q = p + len - 1; p < q; p++)
			*p = 0xffffffff;
		*p = (sq << 16) | 0x0000ffff;
	}

	return ia;
}
