// //

#ifdef TEST
#include <assert.h>
#endif

unsigned int TVMM::cblock=0;
unsigned TVMM::current=0;
int * TVMM::block_addr[_TVMM_MAX_BLOCK_NUM]={0};
int * TVMM::block_head[_TVMM_MAX_BLOCK_NUM]={0};
int * TVMM::block_tail[_TVMM_MAX_BLOCK_NUM]={0};
int * TVMM::phead=0;
int * TVMM::ptail=0;

void * TVMM::alloc(size_t n) // òִСΪnĴ洢顣
			// طַɹʱ0
{
	void * tp;

	if (n > _TVMM_BLOCK_SIZE) {
		cout << "Object too large! Stop program!\n";
		exit(1);
	}

	if (phead + n <= ptail) { // ǰ㹻
		tp = phead;
		phead += n;
		return tp;
	}

/*
	block_head[current] = phead;	// 浱ǰ״̬
	//  block_tail[current] = ptail; Ϊһ

	for (unsigned i = 0; i < cblock; i++) {	// 跨ҵһ㹻ռĿ
		if (block_head[i] + n < block_tail[i]) {
			current = i;
			tp = block_head[i];
			phead = (int*)tp + n;
			ptail = block_tail[i];
			return tp;
		}
	}
//*/

	compact();

	if (phead + n <= ptail) { // ǰ㹻
		tp = phead;
		phead += n;
		return tp;
	}

/*
	block_head[current] = phead;	// 浱ǰ״̬
	//  block_tail[current] = ptail; Ϊһ

	for (unsigned i = 0; i < cblock; i++) {	// 跨ҵһ㹻ռĿ
		if (block_head[i] + n < block_tail[i]) {
			current = i;
			tp = block_head[i];
			phead = (int*)tp + n;
			ptail = block_tail[i];
			return tp;
		}
	}
//*/

	if (add_a_block()) { // ¿飬ɹ
		tp = phead;
		phead += n;
		return tp;
	}

	cout << "Memory exhuasted! Stop program!\n";
	exit(1);
	return 0;
}

int TVMM::add_a_block()
{
	if (cblock == _TVMM_MAX_BLOCK_NUM)
		return 0;

	int * tp=(int *)malloc(_TVMM_BLOCK_SIZE * sizeof(int));
	if (tp)
	{
		block_addr[cblock]=tp;
		phead = block_head[cblock] = tp;
		ptail = block_tail[cblock] = tp + _TVMM_BLOCK_SIZE;
		current = cblock;
		cblock++;
		return 1;
	}
	else
		return 0;
}

typedef struct entry {
	int *addr; int offset;
} tentry, *tentryp;

static int TEMPTABLESIZE = 1024;

static tentry * temptable = 0;

static tentryp tbbase, tbtop, tbp;

#define VCELL_INUSE(x) (((x) & 0x80000000) != 0)
#define VCELL_NOTUSE(x) (((x) & 0x80000000) == 0)
#define VCELL_REALLEN(x) (((x) & VCELL_LEN) + 1)

inline void inittable (int *base) {
	// should set the tbbase and tbtop before going on.
	// base is the start position of the vmm space.
	if (temptable == 0) {
		temptable = (tentry *)malloc(sizeof(tentry) * TEMPTABLESIZE);
		tbtop  = temptable + TEMPTABLESIZE;
	}
	tbp = tbbase = temptable;	// these two statements should modified later.

	tbp->addr = base; tbp->offset = 0;
	tbp++;
}

inline void addin (int *addr, int offset) {
	if (tbp >= tbtop) {
		tentry * temp = 
			(tentry *)realloc(temptable, sizeof(tentry) * TEMPTABLESIZE * 2);
		if (temp == NULL) {
			cout << "Can't get bigger GC stack. Stop!" << endl;
			exit(5);
		}
		tbbase = temptable = temp;
		tbp = temptable + TEMPTABLESIZE;
		tbtop = tbp + TEMPTABLESIZE;
		TEMPTABLESIZE <<= 1;
	}
	
	tbp->addr = addr; 
	tbp->offset = offset;
	tbp++;
}

// *p is the pointer which should be adjusted.
// 1) look up it in the table;
// 2) adjust it (subs from it the offset).
inline void addjust(int *p) {
	tentryp b = tbbase, e = tbp - 1, tp;
	int *q = (int*)*p;

	// use q to search the adjust table, then update the value of *p
	while (e > b) {
		tp = b + (e - b)/2;
		if (q < tp->addr) e = tp;
		else b = tp + 1;
	}
	*((int**)p) -= (b-1)->offset;
}

int TVMM::compact() 
{
	int *bbegin, *bend, *to, *from;
	int hd, len;

#ifdef COMPACT
	cout << "GC begin" << endl;
#endif

	bbegin = block_addr[0]; // begin and end of the checking area
	bend = phead;
	inittable(bbegin);

	/* step over in-used cells at the begining */
	for (from = bbegin; from < bend; from += VCELL_REALLEN(hd)) {
		if (VCELL_NOTUSE(hd = *from)) break;
		// VCELL_NOTUSE(hd) != 0 : not-used now. In-used section end
	}

	to = from;
	/* moving vary-length cell */
	while (from < bend) {
		if (VCELL_NOTUSE(hd = *from)) {
			from += VCELL_REALLEN(hd); 
		}
		else {
			// add an entry into the shift-table: addess, shift
			// shift: different of pointers
			addin(from, from - to);
			do {
				len = VCELL_REALLEN(hd);
				for (int i = 0; i < len; i++)
					*to++ = *from++;
			} while (from < bend && VCELL_INUSE(hd = *from));
			// not finished, and the vcell is in-use.
		}
	}

	addin(from, from-to); // add in an extra-entry to indicate table-end

	if (phead == to) { // no memory reclaimed
#ifdef COMPACT
		cout << "GC: no reclaimed" << endl;
#endif
		return 0;
	}
	else {
#ifdef COMPACT
		cout << "Compact: " << phead - to << "reclaimed" << endl;
#endif
	}

	// adjust temp pointers
	for (int i = 0; i < _INTBBTMP_NUM; i++)
		if (tmpintbbp[i] != 0)
			addjust( (int*)tmpintbbp+i );

	// adjust pointers in up-level cells
	int *p;

	for (i = 0; i < TCMM::cblock - 1; i++) {
		// ӿ0TCMM::cblock - 2ȫùģҪȫɨ
		bbegin = TCMM::cblock_addr[i];
		bend = bbegin + _TCMM_BLOCK_SIZE;
		for (p = bbegin; p < bend; p += _TCMM_OBJ_SIZE)
			if (*p != 0) {
				addjust( p+1 );
//				if (*p & BEXP_FRAC != 0) addjust( p+2 );
			}
	}

	// TCMM::cblock - 1ֻһ֣TCMM::cblock_addr[i] ~ cphead
	// Աɨһռ䣬ݺٵʱ
	bbegin = TCMM::cblock_addr[i];
	bend = TCMM::cphead;
	for (p = bbegin; p < bend; p += _TCMM_OBJ_SIZE)
		if (*p != 0) {
			addjust( p+1 );
// 			if (*p & BEXP_FRAC != 0) addjust( p+2 ); // franctions.

		}


#ifdef COMPACT
	cout << "Compact: end";
	cout << endl;
#endif

	phead = to;	// to is the first positon of the free space
	// moving vary-length cell finished
	
	return 1;
}