//#pragm implementation
//#pragma implementation "lang.h"
//#include <stdafx.h>
#include <stdio.h>
#include <stdlib.h>
//#include <stream.h>
#include <iostream.h>
#include "basetype.h"
#include "global.h"

#include "express.h"
#include "lang.h"
//#include "templist.h"
#include "slistnodetrun.h"
#ifdef _WINDOWS
#include "..\gui\index.h"
#endif
//#pragma interface
//=======================================================================
//=======================================================================
TContinue::TContinue()
{
};
TContinue::~TContinue()
{};
TRunType TContinue::Run()
{
 return TCONTINUE;
}
void TContinue::show(outtype& out) const
{
  //cout << "continue show: not defined;";
   display(out);
}
void TContinue::print(outtype& out) const
{
//cout << "continue print: not defined;";
   display(out);
}
void TContinue::display(outtype& out) const
{
 out << "continue;";
}

void *TContinue:: operator new(size_t)
{
 return  (TContinue*)StarMem->alloc();
};
void TContinue::operator delete(void *p)
{
 (StarMem->free(p));
};
//=========================================
TBreak::TBreak()
{
};
TBreak::~TBreak()
{};
TRunType TBreak::Run()
{
 return TBREAK;
}
void TBreak::show(outtype& out) const
{
out << "break;";
}
void TBreak::print(outtype& out) const
{
out << "break;";
}
void TBreak::display(outtype& out) const
{
out << "break;";
}

void *TBreak::operator new(size_t)
{
 return  (TBreak*)StarMem->alloc();
};
void TBreak::operator delete(void *p)
{
 (StarMem->free(p));
};
//=========================================
TPrint::~TPrint()
{
if(data && data->TypeID() != Variable)
  delete data;
}

TRunType TPrint::Run()
{
 display();
 return TNORMAL;
}
void TPrint::show(outtype& out) const
{
 if (!data) return;
 data->display(out);
 return;
}
void TPrint::print(outtype& out) const
{
 cout<<"TPrint::print: not defined\n";
}

void TPrint::display(outtype& out) const
{
 if (!data) return;
 TAtom *v=data->eval();
 v->display(out);
 delete v;
 return;
}

void *TPrint::operator new(size_t)
{
 return  (TPrint*)StarMem->alloc();
};
void TPrint::operator delete(void *p)
{
 (StarMem->free(p));
};
//===================================================================
TAssign:: TAssign()
{
 var=0; val=0;
};
TAssign:: TAssign(TVariable *vr, TAtom *vl)
{
 var=vr;
 var->type=TVARIABLE;
 val=vl;
};
TAssign:: ~TAssign()
{
 if(val && val->TypeID() != Variable) delete val;
};

TVariable* TAssign::SetVar(TVariable *v)
{
 if(var && (var !=v)) 
	  delete var; 
 var=v;
 var->SetType(TVARIABLE);
 return var;
};
TAtom *  TAssign::SetVal(TAtom* v)
{
 if(val && (val !=v)) 
	  delete val; 
 return  val=v;
};

TRunType  TAssign:: Run()
{
 //var->SetValue(val->Copy());  
 var->SetValue(val->eval());  
 var->SetType(TVARIABLE);
 return TNORMAL;
};

void TAssign::show(outtype& out) const
{
 //cout<<"TAssign::show: not defined\n";
   display(out);
}

void TAssign::print(outtype& out) const
{
 //cout<<"TAssign::show: not defined\n";
   display(out);
}
void TAssign::display(outtype& out) const
{
 var->display(out);
 wout<<"=";
 val->display(out);
}
void *TAssign::operator new(size_t)
{
 return  (TAssign*)StarMem->alloc();
};
void TAssign::operator delete(void *p)
{
 (StarMem->free(p));
};
//==================================================================
 
TDefine::   TDefine():TAssign()
{};
TDefine::TDefine(TVariable *vr, TAtom *vl):TAssign(vr,vl)
{
 var->type=TVARIABLE;
};
TDefine::~TDefine()
{
// if(val) delete val;
};

void TDefine::show(outtype& out) const
{
 //cout<<"TDefine::show: not defined\n";
   display(out);
}
void TDefine::print(outtype& out) const
{
 //cout<<"TDefine::show: not defined\n";
   display(out);
}
void TDefine::display(outtype& out) const
{
 var->display(out);
 wout<<":=";
 val->display(out);
}

TRunType TDefine::Run()
{
 //var->SetValue(val->Copy());  
 var->SetValue(val->eval());  
 var->SetType(TVARIABLE);
 return TNORMAL;
};

void *TDefine::operator new(size_t)
{
 return  (TDefine*)StarMem->alloc();
};
void TDefine::operator delete(void *p)
{
 (StarMem->free(p));
};

//================================================================


TReturn::TReturn(TAtom *v)
{
 val=v;
};
TReturn:: ~TReturn()
{
 if(val && val->TypeID() != Variable)
   delete val;
};
TRunType TReturn::Run()
{
 if(val)
  {
    TAtom *vv=val->eval();
    ReturnValue=vv;
 } 
 else ReturnValue=0;
 return TRETURN;

};
void TReturn::show(outtype& out) const
{
 //cout<<"TReturn::show:\n";
 display(out);
}
void TReturn::print(outtype& out) const
{
 //cout<<"TReturn::show:\n";
 display(out);
}
void TReturn::display(outtype& out) const
{
 out << "return ";
 if(val) {
     wout<<"("; val->display(out); wout<<");\n";
  	 }
}
void *TReturn::operator new(size_t)
{
 return  (TReturn*)StarMem->alloc();
};
void TReturn::operator delete(void *p)
{
 (StarMem->free(p));
};

//===============================================================
TIfClause::TIfClause()
{
//condition=new TBoolCell;
then_list=new TRunList;
else_list=new TRunList;
};
TIfClause::TIfClause(TBoolCell *con,TRunList *th, TRunList *el)
{

 condition=con;
 then_list=th;
 else_list=el;
};
TIfClause::~TIfClause()
{/*
 if(condition) delete condition;
 if(then_list) delete then_list;
 if(else_list) delete else_list;
 */
 if(condition && condition->TypeID() !=Variable) delete condition;
 if(then_list) delete then_list;
 if(else_list) delete else_list;
};
void TIfClause::SetBool(TBoolCell *c)
{
 condition=c;
};
TRunList  *  TIfClause::GetThen()
{ return then_list;
};
TRunList  *  TIfClause::GetElse()
{ return else_list;
};
TRunType TIfClause::Run()
{
 TRunType rt1=TNORMAL,rt=condition->Run();
 if (rt==TERROR) return TERROR;
 if (rt==TBOOLTRUE) rt1= then_list->Run();
 else if(else_list) rt1=else_list->Run() ;
 return rt1;
};

void TIfClause::show(outtype& out)const
{
 //cout<<"TIfClause::show\n";
 display(out);
}
void TIfClause::print(outtype& out)const
{
 //cout<<"TIfClause::show\n";
 display(out);
}
void TIfClause::display(outtype& out)const
{
 wout<<"if ("; condition->display(out);
 wout<<") then \n"; then_list->display(out);
 wout<<" else \n\t"; else_list->display(out); wout<<" fi; "<<endl;
}
void *TIfClause::operator new(size_t)
{
 return  (TIfClause*)StarMem->alloc();
};
void TIfClause::operator delete(void *p)
{
 (StarMem->free(p));
};

//=================================================================
TWhileClause::TWhileClause()
{
 //condition = new TBoolCell;
 condition = 0;
 do_list= new TRunList;
}

TWhileClause::TWhileClause(TBoolCell *con, TRunList *rl)
{
 condition =con;
 if (rl) do_list=rl;
 else do_list=new TRunList;
}

TWhileClause::~TWhileClause()
{
if(condition && condition->TypeID() != Variable)
 delete condition;
 delete do_list;
}

TRunType TWhileClause::Run()
{
 TRunType rt=TNORMAL;
 do_list->type= TBREAK; 
 while(condition->Run() == TBOOLTRUE)
   {
    rt = do_list->Run();
    if(rt!= TNORMAL) break;
  }
 if(rt==TBREAK) return TNORMAL;
 return rt;
};

void TWhileClause::SetCond(TBoolCell *cn)
{
 if (condition) delete condition;
 condition=cn;
 return;
}

TBoolCell *TWhileClause::GetCond()
{
 return condition;
}

TRunList *TWhileClause::GetDo()
{
 return do_list;
}

void TWhileClause::show(outtype& out)const
{
 //cout<<"TWhileClause::show\n";
 display(out);
}
void TWhileClause::print(outtype& out)const
{
 //cout<<"TWhileClause::show\n";
 display(out);
}
void TWhileClause::display(outtype& out)const
{
  out<<"\nWHILE BEGIN:\n";
  out<<"while(";
 condition->display(out);
  out<<") do\n"; 
 do_list->display(out);
  out<<"\nod";
 out<<endl;
}

void *TWhileClause::operator new(size_t)
{
 return  (TWhileClause*)StarMem->alloc();
};

void TWhileClause::operator delete(void *p)
{
 (StarMem->free(p));
}
//=================================================================
TDoClause::TDoClause():TWhileClause()
{
}

TDoClause::TDoClause(TBoolCell *con, TRunList *rl):TWhileClause(con,rl)
{
}

TDoClause::~TDoClause()
{
}

TRunType TDoClause::Run()
{
 TRunType rt=TNORMAL;
 do_list->type= TBREAK; 
 do
   {
    rt = do_list->Run();
    if(rt!= TNORMAL) break;
  }
 while(condition->Run() == TBOOLTRUE);

 if(rt==TBREAK) return TNORMAL;
 return rt;
};

void TDoClause::show(outtype& out)const
{
 //cout<<"TDoClause::show\n";
 display(out);
}
void TDoClause::print(outtype& out)const
{
 //cout<<"TDoClause::show\n";
 display(out);
}
void TDoClause::display(outtype& out)const
{
 wout<<" DoWhile clause:"; condition->display(out);
 wout<<" "; do_list->display(out);
 out<<endl;
}
void *TDoClause::operator new(size_t)
{
 return  (TDoClause*)StarMem->alloc();
};
void TDoClause::operator delete(void *p)
{
 (StarMem->free(p));
}
//==================================================================
TForClause::TForClause(TVariable *v)
{
  var=v;
  from_op= new TNumber;
  to_op  = new TNumber;
  by_op=new TNumber;
  do_list=new TRunList;
}
TForClause::TForClause(TVariable *v, TNumber *f, TNumber *t, TNumber *b, TRunList *rl)
{
 var=v;
 from_op=f;
 to_op= t;
 if(b) by_op=b;
  else
  {
/*
   by_op=new TExpression();
   TExpTerm *nt= new TExpTerm();
   nt->insert(new TExpTermCell( new TNumber(1) ) );
   by_op->insert(nt);
*/
   by_op=new TNumber(1);
  } 
 if(rl) do_list=rl;
  else do_list=new TRunList();
}

TForClause::~TForClause()
{
 if(from_op && from_op->TypeID() != Variable)
 	delete from_op;
 if(to_op && to_op->TypeID() != Variable)
 	delete to_op;
 if(by_op && by_op->TypeID() != Variable)
       delete by_op;
 if(do_list) delete do_list;
}
TRunList* TForClause::GetDo()
{
 return do_list;
}
TRunType TForClause::Run()
{
 TRunType rt=TNORMAL;
 do_list->type= TBREAK; 
 TAtom *vv=var->GetValue();
 TNumber nn=TNumber(*from_op),*ep=new TNumber(*from_op);
 var->SetValue((TAtom*)ep);
 if((nn)>(*to_op) )
   {
    if( (*by_op) >=0 ) return TERROR; 
    while( (nn)>=(*to_op) )
 	{
  	int cc=nn.compare(to_op);
  	if(cc>0) break;
  	rt=do_list->Run();

  	if(rt!= TNORMAL ) break;
  	nn =(nn)+(*by_op);
        var->SetValue((TAtom*)(new TNumber(nn)) );
 	}

 	if(rt==TBREAK) rt=TNORMAL;
        return rt;
    }
    
 if( (*by_op) <=0 ) return TERROR; 
  while( (nn)<=(*to_op) )
 	{
  	int cc=nn.compare(to_op);
  	if(cc>0) break;
  	rt=do_list->Run();
  	if(rt!= TNORMAL) break;
  	nn =(nn)+(*by_op);
        var->SetValue((TAtom*)(new TNumber(nn)) );
 	}


 	if(rt==TBREAK) rt=TNORMAL;
 return rt;

};

void TForClause::show(outtype& out)const
{
 //cout<<"TForClause::show\n";
 display(out);
}
void TForClause::print(outtype& out)const
{
 //cout<<"TForClause::show\n";
 display(out);
}
void TForClause::display(outtype& out)const
{
/* wout<<" For "; var->display(out); wout<<" from "; from_op->display(out); wout<<" to ";
 to_op->display(out); wout<< " step "; by_op->display(out); wout<<"\n do \n";
 do_list->display(out);
 wout<<"\n od\n";
*/
}

void *TForClause::operator new(size_t)
{
 return  (TForClause*)StarMem->alloc();
};
void TForClause::operator delete(void *p)
{
 (StarMem->free(p));
}

//=========================================================
TForClause1::TForClause1()
{
 init=new TRunList();
 condition=0;
 bylist=new TRunList();
 do_list=new TRunList();
}
TForClause1::TForClause1(TRunList *ini, TBoolCell *con, TRunList *by,
			TRunList *rl)
{
 init=ini;
 condition=con;
 bylist=by;
 if (rl) do_list=rl;
 else do_list=new TRunList();
}

TForClause1::~TForClause1()
{
 if (init) delete init;
 if (condition) delete condition;
 if (bylist) delete bylist;
 if (do_list) delete do_list;
}

TRunList *TForClause1::GetDo()
{
 return do_list;
}

TRunType TForClause1::Run()
{
cout<<"Run....in TForClause1\n"; 
 TRunType rt=TNORMAL;
 do_list->type= TBREAK; 
 init->Run();
 while (condition->Run()==TBOOLTRUE) {
	rt=do_list->Run();
    	if(rt!= TNORMAL) break;
	rt=bylist->Run();
    	if(rt!= TNORMAL) break;
	}	
if(rt==TBREAK) rt=TNORMAL;
 return rt;
}

void TForClause1::display(outtype& out) const
{
 cout<<"calling display of TForClause1\n";
 wout<<"for (";
 init->display(out);
 condition->display(out);
 bylist->display(out);
 wout<<") do\n";
 do_list->display(out);
 wout<<"od";
}
void TForClause1::show(outtype& out) const
{
 display(out);
}
void TForClause1::print(outtype& out) const
{
 display(out);
}

void *TForClause1::operator new(size_t)
{
 return  (TForClause1*)StarMem->alloc();
};
void TForClause1::operator delete(void *p)
{
 (StarMem->free(p));
}
//================================================================
TCaseClause::TCaseClause(TNumber *n,TRunList *tl)
{
// TExpTerm *tt;
 option=n;
 if (tl) do_list=tl;
 else do_list=new TRunList();
}

TCaseClause::~TCaseClause()
{
 if(option  && option->TypeID() != Variable)
 	 delete option;
 if (do_list) delete do_list;
}

TRunType TCaseClause::Run()
{
 SListNodeTRun *tmp=do_list->first();
 TRunType rt=TNORMAL;
 while(tmp) 
  {
   rt=(tmp->getdata())->Run();
   if(rt!=TNORMAL) break;
   tmp= tmp->next;
  }
 return rt;
};
TRunType TCaseClause::CanRun(TAtom   *cond)
{
 if(!option) return Run();
 if(!option->compare(cond) ) 
   {
    	return Run(); 
   }
	else return TNORMAL;
}
void TCaseClause::show(outtype& out)const
{
 //cout<<"TCaseClause::show\n";
 display(out);
}
void TCaseClause::print(outtype& out)const
{
 //cout<<"TCaseClause::show\n";
 display(out);
}
void TCaseClause::display(outtype& out)const
{
 if (!option) wout<<"default:";
 else {
	wout<<"case ";option->display(out);wout<<":";
	}
 do_list->display(out);
}

void *TCaseClause::operator new(size_t)
{
 return  (TCaseClause*)StarMem->alloc();
};

void TCaseClause::operator delete(void *p)
{
 (StarMem->free(p));
}

//================================================================
TCaseList::TCaseList():TRunList()
{
}
TCaseList::~TCaseList()
{
}
TRunType TCaseList::ChooseCaseRun(TAtom   *cond)
{
 SListNodeTRun *tmp=first();
 TCaseClause* runcase=0;
 TRunType rt=TNORMAL;
 while(tmp) 
  {
   runcase=(TCaseClause*)(tmp->getdata());
   rt= runcase->CanRun(cond) ; 

   if(rt!=TNORMAL) break; 
   tmp= tmp->next;
  }
 if(rt==TBREAK) rt=TNORMAL; 
 return rt;
};
TRunType TCaseList::Run()
{
 return TNORMAL;
}

void TCaseList::show(outtype& out)const
{
 //cout<<"TCaseList::show\n";
 display(out);
}
void TCaseList::print(outtype& out)const
{
 //cout<<"TCaseList::show\n";
 display(out);
}
void TCaseList::display(outtype& out)const
{
 TRunList::display(out);
}

void *TCaseList::operator new(size_t)
{
 return  (TCaseList*)StarMem->alloc();
};

void TCaseList::operator delete(void *p)
{
 (StarMem->free(p));
}

//================================================================
TSwitchClause::TSwitchClause(TAtom *cond, TCaseList *cl)
{
 condition=cond;
 if (cl) cases=cl;
 else cl=new TCaseList();
 return;
}

TSwitchClause::~TSwitchClause()
{
 if(condition  && condition->TypeID() != Variable)
  delete condition;
 if (cases) delete cases;
}

TRunType TSwitchClause::Run()
{
 TRunType rt=TNORMAL;
 TAtom *econ=condition->eval();
 rt=cases->ChooseCaseRun(econ);
  delete econ;

 return rt;
};
void TSwitchClause::show(outtype& out)const
{
 //cout<<"TSwitchClause::show\n";
 display(out);
}
void TSwitchClause::print(outtype& out)const
{
 //cout<<"TSwitchClause::show\n";
 display(out);
}
void TSwitchClause::display(outtype& out)const
{
 wout<<"SwitchClause---->Display:\n ";
 wout<<"switch("; condition->display(out); wout<<")\n";
 cases->display(out);
 wout<<"END\n";
 return;
}

void *TSwitchClause::operator new(size_t)
{
 return  (TSwitchClause*)StarMem->alloc();
};
void TSwitchClause::operator delete(void *p)
{
 (StarMem->free(p));
}
//===================================================================
TBoolCell::TBoolCell():TAtom(), TRun()
{}
TBoolCell::~TBoolCell()
{}
TRunType TBoolCell::Run()
{
 return TBOOLTRUE;
};
void TBoolCell::show(outtype& out)const
{
 //wout<<"BoolCell ";
 display(out);
}
void TBoolCell::print(outtype& out)const
{
 //wout<<"BoolCell ";
 display(out);
}
void TBoolCell::display(outtype& out)const
{
 //wout<<"BoolCell ";
}
void *TBoolCell::operator new(size_t)
{
 return  (TBoolCell*)StarMem->alloc();
};
void TBoolCell::operator delete(void *p)
{
 (StarMem->free(p));
}
//===================================================================
TBoolExp::TBoolExp()
{}
TBoolExp::TBoolExp(TLogicExp *p1, TLogicExp *p2, TLogOperator p):TBoolCell()
{
	op1=p1;
	op2=p2;
	op=p;
};
TBoolExp::~TBoolExp()
{
 if(op1  && op1->TypeID() != Variable)
 	delete op1;
 if(op2  && op2->TypeID() != Variable)
 	delete op2;
}
TRunType TBoolExp::Run()
{
 TRunType v1=op1->Run();
 TRunType v2=(op2? op2->Run(): TNORMAL );
 TRunType rt;
 switch(op) {
	case TAND: if (v1==TBOOLTRUE && v2 == TBOOLTRUE)
		     rt=TBOOLTRUE;
		else rt=TBOOLFALSE;
		break;
	case TOR: if (v1==TBOOLTRUE || v2 == TBOOLTRUE)
			rt=TBOOLTRUE;
                else rt=TBOOLFALSE;
                break;
 
	case TNOT: if (v1==TBOOLFALSE) 
                        rt=TBOOLTRUE;
                else rt=TBOOLFALSE;
                break;
	default: rt=TERROR; 
	}
 return rt;
};

TAtom* TBoolExp::Copy()
{
 return this;
}
void TBoolExp::show(outtype& out)const
{
 //wout<<"BOOLExp ";
 display(out);
}
void TBoolExp::print(outtype& out)const
{
 //wout<<"BOOLExp ";
 display(out);
}
void TBoolExp::display(outtype& out)const
{
 if(op2){
 
   op1->display(out);
   out<<opsTbl[op].sym;
  op2->display(out);
    }
    else
     {
      cout<<"!";op1->display();
     }
}
void *TBoolExp::operator new(size_t)
{
 return  (TBoolExp*)StarMem->alloc();
};
void TBoolExp::operator delete(void *p)
{
 (StarMem->free(p));
}
 
//===================================================================
TLogicExp::TLogicExp()
{}

TLogicExp::TLogicExp(TAtom *p1, TAtom *p2, TLogOperator p)
{
	op1=p1;
	op2=p2;
 op=p;
};
TLogicExp::~TLogicExp()
{
 if(op1  && op1->TypeID() != Variable)
 	delete op1;
 if(op2  && op2->TypeID() != Variable)
 	delete op2;
}
TRunType TLogicExp::Run()
{
 TAtom *v1=op1->eval();
 TAtom *v2=op2->eval();
 int t=0;
 TRunType rt;
 t=v1->compare(v2);
 delete v1;
 delete v2;
 switch(t) {
	case 0: if (op==TEQ || op == TGE || op == TLE ) 
		     rt=TBOOLTRUE;
		else rt=TBOOLFALSE;
		break;
	case 1: if (op==TGT || op == TGE ||op==TNE)
			rt=TBOOLTRUE;
                else rt=TBOOLFALSE;
                break;
 
	case -1: if (op==TLT || op == TLE ||op==TNE)
                        rt=TBOOLTRUE;
                else rt=TBOOLFALSE;
                break;
	default: rt=TERROR; 
	}
 return rt;
};
TAtom* TLogicExp::Copy()
{
 return (TAtom*)(new TLogicExp(op1,op2,op));
}
void TLogicExp::show(outtype& out)const
{
 //wout<<"LogicExp ";
 display(out);
}
void TLogicExp::print(outtype& out)const
{
 //wout<<"LogicExp ";
 display(out);
}
void TLogicExp::display(outtype& out)const
{
 op1->display(out);
 out<<opsTbl[op].sym;
 op2->display(out);
 //cout<<"LogicExp ";
}
void *TLogicExp::operator new(size_t)
{
 return  (TLogicExp*)StarMem->alloc();
};
void TLogicExp::operator delete(void *p)
{
 (StarMem->free(p));
}

