//#include <stdafx.h>
#include <stdio.h>
#include <string.h>
#include <new.h>

#include "basetype.h"
#include "global.h"
#include "lists.h"
#include "vectors.h"
#include "pol.h" 
#include "matrix.h"
#include "number.h"
#include "geometry.h"
#include "check.h"
#ifdef _WINDOWS
#include "..\gui\index.h"
#endif

//the width of the matrix is h_dim,so the range of h_dim is from 1.
//the heighth of the matrix is v_dim,so the range of v_dim is from 1.
TMatrix::TMatrix(int v,int h)
{
	if(v <= 0 || h <= 0)
	{
		wout<<"matrix constructor is wrong!"<<endl;
		return;
	}
	v_dim = v;
	h_dim = h;
	val = (TAtom **)malloc((sizeof(TAtom *)) * v_dim * h_dim);
	for(int i = 0;i < v_dim * h_dim;i ++)
		val[i] = 0;
}

TMatrix::TMatrix(int v,int h,TList * l)
{
	int len = l->length();
	if(v <= 0 || h <= 0 || len != v * h)
	{
		wout<<"matrix constructor is wrong!"<<endl;
		val = (TAtom **)malloc(sizeof(TAtom *));
	}
	else
	{
		v_dim = v;
		h_dim = h;
	
		val = (TAtom **)malloc((sizeof(TAtom *)) * v_dim * h_dim);
		int i = 0;
		for(TListNode * tmp = FIRSTNODE(l);tmp;RNEXT(tmp))
		{
			TAtom *a = DATA(tmp);
			val[i] = a->Copy();
			i ++;
		}
//  val[0] = (TAtom *)(l->first()->getdata()->Copy());
//	for(int i = 1;i < len;i ++)
//		val[i] = (TAtom *)(l->Part(i + 1)->Copy());
	}
}

TMatrix::TMatrix(TMatrix * tm)
{
	v_dim = tm->VSize(); 
	h_dim = tm->HSize();
	
	val = (TAtom **)malloc(sizeof(TAtom *)* v_dim * h_dim);

	val[0] = (TAtom *)(tm->val[0]->Copy());
	for(int i = 1;i < v_dim * h_dim;i ++)
		val[i] = (TAtom *)(tm->val[i]->Copy());
}

TMatrix::TMatrix(TList* list,int direction)
{
	list->display();wout<<endl;
	if(direction == 0)
	{
		v_dim = list->length();
		h_dim = 1;
		val = (TAtom **)malloc(sizeof(TAtom *)* v_dim);
		
		for(int i = 0;i < v_dim;i ++)
		{
			TAtom *a = (list->Part(i + 1))->Copy();
			a->display();wout<<endl;
			val[i] = (list->Part(i + 1))->Copy();
		}

	}
	else
	{
		h_dim = list->length();
		v_dim = 1;
		val = (TAtom **)malloc(sizeof(TAtom *) * h_dim);
		
		for(int i = 0;i < h_dim;i ++)
			val[i] = (list->Part(i + 1))->Copy();
	}
}

TMatrix::~TMatrix()
{
   TAtom * t1;
   for(int i = 0;i < v_dim;i ++)
		for(int j = 0;j < h_dim;j ++)
		{ 
			t1 = GetVal(i,j);
		    if  (t1) delete t1;
		}
	::free(val); 
}

TMatrix* TMatrix:: operator=(TMatrix* m)
{
	TAtom * t1;
	for(int i = 0;i < v_dim;i ++)
		for(int j = 0;j < h_dim;j ++)
		{ 
			t1 = GetVal(i,j);
		    if  (t1) delete t1;
		}
	::free(val);

	v_dim = m->VSize();
	h_dim = m->HSize();
	val = (TAtom **)malloc(sizeof(TAtom *)* v_dim * h_dim);

	val[0] = (TAtom *)(m->val[0]->Copy());
	for(i = 1;i < v_dim * h_dim;i ++)
		val[i] = (TAtom *)(m->val[i]->Copy());

	return this;
}

TList * TMatrix::TranList()
{
	TList * list = new TList();
	for(int i = 0;i < v_dim;i ++)
		for(int j = 0;j < h_dim;j ++)
			list->append(CopyVal(i,j));
	return list;
}

TAtom * TMatrix::GetVal(int i,int j)
{
	if(val[i * h_dim + j] != 0)
		return val[i * h_dim + j];
	else return 0;
}

TAtom * TMatrix::CopyVal(int i,int j)
{
	if(val[i * h_dim + j] != 0)
		return val[i * h_dim + j]->Copy();
	else return 0;
}

void TMatrix::SetVal(int i,int j,TAtom * value)
{
	TAtom * t1 = GetVal(i,j);
	if(t1) {delete t1;t1 = 0;}
	val[i * h_dim + j] = value;
}

DataType TMatrix::TypeID()const
{	
	return MatrixType;
};

//============================================

TAtom* TMatrix::Clone()
{
	return (TMatrix *)(Copy());
}

TAtom* TMatrix::Copy()
{
	TMatrix* m;
	m = new TMatrix(this);
	return m;
};

//====================================================
void TMatrix::display(outtype& out)const
{
	wout<<"matrix(";
	for(int i = 0;i < v_dim;i ++)
	{	
		for(int j = 0;j < h_dim;j ++)
		{
			val[i * h_dim + j]->display();
			if(j != h_dim - 1)
				wout<<",";
		}
		if(i != v_dim - 1)
			wout<<";";
	}
	wout<<")";
}

void TMatrix::show(outtype& out)const
{
	display(out);
}

void TMatrix::print(outtype& out)const
{
	display(out);
}
//===================================
TAtom * TMatrix::eval()
{
	TMatrix* m=new TMatrix(v_dim,h_dim);

	for(int i = 0;i < v_dim;i ++)
		for(int j = 0;j < h_dim;j ++)
			m->SetVal(i,j,val[i * h_dim + j]->eval());
	return m;
}


TRunType TMatrix::Run()
{

 TRunType rt = TNORMAL;
 return rt;
}
//===================================================================
TMatrix* TMatrix::Tran()        ///  [      ]T
{
	TMatrix* nr=new TMatrix(this->h_dim,this->v_dim); 

	for(int i = 0;i < h_dim;i ++)
		for(int j = 0;j < v_dim;j ++)
			nr->SetVal(i,j,CopyVal(j,i));

	return nr;
}

TMatrix* TMatrix::SubMatrix(int v1,int v2,int h1,int h2)
{
	if(v1 < 0 || v2 < 0 || h1 < 0 || h2 < 0 || (v2 - v1) < 0 || (h2 - h1) < 0
		 || v2 >= v_dim || h2 >= h_dim)
	{
		wout<<"submatrix input wrong"<<endl;
		return 0;
	}

	TMatrix * m = new TMatrix(v2 - v1 + 1,h2 - h1 + 1);
	for(int i = v1;i <= v2;i ++)
		for(int j = h1;j <= h2;j ++)
		{
			m->SetVal(i - v1,j - h1,CopyVal(i,j));		
		}

	return m;
}

TMatrix* TMatrix::SubMatrix(TList* Vlist,TList* Hlist)
{
	int v = Vlist->length();
	int h = Hlist->length();
	TMatrix * m = new TMatrix(v,h);
	
	for(int i = 0;i < v;i ++)
		for(int j = 0;j < h;j ++)
		{
		
			TNumber * num1 = (TNumber *)(Vlist->Part(i + 1));
			TBigInt * n1 = (TBigInt *)num1->GetPtr();
			int a = n1->GetShort(0);
			if(a < 0 || a >= v_dim)
			{
				wout<<"Error! wrong parameter type\n";
				delete m;
				return 0;
			}
			
			TNumber * num2 = (TNumber *)(Hlist->Part(j + 1));
			TBigInt * n2 = (TBigInt *)num2->GetPtr();
			int b = n2->GetShort(0);
			if(b < 0 || b >= h_dim)
			{
				wout<<"Error! wrong parameter type\n";
				delete m;
				return 0;
			}
	
			m->SetVal(i,j,CopyVal(a,b));
		}

	return m;
}

TMatrix* TMatrix::SubMatrix(TList* Vlist,int h1,int h2)
{
	int v = Vlist->length();
	int h = h2 - h1 + 1;
	
	TMatrix * m = new TMatrix(v,h);
	for(int i = 0;i < v;i ++)
		for(int j = 0;j < h;j ++)
		{
		
			TNumber * num1 = (TNumber *)(Vlist->Part(i + 1));
			TBigInt * n1 = (TBigInt *)num1->GetPtr();
			int a = n1->GetShort(0);
			if(a < 0 || a >= v_dim)
			{
				wout<<"Error! wrong parameter type\n";
				delete m;
				return 0;
			}
			m->SetVal(i,j,CopyVal(a,j + h1));
		}

	return m;
}

TMatrix* TMatrix::SubMatrix(int v1,int v2,TList* Hlist)
{
	int v = v2 - v1 + 1;
	int h = Hlist->length();
	
	TMatrix * m = new TMatrix(v,h);
	for(int i = 0;i < v;i ++)
		for(int j = 0;j < h;j ++)
		{
			TNumber * num1 = (TNumber *)(Hlist->Part(j + 1));
			TBigInt * n1 = (TBigInt *)num1->GetPtr();
			int a = n1->GetShort(0);
			if(a < 0 || a >= h_dim)
			{
				wout<<"Error! wrong parameter type\n";
				delete m;
				return 0;
			}
			m->SetVal(i,j,CopyVal(i + v1,a));
		}

	return m;
}

TMatrix* TMatrix::col(int h1)
{
	if(h1 < 0 || h1 >= h_dim)
	{
		wout<<"col input wrong"<<endl;
		return 0;
	}

	TMatrix * m = new TMatrix(v_dim,1);
	for(int i = 0;i < v_dim;i ++)
		m->SetVal(i,0,CopyVal(i,h1));

	return m;
}

TMatrix* TMatrix::col(int h1,int h2)
{
	int range;
	range = h2 - h1 + 1;

	if(h1 < 0 || h1 >= h_dim || h2 < 0 || h2 >= h_dim || range <= 0)
	{
		wout<<"col input wrong"<<endl;
		return 0;
	}

	TMatrix * m = new TMatrix(v_dim,range);
	for(int i = 0;i < v_dim;i ++)
		for(int j = 0;j < range;j ++)
		{
			m->SetVal(i,j,CopyVal(i,j + h1));
		}
	
	return m;
}

TMatrix* TMatrix::row(int v1)
{
	
	if(v1 < 0 || v1 >= v_dim)
	{
		wout<<"row input wrong"<<endl;
		return 0;
	}

	TMatrix * m = new TMatrix(1, h_dim);
	for(int i = 0;i < h_dim;i ++)
		m->SetVal(0,i,CopyVal(v1,i));

	return m;
}

TMatrix* TMatrix::row(int v1,int v2)
{
	int range;
	range = v2 - v1 + 1;

	if(v1 < 0 || v1 >= v_dim || v2 < 0 || v2 >= v_dim || range <= 0)
	{
		wout<<"row input wrong"<<endl;
		return 0;
	}

	TMatrix * m = new TMatrix(range,h_dim);
	for(int i = 0;i < range;i ++)
		for(int j = 0;j < h_dim;j ++)
		{
			m->SetVal(i,j,CopyVal(i + v1,j));
		}
	
	return m;
}

TMatrix* TMatrix::delrow(int v1)
{
	TMatrix * m = new TMatrix(v_dim - 1,h_dim);
	for(int i = 0;i < v_dim;i ++)
		for(int j = 0;j < h_dim;j ++)
		{
			int k = i;
			if(i >= v1)
				k ++;
			m->SetVal(i,j,CopyVal(k,j));
		}
	return m;
}

TMatrix* TMatrix::delcol(int h1)
{
	TMatrix * m = new TMatrix(v_dim,h_dim - 1);
	for(int i = 0;i < v_dim;i ++)
		for(int j = 0;j < h_dim - 1;j ++)
		{
			int k = j;
			if(j >= h1)
				k ++;
			m->SetVal(i,j,CopyVal(i,k));
		}
	return m;
}

void TMatrix::swaprow(int v1,int v2)
{
	if(v1 < 0 || v1 >= v_dim || v2 < 0 || v2 >= v_dim || v1 == v2)
	{
		wout<<"swaprow input wrong"<<endl;
		return;
	}

	TAtom * tmp;
	for(int i = 0;i < h_dim;i ++)
	{
		tmp = GetVal(v1,i);
		SetVal(v1,i,GetVal(v2,i));
		SetVal(v2,i,tmp);
	}
}

void TMatrix::swapcol(int h1,int h2)
{
	if(h1 < 0 || h1 >= h_dim || h2 < 0 || h2 >= h_dim || h1 == h2)
	{
		wout<<"swapcol input wrong"<<endl;
		return;
	}

	TAtom * tmp;
	for(int i = 0;i < v_dim;i ++)
	{
		tmp = GetVal(i,h1);
		SetVal(i,h1,GetVal(i,h2));
		SetVal(i,h2,tmp);
	}
}

int TMatrix::coldim()
{
	return h_dim;
}

int TMatrix::rowdim()
{
	return v_dim;
}

//********************************************************************************
//m is non destructive
//this is used, 
TMatrix* TMatrix::add(TMatrix *m)
{

	if(v_dim != m->VSize() || h_dim != m->HSize())
	{
		wout<<"Matrix addition different size\n";
		return 0;
	}

	TMatrix* tm = new TMatrix(v_dim,h_dim); 
	for(int i = 0;i < v_dim;i ++)
		for(int j = 0;j < h_dim;j ++)
			tm->SetVal(i,j,::add(CopyVal(i,j),m->CopyVal(i,j)));

 return tm;
}

//m is non destructive
//this is used, 
TMatrix* TMatrix::minus(TMatrix *m)
{

	if(v_dim != m->VSize() || h_dim != m->HSize())
	{
		wout<<"Matrix minus different size\n";
		return 0;
	}
	TMatrix* tm = new TMatrix(v_dim,h_dim); 
 	for(int i = 0;i<v_dim;i ++)
		for(int j = 0;j < h_dim;j ++)
			tm->SetVal(i,j,::minus(CopyVal(i,j),m->CopyVal(i,j)));

 return tm;
}



TMatrix* TMatrix::mul(TMatrix *m)
{
	if(h_dim != m->VSize())
	{
		wout<<"Matrix mult different size\n";
		return 0;
	}

	TAtom *nt;
	int nH = m->HSize();
	TMatrix* tm = new TMatrix(v_dim,nH);

	for (int i = 0;i < v_dim;i ++)
	{
   		for (int j = 0;j < nH;j ++)
		{
			nt = 0;
			for(int k = 0;k < h_dim;k ++)
			{
				nt = ::add(nt,::mul(CopyVal(i,k),m->CopyVal(k,j)));
			}
			tm->SetVal(i,j,nt);
		}
	}

	return tm; 
}

TMatrix * TMatrix::uminus()
{
	TMatrix * m = new TMatrix(v_dim,h_dim);
	for(int i = 0;i < v_dim;i ++)
		for(int j = 0;j < h_dim;j ++)
			(m->val[i * h_dim + j]) = ((TAtom *)val[i * h_dim + j])->uminus();
			
	return m;
}

TMatrix* TMatrix::exp(int p)
{
	TMatrix *m;
	
	if(p < 0 || v_dim != h_dim)
	{
		wout<<"Error! wrong parameter"<<endl;
		return 0;
	}
	if(p == 0)
	{
		m = new TMatrix(v_dim,h_dim);
		for(int i = 0;i < v_dim;i ++)
		{
			TBigInt *a = new TBigInt(1);
			m->SetVal(i,i,a);
		}
		return m;
	}
	if(p == 1)
	{
		m = new TMatrix(this);
		return m;
	}
	else
	{
		m = new TMatrix(this);
		TMatrix *m1;
		for(int i = 1;i < p;i ++)
		{
			m1 = m->mul(this);
			delete m;
			m = m1;
		}
		return m;
	}
}
//=================================================================
//example:a:=matrix(3,3,[x^2,y-3,z^2*x-y^2,12,x^5*y,y*z,3*z,0,y^4*x]);
//			det(a);
//			x^8*y^5-12*y^5*x+36*y^4*x+3*y^2*z^2-9*y*z^2-3*x^6*y*z^3+3*z*x^5*y^3
//example:a:=matrix(4,4,[32,42,11,32,121,18,43,6,4,12,17,62,3,42,12,44]);
//			det(a);
//			1983024
//example:a:=matrix(3,3,[2*x,43*y^2,x*y,0,11*(x-2)*y^2,5*y,0,0,3*z^4]);
//			det(a);
//			66*z^4*y^2*x^2-132*z^4*y^2*x
//example:a:=matrix(3,3,[1,2,3,4,5,8,0,0,0]);
//			det(a);
//			0
//example:a:=matrix(3,3,[x,y,z,2*x,y,0,0,2*x,y]);
//			det(a);
//			4*z*x^2-y^2*x
//example:a:=matrix(4,4,[3*x^3,y^2-3,z^2*x-y^2,12*y,x^5*y,y*z,3*z,5*x^4-5,y^4*x,x2*z,7*y^3-x*z,z^2-3,y*z^3,4*x^2,123*x*y,65*y^3*z*4]);
//			det(a);
//			-369*x^6*y^4+5460*x^3*y^7*z^2-1476*x^6*y^3*x2*z-260*x^5*y^6*x2*z^2+260*x^6*y^4*x2*z^4-1845*x^4*x2*z*y+1845*x^8*x2*z*y-2340*x^3*x2*z^3*y^3+5*y^3*z^4*x2*x^4+5*y*z^6*x2*x-5*y*z^6*x2*x^5-369*x^4*y^2*z^3-885*x^4*y^4*z^3+1107*x^4*y^2*z+260*x^6*y^6*z^2-1820*x^5*y^9*z-369*x^6*y^2*z^2+5460*x^5*y^7*z-657*x^6*y^4*z^2-48*x^8*y^2*z+4*x^7*y^3*z^2+12*x^8*y*z^2-4*x^8*y*z^4-144*y^5*x^3*z-20*y^4*x^4*z^2+20*y^4*x^8*z^2+1476*y^7*x^2*z+260*y^10*x*z^2-260*y^8*x^2*z^4-2340*y^7*x*z^2+780*y^9*x*z^2+y^2*z^8*x-15*y*z^4*x+15*y*z^4*x^5+5*y^3*z^4*x-5*y^3*z^4*x^5+35*y^6*z^3*x^4+36*y^2*z^5*x2-5*y^3*z^4*x2+12*y^3*z^5*x-3*y^2*z^6*x-108*x^5*z+1107*x^6*y^2+420*y^3*x^5-27*y*z^4+9*y*z^6-35*y^6*z^3+9*y^3*z^4-3*y^3*z^6+20*y^6*x^3-20*y^6*x^7-1845*y^5*x^2+1845*y^5*x^6+615*y^7*x^2-615*y^7*x^6+336*x^7*y^5-12*x^7*y^3-60*x^6*z+60*x^10*z-420*x^9*y^3+36*x^5*z^3-84*y^6*z^4+3*y^4*z^4-y^4*z^6+105*y^4*z^3
//example:a:=matrix(5,5,[11,1315,3123,12,43,65,4324,65,4,4324,54654,7657,8768,3543,343,5435,654,654,654,4654,4564,4564,987970,3123,4433]);
//			det(a);
//			-92410140159906731807
TAtom* TMatrix::det()
{
	if(v_dim != h_dim)
	{
		wout<<"can not run in det"<<endl;

		return 0;
	}
	
	int flag = 1;
	TAtom * div1, * div2, * answer;
	TMatrix * tm1,* tm2;
	tm2 = new TMatrix(this);

	for(int k = 0;k < v_dim;k ++)
	{
//		tm2->GetVal(k,k)->display();wout<<endl;
		if(IsZero(tm2->GetVal(k,k)))
		{
			for(int a = k + 1;a < v_dim;a ++)
			{
				if(!IsZero(tm2->GetVal(a,k)))
				{
					tm2->swaprow(k,a);
					flag = - flag;
					break;
				}
			}
			if(IsZero(tm2->GetVal(k,k)))
			{
				//TBigInt * a = new TBigInt(0);
				//return ((TAtom *)a);//the det is 0
				TAtom *a = 0;
				return a;
			}
		}
		
		
		if(k == 0)
		{
			TNumber *a = new TNumber(1);
			div2 = (TAtom *)(a);
		}
		else 
		{
			delete div2;
			div2 = div1;
		}
		div1 = tm2->CopyVal(k,k);
		
		tm1 = tm2;
		tm2 = new TMatrix(v_dim,h_dim);
		for(int i = 0;i < v_dim;i ++)
			for(int j = 0;j < v_dim;j ++)
			{
				if(i == k)
					tm2->SetVal(i,j,tm1->CopyVal(i,j));
				else
				{
					TAtom * a, * b, * c,* d;
					a = ::mul(tm1->CopyVal(k,k),tm1->CopyVal(i,j));
					b = ::mul(tm1->CopyVal(i,k),tm1->CopyVal(k,j));
					c = ::minus(a,b);
					d = ::div(c,div2->Copy());
					tm2->SetVal(i,j,d);
				}
			}
		if(k == v_dim - 1)
			answer = tm1->CopyVal(k,k);
		delete tm1;
	}
	delete div1;
	delete div2;
	delete tm2;
	if(flag == 1)
		return answer;
	else 
	{	
		TBigInt* a = new TBigInt(-1);
		return ::mul((TAtom *)(a),answer);
	}
}

//=================================================================
//example
//1.input   a:=matrix(2,3,[1,1,2,1,3,2]);root(a);
//  answer: x[1] = 2 x[2] = 0

//2.input   a:=matrix(4,5,[2,-1,4,1,6,1,-2,0,1,0,3,3,-4,-1,1,2,-1,1,2,4]);root(a);
//  answer: x[1] = 1 x[2] = 1 x[3] = 1 x[4] = 1

//3.input:  a:=matrix(4,5,[3,-5,7,1,1,2,-1,4,3,1,1,5,5,6,1,-2,0,3,7,1]);root(a);
//  answer: x[1] = 11/57 x[2] = -9/133 x[3] = -1/57 x[4] = 82/399

//4.input:  a:=matrix(3,4,[2,3,5,8,4,6,12,7,6,9,3,4]);root(a);
//  answer: the equation has no solution!

//5.input:  a:=matrix(2,5,[2,3,5,9,8,2,3,6,11,15]);root(a);
//  answer: x[1] = -27/2-3/2*x[2]+1/2*x[4] x[3] = 7-2*x[4]
void TMatrix::root()
{
	TAtom * div1, * div2;
	TMatrix * tm1,* tm2;
	tm2 = new TMatrix(this);
	
	int times = v_dim < h_dim - 1 ? v_dim : h_dim - 1;
	int displace = 0;

	for(int k = 0;k < times;k ++)
	{
		loop:
		if(IsZero(tm2->GetVal(k,k + displace)))
		{
			for(int a = k + 1;a < v_dim;a ++)
			{
				if(!IsZero(tm2->GetVal(a,k + displace)))
				{
					tm2->swaprow(k,a);
					break;
				}
			}
			if(IsZero(tm2->GetVal(k,k + displace)))
			{
				displace ++;
				times --;
				goto loop;
			}
		}
		
		if(k == 0)
		{
			TNumber *a = new TNumber(1);
			div2 = (TAtom *)(a);
		}
		else 
		{
			delete div2;
			div2 = div1;
		}
		div1 = tm2->CopyVal(k,k + displace);
		
		tm1 = tm2;
		tm2 = new TMatrix(v_dim,h_dim);
		for(int i = 0;i < v_dim;i ++)
			for(int j = 0;j < h_dim;j ++)
			{
				if(i == k)
					tm2->SetVal(i,j,tm1->CopyVal(i,j));
				else
				{
					TAtom * a, * b, * c,* d;
					a = ::mul(tm1->CopyVal(k,k + displace),tm1->CopyVal(i,j));
					b = ::mul(tm1->CopyVal(i,k + displace),tm1->CopyVal(k,j));
					c = ::minus(a,b);
					d = ::div(c,div2->Copy());
					tm2->SetVal(i,j,d);
				}
			}
		delete tm1;
	}
	delete div1;
	delete div2;

	int flag;
	for(int i = v_dim - 1;i >= 0;i --)
	{
		flag = 0;
		for(int j = 0;j < h_dim - 1;j ++)
		{
			if(IsZero(tm2->GetVal(i,j)))
				continue;
			else
			{
				flag = 1;
				break;
			}
		}
		if(flag == 0 && !IsZero(tm2->GetVal(i,h_dim - 1)))
		{
			wout<<"the equation has no solution!"<<endl;
			delete tm2;
			return;
		}
		if(flag == 1)
		{
			break;
		}
	}

	if(i == h_dim - 2)
	{
		for(int j = 0;j <= i;j ++)
		{
			wout<<"x["<<j + 1<<"] = ";
			if(*((TNumber *)(tm2->GetVal(j,h_dim - 1))) == TNumber(0))
			{
				wout<<"0"<<endl;
				break;
			}
			
			TBigInt tmp1 = ((TNumber *)(tm2->GetVal(j,j)))->Ceil();
			TBigInt tmp2 = ((TNumber *)(tm2->GetVal(j,h_dim - 1)))->Ceil();
			TFraction tmp(tmp2,tmp1);
			tmp.display();
			wout<<endl;
		}
		delete tm2;
		return;
	}

	else
	{
		for(int j = 0;j <= i;j ++)
		{	
			int s = 0;
			while(IsZero(tm2->GetVal(j,j + s)))
				s ++;

			wout<<"x["<<j + s + 1<<"] = ";
			if(*((TNumber *)(tm2->GetVal(j,h_dim - 1))) != TNumber(0))
			{
				TBigInt tmp1 = ((TNumber *)(tm2->GetVal(j,j + s)))->Ceil();
				TBigInt tmp2 = ((TNumber *)(tm2->GetVal(j,h_dim - 1)))->Ceil();
				TFraction tmp(tmp2,tmp1);
				tmp.display();
			}
			for(int k = j + s + 1;k < h_dim - 1;k ++)
			{
				if(!IsZero(tm2->GetVal(j,k)))
				{
					TBigInt tmp1 = ((TNumber *)(tm2->GetVal(j,j + s)))->Ceil();
					TBigInt tmp2 = ((TNumber *)(tm2->GetVal(j,k)))->Ceil();
					TFraction tmp(tmp2,tmp1);
					if(tmp < TFraction(0))
					{
						wout<<"+";
						tmp = tmp * TFraction(-1);
						tmp.display();
					}
					else
					{
						wout<<"-";
						tmp.display();
					}
					wout<<"*x["<<k + 1<<"]";
				}
			}
			wout<<endl;
		}
		delete tm2;
		return;
	}
}

//=================================================================
//example
//1.		a:=[x+y-1,x-y+1];b:=[x,y];solve(a,b);
//answer:	[0,1];

//2.		a:=[53*x+37*y-432,24*x-62*y+89];b:=[x,y];solve(a,b);
//answer:	[(23491)/(4174),(15085)/(4174)]

//3.		a:=[2*i*x+3*j*y-4*k,5*l*x-6*m*y-8*n];b:=[x,y];solve(a,b);
//answer:	[(24*n*j+24*m*k)/(12*m*i+15*l*j),(-16*n*i+20*l*k)/(12*m*i+15*l*j)]

//4.		a:=[3*x+2*y-5,6*x+4*y-7];b:=[x,y];solve(a,b);
//answer:	the equation has no solution!

//5.		a:=[3*x+2*y-7*z-5,4*x+6*y-18*z+33];b:=[x,y,z];solve(a,b);
//answer:	[(3*z+48)/(5),(26*z-119)/(10),z]

//6.		a:=[3*i*x+2*y-7*j*z+12*k*t-25,6*i*x+4*y-18*z+45*i*j*t+33];b:=[x,y,z,t];solve(a,b);
//answer:	[(-315*t*j^2*i-28*j*y+36*y-231*j+216*t*k-450)/(42*j*i-54*i),y,(-135*t*j*i+72*t*k-249)/(42*j-54),t]
TList*  TMatrix::solve(TList * ps,TList * var)
{
	int v = ps->length();
	int h = var->length();
	TMatrix * CoefMatrix = new TMatrix(v,h + 1);
	v = h = 0;
	TAtom * tr;

	for(TListNode * tmp1 = FIRSTNODE(ps);tmp1;RNEXT(tmp1))
	{
		TAtom *a = DATA(tmp1);
		if(a->TypeID() != RIPolyType && a->TypeID() != Expression)
		{
			wout<<"error in input!"<<endl;
			delete CoefMatrix;
			return 0;
		}
		if(a->TypeID() == Expression)
			a = a->eval();

		h = 0;
		for(TListNode * tmp2 = FIRSTNODE(var);tmp2;RNEXT(tmp2))
		{
			TAtom *b = DATA(tmp2);
			if(b->TypeID() != Variable)
			{
				wout<<"error in input!"<<endl;
				delete CoefMatrix;
				return 0;
			}
			if(TP(a)->Degree(TV(b)) == 1)
			{
				tr = TA(TP(a)->Coefficient(TV(b),1));
				for(TListNode * tmp3 = FIRSTNODE(var);tmp3;RNEXT(tmp3))
				{
					if(tmp3 == tmp2)
						continue;
					TAtom *c = DATA(tmp3);
					if(c->TypeID() != Variable)
					{
						wout<<"error in input!"<<endl;
						delete CoefMatrix;
						return 0;
					}
					if(TP(tr)->Degree(TV(c)) != 0)
					{
						wout<<"error in input!"<<endl;
						delete CoefMatrix;
						return 0;
					}
				}
				TRIPoly tt = (*TP(a)) - (*TP(tr)) * TRIPoly(TV(b),1);
				delete a;
				a = new TRIPoly(tt);
				CoefMatrix->SetVal(v,h,tr);
			}
			else if(TP(a)->Degree(TV(b)) == 0)
			{
				tr = TA(new TBigInt(0));
				CoefMatrix->SetVal(v,h,tr);
			}
			else if(TP(a)->Degree(TV(b)) > 1)
			{
				wout<<"error in input!"<<endl;
				delete CoefMatrix;
				return 0;
			}
			h ++;
		}
		CoefMatrix->SetVal(v,h,::uminus(TA(a)));
		v ++;
	}
	
	//Now have got the CoefMatrix,Can solve the equation
	TList * Answer = new TList();
	TAtom * div1, * div2;
	TMatrix * tm1;
	int v_dim = CoefMatrix->VSize();
	int h_dim = CoefMatrix->HSize();

	int times = v_dim < h_dim - 1 ? v_dim : h_dim - 1;
	int displace = 0;

	for(int k = 0;k < times;k ++)
	{
		loop:
		if(IsZero(CoefMatrix->GetVal(k,k + displace)))
		{
			for(int n = k + 1;n < v_dim;n ++)
			{
				if(!IsZero(CoefMatrix->GetVal(n,k + displace)))
				{
					CoefMatrix->swaprow(k,n);
					break;
				}
			}
			if(IsZero(CoefMatrix->GetVal(k,k + displace)))
			{
				displace ++;
				times --;
				goto loop;
			}
		}
		
		if(k == 0)
		{
			TNumber *num = new TNumber(1);
			div2 = (TAtom *)(num);
		}
		else 
		{
			delete div2;
			div2 = div1;
		}
		div1 = CoefMatrix->CopyVal(k,k + displace);
		
		tm1 = CoefMatrix;
		CoefMatrix = new TMatrix(v_dim,h_dim);
		for(int i = 0;i < v_dim;i ++)
			for(int j = 0;j < h_dim;j ++)
			{
				if(i == k)
					CoefMatrix->SetVal(i,j,tm1->CopyVal(i,j));
				else
				{
					TAtom * aa, * bb, * cc,* dd;
					aa = ::mul(tm1->CopyVal(k,k + displace),tm1->CopyVal(i,j));
					bb = ::mul(tm1->CopyVal(i,k + displace),tm1->CopyVal(k,j));
					cc = ::minus(aa,bb);
					dd= ::div(cc,div2->Copy());
					CoefMatrix->SetVal(i,j,dd);
				}
			}
		delete tm1;
	}
	delete div1;
	delete div2;

	int flag;
	for(int i = v_dim - 1;i >= 0;i --)
	{
		flag = 0;
		for(int j = 0;j < h_dim - 1;j ++)
		{
			if(IsZero(CoefMatrix->GetVal(i,j)))
				continue;
			else
			{
				flag = 1;
				break;
			}
		}
		if(flag == 0 && !IsZero(CoefMatrix->GetVal(i,h_dim - 1)))
		{
			wout<<"the equation has no solution!"<<endl;
			delete CoefMatrix;
			return Answer;
		}
		if(flag == 1)
		{
			break;
		}
	}

	if(i == h_dim - 2)
	{
		for(int j = 0;j <= i;j ++)
		{
			if(IsZero(CoefMatrix->GetVal(j,h_dim - 1)))
			{
				TRational * node = new TRational();
				Answer->append(TA(node));
			}
			else 
			{
				TRational * node = new TRational(CoefMatrix->GetVal(j,h_dim - 1),CoefMatrix->GetVal(j,j));
				Answer->append(TA(node));
			}
		}
		delete CoefMatrix;
		return Answer;
	}

	else
	{
		int s = 0;
		for(int j = 0;j <= i;j ++)
		{	
			while(s < h_dim - 1 && IsZero(CoefMatrix->GetVal(j,s)))
			{
				TRIPoly * nu = new TRIPoly(TV(var->Part(s + 1)));
				TRIPoly * de = new TRIPoly(TBigInt(1));
				TRational * node = new TRational(nu,de);
				Answer->append(node);
				delete nu;
				delete de;
				s ++;
			}
			
			TRIPoly * t = TP(CoefMatrix->GetVal(j,h_dim - 1));
			for(int k = s + 1;k < h_dim - 1;k ++)
			{
				if(!IsZero(CoefMatrix->GetVal(j,k)))
					*t = *t - (*(TP(CoefMatrix->GetVal(j,k)))) * TRIPoly(TV(var->Part(k + 1)));
			}
			TRational * node = new TRational(t,CoefMatrix->GetVal(j,s));
			Answer->append(node);
			
			s ++;
			while(s < h_dim - 1 && !IsZero(CoefMatrix->GetVal(j,s)))
			{
				TRIPoly * nu = new TRIPoly(TV(var->Part(s + 1)));
				TRIPoly * de = new TRIPoly(TBigInt(1));
				TRational * node = new TRational(nu,de);
				Answer->append(node);
				delete nu;
				delete de;
				s ++;
			}
		}
		
		delete CoefMatrix;
		return Answer;
	}	
}
  
//=================================================================
int TMatrix::SameSize(TMatrix *m)
{
	if( h_dim == m->HSize() && v_dim== m->VSize() )
		return 1;
	else return 0;
}
//=================================================================

void* TMatrix::operator new(size_t)
{
	return  (TMatrix*)StarMem->alloc();
}
void  TMatrix::operator delete(void *p)
{
	(StarMem->free(p));
}

//=================================================================


//If B := BezoutMatrix(P, Q, x) and m = degree(Q) <= degree(P) = n, then B is an n x n Matrix with 
 
//     B[m-i+1, j] = coeff(sum(coeff(Q, x, m-r) * x^(n-r), r = i..m) * sum(coeff(P, x, n-r+1) * x^(i-r), r=1..i) 
//			- sum(coeff(P, x, n-r) * x^(n-r), r = i..n) * sum(coeff(Q, x, m-r+1) * x^(i-r), r = 1..i), x, n-j) for i = 1..m and j = 1..n, 
 
//     B[i, i-m-1+j] = coeff(Q, x, m-j-1) for i = m+1..n and j = 1..m+1, 
 
//     and B[i, j] = 0 for all other values of i and j. 
TMatrix* bezout(TRIPoly* p,TRIPoly* q,TVariable* v)
{
	int m = q->deg();
	int n = p->deg();
	if(m > n)
	{
		TRIPoly * tmp = p;
		p = q;
		q = tmp;
	}

	TMatrix * B = new TMatrix(n,n);
	for(int i = 1;i <= m;i ++)
		for(int j = 1;j <= n;j ++)
		{
			TRIPoly a(TBigInt(0));
			TRIPoly b(TBigInt(0));
			TRIPoly c(TBigInt(0));
			TRIPoly d(TBigInt(0));
			for(int r = 1;r <= m;r ++)
				a += (*(q->Coefficient(v,m - r))) * TRIPoly(v,n - r);

			for(r = 1;r <= i;r ++)
				b += (*(p->Coefficient(v,n - r + 1))) * TRIPoly(v,i - r);

			for(r = 1;r <= n;r ++)
				c += (*(p->Coefficient(v,n - r))) * TRIPoly(v,n - r);

			for(r = 1;r <= i;r ++)
				d += (*(q->Coefficient(v,m - r + 1))) * TRIPoly(v,i - r);

			TRIPoly t = a * b - c * d;
			B->SetVal(m-i+1, j,(TAtom *)(t.Coefficient(v,n - j)));
		}

	return 0;
}


TMatrix* TMatrix::mdiff(int n,TVariable * v)
{
	TMatrix * re = (TMatrix *)(this->Copy());
	TRIPoly * tmp,*tmp1;
	for(int i = 0;i < v_dim;i ++)
		for(int j = 0;j < h_dim;j ++)
		{
			tmp = toTRIPoly(GetVal(i,j));
	       	tmp1 = dDiff_chen(tmp,n,v);
 			/*		    TAtom * val=GetVal(i,j);
			G_OUT("val:",val);
			if (val) delete val;
			G_OUT("val:",val);
			if (val) delete val; */
 			//delete re->GetVal(i,j);
		    re->SetVal(i,j,tmp1);
			delete tmp;
		}
	return re;
}