//#pragma implementation
#ifndef __STAR_MATRIX__
#define __STAR_MATRIX__
#include <stdio.h>
#include <string.h>
#include <new.h>

#include "basetype.h"
#include "lists.h"
#include "check.h"

//#include "basetype.h"
//class TMatrix;
//class TVector : public TAtom, public TRun
// {
//  protected:
//	TAtom **val;   // *val[100]
//	int   len;
//  public:


class TMatrix : public TAtom, public TRun
{
protected:
		int v_dim,h_dim; // size of matrix is v_dim X h_dim
        TAtom **val;
  public:
		TMatrix(int v=1,int h=1); //constructor
		TMatrix(int v,int h,TList * l);
		TMatrix(TMatrix * tm); //constructor
		TMatrix(TList* list,int direction); //constructor
		~TMatrix(); // destructor

        virtual DataType TypeID()const;
        TAtom *eval();

        //virtual TVector*  Part(int n)const;
        //virtual TVector*  SetPart(int n, TVector *v);
		TMatrix* operator=(TMatrix* m);

		TList * TranList();
		TAtom * GetVal(int i,int j);
		TAtom * CopyVal(int i,int j);
		void SetVal(int i,int j,TAtom * value);

        virtual TRunType Run();
        //int     compare(TMatrix *);
        TAtom * Copy();
        TAtom * Clone();

		TMatrix* Tran();
		TMatrix* SubMatrix(int v1,int v2,int h1,int h2);
		TMatrix* SubMatrix(TList* Vlist,TList* Hlist);
		TMatrix* SubMatrix(TList* Vlist,int h1,int h2);
		TMatrix* SubMatrix(int v1,int v2,TList* Hlist);
		TMatrix* row(int v1);
		TMatrix* row(int v1,int v2);
		TMatrix* col(int h1);
		TMatrix* col(int h1,int h2);
		TMatrix* delrow(int v1);
		TMatrix* delcol(int h1);
		void swaprow(int v1,int v2);
		void swapcol(int h1,int h2);
		int rowdim();
		int coldim();
		
        TMatrix* add(TMatrix *m);
		TMatrix* minus(TMatrix *m);
        TMatrix* mul(TMatrix *m);
		TMatrix* uminus();
		TMatrix* exp(int p);
		
		int SameSize(TMatrix *m);
		TAtom* det();
		void root();
		TList * solve(TList * ps,TList * var);
        //virtual TVector* mul(TVector* ); 
        //virtual TMatrix* mul(TAtom * ); 

        int VSize() const{ return v_dim; };
		int HSize() const{ return h_dim; };
        
        virtual void display(outtype& out =wout) const;
        virtual void show(outtype& out =wout) const;
        virtual void print(outtype& out =wout) const;
 
        void* 	operator new(size_t);
		void  	operator delete(void *);

		TMatrix* bezout(TRIPoly* p,TRIPoly* q,TVariable* v);
		TMatrix* mdiff(int n = 1,TVariable * v = 0);
	};

#endif

/*
//#pragma implementation//!!
#ifndef __STAR_MATRIX__
#define __STAR_MATRIX__
#include <stdio.h>
#include <string.h>
#include <new.h>

#include "basetype.h"
#include "lists.h"

class TMatrix : public TAtom, public TRun
{
		int h_dim,v_dim; // size of matrix is v_dim X h_dim
        TVector **val;
  public:
		TMatrix(int x=1,int y=1); //constructor
		TMatrix(const TMatrix &m); //constructor
		TMatrix(TList * m); //constructor
		~TMatrix(); // destructor

        virtual DataType TypeID()const;
        TAtom *eval();

        virtual TVector*  Part(int n)const;
        virtual TVector*  SetPart(int n, TVector *v);
 

        virtual TRunType Run();
        int     compare(TMatrix *);
        virtual TAtom* Copy();
        virtual TMatrix* Clone();

        virtual TMatrix* MT(); 
        virtual TMatrix* add(TMatrix* ); 
        virtual TMatrix* mul(TMatrix* ); 
        virtual TVector* mul(TVector* ); 
        virtual TMatrix* mul(TAtom * ); 

        int HSize() const{ return h_dim; };
        int VSize() const{ return v_dim; };

        virtual void display(outtype& out =wout) const;
        virtual void show(outtype& out =wout) const;
        virtual void print(outtype& out =wout) const;
 
        void* 	operator new(size_t);
		TMatrix& operator = (TMatrix& v);
        void  	operator delete(void *);
	};

#endif
*/
