//#pragma implementation
#ifndef __STAR_NMATRIX__
#define __STAR_NMATRIX__
#include <stdio.h>
#include <string.h>
#include <new.h>

#include "basetype.h"
#include "lists.h"
#include "nvectors.h"

class TNMatrix : public TAtom, public TRun
{
/*========== no-edit begin=========*/
	int h_dim,v_dim; 
		// size of matrix is v_dim X h_dim
		// v_dim is row number; h_dim is column number;
                // v_dim :row;  h_dim:column 
                   
        TNVector **val;
//        void SelMainMem(int);
//        void Gauss();
         
  public:
	TNMatrix();
//	TNMatrix(int);
	TNMatrix(TBigInt *,TBigInt *);
		//test constructor
	TNMatrix(int,int);
	TNMatrix(const TNMatrix &m);
	TNMatrix(TList *m);  
        TNMatrix & operator=(const TNMatrix &m);
       ~TNMatrix(); 
		// destructor

        virtual DataType TypeID()const;
        TAtom *eval();

        virtual TNVector*  Part(int n)const;
        virtual TNumber* Part(int,int)const;
        virtual TNVector*  SetPart(int n, TNVector *v);
	virtual void SetPart(int,int,TNumber *); 

        virtual TRunType Run();
        int     compare(TNMatrix *);
        virtual TAtom* Copy();
        virtual TNMatrix* Clone();
	
	virtual int SelMainMem(int);
	virtual int SelMainMem(int,int *);
	virtual int SelMainMemAll(int,int *);
	virtual int Gauss();
	virtual int Gauss(int *);
	virtual int Gauss(int,int *); //this function call SelMainMemAll()
	virtual void upTriangle();
	virtual void downTriangle();
	virtual int Dooittle(int *);
        virtual TNMatrix* MT(); 
        virtual TNMatrix* add(TNMatrix* ); 
        virtual TNMatrix* mul(TNMatrix* ); 
        virtual TNVector* mul(TNVector* ); 
        virtual TNMatrix* mul(TNumber * ); 

        int HSize() const{ return h_dim; };
        int VSize() const{ return v_dim; };

        virtual void display(outtype& out =wout) const;
        virtual void show(outtype& out =wout) const;
        virtual void print(outtype& out =wout) const;
 
        void* 	operator new(size_t);
        void  	operator delete(void *);
/*============no-edit end==========*/
//add your stuff below 

	int nmatrixtest(){cout <<"test test\n"; return 1234;}
	};
#endif

