///////////////////////////////
// ߲ģʵļ//
// ļ:num_bigint.cpp     //
///////////////////////////////
 

//#include "stdafx.h"
//#include "bignum.h"//the low operations on bignum
//#include "integer.h"

//#include "include\integer.h"
//#include "bigint.h"//the high operations on bignum


//#include "number1.h"
#include "num_integer.h"
//#include "num_prime.h"
#include "prime.h"
#include "primesieve.h"
#include "lists.h"

#ifdef _WINDOWS
#include "../gui/index.h"
#endif


/*
unsigned long log2(const TBigInt & bn)
{
  return (unsigned long)(bn.blength()-1);
}
*/

//find the largest 2^k that divides bn, return bn/2^k and k.
TBigInt MakeOdd(TBigInt bn, int * k)
{  
   if(bn == 0)
   {
     *k = 0;
     return 0;
   }
   else
   {
     *k = NumberOf2(bn);
     return ( bn >> (*k) );
   }
}      


//generates a random bignum of the given length(the number of decimal digits)
//Note:m < MaxString1
TBigInt Random(TBigInt m)
{

  TBigInt bn;
  char * string;

  unsigned long i;
  unsigned long n;

  if(m.Len() == 1)
    n = m.GetShort(0);
  else
    n = (unsigned long)m.GetShort(0)+65536L*(unsigned long)m.GetShort(1);


  string = (char *)malloc(MaxString1);
  if(!string)
  {
      wout << "Out of memory!\n";
      return -1;
  }


  for ( i = 0;i < n;i++ )
      string[i] = '0'+ rand() % 10;

  string[n] = 0;

  bn = TBigInt(string);
 
  free(string);

  return bn;

}

/*
//the integer part of log10(bn)
unsigned long log10(const TBigInt & bn)
{
  //return (unsigned long)(strlen( bn.TransNumToString() )-1);
	
  int n = bn.Len();
  //char * buffer = (char *)malloc((n*2.42+2)*sizeof(unsigned short));
  char * buffer = (char *)malloc((n*3+2)*sizeof(unsigned short));
  char * p=bn.TransNumToString(buffer);
  unsigned long l= strlen(p)-1;
  free(buffer);

  return l;
}
*/

//the factorial of a bignum
TBigInt FactorialOP(const TBigInt & bn)
{
 TBigInt II=bn, RN(1);
 for(II=bn;II>1;II=II-1)
 {
   RN=RN*II;
 }
 return RN;
}

/*
//the integer part of sqrt(bn)
TBigInt sqrt(const TBigInt & bn)
{

  TBigInt tmpbnx,tmpbny;

  
  if(bn < 0) 
  { 
    wout << "\nThe integer must be a non-negative one!\n";
    exit(1);
  }
  
  if(bn == 0)  return 0;


  tmpbnx = bn;

  tmpbny = ( tmpbnx + bn / tmpbnx ) >> 1;


  while(tmpbny < tmpbnx)
  { 
     
    tmpbnx = tmpbny;
    

    tmpbny = ( tmpbnx + bn / tmpbnx ) >> 1;
 
       
  }

  return tmpbnx;


}
*/

/* comparing function -- compare two bignums
   Usage:
   TBigInt bn1,bn2;
   int c;
   c = comp(bn1,bn2);
*/
/*
int comp(const TBigInt & bn1,const TBigInt & bn2)
{
 
  if( bn1 == bn2 )
    return 0;    // bn1 == bn2
   else 
    if( bn1 > bn2 )
      return 1;  // bn1 > bn2
    else 
      return -1; // bn1 < bn2
}
*/

/*
TBigInt bmax(TBigInt a,TBigInt b)
{
 return (a>b)?a:b;
}


TBigInt bmin(TBigInt a,TBigInt b)
{
 return (a<b)?a:b;
}
*/


//************************ Gcd of Bignum ************************

/*
// GCD(Euclid's Algorithm)
TBigInt igcd(const TBigInt & bn1,const TBigInt & bn2)
{
   
   TBigInt u = bnabs(bn1),v = bnabs(bn2);
   TBigInt r;

   while( v != 0 )
   {
     r = u % v; // multi-precision division

     u = v;

     v = r;
   }

   return bnabs(u);

}
*/


// GCD(Euclid's Extended Algorithm)
// 
// compute (u,v,d), s.t. |aa|*u + |bb|*v = d = gcd(|aa|,|bb|)
//
int ExtendEuclid(TBigInt * u,
    TBigInt * v,TBigInt * d,
    const TBigInt & aa,const TBigInt & bb)
{

    TBigInt a,b;

    a = bnabs(aa);
    b = bnabs(bb);


    TBigInt v1,v3,t1,t3,q;

    *u=1;
    *d=a;

    if (b == 0)
    {
        *v=0;
        return 0;
    }

    v1=0;
    v3=b;

    while(v3 != 0)
    {
        q=(*d)/v3;
        t3=(*d) % v3;
        t1=(*u)-q*v1;
        *u = v1;
        *d = v3;
        v1 = t1;
        v3 = t3;
    }

    *v=(*d - a*(*u))/b;

    return 0;
}


// GCD(Lehmer method)
// This function needs the low subfunction TBigInt::GetHighUnit()
// This function is defined as an external function
TBigInt Lehmer_gcd( const TBigInt & bn1,const TBigInt & bn2 )
{

    TBigInt bngcd; // for saving the result

    //multiple-precision variables:
    TBigInt t,w;
    TBigInt u,v;

    //single-precision variables:
    //long lu,lv,u1,v1,u2,v2,q,q1,q2;
    //long A,B,C,D,T;
    int lu,lv,u1,v1,u2,v2,q,q1,q2;
    int A,B,C,D,T;

    
    // let u >= 0,v >= 0,u >= v
    u = bmax(bnabs(bn1),bnabs(bn2));
    v = bmin(bnabs(bn1),bnabs(bn2));  

    while(1)
    {

	// Step 1: initialize //
        // calculate lu,lv,A,B,C,D on the first
        // line of each sub-loop

	if (v == 0) return u;

	if ( v < TBigInt("65536") )
        {
           if( u >= TBigInt("65536") )
           {
            // do one step of multiple-precision Euclid
            // calculation to (u,v) in order to let u and
            // v both be single-precision integers

            t = u % v; // multiple-precision division
                       // here v < 65536

            u = v;

            v = t;
           }

           // call single-precision Euclid's algorithm
           // note that here u and v both be single-precision
           // integers

           //*bngcd->num = sp_Euclid_gcd(*u.num,*v.num);
           bngcd = TBigInt(sp_Euclid_gcd(u.GetShort(0),v.GetShort(0)));

	       return (bngcd);
        }

        // let lu be the first high non_zero unit of the current u
        // let lv be the corresponding unit of the current v
        // note that lv isn't the first high non_zero 
        // unit of v sometimes

	    //while ( (*(u.num + u.len-1) == 0) && (u.len > 1) )
              //u.len --;
    	//lu = *(u.num + u.len-1);
   	    //lv = ( u.len <= v.len )? *(v.num + u.len-1): 0;

        int tmparray[2];

        u.GetHighUnit(tmparray);
        //tmparray[0]: the actual number of units of u
        //tmparray[1]: the first high non-zero unit of u

        lu = tmparray[1];
        lv = ( tmparray[0] <= (int)(v.Len()) )? (v.GetShort(tmparray[0]-1)): 0;       

	A = 1;
	B = 0;
	C = 0;
	D = 1;

	// Step 2:  test the quotient //

	while(1)
	{
            // calculate u1,v1,u2,v2 
	    u1 = lu + B;
	    v1 = lv + D;
	    u2 = lu + A;
	    v2 = lv + C;

            // if one of the denominators is zero,then 
            // go to Step 4
	    if ( (v1 == 0) || (v2 == 0) ) break;

            // calculate q1,q2 by single-precision division
	    q1 = u1 / v1;
            q2 = u2 / v2; 
  
            // if q1 != q2,then go to Step 4
	    if (q1 != q2) break;

            q = q1;

	// Step 3:  stimulate Euclid alghorithm //
        // emulate one step of single-precision Euclid
        // calculation to (A,C),(B,D),(lu,lv) with q


	    T = A - q * C;
	    A = C;
	    C = T;

	    T = B - q * D;
	    B = D;
	    D = T;

	    T  = lu - q * lv;
	    lu = lv;
	    lv = T;

	} // end of the inline while(1)

	// Step 4: multiple-precision calculations //

	if (B == 0)
        // this may be occur on the first line of the
        // first sub-loop or happens if the single-
        // precision operations cannot simulate any of 
        // the multiple-precision ones, but the latter 
        // is an extremely rare occurence
	{
            // do one step of multiple-precision Euclid
            // calculation to the current u and v

	    t = u % v; // multiple-precision division
	    u = v;
	    v = t;
	}
	else
        // calculate the values of u and v by the linear
        // combination of A,B,C,D on the line of q1 != q2
	{
            // multiple-precision addition and multiplication

	    t = A * u;
	    t = t + B * v;
	    w = C * u;
	    w = w + D * v;

	    u = t;
	    v = w;
	}

    } // end of the outline while(1)

} // end of Lehmer_gcd()

 
// GCD(single-precision Euclid's Algorithm)
// used in Lehmer_gcd()
unsigned short sp_Euclid_gcd(unsigned short n1,unsigned short n2)
// n1 and n2 are single-precision non-negative integers
{
   unsigned short u = n1,v = n2;
   unsigned short r;


   while( v != 0 )
   {
     r = u % v; // single-precision division

     u = v;

     v = r;
   }

   return u;

}


//********************* End of Gcd of Bignum *********************

//******************* Modular Arithmetic *************************


//=== Chinese Remainder Algorithm ===
//Interface1:  this interface is used for system function 
//This function will call TBigInt ChineseRemainder(int k, TBigInt ** m,TBigInt ** x)
TBigInt ChineseRemainder(TList * Mm,TList * Xx)
{
    TBigInt res;
    int k;
    TBigInt ** m;
    TBigInt ** x;
    k=Mm->length();
    m=(TBigInt **)calloc(sizeof(TBigInt *),k);
    x=(TBigInt **)calloc(sizeof(TBigInt *),k);
    int i;
    for (i=1;i<=k;i++)
      {
        m[i-1]=(TBigInt *)(Mm->Part(i));
        x[i-1]=(TBigInt *)(Xx->Part(i));
      }
    res=ChineseRemainder(k,m,x);
    free(m);
    free(x);
    return res;
}


//=== Chinese Remainder Algorithm ===
//Interface2: this interface will not use the class TList
//
//   Given pairwise coprime positive integers m[i] and integers x[i],(1<=i<=k)
//
//   finds an interger x, s.t. x = x[i] (mod m[i]) for all i,and
//            0 <= x <= m[0]*m[1]*...*m[k-1]
//
//   Note that:this algorithm should only be used when the m[i] are fixed 
//             and the x[i] vary.
//
TBigInt ChineseRemainder(int k, TBigInt ** m,TBigInt ** x)
{

    // the following steps are precomputation which need to be 
    // done only once when the m[i] are fixed and x[i] vary

    // precompute: c[0],c[1],...,c[k-1],they are determined by
    //             m[i]


    // if it is not too costly,reorder the m[i](and hence the x[i])
    // so that they are in increasing order
    // here we don't do the reorder work 

    TBigInt **c;
    TBigInt **y;

    c=(TBigInt **)calloc(sizeof(TBigInt *),k);
    y=(TBigInt **)calloc(sizeof(TBigInt *),k);

    int i;
    for(i=0;i<k;i++)
    {
        c[i]=new TBigInt;
        y[i]=new TBigInt;
    }



    int j=2;
     
    *(c[0])=1;

    TBigInt p,u,v,d,pp;

    pp=1;

    while (j <= k)
    {
        pp *= *(m[j-2]);

        p  = pp % (*(m[j-1]));

        ExtendEuclid(&u,&v,&d,p,*(m[j-1]));
        if(d>1)
        {
          wout << "Error! The modulos must be pairwise coprime!\n";
          exit(1);
        }

        *(c[j-1]) = u;

        j++;
    }

    // end of the precomputation


    //compute y[0],y[1],...,y[k-1]

    *(y[0])=*(x[0]) % (*(m[0]));

    for (j=2;j<=k;j++)
    {
        TBigInt tmp;
        tmp=*(y[j-2]);
        for (i=j-3;i>=0;i--)
        {
            tmp=*(y[i])+ *(m[i]) * tmp;
        }
        *(y[j-1]) = (*(c[j-1]) * (*(x[j-1]) - tmp) ) % (*(m[j-1]));

		//wout << "\n*(c[j-1]) = " << *(c[j-1]) << endl;
		//wout << "\n*(x[j-1]) = " << *(x[j-1]) << endl;
		//wout << "\ntmp = " << tmp << endl;
		//wout << "\n(*(x[j-1]) - tmp)) = " << (*(x[j-1]) - tmp)  << endl;
		//wout << "\n(*(m[j-1])) = " << (*(m[j-1])) << endl;

		//wout << "\n*(y[j-1]) = " << *(y[j-1]) << endl;

        if (*(y[j-1]) < 0)
        {
			//wout << "\nhello!\n";
            *(y[j-1]) += (*(m[j-1]));
        }
    }

    //end of computing y[i]

    TBigInt xx;

    xx=*(y[k-1]);

    for (i=k-2;i>=0;i--)
    {
        xx=*(y[i])+ *(m[i]) * xx;
    }


    for (i=0;i<k;i++)
    {
        delete c[i];
        delete y[i];
    }
    free(c);
    free(y);

    return xx;
}


//=== Chinese Remainder Algorithm:inductive algorithm ===
//
//   Given pairwise coprime positive integers m[i] and integers x[i],(1<=i<=k)
//
//   finds an interger x, s.t. x = x[i] (mod m[i]) for all i,and
//            0 <= x <= m[0]*m[1]*...*m[k-1]
//
//
TBigInt ChineseRemainderInductive(int k, TBigInt ** m,TBigInt ** x)
{
    TBigInt xx;
    TBigInt mm;

    int i = 1;

    mm=*(m[0]);

    xx=*(x[0]);

    TBigInt u,v,d;

    //d=1;
    while (i != k)
    {
        i=i+1;

        ExtendEuclid(&u,&v,&d,mm,*(m[i-1]));
        if(d>1)
        {
          wout << "Error! The modulos must be pairwise coprime!\n";
          exit(1);
        }

        xx=u*mm*(*(x[i-1]))+v*(*(m[i-1]))*xx;

        mm=mm * (*(m[i-1]));

        xx=xx % mm;

        //if (xx < 0) xx+= mm;
    }

    if (xx < 0) xx += mm;

    return xx;

}


//=== compute Kronecker symbol (or Legendre symbol) ===
//
//   the value of Kronecker symbol may be -1,0 or 1
//
int KroneckerSymbol(int a,int b)
{
    static int tab2[8]={0,1,0,-1,0,-1,0,1};

    if (b == 0)
    {
        if ((a == 1)||(a ==-1))
            return 1;
        else
            return 0;
    }

    if (((a%2)==0)&&((b%2)==0))
    {
        return 0;
    }

    int k;
    int v;

    v=0;

    while((b%2)==0)
    {
        v++;
        b>>=1;
    }

    if ((v%2)==0)
        k=1;
    else
        k=tab2[a%8];

    if (b<0)
    {
        b=-b;
        if (a<0) k=-k;
    }

    int r;

    while (a!=0)
    {
        v=0;
        while ((a%2)==0)
        {
            v++;
            a>>=1;
        }
        if ((v%2)==1) k*=tab2[b%8];
        if ((a%2)&(b%2)) k=-k;
        r=(a>0)?a:-a;
        a=b%r;
        b=r;
    }

    if (b>1)
    {
        return 0;
    }

    if (b==1) return k;

    return -1000;//may be not necessary!

}


//=== compute Square Root Mod p ===
//
//   p is an add prime.
//
//   This algorithm, either outputs an x, s.t. x^2 = a (mod p)
//   (x is one of the square roots of a mod p);
//   or says that such an x does not exist(i.e. a is a quadratic
//   non-residue mod p)
//
//   Note that: x^2 = a (mod p) is equivalent to x^2 = (a % p) (mod p)
//              so it is enough to define 'a' as the type 'int'
//
int SquareRootMod(int a,int p)
{
    int e,q;

    e=0;
    q=p-1;

    //let p-1 = (2^e) * q with q odd
    while((q%2)==0)
    {
        e++;
        q>>=1;
    }
    

    //choose numbers n at random
    int n;
    n=5;
    while(KroneckerSymbol(n,p) != -1) n++;


    int z;
    int i;

    z=1;

    for (i=0;i<q;i++)  z=(z*n) % p;

    int y,r,x;

    y=z;
    r=e;
    x=1;

    for (i=0;i<(q-1)/2;i++)  x=(x*a) % p;
 
    int bb,b,t;

    b=(a*x*x) % p;
    x=(a*x) % p;

    int m;

    while(1)
    {
        if (((b-1+p)%p)==0) return x;

        m=1;

        bb=(b*b)%p;

        while(((bb-1+p)%p)!=0)
        {
            m++;
            bb=(bb*bb) % p;
        }

        if (m==r)
        {
            wout << "No solution for x^2="<<a<<" (mod "<<p<<")!\n";
            //exit(1);
            return -1;  
        }

        t=y;

        for (i=0;i<r-m-1;i++) t=(y*y) % p;

        y=(t*t) % p;

        r=m;

        x=(x*t) % p;

        b=(b*y) % p;
    }

}


/*
TBigInt modular_sum1(const TBigInt & mm,const TBigInt & a,const TBigInt & b)
{  

   TBigInt m;

   m = bnabs(mm);

   //if(m <= 0) 
   //{
     //wout << "Error: the modulo must be positive integer!\n";
     //exit(1);
   //}

   TBigInt c;

   TBigInt aa = a,bb = b;

   //if(a.Len() * b.Len() < 0)  
   if(sign(aa) * sign(bb) < 0)
   {  
     c = modular_diff(m,aa,-bb);
     return c;
   }
      

   //TBigInt aa = a,bb = b;
   
   aa = aa % m;
   bb = bb % m;

   //if(aa.Len() < 0) aa = aa + m;
   //if(bb.Len() < 0) bb = bb + m;
   if(sign(aa) < 0) 
   {   
	 aa = aa + m;
     bb = bb + m;
   }


   //so we have: 0 <= aa < m, 0 <= bb < m

   c = aa + bb;  //call "operator +"

   //here 0 <= c < 2*m

   if(c >= m) 
      c = c - m;

   return c;
}
*/


TBigInt modular_sum(const TBigInt & mm,const TBigInt & a,const TBigInt & b)
{  

   TBigInt m;

   m = bnabs(mm);

   TBigInt c;

   if(sign(a) * sign(b) < 0)
   {  
     c = modular_diff(m,a,-b);
     return c;
   }

   c = a + b;   

   c = mod(c,m);    

   return c;
}


/*
TBigInt modular_diff1(const TBigInt & mm,const TBigInt & a,const TBigInt & b)
{  

   TBigInt m;

   m = bnabs(mm);

   //if(m <= 0) 
   //{
     //wout << "Error: the modulo must be positive integer!\n";
     //exit(1);
   //}

   TBigInt c;

   TBigInt aa = a,bb = b;

   //if(a.Len() * b.Len() < 0)  
   if(sign(aa) * sign(bb) < 0)
   {  
     c = modular_sum(m,aa,-bb);
     return c;
   }


   //TBigInt aa = a,bb = b;

        
   aa = aa % m;
   bb = bb % m;

   //if(aa.Len() < 0) aa = aa + m;
   //if(bb.Len() < 0) bb = bb + m;
   if(sign(aa) < 0)
   {
	aa = aa + m;
    bb = bb + m;
   }

   //so we have: 0 <= aa < m, 0 <= bb < m

   c = aa - bb;  //call "operator -"

   //here -m < c < m

   //if(c.Len() < 0)  c = c + m;
   if(sign(c) < 0) c = c + m;

   return c;
}
*/
  

TBigInt modular_diff(const TBigInt & mm,const TBigInt & a,const TBigInt & b)
{  

   TBigInt m;
   //wout << "\nbefore bnabs(),mm = " << mm << endl;
   m = bnabs(mm);
   //wout << "\nafter bnabs(),m = " << m << endl;

   TBigInt c;

   if(sign(a) * sign(b) < 0)
   {  
     c = modular_sum(m,a,-b);
     return c;
   }

   c = a - b;  
   //wout << "\nc = " << c << endl;

   c = mod(c,m);    
   //wout << "\nc = " << c << endl;

   return c;
}


TBigInt modular_prod(const TBigInt & mm,const TBigInt & a,const TBigInt & b)
{  

   TBigInt c,m;
   TBigInt aa = a, bb = b;
   int shortc;
   int shortm;

   m = bnabs(mm);
   
   if(m.Len() == 1)
   {
	   if((aa.Len() ==1) && (bb.Len() ==1))
	   {
		 shortc = (aa.GetShort(0)*sign(aa)) * (bb.GetShort(0)*sign(bb)); 
		 shortm = m.GetShort(0);
		 shortc = MOD(shortm,shortc);
		 return shortc;
	   }
	   else
	   {

		 shortm = m.GetShort(0);
         //ôͨĳ
         aa = aa % m;
		 bb = bb % m;
		 //bnModQ(aa,shortm);
		 //bnModQ(bb,shortm);
 
		 shortc = (aa.GetShort(0)*sign(aa)) * (bb.GetShort(0)*sign(bb)); 
		 shortc = MOD(shortm,shortc);
		 return shortc;
	   }
   }
   else
   {
     //㶼Ǵ
     aa = aa % m;
     bb = bb % m;
     //so we have: 0 <= aa < m, 0 <= bb < m
     c = aa * bb;  //call "operator *"
     //here 0 <= c < m^2
     c = mod(c,m);  
     return c;
   }
}

/*
TBigInt modular_prod1(const TBigInt & mm,const TBigInt & a,const TBigInt & b)
{  

   TBigInt c,m,aa,bb;
   unsigned long shortc;
   unsigned short shortm;

   aa = bnabs(a);
   bb = bnabs(b);
   m = bnabs(mm);

   if(m.Len() == 1)
   {
	   if((aa.Len() ==1) && (bb.Len() ==1))
	   {
		 shortc = aa.GetShort(0) * bb.GetShort(0); 
		 shortm = m.GetShort(0);
		 if(shortc >= shortm) shortc = shortc % shortm;
		 return shortc;
	   }
	   else
	   {

		 shortm = m.GetShort(0);
         //ôͨĳ
         aa = aa % m;
		 bb = bb % m;
		 //bnModQ(aa,shortm);
		 //bnModQ(bb,shortm);

		 shortc = aa.GetShort(0) * bb.GetShort(0); 
		
		 if(shortc >= shortm) shortc = shortc % shortm;
		 return shortc;
	   }
   }
   else
   {
   //㶼Ǵ

   //aa = aa % m;
   //bb = bb % m;//prod()prod1()Ĳ֮ͬ

   //so we have: 0 <= aa < m, 0 <= bb < m
   c = aa * bb;  //call "operator *"
   //here 0 <= c < m^2
   c = c % m;
   return c;
   }
}
*/

/*
 modular exponent
 (modulo is TBigInt)

 Usage:
 TBigInt bn1,bn2,bn3,res;
 
 res = modular_exponent(bn3,bn1,bn2);
*/
TBigInt modular_exponent( const TBigInt & mm,const TBigInt & bbnn,const TBigInt & nn)
{
 
  TBigInt bnpower(1);
  TBigInt powertmp;
  TBigInt tmp;
  TBigInt bn,n,m;
  int i=1;
   
   bn = bnabs(bbnn);
   n = bnabs(nn);
   m = bnabs(mm);

  if( n == 0 ) 
  {
    if( bn == 0 )
    {
      wout << "\nCan't calculate 0 ^ 0!\n";
      exit(1);
    }
    else
      return 1;
  }

  if( n == 1 )   return (bn % m);
   
  if( bn == 0 )  return 0;
  
  /*
  //wout << "\nn = " << n << endl;
  if(n <= 20)
  {
    //wout << "\nn = " << n << endl;
    //wout << "\nenter if(n <= 20)!!!\n" << flush;

	bn = bn % m;
    bnpower = bn;

    for( i ; i < n; i++)
       bnpower = bnpower * bn;

    return (bnpower % m);
  }
  */

  // case of n > 20

  if(m.Len() > 1)
  //12˷
  {
     tmp = bn % m;
     bnpower = 1;

     while( n != 0 )
	 {
     
        if( isodd(n) )
		{
          powertmp = tmp;
    
          (bnpower) = (bnpower) * powertmp;
      
		}

        n = n >> 1;
    
        if( n != 0 )
		{
          tmp = (tmp * tmp) % m; 
		}  
        
	 }
     bnpower = bnpower % m;
     return (bnpower);
  }
  else
  {
     unsigned short shortm = m.GetShort(0);
	 //³ôͨĳ
	 tmp = bn % m;
	 //bnModQ(bn,shortm);
	 unsigned short shorttmp=tmp.GetShort(0);
     bnpower = 1;

     while( n != 0 )
	 {
     
        if( isodd(n) )
		{
          powertmp = shorttmp;
    
          (bnpower) = (bnpower) * powertmp;
      
		}

        n = n >> 1;
    
        if( n != 0 )
		{
		  //ͨ
          shorttmp = (shorttmp * shorttmp) % shortm; 
		}  
        
	 }
     //³ôͨĳ
     bnpower = bnpower % m;
	 //bnModQ(bnpower,shortm);
     return (bnpower);
  }

}

 
/*
 modular exponent
 (modulo is unsigned short)

 Usage:
 TBigInt bn1,bn2,res;
 unsigned short m;

 res = modular_exponent(m,bn1,bn2);
*/
/*
TBigInt modular_exponent(unsigned short mm,const TBigInt & bbnn,const TBigInt & nn)
//mmunsigned short,unsigned long˷.
{
 
  TBigInt bnpower(1);
  TBigInt powertmp;
  TBigInt tmp;
  TBigInt bn,n;
  unsigned short m;
  int i=1;
   
   bn = bnabs(bbnn);
   n  = bnabs(nn);
   m  = abs(mm);

  if( n == 0 ) 
  {
    if( bn == 0 )
    {
      wout << "\nCan't calculate 0 ^ 0!\n";
      exit(1);
    }
    else
      return 1;
  }

  if( n == 1 )   return (bn % m);
   
  if( bn == 0 )  return 0;
   
  if(n <= 20)
  {
	bn = bn % m;
    bnpower = bn;

    for( i ; i < n; i++)
       bnpower = bnpower * bn;

    return (bnpower % m);
  }

  // case of n > 20

     unsigned short shortm = m;
	 //³ôͨĳ
	 tmp = bn % m;
	 //bnModQ(bn,shortm);
	 unsigned short shorttmp=tmp.GetShort(0);
     bnpower = 1;

     while( n != 0 )
	 {
     
        if( isodd(n) )
		{
          powertmp = shorttmp;
    
          (bnpower) = (bnpower) * powertmp;
      
		}

        n = n >> 1;
    
        if( n != 0 )
		{
		  //ͨ
          shorttmp = (shorttmp * shorttmp) % shortm; 
		}  
        
	 }
     //³ôͨĳ
     bnpower = bnpower % m;
	 //bnModQ(bnpower,shortm);
     return (bnpower);
  
}
*/


TBigInt modular_neg(const TBigInt & mm,const TBigInt & a)
{  

   TBigInt m;

   m = bnabs(mm);


/*
   if(m <= 0) 
   {
     wout << "Error: the modulo must be positive integer!\n";
     exit(1);
   }
*/
    

   TBigInt c;

   TBigInt aa = a;

        
   aa = aa % m;

   c = -aa ;  

   //here -m < c < m

   if(sign(c) < 0)  c = c + m;

   return c;
}



TBigInt modular_inv(const TBigInt & mm,const TBigInt & a)
{
 

   TBigInt m;

   m = bnabs(mm);


/*
   if(m <= 0) 
   {
     wout << "Error: the modulo must be positive integer!\n";
     exit(1);
   }
*/
    

   TBigInt aa = a;

   TBigInt u,v,d;

        
   aa = aa % m;
   
   //if(aa.Len() < 0) aa = aa + m;
   if(sign(aa) < 0) aa = aa + m;

   //so we have: 0 <= aa < m
  
   ExtendEuclid(&u,&v,&d,aa,m);

   if(d>1)
   {
       wout << "\nThe integer is not invertible (mod m)!\n";
       exit(1);
    }

    //here -m < u < m

    if(u < 0) u = u + m;
    
    return u;

}


TBigInt modular_quo(const TBigInt & m, const TBigInt & bn1,const TBigInt & bn2)
{
   
   return modular_prod(m, bn1, modular_inv(m,bn2));

}


//a mod m : the least non-negative representation(0 <= a < m)
TBigInt  mod(const TBigInt & a,const TBigInt & mm)
{  



   TBigInt m;

   m = bnabs(mm);


/*
   if(m <= 0) 
   {
     wout << "Error: the modulo must be positive integer!\n";
     exit(1);
   }
*/
    

   TBigInt aa = a;

   //wout << "\naa = " << aa << endl;
   //wout << "\nm = " << m << endl;

   aa = aa % m;

   //if(aa.Len() < 0)  aa = aa + m;
   if(sign(aa) < 0)  aa = aa + m;


   return aa;

}


//a mod m : the zero-centered  representation(-m/2 < a <= m/2)
TBigInt  mod_0(const TBigInt & a,const TBigInt & mm)
{  


   TBigInt m;

   m = bnabs(mm);


/*
   if(m <= 0) 
   {
     wout << "Error: the modulo must be positive integer!\n";
     exit(1);
   }
*/
    

   TBigInt aa = a;

   aa = aa % m;

   //if(aa.Len() < 0)  aa = aa + m;
   if(sign(aa) < 0)  aa = aa + m;


   if(aa > m/2)  aa = aa - m;

   return aa;

}


//bn1 mod bn2(by Wu)
TBigInt imod(const TBigInt &bn1,const TBigInt &bn2)
{
   TBigInt  bn=bn1/bn2 ;
   bn = bn1 -  bn * bn2;
   /* 
   if(iseven(bn2))
   {
     if(bn<(-bn2/2))
       bn=bn+bn2;
     if(bn>(bn2/2))
       bn=bn-bn2;
   }
   else
   {
     if(bn<=(-(bn2+TBigInt(1))/2))
       bn=bn+bn2;
     if(bn>=((bn2+TBigInt(1))/2))
       bn=bn-bn2;
   }
   */
   if(bn < 0)
     bn = bn + bn2;
     
   return bn;
}


//the inverse of bn1(mod bn2) (by Wu)
TBigInt invm(const TBigInt &bn1,const TBigInt &bn2)
{
  /*m=bn2;a=bn1;*/
  
  TBigInt a1,a2,v1,v2,a3,v3,q,b;
  a1=bn2;
  a2=bn1;
  v1=0;
  v2=1;
  while(a2!=1)
  {
    q=a1/a2;
    a3 = a1 - q * a2;
    v3 = v1 - q * v2;
    a1 = a2;
    a2 = a3;
    v1 = v2;
    v2 = v3;
  }
  if (v2 >= 0)
    b = v2;
  else
    b = v2 + bn2;
    
   /*  
   if(iseven(bn2))
   {
     if(v2<(-bn2/2))
       b=v2+bn2;
     if(v2>(bn2/2))
       b=v2-bn2;
   }
   else
   {
     if(v2<=(-(bn2+TBigInt(1))/2))
       b=v2+bn2;
     if(v2>=((bn2+TBigInt(1))/2))
       b=v2-bn2;
   }
   */
   
  return b;
}

/*
//Ѵ(TBigInt)תΪͨ(int), ע:|bn| < 65536 
int BigToInt(TBigInt bn)
{
  return (sign(bn)*bn.GetShort(0));
}
*/

//******************* End of Modular Arithmetic *************************


//******************* End of Modular Arithmetic *************************
 
//******************* Integer  Factorization ***********************

static PrimeNumber pg(MAXPRIME);
//pg is a sieve table of prime numbers below MAXPRIME
//the prime table(pg) is used for integer factorization

//Integer Factorization
//Interface 1:this interface will not use the class TList
unsigned long PrimeFactor(TBigInt * FactorExpArray[],TBigInt n,int method)
//FactorExpArray[]:
//  contains the prime factors and their corresponding exp
//  i.e. FactorExpArray: [factor1, exp1, factor2, exp2, ...]
//method:
//  takes the value of 0(default),1 and 2:
//    0: ֻֽ⣨ֽСڽMAXPRIMEӣ 
//    1: ʣµֻһηֽ⡣			     
//    2: ʣµܶķֽ⣬
//	     ֱÿ޷ҵķƽΪֹ
//return value: the number of prime divisors
{
	//static PrimeNumber pg(10000);

    //add on 2001.4.26
    if(n==0)
	{
     *FactorExpArray[0]=0;
	 return 0;
	}
	//end add

	unsigned long i,j,nm;

    TBigInt  *factor[100];

    int l;

    for(l=0;l<100;l++)
       factor[l] = new TBigInt;

    unsigned long expFactor[100];

    nm = pg.PrimeFactor(factor,expFactor,n,method);
         
    for(i=0;i< nm;i++)
    {
       j = 2*i;

       *FactorExpArray[j] = *factor[i] ;
          
       *FactorExpArray[j+1] = TBigInt(expFactor[i]);
    }

    for(l=0;l<100;l++)
       delete factor[l];

	return nm;
}


//Integer Factorization
//Interface 2: this interface is used for system function
TList * PrimeFactor(TBigInt n,int method)
{

    	//static PrimeNumber pg(10000);

    	unsigned long i, nm;

        TBigInt  *factor[100];

        int l;

        for(l=0;l<100;l++)
           factor[l] = new TBigInt;

        unsigned long expFactor[100];

		nm = pg.PrimeFactor(factor,expFactor,n,method);

        //wout << "\nfactor:\n";
        //for(i=0;i<nm;i++)
          //wout << *factor[i] << ",";

        //wout << "\n\nexpFactor:\n";
        //for(i=0;i<nm;i++)
          //wout << expFactor[i] << ",";
       
        //for (i=0;i<nm;i++)
        //{
	      //wout << *(factor[i]) ;
	      //wout << "^" ;
	      //wout << expFactor[i]<< "   ";
        //}

        //wout << "\n\n";
     
        TList * PrimeExp = new TList();
       
        for(i=0;i<nm;i++)
        {

           PrimeExp->append((TAtom *)(new TBigInt(*factor[i])));  

           PrimeExp->append((TAtom *)(new TBigInt(expFactor[i])));
          
        }

        for(l=0;l<100;l++)
          delete factor[l];

        //wout << "PrimeExp: \n";
        //PrimeExp->display();
        //wout << "\n\n";

	    return PrimeExp;

}


//Integer Factorization(Pollard rho method: GTM 138:P429 Algorithm 8.5.2)

//sub-function for Pollard rho method
//finds a non-trival factor of a bignum
//if the function doesn't find non-trival factor, then returns -1
TBigInt NonTrivalFactor(TBigInt N)
{
  int i,k,l,c;
  TBigInt y,x,x1,p,g;

  //Step #1
  y = 2;
  x = 2;
  x1 = 2;
  k = 1;
  l = 1;
  p = 1;
  c = 0;

  //add on 2001.9.24
  int Count=0;
  //end add

  //Step #2 and #3
  while(1)
  { 
    //add on 2001.9.24
    Count++;
    //wout << "\nCount= " << Count << endl;
	//ѭִ20000λûҵNķƽӣû˳
	//ΪNڷƽӣǿƺֱӷؼɡ
	if(Count > 20000) return -1; //Important!!!
    //end add

    x = (x*x+1) % N;
    p = (p*(x1-x)) % N;
    c = c+1;
    if(c == 20) g = igcd(p,N);
    if(g > 1) break;
    if(c == 20)
    {
      y = x;
      c = 0;
    }
    k = k-1;
    if(k != 0) continue;
    g = igcd(p,N);
    if(g>1) break;
    x1 = x;
    k = l;
    l = 2*l;
    for(i = 0; i < k; i++)
    {
       x = (x*x + 1) % N;
    }
    y = x;
    c = 0;
  }

  //Step #4
  while(g <= 1)
  {
    y = (y*y + 1) % N;
    g = igcd((x1 - y),N);
  }

  //for test
  //display(g);
  //display(N); 
  //end test

  if (g < N) return g;

  return -1;

}



//main-function for Pollard rho method
//tries to find the prime divisors of a bignum
//returns the number of prime divisors
//Note: ֽӲһӣֻNonTrivalFactor()Ѳҵķƽӡ
int PrimeFactor_Pollard(TBigInt N,TBigInt * primeFactor [],int expFactor[])
{
  int nPrime;
  nPrime = 0;

  TBigInt nRemainder,nTest,p;

  nRemainder = N;

  while(nRemainder != 1)
  {
    nTest = nRemainder;
    p = nTest;

    while(p != -1)
    {
      p = NonTrivalFactor(nTest);
      //wout << p << endl;
	  if(p != -1)
       nTest = p;
    }

    nRemainder /= nTest;

    *(primeFactor[nPrime]) = nTest;
    expFactor[nPrime] = 1;

    while((nRemainder % nTest) == 0)
    {
        nRemainder /= nTest;
        expFactor[nPrime]++;
    }

    nPrime++;

  }

  return nPrime;//the number of prime divisors

}


TBigInt NextPrime(TBigInt bn)
{
    //static PrimeNumber pg(10000);

    unsigned long n;
    if (bn<=0) return 2;

    //short bnlen = bn.uActualLen();
	int bnlen = bn.Len();

    if(bnlen > 2)
        return -1;

    if(bnlen == 1)
        n = bn.GetShort(0);

    if(bnlen == 2)
        n = (unsigned long)bn.GetShort(0)+65536L*(unsigned long)bn.GetShort(1);

    n=n+1;
    while((!(pg.IsPrime(n)))&&(n<MAXPRIME)) n++;    
    TBigInt tbb(n);
    return tbb;
}


TBigInt PrevPrime(TBigInt bn)
{
    //static PrimeNumber pg(10000);

    unsigned long n;
    if (bn<=2) return -1;

    //short bnlen = bn.uActualLen();
	int bnlen = bn.Len();

    if(bnlen > 2)
        return -1;

    if(bnlen == 1)
        n = bn.GetShort(0);

    if(bnlen == 2)
        n = (unsigned long)bn.GetShort(0)+65536L*(unsigned long)bn.GetShort(1);

    n=n-1;
    while((!(pg.IsPrime(n)))&&(n>0)) n--;    
    TBigInt tbb(n);
    return tbb;
}


// primality test: 
// if bn >= 2^32, then returns -1.
// for bn < 2^32, returns 1 if bn is prime,returns 0 if else. 
// úֻС2^32жϣڴڵ2^32жϡ
int IsPrime(TBigInt bn)
{

	//static PrimeNumber pg(10000);

	unsigned long n;

    //short bnlen = bn.uActualLen();
	int bnlen = bn.Len();
	//wout << "\nbnlen=" << bnlen <<endl;

    if(bnlen > 2)
       return -1;

    if(bnlen == 1)
       n = bn.GetShort(0);

    if(bnlen == 2)
       n = (unsigned long)bn.GetShort(0)+65536L*(unsigned long)bn.GetShort(1);

	//wout << "\nn=" << n << endl;
    return pg.IsPrime(n);

}


//ĳָڵ
//ϽɺSMALLָ
//ú[SMALLSTART, SMALLSTART+2*(8*SMALL-1)]ڵı
//ĸ
int PrimeTableGen(TBigInt ** primeArray)
{ 
   unsigned char smallTable[SMALL];
   int i;
   int NumOfPrime=0; //the number of primes
   TBigInt currentPrime;

   //Build a sieve table of small odd primes:
   sieveSmall(smallTable, SMALL);

   i = (smallTable[0] & 1) ? 0 : sieveSearch(smallTable, SMALL, 0);
   //i=0,or i=1

   do {
	        currentPrime = 2 * i + SMALLSTART;
			*primeArray[NumOfPrime] = currentPrime;
			NumOfPrime++;

	}while ((i = sieveSearch(smallTable, SMALL, i)) != 0);

      
    return NumOfPrime;
 
}


TList * PrimeTableGen()
{
	
     TBigInt  *prime[20000];

     int i;

     for(i=0;i<20000;i++)
         prime[i] = new TBigInt;

     int k = PrimeTableGen(prime);

     TList * primetable = new TList();
       
     for(i=0;i<k;i++)
       primetable->append((TAtom *)(new TBigInt(*prime[i])));  
 
     for(i=0;i<20000;i++)
         delete prime[i]; 

	 return primetable;

}



//ʵṩûʹõ麯
//,ֱòͬӺʵ֡
//ʵbnǷΪĸжϣ
//1ʾbnָϵ
//0ʾbn
//עٶϽΪMAXPRIME=65535
int TestIfPrime(TBigInt bn)
{
	int bnlen = bn.Len();

    if(bnlen <= 2)//bn<2^32
    {
       unsigned long n;

	   if(bnlen == 1)
         n = bn.GetShort(0);

       if(bnlen == 2)
         n = (unsigned long)bn.GetShort(0)+65536L*(unsigned long)bn.GetShort(1);

	   return pg.IsPrime(n);
    }
	else//bn>=2^32
    {
	  int k=primeTestSub(bn);//úprimeTest޸Ķ
	  if(k==0) return 1;
	  else return 0;
    } 
       
}


//--Prime Test (Probability Test Method)
//--If it is nearly prime , returns 0.
//--If it is not prime, returns a positive number, representing
//  the number of modular exponentiation performed.If the number
//  of modular exponentiation is 0 or 1, returns 1.
//--úprimeTest޸Ķ,ֻΪTestIfPrimeӺʹã
//  ʱbn>=2^16
int primeTestSub(TBigInt bn)
{  
  TBigInt a,e;
  int i,l;
  int k,j;
  
  //Step1: Small Divisor Test
  //test if bn is the multiple of 2,3,5,7,11,13,17,19,23,29,31,37,41
  
  i = bn.GetShort(0);
  
  //test if bn is even
  if (!(i & 1)) return 1;
  
  //51051 = 3 * 7 * 11 * 13 * 17
  i = ((bn) % 51051).GetShort(0);	
  if (!(i % 3))  return 1;
  if (!(i % 7))  return 1;
  if (!(i % 11)) return 1;
  if (!(i % 13)) return 1;
  if (!(i % 17)) return 1;
  
  //63365 = 5 * 19 * 23 * 29
  i = ((bn) % 63365).GetShort(0);		
  if (!(i % 5))  return 1;
  if (!(i % 19)) return 1;
  if (!(i % 23)) return 1;
  if (!(i % 29)) return 1;
  
  //47027 = 31 * 37 * 41 
  i = ((bn) % 47027).GetShort(0);
  if (!(i % 31)) return 1;
  if (!(i % 37)) return 1;
  if (!(i % 41)) return 1;
  
  //Step2: Fermat test to the base 2 (Euler's criterion)
  
  (e) = (bn) - 1; //Note: e must be allocated before call primeTest()
  
  l=e.GetShort(0);
  
  j=1;
  
  if(l & 7)
  {
     //wout << "\nstep2:if\n" << endl;
     
     (e) = (e) >> 1;

     //(a) = (2 ^ (e)) % (bn); // /Note: a must be allocated before call primeTest()
     //(a) = (LeftShift1(e)) % (bn);
	 (a) = modular_exponent(bn,2,e);

     if((l & 7) == 6)
     {
       if(a.blength() != 1)
           return 1;   //Not Prime!
       k = 1;
     }
     else
     {
       (a) = (a) + 1;
       if( (a) != (bn) )
          return 1; //Not Prime!  
       k=1;
       if(l & 4)
       {
         (e) = (e) >> 1;
	 k=2;
       }
     }
  }
  else
  {
    //wout << "\nstep2:else\n" << endl;
    
    //wout << "\n(*e) = " << (*e) << endl;
    
    (e) = (e) >> 2;
    
    //wout << "\n(*e) = " << (*e) << endl;
    
    //wout << "\n(*bn) = " << (*bn) << endl;
    
    //(a) = (2 ^ (e)) % (bn);
    //(a) = (LeftShift1(e)) % (bn);
	(a) = modular_exponent(bn,2,e);
    
    //wout << "\n(*a) = " << (*a) << endl;
    
    if(a.blength() == 1) // that is,(*a) == 1          	    	   
    {
      j=0;
    }
    else
    {
      (a) = (a) + 1;
      if( (a) != (bn) )
          return 1; //Not Prime!
    }
    
    (e) = MakeOdd((e),&k);
    k = k+2;
    
  }
  
  //wout << "\nend of step 2!\n";
  
  //Step3: Miller-Rabin test (also called strong pseudoprimality test, or Knuth. Algorithm P)
  for(i=j; i < CONFIRMTESTS; i++)
  {
     (a) = confirm[i];

     //(a) = ((a)^(e) ) % (bn);
	 (a) = modular_exponent(bn,a,e);

     if(a.blength() == 1)  continue; 
     //passed this test to the current base, change the base, try again.
     l=k;
     for(;;)
     {
        (a) = (a) + 1;
	    if( (a) == (bn) ) break; //It is probably prime
	    if(!--l) return i+2-j; //Not prime!
    	(a) = (a) - 1;

	    (a) = ( (a) ^ 2) % (bn);

	    if(a.blength() == 1) return i+2-j; //Not Prime!
     }
  }
  
  //We've nearly decided that it is prime
  
  return 0; //bn is nearly prime !   	
     
}  


//******************* End of Integer  Factorization *************************

/*

//TBigIntļԱ:
//integer.h

TBigInt::TBigInt(const unsigned long inum)
{
	TBigInt((unsigned)inum);
}

// operator +=
TBigInt TBigInt::operator += (const TBigInt & bn)
{
   (*this) = (*this) + bn;

   return (*this);
}

// operator -=
TBigInt TBigInt::operator -= (const TBigInt & bn)
{
   (*this) = (*this) - bn;

   return (*this);
}

// operator *=
TBigInt TBigInt::operator *= (const TBigInt & bn)
{
   (*this) = (*this) * bn;

   return (*this);
}

// operator /=
TBigInt TBigInt::operator /= (const TBigInt & bn)
{
   (*this) = (*this) / bn;

   return (*this);
}

// operator %=
TBigInt TBigInt::operator %= (const TBigInt & bn)
{
   (*this) = (*this) % bn;

   return (*this);
}

*/

/*
//ͼʾ   
void DisplayBigNum(CDC * pDC,TBigInt * bn, int x0,int y0)
//(x0,y0)ַĿʼλ
{
  char *str, *str1;	  
  int LineLength = 70;//the number of chars in each line
  int LineWidth = 20; //the number of pixels
  int nCount;
  char *headstr, *tailstr,*strtmp;
  
  //str = bn->TransNumToString();
  int nl = bn->Len();
  char * buffer = (char *)malloc((nl*3+2)*sizeof(unsigned short));
  str=bn->TransNumToString(buffer);

  str1=(char *)malloc(strlen(str)+10);
  strcpy(str1,str);

  headstr=str1;
  tailstr=str1;
  strtmp=str;

  while(1)
  {
   nCount = 1;
   *tailstr=*strtmp;
   while((*tailstr != '\0') && (nCount<LineLength))
   {  
	   tailstr++;
	   strtmp++;
       nCount++;
   }
   if(*tailstr == '\0') break;
   tailstr++;
   strtmp++;
   *tailstr = '\0';
   pDC->TextOut(x0,y0,CString(headstr));
   headstr = tailstr;
   y0 = y0+LineWidth;
 }
 
 if(*headstr != '\0')
   pDC->TextOut(x0,y0,CString(headstr));//ʾһ

 free(str1);
 free(buffer);

}
*/

//ڿ̨ʾ
void display(TBigInt bn)
{
	char * p;
    int nl=bn.Len();
	char * buffer=(char *)malloc((3*nl+2)*sizeof(unsigned short));
	p=bn.TransNumToString(buffer);
	printf("\n%s\n", p);
	free(buffer);
}  

TList * CCList(short n)
{
  short m = n/2; 
  TList * cclist = new TList();
  int i;
   
  TBigInt ci,ci1;
  ci=1;
  cclist->append((TAtom *)(new TBigInt(ci)));
  for(i=1;i<=m;i++)
  {
//     ci = CC(n,i);
     ci1=ci*(n-i+1)/(i);
     cclist->append((TAtom *)(new TBigInt(ci1))); 
	 ci=ci1;
  }
/*
  if(n%2!=0) //n is odd
  {
    for(i=m+1;i>=1;i--)
	{ 
      pci = cclist->Part(i)->Copy();
      cclist->append(pci);      
	}
  }
  else //n is even
  {
    for(i=m;i>=1;i--)
	{ 
      pci = cclist->Part(i)->Copy();
      cclist->append(pci); 
	}
  } 
*/
  return cclist;

} 




 
 

 

 
