///////////////////////////////
// Ͳģʵļ//
// ļ:num_integer.cpp    //
///////////////////////////////

#include <ctype.h>
#include <stdlib.h>

#include "include\head0.h"
#include "num_integer.h"

#include "include\intbb.h"
#include "include\intbase.h"

TBigInt::~TBigInt() {
	if (num->decref() == 0) delete num;
}

TBigInt::TBigInt() {
    ptr=this;
	num = new TBigInt::B((unsigned)0, 0);
	num->incref();
}

TBigInt::TBigInt(const char str[]) {
    ptr=this;
	const char * p = str; BBUNIT sign = 0;
	while (1) {
		if (isspace(*p) || *p == '+') {
			p++; continue;	// skip over leading space and positive sign
		}
		if (*p == '-') {
			p++; sign ^= SIGN_BIT; continue;
		}
		break;
	}
	while (*p == '0') p++;	// skip over leading 0

	if (!isdigit(*p)) { // 0, with or without sign, special treatment
		num = new TBigInt::B((unsigned)0, 0);
	}
	else {
		num = new TBigInt::B(p, sign);
	}

	num->incref();
}

TBigInt::TBigInt(const short inum) {
    ptr=this;
	if (inum < 0)
		num = new TBigInt::B(-inum, SIGN_BIT);
	else
		num = new TBigInt::B(inum, 0);
	num->incref();
}

TBigInt::TBigInt(const unsigned short inum) {
    ptr=this;
	num = new TBigInt::B(inum, 0);
	num->incref();
}

TBigInt::TBigInt(const int inum) {
    ptr=this;
	if (inum < 0)
		num = new TBigInt::B(-inum, SIGN_BIT);
	else
		num = new TBigInt::B(inum, 0);
	num->incref();
}

TBigInt::TBigInt(const unsigned inum) {
    ptr=this;
	num = new TBigInt::B(inum, 0);
	num->incref();
}

TBigInt::TBigInt (const unsigned long inum) {
    ptr=this;
	num = new TBigInt::B((unsigned)inum, 0);
	num->incref();
}

TBigInt::TBigInt(TBigInt::B * base) {	// constructor from (TBigInt::B *)
    ptr=this;
	if ((num = base) != 0)
		num->incref();
}

TBigInt::TBigInt(const TBigInt & bn) {	// copy constructor
    ptr=this;
	if ((num = bn.num) != 0)
		num->incref();
}

//=======================================================

TBigInt & TBigInt::operator = (const TBigInt & bn) { // assignment
	if (this == &bn) return *this;
	if (num && num->decref() == 0) delete num;
	if ((num = bn.num) != 0)
		num->incref();
	return *this;
}


//--------------------------------------------------------

bool TBigInt::iszero() {
	return num->iszero();
}

//========================================================
void TBigInt::print (outtype & out) const {
	num->print(out); 
}

// ---------------------2001.5 begin----------------------
unsigned TBigInt::Len() const
{
	return num->Len();
}
	// the internal length with the sign of a bignum
	
unsigned TBigInt::length() const
	// the number of digits (base 10) in a bignum
{
	return num->length();
}

unsigned TBigInt::blength() const
{
	return num->blength();
}

void TBigInt::GetHighUnit(int *res) const
	// ôĵԪţλ㵥Ԫ
    // ԼλԪֵ㣩ѽresС÷ʽ£
    //    TBigInt bn;
    //    int a[2];
    //    bn.GetHighUnit(a);
    //    Note:        a[0]: ĵԪ         a[1]: λԪֵ  
{
	num->GetHighUnit(res);
}

unsigned short TBigInt::GetShort(unsigned n)
	// شڸnԪֵֵӦ065535֮䡣ֵn0ʼ
{
	return num->GetShort(n);
}

char * TBigInt::TransNumToString (char * s) const
{
	char *t=num->TransNumToString(s+1);
	if((*this)>=0)  return t;
	else
	{
        t[-1]='-';
		return t-1;
	}
}

// operator +=
TBigInt TBigInt::operator += (const TBigInt & bn)
{
   (*this) = (*this) + bn;
   return (*this);
}

// operator -=
TBigInt TBigInt::operator -= (const TBigInt & bn)
{
   (*this) = (*this) - bn;
   return (*this);
}

// operator *=
TBigInt TBigInt::operator *= (const TBigInt & bn)
{
   (*this) = (*this) * bn;
   return (*this);
}

// operator /=
TBigInt TBigInt::operator /= (const TBigInt & bn)
{
   (*this) = (*this) / bn;
   return (*this);
}

// operator %=
TBigInt TBigInt::operator %= (const TBigInt & bn)
{
   (*this) = (*this) % bn;
   return (*this);
}

// ----------------------2001.5 end-----------------------

///=======================================================
///  friend functions
//========================================================

TBigInt operator - (const TBigInt & bn) // the negative of a bignum
{
	return TBigInt(-(*bn.num));
}

const TBigInt bnabs(const TBigInt & bn) // bool SameData(const TBigInt&,const TBigInt&);
{
	return TBigInt(bnabs(*bn.num));
}

bool isodd(const TBigInt & bn)
{
	return bn.num->isodd();	
}

bool iseven(const TBigInt & bn)
{
	return bn.num->iseven();	
}

int sign (const TBigInt & bn)
    // sign function
    // -1, 0, 1 if bn < 0, bn = 0, bn > 0 
{
	return bn.num->sign();
}

/********************** comparing operators **********************/
    // comparing function

int comp(const TBigInt & bn1, const TBigInt & bn2)
       // return -1, 0, 1 if bn1 < bn2, bn1 = bn2, bn1 > bn2  
{
	/*
	if (bn1.iszero())
		if (bn2.iszero()) return 0;
		else return (- sign(*bn2.num));	// 1, if bn2 < 0; -1, if bn2 > 0
	if (bn2.iszero()) return sign(*bn2.num));
	*/

	if ((*bn1.num) == (*bn2.num)) return 0;
	if ((*bn1.num) > (*bn2.num)) return 1;
	return -1;
}

bool operator == (const TBigInt & bn1,const TBigInt & bn2)
{
	/*
	if (bn1.iszero())
		if (bn2.iszero()) return true;
		else return false;
	if (bn2.iszero()) return false;
	*/

	return (*bn1.num)==(*bn2.num);
}

bool operator != (const TBigInt & bn1, const TBigInt & bn2)
{
	/*
	if (bn1.iszero())
		if (bn2.iszero()) return false;
		else return true;
	if (bn2.iszero()) return true;
	*/

	return (*bn1.num) != (*bn2.num);
}

bool operator < (const TBigInt & bn1,const TBigInt & bn2)
{
	/* when use num == 0 to represent number 0.
	if (bn1.iszero())
		if (bn2.iszero() || sign(*bn2.num) < 0) return false;
		else return true;
	if (bn2.iszero())
		return sign(*bn1.num) < 0;
	*/

	return (*bn1.num) < (*bn2.num);
}

bool operator <= (const TBigInt & bn1, const TBigInt & bn2)
{
	return (*bn1.num) <= (*bn2.num);
}

bool operator >  (const TBigInt & bn1, const TBigInt & bn2)
{
	return (*bn1.num) > (*bn2.num);
}

bool operator >= (const TBigInt & bn1, const TBigInt & bn2)
{
	return (*bn1.num) >= (*bn2.num);
}

const TBigInt & bmax(const TBigInt & bn1, const TBigInt & bn2)
{
	return (*bn1.num) >= (*bn2.num) ? bn1 : bn2;
}

const TBigInt & bmin(const TBigInt & bn1, const TBigInt & bn2)
{
	return (*bn1.num) >= (*bn2.num) ? bn2 : bn1;
}

/**************************** arithematic operators *****************************/

TBigInt operator + (const TBigInt & bn1, const TBigInt & bn2)
{
	return TBigInt((*bn1.num)+(*bn2.num));
}

TBigInt operator - (const TBigInt & bn1, const TBigInt & bn2)
{
	return TBigInt((*bn1.num)-(*bn2.num));
}

TBigInt operator * (const TBigInt & bn1, const TBigInt & bn2) //classical algorithm
{
	return TBigInt((*bn1.num)*(*bn2.num));
}

TBigInt operator / (const TBigInt & bn1, const TBigInt & bn2) // quotient
{
	return TBigInt((*bn1.num)/(*bn2.num));
}

TBigInt operator % (const TBigInt & bn1, const TBigInt & bn2) // remainder
{
	return TBigInt((*bn1.num)%(*bn2.num));
}

TBigInt operator ^ (const TBigInt & bn1, const TBigInt & bn2) {
	return TBigInt((*bn1.num)^(*bn2.num));
}

TBigInt operator ^ (const TBigInt & bn1, unsigned n) {
	return TBigInt((*bn1.num)^n);
}

TBigInt square(const TBigInt & bn) // the square of a bignum
{
	return TBigInt(square(*bn.num));
}

istream & operator >> (istream & in, TBigInt & bignum)  // input
{
	return in;
}

#ifdef CONSOLE
outtype& operator << (outtype& out, const TBigInt & bignum) // output
{
	bignum.num->print(out);
	//out<<(*bignum.num);
	return out;
}
#endif


// ---------------------2001.5---------------------------

void BnAdd1 (TBigInt & bn){	// modify bn to bn+1
//	if (bn.num->isminus1())
//		bn.num = bintconst.b(0);
	BnAdd1(bn.num);
}

void BnSub1 (TBigInt & bn){	// modify bn to bn-1
//	if (bn.num->iszero())
//		bn.num = bintconst.b(-1);
	BnSub1(bn.num);
}

//#ifdef CONSOLE
TBigInt operator << (const TBigInt & bn, int n)  // bn * (2^n)
{
	return (n >= 0) ? TBigInt((*bn.num)<<n) : TBigInt((*bn.num) >> (-n));
}
//#endif

TBigInt operator >> (const TBigInt & bn, int n)  // bn / (2^n)
{
	return (n >= 0) ? TBigInt((*bn.num) >> n) : TBigInt((*bn.num) << (-n));
}
   
TBigInt LeftShift1 (const TBigInt & bn)	// return 2^n, bn is a bigint.
{
	return TBigInt(LeftShift1B(*bn.num));
}

int NumberOf2(const TBigInt & bn) //bn = 2^n * bn1,with bn1 is odd, return n, if bn=0,then return -1
{
	return NumberOf2(*bn.num);
}

TBigInt div2(const TBigInt & bn) //bn = 2^n * bn1,with bn1 is odd, return bn1, if bn=0,then return 0
{
	return TBigInt(div2(*bn.num));
}

//the integer part of sqrt(bn)
TBigInt sqrt(const TBigInt & bn)
{
	if(bn.num->isneg()) {
		wout << "\nThe integer must be a non-negative one!\n";
		exit(1);
	}

	if(bn.num->ilength() == 1) // use sqrt_unsigned() to deal with simple case
		return TBigInt( sqrt0(*bn.num) );

	TBigInt tmpbnx(bn.num), 
 		tmpbny( approxsqrt( *bn.num ) );	// improved init value
//		tmpbny((bn + 1) >> 1);	// old init value;
	while(tmpbny < tmpbnx) {
		tmpbnx = tmpbny;
		tmpbny = ( tmpbnx + bn / tmpbnx ) >> 1;
	}

	return tmpbnx;
}

unsigned long log2 (const TBigInt & bn)
{
	return (bn.num)->blength() - 1;
}

unsigned long log10(const TBigInt & bn)
{
	return (bn.num)->length() - 1;
}

/*
TBigInt nroot(const TBigInt & bn, short n)
{
	return TBigInt(nroot(*bn.num,n));
}
*/

// GCD(Euclid's Algorithm)
TBigInt igcd(const TBigInt & bn1, const TBigInt & bn2)
{

   TBigInt u = bnabs(bn1), v = bnabs(bn2);

   while( v != 0 )
   {
     TBigInt r(u % v); // multi-precision division
//	 wout << r << endl;
     u = v;
     v = r;
   }

   return u;

}

//======================================================
//add on 2001.10.25

TBigInt TBigInt::Clone()const
{
   TBigInt bntmp(*this);
   return bntmp;
}

DataType TBigInt::TypeID()const
{
  return BigNumberType;
}

//how=1:޸ıԭ෴make a new copy
//how=0:޸ıԭnot make a new copy
TAtom* TBigInt::uminus(int how) //default how=1, make a new copy
{
 //if(!how)
 //{
 	//len *=-1;  
 	//return this;
 //}
 
 /*
 TBigInt *nbp;
 TBigInt nb= -(*this);
 nbp=new TBigInt(nb);
 return nbp;
 */
  //modify on 2002.6.6
  if(!how) return this;
  return new TBigInt(-(*this));
}


void TBigInt::display(outtype& out)const
{
  out<<*this;
}


void TBigInt::show(outtype& out )const
{
 display(out);
}


TBigInt TBigInt::operator ++()
{
 (*this) = (*this)+1;
 return *this;	
}


TBigInt TBigInt::operator ++(int)
{
 TBigInt n(*this);
(*this) = (*this)+1;
 return n;	
}


TBigInt TBigInt::operator --()
{
 (*this) = (*this)-1;
 return *this;	
}


TBigInt TBigInt::operator --(int)
{
 TBigInt n=*this;
 (*this) = (*this)-1;
 return n;	
}

//end add
//=====================================================