//////////////////////////////
// ͷļ           //
// ļ:num_complex.h     //
//////////////////////////////


#ifndef __STAR_NUMBER_COMPLEX_
#define __STAR_NUMBER_COMPLEX_

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <new.h>
#include <math.h>

#include "num_number.h"   //TNumber
#include "num_integer.h"  //TBigInt
#include "num_float.h"    //TFloatNum
#include "num_fraction.h" //TFraction
#include "num_double.h"   //TComplex

// class defination -- TComplex

class TComplex :public TNumber
{
   TNumber * real; //the real part of a complex number
   TNumber * imag; //the imaginary part of a complex number
   //Note:the real part and the imag part are not of type TComplex again

   public:
	  //======================= Constructor ==================================

	  TComplex();  
      TComplex(TNumber a,TNumber b);
	  TComplex(TBigInt a,TBigInt b);
	  TComplex(int a,int b);
	  TComplex(TDouble a,TDouble b);
	  TComplex(char *); 
	  TComplex(TFloatNum fn);    // type conversion: TFloatNum    -> TComplex 
	  TComplex(TBigInt bn);      // type conversion: TBigInt      -> TComplex
	  TComplex(TFraction r);     // type conversion: TFraction    -> TComplex
	  TComplex(TDouble d);       // type conversion: TDouble      -> TComplex
      TComplex(TNumber n);       // type conversion: TNumber      -> TComplex
      TComplex(int i);           // type conversion: int          -> TComplex
	  TComplex(short i);         // type conversion: short        -> TComplex 
	  TComplex(unsigned long i); // type conversion: unsigned long-> TComplex
	  TComplex(double d);        // type conversion: double       -> TComplex
	  TComplex(const TComplex & c); // copy constructor
       
	  ~TComplex();
	   
      //====================================================================== 

      int iszero() {if( (*real==0)&&(*imag==0) ) return 1; else return 0;}
	   
      TNumber& SetReal(TNumber);//set real part of a complex
      TNumber& Real()const { return *real;}//get real part of a complex
      TNumber& SetImag(TNumber);//set imag part of a complex
      TNumber& Imag()const { return *imag;}//get imag part of a complex

	  friend TComplex operator - (const TComplex & c);//negative of a complex 
      friend TComplex conjugate (const TComplex & c); //conjugate imaginary number
	  friend TNumber abs(const TComplex & c);//the modular of a complex

	  TComplex Clone()const;
       
      TComplex & operator = (const TComplex & c);  

	  //===================== arithematic operators =======================
      friend TComplex operator + (const TComplex & d1,const TComplex & d2);
      friend TComplex operator - (const TComplex & d1,const TComplex & d2);
	  friend TComplex operator * (const TComplex & d1,const TComplex & d2);
	  friend TComplex operator / (const TComplex & d1,const TComplex & d2);
	  friend TComplex operator ^ (const TComplex & d, TBigInt & n);
	  //===================================================================

	  //==================== comparing operators ==========================
      //friend bool operator == (const TComplex & d1,const TComplex & d2);
      //friend bool operator != (const TComplex & d1,const TComplex & d2);
      //friend bool operator <  (const TComplex & d1,const TComplex & d2);
      //friend bool operator <= (const TComplex & d1,const TComplex & d2);
      //friend bool operator >  (const TComplex & d1,const TComplex & d2);
	  //friend bool operator >= (const TComplex & d1,const TComplex & d2);
	  //===================================================================
    
      // comparing function
      //friend int comp(const TComplex & d1,const TComplex & d2);
      //compare two floatnums: 
	  //  0 -- if d1 == d2
      //  1 -- if d1 >  d2
	  // -1 -- if d1 <  d2
       
      //friend const TComplex & bmax(const TComplex & d1, const TComplex & d2);
	  //friend const TComplex & bmin(const TComplex & d1, const TComplex & d2);

	  //======================= Input & Output =============================
      //friend istream & operator >> (istream & in,  TComplex & d);
                      
#ifdef CONSOLE
      friend outtype& operator << (outtype& out,const TComplex & c);
#endif

      virtual void display(outtype& out =wout) const;
      virtual void show(outtype& out =wout) const;
      virtual void print(outtype& out =wout) const;

	 //======================================================================

      virtual TAtom* uminus(int how=1); //default how=1; make a new copy
 
      virtual DataType TypeID()const
      { return ComplexType; }

      void* operator new(size_t);
      void  operator delete(void *);
};

#endif