//////////////////////////////
// ͷļ         //
// ļ:num_double.h      //
//////////////////////////////


#ifndef __STAR_NUMBER_DOUBLE_
#define __STAR_NUMBER_DOUBLE_

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <new.h>
#include <math.h>

#include "num_number.h"   //TNumber
#include "num_integer.h"  //TBigInt
#include "num_float.h"    //TFloatNum
#include "num_fraction.h" //TFraction

// class defination -- TDouble

class TDouble :public TNumber
{
    double  dnum;

    public:

      //========================= Constructor =============================/ 

	  TDouble() { dnum = 0.0; } //initialized by 0.0

	  TDouble(char *);

      TDouble(double d)          // type conversion: double       -> TDouble
	  { ptr=this; dnum=d;} 

      TDouble(float f)           // type conversion: float        -> TDouble
      { ptr=this; dnum=(double)f;} 

	  TDouble(TFloatNum fn);     // type conversion: TFloatNum    -> TDouble 
	   
      TDouble(TBigInt bn);       // type conversion: TBigInt      -> TDouble
	   
      TDouble(TFraction r);      // type conversion: TFraction    -> TDouble
	   
      TDouble(TNumber n);        // type conversion: TNumber      -> TDouble
            
      TDouble(int i)             // type conversion: int          -> TDouble
	  { ptr=this;dnum=(double)i;}

      TDouble(short i)           // type conversion: short        -> TDouble 
	  { ptr=this;dnum=(double)i;}

      TDouble(unsigned long i)   // type conversion: unsigned long-> TDouble
	  { ptr=this;dnum=(double)i;}

      TDouble(const TDouble & d) // copy constructor
      {  
		ptr=this;
		dnum=d.dnum;  
      }

      //==================================================================== 

      double GetNum()const { return dnum; }
      double SetNum(double d) { dnum=d; return d;}

	  friend TDouble operator - (const TDouble & d); //negative of a double 
	   
      friend TDouble fabs (const TDouble & d); //absolute value of a double  
	   
	  // sign function
      friend int sign (const TDouble & d);
      // floatnum sign: 0 -- if d = 0; 1 -- if d > 0; -1 -- if d < 0

	  friend TDouble sqrt (const TDouble & d);
      friend TDouble sin (const TDouble & d);
      friend TDouble cos (const TDouble & d);

	  TDouble dceil(); 
      TDouble dfloor();
	  //Note:
	  //here the function name can't be Ceil() and Floor(),
	  //also can't be ceil() and floor().
	  //if we have the constructor TBigInt(TDouble),
	  //then we can define the two functions as follows:
	  //TBigInt Ceil();
      //TBigInt Floor();
	  //and then TNumber::Ceil() and TNumber::Floor() will be changed accordingly!

      TDouble Clone()const
      {
         TDouble d(*this);
         return d;
      }  
       
      TDouble & operator = (const TDouble & d) // copy a double
	  { 
		dnum = d.dnum;
        return (*this);
      }

      //====================== arithematic operators =======================
      friend TDouble operator + (const TDouble & d1,const TDouble & d2);
      friend TDouble operator - (const TDouble & d1,const TDouble & d2);
	  friend TDouble operator * (const TDouble & d1,const TDouble & d2);
	  friend TDouble operator / (const TDouble & d1,const TDouble & d2);
	  friend TDouble operator ^ (const TDouble & d,const TDouble & n);
	  friend TDouble pow(const TDouble & d,const TDouble & n);
	  //==================================================================== 

      //===================== comparing operators ==========================
      friend bool operator == (const TDouble & d1,const TDouble & d2);
      friend bool operator != (const TDouble & d1,const TDouble & d2);
      friend bool operator <  (const TDouble & d1,const TDouble & d2);
      friend bool operator <= (const TDouble & d1,const TDouble & d2);
      friend bool operator >  (const TDouble & d1,const TDouble & d2);
	  friend bool operator >= (const TDouble & d1,const TDouble & d2);
	  //==================================================================== 
    
      // comparing function
      friend int comp(const TDouble & d1,const TDouble & d2);
      //compare two floatnums: 
	  //  0 -- if d1 == d2
      //  1 -- if d1 >  d2
	  // -1 -- if d1 <  d2
       
      friend const TDouble & bmax(const TDouble & d1, const TDouble & d2);
	  friend const TDouble & bmin(const TDouble & d1, const TDouble & d2);

	  //========================== Input & Output ===========================
      friend istream & operator >> (istream & in,  TDouble & d);
                      
#ifdef CONSOLE
      friend outtype& operator << (outtype& out,const TDouble & d);
#endif

      virtual void display(outtype& out =wout) const;
      virtual void show(outtype& out =wout) const;
      virtual void print(outtype& out =wout) const;

	 //====================================================================== 

      virtual TAtom* uminus(int how=1); //default how=1; make a new copy
 
      virtual DataType TypeID()const
      { return DoubleType; }

      void* operator new(size_t);
      void  operator delete(void *);
};

#endif 


 
    
