//////////////////////////////
// 󸡵ʵļ     //
// ļ:num_float.cpp     //
//////////////////////////////

#include <stdio.h>
#include <math.h>
#include "expval.h"
//#include "number0.h"
#include "num_number.h"
//#include "number1.h"
#include "num_integer.h"
//#include "number2.h"
//#include "number3.h"
#include "num_float.h"
#include "num_fraction.h"
#include "lists.h"
#include "vectors.h"
#include "poly.h"
#include "matrix.h"
#include "global.h"
#ifdef _WINDOWS
#include "..\gui\index.h"
#endif
//==========================================
//---- Implementation for TFloatNum

//constructor: initializing

/*
TFloatNum::TFloatNum(TBigInt bn,short i)
{
  ptr=this;
  mant = new TBigInt(bn);
  exp = i;
}
*/


TFloatNum::TFloatNum(TBigInt bn,short i)
{
  ptr=this;

  if(i <= 0)
  {
     mant = new TBigInt(bn);
     exp = i;
  }
  else
  {
     mant = new TBigInt(bn*(TBigInt(10)^TBigInt(i)));
     exp = 0;
  }
}


//constructor: initialized by a number string with a point
TFloatNum::TFloatNum(char * str)
{  
   
  //wout << "\nfperpweurpqweurpuw\n";
  
  char *s;
  short sum = 0;
  ptr=this;

  static char sstr[10000];
  int i,j;
  j=0;
  for (i=0;i<(int)strlen(str);i++)
  {
	  if (str[i] != '.') sstr[j++]=str[i];
  }
  sstr[j]=0;

  mant = new TBigInt(sstr);
  s = str + ( strlen(str)-1 ); // point s to the end of str
  while( (*s != '.') && (s != str) )
  {
    if( (*s >= '0') && (*s <= '9') )
      sum ++;
    s--;    
  }
 
  if(*s == '.')
     exp = -sum;
  else
     exp = 0;
}

     
//constructor: type conversion(double -> TFloatNum)
TFloatNum::TFloatNum(double f)
{
  short sum = 0;
  double ftmp = f;

  ptr=this;

  while(1)
  {
	if( floor(ftmp) == ftmp ) // ftmp is an integer
      break;
    ftmp = ftmp * 10;
    sum ++;
  }

  mant = new TBigInt((int)ftmp); 
  exp = -sum;
}


//constructor: type conversion(TDouble -> TFloatNum)
TFloatNum::TFloatNum(TDouble f)
{
  short sum = 0;
  double ftmp = f.GetNum();

  ptr=this;

  while(1)
  {
	if( floor(ftmp) == ftmp ) // ftmp is an integer
      break;
    ftmp = ftmp * 10;
    sum ++;
  }

  mant = new TBigInt((int)ftmp); 
  exp = -sum;
}

     
//constructor: type conversion(float -> TFloatNum)
TFloatNum::TFloatNum(float f)
{
  short sum = 0;
  float ftmp = f;

  ptr=this;

  while(1)
  {
	if( floor(ftmp) == ftmp ) // ftmp is an integer
      break;
    ftmp = ftmp * 10;
    sum ++;
  }

  mant = new TBigInt((int)ftmp); 
  exp = -sum;
}

//constructor: type conversion(int -> TFloatNum)
TFloatNum::TFloatNum(int i)
{
  ptr=this;
  mant = new TBigInt(i);
  exp = 0;
}

//constructor: type conversion(short -> TFloatNum)
TFloatNum::TFloatNum(short i)
{
  ptr=this;
  mant = new TBigInt(i);
  exp = 0;
}

//constructor: type conversion(unsigned long -> TFloatNum)
TFloatNum::TFloatNum(unsigned long i)
{
  ptr=this;
  mant = new TBigInt(i);
  exp = 0;
}


//constructor: type conversion(TBigInt -> TFloatNum)
TFloatNum::TFloatNum(TBigInt bn)
{
  ptr=this;
  mant = new TBigInt(bn);
  exp = 0;
}


//constructor: type conversion(TFraction -> TFloatNum)
TFloatNum::TFloatNum(TFraction r) 
{
   ptr=this;

   TFloatNum ftmp;

   TFloatNum n = TFloatNum( r.Nu() ), d = TFloatNum( r.De() );

   ftmp = n / d;  // call "operator /" in TFloatNum

   mant = new TBigInt(*ftmp.mant );
   exp = ftmp.exp;
}   


//constructor: type conversion(TNumber -> TFloatNum)
TFloatNum::TFloatNum(TNumber n)
{
   ptr=this;

   TFloatNum ftmp(0);

   DataType DT=n.GetPtr()->TypeID();

   switch(DT)
   {
    case BigNumberType:
         ftmp = TFloatNum(*((TBigInt*)n.GetPtr()));
         break;
    case FloatNumberType:
         ftmp = TFloatNum(*((TFloatNum*)n.GetPtr()));
         break;
    case FractionType:
         ftmp = TFloatNum(*((TFraction*)n.GetPtr()));
         break;
    //case DoubleType:
		 //ftmp = TFloatNum(*((TDouble*)n.GetPtr()));
		 //break;
    default: 
		 wout << "\nCan't convert this type to TFloatNum!\n" << endl;
         break;
   }

   mant = new TBigInt(*ftmp.mant );
   exp = ftmp.exp;
}


//constructor: create a new floatnum initialized by a specified floatnum
TFloatNum::TFloatNum(const TFloatNum & fn)
{
   ptr=this;
   mant = new TBigInt(*fn.mant);
   exp = fn.exp;
}
  

TFloatNum::~TFloatNum()
{
 if(mant) delete mant;
};

short TFloatNum::SetExp(short tm)
{
  exp=tm;
  return tm;
}

TBigInt TFloatNum::SetMant(TBigInt m)
{
  *mant=m;
  return m;
}
 
TBigInt TFloatNum::CopyMant()
{
 return mant->Clone();
}

TFloatNum TFloatNum::Clone()const
{
 /*
 TFloatNum f;
 f.SetMant(*mant);
 return f;
 */

 //modify on 2002.6.7
 TFloatNum f;
 f.SetMant(*mant);
 f.SetExp(exp);
 return f;
}

/*
  copy a floatnum
*/
TFloatNum & TFloatNum::operator = (const TFloatNum & fn)
{
    if(mant)
      {
        delete mant;
      }
    mant = new TBigInt(*fn.mant);
    exp = fn.exp;
    return (*this);
}

void TFloatNum::show(outtype& out)const
{
 display(out);
}
void TFloatNum::print(outtype& out)const
{
 display(out);
}
void TFloatNum::display(outtype& out)const
{
/*
  cout << "(";
  cout << *mant;
  cout << "  ,  ";
  cout << exp;
  cout << ")" << "\n";
*/
 out<<*this;
}


//  Get the number of decimal digits carried in the mantissa part 
//  For example:
//     12345678.978 --> 11
//     0.000012345 --> 5
short TFloatNum::length()const
{
   return  ( mant->length() );
}  


//Get the number of decimal digits after the dot 
//Note: if the integer part is 0, then the 0-digits immediately
//      after the dot will be ignored!
//For example:
//    12345678.0978 --> 4
//    0.000012345 --> 5
short TFloatNum::lengthPT()const
{
  short L1=mant->length() ;
  short L2=abs(exp); 
  return (L1>L2? L2: L1 ) ;
}


/*
  Modify a floatnum according to the specified accuracy(the value of digits),
  considering carry.  The floatnum itself will not be modified!!
  ( used in operator +,-,*,/,^ )

  Note: CHANGE the number of decimal digits after the dot(i.e. the number of 
        decimal digits carried in the xiao shu part) of the float number TO the 
        specified value (digits)
        ( The 0-digits immediately after the dot will be ignored if the 
          integer part is 0 ! )  
		//޸Сֵλ
  
  For example:

  digits = 5
 
  1. (12345678,-7) --> (123457,-5) 
       i.e. 1.2345678 --> 1.23457

  2. (34234932423, -14) --> (34235, -8)
       i.e. 0.00034234932423 --> 0.00034235

  3. (1230078924679, -10)  --> (12300789, -5) 
       i.e. 123.0078924679 --> 123.00789

  4. (123456789,0) --> (123456789,0)
	   i.e. 123456789. --> 123456789.

*/
TFloatNum TFloatNum::SetFloatNum1(short digits)const
{
   TFloatNum  f ;

   short n = length(), n1=lengthPT();
   short digits2=(n>n1? (n-n1+digits):digits);
   short d;
   short s = sign(*this);
   char * pmant, * pnewmant;
   
   if( digits < 1 ) 
   {
      cout << "\nThe value of digits must be no less than 1!\n";
      exit(1);
   }
   if( n1<= digits )   return (*this);
   
  //pmant = mant->TransNumToString();

  int nl = mant->Len();
  char * buffer = (char *)malloc((nl*3+2)*sizeof(unsigned short));
  pmant=mant->TransNumToString(buffer);

   d = *(pmant + digits2) - '0';  //  0 <= d <= 9
       
   *(pmant + digits2) = '\0';

   pnewmant = (char *)malloc(digits2+3);
   if(!pnewmant) exit(1);

   strcpy(pnewmant,pmant);

   if(d < 5)
     *f.mant = TBigInt(pnewmant);
   else
     *f.mant = TBigInt(pnewmant) + 1;

   f.exp = (n + exp) - digits2;
   f = TFloatNum(TBigInt(s)) * (f);
   free(pnewmant);
   free(buffer);
   return ( f );
}
 


/*
  Another implementation for SetFloatNum1():

  Modify a floatnum according to the specified accuracy(the value of digits),
  considering carry.  The floatnum itself will not be modified!!
  ( used in operator +,-,*,/,^ )
  
  Note: CHANGE the number of decimal digits carried in the mantissa part (mant)
        of the float number TO the specified value (digits)
		//޸Чֲֵλ
  
  For example:

  digits = 5

  1. (12345978978,-3) --> (12346,3)  
       i.e. 12345978.978 --> 12346000.

  2. (123456789,0) --> (12346,4)
	   i.e. 123456789. --> 123460000.

*/
TFloatNum TFloatNum::SetFloatNum2(short digits)const
{
   TFloatNum f;

   short n = length();
   TBigInt mant1, mant2, d;
   short s = sign(*this);
   

   if( digits < 1 ) 
   {
      cout << "\nThe value of digits must be no less than 1!\n";
      exit(1);
   }

   if( n <= digits )   return (*this);


   mant1 = bnabs(*mant) / ( TBigInt(10) ^ (n - digits) );
   mant2 = bnabs(*mant) / ( TBigInt(10) ^ (n - digits - 1) );
   d = mant2 - mant1 * 10;  // 0 <= d <= 9

   if(d < 5)
     *(f.mant) = mant1;
   else
     *(f.mant) = mant1 + 1;

   f.exp = (n + exp) - digits;

   f = s * (f);

   return ( f );

}


/*
  Get the integer part of a floatnum(not considering jinwei).

  For example:
     123.999456 --> 123
    -123.999456 --> -123
*/
/*
TBigInt TFloatNum::GetInteger()const
{
  TBigInt  bn ;  
  if( exp <= 0 )
    {  short eep= -1*exp;
       bn = *mant / ( TBigInt(10) ^ TBigInt(eep) );
    }
  else
       bn = *mant * ( TBigInt(10) ^ TBigInt(exp) );  
  return (bn);
}
*/


/*
  Get the integer part of a floatnum(not considering carry).

  For example:
     123.999456 --> 123
    -123.999456 --> -123
*/
TBigInt TFloatNum::GetInteger()const
{
  TBigInt  bn ;  
  if( exp < 0 )
  { 
    short eep= -1*exp;
    bn = *mant / ( TBigInt(10) ^ TBigInt(eep) );
  }
  else
    bn = *mant * ( TBigInt(10) ^ TBigInt(exp) );  
  return (bn);
}


/*
  Get the integer part of a floatnum(considering carry).

  For example:
     123.999456 --> 124
    -123.999456 --> -124
*/
TBigInt TFloatNum::GetInteger_carry()const
{

  TBigInt  bn ;  
  short s = sign(*this);
  if( exp < 0 )
  {    
    TFloatNum xs=abs(GetXiaoshu());
    if(xs >= TFloatNum(0.5))
       if(s == 1) bn = GetInteger() +1;
       else bn= GetInteger() -1;
    else
       bn = GetInteger();    
  }
  else
       bn = *mant * ( TBigInt(10) ^ TBigInt(exp) );  

  return (bn);
}


TBigInt TFloatNum::Ceil()
{
    TBigInt bn;
    bn=GetInteger();
    if ( GetXiaoshu() != (*this- *this)) 
    {
        if (sign(*mant) >=0) bn=bn+1;
    }
    return bn;
}


TBigInt TFloatNum::Floor()
{
    TBigInt bn;
    bn=GetInteger();
    if ( GetXiaoshu() != (*this- *this)) 
    {
        if (sign(*mant) <=0) bn=bn-1;
    }
    return bn;
}


/*
   Get the xiaoshu part of a floatnum.
   For example:
      123.000456 -->  0.000456
     -123.000456 --> -0.000456
*/
TFloatNum TFloatNum::GetXiaoshu()const
{
  TFloatNum  f;

  if( exp < 0 )
  {
    f.exp = exp;
    *f.mant = *mant % ( TBigInt(10) ^ (-exp) );
  }
  else
  {
    f.exp = 0;
    *f.mant = 0;
  }

  return (f);
}

//how=1:޸ıԭ෴make a new copy
//how=0:޸ıԭnot make a new copy 
TAtom* TFloatNum::uminus(int how) // defalut how=1 make a new copy
{  
   /*
   TBigInt nb=Mant();
   nb.uminus(how);
   if(!how) return this;
   return new TFloatNum(nb,Exp() );
   */
   //modify on 2002.6.6
   if(!how) return this;
   return new TFloatNum(-(*mant),exp);
}

   
// read a floatnum
istream & operator >> (istream & in,TFloatNum & f)
{
  char * str;
  char * s;
  short sum = 0;

  str = (char *)malloc(MaxString);
  if(!str) 
  {
    cout << "Out of memory!\n";
    exit(1);
  }

  in >> str;
  *f.mant = TBigInt(str);
  s = str + ( strlen(str)-1 );  // point s to the end of str
  while( (*s != '.') && (s != str) )
  {
    if( (*s >= '0') && (*s <= '9') )
       sum ++;
    s--;
  }

  if( *s == '.' )
     f.exp = -sum;
  else
     f.exp = 0;
  free(str);
  return in;
}
  
//--------------------------------------------------------
// write a floatnum
//--------------------------------------------------------
#ifdef CONSOLE
outtype& operator << (outtype& out,const TFloatNum & f)
{
     
    TBigInt bn1 = bnabs( f.GetInteger() ), bn2;
    short i,n,m;
   
    if( *f.mant == 0 )
      if(f.exp >= 0 )
           return ( out << "0." );
    
    if(f.exp < 0) 
    {
      n = -f.exp;  // n is the number of digits after "."  in f
      bn2 = bnabs(*f.mant) % ( TBigInt(10) ^( n) );
      // bn2 is the value of the bignum after "." in f
      m = bn2.length();
      
      if(*f.mant < 0 ) out << "- "; 
      out << bn1;
      out << ".";
      if( n > m )
        for( i = 0; i < (n-m); i++ )
	    out << "0";
      out << bn2;
    }
    else // f.exp >= 0
    {
      out << *f.mant;
      if(f.exp > 0)
       for( i = 0; i < f.exp; i++ )
	 out << "0";
      out << ".";

    }
     return out;
}
#endif


/*
//this function is used for testing other functions
//Note: this function is not the output stream
outtype& operator << (outtype& out,const TFloatNum & f)
{
    TFraction r(103,4);

    TFloatNum f1=TFloatNum(r);

    cout << f1.Mant() << endl;

    cout << f1.Exp() << endl;

    return out;

//===============================================

    TBigInt bn1 = abs( f.GetInteger() ), bn2;
    short i,n,m;
   
    if( *f.mant == 0 )
      if(f.exp >= 0 )
           return ( out << "0." );
    
    if(f.exp < 0) 
    {
      n = -f.exp;  // n is the number of digits after "."  in f
      bn2 = abs(*f.mant) % ( TBigInt(10) ^( n) );
      // bn2 is the value of the bignum after "." in f
      m = bn2.length();
      
      if(*f.mant < 0 ) out << "- "; 
      out << bn1;
      out << ".";
      if( n > m )
        for( i = 0; i < (n-m); i++ )
	    out << "0";
      out << bn2;
    }
    else // f.exp >= 0
    {
      out << *f.mant;
      if(f.exp > 0)
       for( i = 0; i < f.exp; i++ )
	 out << "0";
      out << ".";

    }
     return out;
}
*/


/*
  sign function:

     0 -- if f = 0
     1 -- if f > 0
    -1 -- if f < 0
*/
int sign(const TFloatNum  f)
{
 // TBigInt bn=f.mant;
 // return sign(bn);
 return sign(*f.mant);
}

// the absolute value of a floatnum
TFloatNum abs(const TFloatNum & f)
{
   return TFloatNum( bnabs(*f.mant), f.exp );
}

// the negative of a floatnum
TFloatNum operator - (const TFloatNum & f)
{
   return TFloatNum( - (*f.mant), f.exp );
}


//mant*10^exp = mant*(10^100)*10^(exp-100)
//that is, f( mant,exp ) = f( mant*(10^100) , (exp-100) )
//so, sqrt(f) = (sqrt(mant*(10^100)), (exp-100)/2)
//in this way ,we can get the enough precision
TFloatNum sqrt (const TFloatNum & f )
{
  TBigInt mtmp=f.Mant();
  short etmp=f.Exp();

  if( (etmp % 2)!=0 ) {mtmp=mtmp*10; etmp=etmp-1;}

  mtmp=mtmp * (TBigInt(10) ^ TBigInt(100)); //TBigInt ^, *
  etmp=etmp-100;

  mtmp=sqrt(mtmp); //call TBigInt sqrt
  etmp=etmp/2;

  return TFloatNum(mtmp,etmp);
 
}


// comparing operator: ==
bool operator == (const TFloatNum & f1,const TFloatNum & f2)
{
  short exp1 = f1.exp, exp2 = f2.exp;
  TBigInt mant1 = f1.mant->Clone(), mant2 =f2.mant->Clone();
  short n,m;
  // to the case: the signs of the two floatnums are different
  //n=sign(f1);
  //m=sign(f2);
  //if(n*m<0) return FALSE;
  if( (sign(f1) * sign(f2)) < 0 )    return FALSE;

  if(exp1 == exp2)
     return ( mant1 == mant2 );

  // to the case: f1.exp != f2.exp, then let f1.exp == f2.exp
  // begin:

  n = min(exp1,exp2);
  m = abs(exp1) - abs(exp2);

  if(exp1 > n)
  {
     exp1 = n;
     mant1 = mant1 * ( TBigInt(10) ^ TBigInt(abs(m)) );
  }
  else
  {
     exp2 = n;
     mant2 = mant2 * ( TBigInt(10) ^ TBigInt(abs(m)) );
  }
 
  // end

  return ( mant1 == mant2 );

}




// comparing operator: <
bool operator < (const TFloatNum & f1,const TFloatNum & f2)
{
  short exp1 = f1.exp, exp2 = f2.exp;
  TBigInt mant1 = f1.mant->Clone(), mant2 = f2.mant->Clone();
  short n,m;

  // to the case: the signs of the two floatnums are different
  //if( (sign(f1) > 0) && (sign(f2) < 0) )  return FALSE;
  //if( (sign(f1) < 0) && (sign(f2) > 0) )  return TRUE;
  n=sign(f1);
  m=sign(f2); 
  if( (n> 0) && (m< 0) )  return FALSE;
  if( (n < 0) && m > 0 )  return TRUE;

  //cout<<*f1.mant<<" "<<*f2.mant<<endl;
  if(exp1 == exp2)
     return ( mant1 < mant2);

  // to the case: f1.exp != f2.exp, then let f1.exp == f2.exp
  // begin:

  n = min(exp1,exp2);
  m = abs(exp1) - abs(exp2);

  if(exp1 > n)
  {
     exp1 = n;
     mant1 = mant1 * ( TBigInt(10) ^ TBigInt(abs(m)) );
  }
  else
  {
     exp2 = n;
     mant2 = mant2 * ( TBigInt(10) ^ TBigInt(abs(m)) );
  }
 
  // end
  //cout<<*f1.mant<<" "<<*f2.mant<<endl;

  bool bb= ( mant1 < mant2 );
  //cout<<*f1.mant<<" "<<*f2.mant<<endl;
return bb;
}



// comparing operator: !=
bool operator != (const TFloatNum & f1,const TFloatNum & f2)
{ 
   if( !(f1 == f2) )
      return TRUE;
   else
      return FALSE;

}



// comparing operator: <=
bool operator <= (const TFloatNum & f1,const TFloatNum & f2)
{ 
   
   if( f1 == f2 ) 
     return TRUE;
   if( f1 < f2 )
     return TRUE;
   return FALSE;
    
}



// comparing operator: >
bool operator > (const TFloatNum & f1,const TFloatNum & f2)
{ 
   
   if( !(f1 <= f2) ) 
     return TRUE;
   else
     return FALSE;
    
}



// comparing operator: >=
bool operator >= (const TFloatNum & f1,const TFloatNum & f2)
{ 
   
   if( !(f1 < f2) ) 
     return TRUE;
   else
     return FALSE;
    
}




/* 
   comparing function:
        
     0 -- if f1 == f2
     1 -- if f1 >  f2
    -1 -- if f1 <  f2
*/
int comp(const TFloatNum & f1, const TFloatNum & f2)
{
   if(f1 == f2) return  0;
   else 
   {if(f1 > f2)  
       return  1;
    else return -1;
   }
}


/*
// the max of two floatnums
TFloatNum & max(const TFloatNum & f1,const TFloatNum & f2)
{
   if( f1 >= f2 ) return f1;
   return f2;
}

// the min of two floatnums
TFloatNum& min(const TFloatNum & f1,const TFloatNum & f2)
{
   if( f1 <= f2 )  return f1;
   return f2;   
}
*/

const TFloatNum & bmax(const TFloatNum & fn1, const TFloatNum & fn2)
{
	return (fn1  >=  fn2 ) ? fn1 : fn2;
}

const TFloatNum & bmin(const TFloatNum & fn1, const TFloatNum & fn2)
{
	return (fn1  <=  fn2 ) ? fn1 : fn2;
}

/********************** arithematic operators **********************/


// the sum of two floatnums
TFloatNum operator + ( TFloatNum & f1, TFloatNum & f2)
{  
  TFloatNum f ;
  short exp1, exp2;
  short n,m;
  TBigInt mant1, mant2;
  TFloatNum f11(f1),f22(f1);

  if(f1 == 0) return f2;
  if(f2 == 0) return f1;


  f11 = f1.SetFloatNum1(Digits+1);
  f22 = f2.SetFloatNum1(Digits+1);
  mant1 = f11.mant->Clone();
  mant2 = f22.mant->Clone();

  exp1 = f11.exp;
  exp2 = f22.exp;


  if(exp1 == exp2)
  {
    f.exp = exp1;
    f.SetMant(  mant1 + mant2);
    f = (f).SetFloatNum1(Digits);
    return (f);
  }

  // to the case: f1.exp != f2.exp, then let f1.exp == f2.exp
  // begin:
  n = min(exp1,exp2);
  m = abs(exp1) - abs(exp2);
  if(exp1 > n)
  {
     exp1 = n;
     mant1 = mant1 * ( TBigInt(10) ^ TBigInt(abs(m)) );
  }
  else
  {
     exp2 = n;
     mant2 = mant2 * ( TBigInt(10) ^ TBigInt(abs(m) ));
  }
  // end

  f.SetMant ( mant1 + mant2);
  f.exp = n;
  f = (f).SetFloatNum1(Digits);
  return (f);
}


// the difference of two floatnums
TFloatNum operator - ( TFloatNum & f1, TFloatNum & f2)
{  
  TFloatNum f ;
  short exp1, exp2;
  short n,m;
  TBigInt mant1, mant2;
  TFloatNum f11(f1),f22(f1);

  /*
  if(f1 == TFloatNum(0)) return (-f2);
  if(f2 == TFloatNum(0)) return f1;
  */
  if(f1 == (0)) return (-f2);
  if(f2 == (0)) return f1;

  f11 = f1.SetFloatNum1(Digits+1);
  f22 = f2.SetFloatNum1(Digits+1);

  mant1 = f11.mant->Clone();
  mant2 = f22.mant->Clone();

  exp1 = f11.exp;
  exp2 = f22.exp;

  if(exp1 == exp2)
  {
    f.exp = exp1;
    f.SetMant ( mant1 - mant2);
    f = (f).SetFloatNum1(Digits);
    return (f);
  }

  // to the case: f1.exp != f2.exp, then let f1.exp == f2.exp
  // begin:

  n = min(exp1,exp2);
  m = abs(exp1) - abs(exp2);

  if(exp1 > n)
  {
     exp1 = n;
     mant1 = mant1 * ( TBigInt(10) ^ TBigInt(abs(m)) );
  }
  else
  {
     exp2 = n;
     mant2 = mant2 * ( TBigInt(10) ^ TBigInt(abs(m) ));
  }
 
  // end
  f.SetMant ( mant1 - mant2);
  f.exp = n;
  f = (f).SetFloatNum1(Digits);
  return (f);
}



// the product of two floatnums
TFloatNum operator * ( const TFloatNum & f1, const TFloatNum & f2)
{
    TFloatNum  f ;
    TFloatNum f11,f22;

    if(f1 == 0) return 0;
    if(f2 == 0) return 0;
    if(f1 == 1) return f2;
    if(f2 == 1) return f1;
    if(f1 == -1) return (-f2);
    if(f2 == -1) return (-f1);

    f11 = f1.SetFloatNum1(Digits+1);
    f22 = f2.SetFloatNum1(Digits+1);

    f.SetMant ( f11.Mant() * f22.Mant() );
    f . SetExp  ( f11.Exp()  + f22.Exp() );
    f = (f).SetFloatNum1(Digits);
    return (f);
}



// the quotient of two floatnums (considering accuracy and jinwei)
TFloatNum operator / (const TFloatNum & f1,const TFloatNum & f2)
{

   //wout << "\nenter TFloatNum operator /\n" << endl; 
	   
   TFloatNum  f ;
   TBigInt q,r,bn;
   TBigInt mant1 = bnabs(f1.mant->Clone()), mant2 = bnabs(f2.mant->Clone());
   short exp1 = f1.exp, exp2 = f2.exp;
   short n,m,i,j,l;
   short s = sign(f1) * sign(f2); // s if the sign of f
   short flag = 1; 
   /*
      flag = 0 ---> the digit calculated at this time is not in the mantissa
      flag = 1 ---> the digit calculated at this time is in the mantissa
   */


   if(f2 == 0)
   {
     cout << "\nThe denominator can't be 0!\n";
     exit(1);
   }
   if(f1 == 0)
     return 0;
   if(f2 == 1)
     return f1;
   if(f2 == -1)
     return (-f1);

   
   if(exp1 != exp2)
   {
      n = min(exp1,exp2);
      m = abs(exp1) - abs(exp2); 

      if(exp1  > n)
         mant1 = mant1 * ( TBigInt(10) ^TBigInt( abs(m)) );
      else
         mant2 = mant2 * ( TBigInt(10) ^ TBigInt(abs(m)) );
   }

   q = mant1 / mant2; // calculate the part before "." 
   if( q == 0 ) flag = 0;
 
   //r = mant1 % mant2;
   r=mant1-q*mant2;

   l = q.length();


   /*
      if the number of digits carried in the quotient is 
      the value of Digits, we calculate the digit after "."
      to determine if needing jinwei
   */
   if( (l == Digits) && (flag == 1) )
   {  
      //TBigInt q1 = q;
      TBigInt q1 ( q);

      r = r * 10;
      q = r / mant2; // calculate the digit after "."( 0 <= q <= 9 )

      if( q < 5 )
         f.SetMant ( q1);
      else
         f.SetMant ( q1 + 1);
      f.SetExp ( 0);
      return ( s * (f) );
    }

   if( (l > Digits) && (flag == 1) )
   {
     f.SetMant ( q);
     f.SetExp ( 0);

     (f) = (f).SetFloatNum1(Digits);

     return ( s * (f) );
   }


   if(r == 0)
   {
     f.SetMant ( q);
     f.exp = 0;
 
     return ( s * (f) );
   }

   // general case
   bn = q; i = ( (flag == 1)?l:0 ); j = 0;
   while( i < Digits )
   {
      //r = r * 10;
      r *=10;
      q = r / mant2;
      /*
         calculate  a digit in the part after "." 
         the length of q must be 1 ( 0 <= q <= 9 )
      */

      if( q != 0 ) flag = 1;

      //r = r % mant2;
      r=r -q*mant2;
      bn = bn * 10 + q;
      if( flag == 1 )
          i = i + 1;    
      /* 
         i is the number of digits in mantissa that                             
         is already calculated at this time
      */
   
      j = j + 1;
      /*
         j is the number of digits in the part after "."
         at this time
      */

      if( r == 0 )   break;
   }

   
   // considering jinwei
   if(r == 0)
      f.SetMant ( bn);
   else
   {
      r = r * 10;
      q = r / mant2; // calculate the last digit( 0 <= q <= 9 )

      if( q < 5 )
         f.SetMant ( bn);
      else
        f.SetMant ( bn + 1);
   }
   f.exp = -j;
   return ( s * (f) );
}


//=================================================================
// the power of a floatnum
//=================================================================
TFloatNum operator ^ ( TFloatNum & f, TBigInt & nn)
{
  if(nn.Len()>1)
  {
     wout<<"\nExp must between -65536--65535!\n"<<endl;
     return f;
  }

  long n=nn.GetShort(0)*sign(nn);

  TFloatNum fn ;
  TFloatNum ff;

  if( n < 0 )
  {
    wout << "\nThe exponent can't be negative number!\n"<<endl;
    return -1;
  }

  if( n == 0 ) 
  {
    if( f == 0 )
    {
      wout << "\nCan't calculate 0 ^ 0!\n"<<endl;
      return -1;
    }
    else
      return 1;
  }

  if( n == 1 )   return f;
   
  if( f == 0 )   return 0;



  ff = f.SetFloatNum1(Digits+1);

  fn.SetMant ((*ff.mant) ^ (nn));
  fn.exp  = n * ff.exp;

  fn = (fn).SetFloatNum1(Digits);

  return (fn);

}



DataType TFloatNum::TypeID()const
{
  return FloatNumberType;
}

//=====================================

void *TFloatNum::operator new(size_t)
{
 return  (TFloatNum*)StarMem->alloc();
};

void TFloatNum::operator delete(void *p)
{
  StarMem->free(p);
};


/*
bool SameData(const TFloatNum& f1, const TFloatNum& f2) 
{
 bool b=SameData((f1.GetMant()),(f2.GetMant()));
 return b&& (f1.Exp() == f1.Exp() );
}
*/
