//////////////////////////////
// 󸡵ͷļ       //
// ļ:num_float.h       //
//////////////////////////////

#ifndef __STAR_NUMBER_FLOAT_
#define __STAR_NUMBER_FLOAT_
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <new.h>

//#include "global.h"
#include "expval.h"


// class defination -- TFloatNum

class TFloatNum :public TNumber
{
      private:

         TBigInt *mant;        // mantissa
         short exp;            // exponent

      public:

      /****************** constructors *******************************/

      TFloatNum()            //initialized by 0.0
      {
         mant=new TBigInt; 
         exp= 0;
      }
      TFloatNum(char * str); //initialized by a number string with a point
                                    
      TFloatNum(TBigInt bn,short i);// initializing  
	 
      TFloatNum(double f);          // type conversion: double       -> TFloatNum
      TFloatNum(float f);           // type conversion: float        -> TFloatNum
      TFloatNum(TBigInt bn);        // type conversion: TBigInt      -> TFloatNum
      TFloatNum(TFraction r);       // type conversion: TFraction    -> TFloatNum
      TFloatNum(TNumber n);         // type conversion: TNumber      -> TFloatNum
	  TFloatNum(TDouble f);         // type conversion: TDouble      -> TFloatNum
      TFloatNum(int i);             // type conversion: int          -> TFloatNum 
      TFloatNum(short i);           // type conversion: short        -> TFloatNum 
      TFloatNum(unsigned long i);   // type conversion: unsigned long-> TFloatNum 

      TFloatNum(const TFloatNum & fn); // create a new floatnum initialized by fn

      virtual ~TFloatNum();

      /*********************************************************************/

      short length()const;
      short lengthPT()const;
      /* get the number of digits carried in the mantissa of a floatnum */

      TFloatNum SetFloatNum1(short digits = 30)const;//Default precision=30
      /* modify a floatnum according to the specified accuracy(digits) */
      TFloatNum SetFloatNum2(short digits = 30)const;//Default precision=30
	  /* modify a floatnum according to the specified accuracy(digits) */

      
      TBigInt GetMant()const { return (*mant); };//get the mantissa of a floatnum
	  TBigInt Mant()const    { return (*mant); };//get the mantissa of a floatnum
      short GetExp()const    { return exp; };    //get the exponent of a floatnum
	  short   Exp()const     { return exp; };    //get the exponent of a floatnum
	  TBigInt SetMant(TBigInt);//set the mantissa
      short SetExp(short);//set the exponent
	  
      TBigInt   CopyMant();
      TFloatNum Clone()const;

      TBigInt GetInteger()const;     //get the integer part of a floatnum
      TBigInt GetInteger_carry()const;//get the integer part of a floatnum(with carry)
      TFloatNum GetXiaoshu()const;   //get the xiaoshu part of a floatnum

      TBigInt Ceil();
      TBigInt Floor();

	  TFloatNum & operator = (const TFloatNum & fn); // copy a floatnum

    /********************** arithematic operators *************************/
      friend TFloatNum operator + (TFloatNum & fn1,TFloatNum & fn2); 
      friend TFloatNum operator - (TFloatNum & fn1,TFloatNum & fn2);
      friend TFloatNum operator * (const TFloatNum & fn1,const TFloatNum & fn2); 
      friend TFloatNum operator / (const TFloatNum & fn1,const TFloatNum & fn2); 
      friend TFloatNum operator ^ (TFloatNum & fn, TBigInt & m); 
    /**********************************************************************/

      friend TFloatNum operator - (const TFloatNum & fn); 
      //negative of a floatnum 
      friend TFloatNum abs (const TFloatNum & fn);        
	  //absolute value of a floatnum

      //friend  bool  SameData(const TFloatNum&,const TFloatNum&);

      //sign function
      friend int sign (const TFloatNum  fn);
      //floatnum sign: 0 -- if fn = 0; 1 -- if fn > 0; -1 -- if fn < 0

	  friend TFloatNum sqrt (const TFloatNum & fn);

    /********************** comparing operators ****************************/
      friend bool operator == (const TFloatNum & fn1,const TFloatNum & fn2);
      friend bool operator != (const TFloatNum & fn1,const TFloatNum & fn2);
      friend bool operator <  (const TFloatNum & fn1,const TFloatNum & fn2);
      friend bool operator <= (const TFloatNum & fn1,const TFloatNum & fn2);
      friend bool operator >  (const TFloatNum & fn1,const TFloatNum & fn2);
      friend bool operator >= (const TFloatNum & fn1,const TFloatNum & fn2);
    /***********************************************************************/
    
      // comparing function
      friend int comp(const TFloatNum & fn1,const TFloatNum & fn2);
      /* compare two floatnums: 0 -- if fn1 == fn2
          1 -- if fn1 >  fn2; -1 -- if fn1 <  fn2
      */

	  friend const TFloatNum & bmax(const TFloatNum & fn1, const TFloatNum & fn2);
      friend const TFloatNum & bmin(const TFloatNum & fn1, const TFloatNum & fn2);

      friend istream & operator >> (istream & in,  TFloatNum & fn); 
      // read in a floatnum
#ifdef CONSOLE
      friend outtype& operator << (outtype& out,const TFloatNum & fn); 
      // write out a floatnum to a stream
#endif

	  virtual void display(outtype& out =wout) const;
      virtual void show(outtype& out =wout) const;
      virtual void print(outtype& out =wout) const;

      virtual TAtom* uminus(int how=1); //default how=1; make a new copy
 
      virtual DataType TypeID()const;

      void* operator new(size_t);
      void  operator delete(void *);
 
};



#endif 
