//////////////////////////////
// ͷļ         //
// ļ:num_number.h      //
//////////////////////////////

#ifndef __STAR_NUMBER_BASE_
#define __STAR_NUMBER_BASE_
#include <stdio.h>
#include <string.h>
#include <new.h>
#include <stdlib.h>

#include "expval.h"
#define _ToNumber(a) (*(TNumber*)&(a))

const int MaxString  = 10000; // used for operator >>(input stream)
//const int MaxString1 = 100000;// used for random bignum generation

//short Digits=30 ; // accuracy:the number of digits carried
                   //          in the mantissa of a floatnum

//#define REALLOCTYPE malloc_t
#define REALLOCTYPE  void *

class TNumber : public TExpVal {

    TNumber & SetNewValue(const TNumber n);

    protected:

    TNumber *ptr;

    public:

    //------------------- constructor & destructor ------------------
 	TNumber();
    TNumber(char *);

    TNumber(int);
    TNumber(short);
    TNumber(unsigned long);
    TNumber(double);

	TNumber(TBigInt bi);
	TNumber(TFloatNum &);
	TNumber(TFraction &);
	TNumber(TDouble &);
	TNumber(TComplex &);

	TNumber(const TNumber &);
	
    virtual ~TNumber();
	//----------------------------------------------------------------

    virtual TNumber* GetPtr() {return ptr;}; 

    TNumber& operator=(const TNumber& n);
    virtual TAtom* Copy(); 

    virtual int compare(TAtom *);
    virtual int isone(){ if (*this==1) return 1; else return 0;}
    int length();

    virtual int GetInt();
    virtual float GetFloat();

    virtual TBigInt Ceil();
    virtual TBigInt Floor();

	friend TNumber abs(const TNumber & fn); //absolute value of a number
    friend int sign(const TNumber fn);
    //number sign: 0 -- if fn = 0; 1 -- if fn > 0; -1 -- if fn < 0
	TNumber operator - (); //negative of a number
    friend TNumber sqrt(const TNumber & fn); //the square root of a number
	friend TNumber inv(const TNumber & n); //the inverse of a number

    //---------------- arithematic operators ------------------------
	virtual TNumber operator+(const TNumber& n) ;
	virtual TNumber operator-(const TNumber& n) ;
	virtual TNumber operator*(const TNumber& n) ;
	virtual TNumber operator/(const TNumber& n) ;
	virtual TNumber operator%(const TNumber& n) ;
    virtual TNumber operator += (const TNumber & bn);
    virtual TNumber operator -= (const TNumber & bn);
   	virtual TNumber operator *= (const TNumber & bn);
    virtual TNumber operator /= (const TNumber & bn);
    virtual TNumber operator %= (const TNumber & bn);
    TNumber operator ++ (int);
    TNumber operator ++ ();
    TNumber operator -- ();
    TNumber operator -- (int);
	TNumber operator ^ ( TNumber& n);
    //---------------------------------------------------------------

    //friend  bool  SameData(const TNumber&,const TNumber&);

    //------------------ comparing operators -------------------------
    friend bool operator == (const TNumber &, const TNumber & fn2);
    friend bool operator != (const TNumber &, const TNumber & fn2);
    friend bool operator <  (const TNumber &, const TNumber & fn2);
    friend bool operator <= (const TNumber &, const TNumber & fn2);
    friend bool operator >  (const TNumber &, const TNumber & fn2);
    friend bool operator >= (const TNumber &, const TNumber & fn2);
    //-----------------------------------------------------------------

    friend int comp(const TNumber & fn1,const TNumber & fn2);
    /* 
       compare two numbers: 
       0 -- if fn1 == fn2
       1 -- if fn1 >  fn2; 
      -1 -- if fn1 <  fn2
    */

    friend const TNumber & bmax(const TNumber &bn1, const TNumber &bn2);
    friend const TNumber & bmin(const TNumber &bn1, const TNumber &bn2); 
   
#ifdef CONSOLE
    friend TNumber operator << (const TNumber & bn,short n);  // bn * (2^n)
#endif
    friend TNumber operator >> (const TNumber & bn,short n);  // bn / (2^n)

    friend istream & operator >> (istream & in, TNumber &num);  // input
#ifdef CONSOLE
    friend outtype& operator << (outtype& out,const TNumber &num); // output
#endif

	virtual void display(outtype& out =wout) const;
    virtual void show(outtype& out =wout) const;
    virtual void print(outtype& out =wout) const;
    
	friend TNumber square(const TNumber & bn); //the square of a number
	friend TNumber div(TNumber & fn1,const TNumber & fn2);//the same as operator /

    friend TNumber igcd(const TNumber &bn1,const TNumber &bn2);
    friend TNumber imod(const TNumber &bn1,const TNumber &bn2);
    friend TNumber invm(const TNumber &bn1,const TNumber &bn2);

	virtual DataType TypeID() const;
	virtual TAtom* uminus(int how=1); //default how=1; make a new copy

	void* operator new(size_t);
    void  operator delete(void *);
 
	private:

    //The following functions are only used in TNumber::operator < and TNumber::operator ==
    //they only deal with the real number type(TBigInt,TFloatNum,TFraction,TDouble)

	int iszero_real(); //test if a real number is zero

	bool lessthan_real(const TNumber & n); //compare two real numbers
	bool equal_real(const TNumber & n); //compare two real numbers

};

#endif

