#include <stdio.h>
#include <ctype.h>
#include <iostream.h>
#include <string.h>
#include <new.h>
#include "basetype.h"
#include "number.h"
//#include "number1.h"
#include "num_integer.h"
#include "lists.h"
#include "vectors.h"
#include "pol.h"
#include "matrix.h"
#include "convert.h"
#include "strstrea.h"
extern "C"{
#include <time.h>
#include <sys/timeb.h>
}

extern int primelist[];

#ifdef _WINDOWS
#include "..\gui\index.h"
#endif

const TBigInt big_integer0(0);
const TBigInt big_integer1(1);

//==================================================
//    Implementation for class TRIPoly
//==================================================      

static TRIPoly * xpool;
static TDITerm * dpool;
static TPolyRC * rcpool;

const int num_rc_block = 1024 - 2;

void add_rc ()
{ 
	TPolyRC *pp;
	int i;
	pp = (TPolyRC *)malloc(num_rc_block * sizeof(TPolyRC));
	if (pp==NULL) { wout <<"run out of memory."<<endl; exit(1); }
	rcpool=pp;
	for (i = 1; i < num_rc_block; i++, pp++)
		pp->nx = pp + 1;
    pp->nx = NULL;
}

inline TPolyRC *get_rc ()
{ 
	if (rcpool == NULL) add_rc();
	TPolyRC *d1 = rcpool;
	rcpool = rcpool->nx;
//	d1->nx = NULL;
	d1->rc = 1;
	return(d1);
}
           
inline void put_rc (TPolyRC *dpt)
{ dpt->nx = rcpool; rcpool = dpt; }    
             
/* initials */

void init_TRIPoly ()
{ 
//	if(last_var==0){
//	  last_var=&all_var;
//	  all_var.nx=0;
//	}
//	last_var = &all_var; 
//	all_var.nx = 0;
//	if(xpool==0)add_xt();
//	if(dpool==0)add_dt();
	if(rcpool==NULL) add_rc();  
}

////////////////////////////////////////////////////////////

TRIPoly::TRIPoly()
{
  var=0;
  c=0;
  ups=0;
  RefCount=get_rc();
}
TRIPoly::TRIPoly(TNumber va) // QZY
{
  var=0;
  c=va;
  ups=0;  
  RefCount=get_rc();
}
TRIPoly::TRIPoly(TNumber * va) // QZY
{
  var=0;
  c=*va;
  ups=0;  
  RefCount=get_rc();
}

TRIPoly::TRIPoly(TVariable * v,unsigned short * d)
{
  if(v==0)
  {
		var=0;
		c = TBigInt(0);
                ups=0;  
		RefCount=get_rc(); 
  }
  else{
	if((*d)==0)
  {
  var=0;
  c = TBigInt(1);
  ups=0;  
  RefCount=get_rc();
  }
  else
  {
  var=v;
  c=0;
  ups=new TDITerm(d);
  RefCount=get_rc();
  }
  }
}
TRIPoly::TRIPoly(TVariable * v,unsigned short d)
{
	if(v==0)
  {
		var=0;
		c=TBigInt(0);
                ups=0;  
		RefCount=get_rc(); 
  }
  else{
  if(d==0)
  {
  var=0;
  c=TBigInt(1);
  ups=0;  
  RefCount=get_rc();
  }
  else
  {
  var=v;
  c=0;
  ups=new TDITerm(d);
  RefCount=get_rc();
  }
  }
}
TRIPoly::TRIPoly(const TRIPoly & tr)
{
/*
//wout<<"TRIPoly1"<<endl;    
//wout<<"TR=";tr.display();wout<<endl;      
	if(tr.var==0) 
	{
//wout<<"TR1=";tr.display();wout<<endl; 
		var=0;
		c=tr.c;
		ups=0;  
	}
	else
	{
//wout<<"TR2=";tr.display();wout<<endl;      
		var=tr.var;
		c=0;
		ups=cp_TDITerm(tr.ups);
//wout<<"dddd=";this->display();wout<<endl;
	}
*/
  var=tr.var;
  ups=tr.ups;
  c=tr.c;     
  RefCount=tr.RefCount;
  RefInc();
}

/*TRIPoly::TRIPoly(TRIPoly &tr)
{
  var=tr.var;
  ups=tr.ups;
  c=tr.c;                
  RefCount=tr.RefCount;
  RefInc();
}                       
*/

//=================           Distruction of class TRIPoly     ===========

TRIPoly::~TRIPoly()
{
  TDITerm *pp,*pp1;
/*
if(this)
	 if(var!=0)
	 {
		pp=ups;
		while(pp!=0)
		{
			pp1=pp->nx;
delete pp->p;
			delete pp;
			pp=pp1;
		 }
	 }
*/
	if(this){
		if(RefDec()) return;
		
		put_rc(RefCount);
//           if(var!=0)
//         {
                pp=ups;
                while(pp!=0)
                {
                        pp1=pp->nx;
					delete pp->p;
                        delete pp;
                        pp=pp1;
                 }
//         }                    
	}
}



void * TRIPoly::operator new(size_t)
{
//  return get_xx();
 return (TRIPoly *)StarMem->alloc();   
}
void TRIPoly::operator delete(void * p)
{
//  put_xx((TRIPoly *)p);
StarMem->free(p); 
}

TRIPoly TRIPoly::operator=(const TRIPoly &p)
{
	TDITerm *pp,*pp1;
/*	if(this->var!=0)
	 {
		pp=ups;
		while(pp!=0)
		{
			delete pp->p;
			pp1=pp->nx;
			delete pp;
			pp=pp1;
		 }
	 }
c=p.c;
var=p.var;
if(!var)
{
    return *this;
}
else{
ups=cp_TDITerm(p.ups);
return *this;
}*/
//if(p.ups==ups&&p.var==var&&p.c==c) return *this;
//if(eq_TRIPoly(this,p) return *this;
	if(RefDec() == 0)
	{
//		if(this->var!=0)
//		{
		pp=ups;
        while(pp!=0)
        {
            delete pp->p;
            pp1=pp->nx;
            delete pp;
            pp=pp1;
        }
//      }       
		put_rc(RefCount);
	}
	c=p.c;
	var=p.var;
	RefCount=p.RefCount;
	RefInc();  
//if(!var)
//{
//    return *this;
//}
//else{
//ups=cp_TDITerm(p.ups);
	ups=p.ups;
	return *this;
//}                        

}


//========== Begin information part;

unsigned short TRIPoly::deg()
{
  if(var==0)
    return 0;
  else
    return ups->deg;
}       
unsigned short TRIPoly::maindeg()
{
TDITerm *td;
  if(var==0)
    return 0;
  else
  {
    td=ups;
    while(td->nx!=0)
      td=td->nx;
    return td->deg;
  }
}       
unsigned short TRIPoly::Degree(TVariable *v)
{                               
  return pdeg(this,v);
}
unsigned short TRIPoly::MinDegree(TVariable *v)
{                               
/* TDITerm *dp1; unsigned short count =0;
  if (this->var == 0) return(0);
  else { dp1 = this->ups;
         while (dp1 != 0)
                         {count=dp1->deg ; dp1=dp1->nx; }
                 }
  return(count);*/
	return mdeg(this,v);
}
unsigned long TRIPoly::PolyLen()
{ TDITerm *dp1; unsigned long count =0;
  if (this->var == 0) return(0);
  else { dp1 = this->ups;
         while (dp1 != 0)
                         { count++; dp1=dp1->nx; }
                 }
  return(count);
}

unsigned long TRIPoly::polylen()
{
  TDITerm *dp1; unsigned count =0;

  if (pzerop(this)) return(0);
  else if (this->var == 0) return(1);
  else { dp1 = this->ups;
         while (dp1 != 0)
                { count += plength(dp1->p); dp1=dp1->nx; }
                 }
  return(count);
}

int TRIPoly::IsNumber()
{
  return(var==0);
}


int TRIPoly::IsBigInt()
{
  return (var==0);
}

 
TVariable * TRIPoly::MainVar()
{
  return var;
}

int TRIPoly::IsZero()
{
  return(var==0&&c==0);
}

TRIPoly * TRIPoly::Coefficient(TVariable *v,unsigned short d)
{
//  return pinit(this->Clone(),v,d);
  TDITerm * td;
  TRIPoly * tr,*tr1,*tr2,*tr3,*tmp,*tr4,*tr5;
  if(var==0)
  {
    if(d==0)
    {
      return this->Clone();
    }
    else
    {
      tr=new TRIPoly();
      return tr;
    }
  }
  else if(var==v)
  {
    tr=new TRIPoly();
    for(td=ups;td!=0;td=td->nx)
    {
      if((td->deg)==d)
      {
        tmp=tr;
        tr=(td->p)->Clone();
        delete tmp;
       }
    }
    return tr;
  }
  else
  {
    tr=new TRIPoly();
    for(td=ups;td!=0;td=td->nx)
    {
      if((td->deg)>0)
      {
        tr1=new TRIPoly(var,(td->deg));
        tr2=tr1;
        tr4=td->p->Coefficient(v,d);
        tr5=tr4;
        tr1=poly_mul(tr1,tr4);
        tr3=tr1;
        tmp=tr;
        tr=poly_plus(tr,tr1);
        delete tmp;
        delete tr5;
        delete tr2;delete tr3;
      }
      else
      {
        tr1=td->p->Coefficient(v,d);
        tr2=tr1;
        tmp=tr;
        tr=poly_plus(tr,tr1);
        delete tmp;
        delete tr2;
      }
    }
  return tr;
  }
}  


TList * TRIPoly::Coeffs(TVariable *v)
{
  TList * l=new TList();
  unsigned short i=this->Degree(v);
  TRIPoly *p;
  unsigned short j;
  if(i==0)
    return l;
  for(j=0;j<=i;j++)
  {
    p=this->Coefficient(v,j);
    if(!(p->IsZero()))
      l->append((TAtom *)(p->Copy()));
    delete p;
  }
  return l;
}         

TVariable * TRIPoly::minv()
{
  TVariable *v=this->var,*v0;
  int i=0;
  TRIPoly *tmp;
  TDITerm *t;
  t=this->ups;
//wout<<"in MINV v=";v->display();wout<<endl;
  while(t!=0)
  {
    tmp=t->p;
//wout<<"in MINV tmp=";tmp->display();wout<<endl;
    if((tmp->var)!=0)
    {
      v0=tmp->minv();
//wout<<"in MINV v0=";v0->display();wout<<endl;
//wout<<"v0.order="<<v0->order<<endl;
//wout<<"in MINV v1=";v->display();wout<<endl;
//wout<<"v1.order="<<v->order<<endl;
      if((v->compare(v0))<0)
      {
//        wout<<"in MINV v=";v->display();wout<<endl;
        v=v0;
//        wout<<"in MINV v=";v->display();wout<<endl;
      }
//wout<<"in MINV v2=";v->display();wout<<endl;
//wout<<"v2.order="<<v->order<<endl;
    }
    t=t->nx;
//    if(t!=0)
//    tmp=t->icoef;
  }
  return v;
}

TNumber TRIPoly::mincoef() // QZY
{
	TRIPoly p;
	TRIPoly ld;
	TNumber n,n1; // 2002 QZY
	p=*this;
	ld=p.IPlbt();
	n = abs(ld.IPlbcf());
	p=p-ld;
	while(p.var!=0 || p.c!=0)
	{
		ld=p.IPlbt();
		n1 = abs(ld.IPlbcf());
		if(n1<n) n=n1;
		p=p-ld;
	}
	return n;
}

TNumber TRIPoly::maxcoef() // QZY
{
	TRIPoly p;
	TRIPoly ld;
	TNumber n,n1; // QZY
	p=*this;
	ld=p.IPlbt();
	n = abs(ld.IPlbcf());
	p=p-ld;
	while(p.var!=0 || p.c!=0)
	{
		ld=p.IPlbt();
		n1 = abs(ld.IPlbcf());
		if(n1>n) n=n1;
		p=p-ld;
	}
	return n;
}

unsigned short TRIPoly::maxdeg()
{
  TDITerm *t;
  TRIPoly p0=*this;
  unsigned short  n,n1;
  if(p0.var==0)
    n=0;
  else if(p0.IPunt()==TBigInt(1))
  {
    n=p0.ups->deg;
  }
  else
  {
    n=p0.ups->deg;
    for(t=p0.ups;t!=0;t=t->nx)
    {
      n1=t->p->maxdeg();
      if(n1>n)
        n=n1;
    }
  }
  return n;   
}

TRIPoly TRIPoly::IPldcf()
{
  if(var==0)
  {
    return TRIPoly(TBigInt(0));
  }
  else
  {
    return (*(this->ups->p));
  }
}

TRIPoly TRIPoly::IPlbt()
{
  TRIPoly p,p0;
  if(var==0)
  {
    return (*this);
  }
  else
  {
    p0=this->ups->p->IPlbt();
    return p0*TRIPoly(var,this->ups->deg);
  }
}

TRIPoly TRIPoly::IPltv(TVariable * v)
{
  unsigned short t;
  TRIPoly *pp,p,p0;
  if(var==0)
  {
    return (*this);
  }
  else
  {
//    p0=this->ups->p->IPlbt();
//    return p0*TRIPoly(var,this->ups->deg);
    t=this->Degree(v);
    pp=this->Coefficient(v,t);
    p=(*pp)*TRIPoly(v,t);
    delete pp;
    return p;
  }
}               

TRIPoly TRIPoly::IPred()
{
	TRIPoly *temp=cp_rem(this),tmp=*temp;
	delete temp;
	return tmp;
}

TNumber TRIPoly::IPlbcf() // 2002 QZY
{
	TDITerm *dp1;
	TRIPoly * p=this;
	while (p->var != 0) { dp1 = p->ups; p = dp1->p; }
	return(p->c);
}                  

int TRIPoly::IPconst()
{
  return (var==0);
}

int TRIPoly::IPunt()
{
  TRIPoly *tmp;
  TDITerm * t;
  int i=1;
  if(var==0)
  {
    i=0;
  }
  else
  {
    t=this->ups;
    tmp=t->p;
    while(t!=0)
    {
      if((tmp->var)!=0)
      {
        i=0;
        return i;
      }
      t=t->nx;
      if(t!=0)
      tmp=t->p;
    }
  }    
  return i;
}

unsigned short TRIPoly::IPord()
{
  TDITerm * t;
  if(var==0)
  {
    return 0;
  }
  else
  {
    t=this->ups;
    while((t->nx)!=0);
    {
      t=t->nx;
    }
    return (t->deg);
  }
}

//*************** For Prof. Wang

int TRIPoly::pis1()
{
  if((this->c)==TBigInt(1))
    return 1;
  else
    return 0;
}

int TRIPoly::pis0()
{
  if((this->c)==TBigInt(0) && (this->var)==0)
    return 1;
  else
    return 0;
}                

TVariable * TRIPoly::mainvar_w(TList * ord)
{
  int l=ord->length();
  int i;
  unsigned short tmp;
//wout<<"go into the mainvar_w"<<endl;
  if(var==0)
    return NULL;
  for(i=1;i<=l;i++)
  {
    tmp=this->Degree((TVariable *)(ord->Part(i)));
    if(tmp!=0)
      return (TVariable *)(ord->Part(i));
  }
  return NULL;
}
TRIPoly *TRIPoly::IPLdCf_w(TList * ord)
{
  if(var==0)
    return (new TRIPoly());
  TRIPoly tmp,*tmp1;
  TVariable * var=(this->mainvar_w(ord));
  tmp1=(this->Coefficient(var,this->Degree(var)));
//  tmp=*tmp1;
  return tmp1;
}                                        
TRIPoly *TRIPoly::IPldt_w(TList * ord)
{
  if(var==0)
    return (TRIPoly *)(this->Copy());
  TRIPoly *tmp=this->IPLdCf_w(ord);
  TRIPoly tmp1;
  TVariable * var=(this->mainvar_w(ord));
  tmp1=TRIPoly(var, this->Degree(var));
  tmp1=(*tmp)*tmp1;
  delete tmp;
  return new TRIPoly(tmp1);
}

TNumber TRIPoly::IPLbCf_w(TList * ord) // 2002 QZY
{
	if(var==0) return c;
	TRIPoly tmp;
	tmp=*this;
	while((tmp.mainvar_w(ord))!=0)
	{
		tmp=tmp.IPLdCf(ord);
	}
//  if(tmp.var==0)
    return tmp.c;
//  else
//    return tmp;
}                                     

//*************** End for Prof. Wang;

//*************** For yang Hong

TVariable * TRIPoly::mainvar(TList * ord)
{
  int l=ord->length();
  unsigned short tmp;
  if(var==0)
    return NULL;
  while(l>0)
  {
    tmp=this->Degree((TVariable *)(ord->Part(l)));
    if(tmp!=0)
      return (TVariable *)(ord->Part(l));
    l=l-1;
  }
  return NULL;
}
TRIPoly TRIPoly::IPLdCf(TList * ord)
{
  if(var==0)
    return TRIPoly(TBigInt(0));
  TRIPoly tmp,*tmp1;
  TVariable * var=(this->mainvar(ord));
  tmp1=(this->Coefficient(var,this->Degree(var)));
  tmp=*tmp1;
  delete tmp1;
  return tmp;
}
TRIPoly TRIPoly::IPldt(TList * ord)
{
  if(var==0)
    return (*this);
  TRIPoly tmp=this->IPLdCf(ord);
  TRIPoly tmp1;
  TVariable * var=(this->mainvar(ord));
  tmp1=TRIPoly(var, this->Degree(var));
  return tmp*tmp1;
}                                                      

TRIPoly TRIPoly::IPred(TList * ord)
{
  return (*this)-(this->IPldt(ord));
}

TRIPoly TRIPoly::IPLbCf(TList * ord)
{
	if(var==0) return TRIPoly(c);
	TRIPoly tmp;
	tmp=*this;
	while((tmp.mainvar(ord))!=0)
	{
		tmp=tmp.IPLdCf(ord);
	}
//  if(tmp.var==0)
//    return tmp.c;
//  else
    return tmp;
}
                                       
//*********** End For Yang hong; 

// added by QZY, 2002

bool TRIPoly::isIntPoly () {
	return c.GetPtr()->TypeID() == BigNumberType && ups->isIntCoefs();
}

//========== End information part;

//=================  MOD   ================    


TRIPoly *TRIPoly::mod(const TBigInt &m)
{
	TDITerm *t1;
	TNumber n;  // 2002 QZY
	TRIPoly *p0,*p1,*p2,*p3,*p4,*p5,*p6,*p7;
	if(this->var==0)
	{
		n=(this->c)%m;
		if(n<0) n=n+m;
/*    if(iseven(m))
   {
     if(n<(-m/2))
       n=n+m;
     if(n>(m/2))
       n=n-m;
   }
   else
   {
     if(n<=(-(m+TBigInt(1))/2))
       n=n+m;
     if(n>=((m+TBigInt(1))/2))
       n=n-m;
   }*/
    return new TRIPoly(n);
  }
  else if(m==1)
  {
    return this->Clone();
  }
  else
  {
    p0=new TRIPoly();
    for(t1=this->ups;t1 !=0;t1=t1->nx)
    {
      p2=new TRIPoly(this->var,(t1->deg));
      p3=p2;
      p1=p0;
      p4=t1->p->mod(m);
      p5=p4;
      p6=ptimes(cp_TRIPoly(p2),cp_TRIPoly(p4));
      p7=p6;
      p0=pplus(cp_TRIPoly(p6),cp_TRIPoly(p0));
      delete p7;
      delete p3;
      delete p1;
      delete p5;
    }
    return p0;    
  }
}

TRIPoly* IPmium(TRIPoly *p1,TRIPoly *p2,TBigInt m)
{
        return mpplus(cp_TRIPoly(p1),cp_TRIPoly(p2),m);
}       

TRIPoly* IPmdif(TRIPoly *p1,TRIPoly *p2,TBigInt m)
{
  TRIPoly tmp,*tmp1;
  TRIPoly *pp2=neg_TRIPoly(cp_TRIPoly(p2));
//pp2->display();wout<<endl;
  tmp1=IPmium(p1,pp2,m);
  delete pp2;
  return tmp1;
}                 

TRIPoly* IPmpro(TRIPoly *p1,TRIPoly *p2,TBigInt m)
{
//        return mptimes(cp_TRIPoly(p1),cp_TRIPoly(p2),m);
   TRIPoly *p3,*p4;
   p3=ptimes(cp_TRIPoly(p1),cp_TRIPoly(p2)); 
//p3->display();wout<<endl;
   p4=p3->mod(m);
   delete p3; 
   return p4;
}         


char *TRIPoly::pol_to_char()
{
	char *fname;
  #ifdef CONSOLE
    strstream buffer;
    display(buffer);
    buffer<<ends;
    fname=buffer.str();
  #else
	CString str;
    display(wout);
    str=wout.GetData(wout.GetLength());
	fname=strdup(str.GetBuffer(str.GetLength()));
  #endif
    return fname;
}



////////////////////////////////////////////////////////
//Display part:=================================
//////////////////////////////////////////////////////////

void TRIPoly::show(outtype & out)const
{
  display(out);
}
void TRIPoly::print(outtype &out)const
{
  display(out);
}
void TRIPoly::display(outtype & out)const
{
  display1("",0,out);
}

void TRIPoly::display1(char *s,int t,outtype & out)const
{
  TDITerm *d;
  char tmp[500];
  TBigInt v1(1),v2(-1),v3(0);
  if(var==0)
  {
     if(c==v1||c==v2)
     {
      if(strlen(s)&&t)
      {
        if(c==v1)
            out<<"+"<<s;
        if(c==v2)
            out<<"-"<<s;
      }

      if(strlen(s)&&!t)
      {
        if(c==v1)
            out<<s;
        if(c==v2)
            out<<"-"<<s;
      }
      if(t&&(!strlen(s)))
      {
          if(c==v1)
		  {
              out<<"+"<<c;
		  }
          if(c==-1)
		  {
			   out<<c;
		  }
      }
      if((!strlen(s))&&!t)
      { out<<c;
      }
    }
    if(c!=v1&&c!=v2)
    {
      if(t)
      {
        if(strlen(s))
        {
            //if(c>v1)
            if(c>0) //YH 2002.11.06
			{
              out<<"+"<<c<<"*"<<s;
			}
            //if(c<v2)
			if(c<0) //YH 2002.11.06
			{
               out<<c<<"*"<<s;
			}
        }
        else
        {
            //if(c>v1)
			if(c>0) //YH 2002.10.30
			{
                out<<"+"<<c;
			}
            //if(c<v2)
			if(c<0) //YH 2002.10.30
			{
                out<<c;
			}
        }
     }
     else
      {
        if(strlen(s))
		{
            out<<c<<"*"<<s;
		}
        else 
		{
            out<<c;
		}
       }
    }
    return;
  }  
  for(d=ups;d!=0;d=d->nx)
  {
    if((d->deg)==0)
      sprintf(tmp,"%s",s);
    else if((d->deg)==1)
      if(strlen(s)!=0)
        sprintf(tmp,"%s*%s",var->GetName(),s);
      else
        sprintf(tmp,"%s",var->GetName());
    else
    {
      if(strlen(s)!=0)
      {
        sprintf(tmp,"%s^%d*%s",var->GetName(),
                     ((d->deg)),s);
      }
      else
        sprintf(tmp,"%s^%d",var->GetName(),((d->deg)));
    }
    if(t)
      (d->p)->display1(tmp,1,out);
    else if(d==ups)
      (d->p)->display1(tmp,0,out);
    else
      (d->p)->display1(tmp,1,out);    
  }
  return;
}


//======================================================================
/////////////////////////////////////////////////
//Implementation for class: TDITerm
/////////////////////////////////////////////////
TDITerm::TDITerm(const TDITerm & td)
{
  TDITerm dt2, *dp2,*dp1;
  dt2.nx=0; dp2= &dt2;
//  while (dp1 != 0)
  if(pzerop(td.p))
  do
  { dp2->nx=get_dt(td.deg,cp_TRIPoly(td.p), 0);
		dp2=dp2->nx;
		dp1=td.nx;
  }while(dp1!=0);

  deg=dt2.nx->deg;
  p=dt2.nx->p;
  nx=dt2.nx->nx;
}


//end of the file