#include <stdio.h>
#include <iostream.h>
#include <fstream.h>
#include <string.h>
#include <new.h>
#include "basetype.h"
#include "number.h"
#include "lists.h"
#include "nvar.h"
#include "shortlist.h"
#include "vectors.h"
#include "pol.h"
#include "matrix.h"
#include "convert.h"

extern "C"{
#include <time.h>
#include <sys/timeb.h>
}

extern int primelist[];

//================  Ipsign  =========================
short TRIPoly::Ipsign()
{
  return sign(this->IPlbcf());
}

//=================  Ipabs  ==========================
TRIPoly TRIPoly::Ipabs()
{
  TRIPoly tmp;
  short s;
  s=this->Ipsign();
  if(s>=0)
    tmp=*this;
  else
    tmp=TRIPoly(TBigInt(-1))*(*this);
  return tmp;
}

//=================  Ipvri  =========================
TRIPoly *TRIPoly::IPvri(TVariable * v,TBigInt t)
{
  unsigned short i1,i;
  TRIPoly *p1,*p2,*tr1,*tr2,*tr3,*tr4,*tr5,*tr6;
  i1=this->Degree(v);
  if(i1==TBigInt(0))
  {
    return this->Clone();
  }
    p1=this->Coefficient(v,0);
  for(i=1;i<=i1;i++)
  {
    if(t==0)
      tr1=new TRIPoly(TBigInt(0));
    else
      tr1=new TRIPoly(t^i);
    tr2=tr1;
    p2=p1;
    tr3=this->Coefficient(v,i);
    tr4=tr3;
    tr5=ptimes(cp_TRIPoly(tr3),cp_TRIPoly(tr1));
    tr6=tr5;
    p1=pplus(cp_TRIPoly(p1),cp_TRIPoly(tr5));
    delete tr2;
    delete tr4;
    delete tr6;
    delete p2;
  }                       
  return p1;
}                            

//=================  IPvtp  =========================  

TRIPoly *TRIPoly::IPvtp(TVariable * v,TRIPoly p)
{
  	G_OUT("this is:",this);
	G_OUT("v is:",v);
    p.display();
	wout<<endl;
  unsigned short i1,i;
  TRIPoly *p1,*p2,*tr1,*tr2,*tr3,*tr4,*tr5,*tr6;
  i1=this->Degree(v);
  if(i1==TBigInt(0))
  {
    return this->Clone();
  }
  p1=this->Coefficient(v,0);
  for(i=1;i<=i1;i++)
  {
    tr1=new TRIPoly(p^i);
    tr2=tr1;
    p2=p1;
    tr3=this->Coefficient(v,i);
    tr4=tr3;
    tr5=ptimes(cp_TRIPoly(tr3),cp_TRIPoly(tr1));
    tr6=tr5;
    p1=pplus(cp_TRIPoly(p1),cp_TRIPoly(tr5));
    delete tr2;
    delete tr4;
    delete tr6;
    delete p2;
  }
  return p1;
}                 

/*
TRIPoly * Sub_Ra(TRIPoly *p0, TVariable * v, TRational * r)
{
  	G_OUT("this is:",p0);
	G_OUT("v is:",v);
	G_OUT("r is:",r);
	wout<<endl;

  unsigned short i1,i;
  TRIPoly p, q, *p1,*p2,*tr1,*tr2,*tr3,*tr4,*tr5,*tr6, *q1, *q2;
  i1=p0->Degree(v);
  if(i1==TBigInt(0))
  {
    return p0->Clone();
  }
  p1=p0->Coefficient(v,0);
  p = *(r->GetNu());
  q = *(r->GetDe());

  for(i=1;i<=i1;i++)
  {
    tr1=new TRIPoly(p^i);
    tr2=tr1;
    q1=new TRIPoly(q^(i1-i));
    q2=q1;

    p2=p1;
    tr3=p0->Coefficient(v,i);
    tr4=tr3;
    tr5=ptimes(cp_TRIPoly(tr3),cp_TRIPoly(tr1));
    tr5=ptimes(tr5,cp_TRIPoly(q2));
    tr6=tr5;
    p1=pplus(cp_TRIPoly(p1),cp_TRIPoly(tr5));

    delete tr2;
    delete tr4;
    delete tr6;
    delete p2;
  }
  return p1;
}       
//*/          



//===========    Factorization   =====================

//========  Unvariate Hensel Lifting Algorithm    ============

TRIPoly TRIPoly::derivative(TVariable *v)
{
  unsigned short d1,d2;
  TRIPoly out,p1,p2,*pr1,*pr2;
  if(v==0)
    return (*this);
  if(this->var==0)
    return TRIPoly(TBigInt(0));
  p1=(*this);
  d1=p1.Degree(v);
  if(d1==0)
    return TRIPoly(TBigInt(0));

  if(d1!=TBigInt(0)) 
  {
    out=TRIPoly(TBigInt(0));
    for(d2=1;d2<=d1;d2++)
    {
      pr1=p1.Coefficient(v,d2);
      pr2=pr1;
      p2=(*pr1)*TRIPoly(d2)*TRIPoly(v,(d2-1));
      delete pr2;
      out=out+p2;
    }
    return out;
  }     
}


TList *TRIPoly::SqureFree()
{
	TVariable * v;
	TList *l = new TList();
	TBigInt t2;
	unsigned short t1;
	TRIPoly a,b,c,w,y,z,g,tmp,tmp0;

	if( this->var == 0 && this->c == TBigInt(0) )
	{
		l->append((TAtom*)(new TRIPoly(*this)));
		l->append((TAtom*)(new TBigInt(1)));
		return l;
	}
	t1=1;
	t2=this->icont();
//         Modified on Feb. 2, 2000
//  if(t2!=TBigInt(1))
//  {
    l->append((TAtom*)(new TRIPoly(t2)));
    l->append((TAtom*)(new TBigInt(1)));
//  }
	a=(*this)/t2;
	tmp=a;
//cout<<"outoutoutoutoutotuoutotutoutoutooutouot"<<endl;
	//while(tmp.c!=TBigInt(1))
	while(abs(tmp.c)!=TNumber(1)) //YH 2002.07.15
	//if we don't modify it as above,then squarefree(-x-1) will
    //cause endless while loop.
    //now squarefree(-x-1) and squarefree(x+1) will cause
    //the same result.
	{
//cout<<"alkjdsfalskdjf"<<endl;
		t1=1;
		a=tmp;
		v=a.var;
		b=a.derivative(v);
//cout<<"a=";a.display();cout<<endl;
//cout<<"b=";b.display();cout<<endl;
		c=a.mipgcd(b);
//cout<<"c=";c.display();cout<<endl;
		if(c.c==TBigInt(1))
		{
			w=a;   
		}
		else
		{
			w=a/c;
//cout<<"w=";w.display();cout<<endl;
			y=b/c;
//cout<<"y=";y.display();cout<<endl;
			z=y-(w.derivative(v));
//cout<<"z=";z.display();cout<<endl;
//cout<<"ddddddddddddddddddddddddddddd1"<<endl;
			while(z.var!=0 || z.c!=0)
			{
				g=w.mipgcd(z);
//cout<<"g=";g.display();cout<<endl;
				if(g.c!=TBigInt(1))
				{
					l->append((TAtom*)(new TRIPoly(g)));
					l->append((TAtom*)(new TBigInt(t1)));
					tmp0=g^t1;
					tmp=tmp/tmp0; 
				}
//cout<<"l=";l->display();cout<<endl;
				t1=t1+1;
				w=w/g;
				y=z/g;
				z=y-(w.derivative(v));
  //cout<<"w=";w.display();cout<<endl;
//cout<<"z=";z.display();cout<<endl;
			}
//cout<<"dddddddddddddddddddddddddddddddddd"<<endl;
		}
		l->append((TAtom*)(new TRIPoly(w)));
		l->append((TAtom*)(new TBigInt(t1)));
		tmp0=w^t1;
		tmp=tmp/tmp0;
//cout<<"tmp=";tmp.display();cout<<endl;
//cout<<"l=";l->display();cout<<endl;
	}
	return l;
}

//another implementation of SqureFree()
TList * TRIPoly::Factor1()
{
  TVariable * v;
  TList *l=new TList();
  TBigInt t2;
  unsigned t1;
  TRIPoly a,b,c,w,y,z,g,tmp,tmp0,tmp1,tmp2;
  t1=1;
  t2=this->icont();
  if(t2!=TBigInt(1))
  {
    l->append((TAtom*)((TRIPoly(t2)).MPfactor()));
    l->append((TAtom*)(new TBigInt(1)));
  }
  a=(*this)/t2;
  tmp=a;
while(tmp.c!=TBigInt(1))
{
  t1=1;
  a=tmp;
//cout<<"a=";a.display();cout<<endl;
  v=a.var;
  b=a.derivative(v);
//cout<<"b=";b.display();cout<<endl;
  c=a.mipgcd(b);
//cout<<"c=";c.display();cout<<endl;
/////////tmp1=a/c;tmp1=a-tmp1*c;
////////tmp2=b/c;tmp2=b-tmp2*c;
//cout<<"tmp1=";tmp1.display();cout<<endl;
//cout<<"tmp2=";tmp2.display();cout<<endl;
//////if(tmp1.var!=0 || tmp1.c!=0 || tmp2.var!=0 || tmp2.c!=0)
//////{c=a.mipgcd(b);cout<<"Come into"<<endl;}
//cout<<"c=";c.display();cout<<endl;
  if(c.c==TBigInt(1))
  {
    w=a;
  }
  else
  {
    w=a/c;
//cout<<"w=";w.display();cout<<endl;
    y=b/c;
//cout<<"y=";y.display();cout<<endl;
    z=y-(w.derivative(v));
//cout<<"z=";z.display();cout<<endl;
    while(z.var!=0 || z.c!=0)
    {
      g=w.mipgcd(z);
///////tmp1=w/g;tmp1=w-tmp1*g;
///////tmp2=z/g;tmp2=z-tmp2*g;
///////if(tmp1.var!=0 || tmp1.c!=0 || tmp2.var!=0 || tmp2.c!=0)
///////g=w.mipgcd(z);
//cout<<"g=";g.display();cout<<endl;
      if(g.c!=TBigInt(1))
      {
        l->append((TAtom*)(g.MPfactor()));
        l->append((TAtom*)(new TBigInt((int)t1)));
        tmp0=g^t1;
        tmp=tmp/tmp0;
      }
//cout<<"l=";l->display();cout<<endl;
      t1=t1+1;
      w=w/g;
      y=z/g;
      z=y-(w.derivative(v));
    }
  }
  l->append((TAtom*)(w.MPfactor()));
  l->append((TAtom*)(new TBigInt((int)t1)));
  tmp0=w^t1;
  tmp=tmp/tmp0;
//cout<<"tmp=";tmp.display();cout<<endl;
//cout<<"l=";l->display();cout<<endl;
}
return l;
}

TList * TRIPoly::Factor()
{
 	DCP dc;
//	P * pr;
//LIST *rp;
	P temp=eptoap(this);
	fctrp(CO, temp, &dc);
    //(CO, temp, &dc);
	TList * l=DCP2List(dc);
//	l->display();cout<<endl;

//	delete l;
return l;
}

//this function is used in poly_factoras.cpp
//Don't remove it!
TList * TRIPoly::Factorold()
{
//	TRIPoly *t= aptoep(temp);

//	tri1 = new TRIPoly();
//	delete tri1;
	
//	return t;


  TList *ltmp1=new TList(),*ltmp,*ltmp2;
  TBigInt btmp;
  TRIPoly ptmp=TRIPoly(TBigInt(1)),ptmp0;
  int i=1,j;
//cout<<"Polynomial="; this->display();
//cout<<endl;
  ltmp=this->SqureFree();

//cout<<"SquareFree=";ltmp->display();
//cout<<endl;
  while(i<(ltmp->length()))
  {
//cout<<"p===";
//((TRIPoly *)(ltmp->Part(i)))->display();cout<<endl;
    ltmp2=((TRIPoly *)(ltmp->Part(i)))->MPfactor();
//============modified 2000,3,2 =================
//cout<<"ltmp2=";ltmp2->display();cout<<endl;
        ptmp0=*((TRIPoly *)(ltmp->Part(i)));
//cout<<"ptmp0=";ptmp0.display();cout<<endl;
	for(j=1;j<=(ltmp2->length());j++)
	  ptmp=ptmp*(*((TRIPoly *)(ltmp2->Part(j))));
//cout<<"ptmp=";ptmp.display();cout<<endl;
        if(ptmp.deg()!=ptmp0.deg())
          ltmp2->append((TAtom *)(new TRIPoly(ptmp0/ptmp))); 
	ptmp=TRIPoly(TBigInt(1));
//===============================================
//cout<<"Mpfactor=";ltmp2->display();
//cout<<endl;
    ltmp1->append((TAtom*)ltmp2);
    btmp=*((TBigInt *)(ltmp->Part(i+1)));
    ltmp1->append((TAtom*)(new TBigInt(btmp)));
    i=i+2; 
  }
//cout<<"Mpfactor=";ltmp2->display();cout<<endl;
  delete ltmp;
  return ltmp1;
}

TRIPoly TRIPoly::mdiv(TRIPoly p,TBigInt m)
{
  TRIPoly *p3,p0,p1,p2,*pp1,*pp2,pp11,tt1,*tt,*ppp1;
  TBigInt t1,t2;
  ppp1=p.mod(m); tt=this->mod(m);
  pp11=*ppp1; tt1=*tt; 
  delete ppp1; delete tt;
  TVariable * v=pp11.MainVar();
  if(v==0 && var==0)
  {
    t1=invm(toBigInt(pp11.c),m);
//cout<<"t1=";t1.display();cout<<endl;
    t2=imod(t1 * toBigInt(tt1.c), m);
    p0=TRIPoly(t2);
  }
  else if(v==0 && var!=0)
  {
    p1=TRIPoly(var,(tt1.Degree(var)));
    pp1=tt1.Coefficient(var,tt1.Degree(var));
    p2=pp1->mdiv(pp11,m);
    if(p2.var!=0 || p2.c!=0)
    {
//cout<<"p0=";p0.display();cout<<"="<<endl;
      p0=p2*p1+(tt1-p2*p1*pp11).mdiv(pp11,m);
    }
    delete pp1;
  }
  else
  {
    if(tt1.MainVar()!=0)
    {
      if((tt1.Degree(v))>=(pp11.Degree(v)))
      {
        if((tt1.Degree(v))==(pp11.Degree(v)))
        {
          p1=TRIPoly(TBigInt(1));
        }
        if((tt1.Degree(v))!=(pp11.Degree(v)))
        {
          p1=TRIPoly(v,((tt1.Degree(v))-(pp11.Degree(v))));
        }
        pp1=tt1.Coefficient(v,tt1.Degree(v));
//cout<<"pp1=";pp1->display();cout<<endl;
        pp2=pp11.Coefficient(v,pp11.Degree(v));
//cout<<"pp1=";pp2->display();cout<<endl;
        p2=p1*(pp1->mdiv(*pp2,m));
//cout<<"p2=";p2.display();cout<<endl;cout<<endl;
        if(p2.var!=0 || p2.c!=0)
        {
          p0=p0+p2+(tt1-p2*pp11).mdiv(pp11,m);
        }
        delete pp2;
        delete pp1;
      }
    }
  }
  ppp1=p0.mod(m);
  p0=*ppp1;
  delete ppp1;
  while(p0.deg()==0 && p0.var!=0) {
        p3=p0.Coefficient(p0.var,0);
        p0=*p3;
        delete p3;
        }
  return p0;
}
TRIPoly TRIPoly::mdiv(TBigInt p,TBigInt m)
{
  TBigInt tmp;
  TDITerm *t1;
  TRIPoly p1,pp,*pr;
  if(p==0)
  {
    cout<<"Error:The denominator can not be ZERO."<<endl;
    return p1;
  }
  else
  {
    pr=this->mod(m);
    pp=*pr;
    delete pr;
    if(pp.MainVar()==0)
    {
      tmp=imod((invm(p,m))*toBigInt(pp.c),m); 
      return TRIPoly(tmp);
    }
    else
    {
      t1=pp.ups;
      while(t1!=0)
      {
        p1=p1+((*(t1->p)).mdiv(p,m))*TRIPoly(pp.var,t1->deg);
        t1=t1->nx;
      }
      return p1;
    }
  }
}


TList *TRIPoly::FFiupSF(TBigInt p, TBigInt m)
{
//cout<<"go into"<<endl;
  TList *l=new TList();
  unsigned short temp1,k,i,j,temp;
  TBigInt limit1,limit0,ipp1,ipp2; 
  TRIPoly a,b,c,w,y,z,pp,tmp1,*tmp2,tmp3,*tmp4,temp2,u,pp1,pp2;
  TRIPoly *pr1;
  temp1=(p^m).GetShort(0);
  i=1;
  a=(*this);
  pr1=a.derivative(var).mod(p);
  b=*pr1;
//cout<<"b=";b.display();cout<<endl;
  delete pr1;
  if(b.var!=0 || b.c!=TBigInt(0))
  {
    c=a.miupgcd(b,p);
//cout<<"c=";c.display();cout<<endl;
    w=a.mdiv(c,p);
//cout<<"w=";w.display();cout<<endl;
    while(w.c!=TBigInt(1))
    {
      y=w.miupgcd(c,p);
//cout<<"y=";y.display();cout<<endl;
      z=w.mdiv(y,p);
//cout<<"z=";z.display();cout<<endl;
//===========================
  temp2=z;
  limit1=p/2;
  limit0=p;
  u=TRIPoly(TBigInt(0));
  pp1=temp2.IPlbt();
  ipp1 = toBigInt(pp1.IPlbcf());
  if(ipp1 > limit1)
  {
    ipp2=ipp1-limit0;
    pp2=TRIPoly(ipp1);
    u=u+TRIPoly(ipp2)*(pp1/pp2);
  }
  else
  {
    u=u+pp1;
  }
  while(temp2.var!=0 || temp2.c!=0)
  {
    temp2=temp2-pp1;
    if(temp2.var!=0 || temp2.c!=0)
    {
      pp1=temp2.IPlbt();
      ipp1 = toBigInt(pp1.IPlbcf());
      if(ipp1>limit1)
      {
        ipp2=ipp1-limit0;
        pp2=TRIPoly(ipp1);
        u=u+TRIPoly(ipp2)*(pp1/pp2);
      }
      else
      {
        u=u+pp1;
      }
    }
  }
//=========================

      if(u.c!=TBigInt(1))
      {
        l->append((TAtom*)(new TRIPoly(u)));
        l->append((TAtom*)(new TBigInt(i)));
//cout<<"l=";l->display();cout<<endl;
      }
      i=i+1;
      w=y;
      c=c.mdiv(y,p);
    }
//cout<<"c=";c.display();cout<<endl;
    if(c.c!=TBigInt(1))
    {
      temp=c.Degree(var);
      j=temp/(p.GetShort(0));
//cout<<"j=";j.display();cout<<endl;
      tmp2=c.Coefficient(var,0);
      tmp3=*tmp2;
      delete tmp2;
      if(tmp3.var!=0)
      {
         cout<<"there is erroe about variable;"<<endl;
         return l; 
      }
      tmp4=(tmp3^temp1).mod(p); 
//cout<<"tmp4=";tmp4->display();cout<<endl;
      tmp1=(*tmp4);
      delete tmp4;
      for(k=1;k<=j;k++)
      {
        tmp2=c.Coefficient(var,k*(p.GetShort(0)));
        tmp3=*tmp2;
        delete tmp2;
        if(tmp3.var!=0)
        {
          cout<<"there is erroe about variable;"<<endl;
          return l;
        }
        tmp4=(tmp3^temp1).mod(p);
//cout<<"tmp4=";tmp4->display();cout<<endl;
        tmp1=tmp1+(*tmp4)*TRIPoly(var,k);
        delete tmp4;
      }
      c=tmp1;
//cout<<"c=";c.display();cout<<endl;
      if(c.c!=TBigInt(1))
      {
        l->append((TAtom*) (c.FFiupSF(p,m)));
        l->append((TAtom*)(new TBigInt(p)));
      }
    }        
  }
  else 
  {
    temp=a.Degree(var);
    j=temp/(p.GetShort(0));
    tmp2=a.Coefficient(var,0);
    tmp3=*tmp2;
    delete tmp2;
    if(tmp3.var!=0)
    {
       cout<<"there is erroe about variable;"<<endl;
       return l;
    }
    tmp4=(tmp3^temp1).mod(p);
    tmp1=(*tmp4);
//cout<<"tmp1=";tmp1.display();cout<<endl;
    delete tmp4;
    for(k=1;k<=j;k++)
    {
      tmp2=a.Coefficient(var,k*(p.GetShort(0)));
      tmp3=*tmp2;
      delete tmp2;
      if(tmp3.var!=0)
      {
        cout<<"there is erroe about variable;"<<endl;
        return l;
      }
      tmp4=(tmp3^temp1).mod(p);
      tmp1=tmp1+(*tmp4)*TRIPoly(var,k);
//cout<<"tmp1=";tmp1.display();cout<<endl;
      delete tmp4;
    }
    a=tmp1;
//cout<<"a=";a.display();cout<<endl;
    if(a.c!=TBigInt(1))
    {
      l->append((TAtom*) (a.FFiupSF(p,m)));
      l->append((TAtom*)(new TBigInt(p)));
    }
  }
  return l;   
} 


//    monic polynomial is required.====================


TList * TRIPoly::FormMatrixQ(TBigInt p,TBigInt m)
{
  TList * ll;
  TBigInt r,n,d1,d2,*pp3,q;
  short n0,rr,k,l,s,n1;
  TRIPoly *pp1,pp2,*pp4,pp5,tmp;
  tmp=TRIPoly(invm((this->IPlbcf()),p));
  tmp=tmp*(*this);
  pp1=tmp.mod(p);
  pp2=*pp1;
  delete pp1;
  n=pp2.deg();
  r=n;
  n0=n.GetShort(0);
  rr=n0*n0;
//  TBigInt *temp[n0];
//  TBigInt *temp0[n0];
//  TBigInt *tt[rr];
  TBigIntPt *temp = new TBigIntPt[n0];
  TBigIntPt *temp0 = new TBigIntPt[n0];
  TBigIntPt *tt = new TBigIntPt[rr];

  pp3=new TBigInt(1);
  tt[0]=pp3;
  temp[0]=pp3;
  for(k=1;k<n;k++)
  {
    pp3=new TBigInt(0);
    tt[k]=pp3;
    temp[k]=pp3;
//cout<<k<<"=";tt[k]->display();cout<<endl;
  }  
  s=(n0-1)*(p.GetShort(0))*(m.GetShort(0));
  for(l=1;l<=s;l++)
  {
    pp4=pp2.Coefficient(pp2.var,0);
    pp5=*pp4;
    delete pp4;
    temp0[0]=new TBigInt(imod(-(*temp[n0-1])*toBigInt(pp5.c),p));
    for(k=1;k<n0;k++)    
    {
      pp4=pp2.Coefficient(pp2.var,k);
      pp5=*pp4;
      delete pp4;
      temp0[k]=new TBigInt(imod((*temp[k-1])-(*temp[n0-1]) * toBigInt(pp5.c),p));
//temp0[k]->display();cout<<",";
    }
//cout<<endl;
    q=p*m;
    d1=imod(TBigInt(l),q);
    if(d1!=TBigInt(1))
    {
      for(k=0;k<n0;k++)
      {
        delete temp[k];
      }
    }
    for(k=0;k<n0;k++)
    {
      temp[k]=temp0[k];
    }
//    for(k=0;k<n0;k++)
//    {
//      delete temp0[k];
//    }
    d1=TBigInt(l)/q;
    if(d1*m*p==TBigInt(l))
    {
      n1=(d1.GetShort(0))*n0;
      for(k=n1;k<n1+n0;k++)
      {
        tt[k]=temp[(k%n0)];
//cout<<k<<"=";tt[k]->display();cout<<endl;
      }
    }
  } 
//  for(k=0;k<n0;k++)
//  {
//    delete temp[k];
//  }
//  for(k=0;k<rr;k++)
//  {
//tt[k]->display();cout<<","; 
//  }
//cout<<endl;
//cout<<"rr="<<r<<endl;
  NullSpaceBasis((tt),p,m,r); 
////  for(k=0;k<rr;k++)
////  {
////tt[k]->display();cout<<",";
////  }
////cout<<endl;
  ll=pp2.IupFactor(tt,p,m);
//cout<<"end of the UPFACTOR"<<endl;
  delete[] temp;
  delete[] temp0;
  delete[] tt;
  return ll;
}


TBigInt TRIPoly::NullSpaceBasis(TBigInt **tt,TBigInt p,TBigInt m,TBigInt r)
{
  short n,k,i,j,j0,l;
  TBigInt *temp1,*temp2,inv,*temp5;
  n=r.GetShort(0);
//cout<<"n="<<n<<endl;
  for(l=0;l<n;l++)
  {
    temp1=tt[l*n+l];
//cout<<"temp1=";temp1->display();cout<<endl;
    tt[l*n+l]=new TBigInt(imod((*temp1)-TBigInt(1),p));
    delete temp1;
  }
//for(j=0;j<n*n;j++)
//{
//tt[j]->display();cout<<",";
//}
//cout<<endl;
  for(k=1;k<=n;k++)
  {
    i=k;
//cout<<"k="<<k<<endl;
//    for(j=k;j<=n;j++)
//    {
    while(i<=n && (*tt[(k-1)*n+i-1])==TBigInt(0))
        i=i+1;
//    }
//cout<<"i="<<i<<endl;
    if(i<=n)
    {
      inv=invm((*tt[(k-1)*n+i-1]),p);
      for(j=0;j<n*n;j++)
      {
        if(imod(TBigInt(j),TBigInt(n))==TBigInt(i-1))
        {
          temp1=tt[j];
          tt[j]=new TBigInt(imod(inv*(*temp1),p));
          delete temp1;
        }
      }
//for(j=0;j<n*n;j++)
//{
//tt[j]->display();cout<<",";
//}
//cout<<endl;
//cout<<"No1. OK"<<endl;
      if(k!=i)
      {
//cout<<"k="<<k<<";"<<"i="<<i<<endl;
        for(j=0;j<n*n;j++)
        {
//cout<<"j="<<j<<endl;
          if(imod(TBigInt(j),TBigInt(n))==TBigInt(k-1))
          {  
             temp5=new TBigInt(tt[j]->Clone());
             j0=j;
             delete tt[j];
//cout<<"dd";tt[30]->display();cout<<"dd";
          }
          if(imod(TBigInt(j),TBigInt(n))==TBigInt(i-1))
          {
//cout<<"j0="<<j0<<endl;
            tt[j0]=new TBigInt(tt[j]->Clone());
            delete tt[j];
//cout<<"ff";tt[30]->display();cout<<"ff";
            tt[j]=temp5;
            temp5=0;
//cout<<"tt";tt[30]->display();cout<<"tt";
          }
        }
      }
//for(j=0;j<n*n;j++)
//{
//tt[j]->display();cout<<",";
//}
//cout<<endl;
//cout<<"No2. OK"<<endl;
      for(l=1;l<=n;l++)
      {
        if(l<k)
        {
          inv=(*tt[(k-1)*n+l-1]);
/*          for(j=(k-1)*n;j<n*n;j++)
          {
            if(imod(TBigInt(j),TBigInt(n))==TBigInt(l-1))
            {
               j0=j;
               temp2=tt[j];
            }
            if(imod(TBigInt(j),TBigInt(n))==TBigInt(k-1))
            {
              temp1=tt[j];
              tt[j0]=new TBigInt(imod((*temp2)-(*temp1)*inv,p));
              delete temp2;
              temp1=0;
            }
          }*/
          for(j=(n*n)-1;j>=(k-1)*n;j--)
          {
            if(imod(TBigInt(j),TBigInt(n))==TBigInt(k-1))
            {
               temp2=tt[j];
            }
            if(imod(TBigInt(j),TBigInt(n))==TBigInt(l-1))
            {
              temp1=tt[j];
              tt[j]=new TBigInt(imod((*tt[j])-(*temp2)*inv,p));
              delete temp1;
              temp2=0;
            }
          }
        }
        if(l>k)
        {
//cout<<"go into the a;sldkfjaskdlf"<<endl;
          inv=(*tt[(k-1)*n+l-1]);
          for(j=(k-1)*n;j<n*n;j++)
          {
            if(imod(TBigInt(j),TBigInt(n))==TBigInt(k-1))
            {
              temp2=tt[j];
            }
            if(imod(TBigInt(j),TBigInt(n))==TBigInt(l-1))
            {
              temp1=tt[j];
//cout<<"inv=";inv.display();cout<<endl;
//cout<<"temp2";temp2->display();cout<<endl;
//cout<<"tt[j]";tt[j]->display();cout<<endl;
              tt[j]=new TBigInt(imod((*tt[j])-(*temp2)*inv,p));
              delete temp1;
              temp2=0;
            }
          }
        }
      }
//for(j=0;j<n*n;j++)
//{
//  tt[j]->display();cout<<",,";
//}
//cout<<endl;
    }
  }
  for(l=0;l<n*n;l++)
  {
    temp1=tt[l];
//cout<<"temp1=";temp1->display();cout<<",";
//cout<<endl;
    if((l%n)==(TBigInt(l)/TBigInt(n)).GetShort(0))
      tt[l]=new TBigInt(imod(TBigInt(1)-(*tt[l]),p));
    else
      tt[l]=new TBigInt(imod(TBigInt(0)-(*tt[l]),p));
    delete temp1;
  }  
//cout<<endl;
//for(j=0;j<n*n;j++)
//{
//tt[j]->display();cout<<",";
//}
//cout<<endl;
  return TBigInt(1);
}


TList *TRIPoly::IupFactor(TBigInt **tt,TBigInt p,TBigInt m)
{
  TList *ll=new TList();
  TBigInt n=this->deg(),h;
  short n0=n.GetShort(0);
//cout<<"n0="<<n0<<endl;
  short rr=n0*n0;
  short i,j,k,l,jj,kk,ii,hh,iii,kkk1,kkk2;
  TRIPoly temp,*temp1,temp2, temp4, temp5,temp6,temp7,temp8,*temp9,*temp10;
  TRIPoly *temp11;
  j=0;
  for(i=0;i<n0;i++)
  {
    k=0;
    for(l=0;l<n0;l++)
    {
      if((*tt[i*n0+l])!=TBigInt(0))
        k=1;
    }
    if(k==1)   
      j=j+1;
  }
//cout<<"j="<<j<<endl;

//  TRIPoly *pp[j];

    TRIPolyPt *pp = new TRIPolyPt[j];

  k=0;
  for(i=0;i<n0;i++)
  {
    temp=TRIPoly(TBigInt(0));
    for(l=0;l<n0;l++)
    {
     temp=temp+TRIPoly(*tt[i*n0+l])*TRIPoly(var,abs(l));
    }
    if(temp.var!=0 || temp.c!=TBigInt(0))
    {
      pp[k]=new TRIPoly(temp);
//cout<<"k="<<k<<endl;
//cout<<"pp[k]=";pp[k]->display();cout<<endl;
      k=k+1;
    }        
  }
  for(k=0;k<rr;k++)
  {
    delete tt[k];
  }  
  if(j==1)
  {
    delete pp[0]; 
    ll->append((TAtom*)(new TRIPoly(*this)));  
    delete []pp;
	return ll;
  }
//TRIPoly *pp1[j];
//TRIPoly *pp2[j];
  TRIPolyPt *pp1 = new TRIPolyPt[j];
  TRIPolyPt *pp2 = new TRIPolyPt[j];
  i=1;
  k=0;
  l=0;
  ii=0;
  pp1[0]=new TRIPoly(*this);
  temp11=pp1[0];
  while(ii<j)
  {
    for(jj=0;jj<=l;jj++)
    {
      for(i=1;i<j;i++)
      {  
      temp1=pp1[jj];
//cout<<"jj="<<jj<<"  "<<"temp1=";temp1->display();cout<<endl;
      for(h=TBigInt(0);h<p*m;h++)
      {
        temp4=(*(pp[i]));
        temp4=temp4+TRIPoly(TBigInt(h)); 
//cout<<"temp4=";temp4.display();cout<<endl;
        temp2=temp1->miupgcd(temp4,p);
//cout<<"temp2=";temp2.display();cout<<endl;
        temp5=(*temp1);
        temp6=temp5.mdiv(temp2,p);
//cout<<"temp6=";temp6.display();cout<<endl;
        if(temp2.c!=TBigInt(1))
        if(temp6.c!=TBigInt(1))
        {
          if(ii>0)
          {
            iii=ii;
            kkk1=0;
            for(hh=0;hh<iii;hh++)
            {
//cout<<"pp2[ii]=";pp2[hh]->display();cout<<endl;
               temp7=pp2[hh]->mdiv(temp2,p);
               if((temp7.var)!=0)
               {
               temp8=temp7*temp2-(*pp2[hh]);
               temp10=temp8.mod(p);
               temp8=*temp10;
               delete temp10;
               if((temp8.var)==0 && (temp8.c)==TBigInt(0))
               {
                  temp9=pp2[hh];
                  if(kkk1==0)
                    {pp2[hh]=new TRIPoly(temp2);kkk1=1;}
                  delete temp9;
                  pp2[ii]=new TRIPoly(temp7);ii=ii+1;
//cout<<"ii="<<ii<<endl;
//cout<<"pp2[ii]=";pp2[ii-1]->display();cout<<endl;
               }
               }
               if(ii==j)
               {
                 for(kk=0;kk<j;kk++)
                 {
                   ll->append((TAtom*)(new TRIPoly(*pp2[kk])));
                   delete pp[kk];delete pp2[kk];
                 }
                 delete temp11;
				 delete []pp;
				 delete []pp1;
				 delete []pp2;
                 return ll;
               }
            }
            kkk2=0;
            for(hh=0;hh<iii;hh++)
            {
//cout<<"pp2[ii]=";pp2[hh]->display();cout<<endl;
               temp7=pp2[hh]->mdiv(temp6,p);
               if((temp7.var)!=0)
               {
               temp8=temp7*temp6-(*pp2[hh]);
               temp10=temp8.mod(p);
               temp8=*temp10;
               delete temp10;
               if((temp8.var)==0 && (temp8.c)==TBigInt(0))
               {
                  temp9=pp2[hh];
                  if(kkk2==0)
                    {pp2[hh]=new TRIPoly(temp6);kkk2=1;}
                  delete temp9;
                  pp2[ii]=new TRIPoly(temp7);ii=ii+1;
//cout<<"ii="<<ii<<endl;
//cout<<"pp2[ii]=";pp2[ii-1]->display();cout<<endl;
               }
               }
               if(ii==j)
               {
                 for(kk=0;kk<j;kk++)
                 {
                   ll->append((TAtom*)(new TRIPoly(*pp2[kk])));
                   delete pp[kk];delete pp2[kk];
                 }
                 delete temp11;
				 delete []pp;
				 delete []pp1;
				 delete []pp2;
                 return ll;
               }
            }
          }
          else
          {
            pp2[ii]=new TRIPoly(temp2);ii=ii+1;
//cout<<"pp2[ii]=";pp2[ii-1]->display();cout<<endl;
            pp2[ii]=new TRIPoly(temp6); ii=ii+1;
//cout<<"pp2[ii]=";pp2[ii-1]->display();cout<<endl;
          }
        }
        if(ii==j)
        {
          for(kk=0;kk<j;kk++)
          {
            ll->append((TAtom*)(new TRIPoly(*pp2[kk])));
            delete pp[kk];delete pp2[kk];
          } 
          delete temp11;
		  delete []pp;
     	  delete []pp1; 
		  delete []pp2;
          return ll;

        }
      }
    }              
    }
    if(ii>l+1)
    {
      l=ii-1;
      for(hh=0;hh<=l;hh++)
        {pp1[hh]=pp2[hh];}
    }
  }        
}


TRIPoly TRIPoly::UEEA(TRIPoly p,TBigInt b,TRIPoly *s_,TRIPoly *t_)
{
///  TList *ll=new TList();
  TRIPoly p1,p2,*pp1,*pp2;
  TBigInt e,f,cic;
  TRIPoly c,d,g,c1,c2,d1,d2;
  TRIPoly * q0,q,r,r1,r2,*rr,*rr1,*rr2,s,t;
  pp1=this->mod(b);
  p1=*pp1;
  pp2=p.mod(b);
  p2=*pp2;
//cout<<"p1=";p1.display();cout<<endl;
//cout<<"p2=";p2.display();cout<<endl;
  delete pp1;delete pp2;
  if(p1.var==0 && p2.var!=0)
  {
    cic=igcd(p1.icont(),p2.icont());
    e=imod((invm(p1.icont(),b)*cic),b);
    g=TRIPoly(cic);
    f=TBigInt(0);
    s=TRIPoly(e);
    t=TRIPoly(f);
    *s_=s;*t_=t;
///    ll->append((TAtom*)(new TRIPoly(cic)));
///    ll->append((TAtom*)(new TRIPoly(e)));
///    ll->append((TAtom*)(new TRIPoly(f))); 
///    return ll;
    return g;
  }
  if(p1.var!=0 && p2.var==0)
  {
    cic=igcd(p1.icont(),p2.icont());
    e=imod((invm(p2.icont(),b)*cic),b);
    f=TBigInt(0);
    g=TRIPoly(cic);
    s=TRIPoly(e);
    t=TRIPoly(f);
    *s_=s;*t_=t;
///    ll->append((TAtom*)(new TRIPoly(cic)));
///    ll->append((TAtom*)(new TRIPoly(e)));
///    ll->append((TAtom*)(new TRIPoly(f)));
///    return ll;
    return g;
  }
//==========             please pay attention to ============
  else if(p1.var!=p2.var)
  {
    cout<<"Maybe have some problems!"<<endl;
///    return ll;
    return g;
  }
  e=p1.icont();
  f=p2.icont();
  c=p1/e;
  d=p2/f;
  c1=TRIPoly(TBigInt(1));c2=TRIPoly(TBigInt(0));
  d1=TRIPoly(TBigInt(0));d2=TRIPoly(TBigInt(1));
//cout<<"c=";c.display();cout<<endl;
//cout<<"d=";d.display();cout<<endl;
  while(d.var!=0 || d.c!=0)
  {
    q0=c.mprem(d,var,b);
    q=*q0;
    q=(c-q).mdiv(d,b);
//cout<<"q1=";q.display();cout<<endl;
//cout<<"q*d=";(q*d).display();cout<<endl;
//cout<<"c-qd=";(c-q*d).display();cout<<endl;
    rr=(c-q*d).mod(b);r=*rr;
    rr1=(c1-q*d1).mod(b);r1=*rr1;
    rr2=(c2-q*d2).mod(b);r2=*rr2;
    c=d;c1=d1;c2=d2;
    d=r;d1=r1;d2=r2;
//cout<<"d=";d.display();cout<<endl;
//    d=d.iuppp();
//cout<<"c=";c.display();cout<<endl;
//cout<<"d=";d.display();cout<<endl;
    delete q0;delete rr;delete rr1;delete rr2;
  }
  cic=c.icont();
  g=c/cic;
//cout<<"[in UEEA]g=";g.display();cout<<endl;
  s=c1.mdiv(e*(c.icont()),b);
  t=c2.mdiv(f*(c.icont()),b);
//cout<<"[in UEEA]s=";s.display();cout<<endl;
//cout<<"[in UEEA]t=";t.display();cout<<endl;
  while(g.deg()==0 && g.var!=0) {
        TRIPoly *temp=g.Coefficient(g.var,0);
        g=*temp;
        delete temp;
        }
  while(s.deg()==0 && s.var!=0) {
        TRIPoly *temp=s.Coefficient(s.var,0);
        s=*temp;
        delete temp;
        }
  while(t.deg()==0 && t.var!=0) {
        TRIPoly *temp=t.Coefficient(t.var,0);
        t=*temp;
        delete temp;
        }
///  ll->append((TAtom*)(new TRIPoly(g)));
///  ll->append((TAtom*)(new TRIPoly(s)));
///  ll->append((TAtom*)(new TRIPoly(t)));
///  return ll;
//cout<<"[in UEEA]s=";s.display();cout<<endl;
//cout<<"[in UEEA]t=";t.display();cout<<endl;
  *s_=s;*t_=t;
  return g;
}
TRIPoly TRIPoly::dm(TBigInt m)
{
  TRIPoly temp,u,pp1,pp2;
  TBigInt ipp1,limit1,ipp2;
  limit1=m/TBigInt(2);
  temp=*this;
  u=TRIPoly(TBigInt(0));
  pp1=temp.IPlbt();
  ipp1 = toBigInt(pp1.IPlbcf());
  if(ipp1>limit1)
  {
    ipp2=ipp1-m;
    pp2=TRIPoly(ipp1);
    u=u+TRIPoly(ipp2)*(pp1/pp2);
  }
  else
  {
    u=u+pp1;
  }
  while(temp.var!=0 || temp.c!=0)
  {
    temp=temp-pp1;
    if(temp.var!=0 || temp.c!=0)
    {
      pp1=temp.IPlbt();
      ipp1 = toBigInt(pp1.IPlbcf());
      if(ipp1>limit1)
      {
        ipp2=ipp1-m;
        pp2=TRIPoly(ipp1);
        u=u+TRIPoly(ipp2)*(pp1/pp2);
      }
      else
      {
        u=u+pp1;
      }
    }
  }
//cout<<"pay attention";
//cout<<endl;
//if(((this->var)->compare(this->minv()))<0)
//cout<<"good";cout<<endl;
  return u;
} 


TList * TRIPoly::UHLA(TRIPoly p1,TRIPoly p2,TBigInt it)
{
  TList * ll=new TList();
  TBigInt alpha,galma,modu,M,moit;
  TRIPoly temp,q,r,p0,*p3,*p4,w,u,e,z1,z2,zz1,zz2,s,t,c;
if(p1.var==0 || p2.var==0)
{
  return ll;
}
  p0=*this;
  alpha = toBigInt(p0.IPlbcf());
  galma=alpha;
  p0=TRIPoly(alpha)*p0;
//cout<<"p0=";p0.display();cout<<endl;
  p3=(p1*TRIPoly(invm((p1.IPlbcf()),it))*TRIPoly(alpha)).mod(it);
  p1=p3->dm(it);
  delete p3;
  p3=(p2*TRIPoly(invm((p2.IPlbcf()),it))*TRIPoly(alpha)).mod(it);
  p2=p3->dm(it);
  delete p3;
//cout<<"p1=";p1.display();cout<<endl;
//cout<<"p2=";p2.display();cout<<endl;
  p1.UEEA(p2,it,&s,&t);
//cout<<"s=";s.display();cout<<endl;
//cout<<"t=";t.display();cout<<endl;
  u=p1-p1.IPlbt()+TRIPoly(p1.var,p1.deg())*galma;
  w=p2-p2.IPlbt()+TRIPoly(p2.var,p2.deg())*galma; 
//cout<<"u=";u.display();cout<<endl;
//cout<<"w=";w.display();cout<<endl;
  e=p0-u*w;
//cout<<"e=";e.display();cout<<endl;
  modu=it;
  M=(TBigInt(2)^(p0.deg()+1))*toBigInt(p0.maxcoef());
//cout<<"M=";M.display();cout<<endl;
  while((!(e.var==0 && e.c==0)) && modu<M)
  {
    c=e/modu;
    p3=(s*c).mod(it);
    z1=p3->dm(it);delete p3;
    p4=(t*c).mod(it);
    z2=p4->dm(it);delete p4;
//cout<<"z1=";z1.display();cout<<endl;
//cout<<"z2=";z2.display();cout<<endl;
///    p3=(z1.mprem(p2,var,it));
///    r=*p3;
///cout<<"r=";r.display();cout<<endl;
///    delete p3;
///    q=(z1-r).mdiv(p2,it);
///cout<<"q=";q.display();cout<<endl;
    q=(z1.mdiv(p2,it)).dm(it);
//cout<<"q=";q.display();cout<<endl;
    p4=(z1-q*p2).mod(it);
    r=*p4;delete p4;
    zz1=r.dm(it);
    p3=(z2+q*p1).mod(it);
    zz2=p3->dm(it);delete p3;
//cout<<"zz1=";zz1.display();cout<<endl;
//cout<<"zz2=";zz2.display();cout<<endl;
    u=u+zz2*TRIPoly(modu);
    w=w+zz1*TRIPoly(modu);
//cout<<"u=";u.display();cout<<endl;
//cout<<"w=";w.display();cout<<endl;
    moit=modu*it;
//////////////////////////////////////////////////
    p3=u.mod(moit);
    u=*p3;delete p3;
////////////////////////////
    p3=(u*TRIPoly(invm((u.IPlbcf()),moit))*TRIPoly(alpha)).mod(moit);
    u=p3->dm(moit);delete p3;
/////////////////////////////////////////////////
    p4=w.mod(moit);
    w=*p4;delete p4;
/////////////////////////
    p4=(w*TRIPoly(invm((w.IPlbcf()),moit))*TRIPoly(alpha)).mod(moit);
    w=p4->dm(moit);delete p4;
//cout<<"u=";u.display();cout<<endl;
//cout<<"w=";w.display();cout<<endl;
    e=p0-u*w;
//cout<<"e=";e.display();cout<<endl;
    modu=modu*it;
  }
  if(e.var==0 && e.c==0)
  {
    zz1=TRIPoly(u.icont());
    u=u/zz1;
    temp=TRIPoly(galma)/zz1;
    w=w/temp;
//cout<<"u=";u.display();cout<<endl;
//cout<<"w=";w.display();cout<<endl;
    ll->append((TAtom*)(new TRIPoly(u)));
    ll->append((TAtom*)(new TRIPoly(w)));
    return ll;
  }    
  else
  {
//    cout<<"no such factorization exists"<<endl;
    return ll;
  }
}

//====  Multvariate Hensel Lifting Algorithm   ================

TList * TRIPoly::VLDegree(TList *I)
{
  TRIPoly A=*this;
  TRIPoly ptmp1,*ptmp2;
  TList *il=new TList();
  TList *ltmp=new TList();
  TList *ltmp2;
  TBigInt btmp,btmp1;
  unsigned short i;
  int i0,i1,itmp1,itmp2;
//cout<<"Go into VLDegree"<<endl;
//cout<<"A=";A.display();cout<<endl;
//cout<<"I=";I->display();cout<<endl;
  if((I->length())==1)
  {
    il->append((TAtom *) (new TBigInt(A.Degree((TVariable *)(I->Part(1))))));
    delete ltmp;
//cout<<"[[[[1]]]]]il=";il->display();cout<<endl;
    return il;
  }    
  else
  {
//cout<<"else========"<<endl;
    itmp2=I->length();
    btmp=TBigInt(0);
    for(i0=1;i0<=itmp2;i0++)
    {
      il->append((TAtom*)(new TBigInt(0)));
    }
//cout<<"**il=";il->display();cout<<endl;
//cout<<"a;skdfja;sdkf=";(A.Degree(((TVariable *)(I->Part(1))))).display();
//cout<<endl;
    itmp1=(A.Degree((TVariable *)(I->Part(1))));
    for(i1=2;i1<=itmp2;i1++)
    {
      ltmp->append(I->Part(i1));
    }
//cout<<"**ltmp=";ltmp->display();cout<<endl;
//cout<<"cycle number="<<itmp1<<endl;
    for(i=0;i<=itmp1;i++)
    {
      btmp1=TBigInt(i);
      ptmp2=A.Coefficient(((TVariable *)(I->Part(1))),i);
      ptmp1=*ptmp2;
      delete ptmp2;
//cout<<"ptmp1=";ptmp1.display();cout<<endl;
      ltmp2=ptmp1.VLDegree(ltmp);
//cout<<"ltmp2=";ltmp2->display();cout<<endl;
      for(i1=1;i1<itmp2;i1++)
      {
        btmp1=btmp1+(*((TBigInt *)(ltmp2->Part(i1))));
      }
//cout<<"btmp1=";btmp1.display();cout<<endl;
      if(btmp1>btmp)
      {
        ltmp2->dinsert((TAtom*)(new TBigInt(i)),1);
        delete il;
        il=ltmp2;
//      following line is modified;
        btmp=btmp1;
      } 
      else
      {
        delete ltmp2;
      }
    }
    delete ltmp;
//cout<<"il==";il->display();cout<<endl;
//cout<<"out VLDegree"<<endl;
    return il;
  }
}



TRIPoly TRIPoly::PmodIk(TList *I,TBigInt k)
{
TList *vl=new TList();
TList * bl;
TVariable *v;
TRIPoly A=(* this),*ptmp1,ptmp2,ptmp3,*ptmp4,ptmp5,ptmp6,ptmp7,ptmp8,ptmp9,ptmp10;
TBigInt itmp,btmp1,btmp2; 
unsigned short j;
int i0,i1,i,j0,l=I->length();
//cout<<"A=";A.display();cout<<endl;
for(i=1;i<=l;i++)
{
  v=((TRIPoly *)(I->Part(i)))->MainVar();
  vl->append((TAtom *) v);
}
//cout<<"Variable List:";vl->display();cout<<endl;
// Maybe have some problems;
for(i=1;i<=l;i++)
{
  itmp=A.Degree((TVariable *)(vl->Part(i)));
  j=itmp.GetShort(0);
//  if(j>=k)
while(j>=(k.GetShort(0)))
  {
    ptmp1=A.Coefficient((TVariable *)(vl->Part(i)),j);
    A=A-(*ptmp1)*TRIPoly((TVariable *)(vl->Part(i)),j);
    ptmp2=*ptmp1;
    delete ptmp1;
    j0=j;
/*========================================================================
    ptmp3=(TRIPoly((TVariable *)(vl->Part(i)),TBigInt(k))-
            ((*((TRIPoly *)(I->Part(i))))^k))*TRIPoly((TVariable *)(vl->Part(i)),TBigInt(j0-k));
//cout<<"ptmp3=";ptmp3.display();cout<<endl;
    j0=(ptmp3.Degree((TVariable *)(vl->Part(i)))).GetShort(0);
    while(j0>=k)
    {
      ptmp3=ptmp3.PmodIk(I,k);
      j0=(ptmp3.Degree((TVariable *)(vl->Part(i)))).GetShort(0);
    }
=======================================================================*/
    ptmp9=TRIPoly((TVariable *)(vl->Part(i)),j);
    ptmp10=((*((TRIPoly *)(I->Part(i))))^(k.GetShort(0)));
    ptmp3=ptmp9-(ptmp9/ptmp10)*ptmp10;
//cout<<"ptmp3=";ptmp3.display();cout<<endl;
//========================================================================
    A=A+ptmp2*ptmp3;
itmp=A.Degree((TVariable *)(vl->Part(i)));
j=itmp.GetShort(0);
//cout<<"A=";A.display();cout<<endl;
  }
}
//cout<<"A=";A.display();cout<<endl;
bl=(A.VLDegree(vl));
//cout<<"bl===";bl->display();cout<<endl;
itmp=TBigInt(0);
for(i=1;i<=l;i++)
{
  itmp=itmp+(*((TBigInt *)(bl->Part(i))));
}
if(itmp>=k)
{
//cout<<"go into multi-variable++++ "<<endl;
  btmp1=(*((TBigInt *)(bl->Part(1))));
  i0=1;
  while(btmp1<k)
  {
    i0=i0+1;
    btmp1=btmp1+(*((TBigInt *)(bl->Part(i0))));
  }
//cout<<"btmp1=";btmp1.display();cout<<"**endl**";
//cout<<"i0="<<i0<<"**endl**";
  //12345678wuyw
  if(btmp1>=k)
  {
    btmp2=(*((TBigInt *)(bl->Part(i0))))-btmp1+k;
//    btmp2=btmp1-k;
  }
//cout<<"btmp2=";btmp2.display();cout<<endl;
  ptmp5=A;
  ptmp7=TRIPoly(TBigInt(1));
  ptmp6=TRIPoly(TBigInt(1));
  for(i1=1;i1<i0;i1++)
  {
    ptmp4=ptmp5.Coefficient((TVariable *)(vl->Part(i1)),(*((TBigInt *)(bl->Part(i1)))).GetShort(0));
    ptmp5=*ptmp4;
    delete ptmp4;
    if((*((TBigInt *)(bl->Part(i1))))!=0)
    {
      ptmp6=ptmp6*((*((TRIPoly *)(I->Part(i1))))^((*((TBigInt *)(bl->Part(i1)))).GetShort(0)));
    }
    ptmp7=ptmp7*TRIPoly((TVariable *)(vl->Part(i1)),(*((TBigInt *)(bl->Part(i1)))).GetShort(0));
  }
//cout<<"ptmp5=";ptmp5.display();cout<<"++++";
//cout<<"ptmp6=";ptmp6.display();cout<<"++++";
//cout<<"ptmp7=";ptmp7.display();cout<<"++++";
//cout<<endl;
  ptmp4=ptmp5.Coefficient((TVariable *)(vl->Part(i0)),(*((TBigInt *)(bl->Part(i0)))).GetShort(0));
  ptmp5=*ptmp4;
  delete ptmp4;
  ptmp6=ptmp6*((*((TRIPoly *)(I->Part(i0))))^(btmp2.GetShort(0)));
  ptmp7=ptmp7*TRIPoly((TVariable *)(vl->Part(i0)),btmp2.GetShort(0)); 
//cout<<"ptmp5=";ptmp5.display();cout<<"++++";
//cout<<"ptmp6=";ptmp6.display();cout<<"++++";
//cout<<"ptmp7=";ptmp7.display();cout<<"++++";
//cout<<endl;
  ptmp8=TRIPoly((TVariable *)(vl->Part(i0)),((*((TBigInt *)(bl->Part(i0))))-btmp2).GetShort(0));
  for(i=(i0+1);i<=l;i++)
  {
ptmp4=ptmp5.Coefficient((TVariable *)(vl->Part(i)),(*((TBigInt *)(bl->Part(i)))).GetShort(0));
ptmp5=*ptmp4;
delete ptmp4;
    ptmp8=ptmp8*TRIPoly((TVariable *)(vl->Part(i)),(*((TBigInt *)(bl->Part(i)))).GetShort(0));
  }
//cout<<"ptmp5=";ptmp5.display();cout<<"++++";
//cout<<"ptmp8=";ptmp8.display();cout<<"++++";
//cout<<endl;
  A=A-ptmp8*ptmp5*ptmp7+ptmp5*(ptmp7-ptmp6)*ptmp8;;
//A=A+ptmp6*ptmp5*ptmp8-ptmp8*ptmp7*ptmp5;
//cout<<"A====";A.display();cout<<endl;
  delete bl;
  bl=(A.VLDegree(vl));
//cout<<"bl==";bl->display();cout<<endl;
  itmp=TBigInt(0);
  for(i=1;i<=l;i++)
  {
    itmp=itmp+(*((TBigInt *)(bl->Part(i))));
  }
  while(itmp>=k)
  {
    A=A.PmodIk(I,k);
    delete bl;
    bl=(A.VLDegree(vl));
    itmp=TBigInt(0);
    for(i=1;i<=l;i++)
    {
      itmp=itmp+(*((TBigInt *)(bl->Part(i))));
    }
  } 
}
delete bl;
delete vl;
return A;
}

TList * TRIPoly::EEApl(TRIPoly B,TRIPoly C,TBigInt p,TBigInt l)
{
//cout<<"Go into EEApl"<<endl;
  TRIPoly A=*this,A1,B1;
  TList * pl=new TList();
  TRIPoly s,t;
  TList *pltmp1,*pltmp2,*pltmp3;
  TRIPoly *ptmp1,ptmp2,ptmp3,*ptmp4,*ptmp5,ptmp6,ptmp7;
  TBigInt btmp,btmp1;
  TVariable * v=C.MainVar();
  int itmp,i;
  if(v==0 &&  l==TBigInt(1))
  {
//cout<<"go into step 1"<<endl;
    ptmp4=A.mod(p);ptmp5=B.mod(p);
    A1=ptmp4->dm(p);B1=ptmp5->dm(p);
//cout<<"A=";A1.display();cout<<endl;
//cout<<"B=";B1.display();cout<<endl;
    delete ptmp4;delete ptmp5;
    A1.UEEA(B1,p,&s,&t);
//cout<<"s===";s.display();cout<<"++++t=";t.display();cout<<endl;
    ptmp1=C.mod(p);
    ptmp2=*ptmp1;
    delete ptmp1;
    s=s*ptmp2;
    t=t*ptmp2;
    pl->append((TAtom *)(new TRIPoly(s)));
    pl->append((TAtom *)(new TRIPoly(t)));
//cout<<"pl1";pl->display();cout<<endl;
//    return pl;
  }
  if(v!=0 &&  l==TBigInt(1))
  {
//cout<<"go into step 2"<<endl;
    pltmp1=A.EEApl(B,TRIPoly(TBigInt(1)),p,l);
//cout<<"pltmp1=";pltmp1->display();cout<<endl;
    ptmp2=C*(*((TRIPoly *)(pltmp1->Part(1))));
    ptmp3=C*(*((TRIPoly *)(pltmp1->Part(2))));
//cout<<"ptmp2=";ptmp2.display();cout<<endl;
//cout<<"ptmp3=";ptmp3.display();cout<<endl;
//    ptmp4=ptmp2.mprem(B,v,p);ptmp5=ptmp3.mprem(A,v,p);
//    ptmp2=*ptmp4;ptmp3=*ptmp5;
    ptmp2=ptmp2-(ptmp2.mdiv(B,p))*B;
    ptmp3=ptmp3-(ptmp3.mdiv(A,p))*A;
    ptmp4=ptmp2.mod(p);ptmp5=ptmp3.mod(p);
    ptmp2=*ptmp4;ptmp3=*ptmp5;
    delete ptmp4;delete ptmp5;
    pl->append((TAtom *)(new TRIPoly(ptmp2)));
    pl->append((TAtom *)(new TRIPoly(ptmp3)));
    delete pltmp1;
//cout<<"pl2";pl->display();cout<<endl;
  }
  if(v==0 &&  l!=TBigInt(1)) 
  {
//cout<<"go into step 3"<<endl;
    btmp=p^l;
    ptmp1=C.mod(btmp);
    ptmp2=*ptmp1;
    delete ptmp1;
    itmp=l.GetShort(0);
    pltmp1=A.EEApl(B,TRIPoly(TBigInt(1)),p,TBigInt(1));
//cout<<"pltmp1";pltmp1->display();cout<<endl;
    for(i=1;i<itmp;i++)
    {
      btmp1=TBigInt(i);
      btmp1=p^btmp1;
      ptmp3=TRIPoly(TBigInt(1))-(*((TRIPoly *)(pltmp1->Part(1))))*A-
                    (*((TRIPoly *)(pltmp1->Part(2))))*B;
      ptmp3=ptmp3/(btmp1);
      ptmp4=ptmp3.mod(p);
      ptmp3=*ptmp4;delete ptmp4;
//cout<<"ptmp3=";ptmp3.display();cout<<endl;
//      delete pltmp1;
      pltmp2=A.EEApl(B,ptmp3,p,TBigInt(1));
//cout<<"pltmp2";pltmp2->display();cout<<endl;
      ptmp6=(*((TRIPoly *)(pltmp1->Part(1))))+
            (*((TRIPoly *)(pltmp2->Part(1))))*btmp1;
      ptmp7=(*((TRIPoly *)(pltmp1->Part(2))))+
            (*((TRIPoly *)(pltmp2->Part(2))))*btmp1;
      delete pltmp1;delete pltmp2;
      pltmp3=new TList();
      pltmp3->append((TAtom *)(new TRIPoly(ptmp6)));
      pltmp3->append((TAtom *)(new TRIPoly(ptmp7)));
//cout<<"pltmp3";pltmp3->display();cout<<endl;
      pltmp1=pltmp3;
//      delete pltmp3;
      
//    return pl;
    }
    ptmp4=((*((TRIPoly *)(pltmp1->Part(1))))*ptmp2).mod(btmp);
    ptmp5=((*((TRIPoly *)(pltmp1->Part(2))))*ptmp2).mod(btmp);
    ptmp6=*ptmp4;ptmp7=*ptmp5;
    delete ptmp4;delete ptmp5;
    delete pltmp1;
    pl->append((TAtom *)(new TRIPoly(ptmp6)));
    pl->append((TAtom *)(new TRIPoly(ptmp7)));
//cout<<"pl3";pl->display();cout<<endl;
  }
  if(v!=0 &&  l!=TBigInt(1))
  {
//cout<<"go into step 4"<<endl;
    btmp=p^l;
    pltmp1=A.EEApl(B,TRIPoly(TBigInt(1)),p,l);
    ptmp2=C*(*((TRIPoly *)(pltmp1->Part(1))));
    ptmp3=C*(*((TRIPoly *)(pltmp1->Part(2))));   
    delete pltmp1;
//    ptmp4=ptmp2.mprem(B,v,btmp);ptmp6=*ptmp4;delete ptmp4;
    ptmp6=ptmp2-(ptmp2.mdiv(B,btmp))*B;
    ptmp7=(C-ptmp6*A).mdiv(B,btmp);
//    ptmp7=(ptmp2.mdiv(B,btmp))*A*B;
//    ptmp6=ptmp2-(ptmp2.mdiv(B,p))*B;
//    ptmp7=ptmp3-(ptmp3.mdiv(A,p))*A;

    ptmp4=ptmp6.mod(btmp);
    ptmp5=ptmp7.mod(btmp);
    ptmp6=*ptmp4;ptmp7=*ptmp5;delete ptmp4;delete ptmp5;
    pl->append((TAtom *)(new TRIPoly(ptmp6)));
    pl->append((TAtom *)(new TRIPoly(ptmp7)));
//cout<<"pl4";pl->display();cout<<endl;
  } 
//cout<<"pl";pl->display();cout<<endl;
  btmp=p^l;
       ptmp7=A*(*((TRIPoly *)(pl->Part(1))))+B*(*((TRIPoly *)(pl->Part(2))));
       ptmp5=ptmp7.mod(btmp);
       ptmp7=*ptmp5; delete ptmp5;
///////cout<<"Result:";       ptmp7.display(); cout<<endl;
  return pl;
}  

//   Use polynomial structure;
TList * TRIPoly::getVL1()
{
//cout<<"go into getVL"<<endl;
  TRIPoly p=(*this);
  TDITerm * temp;
  TList * pl=new TList();
  TList * vltmp1,*pl1;;
  int itmp=p.IPunt(),i,j,i0;
  if((p.MainVar())==0)
  {
    return pl;
  }
  else
  {
    if(itmp==1)
    {
      pl->append((TAtom *)(p.MainVar()));
      return pl;
    }
    else
    {
      pl->append((TAtom *)(p.MainVar()));
      temp=p.ups;
      while(temp!=0)
      {
        vltmp1=(temp->p)->getVL(); 
cout<<"EEvltmp1=";vltmp1->display();cout<<endl;
        for(i=1;i<=(vltmp1->length());i++)
        {
cout<<"Epl=";pl->display();cout<<endl;
          for(j=1;j<pl->length();j++)
          {
//cout<<"go into cycle"<<endl;
            if((vltmp1->Part(i))->compare(pl->Part(j))>0 &&
               (vltmp1->Part(i))->compare(pl->Part(j+1))<0)
            {
              pl1=new TList();
              for(i0=1;i0<=j;i0++)
                pl1->append((TAtom *)(TVariable *)(pl->Part(i0)));
              pl1->append((TAtom *)(TVariable *)(vltmp1->Part(i)));
              for(i0=j+1;i0<=pl->length();i0++)
                pl1->append((TAtom *)(TVariable *)(pl->Part(i0)));
              delete pl;
              pl=pl1;
            }
          }
          if((vltmp1->Part(i))->compare(pl->Part(pl->length()))>0) 
          {
            pl->append((TAtom *)(TVariable *)(vltmp1->Part(i)));
          }
cout<<"EEpl=";pl->display();cout<<endl;
        }
        temp=temp->nx;
        delete vltmp1;
      }
      return pl;
    }
  }
}
TList * TRIPoly::getVL()
{
//cout<<"go into getVL"<<endl;
  TRIPoly p=(*this);
  TDITerm * temp;
  TList * pl=new TList();
  TList * vltmp1;
  int itmp=p.IPunt(),i,j,bo;
  if((p.MainVar())==0)
  {
    return pl;
  }
  else
  {
    if(itmp==1)
    {
      pl->append((TAtom *)(p.MainVar()));
      return pl;
    }
    else
    {
      pl->append((TAtom *)(p.MainVar()));
      temp=p.ups;
      while(temp!=0)
      {
        vltmp1=(temp->p)->getVL();
//cout<<"EEvltmp1=";vltmp1->display();cout<<endl;
        for(i=1;i<=(vltmp1->length());i++)
        {
//cout<<"Epl=";pl->display();cout<<endl;
          bo=1;
          for(j=1;j<=pl->length();j++)
          {
//cout<<"go into cycle"<<endl;
            if((vltmp1->Part(i))->compare(pl->Part(j))==0) 
            {
              bo=0; 
            }
          }
          if(bo==1)
          {
            pl->append((TAtom *)(TVariable *)(vltmp1->Part(i)));
          }
        }
        temp=temp->nx;
        delete vltmp1;
      }
      return pl;
    }
  }
}
TList * TRIPoly::getVL2()
{
  TList * pl,*bltmp=new TList(),*pl1=new TList();
  TBigInt btmp1,btmp2;
  int i,itmp1;
  pl=this->getVL();
  if(pl->length()==0)
  {  delete bltmp;delete pl1;  return pl;}
  bltmp->append((TAtom *)(new TBigInt(this->deg())));
  if(pl->length()==1)
  {  delete pl1;delete pl;return bltmp;} 
  for(i=2;i<=pl->length();i++)
    bltmp->append((TAtom *)(new TBigInt(this->Degree((TVariable *)(pl->Part(i))))));
  itmp1=1;
  btmp1=*((TBigInt *)(bltmp->Part(1)));
  for(i=2;i<=pl->length();i++)
  {
    btmp2=*((TBigInt *)(bltmp->Part(i)));
    if(btmp2<btmp1)
    {  btmp1=btmp2;itmp1=i; }
  }
  pl1->append((TAtom *)(TVariable *)(pl->Part(itmp1)));
  for(i=1;i<=pl->length();i++)
  {
    if(i != itmp1)
      pl1->append((TAtom *)(TVariable *)(pl->Part(i))); 
  }
  delete pl;delete bltmp;
  return pl1;
}

TVariable * TRIPoly::MinDeg()
{
  TList *l=this->getVL();
  int i,j;
  TVariable * v;
  if(l->length()==0)
    return NULL;
  v=(TVariable *)(l->Part(1));
  j=l->length();
  for(i=2;i<=j; i++)
  {  
    if(this->Degree((TVariable *)(l->Part(i)))<this->Degree(v))
      v=(TVariable *)(l->Part(i));
  }
  delete l;
  return v;
}

TList * TRIPoly::getI()
{
  TList * vl,*pl=new TList(),*pl1=new TList(),*pltmp,*ltmp1,*pltmp1;
  TRIPoly ptmp0=*this,ptmp1,ptmp2,ptmp,ptmp3,ptmp4,ptmp5,*ptmp6,ptmp7,ptmp8;
  int jj,i,bo,ii;
  TBigInt btmp1,btmp2;
  vl=this->getVL();
//cout<<"vl";vl->display();cout<<endl;
//////////  ptmp6=ptmp0.ifirst->icoef;
ptmp6=ptmp0.ups->p;
ptmp7=*ptmp6;
//  ptmp1=ptmp0.IPlbt();
  ptmp1=ptmp0.IPlbt();//////////*ptmp6;
//cout<<"ptmp1=";ptmp1.display();cout<<endl;
  for(i=2;i<=vl->length();i++)
  {
    if(ptmp1.Degree((TVariable *)(vl->Part(i)))!=0)
    {
      ptmp2=TRIPoly((TVariable *)(vl->Part(i)),1)-TRIPoly(TBigInt(1));
      pl->append((TAtom *)(new TRIPoly(ptmp2)));
    }
    else
    {
      ptmp2=TRIPoly((TVariable *)(vl->Part(i)),1);
      pl->append((TAtom *)(new TRIPoly(ptmp2)));
    }
  }
ptmp8=ptmp7.PmodIk(pl,TBigInt(1));
//ptmp8.display();cout<<endl;
ii=2;
while(ptmp8.c==0)
{
//cout<<"Pay more attention"<<endl;
  delete pl;
  pl=new TList();
  for(i=2;i<=vl->length();i++)
  {
    if(ptmp1.Degree((TVariable *)(vl->Part(i)))!=TBigInt(0))
    {
      ptmp2=TRIPoly((TVariable *)(vl->Part(i)),1)-TRIPoly(TBigInt(ii));
      pl->append((TAtom *)(new TRIPoly(ptmp2)));
    }
    else
    {
      ptmp2=TRIPoly((TVariable *)(vl->Part(i)),1);
      pl->append((TAtom *)(new TRIPoly(ptmp2)));
    }
  }
  ptmp8=ptmp7.PmodIk(pl,TBigInt(1));
  ii=ii+1;
  if(ii>=6 && ptmp8.c==0)
  {
    jj=ii/6;
    delete pl;
    pl=new TList();
    for(i=2;i<=vl->length();i++)
    {
      if(ptmp1.Degree((TVariable *)(vl->Part(i)))!=TBigInt(0))
      {
        ptmp2=TRIPoly((TVariable *)(vl->Part(i)),1)-TRIPoly(TBigInt(jj+i-2));
        pl->append((TAtom *)(new TRIPoly(ptmp2)));
      }
      else
      {
        ptmp2=TRIPoly((TVariable *)(vl->Part(i)),1);
        pl->append((TAtom *)(new TRIPoly(ptmp2)));
      }
    }
  }
  ptmp8=ptmp7.PmodIk(pl,TBigInt(1));
}
//cout<<"pl=";pl->display();cout<<endl;
  ptmp=ptmp0.PmodIk(pl,TBigInt(1));
//cout<<"ptmp=";ptmp.display();cout<<endl;
  ltmp1=ptmp.SqureFree();
//cout<<"ltmp1=";ltmp1->display();cout<<endl;
  btmp1=TBigInt(1);
  if(((TRIPoly *)(ltmp1->Part(1)))->var == 0 && ((TRIPoly *)(ltmp1->Part(3)))->var !=0 )
  {
    ptmp3=(*((TRIPoly *)(ltmp1->Part(1))))*(*((TRIPoly *)(ltmp1->Part(3))));
  }
  else
  {
    ptmp3=(*((TRIPoly *)(ltmp1->Part(1))));
  }
  ptmp3=ptmp3-ptmp;
//cout<<"ptmp3=";ptmp3.display();cout<<endl;
  delete ltmp1;
//=================================================
//Pay attention:  polynomial must be primitive;
//        and this question may be produced by
//        SquareFree();
//=================================================
  for(i=1;i<=pl->length();i++)
  {
    ptmp2=*((TRIPoly *)(pl->Part(i)));
    pl1->append((TAtom *)(new TRIPoly(ptmp2)));
  }
//////////////////////////////////////////////////
ptmp1=ptmp7.PmodIk(pl,TBigInt(1));
  while((ptmp3.var) != 0 || ptmp1.c==0)
  {
//cout<<"go into while"<<endl;
     bo=0;
     pltmp=new TList();
     btmp1=imod(btmp1,TBigInt(pl->length()));
     if(btmp1==TBigInt(0))
     {
       btmp1=TBigInt(pl->length());
     }
     for(i=1;i<=pl->length();i++)
     {
// following line is modified;
       ptmp4=(*((TRIPoly *)(pl1->Part(i))));
       ptmp5=TRIPoly(((TVariable *)(vl->Part(i+1))),1);
       ptmp4=ptmp4-ptmp5;
//cout<<"ptmp4=";ptmp4.display();cout<<endl;
       if(TBigInt(i)==btmp1)
       {
//         if(ptmp4.c!=0  || (pl->length())==1)
//////         if(ptmp4.c==0)
         if(ptmp4.c==0 || (pl->length())==1)
         {
         ptmp2=(*((TRIPoly *)(pl->Part(i))))-TBigInt(1);
         pltmp->append((TAtom *)(new TRIPoly(ptmp2)));
         bo=1;
         }
         else
         {
         ptmp2=*((TRIPoly *)(pl->Part(i)));
         pltmp->append((TAtom *)(new TRIPoly(ptmp2)));
         }
       }
       else
       {
         ptmp2=*((TRIPoly *)(pl->Part(i)));
         pltmp->append((TAtom *)(new TRIPoly(ptmp2)));
       }
     }
     delete pl;pl=pltmp;
     if(bo==0)
     {
       pltmp1=new TList();
       ptmp2=(*((TRIPoly *)(pl->Part(1))))-TBigInt(1);
       pltmp1->append((TAtom *)(new TRIPoly(ptmp2)));
       for(i=2;i<=pl->length();i++)
       {
         ptmp2=*((TRIPoly *)(pl->Part(i)));
         pltmp1->append((TAtom *)(new TRIPoly(ptmp2)));
       }
       delete pl;pl=pltmp1;
     } 

//cout<<"pl=";pl->display();cout<<endl;
     ptmp=ptmp0.PmodIk(pl,TBigInt(1));
//cout<<"ptmp=";ptmp.display();cout<<endl;
if(ptmp.var==0 && ptmp.c==TBigInt(0))
{
  ptmp3=ptmp;
}
else
{
     ltmp1=ptmp.SqureFree();
//cout<<"ltmp1=";ltmp1->display();cout<<endl;
     btmp1=btmp1+TBigInt(1);
//     btmp2=(*((TBigInt *)(ltmp1->Part(2))));
//     ptmp3=(*((TBigInt *)(ltmp1->Part(1))));
     if(((TRIPoly *)(ltmp1->Part(1)))->var == 0 && ((TRIPoly *)(ltmp1->Part(3)))->var != 0)
    {
      ptmp3=(*((TRIPoly *)(ltmp1->Part(1))))*(*((TRIPoly *)(ltmp1->Part(3))));
    }
    else
    {
      ptmp3=(*((TRIPoly *)(ltmp1->Part(1))));
    }
    ptmp3=ptmp3-ptmp;
//cout<<"ptmp3=";ptmp3.display();cout<<endl;
    delete ltmp1;
}
ptmp1=ptmp7.PmodIk(pl,TBigInt(1));
  }
///////////////////////////////
  delete pl1;
//  delete ltmp1;

  delete vl;
//cout<<"out getI"<<endl;
  return pl;
}  
TBigInt TRIPoly::getB()
{
  TList *vl,*bltmp;
  TRIPoly ptmp=*this,ptmp1,ptmp2,ptmp4;
  TBigInt btmp,btmp1,btmp2,btmp3,btmp4;
  int i;
//cout<<"go into getB"<<endl;
  vl=ptmp.getVL();
//cout<<"vl=";vl->display();cout<<endl;
//  I=ptmp.getI();
  bltmp=ptmp.VLDegree(vl);
//cout<<"bltmp=";bltmp->display();cout<<endl;
  btmp=TBigInt(0);
  for(i=1;i<=bltmp->length();i++)
  {
    btmp1=(*((TBigInt *)(bltmp->Part(i))));
    btmp=btmp+btmp1;
  }
  btmp1=TBigInt(2);
  btmp1==btmp/btmp1;
  btmp2=TBigInt(1);btmp3=TBigInt(1);btmp4=TBigInt(1);
  for(i=1;i<=btmp1.GetShort(0);i++)
  {
    btmp2=btmp2*btmp;btmp=btmp-TBigInt(1);
    btmp3=btmp3*btmp4;btmp4=btmp4+TBigInt(1);
  }
  btmp1=btmp2/btmp3;
//cout<<"btmp1=";btmp1.display();cout<<endl;
  ptmp1=ptmp.IPlbt();
//cout<<"ptmp=";ptmp.display();cout<<endl;
  ptmp2=ptmp-ptmp1;
//cout<<"ptmp2=";ptmp2.display();cout<<endl;
  btmp4 = toBigInt(ptmp1.IPlbcf());
  btmp3=btmp4^2;
//           btmp3=abs(btmp4);
//cout<<"btmp3=";btmp3.display();cout<<endl;
  while(ptmp2.var!=0 || ptmp2.c !=0)
  {
    ptmp4=ptmp2.IPlbt();
    ptmp2=ptmp2-ptmp4;
//cout<<"ptmp2=";ptmp2.display();cout<<endl;
    btmp4 = toBigInt(ptmp4.IPlbcf());
//cout<<"btmp4=";btmp4.display();cout<<endl;
    btmp3=btmp3+(btmp4^2);
//        if((abs(btmp4))>btmp3) btmp3=abs(btmp4);
//cout<<"btmp3=";btmp3.display();cout<<endl;
  }
//cout<<"B=";(btmp1*sqrt(btmp3)).display();cout<<endl;
  delete bltmp;delete vl;
//delete I;
  return btmp1*sqrt(btmp3); 
//        return btmp1*btmp3;
}



TList * TRIPoly::MHLA(TList * pl)
{
  int primebit=1;
  TList * I,*ltmp1,*pltmp,*mvl,*vl=new TList(),*bltmp,*bltmp1;
  TList * aaltmp=new TList(),*bbltmp=new TList();
  TList * mltmp=new TList();
  TBigInt BB,p,l,btmp1,btmp,btmp2,btmp3,btmp4,jtmp,h,k,h1,itmp2,h0,h2;
  TRIPoly RB,A,B,ptmp,ptmp1,R,F,G,V,W;
  TRIPoly *ptmp2,*ptmp3,*ptmp4,ptmp5,ptmp6,ptmp7,ptmp8;
  int itmp,itmp1,i;
  if(((TRIPoly *)(pl->Part(1)))->deg()>=((TRIPoly *)(pl->Part(2)))->deg())
  {
    F=(*((TRIPoly *)(pl->Part(1))));
    G=(*((TRIPoly *)(pl->Part(2))));
  }
  else
  {
    F=(*((TRIPoly *)(pl->Part(2))));
    G=(*((TRIPoly *)(pl->Part(1))));
  }
  if(G.var==0)
  {
    delete vl;delete aaltmp;delete bbltmp;return mltmp;
  } 
//cout<<"go into MHLA"<<endl;
  BB=this->getB();
//cout<<"BB=";BB.display();cout<<endl;
  I=this->getI();
//cout<<"I=";I->display();cout<<endl;
  ptmp=*this;
  ptmp1=ptmp.PmodIk(I,TBigInt(1));
//cout<<"ptmp1=";ptmp1.display();cout<<endl;
  btmp1 = toBigInt(ptmp.IPlbcf());
  btmp4 = toBigInt(ptmp1.IPlbcf());
/*  ifstream in("/HOMEA/users/others/soft/public/lib/prime");
  if(!in)
  {
    cout<<"Can not open file: test "<<endl;
    return mltmp;
  }
  in>>itmp;
  in>>itmp;
*/
  primebit=primebit+1;
  btmp=TBigInt(primelist[primebit]);
  itmp=4;
//  if(imod(btmp1,btmp)!=TBigInt(0))
  if(imod(btmp4,btmp)!=TBigInt(0))
  {
/////////////////////////////////
  ptmp4=ptmp1.mod(btmp);
  ptmp5=*ptmp4;delete ptmp4;
  ptmp5=TRIPoly(invm((ptmp5.IPlbcf()),btmp))*ptmp5;
  ptmp4=ptmp5.mod(btmp);
  ptmp5=*ptmp4;delete ptmp4;
  ltmp1=ptmp5.FFiupSF(btmp,TBigInt(1));
///////////////////////////////////
//  ltmp1=ptmp1.FFiupSF(btmp,TBigInt(1));
//cout<<"ltmp1=";ltmp1->display();cout<<endl;
  itmp1=ltmp1->length();
  btmp3=*((TBigInt *)(ltmp1->Part(2)));
  if(btmp3>TBigInt(1))
      itmp1=4;
  delete ltmp1;
if(imod(ptmp1.IPlbcf(),btmp)==TBigInt(0))
    itmp1=4;
  }
//  while(imod(btmp1,btmp)==TBigInt(0) || itmp1!=2)
  while(imod(btmp4,btmp)==TBigInt(0) || itmp1!=2)
  {
/*    in>>itmp;
    btmp=TBigInt(itmp); 
//    while(imod(btmp1,btmp)==TBigInt(0))
    while(imod(btmp4,btmp)==TBigInt(0))
    {
      in>>itmp;
      btmp=TBigInt(itmp);
    }
*/
    primebit=primebit+1;
    btmp=TBigInt(primelist[primebit]);
    while(imod(btmp1,btmp)==TBigInt(0))
    {
      primebit=primebit+1;
      btmp=TBigInt(primelist[primebit]);
    }
/////////////////////////////////
  ptmp4=ptmp1.mod(btmp);
  ptmp5=*ptmp4;delete ptmp4;
  ptmp5=TRIPoly(invm((ptmp5.IPlbcf()),btmp))*ptmp5;
  ptmp4=ptmp5.mod(btmp);
  ptmp5=*ptmp4;delete ptmp4;
  ltmp1=ptmp5.FFiupSF(btmp,TBigInt(1));
///////////////////////////////////
//    ltmp1=ptmp1.FFiupSF(btmp,TBigInt(1));
//cout<<"ltmp1=";ltmp1->display();cout<<endl;
    itmp1=ltmp1->length();
    btmp3=*((TBigInt *)(ltmp1->Part(2)));
    if(btmp3>TBigInt(1))
      itmp1=4;
    delete ltmp1;
if(imod(ptmp1.IPlbcf(),btmp)==TBigInt(0))
    itmp1=4;
  }
//cout<<"btmp=";btmp.display();cout<<endl;
  jtmp=TBigInt(2);
  btmp2 = bnabs(toBigInt(ptmp.IPlbcf()))*TBigInt(2)*BB;
//cout<<"btmp2=";btmp2.display();cout<<endl;
  while((btmp^jtmp) <= btmp2)
  {
    jtmp=jtmp+TBigInt(2);
  }
//cout<<"jtmp=";jtmp.display();cout<<endl;
  ////////////////////////////////////////
  btmp2=btmp^jtmp;
//cout<<"btmp2=";btmp2.display();cout<<endl;
  itmp=ptmp.deg();
  V=ptmp;
//cout<<"F=";F.display();cout<<endl;
//cout<<"G=";G.display();cout<<endl;
  R=F*G-V;
//cout<<"R=";R.display();cout<<endl;
  W=R.PmodIk(I,TBigInt(2));
//cout<<"W=";W.display();cout<<endl;
  ptmp2=W.mod(btmp2);W=*ptmp2;delete ptmp2;
  W=W.dm(btmp2);
//cout<<"W=";W.display();cout<<endl;
  A=TRIPoly(TBigInt(0));B=TRIPoly(TBigInt(0));
  for(i=0;i<=itmp;i++)
  {
    pltmp=F.EEApl(G,TRIPoly(ptmp.MainVar(),i),btmp,jtmp);
//cout<<"pltmp=";pltmp->display();cout<<endl;
    ptmp2=W.Coefficient(ptmp.MainVar(),i);
    ptmp5=*ptmp2;delete ptmp2;
//    ptmp6=W-ptmp5*TRIPoly(ptmp.MainVar(),TBigInt(i));
    ptmp7=((TRIPoly *)(pltmp->Part(1)))->dm(btmp2);
    ptmp8=((TRIPoly *)(pltmp->Part(2)))->dm(btmp2);
    aaltmp->append((TAtom *)(new TRIPoly(ptmp7)));
    bbltmp->append((TAtom *)(new TRIPoly(ptmp8)));
//cout<<"alpha=";ptmp7.display();cout<<endl;
//cout<<"beta=";ptmp8.display();cout<<endl;
    A=A+ptmp5*ptmp7;
    ptmp3=A.mod(btmp2);
    A=ptmp3->dm(btmp2);
//cout<<"A=";A.display();cout<<endl;
    B=B+ptmp5*ptmp8;
    ptmp4=B.mod(btmp2);
    B=ptmp4->dm(btmp2);
//cout<<"B=";B.display();cout<<endl;
    delete ptmp3; delete ptmp4;
    delete pltmp;
  }
//cout<<"A*B=";((V-F*G).PmodIk(I,TBigInt(1))).display();cout<<endl;
R=R+A*B-A*F-B*G;ptmp4=R.mod(btmp2);R=*ptmp4;R=R.dm(btmp2);
  F=F-B;G=G-A;
  ptmp2=F.mod(btmp2);ptmp3=G.mod(btmp2);
  F=*ptmp2;G=*ptmp3;
  F=F.dm(btmp2);G=G.dm(btmp2);
//cout<<"F=";F.display();cout<<endl;
//cout<<"G=";G.display();cout<<endl;
//cout<<"R=";R.display();cout<<endl;
//cout<<"A*B=";((F*G-V).PmodIk(I,TBigInt(2))).display();cout<<endl;
//RB=ptmp-F*G;
  delete ptmp2;delete ptmp3;delete ptmp4;
  mvl=ptmp.getVL();
//cout<<"mvl=";mvl->display();cout<<endl;
  for(i=2;i<=(mvl->length());i++)
    vl->append((TVariable *)(mvl->Part(i)));
//cout<<"vl=";vl->display();cout<<endl;
  bltmp=ptmp.VLDegree(vl);
  bltmp1=(ptmp.IPlbt()).VLDegree(vl);
//cout<<"bltmp=";bltmp->display();cout<<endl;
  h=TBigInt(1);h0=TBigInt(1);
  for(i=1;i<=(bltmp->length());i++)
    h=h+(*((TBigInt *)(bltmp->Part(i))));
  for(i=1;i<=(bltmp1->length());i++)
    h0=h0+(*((TBigInt *)(bltmp1->Part(i))));
  delete mvl;delete bltmp;delete bltmp1;
//cout<<"h=";h.display();cout<<endl;
  itmp2=2;
  k=TBigInt(3);
//cout<<"RB.var=";RB.display();cout<<endl;
  while(k<=h && R.var!=0)
  {
//cout<<"go into while "<<endl;
    W=R.PmodIk(I,k);
    ptmp2=W.mod(btmp2);W=*ptmp2;delete ptmp2;
    W=W.dm(btmp2);
//cout<<"W=";W.display();cout<<endl;
    A=TRIPoly(TBigInt(0));B=TRIPoly(TBigInt(0));
    for(i=0;i<=itmp;i++)
    {
//      pltmp=F.EEApl(G,TRIPoly(ptmp.MainVar(),TBigInt(i)),btmp,jtmp);
      ptmp2=W.Coefficient(ptmp.MainVar(),i);
      ptmp5=*ptmp2;delete ptmp2;
//      ptmp6=W-ptmp5*TRIPoly(ptmp.MainVar(),TBigInt(i));
      ptmp7=((TRIPoly *)(aaltmp->Part(i+1)))->dm(btmp2);
      ptmp8=((TRIPoly *)(bbltmp->Part(i+1)))->dm(btmp2);
//cout<<"alpha=";ptmp7.display();cout<<endl;
//cout<<"beta=";ptmp8.display();cout<<endl;
      A=A+ptmp5*ptmp7;
      ptmp3=A.mod(btmp2);
      A=ptmp3->dm(btmp2);
      B=B+ptmp5*ptmp8;
      ptmp4=B.mod(btmp2);
      B=ptmp4->dm(btmp2);
      delete ptmp3; delete ptmp4;
//      delete pltmp;
    }
  R=R+A*B-A*F-B*G;ptmp4=R.mod(btmp2);R=*ptmp4;R=R.dm(btmp2);
    F=F-B;G=G-A;
    ptmp2=F.mod(btmp2);ptmp3=G.mod(btmp2);
    F=*ptmp2;G=*ptmp3;
    F=F.dm(btmp2);G=G.dm(btmp2);
    delete ptmp2;
////////    ptmp2=((F*G-V).PmodIk(I,k)).mod(btmp2);
//cout<<"A*B=";ptmp2->display();cout<<endl;
////////   delete ptmp2;
delete ptmp3;delete ptmp4;
//cout<<"F=";F.display();cout<<endl;
//cout<<"G=";G.display();cout<<endl;
//cout<<"R=";R.display();cout<<endl;
    bltmp=(F*G).VLDegree(vl);
    h1=TBigInt(1);
    for(i=1;i<=(bltmp->length());i++)
   h1=h1+(*((TBigInt *)(bltmp->Part(i))));
//cout<<"h1=";h1.display();cout<<endl;
    bltmp1=((F*G).IPlbt()).VLDegree(vl);
    h2=TBigInt(1);
    for(i=1;i<=(bltmp1->length());i++)
      h2=h2+(*((TBigInt *)(bltmp1->Part(i))));
    itmp2=k;
    delete bltmp;delete bltmp1;
    if(h1>h && h2>=h0) 
    {
//      k=h1;
      ptmp8=ptmp-F*G;
      if(ptmp8.var==0 && ptmp8.c==0)
      {
//cout<<"1111111"<<endl;
        mltmp->append((TAtom *) (new TRIPoly(F)));
        mltmp->append((TAtom *) (new TRIPoly(G)));
        delete I;delete vl;delete aaltmp;delete bbltmp;
//---------       in.close();
        return mltmp;
      }
      ptmp4=F.Coefficient(F.var,F.deg());
      ptmp5=*ptmp4;delete ptmp4;
      if(ptmp5.var!=0)
      {
//cout<<"41414141414414141"<<endl;
        ptmp6=ptmp5*G;
        ptmp4=ptmp6.mod(btmp2);
        ptmp6=*ptmp4;delete ptmp4;
        ptmp6=ptmp6.dm(btmp2);
        ptmp6=ptmp6.PmodIk(I,itmp2);
        ptmp4=ptmp6.mod(btmp2);
        ptmp6=ptmp4->dm(btmp2);delete ptmp4;
//cout<<"ptmp6=";ptmp6.display();cout<<endl;
        ptmp7=ptmp6.ppp();
//cout<<"eeeeeeeeeeeee"<<endl;
        ptmp7=ptmp7.ppp1();
//cout<<"qqqqqqqqqqqqq"<<endl;
        ptmp6=ptmp/ptmp7;
      }
      ptmp8=ptmp-ptmp6*ptmp7;
//cout<<"ptmp8=";ptmp8.display();cout<<endl;
      if(ptmp8.var==0 && ptmp8.c==0)
      {
//cout<<"444444444444444"<<endl;
        mltmp->append((TAtom *) (new TRIPoly(ptmp6)));
        mltmp->append((TAtom *) (new TRIPoly(ptmp7)));;
        delete I;delete vl;delete aaltmp;delete bbltmp;
//-----------        in.close();
        return mltmp;
      }
      if(h1>h+4)
      {
        delete vl;delete aaltmp;delete bbltmp;
//-----------        in.close();
        delete I;return mltmp;
      }
    }
    k=k+TBigInt(1);
//cout<<"k=";k.display();cout<<endl;
  }
  delete vl;
  delete aaltmp;delete bbltmp;
//---------  in.close();
/////////////////////////////////////////
  ptmp8=ptmp-F*G;
  if(ptmp8.var==0 && ptmp8.c==0)
  {
//cout<<"1111111"<<endl;
    mltmp->append((TAtom *) (new TRIPoly(F)));
    mltmp->append((TAtom *) (new TRIPoly(G)));
    delete I;return mltmp;
  }
//cout<<"555555555555555"<<endl;
  delete I;
  return mltmp;
}



TList * TRIPoly::MHLA1(TList * pl)
{
  TList * I,*ltmp1,*pltmp,*mvl,*vl=new TList(),*bltmp,*bltmp1;
  TList * aaltmp=new TList(),*bbltmp=new TList();
  TList * mltmp=new TList();
  TBigInt BB,p,l,btmp1,btmp,btmp2,btmp3,jtmp,h,k,h1,itmp2,h0,h2;
  TRIPoly RB,A,B,ptmp,ptmp1,R,F,G,V,W;
  TRIPoly *ptmp2,*ptmp3,*ptmp4,ptmp5,ptmp6,ptmp7,ptmp8;
  int itmp,itmp1,i;
  if(((TRIPoly *)(pl->Part(1)))->deg()>((TRIPoly *)(pl->Part(2)))->deg())
  {
    F=(*((TRIPoly *)(pl->Part(1))));
    G=(*((TRIPoly *)(pl->Part(2))));
  }
  else
  {
    F=(*((TRIPoly *)(pl->Part(2))));
    G=(*((TRIPoly *)(pl->Part(1))));
  }
  if(G.var==0)
  {
    delete vl;delete aaltmp;delete bbltmp;return mltmp;
  }
cout<<"go into MHLA"<<endl;
  BB=this->getB();
cout<<"BB=";BB.display();cout<<endl;
  I=this->getI();
cout<<"I=";I->display();cout<<endl;
  ptmp=*this;
  ptmp1=ptmp.PmodIk(I,TBigInt(1));
cout<<"ptmp1=";ptmp1.display();cout<<endl;
  btmp1 = toBigInt(ptmp.IPlbcf());
  ifstream in("/HOMEA/users/others/soft/public/lib/prime");
  if(!in)
  {
    cout<<"Can not open file: test "<<endl;
    return mltmp;
  }
  in>>itmp;
  in>>itmp;
  btmp=TBigInt(itmp);
  itmp=4;
  if(imod(btmp1,btmp)!=TBigInt(0))
  {
/////////////////////////////////
  ptmp4=ptmp1.mod(btmp);
  ptmp5=*ptmp4;delete ptmp4;
  ptmp5=TRIPoly(invm((ptmp5.IPlbcf()),btmp))*ptmp5;
  ptmp4=ptmp5.mod(btmp);
  ptmp5=*ptmp4;delete ptmp4;
  ltmp1=ptmp5.FFiupSF(btmp,TBigInt(1));
///////////////////////////////////
//  ltmp1=ptmp1.FFiupSF(btmp,TBigInt(1));
cout<<"ltmp1=";ltmp1->display();cout<<endl;
  itmp1=ltmp1->length();
  btmp3=*((TBigInt *)(ltmp1->Part(2)));
  if(btmp3>TBigInt(1))
      itmp1=4;
  delete ltmp1;
  if(imod(ptmp1.IPlbcf(),btmp)==TBigInt(0))
      itmp1=4;
  }
  while(imod(btmp1,btmp)==TBigInt(0) || itmp1!=2)
  {
    in>>itmp;
    btmp=TBigInt(itmp);
    while(imod(btmp1,btmp)==TBigInt(0))
    {
      in>>itmp;
      btmp=TBigInt(itmp);
    }
/////////////////////////////////
  ptmp4=ptmp1.mod(btmp);
  ptmp5=*ptmp4;delete ptmp4;
  ptmp5=TRIPoly(invm((ptmp5.IPlbcf()),btmp))*ptmp5;
  ptmp4=ptmp5.mod(btmp);
  ptmp5=*ptmp4;delete ptmp4;
  ltmp1=ptmp5.FFiupSF(btmp,TBigInt(1));
///////////////////////////////////
//    ltmp1=ptmp1.FFiupSF(btmp,TBigInt(1)); 
cout<<"ltmp1=";ltmp1->display();cout<<endl;
    itmp1=ltmp1->length();
    btmp3=*((TBigInt *)(ltmp1->Part(2)));
    if(btmp3>TBigInt(1))
      itmp1=4; 
    delete ltmp1;
    if(imod(ptmp1.IPlbcf(),btmp)==TBigInt(0))
      itmp1=4;
  }
cout<<"btmp=";btmp.display();cout<<endl;
  jtmp=TBigInt(2);
  btmp2=bnabs(toBigInt(ptmp.IPlbcf()))*TBigInt(2)*BB;
//cout<<"btmp2=";btmp2.display();cout<<endl;
  while((btmp^jtmp) <= btmp2)
  {
    jtmp=jtmp+TBigInt(2);
  }
//jtmp=TBigInt(4);
cout<<"jtmp=";jtmp.display();cout<<endl;
  //////////////////////////////////////// 
  btmp2=btmp^jtmp;
cout<<"btmp2=";btmp2.display();cout<<endl;
  itmp=ptmp.deg();
  V=ptmp;
cout<<"F=";F.display();cout<<endl;
cout<<"G=";G.display();cout<<endl;
  R=F*G-V;
cout<<"R=";R.display();cout<<endl;
  W=R.PmodIk(I,TBigInt(2));
cout<<"W=";W.display();cout<<endl;
  ptmp2=W.mod(btmp2);W=*ptmp2;delete ptmp2;
  W=W.dm(btmp2);
cout<<"W=";W.display();cout<<endl;
  A=TRIPoly(TBigInt(0));B=TRIPoly(TBigInt(0));
  for(i=0;i<=itmp;i++)
  {
    pltmp=F.EEApl(G,TRIPoly(ptmp.MainVar(),i),btmp,jtmp);
    ptmp2=W.Coefficient(ptmp.MainVar(),i);
    ptmp5=*ptmp2;delete ptmp2;
    ptmp7=((TRIPoly *)(pltmp->Part(1)))->dm(btmp2);
    ptmp8=((TRIPoly *)(pltmp->Part(2)))->dm(btmp2);
    aaltmp->append((TAtom *)(new TRIPoly(ptmp7)));
    bbltmp->append((TAtom *)(new TRIPoly(ptmp8)));
//cout<<"alpha=";ptmp7.display();cout<<endl;
//cout<<"beta=";ptmp8.display();cout<<endl;
    A=A+ptmp5*ptmp7;
    ptmp3=A.mod(btmp2);
    A=ptmp3->dm(btmp2);
//cout<<"A=";A.display();cout<<endl;
    B=B+ptmp5*ptmp8;
    ptmp4=B.mod(btmp2); 
    B=ptmp4->dm(btmp2);
//cout<<"B=";B.display();cout<<endl;
    delete ptmp3; delete ptmp4;
    delete pltmp;
  }
//cout<<"A*B=";((V-F*G).PmodIk(I,TBigInt(1))).display();cout<<endl;
R=R+A*B-A*F-B*G;ptmp4=R.mod(btmp2);R=*ptmp4;R=R.dm(btmp2);
  F=F-B;G=G-A;
//  btmp2=btmp^jtmp;
  ptmp2=F.mod(btmp2);ptmp3=G.mod(btmp2);
  F=*ptmp2;G=*ptmp3;
  F=F.dm(btmp2);G=G.dm(btmp2);
//  R=R+A*B-A*F-B*G;ptmp4=R.mod(btmp2);R=*ptmp4;R=R.dm(btmp2);
cout<<"F=";F.display();cout<<endl;
cout<<"G=";G.display();cout<<endl;
cout<<"R=";R.display();cout<<endl;
///////cout<<"A*B=";((F*G-V).PmodIk(I,TBigInt(2))).display();cout<<endl;
//RB=ptmp-F*G;
  delete ptmp2;delete ptmp3;delete ptmp4; 
  mvl=ptmp.getVL();
//cout<<"mvl=";mvl->display();cout<<endl;
  for(i=2;i<=(mvl->length());i++)
    vl->append((TVariable *)(mvl->Part(i)));
//cout<<"vl=";vl->display();cout<<endl;
  bltmp=ptmp.VLDegree(vl);
  bltmp1=(ptmp.IPlbt()).VLDegree(vl);
cout<<"bltmp=";bltmp->display();cout<<endl;
  h=TBigInt(1);h0=TBigInt(1);
  for(i=1;i<=(bltmp->length());i++)
    h=h+(*((TBigInt *)(bltmp->Part(i))));
  for(i=1;i<=(bltmp1->length());i++)
    h0=h0+(*((TBigInt *)(bltmp1->Part(i))));
//  delete vl;
  delete mvl;delete bltmp;delete bltmp1;
cout<<"h=";h.display();cout<<endl;
  itmp2=2;
  k=TBigInt(3);
//cout<<"RB.var=";RB.display();cout<<endl;
  while(k<=h && R.var!=0)
  {
cout<<"go into while "<<endl;
    W=R.PmodIk(I,k);
    ptmp2=W.mod(btmp2);W=*ptmp2;delete ptmp2;
    W=W.dm(btmp2);
cout<<"W=";W.display();cout<<endl;
    A=TRIPoly(TBigInt(0));B=TRIPoly(TBigInt(0));
    for(i=0;i<=itmp;i++)
    {
//      pltmp=F.EEApl(G,TRIPoly(ptmp.MainVar(),TBigInt(i)),btmp,jtmp);
      ptmp2=W.Coefficient(ptmp.MainVar(),i);
      ptmp5=*ptmp2;delete ptmp2;
//      ptmp6=W-ptmp5*TRIPoly(ptmp.MainVar(),TBigInt(i));
      ptmp7=((TRIPoly *)(aaltmp->Part(i+1)))->dm(btmp2);
      ptmp8=((TRIPoly *)(bbltmp->Part(i+1)))->dm(btmp2);
//cout<<"alpha=";ptmp7.display();cout<<endl;
//cout<<"beta=";ptmp8.display();cout<<endl;
      A=A+ptmp5*ptmp7;
      ptmp3=A.mod(btmp2);
      A=ptmp3->dm(btmp2);
      B=B+ptmp5*ptmp8;
      ptmp4=B.mod(btmp2);
      B=ptmp4->dm(btmp2);
      delete ptmp3; delete ptmp4;
//      delete pltmp;
    }
R=R+A*B-A*F-B*G;ptmp4=R.mod(btmp2);R=*ptmp4;R=R.dm(btmp2);
    F=F-B;G=G-A;
//    R=R+A*B-A*F-B*G;
    ptmp2=F.mod(btmp2);ptmp3=G.mod(btmp2);
//ptmp4=R.mod(btmp2);
    F=*ptmp2;G=*ptmp3;
//R=*ptmp4;
    F=F.dm(btmp2);G=G.dm(btmp2);
delete ptmp2;
//////ptmp2=((F*G-V).PmodIk(I,k)).mod(btmp2);
/////cout<<"A*B=";ptmp2->display();cout<<endl;
//R=R.dm(btmp2);
//    R=R+A*B-A*F-B*G;ptmp4=R.mod(btmp2);R=*ptmp4;R=R.dm(btmp2);
/////////    delete ptmp2;
delete ptmp3;delete ptmp4;
cout<<"F=";F.display();cout<<endl;
cout<<"G=";G.display();cout<<endl;
cout<<"R=";R.display();cout<<endl;
//ptmp2=(ptmp-F*G).mod(btmp2);
//RB=*ptmp2;delete ptmp2;
//cout<<"RB=";RB.display();cout<<endl;
bltmp=(F*G).VLDegree(vl);
h1=TBigInt(1);
for(i=1;i<=(bltmp->length());i++)
  h1=h1+(*((TBigInt *)(bltmp->Part(i))));
cout<<"h1=";h1.display();cout<<endl;
bltmp1=((F*G).IPlbt()).VLDegree(vl);
h2=TBigInt(1);
for(i=1;i<=(bltmp1->length());i++)
  h2=h2+(*((TBigInt *)(bltmp1->Part(i))));
  itmp2=k;
  delete bltmp;delete bltmp1;
  if(h1>h && h2>=h0) 
  {
//    k=h1;
    ptmp8=ptmp-F*G;
      if(ptmp8.var==0 && ptmp8.c==0)
      {
cout<<"1111111"<<endl;
        mltmp->append((TAtom *) (new TRIPoly(F)));
        mltmp->append((TAtom *) (new TRIPoly(G)));
        delete I;delete vl;delete aaltmp;delete bbltmp;in.close();return mltmp;
      }
      ptmp4=F.Coefficient(F.var,F.deg());
      ptmp5=*ptmp4;delete ptmp4;
      if(ptmp5.var!=0)
      {
cout<<"41414141414414141"<<endl;
        ptmp6=ptmp5*G;
        ptmp4=ptmp6.mod(btmp2);
        ptmp6=*ptmp4;delete ptmp4;
        ptmp6=ptmp6.dm(btmp2);
        ptmp6=ptmp6.PmodIk(I,itmp2);
        ptmp4=ptmp6.mod(btmp2);
        ptmp6=ptmp4->dm(btmp2);delete ptmp4;
        ptmp7=ptmp6.ppp();
        ptmp7=ptmp7.ppp1();
        ptmp6=ptmp/ptmp7;
      }
      ptmp8=ptmp-ptmp6*ptmp7;
cout<<"ptmp8=";ptmp8.display();cout<<endl;
      if(ptmp8.var==0 && ptmp8.c==0)
      {
cout<<"444444444444444"<<endl;
        mltmp->append((TAtom *) (new TRIPoly(ptmp6)));
        mltmp->append((TAtom *) (new TRIPoly(ptmp7)));;
        delete I;delete vl;delete aaltmp;delete bbltmp;in.close();return mltmp;
      }
      ptmp5=F.IPlbt();
      ptmp5=ptmp5.IPldcf();
      if(ptmp5.var!=0)
      {
cout<<"313131313"<<endl;
        ptmp6=ptmp5*G;
        ptmp4=ptmp6.mod(btmp2);
        ptmp6=*ptmp4;delete ptmp4;
        ptmp6=ptmp6.dm(btmp2);
        ptmp6=ptmp6.PmodIk(I,itmp2);
        ptmp4=ptmp6.mod(btmp2);
        ptmp6=ptmp4->dm(btmp2);delete ptmp4;
        ptmp7=ptmp6.ppp();
        ptmp6=ptmp/ptmp7;
      }
      ptmp8=ptmp-ptmp6*ptmp7;
      if(ptmp8.var==0 && ptmp8.c==0)
      {
cout<<"33333333333333"<<endl;
        mltmp->append((TAtom *) (new TRIPoly(ptmp6)));
        mltmp->append((TAtom *) (new TRIPoly(ptmp7)));;
        delete I;delete vl;delete aaltmp;delete bbltmp;in.close();return mltmp;
      }
      ptmp6=F.ppp();
cout<<"ptmp6=";ptmp6.display();cout<<endl;
      ptmp5=ptmp6-F;
      if(ptmp5.var!=0)
        ptmp7=ptmp/ptmp6;
      else
      {
        ptmp7=G.ppp();
        ptmp6=ptmp/ptmp7;
      }
      ptmp8=ptmp-ptmp6*ptmp7;
      if(ptmp8.var==0 && ptmp8.c==0)
      {
cout<<"22222222222"<<endl;
        mltmp->append((TAtom *) (new TRIPoly(ptmp6)));
        mltmp->append((TAtom *) (new TRIPoly(ptmp7)));;
        delete I;delete vl;delete aaltmp;delete bbltmp;in.close();return mltmp;
      } 
cout<<"555555555555555"<<endl;
cout<<"F=";F.display();cout<<endl;
cout<<"G=";G.display();cout<<endl;
cout<<"btmp2=";btmp2.display();cout<<endl;
      ptmp5=((F*G).IPlbt());//btmp3=ptmp5.IPlbcf();ptmp5=ptmp5/btmp3;
cout<<"ptmp5=";ptmp5.display();cout<<endl;
      ptmp4=ptmp5.mod(btmp2);ptmp5=ptmp4->dm(btmp2);delete ptmp4;
cout<<"ptmp5=";ptmp5.display();cout<<endl;
      ptmp6=ptmp.IPlbt();//btmp3=ptmp6.IPlbcf();ptmp6=ptmp6/btmp3;
cout<<"ptmp6=";ptmp6.display();cout<<endl;
      ptmp6=ptmp5-(ptmp5/ptmp6)*ptmp6;
cout<<"ptmp6=";ptmp6.display();cout<<endl;
      if(ptmp6.var!=0)
      {
        delete vl;delete aaltmp;delete bbltmp;in.close();delete I;return mltmp;
      }
/*  
     Following code have no any theory base to support it.
*/
//      if(h1>h+4)
//      {
//        delete I;delete vl;delete aaltmp;delete bbltmp;in.close();return mltmp;
//      }
    }  
    k=k+TBigInt(1);
cout<<"k=";k.display();cout<<endl;
  }
  delete vl;
  delete aaltmp;delete bbltmp;
  in.close();
/////////////////////////////////////////
  ptmp8=ptmp-F*G;
  if(ptmp8.var==0 && ptmp8.c==0)
  {
cout<<"1111111"<<endl;
    mltmp->append((TAtom *) (new TRIPoly(F)));
    mltmp->append((TAtom *) (new TRIPoly(G)));
    delete I;return mltmp;
  }
/*  ptmp5=F.IPlbt();
  ptmp5=ptmp5.IPldcf();
  if(ptmp5.var!=0)
  {
cout<<"313131313"<<endl;
cout<<"btmp2=";btmp2.display();cout<<endl;
    ptmp6=ptmp5*G;
cout<<"ptmp6=";ptmp6.display();cout<<endl;
    ptmp4=ptmp6.mod(btmp2);
    ptmp6=*ptmp4;delete ptmp4;
    ptmp6=ptmp6.dm(btmp2);
cout<<"ptmp6=";ptmp6.display();cout<<endl;
cout<<"itmp2="<<itmp2<<endl;
cout<<"I=";I->display();cout<<endl;
    ptmp6=ptmp6.PmodIk(I,TBigInt(itmp2));
cout<<"ptmp6=";ptmp6.display();cout<<endl;
    ptmp4=ptmp6.mod(btmp2);
cout<<"ptmp6=";ptmp6.display();cout<<endl;
    ptmp6=ptmp4->dm(btmp2);delete ptmp4;
cout<<"ptmp6=";ptmp6.display();cout<<endl;
    ptmp7=ptmp6.ppp();
    ptmp6=ptmp/ptmp7;
  }
  ptmp8=ptmp-ptmp6*ptmp7;
  if(ptmp8.var==0 && ptmp8.c==0 )
  {
cout<<"33333333333333"<<endl;
    mltmp->append((TAtom *) (new TRIPoly(ptmp6)));
    mltmp->append((TAtom *) (new TRIPoly(ptmp7)));;
    delete I;return mltmp;
  }
  ptmp4=F.Coefficient(F.var,F.deg());
  ptmp5=*ptmp4;delete ptmp4;
  if(ptmp5.var!=0)
  {
cout<<"41414141414414141"<<endl;
cout<<"btmp2=";btmp2.display();cout<<endl;
    ptmp6=ptmp5*G;
    ptmp4=ptmp6.mod(btmp2);
    ptmp6=*ptmp4;delete ptmp4;
    ptmp6=ptmp6.dm(btmp2);
cout<<"itmp2=";itmp2.display();cout<<endl;
    ptmp6=ptmp6.PmodIk(I,itmp2);
    ptmp4=ptmp6.mod(btmp2);
    ptmp6=ptmp4->dm(btmp2);delete ptmp4;
cout<<"ptmp6=";ptmp6.display();cout<<endl;
    ptmp7=ptmp6.ppp();
cout<<"ptmp7=";ptmp7.display();cout<<endl;
    ptmp7=ptmp7.ppp1();
cout<<"ptmp7=";ptmp7.display();cout<<endl;
    ptmp6=ptmp/ptmp7;
  }
  ptmp8=ptmp-ptmp6*ptmp7;
cout<<"ptmp8=";ptmp8.display();cout<<endl;
  if(ptmp8.var==0 && ptmp8.c==0)
  {
cout<<"444444444444444"<<endl;
    mltmp->append((TAtom *) (new TRIPoly(ptmp6)));
    mltmp->append((TAtom *) (new TRIPoly(ptmp7)));;
    delete I;return mltmp;
  }
  ptmp6=F.ppp();
cout<<"ptmp6=";ptmp6.display();cout<<endl;
  ptmp5=ptmp6-F;
  if(ptmp5.var!=0)
    ptmp7=ptmp/ptmp6;
  else
  {
    ptmp7=G.ppp();
    ptmp6=ptmp/ptmp7;
  }
  ptmp8=ptmp-ptmp6*ptmp7;
  if(ptmp8.var==0 && ptmp8.c==0)
  {
cout<<"22222222222"<<endl;
    mltmp->append((TAtom *) (new TRIPoly(ptmp6)));
    mltmp->append((TAtom *) (new TRIPoly(ptmp7)));;
    delete I;return mltmp;
  }
cout<<"555555555555555"<<endl;
*/
  delete I;
  return mltmp;
}

//using p.var=0 refer to p=0
TRIPoly TRIPoly::ppp()
{
  TRIPoly ptmp0,ptmp=*this,ptmp2,ptmp4;
//cout<<"IN PPP"<<endl;
  ptmp2=ptmp.IPlbt();
//cout<<"ptmp2=";ptmp2.display();cout<<endl;
  ptmp4=ptmp2;
  ptmp=ptmp-ptmp2;
  while(ptmp.var!=0 || ptmp.c!=0)
  {
    ptmp2=ptmp.IPlbt();
//cout<<"ldkadf;adf"<<endl;
    ptmp=ptmp-ptmp2;
//cout<<"ptmp4=";ptmp4.display();cout<<endl;
//cout<<"ptmp2=";ptmp2.display();cout<<endl;
    ptmp4=ptmp4.mipgcd(ptmp2);
//cout<<"ptmp4=";ptmp4.display();cout<<endl;
  }
  ptmp0=*this;
  ptmp0=ptmp0/ptmp4;
//cout<<"in PPPi====";ptmp0.display();cout<<endl;
  return ptmp0;
}





TRIPoly TRIPoly::ppp1()
{
  TRIPoly ptmp=*this,*ptmp1,ptmp2,ptmp3,ptmp4,ptmp5;
//cout<<"IN PPP"<<endl;
  TDITerm * term=ptmp.ups;
  ptmp1=term->p;
  ptmp2=*ptmp1;
//cout<<"ptmp2=";ptmp2.display();cout<<endl;
  term=term->nx;
  while(term != 0 && ptmp2.var!=0)
  {
    ptmp1=term->p;
    term=term->nx;
    ptmp3=*ptmp1;
//cout<<"ptmp3=";ptmp3.display();cout<<endl;
    ptmp4=ptmp2.mipgcd(ptmp3);
    ptmp5=ptmp2-(ptmp2/ptmp4)*ptmp4;
//cout<<"ptmp5=";ptmp5.display();cout<<endl;
    if(ptmp5.var!=0)
      ptmp2=ptmp2.mipgcd(ptmp3);
    else
      ptmp2=ptmp4;
//cout<<"ptmp2=";ptmp2.display();cout<<endl;
  }
  ptmp=ptmp/ptmp2;
//cout<<"in PPP1=";ptmp.display();cout<<endl;
  return ptmp;
}


TList * TRIPoly::MPfactor()
{
//cout<<"this=";this->display();cout<<endl;
  TList * pl=new TList(),*I,*pltmp1,*pltmp2,*pltmp3,*pltmp4,*pltmp5;
  TRIPoly ptmp=*this,*ptmp1,ptmp2,ptmp3,ptmp4,ptmp5,ptmp6,ptmp7,ptmp8,p1,p2;
  TDITerm * term=ptmp.ups;
  TBigInt btmp;
  TVariable * v;
  int i,j,jj,i0,i1,bo,bbo;
  if(ptmp.var==0)
  {
//cout<<"Const Polynomial=="; ptmp.display();cout<<endl;
    delete pl;
    return ptmp.Upfactor();
  }    
  if(ptmp.IPunt()==1)
  {
    delete pl;
    return ptmp.Upfactor();
  }
  if(ptmp.maindeg()>=TBigInt(1))
  {
    ptmp8=TRIPoly(ptmp.var,ptmp.maindeg());
    pl->append((TAtom *)(new TRIPoly(ptmp8)));
    ptmp=ptmp/ptmp8;
    pltmp1=ptmp.MPfactor();
    pltmp2=pl->Union(pltmp1);
    delete pl;delete pltmp1;
    return pltmp2;
  }

  ptmp1=term->p;
  ptmp2=*ptmp1;
//cout<<"ptmp2=";ptmp2.display();cout<<endl;
  term=term->nx;
  while(term != 0 && ptmp2.var!=0)
  {
    ptmp1=term->p;
    ptmp3=*ptmp1;
//cout<<"ptmp3=";ptmp3.display();cout<<endl;
    ptmp2=ptmp2.mipgcd(ptmp3);
//cout<<"ptmp2=";ptmp2.display();cout<<endl;
    term=term->nx;
  }
  if(ptmp2.var==0)
  {
    btmp=ptmp.icont();
    ptmp2=TRIPoly(btmp);
  }
//cout<<"ptmp=";ptmp.display();cout<<endl;
  ptmp=ptmp/ptmp2;
//=======================================*********************
if(ptmp.deg()==TBigInt(1))
{
  pl->append((TAtom *)(new TRIPoly(ptmp)));
  if(ptmp2.var!=0 || ptmp2.c!=TBigInt(1))
  {
    pltmp5=ptmp2.MPfactor();
    cout<<"pltmp5=";pltmp5->display();cout<<endl;
    pltmp2=pl->Union(pltmp5);
    delete pl;
    delete pltmp5;
    return pltmp2;
  }
  return pl;
}
  v=ptmp.MinDeg();
//cout<<"v=";  v->display(); cout<<endl;
//cout<<"degree="; (ptmp.Degree(v)).display();cout<<endl;
//Should added the situation "2";
//=======================================*********************
//cout<<"ptmp=";ptmp.display();cout<<endl;
//cout<<"ptmp2=";ptmp2.display();cout<<endl;
  I=ptmp.getI();
//cout<<"I=";I->display();cout<<endl;
  ptmp3=ptmp.PmodIk(I,TBigInt(1));
//cout<<"ptmp3=";ptmp3.display();cout<<endl;
  pltmp1=ptmp3.Upfactor();
//cout<<"pltmp1=";pltmp1->display();cout<<endl;
  if((pltmp1->length())==2)
  {
    delete pl; 
    pl=ptmp.MHLA(pltmp1);
//cout<<"pl=";pl->display();cout<<endl;
    if(pl->length()==0)
      pl->append((TAtom *)(new TRIPoly(ptmp)));
    if(ptmp2.c!=TBigInt(1))
    {
      pltmp5=ptmp2.MPfactor();
      for(i0=1;i0<=pltmp5->length();i0++)
      pl->append((TAtom *)(new TRIPoly((*((TRIPoly *)(pltmp5->Part(i0)))))));
      delete pltmp5;
    }
    delete I;delete pltmp1;
    return pl;
 }
  pltmp2=LChoice(pltmp1,pltmp1->length());
  ptmp4=*((TRIPoly *)pltmp2->Part(1)); 
//cout<<"ptmp4=";ptmp4.display();cout<<endl;
  delete pltmp2;
  i=1;
  jj=(pltmp1->length());
  j=(pltmp1->length())/2;
  ptmp6=ptmp;
  while(ptmp.var!=0 && i<=j)
  {
    pltmp2=this->LChoice(pltmp1,i);
//cout<<"pltmp2=";pltmp2->display();cout<<endl;
    for(i0=1;i0<=pltmp2->length();i0++)
    {
      p1=(*((TRIPoly*)pltmp2->Part(i0)));
      p2=ptmp4/p1;
//cout<<"p1=";p1.display();cout<<endl;
//cout<<"p2=";p2.display();cout<<endl;
      bbo=0;
      if(p1.deg()>=p2.deg())
        bbo=1;
      pltmp3=new TList();      
      pltmp3->append((TAtom *)(new TRIPoly(p1)));
      pltmp3->append((TAtom *)(new TRIPoly(p2)));
      pltmp4=ptmp6.MHLA(pltmp3); delete pltmp3;
//cout<<"2pltmp4=";pltmp4->display();cout<<endl;
      if(pltmp4->length()>1)
      {
        bo=0;
        for(i1=1;i1<=pl->length();i1++)
        {
          if(bbo==1)
            ptmp7=(*((TRIPoly *)pltmp4->Part(1)));
          else
            ptmp7=(*((TRIPoly *)pltmp4->Part(2)));
          ptmp8=(*((TRIPoly *)pl->Part(i1)));
//cout<<"ptmp7=";ptmp7.display();cout<<endl;
//cout<<"ptmp8=";ptmp8.display();cout<<endl;
          ptmp5=ptmp7/ptmp8;
          ptmp8=ptmp7-ptmp5*ptmp8;
//cout<<"ptmp5=";ptmp5.display();cout<<endl;
//cout<<"ptmp8=";ptmp8.display();cout<<endl;
          if(ptmp8.var==0 && ptmp8.c==0)
          {
            bo=1;
          }
        } 
        if(bo==0)
        {
          if(bbo==1)
          {
            pl->append((TAtom *)(new TRIPoly(*((TRIPoly *)pltmp4->Part(1)))));
            ptmp=ptmp/(*((TRIPoly *)pltmp4->Part(1)));
          }
          else
          {
            pl->append((TAtom *)(new TRIPoly(*((TRIPoly *)pltmp4->Part(2)))));
            ptmp=ptmp/(*((TRIPoly *)pltmp4->Part(2)));
          }
//cout<<"pl=";pl->display();cout<<endl;
//cout<<"ptmp=";ptmp.display();cout<<endl;
          if(ptmp.var==0)
          {
            delete pltmp2; delete pltmp4;
            delete pltmp1; delete I;
            if(ptmp2.c!=TBigInt(1))
            {
              pltmp5=ptmp2.MPfactor();
              for(i0=1;i0<=pltmp5->length();i0++)
                pl->append((TAtom *)(new TRIPoly((*((TRIPoly *)(pltmp5->Part(i0)))))));
              delete pltmp5;
            }
//cout<<"pl2=";pl->display();cout<<endl;
            return pl;
          }
          if(pl->length()==(jj-i))
          {
            pl->append((TAtom *)(new TRIPoly(ptmp)));
            delete pltmp2; delete pltmp4;
            delete pltmp1; delete I;
            if(ptmp2.c!=TBigInt(1))
            {
              pltmp5=ptmp2.MPfactor();
              for(i0=1;i0<=pltmp5->length();i0++)
                pl->append((TAtom *)(new TRIPoly((*((TRIPoly *)(pltmp5->Part(i0)))
)
)));
              delete pltmp5;
            }
//cout<<"pl1=";pl->display();cout<<endl;
            return pl;
          }
        }
      }  
      delete pltmp4;
    }
    delete pltmp2;
    i=i+1;
    if(pl->length()!=0 && jj>=4)
    {
//cout<<"MPFACTOR"<<endl;
      delete pltmp1;delete I;
      if(ptmp2.c!=TBigInt(1))
      {
        pltmp5=ptmp2.MPfactor();
        for(i0=1;i0<=pltmp5->length();i0++)
          pl->append((TAtom *)(new TRIPoly((*((TRIPoly *)(pltmp5->Part(i0)))))));
        delete pltmp5;
      }
      pltmp2=ptmp.MPfactor();
      pltmp4=pltmp2->Union(pl);
      delete pl;delete pltmp2;
      pl=pltmp4;
      return pl;
    }

//cout<<"outwhile"<<endl;
  }
  if(pl->length()==0)
    pl->append((TAtom *)(new TRIPoly(ptmp6)));
  if(ptmp2.c!=TBigInt(1))
  {
    pltmp5=ptmp2.MPfactor();
    for(i0=1;i0<=pltmp5->length();i0++)
      pl->append((TAtom *)(new TRIPoly((*((TRIPoly *)(pltmp5->Part(i0))))))); 
    delete pltmp5;
  }
//cout<<"pl=";pl->display();cout<<endl;
  delete pltmp1;
  delete I;
  return pl;
}

TList * TRIPoly::LChoice(TList * pl,int n)
{
  TList * pl1=new TList(),*pltmp,*pltmp2;
  TRIPoly ptmp;
  int i,len=pl->length(),i0,i1;
//cout<<"go into LChoice"<<endl;
  if(n==1)
  {
    for(i=1;i<=pl->length();i++)  
      pl1->append((TAtom *) (new TRIPoly((*((TRIPoly *)(pl->Part(i)))))));
  }
  else
  {
  if(n>pl->length())
    cout<<"The length of TList is not larger than n;"<<endl;
  else if(n==pl->length())
  {
    ptmp=TRIPoly(TBigInt(1));
    for(i=1;i<=pl->length();i++)
      ptmp=ptmp*(*((TRIPoly *)(pl->Part(i))));
    pl1->append((TAtom *) (new TRIPoly(ptmp)));
  } 
  else
  {
    for(i0=1;i0<=len-n+1;i0++)
    {
      pltmp=new TList();
      for(i1=i0+1;i1<=len;i1++)
        pltmp->append((TAtom *) (new TRIPoly((*((TRIPoly *)(pl->Part(i1)))))));
      pltmp2=this->LChoice(pltmp,n-1);
      delete pltmp;
      for(i1=1;i1<=pltmp2->length();i1++)
      {
        ptmp=(*((TRIPoly *)(pltmp2->Part(i1))))*(*((TRIPoly *)(pl->Part(i0))));
        pl1->append((TAtom *) (new TRIPoly(ptmp))); 
      }
      delete pltmp2;
    }
  }
  }
  return pl1;
}

TList * TRIPoly::Upfactor()
{
  int primebit=1;
  TList *mltmp=new TList(),*ltmp1;
  TList *pl,*pltmp1,*pltmp2,*pltmp3;
  TRIPoly ptmp,ptmp1,ptmp2,p1,p2,ptmp3,ptmp4,ptmp5,ptmp6,ptmp7,*ptmp10;
  int itmp1,i0,i,j,jj,i1,bo;
  TBigInt btmp,btmp1,btmp3,btmp4,btmp5,m,m1;
  ptmp=*this;
  btmp5=bnabs(ptmp.icont());
  ptmp=ptmp/btmp5;
  if(ptmp.var==0)
  {
/*    m=abs(this->c); 
    if(m<TBigInt(3))
    {
      mltmp->append((TAtom *)(new TRIPoly(*this)));
      return mltmp;
    }
    m1=sqrt(m);m2=m1.GetShort(0)+1; 
    m3=20;
    TBigInt *fa[m3];
    unsigned long exfa[m3];
    PrimeNumber pg(m2);
cout<<"hello?"<<endl;
    for(l=0;l<m3;l++)
      fa[l] = new TBigInt();
    nm = pg.PrimeFactor(fa,exfa,m);
    ptmp3=(*fa[0])*(m/(this->c));
    mltmp->append((TAtom *)(new TRIPoly(ptmp3)));
    for(n0=2;n0<=exfa[0];n0++)
      mltmp->append((TAtom *)(new TRIPoly(*fa[0])));
    for (ni=1;ni<nm;ni++)
    {
      for(n0=1;n0<=exfa[ni];n0++)
        mltmp->append((TAtom *)(new TRIPoly(*fa[ni])));
    }
    for(l=0;l<m3;l++)
    delete fa[l];
*/
    mltmp->append((TAtom * )(new TRIPoly(this->c)));
//    delete [] fa;
    return mltmp;
  }
//  btmp5=abs(ptmp.icont());
//  ptmp=ptmp/btmp5;
//=============== Should be modified!!!!!!!!!!!!!!
  if(ptmp.deg()==TBigInt(1))
  {
    if(btmp5!=TBigInt(1))
    {
      delete mltmp;
	  TRIPoly ty = TRIPoly(btmp5);
      mltmp=ty.Upfactor();
    }
    mltmp->append((TAtom *)(new TRIPoly(ptmp)));
    return mltmp;
  }
  btmp1 = toBigInt(ptmp.IPlbcf()) * ptmp.deg();
/*  ifstream in("/HOMEA/users/others/soft/public/lib/prime");
  if(!in)
  {
    cout<<"Can not open file: prime "<<endl;
    return mltmp;
  }
  in>>itmp;
//while(itmp<12)
  in>>itmp;
  btmp=TBigInt(itmp);
*/
  primebit=primebit+1;
  btmp=TBigInt(primelist[primebit]);
//cout<<"btmp=";btmp.display();cout<<endl;
  if(imod(btmp1,btmp)!=TBigInt(0))
  {
//cout<<"ptmp=";ptmp.display();cout<<endl;
////////////////////////
  ptmp10=ptmp.mod(btmp);
  ptmp7=*ptmp10;delete ptmp10;
  ptmp7=TRIPoly(invm((ptmp7.IPlbcf()),btmp))*ptmp7;
  ptmp10=ptmp7.mod(btmp);
  ptmp7=*ptmp10;delete ptmp10;
  ltmp1=ptmp7.FFiupSF(btmp,TBigInt(1));
////////////////////
//cout<<"ltmp11=";ltmp1->display();cout<<endl;
  itmp1=ltmp1->length();
  btmp3=*((TBigInt *)(ltmp1->Part(2)));
  if(btmp3>TBigInt(1))
      itmp1=4;
  delete ltmp1;
  if(imod(btmp1,btmp)==TBigInt(0))
    itmp1=4;
  }
  while(imod(btmp1,btmp)==TBigInt(0) || itmp1!=2)
  {
/*    in>>itmp;
    btmp=TBigInt(itmp);
    while(imod(btmp1,btmp)==TBigInt(0))
    {
      in>>itmp;
      btmp=TBigInt(itmp);
    }
*/
    primebit=primebit+1;
    btmp=TBigInt(primelist[primebit]);
    while(imod(btmp1,btmp)==TBigInt(0))
    {
      primebit=primebit+1;
      btmp=TBigInt(primelist[primebit]);
    }
//cout<<"btmp=";btmp.display();cout<<endl;
/////////////////////////////////
  ptmp10=ptmp.mod(btmp);
  ptmp7=*ptmp10;delete ptmp10;
  ptmp7=TRIPoly(invm((ptmp7.IPlbcf()),btmp))*ptmp7;
  ptmp10=ptmp7.mod(btmp);
  ptmp7=*ptmp10;delete ptmp10;
  ltmp1=ptmp7.FFiupSF(btmp,TBigInt(1));
////////////////////////////////
//    ltmp1=ptmp.FFiupSF(btmp,TBigInt(1));
//cout<<"ltmp1=";ltmp1->display();cout<<endl;
    itmp1=ltmp1->length();
    btmp3=*((TBigInt *)(ltmp1->Part(2)));
    if(btmp3>TBigInt(1))
      itmp1=4;
    delete ltmp1;
    if(imod(ptmp.IPlbcf(),btmp)==TBigInt(0))
    itmp1=4;
  }
//cout<<"btmp=";btmp.display();cout<<endl;
  ptmp10=ptmp.mod(btmp);
  pl=ptmp10->FormMatrixQ(btmp,TBigInt(1)); 
  delete ptmp10;
//cout<<"pl=";pl->display();cout<<endl;
  pltmp3=LChoice(pl,pl->length());
  ptmp2=*((TRIPoly *)pltmp3->Part(1));
  delete pltmp3;
  i=1;j=(pl->length())/2;
  jj=pl->length();
  btmp4=bnabs(this->icont());
//===================Should be modified!!!!!!!!
  if(btmp4!=TBigInt(1))
  {
    delete mltmp;
	TRIPoly  ty = TRIPoly(btmp5);
    mltmp=ty.Upfactor();
  }
  ptmp6=ptmp;
  while(ptmp.var!=0 && i<=j)
  {
    pltmp1=this->LChoice(pl,i);
//cout<<"pltmp1=";pltmp1->display();cout<<endl;
    for(i0=1;i0<=pltmp1->length();i0++)
    {
      p1=(*((TRIPoly*)pltmp1->Part(i0)));
//cout<<"p1=";p1.display();cout<<endl;
      p2=ptmp2/p1;
//cout<<"p2=";p2.display();cout<<endl;
      pltmp2=ptmp6.UHLA(p1,p2,btmp);
//cout<<"i="<<i<<"::"<<"pltmp2=";pltmp2->display();cout<<endl;
      if(pltmp2->length()>1)
      {
        bo=0;
        for(i1=1;i1<=mltmp->length();i1++)
        {
          ptmp3=(*((TRIPoly *)pltmp2->Part(1)));
          ptmp4=(*((TRIPoly *)mltmp->Part(i1)));
//cout<<"ptmp3=";ptmp3.display();cout<<endl;
//cout<<"ptmp4=";ptmp4.display();cout<<endl;
          ptmp5=ptmp3/ptmp4;
          ptmp4=ptmp3-ptmp5*ptmp4;
//cout<<"ptmp5=";ptmp5.display();cout<<endl;
//cout<<"ptmp4=";ptmp4.display();cout<<endl;
          if(ptmp4.var==0 && ptmp4.c==0)
          {
            bo=1;
          }
        }  
        if(bo==0)
        {
          ptmp5=(*((TRIPoly *)pltmp2->Part(1)));
          ptmp=ptmp/ptmp5;
          if(ptmp.var==0)
          {
            ptmp5=ptmp5*ptmp;
            mltmp->append((TAtom *)(new TRIPoly(ptmp5)));
          }
          else
            mltmp->append((TAtom *)(new TRIPoly(ptmp5)));
//cout<<"mltmp=";mltmp->display();cout<<endl;
//cout<<"ptmp=";ptmp.display();cout<<endl;
          if(ptmp.var==0)
          {
            delete pltmp1; delete pltmp2;
            delete pl;
            return mltmp;
          }
          if(mltmp->length()==(jj-i))
          {
            mltmp->append((TAtom *)(new TRIPoly(ptmp)));
            delete pltmp1;delete pltmp2;delete pl;
            return mltmp;
          }
        }
      }
      delete pltmp2;
    }
    delete pltmp1;
    i=i+1;
    if(mltmp->length()!=0 && jj>=4)
    {
//cout<<"UPFACTOR"<<endl;
      delete pl;
      pltmp2=ptmp.Upfactor();
      pltmp1=pltmp2->Union(mltmp);
      delete pltmp2;
      delete mltmp;
      mltmp=pltmp1;
      return mltmp;
    }
  } 
  if(mltmp->length()==0)
    mltmp->append((TAtom *)(new TRIPoly(ptmp6)));
  else if(mltmp->length()==1 && (((TRIPoly *)(mltmp->Part(1)))->var)==0)
    mltmp->append((TAtom *)(new TRIPoly(ptmp6)));
  else
  {
    ptmp3=*((TRIPoly *)(mltmp->Part(1)));
    for(i=2;i<=mltmp->length();i++)
      ptmp3=ptmp3*(*((TRIPoly *)(mltmp->Part(i))));
    ptmp4=ptmp6/ptmp3;
    if(!(ptmp4.pis1()))
    {
       ptmp3=ptmp6-ptmp3*ptmp4;
       if(ptmp3.pis0())
         mltmp->append((TAtom *)(new TRIPoly(ptmp4)));     
       else
         cout<<"ERROR IN Upfactor"<<endl;
    }
  }
  delete pl;

  return mltmp;
}


//=======   End of Factorization  =============


//================================================================
//
//                     RESULTANT
//
//================================================================

TRIPoly TRIPoly::Resultant(TRIPoly G, TVariable *v)
{
  TRIPoly F=(*this); 
  TBigInt d1=F.Degree(v),d2=G.Degree(v);
  int i,j,tmp=d2.GetShort(0)+2;
//cout<<"tmp="<<tmp<<endl;  
  TRIPoly *P= new TRIPoly[tmp+1], *a= new TRIPoly[tmp+1],
	  *b = new TRIPoly[tmp+1]  ,ptmp0,*ptmp1;
  TBigInt *d = new TBigInt[tmp+1], *l = new TBigInt[tmp+1];
  TRIPoly c1,c2,R,Q,q,e,res;
  TList *SR1=new TList();

//    Initialize

  if(d1<d2)
    {delete SR1; return G.Resultant(*this,v);}
  
  P[1]=F;P[2]=G;
  d[1]=d1;d[2]=d2; 
  l[2]=d1-d2+1;
  i=2;
//cout<<"P[2]=";P[2].display();cout<<endl;

//    Compute

  while(d[i]>0)
  {
    i=i+1;

    if(i==3)
      if(isodd(l[2]))
        e=TRIPoly(-1);
      else
        e=TRIPoly(1);
    else
      if(isodd(l[i-1]))
        e=TRIPoly(-1)*((b[i-2])^(((l[i-1]).GetShort(0))-1))*(a[i-2]);
      else
        e=((b[i-2])^(((l[i-1]).GetShort(0))-1))*(a[i-2]);
//cout<<"e=";e.display();cout<<endl;
    ptmp0=(P[i-1]);
    ptmp1=P[i-2].prem(ptmp0,v);
    R=*ptmp1;
//cout<<"ptmp1=";ptmp1->display();cout<<endl;
    delete ptmp1;
    Q=R/e;
//cout<<"Q=";Q.display();cout<<endl;
    P[i]=Q;
//cout<<"P[i]=";P[i].display();cout<<endl;
    d[i]=P[i].Degree(v); 
//cout<<"d[i]=";d[i].display();cout<<endl;
     
//    Update outputs and check termination

    if(P[i].IsZero())
    {  i=i-1; break;}
    if(d[i]==0)
    {
      l[i]=d[i-1]-d[i]+1;
      ptmp1=P[i-1].Coefficient(v,P[i-1].Degree(v));
      a[i-1]=*ptmp1;
//cout<<"a[i-1]=";ptmp1->display();cout<<endl;
      delete ptmp1;
      if(i==3)
        b[2]=a[2]^((l[2].GetShort(0))-1);
      else
        if(l[i-1]==2)
          b[i-1]=a[i-1];
        else
        {
          c1=a[i-1]^(l[i-1].GetShort(0)-1);
          c2=b[i-2]^(l[i-1].GetShort(0)-2);
          q=c1/c2;
          b[i-1]=q;
        }
      cout<<"b2=";b[2].display();cout<<endl;
      break;
    }       
    
//    Update sequences

    l[i]=d[i-1]-d[i]+1;
    ptmp1=P[i-1].Coefficient(v,P[i-1].Degree(v));
    a[i-1]=*ptmp1;
    delete ptmp1;
    if(i==3)
      b[2]=a[2]^(l[2].GetShort(0)-1);
    else
      if(l[i-1]==2)
        b[i-1]=a[i-1];
      else
      {
        c1=a[i-1]^(l[i-1].GetShort(0)-1);
        c2=b[i-2]^(l[i-1].GetShort(0)-2);
        q=c1/c2;
        b[i-1]=q;
      }
  }

  if((P[i].Degree(v))>0)
    res=TRIPoly(TBigInt(0));
  else
  {
    c1=P[i]^(d[i-1].GetShort(0)-d[i].GetShort(0));
//cout<<"b[i-1]=";b[i-1].display();cout<<endl;
    c2=b[i-1]^(d[i-1].GetShort(0)-d[i].GetShort(0)-1);
//cout<<"c1=";c1.display();cout<<endl;
//cout<<"c2=";c2.display();cout<<endl;
    res=c1/c2;
  }

//    output

  for(j=1;j<=i;j++)
    SR1->append((TAtom *)(new TRIPoly(P[j])));
  cout<<"SR1=";SR1->display();cout<<endl;
  delete SR1;
  delete []P; delete []a;
  delete []b; delete []d; delete []l;
  return res; 
    
}

char * TRIPoly::PolyRoot()
{
//cout<<"in polyroot:";this->display();cout<<endl;
  if(this->polylen()>1)
    return "+";
  if(this->var!=0)
    {
      if(!(this->ups->p->pis1()))
        return "*";
      else 
      {
        if((this->ups->deg)!=1)
          return "^";
        else 
        {
		  TShortList * sl=getlist(this->var);
          if(sl==0)
		  return "SYMBOL";
          else
          {delete sl; return "X";}
        }
      }  
    }
  return "INTEGER";
}

TList * TRIPoly::PolyArgs()
{
  TRIPoly p=*this;
// cout<<"p=";p.display();cout<<endl;
  if(this->polylen()>1)
  {
    TList * l=new TList();
    while(!(p.pis0()))
    {
      l->append((TAtom *)(new TRIPoly(p.IPlbt())));
      p=p-(p.IPlbt());
    }
    return l;
  }
  if(this->var!=0)
    {
      if(!(this->ups->p->pis1()))
      { 
        TList * l3=new TList();
        unsigned short b;
        TVariable * v;
        TRIPoly p1;
        while((p.var))
        {
//cout<<"alksjdfhalsjfd"<<endl;
          v=p.var;
          b=p.deg();
          p1=TRIPoly(v,b);
//cout<<"p1=";p1.display();cout<<endl;
          p=p/p1;
//cout<<"p=";p.display();cout<<endl;
          l3->append((TAtom *)(new TRIPoly(p1)));
//cout<<"*l3=";l3->display();cout<<endl;
//cout<<"p=";p.display();cout<<endl;
        }
//cout<<"*l3=";l3->display();cout<<endl;
		if(!(p.pis1()))
          l3->append((TAtom *)(new TRIPoly(p)));
        return l3;
      }
      else 
      {
        if((this->ups->deg)==1)
        {
           TList * l2=new TList();
           l2->append((TAtom *)(new TRIPoly(this->var,1)));
           l2->append((TAtom *)(new TBigInt((this->ups->deg))));
           return l2;
        }  
        else 
        {
          TList * l4=new TList();
			l4->append((TAtom *)(new TRIPoly(this->var,1 )));
			l4->append((TAtom *)(new TBigInt(this->deg())));
//			wout<<"l4=";l4->display();wout<<endl;
			return l4;
/*	  TShortList * sl=getlist(this->var);
          if(sl==0)
          {
			  l4->append((TAtom *)(new TRIPoly(*this)));
			  return l4; 
		  }
          else
		  {
			  delete sl;
              l4->append((TAtom *)(this->var));
            return l4;
		  }
		  */
        }
      }  
    }
    TList * l5=new TList();
	l5->append((TAtom *)(new TRIPoly(c)));
	return l5;
}


//end of file

        
