#include "polyn.h"

TFloatNum square(TFloatNum a,TFloatNum rooteps)
{       int zerosign=0;
        assert(a>0);
        if(a<1)
        {      a=TFloatNum(1.0)/a;
               zerosign=1;
        }
        TFloatNum prevar,latevar;
        TFloatNum iteration=TFloatNum(0);
        TFloatNum floatunit=TFloatNum(1.0);
        prevar=a;
        latevar=a;
        do
        {      prevar=latevar;
               latevar=a/prevar;
               latevar=latevar+prevar;
               latevar=latevar/2;  
               iteration=iteration+floatunit;   
               if(iteration>maxiter)
               {     cout<<"too many iteration"<<endl;
                     break;
               }
        }
        while(abs(latevar-prevar)>rooteps);
        cout<<"iteration="<<iteration<<endl;
        if(zerosign) latevar=TFloatNum(1.0)/latevar;
        return latevar;
}





//a^(1/n)
TFloatNum nroot(TFloatNum a, TBigInt exponent,TFloatNum rooteps)
{       int zerosign=0;
        assert(a>0);
        if(exponent==TBigInt(1)) return a;
        if(a<1)
        {      a=TFloatNum(1.0)/a;
               zerosign=1;
        }
        TFloatNum prevar,latevar;
        TBigInt tempint;
        TFloatNum iteration=TFloatNum(0);
        TFloatNum temp; 
        prevar=a;
        latevar=a;
		TFloatNum temp1 = TFloatNum(exponent);
        do
        {      prevar=latevar;
               tempint=exponent-TBigInt(1);
               temp=prevar^tempint;
               temp=a/temp;
               temp=prevar-temp;
               temp=temp/(temp1);
               latevar=prevar-temp;
               temp=TFloatNum(1.0);
               iteration=iteration+temp;
               if(iteration>maxiter)
               {     cout<<"too many iteration"<<endl;
                     break;
               }
	}
       // while(abs(latevar-prevar)>rooteps);//is it right?
        while(abs((latevar^exponent)-a)>rooteps);
        if(zerosign) latevar=TFloatNum(1.0)/latevar;
        cout<<"iteration="<<iteration<<endl;
        return latevar;
}


//min,max haven't beee used,and use the condition of default parameters


/********************************************************************************
 
                  add the condition that the range is considered

*******************************************************************************/

//TList *SolvePolyn(TRIPoly *polyn,TFloatNum* RngMin=0,TFloatNum* RngMax=0)
TList *SolvePolyn(TRIPoly *polyn)
{
/*
        int sort;
        if((RngMin==0)&&(RngMax==0))   sort=0;  //no range 
        else
        {     if(RngMin>RngMax)  
              {      cout<<"The Range Is Not Correct!"<<endl;
                     return this;
              }         
              else   sort=1;
        } 
*/

        int i;
        TList* templist=UPBCoefL(*polyn);//no need to new TList()!!!
        TList* coefflist=new TList();
        int dim=templist->length();
                      
        TFloatNum coeff;
	TFloatNum* coeffptr;
       	int iteration=-1;

        for(i=1;i<=dim;i++)
        {     TBigInt coeffint=*((TBigInt*)(templist->Part(i)));
              coeff=TFloatNum(coeffint);
              coeffptr=new TFloatNum();
              *coeffptr=coeff;
              coefflist->append(coeffptr);
        }         
        delete(templist);

        TFloatNum temp;
	TFloatNum prevar,latevar;
        TList* SolList=new TList();
        TList* cplsol;
        int sol;	
        for(sol=0;sol<dim-1;sol++)   //solution: 0--dim-2
	{ //the solth solution
          //if the degree of the polynomials is 2,use the formular

                if((dim-sol)==3)   
                {    TFloatNum a,b,c;
                     a=*((TFloatNum*)(coefflist->Part(1)));
                     b=*((TFloatNum*)(coefflist->Part(2)));
                     c=*((TFloatNum*)(coefflist->Part(3)));
                     b=b/a;
                     c=c/a;
                     TFloatNum delta;
                     TFloatNum tempfloat=TFloatNum(4.0);

                     temp=tempfloat*c;
                     tempfloat=b*b;
                     delta=tempfloat-temp; 
                     if(delta>=0)
                     {//real solution
                           if(delta!=0) 
                                delta=nroot(delta,2,eps);
                           delta=delta/2.0;
                           b=b/2.0;
                           b=-b;
                           
                           coeff=b+delta;
                           coeffptr=new TFloatNum();
                           *coeffptr=coeff;
                           SolList->append(coeffptr);
 
                           coeff=b-delta;
                           coeffptr=new TFloatNum();
                           *coeffptr=coeff;
                           SolList->append(coeffptr);
 
                           delete(coefflist);
                           return SolList;
                     }
                     else
                     {//complex solution
                           delta=-delta;
                           coeff=-b;
                           coeff=coeff/2.0;
                           coeffptr=new TFloatNum();
                           *coeffptr=coeff;
                           cplsol=new TList();
                           cplsol->append(coeffptr);//the real part
                             
                           temp=nroot(delta,2,eps);
                           coeff=temp/2.0;
                           coeffptr=new TFloatNum();
                           *coeffptr=coeff;
                           cplsol->append(coeffptr);//the image part
                           SolList->append((TAtom*)cplsol);
                           delete(coefflist);
                           return SolList;
                     }        
                }              
 
             
                coeff=*((TFloatNum*)(coefflist->Part(1)));
		if(coeff<0){
	      	for(i=0;i<dim-sol;i++)
                      *((TFloatNum*)(coefflist->Part(i+1)))=-
                                 *((TFloatNum*)(coefflist->Part(i+1))); 
                }        
                
                //the maximum of the solution,the initial value
		TFloatNum max=TFloatNum(0.0);
                TBigInt number=TBigInt(0);
		for(i=1;i<dim-sol;i++)
		{       coeff=*((TFloatNum*)(coefflist->Part(i+1)));
                        if((coeff<0)&&(-coeff>max))
			{       max=-coeff;
				number=TBigInt(i);
			}
		}
		if(number==TBigInt(0))	
                        prevar=TFloatNum(0.0);  //all is bigger than 0
                else
                {       coeff=*((TFloatNum*)(coefflist->Part(1)));
                        max=max/coeff; 
                        TFloatNum temp=nroot(max,number);
                        prevar=TFloatNum(1.0);
                        prevar=prevar+temp;
                }
                //add some parts to use the range and calculate the minimum of 
                //           the solution		        
           
iterloop:
                TList* func=new TList();
                TList* dfunc=new TList();
		iteration++;
                coeff=*((TFloatNum*)(coefflist->Part(1)));
                coeffptr=new TFloatNum();
                *coeffptr=coeff;
                func->append(coeffptr);
                //the first step to calculate the function value 
                coeffptr=new TFloatNum();
                *coeffptr=coeff;
                dfunc->append(coeffptr);
                //the first step to calculate the derivative value 
                coeff=*((TFloatNum*)(func->Part(1))); 

         	for(i=2;i<dim-sol;i++)
		{//calculate the function value and the derivative value   
                 //part(i)
                        temp=*((TFloatNum*)(func->Part(i-1)));
                        coeff=*((TFloatNum*)(coefflist->Part(i)));
                        temp=temp*prevar;
                        temp=coeff+temp;
                        coeffptr=new TFloatNum();
                        *coeffptr=temp;
                        func->append(coeffptr);
                        
                        temp=*((TFloatNum*)(func->Part(i)));
                        coeff=*((TFloatNum*)(dfunc->Part(i-1)));
                        TFloatNum temptemp=prevar*coeff; 
                        temp=temp+temptemp;
                        coeffptr=new TFloatNum();
                        *coeffptr=temp;
			dfunc->append(coeffptr);
		}
                 //part(dim-sol) of the function 
                temp=*((TFloatNum*)(func->Part(dim-sol-1)));
                coeff=*((TFloatNum*)(coefflist->Part(dim-sol)));
                temp=prevar*temp;
                temp=coeff+temp;
                coeffptr=new TFloatNum();
                *coeffptr=temp;
                func->append(coeffptr);

                //the denominator maybe 0
                temp=*((TFloatNum*)(func->Part(dim-sol)));
                coeff=*((TFloatNum*)(dfunc->Part(dim-sol-1)));
                if(abs(coeff)<eps)  
                {       temp=TFloatNum(0.5);
                        prevar=prevar+temp;
                        delete(func);
                        delete(dfunc);
                        goto iterloop; 
                }
                temp=temp/coeff;
		latevar=prevar-temp;
       
		//if the solution
		if(abs(latevar-prevar)<eps)
                {       delete(func);
                        delete(dfunc);
                        coeffptr=new TFloatNum();
                        *coeffptr=latevar;
                        SolList->append(coeffptr);
		}
                else
		{       if(iteration>maxiter) //if can't find the solution  
                        {       delete(func);
                                delete(dfunc);
                                delete(coefflist);
                                cout<<"Not All Solution"<<endl;
                                cout<<"iteration="<<iteration<<endl;
                                return(SolList);
                        }
			else 
			{       prevar=latevar;
                                delete(func);
                                delete(dfunc);
				goto iterloop;
			}
		}//if end ,then the solth solution has been found
		
                //reduce to compute the next solution 
		//and compute the coefficient of the quotient polynomial
                // ie. the function value at the solution(latevar)
               
                 
                TList *medialist=new TList();
                coeff=*((TFloatNum*)(coefflist->Part(1)));
                coeffptr=new TFloatNum();
                *coeffptr=coeff;
                medialist->append(coeffptr);
                for(i=2;i<dim-sol;i++)
                {       temp=*((TFloatNum*)(medialist->Part(i-1)));
                        coeff=*((TFloatNum*)(coefflist->Part(i)));
                        temp=temp*latevar;
                        temp=coeff+temp;
                        coeffptr=new TFloatNum();
                        *coeffptr=temp;
                        medialist->append(coeffptr);
                }
                delete( coefflist);
                coefflist=medialist;
	}
        delete(coefflist);
        cout<<"iteration="<<iteration<<endl;
	return(SolList);
}

		

//use the Qing's methods to calculate the polynomial and it's derivation at point value
TNumber* dfuneval(TRIPoly *polyn,TNumber value)
{              
        int i;
        TList* coefflist=UPBCoefL(*polyn);//no need to new TList()!!!
        int dim=coefflist->length();
            
        TNumber coeff;
        TNumber* coeffptr;
        TNumber temp;

        TNumber prefun,latefun;
        TNumber predfun,latedfun;
        prefun=*((TNumber*)(coefflist->Part(1)));           
        predfun=*((TNumber*)(coefflist->Part(1)));     
 
        for(i=2;i<dim;i++)
        {      coeff=*((TNumber*)(coefflist->Part(i)));
               temp=value*prefun;
               latefun=coeff+temp;
                        
               temp=value*predfun;
               latedfun=latefun+temp; 
               prefun=latefun;
               predfun=latedfun;     
       }
       coeff=*((TNumber*)(coefflist->Part(dim)));
       temp=value*prefun;
       latefun=coeff+temp;
                
       TNumber* dfunvalue=new TNumber(latedfun);
       delete coefflist;
       return dfunvalue;           
}

TNumber* funeval(TRIPoly *polyn,TNumber value)
{
       int i;
       TList* coefflist=UPBCoefL(*polyn);
       int dim=coefflist->length();

       TNumber coeff;
       TNumber* coeffptr;
       TNumber temp;

       TNumber prefun,latefun;
       prefun=*((TNumber*)(coefflist->Part(1)));

       for(i=2;i<=dim;i++)
       {       coeff=*((TNumber*)(coefflist->Part(i)));
               temp=value*prefun;
               latefun=coeff+temp;
               prefun=latefun;
       }
       TNumber* funvalue=new TNumber(latefun);
       delete coefflist;
       return funvalue;
}
       
