

//File name: prime.cpp(prime.cc)
//The used memory of this program :  
//
// if you want to find all the prime numbers below n, 
// then the memory of n/2 bits(n/16 bytes) is needed.
//
//The implementation of class PrimeNumber 
//The class PrimeNumber includes member functions which
//serve as the sub-functions for the related functions 
//in bigint.cc(bigint.cpp)


//#include "stdafx.h"
#include "prime.h"
//#include "bignum.h"//the low operations on bignum
//#include "integer.h"//the low operations on bignum

//#include "include\integer.h"
//#include "bigint.h"//the high operations on bignum
//#include "number1.h"
#include "num_integer.h"

//Primality Test
/*  
    1:  n is a prime;
    0:  n is not a prime;
   -1: the primality could not be determined
*/
/*  Note:
    if n <= nLimitIn^2 , then the primality can be determined,
    else the primality can't be determined.
*/
int PrimeNumber::IsPrime(unsigned long n)
{

  if((n==1)||(n==0)) return 0;
  if (n == 2) return 1;
  if ((n%2)==0) return 0;

  if (nLimit>(n-1)/2)
  {
      return (StatusBit((n-3)/2)!=0);
  }
  else
  {
    unsigned long i;
    for (i=0;i<nLimit;i++)
	{
	  if (StatusBit(i))
	  {
	    if (n%(2*i+3)==0) return 0;
	  }
	}
  }

  //ʱnѲnLimitIn(MAXPRIME)ڵκ

  if (n <= (MAXPRIME*MAXPRIME)) return 1;

  return -1;//nԲȷ

}


/*
//Integer Factorization
// Note:
//   If all of the prime divisors of n are less than nLimitIn,
//   then the factorization of n is right.
//   In generally, nLimitIn = sqrt(n) is enough.
//
unsigned long PrimeNumber::PrimeFactor(TBigInt factor[],unsigned long expFactor[],TBigInt n)
// factor[]:     the array of prime divisors
// expFactor[]:  the array of exps of prime divisors
// return value: the number of prime divisors 
{
  unsigned long nFactor;
  TBigInt remainDiv;
  remainDiv=n;
  nFactor=0;
  if ((n%2)==0)
    {
      factor[nFactor]=2;
      expFactor[nFactor]=0;
      while((remainDiv%2)==0)
	{
	  (expFactor[nFactor])++;
	  remainDiv /= 2;
	}
      nFactor++;
    }

  //unsigned long i,nTest;
  //nTest=(unsigned long)sqrt(n)+2;//only need to test whether the primes below sqrt(n) can divide n

  unsigned long i;
  TBigInt nTest;
  nTest = sqrt(n)+2;

  for (i=0;(i<nLimit)&&(i<(nTest-3)/2);i++)
    {
      if (StatusBit(i))
	{
	  if (remainDiv%(2*i+3)==0)
	    {
	      factor[nFactor]=2*i+3;
	      expFactor[nFactor]=0;
	      while((remainDiv%(factor[nFactor]))==0)
		{
		  (expFactor[nFactor])++;
		  remainDiv /= factor[nFactor];
		}
	      nFactor++;
	    }
	}
    }

  
  if (remainDiv > 1)//here remainDiv is the last divisor
  {
      factor[nFactor]=remainDiv;
      expFactor[nFactor]=1;
      nFactor++;
  }


  // Note:
  //   if remainDiv <= nLimitIn^2,then remainDiv is a prime divisor,
  //   i.e. the above factorization of n is right,else the correctness 
  //   of the factorization can`t be determined.
  //


  return nFactor;

}



*/


//Integer Factorization
//Note:
//If all of the prime divisors of n are less than nLimitIn(nLimitIn is
//the upper bound of the prime table),
//then the factorization of n (method=0) is a complete factorization.
//In generally, nLimitIn = sqrt(n) is enough.
unsigned long PrimeNumber::PrimeFactor(TBigInt * factor[],unsigned long expFactor[],TBigInt n,int method)
// factor[]:     the array of prime divisors
// expFactor[]:  the array of exps of prime divisors
// method: takes the value of 0(default),1 and 2:
//         0: ֻֽ⣨ֽСڽMAXPRIMEӣ 
//         1: ʣµֻһηֽ⡣			     
//         2: ʣµܶķֽ⣬
//			  ֱÿ޷ҵķƽΪֹ
// return value: the number of prime divisors 
{
  //ֽ⣺

  unsigned long nFactor;
  TBigInt remainDiv;
  remainDiv=n;
  nFactor=0;
  if ((n%2)==0)
    {
      *(factor[nFactor])=2;
      expFactor[nFactor]=0;
      while((remainDiv%2)==0)
	{
	  (expFactor[nFactor])++;
	  remainDiv /= 2;
	}
      nFactor++;
    }
     
  //unsigned long i,nTest;
  //nTest=(unsigned long)sqrt(n)+2;//only need to test whether the primes below sqrt(n) can divide n

  //unsigned long i;
  int i;
  TBigInt nTest;
  nTest = sqrt(n)+2;

  for (i=0;(i<(int)nLimit)&&(i<(nTest-3)/2);i++)
    {
      if (StatusBit(i))
	{
	  if (remainDiv%(2*i+3)==0)
	    {
	      *(factor[nFactor])=2*i+3;
	      expFactor[nFactor]=0;
	      while((remainDiv%(*(factor[nFactor])))==0)
		{
		  (expFactor[nFactor])++;
		  remainDiv /= *(factor[nFactor]);
		}
	      nFactor++;
	    }
	}
    }

  //ֽ

  if(remainDiv==1) return nFactor;

  if(method==0)
  {
	 *(factor[nFactor])=remainDiv;
	 expFactor[nFactor]=1;
	 nFactor++;
	 return nFactor;
  }

  //-----------------modified on 2001.9.18---------------

  //Note:
  //if remainDiv <= nLimitIn^2,then remainDiv must be a prime divisor,
  //i.e. the above factorization of n is a complete factorization,
  //else the factorization is probablly a non-complete factoriztion,
  //we will try to factor the remain divisor,using Pollard's rho method
  //or Square-free factorization.
  unsigned long nLimitInSqr = MAXPRIME*MAXPRIME;
  //unsigned long nLimitInSqr = 4*nLimit*nLimit+4*nLimit+1;
  //cout << "\nnLimitInSqr=" << nLimitInSqr << endl;
  //nLimitInSqr is the square of nLimitIn(MAXPRIME), nLimitIn(MAXPRIME) is
  //the upper bound of the prime table,if MAXPRIME=65535,then 
  //nLimitInSqr=65535*65535=4294836225
  if(remainDiv <= nLimitInSqr)
  //in this case,remainDiv must be a prime divisor
  {
	 //cout << "\nok!\n";
     *(factor[nFactor])=remainDiv;
	 expFactor[nFactor]=1;
	 nFactor++;
  }
  else
  //here remainDiv is the remain divisor
  {    
	    switch (method) 
        {
		 case 1://case1:ʣµremainDivֻһηֽ⣬
			    //      ֽΪӣһӣĳ˻
			{
            TBigInt newDiv; 
            //ͼѰremainDivһƽ
			//cout << "\nremainDiv= " << remainDiv << endl;
		    newDiv = NonTrivalFactor(remainDiv);
			if(newDiv != -1) 
		    //ҵremainDivһƽ
            {
			  remainDiv /= newDiv;
			  *(factor[nFactor])=newDiv;
              expFactor[nFactor]=1;
              nFactor++;
			  *(factor[nFactor])=remainDiv;
              expFactor[nFactor]=1;
              nFactor++;
            }
			else
            //remainDivûзֽɹ
			{
			 *(factor[nFactor])=remainDiv;
	         expFactor[nFactor]=1;
	         nFactor++;
            }
			break;
			}
		 case 2://case2:ʣµremainDivܶķֽ⣬
			    //ֱÿ޷ҵķƽΪֹ
			    //ȻЩӻܱ֤ӣӵ
			    //Ѻܴ
			{
		    TBigInt  *moreFactor[100];//ŶremainDivֽõ
			int moreExpFactor[100];
            int i;

            for(i=0;i<100;i++)
              moreFactor[i] = new TBigInt;

            int k = PrimeFactor_Pollard(remainDiv,moreFactor,moreExpFactor);
			 
			for(i=0;i<k;i++)
			{ 
			  *(factor[nFactor])= *(moreFactor[i]);
	          expFactor[nFactor]= moreExpFactor[i];
	          nFactor++;
            } 

            for(i=0;i<100;i++)
              delete moreFactor[i];

			break;
			}
		 default:
			//the same as the case of method = 0
            *(factor[nFactor])=remainDiv;
	        expFactor[nFactor]=1;
	        nFactor++;
			break; 
		}
  } 

  //--------------------end modified--------------------------------
  
  return nFactor;

}


/*
//Euler Function
TBigInt PrimeNumber::Euler(TBigInt n)
{
  unsigned long nnn,i;
  TBigInt neuler;
  neuler=n;
  TBigInt * nf;
  unsigned long * nexp;
  //nf=new TBigInt [nLimit];
  nf=(TBigInt *)malloc(sizeof(TBigInt)*nLimit);  //error!!!
  nexp=new unsigned long [nLimit];
  nnn=PrimeFactor(nf,nexp,n);
  for (i=0;i<nnn;i++)
    {
      neuler=neuler/nf[i];
      neuler=neuler*(nf[i]-1);
    }
  delete [] nf;
  delete [] nexp;
  return neuler;
}



*/


/*


//Euler Function
TBigInt PrimeNumber::Euler(TBigInt n)
{
  unsigned long nnn,i;
  TBigInt neuler;

  neuler=n;

  TBigInt ** nf;
  unsigned long * nexp;

  nf=(TBigInt **)malloc(sizeof(TBigInt *)*nLimit);
  for(i=0; i<nLimit;i++)
  {
     nf[i]=new TBigInt;
  }

  nexp=new unsigned long [nLimit];

  nnn=PrimeFactor(nf,nexp,n);

  for (i=0;i<nnn;i++)
  {
      neuler=neuler/*(nf[i]);
      neuler=neuler*(*(nf[i])-1);
  }

  
  for(i=0; i<nLimit;i++)
  {
     delete nf[i];
  }
  free(nf);

  delete [] nexp;

  return neuler;


}


*/



//Constructor & Sieve
/* 
   construct a bit array(bitForSieve) with the value 1 or 0
   of each bit.
   when the bit array is constructed, we in fact find all of 
   the prime numbers below nLimitIn
*/
PrimeNumber::PrimeNumber(unsigned long nLimitIn)
{
    if(nLimitIn < 2)
    {
      exit(1);
    }

    nLimit=(nLimitIn-1)/2;

	//cout << "\nnLimit = " << nLimit << endl;

    bitForSieve=new unsigned char [nLimit/8+1];

    unsigned long i;
    for (i=0;i<nLimit/8+1;i++) bitForSieve[i]=0xff;

    Sieve();
}





//Destructor
PrimeNumber::~PrimeNumber()
{
    delete [] bitForSieve;
}




//***Sieve Method***



// set 0 to the nth bit 
unsigned long PrimeNumber::SetSieveTag(unsigned long idxIn)
{
    bitForSieve[idxIn/8] &= (~(0x01 << (idxIn%8)));
    return 0;
}

// check if the nth bit is 0: return 0 if 0, return a nonzero integer if 1
unsigned long PrimeNumber::StatusBit(unsigned long idxIn)
{
    return bitForSieve[idxIn/8] & (0x01<< (idxIn%8) );
}

// find the first bit of value 1 after the nth bit
// if return -1,then all the prime numbers are found
int PrimeNumber::NextPrimeIdx(unsigned long idxIn)
{
    int i;
    i=idxIn;  //? 
    while(i<(int)nLimit)
    {
        if (StatusBit(i)) return i;
        i++;
    }
    return -1;
}



// sieve program:
/*
   sieve for all of the odd numbers in [3,nLimitIn]

   if the odd number is prime, then set 1 to the corresponding bit,
   else set 0 to the bit.

   Note:

   in fact, it's enough to only sieve for the odd numbers less than 
   sqrt(nLimitIn)
*/ 
unsigned long PrimeNumber::Sieve()
{
    unsigned long i,j;
    i=0;

    unsigned long currPrime = 3;

    while( (i>=0) && ((currPrime-1)*(currPrime-1) <= (2*nLimit+5)) )
    {

        for (j=i+1;j<nLimit;j++)
        {
            if ((j-i)%(2*i+3)==0) SetSieveTag(j);
        }

        i=NextPrimeIdx(i+1); //?
        currPrime = 2*i+3;

    }

    return 0;
}



//***end of Sieve Method***


//print function

unsigned long PrimeNumber::OutputPrime(unsigned long * primeOut)
/*
   put all the prime numbers in the array primeOut
   return the number of prime numbers
*/
{
    unsigned long i,j;
    i=0;
    primeOut[i]=2;
    i++;
    for (j=0;j<nLimit;j++)
    {
        if (StatusBit(j)) 
        {
            primeOut[i]=j*2+3;
            i++;
        }
    }
    return i;
}




unsigned long PrimeNumber::OutputLastPrime()
// return the largest prime number below nLimitIn
{

   if(nLimit == 0) return 2;

   unsigned long i;

   i=nLimit-1;

   while( (StatusBit(i) == 0) && (i>0) )
     i--;

   return (2*i+3);
               
}



 
