

//File name: prime.h
//The used memory of this program :  
//
// if you want to find all the prime numbers below n, 
// then the memory of n/2 bits(n/16 bytes) is needed.
//
//The defination of class PrimeNumber 
//The class PrimeNumber includes member functions which
//serve as the sub-functions for the related functions 
//in bigint.cc(bigint.cpp)

class TBigInt;
class PrimeNumber
{

  public:

    unsigned char * bitForSieve;
   
    unsigned long nLimit;
    /*
       nLimit is the number of odd numbers in
       [3,nLimitIn]
    */

    // Constructor and Destructor
    PrimeNumber(unsigned long nLimitIn);
    ~PrimeNumber();

    // Sieve Method 
    int NextPrimeIdx(unsigned long idxIn);
    unsigned long SetSieveTag(unsigned long idxIn);
    unsigned long StatusBit(unsigned long idxIn);
    unsigned long Sieve();

    // print function
    unsigned long OutputPrime(unsigned long * primeOut);
    unsigned long OutputLastPrime();
    
     
    // Primality Test
    int IsPrime(unsigned long n);
    /*  
        1:  n is a prime;
        0:  n is not a prime;
        -1: the primality could not be determined;
    */

    // Integer Factorization
    unsigned long PrimeFactor(TBigInt * factor[],unsigned long expFactor[],TBigInt n,int method);
    // unsigned long PrimeFactor(TBigInt  factor[],unsigned long expFactor[],TBigInt n);
	// factor[]:     the array of prime divisors
    // expFactor[]:  the array of exps of prime divisors
    // method: takes the value of 0(default),1 and 2:
    //         0: ֻֽ⣨ֽСڽMAXPRIMEӣ 
    //         1: ʣµֻһηֽ⡣			     
    //         2: ʣµܶķֽ⣬
    //			  ֱÿ޷ҵķƽΪֹ
    // return value: the number of prime divisors

    // Euler Function
    TBigInt Euler(TBigInt n);
 
};
