

//File name: primegen.cc(primegen.cpp)
//Prime test and prime generation
//The linux compile command(on dell and elim):
//bnprime % g++ bignum.cc primegen.cc primesieve.cc primetest.cc -o prime
                           

//#include "stdafx.h"
#include "primesieve.h"
//#include "bignum.h"
//#include "integer.h"

//#include "include\integer.h"
//#include "bigint.h"
//#include "number1.h"
#include "num_integer.h"


//The size of the shuffle table (in words)
#define SHUFFLE 256

//The size of the sieve array (in bytes)
#define SIEVE 2048

//#define WHERETEST 1
//primeTestΪӺںprimeGenбʱWHERETEST=1
#define WHERETEST 0
//primeTestΪûֱӵʱWHERETEST=0


/*
//--Prime Test (Probability Test Method)
//--If it is nearly prime , returns 0.
//--If it is not prime, returns a positive number, representing
//  the number of modular exponentiation performed.If the number
//  of modular exponentiation is 0 or 1, returns 1.
int primeTest(TBigInt * bn, TBigInt * e, TBigInt * a)
{  
  unsigned short i,l;
  int k,j;
  
  //Step1: Small Divisor Test
  //test if bn is the multiple of 2,3,5,7,11,13,17,19,23,29,31,37,41
  
  i = bn->GetShort(0);
  
  //test if bn is 0,1,2,3,5,7,11,13,17,19,23,29,31,37,41
  if(bn->Len() == 1)
  {
    if((i==0)||(i==1)) return 1;
    if((i==2)||(i==3)||(i==5)||(i==7)||(i==11)||(i==13)||(i==17))
      return 0;
    if((i==19)||(i==23)||(i==29)||(i==31)||(i==37)||(i==41))  
      return 0;
  }
  
  //test if bn is even
  if (!(i & 1)) return 1;
  
  //51051 = 3 * 7 * 11 * 13 * 17
  i = ((*bn) % 51051).GetShort(0);	
  if (!(i % 3))  return 1;
  if (!(i % 7))  return 1;
  if (!(i % 11)) return 1;
  if (!(i % 13)) return 1;
  if (!(i % 17)) return 1;
  
  //63365 = 5 * 19 * 23 * 29
  i = ((*bn) % 65535).GetShort(0);		
  if (!(i % 5))  return 1;
  if (!(i % 19)) return 1;
  if (!(i % 23)) return 1;
  if (!(i % 29)) return 1;
  
  //47027 = 31 * 37 * 41 
  i = ((*bn) % 47027).GetShort(0);
  if (!(i % 31)) return 1;
  if (!(i % 37)) return 1;
  if (!(i % 41)) return 1;
  
  //Step2: Fermat test to the base 2 (Euler's criterion)
  
  (*e) = (*bn) - 1; //Note: e must be allocated before call primeTest()
  
  l=e->GetShort(0);
  
  j=1;
  
  if(l & 7)
  {
     cout << "\nstep2:if\n" << endl;
     
     (*e) = (*e) >> 1;
     (*a) = (2 ^ (*e)) % (*bn); // /Note: a must be allocated before call primeTest()
     if((l & 7) == 6)
     {
       if(a->blength() != 1)
           return 1;   //Not Prime!
       k = 1;
     }
     else
     {
       (*a) = (*a) + 1;
       if( (*a) != (*bn) )
          return 1; //Not Prime!  
       k=1;
       if(l & 4)
       {
         (*e) = (*e) >> 1;
	 k=2;
       }
     }
  }
  else
  {
    cout << "\nstep2:else\n" << endl;
    
    //cout << "\n(*e) = " << (*e) << endl;
    
    (*e) = (*e) >> 2;
    
    cout << "\n(*e) = " << (*e) << endl;
    
    cout << "\n(*bn) = " << (*bn) << endl;
    
    (*a) = (2 ^ (*e)) % (*bn);
    
    cout << "\n(*a) = " << (*a) << endl;
    
    if(a->blength() == 1) // that is,(*a) == 1          	    	   
    {
      j=0;
    }
    else
    {
      (*a) = (*a) + 1;
      if( (*a) != (*bn) )
          return 1; //Not Prime!
    }
    
    (*e) = MakeOdd((*e),&k);
    k = k+2;
    
  }
  
  //cout << "\nend of step 2!\n";
  
  //Step3: Miller-Rabin test (also called strong pseudoprimality test, or Knuth. Algorithm P)
  for(i=j; i < CONFIRMTESTS; i++)
  {
     (*a) = confirm[i];
     (*a) = ((*a)^(*e) ) % (*bn);
     if(a->blength() == 1)  continue; 
     //passed this test to the current base, change the base, try again.
     l=k;
     for(;;)
     {
        (*a) = (*a) + 1;
	if( (*a) == (*bn) ) break; //It is probably prime
	if(!--l) return i+2-j; //Not prime!
	(*a) = (*a) - 1;
	(*a) = ( (*a) ^ 2) % (*bn);
	if(a->blength() == 1) return i+2-j; //Not Prime!
     }
  }
  
  //We've nearly decided that it is prime
  
  return 0; //It is nearly prime !   	
     
}  
  	  
*/



//--Prime Test (Probability Test Method)
//--If it is nearly prime , returns 0.
//--If it is not prime, returns a positive number, representing
//  the number of modular exponentiation performed.If the number
//  of modular exponentiation is 0 or 1, returns 1.
//úһΪprimeGenӺʹãҲΪûֱӵã
//ͨԺWHERETESTȡֵͬ
int primeTest(TBigInt bn)
{  
  TBigInt a,e;
  int i,l;
  int k,j;
  
  
#if WHERETEST == 0
//the primeTest() call in ordinary case
//add the Small Divisor Test
 
  //Step1: Small Divisor Test
  //test if bn is the multiple of 2,3,5,7,11,13,17,19,23,29,31,37,41
  
  i = bn.GetShort(0);
  
  //test if bn is 0,1,2,3,5,7,11,13,17,19,23,29,31,37,41
  if(bn.Len() == 1)
  {
    if((i==0)||(i==1)) return 1;
    if((i==2)||(i==3)||(i==5)||(i==7)||(i==11)||(i==13)||(i==17))
      return 0; //bn must be prime !
    if((i==19)||(i==23)||(i==29)||(i==31)||(i==37)||(i==41))  
      return 0; //bn must be prime !
  }
  
  //test if bn is even
  if (!(i & 1)) return 1;
  
  //51051 = 3 * 7 * 11 * 13 * 17
  i = ((bn) % 51051).GetShort(0);	
  if (!(i % 3))  return 1;
  if (!(i % 7))  return 1;
  if (!(i % 11)) return 1;
  if (!(i % 13)) return 1;
  if (!(i % 17)) return 1;
  
  //63365 = 5 * 19 * 23 * 29
  i = ((bn) % 63365).GetShort(0);		
  if (!(i % 5))  return 1;
  if (!(i % 19)) return 1;
  if (!(i % 23)) return 1;
  if (!(i % 29)) return 1;
  
  //47027 = 31 * 37 * 41 
  i = ((bn) % 47027).GetShort(0);
  if (!(i % 31)) return 1;
  if (!(i % 37)) return 1;
  if (!(i % 41)) return 1;
  
#else
//the case of the primeTest() call in primeGen()
//the Small Divisor Test is not necessary  

  if(bn.Len() <= 2) return 0; 
  //ʱbn65536ڵӣbnС2^32,bnһ
  //
  //עٶϽȡ65536SMALL=4096
  
#endif    


  //Step2: Fermat test to the base 2 (Euler's criterion)
  
  (e) = (bn) - 1; //Note: e must be allocated before call primeTest()
  
  l=e.GetShort(0);
  
  j=1;
  
  if(l & 7)
  {
     //cout << "\nstep2:if\n" << endl;
     
     (e) = (e) >> 1;

     //(a) = (2 ^ (e)) % (bn); // /Note: a must be allocated before call primeTest()
     //(a) = (LeftShift1(e)) % (bn);
	 (a) = modular_exponent(bn,2,e);

     if((l & 7) == 6)
     {
       if(a.blength() != 1)
           return 1;   //Not Prime!
       k = 1;
     }
     else
     {
       (a) = (a) + 1;
       if( (a) != (bn) )
          return 1; //Not Prime!  
       k=1;
       if(l & 4)
       {
         (e) = (e) >> 1;
	 k=2;
       }
     }
  }
  else
  {
    //cout << "\nstep2:else\n" << endl;
    
    //cout << "\n(*e) = " << (*e) << endl;
    
    (e) = (e) >> 2;
    
    //cout << "\n(*e) = " << (*e) << endl;
    
    //cout << "\n(*bn) = " << (*bn) << endl;
    
    //(a) = (2 ^ (e)) % (bn);
    //(a) = (LeftShift1(e)) % (bn);
	(a) = modular_exponent(bn,2,e);
    
    //cout << "\n(*a) = " << (*a) << endl;
    
    if(a.blength() == 1) // that is,(*a) == 1          	    	   
    {
      j=0;
    }
    else
    {
      (a) = (a) + 1;
      if( (a) != (bn) )
          return 1; //Not Prime!
    }
    
    (e) = MakeOdd((e),&k);
    k = k+2;
    
  }
  
  //cout << "\nend of step 2!\n";
  
  //Step3: Miller-Rabin test (also called strong pseudoprimality test, or Knuth. Algorithm P)
  for(i=j; i < CONFIRMTESTS; i++)
  {
     (a) = confirm[i];

     //(a) = ((a)^(e) ) % (bn);
	 (a) = modular_exponent(bn,a,e);

     if(a.blength() == 1)  continue; 
     //passed this test to the current base, change the base, try again.
     l=k;
     for(;;)
     {
        (a) = (a) + 1;
	    if( (a) == (bn) ) break; //It is probably prime
	    if(!--l) return i+2-j; //Not prime!
    	(a) = (a) - 1;

	    (a) = ( (a) ^ 2) % (bn);

	    if(a.blength() == 1) return i+2-j; //Not Prime!
     }
  }
  
  //We've nearly decided that it is prime
  
  return 0; //bn is nearly prime !   	
     
}  


//--Prime Generation
//--return a probable prime which is larger than the specified bignum bn
//--rand(i) is a function which is used to generate a random integer between 0 and i-1
//--if rand != NULL, then return a prime larger than the specified bignum (random search)
//--if rand == NULL, then return a prime next to the specified bignum (sequential search)
//                   if the specified bignum bn is a prime, then return bn.
//--NumOfExp is an output argument, which is the number of unsuccessful modular exponentiations
//  performed.
//--This function never gives up searching until it finally finds a prime!
//--Note: 
//  1.bn should satisfy:  bn > 16*SMAll - 1, i.e. if SMALL = 4096, then
//    bn > 65535
//  2.if SMALL = 4096, this function is used to generate a prime greater than 65535, 
//    in other words, the smallest prime which can be generated by this function is 65537.
//    i.e. if 1<bn<=65537, then for sequential search,primeGen(bn)=65537,
//                              for random search,primeGen(bn)>=65537
TBigInt primeGen(TBigInt bn, int * NumOfExp,int (*rand)(int))
{
   TBigInt newprime(bn);
   int retval;
   int modexps = 0; //the number of modular exponentiations
   unsigned short offsets[SHUFFLE]; 
   //the shuffle table:
   //this is an integer array of the 1-bit positions (indexes) in the big sieve table
   unsigned p,q,prev; //the three variables are used to get the bit position (index)
   int i,j;
   unsigned char sieve[SIEVE]; //the big sieve table 
   
   //==1. preparation: make sure that bn is odd
   
   if((bn.GetShort(0) & 1) == 0) //bn is even
      newprime = newprime + 1;
      
   while(1)
   {
     //==2. build a big sieve table (sieve): the initial value is newprime, the step is 2
     
     sieveBuild(sieve, SIEVE,newprime,2,0);   
     
     //==3. build an integer array (offsets):
     //     add the first 1-bit position in the sieve
     //     table into the array (sequential search) ,or
     //     add the first SHUFFLE 1-bit positions in the 
     //     sieve table into the array (random search).
      
     
     i=p=0;
     
     //about p:
     //From now on, p is always the 1-bit position next to the largest position
     //in the shuffle table,which has not been added to the shuffle table,and p
     //is 0 iff the sieve table has been exhausted.
     
     //get the first 1-bit position in the sieve table
     if(sieve[0] & 1 || (p=sieveSearch(sieve,SIEVE,p))!=0)
     {
       offsets[i++] = p;
       p = sieveSearch(sieve,SIEVE,p);
     }  
     //get the other 1-bit positions in the sieve table
     //until the shuffle table is full, or the sieve table
     //is exhausted.
     if (rand && p)
     {
	do {
	    offsets[i++] = p;
	    p = sieveSearch(sieve, SIEVE, p);
	   } while (p && i < SHUFFLE);
     }
     
     //now i is the number of 1-bit positions(indexes) which have been added to the shuffle table 
     
     //==4. choose a candidate at random or in sequence from the shuffle table for
     //     primality test 
     
     prev = 0;
     while (i) 
     {
	//choose a random index from the shuffle table 
	//or get the first index from the shuffle table
	j = rand ? rand(i) : 0;
	q = offsets[j];//q is the current index for test

	//modify the shuffle table:
	//replace the choosed index with the next new index from the sieve table if possible, or 
	//replace it with the final non-zero index in the shuffle table
	if (p) 
	{
	  offsets[j] = p;
	  p = sieveSearch(sieve, SIEVE, p);
	} 
	else 
	{
	  offsets[j] = offsets[--i];
	  offsets[i] = 0;
	}
	

	//calculate the number corresponding to the q-th bit in the sieve table,
	//then test if the number is prime 
	newprime = (q>prev)?(newprime+(int)((q-prev)*2)):(newprime-(int)((prev-q)*2)); 
	prev = q;//prev is the previous index for test
	
	//now do the strong primality test
	//Note: here newprime has been no longer the multiple 
	//of any prime divisor less than 2^16, so the Small
	//Divisor Test in the primeTest() call is not necessary
	//עٶϽȡ65536SMALL=4096
	retval = primeTest(newprime);
	
	if(retval == 0) 
	//find a prime, success!
	//reset the shuffle table and the sieve table to zero, and then return the prime
	{
	  memset(offsets, 0, sizeof(offsets));
	  memset(sieve, 0, sizeof(sieve));
	  
	  *NumOfExp = modexps + CONFIRMTESTS;
	  
	  return newprime;
	}
	
	modexps += retval;
	
      } //end of the inner loop while(i)
      
      //==5. now ran out of the sieve table, indicating that we don't find any
      //     prime in the current sieve table, then rebuild a big sieve
      //     table with a new initial value, and keep trying, the initial
      //     value is the number corresponding to the 8*SIEVE-th bit in the 
      //     current sieve table	  
	  
       newprime = newprime + (int)(2*(8*SIEVE - prev));//the new initial value	
	
   } //end of the outer loop while(1)		 
     
}

//generate a random number between 0 and i-1
int randi(int i)
{
  return (rand()%i);
}
