#include "basetype.h"
#include "stacks.h"
#include "global.h"
#include "lists.h"
#include "poly.h"
#include "pol.h"
#include "sysfunc.h"
#include "charset.h"
#include "wsolve.h"
#include "check.h"
//#include "fwang.h"
//#include "lists_cs.h"
//#include "factorrs.h"
#include "express.h"
#include "projection.h"
//--------------------------PART4--------------------------------------
// simplify projection result in PART3 (in projection.cpp)
//--------------------------PART4---------------------------------------
// --- simplify1 ----
//for every qausi variety in the result of Project() call doRem
TList * Simplify1(TList * l,TList * ord)
{ 
	TList *qv,*newqv,* rt=new TList();
	for (TListNode *tmp=FIRSTNODE(l);tmp;RNEXT(tmp))
	{
		qv=(TList *)DATA(tmp);
		newqv=doRem(qv,ord);
		if(newqv) rt->append((TAtom *)newqv);
	}
	return rt;
};

// a qausi variety is denoted as: [[isZero],[notZero]]
// for every pol in [notZero]  rem=premas(pol,[isZero],ord)
// all rems creat a new [notZero_new]; return [[isZero],[notZero_new]]
TList * doRem(TList * l,TList * ord)
{
	TList * isZero=((TList *)(l->HEAD()))->Inverse();
   	TList * notZero=(TList *)(l->Part(2));
	TList * rt=new TList(), * remList=new TList();
	rt->append(l->HEAD()->Copy());
	TRIPoly *rem,*pol;
	for (TListNode *tmp=FIRSTNODE(notZero);tmp;RNEXT(tmp))
	{
		pol=(TRIPoly *)DATA(tmp);
		rem=premas_wdk(pol,isZero,ord);
		if(rem->IsZero())
		{
			delete rem;
            delete rt;
			delete remList;
			delete isZero;
			return 0;
		}
        remList->append((TAtom *)rem);
    }
	rt->append((TAtom *)remList);
	delete isZero;
	return rt;
};

// --- simplify2 ---
//for every quasi_variety denoted as [[isZero1],[notZero1]];
//factorize every polynomial in [notZero1];

// p is a polynomial, return a list which is a list of factors of polynomial p.
// p=3*(x+y)^2*(x-y); result=[x+y,x-y];
// p=2; result=[2];
TList * factorlist_chen(TRIPoly *p)
{ 
  int i,j;
  TList * l1,* l2,* r1;
  TRIPoly * l3;

  l1=p->Factor();
  if (l1->length()<3) 
  {
      r1=(TList *)(l1->HEAD()->Copy());
      delete l1;
      return r1;
  } 
  r1=new TList(); 
  for (i=3;i<=l1->length();i=i+2)
  {    l2=(TList *) (l1->Part(i));
      for (j=1;j<=l2->length();j++)
	{  l3=(TRIPoly *)l2->Part(j); 
	      r1->append((TAtom *)(new TRIPoly (* l3)));
	}
  } 
  delete l1;
  return r1;
};

//collect all factors of every polynomial in the list 'l' to a set 
TList *FactPolyListToSet(TList *l)
{
//	G_OUT("qv is: ",l);
	TList *factlist,*drt,*rt=new TList();
	for(TListNode *tmp=FIRSTNODE(l);tmp;RNEXT(tmp))
	{
		factlist=factorlist_chen((TRIPoly *)DATA(tmp));
		drt=rt;
		rt=drt->Union(factlist);
		delete drt;
		delete factlist;
	}
    return rt;
};

TList *Simplify2(TList *l)
{
	int i,len=l->length();
	TList *qv,*notZero,*isZero,*newqv;
	TList *rt=new TList();
	for (i=1;i<len+1;i++)
	{
		qv=(TList *)(l->Part(i));
		isZero=(TList *)(qv->HEAD());
		notZero=(TList *)(qv->Part(2));
        newqv=new TList();
		newqv->append((TAtom *)(isZero->Copy()));
        newqv->append(FactPolyListToSet(notZero));
        rt->append((TAtom *)newqv);
	}
	return rt;
};


//  ---Simplify3--------;
// for every two quasi-varieties denoted as (A) [[isZero1],[notZero1]], 
//                                      and (B) [[isZero2],[notZero2]].
// (1) if isZero1==isZero2 and notZero1 is a part of notZero2 then erase (B)
// (2) if isZero1==isZero2 and notZero2 is a part of notZero1 then erase (A)
// (3) if notZero1==notZero2 and isZero1 is a part of isZero2 then erase (B)
// (4) if notZero1==notZero2 and isZero2 is a part of isZero1 then erase (A)
int whichCase(TList *qv1,TList *qv2)
{
	TList *isZero1=(TList *)(qv1->HEAD());
    TList *notZero1=(TList *)(qv1->Part(2));
	TList *isZero2=(TList *)(qv2->HEAD());
	TList *notZero2=(TList *)(qv2->Part(2));
	TList *not1_Minus_not2=notZero1->Minus(notZero2);
    TList *not2_Minus_not1=notZero2->Minus(notZero1);
    TList *is1_Minus_is2=isZero1->Minus(isZero2);
	TList *is2_Minus_is1=isZero2->Minus(isZero1);
	int rt=0;
	if (isZero1->equal(isZero2) && not1_Minus_not2->length()==0)
		rt=1;
    if (isZero1->equal(isZero2) && not2_Minus_not1->length()==0)
		rt=2;
    if (not2_Minus_not1->length()==0 && not1_Minus_not2->length()==0
		&& is1_Minus_is2->length()==0)
		rt=4;
	if (not2_Minus_not1->length()==0 && not1_Minus_not2->length()==0
		&& is2_Minus_is1->length()==0)
		rt=3;
	delete not1_Minus_not2;
    delete not2_Minus_not1;
	delete is1_Minus_is2;
	delete is2_Minus_is1;
	return rt;
}

TList *Simplify3(TList *l)
{
//	G_OUT("Project_OD result is:",l);
	int i,j,casenum,len=l->length();
	bool append_l;
	TList *qv1,*qv2;
	TList *rt=new TList();
	rt->append(l->HEAD()->Copy());
    for(i=2;i<len+1;i++)
	{
		append_l=true;
		for(j=1;j<rt->length()+1;j++)
		{
			qv1=(TList *)(rt->Part(j));
			qv2=(TList *)(l->Part(i));
//          G_OUT("qv1",qv1);
//			G_OUT("qv2",qv2);
//			G_OUT("rt",rt);

			casenum=whichCase(qv1,qv2);
			switch(casenum)
			{
			case 0:
				break;
			case 1:
			case 4:
				append_l=false;
				j=rt->length();
				break;
			case 2:
			case 3:
				rt->dremove(j);
				j=j-1;
                break;
			}			
		}
//		cout<<"rt's length is:"<<rt->length()<<endl;
		if(append_l) rt->append(l->Part(i)->Copy());
//		G_OUT("rt1",rt);
//		cout<<"rt's length is:"<<rt->length()<<endl;
	};
	return rt;
};
