
#include "typedef.h"
#include "memory.h"
#include "stacks.h"
#include "global.h"
#include "poly.h"
#include "sysfunc.h"
#include "express.h"
#include "projection.h"
#include <stdio.h>
#include <iostream.h>
#include <string.h>
#include <new.h>
#include "basetype.h"
#include "number.h"
#include "lists.h"
#include "vectors.h"
#include "trpoly.h"
#include "pol.h"
#include "wsolve.h"
#include "check.h"
#include "rath.h"

#ifdef _WINDOWS
#include "..\gui\index.h"
#endif

TList * twave_sysfun(TList *l)
{
   RATH * r1 = new RATH(l);
   r1->twavesol();
   return r1->solve();
}

RATH::RATH()
{

}

RATH::RATH(TList *l)
{  
  input = 0;	
  if(l->length() <1) 
  { 
	  gerror(l,"should be a differential polynomial");
  }
  else if(!(input=poly_p(FIRST(l))))
  { 
	  gerror(FIRST(l),"should be a differential polynomial");
  }
}

RATH::~RATH()
{

}
TList * RATH::twavesol()
{ TList * sl = new TList();
  TList *flist=new TList();
  TList *llist=new TList();
  TList * vl,  *fvl,*pvarl,*diff_vl, *varl, *funl, *cons_vl,*par_vl,*ps;
  TVariable *w,*T,*m, *v,*fv=0,*tp1=0,*tp2=0;
  TRIPoly *pol,*mpol,*pol1,*m_value,trave_var=TRIPoly(TBigInt(0));
  //char *fun_nam;
  TBigInt mn1;
  int i,j,mn;
  
  if (!input) return sl;
  vl = input->getVL();
  G_OUT("vl=", vl);
  G_OUT("vl=", depend_relation);
  funl = TL(FIRST(depend_relation));
  fvl = new TList();
  for (i =1; i<=vl->length(); i++)
  {   fv = TV(vl->Part(i));
	  if (Isdiffvar(fv))
	  {  fvl->append(TA(fv)); 
	  }
  }
  if (fvl->length()==0) { gerror(0,"no differential variables"); return 0; }
  varl = TL(depend_relation->Part(2));
  G_OUT("varl=", varl);
  G_OUT("fvl=", fvl);
  pvarl = vl->Minus(fvl);
  pvarl = pvarl->Minus(funl);
  G_OUT("pvarl=", pvarl);
  cons_vl = new TList();  
  if (varl->length()==1)
  {   
     cons_vl->append(TA(new TRIPoly(TBigInt(1))));
     G_OUT("cons_vl=", cons_vl);
  }
  else
  {	 
      v = GenVar ("c"); cons_vl->append(TA(v)); 
  	  v = GenVar ("k1"); cons_vl->append(TA(v));
  	  v = GenVar ("k2"); cons_vl->append(TA(v));
  	  v = GenVar ("k3"); cons_vl->append(TA(v));
  	  v = GenVar ("k4"); cons_vl->append(TA(v));
  	  v = GenVar ("k5"); cons_vl->append(TA(v));
      G_OUT("cons_vl=", cons_vl);
      trave_var=trave_var-TRIPoly(TV(varl->Part(1)))*TRIPoly(TV(cons_vl->Part(1)));
      for(j=2;j<=varl->length();j++)
	  {   tp1 = TV(varl->Part(j));
          tp2= TV(cons_vl->Part(j));
	      trave_var=trave_var+TRIPoly(tp1,1)*TRIPoly(tp2,1);
	  }
      G_OUTP("trave_var=",trave_var);
  }
  // here generate variables w,T,m
  w = GenVar ("w");
  T= GenVar ("T");
  m =GenVar("m");
  pol = cp_poly(input);
  for (i = 1; i<=fvl->length();i++)
  { 
	v = TV(fvl->Part(i));
	//For ODE,the  function gen_tpol will be omited
	if (varl->length()!=1)
	    pol = gen_tpol(pol,v,w,cons_vl); //function gen_tpol
  } 
    //G_OUT("pol=",pol);
	TList *ofl=new TList();
	ofl->append(TA(w));
    diff_vl=pol->getVL();
	diff_vl=diff_vl->Minus(pvarl);
	diff_vl=diff_vl-> Minus(cons_vl);
	diff_vl=diff_vl-> Minus(ofl);
    G_OUT("diff_vl=",diff_vl);
    pol1=pol->IPvtp(w,TRIPoly(T,20));
    mpol=findm_pol(pol1,T,diff_vl); //function findm_pol
  //	G_OUT("mpol=",mpol);
    flist=fdlist(mpol,T,m,llist);  //function fdlist
	G_OUT("flist=",flist);
   	G_OUT("llist=",llist);
    m_value=find_m(flist,llist,m);  // function find_m
    //G_OUTP("m=",*m_value);
    mn1=m_value->icont();
	mn=mn1.GetInt();
	wout<<"the degree of the solution is :"<<" mn="<<mn<<endl;

	//G_OUT("pol=",pol);
    par_vl = new TList();  
    v = GenVar ("a0"); par_vl->append(TA(v)); 
    v = GenVar ("a1"); par_vl->append(TA(v));
    v = GenVar ("a2"); par_vl->append(TA(v));
    v = GenVar ("a3"); par_vl->append(TA(v));
    v = GenVar ("a4"); par_vl->append(TA(v));
    v = GenVar ("a5"); par_vl->append(TA(v));
    v = GenVar ("a6"); par_vl->append(TA(v));
    v = GenVar ("a7"); par_vl->append(TA(v));
    v = GenVar ("a8"); par_vl->append(TA(v));
	v = GenVar ("a9"); par_vl->append(TA(v)); 
    v = GenVar ("a10"); par_vl->append(TA(v));
    //OUT("par_vl=", par_vl);
	ps=cof_pol(pol,mn,par_vl,cons_vl,varl,T); // function cof_pol
    G_OUT("ps=", ps);
	ps_solve(ps, par_vl, cons_vl, pvarl,varl,mn);
    //ps_solve(ps,list1,clist,varl);

	return 0;

}
//  the definition of function gen_tpol

TRIPoly * RATH::gen_tpol(TRIPoly * p, TVariable *v, TVariable *w, TList *cons_vl)
{
   TRIPoly p_var,*pp1;
   TShortList *sdl; 
   TVariable *funnam;
   int d,e;
   sdl = getlist(v);
   funnam=getname(v);
   d = sdl->get(1);
   if (sdl->length()==1)
     p_var=TRIPoly(TBigInt(1));
   else
   { // derivative of t
     if (d) 
	   {	   
	     p_var= TRIPoly(TV(cons_vl->Part(1)),d);
		 if (d%2!=0)
     		 p_var=(TRIPoly(TBigInt(-1))* p_var);
	  	 }
     else p_var =  TRIPoly(TBigInt(1));

     for(int i = 2; i<=sdl->length(); i++)
	 { e = sdl->get(i);
       d = d + e;
       if (e) p_var = p_var * TRIPoly(TV(cons_vl->Part(i)),e);
	 }
   }
   TShortList *sh1 =new TShortList(0);
   sh1->append(d);
   TVariable *w1 =formvar(w,sh1);
   TRIPoly pps;
   pps=TRIPoly(w1,1)*p_var;
   pp1=p->IPvtp(v,TRIPoly(w1,1)*p_var);
   pp1=pp1->IPvtp(TV(funnam),TRIPoly(w,1));
   //G_OUT("pp1=",pp1);
   return pp1; 
}

// the definition of function findm_pol 

TRIPoly * RATH::findm_pol(TRIPoly *p,TVariable *T,TList *diff_vl)
{
 
  TRIPoly* tanh_p=p;
  TVariable *ofl;
  TShortList *sl;
  for (int i=1; i<=diff_vl->length(); i++)
  { ofl=TV(diff_vl->Part(i));
    sl=getlist(ofl);
    tanh_p=tanh_p->IPvtp(ofl,TRIPoly(T,20+sl->get(1)));
  }
  return(tanh_p);
}

// the definition of function fdlist

TList* RATH::fdlist(TRIPoly *p,TVariable *T,TVariable *m,TList* &ldeg_list)
{
  TRIPoly pp1,tanp,va=TRIPoly(TBigInt(1));
  TList *var_lst=new TList(),*fdeg_list=new TList();
  TShortList *ideg_list=new TShortList(0);
  TShortList *fmax_list=new TShortList(0);
  TShortList *lmax_list=new TShortList(0); 
  int dgreeT,maxquo,maxrem,maxval,tmp;

  tanp=*p;
  var_lst->append(TA(T));
  for( ; ;)
  {
	  pp1=tanp.IPldt(var_lst);
      dgreeT=pp1.Degree(T);
      ideg_list->append(dgreeT);
   	  tanp=tanp-pp1;
      if (tanp==TRIPoly(TBigInt(0))) break;
  }
  G_OUT("ideg_list=",ideg_list);
  maxrem=0;
  maxquo=0;
  for (int i=1;i<=ideg_list->length();i++)
  {
	 if (ideg_list->get(i)%20>maxrem)     
             maxrem=ideg_list->get(i)%20;
     if (ideg_list->get(i)/20>maxquo)     
             maxquo=ideg_list->get(i)/20;
  }
 for (i=1;i<=ideg_list->length();i++)
  {
     if (ideg_list->get(i)%20==maxrem)     
         lmax_list->append(ideg_list->get(i));
     if (ideg_list->get(i)/20==maxquo)
         fmax_list->append(ideg_list->get(i));
 }
 if (lmax_list->length()>1)
 {
   maxval=0;
   for(i=1;i<=lmax_list->length();i++)
   { if (lmax_list->get(i)>maxval)
        maxval=lmax_list->get(i);
   } 
   lmax_list=new TShortList(0);
   lmax_list->append(maxval);
 }
for(i=1;i<=fmax_list->length();i++)
 {
	 for(int ii=1;ii<=lmax_list->length();ii++)
     {
		 tmp=lmax_list->get(ii);
         if (fmax_list->get(i)==tmp)
			 fmax_list->deleteterm(i);
	 }
 }
for(i=1;i<=lmax_list->length();i++)
 {	 
	 dgreeT=lmax_list->get(i);
	 va=TRIPoly(TBigInt(dgreeT/20))*TRIPoly(m,1)+TRIPoly(TBigInt(dgreeT%20));
     ldeg_list->append(TA(new TRIPoly(va)));
 }

 for(i=1;i<=fmax_list->length();i++)
 {	 
	 dgreeT=fmax_list->get(i);
	 va=TRIPoly(TBigInt(dgreeT/20))*TRIPoly(m,1)+TRIPoly(TBigInt(dgreeT%20));
     fdeg_list->append(TA(new TRIPoly(va)));
 }
return fdeg_list;
}

// the definition of function find_m

TRIPoly* RATH::find_m(TList *list1, TList *list2, TVariable *m)
{
	TList *var_lst=new TList(),*beqlt=new TList();
    TRIPoly *pol,pol1,pol2,*cofpol,*m_value=new TRIPoly(TBigInt(0)) ;
    for (int i=1;i<=list1->length();i++)
	{ pol1=(*(TRIPoly *)list1->Part(i)-*(TRIPoly *)list2->Part(1));
      beqlt->append(TA(new TRIPoly(pol1)));
    }
 //   G_OUT("beqlt=",beqlt);
	for (i=1;i<=beqlt->length();i++)
	{
		pol=(TRIPoly *)beqlt->Part(i);
		cofpol=pol->Coefficient(m,1);
          if (cofpol->pis0())
               continue;
	 	  else
		  { var_lst->append(TA(m));
	        pol1=pol->IPldt(var_lst); 
	        pol2=*pol-pol1;
		    pol2=TRIPoly(TBigInt(-1))*pol2;
		    m_value=new TRIPoly(pol2/(*cofpol));
            //return m_value;  
		  }  
	}
 return m_value;  
}

// the definition of function cof_pol

TList* RATH::cof_pol(TRIPoly* pol,int mn,TList *list1,TList *clist,TList *varl,TVariable *T)
{
  TRIPoly *pol1,*po3,*pol2,pol4,pol5,pis=TRIPoly(TBigInt(0)),pgcd=TRIPoly(TBigInt(0));
  TList *ps,*pp,*vl,*diff_vl=new TList(),*T_vl=new TList(),*p_factors,*part_pol_vls;
  TVariable *funnam;
  unsigned long mn1;
  int degT,jj;
  //G_OUT("pol=",pol);
  vl=pol->getVL();
  for (int i=1;i<=vl->length();i++)
     if (Isdiffvar(TV(vl->Part(i))))
	 {
	     funnam=getname(TV(vl->Part(i)));
	  	 diff_vl->append(vl->Part(i));
	 }
		 //G_OUT("diff_vl=",diff_vl);
  pis=pis+TRIPoly(TV(list1->Part(1)),1);
  for (i=1;i<=mn;i++)
  	pis=pis+TRIPoly(T,i)*TRIPoly(TV(list1->Part(i+1)),1);
  for(i=1;i<=diff_vl->length();i++)
	{
	  mn1=pis.PolyLen();
	  pol1=Treplace(TV(diff_vl->Part(i)),pis,mn1,T);
      T_vl->append(TA(pol1));
	}  
   //G_OUT("T_vl=",T_vl);
  pol1=pol;
  for(i=1;i<=diff_vl->length();i++)
   { 
     pol2=Treplace(TV(diff_vl->Part(i)), pis,mn,T);
     //G_OUT("pol2=",pol2);
     pol1=pol1->IPvtp(TV(diff_vl->Part(i)),*pol2);
   } 
  pol1=pol1->IPvtp(funnam,pis);
  ps=new TList();
  degT=pol1->Degree(T);
  wout<<"degT="<<degT<<endl;
  while (degT>=0)
   {
	 po3=pol1->Coefficient(T,degT);
     //G_OUT("po3=",po3);  
     if (!po3->pis0())
       ps->append(TA(po3));
     degT=degT-1; 
   }
  //G_OUT("ps=",ps);
  pp=new TList();
  for(i=1;i<=ps->length();i++)
  {  pol4=(*(TRIPoly *)(ps->Part(i)));
     pol5=pgcd.mipgcd(pol4);
	 pgcd=pol5;
  }
  //G_OUTP("pgcd=",pgcd);
  if (!pgcd.pis1())
   for(i=1;i<=ps->length();i++)
  { pp->append(TA(new TRIPoly(*(TRIPoly *)(ps->Part(i))/pgcd)));
	ps=pp->Clone();
  }
    //  G_OUT("pp=",pp);
      //G_OUT("ps=",ps);
  int j;
  
  TList *ll1,*ll2=new TList(),*pps=new TList();
  TRIPoly *pp1,*pp2,pp3,pp4,*vvv1;
  int ij,ii,g1;
  TList *lp1;
 //
  ll2->append(list1->Part(mn+1));

  for(i=1;i<=varl->length();i++) 
  ll2->append(clist->Part(i));
  //G_OUT("ll2=",ll2);
  p_factors=new TList();
  part_pol_vls=new TList();
  
  for(i=1;i<=ps->length();i++)
  { pp2=(TRIPoly *)(ps->Part(i));
    p_factors=((TRIPoly *)(ps->Part(i)))->Factor();
   // G_OUT("p_factors=",p_factors);
  
	for(j=1;j<=p_factors->length();j=j+2)
    
		if (((TRIPoly *)((TList *)(p_factors->Part(j)))->Part(1))->IPunt())
	   {   ll1=(TList *)(p_factors->Part(j));
	     //  G_OUT("ll1=",ll1);
		  // G_OUT("ll2=",ll2);
		   vvv1=(TP(ll1->Part(1)->Copy()));
		  // G_OUT("vv1=",vvv1);
		
		   for(jj=1;jj<=ll2->length();jj++)
		   { pp3=TRIPoly(TV(ll2->Part(jj)))-(*vvv1);
           
		   if (pp3.pis0())  
			  {  //G_OUTP("pp3=",pp3);
			     ij=((TBigInt *)(p_factors->Part(j+1)))->GetInt();
		
				 for(ii=1;ii<=ij;ii++)
			  	    pp2=new TRIPoly(*pp2/(*vvv1));
			     
			  }
		   }
	   }
	   else
		 if (((TRIPoly *)((TList *)(p_factors->Part(j)))->Part(1))->IsNumber())
		 {     
           lp1=(TList *)(p_factors->Part(j));

		   //G_OUT("lp1=",lp1);
		   
		   g1=(((TRIPoly *)(lp1->Part(1)))->icont()).GetInt();
           
		   ij=((TBigInt *)(p_factors->Part(j+1)))->GetInt();
		   
		   for(ii=1;ii<=ij;ii++)
		     pp2=new TRIPoly(*pp2/(TRIPoly(TBigInt(g1)))); 
		 } 
 	 pps->append(TA(pp2));
  }

    //G_OUT("pps=",pps);
    
  ps=pps->Clone();
  //G_OUT("ps=",ps);
  return ps;



}
// the definition of function Treplace

TRIPoly* RATH::Treplace(TVariable *var1,TRIPoly pis,int mn,TVariable *T)
{
   TRIPoly *pol1=new TRIPoly(TBigInt(0));
   TRIPoly pol2,pol3,term,*cof1,pol4=TRIPoly(TBigInt(0));
   TShortList *short1,*short2=new TShortList();
   TList *var_lst=new TList();
   TVariable *var2,*nam1;
   int sub1,deg1;
   unsigned long mn1;
   pol3=pis;
   short1=getlist(var1);
   //G_OUT("var1=",var1);
   nam1=getname(var1);
  // G_OUT("nam1=",nam1);
   var_lst->append(TA(T));
       
	   for (int i=1;i<=mn;i++)
       {   term=pol3.IPldt(var_lst);
		   deg1=term.Degree(T);
		   cof1=term.Coefficient(T,deg1);
		   deg1=deg1-1;
	       // wout<<"deg1="<<deg1<<endl;
		   if (deg1==0)
             pol4=pol4+TRIPoly(TBigInt(deg1+1))*(*cof1)*(*diffT(T));
		   else
		     pol4=pol4+TRIPoly(TBigInt(deg1+1))*(*cof1)*TRIPoly(T,deg1)*(*diffT(T));
		   pol3=pol3-term;
		   
	   }
       pol1=new TRIPoly(pol4);
       if (short1->get(1)==1)
	      return pol1;
       else
	   {
	     sub1=short1->get(1)-1;
         short2->append(sub1);    
         var2=formvar(nam1, short2);
	     pis=pol4;
		 //G_OUT("p4=",(&pol4));
		 mn1=pol4.PolyLen();
         return Treplace(var2,pis,mn1-1,T);
	 
	   }
}

//the definition of function diffT

TRIPoly* RATH::diffT(TVariable *T)
{ TRIPoly *pol1,pol2;
  pol2=TRIPoly(TBigInt(1))-TRIPoly(T,1)*TRIPoly(T,1);
 // G_OUTP("pol2=",pol2);
  pol1=new TRIPoly(pol2);
  return pol1;

}

// the definition of function ps_solve()

TList* RATH::ps_solve(TList *ps, TList *sclist, TList *tclist, TList *plist,TList *varl,int mn)
{
  TList *lae,*lkc,*lce,*list1=new TList(),*list2,*orderl,*ds;
  int i,j;  
  TRIPoly *p1,*p2,p3;
 
  // G_OUT("ps3=",ps);
  // G_OUT("sclist=",sclist);
  // G_OUT("tclist=",tclist);
  // G_OUT("plist=",plist);
  for(i=1;i<=ps->length();i++)
  {
	  p1=(TRIPoly *)(ps->Part(i));
	 // G_OUT("p1=",p1);
	  lae=p1->getVL();
	 // G_OUT("lae=",lae);
      list2=list1->Union(lae);
      list1=list2; 
  }
  // G_OUT("list2=",list2);
  lae=list2->Intersect(sclist);
  G_OUT("lae=",lae);
  lkc=list2->Intersect(tclist);
  G_OUT("lkc=",lkc);
  lce=list2->Intersect(plist);
  G_OUT("lce=",lce);
  orderl=lae->Union(lkc);
  // G_OUT("orderl=",orderl);
  list1=orderl;
  orderl=list1->Union(lce);
  G_OUT("orderl=",orderl);
  ds=lkc;
  list2=new TList();
  list2->append(lae->Part(1));
  G_OUT("list2=",list2);
  ds=lkc->Union(list2);
  G_OUT("ds=",ds);
  list2=new TList();
  list2=RootsOfPolys(ps,orderl,ds); 
   G_OUT("list2=",list2);
  // TList * RootsOfPolys(TList *polys,TList *ord,TList *ds)









return(0);
}







//the definition of function solve

TList * RATH::solve()
{
return 0;
}
