#include <iostream.h>
#include "basetype.h"
#include "global.h"
#include "poly.h"
#include "pol.h"
#include "slistnodetrun.h"
#include "express.h"
#include "run.h"
#include "number.h"
#ifdef _WINDOWS
#include "..\gui\index.h"
#endif

TRunList::TRunList(TRunType t)
{ 
  type=t;
};

TRunList::~TRunList()
{};

TRunType TRunList::Run()
{

 if(first()==NULL) return TNORMAL;
 SListNodeTRun *tmp1=first();
 TRunType rt=TNORMAL;

 for(;tmp1!=NULL; )
 {
  rt=tmp1->getdata()->Run();
  if(type == TBREAK && rt==TCONTINUE )  //Loop TYPE
    {
      return TNORMAL;
    }
 
  if(rt!=TNORMAL && rt!=TCONTINUE ) break;
  tmp1= tmp1->next;
 }

 if(rt==TERROR || rt==TNORMAL) return rt;
 if(rt==TCONTINUE ) return rt;
 if( type==TBREAK && rt==TBREAK) return TBREAK;
 switch(type)     //RunList's type
   {
     case TNORMAL:
                break;
     case  TRETURN: // In a porc/func defination
        switch(rt)
        {
         case TRETURN : rt=TNORMAL;
                break;

         case TBREAK:   rt=TERROR;
                break;
         default: break;
        }
       break;
     case TBREAK:     // in Loop
        switch(rt)
        {
         case TRETURN:
                break;
         case TBREAK: rt=TNORMAL;
                break;
         default: break;
        }
       break;
     default: rt=TERROR;
        break;
 }

 return rt;
};

void TRunList::show(outtype& out  ) const  
{
 SListNodeTRun *ln=first();
 while (ln) {
        ln->display(out);
        ln=ln->next;
        if(ln) out<<",";
        }
}

void TRunList::print(outtype& out  ) const 
{
 SListNodeTRun *ln=first();
 while (ln) {
        ln->display(out);
        ln=ln->next;
        if(ln) out<<",";
        }
}

void TRunList::display(outtype& out  ) const 
{
 SListNodeTRun *ln=first();
 while (ln) {
        out<<"\t  ";
        ln->getdata()->show(out);
        ln=ln->next;
	if (ln)
            out<<endl;
        }
}

TAtom* TRunList::Copy()
{
 TRunList* nr;
 nr=new TRunList();
 //nr=(TRunList*)( SList<TRun>::Copy() );

 //------------------------------------------
 SListNodeTRun * nn=0, *tmp=head;
 while(tmp)
  {
        nn=tmp->Clone();
        nr->append(nn);
        tmp= tmp->next;
 }
 nr->SetType(type);

 return (TAtom*)nr;
} 

TRunList* TRunList::Clone()
{
 return (TRunList*)Copy();
} 
  
void *TRunList::operator new(size_t)
{
 return  (TRunList*)StarMem->alloc();
};

void TRunList::operator delete(void *p)
{
 (StarMem->free(p));
};



//==========================================================
TAtom * TString::Copy()
{
return new TString(strdup(str));
// return 0;
};

TAtom* TString::eval()
{
 return this->Copy();
}

TString::TString(char *s)
{
  str=s;
};
TString::~TString()
{//delete str;
};

void TString::show(outtype& out) const
{display(out);};

void TString::print(outtype& out) const
{display(out);};

void TString::display(outtype& out) const
{
 out<<'"'<<str<<'"';
};

inline DataType TString::TypeID() const
{return Strings;};

void* TString::operator new(size_t)
{
 return  (TString*)StarMem->alloc();
};
void  TString::operator delete(void *p)
{
 (StarMem->free(p));
}
//===================================================================================
 