#include <stdio.h>
#include <iostream.h>
//#include <fstream.h>
#include <string.h>
#include <new.h>
#include "basetype.h"
#include "number.h"
#include "lists.h"
#include "vectors.h"

#include "matrix.h"
#include "global.h"
//#include "num_prime.h"
#include "prime.h"
#include "shortlist.h"
extern "C"{
#include <time.h>
#include <sys/timeb.h>
}
#include "global.h"

ShortNode::ShortNode()
{	
	data = 0;	
	next = NULL;
}

ShortNode::~ShortNode()
{	

}

void * ShortNode::operator new(size_t)
{
  return (ShortNode *)StarMem->alloc();
}

void ShortNode::operator delete(void * p)
{
  StarMem->free(p);
}

TShortList::TShortList():TExpVal()
{
	head=0;
}

TShortList::TShortList(int len):TExpVal()
{
	if(len<0) {cout<<"initial list error!"<<endl; return;}
	if(len==0) {head=NULL; return;}
 	int i; ShortNode * current = new ShortNode();
	head=current; 
	for(i=2;i<=len;i++)     //create 1..length node 
	{	
		current->next = new ShortNode;
		current = current->next;
	} 
}

TShortList::~TShortList()      
{

	int i, len=length(); 
	if(len==0)	return;
	ShortNode* current = this->head,  *nx= current->next;
		for(i=1;i<=len-1;i++)
		{
			 delete current;
			 current = nx; nx = nx->next;
		}
		delete current;
	head=NULL;

}

//return the list's length
int TShortList::length()
{
	int i=0; ShortNode * current = this->head;
	while(current!=NULL) 
	{
		i+=1;
		current = current->next;
	}
	return i;	
}


//judge if the list is empty
bool TShortList::empty()
{
	if(this==NULL)	return 1;
	if(this->head==NULL) return 1;
	else return 0;
}

//return the list's first value
short TShortList::first()
{
	if(empty()) {cout<<"this is a empty list, no first element!"<<endl; 
				 return 0; }
	else{
		return  this->head->data;
	}
}

//return the rest list except the 1st value
TShortList* TShortList::rest()
{
	if(empty()) {cout<<"this is a empty list!"; return this; }
	TShortList *newlist=new TShortList; 
	newlist->head=this->head->next;
	return newlist;
}


//put a new value in the end of the list
void TShortList::append(short value) 
{
	if(empty())	
	{
		this->head=new ShortNode;
		ShortNode * cur =this->head;
		cur->data=value;
		cur->next=NULL;
	}
	else
	{
	ShortNode * current =this->head, *nx=this->head;
	while(nx!=NULL)
	{
		current=nx; nx=nx->next;
	}
	current->next = new ShortNode;
	current=current->next;
	current->data=value;
	current->next=NULL;

	}
}

//in the nth's positon insert a value 
void TShortList::insert(int n, short value)
{
	if(empty())  {cout<<"this is a empty list, operate error!"; 
						}
	int i, len=length(); ShortNode * current =this->head;
	if(n>len)  {cout<<" out of range!"<<endl; }
	if(n==1)
	{
		ShortNode* newnode = new ShortNode;	
		this->head = newnode; 
		newnode ->data = value; 
		newnode ->next = current;
	}
	for(i=1;i<=n-2;i++)
	{
		current = current->next;
	}
	ShortNode* nx= current->next;
	ShortNode* newnode = new ShortNode;
	newnode->data=value; 
	current->next = newnode;
	newnode ->next = nx;
}


void TShortList::deleteterm(int n)
{
	if(empty())  {cout<<"this is a empty list, operate error!"; }
	if(n>length()||n<=0)  {cout<<" out of range!"<<endl; }
	ShortNode* current= this->head;
	for(int i=1;i<=n-2;i++)
	{
		current = current->next;
	}
	ShortNode* tmp=current->next;
	current->next = tmp->next;
	delete tmp;
}

//merge 2 lists into one  bigger list
TShortList* merge(TShortList* sl1, TShortList* sl2) 		
{
	int i, len1=sl1->length(), len2=sl2->length();
	TShortList *newlist = new TShortList(len1+len2);
	ShortNode *cur = newlist->head, *s1=sl1->head, *s2=sl2->head; 
	for(i=1;i<=len1;i++)
	{
		cur->data=s1->data;
		cur=cur->next; s1=s1->next;
	}
	for(i=1;i<=len2;i++)
	{
		cur->data = s2->data;
		cur=cur->next; s2=s2->next;
	}
	return newlist;
}


//modify the n'th node's value
void TShortList::modify(int n, short value)
{
	if(this==NULL) {cout<<"this is a NULL point!"<<endl; return;}
	if(empty()) {cout<<"this is a empty list!"<<endl; exit(1);}
	if(n>length())	{cout<<"out of range"<<endl; exit(1); }
	
	int i; ShortNode * current =this->head;
	for(i=1;i<=n-1;i++)  current=current->next;
	current->data = value;
}

void TShortList::display()
{
	if(this==NULL) {cout<<"this is a NULL point!"<<endl; return;}
	if(empty()) {cout<<"this is a empty list!"<<endl; return;}
	int i,len=length(); ShortNode * current =this->head;
	cout<<"[";
	for(i=1;i<=len-1;i++)
	{
		cout<<current->data<<", ";
		current=current->next;
	}
	cout<<current->data<<"]";
}

short TShortList::get(int n)
{
	if(empty()) {cout<<"this is a empty list!"<<endl; return 0;}
	if(n>length())	{cout<<"out of range"<<endl; return 0;}

	int i; ShortNode * current =this->head;
	for(i=1;i<=n-1;i++)  current=current->next;
	return current->data;
}

int	compare(TShortList *sl1, TShortList *sl2)
{
	if(sl1==NULL&&sl2==NULL) return 0;
	else if(sl1==NULL)	 return -1;
	else if(sl2==NULL)	 return 1;
	else if(sl1->empty()&&sl2->empty())	return 0;
	else if(sl1->empty())	 return -1;
	else if(sl2->empty())	 return 1;
	ShortNode *s1=sl1->head, *s2=sl2->head; 
	while(s1!=NULL && s2!=NULL)
	{
		if(s1->data > s2->data)	return -1;
		else if(s1->data < s2->data)	return 1;
		s1=s1->next;
		s2=s2->next;
	}
	if(s1==NULL&&s2==NULL) return 0;
	else if(s1==NULL)	return -1;
	else  return 1;  //if(s2==NULL)	
}

void * TShortList::operator new(size_t)
{
  return (TShortList *)StarMem->alloc();
}

void TShortList::operator delete(void * p)
{
  StarMem->free(p);
}

int TShortList::length_char()
{
	char temp[5]; int len=0; 
	ShortNode * current =this->head;
	while(current!=NULL)
	{	
//		itoa((int)(current->data), temp, 10);
		sprintf(temp,"%d",(int)(current->data));
		len=len+strlen(temp);
		current=current->next;
	}
	return len;
}

char * TShortList::convert(char *result)
{
	char temp[5];
	ShortNode * current =this->head, *nx;
	if(current!=NULL)
	{	
//itoa((int)(current->data), temp, 10);
		sprintf(temp,"%d",(int)(current->data));
		strcpy(result, "[");
		strcat(result, temp);
//		strcat(result, ",");
		nx = current->next;
		if(nx!= NULL)		current = current->next;  
		else current=NULL;
	}
	while(current!=NULL)
	{	
		
//itoa((int)(current->data), temp, 10);
		sprintf(temp,"%d",(int)(current->data));
		strcat(result, ",");
		strcat(result, temp);
		current=current->next;
	}
//		itoa((int)(current->data), temp, 10);
		//sprintf(temp,"%d",(int)(current->data));
		//strcat(result, temp);
		strcat(result, "]");
		strcat(result, "\0");

	return result; 
}

TShortList* TShortList::copy()
{
 	TShortList * n = new TShortList;
	if(empty()) return n;
	ShortNode * cur = this->head , *cur1;  
	if(cur!=NULL)
	{	n->head = new ShortNode; cur1 = n->head;
		cur1->data = cur->data;
		cur = cur->next;
	}
	while(cur!=NULL)
	{	
		cur1->next = new ShortNode;
		cur1 = cur1->next;
		cur1->data = cur->data;
		cur = cur->next;
	} 
	return n;
}

	
	
