#ifndef __SHORT_LIST__
#define __SHORT_LIST__

#include <stdio.h>
#include <string.h>
#include <new.h>

#include "basetype.h"

#include "global.h"
//#include "templist.h"

class ShortNode
{
		friend TShortList;
		friend TShortList* merge(TShortList* sl1, TShortList* sl2);
		friend int	compare(TShortList *sl1, TShortList *sl2);
		short data;
		ShortNode* next;
public:
		ShortNode();
		virtual ~ShortNode();

	    void * operator new(size_t);
	    void operator delete(void *);

};

class TShortList:public TExpVal  
{
		ShortNode* head;
public:
        TShortList() ;
	    virtual ~TShortList();

		TShortList(int len);
		int 		length(); 
		int 		length_char(); 
		bool		empty();
		short		first();
		TShortList*  rest();
        void		modify(int n, short value);  
		void		insert(int n, short value);  
		void		deleteterm(int n);  
		short		get(int n);
		void		append(short value);            
		char *		convert(char *result);
					//must delete the pointer after using
		virtual	void		display(); 		
		friend  int			compare(TShortList *sl1, TShortList *sl2);
		friend TShortList*	merge(TShortList* sl1, TShortList* sl2); 	
					//create a new list, must delete the pointer after using
		TShortList*	copy();
					//create a new list, must delete the pointer after using
		virtual DataType TypeID()const{ return ShortList;};
		void * operator new(size_t);
		void operator delete(void *);
};

#endif
