
#ifndef __SListTVariable_H__
#define __SListTVariable_H__


#include "basetype.h"
#include "global.h"
#include "express.h"

class TVariable;
class TAtom;


class SListTVariable
{
 protected:
	friend class SListNodeTVariable;
	SListNodeTVariable   *head, *tail;
	int Total;
 public:
	SListTVariable();
	virtual ~SListTVariable();

	virtual void append(TVariable   *data);
	virtual void append(SListNodeTVariable *data);
	virtual void append(SListTVariable *list);

	virtual void insert(TVariable  *data, SListNodeTVariable *pos=0);
	virtual void insert(SListNodeTVariable * data, SListNodeTVariable *pos=0);
	virtual void insert(SListTVariable  *list, SListNodeTVariable *pos=0);
	virtual void remove(SListNodeTVariable *data);           //removing a 'data'

	SListNodeTVariable *first()const {return head;}
	SListNodeTVariable *last()const  {return tail;}
	virtual int   length() {return Total;}

	SListTVariable * Clone() ;
	SListTVariable * Copy() ;

	virtual void cleardata(); 
	   //clear data in node, delete all nodes except data

        virtual void display(outtype& out =wout) const;
        virtual void show(outtype& out =wout) const;
        virtual void print(outtype& out =wout) const;
 
        void* operator new(size_t);
        void  operator delete(void *);
 
};

class SListNodeTVariable
{
 friend class TVarList;
 protected: 
  TVariable *data;
  unsigned long * RefCount;
 public:
  SListNodeTVariable * next;

  SListNodeTVariable(TVariable *h=NULL);
  virtual ~SListNodeTVariable();

  virtual TVariable   *getdata();
  virtual int  compare(SListNodeTVariable *);

  virtual void display(outtype& out =wout) const;
  virtual void show(outtype& out =wout) const;
  virtual void print(outtype& out =wout) const;
 
  void* operator new(size_t);
  void  operator delete(void *);

   unsigned long& Ref()const { return *RefCount; };
   unsigned long SetRef(unsigned long *n);
    unsigned long RefInc() { return ++(*RefCount); };
    unsigned long RefDec() { return --(*RefCount); };

    SListNodeTVariable* Clone();
    virtual void  ClearMem();
    virtual int   SetMem( TVariable *);
//=====================================================================
//    friend  bool  SameData(const SListNodeTVariable*,const SListNodeTVariable*);

};

#endif

