//#include <stdafx.h>
#include <stdio.h>
#include <stdlib.h>
#include <malloc.h>
#include <iostream.h>
#include <string.h>

#include "basetype.h"
#include "global.h"
#include "express.h"
#include "poly.h"
#include "trpoly.h"
#include "pol.h"
#include "Tbl2ListTVariable.h"
#include "nvar.h"
#include "check.h"
//#include "yacc.tab.h"
#ifdef _WINDOWS
#include "..\gui\index.h"
#endif 
#include "stacks.h"
#include "lists.h"
#define WMODE   (workpstat->mode)
//#define __DELETE_DEBUG__
//#define __SHOW_STACK__
long ook=0;
extern TRunType part(TList*);
//extern YYSTYPE	yylval;		

PState::~PState()
{
 if(mode==PProcRun && vartbl) delete vartbl;
}

void PState::show(outtype& out) const
{
 display();
}

void PState::print(outtype& out) const
{
 display();
}

void PState::display(outtype& out) const
  {
    switch(mode)
    {
       case PNormal: out<<"[mode: Normal"<<" : ";
   		break;
       case PExplain: out<<"[mode: Explain"<<" : ";
   		break;
       case PProcDef: out<<"[mode: ProcDef"<<" : ";
   		break;
       case PProcRun: out<<"[mode: ProcRun"<<" : ";
   		break;
       default: out<<"[mode:"<<mode<< " : ";
              break;
   }
    out<<" RunList : ";
    if(runlist) runlist->display(out);out<<":";
    out<<" VarList : ";
    if(vartbl) vartbl->display(out);
    out<<" ]\n";
  }

//============================================================
void *PState::operator new(size_t)
{
 return  (PState*)StackMem->alloc();
};

void PState::operator delete(void *p)
{
 (StackMem->free(p));
};

///=============================================================

TListCall::TListCall(TVariable *s, TList *rl):TProcCall(s,rl)
{
}
TListCall::~TListCall()
{
}

TAtom*  TListCall::eval()
{

 TRunType rt=Run();
 return ReturnValue;
}

TRunType TListCall::Run()
{
 TRunType rt=TNORMAL;
 ReturnValue=0;

 if(name->type == TLIST)
 {
  TList *nl=new TList();
  nl->append( name->GetValue()->Copy() );
  nl->append( paraList->first()->Clone() );
  rt= ::part(nl);
  delete nl;
/*  if(ReturnValue==0)
      ReturnValue=Copy();
*/
 }
 else	 ReturnValue = 0;
 if(ReturnValue == 0)
 {
	char temp[8];   char result[128];
	int len=paraList->length();  
	char * nm = name->GetName();
	strcpy(result, nm);
	TNumber *num;	TBigInt *n1;
	int n2;			TList *l = paraList;
	if(len != 0) 
	{
	strcat(result, "[");

	num=(TNumber*) (l->Part(1));
	n1=(TBigInt *)num->GetPtr();
	n2=n1->GetShort(0);
	sprintf(temp,"%d", n2);
	strcat(result, temp); int i=2;
	for(i;i<=len;i++) 
	{	
	  num=(TNumber*) (l->Part(i));
	  n1=(TBigInt *)num->GetPtr();
	  n2=n1->GetShort(0);
		sprintf(temp,"%d", n2);
		strcat(result, ",");
		strcat(result, temp);
	}
		strcat(result, "]");
		strcat(result, "\0");
	}

  	TVariable *tv;
		TVariable *tmp=workpstat->vartbl->lookup(nm);
		if (tmp) tv = tmp;
		else {
			if(workpstat->mode==PProcDef) 
			   tv = new TVariable(nm,TVARIABLE);
			else tv = new TVariable(nm);
			tv->order=SerNum++;
			workpstat->vartbl->append(tv);
			}

		tmp=workpstat->vartbl->lookup(result);
		if (tmp) tv = tmp;
		else {
			if(workpstat->mode==PProcDef) 
			   tv = new TVariable(result,TVARIABLE);
			else tv = new TVariable(result);
			tv->order=SerNum++;
			workpstat->vartbl->append(tv);
			}
	 	ReturnValue = (TAtom *)(tv->Copy());
 
//		ReturnValue = Copy();
	}

 return rt;
};

bool TListCall::IsDefined()
{
 if( name->GetValue() ) return true; else return false;
}

void TListCall::display(outtype& out)const
{
 name->display(out);
 out<<"[";
 paraList->display(out);
 out<<"]";
}

void TListCall::print(outtype& out)const
{
 name->print();
 out<<"[";
 paraList->display(out);
 out<<"]";
}

void TListCall::show(outtype& out)const
{
 display(out);
}

TAtom *TListCall::Copy()
{
 TList* nrl=paraList->Clone();
 TListCall *nc=new TListCall(name,nrl);
 return (TAtom *)nc;
}

void *TListCall::operator new(size_t)
{
 return  (TListCall*)StarMem->alloc();
};

void TListCall::operator delete(void *p)
{
 (StarMem->free(p));
};

//==============================
TProcCall::TProcCall(TVariable *s, TList *rl):TAtom(),TRun()
{
 name=s;
 paraList=rl;
}

TProcCall::~TProcCall()
{
#ifdef __DELETE_DEBUG__  
//wout<<"In ProcCall delete :"; if(paraList)paraList->display();wout<<endl;

#endif
 if(paraList) 
    {
//     paraList->cleardata();
     delete paraList;
   }
}

extern bool run;

TAtom*  TProcCall::eval()
{
 TRunType  rt;
 ReturnValue=0;

 if(name->type == TSYSFUNCTION  && run)
 {
      rt=  name->SysRun( paraList);
 } 
 else rt=Run();

 if(rt!=TNORMAL )
       {
        //wout<<"Error in ProcCall:";print();
        //wout<<endl;
        return 0;
       }
 if(ReturnValue==0)
      return Copy();
     else return ReturnValue;
}

TRunType TProcCall::Run()
{
 TRunType rt=TNORMAL;
 TProcDef *p=name->GetProc();
 // TVariable *nt;
 Tbl2ListTVariable * nt;
 if (!p) {
//	wout<<"no such process\n";
	return TNORMAL;
	}
 nt=SetActualPara();
 if (!nt) {
//	wout<<" found error in Run() of Procall\n";
	return TERROR;
	}
// wout<<" NewSTACK ";
 workpstat=new PState(PProcRun, nt);
 savestack->PUSH(workpstat);
 long kkk=savestack->length();
// wout<<" "<<kkk<<"ENDNewSTACK ";
 rt=p->GetDo()->Run();
 //wout<<" before POP "<<savestack->length()<<" ";
 workpstat=savestack->POP();
 //wout<<" POP ";
 if(rt==TRETURN) rt=TNORMAL;
 return rt;
};

bool TProcCall::IsDefined()
{
 if( name->GetProc() ) return true; 
 else return false;
} 

extern bool run;
void TProcCall::display(outtype& out)const
{
	if(run){
		name->display(out);
		out<<"(";
		paraList->display(out);
		out<<")";
	}
}

void TProcCall::print(outtype& out)const
{
 display(out);
}

void TProcCall::show(outtype& out)const
{
 display(out);
}

TAtom  * TProcCall::Copy()
{
 TList* nrl=paraList->Clone();
 TProcCall *nc=new TProcCall(name,nrl);
 //wout<<"Should have error here in TProCall::Copy()\n";
 return (TAtom *)nc;
}

void *TProcCall::operator new(size_t)
{
 return  (TProcCall*)StarMem->alloc();
};

void TProcCall::operator delete(void *p)
//void TProcCall::delete1()
{
 (StarMem->free(p));
}

Tbl2ListTVariable * TProcCall::SetActualPara()
{
 TVariable *nv;
 TProcDef *pr=name->GetProc();
 Tbl2ListTVariable * pl;
 TList  *rl;
 int pnum,i;
 Tbl2ListTVariable *ntbl=new Tbl2ListTVariable();
// Tbl2ListTVariable *ntbl1;
 Tbl2ListNodeTVariable *tmpV;
 TListNode *tmpR;

 if(!pr) { wout<<"ProcCall SetActualPara ERROR\n";return 0;}
  pl =pr->GetVar();

 rl=paraList;        //Actual Parameter list
 pnum=pr->PVnum();
 i=0;

// ntbl=new Tbl2List<TVariable> ;
 tmpV=pl->first();
 tmpR=rl->first();

 while (tmpV) {
	nv=tmpV->get()->Clone();
	nv->SetType(TVARIABLE);
	if (tmpR && i<pnum) {
		//nv->SetValue((TExpression*)(tmpR->getdata()) );
		//nv->display();(tmpR->getdata())->display();wout<<":";
		//nv->display();nv->GetValueReal()->display();
		//wout<<":";nv->GetValue()->display(); wout<<endl;

		nv->SetValueReal(((TExpression *)tmpR->getdata())->eval() );
   		tmpR=tmpR->next;
		i++;
		}
 	ntbl->append(nv);
	tmpV=tmpV->next;
	}
 return ntbl;
}
//=============================================================  

//============================================================
TProcDef::TProcDef()
{ 
  varList=new Tbl2ListTVariable;
  para_num=global_num=0;
  runList=new TRunList;
  RefCount=new unsigned long(1);
};

TProcDef::TProcDef(const TProcDef &p)
{
 runList=p.runList;
 varList=p.varList;
 RefCount=p.RefPtr();
 RefInc();
 SetPVnum(p.para_num);
 SetGVnum(p.global_num);
}

TProcDef::TProcDef(Tbl2ListTVariable *PL, Tbl2ListTVariable *GL, Tbl2ListTVariable *LL, TRunList *RL)
{
// PL: parameters
// GL: global vars
// LL: local vars;
// RL: runlist

 varList=new Tbl2ListTVariable;
 runList=new TRunList;
 varList->append(PL);
 varList->append(GL);
 varList->append(LL);
 runList->append(RL);

 para_num=(PL==NULL)?0: PL->length();
 global_num=(GL==NULL)?0:       GL->length();
 RefCount=new unsigned long(1);

} ;

TProcDef::~TProcDef()
{
 if (Ref()>1) {
	RefDec();
	return;
	}
 else delete RefCount;
 if(runList) {
#ifdef __DELETE_DEBUG__
	wout<<"delete runList in TProcDef-decontruct:";
        runList->display();
        wout<<"\t\n";
#endif
      delete runList;
 }
 if(varList) delete varList; //Remove those vars except GlobalVars
                             // Should re-write this delete clause

};

int TProcDef::AddPL(Tbl2ListTVariable * pl)
{
 varList->append(pl);
 return para_num= (pl==NULL?0:pl->length());
}

int TProcDef::AddGL(Tbl2ListTVariable * gl)
{
 varList->insert(gl);
 return global_num=(gl==NULL)?0:        gl->length();
};

int TProcDef::AddLL(Tbl2ListTVariable * ll)
{
 //return varList->insert(ll);
 return 1;
};

void TProcDef::show(outtype& out) const
{
 display();
}

void TProcDef::print(outtype& out) const
{
 display();
}

void TProcDef::display(outtype& out) const
{

 COUNT i;
 Tbl2ListNodeTVariable   *tmp;
 tmp=varList->first() ;
 out << "proc(";
 if(para_num>0){
       tmp->show(out);
       tmp=tmp->next;
     }
 for(i=1; i<para_num; i++)
   {
     out<<",";
     tmp->show(out);
     tmp=tmp->next;
   }
 out<<" )\n";

 for(i=0; i<global_num; i++)
     {
     out<<"\tglobal ";tmp->show(out);
     out<<";\n";
     tmp=tmp->next;
    }
 while(tmp)
  {
     out<<"\tlocal ";tmp->show(out);
     out<<";\n";
     tmp=tmp->next;
    }

 runList->display(out);
 out<<" end\n";
}

bool TProcDef::CHK(TList *act_para)
{
 if(act_para->length() != para_num)
 {
  wout<<"error in call:";display();
  wout<<"\n wrong actural parameter number\n";
  return false;
 }
return true;
}

int TProcDef::compare(TAtom* c)
{
return 1;
}

TAtom *TProcDef::Copy()
{
 /*
 TProcDef *n=new TProcDef(varList,0,0,runList);
 n->SetRef(RefCount);
 n->RefInc();
 n->SetPVnum(PVnum());
 n->SetGVnum(GVnum());
 */
 TProcDef *n=new TProcDef(*this);
 return (TAtom *)n;
}

unsigned long TProcDef::SetRef(unsigned long *n)
{
 if(n==RefCount) return *n;
 else {
        if( !(*RefCount) )
        delete RefCount;
        //else RefDec();
        (RefCount=n);
        return *n;
        }
};

void *TProcDef::operator new(size_t)
{
 return  (TProcDef*)StarMem->alloc();
};
     
void TProcDef::operator delete(void *p)
{
 (StarMem->free(p));
};
//==================================================================

TFuncDef::TFuncDef():TProcDef()
{
};

TFuncDef::TFuncDef(Tbl2ListTVariable *PL, Tbl2ListTVariable *GL, Tbl2ListTVariable *LL, TRunList *RL):\
TProcDef(PL,GL,LL,RL)
{
};

TFuncDef::TFuncDef(const TFuncDef &p)
{
 runList=p.runList;
 varList=p.varList;
 RefCount=(p.RefPtr());
 RefInc();
 SetPVnum(p.para_num);
 SetGVnum(p.global_num);
}

TFuncDef::~TFuncDef()
{
 if(varList) delete varList; //Remove those vars except GlobalVars
                             // Should re-write this delete clause
 if(runList) delete runList;
};

void TFuncDef::show(outtype& out) const
{
 display();
}
void TFuncDef::print(outtype& out) const
{
 display();
}
void TFuncDef::display(outtype& out) const
{

 COUNT i;
 Tbl2ListNodeTVariable   *tmp;
 tmp=varList->first() ;
 out << "func(";
 if(para_num>0){
       tmp->show(out);
       tmp=tmp->next;
     }
 for(i=1; i<para_num; i++)
   {
     out<<",";
     tmp->show(out);
     tmp=tmp->next;
   }
 out<<" )\n";

 for(i=0; i<global_num; i++)
     {
     out<<"\tglobal ";tmp->show(out);
     out<<";\n";
     tmp=tmp->next;
    }
 while(tmp)
  {
     out<<"\tlocal ";tmp->show(out);
     out<<";\n";
     tmp=tmp->next;
    }

 runList->display(out);
 out<<" end\n";
}

void *TFuncDef::operator new(size_t)
{
 return  (TFuncDef*)StarMem->alloc();
};
void TFuncDef::operator delete(void *p)
{
 (StarMem->free(p));
};


