
#ifndef __STACKS_H__
#define __STACKS_H__

/*
#include "basetype.h"
#include "templist.h"
#include "template.h"
//#incldue "lang.h"
*/
#include "slisttvariable.h"
#include "shortlist.h"
//#include "templist.h"


class Tbl2ListTVariable;
class SListTVariable;

class TProcCall: public TAtom, virtual public TRun
{
   protected:
        TList *         paraList;
        TVariable *     name;
   public:
        TProcCall(TVariable*s,TList *rl=0);
        virtual ~TProcCall();
        virtual TRunType Run();
        TVariable * GetName(){ return name;}
        TList * GetPara(){ return  paraList;}
        TAtom * eval();
        TAtom * Copy();
		bool   IsDefined();

        Tbl2ListTVariable * SetActualPara();
        DataType        TypeID() const{return ProcCall;};

        virtual void display(outtype& out =wout) const;
        virtual void show(outtype& out =wout) const;
        virtual void print(outtype& out =wout) const;
 
        void* operator new(size_t);
        void  operator delete(void *);
//		void  delete1();
};

class TListCall:public TProcCall
{
   public:
     TListCall(TVariable*s,TList *rl=0);
     virtual ~TListCall();
     virtual TRunType Run();
     bool   	IsDefined();
     TAtom*         eval();
     TAtom *		Copy();
     DataType       TypeID() const{return ListCall;};

        virtual void display(outtype& out =wout) const;
        virtual void show(outtype& out =wout) const;
        virtual void print(outtype& out =wout) const;
 
     void* operator new(size_t);
     void  operator delete(void *);
};

//========================================================================
class TProcDef: public TAtom       //NEED NOT have a return value
{
 protected:

//        TVariable *   varList;  // parameters+globalvars+localvars
		Tbl2ListTVariable *   varList;
	    int          para_num, global_num;
        TRunList *   runList;
	unsigned long *RefCount;
 public:
        TProcDef();
        TProcDef(Tbl2ListTVariable *PL, Tbl2ListTVariable *GL, Tbl2ListTVariable *LL, TRunList *RL);
        //------------- Parameter      GlobalVars    LocalVars     RunList
        TProcDef(const TProcDef &proc);
        //------  Used as  copying -----------------------------

        virtual ~TProcDef();
        virtual int AddPL(Tbl2ListTVariable * pl);
        virtual int AddGL(Tbl2ListTVariable * gl);
        virtual int AddLL(Tbl2ListTVariable * ll);
        virtual TRunList* GetDo(){ return runList;}
//        virtual TVariable * GetVar(){ return varList;};
        virtual Tbl2ListTVariable * GetVar(){ return varList;};

	virtual TAtom *Copy();
	TAtom* eval() {return 0;}
        DataType TypeID() const { return ProcDef; }
        virtual int compare(TAtom *);

        int   SetPVnum(int n) {return para_num=n; } // Number of parameters
        int   SetGVnum(int n) {return global_num=n; } // set Number of global
        int   PVnum() {return para_num; } // Number of parameters
        int   GVnum() {return global_num; } // Number of Global vars
	unsigned long& Ref()const { return *RefCount; };
	unsigned long* RefPtr()const { return RefCount; };
	unsigned long SetRef(unsigned long *n);
	unsigned long RefInc() { return ++(*RefCount); };
	unsigned long RefDec() { return --(*RefCount); };

        virtual  bool CHK(TList *act_para);
        virtual void display(outtype& out =wout) const;
        virtual void show(outtype& out =wout) const;
        virtual void print(outtype& out =wout) const;
 
        void* operator new(size_t);
        void  operator delete(void *);
};

class TFuncDef: public TProcDef // MUST  have a return value
{
 public:
        TFuncDef();
        TFuncDef(Tbl2ListTVariable *PL, Tbl2ListTVariable *GL, Tbl2ListTVariable *LL, TRunList *RL);
        //------------- Parameter      GlobalVars    LocalVars     RunList
        TFuncDef(const TFuncDef &proc);
        //------  Used as  copying -----------------------------
        virtual ~TFuncDef();

        virtual void display(outtype& out =wout) const;
        virtual void show(outtype& out =wout) const;
        virtual void print(outtype& out =wout) const;
 
        void* operator new(size_t);
        void  operator delete(void *);

};
//==============================================

// enum TVarType { SYMBOL,VARIABLE,PARAMETER,PROCEDURE,SYSFUNCTION}

//SYMBOL:   can not be set a value, that is said that it can not be a LVAlue
//VARIABLE: can be set a value, that is said that it can be a LVAlue
//PARAMETER: It is a parameter in a procedure/function definition/call
class TVariable: public TAtom
{
 protected:
        char            *name;
		char            *fname;
 public:
    union VValue{
        TAtom           *poly; 		// point to TAtom or TProcDef
        TProcDef        *proc; 		// point to TAtom or TProcDef
        int             sysfunc;	// Location of the sysfunc
        int          	other;
        }value;
        TVarType        type;
        int             order;  // introducing order of the variable

        TVariable();
        TVariable(char *s,TVarType type=UNDEFINED);
        virtual ~TVariable();
		
		TVarType GetType(){ return type;}
        TAtom* 	Copy(){return this;}
        TVariable* Clone();
        TAtom	 *eval();
		int GetFuncId();
        TRunType Run();
        DataType TypeID() const {return Variable;}
        virtual void display(outtype& out =wout) const;
        virtual void show(outtype& out =wout) const;
        virtual void print(outtype& out =wout) const;
 
        void* operator new(size_t);
        void  operator delete(void *);

//=======================================================

        virtual int compare(TAtom *);
        void SetType(TVarType);
        void SetValueReal(TAtom*);
        TAtom* 	GetValueReal();
        void SetValue(TAtom*);
        void SetValue(TProcDef*);
        char *GetName(bool nm = false) const ;
		//char *GetFName() const { return fname;}
		//void ReName(char *s){ delete name;name=strdup(s);}
		
		void ClearValue();

        // for the area method
		TAtom* GetFuncValue();
        char*  GetFuncName(bool nm) const;
		TVariable *GetPt(int );



		TAtom* Simplify1();
		TAtom* Simplify();

        TAtom*     GetValue();
        TProcDef * GetProc();

        TRunType   SysRun(TList *);
        bool    SysFuncCHK(TList *);  // Chk actual parameter's number from ProcCall
        int 	equal(const char *n);
        int 	equal(const int &n);
        int 	equal(TVariable *n);
        
};
TVariable *GenVar(char *result);
TVariable *GenVar(TVariable *v);
TVariable *GenVar(char *, TAtom *);
TVariable *GenVar(char *, TList *);

int Isdiffvar(  TVariable * mvar);

//1 if mvar is a differenct variable
//0 if not.

TVariable* getname (TVariable *mvar);

 //if mvar:=x[1,2,3];
// return x

TShortList * getlist( TVariable *mvar);
//if mvar:=x[1,2,3]
//return [1,2,3]

TVariable * formvar(TVariable *mvar,TShortList *l);
//if mvar:=x;
//   l:=[1,2,3];
//return x[1,2,3];      

  
class TVarList: public TAtom, public SListTVariable
{
 public:
        TVarList();
        virtual ~TVarList();

	virtual DataType TypeID() const { return VarList; }
	virtual void Clear();
	virtual TAtom *Copy();
	virtual TAtom* eval();
	int 	length() {return SListTVariable::length();}
	int OrdComp(TVariable *, TVariable *);


        virtual void display(outtype& out =wout) const;
        virtual void show(outtype& out =wout) const;
        virtual void print(outtype& out =wout) const;
 
        void* operator new(size_t);
        void  operator delete(void *);

};  

//=============================================
struct PState {
public:
        TParseMode mode;
        TRunList *runlist;
        Tbl2ListTVariable *vartbl;

        PState(TParseMode m=PNormal, Tbl2ListTVariable *vt=0, TRunList *rl=0) 
        {
                mode=m;
                runlist=rl;
                vartbl=vt;
        };

        ~PState();

        DataType TypeID() const{ return PSTATE;} ;
        int compare(PState *n){ return 0;};

        virtual void display(outtype& out =wout) const;
        virtual void show(outtype& out =wout) const;
        virtual void print(outtype& out =wout) const;
 
        void* operator new(size_t);
        void  operator delete(void *);

};

             
//template class SList<TVariable>;
#endif

// use namespace std
