#include "memory.h"
#include "stacks.h"
#include "global.h"
#include "lists.h"
#include "poly.h"
#include "trpoly.h"
//#include "tripoly.h"
#include "pol.h"
#include "sysfunc.h"
#include "charset.h"
//#include "fwang.h"
//#include "lists_cs.h"
#include "nvar.h"
#include "basecs.h"
#include "basecs_mod.h"
#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include "projection.h"
//#include "xy.h"
#include "poly_factoras.h"
#include "matrix.h"
#include "vectors.h"
#include "check.h"
#include "list_itr.h"
#include "geometry.h"
#include "poly_solver.h"
#include "gbas.h"


//bxia
#include "realroot.h"
//bxia

#ifdef _WINDOWS
#include "..\gui\index.h"
#endif
 

//===============================================
//===============================================

TRunType Expand(TList *l);
TRunType Restart(TList *l);
TRunType part(TList *l);

//-----------------------------------------------
//
//                     List operation
//
//-----------------------------------------------
TRunType Union(TList *l);
TRunType gunion(TList *l);
TRunType Intersect(TList *l);
TRunType Minus(TList *l);
TRunType Equal(TList *l);
TRunType Append(TList *l);
TRunType Sappend(TList *l);
TRunType Lappend(TList *l);
TRunType Gappend(TList *l);
TRunType Insert(TList *l);
TRunType Remove(TList *l); 
TRunType Replace(TList *l);
TRunType Merge(TList *l);
TRunType First(TList *l);
TRunType Last(TList *l);
TRunType Rest(TList *l);
TRunType Part(TList *l);
TRunType Find(TList *l);
TRunType Inverse(TList *l);
TRunType testSearch(TList *l);
TRunType Issub(TList *l);
//TRunType Inserttmp(TList *l);
//TRunType removetmp(TList *l);

//-----------------------------------------------
//
//                     Number operation
//
//-----------------------------------------------
//test TBigInt
TRunType igcd(TList *l);
TRunType igcd_Lehmer(TList *l);
TRunType ilcm(TList *l);
TRunType ifactor(TList *l);
TRunType iNonTrivalFactor(TList *l);
TRunType isqrt(TList *l);
TRunType ilog2(TList *l);
TRunType ilog10(TList *l);
TRunType isprime(TList *l);
TRunType isodd(TList *l);
TRunType iseven(TList *l);
TRunType nextprime(TList *l);
TRunType prevprime(TList *l);
TRunType random(TList *l);
TRunType chrem(TList *l);
TRunType imod_sqrt(TList *l);
TRunType imod_sum(TList *l);
TRunType imod_diff(TList *l);
TRunType imod_prod(TList *l);
TRunType imod_quo(TList *l);
TRunType imod_exp(TList *l);
TRunType imod_neg(TList *l);
TRunType imod_inv(TList *l);
TRunType imod0(TList *l);
TRunType imod(TList *l);
TRunType primetable(TList *l);
TRunType primegen(TList *l);
TRunType iquo(TList *l);
TRunType irem(TList *l);
TRunType ifactorial(TList *l);
//test TNumber
TRunType abs(TList *l);
TRunType nsqrt(TList *l);
TRunType ceil(TList *l);
TRunType floor(TList *l);
//test TFloatNum
TRunType SetPrecision(TList *l);
TRunType fsqrt(TList *l);
//test TFraction
TRunType rsqrt(TList *l);
TRunType fraction(TList *l);
//test TDouble
TRunType fabs(TList *l);
//test TComplex
TRunType cquo(TList *l);
TRunType cprod(TList *l);
//return the type name of an atom 
TRunType type(TList *l);

//-----------------------------------------------
//
//                     Polynomial operation
//
//-----------------------------------------------
TRunType testconvert(TList *l);
TRunType IsNumber(TList *l);
TRunType IsZero(TList *l);
TRunType PLength(TList *l);
TRunType MainVar(TList *l);
TRunType Coeff(TList *l);
TRunType Coeffs(TList *l);
TRunType Deg(TList *l);
TRunType MinDeg(TList *l);
TRunType TDiv(TList *l);
TRunType Prem(TList *l);
TRunType LeadCoeff(TList *l);
TRunType LeadTerm(TList *l);
TRunType Reductum(TList *l);
TRunType Content(TList *l);
TRunType Primitive(TList *l);
TRunType Gcd(TList *l);
TRunType GcdEuclidean(TList *l);
TRunType PChrem(TList *l);
TRunType Factor(TList *l);
TRunType Factorold(TList *l);
TRunType SquareFree(TList *l);
TRunType Derivative(TList *l);
TRunType GetVarList(TList *l);
TRunType Substitute(TList *l);
TRunType Resultant(TList *l);
TRunType PMod(TList *l);
TRunType PModSum(TList *l);
TRunType PModDiff(TList *l);
TRunType PModProd(TList *l);
TRunType PModQuo(TList *l);
TRunType PModPrem(TList *l);
TRunType PModGcd(TList *l);
TRunType PModFactor(TList *l);
TRunType PModSquareFree(TList *l); 
TRunType vartest(TList *l);  
TRunType factoras(TList *l);
TRunType polysolver(TList *l);
TRunType psimplify(TList *l);


//bxia
//TRunType realroot(TList *l);
//bxia


//-----------------------------------------------
//
//                     Array operation
//
//-----------------------------------------------
TRunType array(TList *l);

//-----------------------------------------------
//
//                     Syzygy operation
//
//-----------------------------------------------
TRunType syzygy(TList *l);
TRunType syz(TList *l);
TRunType grem(TList *l);
TRunType divvar(TList *l);
TRunType gbasis(TList *l);

//===============================================
//===============================================

//TSysFunc SysFuncTbl_User[SYS_FUNC_NUM]={
//{0,0,0},NULL,};
extern TSysFunc SysFuncTbl_User[SYS_FUNC_NUM];

TSysFunc SysFuncTbl[SYS_FUNC_NUM]={
{ "Expand",  1,Expand},
{ "expand",  1,Expand},
{ "restart", 0,Restart},
{ "part",    2,part},

//-----------------------------------------------
//
//                     List operation
//
//-----------------------------------------------
{ "union",	     2,Union},
{ "gunion",	     2,gunion},
{ "intersect",   2,Intersect},
{ "minus",	     2,Minus},
{ "equal",       2,Equal},
{ "append",      2,Append},
{ "sappend",     2,Sappend},
{ "lappend",     2,Lappend},
{ "gappend",     2,Gappend},
{ "insert",	     3,Insert},
{ "remove" ,     2,Remove},
{ "replace",     3,Replace},
{ "merge",       2,Merge},
{ "first",	     1,First},
{ "last",	     1,Last},
{ "rest",	     1,Rest},
{ "part",	     2,Part},
{ "find",	     2,Find},
{ "inverse",     1,Inverse},
{ "testSearch",  0,testSearch},
{ "issub",       2,Issub},
//{ "Inserttmp", 0,Inserttmp},
//{ "removetmp", 3,removetmp},

//-----------------------------------------------
//
//                     Number operation
//
//-----------------------------------------------
{ "igcd",	      2,igcd},
{ "igcd_Lehmer",  2,igcd_Lehmer},
{ "ilcm",	      2,ilcm},
{ "ifactor",      1,ifactor},
{ "iNonTrivalFactor",1,iNonTrivalFactor},
{ "isqrt",	      1,isqrt},
{ "ilog2",	      1,ilog2},
{ "ilog10",	      1,ilog10},
{ "isprime",	  1,isprime},
{ "isodd",	      1,isodd},
{ "iseven",	      1,iseven},
{ "nextprime",	  1,nextprime},
{ "prevprime",	  1,prevprime},
{ "random",	      1,random},
{ "chrem",	      2,chrem},
{ "imod_sqrt",	  2,imod_sqrt},
{ "imod_sum",	  3,imod_sum},
{ "imod_diff",	  3,imod_diff},
{ "imod_prod",	  3,imod_prod},
{ "imod_quo",	  3,imod_quo},
{ "imod_exp",     3,imod_exp},
{ "imod_neg",	  2,imod_neg},
{ "imod_inv",	  2,imod_inv},
{ "imod0",	      2,imod0},
{ "imod",	      2,imod},
{ "primetable",   0,primetable},
{ "primegen",     1,primegen},
{ "iquo",         2,iquo},
{ "irem",         2,irem},
{ "ifactorial",   1,ifactorial},
{ "abs",	      1,abs},
{ "ceil",	      1,ceil},
{ "floor",	      1,floor},
{ "SetPrecision", 2,SetPrecision},
{ "fabs",         1,fabs},
{ "cquo",         2,cquo},
{ "cprod",        2,cprod},
{ "fsqrt",        1,fsqrt},
{ "rsqrt",        1,rsqrt},
{ "nsqrt",        1,nsqrt},
{ "fraction",     2,fraction}, 
{ "type",         1,type},

//-----------------------------------------------
//
//                     Polynomial operation
//
//-----------------------------------------------
{ "is_number",	1,IsNumber},
{ "test",	1,testconvert},
{ "is_zero",	1,IsZero},
{ "plength",	1,PLength},
{ "main_var",	2,MainVar},
{ "coeff",	3,Coeff},
{ "coeffs",	2,Coeffs},
{ "degree",	2,Deg},
{ "min_deg",2,MinDeg},
{ "tdiv",	2,TDiv},
{ "pprem",	3,Prem},
{ "lead_coeff",	2,LeadCoeff},
{ "lead_term",	2,LeadTerm},
{ "reductum",	2,Reductum},
{ "content",	1,Content},
{ "primitive",	1,Primitive},
{ "gcd",	2,Gcd},
{ "pchrem",	2,PChrem},
{ "factor",	1,Factor},
{ "factorold",	1,Factorold},
{ "squarefree",	1,SquareFree},
{ "derivative",	2,Derivative},
{ "get_var_list",	1,GetVarList},
{ "substitute",	3,Substitute},
{ "resultant",	3,Resultant},
{ "pmod",	2,PMod},
{ "pmod_sum",	3,PModSum},
{ "pmod_diff",	3,PModDiff},
{ "pmod_prod",	3,PModProd},
{ "pmod_quo",	3,PModQuo},
{ "pmod_prem",	4,PModPrem},
{ "pmod_gcd",	3,PModGcd},
{ "pmod_factor",	2,PModFactor},
{ "pmod_squarefree",	2,PModSquareFree},
{ "vartest", 1,vartest},
{ "factoras",3,factoras}, 
{ "polysolver",1,polysolver},
{ "psimplify",1,psimplify},

//bixia
//{ "realroot",0,realroot},
//{ "realroot",1,realroot},
//{ "realroot",2,realroot},
//bixia

//-----------------------------------------------
//
//                     Array operation
//
//-----------------------------------------------
{"array",1,array},

//-----------------------------------------------
//
//                     Syzygy operation
//
//-----------------------------------------------
{"syzygy",2,syzygy},
{"syz",2,syz},
{"grem",3,grem},
{"divvar",3,divvar},
{"gbasis",2,gbasis},
 
{0,0,0},NULL,};


//===============================================
//===============================================

SysFuncTbl_Refresh()
{
 int i=0,j=0;
 while (SysFuncTbl[i].name != 0) i++;
 while (SysFuncTbl_User[j].name !=0 ) {
        SysFuncTbl[i].name=(char *)strdup(SysFuncTbl_User[j].name);
        SysFuncTbl[i].num=SysFuncTbl_User[j].num;
        SysFuncTbl[i].func=SysFuncTbl_User[j].func;
        i++;
        j++;
 }
 return 1;
}


TRunType CallSysFunc(int num, TList * act_para)
{
//  if(SysFuncCHK(num,SysFuncTbl[num].num)
    	return (SysFuncTbl[num].func)(act_para);
//  else return

}


bool SysFuncCHK(int n,int pnum)
{
 int i = n; 
 char * nm = SysFuncTbl[n].name;
 while(SysFuncTbl[i].name && strcmp(SysFuncTbl[i].name, nm)==0)
 {
   if(SysFuncTbl[i].num == pnum) return true;
   i++;
 }

 wout<<"Error in call "<<SysFuncTbl[n].name;
 wout<<" wrong number of parameter";
 return false;
}
          
//-----------------------------------------------

TRunType Expand(TList *l)
{
 TRunType rt=TNORMAL;
 TList * return_list;
 int i,ll;

 //---------------------------------------------
 //-----  PLEASE Set Global  ReturnValue    ----
 //---------------------------------------------
 TAtom *d=l->first()->getdata(); //FIRST(l)
 if (d->TypeID() != ListType)
        ReturnValue=d->eval();
 else 
 {
    ll=((TList *)d)->length();
    return_list=new TList();
    for (i=1; i<=ll;i++)
      return_list->append((TAtom *)(((TList *)d)->Part(i)->eval()));
	ReturnValue=return_list;
 }
 return rt;
};


TRunType Restart(TList *l)
{
	TRunType rt=TNORMAL;
    ReturnValue=0;
    resta();
	ReturnValue=new TString("The System has been RSTARTED");
	return rt;
}


TRunType part(TList *l)
{
 //wout<<"v In sys-func part("; l->print(); wout<<") \n";
 if(l->length()!=2) {
     wout<<" Error! wrong para-number in call part(...) \n";
     return TERROR;
   }
 TAtom *f0,*f,*n,*nn;
 TAtom *TRetV=0;
 int nnnn;
 f0=l->HEAD();
 f=f0->eval();
 if(f->TypeID() !=ListType)
   {
        ReturnValue=0;
        delete f;
        delete f0;
        return TNORMAL;

   }
 n=l->Part(2);
 nn=n->eval();
 if(  IsNum( nn ) ){
        nnnn=((TNumber*)nn)->GetInt();
        if(nnnn>((TList*)f)->length()||nnnn<=0) ReturnValue=0;
        else
        {
			TRetV=((TList *)f)->Part(nnnn)->Copy();
        }
  }else
        ReturnValue=0;

  delete f;
  delete nn;
  delete f0;
  if(TRetV) {
     ReturnValue= TRetV->eval();
  if(!((TRetV->TypeID())==Variable))
     delete TRetV;
    }
  return TNORMAL;
};

//-----------------------------------------------
//             
//                     List operation
//
//-----------------------------------------------

//testTList * TList::Union(TList *)
TRunType Union(TList *l)
{
  TRunType rt=TNORMAL;
  ReturnValue=0;

  TList * l1=0, *l2=0;

  if( (l1=list_p(FIRST(l))) && (l2=list_p(SECOND(l))) )
	ReturnValue=l1->Union(l2);

  if(l1) delete l1;
  if(l2) delete l2;

  return rt;
}


//test: void TList::gunion(TList *l)
//the system function itself has memory loss!
TRunType gunion(TList *l)
{
  TRunType rt=TNORMAL;
  ReturnValue=0;

  TList * l1=0, *l2=0;
  TList * ltmp=new TList();

  if( (l1=list_p(FIRST(l))) && (l2=list_p(SECOND(l))) )
	 l1->gunion(l2);

  for(int i=1;i<=l1->length();i++)
	  ltmp->append((TAtom*)((l1->Part(i))->Copy()));

  ReturnValue=ltmp;

  //if(l1) delete l1;
  //if(l2) delete l2;

  return rt;
}

 
//testTList * TList::Intersect(TList *)
TRunType Intersect(TList *l)
{
  TRunType rt=TNORMAL;
  ReturnValue=0;

  TList * l1=0, *l2=0;

  if( (l1=list_p(FIRST(l))) && (l2=list_p(SECOND(l))) )
	ReturnValue=l1->Intersect(l2);

  if(l1) delete l1;
  if(l2) delete l2;

  return rt;

}

//testTList * TList::Minus(TList *)
TRunType Minus(TList *l)
{
  TRunType rt=TNORMAL;
  ReturnValue=0;

  TList * l1=0, *l2=0;

  if( (l1=list_p(FIRST(l))) && (l2=list_p(SECOND(l))) )
	ReturnValue=l1->Minus(l2);

  if(l1) delete l1;
  if(l2) delete l2;

  return rt;
}


//testint TList::equal(TList *)
TRunType Equal(TList *l)
{
  TRunType rt=TNORMAL;
  ReturnValue=0;

  TList * l1=0, *l2=0;

  if( (l1=list_p(FIRST(l))) && (l2=list_p(SECOND(l))) )
	ReturnValue=new TBigInt(l1->equal(l2));

  if(l1) delete l1;
  if(l2) delete l2;

  return rt;
}

//test: TList * TList::sappend(TAtom *)
TRunType Sappend(TList *l)
{
  TRunType rt=TNORMAL;
  ReturnValue=0;

  TList * l0=0;
  TAtom * a=SECOND(l);

  if( (l0=list_p(FIRST(l))) )
	 ReturnValue=l0->sappend(a);

  if(l0) delete l0;
  return rt;
}

//test: TList * TList::lappend(TAtom *)
TRunType Lappend(TList *l)
{
  TRunType rt=TNORMAL;
  ReturnValue=0;

  TList * l0=0;
  TAtom * a=SECOND(l);

  if( (l0=list_p(FIRST(l))) )
	ReturnValue=l0->lappend(a);
	 
  if(l0) delete l0;
  return rt;
}

//test: void TList::append(TAtom * data)
//the system function itself has memory loss!
TRunType Append(TList *l)
{
  TRunType rt=TNORMAL;
  ReturnValue=0;

  TList * l0=0;
  TList * ltmp=new TList();
  TAtom * a=SECOND(l);

  if( l0=list_p(FIRST(l)) )
    l0->append(a);

  for(int i=1;i<=l0->length();i++)
	  ltmp->append((TAtom*)((l0->Part(i))->Copy()));
	   
  ReturnValue=ltmp;

  //if(l0) delete l0;

  return rt;
}

//test: void TList::gappend(TAtom * data)
//the system function itself has memory loss!
TRunType Gappend(TList *l)
{
  TRunType rt=TNORMAL;
  ReturnValue=0;

  TList * l0=0;
  TList * ltmp=new TList();
  TAtom * a=SECOND(l);

  if( l0=list_p(FIRST(l)) )
    l0->gappend(a);

  for(int i=1;i<=l0->length();i++)
	  ltmp->append((TAtom*)((l0->Part(i))->Copy()));
	   
  ReturnValue=ltmp;

  //if(l0) delete l0;

  return rt;
}

//test: TList * TList::remove(int pos)
TRunType Remove(TList *l)
{
  TRunType rt=TNORMAL;
  ReturnValue=0;

  TList * l0=0;
  TBigInt * b=0;

  if( (l0=list_p(FIRST(l))) && (b=bigint_p(SECOND(l))) )
	ReturnValue=l0->remove(b->GetInt());

  if(l0) delete l0;
  if(b) delete b;

  return rt;
}

/*
//test:  TList * TList::remove(int pos)
//this function tests the following special case: 
//remove([10],1,100);
//(delete the 1st node in [10],then append 100) 
//the system function itself has memory loss!
TRunType removetmp(TList *l)
{
  TRunType rt=TNORMAL;
  ReturnValue=0;

  TList * l0=0;
  TBigInt * b=0;
  TList * l1=0;
  TList * ltmp=new TList();
  TAtom * a=THIRD(l);

  if( (l0=list_p(FIRST(l))) && (b=bigint_p(SECOND(l))) )
  {
	l1=l0->remove(b->GetInt());
   
    l1->append(a);

    for(int i=1;i<=l1->length();i++)
	  ltmp->append((TAtom*)((l1->Part(i))->Copy()));

	ReturnValue=ltmp; 
  }
  
  if(l0) delete l0;
  if(b) delete b;
  //if(l1) delete l1;
  //if(a) delete a;
  
  return rt;
}
*/

/*
//test: TList * TList::remove(TAtom * data)
TRunType Remove(TList *l)
{
  TRunType rt=TNORMAL;
  ReturnValue=0;
 
  TList * l0=0;
  TAtom * a = SECOND(l);
  TAtom * pos;
 
  if(l0=list_p(FIRST(l)))
  {
 
    pos=l0->find(a);

    ReturnValue=l0->remove(pos);
    
  }

  if(l0) delete l0;
  
  return rt;
}
*/

/*
//test: TList * TList::remove(TListNode * data)
TRunType Remove(TList *l)
{
  TRunType rt=TNORMAL;
  ReturnValue=0;
 
  TList * l0=0;
  TAtom * a = SECOND(l);
  TListNode * pos;
   
  if(l0=list_p(FIRST(l)))
  {
 
    pos=l0->findnode(a);
 
    ReturnValue=l0->remove(pos);
    
  }

  if(l0) delete l0;
  
  return rt;
}
*/


/*
//test: TList *  TList::insert(int i,TAtom * v)
TRunType Insert(TList *l)
{
  TRunType rt=TNORMAL;
  ReturnValue=0;
  TList * l0=0;
  TBigInt * b=0;
  TAtom *a=SECOND(l);
  if( (l0=list_p(FIRST(l))) && (b=bigint_p(THIRD(l))) )
	ReturnValue=l0->insert(b->GetInt(),a);
  if(l0) delete l0;
  if(b) delete b;
   return rt;
}
*/

/*
//test: TList *  TList::insert(TListNode * data,TListNode * pos=0)
TRunType Insert(TList *l)
{
  TRunType rt=TNORMAL;
  ReturnValue=0;

  TList * l0=0;
  TAtom * a=THIRD(l);
  TAtom * data=SECOND(l);
  TListNode * pos;
  TListNode * lndata;
  if(l0=list_p(FIRST(l)))  
  { 
	pos=l0->findnode(a);
	lndata=new TListNode(data->Copy());
	TList * l1;
	l1=l0->insert(lndata,pos);
	ReturnValue=l1;
  }
  if(l0) delete l0;

  return rt;
}
*/


//test: TList *  TList::insert(TAtom * data,TListNode * pos=0)
TRunType Insert(TList *l)
{
  TRunType rt=TNORMAL;
  ReturnValue=0;

  TList * l0=0;
  TAtom * a=THIRD(l);
  TAtom * data=SECOND(l);
  TListNode * pos;
   
  if(l0=list_p(FIRST(l)))  
  { 
	pos=l0->findnode(a);
	TList * l1;
	l1=l0->insert(data->Copy(),pos);
	ReturnValue=l1;
  }

  if(l0) delete l0;

  return rt;
}


/*
//test: void TList::dinsert(TAtom *, int)
//the system function itself has memory loss!
TRunType Insert(TList *l)
{
  TRunType rt=TNORMAL;
  ReturnValue=0;

  TList * l0=0;
  TList * ltmp=new TList();
  TBigInt * b=0;
  TAtom * a=SECOND(l);

  if( (l0=list_p(FIRST(l))) && (b=bigint_p(THIRD(l))) )
    l0->dinsert(a,b->GetInt());

  for(int i=1;i<=l0->length();i++)
	  ltmp->append((TAtom*)((l0->Part(i))->Copy()));

  ReturnValue=ltmp;

  if(b) delete b;
   
  return rt;
}
*/


/*
//test: void TList::dinsert(TAtom *, int)
//ֲԷmemory loss!
TRunType Inserttmp(TList *l)
{
  TRunType rt=TNORMAL;
  ReturnValue=0;

  TList * ll= new TList();
  
  ll->dinsert((TAtom *)(new TBigInt(10)),1);
  ll->dinsert((TAtom *)(new TBigInt(20)),2);
  ll->dinsert((TAtom *)(new TBigInt(30)),3);
  ll->dinsert((TAtom *)(new TBigInt(40)),4);
  ll->dinsert((TAtom *)(new TBigInt(50)),5);
  ll->dinsert((TAtom *)(new TBigInt(60)),6);
  ll->dinsert((TAtom *)(new TBigInt(70)),7);

  ReturnValue=ll;
  
  return rt;
}
*/

 
/*
//test: õ
TRunType testSearch(TList *l)
{
  TRunType rt=TNORMAL;
  ReturnValue=0;

  TList * ll= new TList();
  
  ll->append((TAtom *)(new TBigInt(1)));
  ll->append((TAtom *)(new TBigInt(2)));
  ll->append((TAtom *)(new TBigInt(3)));
  ll->append((TAtom *)(new TBigInt(4)));
  ll->append((TAtom *)(new TBigInt(5)));

  for(ListIt it = ll->firstIt(), end = ll->endIt(); it != end; ++it)
  {
	 wout << (*(TBigInt *)(*it)) << "\n";

  }

  ReturnValue=ll;
  return rt;
};
//*/


//test: úķ
TRunType testSearch(TList *l)
{
  TRunType rt=TNORMAL;
  ReturnValue=0;

  TList * ll= new TList();
  
  ll->append((TAtom *)(new TBigInt(11)));
  ll->append((TAtom *)(new TBigInt(22)));
  ll->append((TAtom *)(new TBigInt(33)));
  ll->append((TAtom *)(new TBigInt(44)));
  ll->append((TAtom *)(new TBigInt(55)));

  for(TListNode * tmp=FIRSTNODE(ll);tmp;RNEXT(tmp))
  {  
	   
	  wout << (*(TBigInt *)DATA(tmp)) << "\n";

  }

  ReturnValue=ll;
  return rt;
};


//test: TList * TList::replace(int, TAtom *)
TRunType Replace(TList *l)
{
  TRunType rt=TNORMAL;
  ReturnValue=0;

  TList * l0=0;
  TBigInt * b=0;
  TAtom *a=SECOND(l);

  if( (l0=list_p(FIRST(l))) && (b=bigint_p(THIRD(l))) )
	ReturnValue=l0->replace(b->GetInt(),a);

  if(l0) delete l0;
  if(b) delete b;

  return rt;
}

 
//test: TList * TList::merge(TList *)
TRunType Merge(TList *l)
{
  TRunType rt=TNORMAL;
  ReturnValue=0;

  TList * l1=0, *l2=0;

  if( (l1=list_p(FIRST(l))) && (l2=list_p(SECOND(l))) )
	ReturnValue=l1->merge(l2);

  if(l1) delete l1;
  if(l2) delete l2;

  return rt;
}


TRunType First(TList *l)
{
  TRunType rt=TNORMAL;
  ReturnValue=0;

  TList * l1=0;

  if( (l1=list_p(FIRST(l))) )
	ReturnValue=l1->HEAD();

  if(l1) delete l1;
  return rt;
};

TRunType Last(TList *l)
{
  TRunType rt=TNORMAL;
  ReturnValue=0;

  TList * l1=0;

  if( (l1=list_p(FIRST(l))) )
	ReturnValue=l1->TAIL();

  if(l1) delete l1;
  return rt;
};

TRunType Rest(TList *l)
{
  TRunType rt=TNORMAL;
  ReturnValue=0;

  TList * l1=0;

  if( (l1=list_p(FIRST(l))) )
	ReturnValue=l1->Rest();

  if(l1) delete l1;
  return rt;
};

TRunType Part(TList *l)
{
 TAtom *f0,*f,*n,*nn;
 TAtom *TRetV=0;
 int nnnn;
 f0=l->HEAD();
 f=f0->eval();
 if(f->TypeID() !=ListType)
   {
        ReturnValue=0;
        delete f;
        delete f0;
        return TNORMAL;
   }
 n=l->Part(2);
 nn=n->eval();
 if(  IsNum( nn ) ){
        nnnn=((TNumber*)nn)->GetInt();
        if(nnnn>((TList*)f)->length()) ReturnValue=0;
            else
       {
         TRetV=((TList *)f)->Part(nnnn)->Copy();
        }
  } else
        ReturnValue=0;

  delete f;
  delete nn;
  delete f0;
  if(TRetV) {
     ReturnValue= TRetV->eval();
  if(!((TRetV->TypeID())==Variable))
     delete TRetV;
    }
  return TNORMAL;
};


/*
//test:  TAtom * TList::find(TAtom * v)
TRunType Find(TList *l)
{
  TRunType rt=TNORMAL;
  ReturnValue=0;

  TList * l0=0;
  TAtom *a=FIRST(l);

  if( (l0=list_p(SECOND(l))) )
	ReturnValue= l0->find(a);

  if(l0) delete l0;
  return rt;

}
*/

//test:  int TList::findindex(TAtom * v)
TRunType Find(TList *l)
{
  TRunType rt=TNORMAL;
  ReturnValue=0;

  TList * l0=0;
  TAtom *a=FIRST(l);

  if( (l0=list_p(SECOND(l))) )
	ReturnValue= new TBigInt(l0->findindex(a));

  if(l0) delete l0;
  return rt;

}

//test: TList * TList::Inverse()
TRunType Inverse(TList *l)
{
  TRunType rt=TNORMAL;
  ReturnValue=0;

  TList * l1=0;

  if( (l1=list_p(FIRST(l))) )
	ReturnValue=l1->Inverse();

  if(l1) delete l1;
  return rt;
};

//test: int  Issub(TList *l1,TList *l2)
TRunType Issub(TList *l)
{
  TRunType rt=TNORMAL;
  ReturnValue=0;

  TList * l1=0, *l2=0;

  if( (l1=list_p(FIRST(l))) && (l2=list_p(SECOND(l))) )
	ReturnValue=new TBigInt(Issub(l1,l2));

  if(l1) delete l1;
  if(l2) delete l2;
  return rt;
}

//-----------------------------------------------
//
//                     Number operation
//
//-----------------------------------------------

//test TBigInt:
 
TRunType igcd(TList *l)
{
  TRunType rt=TNORMAL;
  ReturnValue=0;

  TBigInt * b1=0;
  TBigInt * b2=0;

  if( (b1=bigint_p(FIRST(l))) && (b2=bigint_p(SECOND(l))))
	 ReturnValue=new TBigInt(igcd(*b1,*b2));

  if(b1) delete b1;
  if(b2) delete b2;

  return rt;
};
   
TRunType igcd_Lehmer(TList *l)
{
  TRunType rt=TNORMAL;
  ReturnValue=0;

  TBigInt * b1=0;
  TBigInt * b2=0;

  if( (b1=bigint_p(FIRST(l))) && (b2=bigint_p(SECOND(l))))
	 ReturnValue=new TBigInt(Lehmer_gcd(*b1,*b2));

  if(b1) delete b1;
  if(b2) delete b2;

  return rt; 
   
};

 
TRunType ilcm(TList *l)
{
  TRunType rt=TNORMAL;
  ReturnValue=0;

  TBigInt * b1=0;
  TBigInt * b2=0;

  if( (b1=bigint_p(FIRST(l))) && (b2=bigint_p(SECOND(l))))
	ReturnValue=new TBigInt((((*b1)*(*b2))/(igcd(*b1,*b2))));

  if(b1) delete b1;
  if(b2) delete b2;

  return rt; 
   
};


//one para
TRunType ifactor(TList *l)
{
  TRunType rt=TNORMAL;
  ReturnValue=0;

  TBigInt * b=0;
   
  if( (b=bigint_p(FIRST(l))))
	ReturnValue=PrimeFactor(*b, 2);

  if(b) delete b;
   
  return rt;

};


TRunType iNonTrivalFactor(TList *l)
{
  TRunType rt=TNORMAL;
  ReturnValue=0;

  TBigInt * b=0;
   
  if( (b=bigint_p(FIRST(l))))
	ReturnValue=new TBigInt(NonTrivalFactor(*b));

  if(b) delete b;
   
  return rt;

};


/*
//two para
TRunType ifactor(TList *l)
{
  TRunType rt=TNORMAL;
  ReturnValue=0;
  if(l->length()!=2) {
    wout<<" Error! wrong para-number in call IFactor(...) \n";
   return TERROR;
  }
  TNumber *num1=(TNumber*) (l->first()->getdata()->Copy() );
  TNumber *num2=(TNumber*) (l->Part(2));
  TBigInt *n1=(TBigInt *)num1->GetPtr();
  TBigInt *n2=(TBigInt *)num2->GetPtr();
  int n3=(*n2).GetShort(0);
  ReturnValue=PrimeFactor(*n1, n3);
  delete num1; 
  return rt;
};
*/

/*
//try one or two para,but failed.
TRunType ifactor(TList *l)
{
  TRunType rt=TNORMAL;
  ReturnValue=0;
  if(l->length() > 2) {
    wout<<" Error! wrong para-number in call IGcd(...) \n";
    return TERROR;
  }
  if(l->length() == 1)
  {
  TNumber *num1=(TNumber*) (l->first()->getdata()->Copy() );
  TBigInt *n1=(TBigInt *)num1->GetPtr();
  TBigInt n3=*n1;
  ReturnValue=PrimeFactor(n3,2);
  delete num1;
  return rt;
  }	  
  else
  {
  TNumber *num1=(TNumber*) (l->first()->getdata()->Copy() );
  TNumber *num2=(TNumber*) (l->Part(2));
  TBigInt *n1=(TBigInt *)num1->GetPtr();
  TBigInt *n2=(TBigInt *)num2->GetPtr();
  int n3=(*n2).GetShort(0);
  ReturnValue=PrimeFactor(*n1, n3);
  delete num1; 
  return rt;
  }
};
*/

TRunType primetable(TList *l)
{
  TRunType rt=TNORMAL;
  ReturnValue=0;
   
  ReturnValue=PrimeTableGen();

  return rt;
};

TRunType isqrt(TList *l)
{
  TRunType rt=TNORMAL;
  ReturnValue=0;

  TBigInt * b=0;
   
  if( (b=bigint_p(FIRST(l))))
	 ReturnValue=new TBigInt(sqrt(*b));

  if(b) delete b;
   
  return rt;
  
};

TRunType ilog2(TList *l)
{
  TRunType rt=TNORMAL;
  ReturnValue=0;

  TBigInt * b=0;
   
  if( (b=bigint_p(FIRST(l))))
	ReturnValue=new TBigInt(log2(*b));

  if(b) delete b;
   
  return rt;
	 
};

TRunType ilog10(TList *l)
{
  TRunType rt=TNORMAL;
  ReturnValue=0;

  TBigInt * b=0;
   
  if( (b=bigint_p(FIRST(l))))
	ReturnValue=new TBigInt(log10(*b));

  if(b) delete b;
   
  return rt;
};

TRunType isprime(TList *l)
{
  TRunType rt=TNORMAL;
  ReturnValue=0;

  TBigInt * b=0;
   
  if( (b=bigint_p(FIRST(l))))
	ReturnValue=new TBigInt(TestIfPrime(*b));

  if(b) delete b;
   
  return rt;

};

TRunType isodd(TList *l)
{
  TRunType rt=TNORMAL;
  ReturnValue=0;

  TBigInt * b=0;
   
  if( (b=bigint_p(FIRST(l))))
	ReturnValue=new TBigInt(isodd(*b));

  if(b) delete b;
   
  return rt;
	
};

TRunType iseven(TList *l)
{
  TRunType rt=TNORMAL;
  ReturnValue=0;

  TBigInt * b=0;
   
  if( (b=bigint_p(FIRST(l))))
	ReturnValue=new TBigInt(iseven(*b));

  if(b) delete b;
   
  return rt;
	
};

TRunType nextprime(TList *l)
{
  TRunType rt=TNORMAL;
  ReturnValue=0;

  TBigInt * b=0;
   
  if( (b=bigint_p(FIRST(l))))
  {
    int k;

	if(sign(*b)<0)
         ReturnValue=new TBigInt(2); 
    else
      if(b->Len()<2) //(*b) < 65536
         ReturnValue=new TBigInt(NextPrime(*b));
      else
         ReturnValue=new TBigInt(primeGen(*b,&k,0));

  }

  if(b) delete b;
   
  return rt;
  
};


TRunType primegen(TList *l)
{
  TRunType rt=TNORMAL;
  ReturnValue=0;

  TBigInt * b=0;
   
  if( (b=bigint_p(FIRST(l))))
  {
	int k;
    ReturnValue=new TBigInt(primeGen(*b,&k,randi));
  }
  
  if(b) delete b;
   
  return rt;
   
};

//ֻС2^32ǰһ
TRunType prevprime(TList *l)
{
  
  TRunType rt=TNORMAL;
  ReturnValue=0;

  TBigInt * b=0;
   
  if( (b=bigint_p(FIRST(l))))
  {
    if((*b) <= 2)
    {
       gerror((TAtom *)b, "should be a integer greater than 2.");
       ReturnValue=0;
    }
	else
       ReturnValue=new TBigInt(PrevPrime(*b));
  }

  if(b) delete b;
   
  return rt;
   
};

TRunType random(TList *l)
{
  TRunType rt=TNORMAL;
  ReturnValue=0;

  TBigInt * b=0;
   
  if( (b=bigint_p(FIRST(l))))
	ReturnValue=new TBigInt(Random(*b));

  if(b) delete b;
   
  return rt;
	
};

/*
TRunType chrem(TList *l)
{
  TRunType rt=TNORMAL;
  ReturnValue=0;

  if(l->length()!=2) {
     wout<<" Error! wrong parameter numbers \n";
     return TERROR;
  }

  TAtom *e1= (l->first()->getdata()->eval() );
  TAtom *e2= (l->Part(2));

  if(e1->TypeID() != ListType) {
    wout <<"Error! First parameter should be a Integer set\n";
  }
  if(e2->TypeID() != ListType) {
    wout <<"Error! Second parameter should be an Integer set\n";
  }

  //convert list e1 into TBigInt list ps1
  TList *ps1=new TList();
  SListNodeTAtom *tmp1=((TList *)e1)->first();
  while (tmp1) {
         TAtom *p1=tmp1->getdata()->eval();
         if (p1->TypeID() != BaseNumber ) {
                delete p1;
                delete ps1;
                wout<<" Wrong type!!! (in ascset func)\n";
                return TERROR;
         }
         TBigInt pp1=((TNumber *)p1)->Floor();
         TBigInt *temp= new TBigInt(pp1);
         ps1->dinsert(temp);
         tmp1=tmp1->next;
         delete p1;
  }

  //convert list e2 into TBigInt list ps2
  TList *ps2=new TList();
  SListNodeTAtom *tmp2=((TList *)e2)->first();
  while (tmp2) {
         TAtom *p2=tmp2->getdata()->eval();
         if (p2->TypeID() != BaseNumber ) {
            delete p2;
            delete ps2;
            wout<<" Wrong type!!! (in ascset func)\n";
            return TERROR;
         }
         TBigInt pp2=((TNumber *)p2)->Floor();
         TBigInt *temp2= new TBigInt(pp2);
         ps2->dinsert(temp2);
         tmp2=tmp2->next;
         delete p2;
  }

  ReturnValue=new TBigInt(ChineseRemainder(ps1,ps2));

  delete ps1;
  delete ps2;
  delete e1;

  return rt;
};
*/         

TRunType chrem(TList *l)
{
  TRunType rt=TNORMAL;
  ReturnValue=0;

  TList * bs1=0;
  TList * bs2=0;

  if( (bs1=bigintlist_p(FIRST(l))) && (bs2=bigintlist_p(SECOND(l))))
	  ReturnValue=new TBigInt(ChineseRemainder(bs1,bs2));

  if(bs1) delete bs1;
  if(bs2) delete bs2;

  return rt;
};

TRunType imod_sqrt(TList *l)
{
  TRunType rt=TNORMAL;
  ReturnValue=0;

  TBigInt * b1=0;
  TBigInt * b2=0;
   
  if( (b1=bigint_p(FIRST(l))) && (b2=bigint_p(SECOND(l))))
  {
	int i1=b1->GetShort(0);
    int i2=b2->GetShort(0);
	ReturnValue=new TBigInt(SquareRootMod(i1,i2));
  }

  if(b1) delete b1;
  if(b2) delete b2;
   
  return rt;

};

TRunType imod_sum(TList *l)
{
  TRunType rt=TNORMAL;
  ReturnValue=0;

  TBigInt * b1=0;
  TBigInt * b2=0;
  TBigInt * b3=0;
   
  if( (b1=bigint_p(FIRST(l))) && (b2=bigint_p(SECOND(l))) &&(b3=bigint_p(THIRD(l))))
    ReturnValue=new TBigInt(modular_sum(*b3,*b1,*b2));
  
  if(b1) delete b1;
  if(b2) delete b2;
  if(b3) delete b3;
   
  return rt;
	 
};

TRunType imod_diff(TList *l)
{
  TRunType rt=TNORMAL;
  ReturnValue=0;

  TBigInt * b1=0;
  TBigInt * b2=0;
  TBigInt * b3=0;
   
  if( (b1=bigint_p(FIRST(l))) && (b2=bigint_p(SECOND(l))) &&(b3=bigint_p(THIRD(l))))
    ReturnValue=new TBigInt(modular_diff(*b3,*b1,*b2));
  
  if(b1) delete b1;
  if(b2) delete b2;
  if(b3) delete b3;
   
  return rt;
};

TRunType imod_prod(TList *l)
{
  TRunType rt=TNORMAL;
  ReturnValue=0;

  TBigInt * b1=0;
  TBigInt * b2=0;
  TBigInt * b3=0;
   
  if( (b1=bigint_p(FIRST(l))) && (b2=bigint_p(SECOND(l))) &&(b3=bigint_p(THIRD(l))))
    ReturnValue=new TBigInt(modular_prod(*b3,*b1,*b2));
  
  if(b1) delete b1;
  if(b2) delete b2;
  if(b3) delete b3;
   
  return rt;
};

TRunType imod_quo(TList *l)
{
  TRunType rt=TNORMAL;
  ReturnValue=0;

  TBigInt * b1=0;
  TBigInt * b2=0;
  TBigInt * b3=0;
   
  if( (b1=bigint_p(FIRST(l))) && (b2=bigint_p(SECOND(l))) &&(b3=bigint_p(THIRD(l))))
    ReturnValue=new TBigInt(modular_quo(*b3,*b1,*b2));
  
  if(b1) delete b1;
  if(b2) delete b2;
  if(b3) delete b3;
   
  return rt;
};

TRunType imod_exp(TList *l)
{
  TRunType rt=TNORMAL;
  ReturnValue=0;

  TBigInt * b1=0;
  TBigInt * b2=0;
  TBigInt * b3=0;
   
  if( (b1=bigint_p(FIRST(l))) && (b2=bigint_p(SECOND(l))) &&(b3=bigint_p(THIRD(l))))
    ReturnValue=new TBigInt(modular_exponent(*b3,*b1,*b2));
  
  if(b1) delete b1;
  if(b2) delete b2;
  if(b3) delete b3;
   
  return rt;
};


TRunType imod_neg(TList *l)
{
  TRunType rt=TNORMAL;
  ReturnValue=0;

  TBigInt * b1=0;
  TBigInt * b2=0;
  
  if( (b1=bigint_p(FIRST(l))) && (b2=bigint_p(SECOND(l))))
    ReturnValue=new TBigInt(modular_neg(*b2,*b1));
  
  if(b1) delete b1;
  if(b2) delete b2;
   
  return rt;
};
                 
TRunType imod_inv(TList *l)
{
  TRunType rt=TNORMAL;
  ReturnValue=0;

  TBigInt * b1=0;
  TBigInt * b2=0;
  
  if( (b1=bigint_p(FIRST(l))) && (b2=bigint_p(SECOND(l))))
    ReturnValue=new TBigInt(modular_inv(*b2,*b1));
  
  if(b1) delete b1;
  if(b2) delete b2;
   
  return rt;
};

TRunType imod0(TList *l)
{
  TRunType rt=TNORMAL;
  ReturnValue=0;

  TBigInt * b1=0;
  TBigInt * b2=0;
  
  if( (b1=bigint_p(FIRST(l))) && (b2=bigint_p(SECOND(l))))
    ReturnValue=new TBigInt(mod_0(*b1,*b2));
  
  if(b1) delete b1;
  if(b2) delete b2;
   
  return rt;

};

TRunType imod(TList *l)
{
  TRunType rt=TNORMAL;
  ReturnValue=0;

  TBigInt * b1=0;
  TBigInt * b2=0;
  
  if( (b1=bigint_p(FIRST(l))) && (b2=bigint_p(SECOND(l))))
    ReturnValue=new TBigInt(mod(*b1,*b2));
  
  if(b1) delete b1;
  if(b2) delete b2;
   
  return rt;

};

TRunType iquo(TList *l)
{
  TRunType rt=TNORMAL;
  ReturnValue=0;

  TBigInt * b1=0;
  TBigInt * b2=0;

  if( (b1=bigint_p(FIRST(l))) && (b2=bigint_p(SECOND(l))))
	ReturnValue=new TBigInt((*b1)/(*b2));

  if(b1) delete b1;
  if(b2) delete b2;

  return rt; 

};


TRunType irem(TList *l)
{
  TRunType rt=TNORMAL;
  ReturnValue=0;

  TBigInt * b1=0;
  TBigInt * b2=0;

  if( (b1=bigint_p(FIRST(l))) && (b2=bigint_p(SECOND(l))))
	ReturnValue=new TBigInt((*b1)%(*b2));

  if(b1) delete b1;
  if(b2) delete b2;

  return rt;
};

TRunType ifactorial(TList *l)
{
  TRunType rt=TNORMAL;
  ReturnValue=0;

  TBigInt * b=0;
  
  if( (b=bigint_p(FIRST(l))))
      ReturnValue=new TBigInt(FactorialOP(*b));

  if(b) delete b;

  return rt;
};

//test TNumber:

//TNumber abs(TNumber)
TRunType abs(TList *l)
{
  TRunType rt=TNORMAL;
  ReturnValue=0;
  
  TAtom * a = l->Part(1);
  TAtom * c = a->eval();

  if(c->TypeID() == BaseNumber) {
	TNumber *  num=(TNumber *)c;
    ReturnValue=new TNumber(abs(*num));
  }
  else
  {
	gerror(a, "should be a number.");
    ReturnValue=0;
  }
   
  delete c;
  return rt;
};


//TNumber sqrt(TNumber)
TRunType nsqrt(TList *l)
{
  TRunType rt=TNORMAL;
  ReturnValue=0;

  TNumber * num=0;
   
  if( (num=number_p(FIRST(l))))
      ReturnValue=new TNumber(sqrt(*num));

  if(num) delete num;
   
  return rt;
};


//TNumber::Ceil()
TRunType ceil(TList *l)
{
  TRunType rt=TNORMAL;
  ReturnValue=0;
  
  TAtom * a = l->Part(1);
  TAtom * c = a->eval();

  if(c->TypeID() == BaseNumber) {
	TNumber *  num=(TNumber *)c;
    ReturnValue=new TNumber(num->Ceil());
  }
  else
  {
	gerror(a, "should be a number.");
    ReturnValue=0;
  }
   
  delete c;
  return rt;
};	 

   
//TNumber::Floor()
TRunType floor(TList *l)
{
  TRunType rt=TNORMAL;
  ReturnValue=0;
  
  TAtom * a = l->Part(1);
  TAtom * c = a->eval();

  if(c->TypeID() == BaseNumber) {
	TNumber *  num=(TNumber *)c;
    ReturnValue=new TNumber(num->Floor());
  }
  else
  {
	gerror(a, "should be a number.");
    ReturnValue=0;
  }
   
  delete c;
  return rt;
};


//test TFloatNum:

TRunType SetPrecision(TList *l)
{
  TRunType rt=TNORMAL;
  ReturnValue=0;

  TAtom *a1=l->Part(1);
  TAtom *a2=l->Part(2);

  TAtom *c1=a1->eval();
  TAtom *c2=a2->eval(); 

  if((c1->TypeID() == BaseNumber) && (c2->TypeID() == BaseNumber))
  {
	  TNumber * num1 = (TNumber *)c1;
	  TNumber * num2 = (TNumber *)c2;
	  if(((num1->GetPtr())->TypeID() == FloatNumberType) && ((num2->GetPtr())->TypeID() == BigNumberType))
      {
		  TFloatNum * n1 = (TFloatNum *)(num1->GetPtr());
		  TBigInt * n2 = (TBigInt *)(num2->GetPtr());
		  short d = n2->GetShort(0);
  
          ReturnValue=new TFloatNum(n1->SetFloatNum2(d));
      }
	  else
      {
		  wout << "The first parameter should be a float number and the second should be an integer." << endl;
		  ReturnValue=0;
      }
  }
  else
  {
	  wout << "The two parameters should be two numbers." << endl;
	  ReturnValue=0;
  }	    
  
  delete c1;
  delete c2;
  return rt;
};


TRunType fsqrt(TList *l)
{
  TRunType rt=TNORMAL;
  ReturnValue=0;

  TFloatNum * f=0;
   
  if( (f=floatnum_p(FIRST(l))))
      ReturnValue=new TFloatNum(sqrt(*f));

  if(f) delete f;
   
  return rt;
	
};


//test TFraction:

TRunType rsqrt(TList *l)
{
  TRunType rt=TNORMAL;
  ReturnValue=0;

  TFraction *f=0;
   
  if(f=fraction_p(FIRST(l)))
      ReturnValue=new TFraction(sqrt(*f));

  if(f) delete f;
   
  return rt;
	
};

/*
//construct a fraction
//TFraction::TFraction(TBigInt, TBigInt)
TRunType fraction(TList *l)
{
  TRunType rt=TNORMAL;
  ReturnValue=0;

  TBigInt *n=0;
  TBigInt *d=0;
   
  if( (n=bigint_p(FIRST(l))) &&  (d=bigint_p(SECOND(l))) )
      ReturnValue=new TFraction(*n,*d);

  if(n) delete n;
  if(d) delete d;
   
  return rt;
	
};
//*/

/*
//construct a fraction
//TFraction::TFraction(int,int)
TRunType fraction(TList *l)
{
  TRunType rt=TNORMAL;
  ReturnValue=0;

  TBigInt *n=0;
  TBigInt *d=0;
  int nn,dd;
   
  if( (n=bigint_p(FIRST(l))) &&  (d=bigint_p(SECOND(l))) )
  {
      nn=n->GetInt();
	  dd=d->GetInt();
      ReturnValue=new TFraction(nn,dd);
  }

  if(n) delete n;
  if(d) delete d;
   
  return rt;
	
};
//*/

//*
//construct a fraction
//TFraction::TFraction(TNumber,TNumber)
TRunType fraction(TList *l)
{
  TRunType rt=TNORMAL;
  ReturnValue=0;

  TNumber *n=0;
  TNumber *d=0;
  
  if( (n=number_p(FIRST(l))) &&  (d=number_p(SECOND(l))) )
  {
       
      ReturnValue=new TFraction(*n,*d);
  }

  if(n) delete n;
  if(d) delete d;
   
  return rt;
	
};
//*/

//test TDouble:

/*
TRunType fabs(TList *l)
{
  TRunType rt=TNORMAL;
  ReturnValue=0;

  TAtom *a=l->Part(1);
  TAtom *c=a->eval();
 
  DataType dtc = c->TypeID();

  if(dtc == BaseNumber)
  {
	  TNumber * num= (TNumber *)c;
	  
	  if((num->GetPtr())->TypeID() == DoubleType) 
      {
		 TDouble * n = (TDouble *)(num->GetPtr());
		   
         ReturnValue=new TDouble(fabs(*n));
      }
	  else
      {
         wout << "The parameter should be a double. "<< endl;
	     ReturnValue=0;
      }
  }
  else
  {
      wout << "The parameter should be a number." << endl;
      ReturnValue=0;
  }	    
  
  delete c;
  
  return rt;
};
*/


TRunType fabs(TList *l)
{
  TRunType rt=TNORMAL;
  ReturnValue=0;

  TDouble * b=0;
   
  if( (b=double_p(FIRST(l))))
      ReturnValue=new TDouble(fabs(*b));

  if(b) delete b;
   
  return rt;
	
};

//test TComplex:

TRunType cprod(TList *l)
{
  TRunType rt=TNORMAL;
  ReturnValue=0;

  TComplex * c1=0;
  TComplex * c2=0;

  if( (c1=complex_p(FIRST(l))) && (c2=complex_p(SECOND(l))))
  {
     TComplex cc=(*c1) * (*c2); //call TComplex *

     ReturnValue=new TComplex(cc); 
  }

  if(c1) delete c1;
  if(c2) delete c2;

  return rt; 

};


TRunType cquo(TList *l)
{
  TRunType rt=TNORMAL;
  ReturnValue=0;

  TComplex * c1=0;
  TComplex * c2=0;

  if( (c1=complex_p(FIRST(l))) && (c2=complex_p(SECOND(l))))
  {
     TComplex cc=(*c1) / (*c2); //call TComplex /

     ReturnValue=new TComplex(cc); 
  }

  if(c1) delete c1;
  if(c2) delete c2;

  return rt; 

};

 
//>type(a);
//return the type name of an atom a
//Note:
//we can get the decimal number of the type by using
//the Maple command:
//>convert(n,decimal,8);
//where n is the 8 base number in DataType
TRunType type(TList *l)
{
	TRunType rt=TNORMAL;
	ReturnValue=0;

    TAtom * a=FIRST(l);

	DataType dt=a->TypeID();

	//TAtom * c = a->eval();
    //DataType dt=c->TypeID();

	switch(dt)
    {  
	     case BaseNumber:{
		       
              TNumber * n = (TNumber*)a;
              DataType dt1=n->GetPtr()->TypeID();
              
			  switch(dt1)
			  {
                case BigNumberType: wout<<"\nBaseNumber(TNumber)->BigNumberType(TBigInt)\n"<< endl;break;
	            case FloatNumberType: wout<<"\nBaseNumber(TNumber)->FloatNumberType(TFloatNum)\n"<< endl;break;
	            case FractionType: wout<<"\nBaseNumber(TNumber)->FractionType(TFraction)\n"<< endl;break;
		        case DoubleType: wout<<"\nBaseNumber(TNumber)->DoubleType(TDouble)\n"<< endl;break;
	            case ComplexType: wout<<"\nBaseNumber(TNumber)->ComplexType(TComplex)\n"<< endl;break;
			    default: break;
			  }
		      break;
		  }
          case BigNumberType: wout<<"\nBigNumberType(TBigInt)\n"<< endl; break;
	      case FloatNumberType: wout<<"\nFloatNumberType(TFloatNum)\n"<< endl;break;
	      case FractionType: wout<<"\nFractionType(TFraction)\n"<< endl;break;
		  case DoubleType: wout<<"\nDoubleType(TDouble)\n"<< endl;break;
	      case ComplexType: wout<<"\nComplexType(TComplex)\n"<< endl;break;

	      case Variable: 
			  {	  
                wout<<"\nVariable(TVariable)\n"<< endl;

			    TVarType vt=((TVariable *)a)->type;

				switch(vt)
				{
				   case UNDEFINED:wout<<"\ntype:UNDEFINED\n"<< endl; break;
	               case TSYMBOL:wout<<"\ntype:TSYMBOL\n"<< endl; break;
		           case TVARIABLE:wout<<"\ntype:TVARIABLE\n"<< endl; break;
		           case TPARAMETER:wout<<"\ntype:TPARAMETER\n"<< endl; break;
	               case TPROCEDURE:wout<<"\ntype:TPROCEDURE\n"<< endl; break;
		           case TSYSFUNCTION:wout<<"\ntype:TSYSFUNCTION\n"<< endl; break;
		           case TLIST:wout<<"\ntype:TLIST\n"<< endl; break;
		           case TFUNCTION:wout<<"\ntype:TFUNCTION\n"<< endl; break;
				}
			    break;
			  }
	      case Expression: wout<<"\nExpression(TExpression)\n"<< endl;break;
	      case ListType: wout<<"\nListType(TList)\n"<< endl;break;
	      case RIPolyType: wout<<"\nRIPolyType(TRIPoly)\n"<< endl;break;
		  case RationalType: wout<<"\nRationalType(TRational)\n"<< endl;break;
          case MatrixType: wout<<"\nMatrixType(TMatrix)\n"<< endl;break;
          case Strings: wout<<"\nStrings(TString)\n"<< endl;break;
		  case VectorType: wout<<"\nVectorType(TVector)\n"<< endl;break;
          default: break;
	}

    ReturnValue=new TBigInt(0);

    //delete c;

	return rt;

}


//-----------------------------------------------
//
//                     Polynomial operation
//
//-----------------------------------------------

TRIPoly* testconvert1(TRIPoly* b);
//TRIPoly* testconvert2(TRIpoly* b);

TRunType testconvert(TList *l)
{
 TRunType rt=TNORMAL;
  ReturnValue=0;
 if(l->length()!=1) {
     wout<<" Error! wrong para-number in call IsNumber(...) \n";
     return TERROR;
   }

 TAtom *e1=(l->first()->getdata()->eval() );
/* if (e1->TypeID() != RIPolyType) {
     delete e1;
     wout<<" wrong type\n";
     return TERROR;
   }
 TRIPoly *bi=testconvert1((TRIPoly *)e1);
*/
 char *ch=((TString *)e1)->GetStr(); 
 wout<<ch;
 wout<<endl;
 ReturnValue=0;
 delete e1;
 return rt;
};

TRunType IsNumber(TList *l)
{
 TRunType rt=TNORMAL;
  ReturnValue=0;
  TRIPoly * p=0;
  if(p=poly_p(FIRST(l)))
	  ReturnValue=new TBigInt(p->IsBigInt());
  if(p) delete p;
  return rt;
};

TRunType IsZero(TList *l)
{
 TRunType rt=TNORMAL;
  ReturnValue=0;
  TRIPoly * p=0;
  if(p=poly_p(FIRST(l)))
	  ReturnValue=new TBigInt(p->IsZero());
  if(p) delete p;
  return rt;
};

TRunType PLength(TList *l)
{
  TRunType rt=TNORMAL;
  ReturnValue=0;
  TRIPoly * p=0;
  if(p=poly_p(FIRST(l)))
	  ReturnValue=new TBigInt(p->polylen());
  if(p) delete p;
  return rt;
};

TRunType MainVar(TList *l)
{
  TRunType rt=TNORMAL;
  ReturnValue=0;
  TRIPoly * p=0;
  TList * vs=0;
  if( (p=poly_p(FIRST(l))) && (vs=varlist_p(SECOND(l))))
	   ReturnValue=mainvar_wdk(p,vs);
  if(p) delete p;
  if(vs) delete vs;
  return rt;
};

TRunType Coeff(TList *l)
{
  TRunType rt=TNORMAL;
  ReturnValue=0;
  TRIPoly * p=0;
  TVariable * v=0;
  TBigInt * b=0;
  if( (p=poly_p(FIRST(l))) && (v=var_p(SECOND(l))) && (b=bigint_p(THIRD(l))))
	   ReturnValue=p->Coefficient(v,b->GetShort(0));
  if(p) delete p;
  if(b) delete b;
  return rt;
};

TRunType Coeffs(TList *l)
{
  TRunType rt=TNORMAL;
  ReturnValue=0;
  TRIPoly * p=0;
  TVariable * v=0;
  if( (p=poly_p(FIRST(l))) && (v=var_p(SECOND(l))) )
	   ReturnValue=p->Coeffs(v);
  if(p) delete p;
  return rt;
};

TRunType Deg(TList *l)
{
  TRunType rt=TNORMAL;
  ReturnValue=0;
  TRIPoly * p=0;
  TVariable * v=0;
  if( (p=poly_p(FIRST(l))) && (v=var_p(SECOND(l))) )
	   ReturnValue=new TBigInt(p->Degree(v));
  if(p) delete p;
  return rt;
};

TRunType MinDeg(TList *l)
{
  TRunType rt=TNORMAL;
  ReturnValue=0;
  TRIPoly * p=0;
  TVariable * v=0;
  if( (p=poly_p(FIRST(l))) && (v=var_p(SECOND(l))) )
	   ReturnValue=new TBigInt(p->MinDegree(v));
  if(p) delete p;
  return rt;
};

TRunType TDiv(TList *l)
{
  TRunType rt=TNORMAL;
  ReturnValue=0;
  TRIPoly * p1=0,*p2=0;
  TVariable * v=0;
  if( (p1=poly_p(FIRST(l))) && (p2=poly_p(SECOND(l))) )
  {
	  TRIPoly temp=(*p1)-(*p2)*((*p1)/(*p2));
	  if(temp.IsZero())
			ReturnValue=new TBigInt(1);
	  else
			ReturnValue=new TBigInt(0);
  }
  if(p1) delete p1;
  if(p2) delete p2;
  return rt;
};

TRunType Prem(TList *l)
{
  TRunType rt=TNORMAL;
  ReturnValue=0;
  TRIPoly * p1=0,*p2=0;
  TVariable * v=0;
  if( (p1=poly_p(FIRST(l))) && (p2=poly_p(SECOND(l))) && (v=var_p(THIRD(l))) )
	   ReturnValue=p1->prem(*p2,v);
  if(p1) delete p1;
  if(p2) delete p2;
  return rt;
};

TRunType LeadCoeff(TList *l)
{
  TRunType rt=TNORMAL;
  ReturnValue=0;
  TRIPoly * p=0;
  TList * vs=0;
  if( (p=poly_p(FIRST(l))) && (vs=varlist_p(SECOND(l))))
	   ReturnValue=p->IPLdCf_w(vs);
  if(p) delete p;
  if(vs) delete vs;
  return rt;
};

TRunType LeadTerm(TList *l)
{ 
  TRunType rt=TNORMAL;
  ReturnValue=0;
  TRIPoly * p=0;
  TList * vs=0;
  if( (p=poly_p(FIRST(l))) && (vs=varlist_p(SECOND(l))))
	   ReturnValue=p->IPldt_w(vs);
  if(p) delete p;
  if(vs) delete vs;
  return rt;
};

TRunType Reductum(TList *l)
{
  TRunType rt=TNORMAL;
  ReturnValue=0;
  TRIPoly * p=0;
  TList * vs=0;
  if( (p=poly_p(FIRST(l))) && (vs=varlist_p(SECOND(l))))
  {
	TRIPoly *temp=((p->IPldt_w(vs)));
	ReturnValue=new TRIPoly((*p)-(*temp));
	delete temp;
  }
  if(p) delete p;
  if(vs) delete vs;
  return rt;
};

TRunType Content(TList *l)
{
  TRunType rt=TNORMAL;
  ReturnValue=0;
  TRIPoly * p=0;
  if(p=poly_p(FIRST(l)))
	  ReturnValue=new TRIPoly(p->icont());
  if(p) delete p;
  return rt;
};

TRunType Primitive(TList *l)
{	
  TRunType rt=TNORMAL;
  ReturnValue=0;
  TRIPoly * p=0;
  if(p=poly_p(FIRST(l)))
//	  ReturnValue=new TRIPoly((*p)/(p->icont()));
ReturnValue=new TRIPoly(p->ippp(p->var));
  if(p) delete p;
  return rt;
};

TRunType Gcd(TList *l)
{
  TRunType rt=TNORMAL;
  ReturnValue=0;
  TRIPoly * p1=0,*p2=0;
  if( (p1=poly_p(FIRST(l))) && (p2=poly_p(SECOND(l))) ){
	int t1=clock();                             
	   ReturnValue=new TRIPoly(p1->mipgcdold(*p2));
	int t2=clock();
	wout<<"\ntime is:"<<t2-t1<<endl;

  }
  if(p1) delete p1;
  if(p2) delete p2;
  return rt;
};

TRunType GcdEuclidean(TList *l)
{
  TRunType rt=TNORMAL;
  ReturnValue=0;
  TRIPoly * p1=0,*p2=0;
  if( (p1=poly_p(FIRST(l))) && (p2=poly_p(SECOND(l))) )
	   ReturnValue=new TRIPoly(p1->ipgcd(*p2));
  if(p1) delete p1;
  if(p2) delete p2;
  return rt;
};

TRunType PChrem(TList *l)
{
 TRunType rt=TNORMAL;
 ReturnValue=0;
 TList *pl=0,*bl=0;
 if( (bl=bigintlist_p(FIRST(l))) && (pl=polylist_p(SECOND(l))) )
	   ReturnValue=new TRIPoly(PCRAt(bl,pl));
 if(bl) delete bl;
 if(pl) delete pl;
 return rt;
};

TRunType Factor(TList *l)
{
  TRunType rt=TNORMAL;
  ReturnValue=0;

  TRIPoly * p=0;

  if(p=poly_p(FIRST(l)))
  {
	//int t1=clock();                             
	ReturnValue=p->Factor();
	//int t2=clock();
	//wout<<"\ntime is: "<<t2-t1<<endl;
  }

  if(p) delete p;

  return rt;
};

TRunType Factorold(TList *l)
{
  TRunType rt=TNORMAL;
  ReturnValue=0;

  TRIPoly * p=0;

  if(p=poly_p(FIRST(l)))
	 ReturnValue=p->Factorold();

  if(p) delete p;

  return rt;
};

TRunType SquareFree(TList *l)
{
  TRunType rt=TNORMAL;
  ReturnValue=0;
  TRIPoly * p=0;
  if(p=poly_p(FIRST(l)))
	  ReturnValue=p->SqureFree();
  if(p) delete p;
  return rt;
};

TRunType Derivative(TList *l)
{
  TRunType rt=TNORMAL;
  ReturnValue=0;
  TRIPoly * p=0;
  TVariable * v=0;
  if( (p=poly_p(FIRST(l))) && (v=var_p(SECOND(l))) )
	   ReturnValue=new TRIPoly(p->derivative(v));
  if(p) delete p;
  return rt;
};

TRunType GetVarList(TList *l)
{
  TRunType rt=TNORMAL;
  ReturnValue=0;
  TRIPoly * p=0;
  if(p=poly_p(FIRST(l)))
	  ReturnValue=p->getVL();
  if(p) delete p;
  return rt;
};

TRunType Substitute(TList *l)
{
  TRunType rt=TNORMAL;
  ReturnValue=0;
  TRIPoly * p=0;
  TVariable * v=0;
  TBigInt * b=0;
  if( (p=poly_p(FIRST(l))) && (v=var_p(SECOND(l))) && (b=bigint_p(THIRD(l))) )
	   ReturnValue=p->IPvri(v,*b);
  if(p) delete p;
  if(b) delete b;
  return rt;
};

TRunType Resultant(TList *l)
{
  TRunType rt=TNORMAL;
  ReturnValue=0;
  TRIPoly * p1=0,*p2=0;
  TVariable * v=0;
  if( (p1=poly_p(FIRST(l))) && (p2=poly_p(SECOND(l))) && (v=var_p(THIRD(l))) )
	   ReturnValue=new TRIPoly(p1->Resultant(*p2,v));
  if(p1) delete p1;
  if(p2) delete p2;
  return rt;
};

TRunType PMod(TList *l)
{
  TRunType rt=TNORMAL;
  ReturnValue=0;
  TRIPoly * p=0;
  TBigInt * b=0;
  if( (p=poly_p(FIRST(l))) && (b=bigint_p(SECOND(l))) )
	   ReturnValue=p->mod(*b);
  if(p) delete p;
  if(b) delete b;
  return rt;
};

TRunType PModSum(TList *l)
{
  TRunType rt=TNORMAL;
  ReturnValue=0;
  TRIPoly * p1=0,*p2=0;
  TBigInt * b=0;
  if( (p1=poly_p(FIRST(l))) && (p2=poly_p(SECOND(l))) && (b=bigint_p(THIRD(l))) )
	   ReturnValue=IPmium(p1,p2,*b);
  if(p1) delete p1;
  if(p2) delete p2;
  if(b) delete b;
  return rt;
};

TRunType PModDiff(TList *l)
{
  TRunType rt=TNORMAL;
  ReturnValue=0;
  TRIPoly * p1=0,*p2=0;
  TBigInt * b=0;
  if( (p1=poly_p(FIRST(l))) && (p2=poly_p(SECOND(l))) && (b=bigint_p(THIRD(l))) )
	   ReturnValue=IPmdif(p1,p2,*b);
  if(p1) delete p1;
  if(p2) delete p2;
  if(b) delete b;
  return rt;
};
                        
TRunType PModProd(TList *l)
{
  TRunType rt=TNORMAL;
  ReturnValue=0;
  TRIPoly * p1=0,*p2=0;
  TBigInt * b=0;
  if( (p1=poly_p(FIRST(l))) && (p2=poly_p(SECOND(l))) && (b=bigint_p(THIRD(l))) )
	   ReturnValue=IPmpro(p1,p2,*b);
  if(p1) delete p1;
  if(p2) delete p2;
  if(b) delete b;
  return rt;
};
           
TRunType PModQuo(TList *l)
{
  TRunType rt=TNORMAL;
  ReturnValue=0;
  TRIPoly * p1=0,*p2=0;
  TBigInt * b=0;
  if( (p1=poly_p(FIRST(l))) && (p2=poly_p(SECOND(l))) && (b=bigint_p(THIRD(l))) )
	   ReturnValue=new TRIPoly(p1->mdiv(*p2,*b));
  if(p1) delete p1;
  if(p2) delete p2;
  if(b) delete b;
  return rt;
};
           
TRunType PModPrem(TList *l)
{
  TRunType rt=TNORMAL;
  ReturnValue=0;
  TRIPoly * p1=0,*p2=0;
  TBigInt * b=0;
  TVariable *v;
  if( (p1=poly_p(FIRST(l))) && (p2=poly_p(SECOND(l))) && (v=var_p(THIRD(l))) && (b=bigint_p(FOURTH(l))) )
	   ReturnValue=p1->mprem(*p2,v,*b);
  if(p1) delete p1;
  if(p2) delete p2;
  if(b) delete b;
  return rt;
};

TRunType PModGcd(TList *l)
{
  TRunType rt=TNORMAL;
  ReturnValue=0;
  TRIPoly * p1=0,*p2=0;
  TBigInt * b=0;
  if( (p1=poly_p(FIRST(l))) && (p2=poly_p(SECOND(l))) && (b=bigint_p(THIRD(l))) )
	   ReturnValue=new TRIPoly(p1->pipgcd(*p2,*b));
  if(p1) delete p1;
  if(p2) delete p2;
  if(b) delete b;
  return rt;
};

TRunType PModFactor(TList *l)
{
  TRunType rt=TNORMAL;
  ReturnValue=0;
  TRIPoly * p1=0;
  TBigInt * b=0;
  if( (p1=poly_p(FIRST(l))) && (b=bigint_p(SECOND(l))) )
	   ReturnValue=p1->FormMatrixQ(*b,TBigInt(1));
  if(p1) delete p1;
  if(b) delete b;
  return rt;
};

TRunType PModSquareFree(TList *l)
{
  TRunType rt=TNORMAL;
  ReturnValue=0;
  TRIPoly * p1=0;
  TBigInt * b=0;
  if( (p1=poly_p(FIRST(l))) && (b=bigint_p(SECOND(l))) )
	   ReturnValue=p1->FFiupSF(*b,TBigInt(1));
  if(p1) delete p1;
  if(b) delete b;
  return rt;
};

TRunType vartest(TList *l)
{
 TRunType rt=TNORMAL;
 if(l->length()!=1) {
     wout<<" Error! wrong para-numbers \n";
     return TERROR;
   }
 TAtom *e1= (l->first()->getdata()->eval() );
 TVariable * t;
 TShortList* temp=getlist(((TRIPoly *)e1)->MainVar());
 t=formvar(getname(((TRIPoly *)e1)->MainVar()),temp);
 delete temp;
// t->display();wout<<endl;
 ReturnValue=t;
 delete e1;
 return rt;
}                          

//test: TList * Poly_Solver(TList *)
/*
TRunType polysolver(TList *l)
{
  TRunType rt=TNORMAL;
  ReturnValue=0;

  TList * l1=0;

  if( (l1=doublelist_p(FIRST(l))) )
	ReturnValue=Poly_Solver(l1);

  if(l1) delete l1;
  return rt;
};
*/

//test: TList * Poly_Solver(TList * Poly)
//>polysolver(l);
//the elements in the list l can be of the mixed type of 
//TBigInt,TFloatNum,TFraction,TDouble.
//For example:
//>polysolver([3D,-92D,1016D,-5074D,11413D,-9282D]);
//[13,7,5.66667,3,2]
//>polysolver([3,-92,1016,-5074,11413,-9282]);
//[13,7,5.66667,3,2]
//>polysolver([3,-92,1016D,-5074D,11413.0,-9282.0]);
//[13,7,5.66667,3,2]
//>polysolver([3,-92,1016,-5074,1413,-9282]);
//[-1.10096,15.9317+0.141453I,15.9317-0.141453I,-0.0479017-1.36161I,-0.0479017+1.3
//6161I]
TRunType polysolver(TList *l)
{
  TRunType rt=TNORMAL;
  ReturnValue=0;

  TList * l1=0;

  if( (l1=numberlist_p(FIRST(l))) ) //l1 is a list of TNumber
  {
	TList * ltemp = new TList();

	for(int i=1; i<=l1->length();i++)
		ltemp->append((TAtom *)(new TDouble(*(TNumber*)(l1->Part(i))))); 
	//ltemp becomes a list of TDouble

	ReturnValue=Poly_Solver(ltemp);

	delete ltemp;
  }

  if(l1) delete l1;
  return rt;
};


/*
//test: TRIPoly *TRIPoly::Simplify()
//For example:
//>psimplify(x);
//x
//>psimplify(x^2+2*x+1);
//x^2+2*x+1
//>psimplify(sin(-x)^2+2*sin(-x)+1);
//sin(x)^2-2*sin(x)+1
//>psimplify(sqrt(9)^2+2*sqrt(9)+1);
//16
//>psimplify(sqrt(10)^2+2*sqrt(10)+1);
//sqrt(10)^2+2*sqrt(10)+1
TRunType psimplify(TList *l)
{
  TRunType rt=TNORMAL;
  ReturnValue=0;

  TRIPoly * p=0;

  p=(TRIPoly *)(FIRST(l)->eval());
  G_OUT("p=",p);
  ReturnValue=p->Simplify();
   
  if(p) delete p;

  return rt;
};
//*/


//*
//this function is useful!
//test: TRIPoly *TRIPoly::Simplify()
//For example:
//>psimplify(x);
//x
//>psimplify(x^2+2*x+1);
//x^2+2*x+1
//>psimplify(sin(-x)^2+2*sin(-x)+1);
//sin(x)^2-2*sin(x)+1
//>psimplify(sqrt(9)^2+2*sqrt(9)+1);
//16
//>psimplify(sqrt(10)^2+2*sqrt(10)+1);
//sqrt(10)^2+2*sqrt(10)+1
TRunType psimplify(TList *l)
{
  TRunType rt=TNORMAL;
  ReturnValue=0;

  TRIPoly * p=0;

  if(p=poly_p(FIRST(l)))
  //ע⣺poly_p()Ѷ˻
  //poly_p() -> toTRIPoly() -> TVariable::eval() -> TVariable::Simplify()
  {
     G_OUT("p=",p);
     ReturnValue=p->Simplify();
  }

  if(p) delete p;

  return rt;
};
//*/



//-----------------------------------------------
//
//                     Array operation
//
//-----------------------------------------------

TRunType array(TList *l)
{
	TRunType rt=TNORMAL;
	ReturnValue=0;
  	if(l->length()!=1) {
		wout<<" Error! wrong parameter numbers \n";
		return TERROR;
    }

	TAtom *e3 = l->first()->getdata()->eval();
	if(e3->TypeID() != ListType) {
		wout <<"Error! Second parameter should be a list\n";
		return TERROR;
	}

	TList *ps=new TList();
	TListNode *tmp=((TList *)e3)->first();
	while (tmp) {
        TAtom *p=tmp->getdata()->eval();
        ps->append(p);
        tmp=tmp->next;
        }

	Tarray *t = new Tarray((TList *)ps);
	ReturnValue=t;
	delete e3;
	delete ps;
	return rt;
}         

//-----------------------------------------------
//
//                     Syzygy operation
//
//-----------------------------------------------

TRunType syzygy(TList *l)
{
 TRunType rt=TNORMAL;
 ReturnValue=0;

 TList* l1 = toTRIPolyList((TList*)FIRST(l));
 TList * vs=varlist_p(l->Part(2));
// l1->display();wout<<endl;
// vs->display();wout<<endl;

 TMatrix * re = get_syzygy(l1,vs);

 delete l1;
 delete vs;
 ReturnValue = re;
 return rt;

}

TRunType syz(TList *l)
{
 TRunType rt=TNORMAL;
 ReturnValue=0;

 TList* l1 = toTRIPolyList((TList*)FIRST(l));
 TList * vs=varlist_p(l->Part(2));
 l1->display();wout<<endl;
 vs->display();wout<<endl;

 TList * re = Syzygy(l1,vs);

 delete l1;
 delete vs;
 ReturnValue = re;
 return rt;

}

TRunType grem(TList *l)
{
 TRunType rt=TNORMAL;
 ReturnValue=0;
 TList *p = (TList *)(l->Part(1));
 TList *g = (TList *)(l->Part(2));
 TList *vs=varlist_p(l->Part(3));
 p->display();wout<<endl;
 g->display();wout<<endl;
 vs->display();wout<<endl;
 TMatrix *r = grem_for_syzygy(p,g,vs);

/* TRIPoly* p1 = TP(l->Part(1)->eval());
 TRIPoly* p2 = TP(l->Part(2)->eval());
 PP pp = grem_syzygy(p1,p2);

 pp.p1 = uprim(pp.p1);
 pp.p2 = uprim(pp.p2);
 pp.p1->display();wout<<endl;
 pp.p2->display();wout<<endl;
// POLY * pp = grem(p1,p2);
 delete p2;
 */ReturnValue = r;
 delete p;
 delete g;
 delete vs;
 return rt;
}

TRunType divvar(TList *l)
{
 TRunType rt=TNORMAL;
 ReturnValue=0;
/*//computer divvar
 TRIPoly* p1 = TP(l->Part(1)->eval());
 TRIPoly* p2 = TP(l->Part(2)->eval());
 TList * vs=varlist_p(l->Part(3));
 p1->display();wout<<endl;
 p2->display();wout<<endl;
 vs->display();wout<<endl;

 TRIPoly p = p1->divvar((*p2),vs);
 p.display();wout<<endl;
 TRIPoly pp = (*p1)-(*p2)*p;
 pp.display();
//*/
/*//computer s_poly
 TRIPoly * p1 = TP(l->Part(1)->eval());
 TRIPoly * l2 = TP(l->Part(2)->eval());
 TList * vs=varlist_p(l->Part(3));
 TRIPoly * re = S_poly(p1,l2,vs);
 //*/
//compute div_var
 TRIPoly* p1 = TP(l->Part(1)->eval());
 TList* l2 = (TList *)(l->Part(2)->eval());
 TList * vs=varlist_p(l->Part(3));
 p1->display();wout<<endl;
 l2->display();wout<<endl;
 vs->display();wout<<endl;
 TList * re = div_var((*p1),l2,vs);
//*/
 delete p1;
 delete l2;
 delete vs;
 ReturnValue = re;
 return rt;
}

TRunType gbasis(TList *l)
{
 TRunType rt=TNORMAL;
 ReturnValue=0;

 TList* l1 = toTRIPolyList((TList*)FIRST(l));
 TList * vs=varlist_p(l->Part(2));
 l1->display();wout<<endl;
 vs->display();wout<<endl;
 TList * re = gbasis_for_syzygy(l1,vs);

 delete l1;
 delete vs;
 ReturnValue = re;
 return rt;
}

//-----------------------------------------------
//
//                  Tofind (by bxia)
//  debuging...
//-----------------------------------------------
/*
TRunType realroot(TList *l)
{
	TRunType rt=TNORMAL;
	if(FIRST(l)==NULL && SECOND(l)==NULL)
	{
		cout<<"no paramater"<<endl;
		return rt;
	}
	else if(SECOND(l)==NULL)
	{
		cout<<"1 paramater"<<endl;
		return rt;
	}
	else
	{
		TRIPoly* p = 0;
		TFloatNum* widthgoal = 0;
		if(p=poly_p(FIRST(l)))
		{
			if(widthgoal=floatnum_p(SECOND(l)))
			{
				//ifֻΪ˱ӦòǱ
				TList* L;
				L = realRoot(p,widthgoal);
				ReturnValue = L;
//				ReturnValue->display();
			}
		}
		//realroot();
	//	cout<<"then,return rt"<<endl;
		return rt;
	}
}    
*/