


//================== ~soft/V1.1/0221/tripoly.h ===================


#ifndef __STAR_RIPOLY__
#define __STAR_RIPOLY__
#include <stdio.h>
#include <string.h>
#include <new.h>
#include "basetype.h"
#include "global.h"
#include "expval.h"
#include "number.h"
#include "number1.h"
#include "express.h"     
//#include "convert.h"
//#include "num.h"

typedef	TBigInt		NUM;
typedef	TVariable	var;
typedef unsigned short  POLYDEG;
typedef TVariable	VAR;
class TDITerm;

class TPolyRC
{
public:
        unsigned long rc;
        TPolyRC * nx;
};        

class TRIPoly:public TExpVal  
{ 
friend TDITerm;    
public:
  TVariable *var;
  TBigInt c;
//union{
  TDITerm *ups;
//  TRIPoly *p;
//} u;
  TPolyRC *RefCount;

//memeber-functions
	TRIPoly();
	//builds a zero polynomial;

    TRIPoly(TBigInt va);
    //build a constant polynomial from TBigInt i;

    TRIPoly(TBigInt * va);	
    //same as former;

    TRIPoly(TVariable *v,unsigned short * d);	
    //build v^d from TVariable v and TBigInt d;
	//TRIPoly(TVariable *v){TRIPoly(v,1);};

    TRIPoly(TVariable *v,unsigned short d=1);	
    //same as former;

    TRIPoly(const TRIPoly &tr);		
    //Build a polynomial from polynomial tr;

//    TRIPoly(TRIPoly &tr);		
    //same as former;

    ~TRIPoly();				
    //distruction;

virtual DataType TypeID()const {
                return RIPolyType;
                };
 TAtom * uminus(int how=1);

    TRIPoly * Clone(){return cp_TRIPoly(this);};
    //make a new polynomial same as the original;

    TAtom *Copy(){return new TRIPoly(*this);};
    //make a copy;


    unsigned long RefInc(){return RefCount->rc=(RefCount->rc)+1;};

    unsigned long RefDec(){return RefCount->rc=(RefCount->rc)-1;};

    unsigned long &Ref()const{return RefCount->rc;};

    unsigned long SetRef(unsigned long * n)
    {
      if(*n==(RefCount->rc)) return *n;
      else
      {
        if(RefCount->rc==1)
          put_rc(RefCount);
        else
          RefDec();
        (RefCount->rc)=*n;
       return *n;
      }
    }                          

    void * operator new(size_t);

    void operator delete(void *);

//==========Begin basic operators

	TRIPoly operator=(const TRIPoly & p);

    TRIPoly operator-();

    TRIPoly operator +(TRIPoly p);

    inline TRIPoly *poly_plus(TRIPoly *p1,TRIPoly *p2)
       {return pplus(cp_TRIPoly(p1),cp_TRIPoly(p2));};

    TRIPoly operator -(TRIPoly p);

    TRIPoly operator*(TRIPoly p);

    friend TRIPoly *poly_mul(TRIPoly *p1,TRIPoly *p2)
        {return ptimes(cp_TRIPoly(p1),cp_TRIPoly(p2));};

    TRIPoly operator/(TRIPoly&);

    TRIPoly operator/(TBigInt &);

    TRIPoly *prem(TRIPoly& p,TVariable *var);
    //integral polynomial pseudo-remainder;

    TRIPoly *mprem(TRIPoly& p,TVariable *var,TBigInt &b);	
    //integral polynomial pseudo-remainder modular TBigInt b;

    TRIPoly *pquo(TRIPoly& p,TVariable *var);	
    //integral polynomial pseudo-quotient;

    TRIPoly operator%(TRIPoly&);

    TRIPoly operator^(unsigned short deg);

    bool operator==(TRIPoly &bn);
 
    TRIPoly operator+=(TRIPoly &bn);

    TRIPoly operator-=(TRIPoly &bn);

    TRIPoly operator*=(TRIPoly &bn);

    TRIPoly operator/=(TRIPoly &bn);

    TRIPoly operator/=(TBigInt &bn);

    TRIPoly operator%=(TRIPoly &bn);

    virtual void show(outtype& out =wout)const;
    //polynomial output in recursive form;

    virtual void print(outtype& out =wout)const;
    //polynomial output in recursive form;

    virtual void display(outtype& out =wout)const;
    //polynomial output in recursive form;

    void display1(char *s,int t,outtype& out =wout)const;
    //polynomial outpur in distribute form;
//============ end basic operators


//============ Begin information part;

    unsigned short deg();
    //return the degree of the argument w.r.t. main variable;

    unsigned short maindeg();
    //return the minumum degree of the argument w.r.t. main variable;

    unsigned short Degree(TVariable *v);
    //return the degree of the argument w.r.t. variable v;
    unsigned short MinDegree(TVariable *v);
    //return the degree of the argument w.r.t. variable v;

//====  ADDING the degree function mdet(TVariable * v) 
//return the minumum degree of the argument w.r.t. variable v;

    unsigned long PolyLen();
    //term count w.r.t. main variable;

    unsigned long polylen();
    //term count in the expand form;        

    int IsBigInt();
    //tests whether the argument is a constant polynomial;

    int IsZero();
    //tests whether the argument is zero polynomial;

    TVariable *MainVar();
    //return the mail variable of polynomial;
                                                             
    TRIPoly * Coefficient(TVariable *v,unsigned short d);
    //return the coefficient of monomial v^d;

    TList * Coeffs(TVariable *v);      
    //return the coefficient  lost w.r.t. variable v;
                                                             
    TVariable * minv();
    //return the last variable of the polynomial;

    TBigInt mincoef();
    //return the minimum base coefficient of all
    //terms(an element of the base domain);

    TBigInt maxcoef();
    //return the maximum base coefficient of all
    //terms(an element of the base domain);

    unsigned short maxdeg();
    //return the minimum degree of all terms w.r.t.
    //all variables;

    TRIPoly IPldcf();
   //return the leading coefficient w.r.t. main variable;
//TRIPoly * cp_init(TRIPoly * p);

    TRIPoly IPlbt();
    //return the leading term w.r.t. main variable;

    TRIPoly IPltv(TVariable * v);
    //return the leading term w.r.t. variable v;

    TRIPoly IPred();
    //return the reductum;
//TRIPoly * cp_rem(TRIPoly * p)

    TBigInt IPlbcf();
    //return the leading term base coefficient;
//TBigInt lcc(TRIPoly *p);

//    TBigInt IPtbcf();
    //return the base coefficient of the term
    //of the lowest degree w.r.t. all variables;

    int IPconst();
    //test whether the polynomial is constant polynomial;

    int IPunt();
    //test whether the polynomial is univariate polynomial;

    unsigned short IPord();
    //return the lowest degree of the polynomial               
    //w.r.t. main variable;
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++1111111
    short Ipsign();
    //return polynomial sign;

    TRIPoly Ipabs();
    //polynomial absolute value;     

    TRIPoly *IPvri(TVariable * v,TBigInt t);
    //substitute constant i for variable of an
    //integral polynomial;

    TRIPoly *IPvtp(TVariable * v,TRIPoly p);
    //substitute polynomial p for variableof an
    //integral polynomial;
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++11111111

//*************************************************************
//            FOR  Prof. WANG

//**************************************************************
    int pis1();

    int pis0();        

    TVariable * mainvar_w(TList * ord);
    //return the main variable in the variable list ord;

    TRIPoly *IPLdCf_w(TList * ord);
    //return the coefficient w.r.t. the main variable in the variable list ord;

    TRIPoly *IPldt_w(TList * ord);
    //return the leading term w.r.t. in the variable list ord;

    TBigInt IPLbCf_w(TList * ord);
    //return the leading basic coefficient in the variable list ord;


//*************************************************************/

//*************************************************************
//            FOR  Prof.Yang Hong 

//**************************************************************

    TVariable * mainvar(TList * ord);
    //return the main variable in the variable list ord;

    TRIPoly IPLdCf(TList * ord);
    //return the coefficient w.r.t. the main variable in the variable list ord;

    TRIPoly IPLbT(TList * ord);

    TRIPoly IPldt(TList * ord);
    //return the leading term w.r.t. in the variable list ord;

    TRIPoly IPred(TList * ord);
    //return the reductum of the polynomial w.r.t. the variable list ord;

    TRIPoly IPLbCf(TList * ord);
    //return the leading basic coefficient in the variable list ord;
    char* pol_to_char();
    
	//return the leading basic coefficient in the variable list ord;

//*************************************************************/   



//==== MOD BASIC ALGORITHM (for integer polynomial ====

    TRIPoly* mod(TBigInt& m);
    //polynomial modular algorithm;

    friend TRIPoly* IPmium(TRIPoly *p1,TRIPoly *p2,TBigInt m);
    //polynomial modular sum;

    friend TRIPoly* IPmdif(TRIPoly *p1,TRIPoly *p2,TBigInt m);
    //polynomial modular difference;

    friend TRIPoly* IPmpro(TRIPoly *p1,TRIPoly *p2,TBigInt m);
    //polynomial modular production;

    friend TRIPoly* IPmquo(TRIPoly *p1,TRIPoly *p2,TBigInt m);
    //polynomial modular quotient(based on the Euclidean division);

    friend TRIPoly* IPmrem(TRIPoly *p1,TRIPoly *p2,TBigInt m);
    //polynomial modular remainder(based on the Euclidean division);

//====== END MOD BASIC ALGORITHM (for integer polynomial =======    


//=======  CONSTENTS AND PRIMITIVE PARTS  ========

    TBigInt iupcont();
    //univariate polynomial integer content;

    TBigInt icont();
    //polynomial integer content;

    TRIPoly iuppp();
    //univariate polynomial integer primitive part;

    TRIPoly ipcont(TVariable *v);
    //compute the content of the polynomial
    //w.r.t. variable v;
 
    TRIPoly ipipp();
    //polynomial integer primitive part of the polynomial

    TRIPoly ippp(TVariable *v);
    //compute the primitive part of the polynomial
    //w.r.t. variable v;

    TRIPoly pipcont(TVariable *v,TBigInt &p);
    //return content of the polynomial as multivariate
    //polynomial in Z[x1,x2,...x(k-1)] mod p with

    TRIPoly pippp(TVariable *v,TBigInt &p);
    //return prime part of the polynomial as multivariate
    //polynomial in Z[x1,x2,...x(k-1)] mod p with
    //coefficients from Z[xk] mod p;

//======  END CONSTENTS AND PRIMITIVE PARTS  =====


//========= GREATEST COMMON DIVISOR =========

    TRIPoly iupgcd(TRIPoly &p);
    //univariate polynomial greatest common divisor
    //by using Euclidean method;

//    TRIPoly *Iupgcd(TRIPoly * p1,TBigInt m);
    //univariate polynomial greatest divisor
    //over finite field;

    TRIPoly vgcd(TVariable *v,TBigInt &p);
    //greatest common divisor of terms witch are the
    //production of base coefficient, degree of v,
    //and variable v in each term.

    TRIPoly ipgcd(TRIPoly &p);
    //polynomial GCD by using Euclidean method;

    TRIPoly miupgcd(TRIPoly &p,TBigInt &b);
    //modular univariate polynomial GCD;

    TRIPoly mipgcd(TRIPoly bb);
    //polynomial GCD by using modular method;
    TRIPoly mipgcdold(TRIPoly &bb);
    //polynomial GCD by using modular method;

    TRIPoly NPI(TVariable *v,TBigInt ** tt,TRIPoly ** pt,
                TBigInt &p,short &t0);
    //Newton polynomial interpolation;

    TBigInt CRA(TBigInt ** mm,TBigInt ** uu,short & t0);
    //Chinese Remainder Algorithm;

    TRIPoly PCRA(TBigInt ** mm,TRIPoly ** uu,short & t0);
    //Polynomial Chinese Remainder Algorithm;

	TRIPoly pipgcd(TRIPoly &bb,TBigInt &p);
    TRIPoly pipgcdold(TRIPoly &bb,TBigInt &p);
    //polynomial GCD over finite fislds;

    TRIPoly pipgcd1(TRIPoly &bb,TBigInt &p);
    //polynomial GCD over finite fislds;

//========= END GREATEST COMMON DIVISOR =========



//============ End Information operators


//========== FACTORIZATION =============
 
    TRIPoly derivative(TVariable * v);
    //computes the derivative of the polynomial
    //w.r.t. variable v;

    TList *SqureFree();
    //polynomial squarefree factorization;

    TList * Factor();
    //factorization;

	TList * Factorold();
    //factorization;

    TList * Factor1();
    //factorization;

    TList *FFiupSF(TBigInt p,TBigInt m);
    //univariate polynomial squarefree
    //factorization over a finite fields;

    TRIPoly mdiv(TRIPoly p,TBigInt m);
    //modular division;

    TRIPoly mdiv(TBigInt p,TBigInt m);
    //modular division;

    TList * FormMatrixQ(TBigInt p,TBigInt m);
    //return the matrix expression of the polynomial;

    TBigInt NullSpaceBasis(TBigInt **tt,TBigInt p,
                           TBigInt m,TBigInt r);
    //return the zero space of the matrix;

    TList * IupFactor(TBigInt **tt,TBigInt p,TBigInt m);
    //univariate polynomial factorization;

    TRIPoly UEEA(TRIPoly p,TBigInt b,TRIPoly *s_,TRIPoly *t_);
    //univariate polynomial extended Eucleading algorithm;

    TRIPoly dm(TBigInt m);
    //symmetric representation of the polynomial
    //modular prime m;

    TList * UHLA(TRIPoly p1,TRIPoly p2,TBigInt t);
    //univariate polynomial Hensel Lifting Algorithm;
    TList * VLDegree(TList *I);
    // Degree list via variable list I;

    TRIPoly PmodIk(TList *I,TBigInt k);
    //polynomial modular I^k;

    TList * EEApl(TRIPoly B,TRIPoly C,TBigInt p,
                  TBigInt l);
    //Extended Euclidean Algorithm modular p^l;

    TList * getVL();
    //get variable list of polynomial;

    TList * getVL1();
    //get variable list of polynomial;

    TList * getVL2();
    //get lowest degree list of polynomial w.r.t.
    //variable list;

    TVariable * MinDeg();
    //return the variable which degree in the polynomial is minumus.

    TList * getI();
    //only available for primitive polynomial;
    //return Ideal I;

    TBigInt getB();
    //bounds the magnitudes of all integer
    //coefficients appearing in the polynomial
    //and in any of its possible factors.

    TRIPoly ppp();
    //deal with base term

    TRIPoly ppp1();
    //deal with the term defined in the structure;

    TList * MHLA(TList * pl);
    //only available for primitive polynomial;
    //multivariate Hensen Lifting Algorithm;

    TList * MHLA1(TList * pl);
    //only available for primitive polynomial;
    //multivariate Hensen Lifting Algorithm;

    TList * LChoice(TList * pl,int n);
    //ideal kesai={p1,p2,...,pn}; return kesai^n;

    TList * Upfactor();
    //univariate polynomial factorization;

    TList * MPfactor();
    //multivariate polynomial factorization;

//============== END FACTORIZATION =============

//============================================================
//
//                     Resultant
//
//============================================================

    TRIPoly Resultant(TRIPoly G, TVariable *v);

//================================================================

    char * PolyRoot();
    TList * PolyArgs();

//================================================================

    int Classyh(TList * ord);
    TRIPoly * premB(TRIPoly * vv,TVariable * x,TRIPoly * fn);
    TRIPoly * premA(TRIPoly * vv,TVariable * x);
    TRIPoly * premas(TList * as,TList * ord);
    TRIPoly * exp_y();

//===============================================================


  //friend functions:
    friend int vless(TVariable * v1,TVariable * v2)
    {//cout<<"v1=";v1->display();cout<<endl;
	 //cout<<"v2=";v2->display();cout<<endl;
	 return ((v1->compare(v2))>0);
	}


	friend TRIPoly *vars_in_p(TRIPoly *p);
//    friend void add_xt();
//    friend void add_dt();
	friend void add_rc();   
	friend void init_TRIPoly (void);
	friend void pool_len (void);
        friend TRIPoly *get_xx (void);
        friend TDITerm *get_dx (void);
	friend TPolyRC *get_rc (void);
	friend TRIPoly *get_x (void);
	friend TDITerm *get_d (void);
	friend TRIPoly *get_n (long n);
	friend TRIPoly *get_num (NUM n);
	friend TRIPoly *get_xt (VAR *v, TDITerm *dp1);
//	friend TRIPoly *get_s(char *ch);
	friend TRIPoly *get_m (VAR *vn);
	friend TRIPoly *get_mv (VAR *vn,POLYDEG d);
	friend TRIPoly *get_v (VAR *v, POLYDEG d, TRIPoly *p);
	friend TRIPoly *get_p (TRIPoly p1);
	friend TDITerm *get_dt (POLYDEG d, TRIPoly *xp1, TDITerm *dp1);
        friend void put_dx (TDITerm *dpt);
        friend void put_xx (TRIPoly *xpt);
	friend void put_rc (TPolyRC *dpt);
	friend void put_d (TDITerm *dpt);
	friend void put_x (TRIPoly *xpt);
	friend void put_p (TRIPoly *p1);
	friend void put_ps (TDITerm *dp0);
	friend int eq_TRIPoly (TRIPoly *p1, TRIPoly *p2);
	friend int eq_TDITerm (TDITerm *dp1, TDITerm *dp2);
	friend TRIPoly *cp_TRIPoly (TRIPoly *p1);
	friend TDITerm *cp_TDITerm (TDITerm *dp1);
	friend TRIPoly *pzero (void);
	friend int numberp (TRIPoly *p);
	friend int nTRIPoly (TRIPoly *p);
	friend int pzerop (TRIPoly *p);
	friend int unitp (TRIPoly *p);
	friend int nunitp (TRIPoly *p);
	friend int classp(TRIPoly *p);
	friend int l (TRIPoly *p);
	friend int pdeg (TRIPoly *p, VAR *v);
	friend int mdeg (TRIPoly *p, VAR *v);
	friend long int fcc (TRIPoly *p);
	friend NUM lcc (TRIPoly *p);
	friend NUM lcontent (TRIPoly *p);
	friend void lcont1 (TRIPoly *p);
	friend TRIPoly *init (TRIPoly *p);
	friend TRIPoly *cp_init (TRIPoly *p);
	friend TRIPoly *init_v (TRIPoly *p, VAR *v);
	friend TRIPoly *pinit (TRIPoly *p, VAR *v, POLYDEG d);
	friend TRIPoly *cp_rem(TRIPoly *p);
	friend TRIPoly *rem(TRIPoly *p);
	friend int  mono_pol (TRIPoly *p);
	friend int  tlength (TRIPoly *p);
	friend int  mlength (TRIPoly *p);
	friend int  plength (TRIPoly *p);
	friend int  dlength (TDITerm *dp1);
	friend int  pless (TRIPoly *p1, TRIPoly *p2);
	friend int  pls (TRIPoly *p1, TRIPoly *p2);
	friend TRIPoly *psimp (TRIPoly *p1, TDITerm *dp0);
	friend int bad_TRIPoly(TRIPoly *p);
	friend int bad_num(NUM n);
	friend TRIPoly *pplus (TRIPoly *p1, TRIPoly *p2);
	friend TDITerm *pplus1 (TDITerm *dp1, TDITerm *dp2);
	friend TRIPoly *pcplus (TRIPoly *c, TRIPoly *p2);

        friend TRIPoly *mpplus (TRIPoly *p1, TRIPoly *p2, TBigInt m);
        friend TDITerm *mpplus1 (TDITerm *dp1, TDITerm *dp2, TBigInt m);
        friend TRIPoly *mpcplus (TRIPoly *c, TRIPoly *p2, TBigInt m);

	friend TRIPoly *pminus (TRIPoly *p1, TRIPoly *p2);
	friend TRIPoly *neg_TRIPoly (TRIPoly *p);
	friend TRIPoly *ptimes (TRIPoly *p1, TRIPoly *p2);
	friend TDITerm *ptimes1 (TDITerm *dp1, TDITerm *dp2);
	friend TRIPoly *pctimes (TRIPoly *c, TRIPoly *p);

        friend TRIPoly *mptimes (TRIPoly *p1, TRIPoly *p2, TBigInt m);
        friend TDITerm *mptimes1 (TDITerm *dp1, TDITerm *dp2, TBigInt m);
        friend TRIPoly *mpctimes (TRIPoly *c, TRIPoly *p, TBigInt m);

	friend TRIPoly *ppower (TRIPoly *p, long int n);
	friend TRIPoly *ppdiv (TRIPoly *p1, TRIPoly *p2);
	friend TRIPoly *pdiv (TRIPoly *p1, TRIPoly *p2);
	friend TRIPoly *pcdiv (TRIPoly *p, TRIPoly *c);
	friend TDITerm *pdiv1 (TDITerm *dp1, TDITerm *dp2);
	friend TRIPoly *prem (TRIPoly *p1, TRIPoly *p2);
	friend TRIPoly *prem_ev (TRIPoly *p1, TRIPoly *p2);

};
TRIPoly PCRAt(TList *Mm,TList *Xx);

class TDITerm
{ 
public:
  unsigned short deg;
  TRIPoly *p;
  TDITerm *nx;

//member functions;
    TDITerm();
    TDITerm(unsigned short int *d);
    TDITerm(unsigned short int d);
    TDITerm(const TDITerm & td);
    ~TDITerm();
    void * operator new(size_t);
    void operator delete(void *);

};


typedef TRIPoly       POLY;
typedef TDITerm       POLS;
typedef unsigned short   DEG;

typedef struct { TRIPoly *p1, *p2; } PP;
typedef struct { TDITerm *ps1, *ps2; } PSS;

#define HYP PP

/* macroes */

#define  c_pplus(x,y)       pplus(cp_TRIPoly(x),cp_TRIPoly(y))
#define  c_pminus(x,y)      pminus(cp_TRIPoly(x),cp_TRIPoly(y))
#define  c_ptimes(x,y)      ptimes(cp_TRIPoly(x),cp_TRIPoly(y))
#define  c_pdiv(x,y)        pdiv(cp_TRIPoly(x),y)

#define  pplus3(x,y,z)     pplus(x,pplus(y,z))
#define  ptimes3(x,y,z)    ptimes(x,ptimes(y,z))
#define  pplus4(x,y,z,w)   pplus(pplus(x,y),pplus(z,w))
#define  ptimes4(x,y,z,w)  ptimes(ptimes(x,y),ptimes(z,w))

//=================================================
#define num_zop(x)  	((x)==0)
#define num_posp(x) 	((x)>0)
#define num_negp(x) 	((x)<0)

#define num_eq(x,y) 	((x)==(y))

#define num_m(x,y)  	((x) - (y))
#define num_p(x,y)  	((x) + (y))
#define num_t(x,y)  	((x) * (y))
#define num_d(x,y)  	((x) / (y))
#define num_neg(x)  	( - (x))
#define num_gcd(x,y)  	igcd((x),(y))
#define num_p3(x,y,z) 	((x) + (y) + (z))
#define num_t3(x,y,z) 	((x) * (y) * (z))
#define num_mod(x,y) 	((x) % (y))
#define num_modt(x)   	((x)%2)

#define mk_num(x)     	(TBigInt((int)x))
#define num_unit(p)   	((p)==1)
#define num_nunit(p)  	((p)==(-1))
//#define num_int(obje) 	(obje)             


#define get_n(n)  (new TRIPoly(TBigInt(n)))
#define get_num(n)  (new TRIPoly(n))
#define npoly(p) (p->var==0)

#define cp_pols(p)  cp_TDITerm(p)
#define cp_poly(p)  cp_TRIPoly(p)
#define eq_poly(p,q)  eq_TRIPoly((p),(q))

#define poly_prim(p) (new TRIPoly((*p)/(p->icont())))

typedef  TRIPoly* TRIPolyPt;

int ldeg (TRIPoly *p);


/*
//
// Functions for Groebner basis
//

void prove_gbas(void);
TRIPoly *rem_gpro (TRIPoly *p, TList *asc);
void coll_div(void);
TList *g_basis(TList *ps);
void g_bs (TList *ps);
TRIPoly *min_pol(TList *ps);
int gless_p(TRIPoly *p1, TRIPoly *p2);
int gred_ps (TRIPoly *p, TList *bs);
int gsub_p(TRIPoly *p1, TRIPoly *p2);
TRIPoly *rem_gpc (TRIPoly *p, TList *asc);
TRIPoly *rem_gc (TRIPoly *p, TList *asc);
TRIPoly *grem (TRIPoly *p1, TRIPoly *p2);
TRIPoly *div_lt(TRIPoly *p1, TRIPoly *p2);
TList *s_TList(TList *ps);
int undos1(TRIPoly *p1, TRIPoly *p2);
TRIPoly *s_pol(TRIPoly *p1, TRIPoly *p2);
TRIPoly *s_pol1(TRIPoly *p1, TRIPoly *p2);
PP gfact(TRIPoly *p1, TRIPoly *p2);
int upol (TRIPoly *p);
TRIPoly *p_term(TRIPoly *p);
TRIPoly *u_term(TRIPoly *p);
TRIPoly *pu_term(TRIPoly *p);
TRIPoly *mv_ufact(TRIPoly *p);
TList *ufactor(TRIPoly *p);
int opoly(TRIPoly *p);
*/
#endif   
