#include <iostream.h>
#include <stdio.h>
#include <iostream.h>
#include <string.h>
#include <new.h>
#include "basetype.h"
#include "number.h"
#include "lists.h"
#include "vectors.h"
#include "trpoly.h"
#include "matrix.h"
extern "C"{
#include <time.h>
#include <sys/timeb.h>
}


//==================================================
//    Implementation for class TRPoly
//==================================================

//==============    Construction of class TRPoly      =============

TRPoly::TRPoly():TExpVal()
{
  var=0;
  first=0;
  value=0;
  RefCount=new unsigned long (1);
}
TRPoly::TRPoly(TNumber va):TExpVal()
{
  var=0;
  first=0;
  value=va;
  RefCount=new unsigned long (1);
}
TRPoly::TRPoly(TNumber * va):TExpVal()
{
  var=0;
  first=0;
  value=*va;
  RefCount=new unsigned long (1);
}
TRPoly::TRPoly(TVariable * v,TBigInt * d):TExpVal()
{
  var=v;
  first=new TDTerm(d);
  RefCount=new unsigned long (1);
  value=0;
}
TRPoly::TRPoly(TVariable * v,TBigInt d):TExpVal()
{
  var=v;
  first=new TDTerm(d);
  RefCount=new unsigned long (1);
  value=0;
}
TRPoly::TRPoly(const TRPoly & tr)
{
  var=tr.var;
  first=tr.first;
  value=tr.value;
  RefCount=tr.RefCount;
  RefInc();
}
TRPoly::TRPoly(TRPoly &tr)
{
  var=tr.var;
  first=tr.first;
  value=tr.value;
  RefCount=tr.RefCount;
  RefInc();
}

//=================           Distruction of class TRPoly     ===========

TRPoly::~TRPoly()
{
  TDTerm *p=first,*p1;
  TRPoly *p0;
  RefDec();
  if(*RefCount)
  { 
//    RefDec(); 
    return;
  }
  else
  {  
     delete RefCount;
  }
  
  while(p!=0)
  {
    p1=p->next;
    p0=p->coef;
    delete p0;
    delete p;
    p=p1;
  }
}

//=================   Degree    and    Coefficient     ==============

TBigInt TRPoly::Degree(TVariable *v)
{
  TBigInt tmp(0);
  TDTerm * d;
  if(var!=0)
  {
    if(var==v)
    {
      tmp=*(first->deg);
    }
    else
    {
      for(d=first;d!=0;d=d->next)
      {
        if(tmp<(d->coef->Degree(v)))
          tmp=(d->coef->Degree(v));
      }
    }
  }
  return tmp;
}   
      
TRPoly * TRPoly::Coefficient(TVariable *v,TBigInt d)
{
  TNumber t(0);
  TDTerm * td;
  TRPoly * tr=new TRPoly(t),*tr1;
  if(var==0)
    return tr;
  else if(var==v)
  {
    for(td=first;td!=0;td=td->next)
    {
      if(*(td->deg)==d)
      {
        tr=td->coef;
       }
    }
    return tr;
  }
  else
  {
    for(td=first;td!=0;td=td->next)
    {
      if(*(td->deg)>0)
      {
        tr1=new TRPoly(var,*(td->deg));
        tr1=poly_mul(tr1,td->coef->Coefficient(v,d));
        tr=poly_plus(tr,tr1);
      }
      else
      {
        tr1=td->coef->Coefficient(v,d);
        tr=poly_plus(tr,tr1);
      }      
    }
    return tr;
  }
}   
//==============             Poly "display"                =====

void TRPoly::display1(char *s,int t,outtype& out)const
{
  TDTerm *d;
  char tmp[500];
  TNumber v1(1),v2(-1),v3(0);
  if(var==0)
  {
     if(value==v1||value==v2)
     {
      if(strlen(s)&&t)
      {
        if(value==v1)
            out<<"+"<<s;
        if(value==v2)
            out<<"-"<<s;
      }

      if(strlen(s)&&!t)
      { 
        if(value==v1)
            out<<s;
        if(value==v2)
            out<<"-"<<s;
      }
      if(t&&(!strlen(s)))
      {
          if(value==v1)
            out<<"+"<<value;
          if(value==-1)
            out<<value;      
      }
      if((!strlen(s))&&!t) 
      {
          out<<value;
      }
    }
    if(value!=v1&&value!=v2)
    {
      if(t)
      {
        if(strlen(s))
        {
            if(value>v1)
            out<<"+"<<value<<"*"<<s;
            if(value<v2) 
            out<<value<<"*"<<s;
        }
        else
        {
            if(value>v1)
              out<<"+"<<value;
            if(value<v2)
              out<<value;
        } 
     }
     else 
      {
        if(strlen(s))
            out<<value<<"*"<<s;
        else  
            out<<value;
       }
    }
    return;
  }   
  for(d=first;d!=0;d=d->next)
  {
    if(*(d->deg)==0)
      sprintf(tmp,"%s",s);
    else if(*(d->deg)==1)
      if(strlen(s)!=0)
        sprintf(tmp,"%s*%s",var->GetName(),s);
      else
        sprintf(tmp,"%s",var->GetName());
    else 
    {
      if(strlen(s)!=0)
      {
        sprintf(tmp,"%s^%s*%s",var->GetName(),
                     (*(d->deg)).TransNumToString(),s);
      }
      else
        sprintf(tmp,"%s^%s",var->GetName(),(*(d->deg)).TransNumToString());
    }
    if(t)
      (d->coef)->display1(tmp,1,out);
    else if(d==first)
      (d->coef)->display1(tmp,0,out);
    else 
      (d->coef)->display1(tmp,1,out);
    }
  return;
}

//==========             Poly  Clone  and Copy            =============

TRPoly * TRPoly::Clone()
{
  TRPoly *tmp;
  TDTerm *d1,*d2;
  tmp=new TRPoly();
//  *tmp=*this;
  (tmp->value)=value;
  tmp->var=var;
  if(!var)
  {
    return tmp;
 }
  d1=first;
  d2=new TDTerm();
  tmp->first=d2;
  while(d1!=0)
  {
    *(d2->deg)=*(d1->deg);
    delete d2->coef;
    d2->coef=(d1->coef)->Clone();
    if(d1->next!=0)
    {
      d2->next=new TDTerm();
      d2=d2->next;
    }
    d1=d1->next;
  }
  return tmp;
}

TAtom *TRPoly::Copy()
{
  return (TAtom *)(new TRPoly(*this));
}

//===== PolyLen  IsNumber  IsZero  uminus  MainVar   ==========

unsigned long TRPoly::PolyLen()
{
  unsigned long len=0;
  TDTerm * tmp;
  if(var==0)
  {
    len=0;
  }
  else
  {
    len=len+1;
    tmp=first;
    while(tmp->next!=0)
    {
      len=len+1;
      tmp=tmp->next;
    }
  }
  return len;
}

TNumber * TRPoly::IsNumber()
{
  TNumber * num,num1;
  if(var==0)
    return new TNumber(value);
  else
    return 0;
}

TVariable * TRPoly::MainVar()
{
  if(var==0)
    return (0);
  else 
    var;
}

int TRPoly::IsZero()
{
  if(var==0&&value==0)
    return 1;
  else
    return 0;
}

TAtom * TRPoly::uminus(int how)
{
  TRPoly p=-(*this);
  if(how) return new TRPoly(p);
  *this=p;
  return this;
}

//==========             Poly "="            ===============

TRPoly TRPoly::operator=(const TRPoly &p)
{
  if(p.first==first&&p.var==var&&value==p.value)
  {
   // return (*this);
   cout<<"problem here...\n";
   value=p.value;
   return(*this);
  }
  RefDec();
  if(*RefCount==0)
  {
    TDTerm *tmp1,*tmp=first;
    while(tmp!=0)
    {
      tmp1=tmp->next;
      delete tmp;
      tmp=tmp1;
    }
    delete RefCount;
  }
  var=p.var;
  RefCount=p.RefCount;
  RefInc();
  first=p.first;
  value=p.value;
  return (*this);
}
 
//============      deg      ==============

TBigInt *TRPoly::degM()
{
  if(var==0)
    return new TBigInt(0);
  else
    return first->deg;
}  
 
//==========           Poly_Plus        ================

TRPoly *TRPoly::poly_plus(TRPoly * p1,TRPoly *p2)
{
  TRPoly *tmp;
  TDTerm *d,*d1,*d2;
  if(p1->var==0&&p2->var==0)
  {
    tmp=new TRPoly();
    tmp->var=0;
    (tmp->value)=(p1->value)+(p2->value);
    return tmp;
  }
  else if(p1->var==0)
    return poly_plus(p2,p1);
  else if(p2->var==0&&(p2->value)==0)
    return p1->Clone();
  else if(p2->var!=0&&(p1->var>p2->var))
    return poly_plus(p2,p1);
  else if(p1->var!=p2->var)
  {
    tmp=new TRPoly();
    tmp->var=p1->var;
    tmp->first=new TDTerm();
    d=tmp->first;
    d1=p1->first;
    while(d1!=0)
    {
      *(d->deg)=*(d1->deg);
      delete d->coef;
      d->coef=(d1->coef)->Clone();
      if(d1->next!=NULL&&(*((d1->next)->deg))==0)
      {
        d1=d1->next;
        break;
      }
      if(d1->next!=NULL)
      {
        d->next=new TDTerm();
        d=d->next;
      }
      d1=d1->next;
    }
    if(d1==NULL)
    {
      d->next=new TDTerm();
      d=d->next;
      *(d->deg)=0;
      delete d->coef;
      d->coef=p2->Clone(); 
    }
    else
    {
      TRPoly * tmp1=poly_plus(d1->coef,p2);
      if(tmp1->var!=0||(tmp1->value)!=0)
      {
        d->next=new TDTerm();
        d=d->next;
        *(d->deg)=0;
      delete d->coef;
        d->coef=tmp1;
      }
    }
  }
  else
  {
    tmp=new TRPoly();
    tmp->var=p1->var;
    d=0;
    d1=p1->first;
    d2=p2->first;
    while(d1!=0||d2!=0)
    {
            if (d1==0) {
                        if (d ==0) {
                                tmp->first=new TDTerm();
                                d=tmp->first;
                                *(d->deg)=*(d2->deg);
      				delete d->coef;
                                d->coef=(d2->coef)->Clone();
                                }
                        else {
                                d->next=new TDTerm();
                                d=d->next;
                                *(d->deg)=*(d2->deg);
      				delete d->coef;
                                d->coef=(d2->coef)->Clone();
                                }
                        d2=d2->next;
                        }
                else if (d2==0) {
                        if (d ==0) {
                                tmp->first=new TDTerm();
                                 d=tmp->first;
                                *(d->deg)=*(d1->deg);
      				delete d->coef;
                                d->coef=(d1->coef)->Clone();
                                }
                        else {
                                d->next=new TDTerm();
                                d=d->next;
                                *(d->deg)=*(d1->deg);
      				delete d->coef;
                                d->coef=(d1->coef)->Clone();
                                }
                        d1=d1->next;
                        }
                else if((*(d1->deg))<(*(d2->deg)))
                {
                        if (d ==0) {
                                tmp->first=new TDTerm();
                                d=tmp->first;
                                *(d->deg)=*(d2->deg);
      				delete d->coef;
                                d->coef=(d2->coef)->Clone();
                                }
                        else {
                                d->next=new TDTerm();
                                d=d->next;
                                *(d->deg)=*(d2->deg);
      				delete d->coef;
                                d->coef=(d2->coef)->Clone();
                                }
                        d2=d2->next;
                        }
                else if((*(d1->deg))>(*(d2->deg)))
                  {
                     if (d ==0) {
                                tmp->first=new TDTerm();
                                 d=tmp->first;
                                *(d->deg)=*(d1->deg);
      				delete d->coef;
                                d->coef=(d1->coef)->Clone();
                                }
                        else {
                                d->next=new TDTerm();
                                d=d->next;
                                *(d->deg)=*(d1->deg);
      				delete d->coef;
                                d->coef=(d1->coef)->Clone();
                                }
                        d1=d1->next;
                        }
                else {
                        TRPoly *tmp1=poly_plus(d1->coef,d2->coef);
                        if (tmp1->var==0 && tmp1->value==0){
                                d1=d1->next;
                                d2=d2->next;
				delete tmp1;
                                }
                        else {
                                if (d ==0) {
                                        tmp->first=new TDTerm();
                                        d=tmp->first;
                                        }
                                else {
                                        d->next=new TDTerm();
                                        d=d->next;
                                        }
                                *(d->deg)=*(d1->deg);
      				delete d->coef;
                                d->coef=tmp1;
                                d1=d1->next;
                                d2=d2->next;
                                }
                        }
                }
        }
 if (tmp->first==0) {
        tmp->var=0;
        (tmp->value)=0;
        }
 return tmp;
}


TRPoly  TRPoly::operator +(TRPoly p)
{
  TRPoly tmp,*tmp1;
  tmp1=tmp.poly_plus(this,&p);
  tmp=*tmp1;
  delete tmp1;
  return tmp;
}

//==============    operator  "-" (double operator)   ===============
TRPoly TRPoly::operator -(TRPoly p)
{
/*  if(var==p.var&&value==p.value&&first==p.first)
  { 
    return *(new TRPoly(new TNumber(0)));
  }
  else
  {*/
    return (*this)+(-p);
/*  }*/
}

//=========            Poly_Mul           ==================

TRPoly * TRPoly::poly_mul(TRPoly *p1,TRPoly *p2)
{
  TRPoly *tmp,*tmp1,*tmp2;
  TDTerm *d1,*d2,*d,*d3;

 if (p1->var == 0 && p2->var ==0) {
        tmp=new TRPoly();
        tmp->var=0;
        (tmp->value)=(p1->value)*(p2->value);
        return tmp;
        }
 else if (p1->var == 0)
        return poly_mul(p2,p1);
 else if (p2->var !=0 && p1->var > p2->var)
        return poly_mul(p2,p1);
 else if (p2->var==0 && (p2->value)==0) {
        tmp=new TRPoly();
        tmp->var=0;
        (tmp->value)=0;
        return tmp;
        }
 else if (p1->var != p2->var ) {
        tmp=new TRPoly();
        tmp->var=p1->var;
        tmp->first=new TDTerm();
        d=tmp->first;
        d1=p1->first;
        while (d1 !=0) {
                *(d->deg)=*(d1->deg);
                delete d->coef;
                d->coef=poly_mul(d1->coef,p2);
                if (d1->next !=0)
                        d->next=new TDTerm();
                d=d->next;
                d1=d1->next;
                }
        return tmp;
        }
 else {
        tmp=new TRPoly();
        tmp->var=0;
        (tmp->value)=0;
        for (d2=p2->first;d2 !=0; d2=d2->next) {
                tmp1=new TRPoly();
                tmp1->var=p1->var;
                tmp1->first=new TDTerm();
                d=tmp1->first;
                for (d1=p1->first;d1 !=0;d1=d1->next) {
                        *(d->deg)=(*(d1->deg))+(*(d2->deg));
                        delete d->coef;
                        d->coef=poly_mul(d1->coef,d2->coef);
                        if (d1->next !=0)
                                d->next=new TDTerm();
                        d=d->next;
                        }
		tmp2=tmp;
                tmp=poly_plus(tmp,tmp1);
		delete tmp1;
		delete tmp2;
                }
        return tmp;
        }
}

TRPoly TRPoly::operator *(TRPoly p)
{
  TRPoly tmp,*tmp1;
  tmp1=tmp.poly_mul(this,&p);
  tmp=*tmp1;
  delete tmp1;
  return tmp;
} 
  
//=============   operator "-"     ===================

TRPoly TRPoly::operator-()
{
  TRPoly *tmp,tmp1;
  TNumber * tmp0;
  tmp0=new TNumber(-1);
  tmp=new TRPoly(tmp0);
  tmp1=(*tmp)*(*this);
  delete tmp0; delete tmp;
  return tmp1;
}

//==============      Print of TRPoly(recursive mode)      ===============

void TRPoly::show(outtype& out)const
{
  display(out);
}
void TRPoly::print(outtype& out)const
{
  display(out);
}
void TRPoly::display(outtype& out)const
{
  display1("",0,out); 
}
/*  TDTerm *tmp,*tmp1;
  TRPoly *p,*p1,*p2;
  if(var==0)
  {
    out<<value;
    return;
  }
  else
  {
    tmp=first;
    p=tmp->coef;
    if(p->var==0)
    {
      if(*(tmp->deg)==1)
      {
        if((p->value)==1)
        {
          var->display(out);
        }
        else if((p->value)==-1)
        {
          out<<"-";
          var->display(out);
        }
        else
        {
          out<<(p->value)<<"*";
          var->display(out);
         }
       }
       else if(*(tmp->deg)==0)
       {
         out<<(p->value);
       }
       else
       {
         if((p->value)==1)
         {
           var->display(out);
           out<<"^"<<*(tmp->deg);
         }
         else if((p->value)==-1)
         {
           out<<"-";
           var->display(out);
           out<<"^"<<*(tmp->deg);
         }
         else
         {
            out<<(p->value)<<"*";
            var->display(out);
            out<<"^"<<*(tmp->deg);
         }
       }
    }
    if(p->var!=0)
    {
      if(*(tmp->deg)==0)
      {
        p->display(out);
      }
      else
      {
        if(p->PolyLen()<=1)
        {
          p->display(out);
          if(*(tmp->deg)==1)
          {
             cout <<"*";
             var->display(out);
          }
          if(*(tmp->deg)!=1)
          {
             cout<<"*";
             var->display(out);
             out<<"^"<<*(tmp->deg);
           }
        }
      
        else
        {
          out<<"(";
          p->display(out);
          out<<")"<<"*";
          var->display(out);
          if(*(tmp->deg)!=1)
          {
            out<<"^"<<*(tmp->deg);
          }
        }
      }
    } 
    tmp1=tmp->next;
    while(tmp1!=0)
    {
      p1=tmp1->coef;
//      out<<"+";
        if(p1->var==0)
        { 
          if(*(tmp1->deg)==1)
          {
            if((p1->value)==1)
            {
              out<<"+";
              var->display(out); 
            }
            else if((p1->value)==-1)
            {
              out<<"-";
              var->display(out);
            }
            else
            {
              if((p1->value)>0)
              {
                out<<"+";
                out<<(p1->value)<<"*";
                var->display(out);
              }
              else
              {
                out<<(p1->value)<<"*";
                var->display(out);
              }
            } 
          }
          else if(*(tmp1->deg)==0)
          {
            if((p1->value)>0)
            {
              out<<"+";
              out<<(p1->value);
            }
            else
            {
               out<<(p1->value);
            } 
          }
          else
          {
            if((p1->value)==1)
            {
              out<<"+";
              var->display(out);
              out<<"^"<<*(tmp1->deg);
            }
            else if((p1->value)==-1)
            {
              out<<"-";
              var->display(out);
              out<<"^"<<*(tmp1->deg);
            }
            else
            {
              if((p1->value)>0)
              {
                out<<"+";
                out<<(p1->value)<<"*";
                var->display(out);
                out<<"^"<<*(tmp1->deg);
              }
              else
              {
                out<<(p1->value)<<"*";
                var->display(out);
                out<<"^"<<*(tmp1->deg);
              } 
            }
          }
        }
        if(p1->var!=0)
        {
          if(*(tmp1->deg)==0)
          {
            out<<"+(";
            p1->display(out);
            out<<")";
          }     
          else
          {
            if(p1->PolyLen()<=1)
            {
              if(*(tmp1->deg)==1)
              {
                p2=p1->first->coef;
                while(p2->PolyLen()==1)
                {
                  p2=p2->first->coef;
                }
                if(p2->var==0&&p2->value<0)
                {
                  p1->display(out);
                  out<<"*";
                  var->display(out);
                }
                else
                {
                  out<<"+";
                  p1->display(out);
                  out<<"*";
                  var->display(out);
                }
              }
              if(*(tmp1->deg)!=1)
              {
                p2=p1->first->coef;
                while(p2->PolyLen()==1)
                {
                  p2=p2->first->coef;
                }
                if(p2->var==0&&p2->value<0)
                {
                  p1->display(out);
                  out<<"*";
                  var->display(out);
                  out<<"^"<<*(tmp1->deg);
                }
                else
                {
                  out<<"+";
                  p1->display(out);
                  out<<"*";
                  var->display(out);
                  out<<"^"<<*(tmp1->deg);
                }
              } 
            }
            else
            {
              out<<"+";
              out<<"(";
              p1->display(out);
              out<<")*";
              var->display(out);
              if(*(tmp1->deg)!=1)
              {
                out<<"^"<<*(tmp1->deg);
              }
            }
          }
        } 
        tmp1=tmp1->next;
      }
    }
  } 
*/       

void * TRPoly::operator new(size_t)
{
  return (TRPoly *)StarMem->alloc();
}
void TRPoly::operator delete(void * p)
{
  StarMem->free(p);
}

//=============  operator  "+="  "-="  "*="     ==================

TRPoly TRPoly::operator += (TRPoly & bn)
{
 *this=*this+bn;
 return *this;
};
TRPoly TRPoly::operator -= (TRPoly & bn)
{
 *this=*this-bn;
 return *this;
};
TRPoly TRPoly::operator *= (TRPoly & bn)
{
 *this=(*this)*bn;
 return *this;
};

//================        operator "^"           ===================

TRPoly TRPoly::operator ^(TNumber &bn)
{
  if(bn.GetPtr()->TypeID() !=BigNumberType)
   {
     cout<<"THe power must be an integer"<<endl;
    return *this;
  }
  TBigInt n((*(TBigInt*)bn.GetPtr()));
  TRPoly bnpower;
  TRPoly powertmp,tmp;

  short i=1;
  if( n < 0 )
  {
    cout << "\nThe exponent can't be negative number!\n";
    exit(1);
  }

  if( n == 0 )
  {
    return bnpower;
  }
#ifdef TIME_DEBUG
struct timeb e,s;
     ftime(&s);
#endif
  if( n == 1 )  return (*this);
  if(n <= 20)
//  else
  {
    bnpower = (*this);
    for( i ; i < n; i++)
       (bnpower) = (bnpower) * (*this);
#ifdef TIME_DEBUG
  ftime(&e);
float u=((e.time - s.time)*1000 +e.millitm- s.millitm)/1000.0 ;
 cout<<"\t"<<"CAL"<<" used Time is: "<<s.time<<"."<<s.millitm<<" to "<<e.time<<".
"<<e.millitm<<"= "<<u
<<" seconds"<<endl;
#endif
    return (bnpower);
  }

 // case of n > 20
  TRPoly *tmpPoly=(TRPoly *)(this->Copy());
  tmp= *tmpPoly;
  delete tmpPoly;
  //tmp = p;
  bnpower = TRPoly(1);
  while( n != 0 )
  {
    //if( (1 & n) == 1 )
    if( isodd(n) )
    {
      powertmp = tmp;
      (bnpower) = (bnpower) * powertmp;
    }
    n = n >> 1;
    if( n != 0 )
       // tmp=tmp^2;
       tmp = tmp * tmp;
       //tmp = square(tmp);
  }
#ifdef TIME_DEBUG
ftime(&e);
float u=((e.time - s.time)*1000 +e.millitm- s.millitm)/1000.0 ;
 cout<<"\tCAL"<<" used Time is: "<<s.time<<"."<<s.millitm<<" to "<<e.time<<"."<<e
.millitm<<"= "<<u
<<" seconds"<<endl;
#endif
  return (bnpower);
}

//=============================================================
//           Implementation for Class TDTerm
//=============================================================

//==================      Construction of class TDTerm   =================

TDTerm::TDTerm()
{
  deg=new TBigInt(0);
  coef=new TRPoly(1);
  next=0;
}
TDTerm::TDTerm(TBigInt *d)
{
  deg=new TBigInt(*d);
  coef=new TRPoly(1);
  next=0;
}
TDTerm::TDTerm(TBigInt d)
{
  deg=new TBigInt(d);
  coef=new TRPoly(1);
  next=0;
}
TDTerm::TDTerm(const TDTerm & td)
{
  deg=td.deg;
  coef=td.coef; 
  next=td.next;
}
TDTerm::TDTerm(TDTerm & td)
{
  deg=td.deg;
  coef=td.coef;
  next=td.next;
} 

//================      Distruction of class TDTerm      ================

TDTerm::~TDTerm()
{
  delete deg;
  delete coef;
}

//=============operator   new and delete =================
 
void * TDTerm::operator new(size_t)
{
  return (TDTerm*)StarMem->alloc();
}
void TDTerm::operator delete(void * p)
{
  StarMem->free(p);
}

//==============================================================
//                        end of file trpoly.cc
//==============================================================

