#include <stdio.h>
#include <stdlib.h>
#include <malloc.h>
#include <iostream.h>
#include <string.h>

#include "typedef.h"
#include "basetype.h"
#include "global.h"
#include "express.h"
#include "poly.h"
#include "trpoly.h"
#include "pol.h"
#include "Tbl2ListTVariable.h"
#include "nvar.h"
#include "check.h"
#ifdef _WINDOWS
#include "..\gui\index.h"
#endif 
#include "stacks.h"
#include "lists.h"

//#define __DELETE_DEBUG__
//#define __SHOW_STACK__
//long ook=0;
//extern TRunType part(TList*);
//extern YYSTYPE	yylval;		

#define WMODE   (workpstat->mode)

//========================================

TVariable::TVariable()
{
 name=0;
 fname=0;
 type=TSYMBOL;
 value.poly=0;
}

TVariable::TVariable(char *s, TVarType t)
{
 name=strdup(s);
 fname=0;
 type=t;
 value.poly=0;
}

TVariable* TVariable::Clone()
{
 TVariable* nv=new TVariable(name,type);
 nv->order=order;
 nv->fname=fname;
 return nv;
}
TVariable::~TVariable()
{
  
//free(name);
#ifdef __DELETE_DEBUG__
 wout<<" TVar del: "<<this<<":"; display();wout<<endl;
#endif

 if(name)     free(name);
 if(fname)    free(fname);
  if(type==TPROCEDURE) {
        if(value.proc)
                delete (value.proc);
           value.proc=0;
        }
  else if (type==TLIST || type==TVARIABLE || type==TFUNCTION )
        if(value.poly)
        {
            // value.poly->display();
               delete value.poly;
               value.poly=0;
        }
  
}

int TVariable::equal(const char *n) {
return strcmp(n,name)==0?1:0;
}

int TVariable::equal(const int &n)
{
return 0;
}
    

int TVariable::equal(TVariable *n)
{
return this==n;
}

//==================================================================
int TVariable::GetFuncId()
{
	static char *allFunction[]=  //##cwhou
	{ 
	  "1", "R", "S", "G", "VEC", //0-4
	  "1","2","3","4","5",   //5-9
	  "sin", "cos", "tan", "cot", "sec", "csc",  //10-14
	  "sinh","cosh","tanh","coth","sech","csch", //15-19
	  "sqrt","curt","qurt",                      //20- 
	  "endoccur"};
	
	if (type!=TFUNCTION) return -1;
	for(int i=0;strcmp(allFunction[i],"endoccur")!=0;i++)
	{
		if (strcmp(name,allFunction[i])==0) return i;
	}
	return -1;
}

/*
int TVariable::GetAType()
{
	int k = 0;
	if (type!=TFUNCTION) return k;

	if     (strcmp(name,"R")==0) k = 1;
	else if(strcmp(name,"S")==0)  k = 2;
	else if(strcmp(name,"G")==0)  k = 3;
	return k;
}
*/

char *TVariable::GetName(bool nm) const
{   
    //	if (nm) return name;
	if (type==TFUNCTION && fname) return fname;
	return name;
}

char *TVariable::GetFuncName(bool nm) const
{   
    //	if (nm) return name;
	if (type==TFUNCTION) return name;
	return 0;
}

//
// for area method
// Getpt(1)/S(A,B,C,D) =  B
//
TVariable *TVariable::GetPt(int k)
{   
	int m = GetFuncId();
	if (m>=0 && m <= 9)
	{ 
		TList *l    = TL(GetValueReal());
		TRIPoly *p  = TP(l->Part(k+1));
		return (p)?(p->var):(NULL);
	}
	return NULL;
}

TAtom *TVariable::eval()
{
 //should retunr the real val of this var if exist
//	wout<<"aaaaa"<<endl;
 TAtom *m;
 if( type==TLIST) {
        if(m=GetValue()) return (TList*)(m->Copy());
    }
 if (type==TVARIABLE)
   {
     if((m=GetValue())) return (m)->eval();
   }
 else if (type==TFUNCTION) return Simplify();//ҪĻһ䣡
 //else if (type==TFUNCTION) return Simplify1();//Ϊ˲ԣʱд


  TRIPoly *p=new TRIPoly(this, 1);
  return p;
}

TRunType  TVariable::SysRun(TList * para)
{
 //return  (value.func)(para);
  return ::CallSysFunc( value.sysfunc, para);
}

 
//
//return a polynomial type(construct a new memory) on any case
//
TAtom *TVariable::Simplify()
{
 TAtom *a1 = this->Simplify1();
 if (a1->TypeID()==Variable) return new TRIPoly(this,1);
 return TP(a1);
}


//
// If it is changed,then return a polynomial type,construct a new memory
// If it is not changed,then return itself(a variable type), not construct
// a new memory
//
TAtom *TVariable::Simplify1()
{
		
	int funnumber = GetFuncId();

	// Ǻ

	if( funnumber>=10 && funnumber<=21){
		int neg=1;
	    TRIPoly  * p1=(TRIPoly  *)GetValue();//ȡǺĲ 

	    TVariable *tv;
     	if (!p1) 
		{   
		    gerror(p1,"should be a polynomial"); 
		    return p1->eval();
		}

	    TRIPoly  * p =(TRIPoly*)(p1->Clone());//˴һҪp1->Clone()
		                                      //ϵͳ
		if(p->IPlbcf() < 0) //QZY 2002
		{	
			p = neg_TRIPoly(p);

			/* static char *allFunction[]=
			  { "sin", "cos", "tan", "cot", "sec", "csc", 
				"sinh","cosh","tanh","coth","sech","csch",
				"sqrt","curt","qurt", 
				"endoccur"};    */

			switch(funnumber)
			{
				 case 10:
				 case 12:
				 case 13:
				 case 15:
				 case 16:
				 case 18:
				 case 19:
				 case 21:
						 neg=-1;
						 break;
				default:
					;
			}
		}

		TVariable *ret = new TVariable(name,TFUNCTION);
		ret->SetValue(p);

		tv = GenVar(ret); 

		if (tv!=ret)	delete ret;

        if (tv==this && neg==1) return TA(this); //not changed
		
		TRIPoly *q=new TRIPoly(tv, 1);
		if (neg==-1) q = neg_TRIPoly(q);
		return TA(q);
	}

	//  

	else if(funnumber >=22 && funnumber<=24)
	{
		switch(funnumber)
		{
		// sqrt(.)
		case 22:
		{
			//sqrt()ĲǶʽʱӦTRIPoly::Clone()õһ
			//ȻлŲƻϵͳе
			 int sgn;
			 TRIPoly *p=(TRIPoly*)GetValue();//get the parameter of sqrt()

			 if (!p->IsBigInt()) 
				//sqrtĲǷǳʽĿǰδκδ
				break; 
             
			 //sqrtĲǳʽ
			 TNumber n = p->c,m,k;
			 if (n<0) { sgn=-1; m = -n; } else { sgn =1; m = n;}
			 k = sqrt(m); //call TNumber sqrt(const TNumber & fn)
			 if ((k*k) == m) //nȫƽ,+9,-9
			 {
				if(sgn==1) //n>=0
					return (new TRIPoly(k)); 
				else//n<0
					return (new TRIPoly(TNumber(TComplex(0,k))));
			 }
			 break;
		} 
		// curt(.)
		case 13:
			break;
		// qurt(.)
		case 14:
			break;
		}

		return TA(this); 
	}
	else//⺯ͨ
		return TA(this); 
}
  

//===========proc=======================================================
void TVariable::display(outtype &out) const
{
   out<<name;
   if(type == TFUNCTION )
   {
	   
	  //*
	   out<<"(";
	   if(value.poly->TypeID()==ListType){ //##cwhou
		   int l=value.poly->length();
		   TList *ls=(TList*)value.poly;
		   for(int i=1;i<l;i++){
		      ls->Part(i)->display();
		      wout<<",";
		   }
           ls->Part(l)->display();

	   }
	   else{
	      value.poly->display();
	   }
	   out<<")";
	   //*/
   }
}
void TVariable::print(outtype &out) const
{
 display(out);
}
void TVariable::show(outtype &out) const
{
 display(out);
}

int TVariable::compare(TAtom *n)
{
#ifdef __COMPARE_DEBUG__
 wout<<"Var:var "; display();wout<<" "; n->display(); wout<<endl;
#endif
 if (!n) return 1;
 if (n->TypeID() != Variable)
        return Variable>n->TypeID()?1:-1;
 if (this->order > ((TVariable *)n)->order) return 1;
 if (this->order < ((TVariable *)n)->order) return -1;
 //if (this->order > ((TVariable *)n)->order) return -1;
 //if (this->order < ((TVariable *)n)->order) return 1;
 return 0;
}

void TVariable::SetType(TVarType t)
{
 type=t;
}
void TVariable::SetValueReal(TAtom *x)
{
   if (value.poly && x!=value.poly) delete value.poly;
   value.poly=x;
} 

void TVariable::ClearValue()
{
   if ((type==TLIST || type==TVARIABLE) && value.poly) {
	if (value.poly->TypeID()!=Variable)
		delete value.poly;
	value.poly=0;
	}
   else if (type==TPROCEDURE && value.proc) {
	delete value.proc;
	value.proc=0;
	}
   return;
}

void TVariable::SetValue(TAtom *x)
{
 if(type==TVARIABLE || type == TLIST)
 {
    if(WMODE!=PProcRun)
	{
         if (value.poly && x!=value.poly) delete value.poly;
         value.poly=x;
		 value.poly->display();wout<<endl;
	}else
 	{
     	TVariable* n=workpstat->vartbl->lookup(name);
		if(n) n->SetValueReal(x);
	}
 }
 else if(type == TFUNCTION)
 {
	value.poly = x;

	if(x->TypeID()==ListType){ //##cwhou
	   strstream buffer;
	   buffer<<name;
       value.poly->display(buffer);
       buffer<<ends;
       fname=buffer.str();
	   fname[strlen(name)]='(';
	   fname[strlen(fname)-1]=')';
	}
	else if(x->TypeID()==RIPolyType){
	   strstream buffer;
	   buffer<<name<<'(';
       value.poly->display(buffer);
       buffer<<')'<<ends;
       fname=buffer.str();
	}
 }
 else  value.poly=0;   
  
}; 


void TVariable::SetValue(TProcDef *x )
{
 if(type==TPROCEDURE) {
    if (value.proc && x!=value.proc) delete value.proc;
     value.proc=x;
   }
}

TProcDef* TVariable::GetProc()
{
 if(type== TPROCEDURE)
        {
        return (TProcDef *)value.proc;
        }
 else
 return NULL;
}

TAtom* TVariable::GetValueReal()
{
  return (TAtom *)value.poly;
}

TAtom* TVariable::GetFuncValue()
{
 if(type == TFUNCTION)
 {
	return (TAtom *)value.poly;
 }
 else return NULL;
}

TAtom* TVariable::GetValue()
{
 TVariable*n;
 if(type== TVARIABLE || type ==TLIST)
        {
        if(WMODE!=PProcRun)
	{
         return (TAtom *)value.poly;
	}else{
        n=workpstat->vartbl->lookup(name);
	if(n) return n->GetValueReal();
         else return 0;	
            }
        }
 else if(type== TFUNCTION)
 {
	return (TAtom *)value.poly;
 }
 else return NULL;
}

bool  TVariable::SysFuncCHK(TList *l)
{
 if(type ==TSYSFUNCTION)
     return ::SysFuncCHK( value.sysfunc, l->length() );
 else return false;
}

void *TVariable::operator new(size_t)
{
 return  (TVariable*)StarMem->alloc();
};

void TVariable::operator delete(void *p)
{
 (StarMem->free(p));
}

//============================
int Isdiffvar(TVariable * mvar)
{
//	cout<<"mvar=";mvar->display();cout<<endl;
	char * v=mvar->GetName();
	for(int i=1; i<=(int)strlen(v);i++)
	{
//		cout<<*(v+i-1)<<endl;
		if(*(v+i-1)=='[')
		  return 1;
	}
	return 0;
}

TVariable * getname (TVariable *mvar)
{
	char result[32];
	int i;
	if(!Isdiffvar(mvar))
       return mvar;
	char * v=mvar->GetName();
//	result[0]=*v;
	char temp[8];
	sprintf(temp,"%c", *v);
	strcpy(result, temp);
	for(i=1; i<=(int)strlen(v);i++)
	{
		sprintf(temp,"%c", *(v+i));
//		cout<<*(v+i)<<endl;
		if(*(v+i)!='[')
			strcat(result, temp);
		else
			break;
	}
//	j=i;
	strcat(result, "\0");
//	cout<<"result="<<result<<endl;
  TVariable * v1;
  TVariable *tmp=workpstat->vartbl->lookup(result);
  if(!tmp) {
//cout<<"???"<<endl;
  v1=new TVariable(result,TVARIABLE);v1->order=SerNum++;
  workpstat->vartbl->append(v1);
  }
  else{
   v1=tmp;
  }
  return v1;
}

TShortList * getlist( TVariable *mvar)
{
	char result[8];
	TShortList * l;
	int i=0,j=1,k;
	if(!Isdiffvar(mvar))
	{
       return 0;
	}
	char * v=mvar->GetName();
	l=new TShortList();
//cout<<"llllllll=";l->display();cout<<endl;
//	result[0]=*v;
	char temp[4];
	while(*(v+i)!='[')
		i=i+1;
	k=i+j;
	while(*(v+k)!=']')
{
//		cout<<*(v+i+j)<<endl;
	sprintf(temp,"%c", *(v+i+j));
	strcpy(result, temp);
	j=j+1;
	while(*(v+i+j)!=',' && *(v+i+j)!=']')
	{
		sprintf(temp,"%c", *(v+i+j));
//		cout<<*(v+i)<<endl;
//		if(*(v+i)!='[')
			strcat(result, temp);
		j=j+1;
	}
	i=i+j;
	j=1;
	strcat(result, "\0");
	short s=(short)atoi(result);
	l->append(s);
	k=i;
}
//	cout<<"l=";l->display();cout<<endl;
	return l;

}

TVariable * formvar(TVariable *mvar,TShortList *l)
{
	char temp[8];
	if(l==0) return mvar;

	int len=l->length();  char result[128];
	strcpy(result, mvar->GetName());
	short num;
//	int n2; 
	strcat(result, "[");
	  num=(l->get(1));
		sprintf(temp,"%d", num);
		strcat(result, temp);
	for(int i=2;i<=len;i++) 
	{	
	  num= (l->get(i));
		sprintf(temp,"%d", num);
		strcat(result, ",");
		strcat(result, temp);
	}
		strcat(result, "]");
		strcat(result, "\0");

		TVariable *tv;
		TVariable *tmp=workpstat->vartbl->lookup(result);
		if (tmp) tv = tmp;
		else {
			if(workpstat->mode==PProcDef) 
			   tv = new TVariable(result,TVARIABLE);
			else tv = new TVariable(result);
			tv->order=SerNum++;
			workpstat->vartbl->append(tv);
			}
	 	return tv;

}

//⺯sin() cos()...

//TVariable *t=GenVar("sqrt",);

TVariable *GenVar(char *name, TAtom *p)
{
	TVariable *tv;
	TVariable *t=new TVariable(name,TFUNCTION);  //##cwhou
    t->SetValue(toTRIPoly(p));

	//*	
	TVariable *tmp=workpstat->vartbl->lookup(t);

	if (tmp) {
		tv = tmp;
		delete t;
	}
	else {
	    tv=t;
		tv->order=SerNum++;
		workpstat->vartbl->append(tv);
		}
	//*/

	return tv;
}

TVariable *GenVar(char *name, TList *l)
{
	TVariable *tv;
	TVariable *t=new TVariable(name,TFUNCTION);  //##cwhou
    t->SetValue(l);

	TVariable *tmp=workpstat->vartbl->lookup(t);

	if (tmp) {
		tv = tmp;
		delete t;
	}
	else {
	    tv=t;
		tv->order=SerNum++;
		workpstat->vartbl->append(tv);
		}

	return tv;
}

TVariable *GenVar(char *result)
{
	TVariable *tv;
	TVariable *tmp=workpstat->vartbl->lookup(result);	
	if (tmp) tv = tmp;
	else {
		if(workpstat->mode==PProcDef) 
		   tv = new TVariable(result,TVARIABLE);
		else tv = new TVariable(result);
		tv->order=SerNum++;
		workpstat->vartbl->append(tv);
		}
	return tv;
}

TVariable *GenVar(TVariable *v)
{	
	TVariable *tv=workpstat->vartbl->LOOKUP(v);	
	if (!tv)  {
		tv = v;
		tv->order=SerNum++;
		workpstat->vartbl->append(tv);
		}
	return tv;
}



//=====================================
TVarList::TVarList():SListTVariable()
{};

TVarList::~TVarList()
{
};

// clear List Nodes but not delete the data it contained
void TVarList::Clear()
{
 SListNodeTVariable *tmp1,*tmp=first();
 while (tmp) {
	tmp1=tmp->next;
	tmp->data=0;
	delete tmp;
	tmp=tmp1;
	}
 head=tail=0;
 Total=0;
 return;
}

TAtom *TVarList::eval() 
{
 wout<<"Calling eval() of TVarList\n";
 return 0;
}

TAtom *TVarList::Copy()
{
 TVarList *ne=new TVarList();
 SListNodeTVariable *tmp=first();
 while (tmp) 
	{
	ne->insert((TVariable *)tmp->getdata()->Copy() );
        tmp=tmp->next;
        }
 return (TAtom *)ne;
}

int TVarList::OrdComp(TVariable *v1,TVariable *v2)
{
 int cp;
 if (!v1 && !v2) return 0;
 if (!v1) return -1;
 if (!v2) return 1;
 SListNodeTVariable *tmp=first();
 if (!(cp=v1->compare(v2))) return 0;
 while (tmp) {
	TVariable *tv=tmp->getdata();
	if (!tv->compare(v1)) return 1;
	if (!tv->compare(v2)) return -1;
	tmp=tmp->next;
	}
 return cp;
}

void TVarList::show(outtype& out) const
{
 SListTVariable::display(out);
}

void TVarList::print(outtype& out) const
{
 show(out);
}

void TVarList::display(outtype& out) const
{
 //wout<<" In Run-list"<<endl;
 SListTVariable::display(out);
}

void *TVarList::operator new(size_t)
{
 return  (Tbl2ListTVariable *)StarMem->alloc();
};

void TVarList::operator delete(void *p)
{
 (StarMem->free(p));
};
