#include <stdio.h>
#include <stdlib.h>
#include <malloc.h>
#include <iostream.h>
#include <string.h>

#include "typedef.h"
#include "basetype.h"
#include "global.h"
#include "express.h"
#include "poly.h"
#include "trpoly.h"
#include "pol.h"
#include "Tbl2ListTVariable.h"
#include "nvar.h"
#include "check.h"
#ifdef _WINDOWS
#include "..\gui\index.h"
#endif 
#include "stacks.h"
#include "lists.h"

//#define __DELETE_DEBUG__
//#define __SHOW_STACK__
//long ook=0;
//extern TRunType part(TList*);
//extern YYSTYPE	yylval;		

//========================================

TVariable::TVariable()
{
 name=0;
 fname=0;
 type=TSYMBOL;
}
TVariable::TVariable(char *s, TVarType t)
{
 name=strdup(s);
 fname=0;
 type=t;
 value.poly=0;
}

TVariable* TVariable::Clone()
{
 TVariable* nv=new TVariable(name,type);
 nv->order=order;
 nv->fname=fname;
 return nv;
}
TVariable::~TVariable()
{
  
//free(name);
#ifdef __DELETE_DEBUG__
 wout<<" TVar del: "<<this<<":"; display();wout<<endl;
#endif
 if(name)     free(name);
 if(fname)    free(fname);
  if(type==TPROCEDURE) {
        if(value.proc)
                delete (value.proc);
           value.proc=0;
        }
  else if (type==TLIST || type==TVARIABLE)
        if(value.poly)
           {
             value.poly->display();
             delete (value.poly);
              value.poly=0;
          }
}

int TVariable::equal(const char *n) {
return strcmp(n,name)==0?1:0;
}

int TVariable::equal(const int &n)
{
return 0;
}
    

int TVariable::equal(TVariable *n)
{
return this==n;
}

//==================================================================
int TVariable::GetFunctionNumber()
{
	static char *allFunction[]=
	{"sin","cos","endoccur"};
	for(int i=0;strcmp(allFunction[i],"endoccur")!=0;i++)
	{
		if (strcmp(name,allFunction[i])==0) return i;
	}
	return -1;
}

char *TVariable::GetName() const
{ 
	if ( type==TFUNCTION && fname ) return fname;
	return name;
}

TAtom *TVariable::eval()
{
 //should retunr the real val of this var if exist
//	wout<<"aaaaa"<<endl;
 TAtom *m;
 if( type==TLIST) {
        if(m=GetValue()) return (TList*)(m->Copy());
    }
 if (type==TVARIABLE)
   {
     if((m=GetValue())) return (m)->eval();
   }
 else if (type==TFUNCTION) return simplify();


  TRIPoly *p=new TRIPoly(this, 1);
  return p;
}
TRunType  TVariable::SysRun(TList * para)
{
 //return  (value.func)(para);
  return ::CallSysFunc( value.sysfunc, para);
}

TAtom *TVariable::simplify()
{
		int funnumber = GetFunctionNumber();
		int neg=1;
		TAtom * b = GetValue();
        TRIPoly  * p = poly_p(b);
		TVariable * ret;
		if (!p) 
		{   gerror(b,"should be a polynomial"); 
		    return b->eval();
		}
		TBigInt c = p->IPlbcf();
		if(c < 0)
		{	//p = neg_TRIPoly(p);
		    neg=-1;
		}
        G_OUT("p",p);
		ret->fname = p->pol_to_char();
  	    switch(funnumber)
		{
		case 0:
			ret = new TVariable("sin",TFUNCTION);
			ret->SetValue(TA(p));			
			break;
		case 1:
			ret = new TVariable("cos",TFUNCTION);
			ret->SetValue(TA(p));
			neg=1;
		default:
			gerror(0,"1111");
			break;
		}
  TRIPoly *q=new TRIPoly(ret, 1);
  if (neg==-1) q = neg_TRIPoly(q);
  return TA(q);
}



		/*
int TVariable::simplify()
{
	if (type==TFUNCTION)
	{
		int funnumber = GetFunctionNumber();
		TAtom * b = GetValue();
		if(b->TypeID() == Expression)
		{
			TRIPoly *e = (TRIPoly *)((TExpression *)b)->eval();
			TRIPoly a = *e;
			TBigInt c;
			c = e->IPlbcf();
			if(c < 0)
			{	
				if(funnumber == 0)
				{
					TAtom * tmp = ::uminus(this->GetValue());
					//delete value.poly;
					this->SetValue(tmp);
					//tmp = ::uminus(this);
					//delete this;
					return 1;
				}
				if(funnumber == 1)
				{
					TAtom * tmp = ::uminus(this->GetValue());
					this->SetValue(tmp);
					return 0;
				}
			}
			else return 0;
		}
	}
}
*/
//===========proc=======================================================
void TVariable::display(outtype &out) const
{
   out<<name;
   if(type == TFUNCTION)
		{
			out<<'(';
			value.poly->display();
			out<<')';
		}
}
void TVariable::print(outtype &out) const
{
 display(out);
}
void TVariable::show(outtype &out) const
{
 display(out);
}

int TVariable::compare(TAtom *n)
{
#ifdef __COMPARE_DEBUG__
 wout<<"Var:var "; display();wout<<" "; n->display(); wout<<endl;
#endif
 if (!n) return 1;
 if (n->TypeID() != Variable)
        return Variable>n->TypeID()?1:-1;
 if (this->order > ((TVariable *)n)->order) return 1;
 if (this->order < ((TVariable *)n)->order) return -1;
 //if (this->order > ((TVariable *)n)->order) return -1;
 //if (this->order < ((TVariable *)n)->order) return 1;
 return 0;
}

void TVariable::SetType(TVarType t)
{
 type=t;
}
void TVariable::SetValueReal(TAtom *x)
{
   if (value.poly && x!=value.poly) delete value.poly;
   value.poly=x;
} 

void TVariable::ClearValue()
{
   if ((type==TLIST || type==TVARIABLE) && value.poly) {
	if (value.poly->TypeID()!=Variable)
		delete value.poly;
	value.poly=0;
	}
   else if (type==TPROCEDURE && value.proc) {
	delete value.proc;
	value.proc=0;
	}
   return;
}

void TVariable::SetValue(TAtom *x)
{
 if(type==TVARIABLE || type == TLIST)
 {
    if(WMODE!=PProcRun)
	{
         if (value.poly && x!=value.poly) delete value.poly;
         value.poly=x;
		 value.poly->display();wout<<endl;
	}else
 	{
     	TVariable* n=workpstat->vartbl->lookup(name);
		if(n) n->SetValueReal(x);
	}
 }
 else if(type == TFUNCTION)
 {
	value.poly = x;
 }
 else  value.poly=0;   
  
}; 


void TVariable::SetValue(TProcDef *x )
{
 if(type==TPROCEDURE) {
    if (value.proc && x!=value.proc) delete value.proc;
     value.proc=x;
   }
}

TProcDef* TVariable::GetProc()
{
 if(type== TPROCEDURE)
        {
        return (TProcDef *)value.proc;
        }
 else
 return NULL;
}

TAtom* TVariable::GetValueReal()
{
  return (TAtom *)value.poly;
}

TAtom* TVariable::GetValue()
{
 TVariable*n;
 if(type== TVARIABLE || type ==TLIST)
        {
        if(WMODE!=PProcRun)
	{
         return (TAtom *)value.poly;
	}else{
        n=workpstat->vartbl->lookup(name);
	if(n) return n->GetValueReal();
         else return 0;	
            }
        }
 else if(type== TFUNCTION)
 {
	return (TAtom *)value.poly;
 }
 else return NULL;
}

bool  TVariable::SysFuncCHK(TList *l)
{
 if(type ==TSYSFUNCTION)
     return ::SysFuncCHK( value.sysfunc, l->length() );
 else return false;
}

void *TVariable::operator new(size_t)
{
 return  (TVariable*)StarMem->alloc();
};

void TVariable::operator delete(void *p)
{
 (StarMem->free(p));
}

//============================
int Isdiffvar(  TVariable * mvar)
{
//	cout<<"mvar=";mvar->display();cout<<endl;
	char * v=mvar->GetName();
	for(int i=1; i<=(int)strlen(v);i++)
	{
//		cout<<*(v+i-1)<<endl;
		if(*(v+i-1)=='[')
		  return 1;
	}
	return 0;
}

TVariable * getname (TVariable *mvar)
{
	char result[32];
	int i;
	if(!Isdiffvar(mvar))
       return mvar;
	char * v=mvar->GetName();
//	result[0]=*v;
	char temp[8];
	sprintf(temp,"%c", *v);
	strcpy(result, temp);
	for(i=1; i<=(int)strlen(v);i++)
	{
		sprintf(temp,"%c", *(v+i));
//		cout<<*(v+i)<<endl;
		if(*(v+i)!='[')
			strcat(result, temp);
		else
			break;
	}
//	j=i;
	strcat(result, "\0");
//	cout<<"result="<<result<<endl;
  TVariable * v1;
  TVariable *tmp=workpstat->vartbl->lookup(result);
  if(!tmp) {
//cout<<"???"<<endl;
  v1=new TVariable(result,TVARIABLE);v1->order=SerNum++;
  workpstat->vartbl->append(v1);
  }
  else{
   v1=tmp;
  }
  return v1;
}

TShortList * getlist( TVariable *mvar)
{
	char result[8];
	TShortList * l;
	int i=0,j=1,k;
	if(!Isdiffvar(mvar))
	{
       return 0;
	}
	char * v=mvar->GetName();
	l=new TShortList();
//cout<<"llllllll=";l->display();cout<<endl;
//	result[0]=*v;
	char temp[4];
	while(*(v+i)!='[')
		i=i+1;
	k=i+j;
	while(*(v+k)!=']')
{
//		cout<<*(v+i+j)<<endl;
	sprintf(temp,"%c", *(v+i+j));
	strcpy(result, temp);
	j=j+1;
	while(*(v+i+j)!=',' && *(v+i+j)!=']')
	{
		sprintf(temp,"%c", *(v+i+j));
//		cout<<*(v+i)<<endl;
//		if(*(v+i)!='[')
			strcat(result, temp);
		j=j+1;
	}
	i=i+j;
	j=1;
	strcat(result, "\0");
	short s=(short)atoi(result);
	l->append(s);
	k=i;
}
//	cout<<"l=";l->display();cout<<endl;
	return l;

}

TVariable * formvar(TVariable *mvar,TShortList *l)
{
	char temp[8];
	if(l==0) return mvar;

	int len=l->length();  char result[128];
	strcpy(result, mvar->GetName());
	short num;
//	int n2; 
	strcat(result, "[");
	  num=(l->get(1));
		sprintf(temp,"%d", num);
		strcat(result, temp);
	for(int i=2;i<=len;i++) 
	{	
	  num= (l->get(i));
		sprintf(temp,"%d", num);
		strcat(result, ",");
		strcat(result, temp);
	}
		strcat(result, "]");
		strcat(result, "\0");

		TVariable *tv;
		TVariable *tmp=workpstat->vartbl->lookup(result);
		if (tmp) tv = tmp;
		else {
			if(workpstat->mode==PProcDef) 
			   tv = new TVariable(result,TVARIABLE);
			else tv = new TVariable(result);
			tv->order=SerNum++;
			workpstat->vartbl->append(tv);
			}
	 	return tv;

}

TVariable *GenVar(char *result)
{
	TVariable *tv;
	TVariable *tmp=workpstat->vartbl->lookup(result);	
	if (tmp) tv = tmp;
	else {
		if(workpstat->mode==PProcDef) 
		   tv = new TVariable(result,TVARIABLE);
		else tv = new TVariable(result);
		tv->order=SerNum++;
		workpstat->vartbl->append(tv);
		}
	return tv;
}



//=====================================
TVarList::TVarList():SListTVariable()
{};

TVarList::~TVarList()
{
};

// clear List Nodes but not delete the data it contained
void TVarList::Clear()
{
 SListNodeTVariable *tmp1,*tmp=first();
 while (tmp) {
	tmp1=tmp->next;
	tmp->data=0;
	delete tmp;
	tmp=tmp1;
	}
 head=tail=0;
 Total=0;
 return;
}

TAtom *TVarList::eval() 
{
 wout<<"Calling eval() of TVarList\n";
 return 0;
}

TAtom *TVarList::Copy()
{
 TVarList *ne=new TVarList();
 SListNodeTVariable *tmp=first();
 while (tmp) 
	{
	ne->insert((TVariable *)tmp->getdata()->Copy() );
        tmp=tmp->next;
        }
 return (TAtom *)ne;
}

int TVarList::OrdComp(TVariable *v1,TVariable *v2)
{
 int cp;
 if (!v1 && !v2) return 0;
 if (!v1) return -1;
 if (!v2) return 1;
 SListNodeTVariable *tmp=first();
 if (!(cp=v1->compare(v2))) return 0;
 while (tmp) {
	TVariable *tv=tmp->getdata();
	if (!tv->compare(v1)) return 1;
	if (!tv->compare(v2)) return -1;
	tmp=tmp->next;
	}
 return cp;
}

void TVarList::show(outtype& out) const
{
 SListTVariable::display(out);
}

void TVarList::print(outtype& out) const
{
 show(out);
}

void TVarList::display(outtype& out) const
{
 //wout<<" In Run-list"<<endl;
 SListTVariable::display(out);
}

void *TVarList::operator new(size_t)
{
 return  (Tbl2ListTVariable *)StarMem->alloc();
};

void TVarList::operator delete(void *p)
{
 (StarMem->free(p));
};
