
//#include <stdafx.h>
#include <stdio.h>
#include <string.h>
#include <new.h>

//#include "geometry.h"
//#include "check.h"
#include "basetype.h"
#include "global.h"
#include "lists.h"
#include "vectors.h"

#ifdef _WINDOWS
#include "..\gui\index.h"
#endif

TVector::TVector(int l,bool t)
{
   len=l;
   val = (TAtom **)malloc(sizeof(TAtom *)*l);
   type=t;
}
TVector::TVector(TList* l,bool t)
{
 len=l->length();
 type=t;
 val = (TAtom **)malloc(sizeof(TAtom *)*len);
 TListNode *tmp=l->first();
 int i;
 for (i=0; i<len; i++) {
	val[i]=tmp->getdata()->Copy();
	tmp=tmp->next;
	}
}

TVector::TVector(TList* l,int nn,bool t)
{
 int i;
 TListNode *tmp=l->first();
 len=l->length();
 type=t;
 if(nn==len) 
  {
    val = (TAtom **)malloc(sizeof(TAtom *)*len);
    tmp=l->first();
    for (i=0; i<len; i++) {
	val[i]=tmp->getdata()->Copy();
	tmp=tmp->next;
    }
  return;
  }	
 int tm=len;
 len=nn;
 val = (TAtom **)malloc(sizeof(TAtom *)*len);
 tmp=l->first();
 if(tm>=len)
  {
    for (i=0; i<len; i++) {
	val[i]=tmp->getdata()->Copy();
	tmp=tmp->next;
	}
 }else
  {
   for (i=0; i<tm; i++) {
        val[i]=tmp->getdata()->Copy();
        tmp=tmp->next;
        }
   for( i=tm; i<len; i++)
     {
      val[i]=new TNumber(0);
     }
   }
}

TVector::TVector(const TVector &v)
{
 len=v.size();
 val = (TAtom **)malloc(sizeof(TAtom *)*len);
 type=v.type;

 for (int i=0; i<len; i++) {
        //val[i]=v.Part(i)->Copy();
        val[i]=v.val[i]->Copy();
    }
}

TVector& TVector::operator =(const TVector &v)
{
	if(len!=v.size() ) 
	{
		::free(val);
		len=v.size();
		val = (TAtom **)malloc(sizeof(TAtom *)*  len );
	}


	for (int i=0; i<len; i++) 
	{
        val[i]=v.Part(i)->Copy();
    }
	
	TVector * p = new TVector(1);
	return *p;
}

TVector::~TVector()
{
 int i;
 for (i=0; i<len; i++) {
        delete val[i];
  }
 free(val);
}

TVector* TVector::trans(TVector *v)
{
 TVector *nv=new TVector(*v);
 type=!type;
 return nv;
}

TVector*  TVector::add(TVector *v)
{
 int i;
 if(length() != v->length() ) {
	cout<<"different length\n";
	return 0;
	}
 if(type != v->type) {
	cout<<"I can not add row vector with colum vector\n";
	return 0;
	}
 TVector *nv=new TVector(len,type);
 TAtom *na;
 for (i=0; i<len; i++) {
	na=::add(val[i]->Copy(),v->Part(i)->Copy());
	nv->SetPart(i,na);
	}
 return nv;
}

TAtom* TVector::mul(TVector *v)
{
 int i;
 if(length() != v->length() ) {
	cout<<"different length\n";
	return 0;
	}
 if(type == v->type) {
	cout<<"I can not mul two row vectors or two colum vectors\n";
	return 0;
	}
 TAtom *na=new TNumber(0),*tmp;
 for (i=0; i<len; i++) {
	tmp=::mul(val[i]->Copy(),v->val[i]->Copy());
	na=::add(na,tmp);
	}
 return na;
}

TVector*  TVector::mul(TAtom *v)
{
	TVector * p = new TVector(1);
	return p;
}

TVector* TVector::Vmul(TVector *v)
{
	TVector * p = new TVector(1);
	return p;
}

TVector* TVector::mul(TMatrix *v)
{
	TVector * p = new TVector(1);
	return p;
}

int TVector::size() const
{
 return len;
}

TAtom *TVector::SetPart(int n,TAtom *nv)
{
 if(n<0 || n>=len) return val[len-1]=nv;
 return  val[n]=nv;
};

TAtom *TVector::Part(int n) const
{
 if(n<0 || n>=len) return val[len-1];
 return  val[n];
};

//============================================
TAtom * TVector::Copy()
{
 TVector* nr;
 nr=new TVector( *this);
 //------------------------------------------
 return (TAtom *)nr; 
};

TVector* TVector::Clone()
{
  return (TVector *)(Copy());
};

//============================================
TRunType TVector::Run()
{
 TRunType rt=TNORMAL;
 return rt;
}

TAtom *TVector::eval()
{
 TVector* nr=new TVector(len);

 for (int i=0; i<len; i++ )
  nr->SetPart(i,val[i]->eval() );
 return (TAtom *)nr;
}
void TVector::print(outtype& out)const
{ display(out);}

void TVector::show(outtype& out)const
{ 
 //display();
 if(len) val[0]->display(out);
 for(int k=1; k<len; k++)
  {
    out<<",";
    val[k]->display(out);
  }
}

void TVector::display(outtype& out)const
{
 out<<"vectorr(";
 if(len) val[0]->display(out); 
 for(int k=1; k<len; k++)
  {
    out<<",";
    val[k]->display(out);
  } 
 out<<")";
  
}

//==========================================
void* TVector::operator new(size_t)
{
  return  (TVector*)StarMem->alloc();
};

void  TVector::operator delete(void *p)
{
  (StarMem->free(p));
};
/////////////////////////////////////////////////////////////////////////////////
Tarray::Tarray(int v,bool t)
{
	if(v <= 0)
	{
		wout<<"array constructor is wrong!"<<endl;
		return;
	}
	v_dim = v;
	h_dim = 1;
	type = t;

	val = (TAtom **)malloc((sizeof(TAtom *)) * v_dim);
	for(int i = 0;i < v_dim;i ++)
		val[i] = 0;
}

Tarray::Tarray(TList *l,bool t)
{
	int len = l->length();
	
	v_dim = len;
	h_dim = 1;
	type = t;
	
	val = (TAtom **)malloc((sizeof(TAtom *)) * len);
	int i = 0;
	for(TListNode * tmp = FIRSTNODE(l);tmp;RNEXT(tmp))
	{
		TAtom *a = DATA(tmp);
		val[i] = a->Copy();
		i ++;
	}
}

Tarray::Tarray(Tarray *l,bool t)
{
	int len = l->v_dim;
	
	v_dim = len;
	h_dim = 1;
	type = t;
	
	val = (TAtom **)malloc((sizeof(TAtom *)) * len);
	
	for(int i = 0;i < len;i ++)
		val[i] = l->val[i]->Copy();
}

Tarray::Tarray(int v,TList *l,bool t)
{
	int len = l->length();
	if(v <= 0 || len != v)
	{
		wout<<"array constructor is wrong!"<<endl;
		exit(0);
	}
	else
	{
		v_dim = v;
		h_dim = 1;
		type = t;
	
		val = (TAtom **)malloc((sizeof(TAtom *)) * v_dim);
		int i = 0;
		for(TListNode * tmp = FIRSTNODE(l);tmp;RNEXT(tmp))
		{
			TAtom *a = DATA(tmp);
			val[i] = a->Copy();
			i ++;
		}
	}
}
/*
Tarray::~Tarray()
{
    TAtom * t1;
    for(int i = 0;i < v_dim;i ++)
	{ 
		t1 = val[i];
		if(t1)
			delete t1;
	}
	::free(val); 
}
*/
TAtom * Tarray::eval()
{
	Tarray* m=new Tarray(v_dim);

	for(int i = 0;i < v_dim;i ++)
		m->val[i] = val[i]->eval();
	return m;
}

TRunType Tarray::Run()
{

 TRunType rt = TNORMAL;
 return rt;
}

Tarray* Tarray:: operator=(Tarray* m)
{
	TAtom * t1;
	for(int i = 0;i < v_dim;i ++)
	{
		t1 = val[i];
	    if  (t1) delete t1;
	}
	::free(val);

	v_dim = m->VSize();

	val = (TAtom **)malloc(sizeof(TAtom *)* v_dim);

	val[0] = (TAtom *)(m->val[0]->Copy());
	for(i = 1;i < v_dim;i ++)
		val[i] = (TAtom *)(m->val[i]->Copy());

	return this;
}

Tarray* Tarray::add(Tarray *m)
{
	if(v_dim != m->VSize())
	{
		wout<<"array addition different size\n";
		return 0;
	}

	Tarray* tm = new Tarray(v_dim); 
	for(int i = 0;i < v_dim;i ++)
		tm->val[i] = ::add(val[i]->Copy(),m->val[i]->Copy());

    return tm;
}

Tarray* Tarray::minus(Tarray *m)
{
	if(v_dim != m->VSize())
	{
		wout<<"array addition different size\n";
		return 0;
	}

	Tarray* tm = new Tarray(v_dim); 
	for(int i = 0;i < v_dim;i ++)
		tm->val[i] = ::minus(val[i]->Copy(),m->val[i]->Copy());

    return tm;
}

Tarray* Tarray::uminus()
{
	Tarray* tm = new Tarray(v_dim); 
	for(int i = 0;i < v_dim;i ++)
		tm->val[i] = (TAtom *)(val[i]->uminus());

    return tm;
}
/////////////////////////////////////////////////////////////////////
TAtom * Tarray::InnerProduct(Tarray *v)
{
	if(this->v_dim != v->v_dim)
	{
		wout<<"array innerproduct is wrong!"<<endl;
		exit(0);		
	}
	else
	{
		TNumber * a = new TNumber(0);
		TAtom * tmp = (TAtom *)a;
		TAtom * re;
		for(int i = 0;i < v_dim;i ++)
		{
			re = ::add(tmp,::mul(this->val[i]->Copy(),v->val[i]->Copy()));
			tmp = re;
		}
		
		return re;
	}
}

Tarray * Tarray::OuterProduct(Tarray *v)
{
	if(this->v_dim != 3 || v->v_dim != 3)
	{
		wout<<"array outerproduct is wrong!"<<endl;
		exit(0);		
	}
	else
	{
		Tarray * re = new Tarray(3);
		re->val[0] = ::minus(::mul(this->val[1]->Copy(),v->val[2]->Copy()),::mul(this->val[2]->Copy(),v->val[1]->Copy()));
		re->val[1] = ::minus(::mul(this->val[2]->Copy(),v->val[0]->Copy()),::mul(this->val[0]->Copy(),v->val[2]->Copy()));
		re->val[2] = ::minus(::mul(this->val[0]->Copy(),v->val[1]->Copy()),::mul(this->val[1]->Copy(),v->val[0]->Copy()));
		return re;
	}
}

Tarray * Tarray::NumberProduct(TAtom *v)
{
	Tarray * re = new Tarray(this->v_dim);
	for(int i = 0;i < v_dim;i ++)
		re->val[i] = ::mul(v->Copy(),this->val[i]->Copy());

	return re;
}   
/*
Tarray* Tarray::adiff(int n,TVariable * v)
{
	Tarray * re = new Tarray(v_dim);
	TRIPoly * tmp,*tmp1;
	for(int i = 0;i < v_dim;i ++)
	{
		tmp = toTRIPoly(val[i]);
		tmp1 = dDiff_chen(tmp,n,v);
		re->val[i] = TA(tmp1);
		delete tmp;
	}
	return re;
}
*/
void Tarray::display(outtype& out)const
{
	wout<<"array(";
	for(int i = 0;i < v_dim;i ++)
	{
		val[i]->display();
		if(i != v_dim - 1)
			wout<<",";
	}
	wout<<")";
}

TAtom* Tarray::Clone()
{
	return (Tarray *)(Copy());
}

TAtom* Tarray::Copy()
{
	Tarray* m;
	m = new Tarray(this,0);
	return m;
} 

void* Tarray::operator new(size_t)
{
	return  (Tarray*)StarMem->alloc();
}
void  Tarray::operator delete(void *p)
{
	(StarMem->free(p));
}
