#ifndef __STAR_VECTOR__
#define __STAR_VECTOR__
#include <stdio.h>
#include <string.h>
#include <new.h>

#include "basetype.h"
#include "matrix.h"

class TMatrix;
class TVector : public TAtom, public TRun
 {
  protected:
	TAtom **val;   // *val[100]
	int   len;
  public:
	bool type;	// default=0=colum vector, 1=row vector

        friend class TMatrix;
	TVector(int l,bool t=0); // constructor
	TVector(TList *l,bool t=0); // constructor
	TVector(TList *l, int nn, bool t=0); // constructor
	TVector(const TVector &v); // constructor
	~TVector();  // destructor

        virtual DataType TypeID()const{ return VectorType;};
        virtual TRunType Run();
	int 	size()const;
        TAtom *	eval();


        virtual TAtom*  Part(int n)const;
        virtual TAtom*  SetPart(int n, TAtom *nv);
 
        int     compare(TVector *){return 1;};
        virtual TAtom* Copy();
        virtual TVector* Clone();


        virtual void display(outtype& out =wout) const;
        virtual void show(outtype& out =wout) const;
        virtual void print(outtype& out =wout) const;
 
        int     length() const { return len;}
	TVector* trans(TVector *);
        TVector& operator =(const TVector& v);
        TVector* add(TVector *v);
        TVector* mul(TAtom *v);
        TVector* mul(TMatrix *v);
        TAtom*   mul(TVector *v);
        TVector* Vmul(TVector *v);

        void* 	operator new(size_t);
        void  	operator delete(void *);

	};
//////////////////////////////////////////////////////////////////////////////////
class Tarray : public TMatrix
{
public:
	bool type;// default=0=colum array, 1=row array
public:
	Tarray(int v,bool t = 0);
	Tarray(TList *l,bool t = 0);
	Tarray(Tarray *l,bool t = 0);
	Tarray(int v,TList *l,bool t = 0);
	//~Tarray();
	virtual DataType TypeID()const{ return ArrayType;};
	TAtom * eval();
	TRunType Run();
	Tarray* operator=(Tarray* m);
	virtual Tarray* add(Tarray *m);
	virtual Tarray* minus(Tarray *m);
	virtual Tarray* uminus();

	TAtom * InnerProduct(Tarray *v);
	Tarray * OuterProduct(Tarray *v);
	Tarray * NumberProduct(TAtom *v);
//	Tarray* adiff(int n = 1,TVariable * v = 0);

	void display(outtype& out)const;
	TAtom * Clone();
	TAtom * Copy();
	void* operator new(size_t);
	void  operator delete(void *p);
};

#endif
