#include "basetype.h"
#include "stacks.h"
#include "global.h"
#include "lists.h"
#include "poly.h"
#include "pol.h"
#include "sysfunc.h"
#include "charset.h"
//#include "fwang.h"
//#include "lists_cs.h"
//#include "factorrs.h"
#include "basetype.h"
//#include "cs.h"
#include "check.h"

#include "wsolve.h"

#ifdef _WINDOWS
#include "..\gui\index.h"
#endif
//=============== Function Member in class TRIPoly ====================

//p is a polynomial
//ord is a variable list; ord=[x,y,z] means x>y>z
//return the class of *p w.r.t. ord

//to determine if an object is [1] (1 is a polynomial type)
int Listisp1(TList *l)
{
  if((l->length())!=1)
    return 0;
  DataType DT=l->Part(1)->TypeID();
  if(DT==RIPolyType)
  {
    if((((TRIPoly *)(l->Part(1))))->pis1())
      return 1;
  }
  return 0;
}

int class_wdk(TRIPoly *p,TList * ord)
{
	 int i;

	 for (i=1;i<=ord->length();i++)
                  if (p->Degree((TVariable *)(ord->Part(i)))>0)
				return ord->length()-i+1;
	 return 0;
}

//p is a polynomial
//ord is a variable list
//return the main variable  of polynomial p w.r.t. ord


TVariable * mainvar_wdk(TRIPoly * p,TList * ord)
{
//	 TVariable * mvar;
/*	 for (i=1;i<=ord->length();i++)
	   { mvar = (TVariable *) (ord->Part(i));
	   if (degree_wdk(p,mvar) > 0) return mvar;
	   }
*/
/*	 cls=class_wdk(p,ord);
	 if (cls==0) {
		 wout<<" A polynomial p is of class 0, its main varialbe will be 0"<<endl;
		 return NULL;}
	 else
	 { return (TVariable *) ord->Part(ord->length()-cls+1);}
*/

	 int i;
	 TVariable *v;
	 for (i=1;i<=ord->length();i++)
	 { v=(TVariable *)ord->Part(i);
	   if (p->Degree((v))>0) return v;
	 }
	 return 0;
}

/*
TList * factors_wdk(TRIPoly *p)
{ 
  int i,j;
  TList * l1,* l2,* r1;
  TRIPoly * l3;

  r1=new TList();
  l1=p->Factor();
  for (i=1;i<=l1->length();i=i+2)
  {    l2=(TList *) (l1->Part(i));
      for (j=1;j<=l2->length();j++)
	{  l3=(TRIPoly *)l2->Part(j); 
	      r1->append((TAtom *)(new TRIPoly (* l3)));
	}
  } 
  delete l1;
  return r1;
}

TList * Nonumber_wdk(TList *ps, TList *ord)
{ 
  TList * rps=new TList();
  TRIPoly *p;
  int i,l=ps->length();
  if (l==0) return rps;
  for (i=1;i<=l;i++)
    { p=(TRIPoly *) (ps->Part(i));
      if ( class_wdk(p,ord) !=0) rps->append(p);
    }
  return rps;
}





Nonumber:=proc(list,ord)
local i,ls;
    ls := {};
    for i in list do  if 0 < Class(i,ord) then ls := ls union {i} fi od;
    ls
end:

*/

//p is a polynomial
//ord is a variable list
//return the initial of p w.r.t. ord


TRIPoly   * initial_wdk(TRIPoly *p,TList * ord)
{
  return  p->IPLdCf_w( ord);
}

TRIPoly * leadcoeff(TRIPoly *p, TVariable *mvar)
{
  
  return p->Coefficient(mvar,p->Degree(mvar));
} 

//p,pol are two  polynomial
//ord is a variable list
//return 1 if p is not greater than pol, otherwise return 0;  



int rank_wdk(TRIPoly *p,TRIPoly *pol, TList * ord)
{
  int c,cpol,result;
  TBigInt d,dpol;
  TRIPoly *Init,*Initpol;
  if ( p->IsBigInt()) return 1;
  if (pol->IsBigInt()) return 0;
  c=class_wdk(p,ord);
  cpol=class_wdk(pol,ord);
  if (c == 0) return 1;
  if (cpol==0) return 0;
  if (c < cpol)  return 1;
  if (c == cpol) { d= degree_wdk(p, (TVariable *) (ord->Part(ord->length()-c+1)));
		   dpol=degree_wdk(pol, (TVariable *) (ord->Part(ord->length()-c+1)));
		  if (d < dpol) return 1;
		    else if (d > dpol) return 0;
		  else { Init=initial_wdk(p,ord);
		           Initpol=initial_wdk(pol,ord);
			   result=rank_wdk(Init,Initpol,ord);
			   delete Init;
			   delete Initpol;
			   return result;
		    }
                 }
  return 0;
		  
}

//l is a polynomial list
//ord is a variable list
//return the least polynomial in list l;

TRIPoly * least_wdk(TList * l,TList * ord)
{
    int i,len;
    TRIPoly *p,*p2;
    p= (TRIPoly *) l->Part(1);
    len=l->length();
    if (len==1) return (TRIPoly *)p->Copy();
    for(i=2;i<=len;i++)
      { p2=(TRIPoly *)l->Part(i);
	if (rank_wdk(p2,p,ord)) p=p2;
      }
    return (TRIPoly *)p->Copy();
}    

// p is a polynomial
// mvar is a variable
// return the degree of p w.r.t. mvar =degree(p,mvar)
int  degree_wdk(TRIPoly * p, TVariable * mvar)
{ return p->Degree(mvar);
}


// p , q are two polynomials;
//ord is a variable list;
//if p is reduced to q then return 1 otherwise 0;

int reduced_wdk(TRIPoly * p,TRIPoly * q,TList * ord)
{ 
  if (degree_wdk(p,  mainvar_wdk(q, ord))
	   < degree_wdk(q, mainvar_wdk(q,ord))) return 1; else return 0;
} 

int greduced_wdk(TRIPoly * p,TList * as,TList * ord)
{ TRIPoly * ip,*r;
  int result=0;

  ip=initial_wdk(p,ord);
  r=premas_wdk(ip,as,ord);
    

  if ( class_wdk(p,ord) > class_wdk((TRIPoly *) as->Part(1),ord)  &&
      ! (r->IsZero()) )
  {result= 1;}
  delete ip;
  delete r; 

  return result;
	   

} 		


			    
// ps is a polynomial set
// q is a polynomial
// ord is a variable list
// return a polynomial list which is composed by all  polynomials in ps
// reduced to q

TList * reducedset_wdk(TList *ps, TRIPoly * q, TList * ord)
{
  TList * reducedset =new TList();
  TRIPoly * pol;
  int j,l=ps->length();
  if (l==0) return reducedset;
  for (j=1;j<=l;j++)
    { pol= (TRIPoly *) (ps->Part(j));
    if (reduced_wdk(pol,q,ord)) reducedset->append( (TAtom *) pol->Copy());
    }
  return reducedset;
}


TList * greducedset_wdk(TList *ps, TList  * q, TList * ord)
{
  TList * reducedset =new TList();
  TRIPoly * pol;
  int j,l=ps->length();
  if (l==0) return reducedset;
  for (j=1;j<=l;j++)
    { pol= (TRIPoly *) (ps->Part(j));
    if (greduced_wdk(pol,q,ord)) reducedset->append( (TAtom *) pol->Copy());
    }
  return reducedset;
}

// ps is a polynomial set
// ord is a variable list
// return the basic set of ps

TList * basicset_wdk(TList * ps,TList * ord)
{
  TList * bs=new TList (), *bs1, *redset,*redset1;
  TRIPoly *pol;

  redset=(TList *)ps->Copy();
  while(redset->length()!=0)
  {  pol=least_wdk(redset,ord);

     bs1=bs->insert(1, (TAtom *) pol);
	 delete bs;
	 bs=bs1; 
     redset1 = reducedset_wdk(redset,pol,ord);
	 delete pol;
     delete redset;
	 redset=redset1;

  }
  if (redset) delete redset;

  return bs;
}


TList * gbasicset_wdk(TList * ps,TList * ord)
{
  TList * bs=new TList (), *bs1, *redset,*redset1;
  TRIPoly *pol;

  redset=(TList *)ps->Copy();
  while(redset->length()!=0)
  {  pol=least_wdk(redset,ord);

     bs1=bs->insert(1, (TAtom *) pol);
	 delete bs;
	 bs=bs1; 
     redset1 = greducedset_wdk(redset,bs,ord);
	 delete pol;
     delete redset;
	 redset=redset1;

  }
  if (redset) delete redset;

  return bs;
}



// for prove constructive geometric theorems
// The following should be tested again;

TList * basicset_cs(TList * ps,TList * ord)
{
  TVariable *v1, *v2;
  TList * bs = new TList(), *ps1;
  TRIPoly *p0, *p1, *p2, *p3, *p4;
  int len = 0;
//  G_OUT("ps:",ps);
  for (int i=1;i<=ord->length() && len<ps->length();)
  {   
	  v1 = (TVariable *)ord->Part(i);
	  //G_OUT("v1:",v1);
	  ps1 = ps_in_var(ps,v1,ord);
	  //G_OUT("ps1:",ps1);
	  switch(ps1->length())
	  {
		 case 0: i++; break;
		 case 1: 
			 bs->append(ps1->Part(1)->Copy());
			 len++;
			 i++;
		     break;
	     case 2:
			 v2 = (TVariable *)ord->Part(i+1);
	         //G_OUT("v2:",v2);
			 p1 = (TRIPoly*)ps1->Part(1);
			 p2 = (TRIPoly*)ps1->Part(2);
			 // ax + by +c 
			 if (p2->Degree(v1)!=1) { p0=p1;p1=p2;p2=p0;}
			 if (p2->Degree(v1)==2 && p1->Degree(v1)==2) 
			 {    p4 = new TRIPoly( (*p1)-(*p2) );}
			 else p4 = (TRIPoly*)p1->Copy();
			 if (p4->Degree(v1)==1)
			 {	
			    if (p2->Degree(v1)==1)
				 {	if       (p4->Degree(v2)==1) { p0=prem_wdk(p2,p4,v2); }
				    else if  (p2->Degree(v2)==1) { p0=prem_wdk(p4,p2,v2); }
					else  { delete p4; delete bs; return 0;}
					bs->append(p0);
				 }
				else { bs->append(p4->Copy());}
				 p3=prem_wdk(p2,p4,v1);
				 bs->append(p3);
				 delete p4;
			 }
			 else { delete bs; return 0;}
			 i+=2; len+=2;
		     break;
		default:
			 delete bs;
	         return 0;
	  }
	  //delete ps1;
	  //G_OUT("bs:",bs);
  }
  if (weak_as(bs,ord))   return bs;
  delete bs; return 0;
}

bool weak_as(TList *as, TList * ord)
{
	bool re = true;
	int len = as->length();
	TRIPoly* ip, *p;
	for (int i=1;i<=len;i++)
	{   ip = initial_wdk((TRIPoly*)as->Part(i),ord);
	    p = premas_wdk(ip,as,ord);
		delete ip;
		if (p->IsZero()) { delete p; re = false; break;}
		delete p;
	}
	return re;
}

TList *ps_in_var(TList *ps, TVariable * v, TList * ord)
{   int i;
	int len = ps->length();
	TList *bs = new TList();
    for (i=1;i<=len;i++)
	{ TRIPoly* p = (TRIPoly*)ps->Part(i);
	  if (mainvar_wdk(p,ord) == v) bs->append((TAtom*)(p->Copy()));
	}
  return bs;;  
}


// p, q are two polynomials
// return the psudo-remainder of p w.r.t.q for the variable var 
/*
TRIPoly * prem_wdk(TRIPoly * p, TRIPoly *q, TVariable *var)
{
  return p->prem(*q,var);
}
*/
/*
TRIPoly * reductum_wdk(TRIPoly * p, TVariable *mvar)
{
  TRIPoly  p1,*l1;
  l1=p->Coefficient(mvar,p->Degree(mvar));
  p1=(*p)-(*l1)*TRIPoly(mvar,(p->Degree(mvar)));
  delete l1;
  return new TRIPoly(p1);
}
*/
 
TRIPoly * prem_wdk(TRIPoly * p, TRIPoly *q, TVariable *var)
{
  TRIPoly * l1, *l2,r,r1, q1, gcd;
  unsigned short dr,dq;
  dq=q->Degree(var);
  if (p->Degree(var)==0) { return (TRIPoly *) (p->Copy());}
  if (dq==0) {return new TRIPoly(TBigInt(0));}
  r=*p;
  dr=r.Degree(var);

  l2=q->Coefficient(var,dq);
  q1 = (*q)-(*l2)*TRIPoly(var,dq);

  while (dr>=dq){
    l1=r.Coefficient(var,dr);
    gcd=l1->mipgcd(*l2);
 
    //r=r* ((*l2)/gcd)-(*q)*((*l1)/gcd)*TRIPoly(var,(dr-dq));
    r1 = r - (*l1)*TRIPoly(var,dr);
    r=r1 * ((*l2)/gcd)-q1 * ((*l1)/gcd)*TRIPoly(var,(dr-dq));
	
	delete l1;
    dr=r.Degree(var);
  }
  delete l2;
  return new TRIPoly(r);
}
    
      
			     
    

  

// p is the polynomial
// as is an ascending set
// ord is a variable list
// return the remainder of p w.r.t. as

TRIPoly * premas_wdk(TRIPoly *p, TList * as, TList *ord)
{ 
  int i,l=as->length();
  TVariable * var;
  TRIPoly *pol,*p1,*p2;
  p1=(TRIPoly *)p->Copy();
  for(i=1;i<=l;i++)
    { pol=(TRIPoly *) (as->Part(i));
      var=mainvar_wdk(pol,ord);
      p2=prem_wdk(p1,pol,var);
      delete p1;
      p1=p2;
    }
  return p1;
}


TRIPoly * gpremas_wdk(TRIPoly *p, TList * as, TList *ord)
{ 
  int i,l=as->length(),pcls,qcls;

  TRIPoly *ip,*rip,*p1,*p2,*q;
  TVariable *mvar;

  ip=initial_wdk(p,ord);
  rip=premas_wdk(ip,as,ord);
  if (rip->IsZero()) { delete ip; delete rip; return premas_wdk(p,as,ord);}
  delete ip;
  delete rip;
  p1=(TRIPoly *) p->Copy();
  for(i=1;i<=l;i++)
  {
	  pcls=class_wdk(p1,ord);
	  q=(TRIPoly *) as->Part(i);
	  qcls=class_wdk(q,ord);

	  if ( pcls == qcls ) {
		  mvar=(TVariable *) ord->Part(ord->length()-qcls+1);
		  p2=prem_wdk(p1,q,mvar);
		  delete p1; 
		  p1=p2;
	  }
  }
	    	  
  return p1;
}
/*
######################
#gao's premas
gPremas :=

    proc(f,as,ord)
    global prem_time;
    local remd,i,st;
        remd := f;
        st:=time();
        if rPremas( Initial(f,ord), as,ord) =0 then RETURN( rPremas(f,as,ord) ) fi;
        
        for i to nops(as) do
                if Class(remd,ord) = Class(as[i],ord) then
                        remd := NPrem(remd,as[i],Mainvar(as[i],ord))
                fi
        od;

        if remd <> 0 then numer(remd/lcoeff(remd)) else 0 fi
    end:
*/    
// as is a polynomial set,
// ord is variable list;
// return 2 if as is an trivial ascending set, ie. as is a contradict asc.
// return 1 if as is an ascending set;
//         0 if else;
int isasc_wdk(TList *as,TList *ord)
{ int la,lo, i,j ;
  TVariable * mvar;
	la=as->length();
	lo=ord->length();
	if (la==0) {return 0;}
	if (la==1 && class_wdk((TRIPoly *) as->Part(1),ord)==0 && !(((TRIPoly *) as->Part(1))->IsZero())){return 2;}
	int c=0;
	for (i=la;i>=1;i--)
	{   TRIPoly *p = (TRIPoly *) as->Part(i);
	    int cls=class_wdk(p, ord);
		if (cls<c)  {return 0;}
		    c=cls;
		if (c==0)  {return 0;}
	       mvar=(TVariable *) ord->Part(lo-c+1);
		   int d=degree_wdk(p,mvar);
		   for (j=i-1;j>=1;j--) {
			if (degree_wdk((TRIPoly *) as->Part(j),mvar) > d) {return 0;}
		   }

	}

	return 1;

}

// ps is a polynomial set, as is an ascending set, ord is a variable list;
// return the remainder set;
// if there exist a polynomial p in ps, r is the remainder of p respect to as, 
// and class(r,ord) =0 and r !=0, then return a list [1];
// if  class(r,ord) >0 then append the polynomial r into the poly set.
// if  r=0, do NOT append 0 to the remainder set

TList * remainderset_wdk(TList *ps, TList *as, TList  *ord)
{
  TList * rs =new TList(),*ps1, *result;
  TRIPoly *p;
  int i,l;


  //ps1=ps->PMinus(as);
  ps1=ps->Minus(as);
  l=ps1->length();
  if (l==0)  {delete ps1; return rs;}
  for (i=1;i<=l;i++)
    {
    p=premas_wdk((TRIPoly *) (ps1->Part(i)),as,ord);
    if (! (p->IsZero())) {
      if (class_wdk(p,ord)==0) {delete p;delete ps1; delete rs; return Getp1list();}
      rs->append((TAtom *)(p->Copy()));
      delete p;
    }
    else 
      delete p;
  }
  //result=rs->Plunion();
  result=rs->lunion();

  delete ps1;
  delete rs;
  return result;
}




TList * gremainderset_wdk(TList *ps, TList *as, TList  *ord)
{
  TList * rs =new TList(),*ps1,*result;
  TRIPoly *p;
  int i,l;

  //ps1=ps->PMinus(as);
  ps1=ps->Minus(as);
  l=ps1->length();
  if (l==0) {delete ps1; return rs;}
  for (i=1;i<=l;i++)
    {
    p=gpremas_wdk((TRIPoly *) (ps1->Part(i)),as,ord);
    if (! (p->IsZero())) {
      if (class_wdk(p,ord)==0) {delete p;delete rs;delete ps1; return Getp1list();}
      rs->append((TAtom *)(p->Copy()));
      delete p;
    }
    else 
      delete p;
  }
  //result=rs->Plunion();
  result=rs->lunion();
  delete ps1;
  delete rs;
  return result;
}
/*
TList * gremainderset_wdk(TList *ps, TList *as, TList  *ord)
{
  TList * rs =new TList(),*result;
  TRIPoly *p;
  int i,l=ps->length();
  if (l==0) return rs;
  for (i=1;i<=l;i++)
    {
    p=gpremas_wdk((TRIPoly *) (ps->Part(i)),as,ord);
    if (! (p->IsZero())) {
      if (class_wdk(p,ord)==0) {delete p;delete rs; return Getp1list();}
      rs->append((TAtom *)(p->Copy()));
      delete p;
    }
    else 
      delete p;
  }
  result=rs->Plunion();
  delete rs;
  return result;
}
*/

//-------------------------


//ps is a polynomial set
//ord is a variable list
//nonzero is a polynomial set
// here we suppose every polynomial is irreducible over rational field Q.
// if there are more than one polynomial with class = 1 , then return empty set;
// if the intersection of ps and nonzero is NOT empty, then return empty set;
// if remainder set is empty, then return basic set;
// if remainder set is a set with one polynomial =1 , then return empty set;
// if remainder set is not empty, then give all possible combinations rset=rs1,rs2,...,rsn.
// and for each ps= bs union rs_i , return union ( csa_wdk(ps) );    

TList * csa_wdk(TList * ps, TList *ord, TList * nonzero, char cs_type)
{
  TList * returnlist=new TList (),* checklist, *bset=0,*rset, *ulist,*rsets,*csets,*tmp_returnlist;
  int i,l;
//	wout<<"\n in csa------------------\n";
/*  if (nums_wdk(ps,ord) >1) { wout<<"\n numbers of class 1 >1\n"; 

  } 
*/
  if (nums_wdk(ps,ord) >1) return returnlist;
  checklist=ps->Intersect(nonzero);
  if (checklist->length() !=0) {delete checklist; return returnlist;}
  delete checklist;

  if (empty_set(ps,nonzero,ord)) { return returnlist; }



//  if(cs_type==10) bset=basicset_cs(ps,ord);
//  if (!bset) bset=basicset_wdk(ps,ord);
//  rset=remainderset_wdk(ps,bset,ord);
  switch(cs_type) {
  case 10:
	  bset=basicset_cs(ps,ord);
	  rset=remainderset_wdk(ps,bset,ord);
	  if (bset) break;
	  delete rset;
	  bset=gbasicset_wdk(ps,ord);
	  rset=gremainderset_wdk(ps,bset,ord);

	  break;
  case 20:
	  bset=gbasicset_wdk(ps,ord);
	  rset=gremainderset_wdk(ps,bset,ord);

	  break;
  case 0:
	  bset=basicset_wdk(ps,ord);
	  rset=remainderset_wdk(ps,bset,ord);

	  break;
  default :
	  bset=gbasicset_wdk(ps,ord);
	  rset=gremainderset_wdk(ps,bset,ord);
  }



  wout<<"\n ps="<<endl;
  ps->display();
  wout<<"\n bs="<<endl;
  bset->display();
  wout<<"\n rs="<<endl;
  rset->display();
  wout<<endl;



  if (rset->length() ==0)  { 
    wout<< " A New Component !\n"; 
	wout<<endl;
    delete rset; 
    returnlist->append((TAtom *) bset); 
//    returnlist->display();
    return returnlist;
    }
//  wout <<"111"<<endl;

  if (Listisp1(rset)) {
	wout<<" \n Contradiction Set \n";wout<<endl;wout<<endl;
    	delete rset; delete bset; return returnlist;}
/*    wout<<"rset=";
    rset->display();
    wout<<endl;

  wout <<"222"<<endl;
*/
  rsets=nrs_wdk(rset,ord);
//  wout<<"\n rsets="<<endl;
//  rsets->display();
//  wout<<"333"<<endl;
//  wout<<endl;  
  
  //  wout<<"length="<<rsets->length()<<endl<<"rsets=";
  //  rsets->display();
  //  wout<<endl;
  delete rset;
  l=rsets->length();
 // for (i=1;i<=1;i++)
  for (i=1;i<=l;i++)
    { 
      ulist=bset ->Union( (TList *) (rsets->Part(i)));
      csets=csa_wdk(ulist,ord,nonzero,cs_type);
      delete ulist;
      tmp_returnlist=returnlist;
      returnlist=tmp_returnlist->Union(csets);
      delete tmp_returnlist;
      delete csets;
    }

  delete bset;
  delete rsets;
  
//  wout<<"end if";
  return returnlist;
}


//ps is a polynomial set;
//ord is a variable list;
//nonzero is a polynomial set;
// To set the returnlist to empty;
// cset1= csa_wdk(ps);
// for every ascending set as, compute rs= RS(ps,as), if rs is empty, then append as to the returnlist;
// if  rs is NOT empty, then form a list of polynomial set, psets=pnrs(ps,rs,ord);
// append csc_(pset,ord,nonzero) to the returnlist;
// return the result=returnlist; 

TList *  csb_wdk(TList * ps, TList *ord, TList *nonzero,char cs_type)
{
  TList * csets1,*csets2,*bs, *rs,*psets,*tmplist, *pstmp, *returnlist=new TList();
  int i,l;
  //  wout<<"inside cssub2 \n";

  csets1=csa_wdk(ps,ord,nonzero,cs_type);


  //  wout<<"csets1=";
  //  csets1->display();
  l=csets1->length();
  //  wout<<"l="<<l<<endl;
  if (l==0) {delete csets1;return returnlist;}
  for (i=1;i<=l;i++){
    bs=(TList *) (csets1->Part(i));
    rs=remainderset_wdk(ps,bs,ord);
    //    wout<<"rs=";
    //    rs->display();
    
    if (rs->length() ==0) { 
      returnlist -> append( (TAtom *) bs->Copy()); 
      //      wout<<"inside if \n";
      //      returnlist->display();
      delete rs;}
    else{
    //    wout<<"outside if\n";
    pstmp=ps->Union(bs);
//wout<<"pstmp";pstmp->display();wout<<endl;
    psets=pnrs_wdk(pstmp,rs,ord);
//wout<<"psets";psets->display();wout<<endl;
    delete pstmp;
    delete rs;
    csets2=csc_wdk(psets,ord,nonzero,cs_type);
    tmplist=returnlist;
    returnlist = tmplist->Union(csets2);
    delete psets;
    delete csets2;
    delete tmplist;
    }
  }
  delete csets1;
  return returnlist;
}

// pss is a list of polynomial set;
// ord is a variable list 
// nonzero is polynomial set;
// for every polynomial set in pss, call csb_wdk to get the result
// return the union csb(pss)

TList * csc_wdk( TList *pss,TList *ord, TList *nonzero,char cs_type)
{
  TList *csets,*tmplist, *returnlist=new TList();
  int i,l;
  l=pss->length();
  if (l==0) return returnlist;
  for(i=1;i<=l;i++){
    csets=csb_wdk(((TList *) (pss->Part(i))) ,ord,nonzero,cs_type);
    tmplist=returnlist;
    returnlist=tmplist->Union (csets);
    delete csets;
    delete tmplist;
  }
  return returnlist;
}

// ps is a polynomial set;
// ord is a variable list;
// nonzero is a polynomial set;
// let pss= nrs(ps,ord);  // nrs will factor all the polynmial in ps over Q,
//			  // delete all the constant factors
//			  // form a list of polynomial set;
// return csc_wdk(pss,ord,nonzero)

TList * cs_wdk( TList *ps, TList *ord, TList * nonzero, char cs_type)
{
  TList *pss,*csets,*nzero;
  pss=nrs_wdk(ps,ord);
  nzero=realfac_wdk(nonzero,ord);
  csets=csc_wdk(pss,ord,nzero, cs_type);
  delete nzero;
  delete pss;
  return csets;
}
  
// bs is an ascending set
// ord is a variable list
// return the non-constant factors of the initials of the polynomials in bs
TList * inits_wdk(TList *bs, TList *ord)
{
  TList * returnlist=new TList(),*initlist,*tmplist;
  TRIPoly *p;
  int i,l;
  l=bs->length();
  for(i=1;i<=l;i++)
    { p=initial_wdk( (TRIPoly *) bs->Part(i),ord);
      if (class_wdk(p,ord) !=0) 
	{ initlist=nonumfactors_wdk(p,ord);
	  tmplist=returnlist;
	  returnlist=tmplist-> Union (initlist);
	  delete initlist;
	  delete tmplist;
	}
      delete p;
    }
  return returnlist;
}



// bs is an ascending set
// ord is a variable list
// return the factors with class >1 of the initials of the polynomial in bs
TList * inits1_wdk(TList *bs, TList *ord)
{
  TList * returnlist=new TList(),*initlist,*tmplist;
  TRIPoly *p;
  int i,l;
  l=bs->length();
//  if (l > 1) {
    for(i=1;i<=l-1;i++)
      { p=initial_wdk( (TRIPoly *) bs->Part(i),ord);
	if (class_wdk(p,ord) >1) 
	  { initlist=highclassfactors_wdk(p,ord);
	    tmplist=returnlist;
	    returnlist=tmplist-> Union (initlist);
	    delete initlist;
	    delete tmplist;
	  }
	delete p;
      }
//  }
  return returnlist;
}

// bs is an ascending set;
// ord is a varialbe list;
// return the appended factors of bs
TList *asinitlist_wdk(TList *bs, TList *ord) 
{ 
  if (class_wdk((TRIPoly *) bs->Part(bs->length()),ord) ==1) {return inits1_wdk(bs,ord);}
  return inits_wdk(bs,ord);
}


// bs is an ascending set;
// ord is a variable list;
// bs=[a1,a2,...,an]; a1>a2>....>an;
// if class(an,ord)=1, then return a list of all the factors of the initials of a1,...,a_(n-1);
//			//because in this case, the class of  an's initial is zero; 
// if class(an,ord)>1, then return a list of all the factors of the initials of a1,...,a_n.
/*
TList * asinitlist_wdk(TList *bs, TList *ord)
{
  TList * returnlist=new TList(),*initlist,*tmplist;
  TRIPoly *p;
  int i,l,m;
  l=bs->length();
  if (class_wdk( (TRIPoly *) bs->Part(l),ord) ==1) m= l-1 ; else m=l;

    for(i=1;i<=m-1;i++)
      { p=initial_wdk( (TRIPoly *) bs->Part(i),ord);
	if (class_wdk(p,ord) !=0) 
	  { initlist=nonumfactors_wdk(p,ord);
	    tmplist=returnlist;
	    returnlist=tmplist-> Union (initlist);
	    delete initlist;
	    delete tmplist;
	  }
	delete p;
      }


  return returnlist;
}
*/

						   
// ps is a polynomial set;
// as is an ascending set;
// ord is a variable list;
// nonzero is a polynomial set;
// since RS(ps,as,ord)=NULL, for each I_i in as we will to get the zero decompostion
// zero({ps,as,I_i} /nonzero)
// return Union zero({ps,as,I_i} /nonzero) for I_i is the factor of the initials in as

TList * cssa_wdk(TList *ps,TList *as, TList *ord, TList *nonzero,char cs_type)
{
  TList *initlist,*pset1,*pset,*css,*tmplist,*nonzeros,*nontmp,*returnlist=new TList();
  TRIPoly *p;
  int i,l;
//  wout<<"in CSSA----------------*\n";
//  wout<<"before asinitlist\n";
  initlist=asinitlist_wdk(as,ord);
  //pset1=initlist->PMinus(nonzero);
  pset1=initlist->Minus(nonzero);
  delete initlist;
  initlist = pset1;

//  G_OUT("initlist=", initlist);

  l=initlist->length();
  if(l==0) {delete initlist;return returnlist;}
  nonzeros=(TList *)nonzero->Copy();

  if (cs_type==10) pset1 = (TList*)(ps->Copy());
  else pset1=ps->Union(as);

  for (i=1;i<=l;i++){
    p=(TRIPoly *) initlist->Part(i);
    //G_OUT("1:",pset1);
    //G_OUT("2:",p);
	if (cs_type==10) 
	{pset=p_append(pset1,p,ord);}
	else
	{pset=pset1->sappend( (TAtom *)p);}
	//G_OUT("3:",pset);
    //    wout<<"ps=";pset->display();wout<<endl;
    tmplist=returnlist;
    css=cssb_wdk(pset,ord,nonzero,cs_type);
    delete pset;
    returnlist=tmplist->Union (css);
    delete tmplist;
    delete css;
    nontmp=nonzeros;
    nonzeros=nonzeros->sappend(p);
    delete nontmp;
  }
  delete initlist;
  delete pset1;
//  G_OUT("1",ps);
  delete nonzeros; 
//  wout<<"out CSSA--------------*\n";
  return returnlist;
}

//presevre ps
TList * p_append(TList *ps, TRIPoly*p, TList* ord)
{
  int d1, len = ps->length();
  TList * tl = new TList();
  TRIPoly *p1,*p2, *ip, *p3, p4;
  TVariable  *v1;

  for (int i=1; i<=len;i++)
  { p1 = (TRIPoly*) ps->Part(i)->Copy();
    ip = initial_wdk(p1,ord);
   	p2 = prem_wdk(ip,p,mainvar_wdk(p,ord));
	if (p2->IsZero())
	{ v1 = mainvar_wdk(p1,ord),
	  d1  =  p1->Degree(v1);
	  p3 = get_mv(v1,d1); 
	  p4 = (*p1) - ((*ip) * (*p3));
	  //wout <<"4:"; p4.display();
	  if (!p4.IsZero()) tl->append((TAtom*) (new TRIPoly(p4)));
	  delete p1;
	  delete p3;
	}
	else 
		tl->append((TAtom*)(p1));
	delete ip;
	delete p2;
  }
  tl->append((TAtom*)(p->Copy()));
//  delete ps;
  return tl;
}

//ps is a polynomial set (every polynomial in ps is irreducible over Q)
//ord is a list of variable
//nonzero is a polynomial set;
//        //call csets=csb_wdk(ps)  to get a list of ascending set;
// for polynomial set ps, to get the zero decomposition Zero(ps/nonzero) = Union (as_i/{I_i,nonzero}) 
//                                                      as_i is in returnlist;
TList * cssb_wdk(TList *ps, TList *ord, TList *nonzero,char cs_type)
{
  TList *csets,*css,*as,*tmplist,*returnlist;
  int i,l;
//  wout<<"**********in CSSB\n";
  csets=csb_wdk(ps,ord,nonzero,cs_type);
  //G_OUT("cset=",csets);

  returnlist=(TList *)csets->Copy();
  l=csets->length();
  if(l==0) {delete csets;return returnlist;}
  for(i=1;i<=l;i++){
    as=(TList *) csets->Part(i);
    tmplist=returnlist;
    css=cssa_wdk(ps,as,ord,nonzero,cs_type);
    returnlist=tmplist->Union(css);
    delete tmplist;
    delete css;
  }
  delete csets;
//  wout<<"************out CSSB\n";
  return returnlist;
}

#define NUM_POLY(p)  ((p)->var==0))

bool empty_set(TList *ps, TList *ds,TList *ord)
{
 TList *ls1, *ls=new TList;
 TRIPoly* p1, *ip;
 bool re = false;
 for (int i=1;i<=ps->length(); i++)
 { p1=(TRIPoly*) ps->Part(i);
   ip = initial_wdk(p1,ord);
   if (class_wdk(ip,ord)==0) ls->append((TAtom*) (p1->Copy()));
   delete ip;
 }
 ls1 = basicset_wdk(ls,ord);
 delete ls;
 for (i=1;i<=ds->length(); i++)
 { 
	 p1=premas_wdk((TRIPoly*) ds->Part(i),ls1,ord);
     if (p1->IsZero()) { re = true; delete p1; break; }
	 delete p1;
 }
 delete ls1;
// if (re) {wout <<"An empty set is deleted.\n"; }
 return re;
}

// pss is a list of polynomial set;
// ord is a variable list 
// nonzero is a polynomial set;
// for every polynomial set in pss, call csb_wdk to get the result
// return the union cssb(pss)

TList * cssc_wdk( TList *pss,TList *ord, TList *nonzero,char cs_type)
{
  TList *csets,*tmplist, *returnlist=new TList();
  int i,l;
  l=pss->length();
  if (l==0) return returnlist;
  for(i=1;i<=l;i++){
    csets=cssb_wdk(((TList *) (pss->Part(i))) ,ord,nonzero,cs_type);
    tmplist=returnlist;
    returnlist=tmplist->Union (csets);
    delete csets;
    delete tmplist;
  }
  return returnlist;
}


// ps is a polynomial set;
// ord is a variable list;
// nonzero is a polynomial set;
// let pss= nrs(ps,ord);  // nrs will factor all the polynmial in ps over Q,
//			  // in nrs, all the constant factors are deleted.
//			  // form a list of polynomial set;
// return csc_wdk(pss,ord,nonzero)

TList * css_wdk( TList *ps, TList *ord, TList * nonzero, char cs_type)
{
  TList *pss,*csets,*as, *nzero, *res=new TList();
  pss=nrs_wdk(ps,ord);
 
  nzero=realfac_wdk(nonzero,ord);

  csets=cssc_wdk(pss,ord,nzero,cs_type);

 
  int l=csets->length();

  for (int i=1;i<=l;i++){
	as=(TList *)csets->Part(i);
	if (degenerate_wdk(nonzero,as,ord)==0) {
	   res->append( (TAtom *) as->Copy());
		}
	};

//  delete res;
  delete nzero;
  delete pss;
  delete csets;
  return res;
//  return csets;
}

  

int degenerate_wdk(TList *nonzero, TList *as, TList *ord)
{
	int l1;
	TRIPoly *p=0;
	l1=nonzero->length();
	for (int i=1;i<=l1;i++)
	{ p=premas_wdk((TRIPoly *)nonzero->Part(i),as,ord);
	if (p->IsZero()) {delete p; return 1;}
	if (p) delete p;
	}

	return 0;
}

//##############The following is for geometric theorem proving
// suppose ps:={p1,p2} p1,p2 is in the following form,
// p1:=a*x+b*y+c;
// p2:=c*x+d*y+e;

TList * elimxy_wdk(TList *ps, TList *ord)
{
	TList *elimxy;
	TRIPoly *p1,*p2;
	int c1;
	c1=class_wdk((TRIPoly *)ps->Part(1), ord);
	p1=prem_wdk((TRIPoly *)ps->Part(2),(TRIPoly *)ps->Part(1),(TVariable *)ord->Part(ord->length()-c1+1));
	p2=prem_wdk((TRIPoly *)ps->Part(2),(TRIPoly *)ps->Part(1),(TVariable *)ord->Part(ord->length()-c1+2));

    elimxy=new TList((TAtom *)p1->Copy(),(TAtom *)p2->Copy());
	delete p1;
	delete p2;
	return elimxy;
}