/* 
Part 1. Differentiation 
This is part  written according to Li Ziming's Maple Program.
*/
#include "basetype.h"
#include "stacks.h"
#include "global.h"
#include "lists.h"
#include "poly.h"
#include "pol.h"
#include "sysfunc.h"
#include "charset.h"
#include "nvar.h"
//#include "fwang.h"
//#include "lists_cs.h"
#include "shortlist.h"
#include "check.h"

#include "wsolve.h"
#ifdef _WINDOWS
#include "..\gui\index.h"
#endif
//extern TList *depend_relation;
int depend_wdk(TList * x, TList *t)
{
 /*	if ( depend_relation->length() !=0 &&
		 (TList*)(depend_relation->Part(1) ) {
	wout<< " Warning: redefine depend_relation will cause some confusion some times"<<endl;
	}
 */
    delete depend_relation;
	depend_relation = new TList((TAtom *) x->Copy(), (TAtom *) t->Copy() );
	return 1;
}

//added by xfchen
int depend_chen(TList *x)
{
	if(depend_relation->length()==2&&((TList *)(depend_relation->Part(1)))->length()!=0)	
	{
		TList *vars=(TList *)(depend_relation->Part(1)->Copy());
		depend_relation->dremove(1);
		depend_relation->dinsert((TAtom *)(vars->Union(x)),1);
		delete vars;
		return 1;
	}
	return 0;
}
// END (added by xfchen)


VAR * diff_var( VAR * mvar0, VAR *v);
TRIPoly * diff_dpol(TRIPoly *dp, TVariable * v);

/*
TRIPoly * DF_wdk(TRIPoly *dp, TVariable * var)
{
 return diff_dpol(cp_TRIPoly(dp), var); 	
}
*/

TRIPoly * diff_dpol(TRIPoly *dp, TVariable * v)
{
	TRIPoly *cp, *p1;
	VAR *v1;
	POLS  pst, *ps1, *ps2;

	//G_OUT("in:",dp);
	if (dp->IsBigInt()) { delete dp; return new TRIPoly(); }
    
	cp = cp_TRIPoly(dp);
    pst.nx = cp->ups;
	for(ps1 = &pst, ps2=ps1->nx; ps2 ;)
	{ 
	  ps2->p = diff_dpol(ps2->p,v);
	  if (ps2->p->IsZero())
	  { ps1->nx = ps2->nx;
	    delete ps2->p; 
		delete ps2;
	  }
	  else ps1 = ps2;
      ps2 = ps1->nx;
	}
	cp = psimp(cp,pst.nx);
    //G_OUT("cp:",cp);
   
   //G_OUT("v :",v);
   v1 = diff_var(dp->var,v);
   if (v1==0)	{ delete dp; return cp; }
   //G_OUT("v1:",v1);
   for(ps1=dp->ups;ps1;ps1=ps1->nx) 
	{ if (ps1->deg==0) 
		{ delete ps1->p;
		  delete ps1;
		  ps2 ->nx = 0;
		  break;
		}
	    p1 = ptimes(get_n(ps1->deg), new TRIPoly(v1,1));
		ps1->p = ptimes(p1,ps1->p);
		ps1->deg = ps1->deg - 1;
		ps2 = ps1;
	  }
    dp = psimp(dp,dp->ups); 
    //G_OUT("dp:",dp);
	return pplus(cp,dp);
}

VAR * diff_var( VAR * mvar0, VAR *var)
{
    TList * Diff_var,*Diff_indets;
	int Lvar,position;
	TVariable *der;
	TVariable *mvar,*mvar_1;
	TShortList * index,*index_0,*index_1;


	Diff_var=(TList *)depend_relation->Part(2);
    Diff_indets=(TList *)depend_relation->Part(1);
    Lvar=Diff_var->length();

	//wout<<"indet=";indet->display();cout<<endl;
	//TVariable * mvar0= indet->MainVar();

	der=(TVariable *) ( getname(mvar0))->Copy();
	mvar=der;
//	wout<<"mvar=";mvar->display();wout<<endl; 

     	//if (! member( (TAtom *) mvar, Diff_indets) ||
			//! member( (TAtom *) var, Diff_var) )
	    if (Diff_indets->find((TAtom *) mvar)==NULL||
			Diff_var->find((TAtom *) var)==NULL)
		{ return 0; }
 
	index_0=getlist(mvar0);
    if (index_0==NULL) 
	{
//	wout<<"lkjasdhfalsjfd"<<endl;
	 index=new TShortList(Lvar);
//	 wout<<"index="; index->display();wout<<endl;
	}
	else
	{index=(TShortList *) index_0->copy();}

	//position=member((TAtom *) var, Diff_var);
	position=Diff_var->findindex((TAtom *) var);
//	wout<<"index=";index->display(); wout<<endl;

	index_1=add_i(position,index);
//	wout<<"index_1=";	index_1->display(); wout<<endl;

	mvar_1=formvar(der,index_1);
 //   wout<<"mvar_1=";mvar_1->display();wout<<endl;

	if(index_0) delete index_0;
 	delete index;
	delete index_1;

	return mvar_1;
}


TRIPoly * DF_wdk(TRIPoly *dp, TVariable * var)
{
int terms_len;
TList * terms;
TRIPoly dpol;
TRIPoly *dq;
TRIPoly *dprod;

//   wout<<"in DF_wdk"<<endl;1
//   wout<<dp->PolyRoot()<<endl;
//   int c= strcmp( dp->PolyRoot() , "+") ;

// strcmp(char *s1, char *s2) 
// if s1=s2 return 0;

   if ( strcmp( dp->PolyRoot() , "+") ==0 )
   {
	   //#Step [Recursion]
//	     wout<<"in222222222222 +"<<endl;
		 terms=dp->PolyArgs();
         terms_len=terms->length();
/*		 wout<<"terms=";
		 terms->display();
		 wout<<endl;
*/
		 
		 for (int i=1;i <= terms_len;i++)
			   {dprod= DF_wdk(  (TRIPoly * ) terms->Part(i) , var);
				dpol= dpol + (*dprod);
				delete dprod;
			   }
 dq=new TRIPoly (dpol);

	delete terms;
   }
   else
//#Step [Recursive base]
   {
			  dq=DF_prod_wdk(dp,var);
   }
//#Step3 [Prepare for return]
    return dq;
  
}



/*




#------------------------------------------
# subroutines
#------------------------------------------


#========================================================= 
#
#
#                der <- DF_indet(indet, var)
#      
#           (differentiate a differential indeterminante)
#
#   Input: indet, a differential indeterminate which is a
#                 derivative of symobls in Diff_Indets w.r.t
#                 some variables in Diff_Var;
#
#          var,   the variable w.r.t which to be differeniated
#
#   Output: der,  the derivative of indet w.r.t var
#
#=========================================================== 
*/

TShortList * add_i(int i, TShortList * oldlist)
{

TShortList * newlist= oldlist->copy();
if(i>oldlist->length() || i<0)  wout << "out of range" <<endl;
newlist->modify(i, oldlist->get(i)+1);
return newlist;
}


TRIPoly * DF_indet_wdk(TRIPoly * indet, TVariable * var)
{   TList * Diff_var,*Diff_indets;
	int Lvar,position;
    TRIPoly * dp;
	TVariable *der;
	TVariable *mvar,*mvar_1;
	TShortList * index,*index_0,*index_1;


	if ( indet->IsBigInt()) 
		{
		return new TRIPoly();}

	Diff_var=(TList *)depend_relation->Part(2);
    Diff_indets=(TList *)depend_relation->Part(1);
    Lvar=Diff_var->length();
//wout<<"indet=";indet->display();cout<<endl;
	TVariable * mvar0= indet->MainVar();

//	if(mvar0) {wout<<"mvar0=";mvar0->display();wout<<endl; }

	der=(TVariable *) ( getname(mvar0))->Copy();
	mvar=der;
//	wout<<"mvar=";mvar->display();wout<<endl; 

     	//if (! member( (TAtom *) mvar, Diff_indets) ||
			//! member( (TAtom *) var, Diff_var) )
		if (Diff_indets->find((TAtom *)mvar)==NULL ||
			Diff_var->find((TAtom *)var)==NULL)
		{ dp=new TRIPoly(indet->derivative(var));
// 			delete mvar;
			return dp;}
//  wout<<"mvar0=";mvar0->display();wout<<endl; 
 
	index_0=getlist(mvar0);
 

    if (index_0==NULL) 
	{
//	wout<<"lkjasdhfalsjfd"<<endl;
	 index=new TShortList(Lvar);
//	 wout<<"index="; index->display();wout<<endl;
	}
	else
	{index=(TShortList *) index_0->copy();}

	//position=member((TAtom *) var, Diff_var);
	position=Diff_var->findindex((TAtom *)var);
//	wout<<"index=";index->display(); wout<<endl;

	index_1=add_i(position,index);
//	wout<<"index_1=";	index_1->display(); wout<<endl;

	mvar_1=formvar(der,index_1);
 //   wout<<"mvar_1=";mvar_1->display();wout<<endl;

	dp=new TRIPoly(mvar_1,1);


//	delete mvar0;
//	delete mvar;
//	delete mvar_1;
	if(index_0) delete index_0;
 	delete index;
	delete index_1;

	return dp;

}


 

/*
#========================================================
#
#           dq <- DF_power(dp, var)
#
#           (differentiating a power of a drivative of a diff indet)
#
#           input:  dp, a power of a diff indet
#                   var, the variable w.r.t which to be differentiated
#
#           output: dq, the result after differentiating dp w.r.t var
#
#=========================================================
*/


TRIPoly * DF_power_wdk( TRIPoly * dp, TVariable *var)
{
	TRIPoly *dq;
    TRIPoly * indet_m;
	TRIPoly *dp1;
	TBigInt   expon_m;
	TList * list_m;
	TRIPoly dpol;

//	wout<<"in DF_power_wdk"<<endl;
	if ( dp->IsBigInt()) 
		{return new TRIPoly();}

	if ( strcmp( dp->PolyRoot(),"^")==0 )
	{   list_m=dp->PolyArgs();

/*	    wout<<"list_m=";
		list_m->display();
		wout<<endl;
*/
		indet_m=(TRIPoly *) list_m->Part(1);
		expon_m= * ((TBigInt *) list_m->Part(2));
//		indet_m->display();
        
//		wout<<"deg="<<expon_m<<endl;

		
        dp1=DF_indet_wdk(indet_m,var);
		dpol=  TRIPoly(expon_m)*((*indet_m)^((expon_m).GetShort(0)-1)) *(*dp1);
	    dq= new TRIPoly (dpol);
 		delete list_m;
		delete dp1;

	}
		else {dq=DF_indet_wdk(dp,var);}
return dq;
}

/*
#=========================================================
#
#        dq <- DF_prod(dp, var)
#
#        (differentiating a product of derivatives of some diff indets)     
#
#        input: dp, a product of derivatives of some diff indets  
#               var,  the variable w.r.t which to be differentiated
#
#        output:  dq, the result after differentiating dp w.r.t var;
#
#==========================================================
*/

TRIPoly * DF_prod_wdk( TRIPoly *dp, TVariable *var)
{	TRIPoly dp1_m,dp2_m , dpol;
	TRIPoly *dpower;
	TList * list_m;
	TRIPoly * dq;
 //  wout<<"in DF_prod_wdk"<<endl;

	int list_l;

	if ( strcmp( dp->PolyRoot() ,"*")==0)

	{   list_m=dp->PolyArgs();
		list_l=list_m->length();
		for (int i=1;i<=list_l;i++)
		{		dpower=DF_power_wdk( (TRIPoly *) list_m->Part(i),var);
		    	dp1_m=*dpower;
			for (int j=1;j<=list_l;j++)
			  {
				if (j != i )
			    dp1_m=dp1_m* (* (TRIPoly *) list_m->Part(j));}

			
		    dpol=dpol+dp1_m;


			delete dpower;			
		}
		  delete list_m;

		  dq=new TRIPoly (dpol);
	
	}
		else {dq=DF_power_wdk(dp,var);}
return dq;
}



