#include "basetype.h"
#include "stacks.h"
#include "global.h"
#include "lists.h"
#include "poly.h"
#include "pol.h"
#include "sysfunc.h"
#include "charset.h"
//#include "fwang.h"
///#include "lists_cs.h"
#include "shortlist.h"
#include "nvar.h"
#include "wsolve.h"
#include "check.h"
#ifdef _WINDOWS
#include "../gui/index.h"
#endif
//extern TList  *depend_relation;

/*
#The following program  is written in  Maple V realease 3. 
#The following package <<wsolve>> is for solving systems of polynomial equations.
#The main algorithm  is based on Wu's method. 
#Polynomial factorization over rational field is used to reduce the sizes of the polynomials produced in the Well-Ordering process.


#------------------------------------------------------------
#Part I: <<wsolve>> for solving systems of polynomial equations
#------------------------------------------------------------

readlib(factors):
*/

// if dp is a constant or dclass(dp)=0; should be tested;
TRIPoly * dDiff_wdk(TRIPoly *dp, TVariable *var,int n)
{ TRIPoly * dq1, *dq;
  dq=(TRIPoly *)(dp->Copy());
  if (n==0) {return dq;}
  for (int i=1;i<=n;i++) {
	dq1= DF_wdk(dq,var);
	delete dq;
	dq=dq1;
  }
  return dq;
}


// if dp is a constant or dclass(dp)=0; should be tested;
/*
dp is a polynomial
return the variable list
for example dp=x+x[1]+x[2]+y[3];
then return [x,y] , x,y is class of TVariable
*/

TList * dIndets_wdk(TRIPoly * dp)
{
	TList *vlist1,*vlist2=new TList(),*vlist3;
    vlist1=dp->getVL();


	int vlen=vlist1->length();
//	vlist3=vlist2;
	for (int i=1;i<=vlen;i++)
	{
//	   TVariable *vv= ((TVariable *) (vlist1->Part(i)))->GetVar() ;
       //TVariable *vv1=new TVariable(vv);
		TVariable *vv1=getname( (TVariable *) (vlist1->Part(i)));
//	   vlist2=vlist3;
	   vlist2->append( (TAtom *) vv1);
//	   delete vlist2;
//	   delete vv1;


	}
	vlist3=vlist2->lunion();
	delete vlist2;
	delete vlist1;


    return vlist3;
}

// if dp is a constant or dclass(dp)=0; should be tested;
TList *AIndets_wdk(TRIPoly *dp)
{
	return dp->getVL();
}

// if dp is a constant or dclass(dp)=0; should be tested;
int dClass_wdk(TRIPoly * dp, TList * ord)
{

	TList * indet_d;
	int ord_l=ord->length();
    int cls=0;
    if (dp->IsZero() || dp->IsBigInt()) {return 0;}
	indet_d=dIndets_wdk(dp);

	for (int i=1;i<=ord_l;i++)
	{ //if (member( (TAtom *) ord->Part(i), indet_d)) 
      if (indet_d->find((TAtom *) ord->Part(i))!=NULL)

	{ cls= ord_l-i+1;delete indet_d;return cls;}

	}
	delete indet_d;
	return cls;

}

// if dp is a constant or dclass(dp)=0; should be tested;
int dClass_wdk(TVariable *mvar,TList *ord)
{
//	int pol;
	int cls;
//	TRIPoly  pol=TRIPoly(mvar,TBigInt(1));
	TRIPoly  pol=TRIPoly(mvar,1);
	TRIPoly *dp=new TRIPoly(pol);
//	pos=member((TAtom *)mvar,ord);
//	if (pos==0) { return 0; } else {return ord->length()-pos+1;}
	cls=dClass_wdk(dp,ord);
	delete dp;
	return cls;

}


// if dp is a constant or dclass(dp)=0; should be tested;
// if l1=l2, return 0;
// if l1<l2, return -1;
// if l1>l2,return 1;

int dRanklist_wdk(TShortList *l1,TShortList *l2)
{   int d;
	d=0;
    if (l1==NULL &&l2==NULL) d= 0;
		else if (l1==NULL) d= -1;
		else if (l2==NULL) d= 1;
	    else 
	    for(int i=1;i<=l1->length();i++){
		  if (l1->get(i) > l2->get(i)) {d=1;break;}
		  if (l1->get(i) < l2->get(i)) {d=-1;break;}		
		}
		return d;
}
	
		   
		  
// if dp is a constant or dclass(dp)=0; should be tested;
//if the main variable of dvar1, dvar2 is the same,
//then call this function to compare the diff part.
// if dvar1=dvar2, return 0;
// if dvar1<dvar2, 
int dRankvar_wdk(TVariable *dvar1, TVariable *dvar2)
{
	TShortList *l1,*l2;
	int res;
//	l1=dvar1->GetDL();
//	l2=dvar2->GetDL();
	l1=getlist(dvar1);
	l2=getlist(dvar2);
	res=dRanklist_wdk(l1,l2);
	delete l1;
	delete l2;
	return res;



}

// if dp is a constant or dclass(dp)=0; should be tested;
TVariable *dMainvar_wdk(TRIPoly *dp,TList *ord)
{   TVariable *mvar;
	int dcls=dClass_wdk(dp,ord);
	mvar= (TVariable *) ord->Part(ord->length()-dcls+1);
	return (TVariable *)( mvar->Copy());
}

// if dp is a constant or dclass(dp)=0; should be tested;
// 
TVariable * dLeader_wdk(TRIPoly * dp, TList * ord)
{	int cls,vcls,tord,vtord;
	TShortList * l1,*l2;
	int len;
	TVariable *mvar,*var,*mainv;
 
	TList * idt=AIndets_wdk(dp);

	mvar=(TVariable *)idt->Part(1);
	cls=dClass_wdk(mvar,ord);
	tord=tOrder_wdk(mvar);

//	l1=mvar->GetDL();
	l1=getlist(mvar);
	len=idt->length();

//  POLY_MODE should be considered also;

    for (int i =1;i<=len;i++)
	{ 

		var=(TVariable *) idt->Part(i);

		l2=getlist(var);

	    vcls=dClass_wdk(var,ord);
		vtord=tOrder_wdk(var);
		int RANKING_MODE=1;
	    switch (RANKING_MODE)
		{
		case 1:			
			if ( vcls > cls || (vcls==cls && vtord > tord) ||
				(vcls==cls && vtord == tord && dRanklist_wdk(l2,l1)==1) )		
				{mvar=var;
//		 l1=mvar->GetDL();
				delete l1;
				l1=l2;
				cls=vcls;
				tord=vtord;
				}

			else {
				delete l2;
				}
			break;

		case 2:

			if ( vtord > tord || (vtord==tord && vcls > cls) ||
					(vcls==cls && vtord == tord && dRanklist_wdk(l2,l1)==1) )		
				{mvar=var;
//		 l1=mvar->GetDL();
				delete l1;
				l1=l2;
				cls=vcls;
				tord=vtord;
				}
			else {
				delete l2;
				}
			break;
		}			    

	}

    delete l1;
	mainv=(TVariable *)mvar;

delete idt;

return mainv;

}
	


int tOrder_wdk(TVariable * var)
{
	int i,ord,len;
	TShortList *sl;
 	  ord=0;
 	  sl=getlist(var);
	  if (sl==NULL) {return ord;}
 	  len=sl->length();
 	  if (len==0){ return ord;}
	  for(i=1;i<=len;i++)
	  { ord=ord+sl->get(i);
	  }
	delete sl;
	return ord;
}

TShortList * dOrder_wdk(TVariable *mvar,TVariable *var)
{
	TShortList *l;
	TRIPoly *dp;
	dp=new TRIPoly(mvar);
	l=dOrder_wdk(dp,var);
	delete dp;
	return l;

}

int dtOrder_wdk(TRIPoly *dp,TVariable *var)
{
	int i,n=0,len;
	TShortList * d_order;

	d_order=dOrder_wdk(dp,var);
	if (d_order==NULL){n=0;}
	else { 
		len=d_order->length();
		for (i=1;i<=len;i++)
		{
			n=n+d_order->get(i);
		}	       
	}
	delete d_order;
	return n;
}

TShortList * dOrder_wdk(TRIPoly *dp,TVariable *var)
{     
	  TList * inds;
	  TVariable * mvar;
	  TVariable *der,*var0;
	  TShortList *sl1,*sl0;
//      if( degree_wdk(dp,var) !=0) {order=0;}

//	  var0=var->GetVar();
	  var0=getname(var);
//	  sl0=var->GetDL();
	  sl0=getlist(var);


	  inds=AIndets_wdk(dp);
	  
	  int l=inds->length();

//	  cout<<"inds=";inds->display();cout<<endl;

	  for(int i =1;i<=l;i++)
	  { mvar=(TVariable *) inds->Part(i);
//	    der=mvar->GetVar();
//		sl1=mvar->GetDL();
	    der=getname(mvar);
		sl1=getlist(mvar);

		if (der==var0 && dRanklist_wdk(sl1,sl0)==1) 
		{    var0=der;
			 delete sl0;
			 sl0=sl1;
//			 order=sl0->get(1);
		}
		else
		{
			delete sl1;
		}
	  }
//	  delete sl0;
	  delete inds;
return sl0;
}





  

TRIPoly * lcoeff_wdk(TRIPoly *p, TVariable *mvar)
{
  
  return p->Coefficient(mvar,p->Degree(mvar));
} 	


TRIPoly * dInitial_wdk(TRIPoly *dp, TList * ord)
{ 
  TRIPoly * dq;
  TVariable *mvar;
  if (dClass_wdk(dp,ord)==0)  {dq=new TRIPoly(TBigInt (1));return dq;}
  mvar=dLeader_wdk(dp,ord);
  dq=lcoeff_wdk(dp,mvar);
//  delete mvar;

  return dq;
}

TList * dAsinitlist_wdk(TList *bs, TList *ord)
{
  TList * returnlist=new TList(),*initlist,*tmplist;
  TRIPoly *p;
  int i,l;
  l=bs->length();
  for(i=1;i<=l;i++)
    { p=dInitial_wdk( (TRIPoly *) bs->Part(i),ord);
      if (dClass_wdk(p,ord) !=0) 
	{ initlist=nonumfactors_wdk(p,ord);
	  tmplist=returnlist;
	  returnlist=tmplist-> Union (initlist);
	  delete initlist;
	  delete tmplist;
	}
      delete p;
    }
  return returnlist;
}
  


TRIPoly * Sept_wdk(TRIPoly * f, TList *ord)
{   TRIPoly * dq;
	TVariable * mvar;

    if (dClass_wdk(f,ord)==0) {dq=new TRIPoly(TBigInt (1));return dq;}    
    mvar=dLeader_wdk(f,ord);
	dq=new TRIPoly (f->derivative(mvar));
//	delete mvar;
	return dq;
}

// added by xfchen. (for the func. name is in wsolve.h)
TRIPoly * dSeparant_wdk(TRIPoly * f, TList *ord) 
{   TRIPoly * dq;
	TVariable * mvar;

    if (dClass_wdk(f,ord)==0) {dq=new TRIPoly(TBigInt (1));return dq;}    
    mvar=dLeader_wdk(f,ord);
	dq=new TRIPoly (f->derivative(mvar));
//	delete mvar;
	return dq;
}
// END (added by xfchen)

// bs is an ascending set
// ord is a variable list
// return the non-constant factors of the initials of the polynomials in bs

TList *dAsseptlist_wdk(TList *bs, TList *ord)
{
  TList * returnlist=new TList(),*initlist,*tmplist;
  TRIPoly *p;
  int i,l;
  l=bs->length();
  for(i=1;i<=l;i++)
    { p=Sept_wdk( (TRIPoly *) bs->Part(i),ord);
      if (dClass_wdk(p,ord) !=0) 
	{ initlist=nonumfactors_wdk(p,ord);
	  tmplist=returnlist;
	  returnlist=tmplist-> Union (initlist);
	  delete initlist;
	  delete tmplist;
	}
      delete p;
    }
  return returnlist;
}
      
   


TList * Septs_wdk(TList * as,TList *ord)
{	int l;
	TRIPoly *sp;
    TList *septs_m=new TList(),*list;
	

	l=as->length();
	for (int i=1;i<=l;i++)
	{ sp=Sept_wdk((TRIPoly *)as->Part(i),ord);
	if (dClass_wdk(sp,ord) >0) {septs_m->append((TAtom *)sp);}
	   else {delete sp;}
	   }
	list=septs_m->lunion();
	delete septs_m;

	return list;
}





///
////
// if f<=g then return 1;
// if f>g  then return 0;



int dLessp_wdk(TRIPoly *f, TRIPoly *g, TList * ord)
{
 int cf,cg,df,dg,cmp,result;
 //TBigInt degf,degg;
 TVariable *leadf,*leadg;
 TRIPoly *initf, *initg;


     cf=dClass_wdk(f,ord);
	 cg=dClass_wdk(g,ord);
//	 cout<<"cf="<<cf<<endl;
//	 cout<<"cg="<<cg<<endl;

	 if (cf==0) {  result = 1;} 
	 else if (cg==0) {result=0;}	 
	 else 
	 {
		 leadf=dLeader_wdk(f,ord);
		 leadg=dLeader_wdk(g,ord);
		 cmp=dercmp_wdk(leadf,leadg,ord);
         if (cmp == 1) 
			{result=1;}
         else if (cmp==-1) 
			{result=0;}
         else {         
			df = degree_wdk(f,leadf);
            dg = degree_wdk(g,leadg);

            if (df < dg) {result=1;}
             else if (df == dg) 
			 {initf=dInitial_wdk(f,ord);
			  initg=dInitial_wdk(g,ord);
			  result=dLessp_wdk(initf,initg,ord);
			  delete initf;
			  delete initg;
			 }
             else {result=0;}
		 }
	 }
		 
	 
         

	 return result;

}

int dercmp_wdk(TVariable * der1, TVariable *der2, TList *ord)
{
  TRIPoly dp1,dp2,dp,*dpp;
  TVariable *lead;
  if (der1==der2 ) return 0;
	dp1=TRIPoly(der1);
	dp2=TRIPoly(der2);
	dp=dp1+dp2;
	dpp=new TRIPoly(dp);
	lead=dLeader_wdk(dpp,ord);
	delete dpp;
	if (lead==der1) {return -1;} else {return 1;}

}




//l is a d-polynomial list
//ord is a variable list
//return the least polynomial in list l;

TRIPoly * dLeast_wdk(TList * l,TList * ord)
{
    int i,len;
    TRIPoly *p,*p2;
    p= (TRIPoly *) l->Part(1);
//	p->display();

    len=l->length();
    if (len==1) { return (TRIPoly *)p->Copy();}
    for(i=2;i<=len;i++)
      { p2=(TRIPoly *)l->Part(i);
//	   G_OUT("p2=",p2);
	if (dLessp_wdk(p2,p,ord)) p=p2;
	   //G_OUT("p=",p);
      }
    return (TRIPoly *)p->Copy();
}    


int dProperDp_wdk(TVariable *der1, TVariable *der2)
{ int c;
  TVariable *dt1,*dt2;
  TShortList *l1,*l2;
//  	G_OUT("der1=",der1);
//	  	G_OUT("der2=",der2);
	if (der1==der2) { return 0;}
	dt1=getname(der1);
	dt2=getname(der2);
	if (dt1 != dt2) { return 0;}

	if (tOrder_wdk(der1) <= tOrder_wdk(der2))
		return 0;
	else if (tOrder_wdk(der1)==0)
		return 0;
	else if (tOrder_wdk(der2)==0)  
		return 1;
	else {
	  l1=getlist(der1);
	  l2=getlist(der2);
//	  c=dRanklist_wdk(l1,l2);
	  c=1;
	  for (int i=1;i<=l1->length();i++)
	  { 
		  if (l1->get(i) < l2->get(i) ) {c=0;break;}
	  }
	  delete l1;
	  delete l2;

	  if (c==1) return 1; else return 0;
	}
}


TList * dProperDs_wdk(TRIPoly *dp, TVariable *der)
{
	int i,l;
	TList *idt,*dets=new TList();
	
	idt=AIndets_wdk(dp);
	l=idt->length();


	for (i=1;i<=l;i++) {
	  if ( dProperDp_wdk((TVariable *) idt->Part(i),der) )  {
				dets->append( (TAtom *) (idt->Part(i)) ->Copy());
	  }
	};
	     
	delete idt;
	return dets;	
}	

	  	

// p , q are two d-polynomials;
//ord is a variable list;
//if p is reduced to q then return 1 otherwise 0;
/*
        if nargs <4 or T='std_asc' then
               idt:=indets(p);
               
            if dercmp(Leader(p,ord), mvar, ord)=-1 and degree(p,mvar) < degree(q,mvar) 
               and   (not member(true, map(Is_proper_derivative,idt,mvar)) )  then 
               1 
            else 
               0 
            fi;
*/

int dReduced_wdk(TRIPoly * p,TRIPoly *q,TList * ord,TList *as, char cs_type)
{  TVariable *var,*mvar;
   TList *idt;
   TRIPoly *initp,*pred;
   int i,l,cls;
   TShortList * lsp, *lsq;

  


   int std_asc=10,wu_asc=20,gao_asc=30,tri_asc=40;
   int result;

   const int ALGEBRAIC_MODE=0,ODE_MODE=1,PDE_MODE=2;
   int len,POLY_MODE;
//   G_OUT("depend_relation=",depend_relation);

   len= ((TList *)(depend_relation->Part(2)))->length();
   if (len==0) {POLY_MODE=ALGEBRAIC_MODE;}
   else if (len==1) {POLY_MODE=ODE_MODE;}
   else {POLY_MODE=PDE_MODE;}

   cls=dClass_wdk(q,ord); 
   var= (TVariable *) ord->Part(ord->length()-cls+1);
 	   mvar=dLeader_wdk(q,ord);



   if (POLY_MODE==ODE_MODE)
   {   

	   if (cs_type=std_asc){
           lsp=dOrder_wdk(p,var);
		   lsq=dOrder_wdk(q,var);
		   
           if (dClass_wdk(p,ord) > dClass_wdk(q,ord) &&  degree_wdk(p,mvar) < degree_wdk(q,mvar) 
                &&  dRanklist_wdk(lsp,lsq) !=1 ){
//dOrder return TList *, <= should be rewritten.
				result=1;}
		   else {
				result=0;}
		   delete lsp;delete lsq;
	   }
	   //the following should be modified later
	   else if (cs_type=wu_asc){
		   if ( dClass_wdk(p,ord) > dClass_wdk(q,ord) && degree_wdk(dInitial_wdk(p,ord),mvar) < degree_wdk(q,mvar)){
			   result=1;}
		   else {
			   result=0;}
	   }
   
	   else if (cs_type=gao_asc){
		   initp=dInitial_wdk(p,ord);
		   pred=dPremas_wdk(initp,as,ord,std_asc);

		   if (dClass_wdk(p,ord) > dClass_wdk(q,ord) && pred->IsZero() ){
			   result= 1;}
		   else {
			   result=0;}
		   delete initp;delete pred;
	   }
	   else if (cs_type=tri_asc){
		   if (dClass_wdk(p,ord) > dClass_wdk(q,ord)){
			   result=1;}
		   else {
			   result=0;}
	   }
   }

   else if ( POLY_MODE==PDE_MODE){
	   if (cs_type==std_asc){               
            if ((dercmp_wdk(dLeader_wdk(p,ord), mvar, ord)==-1 )&&
				(degree_wdk(p,mvar) < degree_wdk(q,mvar) ) ){
				idt=AIndets_wdk(p);
				l=idt->length();
				//suppose m=1 means that: p is reduced to q ;
			    int m=1;
//				G_OUT("p=",p);
//				G_OUT("q=",q);
//				G_OUT("idt=",idt);
				for(i=1;i<=l;i++){
					if (dProperDp_wdk((TVariable *)idt->Part(i),mvar) ){m=0;break;}
				}
//				if (m==1) {cout<<"aa11";} else {cout<<"bb00";}

				if (m==1) {result=1;} else {result=0;}
				delete idt;
			}				
            else {
				result=0;}
			//delete idt;
	   }
	   //the following should be modified later
	   else if (cs_type=wu_asc){
		   initp=dInitial_wdk(p,ord);
		   if ( dClass_wdk(p,ord) > dClass_wdk(q,ord) && degree_wdk(initp,mvar) < degree_wdk(q,mvar)){
			   result=1;}
		   else {
			   result=0;}
		   delete initp;
	   }
	   
	   else if (cs_type=gao_asc){
		   initp=dInitial_wdk(p,ord);
		   pred=dPremas_wdk(initp,as,ord,std_asc);

		   if (dClass_wdk(p,ord) > dClass_wdk(q,ord) && pred->IsZero() ){
			   result= 1;}
		   else {
			   result=0;}
		   delete initp;delete pred;
	   }
	   else if (cs_type=tri_asc){
		   if (dClass_wdk(p,ord) > dClass_wdk(q,ord)){
			   result=1;}
		   else {
			   result=0;}
	   }
   }
//---------------

//----------------------------

   return result;
}
   





// ps is a polynomial set
// q is a polynomial
// ord is a variable list
// return a polynomial list which is composed by all  polynomials in ps
// reduced to q


TList * dReducedset_wdk(TList *ps, TRIPoly * q, TList * ord,TList * as,char cs_type)
{
  TList * reducedset =new TList();
  TRIPoly * pol;
  int j,l=ps->length();
  if (l==0) return reducedset;
  for (j=1;j<=l;j++)
    { pol= (TRIPoly *) (ps->Part(j));
//	dReduced_wdk(pol,q,ord,as,cs_type);
    if (dReduced_wdk(pol,q,ord,as,cs_type)) reducedset->append( (TAtom *) pol->Copy());
    }
  return reducedset;
}




TList * dBasicset_wdk(TList * ps,TList * ord,char cs_type)
{
  TList * bs=new TList (), *bs1, *redset,*redset1;
  TRIPoly *pol;

  redset=(TList *)ps->Copy();
  while(redset->length()!=0)
  {  pol=dLeast_wdk(redset,ord);
//     G_OUT("least pol=", pol);

     bs1=bs->insert(1, (TAtom *) pol);
	 delete bs;
	 bs=bs1;

     redset1 = dReducedset_wdk(redset,pol,ord,bs,cs_type);


//	 delete redset1;
//     redset1 = dReducedset_wdk(redset,pol,ord);

	 delete pol;
     delete redset;
	 redset=redset1;

  }
  if (redset) delete redset;

  return bs;
}




TRIPoly * lcoeff(TRIPoly *p, TVariable *mvar)
{
  
  return p->Coefficient(mvar,p->Degree(mvar));
} 

TRIPoly * lterm(TRIPoly *p, TVariable *x)
{	TRIPoly * pxd,*l;
//	TBigInt degp;
	int degp;
	degp=degree_wdk(p,x);

	pxd=new TRIPoly(x,degp);
	TRIPoly pol=(*lcoeff(p,x))*(*pxd);
	l=new TRIPoly( pol );
	return l;
}




//please notice that the third parameter is type of TList *;
//this is different from the function prem_wdk where the
// third variable is type of TVariable *; this will be convenient.
TRIPoly * dPrem_wdk(TRIPoly * uu, TRIPoly *vv, TVariable *y)
{	TRIPoly *u,*u1,*diffv,*remd;  
	TVariable *xu,*xv,*xx,*t;
	TList *vars=new TList();
	TShortList *lu,*lv;
	int  du,dv,d ;

	t=(TVariable *) ((TList *) depend_relation->Part(2))->Part(1);
    xx=getname(y);
	vars->append((TAtom *) xx);
	if (dClass_wdk(uu,vars)==0) { delete vars;return (TRIPoly *) uu->Copy();}

//		cout<<"y=";
//		y->display();
//		cout<<endl;

//   t= (TVariable *) ((TList *) depend_relation->Part(2))->Part(1);
//   var=(TList *) depend_relation->Part(1);
	u=(TRIPoly *)uu->Copy();

//	cout<<"u=";
//	u->display();
//	cout<<endl;

	xu=dLeader_wdk(u,vars);
    xv=dLeader_wdk(vv,vars);
//	G_OUT("u=",u);
//	G_OUT("vv=",vv);
//	G_OUT("xx=",xx);

	lu=dOrder_wdk(u,xx);
	lv=dOrder_wdk(vv,xx);
	if (lu==NULL)  {du=0;} else {du=lu->get(1);}
    if (lv==NULL)  {dv=0;} else {dv=lv->get(1);}
	delete lv;
/*	cout <<"in dPrem_wdk     "<<endl;
	cout<<"xu=";
	xu->display();
	cout<<endl;
	cout<<"xv=";
	xv->display();
	cout<<endl;
*/

	d=du-dv;
	


//	cout<<"d="<<d<<endl;

	while ( d>0) {
//	cout<<"d="<<d<<endl;
	
		diffv=dDiff_wdk(vv,t,d);
//		cout<<"xu=";
//        xu->display();
//		cout<<endl;

		u1=prem_wdk(u,diffv,xu);
		delete diffv;
		delete u;


// if u1 is a constant or dclass(u1,vars)=0; should be tested;
		if (dClass_wdk(u1,vars)==0) { u=u1; break;}
//		cout<<"ddd"<<endl;


		u=u1;
//		delete xu;
//		cout<<"u=";
//		u->display();
//		cout<<endl;
		xu=dLeader_wdk(u,vars);
//		cout<<"xu=";
//		xu->display();
//		cout<<"y=";
//		y->display();
//		cout<<endl;
		delete lu;
		lu=dOrder_wdk(u,y);
		if (lu==NULL)  {du=0;} else {du=lu->get(1);}
//		du=lu->get(1);
		d=du-dv;
	}

//   cout<<"the end"<<endl;
   u1=prem_wdk(u,vv,xv);
   delete u;
   delete lu;
   u=u1;
//   delete xu;
//   delete xv;
   delete vars;
//	if (d <0) {remd=u;}
   remd=u;
   return remd;
}







///--------------------------
//The following are NOT tested 
//----------------------------

// p is the d-polynomial
// as is an d-ascending set
// ord is a variable list
// return the remainder of p w.r.t. as

TRIPoly * dPremas_wdk(TRIPoly *p, TList * as, TList *ord, char cs_type)
{ 
  int i,l=as->length();
  TVariable * var;
  TRIPoly *pol,*p1,*p2;
  p1=(TRIPoly *)(p->Copy());
  for(i=1;i<=l;i++)
    { pol=(TRIPoly *) (as->Part(i));
//	  G_OUT("pol=",pol);
      var=dLeader_wdk(pol,ord);
      p2=NewPrem_wdk(p1,pol,var);
//	  G_OUT("p1=",p1);
//	  G_OUT("pol=",pol);
//	  G_OUT("var=",var);
//	  G_OUT("p2=",p2);
      delete p1;
//	  delete var;
      p1=p2;
    }
  return p1;
}

TRIPoly * NewPrem_wdk(TRIPoly *uu,TRIPoly *vv,TVariable *y)
{ const int ALGEBRAIC_MODE=0,ODE_MODE=1,PDE_MODE=2;
  int len,POLY_MODE;
  TRIPoly *pol;
  len= ((TList *)(depend_relation->Part(2)))->length();

  if (len==0) {POLY_MODE=0;}
  else if (len==1) {POLY_MODE=1;}
  else {POLY_MODE=2;}
//the following is for testing
//  POLY_MODE=1;
// the following line is for checking only.
  POLY_MODE=2;

  switch(POLY_MODE)
  {
  case ALGEBRAIC_MODE:
	  pol=NPrem_wdk(uu,vv,y);
	  break;
  case ODE_MODE:
	  pol=ODEPrem_wdk(uu,vv,y);
	  break;
  case PDE_MODE:
	  pol=PDEPrem_wdk(uu,vv,y);
	  break;

  }

  return pol;
}


TRIPoly * NPrem_wdk(TRIPoly *uu,TRIPoly *vv,TVariable *y)
{return prem_wdk(uu,vv,y);
}

TRIPoly * ODEPrem_wdk(TRIPoly *uu,TRIPoly *vv,TVariable *y)
{return dPrem_wdk(uu,vv,y);
}

//The third parameter *y should be the leader of the second parameter
// which is a polynomial.
TRIPoly * PDEPrem_wdk(TRIPoly *dp,TRIPoly *dq,TVariable *y)
{
	TList *Diff_Indets=(TList *)depend_relation->Part(1);
	TList *Diff_Var=(TList *)depend_relation->Part(2);
	TVariable *var,*lder;
	TList *idt;
	TRIPoly *dr,*dr0,*da,*db;
	TShortList *l1,*l2;
	int i,s;
	var=getname(y);
    dr0=(TRIPoly *)dp->Copy();
//	G_OUT("dp=",dp);
//	G_OUT("dq=",dq);
//	G_OUT("var=",y);
	idt=dProperDs_wdk(dr0,y);
//    G_OUT("idt=",idt);



	l2=dOrder_wdk(y,var);

	while (idt->length()!=0) 
	{
		lder=dHeadder_wdk(idt);
		da=(TRIPoly *) dq->Copy();
		l1=dOrder_wdk(lder,var);
		for (i=1;i<=l1->length();i++){
			if (l2==NULL) {s=l1->get(i);} else {s=l1->get(i)-l2->get(i);};
			db=dDiff_wdk(da,(TVariable *)Diff_Var->Part(i),s);
			delete da;
			da=db;

		}
		delete l1;
		dr=NPrem_wdk(dr0,da,lder);
		delete da;
		delete dr0;
		dr0=dr;
		delete idt;//wdk
		idt=dProperDs_wdk(dr0,y);
	}
	delete l2;
	delete idt;//wdk
	dr=NPrem_wdk(dr0,dq,y);
	delete dr0;
	return dr;
}

int dlength_wdk(TVariable *var)
{ 
	int len;
	TShortList *ls;
	ls=getlist(var);
	len=ls->length();
	delete ls;
	return len;
}

TVariable *dHeadder_wdk(TList *idts)
{ 
/*	TVariable *hder,*var;
	int i,j;
	hder=(TVariable *)idts->Part(1);
	for (i=1;i<=idts->length();i++)
	{   var=(TVariable *)idts->Part(i);
		if (tOrder_wdk(var)>tOrder_wdk(hder))
		{hder=var;}
		else if (tOrder_wdk(var)==tOrder_wdk(hder))
		{ 
			for(j=1;j<=dlength_wdk(hder);i++){
			
			}
		
		}

	}
*/
	int i,l=idts->length();
	TAtom *mvar,*var;
	mvar=idts->Part(1);
	for(i=1;i<=l;i++){
		var=idts->Part(i);
		if (dRankvar_wdk((TVariable *)mvar,(TVariable *)var)==-1 ){
			mvar=var;
		}
	}
	return (TVariable *) mvar->Copy();

}

         
//namespaces  


TList * dRemainderset_wdk(TList *ps, TList *as, TList  *ord,char cs_type)
{
  TList * rs =new TList(),*ps0,*ps1,*spolys,*result;
  TRIPoly *p;
  int i,l;

   const int PDE_MODE=2;
   int len,POLY_MODE;
//   G_OUT("depend_relation=",depend_relation);

   len= ((TList *)(depend_relation->Part(2)))->length();
   if (len>1) {POLY_MODE=PDE_MODE;}

  //ps1=ps->PMinus(as);
  ps0=ps->Minus(as);

  //the following should be should be modified 
  ps1=ps0;

  if (POLY_MODE==PDE_MODE) {  
	  spolys=spolyset_wdk(as,ord);
//	  delete spolys;
//	  spolys=spolyset_wdk(as,ord);

	  ps1=ps0->Union(spolys);

	  delete spolys;
	  delete ps0;
  }


//  G_OUT("ps1=",ps1);

  l=ps1->length();
  if (l==0)  {delete ps1; return rs;}
  for (i=1;i<=l;i++)
    {
    p=dPremas_wdk((TRIPoly *) (ps1->Part(i)),as,ord,cs_type);
//	if (p->IsZero()) {G_OUT("Pol p is 0",p);}
    if (! (p->IsZero())) {
      if (dClass_wdk(p,ord)==0) {delete p;delete ps1; delete rs; return Getp1list();}
      rs->append((TAtom *)(p->Copy()));
      delete p;
    }
    else 
      delete p;
  }
  //result=rs->Plunion();
  result=rs->lunion();

  delete ps1;
  delete rs;
  return result;
}

TShortList * maxlist_wdk(TShortList *l1, TShortList *l2)
{
	int i,l=l1->length();
	TShortList *sl=new TShortList(l);
//	if (l1==NULL) { G_OUT("this is l1=",l1);}
//	if (l2==NULL) { G_OUT("this is l2=",l1);}
//    if (l2==NULL) {delete sl; return (TShortList *) l2->Copy();}

	for(i=1;i<=l;i++){
      sl->modify(i,max(l1->get(i), l2->get(i)));
	}
    return sl;
}

TRIPoly * PD_spoly_wdk(TRIPoly *p,TRIPoly *q, TList *ord)
{
	TVariable  *leadp,*leadq,*leaddq,*var;
	TList *Diff_Var;
	TShortList *l1,*l2,*ml;
	TRIPoly *dp,*dq,*dp0,*dq0,*rem;
	int i;

	leadp=dLeader_wdk(p,ord);
	leadq=dLeader_wdk(q,ord);

	var=dMainvar_wdk(p,ord);
	Diff_Var=(TList *)depend_relation->Part(2);
    l1=dOrder_wdk(leadp,var);
	l2=dOrder_wdk(leadq,var);
//	G_OUT("l1=",l1);
//	G_OUT("l2=",l2);
    if (l2==NULL) {delete l2;l2=new TShortList( l1->length());}
	ml=maxlist_wdk(l1,l2);
	dp=(TRIPoly *)p->Copy();
	dq=(TRIPoly *)q->Copy();
	for(i=1;i<=ml->length();i++){
		
		dp0=dDiff_wdk(dp,(TVariable *)Diff_Var->Part(i),ml->get(i)-l1->get(i));
		delete dp;
		dp=dp0;
		dq0=dDiff_wdk(dq,(TVariable *)Diff_Var->Part(i),ml->get(i)-l2->get(i));
		delete dq;
		dq=dq0;
	}
//	G_OUT("ml=",l1);
	leaddq=dLeader_wdk(dq,ord);
	rem=NPrem_wdk(dp,dq,leaddq);
	delete l1;
	delete l2;
	delete ml;

	delete dp;
	delete dq;
	return rem;
		

}

TList *spolyset_wdk(TList *as,TList *ord)
{ 
	TList *res=new TList(),*res0,*bs,*bs0;
	int i,l,cls;
	TRIPoly *p,*pol,*poly;

	if (as->length()<=1) {return res;}
	bs=(TList *)as->Copy();
	p=(TRIPoly *) (bs->Part(1));

	bs0=bs->remove((TAtom *) p);
	delete bs;
	bs=bs0
		;
    l=bs->length();
	cls=dClass_wdk(p,ord);


	while (l!=0) {
		for(i=1;i<=l;i++) {
			pol=(TRIPoly *) (bs->Part(i));
			if (dClass_wdk(pol,ord)==cls) {
				poly=PD_spoly_wdk(p,pol,ord);
				res0=res->lappend((TAtom *)poly);
				delete poly;
				delete res;
				res=res0;
			}
		}
		p=(TRIPoly *) (bs->Part(1));
		bs0=bs->remove((TAtom *) p);
		delete bs;
		bs=bs0;

		l=bs->length();
		cls=dClass_wdk(p,ord);
	}

	delete bs;
				
	return res;			

}
