#include "basetype.h"
#include "stacks.h"
#include "global.h"
#include "lists.h"
#include "poly.h"
#include "pol.h"
#include "sysfunc.h"
#include "charset.h"
//#include "cs.h"
//#include "fwang.h"
///#include "lists_cs.h"
//#include "factorrs.h"
#include "wsolve.h"
#ifdef _WINDOWS
#include "..\gui\index.h"
#endif

// p is a polynomial, return a list which is a list of factors of polynomial p.
// p=3*(x+y)^2*(x-y);
// result=[x+y,x-y];
TList * factorlist_wdk(TRIPoly *p)
{ 
  int i,j;
  TList * l1,* l2,* r1;
  TRIPoly * l3;

  r1=new TList();
//  wout<<"(in factorrs.cpp)\np=";p->display();wout<<endl;
  l1=p->Factor();
//  wout<<"(in factorrs.cpp)\nl1=";l1->display();wout<<endl;
//  wout<<"44444444444"<<endl;
  for (i=3;i<=l1->length();i=i+2)
  {    l2=(TList *) (l1->Part(i));
      for (j=1;j<=l2->length();j++)
	{  l3=(TRIPoly *)l2->Part(j); 
	      r1->append((TAtom *)(new TRIPoly (* l3)));
	}
  } 
  delete l1;
  return r1;
}


// ps is a list of polynomials, remove the polynomails with class =0;
// ps=[x+y,a+b,x+2,b^3+a-1];
// ord=[x,y];
// result=[x+y,x+2];
TList * nonumber_wdk(TList *ps, TList *ord)
{ 
  TList * rps=new TList();
  TRIPoly *p;
  int i,l=ps->length();
  if (l==0) return rps;
  for (i=1;i<=l;i++)
    { p=(TRIPoly *) (ps->Part(i));
      if ( class_wdk(p,ord) !=0) rps->append((TAtom *) (p->Copy()));
    }
  return rps;
}

// ps is a list of polynomials, return the numbers of polynomials with class=1;
// ps=[x+a,x^2+a,y-x];
// ord=[y,x];
// result=2;
int nums_wdk(TList *ps, TList * ord)
{
  int n=0,i,l=ps->length();
//  if (l==0) return n;
  for(i=1;i<=l;i++)
    if( class_wdk( (TRIPoly *)( ps->Part(i)), ord)==1) n=n+1;
  return n;
}

// p is a polynomial
// ord is a variable list
// return the polynomial p 's factors with class !=0;
TList * nonumfactors_wdk(TRIPoly *p,TList * ord)
{
  int i,j;
  TList * l1,* l2,* r1;
  TRIPoly * l3;

  r1=new TList();
  l1=p->Factor();
  for (i=1;i<=l1->length();i=i+2)
  {    l2=(TList *) (l1->Part(i));
      for (j=1;j<=l2->length();j++)
        {  l3=(TRIPoly *)l2->Part(j);
          if  ((class_wdk(l3,ord)) !=0)
              r1->append((TAtom *)(new TRIPoly (* l3)));
        }
  }
  delete l1;
  return r1;
}

// p is a polynomial;
// ord is a varaible list;
// return all the factors of p with class(p,ord) >1;
TList * highclassfactors_wdk(TRIPoly *p,TList * ord)
{
  int i,j;
  TList * l1,* l2,* r1;
  TRIPoly * l3;

  r1=new TList();
  l1=p->Factor();
  for (i=1;i<=l1->length();i=i+2)
  {    l2=(TList *) (l1->Part(i));
      for (j=1;j<=l2->length();j++)
        {  l3=(TRIPoly *)l2->Part(j);
          if  ((class_wdk(l3,ord)) >1)
              r1->append((TAtom *)(new TRIPoly (* l3)));
        }
  }
  delete l1;
  return r1;
}



// rs is a polynomial set
// ord is a varialbe list
// return a list of lists which is composed of the factors of class !=0 
//					    of polynomial p in rs;
// rs=[x^2-1, a*y^2-a*x^2];
// ord=[y,x];
// result=[[x+1,x-1],[y+x,y-x]];

TList * produce_wdk(TList *rs,TList * ord)
{
  TList * list1, *flist, *returnrs=new TList();
  int i,l=rs->length();
  if (l==0) return returnrs;
  for (i=1;i<=l;i++)
    { 
//cout<<"3333333333333"<<endl;
	  flist= factorlist_wdk( (TRIPoly *) (rs->Part(i)));
      list1= nonumber_wdk( flist,ord);
      returnrs->append((TAtom *)list1);
      delete flist;
    }
  return returnrs;
}
  
// rs is a polynomial set
// ord is a variable list
// return a list of lists which are sub polynomial set of rs
// Zero(rs) = Union ( rs_i)
//  rs =[x^2-1, a*y^2-a*x^2];
//  ord=[y,x];
//  return [[x+1,y+x],[x+1, y-x],[x-1,y+x],[x-1,y-x]]
TList * nrs_wdk(TList *rs, TList * ord)
{
  TList *list1,*list2,*returnlist;
//  cout<<"111111"<<endl;
  list1=produce_wdk(rs,ord);
/*  cout<<"list1=";
  list1->display();
  cout<<endl;
  cout<<"222222"<<endl;
 
  G_OUT("list1=",list1);
 */
  list2=Lltl(list1);
//  cout<<"333333"<<endl;
//  G_OUT("list2=",list2);
  returnlist=Msubset(list2);
  G_OUT("returnlist=",returnlist);
  delete list1;
  delete list2;
  return returnlist;
}

// ps is a polynomial set
// rs is a polynomial set
// ord is a variable list
// zero(ps,rs) = Union zero( returnlist_i)
TList * pnrs_wdk(TList *ps,TList *rs, TList *ord)
{
  TList *rsets,*list1,*tmprs,*returnlist=new TList();
  int i,l;
//cout<<"00000000"<<endl;
  rsets=nrs_wdk(rs,ord);
  l=rsets->length();
  if (l==0) {delete rsets; returnlist->append((TAtom *) (ps->Copy()));return returnlist;}
  for (i=1;i<=l;i++) {
//  tmpps=ps->Copy();
  tmprs=(TList *)(((TList *) (rsets->Part(i)))->Copy());
  list1 =  ps->Union( tmprs); 
//  delete tmpps;
  delete tmprs;
  returnlist->append((TAtom *) list1);
  }
  delete rsets;
  return returnlist;
}
  
TList * realfac_wdk(TList *ps, TList *ord)
{
	TList *result=new TList (),*res, *lst;

	lst=produce_wdk(ps,ord);

	int l=lst->length();
	for (int i=1;i<=l;i++){ 
		res=result;
		result= res->Union( (TList *)  lst->Part(i));
		delete res;
	}
	delete lst;
	return result;
}

   
 
  
  
     



  
  
