// this file is added by xfchen
#include "basetype.h"
#include "stacks.h"
#include "global.h"
#include "lists.h"
#include "pol.h"
#include "sysfunc.h"
#include "charset.h"
//#include "fwang.h"
//#include "lists_cs.h"
//#include "factorrs.h"
#include "basetype.h"
//#include "cs.h"
#include "check.h"
#include "wsolve.h"
#include <assert.h>

#ifdef _WINDOWS
#include "..\gui\index.h"
#endif

// x,y are int
#define IntToP(x)  TRIPoly(TBigInt(x))
#define FToP(x,y)  TRIPoly(TNumber(TFraction(x,y)))
#define wheresqrt 20 //GetFuncID


// if "p" has only(if has) variables "sqrt","curt" or "qurt", and 
// their values are all numerical, return ture
bool Only234rt(TRIPoly *p)
{
//	G_OUT("p is:", p);
	TList *vl=p->getVL();
//	G_OUT("vl is:",vl);
	TVariable * var;
	if(vl->length()==0) // also return true if has not any variable
	{
		delete vl;
		return true;
	}
	for(TListNode * tmp=FIRSTNODE(vl);tmp;RNEXT(tmp))
	{
		var=(TVariable *)DATA(tmp);
//		G_OUT("var is:",var);
		int fn=var->GetFuncId();
		if (fn!=wheresqrt&&fn!=wheresqrt+1&&fn!=wheresqrt+2)
		{
			delete vl;
			return false;
		}

		int d=((TRIPoly *)(var->GetValue()))->deg();
		if (d==0)	continue;
		delete vl;
		return false;
	}
	delete vl;
	return true;
}

//if coefficents are numerical. "yes" to computer roots. 
// "no" to denote them by "RootsOf". "sqrt", "curt" and
// "qurt" are consided, but should only occur once in initial. 
bool CoeffIsNum(TRIPoly *equat,TVariable *var)
{
	bool judge;
	TList *coeffs=equat->Coeffs(var);
	//G_OUT("coeffs is:", coeffs);

	TRIPoly *init=(TRIPoly *)DATA(coeffs->last());
	TList *vl=init->getVL();
	if(vl->length()>1)
	{
		delete vl;
		delete coeffs;
		return false;
	}
	delete vl;
	
/*  If the coefficents(not Initial) can have other variables except "sqrt"
//  ,"curt", and "qurt". enable below lines	
		if(Only234rt((TRIPoly *)DATA(coeffs->last())))
			{
				delete coeffs;
				return true;
			}
		else
			{
				delete coeffs;
				return false;
			}
//*/
	for(TListNode * tmp=FIRSTNODE(coeffs);tmp;RNEXT(tmp))
	{
		if(((TRIPoly *)DATA(tmp))->IsNumber())
		{
			continue;
		}
//*  If coefficents can only have variables "sqrt","curt" or "qurt".
//  and its value is numerical, enable below lines. 		
		if(Only234rt((TRIPoly *)DATA(tmp)))
		{
			continue;
		}
//*/
		judge=false;
		delete coeffs;
		return judge;
	}
	judge=true;
	delete coeffs;
	return judge;
}

	

// reciprocal of "p", here "p" has no variables except for "sqrt".
// besides, the (TRIPoly *) inside "sqrt" has no variables.
TRIPoly Reciprocal(TRIPoly *p)
{
//	G_OUT("p is:",p);
	TRIPoly rt;
	if(p->deg()==0)  //no "sqrt" or "curt" or "qurt"
	{
		rt=inv(p->c);
	}
	else
	{
		TList *vl=p->getVL();
		assert(vl->length()==1);
		delete vl;
		TVariable *v=p->var;
		int d=v->GetFuncId();
		TRIPoly *a,*b,A,B,poly,vpoly,f;
		a=p->Coefficient(p->var,1);
		b=p->Coefficient(p->var,0);
		A=*a;
		B=*b;
		poly=TRIPoly(*(TRIPoly *)((p->var)->GetValue()));
		vpoly=TRIPoly(p->var,1);
		delete a;
		delete b;
		switch(d)
		{
		case wheresqrt: //"sqrt" e.q  reci. of  3*sqrt(5)+4
			  {
				  f=FToP(1,((A^2)*poly-B^2).c);
				  rt=f*(A*vpoly-B);
			  }
		case wheresqrt+1: //"curt" e.g  reci of 3*curt(5)+4
			  {
				  f=FToP(1,((A^3)*poly+B^3).c);
				  rt=f*((A^2)*(vpoly^2)-A*vpoly*B+B^2);
			  }
		case wheresqrt+2: //"qurt" e.g reci of 3*qurt(5)+4
			  {
				  f=FToP(1,((A^4)*poly-B^4).c);
				  rt=f*(A*vpoly-B)*((A^2)*(vpoly^2)+B^2);
			  }
		}
	}
	return rt;
}

// four roots are: 1/2/c4*2^(1/2)*(c4*(-c2+sqrt(c2^2-4*c4*c0)))^(1/2),
//                -1/2/c4*2^(1/2)*(c4*(-c2+sqrt(c2^2-4*c4*c0)))^(1/2),
//                 1/2/c4*(-2*c4*(c2+sqrt(c2^2-4*c4*c0)))^(1/2), 
//                 -1/2/c4*(-2*c4*(c2+sqrt(c2^2-4*c4*c0)))^(1/2)
TList *Creat4Roots(TRIPoly *c4,TRIPoly *c2,TRIPoly *c0)
{
	TRational *root;
	TList *roots=new TList();
	TRIPoly *de=(*c4*IntToP(2)).Simplify();
    TRIPoly *num;

	
// creat sqrt(c2^2-4*c4*c0)
	TRIPoly *p1=new TRIPoly(((*c2)^2)-IntToP(4)**c4**c0);
	TVariable *v1=GenVar("qurt",p1);
	delete p1;
    TRIPoly sqrtp1=TRIPoly(v1,1);

//-------------------------------------------
// creat sqrt(4*c4*(sqrtp1-c2))
	TRIPoly *p2=new TRIPoly(IntToP(4)**c4*(sqrtp1-*c2));
	TVariable *v2=GenVar("qurt",p2);
	delete p2;
    TRIPoly sqrtp2=TRIPoly(v2,1);
   
// add two roots	
	num=sqrtp2.Simplify();
	root=new TRational(num,de);
	roots->append(root);
	delete num;
	num=(-sqrtp2).Simplify();
	root=new TRational(num,de);
	roots->append(root);
	delete num;
//-------------------------------------------

//---------------------------------------------
// creat sqrt(-2*c4*(c2+sqrtp1))
	TRIPoly *p3=new TRIPoly(IntToP(-2)**c4*(*c2+sqrtp1));
	TVariable *v3=GenVar("qurt",p3);
	delete p3;
    TRIPoly sqrtp3=TRIPoly(v3,1);

// add two roots
	num=sqrtp3.Simplify();
	root=new TRational(num,de);
	roots->append(root);
	delete num;
	num=(-sqrtp3).Simplify();
	root=new TRational(num,de);
	roots->append(root);
	delete num;
//----------------------------------------------


	delete de;
	return roots;
}


//solve equation of degree 4. we can only deal with two case:
// c4*x^4+c2*x^2+c0  or c4*x^4+c0

TList *RootsOfEq4(TRIPoly *equat,TVariable *var)
{
	assert(equat->Degree(var)==4);
	
	TList *roots=new TList();

	TRIPoly *c4=equat->Coefficient(var,4);
	TRIPoly *c3=equat->Coefficient(var,3);
	TRIPoly *c2=equat->Coefficient(var,2);
	TRIPoly *c1=equat->Coefficient(var,1);
	TRIPoly *c0=equat->Coefficient(var,0);
    TRIPoly I,*tmp, Pqurt,*num,*de;
	TRational *root;

	if(!(CoeffIsNum(equat,var))||!(c1->IsZero())||!(c3->IsZero()))
	{
		TVariable *rtof=GenVar("RootOf",(TAtom *)equat);
		TRIPoly *tmp=new TRIPoly(rtof,1);
		roots->append((TAtom *)(new TRational(tmp)));
		delete tmp;
	}
	else 
	{
		if (c2->IsZero())
// four roots are:  1/c4*(-c0*c4^3)^(1/4), I/c4*(-c0*c4^3)^(1/4), 
//                 -1/c4*(-c0*c4^3)^(1/4), -I/c4*(-c0*c4^3)^(1/4)
		{
			I=TRIPoly(TNumber(TComplex(TBigInt(0),TBigInt(1))));
            
			tmp=new TRIPoly(-*c0*((*c4)^3));
			TVariable * Vqurt=GenVar("qurt",tmp);
			Pqurt=TRIPoly(Vqurt,1);
			delete tmp;

			de=c4->Simplify();
			
			num=(Pqurt).Simplify();
			root=new TRational(num,de);
			delete num;
			roots->append(root);

			num=(Pqurt*I).Simplify();
			root=new TRational(num,de);
			delete num;
			roots->append(root);

			num=(-Pqurt).Simplify();
			root=new TRational(num,de);
			delete num;
			roots->append(root);

			num=(-Pqurt*I).Simplify();
			root=new TRational(num,de);
			delete num;
			roots->append(root);

			delete de;
		}
		else
// four roots are: 1/2/c4*2^(1/2)*(c4*(-c2+sqrt(c2^2-4*c4*c0)))^(1/2),
//                -1/2/c4*2^(1/2)*(c4*(-c2+sqrt(c2^2-4*c4*c0)))^(1/2),
//                 1/2/c4*(-2*c4*(c2+sqrt(c2^2-4*c4*c0)))^(1/2), 
//                 -1/2/c4*(-2*c4*(c2+sqrt(c2^2-4*c4*c0)))^(1/2)
		{
			roots=Creat4Roots(c4,c2,c0);
		}

	}
	delete c0;
	delete c1;
	delete c2;
	delete c3;
	delete c4;
	TList *droots=roots;
	roots=droots->lunion();
	delete droots;
    return roots;
}






//solve equation of degree 3
// c3*x^3+c2*x^2+c1*x+c0
TList *RootsOfEq3(TRIPoly *equat,TVariable *var)
{
	assert(equat->Degree(var)==3);
	
	TList *roots=new TList();

	if(!(CoeffIsNum(equat,var)))
	{
		TVariable *rtof=GenVar("RootOf",(TAtom *)equat);
		TRIPoly *tmp=new TRIPoly(rtof,1);
		roots->append((TAtom *)(new TRational(tmp)));
		delete tmp;
	}
	else
	{
		TRIPoly *c0,*c1,*c2,*c3,c3_re,a,b,c,p,q,*delta,*root,*A,*B,w;
		
		c0=equat->Coefficient(var,0);
		c1=equat->Coefficient(var,1);
		c2=equat->Coefficient(var,2);
		c3=equat->Coefficient(var,3);

		// turn to x^3+a*x^2+b*x+c=0
		c3_re=Reciprocal(c3);
//		wout<<"c3_re is:";c3_re.display();wout<<endl;

		a=*c2*c3_re;
		b=*c1*c3_re;
		c=*c0*c3_re;
		
		delete c0;
		delete c1;
		delete c2;
		delete c3;
		

		//if a!=0 turn to 
		// x^3+p*x+q=x^3+(3*a+3*b/a)*x+4*a^2/9+b+3*c/a=0
		if (a.IsZero())
		{
			p=b;
			q=c;
		}
		else
		{
			p=b-(a^2)*FToP(1,3);
			q=(a^3)*FToP(2,27)-a*b*FToP(1,3)+c;
		};

		delta=new TRIPoly((q^2)*FToP(1,4)+(p^3)*FToP(1,27));// delta=q^2/4+p^3/27
     	TVariable *sqrt_delta=GenVar("sqrt",delta);
		delete delta;
		TRIPoly sqrt_delta_poly=TRIPoly(sqrt_delta,1);

		A=new TRIPoly(-q*FToP(1,2)+sqrt_delta_poly);// A=-q/2+sqrt(delta)
		B=new TRIPoly(-q*FToP(1,2)-sqrt_delta_poly);// B=-q/2-sqrt(delta)
        TVariable *curtA=GenVar("curt",A);   
		TVariable *curtB=GenVar("curt",B);
		delete A;
		delete B;
		TRIPoly curtA_p= TRIPoly(curtA,1);
		TRIPoly curtB_p= TRIPoly(curtB,1);
		   
		// construct w=(-1+sqrt(3)*I)/2; w^3=1
		TRIPoly *n3=new IntToP(3);
		TVariable *sqrt3=GenVar("sqrt",n3);
		delete n3;
		TRIPoly sqrt3_poly=TRIPoly(sqrt3,1);
		TRIPoly I=TRIPoly(TNumber(TComplex(TBigInt(0),TBigInt(1))));
	    w=FToP(-1,2)+sqrt3_poly*I*FToP(1,2);

/*
		wout<<"w is:"; w.display();wout<<endl;
//		wout<<"w^2 is:"; (w^2).display();wout<<endl<<endl;
		wout<<"A is:"; curtA_p.display();wout<<endl;
		wout<<"A*w is:"; (curtA_p*w).display();wout<<endl<<endl;
/*
		wout<<"B is:"; curtB_p.display();wout<<endl;
		wout<<"B*(w^2) is:"; (curtB_p*(w^2)).display();wout<<endl;
			wout<<"A*(w^2) is:"; (curtA_p*(w^2)).display();wout<<endl;
	

	
		wout<<"A+B*(w^2) is:"; (curtA_p*curtB_p*(w^2)).display();wout<<endl;
//*/ 


		root=(curtA_p+curtB_p).Simplify();
		roots->append(new TRational(root));
		delete root;
        root=(curtA_p*w+curtB_p*(w^2)).Simplify();
		roots->append(new TRational(root));
		delete root;
		root=(curtA_p*(w^2)+curtB_p*w).Simplify();
		roots->append(new TRational(root));
		delete root;
		TList *droots=roots;
		roots=droots->lunion();
		delete droots;
	}
	return roots;
}

//solve equation of degree 2
//c2*x^2+c1*x+c0
TList *RootsOfEq2(TRIPoly *equat,TVariable *var)
{
	assert(equat->Degree(var)==2);
	TRIPoly *num,*den,*sn,*sd,*c0,*c1,*c2,*delta,*sqrt_delta_poly;
	TVariable *sqrt_delta,rootsOf;
	
	TList *roots=new TList();

    c2=equat->Coefficient(var,2);
	c1=equat->Coefficient(var,1);
    c0=equat->Coefficient(var,0);
	delta=new TRIPoly((*c1)*(*c1)-TRIPoly(TBigInt(4))*(*c2)*(*c0));
    den=new TRIPoly((-(*c2))*TRIPoly(TBigInt(2)));// -2a
	sd=den->Simplify();
	if (delta->IsZero())
	{
		num=new TRIPoly(-(*c1));
       	sn=num->Simplify();
		roots->append(new TRational(sn,sd));
		delete sn;
	}
	else
	{
		sqrt_delta=GenVar("sqrt",delta);
   		sqrt_delta_poly=new TRIPoly(sqrt_delta);
	
		num=new TRIPoly(*c1+*sqrt_delta_poly);
		sn=num->Simplify();
		roots->append(new TRational(sn,sd));
		delete sn;
		delete num;
		
		num=new TRIPoly(*c1-*sqrt_delta_poly);
		sn=num->Simplify();
		roots->append(new TRational(sn,sd));
        delete sn;
//	   	G_OUT("root is (delta!=0):",roots);
		
		// delete sqrt;
		delete sqrt_delta_poly;
	}
	TList *droots=roots;
	roots=droots->lunion();
	delete droots;
	delete sd;
	delete c1;
	delete c2;
	delete c0;
	delete num;
	delete den;
	delete delta;
	return roots;
}

//solve equation of degree 1
TList *RootsOfEq1(TRIPoly *equat,TVariable *var)
{
	TList *roots=new TList();
	TRIPoly *coeff1,*coeff0,*num,*den,*sn,*sd;	
	coeff1=equat->Coefficient(var,1);
    coeff0=equat->Coefficient(var,0);
	num=new TRIPoly(-(*coeff0));
	den=coeff1;
	sn=num->Simplify();
	sd=den->Simplify();
	roots->append(new TRational(sn,sd));
	delete sn;
	delete sd;
	delete coeff0;
	delete coeff1;
	delete num;
	return roots;
}


// solve a equation w.r.t a given variable
TList * RootsOfEquat(TRIPoly *equat,TVariable *var)
{

//	G_OUT("equation is:",equat);
//	G_OUT("var is:",var);
	TList *roots;
	TVariable *rootsOf;
	TRIPoly *p;
	int deg=equat->Degree(var);
	switch(deg)
	{
	case 0:
		cout<<"'var' not found in 'equat' when calling RootsOfEquat() !"<<endl;
		exit(1);
		break;
	case 1:
		roots=RootsOfEq1(equat,var);
		break;
	case 2:
		roots=RootsOfEq2(equat,var);
		break;        
	case 3:
		roots=RootsOfEq3(equat,var);
		break;
//	case 4:
//		roots=RootsOfEq4(equat,var);
	default:
		rootsOf=GenVar("RootOf",(TAtom *)equat);
        p=new TRIPoly(rootsOf,1);
		roots=new TList();
		roots->append(new TRational(p));
		delete p;
		break;
	}
    return roots;
}


// creat a list of main variables in CS, w.r.t a given variable order .
TList *MainVarList(TList *CS,TList *ord)
{
	TVariable *mv;
	TList *mvl=new TList();
	for(TListNode * tmp=FIRSTNODE(CS);tmp;RNEXT(tmp))
	{
		mv=mainvar_wdk((TRIPoly *)DATA(tmp),ord);
        mvl->append((TAtom *)mv->Copy());
	}
	return mvl;
}

/*
input: a list, every element is also a list representing a 
       solution of CS,and  it may be not complete.
output: if the first element as [[roots'],[CS']] is a 
        complete solution of CS, i.e. no more operators are
		needed to it. Then all elements are complete solutions.
		Just to judge if [roots'] and [CS'] have the same length.
*/
bool Finished(TList *rootsAndCSList)
{
	TList *list1,*list11,*list12;
	list1=(TList *)DATA(rootsAndCSList->first());
	list11=(TList *)DATA(list1->first());
	list12=(TList *)DATA(list1->first()->next);
	if(list11->length()==list12->length())
		return 1;
	else return 0;
}

//lost memory!!
TRIPoly * Sub_Ra(TRIPoly *p0, TVariable * v, TRational * r)
{
  //G_OUT("p0 is:", p0);
    //G_OUT("v is:", v);
	  //G_OUT("r is:", r);
	   //G_OUT("r's nu is:", r->GetNu());
	    //G_OUT("r's de is:", r->GetDe());


  unsigned short i1,i;
  TRIPoly p, q, *p1,*p2,*c,*tr1,*tr2,*tr3,*tr4,*tr5,*tr6, *q1, *q2;
  i1=p0->Degree(v);
  if(i1==TBigInt(0))
  {
    return p0->Clone();
  }
  
  p1=p0->Coefficient(v,0);
  p = *(r->GetNu());
  q = *(r->GetDe());

  c=p1;                      // added by xfchen
  p1=new TRIPoly((*c)*(q^i1));
  delete c;

  for(i=1;i<=i1;i++)
  {
    tr1=new TRIPoly(p^i);
    tr2=tr1;
    q1=new TRIPoly(q^(i1-i));
    q2=q1;

    p2=p1;
    tr3=p0->Coefficient(v,i);
    tr4=tr3;
    tr5=ptimes(cp_TRIPoly(tr3),cp_TRIPoly(tr1));
    tr5=ptimes(tr5,cp_TRIPoly(q2));
    tr6=tr5;
    p1=pplus(cp_TRIPoly(p1),cp_TRIPoly(tr5));

    delete tr2;
    delete tr4;
    delete tr6;
    delete p2;
	delete q1;  // added by xfchen
  }
  //G_OUT("sub rt is:",p1);
  return p1;

}       


// replace the variable with its root in a equation.
TRIPoly *ReplaceOne(TRIPoly *eq,TRational *root,TVariable *var)
{
	if (eq->Degree(var)==0) return (TRIPoly *)(eq->Copy());
	else return Sub_Ra(eq, var, root);
}


/*
input: CS, a root, a number, a variable.
       the number means in CS, from which polynomial on, all the following
	   polynomials need to be refreshed by replacing the variable with its root.
output: refreshed CS
*/
TList *ReplaceAll(TList *cs,TRational *root,int index,TVariable *var)
{
	TList *newcs=new TList();
	TListNode *current=cs->first();
	for(int i=1; i<index;i++)
	{
		newcs->append(current->Clone());
		current=current->next;
	}
	for(current;current;RNEXT(current))
	{
		newcs->append((TAtom *)ReplaceOne((TRIPoly *)DATA(current),root,var));
	}
	return newcs;
}

/*
input: a list as [[roots'],[CS']], a root of the last solved polynomial
        in [cs'], its corresponding variable.
output: add the root to [roots'], and replace the varible with it in
        [CS']. So the result is [[newroots'],[newCS']]
*/
TList *AddOneRoot(TList *rootsAndCS,TRational *root,TVariable *var)
{
	
	TList *rt=new TList();
	TList *newroots=(TList *)(DATA(rootsAndCS->first())->Copy());
	newroots->append((TAtom *)(root->Copy()));
    int index=newroots->length()+1;
    rt->append((TAtom *)newroots);
	TList *cs=(TList *)DATA(rootsAndCS->first()->next);
    TList *newcs=ReplaceAll(cs,root,index,var);
	rt->append((TAtom *)newcs);
	return rt;
}


/* 
input: a list as [[roots'],[CS']], [roots'] contains one sort of roots of 
       the first some main variables. [CS'] has been got from [CS] by replacing 
	   these variables with corresponding roots in [roots'], one by one by calling
	   the same function.
output: solve the first unsolved polynomial in [cs'], add every root of it
        to [roots'] respectively and replace the corresponding variable with it
	    in [cs']. So the result is a list of lists.

*/
TList *AddRoots(TList *rootsAndCS,TList *ord)
{
	//G_OUT("rootsAndCS is:",rootsAndCS);

	TList *newRootsAndCS,*rt=new TList();
	TList *roots=(TList *)DATA(rootsAndCS->first());
	int len=roots->length();				
	TRIPoly *eq=(TRIPoly *)(((TList *)DATA(rootsAndCS->first()->next))->Part(len+1));
	TVariable *mvar=mainvar_wdk(eq,ord);
	TList *rootsOfEq=RootsOfEquat(eq,mvar);
	int len1=rootsOfEq->length();
	for(TListNode * tmp=FIRSTNODE(rootsOfEq);tmp;RNEXT(tmp))
	{
		//G_OUT("tmp is:", DATA(tmp));
		newRootsAndCS=AddOneRoot(rootsAndCS,(TRational *)DATA(tmp),mvar);
		rt->append((TAtom *)newRootsAndCS);
	}
	delete rootsOfEq;
	return rt;
}

/*
input: a list as [[],[CS]], this is initial form of a solution ;
       a list of variables order
output: a list, every element is also a list,representing a solution 
        of CS as [[roots],[CSReplaced]]. [CSReplaced] is got from CS 
		by replacing every main variable with corresponding root and
		is the same long as [roots]
*/
TList *RootsOfCS(TList *initRootsAndCS,TList *ord)
{
	TList *addRootsDone,*sl,*rt=(TList *)(initRootsAndCS->Copy());
	//G_OUT("init is:", initRootsAndCS);
	while (!Finished(rt))
	{
		TList * stepList=new TList();
		for(TListNode * tmp=FIRSTNODE(rt);tmp;RNEXT(tmp))
		{
			addRootsDone=AddRoots((TList *)DATA(tmp),ord);
			sl=stepList;
			stepList=sl->Union(addRootsDone);
			delete sl;
			delete addRootsDone;
		}
		delete rt;
		rt=stepList;
	}
	return rt;
}

/*
input: a list of CS , [CS]
output:a solution of initial form, [ [[],[CS]] ]
*/
TList *InitRootsAndCS(TList *cs)
{
	TList *rt=new TList(),*rtList=new TList();
	rt->append((TAtom *)new TList());
	rt->append((TAtom *)(cs->Copy()));
	rtList->append((TAtom *)rt);
	return rtList;
}

/*
input:  a list of charicteristic sets(CS) of normal form; a list of variables order
output: a list, every elements is also a list, representing one of solutions of each 
         charicteristic set. Each CS may have several solutions. All solutions 
		 of all CS are the elements of output list.
*/
TList *RootsOfCSS(TList *CSList,TList *ord)
{
	TList *rt=new TList(),*drt,*initRootsAndCS;
	for(TListNode * tmp=FIRSTNODE(CSList);tmp;RNEXT(tmp))
	{
		TList *cs=(TList *)DATA(tmp);
		//G_OUT("cs",cs);
		initRootsAndCS=InitRootsAndCS(cs);
		TList *rootsAndCSDone=RootsOfCS(initRootsAndCS,ord);
		drt=rt;
		rt=drt->Union(rootsAndCSDone);
		delete drt;
		delete rootsAndCSDone;
		delete initRootsAndCS;
	}
	return rt;
}

// display all the solutions
void DisplayRoots(TList *solutions,TList *ord)
{
	int i=1;
	TList *roots,*mvars,*freevars;
	TListNode *tmp_r,*tmp_m;
	for(TListNode * tmp=FIRSTNODE(solutions);tmp;RNEXT(tmp))
	{
		wout<<endl<<"Solution "<<i<<":"<<endl;
		roots=(TList *)DATA(((TList *)DATA(tmp))->first());
		mvars=MainVarList((TList *)DATA(((TList *)DATA(tmp))->first()->next),ord);
		tmp_r=FIRSTNODE(roots);
		tmp_m=FIRSTNODE(mvars);
		int j=1;
		for(;tmp_r;RNEXT(tmp_r),RNEXT(tmp_m))
		{
			DATA(tmp_m)->display();
			wout<<"=";
			DATA(tmp_r)->display();
			wout<<",";
		}
		freevars=ord->Minus(mvars);
		delete mvars;
		if (freevars->length()==0)
		{
			wout<<endl<<"where no free variables exist";
		}
		else
		{
			wout<<endl<<"where free variables are: ";
			TListNode * tmp_fr=FIRSTNODE(freevars);
			DATA(tmp_fr)->display();
			RNEXT(tmp_fr);
			for(;tmp_fr;RNEXT(tmp_fr))
			{
				wout<<", ";
				DATA(tmp_fr)->display();
			}
		}
		delete freevars;
		wout<<endl;
		i++;
	}
	wout<<endl;
}


// input a list=[list_1,list_2,...list_i...]
// Inverse every list_i inside.
TList * InverseCSS(TList * l)
{
	TList * result=new TList();
	for(int i=0;i<l->length();i++)
	{
		TList * temp=(TList *)(l->Part(i+1)->Copy());
		result->append((TAtom *)(temp->Inverse()));
        delete temp;
	}
	return result;
}


// solve equations "polys"
TList * RootsOfPolys(TList *polys,TList *ord,TList *ds)
{
	TList *dcss,*acss,*solutions,*roots,*mvars,*rt=new TList(),*rt1;
	dcss=css_wdk(polys,ord,ds);
	acss=InverseCSS(dcss);
	wout<<"The ascendant charicteristic sets are : "<<endl;
	acss->display();
	wout<<endl;
	solutions=RootsOfCSS(acss,ord);
    for(TListNode * tmp=FIRSTNODE(solutions);tmp;RNEXT(tmp))
	{
		roots=(TList *)(((TList *)DATA(tmp))->Part(1));
		mvars=MainVarList((TList *)(((TList *)DATA(tmp))->Part(2)),ord);
		rt1=new TList();
		TListNode *tmp2=FIRSTNODE(mvars);
		for(TListNode * tmp1=FIRSTNODE(roots);tmp1;RNEXT(tmp1))
		{			
			rt1->append((DATA(tmp2))->Copy());
			rt1->append((DATA(tmp1))->Copy());
			RNEXT(tmp2);
		}
		delete mvars;
		rt->append(rt1);
	}
	DisplayRoots(solutions,ord);
	delete dcss;
	delete acss;
	delete solutions;
	return rt;
}
;







