#include "basetype.h"

#include "stacks.h"
#include "global.h"
#include "lists.h"
#include "poly.h"
#include "pol.h"
#include "sysfunc.h"
#include "charset.h"
//#include "cs.h"
//#include "fwang.h"
//#include "lists_cs.h"
//#include "factorrs.h"
//#include "cs.h"
#include "wsolve.h"
#ifdef _WINDOWS
#include "..\gui\index.h"
#endif

// ps is a polynomial set
// q is a polynomial
// ord is a variable list
// return a polynomial list which is composed by all  polynomials in ps
// reduced to q

TList * trireducedset_wdk(TList *ps, TRIPoly * q, TList * ord)
{
  TList * reducedset =new TList();
  TRIPoly * pol;
  int j,l=ps->length();
  if (l==0) return reducedset;
  for (j=1;j<=l;j++)
    { pol= (TRIPoly *) (ps->Part(j));
    if ( class_wdk(pol,ord) > class_wdk(q,ord)  ) reducedset->append( (TAtom *) pol->Copy());
    }
  return reducedset;
}


// ps is a polynomial set
// ord is a variable list
// return the basic set of ps

TList * tribasicset_wdk(TList *ps,TList *ord)
{

  TList * bs1 = new TList(), * bs2, * reducedset;
  TRIPoly * pol;
  int l;
  l=ps->length();
  if (l==0) return bs1;
  pol=least_wdk(ps,ord);
  bs1->append( (TAtom *) (pol->Copy()));
  reducedset = trireducedset_wdk(ps,pol, ord);
  bs2=tribasicset_wdk(reducedset,ord);

   /*
   bs=conc_cs(bs2,bs1);
   //cout<<"after recursive";
   delete pol;
   delete bs1;
   delete bs2;
   delete reducedset;
   return bs;
   */

   bs2->dmerge(bs1);
   //cout<<"after recursive";
   delete pol;
   //delete bs1;
   //delete bs2;
   delete reducedset;
   return bs2;
}


// p is the polynomial
// as is an ascending set
// ord is a variable list
// return the remainder of p w.r.t. as
TRIPoly * tripremas_wdk(TRIPoly *p, TList * as, TList *ord)
{ 
  int i,l=as->length();
  TVariable * var;
  TRIPoly *pol,*p1,*p2;
  p1=(TRIPoly *)(p->Copy());
  for(i=1;i<=l;i++)
    { pol=(TRIPoly *) (as->Part(i));
	while ( class_wdk(p1,ord) == class_wdk(pol,ord))
	  { 
	    var=(TVariable *)(mainvar_wdk(pol,ord));
	    p2=prem_wdk(p1,pol,(TVariable *)var);
	    delete p1;
            if(var) delete var;
	    return p2;
	  }
    }
  return p1;
}



// ps is a polynomial set, as is a triangular set, ord is a variable list;
// return the remainder set;
// if there exist a polynomial p in ps, r is the remainder of p respect to as, 
// and class(r,ord) =0 and r !=0, then return a list [1];
// if  class(r,ord) >0 then append the polynomial r into the poly set.
// if  r=0, do NOT append 0 to the remainder set

TList * triremainderset_wdk(TList *ps, TList *as, TList  *ord)
{
  TList * rs =new TList();
  TRIPoly *p;
  int i,l=ps->length();
  if (l==0) return rs;
  for (i=1;i<=l;i++)
    {
    p=tripremas_wdk((TRIPoly *) (ps->Part(i)),as,ord);
    if (! (p->IsZero())) {
      if (class_wdk(p,ord)==0) {delete p;delete rs; return Getp1list();}
      rs->append((TAtom *)(p->Copy()));
      delete p;
    }
    else 
      delete p;
  }
  return rs;
}


//ps is a polynomial set
//ord is a variable list
//nonzero is a polynomial set
// here we suppose every polynomial is irreducible over rational field Q.
// if there are more than one polynomial with class = 1 , then return empty set;
// if the intersection of ps and nonzero is NOT empty, then return empty set;
// if remainder set is empty, then return basic set;
// if remainder set is a set with one polynomial =1 , then return empty set;
// if remainder set is not empty, then give all possible combinations rset=rs1,rs2,...,rsn.
// and for each ps= bs union rs_i , return union ( csa_wdk(ps) );    

TList * triseta_wdk(TList * ps, TList *ord, TList * nonzero)
{
  TList * returnlist=new TList (),* checklist, *bset,*rset, *ulist,*rsets,*csets,*tmp_returnlist;
  int i,l;
//	cout<<"\n in csa------------------\n";
  if (nums_wdk(ps,ord) >1) { wout<<"\n numbers of class 1 >1\n"; ps->display();wout<<endl;} 
  if (nums_wdk(ps,ord) >1) return returnlist;
  checklist=ps->Intersect(nonzero);
  if (checklist->length() !=0) {delete checklist; return returnlist;}
  delete checklist;
  bset=tribasicset_wdk(ps,ord);
  rset=triremainderset_wdk(ps,bset,ord);
/*
  cout<<"\n ps="<<endl;
  ps->display();
  cout<<"\n bs="<<endl;
  bset->display();
  cout<<"\n rs="<<endl;
  rset->display();
  cout<<endl;
*/
//  cout<<"before if";
  if (rset->length() ==0)  { 
    wout<< "(in tri.cpp) A New Component !\n"; 
    delete rset; 
    returnlist->append((TAtom *) bset); 
//    returnlist->display();
    return returnlist;
    }
  if (Listisp1(rset)) {
	wout<<" \n Contradiction Set \n";wout<<endl;
    	delete rset; delete bset; return returnlist;}
  //  cout<<"rset=";
  //  rset->display();
  //  cout<<endl;

  rsets=nrs_wdk(rset,ord);
//  cout<<"\n rsets="<<endl;
//  rsets->display();
//  cout<<endl;  
  
  //  cout<<"length="<<rsets->length()<<endl<<"rsets=";
  //  rsets->display();
  //  cout<<endl;
  delete rset;
  l=rsets->length();
 // for (i=1;i<=1;i++)
  for (i=1;i<=l;i++)
    { 
      ulist=bset ->Union( (TList *) (rsets->Part(i)));
      csets=triseta_wdk(ulist,ord,nonzero);
      delete ulist;
      tmp_returnlist=returnlist;
      returnlist=tmp_returnlist->Union(csets);
      delete tmp_returnlist;
      delete csets;
    }

  delete bset;
  delete rsets;
  
//  cout<<"end if";
  return returnlist;
}




TList * triset_wdk(TList * ps, TList *ord)
{
  TList  *bset,*rset, *nps,*res;


  bset=tribasicset_wdk(ps,ord);
  rset=triremainderset_wdk(ps,bset,ord);

  if (rset->length() ==0)  {     
    delete rset; 
//    returnlist->display();
    return bset;
    }
  if (Listisp1(rset)) {
	wout<<" \n Contradiction Set \n";wout<<endl;
    	delete rset; delete bset; return new TList(); } 

	nps=ps->Union( rset);
	delete bset;
	delete rset;
	res=triset_wdk(nps,ord);
	delete nps;

  return res;
}
