//Polynomial Factorization over algebraic extension fields with
//adjoining polynomials in an ascending set
//Language: C++ codes in ELIMINO system
//Date:    2000.2

#include "typedef.h"
#include "memory.h"
#include "stacks.h"
#include "global.h"
#include "lists.h"
#include "poly.h"
#include "trpoly.h"
#include "pol.h"
#include "sysfunc.h"
#include "charset.h"
#include "basecs.h"
 

//----------------------------------
TList * CharsetCallcharset_base(TList * ps,TList *ord);
TRIPoly * list2tripoly(TList * lpoly);

int wDie();
TList * arrange(TList * ps,TVariable * x);
TList * initialset(TList * as,TList * ord);
TRIPoly * movefactor(TRIPoly * f,TRIPoly * g,TList * ord);
TRIPoly * movefactorps(TRIPoly * f,TList * ps,TList * ord);
int linearas(TList * cs,TList * ord);
TList * factorps(TList * ps);
TList * algcdLL(TRIPoly * f,TRIPoly * g,TList * as,TList * ord);
TRIPoly * aldivide(TRIPoly * f,TRIPoly * g,TList * as,TList * ord);
TList * trivial(TRIPoly * ff,TRIPoly * aa,TVariable * vf,
                 TVariable * va,TRIPoly * fn);
TList * translist(TList * l);
TList * factoras(TRIPoly * f,TList * as,TList * ord);
TList * factorassub(TRIPoly * f,TList * as,TList * ord);



TPoly * TRIPoly2TPoly(TRIPoly * trip);
TRIPoly * TPoly2TRIPoly(TPoly * tp);
TList * tripoly_charset(TList * ps,TList * ord);
TRIPoly * resultant(TRIPoly * f,TRIPoly * g,TVariable * x);
TRIPoly * resultantas(TRIPoly * f,TList * as,TList *ord);
TRIPoly * algcd(TRIPoly * f,TRIPoly * g,TList * as,TList * ord);
int igcd(int m,int n);
//-------------------------------------------------------------

TRIPoly * list2tripoly(TList * lpoly)
{
    TRIPoly trip1(1);
    TBigInt exPoly,j;
    int i;
    for (i=1;i<= (lpoly->length());i+=2)
    {
        TRIPoly * tm=(TRIPoly *)(lpoly->Part(i));
        TBigInt exPoly=*((TBigInt *)(lpoly->Part(i+1)));
        for (j=1;j<=exPoly;j=j+1)
        {
            trip1=trip1*(*tm);
        }
    }
    return (new TRIPoly(trip1));
}
TList * CharsetCallcharset_base(TList * ps,TList *ord)
{
    TList * ordR=new TList ();
    int i;
    TVariable * tv1;
    TRIPoly * tp1;
    for (i=ord->length();i>=1;i--)
    {
        tv1=(TVariable *) ord->Part(i);
        ordR->append(tv1->Copy());
    }
    TList * res=charset_base(ps,ordR);
    TList * resR=new TList();
    for (i=res->length();i>=1;i--)
    {
        tp1=(TRIPoly *)(res->Part(i));
        resR->append(tp1->Copy());    
    }
    delete ordR;
    delete res;
    return resR;
}

//===================== Sub Function =========================

#include <stdlib.h>
int wDie()
{
    static int x=0;
    x=x+1;
    return 2+x;  
}

TList * arrange(TList * ps,TVariable * x)
{
    int nps=ps->length();
    char * ok=new char [nps];
    int i,j,idxok;
    TBigInt degp;
    for (i=0;i<nps;i++) ok[i]=1;
    TList * resps=new TList();
    for (i=0;i<nps;i++)
    {
        degp=-1;
        idxok=-1;
        for (j=0;j<nps;j++)
        {
            if ((ok[j])&&((((TRIPoly *)(ps->Part(j+1)))
                            ->Degree(x)<degp)||(degp==-1)))
            {
                degp=((TRIPoly *)(ps->Part(j+1)))->Degree(x);
                idxok=j;
            }
        }
        resps->append(((TRIPoly *)(ps->Part(idxok+1)))->Copy());
        ok[idxok]=0;
    }
    delete [] ok;
    return resps;
}

TList * initialset(TList * as,TList * ord)
{
    TList * is=new TList();
    TList * iss=new TList();
    int i;
    TRIPoly * trp;
    for (i=0;i<as->length();i++)
    {
        TRIPoly ttrp=((TRIPoly *)(as->Part(i+1)))->IPLdCf(ord);
        trp=new TRIPoly(ttrp);
        if ((trp->Classyh(ord))>0) is->append(trp->Copy());
        delete trp;
    }
    TList * tmpis=factorps(is);
    delete is;
    is=tmpis;
    for (i=0;i<is->length();i++)
    {
        trp=(TRIPoly *)(is->Part(i+1));
        if ((trp->Classyh(ord))>0) iss->append(trp->Copy());
    }
    delete is;
    return iss;
}

TRIPoly * movefactor(TRIPoly * f,TRIPoly * g,TList * ord)
{
    if ((g->IPconst())==1) return f->Clone();
    TRIPoly triq,trir,trif,trig;
    trif=*f;
    trig=*g;
    while(1)
    {
        triq=trif/trig;
        trir=trif-triq*trig;
        if (!(trir.IsZero())) return new TRIPoly(trif);
        trif=triq;
    }
}

TRIPoly * movefactorps(TRIPoly * f,TList * ps,TList * ord)
{
    TRIPoly * restri;
    restri=f->Clone();
    int i;
    for (i=0;i<ps->length();i++)
    {
        TRIPoly * tmprestri=movefactor(restri,(TRIPoly *)(ps->Part(i+1)),ord);
        delete restri;
        restri=tmprestri;
    }
    return restri;
}

int linearas(TList * cs,TList * ord)
{
    if (cs->length()==1) return 1;
    int i;
    for (i=1;i<cs->length();i++)
    {
        if (((TRIPoly *)(cs->Part(i+1)))->Degree(
          ((TRIPoly *)(cs->Part(i+1)))->mainvar(ord)) > 1) return 0;
    }
    return 1;
}

TList * factorps(TList * ps)
{
    TList * fres=new TList();
    TList * tmp;
    TRIPoly * tmpele;
    int i,j;
    TList * tf1;
    for (i=0;i<ps->length();i++)
    {
        tf1=((TRIPoly *)(ps->Part(i+1)))->Factorold();
        tmp=translist(tf1);
        for (j=0;j<tmp->length();j+=2)
        {
            tmpele=(TRIPoly *)(tmp->Part(j+1));
            if ((tmpele->IPconst())==0) fres->append(
                new TRIPoly(tmpele->ipipp()));
        }
        delete tmp;
        delete tf1;
    }
    return fres;
}


TList * algcdLL(TRIPoly * f,TRIPoly * g,TList * as,TList * ord)
{

    TList * res=new TList();
    TRIPoly *r1,*r2,*r;
    int nas;
    nas=as->length()+1;
    if ((f->Degree((TVariable *)(ord->Part(nas))) == 0) ||
        (g->Degree((TVariable *)(ord->Part(nas))) == 0))
    {
        res->append(new TRIPoly(1));
        res->append(new TBigInt(1));
        return res;
    }
    r1=f->premas(as,ord);
    r2=g->premas(as,ord);
    if (r1->IsZero())
    {
        delete r1;
        delete r2;
        res->append(g->Copy());
        res->append(new TBigInt(1));
        return res;
    }
    if (r2->IsZero())
    {
        delete r1;
        delete r2;
        res->append(f->Copy());
        res->append(new TBigInt(1));
        return res;
    }
    r=new TRIPoly();
    TRIPoly * xx,*yy;
    while(1)
    {
        TRIPoly * tmpr;
        tmpr=r1->prem(*r2,(TVariable *)(ord->Part(nas)));
        delete r;
        r=tmpr;
        tmpr=r->premas(as,ord);
        delete r;
        r=tmpr;
        if (!(r->IsZero()))
        {
            *r1=*r2;
            *r2=*r;
        }
        if (!(r->IsZero())) continue;
        xx=r2->Coefficient(   (TVariable *)(ord->Part(nas)),
                  r2->Degree( (TVariable *)(ord->Part(nas)) ));
        yy=xx->premas(as,ord);
        if (!(yy->IsZero())) break;
        *r2=(*r2)-(*xx)*TRIPoly( (TVariable *)(ord->Part(nas)),
                      r2->Degree((TVariable *)(ord->Part(nas))));
        delete xx;
        delete yy;
    }
    delete xx;
    delete yy;
    //cout<<"r2=";r2->display();cout<<endl;
    TList * r2f=r2->Factorold();
    TList * r3f=translist(r2f);
    int i;
    TVariable * ordnas=(TVariable *)(ord->Part(nas));
    for (i=1;i<=(r3f->length());i+=2)
    {
        TRIPoly * trip1=(TRIPoly *)(r3f->Part(i));
        if (trip1->Degree(ordnas)  > 0)
        {
            res->append(trip1->Copy());
            res->append( new TBigInt (*(TBigInt *)(r3f->Part(i+1))) );
        }
    }
    delete r1;
    delete r2;
    delete r;
    delete r2f;
    delete r3f;
    return res;
}

TRIPoly * aldivide(TRIPoly * f,TRIPoly * g,TList * as,TList * ord)
{
    TRIPoly *q;
    q=f->pquo(*g,f->mainvar(ord));
    TRIPoly * tmpq=q->premas(as,ord);
    delete q;
    return tmpq;
}

//================== Main Function ========================
int das[6];

TList * factoras(TRIPoly * f,TList * as,TList * ord)
{
    TList * aas;
    TVariable * vf;
    int r,i;
    TVariable * va;
    TRIPoly fn;

    vf=f->mainvar(ord);
    r=as->length();
    if (f->Degree(vf)<=1)
    {
        TList * tttxxx=new TList();
        tttxxx->append(f->Copy());
        tttxxx->append(new TBigInt(1));
        return tttxxx;
    }

    TBigInt isum1=0;
    for (i=0;i<r;i++)
    {
        isum1+=(((TRIPoly *)as->Part(i+1))->Degree(
                ((TRIPoly *)as->Part(i+1))->mainvar(ord)));
    }
    if (f->Degree(vf) < isum1)
    {
        das[0]=-1;
        das[1]=1;
        das[2]=-2;
        das[3]=2;
        das[4]=-3;
        das[5]=555;
    }
    else
    {
        das[0]=1;
        das[1]=-1;
        das[2]=2;
        das[3]=-2;
        das[4]=-3;
        das[5]=555;
    }

    aas=new TList();
    for (i=0;i<r;i++)
    {
        if (((TRIPoly *)as->Part(i+1))->Degree(
            ((TRIPoly *)as->Part(i+1))->mainvar(ord))>1)
            aas->append(((TRIPoly *)as->Part(i+1))->exp_y()->Copy());
    }
    if ((aas->length())==0)
    {
        TList * tttxxx=new TList();
        tttxxx->append(f->Copy());
        tttxxx->append(new TBigInt(1));
        delete aas;
        return tttxxx;
    }


    //Trivial Factorization: Prop. 2
    va = ((TRIPoly *)(aas->Part(1)))->mainvar(ord);
    if(aas->length()==1 && f->Degree(va)==0)
    {
        TList * t;
        t=trivial(f,(TRIPoly *)(aas->Part(1)),vf,va, &fn);
        if(t->length() >2) // trivial success!
        {
            TList * res = new TList();
            for(i=1;i<=t->length();i+=2)
            {
                TList * tl1=factoras((TRIPoly *)(t->Part(i)),as,ord);
                TBigInt * tb1=(TBigInt *)(t->Part(i+1));
                int j;
                for (j=1;j<tl1->length();j+=2)
                {
                    TRIPoly * tp1=(TRIPoly *)(tl1->Part(j));
                    TBigInt * tb2=(TBigInt *)(tl1->Part(j+1));
                    res->append(tp1->Copy());
                    res->append(new TBigInt( (*tb1)*(*tb2) ));
                }
                delete tl1;
            }
            delete t;
            delete aas;
            return res;
        }
        delete t;
    }
    TList * ress=factorassub(f,aas,ord);
    delete aas;
    return ress;
}

TList * factorassub(TRIPoly * f,TList * as,TList * ord)
{
    int nas,die,ncs,i,j;
    TBigInt con,m,n;
    TVariable * vf;
    TList * nord,* mord,* ci,*cr,*cs,*is,*cstmp,*ccs,*CS;
    TRIPoly * fff,*ff;
    TList * cc;
    TRIPoly der;
    nas=as->length();
    vf=f->mainvar(ord);
    nord=new TList();
    nord->append(vf->Copy());
    mord=new TList();
    for (i=0;i<nas;i++)
    {
        nord->append(((TRIPoly *)(as->Part(i+1)))->mainvar(ord)->Copy());
        mord->append(((TRIPoly *)(as->Part(i+1)))->mainvar(ord)->Copy());
    }
    mord->append(vf->Copy());
    con=0;
    for (i=0;i<nas;i++)
        con+=(f->Degree((TVariable *)(nord->Part(i+2))));
    if ((con==0)&&(nas==1)) // Prop. 1
    {
        m=((TRIPoly *)as->Part(1))->Degree((TVariable *)(nord->Part(2)));
        n=f->Degree(vf);
        if (igcd(m,n)==1)
        {
            TList * tttxxx=new TList();
            tttxxx->append(f->Copy());
            tttxxx->append(new TBigInt(1));
            delete nord;
            delete mord;
            return tttxxx;
        }
    }
    ci=new TList();
    cr=new TList();
    fff=f->Clone();
    ff=f->Clone();
    ccs=new TList();
    is=new TList();
    cs=new TList();
    while(1)
    {
        if (con !=0)
        {
            der=TRIPoly(111);
            der=der-der;
            TRIPoly * tmpff=f->Clone();
            delete ff;
            ff=tmpff;
            con=0;
        }
        else
        {
            if (das[0]!=555)
            {
                die=das[0];
                int iii;
                for (iii=0;iii<5;iii++)
                    das[iii]=das[iii+1];
            }
            else
            {
                die=wDie();
                if (die > 8)
                {
                    delete fff;
                    delete ff;
                    TList * tttxxx=new TList ();
                    tttxxx->append(f->Copy());
                    tttxxx->append(new TBigInt(1));
                    delete ci;
                    delete cr;
                    delete ccs;
                    delete is;
                    delete cs;
                    delete nord;
                    delete mord;
                    return tttxxx;
                }
            }
            der=TRIPoly(111);
            der=der-der;
            for (i=2;i<=nord->length();i++)
            {
                der=der+TRIPoly(i-die-2)*
                        TRIPoly((TVariable *)(nord->Part(i)),1);
            }

            TRIPoly * t1ff=f->IPvtp(vf,der+TRIPoly(vf,1));
            delete ff;
            ff=t1ff;
        }
        TList * tttxxx=as->Clone();
        tttxxx->append(ff->Copy());
        delete ccs;
        ccs=CharsetCallcharset_base(tttxxx,nord);
        delete tttxxx;
        delete is;
        is=initialset(ccs,nord);
        TRIPoly * tp1=movefactorps((TRIPoly *)(ccs->Part(1)),is,ord);
        cstmp=tp1->Factorold();
        delete  tp1;
        TList * csY = translist(cstmp);
        delete cstmp;
        delete cs;
        cs=new TList();
        for (i=1;i<= csY->length();i+=2)
        {
            cs->append(((TRIPoly *)(csY->Part(i)))->Copy());
        }

        delete csY;
        if (cs->length() != 0)
        {
            if (linearas(ccs,nord) || (cs->length()>1))
            {
                ncs=cs->length();
                TList * tt1;
                tt1=arrange(cs,vf);
                delete cs;
                cs=tt1;
                tt1=arrange(is,vf);
                delete is;
                is=tt1;
                for (i=0;i<is->length();i++) 
                    cs->append(((TRIPoly *)(is->Part(i+1)))->Copy());
                CS=new TList();
                for (i=0;i<cs->length();i++)
                {
                    CS->append(((TRIPoly *)(cs->Part(i+1)))->
                                     IPvtp(vf,TRIPoly(vf,1)-der));
                }

                //================================================
                //If CS=[a1,a2,a3,...], then CSnew=[a2,a1,a3,...].
                //The following statements can be ignored.
                //================================================
                //TList * CSnew =  new TList();
                //CSnew->append((TRIPoly *)(CS->Part(2))->Copy());
                //CSnew->append((TRIPoly *)(CS->Part(1))->Copy());
                //for(i=3;i<=CS->length();i++)
                    //CSnew->append((TRIPoly *)(CS->Part(i))->Copy());
                //delete CS;
                //CS=CSnew->Copy();
                //delete CSnew;
                //================================================

                for (i=0;i<CS->length();i++)
                {
                    cc=algcdLL(fff,((TRIPoly *)(CS->Part(i+1)))->
                                          exp_y(),as,mord);
                    for (j=1;j<=cc->length();j+=2)
                    {
                        TRIPoly *trip2=(TRIPoly *)(cc->Part(j));
                        TBigInt *etri2=(TBigInt *)(cc->Part(j+1));
                        if (trip2->Degree(vf) > 0)
                        {
                            TRIPoly * tmpfff=aldivide(fff,trip2,as,mord);
                            delete fff;
                            fff=tmpfff;
                            if (trip2->Degree(vf)==1)
                            {
                                ci->append(trip2->Copy());
                                ci->append(new TBigInt(*etri2));
                            }
                            else
                            {
                                if (i+1<=ncs)
                                {
                                    ci->append(trip2->Copy());
                                    ci->append(new TBigInt(*etri2));
                                }
                                else
                                {
                                    cr->append(trip2->Copy());
                                    cr->append(new TBigInt(*etri2));
                                }
                            }
                        }
                    }
                    delete cc;
                }
                delete CS;
                if ((ci->length()>0)||(cr->length() >2)||
                     ((cr->length() ==2)&& 
                     ((((TRIPoly *)(cr->Part(1)))->Degree(vf))<
                        (f->Degree(vf))))) break;
            }
        }
    }
    delete cs;
    delete is;
    delete ccs;
    TBigInt tbitmp=fff->Degree(vf);
    if (tbitmp >1)
    {
        cr->append(fff->Copy());
        cr->append(new TBigInt(1));
    }
    else
    {
        if (tbitmp ==1) 
        {
            ci->append(fff->Copy());
            ci->append(new TBigInt(1));
        }
    }
    TList * res;
    res=ci;
    for (i=1;i<cr->length();i+=2)
    {
        TList * tfasub=factorassub((TRIPoly *)(cr->Part(i)),as,ord);
        TBigInt xx=*((TBigInt *)(cr->Part(i+1)));
        TBigInt xtm;
        for (j=1;j<= tfasub->length();j+=2)
        {
            xtm=*((TBigInt *)(tfasub->Part(j+1)));
            xtm=xx*xtm;
            res->append(((TRIPoly *)(tfasub->Part(j)))->Copy());
            res->append(new TBigInt(xtm));
        }
        delete tfasub;
    }
    delete cr;
    delete fff;
    delete ff;
    delete nord;
    delete mord;
    return res;
}
//------------------------------------------

//Usage: l=f->Factor(); l=translist(l);
//Ex: l: [[1],1,[p11,p12],e1,[p21,p22,p23],e2,[p3],e3]
//    translist(l): [p11,e1,p12,e1,p21,e2,p22,e2,p23,e2,p3,e3]
TList * translist(TList * l)
{  
    int i,j;
    TList * tttxxx=new TList();
    for (i=3;i<=l->length();i+=2)
    {
        TList * tmpl=(TList *)(l->Part(i));
        TBigInt * tmpexp=(TBigInt *)(l->Part(i+1));
        for (j=1;j<= (tmpl->length());j++)
        {
            TRIPoly * tmpm=(TRIPoly *)(tmpl->Part(j));
            if ((tmpm->IPconst())==0)
            {
                tttxxx->append(tmpm->Copy());
                tttxxx->append(new TBigInt(*tmpexp));
            }
        }
    }
    return tttxxx;
}

TList * trivial(TRIPoly * ff,TRIPoly * aa,TVariable * vf,
                TVariable * va,TRIPoly * fn)
{
    TRIPoly *f,*a;
    TList * ss;
    int i;
    unsigned short da,df;
    TVariable * z=new TVariable("_xy_z");

    f=ff->exp_y();
    a=aa->exp_y();
    da=a->Degree(va);
    df=f->Degree(vf);

    TRIPoly * tp1=(a->ipipp()).IPvtp(va,TRIPoly(vf,1));

    if ((( (f->ipipp()) - *tp1 ).IsZero())
             &&(f->PolyLen()>2))
    {
         *fn=TRIPoly(1);
         ss=new TList();
         ss->append(f->Coefficient(vf,da));
         int dfff;
         dfff=df;
         if (df < 0) { cout<<"SIGN"<<endl; dfff=abs(dfff);}
         for (i=dfff-1;i>=0;i--)
         {
             TRIPoly * tp2=f->Coefficient(vf,i);
             ss->insert(1,new TRIPoly(
                 (*((TRIPoly *)(ss->Part(1)))*TRIPoly(va,1)+
                     (*tp2))
                 ));
                       // insert ahead !!
             delete tp2;
         }
         TRIPoly xx=TRIPoly(111);
         xx=xx-xx;
         for (i=1;i<=df;i++)
         {
              xx=xx+(*((TRIPoly *)(ss->Part(i+1))))*TRIPoly(vf,i-1);
         }
         delete ss;
         delete z;
         delete tp1;
         TList * tttxxx=new TList();
         tttxxx->append(new TRIPoly(TRIPoly(vf,1)-TRIPoly(va,1)));
         tttxxx->append(new TBigInt(1));
         tttxxx->append(new TRIPoly(xx));
         tttxxx->append(new TBigInt(1));
         return tttxxx;
    }
    delete tp1;

    TRIPoly x1=TRIPoly(111);
    TRIPoly x2=TRIPoly(111);
    x1=x1-x1;
    x2=x2-x2;

    for (i=0;i<=da;i++)
    {
        tp1=a->Coefficient(va,i);
        x1=x1+TRIPoly(z,da-i)*TRIPoly(va,i)*(*tp1);
        delete tp1;
    }

    for (i=0;i<=df;i++)
    {
        tp1=f->Coefficient(vf,i);
        x2=x2+TRIPoly(z,df-i)*TRIPoly(vf,i)*(*tp1);
        delete tp1;
    }

    TRIPoly * rbx;

    rbx=x2.premB(&x1,z,fn);

    if ((rbx->Degree(z))==0)
    {
        TList * rbxf=rbx->Factorold();
        TList * tttxxx=translist(rbxf);
        delete z;
        delete rbx;
        delete rbxf;
        return tttxxx;
    }
    TList * tttxxx=new TList();
    tttxxx->append(f->Copy());
    tttxxx->append(new TBigInt(1));
    delete z;
    delete rbx;
    return tttxxx;
}

//----------------------------------
TPoly * TRIPoly2TPoly(TRIPoly * trip)
{
    TPoly tpRes(110);
    tpRes=tpRes-tpRes; //?
    TRIPoly p=*trip;
    TRIPoly lbtTRi=p.IPlbt();


    while(!(lbtTRi.IsZero()) )
    {
        p=p-lbtTRi;

        TRIPoly lbtTRi1=lbtTRi;
        TPoly tpRes1=TPoly(lbtTRi.IPlbcf());
        while ((lbtTRi1.deg()) != 0 )
        {
            TVariable * v=lbtTRi1.MainVar();
            tpRes1=tpRes1*TPoly(TMono(v,lbtTRi1.Degree(v)));
            lbtTRi1=lbtTRi1.IPldcf();
        }
        tpRes=tpRes+tpRes1;
        lbtTRi=p.IPlbt();
    }
    return new TPoly(tpRes);
}

TRIPoly * TPoly2TRIPoly(TPoly * tp)
{
    TPolyCell * pc;
    TRIPoly trip(100);
    trip=trip-trip;
    pc=tp->rep;

    while(pc != NULL)
    {
        TBigInt tbn;
        switch((pc->lcoef).TypeID())
        {
            case  BaseNumber:           
                tbn=(pc->lcoef).GetInt();
                if ((pc->lcoef)<0) tbn=-tbn;
                break;
            case  BigNumberType:        
                tbn=*((TBigInt *)(&(pc->lcoef)));
                break;
            default:
                tbn=100;
                tbn=tbn-tbn;
                break;
        }
        TRIPoly trip1(tbn);
        TMonoCell * tm;
        tm=pc->lmono->rep;
        while(tm != NULL)
        {
            TRIPoly m(tm->var,(tm->deg)->GetShort(0));
            trip1=trip1*m;
            tm=tm->next;
        }
        trip=trip+trip1;
        pc=pc->next;
    }
    return new TRIPoly(trip);
}

TList * tripoly_charset(TList * ps,TList * ord)
{
    int i;
    TList * tt=new TList();
    for (i=0;i<ps->length();i++)
    {
        tt->append(TRIPoly2TPoly((TRIPoly *)(ps->Part(i+1))));
    }
    TList * ree=poly_charset(tt,(TVarList *)ord);
    delete tt;
    tt=new TList ();
    for (i=0;i<ree->length();i++)
    {
        tt->append(TPoly2TRIPoly( (TPoly *)(ree->Part(i+1)) ));
    }
    delete ree;
    return tt;
}

/*
TRIPoly TRIPoly::ipipp()
{
    TBigInt connn;
    connn=this->icont();
    if (connn != 1) return (*this)/connn;
    return *this;
}
*/
TRIPoly * resultant(TRIPoly * f,TRIPoly * g,TVariable * x)
{
    TRIPoly r1,r2,r;
    r1=*(f->Clone());
    r2=*(g->Clone());
    while(r2.Degree(x)>0)
    {
        r=*(r1.prem(r2,x));
        r1=r2;
        r2=r;
    }
    return new TRIPoly(r2);
}


TRIPoly * resultantas(TRIPoly * f,TList * as,TList *ord)
{
    TRIPoly * res;
    int i;
    res=f->Clone();
    for (i=as->length();i>0;i--)
    {
        res=resultant(res,(TRIPoly *)as->Part(i),((TRIPoly *)(as->Part(i)))
                     ->mainvar(ord));
    }
    return res;
}

TRIPoly * algcd(TRIPoly * f,TRIPoly * g,TList * as,TList * ord)
{
    TRIPoly *r1,*r2,*r;
    int nas;
    nas=as->length()+1;
    if ((f->Degree((TVariable *)(ord->Part(nas))) == 0) ||
        (g->Degree((TVariable *)(ord->Part(nas))) == 0))
    return new TRIPoly(1);
    r1=f->Clone();
    r2=g->Clone();
    while(1)
    {
        r=r1->prem(*r2,(TVariable *)(ord->Part(nas)));
        //r=r->premas(as,ord);
        if (resultantas(r,as,ord)->IsZero()) break;
        r1=r2;
        r2=r;
    }
    if (resultantas(r2->Coefficient((TVariable *)(ord->Part(nas)),
                    r2->Degree((TVariable *)(ord->Part(nas)))),
                    as,ord)->IsZero())
    return new TRIPoly(1);
    return r2;
}

int igcd(int m,int n)
{
    int ma=abs(m);
    int na=abs(n);
    if (ma==0) return na;
    if (na==0) return ma;
    int itmp;
    while(1)
    {
        itmp=ma %na;
        if (itmp == 0) return na;
        ma=na;
        na=itmp;
    }
}


//=============== Function Member in class TRIPoly ====================

int TRIPoly::Classyh(TList * ord)
{
    int i;
    for (i=ord->length()-1;i>=0;i--)
    {
        if (this->Degree((TVariable *)(ord->Part(i+1)))>0)
        return i+1;
    }
    return 0;
}

TRIPoly * TRIPoly::premB(TRIPoly * vv,TVariable * x,TRIPoly * fn)
{
    TRIPoly * r,*v;
    TRIPoly l,g,lu,lv,t,gn;
    unsigned short dr,dv;
    TRIPoly * tp1;
    if ((((*vv)/TRIPoly(x,1)).IPconst())==1)
    {
        *fn=TRIPoly(1);
        TBigInt xt(111);
        xt=xt-xt;
        return this->IPvri(x,xt);
    }
    else
    {
        gn=TRIPoly(1);

        r=this->exp_y()->Clone();
        dr=r->Degree(x);
        v=vv->exp_y();
        dv=v->Degree(x);

        if (dv<=dr)
        {
            tp1=v->Coefficient(x,dv);
            l=*tp1;
            delete tp1;
        }
        else
            l=TRIPoly(1);

        while ((dv<=dr)&&(!(r->IsZero())))
        {
            tp1=r->Coefficient(x,dr);
            g=l.mipgcd(*tp1);
            delete tp1;
            lu=l/g;
            tp1=r->Coefficient(x,dr);
            lv=(*tp1)/g;
            delete tp1;
            t=*((TRIPoly(x,dr-dv) * (*v) * lv).exp_y());
            if (dr == 0)
            {
                TBigInt xt(111);
                xt=xt-xt;
                *r=TRIPoly(xt);
            }
            *r=*((lu*(*r)).exp_y())-t;
            gn=gn*lu;
            dr=r->Degree(x);
        }
        *fn=gn;
        return r;
    }
}


TRIPoly * TRIPoly::premA(TRIPoly * vv,TVariable * x)
{
    TRIPoly * r,*v;
    TRIPoly l,g,lu,lv,t;
    unsigned short dr,dv;
    TRIPoly * tp1;
    if ((((*vv)/TRIPoly(x,1)).IPconst())==1)
    {
        TBigInt xt(111);
        xt=xt-xt;
        return this->IPvri(x,xt);
    }
    else
    {
        r=this->exp_y()->Clone();
        dr=r->Degree(x);
        v=vv->exp_y();
        dv=v->Degree(x);

        if (dv<=dr)
        {
            tp1=v->Coefficient(x,dv);
            l=*tp1;
            delete tp1;
        }
        else
            l=TRIPoly(1);

        while ((dv<=dr)&&(!(r->IsZero())))
        {
            tp1=r->Coefficient(x,dr);
            g=l.mipgcd(*tp1);
            delete tp1;
            lu=l/g;
            tp1=r->Coefficient(x,dr);
            lv=(*tp1)/g;
            delete tp1;
            t=*((TRIPoly(x,dr-dv) * (*v) * lv).exp_y());
            if (dr == 0)
            {
                 TBigInt xt(111);
                 xt=xt-xt;
                 *r=TRIPoly(xt);
            }
            *r=*((lu*(*r)).exp_y())-t;
            dr=r->Degree(x);
        }

        return r;
    }
}


//The remainder of a polynomail w.r.t an ascending set as
TRIPoly * TRIPoly::premas(TList * as,TList * ord)
{
    TRIPoly * remd;
    TRIPoly * tp1;
    int i;
  
    remd=this->Clone();
  
    for(i=as->length();i>0;i--)
    {
        //remd = remd->prem(*((TRIPoly *)(as->Part(i))),
        //       ((TRIPoly *)(as->Part(i)))->mainvar(ord));
        tp1 = remd->premA((TRIPoly *)(as->Part(i)),
                   ((TRIPoly *)(as->Part(i)))->mainvar(ord));
        *remd = *tp1;
        delete tp1;
    }

    if(remd->IsZero())
    {
        TBigInt xt(111);
        xt=xt-xt;
        delete remd;
        return new TRIPoly(xt);
    }
    TRIPoly tp=remd->ipipp();
    delete remd;
    return new TRIPoly(tp);
}


TRIPoly * TRIPoly::exp_y()
{
    return this;
}


