

%{
#ifdef _WINDOWS
#include "..\stdafx.h"
#include "afxmt.h"
#include "..\gui\index.h"
#include "basetype.h"
extern bool succeed;
extern bool NewItem;
extern HWND hWnd;
extern  int WM_OUTPUT;
#endif

#include <malloc.h>
#include "number.h"
#include "poly.h"
#include "trpoly.h"
#include "pol.h"
#include "express.h"
#include "lang.h"
#include <time.h>
#include <sys/timeb.h>
#include "stacks.h"
#include "lists.h"
#include "vectors.h"
//#include "matrix.h"
#include "charset.h"
#include "tbl2listtvariable.h"
#include "fstream.h"
//extern short Digits;  
	// For the precision of TFloatNum; defined in number0.h
extern int switch_to_file(char *);
extern int switch_to_string(char *);

extern "C"{
void main1(int argc, char* argv[]);
}
extern TRunStackPState * savestack;
extern PState    *workpstat;
extern Tbl2ListTVariable *TempSymTbl;
extern Tbl2ListTVariable 	*SymTbl;
extern int yylex(void);
extern TRunType Expand(TList *l);

#define WRUN	(workpstat->runlist)
#define WMODE	(workpstat->mode)
#define WVAR	(workpstat->vartbl)

//#define TIME_DEBUG
//#define SHOW_LEFT
//#define __SHOW_CLAUSES__IF__
//#define __SHOW_CLAUSES__FOR__
//#define __SHOW_CLAUSES__WHILE__
//#define __SHOW_CLAUSES__PROC__
//#define __SHOW_CLAUSES__SWITCH__
//#define __SHOW_CLAUSES__DEFINE__
//#define __SHOW_CLAUSES__ASSIGN__

struct timeb first,last;
int yyerror(char *s);
void TimeUsed(const char *ss="",timeb s=first, timeb e=last);
bool prresult=1, run=1;
%}

%union {
	int count;
	TString		*string;
	TAtom 		*val;
	TNumber 	*numval;
	TVariable 	*symval;
	TLogOperator 	logval;
	TBoolCell 	*logexp;
	TExpTerm 	*expterm;
	TExpression 	*expval;
	TIfClause 	*ifclause;
	TRun 		*clause;
	TProcDef 	*procdef;
	TProcCall 	*procall;
	TListCall 	*listcall;
	TList 		*tList;
	TVector 	*tvector;
	TVarList	*vList;
	TRunList	*rlist;
	TCaseClause	*tcase;
	TCaseList	*cList;
	TParseMode	pmode;
	}
%token NUMBER SYMBOL SPEFUNC QSTRING PRECISION
%token DEFINE ASSIGN DECOP INCOP END PROC RETURN
%token IF THEN ELSE ELSEIF FI DO OD WHILE FOR SWITCH CASE DEFAULT 
%token CONTINUE BREAK
%token FROM TO STEP GLOBAL LOCAL
%token EQ GT GE LT LE NE AND OR NOT
%token LIST SET VECTOR
%token READ WRITE PRINT
%token CHARSET ASCSET
%token POINT LINE CIRCLE TRIANGLE RECT
%token GTHEOREM

%type <count>   global_command local_command 
%type <numval> 	NUMBER number 
%type <val>    	atom atom_expression term expression
%type <logexp> 	logic_exp
%type <symval> 	variable SYMBOL SPEFUNC CHARSET ASCSET
%type <expterm> 
%type <expval> 	
%type <logval> 	logic_op EQ GT GE LT LE NE AND OR NOT
%type <ifclause> if_clause_head if_clause else_if_head else_if 
%type <clause>  command assign while_clause switch_clause
%type <clause>  for_clause 
%type <rlist> 	assign_list
%type <procdef> proc_def proc_def_head 
%type <procall> proc_call
%type <listcall> list_call
%type <vList>  	para_list order_expression
%type <tList>  	exp_list list_expression exp_listlist
%type <tcase>	case_clause default_clause
%type <cList>	case_list
%type <string>	str QSTRING 
%type <tvector>   vector_exp


%left AND OR 
%left '+' '-'
%left '.'
%left '*' '/'
%nonassoc '^'
%nonassoc '!'
%nonassoc UMINUS
%%
commandlist: {}
		| commandlist command { 
		if (WRUN) {
			if ($2==0) break;
			WRUN->append($2);
			}
		else{
#ifdef CONSOLE
			printf(">");
#else
		succeed=true;
		::SendMessage(hWnd,WM_OUTPUT,0,0);
#endif
		}
		}
            ;
command: PRECISION  number tail
         { Digits= $2->GetInt();
           delete $2;
           $$=0;
         }
		 | expression tail {
		if ($1==0) {
			$$=0; 
			break;
			}
		if(WMODE==PNormal && !WRUN) 
			{
			if(prresult){
			$1->display();
			wout<<endl;
#ifdef _WINDOWS
            ::SendMessage (hWnd,WM_OUTPUT,0,0);
#endif
			}
			if ($1->TypeID() !=Variable) 
				delete $1;
			$1=0;
			}
		else {
			$$=new TPrint($1);
			break;
			}
	//	TempSymTbl->initial(1);
#ifdef SHOW_LEFT
              StarMem->ShowLeft();
              StackMem->ShowLeft();
#endif
		}
		| logic_exp tail
		{ 
		if(WMODE==PNormal && !WRUN) 
			{
			int t=$1->Run(); 
			if (t==TBOOLTRUE) wout<<"True\n";
			else if (t==TBOOLFALSE) wout<<"False\n";
			else wout<<"Error!\n";
			delete $1;$1=0;
			}
			else 
			$$=$1;
		}
		| if_clause tail
			{ 
		//wout<<endl<<"IF BEGIN\n";
#ifdef __SHOW_CLAUSES__IF__
		//$1->display();
#endif
		//wout<<"IF END\n";
			if(WMODE==PNormal && WRUN==NULL) 
				{delete $1; $1=0;}
			else $$=$1;

		//if(WMODE==PNormal)
		//TempSymTbl->initial(1);
			}
		| while_clause tail {
			if(WMODE==PNormal && WRUN==NULL) {delete $1; $1=0;}
			else $$=$1;
			}
		| for_clause tail{
			if(WMODE==PNormal && WRUN==NULL) {delete $1;$1=0;}
			else $$=$1;
                }
		| switch_clause tail{ 
	        if(WMODE==PNormal && WRUN==NULL) {delete $1;$1=0;}
            else $$=$1;
			}
		| BREAK tail
			{
			if (WMODE==PNormal && WRUN ==0) break;  
			$$=new TBreak;
			}
		| CONTINUE tail 
			{
			if (WMODE==PNormal && WRUN ==0) break;  
			$$=new TContinue;
			}
		| RETURN tail 
			{ 
			if (WMODE==PNormal && WRUN ==0) break;  
			$$=new TReturn;
			}
		| RETURN '(' atom_expression ')' tail
			{
			if (WMODE==PNormal && WRUN ==0) break;  
			$$=new TReturn($3);
			}
	| error tail { 	//WRUN->display();
			//savestack->display();
			wout<<"Error, `;` unexpected"<<endl; }
	| READ '(' str ')' tail {
                //switch_to_file($3);
				switch_to_file($3->GetStr());
                }
	| WRITE '(' variable ',' str ')'  tail 
		{
#ifdef CONSOLE
		ofstream out($5->GetStr());
		if ($3->type==TVARIABLE && $3->value.poly)
			$3->value.poly->display(out);
			out<<endl;
		out.close();
#endif
		}
    | PRINT '('  str ')'  tail
         {
           //$$=new TPrint(new TString( $3) );
			$$=new TPrint($3);
         }
	| PRINT '(' variable ')' tail
         {
			TAtom *a=$3->eval();
//          a->display();
//			wout<<endl;
            delete a;
//          delete $3;
         }
	| gstatement {}
	| GTHEOREM '{' gstatement_list '}' tail {}
	| SYMBOL DEFINE proc_def tail  { 
		if ($1->GetType()!=TSYMBOL) {
			$1->ClearValue();
			$1->SetType(TPROCEDURE);
			}
		$1->SetValue($3);
		$1->display();
		wout<<":=";
		$3->display();
		wout<<endl;
		}
	| assign tail {}
        | tail {}
	;
tail:	';' 
			{  prresult = 1; } 
	;
assign_list: {$$=new TRunList();}
	| assign 
		{
		$$=new TRunList();
		$$->append($1);
		}
	| assign_list ',' assign 
		{
		$$=$1;
		$$->append($3);
		}
	;
assign:	  SYMBOL DEFINE  atom_expression { 
		// should check the type of the variable
                //if($3->TypeID()==ListType)
                 if ( IsListClass($3) )
                 {
                  $1->SetType(TLIST);
                  $1->type= TLIST;
                  $1->SetValue($3);
                  break;
               }else
		if ($1->type!=TSYMBOL)
                     	 {
                           $1->SetType(TVARIABLE); 
			}
		if (WRUN || WMODE != PNormal)
			$$=new TDefine($1,$3);
		else {
			$1->SetValue($3);
#ifdef __SHOW_CLAUSES__DEFINE__
			if(prresult){
			$1->display();
			wout<<":=";
			$3->display();
			wout<<endl;
			}
#endif
			$$=0;
			}
		}
	| SYMBOL ASSIGN atom_expression { 
                //if($3->TypeID()==ListType)
                 if ( IsListClass($3) )
                 {
                  $1->SetType(TLIST);
                  $1->type= TLIST;
                  $1->SetValue($3);
                  break;
               }else
		// should check the type of the varaibel
		if ($1->type !=TSYMBOL) {
                           $1->SetType(TVARIABLE); 
			}
		if (WRUN || WMODE != PNormal)
			$$=new TAssign($1,$3);
		else {
			$1->SetValue($3);
#ifdef __SHOW_CLAUSES__ASSIGN__
			if(prresult){
			$1->display();
			wout<<"=";
			$3->display();
			wout<<endl;
			}
#endif
			}
		}
	| variable INCOP {}
	| variable DECOP {}
	| INCOP variable {}
	| DECOP variable {}
	| '(' assign_list ')' {}
	;
atom_expression: expression 
		{
		$$=$1;
		}
	;
logic_op: EQ { $$=$1; }
	| NE { $$=$1; }
	| GE { $$=$1; }
	| LE { $$=$1; }
	| LT { $$=$1; }
	| GT { $$=$1; }
	;
logic_exp: expression logic_op expression 
		{
		$$=new TLogicExp($1,$3,$2);
		}
	| '(' logic_exp ')'
		{$$=$2;}
	| logic_exp AND logic_exp
		{
		$$=new TBoolExp((TLogicExp *)$1,(TLogicExp *)$3,TAND);
		}
	| logic_exp OR logic_exp
		{
		$$=new TBoolExp((TLogicExp *)$1,(TLogicExp *)$3,TOR);
		}
	| '!' '(' logic_exp ')'
	   {
		$$=new TBoolExp((TLogicExp *)$3,0, TNOT);
		}
	;
list_expression: '[' exp_list ']' 
		{
		$$=$2;
		}
		
	| LIST '(' exp_list ')' 
		{
		$$=$3;
		}
		;
 
order_expression: LT para_list GT
		{
		$$=$2;
		}
	;
/*
order_list:  variable {
			$$=new TVarList();
			$$->append($1);
			}
		| para_list GT variable 
		{
 		$1->append($3); 
		$$=$1;
		}
		;
*/
expression: term { $$=$1; }
	| '-' term %prec UMINUS { 
		$$=uminus($2);
		}
        | expression '.' expression{
               $$=ip($1,$3);
        }
	| expression '+' expression {
		$$=add($1,$3);
		break;
		}
	| expression '-' expression {
		$$=add($1,uminus($3));
		break;
		}
	;
term:	  atom { $$=$1;}
	| term '*' term { 
		$$=mul($1,$3);
		}
	| term '/' term {
		$$=div($1,$3);
		}
	| atom '^' atom {
		$$=exp($1,$3);
		}
 	;
atom:	  variable {
	      	if (WMODE==PNormal && \
		 ($1->type==TVARIABLE || $1->type==TLIST) && $1->GetValue())
			{
			TAtom *v=$1->GetValue();
			$$ =v->Copy();
			}
		else if (WMODE==PNormal && $1->type==TPROCEDURE && 
					$1->GetProc()) 
			{
			$$=$1->GetProc()->Copy();
			break;
			}
		else if ($1->type==TSYMBOL) {
			//$$=new TPoly(TMono($1, &TBigInt("1")));
			$$=new TRIPoly($1, 1);
			}
		else  
			$$=$1;
			//$$=new TRIPoly($1, &TBigInt("1"));
			}
		| number {
			$$=$1;
			}
		| str {
			$$=$1;
			//tstr = $1;
			}
		| atom '!' {
		   $$=new TFactorial($1);
			}
		| '(' expression ')'{ $$=$2; }
		| vector_exp {
			$$=$1;
			}
		| vector_exp '\''{
			$1->type=!$1->type;
			$$=$1;
			}
		| proc_call 
			{
			TVarType dt=$1->GetName()->type;
			if (WMODE==PNormal && WRUN == 0)
				{
                if( dt != TSYSFUNCTION)
					if ($1->GetName()->type != TPROCEDURE || 
							!$1->IsDefined()) 
					{
					$$=$1;
					break;
					}
				//if(run==1) 	
					$$=$1->eval();
				//else ReturnValue = NULL;
				delete $1;
				}
			else  $$=$1;
		  	}
		| list_call 
			{
			TVarType dt=$1->GetName()->type;
			if (WMODE==PNormal && WRUN == 0)
				{
/*                 if(dt !=TLIST || !$1->IsDefined()) {
					$$=$1;
					break;
					}
*/				$$=$1->eval();
				delete $1;
				}
			}
		| order_expression {
			$$=$1;
			}
		| list_expression {
			$$=$1;
			}
		;
	proc_call: variable '(' exp_list ')' 
			{
				TVariable *n;
		    	n =SymTbl->lookup($1->GetName() );
		    	if (!n) 
				{
				 	n=$1->Clone();
				 	if(SymTbl!=workpstat->vartbl)
		    		 	SymTbl->append(n);
				}
                else {
                        //wout<<"FOUND"<<n<<" :";
                     if(SymTbl!=workpstat->vartbl)
                     {
                        if(n!=$1)  workpstat->vartbl->remove($1);
                     }
                }
                if(n->type!= TSYSFUNCTION && n->type !=TLIST)
                {
                     n->order=SymTbl->Total+1;
                     n->SetType(TPROCEDURE);
                }
				else
                {
                     //Check Sys-function
                     if(  !$1->SysFuncCHK($3) )
                     {   run=0;
						 //wout<<"error  number of call \n";
                         //yyerror("error  number in call");
                     }
					 else run=1;
                }
				$$=new TProcCall(n,$3);
			}
		; 
	list_call: variable '[' exp_list ']' {
                        $$=new TListCall($1,$3);
                        break;
                        }
		;
	global_command: {$$=0;}
		| GLOBAL para_list ';' 
		{
		 $$=$2->length();
		 $2->Clear(); delete $2; $2=0;
		}
		; 
	local_command:{$$=0;} 
		| LOCAL para_list ';' 
		{
		 $$=$2->length(); 
		 $2-> Clear();delete $2; $2=0;
		}
		;
	proc_def_head: PROC 
			{
                	$$=new TProcDef();
			workpstat=new PState(PProcDef,WVAR);
			savestack->PUSH(workpstat);
			WVAR=$$->GetVar();
			WMODE=PProcDef;
                	}
			'(' para_list ')'
			{
			$$=$<procdef>2;
			$$->SetPVnum($4->length());
		 	$4-> Clear(); delete $4; $4=0;
			WRUN=$$->GetDo();
			}
			;
	proc_def: proc_def_head global_command local_command
		  commandlist END 
			{
			workpstat=savestack->POP();
			$1->SetGVnum($2);
			$$=$1;
#ifdef __SHOW_CLAUSES__PROC__
			//$$->display();
#endif
			}
		;
	exp_listlist: exp_list{
	         $$=new TList();
		 $$->append((TAtom*)$1);
		}
		| exp_listlist tail exp_list
		{ $1->append((TAtom*)$3);
		  $$=$1;
                }
		;
	exp_list:
		{
		 $$=new TList;
		}
		| atom_expression 
		{
		 $$=new TList;
 		 $$->append($1); 
		}
		| exp_list ',' atom_expression 
		{
 		 $$->append($3); 
		}
		;
	para_list:
		{
		$$=new TVarList();
		}
		| variable {
			$$=new TVarList();
			$$->append($1);
			}
		| para_list ',' variable 
		{
 		$1->append($3); 
		$$=$1;
		}
		;
	else_if_head: ELSEIF '(' logic_exp ')' 
			{ 
			$$=new TIfClause;
			$$->SetBool($3);
			workpstat=new PState(WMODE,WVAR);
			savestack->PUSH(workpstat);
			WRUN=$$->GetThen();
			}
		;
	else_if: else_if_head commandlist
			{
			$$=$1;
			workpstat=savestack->POP();
			}
		| else_if_head commandlist ELSE 
			{
			//savestack->PUSH(workpstat);
			//workpstat=new PState(WMODE,WVAR);
			WRUN=$1->GetElse();
			}
		  commandlist
			{
			$$=$1;
			workpstat=savestack->POP();
			//WRUN=0;
			}
		| else_if_head commandlist 
			{
			WRUN=$$->GetElse();
			}
		  else_if 
			{
			$$=$1;
			WRUN->append($4);
			workpstat=savestack->POP();
			}
		;
	if_clause_head: IF 
			{
			workpstat=new PState(WMODE,WVAR);
			savestack->PUSH(workpstat);
			WMODE=PExplain;
			}
		'(' logic_exp ')' 
			{ 
			$$=new TIfClause;
			$$->SetBool($4);
			WRUN=$$->GetThen();
			}
			;
	if_clause: if_clause_head commandlist FI
			{
			$$=$1;
			workpstat=savestack->POP();
			if(WMODE== PNormal && !WRUN) $$->Run();
			}
		  | if_clause_head commandlist ELSE 
			{
			WRUN=$1->GetElse();
			}
		  commandlist FI
			{
			$$=$1;
			workpstat=savestack->POP();
			if(WMODE== PNormal && !WRUN) $$->Run();
			}
		| if_clause_head commandlist 
			{
			WRUN=$$->GetElse();
			}
		  else_if FI 
			{
			$$=$1;
			WRUN->append($4);
			workpstat=savestack->POP();
			if(WMODE== PNormal && !WRUN) $$->Run();
			}
		;
	for_clause: FOR variable FROM number TO number DO
			{

			workpstat=new PState(WMODE,WVAR);
			savestack->PUSH(workpstat);
			WMODE=PExplain;
			$2->SetType(TVARIABLE);
                        $$=new TForClause($2,$4,$6);
                        WRUN=((TForClause *)$$)->GetDo();
                    	}
			commandlist OD 
			{
			workpstat=savestack->POP();
			$$=$<clause>8;
#ifdef __SHOW_CLAUSES__FOR__
			$$->display();
//			wout<<endl;
#endif
			if(WMODE== PNormal && !WRUN) $$->Run();

			}
		   | FOR variable FROM number TO number STEP number DO
			{
			$2->SetType(TVARIABLE);
                        workpstat=new PState(WMODE,WVAR);
                        savestack->PUSH(workpstat);
                        WMODE=PExplain;
                        $$=new TForClause($2,$4,$6,$8);
                        WRUN=((TForClause *)$$)->GetDo();
			}
			 commandlist OD
			{
			workpstat=savestack->POP();
                        $$=$<clause>10;
#ifdef __SHOW_CLAUSES__FOR__
                        $$->display();
#endif
                        if(WMODE== PNormal && !WRUN) $$->Run();
			} 
		| FOR '(' 
			{
                        workpstat=new PState(WMODE,WVAR);
                        savestack->PUSH(workpstat);
                        WMODE=PExplain;
			}
		  assign_list ';' 
		  logic_exp  ';' 
		  assign_list ')' DO 
		  	{
                        $$=new TForClause1($4,$6,$8);
                        WRUN=((TForClause1 *)$$)->GetDo();
			}
		  commandlist OD
			{
			workpstat=savestack->POP();
                        $$=$<clause>11;
                        $$->display();
                        if(WMODE== PNormal && !WRUN) $$->Run();
			}
		;
	while_clause: WHILE 
			{
			workpstat=new PState(WMODE,WVAR);
			savestack->PUSH(workpstat);
			WMODE=PExplain;
			}
		  '(' logic_exp ')' DO
			{
			$$=new TWhileClause($4);
			WRUN=((TWhileClause *)$$)->GetDo();
			}
		commandlist OD 
			{
			workpstat=savestack->POP();
			$$=$<clause>7;
#ifdef __SHOW_CLAUSES__WHILE__
			$$->display();
#endif
			if(WMODE== PNormal && !WRUN) $$->Run();
			}
		;
	case_clause:  CASE number ':' 
			{
			workpstat=new PState(WMODE,WVAR);
			savestack->PUSH(workpstat);
			WMODE=PExplain;
			$$=new TCaseClause($2);
			WRUN=$$->GetDo();
			}
		commandlist
			{
			$$=$<tcase>4;
			workpstat=savestack->POP();
			}
		;
	default_clause: DEFAULT ':' 
			{
			workpstat=new PState(WMODE,WVAR);
			savestack->PUSH(workpstat);
			WMODE=PExplain;
			$$=new TCaseClause();
			WRUN=$$->GetDo();
			}
		commandlist
			{
			$$=$<tcase>3;
			workpstat=savestack->POP();
			}
		;
	case_list: default_clause 
			{
			$$=new TCaseList();
			$$->append($1);
			}
		| case_clause case_list
			{
			$$=$2;
			$$->insert($1,$$->first());
			}
		;
	switch_clause: SWITCH 
			{
			workpstat=new PState(WMODE,WVAR);
			savestack->PUSH(workpstat);
			WMODE=PExplain;
			}
		'(' expression ')' case_list END 
			{
			$$=new TSwitchClause($4,$6);
			workpstat=savestack->POP();
#ifdef __SHOW_CLAUSES__SWITCH__
			$$->display();
#endif
			if(WMODE== PNormal && !WRUN) $$->Run();
			}
		;
	variable: SYMBOL {
			  $$=$1;
			}
			| SPEFUNC '(' exp_list ')'
			{  
				if($3->length()==1){
				    TRIPoly *p=poly_p($3->Part(1));
				    $1->SetValue(p);
				    delete $3;
				}
                else {
					$1->SetValue($3);
                }
				
				TVariable *tmp=workpstat->vartbl->lookup($1);
		        if (tmp) 
				{
					$$=tmp; delete $1;
				}
		        else 
				{ 
				   $$=$1;
			       $$->order=SerNum++;
			       workpstat->vartbl->append($$);
				}
			}
		;
	str: QSTRING {
			$$=$1;
			}
		;
	number:   NUMBER {
			$$=$1;
			}
		;
vector_exp: VECTOR '(' exp_list ')'
                        {
                        TVector *nv=new TVector($3);
                        delete $3;
                        $$=nv;
                        break;
                        }
                ;
gstatement_list: 
	| gstatement_list gstatement
	;
gstatement: points ';'
	| line ';'
	;
points:  POINT variable
	| POINT variable '(' expression ',' expression ')'
	| points ',' variable
	| points ',' variable '(' expression ',' expression ')'
 	;
line:	LINE '(' points ',' points ')'
	;
%%
#ifdef CONSOLE
void main(void)
{
	main1(0,0);
	star_init();
	printf(">");
    yyparse();
    delete depend_relation;
	star_exit();
}
#endif
#ifdef _WINDOWS
UINT elimino(LPVOID ptr)
{
	main1(0,0);
	star_init();
    yyparse();
    delete depend_relation;
	star_exit();
	return 0;
}
#endif

int yyerror(char *s)
{
	wout<<"---!!!!"<<s<<endl;
	return 1;
}

void TimeUsed(const char *str1,timeb s, timeb e)
{
	 double u=((e.time - s.time)*1000 +e.millitm- s.millitm)/1000.0 ;
	 cout<<"\t"<<str1<<" used Time is: "<<s.time<<"."<<s.millitm
		 <<" to "<<e.time<<"."<<e.millitm<<"= "<<u<<" seconds"<<endl; 
}
