%{
#ifdef _WINDOWS
#include "afxmt.h"
#include "..\gui\index.h"
extern char Buffer[];
extern char *bufferptr;
extern char *bufferlim;
extern CEvent parserStart;
extern CEvent parserPause;
extern bool input_ready;
extern bool succeed;
extern bool bBusy;
extern bool NewItem;
extern HWND hWnd;
extern  int WM_OUTPUT;
int my_yyinput(char *buf, int max_size);
#undef YY_INPUT
#define YY_INPUT(b, r, ms) \
{retry: \
	 	if(succeed)\
		{\
			NewItem=true;\
            ::SendMessage(hWnd,WM_OUTPUT,0,0);\
		}\
		if(!input_ready)\
		{\
             parserStart.ResetEvent();\
		 	 parserPause.SetEvent();\
			 ::WaitForSingleObject(parserStart.m_hObject,INFINITE);\
		}\
		r=my_yyinput(b, ms);\
		if(!r) goto retry;\
		input_ready=false;\
}
#endif
#include <stdio.h>
#include <iostream.h>
#include <fstream.h>
#include <malloc.h>
#include <string.h>
#include "number.h"
#include "global.h"
#include "express.h"
#include "lang.h"
#include "yacc.tab.h"
#include <io.h>
#include "tbl2listtvariable.h"

struct TBuffer_State {
        BufferType type;
        YY_BUFFER_STATE theState;
        TBuffer_State *next;

        TBuffer_State(YY_BUFFER_STATE s,BufferType t=InStdIO) {
                type=t;
                theState=s;
                next=0; }
        ~TBuffer_State(){next=0;}
        };

int switch_to_state(YY_BUFFER_STATE newSt,YY_BUFFER_STATE oldSt);
int return_from_state();
TBuffer_State *BufferStacks=0;
extern Tbl2ListTVariable 	*SymTbl;

BufferType nowBufferType=InStdIO;
ifstream newin;
%}

ws	[ \t]
wsline	^[ \t]*\n
comment	#.*
number [0-9]+[D]?[I]?|[0-9]+\.[D]?[I]?|[0-9]*\.[0-9]+[D]?[I]?|I|[0-9]+\/[0-9]+I
symbol	[a-zA-Z_][a-zA-Z0-9_]*
qstring \"[^\"]*\"
%%
{ws}		;
{wsline}	;
{comment}       ;
sin |
cos |
tan |
sec |
csc |
cot |
sinh |
cosh |
tanh |
sech |
csch |
coth |
ln |
log |
lg |
sqrt |
curt |
qurt {
	        yylval.symval=new TVariable(yytext,TFUNCTION);
		    return SPEFUNC;
	}
{qstring}	{ 
	          char * ch=(char *)strdup(yytext+1);
			  ch[yyleng-2]='\0';
			  yylval.string=(TString *)new TString(ch);
			  return QSTRING;
			}
=			{ return ASSIGN; }
":="		{ return DEFINE; }
"++"		{ return INCOP; }
"--"		{ return DECOP; }
"=="		{ yylval.logval=TEQ; return EQ;}
">"			{ yylval.logval=TGT; return GT;}
">="|"=>"|"!<"	{ yylval.logval=TGE; return GE;}
"<"			{ yylval.logval=TLT; return LT;}
"<="|"=<"|"!>"	{ yylval.logval=TLE; return LE;}
"!="|"<>"	{ yylval.logval=TNE; return NE;}
"&&"		{ return AND;	}
"||"		{ return OR;	}
"~"			{ return NOT;	}
if			{ return IF;	}
then		{ return THEN;	}
else		{ return ELSE;	}
"elif"|"elseif"	{ return ELSEIF;}
"fi"|"endif"	{ return FI;	}
for			{ return FOR;	}
while		{ return WHILE;	}
"do"|"begin"	{ return DO;	}
"od"|"endloop"	{ return OD;	}
switch		{ return SWITCH;}
case		{ return CASE;	}
default		{ return DEFAULT;}
break		{ return BREAK;	}
continue	{ return CONTINUE;}
from		{ return FROM;	}
to			{ return TO;	}
"step"|"by"	{ return STEP;	}
return		{ return RETURN;}
proc		{ return PROC; 	}
"end"|"finish"	{ return END;	}
"vector"|"VEC"	{ return VECTOR;}
"set"|"SET"	{ return SET;	}
"list"|"LIST"	{ return LIST;	}
global		{ return GLOBAL;}
local		{ return LOCAL;	}
read		{ return READ; 	}
write		{ return WRITE; }
print		{ return PRINT; }
"quit"		{ return 0;	}
point		{ return POINT; }
line		{ return LINE; }
circle		{ return CIRCLE; }
triangle	{ return TRIANGLE; }
rect		{ return RECT; }
theorem		{ return GTHEOREM;	}
"precision"|"PREC" { return PRECISION;	}
{number}	{ 
		yylval.val=(TNumber *)new TNumber(yytext);
		return NUMBER;
		}
{symbol}	{ 
		TVariable *tmp=workpstat->vartbl->lookup(yytext);
		if (tmp) yylval.symval=tmp;
		else {
			if(workpstat->mode==PProcDef) 
			   yylval.symval=new TVariable(yytext,TVARIABLE);
			else yylval.symval=new TVariable(yytext);
			yylval.symval->order=SerNum++;
			workpstat->vartbl->append(yylval.symval);
			}
		return SYMBOL;
		}
\n		;
.		{return yytext[0];}
%%

int yywrap() {
 return_from_state();
 return 0;
};

int switch_to_string(char *s)
{
 YY_BUFFER_STATE os=YY_CURRENT_BUFFER;
 YY_BUFFER_STATE ns=yy_scan_string(s);
 switch_to_state(ns,os);
 nowBufferType=InBuffer;
 return 1;
};
  
int switch_to_file(char *filename)
{
 FILE *fp=fopen(filename,"rt");
 if (!fp) { wout<<"file open error\n"; return 0;};
 YY_BUFFER_STATE os=YY_CURRENT_BUFFER;
 YY_BUFFER_STATE ns=yy_create_buffer(fp,YY_BUF_SIZE);
 switch_to_state(ns,os);
 nowBufferType=InFile;
 return 1;
};

int switch_to_state(YY_BUFFER_STATE newState,YY_BUFFER_STATE oldState)
{
 TBuffer_State *cur=new TBuffer_State(oldState,nowBufferType);
 cur->next=BufferStacks;
 BufferStacks=cur;
 yy_switch_to_buffer(newState);
 return 1;
};

int return_from_state()
{
 if(BufferStacks==0)
  {
  wout<<"state stacks error!\n";
  return 0;
  }
 TBuffer_State *cur=BufferStacks->next;
 if (nowBufferType==InFile) fclose(YY_CURRENT_BUFFER->yy_input_file);
 yy_delete_buffer(YY_CURRENT_BUFFER);
 yy_switch_to_buffer(BufferStacks->theState);
 nowBufferType=BufferStacks->type;
 delete BufferStacks;
 BufferStacks=cur;
 return 1;
}

#ifdef CONSOLE
int my_YY_INPUT(char *buf, int max_size) 
{	int result;
	if(yy_current_buffer->yy_is_interactive ) 
		{ 
		int c = '*', n; 
		for ( n = 0; n < max_size && 
			     (c = getc( yyin )) != EOF && c != '\n'; ++n ) 
		{	buf[n] = (char) c; 
			if( c == '"') 
			{	
				do { 
					n++; 
					c = getc( yyin ); 
					if ( c == '\n' )  buf[n]='\n'; 
					else buf[n] = (char) c; 
				} while ( c != '"' ); 
			} 
		} 
		if ( c == '\n' )  
			buf[n++] = (char) c;  
		if ( c == EOF && ferror( yyin ) )  
			yy_fatal_error( "input in flex scanner failed" );  
		result = n;
	} 
	else if ( ((result = fread( buf, 1, max_size, yyin )) == 0) 
		  && ferror( yyin ) )
		yy_fatal_error( "input in flex scanner failed" );
	return result;
}
#endif
// _WINDOWS
#ifdef _WINDOWS
int my_yyinput(char *buf, int max_size)
{
	int n=min(max_size, bufferlim-bufferptr);
	if(n>0)
	{
		memcpy(buf, bufferptr, n);
		bufferptr += n;
	}
	return n;
}
#endif
