// DisplayTree.cpp : implementation file
//

#include "..\stdafx.h"
#include "DisplayTree.h"
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// DisplayTree

IMPLEMENT_DYNCREATE(DisplayTree, CView)

DisplayTree::DisplayTree()
{    
   pos=0;
   nCharWidth = 10 ;
   nLnHeight = 15 ;
   nLineDist=5;
   head=new line();
   current_line=new line();
   current_line->prevln=head;
   head->nextln=current_line;	
}
 
DisplayTree::~DisplayTree()
{
	if(head)
       delete head;
}


BEGIN_MESSAGE_MAP(DisplayTree, CView)
	//{{AFX_MSG_MAP(DisplayTree)
		// NOTE - the ClassWizard will add and remove mapping macros here.
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// DisplayTree drawing

void DisplayTree::OnDraw(CDC* pDC)
{
	CDocument* pDoc = GetDocument();
	// TODO: add draw code here
}

/////////////////////////////////////////////////////////////////////////////
// DisplayTree diagnostics

#ifdef _DEBUG
void DisplayTree::AssertValid() const
{
	CView::AssertValid();
}

void DisplayTree::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// DisplayTree message handlers

void DisplayTree::SetOrgBuf(char* buffer)
{   
	if(!Buffer.IsEmpty())
	     Buffer.Empty();

	Buffer+=buffer;
}

long DisplayTree::ShowEdit(CDC *pDC,CRect rt)
{   
	int nCharNum=Buffer.GetLength();
	if(!nCharNum) 
	{
		return pos+nLnHeight;
	}

    pDC->SetTextColor(RGB(255,0,0));
	int nLnChar=(rt.Width()-50)/nCharWidth;
    CString Line;
	long x0=30,y0=pos;
    for(int i=0;i<nCharNum;i++)
		if(Buffer[i]!='\n')
		{
			Line+=Buffer[i];
			if(Line.GetLength()>=nLnChar)
			{
				if( y0>=rt.top-30 && y0<rt.bottom)
				    pDC->TextOut(x0,y0,Line,Line.GetLength());
				Line.Empty();
				y0=y0+nLnHeight+nLineDist;
			}
		}
		else
		{
			if( y0>=rt.top-30 && y0<rt.bottom)
			    pDC->TextOut(x0,y0,Line,Line.GetLength());
			y0=y0+nLnHeight+nLineDist;
			Line.Empty();
		}
    if(!Line.IsEmpty())
	{
		if( y0>=rt.top-30 && y0<rt.bottom)
		    pDC->TextOut(x0,y0,Line,Line.GetLength());
		Line.Empty();
	}

	return y0+nLnHeight+nLineDist;
}

CString DisplayTree::GetOrgBuf()
{
	return  Buffer;
}

void DisplayTree::ShowPoly(CDC *pDC,CRect rt)
{
    pDC->SetTextColor(RGB(0,0,255));
	line *disp_ln=head->nextln;
	long offset=head->ypos;
    for( ; disp_ln && disp_ln->ln;)
	{
		if(disp_ln->ypos+offset>rt.bottom) break;
		if( disp_ln->ypos+offset>=rt.top-30)
		   disp_ln->ShowLine(pDC,offset);
		disp_ln=disp_ln->nextln;
	}
} 
void DisplayTree::DeletePoly()
{
	line *temp=head->nextln;
	delete temp;
	current_line=new line;
	current_line->ypos=0;
	current_line->prevln=head;
	head->nextln=current_line;
}