//////////////////////////////////////////////////////////////////////
// GUIAtom.cpp: implementation of the GUIMonoCell class.
//
//////////////////////////////////////////////////////////////////////

#include "..\stdafx.h"
#include "GUIglobe.h"
#include "GUICell.h"
#include "GUIAtom.h"


//******************************************************************//
//                                                                  //
//    ڱʾbase^power(e.g.x^2)Ķ                   //
//                                                                  //
//******************************************************************//


//******************************************************************//
//                                                                  //
//                      캯                          //
//                                                                  //
//******************************************************************//

GUIMonoCell::GUIMonoCell()
{
	base=0;power=0;rt=0;
	bracket_b=bracket_p=false;
	Pt=CPoint(0,0);pos=Pt;
	next=0;
	state=false;
}
GUIMonoCell::GUIMonoCell(GUIAtom *BASE , GUIAtom *POWER)
{
	base=BASE;power=POWER;rt=0;
	bracket_b=bracket_p=false;
    Pt=CPoint(0,0);pos=Pt;
	next=0;
	state=false;
}
GUIMonoCell:: ~GUIMonoCell()
{
	if(base)  delete base;
	if(power) delete power;
	if(rt)    delete rt;
	if(next)    delete next;
}

void GUIMonoCell::CalcRect()
{
	CPoint pt(0,0);
	CSize  sz(0,0);

	if(power){
		CRect *rt_b=base->GetRect();
		CRect *rt_p=power->GetRect();

		sz.cx+=(rt_b->Width()+rt_p->Width());
	    sz.cy=rt_b->Height()+rt_p->Height()-10;

		rt=new CRect(pt,sz);

		base->ReCalcRect(CPoint(0,rt_p->Height()-10));
        power->ReCalcRect(CPoint(rt_b->Width(),0));

		Pt=base->GetPt();
	}
	else{
		CRect *rt_b=base->GetRect();

		sz.cx+=rt_b->Width();
	    sz.cy=rt_b->Height();

		rt=new CRect(pt,sz);

		Pt=base->GetPt();
		
	}
}
void GUIMonoCell::ReCalcRect(CPoint pt)
{
	Pt+=pt;
	base->ReCalcRect(pt);
	if(power){
		power->ReCalcRect(pt);
	}
}
void GUIMonoCell::CalcLine(CPoint& pt)
{
	pos=pt;
	base->CalcLine(pt);
	if(power){
		power->CalcLine(pt);
	}
}
void GUIMonoCell::Append(GUIMonoCell *MONOCELL)
{
    GUIMonoCell *m=this;
	while(m->next)
		m=m->next;
	m->next=MONOCELL;
}
CRect* GUIMonoCell::GetRect() const
{
	return rt;
}
bool GUIMonoCell::PtInRect(CPoint& pt,CPoint Point)
{
	return false;
}
bool GUIMonoCell::Check(CPoint& pt,CPoint& mousept)
{ 
	St[glSLevel++]=this;
	base->Check(pt,mousept);

	if(power){
		power->Check(pt,mousept);
	}

	return false;
}
bool GUIMonoCell::ReCheck(CPoint& pt,CPoint& mousept)
{ 
	Tr[glTLevel++]=this;
	base->ReCheck(pt,mousept);

	if(power){
		power->ReCheck(pt,mousept);
	}

	return false;
}
void GUIMonoCell::Copy(CString& string)
{	
	bool stop=false;
	if( this==pStart || this==pTerminal){
		if(bShowClip==false) bShowClip=true;
		else stop=true;
	}

	if(base) {
		if( bShowClip && bracket_b){
			string+='(';
			base->Copy(string);
			string+=')'; 
		}
		else{
			base->Copy(string);
		}
	}
	if(power) {
		if(bShowClip && bracket_p){
			string+="^(";
			power->Copy(string);
			string+=')'; 
		}
		else{
			if(bShowClip)string+='^';
		    power->Copy(string);
		}
	}

	if( this==pStart || this==pTerminal) {
		if(bShowClip && stop) bShowClip=false;
	}
}
void GUIMonoCell::Display(CDC *pDC , CPoint& pt,CRect rect)
{
	bool stop=false;
	if( this==pStart || this==pTerminal){
		if(bShowClip==false) bShowClip=true;
		else stop=true;
	}

	if(base) {
		base->Display(pDC,pt,rect);
	}
	if(power) {
		power->Display(pDC,pt,rect);
	}

	if( this==pStart || this==pTerminal) {
		if(bShowClip && stop) bShowClip=false;
	}
}
	
//////////////////////////////////////////////////////////////////////
// GUIAtom.cpp: implementation of the GUITerm class.
//
//////////////////////////////////////////////////////////////////////

GUITerm::GUITerm()
{
	Mono=0;
	rt=0;
	Pt.x=0;Pt.y=0;
	pos.x=pos.y=0;
}
GUITerm::GUITerm(GUICell *MONO)
{
	Mono=MONO;
	rt=0;
	Pt.x=0;Pt.y=0;
	pos.x=pos.y=0;
}
GUITerm::~GUITerm()
{
	if(Mono) delete Mono;
	if(rt)   delete rt;
}

void GUITerm::CalcRect()
{
	CPoint pt(0,0);
	CSize  sz(0,0);
	CRect *rt_m;
	GUICell *m=Mono;

	while(m)
	{
		m->ReCalcRect(CPoint(sz.cx,0));
		rt_m=m->GetRect();
	    sz.cx+=rt_m->Width();
		if(sz.cy<rt_m->Height())
			sz.cy=rt_m->Height();
		m=m->next;
	}
	rt=new CRect(pt,sz);
}
void GUITerm::ReCalcRect(CPoint pt)
{
	Pt+=pt;
	GUICell *m=Mono;

	while(m){
		m->ReCalcRect(pt);
		m=m->next;
	}
}
void GUITerm::Locate()
{ 
	CPoint pt(0,0),p;

	p=MaxOffsetDis();
	pt.y=p.y;

	GUICell *m=Mono;

	while(m){
		p=m->GetPt();
		m->ReCalcRect(CPoint(pt.x,pt.y-p.y));
		m=m->next;
	}

	Pt=Mono->GetPt();
}
 
CPoint GUITerm::MaxOffsetDis()
{
	CPoint pt(0,0),point;

	GUICell *m=Mono;
	while(m){
		point=m->GetPt();
		if(point.y>pt.y)
			pt.y=point.y;
		m=m->next;
	}
	return pt;
}
void GUITerm::CalcLine(CPoint& pt)
{
	pos=pt;
	GUICell *m=Mono;

	while(m){
		m->CalcLine(pt);

		if(m->GetRect()->Width()>SrcWidth &&m->next)
			pt.x+=-m->next->GetPt().x;

		m=m->next;
	}
}
CRect* GUITerm::GetRect() const
{
	return rt;
}
bool GUITerm::PtInRect(CPoint& pt,CPoint Point)
{
	CRect RT(rt);
	RT+=Pt+pt+pos;
	if(RT.PtInRect(Point))return true;

	GUICell *m=Mono;
	while(m){
		if(m->PtInRect(pt,Point))
			return true;
		m=m->next;
	}
	return false;
}
bool GUITerm::Check(CPoint& pt,CPoint& mousept)
{
	//St[glSLevel++]=Mono;

	GUICell *m=Mono;

	while(m){
		CRect RT(m->rt);
	    RT+=m->Pt+pt+m->pos;

	    if(m->PtInRect(pt,mousept)) {
			St[glSLevel++]=m;
			m->Check(pt,mousept);
		    break;
		}
		m=m->next;
	}

	return false;
}
bool GUITerm::ReCheck(CPoint& pt,CPoint& mousept)
{
	//Tr[glTLevel++]=Mono;

	GUICell *m=Mono;

	while(m){
		CRect RT(m->rt);
	    RT+=m->Pt+pt+m->pos;

	    if(m->PtInRect(pt,mousept)) {

			Tr[glTLevel++]=m;

			if(St[glTLevel-1]==Tr[glTLevel-1]){
				m->ReCheck(pt,mousept);
			}
		    else{
				pStart=St[glTLevel-1];
			    pTerminal=Tr[glTLevel-1];
			}
		    break;
		}
		m=m->next;
	}

	return false;
}
void GUITerm::Copy(CString& string)
{
	//*
	bool stop=false;
	if( this==pStart || this==pTerminal){
		if(bShowClip==false) bShowClip=true;
		else stop=true;
	}
	//*/
    bool sp=false;
	GUICell *m=Mono;
	while(m){
		 if( (m==pStart || m==pTerminal) && (pStart!=pTerminal)){
		    if(!bShowClip && !sp) bShowClip=true;
		    else if(bShowClip && !sp)sp=true;
		 }
		  m->Copy(string);
		  if( sp && bShowClip) {
		   bShowClip=false;
		  }
		  m=m->next;
		  if( bShowClip && m )
			  string+='*';
	}

	if( this==pStart || this==pTerminal) {
		if(bShowClip && stop) bShowClip=false;
	}
}
void GUITerm::Display(CDC *pDC , CPoint& pt,CRect rect)
{   
	//*
	bool stop=false;
	if( this==pStart || this==pTerminal){
		if(bShowClip==false) bShowClip=true;
		else stop=true;
	}

	GUICell *m=Mono;

	bool sp=false;
	while(m){
		if( (m==pStart || m==pTerminal) && (pStart!=pTerminal)){
		    if(!bShowClip && !sp) bShowClip=true;
		    else if(bShowClip && !sp)sp=true;
		 }
		 m->Display(pDC,pt,rect);
		 if( sp && bShowClip) {
		   bShowClip=false;
		 }
		 m=m->next;
	}

	if( this==pStart || this==pTerminal) {
		if(bShowClip && stop) bShowClip=false;
	}
}
