//////////////////////////////////////////////////////////////////////
// GUIAtom.h: interface for the GUIAtom class.
//
//////////////////////////////////////////////////////////////////////

#ifndef GUIATOM_H
#define GUIATOM_H 1
#include "..\stdafx.h"
#include "GUIglobe.h"

//******************************************************************//
//                                                                  //
//       һ࣬Ϊеṩ˹Ľӿڡ             //
//                                                                  //
//******************************************************************//

class GUIAtom
{
public:
	GUIAtom(){}
	virtual ~GUIAtom(){}

	virtual enum GUIDataType TypeID()=0; 
    virtual CPoint GetPt()=0;
	virtual void CalcRect()=0;
	virtual void ReCalcRect(CPoint pt)=0;
	virtual CRect* GetRect() const=0;
	virtual void CalcLine(CPoint& pt)=0;
	virtual bool PtInRect(CPoint& pt,CPoint Point)=0;
    virtual bool Check(CPoint& pt,CPoint& mousept)=0;
	virtual bool ReCheck(CPoint& pt,CPoint& mousept)=0;
	virtual void Copy(CString& string)=0;
	virtual void Display(CDC *pDC, CPoint& pt,CRect rt)=0;
};

//////////////////////////////////////////////////////////////////////
// GUIAtom.h: interface for the GUIMonoCell class.
//
//////////////////////////////////////////////////////////////////////

//******************************************************************//
//                                                                  //
//    ڱʾbase^power(e.g.x^2)Ķ                   //
//                                                                  //
//******************************************************************//

class GUIMonoCell:public GUIAtom
{
	GUIAtom  *base;
	GUIAtom  *power;
	bool bracket_b,bracket_p;
	CRect    *rt;
	CPoint Pt;
	CPoint pos;    // ΪλõĲ
	GUIMonoCell *next;
	bool state;
public:
	GUIMonoCell();
	GUIMonoCell(GUIAtom *BASE , GUIAtom *POWER=0);
	virtual ~GUIMonoCell();

	friend class GUITerm;

	void CalcRect();
	void ReCalcRect(CPoint pt);
	void CalcLine(CPoint& pt);
	CPoint GetPt(){ return Pt;}
	void Append(GUIMonoCell *MONOCELL);

	enum GUIDataType TypeID() { return  MONO_TYPE;}
	CRect* GetRect() const;
	bool PtInRect(CPoint& pt,CPoint Point);
	bool Check(CPoint& pt,CPoint& mousept);
	bool ReCheck(CPoint& pt,CPoint& mousept);
	void Copy(CString& string);
	void Display(CDC *pDC , CPoint& pt,CRect rect);
};	

//////////////////////////////////////////////////////////////////////
// GUIAtom.h: interface for the GUITerm class.
//
//////////////////////////////////////////////////////////////////////

//******************************************************************//
//                                                                  //
//    ڱʾʽͱʽe.g.23*x^2*y^2            //
//                                                                  //
//******************************************************************//

class GUITerm:public GUIAtom
{
    GUICell *Mono;
	CRect *rt;
	CPoint Pt;
	CPoint pos;    // ΪλõĲ
public:
	GUITerm();
	GUITerm(GUICell *MONO);
	virtual ~GUITerm();
  
	void CalcRect();
	void ReCalcRect(CPoint pt);
	void CalcLine(CPoint& pt);
	CPoint GetPt(){ return Pt;}

	CPoint MaxOffsetDis();
	void Locate();
	enum GUIDataType TypeID() { return  TERM_TYPE;}
	CRect* GetRect()const;
	bool PtInRect(CPoint& pt,CPoint Point);
	bool Check(CPoint& pt,CPoint& mousept);
	bool ReCheck(CPoint& pt,CPoint& mousept);
	void Copy(CString& string);
	void Display(CDC *pDC , CPoint& pt,CRect rect);
};
#endif