//////////////////////////////////////////////////////////////////////
// GUICell.cpp: implementation of the GUIVariable class.
//
//////////////////////////////////////////////////////////////////////

#include "..\stdafx.h"
#include "GUIglobe.h"
#include "GUIAtom.h"
#include "GUICell.h"

GUIVariable::GUIVariable()
{
	Pt=CPoint(0,0);
	pos=Pt;
	data=0;rt=0;	 
}
GUIVariable::GUIVariable(char *DATA)
{
	Pt=CPoint(0,0);
	pos=Pt;
	data=DATA;rt=0;
}
GUIVariable::~GUIVariable()
{
	if(data)delete data;
	if(rt)  delete rt;
}

void GUIVariable::CalcRect()
{
	CPoint pt(0,0);
	CSize sz(0,0);

	sz.cx=strlen(data)*CHARWIDTH;
	sz.cy=LINEHEIGHT;

	rt=new CRect(pt,sz);
}
void GUIVariable::ReCalcRect(CPoint pt)
{
	Pt+=pt;
}
void GUIVariable::CalcLine(CPoint& pt)
{
	pos=pt;
}
CRect* GUIVariable::GetRect() const
{
	return rt;
}
bool GUIVariable::PtInRect(CPoint& pt,CPoint Point)
{
	return false;
}
bool GUIVariable::Check(CPoint& pt,CPoint& mousept)
{
	CRect RT(rt);
	RT+=Pt+pt+pos;
 
	if(RT.PtInRect(mousept))
		return true;

	return false;
}
bool GUIVariable::ReCheck(CPoint& pt,CPoint& mousept)
{
	CRect RT(rt);
	RT+=Pt+pt+pos;
 
	if(RT.PtInRect(mousept))
		return true;

	return false;
}
void GUIVariable::Copy(CString& string)
{ 
	//*
	if( pStart==pTerminal && this==pStart)
         bShowClip= true;
	//*/

	if(bShowClip){
		string+=data;
	}
 
	//*
	if(bShowClip && pStart==pTerminal && this == pStart)
        bShowClip=false;
	//*/
}
void GUIVariable::Display(CDC *pDC , CPoint& pt,CRect rect)
{	
	//*
	if( pStart==pTerminal && this==pStart  )
         bShowClip= true;
	//*/

	if(!bShowClip){
		pDC->TextOut(Pt.x+pos.x+pt.x,Pt.y+pos.y+pt.y,data);
	}
	else{
		pDC->SetTextColor(RGB(255,255,0));
		pDC->SetBkColor(RGB(0,0,0));
        pDC->TextOut(Pt.x+pos.x+pt.x,Pt.y+pos.y+pt.y,data);
        pDC->SetTextColor(RGB(0,0,255));
		pDC->SetBkColor(RGB(255,255,255));
	}

	//*
	if(bShowClip && pStart==pTerminal && this == pStart )
        bShowClip=false;
	//*/
}

//////////////////////////////////////////////////////////////////////
// GUICell.cpp: implementation of the GUINumber class.
//
//////////////////////////////////////////////////////////////////////

GUINumber::GUINumber()
{
	Pt=CPoint(0,0);
	pos=Pt;
	data=0;rt=0;
	node=0;
}
GUINumber::GUINumber(char *DATA)
{
	Pt=CPoint(0,0);
	pos=Pt;
	data=DATA;rt=0;
	node=0;
}
GUINumber::~GUINumber()
{
	if(data)delete data;
	if(rt)  delete rt;
	if(node) delete node;
}
void GUINumber::CalcRect()
{
	CPoint pt(0,0);
	CSize sz(0,0);

	sz.cx=strlen(data)*CHARWIDTH;
	sz.cy=LINEHEIGHT;

	rt=new CRect(pt,sz);
}
void GUINumber::ReCalcRect(CPoint pt)
{
	Pt+=pt;
}
void GUINumber::CalcLine(CPoint& pt)
{   
	pos=pt;

	CPoint t=Pt;

	char *m=data;
	Node *n=0;
	int l=strlen(m);

	if(t.x+pt.x+l*CHARWIDTH<=SrcWidth){
		node=new Node(m,l,t,pos);
	}
	else {
		int k=(SrcWidth-t.x-pt.x)/CHARWIDTH;
		node=new Node(m,k,t,pt);
		l-=k;m+=k;
	 
		t.x+=k*CHARWIDTH;
		pt.x-=SrcWidth/CHARWIDTH*CHARWIDTH;
		
		pt.y+=LINEHEIGHT+ROWDIS;
		n=node;
		while(l*CHARWIDTH>=SrcWidth){
           n->next=new Node(m,SrcWidth/CHARWIDTH,t,pt);
		   l-=SrcWidth/CHARWIDTH;m+=SrcWidth/CHARWIDTH;
		   pt.x-=SrcWidth/CHARWIDTH*CHARWIDTH;
		   t.x+=SrcWidth/CHARWIDTH*CHARWIDTH;
		   pt.y+=LINEHEIGHT+ROWDIS;
		   n=n->next;
		}
		n->next=new Node(m,l,t,pt);
		//pt.x=l*CHARWIDTH;
	}
}
CRect* GUINumber::GetRect() const
{
	return rt;
}
bool GUINumber::PtInRect(CPoint& pt,CPoint Point)
{
	Node *m=node;

    if(m->next){
	   while(m){
		  CRect RT(CPoint(0,0),CSize(m->len*CHARWIDTH,LINEHEIGHT));
	      RT+=m->Pt+pt+m->pos;
		  if(RT.PtInRect(Point))
			return true;
		  m=m->next;
	   }
	}
	else{
		CRect RT(CPoint(0,0),CSize(m->len*CHARWIDTH,LINEHEIGHT));
	    RT+=Pt+pt+m->pos;
		if(RT.PtInRect(Point))
			return true;
	}
	return false;
}
bool GUINumber::Check(CPoint& pt,CPoint& mousept)
{
	if(PtInRect(pt,mousept)){
		return true;
	}

	return false;
}
bool GUINumber::ReCheck(CPoint& pt,CPoint& mousept)
{
	if(PtInRect(pt,mousept)) {
		return true;
	}

	return false;
}
void GUINumber::Copy(CString& string)
{
		//*
	if( pStart==pTerminal && this==pStart)
        bShowClip= true;
	//*/
 
	if(bShowClip){
		string+=data;
	}
   
	if(bShowClip  && pStart==pTerminal && this == pStart )
        bShowClip=false;
}
void GUINumber::Display(CDC *pDC , CPoint& pt,CRect rect)
{  
	//*
	if( pStart==pTerminal && this==pStart)
        bShowClip= true;
	//*/

	Node *m=node;

	if(!bShowClip){
		while(m){
			pDC->TextOut(m->pos.x+pt.x+m->Pt.x,m->pos.y+pt.y+m->Pt.y,m->data,m->len);
		    m=m->next;
		}
	}
	else{
		pDC->SetTextColor(RGB(255,255,0));
		pDC->SetBkColor(RGB(0,0,0));
        while(m){
			pDC->TextOut(m->pos.x+pt.x+m->Pt.x,m->pos.y+pt.y+m->Pt.y,m->data,m->len);
		    m=m->next;
		}
        pDC->SetTextColor(RGB(0,0,255));
		pDC->SetBkColor(RGB(255,255,255));
	}
    
	if(bShowClip  && pStart==pTerminal && this == pStart )
        bShowClip=false;
}

//////////////////////////////////////////////////////////////////////
// GUICell.cpp: implementation of the GUICell class.
//
//////////////////////////////////////////////////////////////////////

GUICell::GUICell()
{
	Pt=CPoint(0,0);
	pos=Pt;
	data=0;rt=0;
	state=false;
	next=0;
}
GUICell::GUICell(GUIAtom *DATA)
{
	Pt=CPoint(0,0);
	pos=Pt;
	data=DATA;rt=0;
	state=false;
	next=0;
}
GUICell::~GUICell()
{
	if(data)delete data;
	if(rt)  delete rt;
	if(next)delete next;
}
void GUICell::Append(GUICell *MONOCELL)
{
    GUICell *m=this;
	while(m->next)
		m=m->next;
	m->next=MONOCELL;
}
void GUICell::CalcRect()
{
	Pt=data->GetPt();
	CRect RT(data->GetRect());

	switch(data->TypeID()){
	case EXPR_TYPE:
		RT.right+=2*CHARWIDTH;
        data->ReCalcRect(CPoint(CHARWIDTH,0));
		break;
	case VAR_TYPE:
	case NUM_TYPE:
		RT.right+=3;
        data->ReCalcRect(CPoint(3,0));
		break;
	}

	rt=new CRect(RT);
}
void GUICell::ReCalcRect(CPoint pt)
{
	Pt+=pt;
	data->ReCalcRect(pt);
}
void GUICell::CalcLine(CPoint& pt)
{
	pos=pt;
	data->CalcLine(pt);
}
CRect* GUICell::GetRect() const
{
	return rt;
}
bool GUICell::PtInRect(CPoint& pt,CPoint Point)
{
	CRect RT(rt);
	RT+=Pt+pt+pos;
	if(RT.PtInRect(Point))return true;

	return data->PtInRect(pt,Point);
}
bool GUICell::Check(CPoint& pt,CPoint& mousept)
{ 
	bool in=data->Check(pt,mousept);

	switch(data->TypeID()){
	case VAR_TYPE:
	case NUM_TYPE:
	case MSG_TYPE:
		if(in) St[glSLevel++]=this;
		return true;
	case DEFINE_TYPE:
	case ASSIGN_TYPE:
	case PDE_TYPE:
	case FUNC_TYPE:
	case EXPR_TYPE:
	case MONO_TYPE:
	case FRACTION_TYPE:
		if(in){
			St[glSLevel++]=this;
			pStart=St[glSLevel-1];
			pTerminal=St[glSLevel-1];
			return true;
		}
	}

	return false;
}
bool GUICell::ReCheck(CPoint& pt,CPoint& mousept)
{
	bool in=data->ReCheck(pt,mousept);

	switch(data->TypeID()){
	case VAR_TYPE:
	case NUM_TYPE:
	case MSG_TYPE:
		if(in){
			Tr[glTLevel++]=this;
		    if(St[glTLevel-1]==Tr[glTLevel-1]){
			   pStart=St[glTLevel-1];
	           pTerminal=Tr[glTLevel-1];
			   return true;
			}
		}
		break;
	case DEFINE_TYPE:
	case ASSIGN_TYPE:
	case PDE_TYPE:
	case FUNC_TYPE:
	case EXPR_TYPE:
	case MONO_TYPE:
	case FRACTION_TYPE:
		if(in){
			Tr[glTLevel++]=this;
			pStart=St[glSLevel-1];
			pTerminal=St[glSLevel-1];
			return true;
		}
	}

	return false;
}
void GUICell::Copy(CString& string)
{
	if( pStart==pTerminal && this==pStart )
        bShowClip= true;

	if(bShowClip && (data->TypeID()==EXPR_TYPE) ){
		string+="(";
	}
	data->Copy(string);

	if(bShowClip && (data->TypeID()==EXPR_TYPE) ){
		string+=")";
	}

	if(bShowClip && pStart==pTerminal && this==pStart)
        bShowClip=false;
}
void GUICell::Display(CDC *pDC , CPoint& pt,CRect rect)
{	 
    if( pStart==pTerminal && this==pStart )
        bShowClip= true;

	if(data->TypeID()==EXPR_TYPE){
		if(!bShowClip){
		   pDC->TextOut(Pt.x+pos.x+pt.x,Pt.y+pos.y+pt.y,"(");
		}
	    else{
		   pDC->SetTextColor(RGB(255,255,0));
		   pDC->SetBkColor(RGB(0,0,0));
           pDC->TextOut(Pt.x+pos.x+pt.x,Pt.y+pos.y+pt.y,"(");
           pDC->SetTextColor(RGB(0,0,255));
		   pDC->SetBkColor(RGB(255,255,255));
		}	
	}
	data->Display(pDC,pt,rect);

	if(data->TypeID()==EXPR_TYPE){
		if(!bShowClip){
		   pDC->TextOut(Pt.x+pos.x+pt.x+data->GetRect()->Width()+CHARWIDTH,
			   Pt.y+pos.y+pt.y,")");
		}
	    else{
		   pDC->SetTextColor(RGB(255,255,0));
		   pDC->SetBkColor(RGB(0,0,0));
           pDC->TextOut(Pt.x+pos.x+pt.x+data->GetRect()->Width()+CHARWIDTH,
			   Pt.y+pos.y+pt.y,")");
           pDC->SetTextColor(RGB(0,0,255));
		   pDC->SetBkColor(RGB(255,255,255));
		}
	}
	if(bShowClip && pStart==pTerminal && this==pStart )
        bShowClip=false;
}