//////////////////////////////////////////////////////////////////////
// GUICell.h: interface for the GUIVariable class.
//
//////////////////////////////////////////////////////////////////////

#ifndef GUICELL_H
#define GUICELL_H 1

#include "..\stdafx.h"
#include "GUIglobe.h"
#include "GUIAtom.h"

//******************************************************************//
//                                                                  //
//    ڱʾe.g. x,y,etc.                           //
//                                                                  //
//******************************************************************//

class GUIVariable:public GUIAtom
{
	char *data;
	CRect    *rt;
	CPoint Pt;
	CPoint pos;    // ΪλõĲ
public:
	GUIVariable();
	GUIVariable(char *);
	virtual ~GUIVariable();

	void CalcRect();
	void ReCalcRect(CPoint pt);
	void CalcLine(CPoint& pt);
	CPoint GetPt(){ return Pt;}

	enum GUIDataType TypeID() { return  VAR_TYPE;}
	CRect* GetRect() const;
	bool PtInRect(CPoint& pt,CPoint Point);
	bool Check(CPoint& pt,CPoint& mousept);
	bool ReCheck(CPoint& pt,CPoint& mousept);
	void Copy(CString& string);
	void Display(CDC *pDC , CPoint& pt,CRect rect);
};

//////////////////////////////////////////////////////////////////////
// GUICell.h: interface for the GUINumber class.
//
//////////////////////////////////////////////////////////////////////

//******************************************************************//
//                                                                  //
//    ڱʾ                          //
//                                                                  //
//******************************************************************//

class Node;
class GUINumber:public GUIAtom
{
	char *data;
	CRect *rt;
	CPoint Pt;
	CPoint pos;    // ΪλõĲ
	Node *node;
public:
	GUINumber();
	GUINumber(char *);
	virtual ~GUINumber();

	void CalcRect();
	void ReCalcRect(CPoint pt);
	void CalcLine(CPoint& pt);
	CPoint GetPt(){ return Pt;}

	enum GUIDataType TypeID() { return  NUM_TYPE;}
	CRect* GetRect() const;
	bool PtInRect(CPoint& pt,CPoint Point);
	bool Check(CPoint& pt,CPoint& mousept);
	bool ReCheck(CPoint& pt,CPoint& mousept);
	void Copy(CString& string);
	void Display(CDC *pDC , CPoint& pt,CRect rect);
};

//******************************************************************//
//                                                                  //
//    ڴʱĻУÿһһNode              //
//                                                                  //
//******************************************************************//

class Node
{
public:
	char *data;
	CPoint Pt;
	int len;
	CPoint pos;
	Node *next;

	Node()
	{
		data=0;len=0;Pt=CPoint(0,0);pos=Pt;next=0;
	}
	Node(char *Data,int l,CPoint pt,CPoint ps)
	{
		data=Data;len=l;Pt=pt;pos=ps;next=0;
	}
	~Node(){ data=0;if(next) delete next;}
};

//////////////////////////////////////////////////////////////////////
// GUICell.h: interface for the GUICell class.
//
//////////////////////////////////////////////////////////////////////

//******************************************************************//
//                                                                  //
//        ڱʾɶʽʽԪأ      //
//      Ǳ͸ʽ,õ˱ʽǶ   //
//                                                                  //
//******************************************************************//

class GUICell:public GUIAtom
{
	GUIAtom *data;
	CRect *rt;
	CPoint Pt;
	CPoint pos;    // ΪλõĲ
	bool state;
	GUICell *next;
public:
	GUICell();
	GUICell(GUIAtom *);
	virtual ~GUICell();

	friend class GUITerm;
	void Append(GUICell *MONOCELL);
	void CalcRect();
	void ReCalcRect(CPoint pt);
	void CalcLine(CPoint& pt);
	CPoint GetPt(){ return Pt;}

	enum GUIDataType TypeID() { return  CELL_TYPE;}
	CRect* GetRect() const;
	bool PtInRect(CPoint& pt,CPoint Point);
	bool Check(CPoint& pt,CPoint& mousept);
	bool ReCheck(CPoint& pt,CPoint& mousept);
	void Copy(CString& string);
	void Display(CDC *pDC , CPoint& pt,CRect rect);
};

#endif