//////////////////////////////////////////////////////////////////////
// GUIDefine.cpp: implementation of the GUIFunc class.
//
//////////////////////////////////////////////////////////////////////

#include "..\stdafx.h"
#include "GUIglobe.h"
#include "GUIAtom.h"
#include "GUIDefine.h"

GUIDefine::GUIDefine()
{
	Pt=CPoint(0,0);
	pos=Pt;
	name=0;expr=0;
	rt=0;
}
GUIDefine::GUIDefine(char *Name,GUIAtom *EXPR)
{
	Pt=CPoint(0,0);
	pos=Pt;
	name=Name; expr=EXPR;
	rt=0;
}
GUIDefine::~GUIDefine()
{
	if(name)delete name;
	if(expr)  delete expr;
}
void GUIDefine::CalcRect()
{
	CPoint pt(0,0);
	CSize sz(0,0);

	int height=expr->GetRect()->Height();
	sz.cx=(strlen(name)+2)*CHARWIDTH;
	 
	expr->ReCalcRect(CPoint(sz.cx,0));
	sz.cx+=expr->GetRect()->Width();
	sz.cy=height;

	if(height<=MONOHEIGHT){
	    Pt.y=(height-LINEHEIGHT);
	}
	else{
		Pt.y=(height-LINEHEIGHT)/2;
	}
 
	rt=new CRect(pt,sz);
}
void GUIDefine::ReCalcRect(CPoint pt)
{
	Pt+=pt;
	expr->ReCalcRect(pt);
}
void GUIDefine::CalcLine(CPoint& pt)
{
	pos=pt;
	expr->CalcLine(pt);
}
CRect* GUIDefine::GetRect() const
{
	return rt;
}
bool GUIDefine::PtInRect(CPoint& pt,CPoint Point)
{
	/*
	CRect RT(rt);
	RT+=Pt+pt+pos;
	return RT.PtInRect(Point);
	//*/
	return false;
}
bool GUIDefine::Check(CPoint& pt,CPoint& mousept)
{
	CRect RT(CPoint(Pt.x+strlen(name)*CHARWIDTH,Pt.y),CSize(2*CHARWIDTH,LINEHEIGHT));
	RT+=pt+pos;
	if(RT.PtInRect(mousept)){
		return true;
	}
	else{
		expr->Check(pt,mousept);
		return false;
	}
}
bool GUIDefine::ReCheck(CPoint& pt,CPoint& mousept)
{
	CRect RT(CPoint(Pt.x+strlen(name)*CHARWIDTH,Pt.y),CSize(2*CHARWIDTH,LINEHEIGHT));
	RT+=pt+pos;
	if(RT.PtInRect(mousept)) { 
		 return true;
	}
	else{
		expr->ReCheck(pt,mousept);
		return false;
	}
}
void GUIDefine::Copy(CString &string)
{
	if( this==pStart || this==pTerminal)
		bShowClip= !bShowClip;

	if(bShowClip){
		string+=name;
	}

	//  copy  ":="
		
	if(bShowClip) string+=":=";
	 
	
	// copy the elements

	expr->Copy(string);

	if(bShowClip  && this == pStart && pStart==pTerminal)
		bShowClip=false;
}
void GUIDefine::Display(CDC *pDC , CPoint& pt,CRect rect)
{
	if( this==pStart || this==pTerminal)
		bShowClip= !bShowClip;

	if(!bShowClip){
		pDC->TextOut(Pt.x+pos.x+pt.x,Pt.y+pos.y+pt.y,name);
	}
	else{
		pDC->SetTextColor(RGB(255,255,0));
		pDC->SetBkColor(RGB(0,0,0));
        pDC->TextOut(Pt.x+pos.x+pt.x,Pt.y+pos.y+pt.y,name);
        pDC->SetTextColor(RGB(0,0,255));
		pDC->SetBkColor(RGB(255,255,255));
	}

	if(!bShowClip){
		pDC->TextOut(Pt.x+pos.x+pt.x+strlen(name)*CHARWIDTH,Pt.y+pos.y+pt.y,":=");
	}
	else{
		pDC->SetTextColor(RGB(255,255,0));
		pDC->SetBkColor(RGB(0,0,0));
        pDC->TextOut(Pt.x+pos.x+pt.x+strlen(name)*CHARWIDTH,Pt.y+pos.y+pt.y,":=");
        pDC->SetTextColor(RGB(0,0,255));
		pDC->SetBkColor(RGB(255,255,255));
	}
    
    expr->Display(pDC,pt,rect);

	if(bShowClip  && this == pStart && pStart==pTerminal)
		bShowClip=false;
}

//////////////////////////////////////////////////////////////////////
// GUIDefine.cpp: implementation of the GUIAssign class.
//
//////////////////////////////////////////////////////////////////////
GUIAssign::GUIAssign()
{
	Pt=CPoint(0,0);
	pos=Pt;
	name=0;expr=0;
	rt=0;
}
GUIAssign::GUIAssign(char *Name,GUIAtom *EXPR)
{
	Pt=CPoint(0,0);
	pos=Pt;
	name=Name; expr=EXPR;
	rt=0;
}
GUIAssign::~GUIAssign()
{
	if(name)delete name;
	if(expr)  delete expr;
}

void GUIAssign::CalcRect()
{
	CPoint pt(0,0);
	CSize sz(0,0);

	int height=expr->GetRect()->Height();
	sz.cx=(strlen(name)+1)*CHARWIDTH;
	 
	expr->ReCalcRect(CPoint(sz.cx,0));
	sz.cx+=expr->GetRect()->Width();
	sz.cy=height;

	if(height<=MONOHEIGHT){
	    Pt.y=(height-LINEHEIGHT);
	}
	else{
		Pt.y=(height-LINEHEIGHT)/2;
	}

	rt=new CRect(pt,sz);
}
void GUIAssign::ReCalcRect(CPoint pt)
{
	Pt+=pt;
	expr->ReCalcRect(pt);
}
void GUIAssign::CalcLine(CPoint& pt)
{
	pos=pt;
	expr->CalcLine(pt);
}
CRect* GUIAssign::GetRect() const
{
	return rt;
}
bool GUIAssign::PtInRect(CPoint& pt,CPoint Point)
{
	/*
	CRect RT(rt);
	RT+=Pt+pt+pos;
	return RT.PtInRect(Point);
	//*/
	return false;
}
bool GUIAssign::Check(CPoint& pt,CPoint& mousept)
{
	CRect RT(CPoint(Pt.x+strlen(name)*CHARWIDTH,Pt.y),CSize(CHARWIDTH,LINEHEIGHT));
	RT+=pt+pos;
	if(RT.PtInRect(mousept)){
		return true;
	}
	else{
		expr->Check(pt,mousept);
		return false;
	}
}
bool GUIAssign::ReCheck(CPoint& pt,CPoint& mousept)
{
	CRect RT(CPoint(Pt.x+strlen(name)*CHARWIDTH,Pt.y),CSize(CHARWIDTH,LINEHEIGHT));
	RT+=pt+pos;
	if(RT.PtInRect(mousept)) { 
		return true;
	}
	else{
		expr->ReCheck(pt,mousept);
		return false;
	}
}
void GUIAssign::Copy(CString &string)
{
	if( this==pStart || this==pTerminal)
		bShowClip= !bShowClip;

	if(bShowClip){
		string+=name;
	}

	//  copy  ":="
		
	if(bShowClip) string+="=";
	 
	
	// copy the elements

	expr->Copy(string);

	if(bShowClip  && this == pStart && pStart==pTerminal)
		bShowClip=false;
}
void GUIAssign::Display(CDC *pDC , CPoint& pt,CRect rect)
{
	if( this==pStart || this==pTerminal)
		bShowClip= !bShowClip;

	if(!bShowClip){
		pDC->TextOut(Pt.x+pos.x+pt.x,Pt.y+pos.y+pt.y,name);
	}
	else{
		pDC->SetTextColor(RGB(255,255,0));
		pDC->SetBkColor(RGB(0,0,0));
        pDC->TextOut(Pt.x+pos.x+pt.x,Pt.y+pos.y+pt.y,name);
        pDC->SetTextColor(RGB(0,0,255));
		pDC->SetBkColor(RGB(255,255,255));
	}

	if(!bShowClip){
		pDC->TextOut(Pt.x+pos.x+pt.x+strlen(name)*CHARWIDTH,Pt.y+pos.y+pt.y,"=");
	}
	else{
		pDC->SetTextColor(RGB(255,255,0));
		pDC->SetBkColor(RGB(0,0,0));
        pDC->TextOut(Pt.x+pos.x+pt.x+strlen(name)*CHARWIDTH,Pt.y+pos.y+pt.y,"=");
        pDC->SetTextColor(RGB(0,0,255));
		pDC->SetBkColor(RGB(255,255,255));
	}
    
    expr->Display(pDC,pt,rect);

	if(bShowClip  && this == pStart && pStart==pTerminal)
		bShowClip=false;
}
