//////////////////////////////////////////////////////////////////////
// GUIExp.cpp: implementation of the GUIExpTerm class.
//
//////////////////////////////////////////////////////////////////////
#include "..\stdafx.h"
#include "GUIExp.h"

GUIExpTerm::GUIExpTerm()
{
	sign=0; 
	Pt=CPoint(0,0);pos=Pt;
	data=0;rt=0;next=0;
	state=false;
}
GUIExpTerm::GUIExpTerm(GUIAtom *NODE)
{
	sign=0; 
	Pt=CPoint(0,0);pos=Pt;
	data=NODE;rt=0;next=0;
	state=false;
}
GUIExpTerm::~GUIExpTerm()
{
	if(data)  delete data;
	if(next)  delete next;
	if(rt)    delete rt;
}

void GUIExpTerm::SetSign(int SIGN)
{
	sign=SIGN;
}
void GUIExpTerm::Append(GUIExpTerm *NODE)
{
	GUIExpTerm *m=this;
	while(m->next)m=m->next;
	m->next=NODE;
}
void GUIExpTerm::CalcRect()
{
	Pt=data->GetPt();
    rt=new CRect(data->GetRect());
}
void GUIExpTerm::ZoomRect()
{
	if(sign){
		rt->right+=CHARWIDTH/*+2*/;
		data->ReCalcRect(CPoint(CHARWIDTH/*+2*/,0));
	}

}
void GUIExpTerm::ReCalcRect(CPoint pt)
{
	Pt+=pt;
	data->ReCalcRect(pt);
}
void GUIExpTerm::CalcLine(CPoint& pt)
{
	pos=pt;
	data->CalcLine(pt);
}

CRect* GUIExpTerm::GetRect() const
{
	return rt;
}
bool GUIExpTerm::PtInRect(CPoint& pt,CPoint Point)
{
	CRect RT(rt);
	RT+=Pt+pt+pos;
	if(RT.PtInRect(Point))return true;
	return data->PtInRect(pt,Point);
}
bool GUIExpTerm::Check(CPoint& pt,CPoint& mousept)
{
	//*
	if(sign){
		CRect RT(Pt.x+pt.x+pos.x,Pt.y+pt.y+pos.y,
			Pt.x+pt.x+pos.x+CHARWIDTH/*+2*/,Pt.y+pt.y+pos.y+LINEHEIGHT);
	    if(RT.PtInRect(mousept)) {
		    return true;
		}
	}
    //*/
	St[glSLevel++]=data;
	data->Check(pt,mousept);

	return false;
}
bool GUIExpTerm::ReCheck(CPoint& pt,CPoint& mousept)
{	
	Tr[glTLevel++]=data;
	if(glTLevel>=glSLevel)return false;

	if(St[glTLevel-1]==Tr[glTLevel-1]){
		data->ReCheck(pt,mousept);
	}
	else{
		pStart=St[glTLevel-1];
		pTerminal=Tr[glTLevel-1];
	}

	return false;
}
void GUIExpTerm::Copy(CString& string)
{
 	if(bShowClip)
	{
		switch (sign){
	      case 1:
		      string+='+';
		      break;
	      case -1:	 
		      string+='-';
		      break;
		}
	}

	data->Copy(string);
}
void GUIExpTerm::Display(CDC *pDC , CPoint& pt,CRect rect)
{
 	if(bShowClip)
	{
		pDC->SetTextColor(RGB(255,255,0));
		pDC->SetBkColor(RGB(0,0,0));
	}


	switch (sign){
	case 1:
		pDC->TextOut(Pt.x+pt.x+pos.x,Pt.y+pt.y+pos.y,"+");
		break;
	case -1:	 
		pDC->TextOut(Pt.x+pt.x+pos.x,Pt.y+pt.y+pos.y,"-");
		break;
	}
//*
	if(bShowClip)
	{
		pDC->SetTextColor(RGB(0,0,255));
		pDC->SetBkColor(RGB(255,255,255));
	}
//*/
	if(data){
		data->Display(pDC,pt,rect);
	}
}

//////////////////////////////////////////////////////////////////////
// GUIExp.cpp: implementation of the GUIExp class.
//
//////////////////////////////////////////////////////////////////////
GUIExp::GUIExp()
{
	Pt.x=Pt.y=0;
	pos=Pt;
	data=NULL;
	rt=NULL;
	state=false;
}
GUIExp::GUIExp(GUIExpTerm *NODE)
{
	Pt.x=Pt.y=0;
	pos=Pt;
	data=NODE;
	rt=NULL;
	state=false;
}
GUIExp::~GUIExp()
{
	if(data)delete data;
	if(rt)  delete rt;
}
void GUIExp::CalcRect()
{
	CPoint pt(0,0);
	CSize sz(0,0);
   
	GUIExpTerm *m=data;
	CRect *rt_m;
    
	while(m){
		m->ReCalcRect(CPoint(sz.cx,0));
		rt_m=m->GetRect();
		sz.cx+=rt_m->Width()/*+2*/;
		if(rt_m->Height()>sz.cy) 
			sz.cy=rt_m->Height();
		m=m->next;
	}
	rt=new CRect(pt,sz);
}
void GUIExp::ReCalcRect(CPoint pt)
{
	GUIExpTerm *m=data;
 
	while(m){
		m->ReCalcRect(pt);
		m=m->next;
	}
}
void GUIExp::Locate()
{ 
	CPoint pt(0,0),p;

	p=MaxOffsetDis();
	pt.y=p.y;

	GUIExpTerm *m=data;

	while(m){
		p=m->GetPt();
		m->ReCalcRect(CPoint(pt.x,pt.y-p.y));
		m=m->next;
	}

	Pt=data->GetPt();
}
void GUIExp::CalcLine(CPoint& pt)
{
	pos=pt;
	GUIExpTerm *m=data;
   
	while(m){

		// Note : Ln_Height is a global variable

		if(Ln_Height<m->GetRect()->Height())
			Ln_Height= m->GetRect()->Height();

		if(m->Pt.x+pt.x+m->rt->Width()<=SrcWidth){
			m->CalcLine(pt);
		    m=m->next;
		}
		else if(m->rt->Width()<=SrcWidth){
			pt.x=-m->Pt.x;
			pt.y+=Ln_Height+ROWDIS;
			Ln_Height=0;
		}
		else {  // very long BigInt
			m->CalcLine(pt);
		    m=m->next;
		}
	}
}
CPoint GUIExp::MaxOffsetDis()
{
	CPoint pt(0,0),point;

	GUIExpTerm *m=data;
	while(m){
		point=m->GetPt();
		if(point.y>pt.y)
			pt.y=point.y;
		m=m->next;
	}
	return pt;
}
CRect* GUIExp::GetRect() const
{
	return rt;
}
bool GUIExp::PtInRect(CPoint& pt,CPoint Point)
{
	GUIExpTerm *m=data;

	while(m){
		if(m->PtInRect(pt,Point)){
			return true;
		}
		m=m->next;
	}

	return false;
}
bool GUIExp::Check(CPoint& pt,CPoint& mousept)
{
	St[glSLevel++]=this;

	GUIExpTerm *m=data;
	bool in;

    while(m){
	    if(m->PtInRect(pt,mousept)) {
			in=m->Check(pt,mousept);
			if(in){
				pStart=St[glSLevel-1];
			    pTerminal=St[glSLevel-1];
				return true;
			}
		    break;
		}
		m=m->next;
	}
	return false;
}
bool GUIExp::ReCheck(CPoint& pt,CPoint& mousept)
{
	if(glTLevel>=glSLevel)return false;
	if(St[glTLevel-1]!=Tr[glTLevel-1]){
		pStart=St[glTLevel-1];
	    pTerminal=Tr[glTLevel-1];
		return false;
	}

	Tr[glTLevel++]=this;

	GUIExpTerm *m=data;

    while(m){
	    bool in=m->PtInRect(pt,mousept);
	    if(in) { 
			m->ReCheck(pt,mousept);
		    break;
		}
		m=m->next;
	}

	return false;
}
void GUIExp::SetState(bool s)
{
	state=s;
}
bool GUIExp::GetState()
{
	return state;
}
void GUIExp::Copy(CString& string)
{
	GUIExpTerm *m=data;
    //*
	if( this==pStart || this==pTerminal){
		bShowClip=true;
	}
    //*/
	//if(bShowClip && GetState())string+='(';

	while(m){
		m->Copy(string);
		m=m->next;
	}

	//if(bShowClip && GetState())string+=')';
    //*
	if( this==pStart || this==pTerminal) {
		if(bShowClip ) bShowClip=false;
	}
	//*/
}
void GUIExp::Display(CDC *pDC , CPoint& pt,CRect rect)
{
	GUIExpTerm *m=data;
    //*
	if( pStart==pTerminal && this==pTerminal){
		bShowClip=true;
	}
	while(m){
		  m->Display(pDC,pt,rect);
		  m=m->next;
	}
    /*/
	if(pStart && pTerminal){
	   while(m){
		  m->Display(pDC,pt,rect);
		  m=m->next;
	   }
	}
	else{
		while(m){
			CRect RT(m->rt);
			RT+=m->pos+m->Pt+pt;
			RT.top-=100;RT.bottom+=100;
			if(RT.IntersectRect(RT,rect))
		       m->Display(pDC,pt,rect);
		  m=m->next;
	   }
	}
	//*/
    //*
	if( pStart==pTerminal && this==pTerminal) {
		if(bShowClip ) bShowClip=false;
	}
	//*/
}