//////////////////////////////////////////////////////////////////////
// GUIExp.h: interface for the GUIExpTerm class.
//
//////////////////////////////////////////////////////////////////////
#ifndef GUI_EXPRESSION
#define GUI_EXPRESSION 1

#include "GUIglobe.h"
#include "GUIAtom.h"

// +23*x^2*y^3

class GUIExpTerm:public GUIAtom
{
	int sign;
	GUIAtom *data;
	CRect *rt;
	CPoint Pt;
	CPoint pos;
	GUIExpTerm *next;
	bool state;
public:
	GUIExpTerm();
	GUIExpTerm(GUIAtom *NODE);
	virtual ~GUIExpTerm();

	friend class GUIExp;

	void SetSign(int SIGN);
	void Append(GUIExpTerm *node);
	enum GUIDataType TypeID() { return EXPTERM__TYPE; }
	void CalcRect();
	void ZoomRect();
	void ReCalcRect(CPoint pt);
	void CalcLine(CPoint& pt);
	CPoint GetPt(){ return Pt;}
    CRect* GetRect() const;
	bool PtInRect(CPoint& pt,CPoint Point);
	bool Check(CPoint& pt,CPoint& mousept);
	bool ReCheck(CPoint& pt,CPoint& mousept);
	void Copy(CString& string);
	void Display(CDC *pDC , CPoint& pt,CRect rect);

};

//////////////////////////////////////////////////////////////////////
// GUIExp.h: interface for the GUIExp class.
//
//////////////////////////////////////////////////////////////////////

class GUIExp:public GUIAtom
{
	GUIExpTerm *data;
	CRect *rt;
	CPoint Pt;
	CPoint pos;
	bool state;
public:
	GUIExp();
	GUIExp(GUIExpTerm *NODE);
	virtual ~GUIExp();

	enum GUIDataType TypeID() { return EXPR_TYPE; }
	void CalcRect();
	void ReCalcRect(CPoint pt);
	void CalcLine(CPoint& pt);
	void SetState(bool s);
	bool GetState();
	CPoint GetPt(){ return data->GetPt();}
	CPoint MaxOffsetDis();
	void Locate();
	bool PtInRect(CPoint& pt,CPoint Point);
    CRect* GetRect() const;
	bool Check(CPoint& pt,CPoint& mousept);
	bool ReCheck(CPoint& pt,CPoint& mousept);
	void Copy(CString& string);
	void Display(CDC *pDC , CPoint& pt,CRect rect);
};
#endif