//////////////////////////////////////////////////////////////////////
// GUIFraction.cpp: implementation of the GUIFraction class.
//
//////////////////////////////////////////////////////////////////////
#include "..\stdafx.h"
#include "GUIFraction.h"

GUIFraction::GUIFraction()
{
	Pt.x=Pt.y=0;
	pos=Pt; mode=true;
	denominator=numerator=0;
}
GUIFraction::GUIFraction(GUIAtom *NUM,GUIAtom *DEN)
{
	Pt.x=Pt.y=0;
	pos=Pt;mode=true;
	numerator=NUM;
	denominator=DEN;
}
GUIFraction::~GUIFraction()
{
	if(denominator)delete denominator;
	if(numerator)  delete numerator;
}
void GUIFraction::SetMode()
{
	mode=true;
}
void GUIFraction::ReSetMode()
{
	mode=false;
}
void GUIFraction::CalcRect()
{
	CPoint pt(0,0);
	CSize sz(0,0);

	CRect *rt_d=denominator->GetRect();
	CRect *rt_n=numerator->GetRect();

	if(max(rt_d->Width(),rt_n->Width())>SrcWidth)
		ReSetMode();

	if(mode){    //  ʽʾģʽ
	    sz.cx=max(rt_d->Width(),rt_n->Width());
	    sz.cy=rt_d->Height()+rt_n->Height()+4;

	    rt=new CRect(pt,sz);
   
	    Pt.y=rt_n->Height()-LINEHEIGHT/2;

	    if(rt_n->Width()<=rt_d->Width()){
			pt.x=(rt_d->Width()-rt_n->Width())/2;
		    numerator->ReCalcRect(pt);
			pt.x=0;pt.y=rt_n->Height();
            Line.SetRect(pt,CRect(CPoint(0,0),CSize(sz.cx,4)));
		    pt.x=0;pt.y+=4;
		    denominator->ReCalcRect(pt);
		}
	    else
		{
			pt.x=0;pt.y=rt_n->Height();
            Line.SetRect(pt,CRect(CPoint(0,0),CSize(sz.cx,4)));
		    pt.x=(rt_n->Width()-rt_d->Width())/2;
		    pt.y+=4;
		    denominator->ReCalcRect(pt);
		}
	}
	else{       //ƽʽʾģʽ
	    sz.cy=max(rt_d->Height(),rt_n->Height());
		sz.cx=rt_d->Width()+rt_n->Width()+sz.cy*2/3;

	    rt=new CRect(pt,sz);

	    if(rt_n->Height()<=rt_d->Height()){
			pt.y=(rt_d->Height()-rt_n->Height())/2;
		    numerator->ReCalcRect(pt);
            pt.x=rt_n->Width();pt.y=0;
			Line.SetRect(pt,CRect(CPoint(0,0),CSize(sz.cy*2/3,sz.cy)));
		    pt.x+=sz.cy*2/3;
		    denominator->ReCalcRect(pt);
		}
	    else
		{
			pt.x=rt_n->Width();pt.y=0;
			Line.SetRect(pt,CRect(CPoint(0,0),CSize(sz.cy*2/3,sz.cy)));
		    pt.x+=sz.cy*2/3;
		    pt.y=(rt_n->Height()-rt_d->Height())/2;
		    denominator->ReCalcRect(pt);
		}
	}
}
void GUIFraction::ReCalcRect(CPoint pt)
{
	Pt+=pt;

	numerator->ReCalcRect(pt);
	Line.ReCalcRect(pt);
	denominator->ReCalcRect(pt);
 
}
void GUIFraction::CalcLine(CPoint& pt)
{
	pos=pt;

	numerator->CalcLine(pt);
	Line.CalcLine(pt);
	denominator->CalcLine(pt);
	 
}
CRect* GUIFraction::GetRect() const
{
	return rt;
}
bool GUIFraction::PtInRect(CPoint& pt,CPoint Point)
{
	if(Line.PtInRect(pt,Point) || numerator->PtInRect(pt,Point)
	   || denominator->PtInRect(pt,Point))return true;
	return false;
}
bool GUIFraction::Check(CPoint& pt,CPoint& mousept)
{
	if(Line.PtInRect(pt,mousept)){
		return true;
	}

	numerator->Check(pt,mousept);
	denominator->Check(pt,mousept);

	return false;
}
bool GUIFraction::ReCheck(CPoint& pt,CPoint& mousept)
{
	if(glTLevel>=glSLevel)return true;

	numerator->ReCheck(pt,mousept);
	denominator->ReCheck(pt,mousept);

	return false;
}
void GUIFraction::Copy(CString& string)
{
	numerator->Copy(string);
	if(bShowClip)string+='/';
	denominator->Copy(string);
}
void GUIFraction::Display(CDC *pDC , CPoint& pt,CRect rect)
{
	numerator->Display(pDC,pt,rect);

	// display "------"

	CPen pen,*oldpen;
	if(!bShowClip)
        pen.CreatePen(PS_SOLID,1,RGB(0,0,255));
	else
        pen.CreatePen(PS_SOLID,1,RGB(255,255,0));
	oldpen=pDC->SelectObject(&pen);

	Line.Display(pDC,pt,mode);

	pDC->SelectObject(oldpen);

	denominator->Display(pDC,pt,rect);
}
//////////////////////////////////////////////////////////////////////
// GUIFraction.cpp: implementation of the GUIFraction class.
//
//////////////////////////////////////////////////////////////////////
GUIFracLine::GUIFracLine()
{
	Pt.x=Pt.y=0;
	pos=Pt;
	rt=0;
}
GUIFracLine::~GUIFracLine()
{
	if(rt)   delete rt;
}
void GUIFracLine::SetRect(CPoint& pt,CRect& RT)
{ 
	Pt=CPoint(pt);
	rt=new CRect(RT);
}
void GUIFracLine::ReCalcRect(CPoint pt)
{
	Pt+=pt;
}
void GUIFracLine::CalcLine(CPoint &pt)
{
	pos=pt;
}
CRect* GUIFracLine::GetRect() const
{
	return rt;
}
bool GUIFracLine::PtInRect(CPoint& pt,CPoint Point)
{
	CRect RT(rt);
	RT+=Pt+pt+pos;

	if(RT.PtInRect(Point))return true;

	return false;
}
void GUIFracLine::Copy(CString& string)
{
	if(bShowClip)string+='/';
}
void GUIFracLine::Display(CDC *pDC , CPoint& pt,bool mode)
{
	//  display  "/"

	CPoint point[2];
	CRect RT(rt);
	RT+=Pt+pt+pos;
	CBrush Brush;

	if(bShowClip){
	    Brush.CreateSolidBrush(RGB(0,0,0)); 
	    pDC->FillRect(&RT,&Brush);
	}
	else{
	    Brush.CreateSolidBrush(RGB(255,255,255)); 
	    pDC->FillRect(&RT,&Brush);
	}

	if(mode){
	    point[0].x=Pt.x;
	    point[0].y=Pt.y+rt->Height()/2;
	    point[0]+=(pt+pos);
	    point[1].x=Pt.x+rt->Width();
	    point[1].y=Pt.y+rt->Height()/2;
	    point[1]+=(pt+pos);

	    pDC->Polyline(point,2);
	}
	else{
	    point[0].x=Pt.x;
	    point[0].y=Pt.y+rt->Height();
	    point[0]+=(pt+pos);
	    point[1].x=Pt.x+rt->Width();
	    point[1].y=Pt.y;
	    point[1]+=(pt+pos);

	    pDC->Polyline(point,2); 
	}
}