//////////////////////////////////////////////////////////////////////
// GUIFraction.h: interface for the GUIFraction class.
//
//////////////////////////////////////////////////////////////////////
#ifndef GUI_FRACTION
#define GUI_FRACTION 1
#include "GUIglobe.h"
#include "GUIAtom.h"

class GUIFracLine
{
	CPoint Pt;
	CPoint pos;
	CRect *rt;
public:
	GUIFracLine();
	virtual ~GUIFracLine();

	friend class GUIFracLine;
	void SetRect(CPoint& pt,CRect& RT);
	void ReCalcRect(CPoint pt);
	void CalcLine(CPoint& pt);
	CPoint GetPt(){ return Pt;}
    CRect* GetRect() const;
	bool PtInRect(CPoint& pt,CPoint Point);
	void Copy(CString& string);
	void Display(CDC *pDC , CPoint& pt , bool mode);
};

class GUIFraction:public GUIAtom
{
	GUIAtom *denominator;
	GUIAtom *numerator;
	GUIFracLine Line;
	bool mode;  // ʾģʽ mode=true,ʽ;mode=false,ƽʽ;
	CRect *rt;
	CPoint Pt;
	CPoint pos;
public:
	GUIFraction();
	GUIFraction(GUIAtom *NUM,GUIAtom *DEN);
	virtual ~GUIFraction();

	void SetMode();
	void ReSetMode();
	void CalcRect();
	void ReCalcRect(CPoint pt);
	void CalcLine(CPoint& pt);
	CPoint GetPt(){ return Pt;}
	enum GUIDataType TypeID() { return FRACTION_TYPE; }
	CRect* GetRect() const;
	bool PtInRect(CPoint& pt,CPoint Point);
	bool Check(CPoint& pt,CPoint& mousept);
	bool ReCheck(CPoint& pt,CPoint& mousept);
	void Copy(CString& string);
    void Display(CDC *pDC , CPoint& pt,CRect rect);

};

#endif