//////////////////////////////////////////////////////////////////////
// GUIItem.cpp: implementation of the GUIItem class.
//
//////////////////////////////////////////////////////////////////////

#include "..\stdafx.h"
#include "GUIItem.h"

GUIItem::GUIItem()
{    
   b_pos=d_pos=0;
   data=0;
   rt=0;  
}
 
GUIItem::~GUIItem()
{
	if(data)delete data;
	if(rt)delete rt;
}
void GUIItem::SetOrgBuf(char* buffer)
{   
	if(!Buffer.IsEmpty())
	     Buffer.Empty();

	Buffer+=buffer;
}
void GUIItem::SetData(GUIAtom *DATA)
{ 
	if(data)
		data->Append(DATA);
	else
	{
		data=new GUILS(DATA);
		CPoint pt(0,0);
		data->CalcLine(pt);
		data->rt=new CRect(CPoint(0,0),CSize(SrcWidth,pt.y+Ln_Height+2*ROWDIS));
	}
}

//* Note : maybe useless
void GUIItem::CalcLine()
{
	CPoint point(0,0);

    CPoint pt(0,0);
	CSize  sz(0,0);
	
	data->CalcLine(point);

	sz.cx=SrcWidth;
	sz.cy=point.y+Ln_Height+ROWDIS;
    Ln_Height=0;
	rt=new CRect(pt,sz);
}
//*/
long GUIItem::ShowEdit(CDC *pDC,CRect rt)
{   
	int nCharNum=Buffer.GetLength();
	if(!nCharNum) 
	{
		return b_pos+LINEHEIGHT;
	}

    pDC->SetTextColor(RGB(255,0,0));
	int nLnChar=(rt.Width()-50)/CHARWIDTH;
    CString Line;
	long x0=30,y0=b_pos;
    for(int i=0;i<nCharNum;i++)
		if(Buffer[i]!='\n')
		{
			Line+=Buffer[i];
			if(Line.GetLength()>=nLnChar)
			{
				if( y0>=rt.top-30 && y0<rt.bottom)
				    pDC->TextOut(x0,y0,Line,Line.GetLength());
				Line.Empty();
				y0=y0+LINEHEIGHT+5;
			}
		}
		else
		{
			if( y0>=rt.top-30 && y0<rt.bottom)
			    pDC->TextOut(x0,y0,Line,Line.GetLength());
			y0=y0+LINEHEIGHT+5;
			Line.Empty();
		}
    if(!Line.IsEmpty())
	{
		if( y0>=rt.top-30 && y0<rt.bottom)
		    pDC->TextOut(x0,y0,Line,Line.GetLength());
		Line.Empty();
	}

	return y0+LINEHEIGHT+5;
}

long GUIItem::GetDHeight()
{ 
	GUILS *m=data;
	long height=0;
	while(m){
		CRect *rt=m->GetRect();
		if(rt)
		   height+=rt->Height();
		m=m->next;
	}
	return height;
}
void GUIItem::DeletePoly()
{
	if(data) {
		 delete data;
		 data=0;
	}
}
bool GUIItem::Check(CPoint &pt,CPoint& mousept)
{
	GUILS *m=data;
	bool in;

	while(m){
		in=m->Check(pt,mousept);
		if(in) return true;
		pt.y+=m->GetRect()->Height();
		m=m->next;
	}

	return false;
}
bool GUIItem::ReCheck(CPoint &pt,CPoint& mousept)
{
	GUILS *m=data;
	bool in;

	while(m){
		in=m->ReCheck(pt,mousept);
		if(in)return true;
		pt.y+=m->GetRect()->Height();
		m=m->next;
	}

	return false;
}
void GUIItem::Copy(CString& string)
{
	GUILS *m=data;

	bool stop=false;
	while(m){
		//*
	     if( (m==pStart || m==pTerminal) && (pStart!=pTerminal)){
		    if(!bShowClip && !stop) bShowClip=true;
		    else if(bShowClip && !stop)stop=true;
		 }
	    //*/
		 
		m->Copy(string);

		if( stop && bShowClip) {
		   bShowClip=false;
		}
		if(bShowClip)string+="\n";
		m=m->next;
	}
} 
long GUIItem::ShowItem(CDC *pDC,CPoint &pt,CRect rect)
{
    pDC->SetTextColor(RGB(0,0,255));
	GUILS *m=data;

	bool stop=false;
	while(m){
		//*
	     if( (m==pStart || m==pTerminal) && (pStart!=pTerminal)){
		    if(!bShowClip && !stop) bShowClip=true;
		    else if(bShowClip && !stop)stop=true;
		 }
	    //*/
		 
        CRect RT(m->rt);
		RT+=m->Pt+m->pos+pt;
		if(RT.IntersectRect(RT,rect))
		    m->Display(pDC,pt,rect);
		pt.y+=m->GetRect()->Height();

		if( stop && bShowClip) {
		   bShowClip=false;
		}
		m=m->next;
	}
	return pt.y;
} 
//////////////////////////////////////////////////////////////////////
// GUIItem.cpp: implementation of the GUILS class.
//
//////////////////////////////////////////////////////////////////////

GUILS::GUILS()
{
	Pt=CPoint(0,0);
	pos=Pt;
	data=0;rt=0;
	next=0;
}
GUILS::GUILS(GUIAtom *DATA)
{
	Pt=CPoint(0,0);
	pos=Pt;
	data=DATA;rt=0;
	next=0;
}
GUILS::~GUILS()
{
	if(data)delete data;
	if(rt)  delete rt;
	if(next) delete next;
}
void GUILS::Append(GUIAtom *DATA)
{
	GUILS *m=this;
	while(m->next)
		m=m->next;
	m->next=new GUILS(DATA);
	m=m->next;

	CPoint pt(0,0);
	m->CalcLine(pt);
	m->rt=new CRect(CPoint(0,0),CSize(SrcWidth,pt.y+Ln_Height+2*ROWDIS));
}
void GUILS::CalcRect()
{
	Pt=data->GetPt();
	rt=new CRect(data->GetRect());
}
void GUILS::ReCalcRect(CPoint pt)
{
	Pt+=pt;
	data->ReCalcRect(pt);
}
void GUILS::CalcLine(CPoint& pt)
{
	pos=pt;
	data->CalcLine(pt);
}
CRect* GUILS::GetRect() const
{
	return rt;
}
bool GUILS::PtInRect(CPoint& pt,CPoint Point)
{
	CRect RT(rt);
	RT+=Pt+pos+pt;
	return RT.PtInRect(Point)? true:false;
}
bool GUILS::Check(CPoint& pt,CPoint& mousept)
{
	if(PtInRect(pt,mousept)){
		St[glSLevel++]=this;
		data->Check(pt,mousept);
		return true;
	}
	return false;
}
bool GUILS::ReCheck(CPoint& pt,CPoint& mousept)
{
	if(PtInRect(pt,mousept)){
		Tr[glTLevel++]=this;
		if(St[glTLevel-1]==Tr[glTLevel-1]){
			data->ReCheck(pt,mousept);
		}
		else{
			pStart=St[glTLevel-1];
			pTerminal=Tr[glTLevel-1];
		}

		return true;
	}

	return false;
}
void GUILS::Copy(CString& string)
{
	GUILS *m=this;
	//*
	if( (this==pStart || this==pTerminal) && (pStart==pTerminal)){
		if(bShowClip==false) bShowClip=true;
	}
	//*/

	data->Copy(string);
	if(bShowClip)string+=";";

	//*
	if( (this==pStart || this==pTerminal) && (pStart==pTerminal)) {
		if(bShowClip ) bShowClip=false;
	}
	//*/

}
void GUILS::Display(CDC *pDC , CPoint& pt,CRect rect)
{
	//*
	if( (this==pStart || this==pTerminal) && (pStart==pTerminal)){
		if(bShowClip==false) bShowClip=true;
	}
	//*/

	data->Display(pDC,pt,rect);

	//*
	if( (this==pStart || this==pTerminal) && (pStart==pTerminal)) {
		if(bShowClip ) bShowClip=false;
	}
	//*/
}