//////////////////////////////////////////////////////////////////////
// GUIList.cpp: implementation of the GUIListNode class.
//
//////////////////////////////////////////////////////////////////////

#include "..\stdafx.h"
#include "GUIList.h"

GUIListNode::GUIListNode()
{
	comma=0;
	data=0;
	Pt.x=Pt.y=0;
	pos=Pt;
	rt=0;
	next=0;
}
GUIListNode::GUIListNode(GUIAtom *DATA)
{
    comma=0;
	data=DATA;
	Pt.x=Pt.y=0;
	pos=Pt;
	rt=0;
	next=0;
}
GUIListNode::~GUIListNode()
{
	if(data) delete data;
	if(rt)   delete rt;
	if(next) delete next;
}
void GUIListNode::Append(GUIListNode *NODE)
{
	GUIListNode *m=this;
	while(m->next)
		m=m->next;
	m->next=NODE;
}
void GUIListNode::SetComma()
{
	comma=1;
}
void GUIListNode::ZoomRect()
{
	if(comma){
		rt->right+=CHARWIDTH+2;
		data->ReCalcRect(CPoint(CHARWIDTH+2,0));
	}
}
void GUIListNode::CalcRect()
{
	CPoint pt(0,0);
	CSize sz(0,0);
	CRect *rt_m=data->GetRect();

	if(comma){
		sz.cx=CHARWIDTH;
		data->ReCalcRect(CPoint(sz.cx,0));
	}

	Pt=data->GetPt();

	sz.cx+=rt_m->Width();
	sz.cy=rt_m->Height();
	
    rt=new CRect(pt,sz);
}
void GUIListNode::ReCalcRect(CPoint pt)
{
	Pt+=pt;
	data->ReCalcRect(pt);
}
void GUIListNode::CalcLine(CPoint &pt)
{
	pos=pt;//   cwhou  2002.7.8 ޸  

	data->CalcLine(pt);
	//pos=pt;
}
CRect* GUIListNode::GetRect() const
{
	return rt;
}
bool GUIListNode::PtInRect(CPoint& pt,CPoint Point)
{
	if(comma){
		CRect RT(Pt,CSize(CHARWIDTH+2,rt->Height()));
		RT+=pt+pos;
		int in=RT.PtInRect(Point);
		if(in){
		    return true;
		}
	}
	return data->PtInRect(pt,Point);
}
bool GUIListNode::Check(CPoint& pt,CPoint& mousept)
{
	if(comma){
		CRect RT(Pt,CSize(CHARWIDTH+2,rt->Height()));
		RT+=pt+pos;
		int in=RT.PtInRect(mousept);
		if(in){
			pStart=St[glSLevel-2];
			pTerminal=St[glSLevel-2];
		}
	}

	if(PtInRect(pt,mousept))
	{
		St[glSLevel++]=this;
	    data->Check(pt,mousept);
	}

	return false;
}
bool GUIListNode::ReCheck(CPoint& pt,CPoint& mousept)
{  
    if(PtInRect(pt,mousept))
	{ 
	    Tr[glTLevel++]=this;
	    if(glTLevel>=glSLevel)return true;

	    if(St[glTLevel-1]==Tr[glTLevel-1]){
		   data->ReCheck(pt,mousept);
		}
	    else{
		   pStart=St[glTLevel-1];
	       pTerminal=Tr[glTLevel-1];
		}
	}
	return false;
}
void GUIListNode::Copy(CString& string)
{
		//*
	if( (this==pStart || this==pTerminal) && (pStart==pTerminal)){
		if(bShowClip==false) bShowClip=true;
	}
	//*/

	data->Copy(string);

	//*
	if( (this==pStart || this==pTerminal) && (pStart==pTerminal)) {
		if(bShowClip ) bShowClip=false;
	}
	//*/
	
}
void GUIListNode::Display(CDC *pDC , CPoint& pt,CRect rect)
{
	//*
	if( (this==pStart || this==pTerminal) && (pStart==pTerminal)){
		if(bShowClip==false) bShowClip=true;
	}
	//*/

	data->Display(pDC,pt,rect);

	//*
	if( (this==pStart || this==pTerminal) && (pStart==pTerminal)) {
		if(bShowClip ) bShowClip=false;
	}
	//*/
}

//////////////////////////////////////////////////////////////////////
//
//GUIList.cpp: implementation of the GUIList class.
//
//////////////////////////////////////////////////////////////////////

GUIList::GUIList()
{
	data=0;
	Pt.x=Pt.y=0;
	pos=Pt;
	rt=0;
}
GUIList::GUIList(GUIListNode *NODE)
{
	data=NODE;
	Pt.x=Pt.y=0;
	pos=Pt;
	rt=0;
}
GUIList::~GUIList()
{
	if(data) delete data;
	if(rt) delete rt;
}
CPoint GUIList::GetPt()
{ 
	if(data==0) return Pt;
	return data->GetPt()-CPoint(CHARWIDTH,0);
}
void GUIList::CalcRect()
{
	CPoint pt(0,0);
	CSize sz(CHARWIDTH,0);

	if(data==0){
		CRect rt_h(pt,CSize(CHARWIDTH,LINEHEIGHT));
	    Head.SetRect(pt,rt_h);

	    CRect rt_t(pt,CSize(CHARWIDTH,LINEHEIGHT));
	    Tail.SetRect(CPoint(CHARWIDTH,pt.y),rt_t);

	    sz.cx+=CHARWIDTH;
		sz.cy=LINEHEIGHT;
	    rt=new CRect(pt,sz);
		return;
	}

	GUIListNode *m=data;
	CRect *rt_m;

	while(m){
		m->ReCalcRect(CPoint(sz.cx,0));
		rt_m=m->GetRect();
		sz.cx+=rt_m->Width();
		if(rt_m->Height()>sz.cy) 
			sz.cy=rt_m->Height();
		m=m->next;
	}

	CRect rt_h(pt,CSize(CHARWIDTH,sz.cy));
	Head.SetRect(pt,rt_h);

	CRect rt_t(pt,CSize(CHARWIDTH,sz.cy));
	Tail.SetRect(CPoint(sz.cx,pt.y),rt_t);

	sz.cx+=CHARWIDTH;
	rt=new CRect(pt,sz);
}
void GUIList::ReCalcRect(CPoint pt)
{
	GUIListNode *m=data;
    Pt+=pt;
	Head.ReCalcRect(pt);
	while(m){
		m->ReCalcRect(pt);
		m=m->next;
	}
	Tail.ReCalcRect(pt);
}
void GUIList::CalcLine(CPoint &pt)
{
	pos=pt;

	Head.CalcLine(pt);
	GUIListNode *m=data;
	while(m){	 
		m->CalcLine(pt);
		m=m->next;
	} 
	Tail.CalcLine(pt);
}
void GUIList::Locate()
{ 
	CPoint pt(0,0),p;

	p=MaxOffsetDis();
	pt.y=p.y;

	GUIListNode *m=data;

	while(m){
		p=m->GetPt();
		m->ReCalcRect(CPoint(pt.x,pt.y-p.y));
		m=m->next;
	}
}
CPoint GUIList::MaxOffsetDis()
{
	CPoint pt(0,0),point;

	GUIListNode *m=data;
	while(m){
		point=m->GetPt();
		if(point.y>pt.y)
			pt.y=point.y;
		m=m->next;
	}
	return pt;
}
CRect* GUIList::GetRect() const
{
	return rt;
}
bool GUIList::PtInRect(CPoint& pt,CPoint Point)
{
	if(Head.PtInRect(pt,Point) || Tail.PtInRect(pt,Point)){
		return true;
	}

	GUIListNode *m=data;

	while(m){
		if(m->PtInRect(pt,Point))
			return true;
		m=m->next;
	}
	return false;
}
bool GUIList::Check(CPoint& pt,CPoint& mousept)
{
	St[glSLevel++]=this;

	if(Head.PtInRect(pt,mousept) || Tail.PtInRect(pt,mousept)){
		pStart=St[glSLevel-2];
		pTerminal=St[glSLevel-2];
		return true;
	}

	GUIListNode *m=data;
	while(m){
		m->Check(pt,mousept);
		m=m->next;
	}

	return false;
}
bool GUIList::ReCheck(CPoint& pt,CPoint& mousept)
{
	Tr[glTLevel++]=this;
	if(glTLevel>=glSLevel)return true;

	GUIListNode *m=data;
	while(m){
		m->ReCheck(pt,mousept);
		m=m->next;
	}

	return false;
}
void GUIList::Copy(CString& string)
{
	GUIListNode *m=data;
    
	//  copy  "["
	if(bShowClip)Head.Copy(string);

	// copy the elements

	bool stop=false;
	while(m){
		if(m->comma && bShowClip){  
			    string+=',';
		}
		//*
	     if( (m==pStart || m==pTerminal) && (pStart!=pTerminal)){
		    if(!bShowClip && !stop) bShowClip=true;
		    else if(bShowClip && !stop)stop=true;
		 }
	    //*/
		 

		m->Copy(string);

		if( stop && bShowClip) {
		   bShowClip=false;
		}	 
		m=m->next;
	}
	//*/

	if(bShowClip)Tail.Copy(string);
}
void GUIList::Display(CDC *pDC , CPoint& pt,CRect rect)
{
	GUIListNode *m=data;
    
	Head.Display(pDC,pt,rect);
    if(m==0){Tail.Display(pDC,pt,rect);return;}

	// display the elements

	bool stop=false;
	while(m){

		if(m->comma){
		   if(!bShowClip){
			   pDC->TextOut(pt.x+m->Pt.x+m->pos.x,pt.y+m->Pt.y+m->pos.y,',');
		   }
		   else{
			   pDC->SetTextColor(RGB(255,255,0));
		       pDC->SetBkColor(RGB(0,0,0));
               pDC->TextOut(pt.x+m->Pt.x+m->pos.x,pt.y+m->Pt.y+m->pos.y,',');
               pDC->SetTextColor(RGB(0,0,255));
		       pDC->SetBkColor(RGB(255,255,255));
		   }
		}
		//*
	     if( (m==pStart || m==pTerminal) && (pStart!=pTerminal)){
		    if(!bShowClip && !stop) bShowClip=true;
		    else if(bShowClip && !stop)stop=true;
		 }
	    //*/
		 

		m->Display(pDC,pt,rect);

		if( stop && bShowClip) {
		   bShowClip=false;
		}
		if(!m->next)Tail.Display(pDC,pt,rect);
		m=m->next;
	}
	//*/

}

//////////////////////////////////////////////////////////////////////
// GUIList.cpp: implementation of the GUIListHead class.
//
//////////////////////////////////////////////////////////////////////
GUIListHead::GUIListHead()
{
	Pt.x=Pt.y=0;
	pos=Pt;
	rt=0;
}
GUIListHead::~GUIListHead()
{
	if(rt)   delete rt;
}
void GUIListHead::SetRect(CPoint& pt,CRect& RT)
{ 
	Pt=CPoint(pt);
	rt=new CRect(RT);
}
void GUIListHead::ReCalcRect(CPoint pt)
{
	Pt+=pt;
}
void GUIListHead::CalcLine(CPoint &pt)
{
	pos=pt;
}
CRect* GUIListHead::GetRect() const
{
	return rt;
}
bool GUIListHead::PtInRect(CPoint& pt,CPoint Point)
{
	CRect RT(rt);
	RT+=Pt+pt+pos;

	if(RT.PtInRect(Point))return true;

	return false;
}
void GUIListHead::Copy(CString& string)
{
	if(bShowClip)string+='[';
}
void GUIListHead::Display(CDC *pDC , CPoint& pt,CRect rect)
{
	//  display  "["

	if(rt->Height()<=MONOHEIGHT){
		CPoint point;
		//*
		if(rt->Height()==LINEHEIGHT){
			point=Pt+pt+pos;
		}
		else{
			point=Pt+pt+pos+CPoint(0,6);
		}
		//*/
		if(!bShowClip)
			pDC->TextOut(point.x,point.y,"[");
		else{
				pDC->SetTextColor(RGB(255,255,0));
		        pDC->SetBkColor(RGB(0,0,0));
                pDC->TextOut(point.x,point.y,"[");
                pDC->SetTextColor(RGB(0,0,255));
		        pDC->SetBkColor(RGB(255,255,255));
		}
	}
	else{

		CPen pen,*oldpen;
		if(!bShowClip)
			pen.CreatePen(PS_SOLID,1,RGB(0,0,255));
		else
            pen.CreatePen(PS_SOLID,1,RGB(255,255,0));
		oldpen=pDC->SelectObject(&pen);

	    CPoint point[4];
	    point[0]=Pt+pt+CPoint(5,0)+pos;
	    point[1]=point[0]+CPoint(-5,0);
	    point[2]=point[1]+CPoint(0,rt->Height());
	    point[3]=point[2]+CPoint(5,0);
		pDC->Polyline(point,4);

		pDC->SelectObject(oldpen);
	}
	
}
//////////////////////////////////////////////////////////////////////
// GUIList.cpp: implementation of the GUIListTail class.
//
//////////////////////////////////////////////////////////////////////
GUIListTail::GUIListTail()
{
	Pt.x=Pt.y=0;
	pos=Pt;
	rt=0;
}
GUIListTail::~GUIListTail()
{
	if(rt)   delete rt;
}
void GUIListTail::SetRect(CPoint& pt,CRect& RT)
{
	Pt=CPoint(pt);
	rt=new CRect(RT);
}
void GUIListTail::ReCalcRect(CPoint pt)
{
	Pt+=pt;
}
void GUIListTail::CalcLine(CPoint &pt)
{
	pos=pt;
}
CRect* GUIListTail::GetRect() const
{
	return rt;
}
bool GUIListTail::PtInRect(CPoint& pt,CPoint Point)
{
	CRect RT(rt);
	RT+=Pt+pt+pos;

	if(RT.PtInRect(Point))return true;

	return false;
}
void GUIListTail::Copy(CString& string)
{
	if(bShowClip)string+=']';
}
void GUIListTail::Display(CDC *pDC , CPoint& pt,CRect rect)
{
	if(rt->Height()<=MONOHEIGHT){
		CPoint point;
		//*
		if(rt->Height()==LINEHEIGHT){
			point=Pt+pt+pos;
		}
		else{
			point=Pt+pt+pos+CPoint(0,6);
		}
		//*/
		if(!bShowClip)
			pDC->TextOut(point.x,point.y,"]");
		else{
				pDC->SetTextColor(RGB(255,255,0));
		        pDC->SetBkColor(RGB(0,0,0));
                pDC->TextOut(point.x,point.y,"]");
                pDC->SetTextColor(RGB(0,0,255));
		        pDC->SetBkColor(RGB(255,255,255));
		}
	}
	else{

		CPen pen,*oldpen;
		if(!bShowClip)
			pen.CreatePen(PS_SOLID,1,RGB(0,0,255));
		else
            pen.CreatePen(PS_SOLID,1,RGB(255,255,0));
		oldpen=pDC->SelectObject(&pen);

	    CPoint point[4];
	    point[0]=Pt+pt+pos;
	    point[1]=point[0]+CPoint(5,0);
	    point[2]=point[1]+CPoint(0,rt->Height());
	    point[3]=point[2]+CPoint(-5,0);
		pDC->Polyline(point,4);

		pDC->SelectObject(oldpen);
	}
}