//////////////////////////////////////////////////////////////////////
// GUIList.h: interface for the GUIListNode class.
//
//////////////////////////////////////////////////////////////////////
#ifndef GUI_LIST
#define GUI_LIST 1

#include "GUIglobe.h"
#include "GUIAtom.h"
#include "GUIExp.h"

class GUIList;
class GUIListHead
{
	CPoint Pt;
	CPoint pos;
	CRect *rt;
public:
	GUIListHead();
	virtual ~GUIListHead();

	friend class GUIList;
	void SetRect(CPoint& pt,CRect& RT);
	void ReCalcRect(CPoint pt);
	void CalcLine(CPoint& pt);
	CPoint GetPt(){ return Pt;}
    CRect* GetRect() const;
	bool PtInRect(CPoint& pt,CPoint Point);
	void Copy(CString& string);
	void Display(CDC *pDC , CPoint& pt,CRect rect);
};
class GUIListTail
{
	CPoint Pt;
	CPoint pos;
	CRect *rt;
public:
	GUIListTail();
	virtual ~GUIListTail();

	friend class GUIList;
	void SetRect(CPoint& pt,CRect& RT);
	void ReCalcRect(CPoint pt);
	void CalcLine(CPoint& pt);
	CPoint GetPt(){ return Pt;}
    CRect* GetRect() const;
	bool PtInRect(CPoint& pt,CPoint Point);
	void Copy(CString& string);
	void Display(CDC *pDC , CPoint& pt,CRect rect);
};
class GUIListNode:public GUIAtom 
{
	int comma;
	GUIAtom *data;
	CPoint Pt;
	CPoint pos;
	CRect *rt;
	GUIListNode *next;
 
public:
	GUIListNode();
	GUIListNode(GUIAtom *DATA);
	virtual ~GUIListNode();

	friend class GUIList;
	friend class GUIFunc;
	friend class GUIPDE;
	void Append(GUIListNode *NODE);
	virtual enum GUIDataType TypeID() { return LIST_TYPE; }
	void SetComma();
	void CalcRect();
	void ZoomRect();
	void ReCalcRect(CPoint pt);
	void CalcLine(CPoint& pt);
	CPoint GetPt(){ return Pt;}
    CRect* GetRect() const;
	bool PtInRect(CPoint& pt,CPoint Point);
	bool Check(CPoint& pt,CPoint& mousept);
	bool ReCheck(CPoint& pt,CPoint& mousept);
	void Copy(CString& string);
	void Display(CDC *pDC , CPoint& pt,CRect rect);

};

//////////////////////////////////////////////////////////////////////
// GUIList.h: interface for the GUIList class.
//
//////////////////////////////////////////////////////////////////////

class GUIList:public GUIAtom 
{
	GUIListHead Head;
	GUIListNode *data;
	GUIListTail Tail;
	CPoint Pt;
	CPoint pos;
	CRect *rt;
public:
	GUIList();
	GUIList(GUIListNode *NODE);
	virtual ~GUIList();

	friend class GUIFunc;
	friend class GUIPDE;
	virtual enum GUIDataType TypeID() { return LIST_TYPE; }
	void CalcRect();
	void ReCalcRect(CPoint pt);
	void CalcLine(CPoint& pt);
	CPoint GetPt();
	CRect* GetRect() const;
	CPoint MaxOffsetDis();
	void Locate();
	bool PtInRect(CPoint& pt,CPoint Point);
	bool Check(CPoint& pt,CPoint& mousept);
	bool ReCheck(CPoint& pt,CPoint& mousept);
	void Copy(CString& string);
	void Display(CDC *pDC , CPoint& pt,CRect rect);

};

#endif
