//////////////////////////////////////////////////////////////////////
// GUIMatrix.h: interface for the GUIMatrix class.
//
//////////////////////////////////////////////////////////////////////
#ifndef GUI_MATRIX
#define GUI_MATRIX 1

#include "GUIglobe.h"
#include "GUIAtom.h"

class GUIMatrixNode;

class GUIMatrix:public GUIAtom
{
	GUIMatrixNode *data;
	CRect *rt;
	CPoint   Pt;
public:
	GUIMatrix();
	GUIMatrix(GUIMatrixNode *NODE);
	virtual ~GUIMatrix();

	enum GUIDataType TypeID() { return MATRIX_TYPE; }
	void CalcRect();
	void ReCalcRect(CPoint pt);
	void CalcLine(CPoint& pt);
	void Locate();
	CPoint GetPt(){ return Pt;}
    CRect* GetRect() const;
	bool PtInRect(CPoint& pt,CPoint Point);
    bool Check(CPoint& pt,CPoint& mousept);
	bool ReCheck(CPoint& pt,CPoint& mousept);
	void Copy(CString& string);
	void Display(CDC *pDC , CPoint& pt,CRect rect);

};

//////////////////////////////////////////////////////////////////////
// GUIMatrix.h: interface for the GUIMatrixNode class.
//
//////////////////////////////////////////////////////////////////////

class GUIMatrixNode:public GUIAtom
{
	GUIAtom *data;
	CRect *rt;
	CPoint   Pt;
	int row_height;
	int col_width;
	GUIMatrixNode *right;
	GUIMatrixNode *down;
public:
	GUIMatrixNode();
	GUIMatrixNode(GUIAtom *NODE);
	virtual ~GUIMatrixNode();

	friend class GUIMatrix;

	enum GUIDataType TypeID() { return MATRIX_TYPE; }
	void Append(GUIMatrixNode *NODE);
	void AppendRow(GUIMatrixNode *ROW);
	void CalcRect();
	void ReCalcRect(CPoint pt);
	void CalcLine(CPoint& pt);
	void ZoomRect(CPoint pt);
	CPoint GetPt(){ return Pt;}
    CRect* GetRect() const;

	bool PtInRect(CPoint& pt,CPoint Point);
    bool Check(CPoint& pt,CPoint& mousept);
	bool ReCheck(CPoint& pt,CPoint& mousept);
	void Copy(CString& string);
	void Display(CDC *pDC , CPoint& pt,CRect rect);

};
#endif