//////////////////////////////////////////////////////////////////////
// GUIFunc.cpp: implementation of the GUIFunc class.
//
//////////////////////////////////////////////////////////////////////

#include "..\stdafx.h"
#include "GUIglobe.h"
#include "GUIAtom.h"
#include "GUIPDE.h"

GUIFunc::GUIFunc()
{
	Pt=CPoint(0,0);
	pos=Pt;
	name=0;paralist=0;
	rt=0;
}
GUIFunc::GUIFunc(char *Name,GUIList *para)
{
	Pt=CPoint(0,0);
	pos=Pt;
	name=Name; paralist=para;
	rt=0;
}
GUIFunc::~GUIFunc()
{
	if(name)delete name;
	if(paralist)  delete paralist;
}

void GUIFunc::CalcRect()
{
	CPoint pt(0,0);
	CSize sz(0,0);

	int height=paralist->GetRect()->Height();

	if(height<=MONOHEIGHT){
		sz.cx=strlen(name)*CHARWIDTH;
	}
	else{
		sz.cx=strlen(name)*CHARWIDTH+height/10;
	}
	paralist->ReCalcRect(CPoint(sz.cx,0));
	sz.cx+=paralist->GetRect()->Width();
	sz.cy=height;

	if(sz.cy<=MONOHEIGHT){
		Pt.y=sz.cy-LINEHEIGHT;
	}
	else{
		Pt.y=paralist->GetPt().y;
	}
	rt=new CRect(pt,sz);
}
void GUIFunc::ReCalcRect(CPoint pt)
{
	Pt+=pt;
	paralist->ReCalcRect(pt);
}
void GUIFunc::CalcLine(CPoint& pt)
{
	pos=pt;
	paralist->CalcLine(pt);
}
CRect* GUIFunc::GetRect() const
{
	return rt;
}
bool GUIFunc::PtInRect(CPoint& pt,CPoint Point)
{
	/*
	CRect RT(rt);
	RT+=Pt+pt+pos;
	return RT.PtInRect(Point);
	//*/
	return false;
}
void GUIFunc::Check(CPoint& pt,CPoint& mousept)
{
	CRect RT(Pt,CSize(strlen(name)*CHARWIDTH,LINEHEIGHT));
	RT+=pt+pos;
	if(RT.PtInRect(mousept)){
		St[glSLevel++]=this;
	}
	else{
		paralist->Check(pt,mousept);
	}
}
void GUIFunc::ReCheck(CPoint& pt,CPoint& mousept)
{
	CRect RT(Pt,CSize(strlen(name)*CHARWIDTH,LINEHEIGHT));
	RT+=pt+pos;
	if(RT.PtInRect(mousept)) { 
		Tr[glTLevel++]=this;	    
		pStart=St[glTLevel-1];
	    pTerminal=Tr[glTLevel-1];
	}
	else{
		paralist->ReCheck(pt,mousept);
	}
}
void GUIFunc::Copy(CString &string)
{
	GUIListNode *m=paralist->data;

	if( this==pStart || this==pTerminal)
		bShowClip= !bShowClip;

	if(bShowClip){
		string+=name;
	}

	//  copy  "("
		
	if(bShowClip) string+="(";
	 
	
	// copy the elements

	while(m){

		m->Copy(string);

		if(!m->next)  
            if(bShowClip) string+=")";

		m=m->next;
	}

	if(bShowClip  && this == pStart && pStart==pTerminal)
		bShowClip=false;
}
void GUIFunc::Display(CDC *pDC , CPoint& pt)
{
	if( this==pStart || this==pTerminal)
		bShowClip= !bShowClip;

	if(!bShowClip){
		pDC->TextOut(Pt.x+pos.x+pt.x,Pt.y+pos.y+pt.y,name);
	}
	else{
		pDC->SetTextColor(RGB(255,255,0));
		pDC->SetBkColor(RGB(0,0,0));
        pDC->TextOut(Pt.x+pos.x+pt.x,Pt.y+pos.y+pt.y,name);
        pDC->SetTextColor(RGB(0,0,255));
		pDC->SetBkColor(RGB(255,255,255));
	}

	GUIListNode *m=paralist->data;
    
    CPoint pp=paralist->GetPt();
	//  display  "("

	if(rt->Height()<=MONOHEIGHT){
		CPoint point;
		point=m->Pt+pt+m->pos;
		
		if(!bShowClip){
		    pDC->TextOut(point.x-CHARWIDTH,point.y,"(");
		}
	    else{
		    pDC->SetTextColor(RGB(255,255,0));
		    pDC->SetBkColor(RGB(0,0,0));
            pDC->TextOut(point.x-CHARWIDTH,point.y,"(");
            pDC->SetTextColor(RGB(0,0,255));
		    pDC->SetBkColor(RGB(255,255,255));
		}
	    //pDC->TextOut(point.x-CHARWIDTH,point.y,"(");
	}
	else{
		int height=paralist->GetRect()->Height();
		CPoint point=paralist->Pt+pt+paralist->pos;
		CRect Rect(point.x,point.y,point.x+2*height/6,point.y+height);
	    CPoint ps(point.x+height/6,point.y),pe(point.x+height/6,point.y+height);
	   
		CPen pen,*oldpen;
		pen.CreatePen(PS_SOLID,1,RGB(0,0,255));
	    oldpen=pDC->SelectObject(&pen);
		
		pDC->Arc(&Rect,ps,pe);

		pDC->SelectObject(oldpen);
	}
	 
	
	// display the elements

	while(m){

		m->Display(pDC,pt);

		if(!m->next){  
			
			//  display  ")"
			if(rt->Height()<=MONOHEIGHT){
				CPoint point=m->Pt+pt+CPoint(m->rt->Width(),0)+m->pos;
                if(!bShowClip){
		           pDC->TextOut(point.x,point.y,")");
				}
	            else{
		           pDC->SetTextColor(RGB(255,255,0));
		           pDC->SetBkColor(RGB(0,0,0));
                   pDC->TextOut(point.x,point.y,")");
                   pDC->SetTextColor(RGB(0,0,255));
		           pDC->SetBkColor(RGB(255,255,255));
				}
				//pDC->TextOut(point.x,point.y,")");
			}
			else{
				int height=paralist->GetRect()->Height();
		        CPoint point=m->Pt+pt+CPoint(m->rt->Width(),-pp.y)+m->pos;
		        CRect Rect(point.x-height/6,point.y,point.x+height/6,point.y+height);
	            CPoint ps(point.x,point.y+height),pe(point.x,point.y);
	   
		        CPen pen,*oldpen;
		        pen.CreatePen(PS_SOLID,1,RGB(0,0,255));
	            oldpen=pDC->SelectObject(&pen);
		
		        pDC->Arc(&Rect,ps,pe);

		        pDC->SelectObject(oldpen);
			}
		}
		else{
			pDC->TextOut(pt.x+m->Pt.x+m->pos.x+m->GetRect()->Width(),pt.y+m->Pt.y+m->pos.y,',');
		}
		m=m->next;
	}

	if(bShowClip  && this == pStart && pStart==pTerminal)
		bShowClip=false;
}