// DrawView.cpp : implementation of the CDrawView class
//

#include "stdafx.h"
#include <afxpriv.h>
#include <afxtempl.h>
#include "Draw.h"

#include "DrawDoc.h"
#include "drawobj.h"
#include "CntrItem.h"
#include "DrawView.h"
#include "treeviewobj.h"
#include "treeViewConstraint.h"
#include "AnimationSpeed.h"

#include "gui\GUIItem.h"
extern GUIItem *pItem;
extern POSITION  CurPos2;

#include "drawtool.h"
#include "mainfrm.h"
#include "Construction.h"
#include "math.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern HWND hhh;
extern HWND Ghwnd;
extern HWND GViewhwnd;
HWND GViewhwnd;
/////////////////////////////////////////////////////////////////////////////
// private clipboard format (list of Draw objects)
CLIPFORMAT CDrawView::m_cfDraw = (CLIPFORMAT)
#ifdef _MAC
	::RegisterClipboardFormat(_T("DCLI"));
#else
	::RegisterClipboardFormat(_T("MFC Draw Sample"));
#endif
CLIPFORMAT CDrawView::m_cfObjectDescriptor = NULL;

/////////////////////////////////////////////////////////////////////////////
//

IMPLEMENT_DYNCREATE(CDrawView, CScrollView)

BEGIN_MESSAGE_MAP(CDrawView, CScrollView)
	//{{AFX_MSG_MAP(CDrawView)
	ON_WM_DESTROY()
	ON_WM_SETFOCUS()
	ON_WM_SIZE()
	ON_COMMAND(ID_OLE_INSERT_NEW, OnInsertObject)
	ON_COMMAND(ID_CANCEL_EDIT_CNTR, OnCancelEditCntr)
	ON_WM_CONTEXTMENU()
	ON_COMMAND(ID_DRAW_MYCIRCLE, OnDrawMycircle)
	ON_COMMAND(ID_DRAW_MYLINE, OnDrawMyline)
	ON_COMMAND(ID_DRAW_MYPOINT, OnDrawMypoint)
	ON_COMMAND(ID_DRAW_POLYGON, OnDrawPolygon)
	ON_COMMAND(ID_DRAW_SELECT, OnDrawSelect)
	ON_COMMAND(ID_EDIT_CLEAR, OnEditClear)
	ON_COMMAND(ID_EDIT_CONSTRUCTION, OnEditConstruction)
	ON_COMMAND(ID_EDIT_COPY, OnEditCopy)
	ON_COMMAND(ID_EDIT_CUT, OnEditCut)
	ON_COMMAND(ID_EDIT_INTSCTION, OnEditIntsction)
	ON_COMMAND(ID_EDIT_MIDPOINT, OnEditMidpoint)
	ON_COMMAND(ID_EDIT_PARALLE, OnEditParalle)
	ON_COMMAND(ID_EDIT_PASTE, OnEditPaste)
	ON_COMMAND(ID_EDIT_PROPERTIES, OnEditProperties)
	ON_COMMAND(ID_EDIT_SELECT_ALL, OnEditSelectAll)
	ON_COMMAND(ID_EDIT_VERTICAL, OnEditVertical)
	ON_COMMAND(ID_EDIT_VERTICALFOOT, OnEditVerticalfoot)
	ON_WM_ERASEBKGND()
	ON_WM_LBUTTONDBLCLK()
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONUP()
	ON_WM_MOUSEMOVE()
	ON_COMMAND(ID_OBJECT_FILLCOLOR, OnObjectFillcolor)
	ON_COMMAND(ID_OBJECT_LINECOLOR, OnObjectLinecolor)
	ON_COMMAND(ID_OBJECT_MOVEBACK, OnObjectMoveback)
	ON_COMMAND(ID_OBJECT_MOVEFORWARD, OnObjectMoveforward)
	ON_COMMAND(ID_OBJECT_MOVETOBACK, OnObjectMovetoback)
	ON_COMMAND(ID_OBJECT_MOVETOFRONT, OnObjectMovetofront)
	ON_UPDATE_COMMAND_UI(ID_EDIT_CLEAR, OnUpdateEditClear)
	ON_UPDATE_COMMAND_UI(ID_EDIT_CONSTRUCTION, OnUpdateEditConstruction)
	ON_UPDATE_COMMAND_UI(ID_EDIT_COPY, OnUpdateEditCopy)
	ON_UPDATE_COMMAND_UI(ID_EDIT_CUT, OnUpdateEditCut)
	ON_UPDATE_COMMAND_UI(ID_EDIT_INTSCTION, OnUpdateEditIntsction)
	ON_UPDATE_COMMAND_UI(ID_EDIT_MIDPOINT, OnUpdateEditMidpoint)
	ON_UPDATE_COMMAND_UI(ID_EDIT_PARALLE, OnUpdateEditParalle)
	ON_UPDATE_COMMAND_UI(ID_EDIT_PASTE, OnUpdateEditPaste)
	ON_UPDATE_COMMAND_UI(ID_EDIT_PROPERTIES, OnUpdateEditProperties)
	ON_UPDATE_COMMAND_UI(ID_EDIT_SELECT_ALL, OnUpdateEditSelectAll)
	ON_UPDATE_COMMAND_UI(ID_EDIT_VERTICAL, OnUpdateEditVertical)
	ON_UPDATE_COMMAND_UI(ID_EDIT_VERTICALFOOT, OnUpdateEditVerticalfoot)
	ON_UPDATE_COMMAND_UI(ID_OBJECT_MOVEBACK, OnUpdateObjectMoveback)
	ON_UPDATE_COMMAND_UI(ID_OBJECT_MOVEFORWARD, OnUpdateObjectMoveforward)
	ON_UPDATE_COMMAND_UI(ID_OBJECT_MOVETOBACK, OnUpdateObjectMovetoback)
	ON_UPDATE_COMMAND_UI(ID_OBJECT_MOVETOFRONT, OnUpdateObjectMovetofront)
	ON_UPDATE_COMMAND_UI(ID_VIEW_GRID, OnUpdateViewGrid)
	ON_UPDATE_COMMAND_UI(ID_VIEW_SHOWOBJECTS, OnUpdateViewShowobjects)
	ON_COMMAND(ID_VIEW_GRID, OnViewGrid)
	ON_COMMAND(ID_VIEW_SHOWOBJECTS, OnViewShowobjects)
	ON_WM_CREATE()
	ON_COMMAND(ID_DRAW_ELLIPSE, OnDrawEllipse)
	ON_COMMAND(ID_DRAW_LINE, OnDrawLine)
	ON_COMMAND(ID_DRAW_RECT, OnDrawRect)
	ON_COMMAND(ID_DRAW_ROUNDRECT, OnDrawRoundrect)
	ON_UPDATE_COMMAND_UI(ID_DRAW_ELLIPSE, OnUpdateDrawEllipse)
	ON_UPDATE_COMMAND_UI(ID_DRAW_LINE, OnUpdateDrawLine)
	ON_UPDATE_COMMAND_UI(ID_DRAW_POLYGON, OnUpdateDrawPolygon)
	ON_UPDATE_COMMAND_UI(ID_DRAW_RECT, OnUpdateDrawRect)
	ON_UPDATE_COMMAND_UI(ID_DRAW_ROUNDRECT, OnUpdateDrawRoundrect)
	ON_UPDATE_COMMAND_UI(ID_DRAW_SELECT, OnUpdateDrawSelect)
	ON_COMMAND(ID_SHOW_NAME, OnShowName)
	ON_COMMAND(ID_SHOW_SCALE, OnShowScale)
	ON_UPDATE_COMMAND_UI(ID_DRAW_MYLINE, OnUpdateDrawMyline)
	ON_UPDATE_COMMAND_UI(ID_DRAW_MYPOINT, OnUpdateDrawMypoint)
	ON_UPDATE_COMMAND_UI(ID_DRAW_MYCIRCLE, OnUpdateDrawMycircle)
	ON_WM_RBUTTONDOWN()
	ON_WM_RBUTTONUP()
	ON_COMMAND(ID_ROTATE, OnRotate)
	ON_UPDATE_COMMAND_UI(ID_ROTATE, OnUpdateRotate)
	ON_COMMAND(ID_TRANSLATE, OnTranslate)
	ON_UPDATE_COMMAND_UI(ID_TRANSLATE, OnUpdateTranslate)
	ON_COMMAND(ID_ZOOM, OnZoom)
	ON_UPDATE_COMMAND_UI(ID_ZOOM, OnUpdateZoom)
	ON_COMMAND(ID_DPLAY, OnDplay)
	ON_WM_TIMER()
	ON_COMMAND(ID_DLINE, OnDline)
	ON_COMMAND(ID_DPOINT, OnDpoint)
	ON_COMMAND(ID_DCIRCLE, OnDcircle)
	ON_COMMAND(ID_DSELFDRAW, OnDselfdraw)
	ON_COMMAND(ID_STYLEPOINT, OnStylepoint)
	ON_COMMAND(ID_STYLELINE, OnStyleline)
	ON_COMMAND(ID_STYLECIRCLE, OnStylecircle)
	ON_UPDATE_COMMAND_UI(ID_DPOINT, OnUpdateDpoint)
	ON_COMMAND(ID_TR_CENTRIOD, OnTrCentriod)
	ON_COMMAND(ID_TR_CIRCUMCENTER, OnTrCircumcenter)
	ON_COMMAND(ID_TR_EQUILATERAL, OnTrEquilateral)
	ON_COMMAND(ID_TR_INCENTER, OnTrIncenter)
	ON_COMMAND(ID_TR_ORTHOCENTER, OnTrOrthocenter)
	ON_COMMAND(ID_TR_VERTEX, OnTrVertex)
	ON_COMMAND(ID_ASPEED, OnAspeed)
	ON_COMMAND(ID_CREATEANGLE, OnCreateangle)
	ON_COMMAND(ID_CREATE_PCIRCLE, OnCreatePcircle)
	ON_COMMAND(ID_CREATE_RCIRCLE, OnCreateRcircle)
	ON_COMMAND(ID_CREATE_TCIRCLE, OnCreateTcircle)
	ON_COMMAND(ID_CO_CZ, OnCoCz)
	ON_COMMAND(ID_CO_MID, OnCoMid)
	ON_COMMAND(ID_CO_PX, OnCoPx)
	//}}AFX_MSG_MAP
	// Standard printing commands
	ON_COMMAND(ID_FILE_PRINT, CScrollView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CScrollView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CScrollView::OnFilePrintPreview)
	ON_MESSAGE(WM_MESSAGEOBJ,OnMessageObjSend)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDrawView construction/destruction
LONG CDrawView::OnMessageObjSend(WPARAM wParam,LPARAM lParam)
{	
    itemp=1;   
	CDrawDoc*pDdoc=(CDrawDoc*)lParam;
	GetConstraintList(pDdoc->GetObjects());
	Invalidate();
    return 0;
}
CDrawView::CDrawView()
{    
	bShowName=0;
	bShowScale=1;
	bAngle=0;
	itemp=0;
	m_bGrid = FALSE;
	m_gridColor = RGB(0, 0, 128);
	m_bActive = FALSE;
	if( m_cfObjectDescriptor == NULL )
		m_cfObjectDescriptor = (CLIPFORMAT)::RegisterClipboardFormat(_T("Object Descriptor") );
	m_prevDropEffect = DROPEFFECT_NONE;
	intersection=new CPoint2(0.0 ,0.0);
    m_bool_midpoint=NULL;  
	m_CurrentMove=0;
	m_Dragging=0;  
}

CDrawView::~CDrawView()
{
	delete intersection;
    m_selection.RemoveAll();
	m_combineobject.RemoveAll();//no use
	m_abstractofline.RemoveAll();//
	m_abstractofpoint.RemoveAll();
    m_transformedlist.RemoveAll();
	m_dependentslist.RemoveAll();
}

BOOL CDrawView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	ASSERT(cs.style & WS_CHILD);
	if (cs.lpszClass == NULL)
		cs.lpszClass = AfxRegisterWndClass(CS_DBLCLKS);
	return TRUE;
}
/////////////////////////////////////////////////////////////

void CDrawView::OnActivateView(BOOL bActivate, CView* pActiveView,
	CView* pDeactiveView)
{
	CView::OnActivateView(bActivate, pActiveView, pDeactiveView);

	// invalidate selections when active status changes
	if (m_bActive != bActivate)
	{
		if (bActivate)  // if becoming active update as if active
			m_bActive = bActivate;
		if (!m_selection.IsEmpty())
			OnUpdate(NULL, HINT_UPDATE_SELECTION, NULL);
		m_bActive = bActivate;
	}
}

/////////////////////////////////////////////////////////////////////////////
// CDrawView drawing

void CDrawView::OnDraw(CDC* pDC)
{
	CDrawDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
    /////////////////////////////////////////////////////////////////
	CDC dc;
	CDC* pDrawDC = pDC;
	CBitmap bitmap;
	CBitmap* pOldBitmap;

	// only paint the rect that needs repainting
	CRect client;
	pDC->GetClipBox(client);
	CRect rect = client;
	DocToClient(rect);

	if (!pDC->IsPrinting())
	{
		// draw to offscreen bitmap for fast looking repaints
		if (dc.CreateCompatibleDC(pDC))
		{
			if (bitmap.CreateCompatibleBitmap(pDC, rect.Width(), rect.Height()))
			{
				OnPrepareDC(&dc, NULL);
				pDrawDC = &dc;

				// offset origin more because bitmap is just piece of the whole drawing
				dc.OffsetViewportOrg(-rect.left, -rect.top);
				pOldBitmap = dc.SelectObject(&bitmap);
				dc.SetBrushOrg(rect.left % 8, rect.top % 8);

				// might as well clip to the same rectangle
				dc.IntersectClipRect(client);
			}
		}
	}
	// paint background
	CBrush brush;
	if (!brush.CreateSolidBrush(pDoc->GetPaperColor()))
		return;
	brush.UnrealizeObject();
	pDrawDC->FillRect(client, &brush);
	if (!pDC->IsPrinting() && m_bGrid)
		DrawGrid(pDrawDC);
	pDoc->Draw(pDrawDC, this);
	if (pDrawDC != pDC)
	{
		pDC->SetViewportOrg(0, 0);
		pDC->SetWindowOrg(0,0);
		pDC->SetMapMode(MM_TEXT);
		dc.SetViewportOrg(0, 0);
		dc.SetWindowOrg(0,0);
		dc.SetMapMode(MM_TEXT);
		pDC->BitBlt(rect.left, rect.top, rect.Width(), rect.Height(),
			&dc, 0, 0, SRCCOPY);
		dc.SelectObject(pOldBitmap);
	}
}

void CDrawView::OnInitialUpdate()
{
	CScrollView::OnInitialUpdate();

    GViewhwnd=GetSafeHwnd();
	// TODO: remove this code when final selection model code is written
/*	m_pSelection = NULL;    // initialize selection

	CSize sizeTotal;
	// TODO: calculate the total size of this view
	sizeTotal.cx = sizeTotal.cy = 100;
	SetScrollSizes(MM_TEXT, sizeTotal);
*/
	CDrawDoc *pDoc=(CDrawDoc *)GetDocument();
	((CDrawApp*)(::AfxGetApp()))->m_pDoc=pDoc;
	ASSERT_VALID(pDoc);

	CSize size = GetDocument()->GetSize();
	CClientDC dc(NULL);
	size.cx = MulDiv(size.cx, dc.GetDeviceCaps(LOGPIXELSX), 100);
	size.cy = MulDiv(size.cy, dc.GetDeviceCaps(LOGPIXELSY), 100);
	SetScrollSizes(MM_TEXT, size);


	 pItem=new GUIItem();
     CurPos2=pDoc->ExpList.AddTail(pItem);
	//////////////////////////////////////////////	
}
///**********************************************///

void CDrawView::DrawGrid(CDC* pDC)
{
	CDrawDoc* pDoc = GetDocument();

	COLORREF oldBkColor = pDC->SetBkColor(pDoc->GetPaperColor());

	CRect rect;
	rect.left = -pDoc->GetSize().cx / 2;
	rect.top = -pDoc->GetSize().cy / 2;
	rect.right = rect.left + pDoc->GetSize().cx;
	rect.bottom = rect.top + pDoc->GetSize().cy;

	// Center lines
	CPen penDash;
	penDash.CreatePen(PS_DASH, 1, m_gridColor);
	CPen* pOldPen = pDC->SelectObject(&penDash);

	pDC->MoveTo(0, rect.top);
	pDC->LineTo(0, rect.bottom);
	pDC->MoveTo(rect.left, 0);
	pDC->LineTo(rect.right, 0);

	// Major unit lines
	CPen penDot;
	penDot.CreatePen(PS_DOT, 1, m_gridColor);
	pDC->SelectObject(&penDot);

	for (int x = rect.left / 100 * 100; x < rect.right; x += 100)
	{
		if (x != 0)
		{
			pDC->MoveTo(x, rect.top);
			pDC->LineTo(x, rect.bottom);
		}
	}

	for (int y = rect.top / 100 * 100; y < rect.bottom; y += 100)
	{
		if (y != 0)
		{
			pDC->MoveTo(rect.left, y);
			pDC->LineTo(rect.right, y);
		}
	}

	// Outlines
	CPen penSolid;
	penSolid.CreatePen(PS_SOLID, 1, m_gridColor);
	pDC->SelectObject(&penSolid);
	pDC->MoveTo(rect.left, rect.top);
	pDC->LineTo(rect.right, rect.top);
	pDC->LineTo(rect.right, rect.bottom);
	pDC->LineTo(rect.left, rect.bottom);
	pDC->LineTo(rect.left, rect.top);

	pDC->SelectObject(pOldPen);
	pDC->SetBkColor(oldBkColor);
}
///**********************************************///
void CDrawView::SetPageSize(CSize size)
{
	CClientDC dc(NULL);
	size.cx = MulDiv(size.cx, dc.GetDeviceCaps(LOGPIXELSX), 100);
	size.cy = MulDiv(size.cy, dc.GetDeviceCaps(LOGPIXELSY), 100);
	SetScrollSizes(MM_TEXT, size);
	GetDocument()->UpdateAllViews(NULL, HINT_UPDATE_WINDOW, NULL);
}


/////////////////////////////////////////////////////////////////////////////
void CDrawView::Deselect(CDrawObj* pObj)
{
	POSITION pos = m_selection.Find(pObj);
	if (pos != NULL)
	{
		InvalObj(pObj);
		m_selection.RemoveAt(pos);
	}
}
///////////////////////////////////////////////////////////////////
CMyLine* CDrawView::Paralle(CDrawObjList &temp)
{
    if(temp.GetCount()>1)
	{
	    POSITION pos = temp.GetTailPosition();
	    CDrawObj* pObj1 = temp.GetPrev(pos);
        CDrawObj* pObj2 = temp.GetPrev(pos);
		CPoint2 temp,temp1,temp2,temp3;
		if(pObj1->type==1&&pObj2->type==2)
		{
		    temp1=((CMyPoint*)pObj1)->m_startpoint;
			temp2=((CMyLine*)pObj2)->my_startpoint->m_startpoint;
			temp3=((CMyLine*)pObj2)->my_endpoint->m_startpoint;
            temp=temp1+temp2-temp3;
			CMyPoint* pObjpoint=new CMyPoint(&temp);
			pObjpoint->ptype=3;//ʾƽֱϵ
			pObjpoint->m_scale=1;
			m_paralleline=new CMyLine((CMyPoint*)pObj1,pObjpoint);
			pObjpoint->m_startpoint=m_paralleline->getPointByScale(pObjpoint->m_scale);
			pObjpoint->m_conect1=m_paralleline;
            pObjpoint->m_conect2=(CMyLine*)pObj2;
            GetDocument()->Add(pObjpoint);
			CMyPoint *tmp=new CMyPoint(&temp);
			CMyPoint *tmp1=new CMyPoint(&temp1);
            pObjpoint->m_conectrecord=new CMyLine(tmp1,tmp);
            
			//GetDocument()->Add(m_paralleline);
			return m_paralleline;
            //Select(pObjpoint);
			//Select(pObjline);
		}
		else if(pObj1->type==2&&pObj2->type==1)
		{
		    temp1=((CMyPoint*)pObj2)->m_startpoint;
			temp2=((CMyLine*)pObj1)->my_startpoint->m_startpoint;
			temp3=((CMyLine*)pObj1)->my_endpoint->m_startpoint;
            temp=temp1+temp2-temp3;
			CMyPoint* pObjpoint=new CMyPoint(&temp);
			pObjpoint->ptype=3;//ʾƽֱϵ
            pObjpoint->m_scale=1;
			m_paralleline=new CMyLine((CMyPoint*)pObj2,pObjpoint);
			pObjpoint->m_startpoint=m_paralleline->getPointByScale(pObjpoint->m_scale);
			pObjpoint->m_conect1=m_paralleline;
			pObjpoint->m_conect2=(CMyLine*)pObj1;
            GetDocument()->Add(pObjpoint);
			CMyPoint *tmp=new CMyPoint(&temp);
			CMyPoint *tmp1=new CMyPoint(&temp1);
            pObjpoint->m_conectrecord=new CMyLine(tmp1,tmp);
			return m_paralleline;
		}

		return NULL;
	}
	else
	{
	    return NULL;
	}
}
// rect is in device coordinates
void CDrawView::SelectWithinRect(CRect rect, BOOL bAdd)
{
	if (!bAdd)
		Select(NULL);

	ClientToDoc(rect);

	CDrawObjList* pObList = GetDocument()->GetObjects();
	POSITION posObj = pObList->GetHeadPosition();
	while (posObj != NULL)
	{
		CDrawObj* pObj = pObList->GetNext(posObj);
       	if (pObj->Intersects(rect))
			Select(pObj, TRUE);
	}
}

////////////////////////////////////////////////////////////////////
void CDrawView::CloneSelection()
{
	POSITION pos = m_selection.GetHeadPosition();
	while (pos != NULL)
	{
		CDrawObj* pObj = m_selection.GetNext(pos);
		pObj->Clone(pObj->m_Document);
			// copies object and adds it to the document
	}
}
//////////////////////////////////////////////////////////////////////
void CDrawView::InvalObj(CDrawObj* pObj)
{
	CRect rect = pObj->m_position;
	DocToClient(rect);
	if (m_bActive && IsSelected(pObj))
	{
		rect.left -= 45;
		rect.top -= 45;
		rect.right += 45;
		rect.bottom += 45;
	}
	rect.InflateRect(1, 1); // handles CDrawOleObj objects

	InvalidateRect(rect, TRUE);
}
// CDrawView printing
void CDrawView::ClientToDoc(CPoint& point)
{
	CClientDC dc(this);
	OnPrepareDC(&dc, NULL);
	dc.DPtoLP(&point);
}

void CDrawView::ClientToDoc(CRect& rect)
{
	CClientDC dc(this);
	OnPrepareDC(&dc, NULL);
	dc.DPtoLP(rect);    //turning into logic
	ASSERT(rect.left <= rect.right);
	ASSERT(rect.bottom <= rect.top);
}

void CDrawView::DocToClient(CPoint& point)
{
	CClientDC dc(this);
	OnPrepareDC(&dc, NULL);
	dc.LPtoDP(&point);
}

void CDrawView::DocToClient(CRect& rect)
{
	CClientDC dc(this);
	OnPrepareDC(&dc, NULL);
	dc.LPtoDP(rect);
	rect.NormalizeRect();
}
/////////////////////////////////////////////////////////////

CRect CDrawView::GetInitialPosition()
{
	CRect rect(10, 10, 10, 10);
	ClientToDoc(rect);
	return rect;
}

/////////////////////////////////////////////////////////////
void CDrawView::PasteNative(COleDataObject& dataObject)
{
	// get file refering to clipboard data
	CFile* pFile = dataObject.GetFileData(m_cfDraw);
	if (pFile == NULL)
		return;

	// connect the file to the archive
	CArchive ar(pFile, CArchive::load);
	TRY
	{
		ar.m_pDocument = GetDocument(); // set back-pointer in archive

		// read the selection
		m_selection.Serialize(ar);
	}
	CATCH_ALL(e)
	{
		ar.Close();
		delete pFile;
		THROW_LAST();
	}
	END_CATCH_ALL

	ar.Close();
	delete pFile;
}
/////////////////////////////////////////////////////////////

void CDrawView::PasteEmbedded(COleDataObject& dataObject, CPoint point )
{
	BeginWaitCursor();

	// paste embedded
	CDrawOleObj* pObj = new CDrawOleObj(GetInitialPosition());
	ASSERT_VALID(pObj);
	CDrawItem* pItem = new CDrawItem(GetDocument(), pObj);
	ASSERT_VALID(pItem);
	pObj->m_pClientItem = pItem;

	TRY
	{
		if (!pItem->CreateFromData(&dataObject) &&
			!pItem->CreateStaticFromData(&dataObject))
		{
			AfxThrowMemoryException();      // any exception will do
		}

		// add the object to the document
		GetDocument()->Add(pObj);
		m_selection.AddTail(pObj);
		ClientToDoc( point );
		pObj->MoveTo( CRect( point, pObj->m_extent ), this );

		// try to get initial presentation data
		pItem->UpdateLink();
		pItem->UpdateExtent();
	}
	CATCH_ALL(e)
	{
		// clean up item
		pItem->Delete();
		pObj->m_pClientItem = NULL;
		GetDocument()->Remove(pObj);
		pObj->Remove();

		AfxMessageBox(IDP_FAILED_TO_CREATE);
	}
	END_CATCH_ALL

	EndWaitCursor();
}

/////////////////////////////////////////////////////////////
double CDrawView::JudgeAngle(CDrawObjList* temp1,CDrawObj *temp2,CDrawObj * temp3,double temp4)
{
    ///úΪSAS任нֱߺһɾ֮󣬽ֱйϵֱӵ
	///ֱϡ
	///һжϸֱǷһ㣬һûɴ㡣
	///ڶɸýǶȵôСͷжϸýǶȵôС
    if((temp2->type==2)&&(temp3->type==2))
	{
	   CDrawObj* tt1;
	   CDrawObj* tt2;
	   CDrawObj* tt3;
	   CDrawObj* tt4;
	   int i(0);
	   int j(0);	 
	   ///Ѱֱϵĸ㡣
	   POSITION pos=temp2->Nlink.GetHeadPosition();
	   while(pos!=NULL)
	   {
	        RELATION* temp_relation=temp2->Nlink.GetNext(pos);
			POSITION pos1=temp1->FindIndex(temp_relation->Nserialno);
			CDrawObj* pObj=temp1->GetAt(pos1);
			if((pObj->type==1)&&(i==0)&&(temp_relation->Nconstraintype==0))
			{
				 tt1=pObj;
				 i++;
			}
			else if((pObj->type==1)&&(i==1)&&(temp_relation->Nconstraintype==0))
			{
				 tt2=pObj;
				 i++;
			}
	   }
	   pos=temp2->Nlink.GetHeadPosition();
		double fangle(0.0);
		while(pos!=NULL)
		{
		    RELATION* temp_rr=temp2->Nlink.GetNext(pos);
			if(temp3->m_listindex==temp_rr->Nserialno)
			{
				fangle=temp_rr->N_dis_clamp;
				break;
			}
		}
	   pos=temp3->Nlink.GetHeadPosition();
	   while(pos!=NULL)
	   {
	        RELATION* temp_relation=temp3->Nlink.GetNext(pos);
			POSITION pos1=temp1->FindIndex(temp_relation->Nserialno);
			CDrawObj* pObj=temp1->GetAt(pos1);
			if((pObj->type==1)&&(j==0)&&(temp_relation->Nconstraintype==0))
			{
				 tt3=pObj;
				 j++;
			}
			else if((pObj->type==1)&&(j==1)&&(temp_relation->Nconstraintype==0))
			{
				 tt4=pObj;
				 j++;
			}
	   }
	   if((tt1->m_listindex==tt3->m_listindex)||(tt1->m_listindex==tt4->m_listindex)
		   ||(tt2->m_listindex==tt3->m_listindex)||(tt2->m_listindex==tt4->m_listindex))///ֱн㡣
	   {
	      if((tt1->m_listindex==tt3->m_listindex)||(tt1->m_listindex==tt4->m_listindex))
		  {
		      if(tt1->m_listindex==tt3->m_listindex)
			  {
			      tt2=tt2;
			      tt3=tt4;
			  }
			  else
			  {
			      tt2=tt2;
			      tt3=tt3;
			  }
		  }
		  else
		  {
		     if(tt2->m_listindex==tt3->m_listindex)
			 {
			      tt3=tt4;
			      tt4=tt1;
			      tt1=tt2;
                  tt2=tt4;
			 }
			 else
			 {
			      tt4=tt1;
			      tt1=tt2;
			      tt2=tt4;
			      tt3=tt3;
			 }
		  }
			 /// tt2,tt1ȷһֱtemp2,tt1,tt3ȷڶֱtemp3
			double ddx1,ddy1,ddx2,ddy2,ddx3,ddy3,d12,d13,d23;
			ddx1=((CMyPoint*)tt1)->x();
			ddy1=((CMyPoint*)tt1)->y();
			ddx2=((CMyPoint*)tt2)->x();
			ddy2=((CMyPoint*)tt2)->y();
			ddx3=((CMyPoint*)tt3)->x();
			ddy3=((CMyPoint*)tt3)->y();
			d12=(ddx1-ddx2)*(ddx1-ddx2)+(ddy1-ddy2)*(ddy1-ddy2);
			d13=(ddx1-ddx3)*(ddx1-ddx3)+(ddy1-ddy3)*(ddy1-ddy3);
			d23=(ddx2-ddx3)*(ddx2-ddx3)+(ddy2-ddy3)*(ddy2-ddy3);
		    if(d23>d12+d13)///üнӦΪ۽ǡ
			{
				if(temp4<(PI/2.0))
					temp4=PI-temp4;
			}
			else ///üнΪǡ
			{
				 if(temp4>(PI/2.0))
					 temp4=PI-temp4;
			}
			///Ȼж˳ʱ뷽
			double x1=((CMyPoint*)tt2)->x();
			double y1=((CMyPoint*)tt2)->y();
			double x2=((CMyPoint*)tt1)->x();
			double y2=((CMyPoint*)tt1)->y();
			double x3=((CMyPoint*)tt3)->x();
			double y3=((CMyPoint*)tt3)->y();
			if(x2*y3+x1*y2+y1*x3-y1*x2-y2*x3-x1*y3>0)
			{
			    temp4=temp4;
			}
			else
			{
			     temp4=-temp4;
			}
	   }
	   else ///ôֱཻ߲һ㡣******************
	   {	
		   ///x1,y1,x2,y2һֱߣx3,y3,x4,y4һֱߣ****
		   ///ֱཻһx,y.********************************
		   double x1,y1,x2,y2,x3,y3,x4,y4,y,x;
		   x1=((CMyPoint*)tt1)->x();
		   y1=((CMyPoint*)tt1)->y();
		   x2=((CMyPoint*)tt2)->x();
		   y2=((CMyPoint*)tt2)->y();
		   x3=((CMyPoint*)tt3)->x();
		   y3=((CMyPoint*)tt3)->y();
		   x4=((CMyPoint*)tt4)->x();
		   y4=((CMyPoint*)tt4)->y();
		   if((-y2+y1)/(-x2+x1)==(-y4+y3)/(-x4+x3))///ֱƽ********
		   {
		       temp4=0;
		   }
		   else
		   {
		       y=(y3*y1*x2+y2*y3*x4-y2*x3*y4-y1*y3*x4+y1*x3*y4-y4*y1*x2+y4*x1*y2-y3*x1*y2)
			      /(y2*x4-y2*x3-y1*x4+y1*x3-y4*x2+y4*x1+y3*x2-y3*x1);
               x = (-y1*x4*x2+y1*x3*x2+x3*y4*x1+y3*x4*x2-y3*x4*x1-x3*y4*x2-y2*x3*x1+y2*x4*x1)
			      /(y2*x4-y2*x3-y1*x4+y1*x3-y4*x2+y4*x1+y3*x2-y3*x1);
			   if((y>y2)&&(y>y3))
             {
			    if(x2>x3)
					temp4=temp4;
				else
					temp4=-temp4;
			 }     
			 else if((y<y2)&&(y<y3))
			 {
			     if(x2>x3)
					temp4=-temp4;
				else
					temp4=temp4;
			 }
             else if((x>x2)&&(x>x3))
			 {
			     if(y2>y3)
					 temp4=-temp4;
				 else
					 temp4=temp4;
			 }
             else if((x<x2)&&(x<x3))
			 {
			     if(y2>y3)
					 temp4=temp4;
				 else
					 temp4=-temp4;
			 }	
			 else if(y>((x-x2)*(y3-y2)/(x3-x2)+y2))
			 {
			      if(x2>x3)
					  temp4=temp4;
				  else
					  temp4=-temp4;
			 }
			 else if(y<((x-x2)*(y3-y2)/(x3-x2)+y2))
			 {
			      if(x2>x3)
					  temp4=-temp4;
				  else
					  temp4=temp4;
			 }
			 else
			 {}
		   }
	   }
	}
	return temp4;
}
///////////////////////////////////////////////////////
void CDrawView::AbstractLinesFrom(CDrawObjList &temp)
{
	m_abstractofline.RemoveAll();
    POSITION pos = temp.GetHeadPosition();
	while(pos !=NULL)
	{
	    CDrawObj *pObj = temp.GetNext(pos);
		if(pObj->type==2)
		{
		    m_abstractofline.AddTail(pObj);
		}
	}
}

void CDrawView::AbstractPointsFrom(CDrawObjList &temp)
{
	m_abstractofpoint.RemoveAll();
    POSITION pos = temp.GetHeadPosition();
	while(pos !=NULL)
	{
	    CDrawObj *pObj = temp.GetNext(pos);
		if(pObj->type==1)
		{
		    m_abstractofpoint.AddTail(pObj);
		}
	}
}
///////////////////////////////////////////////////////
void CDrawView::AddConstructionToList(CDrawObj*temp1,CDrawObj*temp2,int temp3,double temp4)
{
     ///úҪǶl_AddRelationListԼ޸Լ*****/////
	int iJudge(0);
	int iCount;
	iCount=m_transformedlist.GetCount();
	CDrawObj *pObj1;
	CDrawObj *pObj2;
	POSITION Gaop;
	CDrawObj*GaoObj;
	int iBool(0);
	Gaop=l_AddRelationList.GetHeadPosition();
	while(Gaop!=NULL)
	{
	   GaoObj=l_AddRelationList.GetNext(Gaop);
	   if(GaoObj->m_listindex==temp1->m_listindex)
	   {
		   pObj1=GaoObj;
		   iBool++;
	   }
	   if(GaoObj->m_listindex==temp2->m_listindex)
	   {
		   pObj2=GaoObj;
		   iJudge++;
	   }
	}
    if(iBool==0)
		l_AddRelationList.AddTail(temp1);
	if((iBool==1)&&(iJudge==1))
	{
       switch(temp3)
	   {
           case 1: ///֮ľ**********************///////////////////////////
			   {			   
			    	AddRelation(PP_DIS,1,temp4,I_ZERO,pObj1,pObj2);
			   }
		       break;
           case 2:///ֱߴֱ***********************************//////////////////////
			   {
				  AddRelation(LL_PERP,1,90,I_ZERO,pObj1,pObj2);
			   }
		       break;
	       case 3:///ֱƽ*****************************//////////////////////////
			  {
			 	  AddRelation(LL_PARA,1,0,I_ZERO,pObj1,pObj2);
			  }
			  break;
		   case 4:///ֱ߼ƽַǴֱ********************///
			   {				
				  AddRelation(LL_ANGLE,1,temp4,I_ZERO,pObj1,pObj2);				  
			   }
			   break;
	       default:
		          break;

	   }
	}
	if((iBool==0)&&(iJudge==0))
	{
       switch(temp3)
	   {
           case 1: ///֮ľ**********************///////////////////////////
			   {			   
			    	AddRelation(PP_DIS,1,temp4,I_ZERO,temp1,temp2);
			   }
		       break;
           case 2:///ֱߴֱ***********************************//////////////////////
			   {	  		
			        AddRelation(LL_PERP,1,90,I_ZERO,temp1,temp2);
			   }
		       break;
	       case 3:///ֱƽ*****************************//////////////////////////
			   {			
                    AddRelation(LL_PARA,1,0,I_ZERO,temp1,temp2);
			   }
			   break;
		   case 4:///ֱ߼ƽַǴֱ********************///
			   {				
				  AddRelation(LL_ANGLE,1,temp4,I_ZERO,temp1,temp2);
			   }
			   break;
	       default:
		          break;

	   }
	}
}
/////////////////////////////////////////////////////////////
CDrawObjList* CDrawView::GetParaNoLine(CDrawObjList *temp1,CDrawObj*temp2,CDrawObj*temp3,double temp4)
{
   	     CDrawObj* ppoint0;
		 CDrawObj* ppoint1;
		 CDrawObj* ppoint2;
		 CDrawObj* ppoint3;
		 CDrawObj* ppoint4;
		 CDrawObj* ppoint5;
		 CDrawObj* ppoint6;
		 CDrawObj* ptemp;
		 CDrawObj* pline0;
		 CDrawObj* pline1;
		 CDrawObj* pline2;
		 POSITION pp=temp1->GetHeadPosition();
		 while(pp!=NULL)
		 {
		    CDrawObj* pobj=temp1->GetNext(pp);
			if(pobj->m_listindex==temp2->m_listindex)
			{
				pline0=pobj;
				pline1=pobj;
				pline2=pobj;
				break;
			}
		 }
		 ///һõֱϵĸ/////////////////////
		 int kk(0);
		 int ipline1(1),icount1(0);
		 int ipline2(1),icount2(0);
		 POSITION pos=temp2->Nlink.GetHeadPosition();		
		 while(pos!=NULL)
		 {
		       RELATION* temp_relation = temp2->Nlink.GetNext(pos);
			   POSITION pos2=temp_relation->pObjList.GetHeadPosition();
			   while(pos2!=NULL)
			   {
			        CDrawObj*pObj=temp_relation->pObjList.GetNext(pos2);
					if((pObj->type==1)&&(kk==0)&&(temp_relation->Nconstraintype==0))
					{
					    ppoint1=pObj;
					    kk++;
					}
				    else if((pObj->type==1)&&(kk==1)&&(temp_relation->Nconstraintype==0))
					{
					    ppoint2=pObj;
					    kk++;
					}				    
			   }				
		 }
		 ////////////////////////////////////////////////////////////////////////////////////
		 kk=0;
		pos = temp3->Nlink.GetHeadPosition();
		while(pos!=NULL)
		{
		    RELATION* temp_relation = temp3->Nlink.GetNext(pos);
			POSITION pos2=temp_relation->pObjList.GetHeadPosition();
			while(pos2!=NULL)
			{
			     CDrawObj*pObj=temp_relation->pObjList.GetNext(pos2);
				 if((pObj->type==1)&&(kk==0)&&(temp_relation->Nconstraintype==0))
				 {
			    	ppoint3=pObj;
				    kk++;
				 }
                 else if((pObj->type==1)&&(kk==1)&&(temp_relation->Nconstraintype==0))
				 {
			    	ppoint4=pObj;
			    	kk++;
				 }		   
			}
		}
		////////////////////////////////////////////////////////////////////////////////
		 ppoint0=ppoint1;
		 ppoint5=ppoint1;
		 ppoint6=ppoint2;
		 while((ppoint5!=ppoint3)&&(ppoint5!=ppoint4))/////ʼѭ
		 {
			  POSITION position1=ppoint5->Nlink.GetHeadPosition();
			  CDrawObj *ptempObj;
			  while(position1!=NULL)////жϺ͸õĸУӦĸ㡣
			  {
			       RELATION* temp_rela=ppoint5->Nlink.GetNext(position1);
				   POSITION position2=temp_rela->pObjList.GetHeadPosition();
				   while(position2!=NULL)
				   {
				        ptempObj=temp_rela->pObjList.GetNext(position2);
						if((ptempObj->type==2)&&(ptempObj!=pline0)&&(temp_rela->Nconstraintype==0))
						{
				             POSITION Gao_pp=ptempObj->Nlink.GetHeadPosition();
						     while(Gao_pp!=NULL)
							 {
						           RELATION* Gao_temp=ptempObj->Nlink.GetNext(Gao_pp);
								   POSITION Gao_ppos2=Gao_temp->pObjList.GetHeadPosition();
								   while(Gao_ppos2!=NULL)
								   {
								         CDrawObj*Gao_obj=Gao_temp->pObjList.GetNext(Gao_ppos2);
										 if((Gao_obj->type==1)&&(Gao_obj!=ppoint1)&&(Gao_temp->Nconstraintype==0))
										 {
								              int aaa(0);
								              POSITION Gao_pp2=Gao_obj->Nlink.GetHeadPosition();
								              while(Gao_pp2!=NULL)
											  {
								                    RELATION* Gao_temp2=Gao_obj->Nlink.GetNext(Gao_pp2);
													POSITION pos22=Gao_temp2->pObjList.GetHeadPosition();
													while(pos22!=NULL)
													{
													     CDrawObj*temp_pObj=Gao_temp2->pObjList.GetNext(pos22);
														 if(temp_pObj==ppoint5)
														 {
														      aaa=1;
										                      break;
														 }
													}									                                            
											  }
										      ipline1=ipline1&&aaa;
										      ppoint5=Gao_obj;
										      pline0=ptempObj;
										      icount1++;
										      break; 
										 }
								   }
							      
							       
							 }					
						     break;
						}		
				   }
			       
				  	       
			  }
		 }
		while((ppoint6!=ppoint3)&&(ppoint6!=ppoint4))/////ʼѭ
		{
			  POSITION position1=ppoint6->Nlink.GetHeadPosition();
			  CDrawObj *ptempObj;
			  while(position1!=NULL)////жϺ͸õĸУӦĸ㡣
			  {
			       RELATION* temp_rela=ppoint6->Nlink.GetNext(position1);
				   POSITION position2=temp_rela->pObjList.GetHeadPosition();
				   while(position2!=NULL)
				   {
				        ptempObj=temp_rela->pObjList.GetNext(position2);
						if((ptempObj->type==2)&&(ptempObj!=pline1)&&(temp_rela->Nconstraintype==0))
						{
				             POSITION Gao_pp=ptempObj->Nlink.GetHeadPosition();
						     while(Gao_pp!=NULL)
							 {
						          RELATION* Gao_temp=ptempObj->Nlink.GetNext(Gao_pp);
                                  POSITION  Gao_ppos2=Gao_temp->pObjList.GetHeadPosition();
								  while(Gao_ppos2!=NULL)
								  {
								       CDrawObj* Gao_obj=Gao_temp->pObjList.GetNext(Gao_ppos2);
								       if((Gao_obj->type==1)&&(Gao_obj!=ppoint2)&&(Gao_temp->Nconstraintype==0))
									   {
								            int aaa(0);
								            POSITION Gao_pp2=Gao_obj->Nlink.GetHeadPosition();
								            while(Gao_pp2!=NULL)
											{
								                 RELATION* Gao_temp2=Gao_obj->Nlink.GetNext(Gao_pp2);
												 POSITION pos22=Gao_temp2->pObjList.GetHeadPosition();
												 while(pos22!=NULL)
												 {
												      CDrawObj*temp_PObj=Gao_temp2->pObjList.GetNext(pos22);
													  if(temp_PObj==ppoint2)
													  {
													       aaa=1;
										                   break;
													  }
												 }									                                           
											}
								            ipline2=ipline2&&aaa;
							                ppoint6=Gao_obj;
								            pline1=ptempObj;
								            icount2++;
                                            break; 
									   }
								  }						     
							    
							 }					
						     break;
						}		
				   }
			      
				   	       
			  }
		}
		int judge(0);
		if((ipline1==1)&&(ipline2==1))
		{
		   if(icount1<=icount2)
			   judge=1;
		   else
			   judge=2;
		}
		else if((ipline1==1)&&(ipline2==0))
		{
			judge=1;
		}
		else if((ipline1==0)&&(ipline2==1))
		{
		    judge=1;
		}
		else if((ipline1==0)&&(ipline2==0))
		{
		    if(icount1<=icount2)
				judge=1;
			else
				judge=2;
		}
		else
		{}
        if(judge==1)
		{
		}
		if(judge==2)
		{
		   ptemp=ppoint1;
		   ppoint1=ppoint2;
		   ppoint2=ptemp;
		}
		l_AddList.RemoveAll();
		while((ppoint0!=ppoint3)&&(ppoint0!=ppoint4))/////ʼѭ
		 {
			  POSITION position1=ppoint0->Nlink.GetHeadPosition();
			  CDrawObj *ptempObj;
			  while(position1!=NULL)////жϺ͸õĸУӦĸ㡣
			  {
			       RELATION* temp_rela=ppoint0->Nlink.GetNext(position1);
				   POSITION position2=temp_rela->pObjList.GetHeadPosition();
				   while(position2!=NULL)
				   {
				        ptempObj=temp_rela->pObjList.GetNext(position2);
						if((ptempObj->type==2)&&(ptempObj!=pline2)&&(temp_rela->Nconstraintype==0))
						{
				            POSITION Gao_pp=ptempObj->Nlink.GetHeadPosition();
						    while(Gao_pp!=NULL)
							{
						         RELATION* Gao_temp=ptempObj->Nlink.GetNext(Gao_pp);
								 POSITION Gao_ppos2=Gao_temp->pObjList.GetHeadPosition();
								 while(Gao_ppos2!=NULL)
								 {
								      CDrawObj*Gao_obj=Gao_temp->pObjList.GetNext(Gao_ppos2);
									  if((Gao_obj->type==1)&&(Gao_obj!=ppoint1)&&(Gao_temp->Nconstraintype==0))
									  {
								            l_AddList.AddTail(Gao_obj);
								            ppoint0=Gao_obj;
								            pline2=ptempObj;
								            icount1++;
                                            break; 
									  }
								 }
							}					
						    break;
						}		
				   }      
			  }
		 }
		if(ppoint1==ppoint3)
		{
		    ptemp=ppoint4;
			ppoint4=ppoint3;
			ppoint3=ptemp;
		}
		else
		{		   
		}
		 return  ParaAllTransform(temp1,ppoint1,ppoint2,ppoint3,ppoint4,temp2,temp3,temp4); 
}
/////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////
CDrawObjList* CDrawView::GetSASTransform(CDrawObjList* temp1,CDrawObj *temp2,CDrawObj *temp3,double temp4)
{ 
	///Ҫ֤ɾֻȻԼɾĵȻԼԼ
	///˼·ɾֱߣͬʱɾõ㡣ͨbMarkִС
	///һֱߡֱ߼̳˸εһʡ
	///CDrawObjͬɾйصNLink޸ġ
    ///Ǹȷ㡣
    if((temp2->type==2)&&(temp3->type==2))
	{
	   CDrawObj* tt1;
	   CDrawObj* tt2;
	   CDrawObj* tt3;
	   CDrawObj* tt4;
	   int i(0);
	   int j(0);
	   int icount(0);
	   icount=temp1->GetCount();
	   double fangle(0.0);	   
       ///Ѱֱϵĸ㡣
	   POSITION pos=temp2->Nlink.GetHeadPosition();
	   while(pos!=NULL)
	   {
	        RELATION* temp_relation=temp2->Nlink.GetNext(pos);
			POSITION pos1=temp_relation->pObjList.GetHeadPosition();
			while(pos1!=NULL)
			{
			    CDrawObj*pObj=temp_relation->pObjList.GetNext(pos1);
				if((pObj->type==1)&&(i==0)&&(temp_relation->Nconstraintype==0)&&(pObj->bMark<1))
				{
				    tt1=pObj;
				    i++;
				}
			    else if((pObj->type==1)&&(i==1)&&(temp_relation->Nconstraintype==0)&&(pObj->bMark<1))
				{
				    tt2=pObj;
				    i++;
				}
			    if(temp_relation->Nserialno==temp3->m_listindex)
				{
			       fangle=temp_relation->N_dis_clamp;
				}
			}
	   }	   
	   pos=temp3->Nlink.GetHeadPosition();
	   while(pos!=NULL)
	   {
	        RELATION* temp_relation=temp3->Nlink.GetNext(pos);
			POSITION pos1=temp_relation->pObjList.GetHeadPosition();
			while(pos1!=NULL)
			{
			     CDrawObj*pObj=temp_relation->pObjList.GetNext(pos1);
				 if((pObj->type==1)&&(j==0)&&(temp_relation->Nconstraintype==0)&&(pObj->bMark<1))
				 {
				    tt3=pObj;
				    j++;
				 }
			     else if((pObj->type==1)&&(j==1)&&(temp_relation->Nconstraintype==0)&&(pObj->bMark<1))
				 {
				    tt4=pObj;
				    j++;
				 }
			}
	   }
	   if((tt1==tt3)||(tt1==tt4))
		{
		    if(tt1==tt3)
			{
			   tt2=tt2;
			   tt3=tt4;
			}
			else
			{
			  tt2=tt2;
			  tt3=tt3;
			}
		}
		else{
		    if(tt2==tt3)
			{
			   tt3=tt4;
			   tt4=tt1;
			   tt1=tt2;
               tt2=tt4;
			}
			else
			{
			   tt4=tt1;
			   tt1=tt2;
			   tt2=tt4;
			   tt3=tt3;
			}
		}
        ///////////Ѿֱȷtt1,tt2,tt3,tt2,tt1
		////ȷһֱtemp1,tt1,tt3ȷڶֱtemp2
		double x1,y1,x2,y2,x3,y3;
		x3=((CMyPoint*)tt1)->x();
		y3=((CMyPoint*)tt1)->y();
		x1=((CMyPoint*)tt2)->x();
		y1=((CMyPoint*)tt2)->y();
		x2=((CMyPoint*)tt3)->x();
		y2=((CMyPoint*)tt3)->y();
		if((x1*y2+x2*y3+x3*y1-y1*x2-y2*x3-y3*x1)>0)///tt2ʼΪ
		{
		     POSITION pos=tt1->Nlink.GetHeadPosition();
	         while(pos!=NULL)
			 {
	              RELATION* temp_relatt=tt1->Nlink.GetNext(pos);
				  POSITION ppos_1=temp_relatt->pObjList.GetHeadPosition();
				  while(ppos_1!=NULL)
				  {
				      CDrawObj*pObj_1=temp_relatt->pObjList.GetNext(ppos_1);
                      if(pObj_1->m_listindex==tt2->m_listindex)
					  {
				          temp_relatt->bSJudge=1;
					  }
				      if(pObj_1->m_listindex==tt3->m_listindex)
					  {
					      temp_relatt->bSJudge=0;
					  }
				  }
			      
			 }
		}
		else
		{
		     POSITION pos=tt1->Nlink.GetHeadPosition();
			 while(pos!=NULL)
			 {
			      RELATION* temp_relatt=tt1->Nlink.GetNext(pos);
                  POSITION ppos_1=temp_relatt->pObjList.GetHeadPosition();
				  while(ppos_1!=NULL)
				  {
				       CDrawObj*pObj_1=temp_relatt->pObjList.GetNext(ppos_1);
					   if(pObj_1->m_listindex==tt2->m_listindex)
					   {
				          temp_relatt->bSJudge=0;
					   }
				       if(pObj_1->m_listindex==tt3->m_listindex)
					   {
					      temp_relatt->bSJudge=1;
					   }
				  }				 
			 }
		}
		///ʼǶ⣬жϽǶȡ
		if(temp4>0)
		{}
		else
		{
		  temp4=-temp4;
		}
		if(bAngle==1)
		{
		    temp4=temp4;
		}
		else
		{
		     double x1,y1,x2,y2,x3,y3,d12,d13,d23;
			 y2=((CMyPoint*)tt2)->y();
		     x2=((CMyPoint*)tt2)->x();
		     y1=((CMyPoint*)tt1)->y();
		     x1=((CMyPoint*)tt1)->x();
		     d12=(x1-x2)*(x1-x2)+(y1-y2)*(y1-y2);
		     y3=((CMyPoint*)tt3)->y();
		     x3=((CMyPoint*)tt3)->x();
		     d13=(x1-x3)*(x1-x3)+(y1-y3)*(y1-y3);
		     d23=(x2-x3)*(x2-x3)+(y2-y3)*(y2-y3);
		     if(d23>d12+d13)///üнӦΪ۽ǡ
			 {
		         if(temp4<1.5707963267948813)
				     temp4=PI-temp4;
			 }
		     else ///üнΪǡ
			 {
		         if(temp4>1.5707963267948813)
				      temp4=PI-temp4;
			 }
        }
        ///һֱ֮ļн///////
       	///////////ڶһֱߵľ///////////////
		////////////////////ڶֱߵľ////////////////////////
		double dd1,dd2;////ddΪtemp1ĳ
        int iCount(0);
		POSITION pos1=tt1->Nlink.GetHeadPosition();
		while(pos1!=NULL)
		{
		    RELATION* temp_relation = tt1->Nlink.GetNext(pos1);	
			POSITION pos_1=temp_relation->pObjList.GetHeadPosition();
			while(pos_1!=NULL)
			{
			     CDrawObj*pObj_1=temp_relation->pObjList.GetNext(pos_1);
				 if(pObj_1->m_listindex==tt2->m_listindex)
				 {
				     dd1=temp_relation->N_dis_clamp;				
				     iCount++;
				 }
				 if(pObj_1->m_listindex==tt3->m_listindex)
				 {
				     dd2=temp_relation->N_dis_clamp;
				     iCount++;
				 }
			}			
			if(iCount>=2)
				break;
		}        
        ///Ĳȥֱtemp2temp3֮Լ///
		///ֱûмнǹϵɾtemp2һߵļнǹϵ
		///????????????????????
		int iJudge(0);
		pos=temp2->Nlink.GetHeadPosition();
		while(pos!=NULL)
		{
		     RELATION* temp_relat11=temp2->Nlink.GetNext(pos);
			 POSITION pos_1=temp_relat11->pObjList.GetHeadPosition();
			 while(pos_1!=NULL)
			 {
			      CDrawObj*pObj_1=temp_relat11->pObjList.GetNext(pos_1);
				  if((pObj_1==temp3)&&(temp_relat11->Nconstraintype==LL_ANGLE))
				  {
				      iJudge=1;
				      break;
				  }
			 }            
		}
		/////////////////////////////////////////////////////////////////////////////
		if(iJudge==1)///ֱֱӵļнǹϵ
		{
			DeleteRelation(CDD(temp2),CDD(temp3));
			//////////////////////////////////////////////////////////////////
			DeleteRelation(CDD(temp3),CDD(temp2));		
		}
		else///ֱûֱӵļнǣɾtemp2һֱߵĽǶԼϵ
		{
			CDrawObj* pTempObj;
			int ii(0);
		    pos=temp2->Nlink.GetHeadPosition();
			while(pos!=NULL)
			{				
				 RELATION*temp_rela22=temp2->Nlink.GetNext(pos);
				 POSITION pos2=temp_rela22->pObjList.GetHeadPosition();
				 while(pos2!=NULL)
				 {
				     CDrawObj*pObj=temp_rela22->pObjList.GetNext(pos2);
					 if((pObj->type==G_LINE)&&(temp_rela22->Ntype==2)&&(temp_rela22->Nconstraintype==LL_ANGLE)&&(pObj->bMark<1))
					 {
				         pTempObj=pObj;
						 ii++;
				         break;
					 }	
				 }
				 if(ii>D_ZERO)
					 break;
			}
			//////////////////////////////////////////////
            DeleteRelation(CDD(temp2),CDD(pTempObj));
            DeleteRelation(CDD(pTempObj),CDD(temp2));
           ///////////////////////////////////////////////		
		}
		temp2->bMark=2;   ///ֱߺһɾһֱߡ
		temp3->bMark=2;   ///ͬtemp1,temp2йصӵֱϡ
		tt1->bMark=2;     
		m_transformedlist.AddHead(temp2);
		m_transformedlist.AddHead(temp3);
		m_transformedlist.AddHead(tt1);
		///???޸ģһֱߣԼб任ܹؼ
        CMyLine *plineAdd1=new CMyLine;
		plineAdd1->bDraw=1;
		plineAdd1->sLineColor="red";
	    plineAdd1->m_listindex=icount;
		icount++;
        plineAdd1->Ndoc=0;
        plineAdd1->Ndof=2;
        plineAdd1->NFlag=false;
        plineAdd1->type=2;
        plineAdd1->my_endpoint=(CMyPoint*)tt2;
        plineAdd1->my_startpoint=(CMyPoint*)tt3;		
    	GetDocument()->Add(plineAdd1);
		///tt2,tt3////////////////////
		///ΪС
		///.һtt2,tt3ĳȡ
		double dd3,dtemp;
		dtemp=(temp4/180)*PI;
		dd3=sqrt(dd1*dd1+dd2*dd2-2*dd1*dd2*cos(dtemp));
		//////////////////////////////////////////////////////////
		AddRelation(PP_DIS,1,dd3,1,CDD(tt2),CDD(tt3));        
		///
		///֮tt2ֱߵȻԼ
		AddRelation(PL_DIS,1,D_ZERO,1,CDD(tt2),CDD(plineAdd1));
		///֮tt3ֱߵȻԼ
		AddRelation(PL_DIS,1,D_ZERO,1,CDD(tt3),CDD(plineAdd1));		
		///֮ġɾtt2һȻԼ
		DeleteRelation(CDD(tt2),CDD(temp2));		
	    ///֮塣ɾtt32ȻԼ
		DeleteRelation(CDD(tt3),CDD(temp3));
		///֮ɾtt2tt1֮Լ
		DeleteRelation(CDD(tt2),CDD(tt1));	
		///֮ߡɾtt3tt1֮Լ
		DeleteRelation(CDD(tt3),CDD(tt1));       
		///֮ˡɾֱߺֱ֮ĽǶȹϵ
		///ֱ߷ŵȼС***********************
            ///ˣtemp3ֱ߷Ϊ˳ʱ뷽///ʵӦø
		   ///ʵͼжϽǶǷΪ˳ʱ뷽
		///ýǶȵütt3Ϊ֧㣬tt2ָtt1ýǶȡ
		     double tempangle1;
			 tempangle1=acos((dd2*dd2+dd3*dd3-dd1*dd1)/(2*dd2*dd3));
			 CAngleLine ttemp;
			 CMyLine* pTline1;
			 pTline1=(CMyLine*)temp3;
			 ///***************************************************
			double gx1=((CMyPoint*)tt1)->x();
			double gy1=((CMyPoint*)tt1)->y();
			double gx2=((CMyPoint*)tt3)->x();
			double gy2=((CMyPoint*)tt3)->y();
			double gx3=((CMyPoint*)tt2)->x();
			double gy3=((CMyPoint*)tt2)->y();
			if(gx2*gy3+gx1*gy2+gy1*gx3-gy1*gx2-gy2*gx3-gx1*gy3>0)
			{
			   tempangle1=tempangle1;
			}
			else
			{
			    tempangle1=-tempangle1;
			}
		    ttemp.Add(l_AngleList,pTline1,plineAdd1,tempangle1);
		///ɾֱе
		///ǶȹϵֱнǶȹϵ任һ¡
        CDrawObjList l_Copylist;	
	    ////////////////////////////////////////////////////////////////////////
        POSITION pPos=temp2->Nlink.GetHeadPosition();
	    while(pPos!=NULL)
		{   
			POSITION ptempPos=pPos;
	        RELATION* temp_relation=temp2->Nlink.GetNext(pPos);
			POSITION pos1=temp_relation->pObjList.GetHeadPosition();
			while(pos1!=NULL)
			{
			    CDrawObj*pObj=temp_relation->pObjList.GetNext(pos1);
				if((pObj->type==G_LINE)&&(temp_relation->Nconstraintype==LL_ANGLE)&&(pObj->bMark<1)
					&&(pObj->m_listindex!=plineAdd1->m_listindex)&&(pObj->m_listindex!=temp2->m_listindex))
				{ ///Ϊtemp2йϵֱߡ
                    CMyLine* TempLine;
					TempLine=(CMyLine*)pObj;
					temp2->Nlink.GetNext(pPos);
					temp2->Nlink.RemoveAt(ptempPos);///ɾtemp2
					POSITION ptemp=pObj->Nlink.GetHeadPosition();
					while(ptemp!=NULL)
					{
					  POSITION ptempPos1=ptemp;
				      RELATION* temprela=pObj->Nlink.GetNext(ptemp);
					  POSITION pos11=temprela->pObjList.GetHeadPosition();
					  while(pos11!=NULL)
					  {
					      CDrawObj*ptempObj=temprela->pObjList.GetNext(pos11);
					      if(ptempObj->m_listindex==temp2->m_listindex)
						  {
							  l_Copylist.AddHead(pObj);
							   ///ʼԻһ¡
							   pObj->Nlink.GetNext(ptemp);
							   pObj->Nlink.RemoveAt(ptempPos1);///ɾͬtemp2нǶȹϵĶϵ
							   ///ȻӸöֱ֮ͬ
							   double tmpAngle;
							   CAngleLine ttemp;
							   tmpAngle=ttemp.ComputeAngle(l_AngleList,TempLine,plineAdd1);
							   ///?????????????????????????????????????????????????????????????///
								tmpAngle=JudgeAngle(temp1,TempLine,plineAdd1,tmpAngle);
							   ///ôǣǶ⡣	
								AddRelation(LL_ANGLE,1,tmpAngle,1,CDD(pObj),CDD(plineAdd1));							   
								break;
						  }
					  }					 
					
					}
				}		
			}
	   }
       /////////////////////////////////////////////////////////////////////////////////////////
	   pPos=temp3->Nlink.GetHeadPosition();
	   while(pPos!=NULL)
	   {
		    POSITION pPos3=pPos;
	        RELATION* temp_relation=temp3->Nlink.GetNext(pPos);
			POSITION pos1=temp_relation->pObjList.GetHeadPosition();
			while(pos1!=NULL)
			{
			    CDrawObj*pObj=temp_relation->pObjList.GetNext(pos1);				
			    if((pObj->type==G_LINE)&&(temp_relation->Nconstraintype==LL_ANGLE)&&(pObj->bMark<1)
					&&(pObj->m_listindex!=plineAdd1->m_listindex)&&(pObj->m_listindex!=temp3->m_listindex))
				{
				    CMyLine* TTempLine;
					TTempLine=(CMyLine*)pObj;
					temp3->Nlink.GetNext(pPos);
					temp3->Nlink.RemoveAt(pPos3);
					POSITION ptemp=pObj->Nlink.GetHeadPosition();
					while(ptemp!=NULL)
					{
					  POSITION pPos4=ptemp;
				      RELATION* temprela=pObj->Nlink.GetNext(ptemp);
					  POSITION pos11=temprela->pObjList.GetHeadPosition();
					  while(pos11!=NULL)
					  {
					      CDrawObj*ptempObj=temprela->pObjList.GetNext(pos11);
					      if(ptempObj->m_listindex==temp3->m_listindex)
						  {
							  int ggg(0);
							  POSITION ggpos=l_Copylist.GetHeadPosition();
							  while(ggpos!=NULL)
							  {
								 CDrawObj* GG_relation=l_Copylist.GetNext(ggpos);
								 if(GG_relation->m_listindex==pObj->m_listindex)
								 {
									 ggg=1;
									 break;
								 }
							  }
							  if(ggg!=1)
							  {
							   ///ʼԻһ¡
							   pObj->Nlink.GetNext(ptemp);
							   pObj->Nlink.RemoveAt(pPos4);
							   double tmpAngle;
							   CAngleLine ttemp;
							   tmpAngle=ttemp.ComputeAngle(l_AngleList,TTempLine,plineAdd1);
							   ///???????????????????????????????????????????????///
								tmpAngle=JudgeAngle(temp1,TTempLine,plineAdd1,tmpAngle);
								///????????????????????????????????///
								AddRelation(LL_ANGLE,1,tmpAngle,1,CDD(pObj),CDD(plineAdd1));	
								//////////////////////////////////////////////////////////////
								break;
							  }
							  else
							  {
								  pObj->Nlink.GetNext(ptemp);
								  pObj->Nlink.RemoveAt(pPos4);
								  break;
							  }
						  }					 
					  }					  
					 
				}
			}	
			}
				
	   }
	}
	
	return temp1;
}
/////////////////////////////////////////////////////////////
CDrawObjList* CDrawView::GetParaTransform(CDrawObjList* temp1,CDrawObj *temp2,CDrawObj *temp3,double temp4)
{

	////ֱ֮Ĺϵ.  1Ȼϵֱϣ2ϵ
	////ֱ֮ĳ֪
    ////һ:Ƚõĵ㣬point2,point1,point4,point3.
	////ڶppoint1ppoint4֮ŵm_AddArrayȥ
	////ѭֱԼ
		 CDrawObj* ppoint1;
		 CDrawObj* ppoint2;
		 CDrawObj* ppoint3;
		 CDrawObj* ppoint4;
		 CDrawObj* ppoint5;
		 CDrawObj* ppoint6;
		 CDrawObj* ptemp;		
		 ///һõֱϵĸ/////////////////////
		 if((temp2!=NULL)&&(temp3!=NULL))
		 {
			 int kk(0);
			 POSITION pos=temp2->Nlink.GetHeadPosition();
			 while(pos!=NULL)
			 {
				    RELATION* rel = temp2->Nlink.GetNext(pos);
					POSITION pos2=rel->pObjList.GetHeadPosition();
					while(pos2!=NULL)
					{
					     CDrawObj*pObj=rel->pObjList.GetNext(pos2);
						 if((pObj->type==G_POINT)&&(kk==0)&&(rel->Nconstraintype==PL_DIS)&&(rel->N_dis_clamp<L_ZERO))
						 {
					    	ppoint1=pObj;
					    	kk++;
						 }
					     else if((pObj->type==G_POINT)&&(kk==1)&&(rel->Nconstraintype==PL_DIS)&&(rel->N_dis_clamp<L_ZERO))
						 {
					    	ppoint2=pObj;
				    		kk++;
						 }	
					}				
			 }
			kk=0;
			pos = temp3->Nlink.GetHeadPosition();
			while(pos!=NULL)
			{
				RELATION* rel = temp3->Nlink.GetNext(pos);
				POSITION pos2=rel->pObjList.GetHeadPosition();
				while(pos2!=NULL)
				{
				    CDrawObj*pObj=rel->pObjList.GetNext(pos2);
					if((pObj->type==G_POINT)&&(kk==0)&&(rel->Nconstraintype==PL_DIS)&&(rel->N_dis_clamp<L_ZERO))
					{
				    	ppoint3=pObj;
				    	kk++;
					}
				    else if((pObj->type==G_POINT)&&(kk==1)&&(rel->Nconstraintype==PL_DIS)&&(rel->N_dis_clamp<L_ZERO))
					{
			    		ppoint4=pObj;
				    	kk++;
					}	
				}			
			}
		 }	
		 ///////////õֱϵĵ㣬ֱppoint1,ppoint2,ppoint3,ppoint4ϡ
         /////////ڶĵõһͨ·
         int ii1(0),ii2(0);   ///ֱ·Ľ
		 int icount1(0),icount2(0),icount(0);
		 int isas(0);
		 /*
		  ȣppoint1ʼѭ
		 */		
		 ptemp=ppoint2;
		 ppoint5=ppoint1;
		 ppoint6=ppoint2;
         while((ppoint1!=ppoint3)&&(ppoint1!=ppoint4))/////ʼѭ
		 {
			  POSITION position1=ppoint1->Nlink.GetHeadPosition();
			  CDrawObj *ptempObj;
			  isas=0;
			  while(position1!=NULL)////жϺ͸õĸУӦĸ㡣
			  {
			       RELATION* temp_rela=ppoint1->Nlink.GetNext(position1);
				   POSITION position2=temp_rela->pObjList.GetHeadPosition();
				   while(position2!=NULL)
				   {
				       ptempObj=temp_rela->pObjList.GetNext(position2);
					   if((ptempObj->type==G_POINT)&&(ptempObj!=ptemp)&&(ptempObj!=ppoint1)&&(temp_rela->bSAS==1))
					   {
				          isas=1;
						  break;
					   }	
				   }	       
			  }
			  position1=ppoint1->Nlink.GetHeadPosition();
		      while(position1!=NULL)
			  {
			       RELATION* temp_rela=ppoint1->Nlink.GetNext(position1);
				   POSITION position2=temp_rela->pObjList.GetHeadPosition();
				   while(position2!=NULL)
				   {
				       ptempObj=temp_rela->pObjList.GetNext(position2);
					   if(isas==1)
					   {
			               if((ptempObj->type==G_POINT)&&(ptempObj!=ptemp)&&(ptempObj!=ppoint1)&&(temp_rela->bSAS==1))
						   {
				              ii1++;
						      break;
						   }
					   }
				       else
					   {
				          if((ptempObj->type==G_POINT)&&(ptempObj!=ptemp)&&(ptempObj!=ppoint1))
						  {
				              ii1++;
						      break;
						  }
					   }
				   }
			  }
			  POSITION pos = ptempObj->Nlink.GetHeadPosition();
			  icount1=0;
			  icount2=0;
		      while(pos!=NULL)
			  {
		            RELATION* temp_relation = ptempObj->Nlink.GetNext(pos);
					POSITION pos2=temp_relation->pObjList.GetHeadPosition();
					while(pos2!=NULL)
					{
					    CDrawObj*pObj=temp_relation->pObjList.GetNext(pos2); 
						if((pObj->type==G_POINT)&&(pObj!=ptempObj))
			           	    icount1++;
			            if((pObj->type==G_LINE)&&(pObj!=ptempObj))
			             	icount2++;
					}
		            
			       
			   }
			   if((icount1<=2)&&(icount2<=2))
			   {   
		            ptemp=ppoint1;
                    ppoint1=ptempObj;
			    }
			   else
			   {
			       break;
			   }
		 }
		         
		 ptemp=ppoint1;
		 ppoint1=ppoint5;
		 ppoint2=ppoint6;
		 int ibreak;
         while((ppoint2!=ppoint3)&&(ppoint2!=ppoint4)&&(ii2<15))
		 {
		     POSITION position1=ppoint2->Nlink.GetHeadPosition();
			 CDrawObj *ptempObj;
			 isas=0;
			 ibreak=0;
			 while(position1!=NULL)
			 {
			     RELATION* rel=ppoint2->Nlink.GetNext(position1);
                 POSITION position2=rel->pObjList.GetHeadPosition();
				 while(position2!=NULL)
				 {
				     ptempObj=rel->pObjList.GetNext(position2);
					 if((ptempObj->type==G_POINT)&&(ptempObj!=ptemp)&&(ptempObj!=ppoint2)&&(rel->bSAS==1))				 
					 {
				         isas=1;
						 ibreak++;					     
					 }
					 if(ibreak>0)
						 break;
				 }
				 if(ibreak>0)
					 break;
			 }
			 ibreak=0;
			 position1=ppoint2->Nlink.GetHeadPosition();
		     while(position1!=NULL)
			 {
			     RELATION* rel=ppoint2->Nlink.GetNext(position1);
                 POSITION position2=rel->pObjList.GetHeadPosition();
				 while(position2!=NULL)
				 {
				     ptempObj=rel->pObjList.GetNext(position2);
					 if(isas==1)
					 {
				        if((ptempObj->type==G_POINT)&&(ptempObj!=ptemp)&&(ptempObj!=ppoint2)&&(rel->bSAS==1))
						{
				             ii2++;
							 ibreak++;					        
						}
					 }
				     else
					 {
				         if((ptempObj->type==G_POINT)&&(ptempObj!=ptemp)&&(ptempObj!=ppoint2))
						 {
				              ii2++;
							  ibreak++;					          
						 }
					 }
					 if(ibreak>0)
						 break;
				 }			  
				 if(ibreak>0)
					 break;
			 }
			 POSITION pos = ptempObj->Nlink.GetHeadPosition();
			 icount1=0;
			 icount2=0;
		     while(pos!=NULL)
			 {
		           RELATION* rel = ptempObj->Nlink.GetNext(pos);
				   POSITION pos2=rel->pObjList.GetHeadPosition();
				   while(pos2!=NULL)
				   {
				        CDrawObj*pObj=rel->pObjList.GetNext(pos2); 
						if((pObj->type==G_POINT)&&(pObj!=ptempObj))
			           	    icount1++;
			            if((pObj->type==G_LINE)&&(pObj!=ptempObj))
			             	icount2++;
				   }
			 }
			 if((icount1<=2)&&(icount2<=2))
			 {   
			       ptemp=ppoint2;
				   ppoint2=ptempObj;				   
			 }
			 else
			 {
			      break;
			 }
		 }
		 /////////жƽƱ任һ·ppoint1ppoint4·
		 int mm(0);
		 if(ii1>ii2)
		 {
			 ppoint1=ppoint6;
			 ppoint2=ppoint5;
			 icount=ii2;
		 }
		 else
		 {
			 ppoint1=ppoint5;
			 ppoint2=ppoint6;
			 icount=ii1;
		 }
		 //////////·Ѿȷppoint1Ϊ㣬·ΪƽƱ任·
		 l_AddList.RemoveAll();
		 ii1=0;
         ppoint5=ppoint1;
		 ppoint6=ppoint2;
		 ptemp=ppoint2;		
		 CDrawObj *ptempObj;
		 while((ppoint1!=ppoint3)&&(ppoint1!=ppoint4))
		 {
              POSITION position1=ppoint1->Nlink.GetHeadPosition();
			  isas=0;
			  ibreak=0;
			  while(position1!=NULL)
			  {
			       RELATION* rel=ppoint1->Nlink.GetNext(position1);
                   POSITION position2=rel->pObjList.GetHeadPosition();
				   while(position2!=NULL)
				   {
				       ptempObj=rel->pObjList.GetNext(position2);
					   if((ptempObj->type==G_POINT)&&(ptempObj!=ptemp)&&(ptempObj!=ppoint1)&&(rel->bSAS==1))
					   {
				           isas=1;
						   ibreak++;					       
					   }
					   if(ibreak>0)
						   break;
				   }
				   if(ibreak>0)
					   break;
				   		       
			  }		
			  /////////////////////////////////////////////////////////////////////////
			  ibreak=0;
			  position1=ppoint1->Nlink.GetHeadPosition();
			  while(position1!=NULL)
			  {
			       RELATION* rel=ppoint1->Nlink.GetNext(position1);
				   POSITION position2=rel->pObjList.GetHeadPosition();
				   while(position2!=NULL)
				   {
				       ptempObj=rel->pObjList.GetNext(position2);
					   if(isas==1)
					   {
				          if((ptempObj->type==G_POINT)&&(ptempObj!=ptemp)&&(ptempObj!=ppoint1)&&(rel->bSAS==1))
						  {
				              l_AddList.AddTail(ptempObj);
							  ibreak++;					          
						  }
					   }
				       else
					   {
				          if((ptempObj->type==G_POINT)&&(ptempObj!=ptemp)&&(ptempObj!=ppoint1))
						  {
				             l_AddList.AddTail(ptempObj);
					         ibreak++;
						  }
					   }
					   if(ibreak>0)
						   break;
				   }
				   if(ibreak>0)
					   break;
			  }
			  /////////////////////////////////////////////////////////////////////////////
			  POSITION pos = ptempObj->Nlink.GetHeadPosition();
			  icount1=0;
			  icount2=0;
		      while(pos!=NULL)
			  {
		           RELATION* temp_relation = ptempObj->Nlink.GetNext(pos);
				   POSITION pos2=temp_relation->pObjList.GetHeadPosition();
				   while(pos2!=NULL)
				   {
				       CDrawObj*pObj=temp_relation->pObjList.GetNext(pos2); 
					   if((pObj->type==G_POINT)&&(pObj!=ptempObj))
			             	icount1++;
			           if((pObj->type==G_LINE)&&(pObj!=ptempObj))
			             	icount2++;
				   }
		           
			      
			   }
			   if((icount1==2)&&(icount2<=2))
			   {  
				    ptemp=ppoint1;
                    ppoint1=ptempObj;
			   }
			   else
			   {
			       break;
			   }
		 }
		 if(ptempObj==ppoint3)
		 {
		    ptemp=ppoint4;
			ppoint4=ppoint3;
			ppoint3=ptemp;
			ppoint1=ppoint5;
		 }
		 if(ptempObj==ppoint4)
		 {
		    ppoint1=ppoint5;
		 }
		 if((ppoint1!=NULL)&&(ppoint2!=NULL)&&(ppoint3!=NULL)&&(ppoint4!=NULL)&&(temp2!=NULL)&&(temp3!=NULL)&&(temp4!=NULL))
	         return  ParaAllTransform(temp1,ppoint1,ppoint2,ppoint3,ppoint4,temp2,temp3,temp4); 
		 else
			 return NULL;

}
/////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////
CDrawObjList* CDrawView::ParaAllTransform(CDrawObjList* temp1,CDrawObj *ppoint1,CDrawObj *ppoint2,CDrawObj *ppoint3,CDrawObj *ppoint4,CDrawObj *pline1,CDrawObj *pline2,double temp4)
{
	/////d12p1ͬp2ĳ,d34p3ͬp4ĳȣdaaߵļнǡ 
	////ppoint1,ppoint2һϵ㣬ppoint3,ppoint4ڶϵ㡣pline1,pline2ߡ
	double d12(0),d34(0),dsas(0),dtemp(0);
	int icount(0),ii(0),ilin(0);
	CTypedPtrArray<CObArray, CDrawObj*>myArray;//////////һ飬ָ룬CDrawObjĵַ
	myArray.SetSize(50,-1);
	CMyPoint *pointtemp;//////CAddlistеÿһ㡣
	int iGao(0);///k10֮ûгȹϵ.
	//////////l_AddListÿһµ㣬ŵܾƽıε
	/////ߡ
    CDrawObj *plinkline2;
	POSITION pos;
	/////////Ժÿһicount
	icount=temp1->GetCount();
	/////////////////////d12,d34,dsas,daaʼֵ.
	int ibreak(0);
    pos = ppoint1->Nlink.GetHeadPosition();
    while(pos!=NULL)
    {
        RELATION* temp_relation = ppoint1->Nlink.GetNext(pos);
		POSITION pos2=temp_relation->pObjList.GetHeadPosition();
		while(pos2!=NULL)
		{
		    CDrawObj*pObj=temp_relation->pObjList.GetNext(pos2); 
			if(pObj==ppoint2)
			{
                d12=temp_relation->N_dis_clamp;
		        ibreak++;
			}
			if(ibreak>0)
				break;
		}
		if(ibreak>0)
			break;
    }
	ibreak=0;
	pos = ppoint3->Nlink.GetHeadPosition();
    while(pos!=NULL)
    {
        RELATION* temp_relation = ppoint3->Nlink.GetNext(pos);
		POSITION pos2=temp_relation->pObjList.GetHeadPosition();
		while(pos2!=NULL)
		{
		     CDrawObj*pObj=temp_relation->pObjList.GetNext(pos2);
			 if(pObj==ppoint4)
			 {
                 d34=temp_relation->N_dis_clamp;
		         ibreak++;
			 }
			 if(ibreak>0)
				 break;
		}      
        if(ibreak>0)
			break;
    }
	dsas=sqrt(d12*d12+d34*d34-2*d12*d34*cos(temp4));
	////////////////////
	myArray[ilin]=ppoint1;
	myArray[ilin+1]=ppoint2;
	myArray[ilin+2]=pline1;
    POSITION ppos;
	ppos=l_AddList.GetHeadPosition();
	while(ppos != NULL)
    {
	    pointtemp =(CMyPoint*)l_AddList.GetAt(ppos);
		int ii(0);
		///////////////ȷplinkline2 begin///ȷٽ߶///
        POSITION position1=pointtemp->Nlink.GetHeadPosition();
		while(position1!=NULL)
		{
		      RELATION* temp_rela=pointtemp->Nlink.GetNext(position1);
			  POSITION position2=temp_rela->pObjList.GetHeadPosition();
			  while(position2!=NULL)
			  {
			       CDrawObj*ptempObj=temp_rela->pObjList.GetNext(position2); 
				   if((ptempObj->type==G_LINE)&&(temp_rela->Nconstraintype==PL_DIS)&&(temp_rela->N_dis_clamp<L_ZERO))
				   {
			           POSITION pos = ptempObj->Nlink.GetHeadPosition();
                       while(pos!=NULL)
					   {
							 RELATION* temp_relation = ptempObj->Nlink.GetNext(pos);
							 POSITION pos2=temp_relation->pObjList.GetHeadPosition();
							 while(pos2!=NULL)
							 {
							     CDrawObj*pObj=temp_relation->pObjList.GetNext(pos2);
								 if((pObj==myArray[ilin])&&(temp_relation->N_dis_clamp<L_ZERO)&&(temp_relation->Nconstraintype==PL_DIS))
								 {
							    	ii=1;
			          		        	break;
								 }
							 }
							 if(ii==1)
								 break;
					   }
				   }
				   if(ii==1)
				   {
			          myArray[ilin+3] = ptempObj;
				      plinkline2=myArray[ilin+3];
				      break;
				   }
			  }	
		      if(ii==1)
				  break;
		  }
		  int y;
		  y=0;
		  POSITION ppos=ppoint1->Nlink.GetHeadPosition();
		  while(ppos!=NULL)
		  {
		      RELATION* ttemp_rela=ppoint1->Nlink.GetNext(ppos);
			  POSITION pos_1=ttemp_rela->pObjList.GetHeadPosition();
			  while(pos_1!=NULL)
			  {
			      CDrawObj*pObj_1=ttemp_rela->pObjList.GetNext(pos_1);
				  if(pObj_1->m_listindex==pointtemp->m_listindex)
				  {
				      y=1;
				  }
				  if(y==1)
					  break;
			  }
			  if(y==1)
				  break;			  
		  }
		  if(y==1)
		  {
		     iGao=1;
		  }
		  else
		  {
		     iGao=0;
		  }
		  ///ֱѱɾָ
		  if(plinkline2->bMark>0)
		  {
		         plinkline2->bMark=0;
			     POSITION pp=m_transformedlist.GetHeadPosition();
			     while(pp!=NULL)
				 {
			              CDrawObj* pObj=m_transformedlist.GetAt(pp);
				          if(pObj->m_listindex==plinkline2->m_listindex)
						  {
				                  m_transformedlist.RemoveAt(pp);
								  break;
						  }
				          m_transformedlist.GetNext(pp);
				 }
		  }
		///////////////ȷplinkline1 End/////
		/////////////////////////ȷһڽ߳//////
        ibreak=0;
        position1=pointtemp->Nlink.GetHeadPosition();
		while(position1!=NULL)
		{
		     RELATION* temp_rela=pointtemp->Nlink.GetNext(position1);
			 POSITION position2=temp_rela->pObjList.GetHeadPosition();
			 while(position2!=NULL)
			 {
			     CDrawObj*ptempObj=temp_rela->pObjList.GetNext(position2);
				 if(ptempObj==myArray[ilin])
				 {
				       dtemp=temp_rela->N_dis_clamp;
					   ibreak++;
				 }
				 if(ibreak>0)
					 break;
			 }
			 if(ibreak>0)
				 break;
		}
		////////////////////////
		if(pointtemp!=ppoint4)     //////////м㡣һߣ
		{
			///Ԫء
			double da,db;
			CMyPoint* px=(CMyPoint*)myArray[ilin+1];
			CMyPoint* py=(CMyPoint*)myArray[ilin];
			da=pointtemp->x()+px->x()-py->x();
			db=pointtemp->y()+px->y()-py->y();
			CMyPoint *ppoint=new CMyPoint(da,db);
			CMyLine *plineAdd1=new CMyLine;
			CMyLine *plineAdd2=new CMyLine;
			ppoint->bDraw=2;
			plineAdd1->bDraw=2;
			plineAdd2->bDraw=2;
            ppoint->m_listindex=icount;
			icount++;
            ppoint->Ndoc=0;
            ppoint->Ndof=2;
            ppoint->NFlag=false;
            ppoint->type=1;
			GetDocument()->Add(ppoint);
            plineAdd1->sLineColor="green";
            plineAdd1->m_listindex=icount;
			icount++;
            plineAdd1->Ndoc=0;
            plineAdd1->Ndof=2;
            plineAdd1->NFlag=false;
            plineAdd1->type=2;
            plineAdd1->my_endpoint=(CMyPoint*)ppoint;
            plineAdd1->my_startpoint=(CMyPoint*)pointtemp;
			///˴ϸøߵλá
            GetDocument()->Add(plineAdd1); 
            plineAdd2->sLineColor="green";
            plineAdd2->m_listindex=icount;
			icount++;
            plineAdd2->Ndoc=0;
            plineAdd2->Ndof=2;
            plineAdd2->NFlag=false;
            plineAdd2->type=2;
            plineAdd2->my_endpoint=(CMyPoint*)myArray[ilin+1];
            plineAdd2->my_startpoint=(CMyPoint*)ppoint;
        	GetDocument()->Add(plineAdd2);
            ppoint->Nlink.RemoveAll();
            plineAdd1->Nlink.RemoveAll();
            plineAdd2->Nlink.RemoveAll();
		    CAngleLine aaa;
			POSITION npos=l_AngleList.GetHeadPosition();
			while(npos!=NULL)
			{
			   CMyLine* pLine=l_AngleList.GetNext(npos);
			   if(pLine->m_listindex==myArray[ilin+2]->m_listindex)
				   aaa.Add(l_AngleList,(CMyLine*)myArray[ilin+2],plineAdd1,0.0);
			   if(pLine->m_listindex==myArray[ilin+3]->m_listindex)
				   aaa.Add(l_AngleList,(CMyLine*)myArray[ilin+3],plineAdd2,0.0);
			}	
			
		   ///ǶȹϵmyArray[ilin+2]ֱнǶȹϵ任plineAdd1ϡ		
           POSITION pPos=myArray[ilin+2]->Nlink.GetHeadPosition();
	       while(pPos!=NULL)
		   {   
			POSITION ptempPos=pPos;
			double dAngle;
	        RELATION* temp_relation=myArray[ilin+2]->Nlink.GetNext(pPos);
			dAngle=temp_relation->N_dis_clamp;
            POSITION pos1=temp_relation->pObjList.GetHeadPosition();
			while(pos1!=NULL)
			{
			    CDrawObj*pObj=temp_relation->pObjList.GetNext(pos1);				
		    	if((pObj->type==G_LINE)&&(temp_relation->Nconstraintype==LL_ANGLE)&&(pObj->bMark<1)
					&&(pObj->m_listindex!=plineAdd1->m_listindex)&&(pObj->m_listindex!=myArray[ilin+2]->m_listindex))
				{ ///ΪmyArray[ilin+2]йϵֱߡ
					CMyLine* TempLine;
					TempLine=(CMyLine*)pObj;
					myArray[ilin+2]->Nlink.GetNext(pPos);
					myArray[ilin+2]->Nlink.RemoveAt(ptempPos);///ɾmyArray[ilin+2]
					POSITION ptemp=pObj->Nlink.GetHeadPosition();
					while(ptemp!=NULL)
					{
						  POSITION ptempPos1=ptemp;
						  RELATION* temprela=pObj->Nlink.GetNext(ptemp);
						  POSITION pos11=temprela->pObjList.GetHeadPosition();
						  while(pos11!=NULL)
						  {
						      CDrawObj*ptempObj=temprela->pObjList.GetNext(pos11);
							  if(ptempObj->m_listindex==myArray[ilin+2]->m_listindex)
							  {
							      ///ʼԻһ¡
							      pObj->Nlink.GetNext(ptemp);
							      pObj->Nlink.RemoveAt(ptempPos1);///ɾͬpline2нǶȹϵĶϵ
							      ///ȻӸöֱ֮ͬ
							      AddRelation(LL_ANGLE,1,dAngle,1,CDD(pObj),CDD(plineAdd1));							   
								  break;
							  }
						  }	
					}
				}		
			}
		
	   }

		///debug
		   ///ڶ
		   	///ǶȹϵֱнǶȹϵ任һ¡
		///debug begin	

        pPos=myArray[ilin+3]->Nlink.GetHeadPosition();
	    while(pPos!=NULL)
		{   
			POSITION ptempPos=pPos;
	        RELATION* temp_relation=myArray[ilin+3]->Nlink.GetNext(pPos);
			POSITION pos1=temp_relation->pObjList.GetHeadPosition();
			while(pos1!=NULL)
			{
			    CDrawObj*pObj=temp_relation->pObjList.GetNext(pos1);
				double dAngle;
			    dAngle=temp_relation->N_dis_clamp;
			    if((pObj->type==G_LINE)&&(temp_relation->Nconstraintype==LL_ANGLE)&&(pObj->bMark<1)
					&&(pObj->m_listindex!=plineAdd2->m_listindex)&&(pObj->m_listindex!=myArray[ilin+3]->m_listindex))
				{ ///Ϊtemp2йϵֱߡ
					CMyLine* TempLine;
					TempLine=(CMyLine*)pObj;
					myArray[ilin+3]->Nlink.GetNext(pPos);
					myArray[ilin+3]->Nlink.RemoveAt(ptempPos);///ɾtemp2
					POSITION ptemp=pObj->Nlink.GetHeadPosition();
					while(ptemp!=NULL)
					{
						  POSITION ptempPos1=ptemp;
						  RELATION* temprela=pObj->Nlink.GetNext(ptemp);
						  POSITION pos11=temprela->pObjList.GetHeadPosition();
						  while(pos11!=NULL)
						  {
						      CDrawObj*ptempObj=temprela->pObjList.GetNext(pos11);
							  if(ptempObj->m_listindex==myArray[ilin+3]->m_listindex)
							  {
							      ///ʼԻһ¡
							      pObj->Nlink.GetNext(ptemp);
							      pObj->Nlink.RemoveAt(ptempPos1);///ɾͬtemp2нǶȹϵĶϵ
							      ///ȻӸöֱ֮ͬ
							      AddRelation(LL_ANGLE,1,dAngle,1,CDD(pObj),CDD(plineAdd2));						   
								  break;
							  }	
						  }
					}
				}		
			}			
	   }
	  ///ǽɾֱϵӵֱϡ			
		//////////////////////////////////////////////////////////////////
	    	///ʼɾһ㡣
		    myArray[ilin]->bMark=3;
		    m_transformedlist.AddHead(myArray[ilin]);
			///ʼɾһߡ
			myArray[ilin+2]->bMark=3;
			m_transformedlist.AddHead(myArray[ilin+2]);
			///////////////////////////////////////////////////////////////
			DeleteRelation(CDD(myArray[ilin+1]),CDD(myArray[ilin+2]));
			////////////////////////////////////////////////////////////////
           	///ʼɾһߡ
			myArray[ilin+3]->bMark=3;
			m_transformedlist.AddHead(myArray[ilin+3]);	
			///////////////////////////////////////////////////////////////
			DeleteRelation(CDD(pointtemp),CDD(myArray[ilin+3]));
			///////////////////////////////////////////////////////////////
			////////jiaBegin///////һĳ/////
			if(iGao==1)
			{
				AddRelation(PP_DIS,1,dtemp,1,CDD(ppoint),CDD(myArray[ilin+1]));			
			}
             ////////jiaEnd//////
				////////jiaBegin///////ڽӵĳ///
			{
				AddRelation(PP_DIS,1,d12,1,CDD(ppoint),CDD(pointtemp));			
			}
            ////////jiaEnd//////
			////////jiaBegin///////Ȼϵ
			{
				AddRelation(PL_DIS,1,D_ZERO,1,CDD(ppoint),CDD(plineAdd1));				
			}
            ////////jiaEnd//////
			////////jiaBegin///////Ȼϵ
			{
				AddRelation(PL_DIS,1,D_ZERO,1,CDD(ppoint),CDD(plineAdd2));				
			}
             ////////jiaEnd//////
             ////////jiaBegin///////ֱȻϵһ
			{
				AddRelation(PL_DIS,1,D_ZERO,1,CDD(pointtemp),CDD(plineAdd1));				
			}
             ////////jiaEnd//////

			////////jiaBegin///////ֱȻϵ
			{
				AddRelation(PL_DIS,1,D_ZERO,1,CDD(myArray[ilin+1]),CDD(plineAdd2));				
			}
        	///ɾֱߵƽйϵ
			{
			     RELATION* Temp1=new RELATION;
				 Temp1->Nconstraintype=LL_PARA;
				 Temp1->cDeg=1;
				 Temp1->N_dis_clamp=D_ZERO;
				 Temp1->pObjList.AddTail(CDD(myArray[ilin+2]));
				 Temp1->pObjList.AddTail(CDD(plineAdd1));
			     Temp1->Nserialno=plineAdd1->m_listindex;
				 Temp1->Ntype=plineAdd1->type;
				 Temp1->bAdjust=1;
				 myArray[ilin+2]->Nlink.AddTail(Temp1);
				 myArray[ilin+2]->Ndoc++;
				 GetDocument()->m_RelationList.AddTail(Temp1);
			}
			{
			     RELATION* Temp1=new RELATION;
				 Temp1->Nconstraintype=LL_PARA;
				 Temp1->cDeg=1;
				 Temp1->N_dis_clamp=D_ZERO;
				 Temp1->pObjList.AddTail(CDD(myArray[ilin+3]));
				 Temp1->pObjList.AddTail(CDD(plineAdd2));
			     Temp1->Nserialno=plineAdd2->m_listindex;
				 Temp1->Ntype=plineAdd2->type;
				 Temp1->bAdjust=1;
				 myArray[ilin+3]->Nlink.AddTail(Temp1);
				 myArray[ilin+3]->Ndoc++;
				 GetDocument()->m_RelationList.AddTail(Temp1);
			}
          ////////jiaEnd//////
		  ////////jiaBegin///////ֱƽйϵ
		     //////ʱɾʼ
			///ɾɾֱߵĳȡ
			DeleteRelation(CDD(pointtemp),CDD(myArray[ilin]));
             ///////////////////////////////////////////////////////
			DeleteRelation(CDD(myArray[ilin]),CDD(pointtemp));
		    ////////////////////////////////////////////////////////////
			DeleteRelation(CDD(myArray[ilin]),CDD(myArray[ilin+1]));
			////////////////////////////////////////////////////////////
		    DeleteRelation(CDD(myArray[ilin+1]),CDD(myArray[ilin]));
		    //////////////////////////////////////////////////////////////////
		    ilin+=4;
		    myArray[ilin]=pointtemp;    
		    myArray[ilin+1]=ppoint;
		    myArray[ilin+2]=plineAdd1;
		    l_AddList.GetNext(ppos);	  
		}
		else                    
		{
			///Ԫء
			double da,db;
			CMyPoint* px=(CMyPoint*)myArray[ilin+1];
			CMyPoint* py=(CMyPoint*)myArray[ilin];
			da=pointtemp->x()+px->x()-py->x();
			db=pointtemp->y()+px->y()-py->y();
			CMyPoint *ppoint=new CMyPoint(da,db);
			CMyLine *plineAdd1=new CMyLine;
			CMyLine *plineAdd2=new CMyLine;
			ppoint->bDraw=2;
			plineAdd1->bDraw=2;
			plineAdd2->bDraw=2;
            ppoint->m_listindex=icount;
			icount++;
            ppoint->Ndoc=0;
            ppoint->Ndof=2;
            ppoint->NFlag=false;
            ppoint->type=1;
			GetDocument()->Add(ppoint);
			plineAdd1->sLineColor="blue";
            plineAdd1->m_listindex=icount;
			icount++;
            plineAdd1->Ndoc=0;
            plineAdd1->Ndof=2;
            plineAdd1->NFlag=false;
            plineAdd1->type=2;
            plineAdd1->my_endpoint=(CMyPoint*)ppoint;
            plineAdd1->my_startpoint=(CMyPoint*)pointtemp;
        	GetDocument()->Add(plineAdd1);
            //plineAdd2->bDraw=2;
			plineAdd2->sLineColor="blue";
            plineAdd2->m_listindex=icount;
			icount++;
            plineAdd2->Ndoc=0;
            plineAdd2->Ndof=2;
            plineAdd2->NFlag=false;
            plineAdd2->type=2;
            plineAdd2->my_endpoint=(CMyPoint*)myArray[ilin+1];
            plineAdd2->my_startpoint=(CMyPoint*)ppoint;
         	GetDocument()->Add(plineAdd2);
            ppoint->Nlink.RemoveAll();
            plineAdd1->Nlink.RemoveAll();
            plineAdd2->Nlink.RemoveAll();
		    CAngleLine aaa;
			POSITION npos=l_AngleList.GetHeadPosition();
			while(npos!=NULL)
			{
			   CMyLine* pLine=l_AngleList.GetNext(npos);
			   if(pLine->m_listindex==myArray[ilin+2]->m_listindex)
				   aaa.Add(l_AngleList,(CMyLine*)myArray[ilin+2],plineAdd1,0.0);
			   if(pLine->m_listindex==myArray[ilin+3]->m_listindex)
				   aaa.Add(l_AngleList,(CMyLine*)myArray[ilin+3],plineAdd2,0.0);
			}	
			
		   ///ǶȹϵmyArray[ilin+2]ֱнǶȹϵ任plineAdd1ϡ		
			CDrawObj*plin=myArray[ilin+2];
           POSITION pPos=myArray[ilin+2]->Nlink.GetHeadPosition();
	       while(pPos!=NULL)
		   {   
			POSITION ptempPos=pPos;
			double dAngle;
	        RELATION* temp_relation=myArray[ilin+2]->Nlink.GetNext(pPos);
			dAngle=temp_relation->N_dis_clamp;
			POSITION pos1=temp_relation->pObjList.GetHeadPosition();
			while(pos1!=NULL)
			{
			    CDrawObj*pObj=temp_relation->pObjList.GetNext(pos1);
				if((pObj->type==G_LINE)&&(temp_relation->Nconstraintype==LL_ANGLE)&&(pObj->bMark<1)
					&&(pObj->m_listindex!=plineAdd1->m_listindex)&&(pObj->m_listindex!=myArray[ilin+2]->m_listindex))
				{ ///ΪmyArray[ilin+2]йϵֱߡ
					CMyLine* TempLine;
					TempLine=(CMyLine*)pObj;
					if(pPos!=NULL)
					    myArray[ilin+2]->Nlink.GetNext(pPos);
					myArray[ilin+2]->Nlink.RemoveAt(ptempPos);///ɾmyArray[ilin+2]
					POSITION ptemp=pObj->Nlink.GetHeadPosition();
					while(ptemp!=NULL)
					{
						  POSITION ptempPos1=ptemp;
						  RELATION* temprela=pObj->Nlink.GetNext(ptemp);
						  POSITION pos11=temprela->pObjList.GetHeadPosition();
						  while(pos11!=NULL)
						  {
						      CDrawObj*ptempObj=temprela->pObjList.GetNext(pos11);
							  if(ptempObj->m_listindex==myArray[ilin+2]->m_listindex)
							  {
								   ///ʼԻһ¡
								  if(ptemp!=NULL)
								       pObj->Nlink.GetNext(ptemp);
								   pObj->Nlink.RemoveAt(ptempPos1);///ɾͬpline2нǶȹϵĶϵ
								   ///ȻӸöֱ֮ͬ
								   AddRelation(LL_ANGLE,1,dAngle,1,CDD(pObj),CDD(plineAdd1));						  
								   break;
							  }
						  }
					}
					///////////////////////////////////////////
				}			
			}
	   }
		///debug
		   ///ڶ
		   	///ǶȹϵֱнǶȹϵ任һ¡
		///debug begin	
      ////////////////////////////////////////////////////////////////////////////////////////////
       pPos=myArray[ilin+3]->Nlink.GetHeadPosition();
	    while(pPos!=NULL)
		{   
			POSITION ptempPos=pPos;
	        RELATION* temp_relation=myArray[ilin+3]->Nlink.GetNext(pPos);
            POSITION pos1=temp_relation->pObjList.GetHeadPosition();
			while(pos1!=NULL)
			{
			    CDrawObj*pObj=temp_relation->pObjList.GetNext(pos1);
				double dAngle;
				dAngle=temp_relation->N_dis_clamp;
				if((pObj->type==G_LINE)&&(temp_relation->Nconstraintype==LL_ANGLE)&&(pObj->bMark<1)
					&&(pObj->m_listindex!=plineAdd2->m_listindex)&&(pObj->m_listindex!=myArray[ilin+3]->m_listindex))
				{ ///Ϊtemp2йϵֱߡ
					CMyLine* TempLine;
					TempLine=(CMyLine*)pObj;
					myArray[ilin+3]->Nlink.GetNext(pPos);
					myArray[ilin+3]->Nlink.RemoveAt(ptempPos);///ɾtemp2
					POSITION ptemp=pObj->Nlink.GetHeadPosition();
					while(ptemp!=NULL)
					{
						  POSITION ptempPos1=ptemp;
						  RELATION* temprela=pObj->Nlink.GetNext(ptemp);
						  POSITION pos11=temprela->pObjList.GetHeadPosition();
						  while(pos11!=NULL)
						  {
						      CDrawObj*ptempObj=temprela->pObjList.GetNext(pos11);
							  if(ptempObj->m_listindex==myArray[ilin+3]->m_listindex)
							  {
								   ///ʼԻһ¡
								   pObj->Nlink.GetNext(ptemp);
								   pObj->Nlink.RemoveAt(ptempPos1);///ɾͬtemp2нǶȹϵĶϵ
								   ///ȻӸöֱ֮ͬ
								   AddRelation(LL_ANGLE,1,dAngle,1,CDD(pObj),CDD(plineAdd2));						   
								   break;
							  }	
						  }
					}
				}	
			}
	   }
	  ///ǽɾֱϵӵֱϡ
			
		///ʼɾһ㡣
		    myArray[ilin]->bMark=3;
		    m_transformedlist.AddHead(myArray[ilin]);
			CDrawObj*ptestObj=myArray[ilin];
			///ʼɾһߡ
			myArray[ilin+2]->bMark=3;
			m_transformedlist.AddHead(myArray[ilin+2]);
			ptestObj=myArray[ilin+2];
			////////////////////////////////////////////////////////////////////
			DeleteRelation(CDD(myArray[ilin+1]),CDD(myArray[ilin+2]));    
			ptestObj=myArray[ilin+1];
			
			///ʼɾһߡ
			////////////////////////////////////////////////////////////////
			myArray[ilin+3]->bMark=3;
			m_transformedlist.AddHead(myArray[ilin+3]);	
			ptestObj=myArray[ilin+3];
			////////////////////////////////////////////////////////////////////
			DeleteRelation(CDD(pointtemp),CDD(myArray[ilin+3]));			
			////////jiaBegin///////һĳ/////
			if(iGao==1)
				AddRelation(PP_DIS,1,dtemp,1,CDD(ppoint),CDD(myArray[ilin+1]));							
             ////////jiaEnd//////
			ptestObj=myArray[ilin+1];
				////////jiaBegin///////ڽӵĳ///
			AddRelation(PP_DIS,1,d12,1,CDD(ppoint),CDD(pointtemp));							
            ////////jiaEnd//////
			////////jiaBegin///////Ȼϵ
			AddRelation(PL_DIS,1,D_ZERO,1,CDD(ppoint),CDD(plineAdd1));							
            ////////jiaEnd//////
			////////jiaBegin///////Ȼϵ
			AddRelation(PL_DIS,1,D_ZERO,1,CDD(ppoint),CDD(plineAdd2));							
             ////////jiaEnd//////
             ////////jiaBegin///////ֱȻϵһ
			AddRelation(PL_DIS,1,D_ZERO,1,CDD(pointtemp),CDD(plineAdd1));				
			////////jiaEnd//////
			////////jiaBegin///////ֱȻϵ
			AddRelation(PL_DIS,1,D_ZERO,1,CDD(myArray[ilin+1]),CDD(plineAdd2));	
			ptestObj=myArray[ilin+1];
			
		    ///ɾֱߵƽйϵ**********************///
			{
			     RELATION* Temp1=new RELATION;
			     Temp1->Nconstraintype=LL_PARA;
				 Temp1->cDeg=1;
				 Temp1->N_dis_clamp=D_ZERO;
				 Temp1->pObjList.AddTail(CDD(myArray[ilin+2]));
				 Temp1->pObjList.AddTail(CDD(plineAdd1));				 
				 Temp1->Nserialno=plineAdd1->m_listindex;
				 Temp1->Ntype=plineAdd1->type;
				 Temp1->bAdjust=1;
				 myArray[ilin+2]->Nlink.AddTail(Temp1);
				 myArray[ilin+2]->Ndoc++;
				 GetDocument()->m_RelationList.AddTail(Temp1);
			}
			ptestObj=myArray[ilin+2];
			{
			     RELATION* Temp1=new RELATION;
				 Temp1->Nconstraintype=LL_PARA;
				 Temp1->cDeg=1;
				 Temp1->N_dis_clamp=D_ZERO;
				 Temp1->pObjList.AddTail(CDD(myArray[ilin+3]));
				 Temp1->pObjList.AddTail(CDD(plineAdd2));
			     Temp1->Nserialno=plineAdd2->m_listindex;
				 Temp1->Ntype=plineAdd2->type;
				 Temp1->bAdjust=1;
				 myArray[ilin+3]->Nlink.AddTail(Temp1);
				 myArray[ilin+3]->Ndoc++;
				 GetDocument()->m_RelationList.AddTail(Temp1);
			}
			ptestObj=myArray[ilin+3];
     		///ɾɾֱߵĳȡ
			///****************************************************///
			DeleteRelation(CDD(pointtemp),CDD(myArray[ilin]));
			ptestObj=myArray[ilin];
            ///////////////////////////////////////////////////////////
			DeleteRelation(CDD(myArray[ilin]),CDD(pointtemp));
		    ///////////////////////////////////////////////////////////
			DeleteRelation(CDD(myArray[ilin]),CDD(myArray[ilin+1]));
			ptestObj=myArray[ilin+1];
		    //////////////////////////////////////////////////////////////
			DeleteRelation(CDD(myArray[ilin+1]),CDD(myArray[ilin]));
		    //////////////////////////////////////////////////////////////////////
			GetSASTransform(temp1,plineAdd1,pline2,temp4);
			break;

        ////////////////////////
		    ilin+=4;
		    myArray[ilin]=pointtemp;    
		    myArray[ilin+1]=ppoint;
		    myArray[ilin+2]=plineAdd1;
		    l_AddList.GetNext(ppos);
		}        	
		/////////ͨÿѭõЯ߶ֵ
	}
    /////////////////////////////////////////////////// 
    return temp1;
}
/////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////
void CDrawView::GetConstraintList(CDrawObjList* temp)//ѭԼ㷨
{
    //////////////first,initiate////////////////////////////////////
	///һȡNLinkеԭʼݣ
	ChangeNlink(temp);
    /////////////////////ڶ//////////////////////////////////
   	//////////////////////////////////////////////////
	POSITION pos,position;
	int m_sum(0),ik(0),kk(1),i(0),j(0),icount(0);
	int ncount(0),kcount(0),iBreak(0);
	int iGrade(0);             ///ñ𣬼ȽеSAS任ȻٽƽƱ任
	double fAngle;
	int iDecideEnd(0);///òȷǷѭֹ
	CDrawObjList* tempList;
	CDrawObj *pline00,*pline01,*pline10,*plinetemp,*ppoint00,*ppoint01,*ppoint10,*ppoint11,*ppointtemp;
    GetTransformedList(temp,1);///ȶһѭԼ⡣
	tempList=temp;
    ///**********************************
	i=tempList->GetCount();
	j=m_transformedlist.GetCount();////ObjѭԼõĹС	 
	out1:
	while(i>j)///////ûеõͼ//////////		 
	{
		m_transformedlist.RemoveAll();
		///?????һҪжϣȻ׽ѭ
		 ///Ƚеȼ任 
	     CAngleLine tempAngle;
    	 tempAngle.InitialUpdate(*temp,l_AngleList);/////l_AngleListнǶȵֱߡ
		 ///ʼ޸ģȽSAS任ȻڽƽƱ任	
		 ///ʼеSAS任
		 //////////////////////
		 if(iDecideEnd>10)
			 break;
		 iDecideEnd++;
		 /////////////////////
		 {
			 iGrade=0;
			 position =temp->GetHeadPosition();
			 while(position != NULL)
			 {
				 int nCount(0);
				 int kCount(0);
				 CDrawObj* temp1=temp->GetNext(position);
				 if((temp1->type==G_POINT)&&(temp1->bMark<1))
				 {
					  POSITION pos=temp1->Nlink.GetHeadPosition();
					  while(pos!=NULL)
					  {				        
						   RELATION* temp_relation=temp1->Nlink.GetNext(pos);
						   POSITION pos1=temp_relation->pObjList.GetHeadPosition();
						   while(pos1!=NULL)
						   {
						       CDrawObj*pObj=temp_relation->pObjList.GetNext(pos1);
							   if((pObj->type==G_POINT)&&(pObj->bMark<1)&&(pObj!=temp1)&&(temp_relation->Nconstraintype==PP_DIS))
							   {
									if(nCount==0)
									   ppoint00=pObj;					             
									if(nCount==1)
									   ppoint10=pObj;
									nCount++;
							   }
							   if((pObj->type==G_LINE)&&(pObj->bMark<1)&&(temp_relation->Nconstraintype==PL_DIS)&&(temp_relation->N_dis_clamp<L_ZERO))
							   {
								   if(kCount==0)
									   pline00=pObj;
								   if(kCount==1)
									   pline10=pObj;
		   							kCount++;
							   }
						   }
					  }
					  if((nCount==2)&&(kCount==2))
					  {
						  ///жȻԼ⣬ȻжϾϵȻжϽǶȹϵ
						  int kkk(0),mmm(0);
						  POSITION pos=ppoint00->Nlink.GetHeadPosition();
						  while(pos!=NULL)
						  {				        
							  RELATION* temp_relation=ppoint00->Nlink.GetNext(pos);
							  POSITION pos1=temp_relation->pObjList.GetHeadPosition();
							  while(pos1!=NULL)
							  {
							      CDrawObj*pObj=temp_relation->pObjList.GetNext(pos1);
								  if(pObj->m_listindex==temp1->m_listindex)
								  {
									  kkk++;
								  }
								  if((pObj->m_listindex==pline00->m_listindex)||(pObj->m_listindex==pline10->m_listindex))
								  {
									 if((temp_relation->Nconstraintype==PL_DIS)&&(temp_relation->N_dis_clamp<L_ZERO))
										 kkk++;
								  }
							  }
						  }
						  pos=ppoint10->Nlink.GetHeadPosition();
						  while(pos!=NULL)
						  {
							   RELATION* temp_relation=ppoint10->Nlink.GetNext(pos);
							   POSITION pos1=temp_relation->pObjList.GetHeadPosition();
							   while(pos1!=NULL)
							   {
							       CDrawObj*pObj=temp_relation->pObjList.GetNext(pos1);
								   if(pObj->m_listindex==temp1->m_listindex)
								  {
						  			  mmm++;
								  }
								  if((pObj->m_listindex==pline00->m_listindex)||(pObj->m_listindex==pline10->m_listindex))
								  {
									 if((temp_relation->Nconstraintype==PL_DIS)&&(temp_relation->N_dis_clamp<L_ZERO))
										 mmm++;
								  }
							   }
						  }
						  if((kkk==2)&&(mmm==2))///ʼжֱǷмнǡ
						  {
								POSITION ppos1=l_AngleList.GetHeadPosition();
								int incount(0);
								CMyLine* pFirstLine;
								CMyLine* pSecondLine;
								while(ppos1!=NULL)
								{  
									  CMyLine* pTempLine1=l_AngleList.GetNext(ppos1);
									  if(pTempLine1->m_listindex==pline00->m_listindex)
									  {
										  pFirstLine=pTempLine1;
										  incount++;
									  }
									  if(pTempLine1->m_listindex==pline10->m_listindex)
									  {
							          		pSecondLine=pTempLine1;
								    		incount++;
									  }
									  if(incount>=2)
									  {
											break;
									  }
								 }
								if(incount>=2)
								{
									 int ik;
									 CAngleLine tempAngle;
									 ik=tempAngle.bFound(l_AngleList,pFirstLine,pSecondLine);
									 if(ik==1)
									 {
										   fAngle=tempAngle.ComputeAngle(l_AngleList,pFirstLine,pSecondLine);
										   fAngle=JudgeAngle(tempList,pFirstLine,pSecondLine,fAngle);
										   int iTrue(0); 							
										   iGrade=1;
										   //////////////////ӶԽǶȵжϡ
										   bAngle=0;
										   POSITION pos=pFirstLine->Nlink.GetHeadPosition();
										   while(pos!=NULL)
										   {
												RELATION* temp_relation=pFirstLine->Nlink.GetNext(pos);
												POSITION pos1=temp_relation->pObjList.GetHeadPosition();
												while(pos1!=NULL)
												{
													CDrawObj*pObj=temp_relation->pObjList.GetNext(pos1);
													if(pObj->m_listindex==pSecondLine->m_listindex)
													{
														fAngle=temp_relation->N_dis_clamp;
														if(fAngle>0)
															fAngle=fAngle;
														else
															fAngle=-fAngle;
						  								bAngle=1;
														break;
													}
												}
										   }
										   break;
									 }
								}
						  }

					  }
				 }
			 }
		 }
		 ////һSAS任
		 if(iGrade==1)
		 {
 	         CDrawObjList *m_templist1=GetSASTransform(temp,pline00,pline10,fAngle);			  
              GetTransformedList(m_templist1,2);
	          j=m_transformedlist.GetCount();
			  i=m_templist1->GetCount();	    			  
			  if(i>j)
			  {
			   goto out1;
			  }
			  else
			  {
			       break;
			  }
		 }
         ///ʼҵһֱߣֻ㣬㳤֪
		 else
		 {              
              position =temp->GetHeadPosition();
	          while(position != NULL)
			  {
		          int nCount(0);
		          int kCount(0);
		          ik=0;
				  int iJudgeLine(0);
	              CDrawObj* temp1 =temp->GetNext(position);///õбеĵһԪء
			      if((temp1->type==G_LINE)&&(temp1->bMark<1))///Ԫһûɾֱߡ
				  {
			           POSITION pos=temp1->Nlink.GetHeadPosition();
                       while(pos!=NULL)
					   {
		                   RELATION* temp_relation=temp1->Nlink.GetNext(pos);
						   POSITION pos1=temp_relation->pObjList.GetHeadPosition();
						   while(pos1!=NULL)
						   {
						       CDrawObj*pObj=temp_relation->pObjList.GetNext(pos1);
							   if((pObj->type==G_POINT)&&(pObj->bMark<1)&&(temp_relation->Nconstraintype==PL_DIS)&&(temp_relation->N_dis_clamp<L_ZERO))
							   {
									if(nCount==0)
									{
										 ppoint00=pObj;
										 ppoint01=pObj;
									}  
									if(nCount==1)
									{
				    					 ppoint10=pObj;
										 ppoint11=pObj;
									}
									nCount++;
									iJudgeLine=99;
							   }
							   if((pObj->type==G_LINE)&&(pObj->bMark<1)&&(pObj!=temp1))
		   							kCount++;
						   }
		                   
		                   
					   }
				  }
		          ///ȷֱоԼ
				  if(iJudgeLine==99)
				  {
		              POSITION pos=ppoint00->Nlink.GetHeadPosition();
		              while(pos!=NULL)
					  {
		                   RELATION* temp_relation=ppoint00->Nlink.GetNext(pos);
						   POSITION pos1=temp_relation->pObjList.GetHeadPosition();
						   while(pos1!=NULL)
						   {
						       CDrawObj*pObj=temp_relation->pObjList.GetNext(pos1);
							   if(pObj==ppoint10)
							   {
 			                       ik=11;
				                   break;
							   }
						   }
					  }
				  }
                  if((temp1->type==2)&&(nCount==2)&&(kCount>=1)&&(ik==11)&&(temp1->bMark<1))///
				  {
		               int ii1(0),ii2(0),ij1(0),ij2(0),jj1(0),jj2(0);
		               pline00=temp1;   
		               pline01=temp1;
		               pos=ppoint00->Nlink.GetHeadPosition();
		               while(pos!=NULL)
					   {
		                    RELATION* temp_relation=ppoint00->Nlink.GetNext(pos);
							POSITION pos1=temp_relation->pObjList.GetHeadPosition();
							while(pos1!=NULL)
							{
							    CDrawObj*pObj=temp_relation->pObjList.GetNext(pos1);
								if((pObj->type==G_POINT)&&(pObj->bMark<1)&&(pObj!=ppoint00))
       				                ii1++;
			                    if((pObj->type==G_LINE)&&(pObj->bMark<1)&&(pObj!=ppoint00))
				                    ii2++;
							}
			                
			                
					   }
			           if((ii1<=2)&&(ii2<=2))
                            ij1=1; ////Դppoint00ʼѯ
			           pos=ppoint10->Nlink.GetHeadPosition();
			           while(pos!=NULL)
					   {
		                    RELATION* temp_relation=ppoint10->Nlink.GetNext(pos);
							POSITION pos1=temp_relation->pObjList.GetHeadPosition();
							while(pos1!=NULL)
							{
							    CDrawObj*pObj=temp_relation->pObjList.GetNext(pos1);
								if((pObj->type==G_POINT)&&(pObj->bMark<1)&&(pObj!=ppoint10))
			                        jj1++;
				                if((pObj->type==G_LINE)&&(pObj->bMark<1)&&(pObj!=ppoint10))
				                    jj2++;
							}
			               
				            
					   }
			           if((jj1<=2)&&(jj2<=2))
                            ij2=1; ////Դppoint10ʼѯ
			           if(ij1==1)////ʼppoint00ʼѯ
					   {
					        ppointtemp=ppoint00;
				            while(ppointtemp!=ppoint11)////鵽ûУѭ
							{
							     int ipoint(0),iline(0);
							     pos=ppoint00->Nlink.GetHeadPosition();
			                     while(pos!=NULL)
								 {								  
			                          RELATION* temp_relation=ppoint00->Nlink.GetNext(pos);
									  POSITION pos1=temp_relation->pObjList.GetHeadPosition();
									  while(pos1!=NULL)
									  {
									      CDrawObj*pObj=temp_relation->pObjList.GetNext(pos1);
										  if((pObj->type==G_POINT)&&(pObj!=ppoint10)&&(pObj!=ppoint00)&&(pObj->bMark<1))
										  {
											   ppointtemp=pObj;
											   ipoint++;
										  }
										  if((pObj->type==G_LINE)&&(pObj!=pline00)&&(pObj!=ppoint00)&&(pObj->bMark<1))
										  {
											   plinetemp=pObj;
											   iline++;
										  }
									  }
			                         
			                          
								 }
							     if((ipoint>=1)&&(iline>=1)&&(plinetemp->m_listindex!=pline01->m_listindex))
								 {
					                  ///ʼжֱǷмнǡͨȼȷڼн
					                  ///ýǶȡ
			                          POSITION ppos1=l_AngleList.GetHeadPosition();
								      int incount(0);
							          CMyLine* pFirstLine;
						              CMyLine* pSecondLine;
					                  while(ppos1!=NULL)
									  {   
							              CMyLine* pTempLine1=l_AngleList.GetNext(ppos1);
							              if(pTempLine1->m_listindex==pline01->m_listindex)
										  {
							                   pFirstLine=pTempLine1;
									           incount++;
										  }
							              if(pTempLine1->m_listindex==plinetemp->m_listindex)
										  {
							                	pSecondLine=pTempLine1;
									    	    incount++;
										  }
								          if(incount>=2)
										  {
									            break;
										  }
									  }
									  if(incount>=2)
									  {
										  int ik;
										  CAngleLine tempAngle;
										  ik=tempAngle.bFound(l_AngleList,pFirstLine,pSecondLine);
										  if(ik==1)///жֱǷֱ
										  {
											  ///
											  int bDirect(0);
											  pos=pFirstLine->Nlink.GetHeadPosition();
											  while(pos!=NULL)
											  {								  
												  RELATION* temp_relation=pFirstLine->Nlink.GetNext(pos);
												  POSITION pos1=temp_relation->pObjList.GetHeadPosition();
												  while(pos1!=NULL)
												  {
													  CDrawObj*pObj=temp_relation->pObjList.GetNext(pos1);
													  if(pObj->m_listindex==pSecondLine->m_listindex)
													  {
														 fAngle=temp_relation->N_dis_clamp;
														 bDirect=1;
														 break;
													  }
												  }
											  }
											  ///
											  if(bDirect==0)
												 fAngle=tempAngle.ComputeAngle(l_AngleList,pFirstLine,pSecondLine);
											  icount=13;
										  }
									  }
					                  ///жֱǷмнǡ
					                  ncount=0;
					                  kcount=0;
					                  pos=ppointtemp->Nlink.GetHeadPosition();
					                  while(pos!=NULL)
									  {
										  RELATION* temp_relation=ppointtemp->Nlink.GetNext(pos);
										  POSITION pos1=temp_relation->pObjList.GetHeadPosition();
										  while(pos1!=NULL)
										  {
										      CDrawObj*pObj=temp_relation->pObjList.GetNext(pos1); 
											  if((pObj->type==G_POINT)&&(pObj->bMark<1)&&(pObj!=ppointtemp))
											  {
												   ncount++;
											  }
										      if((pObj->type==G_LINE)&&(pObj->bMark<1)&&(pObj!=ppointtemp))
											  {
							                      kcount++;
											  }
										  }
									  }
                                      if((icount!=13)&&(ncount<=2)&&(kcount<=2))
									  {
						                  ppoint10=ppoint00;
					                      ppoint00=ppointtemp;
						                  pline00=plinetemp;
									  }
					                  if(icount==13)
						                  break;
								 }
							     else
								 {
							          ppoint10=ppoint00;
								      ppoint00=ppointtemp;
								      pline00=plinetemp;
								 }
							}
					   }
			   }
               if(icount==13)
			   {
				  //////////////////ֱмнǣʼжֱǷ
                  ///ΪSAS任(kk=2),ΪƽƱ任(kk=3)
				   //////////////////ӶԽǶȵжϡ
                   bAngle=0;
                   POSITION pos=pline01->Nlink.GetHeadPosition();
				   while(pos!=NULL)
				   {
				        RELATION* temp_relation=pline01->Nlink.GetNext(pos);
						POSITION pos1=temp_relation->pObjList.GetHeadPosition();
						while(pos1!=NULL)
						{
						    CDrawObj*pObj=temp_relation->pObjList.GetNext(pos1); 
							if(pObj->m_listindex==plinetemp->m_listindex)
							{
				                bAngle=1;
				    			break;
							}
						}
				   }				
				   ///////////////
                  int klin(0);
                  POSITION poss1=pline01->Nlink.GetHeadPosition();
				  while(poss1!=NULL)
				  {
				       RELATION *temp_rela11=pline01->Nlink.GetNext(poss1);
					   POSITION poss2=temp_rela11->pObjList.GetHeadPosition();
					   while(poss2!=NULL)
					   {
					        CDrawObj*pObj11=temp_rela11->pObjList.GetNext(poss2);
							if((pObj11->type==G_POINT)&&(temp_rela11->Nconstraintype==PL_DIS)&&(pObj11->bMark<1)&&(temp_rela11->N_dis_clamp<L_ZERO))
							{
								POSITION poss3=plinetemp->Nlink.GetHeadPosition();
								while(poss3!=NULL)
								{
									 RELATION *temp_rela21=plinetemp->Nlink.GetNext(poss3);
									 POSITION poss4=temp_rela21->pObjList.GetHeadPosition();
									 while(poss4!=NULL)
									 {
									      CDrawObj*pObj22=temp_rela21->pObjList.GetNext(poss4);
										  if((pObj22->type==G_POINT)&&(temp_rela21->Nconstraintype==PL_DIS)&&(pObj22->bMark<1)&&(temp_rela21->N_dis_clamp<L_ZERO))
										  {
					    				    	if(pObj22->m_listindex==pObj11->m_listindex)
												{
						     					     klin=2;
												     break;
												}
										  }
									 }
								} 
							}
					   }
				  }
			      /////////////////////
			      if(klin==2)
			   	       kk=2;   ////ΪSAS任(kk=2)
			      else
				       kk=3;/////ΪƽƱ任(kk=3)
			      break;
			  }
		 }
		 ///////////////////////////ʼִƽƻSAS任
		 if(kk==2)
		 {
              CDrawObjList *m_templist1=GetSASTransform(temp,pline01,plinetemp,fAngle);
			  ///////////////////////////////////////////////////////////////////////
              GetTransformedList(m_templist1,2);
	          j=m_transformedlist.GetCount();
			  i=m_templist1->GetCount();
			  if(i>j)
			  {
			     goto out1;
			  }
			  else
			  {
			     break;
			  }
		 }
	     if(kk==3)
		 {
	             CDrawObjList *m_templist2=GetParaTransform(temp,pline01,plinetemp,fAngle);
				 if(m_templist2!=NULL)
				 {	    			
					 GetTransformedList(m_templist2,2);
                     ////////////////////////////////////////////////////// 
					 j=m_transformedlist.GetCount();
					 i=m_templist2->GetCount();
					 if(i>j)
					 {
						 goto out1;
					 }
					 else
					 {
						 break;
					 }
				 }
			}
		 }
		 ///׼ӵڶƽƷʽڼнǵֱ֪****************
		 ///меֱߵĳȲ֪ƽƱ任**************************
         ///*******************************************************		 
		 {
			 CMyLine *pFirstline;
			 CMyLine *pSecondline;
			 CMyPoint *pPoint1;
			 CMyPoint *pPoint2;
			 position =temp->GetHeadPosition();
			 while(position != NULL)
			 {
				 int nCount(0),line1Judge(0),line2Judge(0);
				 int kCount(0),iGrade(0);
				 CDrawObj* temp1=temp->GetNext(position);
				 nCount=0;
				 kCount=0;
				 line1Judge=0;
				 line2Judge=0;
				 if((temp1->type==2)&&(temp1->bMark<1))   ///type1,2.
				 {
					  POSITION pos=temp1->Nlink.GetHeadPosition();
					  while(pos!=NULL)
					  {				        
						   RELATION* temp_relation=temp1->Nlink.GetNext(pos);
						   POSITION pos1=temp_relation->pObjList.GetHeadPosition();
						   while(pos1!=NULL)
						   {
						       CDrawObj*pObj=temp_relation->pObjList.GetNext(pos1);
							   if((pObj->type==G_POINT)&&(pObj->bMark<1)&&(temp_relation->Nconstraintype==PL_DIS)&&(temp_relation->N_dis_clamp<L_ZERO))
							   {
							        ///ΪҸֱϵ.
									if(nCount==0)
									   pPoint1=(CMyPoint*)pObj;					             
									if(nCount==1)
									   pPoint2=(CMyPoint*)pObj;
									nCount++;
							   }
						   }
						   if(nCount==2)
						   {
							   POSITION GaoPosition=pPoint1->Nlink.GetHeadPosition();
							   while(GaoPosition!=NULL)
							   {
									RELATION* Gao_relation=pPoint1->Nlink.GetNext(GaoPosition);
									POSITION pos_1=Gao_relation->pObjList.GetHeadPosition();
									while(pos_1!=NULL)
									{
									    CDrawObj*pObj_1=Gao_relation->pObjList.GetNext(pos_1);
										if(pObj_1->m_listindex==pPoint2->m_listindex)
										{
										   line1Judge=1;
										   pFirstline=(CMyLine*)temp1;
										   break;
										}                                        
									}									
							   }
							   break;
						   }
					  }
				 }

				 if(line1Judge==1) ///ֱһΪ߶,ʼжֱһмнǵ߶2.*****************
				 {
					   POSITION temp_pos =temp->GetHeadPosition();
					   while(temp_pos != NULL)
					   {
							CDrawObj* temp2=temp->GetNext(temp_pos);
							if((temp2->m_listindex!=temp1->m_listindex)&&(temp2->type==G_LINE)&&(temp2->bMark<1))
							{
								///Ȼʼжtemp2ǷΪ߶,֮жǷмн*******************
								kCount=0;
								POSITION pos=temp2->Nlink.GetHeadPosition();
								while(pos!=NULL)
								{	
									RELATION* temp_rela=temp2->Nlink.GetNext(pos);
									POSITION pos1=temp_rela->pObjList.GetHeadPosition();
									while(pos1!=NULL)
									{
									     CDrawObj*pObj=temp_rela->pObjList.GetNext(pos1);
										 if((pObj->type==G_POINT)&&(pObj->bMark<1)&&(temp_rela->Nconstraintype==PL_DIS)&&(temp_rela->N_dis_clamp<L_ZERO))
										 {
										   ///ΪҸֱϵ.
										   if(kCount==0)
											   pPoint1=(CMyPoint*)pObj;					             
										   if(kCount==1)
											   pPoint2=(CMyPoint*)pObj;
										   kCount++;
										 }
									}
								}
								if(kCount==2)
								{
									 POSITION GaoPosition=pPoint1->Nlink.GetHeadPosition();
									 while(GaoPosition!=NULL)
									 {
										  RELATION* Gao_relation=pPoint1->Nlink.GetNext(GaoPosition);
										  POSITION pos_1=Gao_relation->pObjList.GetHeadPosition();
										  while(pos_1!=NULL)
										  {
										       CDrawObj*pObj_1=Gao_relation->pObjList.GetNext(pos_1);
											   if(pObj_1->m_listindex==pPoint2->m_listindex)
											   {
											        line2Judge=1;
											        pSecondline=(CMyLine*)temp2;
											        break;
											   }
										  }										  
									 }						        
								}
							}
					   }
					   int ik(0);
					   
					 CAngleLine tempAngle;
					 ik=tempAngle.bFound(l_AngleList,pFirstline,pSecondline);
					 if(ik==1)
					 {
						  fAngle=tempAngle.ComputeAngle(l_AngleList,pFirstline,pSecondline);
    					  int iTrue(0); 							
						  iGrade=2;
						  //////////////////ӶԽǶȵжϡ
						  bAngle=0;
						  POSITION pos=pFirstline->Nlink.GetHeadPosition();
						  while(pos!=NULL)
						  {
							   RELATION* temp_relation=pFirstline->Nlink.GetNext(pos);
							   POSITION pos_2=temp_relation->pObjList.GetHeadPosition();
							   while(pos_2!=NULL)
							   {
							        CDrawObj*pObj_2=temp_relation->pObjList.GetNext(pos_2);
									if(pObj_2->m_listindex==pSecondline->m_listindex)
									{
										bAngle=1;
										break;
									}
							   }							   
						  }				    			 
					 }
				 }
				 if(iGrade==2)
				 {
					 CDrawObjList *m_templist2=GetParaNoLine(temp,pFirstline,pSecondline,fAngle);
					//////////////////////////////////////////////////////////////////
					 GetTransformedList(m_templist2,2);
					 j=m_transformedlist.GetCount();
					 i=m_templist2->GetCount();
					 if(i>j)
					 {
						 goto out1;
					 }
					 else
					 {
						break;
					 }
				 }     
		  }
	  }
	  /*
	  ôǴѭԼͨԼټȥһԼ
	  */
	  {
	          
	  }
    ///*******************************************************
	}
	ComputeTransformedlist();
}
/////////////////////////From QLin///////////////////////////////////
///////////////////////////////////from yang topology test
void CDrawView::ComputeTransformedlist()//transformedlistм
{                                         //óǰԪλ
	POSITION pos,pos1;
	CDrawObj *pObj,*pObj1,*pObj2,*pObj3;
	CDrawObj*ptempObj,*ptempObj1,*ptempObj2,*ptempObj3,*ptempObj4,*ptempObj5;
	RELATION *rel,*rel1,*rel2,*rel3;
	int iJudge(0);

    ///ʼAdd by qlin in 2001/11/15/begin///
    pos=m_transformedlist.GetHeadPosition();
	while(pos!=NULL)
	{
	    pObj=m_transformedlist.GetNext(pos);
		pObj->NFlag=0;
	}
	///ʼAdd by qlin in 2001/11/15/end///
	///мóǰԪλ*****************////////////
    pos = m_transformedlist.GetHeadPosition();
	CRelationlist temp_Nlink;//¼dependentlistӦNlink
    while(pos!=NULL)
	{
	    pObj=m_transformedlist.GetNext(pos);
	   ///////////////////////////////////////////////////
		temp_Nlink.RemoveAll();
		m_dependentslist.RemoveAll();	
		///////////////////////test for get dependents list///////////////////////////////////////
        if(pObj->bStatic==false)
		{
			pos1 = pObj->Nlink.GetHeadPosition();
			while(pos1!=NULL)
			{
				rel=pObj->Nlink.GetNext(pos1);
				if(rel->pObjList.GetCount()>0)
				{
					iJudge=1;			
					POSITION position1=rel->pObjList.GetHeadPosition();
					while(position1!=NULL)
					{
						ptempObj=rel->pObjList.GetNext(position1);
						if((ptempObj!=pObj)&&(ptempObj->NFlag==1))///õѾ졣
						{
							
						}
						else if((ptempObj!=pObj)&&(ptempObj->NFlag==0))///õ㻹ûй졣
						{
							iJudge=0;
						}
					}
					if(iJudge==1)
					{				 
						 temp_Nlink.AddTail(rel);			
					}            
				}		
			}
		}
///////////////////////////////test////////////////////////////

		int dependents=temp_Nlink.GetCount();
		switch (dependents)
		{
		case 0:
			break;
		case 1://obj
			{				
				////////////////////////////////////////
				pos1=temp_Nlink.GetHeadPosition();				
				rel1=temp_Nlink.GetNext(pos1);			
				//////////////////////////////////////////				
				switch(pObj->type)
				{
				    case 1://
			    	switch(rel1->Nconstraintype)
					{
						case PL_DIS:
						{							
							///the first step,get the other points;
							pos1=rel1->pObjList.GetHeadPosition();
							while(pos1!=NULL)
							{
							   ptempObj=rel1->pObjList.GetNext(pos1);
							   if((ptempObj!=pObj)&&(ptempObj->type==G_LINE))
							   {
								   ptempObj1=ptempObj;
								   break;
							   }
							}
							//////////////?????????????????????????????????????????????????????
							if((ptempObj1->type==G_LINE)&&(rel1->N_dis_clamp<0.0000001))
							{								
								
								int k=sol_lll(((CMyLine*)ptempObj1)->ABC[0],
											((CMyLine*)ptempObj1)->ABC[1],
											((CMyLine*)ptempObj1)->ABC[2],
											((CMyLine*)ptempObj1)->ABC[1],
										   -((CMyLine*)ptempObj1)->ABC[0],
											((CMyLine*)ptempObj1)->ABC[0]*((CMyPoint*)pObj)->y()
										   -((CMyLine*)ptempObj1)->ABC[1]*((CMyPoint*)pObj)->x());
								///sol_1صһ㡣ֱߵĽ.ֵΪintersection.
								if(k>0)
								{
									CPoint2 temp_direction=((CMyPoint*)pObj)->m_startpoint
														  -(*intersection);
									double len=rel1->N_dis_clamp;
									((CMyPoint*)pObj)->m_startpoint
									=intersection->getPoint(temp_direction,len);
								}
								else
								{
								   // ASSERT(FALSE);
								}
							}
						}
					    break;
					    case PL_MID:
						{
						      ///the first step,get the other points;
							  pos1=rel1->pObjList.GetHeadPosition();
							  while(pos1!=NULL)
							  {
								   ptempObj=rel1->pObjList.GetNext(pos1);
								   if((ptempObj!=pObj)&&(ptempObj->type==G_LINE))
								   {
									   ptempObj1=ptempObj;
									   break;
								   }
							   }					
							   /////the second step,compute the point;
							   if(ptempObj1->type==G_LINE)
							   {
								   CPoint2 temp;								 
								   temp=0.5*(((CMyLine*)ptempObj1)->my_startpoint->m_startpoint+((CMyLine*)ptempObj1)->my_endpoint->m_startpoint);
                                   ((CMyPoint*)pObj)->m_startpoint=temp;								  
							   }								
						}
						break;
					    case PP_DIS:
						{
						    ///the first step,get the other points;
						    pos1=rel1->pObjList.GetHeadPosition();
							while(pos1!=NULL)
							{
							   ptempObj=rel1->pObjList.GetNext(pos1);
							   if((ptempObj!=pObj)&&(ptempObj->type==G_POINT))
							   {
								   ptempObj1=ptempObj;
								   break;
							   }
						   }					
						   /////the second step,compute the point;	
							if(ptempObj1->type==G_POINT)
							{
								if(rel1->Nconstraintype==PP_DIS)
								{
									CPoint2 temp_direction=((CMyPoint*)pObj)->m_startpoint
														  -((CMyPoint*)ptempObj1)->m_startpoint;
									double len=rel1->N_dis_clamp;
									((CMyPoint*)pObj)->m_startpoint
									=((CMyPoint*)ptempObj1)->m_startpoint.getPoint(temp_direction,len);
								}
								else
								{
									ASSERT(FALSE);//Ǿ뱨
								}
							}
						}
						break;
					    case PC_DIS:///˴Բȷ;
						{
						    /////////Add by qlin begin in 9/10/////////
							///the first step,get the other points;
						    pos1=rel1->pObjList.GetHeadPosition();
							while(pos1!=NULL)
							{
							   ptempObj=rel1->pObjList.GetNext(pos1);
							   if((ptempObj!=pObj)&&(ptempObj->type==G_CIRCLE))
							   {
								   ptempObj1=ptempObj;
								   break;
							   }
						   }		
							/////////Բȷ,ȷһԲϵĵ./////////////////////////
               				if((rel1->N_dis_clamp<=0.00001)&&(ptempObj1->type==G_CIRCLE))
							{
							     double x0,x1,x21,x22,y0,y1,y21,y22,r,a,b,dsqrt;////xo,y0Բ,x1,y1õλ,x2,y2õӦõλ.
							     x0=((CMyCircle*)ptempObj1)->ABC[0];
							     y0=((CMyCircle*)ptempObj1)->ABC[1];
							     r=((CMyCircle*)ptempObj1)->ABC[2];
							     x1=((CMyPoint*)pObj)->m_startpoint.x;
							     y1=((CMyPoint*)pObj)->m_startpoint.y;
                                 dsqrt=-4*y0*y0*y0*y1*r*r+6*y0*y0*y1*y1*r*r+x1*x1*r*r*y0*y0+x1*x1*r*r*y1*y1
									 +x0*x0*r*r*y0*y0+x0*x0*r*r*y1*y1+y1*y1*y1*y1*r*r
								    -4*y0*y1*y1*y1*r*r+4*x0*x1*r*r*y0*y1+y0*y0*y0*y0*r*r-2*x0*x1*r*r*y1*y1-2*x0*x1*r*r*y0*y0
								    -2*x0*x0*r*r*y0*y1-2*x1*x1*r*r*y0*y1;
								 if(dsqrt>=0)
								 {
									 ((CMyPoint*)pObj)->bSqrt=0;
									 a=(0.5)*(2*y0*y1*y1-4*y0*y0*y1+2*x1*x1*y0+2*y0*y0*y0+2*x0*x0*y0-4*x1*y0*x0
										 +2*sqrt(dsqrt))/(-2*y0*y1-2*x0*x1+y0*y0+y1*y1+x1*x1+x0*x0);
									 b=(0.5)*(2*y0*y1*y1-4*y0*y0*y1+2*x1*x1*y0+2*y0*y0*y0+2*x0*x0*y0-4*x1*y0*x0
										 -2*sqrt(dsqrt))/(-2*y0*y1-2*x0*x1+y0*y0+y1*y1+x1*x1+x0*x0);
									 y21=a;
									 y22=b;
									 x21=(x1*y0-x1*a-x0*y1+x0*a)/(y0-y1);
									 x22=(x1*y0-x1*b-x0*y1+x0*b)/(y0-y1);
									 if(((x1-x21)*(x1-x21)+(y1-y21)*(y1-y21))<=((x1-x0)*(x1-x0)+(y1-y0)*(y1-y0)))
									 {
										 ((CMyPoint*)pObj)->m_startpoint.x=x21;
										 ((CMyPoint*)pObj)->m_startpoint.y=y21;
									 }
									 else
									 {
										 ((CMyPoint*)pObj)->m_startpoint.x=x22;
										 ((CMyPoint*)pObj)->m_startpoint.y=y22;
									 }
								 }
								 else
								 {
								   ((CMyPoint*)pObj)->bSqrt=1;
								 }
							}
							//////////Add by qlin end in 9/10///////////////////////
						}
						break;
						case PPPP_CENTR:
						{
								///the first step,get the other three points;
								CDrawObj *ptempObj1,*ptempObj2,*ptempObj3,*ptempObj4;
								pos1=rel1->pObjList.GetHeadPosition();
							    while(pos1!=NULL)
								{
							         ptempObj1=rel1->pObjList.GetNext(pos1);
									 ptempObj2=rel1->pObjList.GetNext(pos1);
									 ptempObj3=rel1->pObjList.GetNext(pos1);
									 ptempObj4=rel1->pObjList.GetNext(pos1);							         
								}		
							/////////the second step,compute the last point;/////////////////////////
								double dx1,dy1,dx2,dy2,dx3,dy3,dx4,dy4,dx,dy;
								dx1=((CMyPoint*)ptempObj1)->m_startpoint.x;
								dy1=((CMyPoint*)ptempObj1)->m_startpoint.y;
								dx2=((CMyPoint*)ptempObj2)->m_startpoint.x;
								dy2=((CMyPoint*)ptempObj2)->m_startpoint.y;
								dx3=((CMyPoint*)ptempObj3)->m_startpoint.x;
								dy3=((CMyPoint*)ptempObj3)->m_startpoint.y;
							    dx4=((CMyPoint*)ptempObj4)->m_startpoint.x;
								dy4=((CMyPoint*)ptempObj4)->m_startpoint.y;
								if(pObj==ptempObj4)
								{									
									dx=(dx1+dx2+dx3)/3;
									dy=(dy1+dy2+dy3)/3;
									((CMyPoint*)pObj)->m_startpoint.x=dx;
									((CMyPoint*)pObj)->m_startpoint.y=dy;
								}
								else if(pObj==ptempObj1)
								{
								    dx=3*dx4-dx2-dx3;
									dy=3*dy4-dy2-dy3;
									((CMyPoint*)pObj)->m_startpoint.x=dx;
									((CMyPoint*)pObj)->m_startpoint.y=dy;
								}
								else if(pObj==ptempObj2)
								{
								    dx=3*dx4-dx1-dx3;
									dy=3*dy4-dy1-dy3;
									((CMyPoint*)pObj)->m_startpoint.x=dx;
									((CMyPoint*)pObj)->m_startpoint.y=dy;
								}
								else 
								{
								    dx=3*dx4-dx1-dx2;
									dy=3*dy4-dy1-dy2;
									((CMyPoint*)pObj)->m_startpoint.x=dx;
									((CMyPoint*)pObj)->m_startpoint.y=dy;
								}
							}
						break;
						case PPPP_CIRCUM:
							{
							     ///the first step,get the other three points;
								CDrawObj *ptempObj1,*ptempObj2,*ptempObj3,*ptempObj4;
								pos1=rel1->pObjList.GetHeadPosition();
							    while(pos1!=NULL)
								{
							         ptempObj1=rel1->pObjList.GetNext(pos1);
									 ptempObj2=rel1->pObjList.GetNext(pos1);
									 ptempObj3=rel1->pObjList.GetNext(pos1);
									 ptempObj4=rel1->pObjList.GetNext(pos1);							         
								}		
							/////////the second step,compute the last point;/////////////////////////
								double x1,y1,x2,y2,x3,y3,x4,y4,x,y,r1,r2,ya,yb,xa,xb;
								x1=((CMyPoint*)ptempObj1)->m_startpoint.x;
								y1=((CMyPoint*)ptempObj1)->m_startpoint.y;
								x2=((CMyPoint*)ptempObj2)->m_startpoint.x;
								y2=((CMyPoint*)ptempObj2)->m_startpoint.y;
								x3=((CMyPoint*)ptempObj3)->m_startpoint.x;
								y3=((CMyPoint*)ptempObj3)->m_startpoint.y;
							    x4=((CMyPoint*)ptempObj4)->m_startpoint.x;
								y4=((CMyPoint*)ptempObj4)->m_startpoint.y;
							    /////////the second step,compute the last point;/////////////////////////                               
								///ĸġ
								///pObj==ptempObj4,ġȣͼ㣬õ
								///ptempObj4ľڸõľȣͬʱһߡ
								if(pObj==ptempObj4)
								{
									 x = 0.5*(x1*x1*y2-x1*x1*y3+y1*x3*x3+x2*x2*y3+y1*y3*y3+y2*y2*y3-y1*x2*x2+y1*y1*y2
											  -y1*y2*y2-y2*y3*y3-y2*x3*x3-y1*y1*y3)/(-x1*y3-x2*y1+x2*y3+x1*y2+x3*y1-x3*y2);
									 y = 0.5*(-x1*x3*x3+x3*y1*y1-x1*y3*y3-x2*x1*x1-x3*y2*y2-x2*y1*y1+x2*x3*x3+x1*y2*y2
											  +x2*y3*y3+x1*x2*x2-x3*x2*x2+x3*x1*x1)/(-x1*y3-x2*y1+x2*y3+x1*y2+x3*y1-x3*y2);
									 if(x>2000||x<-2000||y>2000||y<-2000)
									 {}
									 else
									 {
									    ((CMyPoint*)pObj)->m_startpoint.x=x;
									    ((CMyPoint*)pObj)->m_startpoint.y=y;
									 }
								}
								else if(pObj==ptempObj1)
								{
									///maple solution;
									///solve({(x-x4)^2+(y-y4)^2=(x2-x4)^2+(y2-y4)^2,(x1-x)/(x1-x4)=(y1-y)/(y1-y4)},{x,y});									
									double dsqrt;
									dsqrt=(4*x1*x4*x4*x4*y1*y4
										-8*x1*x4*x4*x2*y1*y4+4*x1*x4*x2*x2*y1*y4-8*x1*x4*y2*y4*y4*y1+4*x1*x4*y2*y4*y1*y1
										+4*x1*x4*y2*y2*y1*y4+4*x1*x4*y2*y4*y4*y4-2*x1*x4*x2*x2*y4*y4-2*x1*x4*y2*y2*y1*y1
										-2*x1*x4*y2*y2*y4*y4-12*y1*y1*y4*y4*x2*x4+8*y1*y4*y4*y4*x2*x4+8*y1*y1*y1*y4*x2*x4
										-2*x1*x1*y2*y4*y1*y1-2*x1*x1*x2*x4*y4*y4-2*x1*x1*x2*x2*y1*y4+4*x1*x1*y2*y4*y4*y1
										-2*x1*x1*y2*y2*y1*y4-2*x1*x1*x2*x4*y1*y1-2*x1*x1*y1*x4*x4*y4-2*x4*x4*y2*y4*y1*y1
										+4*x4*x4*x4*x2*y1*y4+6*y1*y1*y4*y4*y2*y2+8*y1*y4*y4*y4*y4*y2-4*y1*y4*y4*y4*x2*x2
										-4*y1*y1*y1*y4*y2*y2-4*y1*y4*y4*y4*y2*y2+x1*x1*y1*y1*x4*x4+x1*x1*x2*x2*y1*y1
										-2*x1*x1*y2*y4*y4*y4+x1*x1*x2*x2*y4*y4+x1*x1*y2*y2*y1*y1+x1*x1*y2*y2*y4*y4
										-2*x4*x4*x4*x2*y4*y4+x4*x4*x2*x2*y1*y1-2*x4*x4*x4*x2*y1*y1-2*x4*x4*x4*x4*y1*y4
										-2*x4*x4*y2*y4*y4*y4+x4*x4*x2*x2*y4*y4+x4*x4*y2*y2*y1*y1+x4*x4*y2*y2*y4*y4
										-2*y1*y1*y1*y1*y2*y4-2*y1*y1*y1*y1*x2*x4+6*y4*y4*y4*y4*y1*y1-4*y4*y4*y4*y4*y4*y1
										-4*y4*y4*y4*y1*y1*y1+x1*x1*y4*y4*y4*y4+2*y4*y4*y4*y4*x4*x4+x4*x4*x4*x4*y4*y4
										+y4*y4*y1*y1*y1*y1+x4*x4*x4*x4*y1*y1+y1*y1*y1*y1*x4*x4+y1*y1*y1*y1*x2*x2
										+y1*y4*y4*y4*y2*y2-2*y4*y4*y4*y4*y4*y2+y4*y4*y4*y4*x2*x2+y4*y4*y4*y4*y2*y2
										+4*x1*y4*y4*y4*x4*y1-2*x1*y4*y4*x4*y1*y1+4*x1*x4*x4*x2*y4*y4-2*x1*x4*x2*x2*y1*y1
										+4*x1*x4*x4*x2*y1*y1+x1*x1*y4*y4*x4*x4-2*x1*y4*y4*x4-2*x1*y4*y4*x4*x4*x4
										-2*y4*y4*y4*y1*x1*x1-6*y4*y4*y4*y1*x4*x4+x1*x1*y4*y4*y1*y1+7*x4*x4*y4*y4*y1*y1
										-2*x1*x4*x4*x4*y1*y1-4*y1*y1*y1*y4*x4*x4+8*y1*y1*y1*y4*y4*y2+6*y1*y1*y4*y4*x2*x2
										-12*y1*y1*y4*y4*y4*y2-4*y1*y1*y1*y4*x2*x2+y4*y4*y4*y4*y4*y4-2*y4*y4*y4*y4*x2*x4
										+4*x1*x1*x2*x4*y1*y4-2*x4*x4*x2*x2*y1*y4-2*x4*x4*y2*y2*y1*y4+4*x4*x4*y2*y4*y4*y1);
                                    if(dsqrt>=0)
									{
										((CMyPoint*)pObj)->bSqrt=0;
										r1=0.5/(-2*x1*x4-2*y1*y4+x1*x1+x4*x4+y1*y1+y4*y4)*(-4*x1*y4*x4-4*y4*y4*y1
											+2*x1*x1*y4+2*y4*y4*y4+2*x4*x4*y4+2*y4*y1*y1+2*sqrt(dsqrt));
										r2=0.5/(-2*x1*x4-2*y1*y4+x1*x1+x4*x4+y1*y1+y4*y4)*(-4*x1*y4*x4-4*y4*y4*y1
											+2*x1*x1*y4+2*y4*y4*y4+2*x4*x4*y4+2*y4*y1*y1-2*sqrt(dsqrt));
										ya=r1;
										yb=r2;
										xa=-(-x1*y4+y1*x4+ya*x1-ya*x4)/(-y1+y4);
										xb=-(-x1*y4+y1*x4+yb*x1-yb*x4)/(-y1+y4);
										if((xa-x1)*(xa-x1)+(ya-y1)*(ya-y1)>(xb-x1)*(xb-x1)+(yb-y1)*(yb-y1))
										{
											if(xb>2000||xb<-2000||yb>2000||yb<-2000)
											{}
											else
											{
												((CMyPoint*)pObj)->m_startpoint.x=xb;
												((CMyPoint*)pObj)->m_startpoint.y=yb;
											}
										}
										else
										{
											if(xa>2000||xa<-2000||ya>2000||ya<-2000)
											{}
											else
											{
											   ((CMyPoint*)pObj)->m_startpoint.x=xa;
											   ((CMyPoint*)pObj)->m_startpoint.y=ya;
											}
										}
									}
									else
									{
									  ((CMyPoint*)pObj)->bSqrt=1;
									}
								}
                                else if(pObj==ptempObj2)
								{
									///maple solution;
									///solve({(x-x4)^2+(y-y4)^2=(x2-x4)^2+(y2-y4)^2,(x1-x)/(x1-x4)=(y1-y)/(y1-y4)},{x,y});	
                                     x2=((CMyPoint*)ptempObj1)->m_startpoint.x;
								     y2=((CMyPoint*)ptempObj1)->m_startpoint.y;
								     x1=((CMyPoint*)ptempObj2)->m_startpoint.x;
								     y1=((CMyPoint*)ptempObj2)->m_startpoint.y;
							         x4=((CMyPoint*)ptempObj4)->m_startpoint.x;
								     y4=((CMyPoint*)ptempObj4)->m_startpoint.y;
									////////////////////////////////////////MODIFY/////////////////////////////////////
									 double dsqrt;
									 dsqrt=(4*x1*x4*x4*x4*y1*y4
										-8*x1*x4*x4*x2*y1*y4+4*x1*x4*x2*x2*y1*y4-8*x1*x4*y2*y4*y4*y1+4*x1*x4*y2*y4*y1*y1
										+4*x1*x4*y2*y2*y1*y4+4*x1*x4*y2*y4*y4*y4-2*x1*x4*x2*x2*y4*y4-2*x1*x4*y2*y2*y1*y1
										-2*x1*x4*y2*y2*y4*y4-12*y1*y1*y4*y4*x2*x4+8*y1*y4*y4*y4*x2*x4+8*y1*y1*y1*y4*x2*x4
										-2*x1*x1*y2*y4*y1*y1-2*x1*x1*x2*x4*y4*y4-2*x1*x1*x2*x2*y1*y4+4*x1*x1*y2*y4*y4*y1
										-2*x1*x1*y2*y2*y1*y4-2*x1*x1*x2*x4*y1*y1-2*x1*x1*y1*x4*x4*y4-2*x4*x4*y2*y4*y1*y1
										+4*x4*x4*x4*x2*y1*y4+6*y1*y1*y4*y4*y2*y2+8*y1*y4*y4*y4*y4*y2-4*y1*y4*y4*y4*x2*x2
										-4*y1*y1*y1*y4*y2*y2-4*y1*y4*y4*y4*y2*y2+x1*x1*y1*y1*x4*x4+x1*x1*x2*x2*y1*y1
										-2*x1*x1*y2*y4*y4*y4+x1*x1*x2*x2*y4*y4+x1*x1*y2*y2*y1*y1+x1*x1*y2*y2*y4*y4
										-2*x4*x4*x4*x2*y4*y4+x4*x4*x2*x2*y1*y1-2*x4*x4*x4*x2*y1*y1-2*x4*x4*x4*x4*y1*y4
										-2*x4*x4*y2*y4*y4*y4+x4*x4*x2*x2*y4*y4+x4*x4*y2*y2*y1*y1+x4*x4*y2*y2*y4*y4
										-2*y1*y1*y1*y1*y2*y4-2*y1*y1*y1*y1*x2*x4+6*y4*y4*y4*y4*y1*y1-4*y4*y4*y4*y4*y4*y1
										-4*y4*y4*y4*y1*y1*y1+x1*x1*y4*y4*y4*y4+2*y4*y4*y4*y4*x4*x4+x4*x4*x4*x4*y4*y4
										+y4*y4*y1*y1*y1*y1+x4*x4*x4*x4*y1*y1+y1*y1*y1*y1*x4*x4+y1*y1*y1*y1*x2*x2
										+y1*y4*y4*y4*y2*y2-2*y4*y4*y4*y4*y4*y2+y4*y4*y4*y4*x2*x2+y4*y4*y4*y4*y2*y2
										+4*x1*y4*y4*y4*x4*y1-2*x1*y4*y4*x4*y1*y1+4*x1*x4*x4*x2*y4*y4-2*x1*x4*x2*x2*y1*y1
										+4*x1*x4*x4*x2*y1*y1+x1*x1*y4*y4*x4*x4-2*x1*y4*y4*x4-2*x1*y4*y4*x4*x4*x4
										-2*y4*y4*y4*y1*x1*x1-6*y4*y4*y4*y1*x4*x4+x1*x1*y4*y4*y1*y1+7*x4*x4*y4*y4*y1*y1
										-2*x1*x4*x4*x4*y1*y1-4*y1*y1*y1*y4*x4*x4+8*y1*y1*y1*y4*y4*y2+6*y1*y1*y4*y4*x2*x2
										-12*y1*y1*y4*y4*y4*y2-4*y1*y1*y1*y4*x2*x2+y4*y4*y4*y4*y4*y4-2*y4*y4*y4*y4*x2*x4
										+4*x1*x1*x2*x4*y1*y4-2*x4*x4*x2*x2*y1*y4-2*x4*x4*y2*y2*y1*y4+4*x4*x4*y2*y4*y4*y1);
									 if(dsqrt>=0)
									 {
										 ((CMyPoint*)pObj)->bSqrt=0;
										 r1=0.5/(-2*x1*x4-2*y1*y4+x1*x1+x4*x4+y1*y1+y4*y4)*(-4*x1*y4*x4-4*y4*y4*y1
											+2*x1*x1*y4+2*y4*y4*y4+2*x4*x4*y4+2*y4*y1*y1+2*sqrt(dsqrt));
										 r2=0.5/(-2*x1*x4-2*y1*y4+x1*x1+x4*x4+y1*y1+y4*y4)*(-4*x1*y4*x4-4*y4*y4*y1
											+2*x1*x1*y4+2*y4*y4*y4+2*x4*x4*y4+2*y4*y1*y1-2*sqrt(dsqrt));
										 ya=r1;
										 yb=r2;
										 xa=-(-x1*y4+y1*x4+ya*x1-ya*x4)/(-y1+y4);
										 xb=-(-x1*y4+y1*x4+yb*x1-yb*x4)/(-y1+y4);
										 if((xa-x1)*(xa-x1)+(ya-y1)*(ya-y1)>(xb-x1)*(xb-x1)+(yb-y1)*(yb-y1))
										 {
											if(xb>2000||xb<-2000||yb>2000||yb<-2000)
											{}
											else
											{
												((CMyPoint*)pObj)->m_startpoint.x=xb;
												((CMyPoint*)pObj)->m_startpoint.y=yb;
											}
										}
										else
										{
											if(xa>2000||xa<-2000||ya>2000||ya<-2000)
											{}
											else
											{
											   ((CMyPoint*)pObj)->m_startpoint.x=xa;
											   ((CMyPoint*)pObj)->m_startpoint.y=ya;
											}
										}
									 }
									 else
									 {
									      ((CMyPoint*)pObj)->bSqrt=1;
									 }
								}
								else if(pObj==ptempObj3)
								{
								   	///maple solution;
									///solve({(x-x4)^2+(y-y4)^2=(x2-x4)^2+(y2-y4)^2,(x1-x)/(x1-x4)=(y1-y)/(y1-y4)},{x,y});	
                                     x2=((CMyPoint*)ptempObj1)->m_startpoint.x;
								     y2=((CMyPoint*)ptempObj1)->m_startpoint.y;
								     x1=((CMyPoint*)ptempObj3)->m_startpoint.x;
								     y1=((CMyPoint*)ptempObj3)->m_startpoint.y;
							         x4=((CMyPoint*)ptempObj4)->m_startpoint.x;
								     y4=((CMyPoint*)ptempObj4)->m_startpoint.y;
									////////////////////////////////////////MODIFY/////////////////////////////////////
									 double dsqrt;
									 dsqrt=(4*x1*x4*x4*x4*y1*y4
										-8*x1*x4*x4*x2*y1*y4+4*x1*x4*x2*x2*y1*y4-8*x1*x4*y2*y4*y4*y1+4*x1*x4*y2*y4*y1*y1
										+4*x1*x4*y2*y2*y1*y4+4*x1*x4*y2*y4*y4*y4-2*x1*x4*x2*x2*y4*y4-2*x1*x4*y2*y2*y1*y1
										-2*x1*x4*y2*y2*y4*y4-12*y1*y1*y4*y4*x2*x4+8*y1*y4*y4*y4*x2*x4+8*y1*y1*y1*y4*x2*x4
										-2*x1*x1*y2*y4*y1*y1-2*x1*x1*x2*x4*y4*y4-2*x1*x1*x2*x2*y1*y4+4*x1*x1*y2*y4*y4*y1
										-2*x1*x1*y2*y2*y1*y4-2*x1*x1*x2*x4*y1*y1-2*x1*x1*y1*x4*x4*y4-2*x4*x4*y2*y4*y1*y1
										+4*x4*x4*x4*x2*y1*y4+6*y1*y1*y4*y4*y2*y2+8*y1*y4*y4*y4*y4*y2-4*y1*y4*y4*y4*x2*x2
										-4*y1*y1*y1*y4*y2*y2-4*y1*y4*y4*y4*y2*y2+x1*x1*y1*y1*x4*x4+x1*x1*x2*x2*y1*y1
										-2*x1*x1*y2*y4*y4*y4+x1*x1*x2*x2*y4*y4+x1*x1*y2*y2*y1*y1+x1*x1*y2*y2*y4*y4
										-2*x4*x4*x4*x2*y4*y4+x4*x4*x2*x2*y1*y1-2*x4*x4*x4*x2*y1*y1-2*x4*x4*x4*x4*y1*y4
										-2*x4*x4*y2*y4*y4*y4+x4*x4*x2*x2*y4*y4+x4*x4*y2*y2*y1*y1+x4*x4*y2*y2*y4*y4
										-2*y1*y1*y1*y1*y2*y4-2*y1*y1*y1*y1*x2*x4+6*y4*y4*y4*y4*y1*y1-4*y4*y4*y4*y4*y4*y1
										-4*y4*y4*y4*y1*y1*y1+x1*x1*y4*y4*y4*y4+2*y4*y4*y4*y4*x4*x4+x4*x4*x4*x4*y4*y4
										+y4*y4*y1*y1*y1*y1+x4*x4*x4*x4*y1*y1+y1*y1*y1*y1*x4*x4+y1*y1*y1*y1*x2*x2
										+y1*y4*y4*y4*y2*y2-2*y4*y4*y4*y4*y4*y2+y4*y4*y4*y4*x2*x2+y4*y4*y4*y4*y2*y2
										+4*x1*y4*y4*y4*x4*y1-2*x1*y4*y4*x4*y1*y1+4*x1*x4*x4*x2*y4*y4-2*x1*x4*x2*x2*y1*y1
										+4*x1*x4*x4*x2*y1*y1+x1*x1*y4*y4*x4*x4-2*x1*y4*y4*x4-2*x1*y4*y4*x4*x4*x4
										-2*y4*y4*y4*y1*x1*x1-6*y4*y4*y4*y1*x4*x4+x1*x1*y4*y4*y1*y1+7*x4*x4*y4*y4*y1*y1
										-2*x1*x4*x4*x4*y1*y1-4*y1*y1*y1*y4*x4*x4+8*y1*y1*y1*y4*y4*y2+6*y1*y1*y4*y4*x2*x2
										-12*y1*y1*y4*y4*y4*y2-4*y1*y1*y1*y4*x2*x2+y4*y4*y4*y4*y4*y4-2*y4*y4*y4*y4*x2*x4
										+4*x1*x1*x2*x4*y1*y4-2*x4*x4*x2*x2*y1*y4-2*x4*x4*y2*y2*y1*y4+4*x4*x4*y2*y4*y4*y1);
									 /////////////////////////////////////////////////////////////////////////////////////
									 if(dsqrt>=0)
									 {
										 ((CMyPoint*)pObj)->bSqrt=0;
								         r1=0.5/(-2*x1*x4-2*y1*y4+x1*x1+x4*x4+y1*y1+y4*y4)*(-4*x1*y4*x4-4*y4*y4*y1
										    +2*x1*x1*y4+2*y4*y4*y4+2*x4*x4*y4+2*y4*y1*y1+2*sqrt(dsqrt));
									     r2=0.5/(-2*x1*x4-2*y1*y4+x1*x1+x4*x4+y1*y1+y4*y4)*(-4*x1*y4*x4-4*y4*y4*y1
										    +2*x1*x1*y4+2*y4*y4*y4+2*x4*x4*y4+2*y4*y1*y1-2*sqrt(dsqrt));
										ya=r1;
										yb=r2;
										xa=-(-x1*y4+y1*x4+ya*x1-ya*x4)/(-y1+y4);
										xb=-(-x1*y4+y1*x4+yb*x1-yb*x4)/(-y1+y4);
										if((xa-x1)*(xa-x1)+(ya-y1)*(ya-y1)>(xb-x1)*(xb-x1)+(yb-y1)*(yb-y1))
										{
											if(xb>2000||xb<-2000||yb>2000||yb<-2000)
											{}
											else
											{
												((CMyPoint*)pObj)->m_startpoint.x=xb;
												((CMyPoint*)pObj)->m_startpoint.y=yb;
											}
										}
										else
										{
											if(xa>2000||xa<-2000||ya>2000||ya<-2000)
											{}
											else
											{
											   ((CMyPoint*)pObj)->m_startpoint.x=xa;
											   ((CMyPoint*)pObj)->m_startpoint.y=ya;
											}
										}
									 }
									 else
									 {
									      ((CMyPoint*)pObj)->bSqrt=1;
									 }
								}
								else
								{
								 
								}
							}
							break;
						case PPPP_ORTHO:
							{
							    ///the first step,get the other three points;
								CDrawObj *ptempObj1,*ptempObj2,*ptempObj3,*ptempObj4;
								pos1=rel1->pObjList.GetHeadPosition();
							    while(pos1!=NULL)
								{
							         ptempObj1=rel1->pObjList.GetNext(pos1);
									 ptempObj2=rel1->pObjList.GetNext(pos1);
									 ptempObj3=rel1->pObjList.GetNext(pos1);
									 ptempObj4=rel1->pObjList.GetNext(pos1);							         
								}		
							/////////the second step,compute the last point;/////////////////////////
								double x1,y1,x2,y2,x3,y3,x0,y0,x,y;
								x1=((CMyPoint*)ptempObj1)->m_startpoint.x;
								y1=((CMyPoint*)ptempObj1)->m_startpoint.y;
								x2=((CMyPoint*)ptempObj2)->m_startpoint.x;
								y2=((CMyPoint*)ptempObj2)->m_startpoint.y;
								x3=((CMyPoint*)ptempObj3)->m_startpoint.x;
								y3=((CMyPoint*)ptempObj3)->m_startpoint.y;
							    x0=((CMyPoint*)ptempObj4)->m_startpoint.x;
								y0=((CMyPoint*)ptempObj4)->m_startpoint.y;
							    /////////the second step,compute the last point;/////////////////////////                               
								///ĸġ
							/////////the second step,compute the last point;/////////////////////////
                                if(pObj==ptempObj4)
								{
								    x=(-x1*x2*y1-x3*x1*y3+x1*x3*y1+x1*y2*x2+y1*y1*y3-y1*y3*y3+x2*x3*y3
				                       -x2*x3*y2-y1*y1*y2+y1*y2*y2+y2*y3*y3-y2*y2*y3)/(-x1*y3-x2*y1+x2*y3+x1*y2+x3*y1-x3*y2);
				                    y=-(x3*x1*x1+x2*y2*y1-x1*y2*y1+x1*y1*y3-x1*x3*x3-x2*x1*x1+x3*y2*y3-x3*y1*y3+x1*x2*x2
					                   -x3*x2*x2+x2*x3*x3-x2*y2*y3)/(-x1*y3-x2*y1+x2*y3+x1*y2+x3*y1-x3*y2);
									if(x>2000||x<-2000||y>2000||y<-2000)
									{}
									else
									{
								        ((CMyPoint*)pObj)->m_startpoint.x=x;
								        ((CMyPoint*)pObj)->m_startpoint.y=y;
									}
								}
								else if(pObj==ptempObj1)
								{
								    x=(y0*y0*y2-y0*y0*y3+y0*x0*x2-y0*x0*x3-y3*x2*x3+y0*y3*y3-y0*y2*y2-y2*x0*x2+y3*x0*x3
									  +y2*y2*y3+y2*x2*x3-y2*y3*y3)/(-y0*x3-y2*x0+y2*x3+y0*x2+y3*x0-y3*x2);
								    y=-(y0*y3*x3-y2*y0*x2+y0*y2*x0-y0*y3*x0+x0*x3*x3-x2*x3*x3+y2*y3*x2+x2*x2*x3-x0*x2*x2
									  -x0*x0*x3+x0*x0*x2-y2*y3*x3)/(-y0*x3-y2*x0+y2*x3+y0*x2+y3*x0-y3*x2);
								    if(x>2000||x<-2000||y>2000||y<-2000)
									{}
									else
									{
								        ((CMyPoint*)pObj)->m_startpoint.x=x;
								        ((CMyPoint*)pObj)->m_startpoint.y=y;
									}
								}
								else if(pObj==ptempObj2)
								{
								    x=(-y0*y1*y1+y1*y1*y3+y0*y3*y3-y1*x0*x1+y3*x0*x3+y1*x1*x3-y1*y3*y3-y3*x1*x3+y0*y0*y1
										-y0*y0*y3+y0*x0*x1-y0*x0*x3)/(-y1*x0+y3*x0-y3*x1+y0*x1-y0*x3+y1*x3);
								    y=-(-y3*y1*x3-y1*y0*x1+y1*y3*x1+y1*y0*x0+x1*x1*x3-x0*x0*x3-x0*x1*x1+x0*x3*x3-x1*x3*x3
										+x0*x0*x1-y0*y3*x0+y0*y3*x3)/(-y1*x0+y3*x0-y3*x1+y0*x1-y0*x3+y1*x3);
									if(x>2000||x<-2000||y>2000||y<-2000)
									{}
									else
									{
								        ((CMyPoint*)pObj)->m_startpoint.x=x;
								        ((CMyPoint*)pObj)->m_startpoint.y=y;
									}
								}
								else if(pObj==ptempObj3)
								{
								    x=(-y0*y0*y2-y0*x0*x2+y2*y1*y1+y0*y2*y2-y2*y2*y1+y2*x0*x2-y2*x2*x1-y0*y1*y1+y0*y0*y1
										+y0*x0*x1-y1*x0*x1+y1*x2*x1)/(-y0*x2+y0*x1-y2*x1+y2*x0-y1*x0+y1*x2);
								    y=-(y1*y0*x0-y0*y2*x0-y1*y0*x1+y2*y0*x2-x0*x1*x1+y1*y2*x1+x2*x1*x1+x0*x0*x1+x0*x2*x2
										-x2*x2*x1-x0*x0*x2-y1*y2*x2)/(-y0*x2+y0*x1-y2*x1+y2*x0-y1*x0+y1*x2);
									if(x>2000||x<-2000||y>2000||y<-2000)
									{}
									else
									{
								        ((CMyPoint*)pObj)->m_startpoint.x=x;
								        ((CMyPoint*)pObj)->m_startpoint.y=y;
									}
								}
								else
								{}
							}
							break;
						case PPPP_INCEN:
							{
							    ///the first step,get the other three points;
								CDrawObj *ptempObj1,*ptempObj2,*ptempObj3,*ptempObj4;
								pos1=rel1->pObjList.GetHeadPosition();
							    while(pos1!=NULL)
								{
							         ptempObj1=rel1->pObjList.GetNext(pos1);
									 ptempObj2=rel1->pObjList.GetNext(pos1);
									 ptempObj3=rel1->pObjList.GetNext(pos1);
									 ptempObj4=rel1->pObjList.GetNext(pos1);							         
								}		
							/////////the second step,compute the last point;/////////////////////////
								double x1,y1,x2,y2,x3,y3,x0,y0,x,y;
								x1=((CMyPoint*)ptempObj1)->m_startpoint.x;
								y1=((CMyPoint*)ptempObj1)->m_startpoint.y;
								x2=((CMyPoint*)ptempObj2)->m_startpoint.x;
								y2=((CMyPoint*)ptempObj2)->m_startpoint.y;
								x3=((CMyPoint*)ptempObj3)->m_startpoint.x;
								y3=((CMyPoint*)ptempObj3)->m_startpoint.y;
							    x0=((CMyPoint*)ptempObj4)->m_startpoint.x;
								y0=((CMyPoint*)ptempObj4)->m_startpoint.y;
							    /////////the second step,compute the last point;/////////////////////////                               
								///ĸġ
						        if(pObj==ptempObj4)
								{
									 y=-0.5*(sqrt(x1*x1-2*x1*x2+x2*x2+y1*y1-2*y1*y2+y2*y2)
									   *sqrt(x1*x1-2*x1*x3+x3*x3+y1*y1-2*y1*y3+y3*y3)*x3-sqrt(x1*x1-2*x1*x2+x2*x2+y1*y1-2*y1*y2+y2*y2)
									   *sqrt(x1*x1-2*x1*x3+x3*x3+y1*y1-2*y1*y3+y3*y3)*x2-x3*sqrt(x1*x1-2*x1*x2+x2*x2+y1*y1-2*y1*y2+y2*y2)
									   *sqrt(x2*x2-2*x2*x3+x3*x3+y2*y2-2*y2*y3+y3*y3)+x1*sqrt(x1*x1-2*x1*x2+x2*x2+y1*y1-2*y1*y2+y2*y2)
									   *sqrt(x2*x2-2*x2*x3+x3*x3+y2*y2-2*y2*y3+y3*y3)-x1*sqrt(x1*x1-2*x1*x3+x3*x3+y1*y1-2*y1*y3+y3*y3)
									   *sqrt(x2*x2-2*x2*x3+x3*x3+y2*y2-2*y2*y3+y3*y3)+sqrt(x1*x1-2*x1*x3+x3*x3+y1*y1-2*y1*y3+y3*y3)
									   *sqrt(x2*x2-2*x2*x3+x3*x3+y2*y2-2*y2*y3+y3*y3)*x2-x1*x2*x2+x1*x3*x3-x1*y2*y2+x1*y3*y3+x3*y2*y2+x3*x2*x2
									   -x1*x1*x3+x1*x1*x2-x3*x3*x2-y3*y3*x2-y1*y1*x3+y1*y1*x2)/(y1*x3-y1*x2-x3*y2-x1*y3+x1*y2+y3*x2);
									x=0.5*(y3*x2*x2-y1*x2*x2+sqrt(x1*x1-2*x1*x2+x2*x2+y1*y1-2*y1*y2+y2*y2)
									   *sqrt(x2*x2-2*x2*x3+x3*x3+y2*y2-2*y2*y3+y3*y3)*y1+y1*x3*x3-y2*y3*y3-x3*x3*y2
									   -y3*y1*y1+y2*y1*y1+y3*y3*y1-y3*x1*x1+y2*y2*y3-sqrt(x1*x1-2*x1*x3+x3*x3+y1*y1-2*y1*y3+y3*y3)
									   *sqrt(x2*x2-2*x2*x3+x3*x3+y2*y2-2*y2*y3+y3*y3)*y1-sqrt(x1*x1-2*x1*x2+x2*x2+y1*y1-2*y1*y2+y2*y2)
									   *sqrt(x2*x2-2*x2*x3+x3*x3+y2*y2-2*y2*y3+y3*y3)*y3+y3*sqrt(x1*x1-2*x1*x2+x2*x2+y1*y1-2*y1*y2+y2*y2)
									   *sqrt(x1*x1-2*x1*x3+x3*x3+y1*y1-2*y1*y3+y3*y3)+y2*x1*x1-y2*sqrt(x1*x1-2*x1*x2+x2*x2+y1*y1-2*y1*y2+y2*y2)
									   *sqrt(x1*x1-2*x1*x3+x3*x3+y1*y1-2*y1*y3+y3*y3)-y2*y2*y1+y2*sqrt(x1*x1-2*x1*x3+x3*x3+y1*y1-2*y1*y3+y3*y3)
									   *sqrt(x2*x2-2*x2*x3+x3*x3+y2*y2-2*y2*y3+y3*y3))/(y1*x3-y1*x2-x3*y2-x1*y3+x1*y2+y3*x2);
									if(x>2000||x<-2000||y>2000||y<-2000)
									{}
									else
									{
								        ((CMyPoint*)pObj)->m_startpoint.x=x;
								        ((CMyPoint*)pObj)->m_startpoint.y=y;
									}
								}
								else if(pObj==ptempObj1)
								{
								    x=(x0*x2*x2-x2*y3*y0-x2*y3*y2+x2*y2*y0+x2*y3*y3-2*x3*x0*x2+y2*y2*x3-y2*y0*x3+y3*y0*x3+x0*x3*x3
										-x3*y3*y2)/(x2*x2-2*x2*x3+x3*x3+y2*y2-2*y2*y3+y3*y3);
									y=(-2*y0*y2*y3+y0*y3*y3+y0*y2*y2+x2*x2*y3-y3*x2*x0-x3*x2*y2+x2*x0*y2-x3*x2*y3+x3*x0*y3+y2*x3*x3
										-x3*x0*y2)/(x2*x2-2*x2*x3+x3*x3+y2*y2-2*y2*y3+y3*y3);
									if(x>2000||x<-2000||y>2000||y<-2000)
									{}
									else
									{
								        ((CMyPoint*)pObj)->m_startpoint.x=x;
								        ((CMyPoint*)pObj)->m_startpoint.y=y;
									}
								}
								else if(pObj==ptempObj2)
								{
									x=(x0*x1*x1+x1*y3*y3+x1*y1*y0-x1*y1*y3-2*x1*x3*x0-x1*y3*y0-y1*y0*x3+y1*y1*x3+y3*y0*x3+x0*x3*x3
										-x3*y1*y3)/(x1*x1-2*x1*x3+x3*x3+y1*y1-2*y1*y3+y3*y3);
									y=(y0*y1*y1+y0*y3*y3-2*y0*y1*y3+y3*x1*x1-x1*y3*x0+x1*y1*x0-y3*x1*x3-y1*x1*x3-y1*x3*x0+y1*x3*x3
										+x3*x0*y3)/(x1*x1-2*x1*x3+x3*x3+y1*y1-2*y1*y3+y3*y3);
								    if(x>2000||x<-2000||y>2000||y<-2000)
									{}
									else
									{
								        ((CMyPoint*)pObj)->m_startpoint.x=x;
								        ((CMyPoint*)pObj)->m_startpoint.y=y;
									}
								}
								else if(pObj==ptempObj3)
								{
								    if(x>2000||x<-2000||y>2000||y<-2000)
									{}
									else
									{
								        ((CMyPoint*)pObj)->m_startpoint.x=x;
								        ((CMyPoint*)pObj)->m_startpoint.y=y;
									}
								}
							}
							break;
						case PPPP_VERTEX:
							{
							    ///the first step,get the other three points;
								  CDrawObj *ptempObj,*ptempObj1,*ptempObj2,*ptempObj3;
								  int icount(0);
						          pos1=rel1->pObjList.GetHeadPosition();
							      while(pos1!=NULL)
								  {
							         ptempObj=rel1->pObjList.GetNext(pos1);
							         if((ptempObj!=pObj)&&(ptempObj->type==G_POINT))
									 {
										 switch (icount)
										 {
										 case 0:
											 {
											     ptempObj1=ptempObj;
											     icount++;
											 }
											 break;
										 case 1:
											 {
											     ptempObj2=ptempObj;
											     icount++;
											 }
											 break;
										 case 2:
											 {
											     ptempObj3=ptempObj;
											     icount++;
											 }
											 break;
										 }										
									 }
								  }		
							/////////the second step,compute the last point;/////////////////////////
                                 double x1,y1,x2,y2,x3,y3,x,y;
								 x1=((CMyPoint*)ptempObj1)->m_startpoint.x;
								 y1=((CMyPoint*)ptempObj1)->m_startpoint.y;
								 x2=((CMyPoint*)ptempObj2)->m_startpoint.x;
								 y2=((CMyPoint*)ptempObj2)->m_startpoint.y;
								 x3=((CMyPoint*)ptempObj3)->m_startpoint.x;
								 y3=((CMyPoint*)ptempObj3)->m_startpoint.y;
								 y=-0.5*(sqrt(x1*x1-2*x1*x2+x2*x2+y1*y1-2*y1*y2+y2*y2)
								   *sqrt(x1*x1-2*x1*x3+x3*x3+y1*y1-2*y1*y3+y3*y3)*x3-sqrt(x1*x1-2*x1*x2+x2*x2+y1*y1-2*y1*y2+y2*y2)
								   *sqrt(x1*x1-2*x1*x3+x3*x3+y1*y1-2*y1*y3+y3*y3)*x2-x3*sqrt(x1*x1-2*x1*x2+x2*x2+y1*y1-2*y1*y2+y2*y2)
								   *sqrt(x2*x2-2*x2*x3+x3*x3+y2*y2-2*y2*y3+y3*y3)+x1*sqrt(x1*x1-2*x1*x2+x2*x2+y1*y1-2*y1*y2+y2*y2)
								   *sqrt(x2*x2-2*x2*x3+x3*x3+y2*y2-2*y2*y3+y3*y3)-x1*sqrt(x1*x1-2*x1*x3+x3*x3+y1*y1-2*y1*y3+y3*y3)
								   *sqrt(x2*x2-2*x2*x3+x3*x3+y2*y2-2*y2*y3+y3*y3)+sqrt(x1*x1-2*x1*x3+x3*x3+y1*y1-2*y1*y3+y3*y3)
								   *sqrt(x2*x2-2*x2*x3+x3*x3+y2*y2-2*y2*y3+y3*y3)*x2-x1*x2*x2+x1*x3*x3-x1*y2*y2+x1*y3*y3+x3*y2*y2+x3*x2*x2
								   -x1*x1*x3+x1*x1*x2-x3*x3*x2-y3*y3*x2-y1*y1*x3+y1*y1*x2)/(y1*x3-y1*x2-x3*y2-x1*y3+x1*y2+y3*x2);
								 x=0.5*(y3*x2*x2-y1*x2*x2+sqrt(x1*x1-2*x1*x2+x2*x2+y1*y1-2*y1*y2+y2*y2)
								   *sqrt(x2*x2-2*x2*x3+x3*x3+y2*y2-2*y2*y3+y3*y3)*y1+y1*x3*x3-y2*y3*y3-x3*x3*y2
								   -y3*y1*y1+y2*y1*y1+y3*y3*y1-y3*x1*x1+y2*y2*y3-sqrt(x1*x1-2*x1*x3+x3*x3+y1*y1-2*y1*y3+y3*y3)
								   *sqrt(x2*x2-2*x2*x3+x3*x3+y2*y2-2*y2*y3+y3*y3)*y1-sqrt(x1*x1-2*x1*x2+x2*x2+y1*y1-2*y1*y2+y2*y2)
								   *sqrt(x2*x2-2*x2*x3+x3*x3+y2*y2-2*y2*y3+y3*y3)*y3+y3*sqrt(x1*x1-2*x1*x2+x2*x2+y1*y1-2*y1*y2+y2*y2)
								   *sqrt(x1*x1-2*x1*x3+x3*x3+y1*y1-2*y1*y3+y3*y3)+y2*x1*x1-y2*sqrt(x1*x1-2*x1*x2+x2*x2+y1*y1-2*y1*y2+y2*y2)
								   *sqrt(x1*x1-2*x1*x3+x3*x3+y1*y1-2*y1*y3+y3*y3)-y2*y2*y1+y2*sqrt(x1*x1-2*x1*x3+x3*x3+y1*y1-2*y1*y3+y3*y3)
								   *sqrt(x2*x2-2*x2*x3+x3*x3+y2*y2-2*y2*y3+y3*y3))/(y1*x3-y1*x2-x3*y2-x1*y3+x1*y2+y3*x2);
								((CMyPoint*)pObj)->m_startpoint.x=x;
								((CMyPoint*)pObj)->m_startpoint.y=y;
							}
							break;
					    case SS_DIS:///˴ȷ;
						{						    
							///the first step,get the other points;
							if(rel1->pObjList.GetCount()==4)
							{
								pos1=rel1->pObjList.GetHeadPosition();
								while(pos1!=NULL)
								{
								   ptempObj=rel1->pObjList.GetNext(pos1);
								   ptempObj1=rel1->pObjList.GetNext(pos1);
								   ptempObj2=rel1->pObjList.GetNext(pos1);
								   ptempObj3=rel1->pObjList.GetNext(pos1);
								}							
								///the second step,compute the point's x and y coordinate;
								if(pObj->m_listindex==ptempObj->m_listindex)
								{
									 double dDis,dDistance,dCount,dx1,dy1,dx2,dy2;
									 dCount=rel1->N_dis_clamp;
									 dx1=((CMyPoint*)ptempObj2)->m_startpoint.x;
									 dy1=((CMyPoint*)ptempObj2)->m_startpoint.y;
									 dx2=((CMyPoint*)ptempObj3)->m_startpoint.x;
									 dy2=((CMyPoint*)ptempObj3)->m_startpoint.y;
									 dDis=sqrt((dx1-dx2)*(dx1-dx2)+(dy1-dy2)*(dy1-dy2));
									 dDistance=dDis*dCount;///õȡ
									 CPoint2 temp_direction=((CMyPoint*)ptempObj)->m_startpoint
															  -((CMyPoint*)ptempObj1)->m_startpoint;
									 double len=dDistance;
									 ((CMyPoint*)ptempObj)->m_startpoint
										=((CMyPoint*)ptempObj1)->m_startpoint.getPoint(temp_direction,len);
									
								}
								else if(pObj->m_listindex==ptempObj1->m_listindex)
								{
									 double dDis,dDistance,dCount,dx1,dy1,dx2,dy2;
									 dCount=rel1->N_dis_clamp;
									 dx1=((CMyPoint*)ptempObj2)->m_startpoint.x;
									 dy1=((CMyPoint*)ptempObj2)->m_startpoint.y;
									 dx2=((CMyPoint*)ptempObj3)->m_startpoint.x;
									 dy2=((CMyPoint*)ptempObj3)->m_startpoint.y;
									 dDis=sqrt((dx1-dx2)*(dx1-dx2)+(dy1-dy2)*(dy1-dy2));
									 dDistance=dDis*dCount;///õȡ
									 CPoint2 temp_direction=((CMyPoint*)ptempObj1)->m_startpoint
															  -((CMyPoint*)ptempObj)->m_startpoint;
									 double len=dDistance;
									 ((CMyPoint*)ptempObj1)->m_startpoint
										=((CMyPoint*)ptempObj)->m_startpoint.getPoint(temp_direction,len);
								}
								else if(pObj->m_listindex==ptempObj2->m_listindex)
								{
									 double dDis,dDistance,dCount,dx1,dy1,dx2,dy2;
									 dCount=rel1->N_dis_clamp;
									 dx1=((CMyPoint*)ptempObj)->m_startpoint.x;
									 dy1=((CMyPoint*)ptempObj)->m_startpoint.y;
									 dx2=((CMyPoint*)ptempObj1)->m_startpoint.x;
									 dy2=((CMyPoint*)ptempObj1)->m_startpoint.y;
									 dDis=sqrt((dx1-dx2)*(dx1-dx2)+(dy1-dy2)*(dy1-dy2));
									 dDistance=(dDis/dCount);///õȡ
									 CPoint2 temp_direction=((CMyPoint*)ptempObj2)->m_startpoint
															  -((CMyPoint*)ptempObj3)->m_startpoint;
									 double len=dDistance;
									 ((CMyPoint*)ptempObj2)->m_startpoint
										=((CMyPoint*)ptempObj3)->m_startpoint.getPoint(temp_direction,len);
								}
								else if(pObj->m_listindex==ptempObj3->m_listindex)
								{
									 double dDis,dDistance,dCount,dx1,dy1,dx2,dy2;
									 dCount=rel1->N_dis_clamp;
									 dx1=((CMyPoint*)ptempObj)->m_startpoint.x;
									 dy1=((CMyPoint*)ptempObj)->m_startpoint.y;
									 dx2=((CMyPoint*)ptempObj1)->m_startpoint.x;
									 dy2=((CMyPoint*)ptempObj1)->m_startpoint.y;
									 dDis=sqrt((dx1-dx2)*(dx1-dx2)+(dy1-dy2)*(dy1-dy2));
									 dDistance=dDis/dCount;///õȡ
									 CPoint2 temp_direction=((CMyPoint*)ptempObj3)->m_startpoint
															  -((CMyPoint*)ptempObj2)->m_startpoint;
									 double len=dDistance;
									 ((CMyPoint*)ptempObj3)->m_startpoint
										=((CMyPoint*)ptempObj2)->m_startpoint.getPoint(temp_direction,len);
								}
							}
							
							//////////Add by qlin end in 9/10///////////////////////
						}
						break;
						case PPP_MID:
						{
						    if(rel1->pObjList.GetCount()==3)
							{
                                pos1=rel1->pObjList.GetHeadPosition();
								while(pos1!=NULL)
								{
								   ptempObj=rel1->pObjList.GetNext(pos1);
								   ptempObj1=rel1->pObjList.GetNext(pos1);
								   ptempObj2=rel1->pObjList.GetNext(pos1);								  
								}							
								///the second step,compute the point's x and y coordinate;
								if(pObj->m_listindex==ptempObj1->m_listindex)
								{
									 double dx1,dy1,dx2,dy2;
									 dx1=((CMyPoint*)ptempObj)->m_startpoint.x;
									 dy1=((CMyPoint*)ptempObj)->m_startpoint.y;
									 dx2=((CMyPoint*)ptempObj2)->m_startpoint.x;
									 dy2=((CMyPoint*)ptempObj2)->m_startpoint.y;									 
									 ((CMyPoint*)pObj)->m_startpoint.x=(dx1+dx2)/2;
                                     ((CMyPoint*)pObj)->m_startpoint.y=(dy1+dy2)/2;
								} 
								else if(pObj->m_listindex==ptempObj->m_listindex)
								{
								     double dx1,dy1,dx2,dy2;
									 dx1=((CMyPoint*)ptempObj1)->m_startpoint.x;
									 dy1=((CMyPoint*)ptempObj1)->m_startpoint.y;
									 dx2=((CMyPoint*)ptempObj2)->m_startpoint.x;
									 dy2=((CMyPoint*)ptempObj2)->m_startpoint.y;									 
									 ((CMyPoint*)pObj)->m_startpoint.x=(2*dx1-dx2);
                                     ((CMyPoint*)pObj)->m_startpoint.y=(2*dy1-dy2);
								}
								else if(pObj->m_listindex==ptempObj2->m_listindex)
								{
								     double dx1,dy1,dx2,dy2;
									 dx1=((CMyPoint*)ptempObj)->m_startpoint.x;
									 dy1=((CMyPoint*)ptempObj)->m_startpoint.y;
									 dx2=((CMyPoint*)ptempObj1)->m_startpoint.x;
									 dy2=((CMyPoint*)ptempObj1)->m_startpoint.y;									 
									 ((CMyPoint*)pObj)->m_startpoint.x=(2*dx2-dx1);
                                     ((CMyPoint*)pObj)->m_startpoint.y=(2*dy2-dy1);
								}
							}
						}
							break;
						/////////////////////////////////////
					}
					break;
				case 2://ֱߣһһ߾					
                    switch(rel1->Nconstraintype)
					{
					case PL_DIS:///оԼ
						{
						    ///the first step,get the other points;
						    pos1=rel1->pObjList.GetHeadPosition();
							while(pos1!=NULL)
							{
							   ptempObj=rel1->pObjList.GetNext(pos1);
							   if((ptempObj!=pObj)&&(ptempObj->type==G_POINT))
							   {
								   ptempObj1=ptempObj;
								   break;
							   }
						   }					
						   /////the second step,compute the point;							
							if(ptempObj1->type==G_POINT)
							{
							    CPoint2 * footpoint
								=Intersection_Paral_Verti(((CMyLine*)pObj)->my_startpoint,(CMyLine*)pObj,
									                      (CMyPoint*)ptempObj1,(CMyLine*)pObj,6);
								CPoint2 temp=(*footpoint)-((CMyPoint*)ptempObj1)->m_startpoint;
						        double len=rel1->N_dis_clamp;
								temp=len*temp.Unit()+((CMyPoint*)ptempObj1)->m_startpoint;
								((CMyLine*)pObj)->computeABC(temp);
							}							
						}
						break;					
					case LL_PARA://
                        {
							///the first step,get the other points;
						    pos1=rel1->pObjList.GetHeadPosition();
							while(pos1!=NULL)
							{
							   ptempObj=rel1->pObjList.GetNext(pos1);
							   if((ptempObj!=pObj)&&(ptempObj->type==G_LINE))
							   {
								   ptempObj1=ptempObj;
								   break;
							   }
						   }					
						   /////the second step,compute the point;	
							if(ptempObj1->type==G_LINE)
							{
								double a,b;
							    CPoint2 point_temp;
							    a=((CMyLine*)ptempObj1)->ABC[0];
							    b=((CMyLine*)ptempObj1)->ABC[1];
							    point_temp=((CMyLine*)pObj)->my_startpoint->m_startpoint;
							    ((CMyLine*)pObj)->computeABC(a,b,point_temp);
							}
						}
						break;
					case LL_PERP:
						{
						    ///the first step,get the other points;
						    pos1=rel1->pObjList.GetHeadPosition();
							while(pos1!=NULL)
							{
							   ptempObj=rel1->pObjList.GetNext(pos1);
							   if((ptempObj!=pObj)&&(ptempObj->type==G_LINE))
							   {
								   ptempObj1=ptempObj;
								   break;
							   }
						   }					
						   /////the second step,compute the point;							
							if(ptempObj1->type==G_LINE)
							{
								if(((CMyLine*)pObj)->my_startpoint->NFlag==1)
								{
									double a,b;
									CPoint2 point_temp;
									a=((CMyLine*)ptempObj1)->ABC[0];
									b=((CMyLine*)ptempObj1)->ABC[1];
									point_temp=((CMyLine*)pObj)->my_startpoint->m_startpoint;
									((CMyLine*)pObj)->computeABC(-b,a,point_temp);
								}
								else if(((CMyLine*)pObj)->my_endpoint->NFlag==1)
								{
									double a,b;
									CPoint2 point_temp;
									a=((CMyLine*)ptempObj1)->ABC[0];
									b=((CMyLine*)ptempObj1)->ABC[1];
									point_temp=((CMyLine*)pObj)->my_endpoint->m_startpoint;
									((CMyLine*)pObj)->computeABC(-b,a,point_temp);
								}
								else//ֱߵ㶼δ
								{
									double temp_distance1,temp_distance2;
									temp_distance1=getSquareDistance(((CMyLine*)pObj)->my_startpoint,
																	(CMyLine*)ptempObj1);
									temp_distance2=getSquareDistance(((CMyLine*)pObj)->my_endpoint,
																	(CMyLine*)ptempObj1);
									if(temp_distance1>=0 && temp_distance2>=0)
									{
										if(temp_distance1<=temp_distance2)
										{//ѡΪ㣬ֱ֪߽Ͻ
											double a,b;
											CPoint2 point_temp;
											a=((CMyLine*)ptempObj1)->ABC[0];
											b=((CMyLine*)ptempObj1)->ABC[1];
											point_temp=((CMyLine*)pObj)->my_startpoint->m_startpoint;
											((CMyLine*)pObj)->computeABC(-b,a,point_temp);
										}
										else
										{//ѡյΪ㣬ֱ֪߽Ͻ
											double a,b;
											CPoint2 point_temp;
											a=((CMyLine*)ptempObj1)->ABC[0];
											b=((CMyLine*)ptempObj1)->ABC[1];
											point_temp=((CMyLine*)pObj)->my_endpoint->m_startpoint;
											((CMyLine*)pObj)->computeABC(-b,a,point_temp);
										}
									}
									else
									{
									 ASSERT(FALSE);
									}
								}
							}
						}
						break;
					case LL_ANGLE:
						{
						    ///the first step,get the other points;
						    pos1=rel1->pObjList.GetHeadPosition();
							while(pos1!=NULL)
							{
							   ptempObj=rel1->pObjList.GetNext(pos1);
							   if((ptempObj!=pObj)&&(ptempObj->type==G_LINE))
							   {
								   ptempObj1=ptempObj;
								   break;
							   }
							}					
						    /////the second step,compute the point;
							if(ptempObj1->type==G_LINE)
							{
								double a,b;
							    CPoint2 point_temp;
							    a=((CMyLine*)ptempObj1)->ABC[0];
							    b=((CMyLine*)ptempObj1)->ABC[1];
							    ((CMyLine*)pObj)->ABC[0]=a*cos(rel1->N_dis_clamp)
								                    -b*sin(rel1->N_dis_clamp);
							    ((CMyLine*)pObj)->ABC[1]=a*sin(rel1->N_dis_clamp)
								                    +b*cos(rel1->N_dis_clamp);
							}
						}
						break;
					}
					break;
				case 3://Բ		///ǴԲԲĵĹϵԲȷȷԲ							
					{  
					    switch(rel1->Nconstraintype)
						{
					         case PC_CEN:
							 {
							      ///the first step,get the other points;
						          pos1=rel1->pObjList.GetHeadPosition();
							      while(pos1!=NULL)
								  {
							           ptempObj=rel1->pObjList.GetNext(pos1);
							           if((ptempObj!=pObj)&&(ptempObj->type==G_POINT))
									   {
								            ptempObj1=ptempObj;
								            break;
									   }
								  }	
								  ////the second step,compute;
                                  if(ptempObj1->type==G_POINT)
								  {
									  ((CMyCircle*)pObj)->ABC[0]=((CMyPoint*)ptempObj1)->m_startpoint.x;
									  ((CMyCircle*)pObj)->ABC[1]=((CMyPoint*)ptempObj1)->m_startpoint.y;
								  }
							 }
							 break;
							 case PC_DIS:
							 {
						          ///the first step,get the other points;
						          pos1=rel1->pObjList.GetHeadPosition();
							      while(pos1!=NULL)
								  {
							           ptempObj=rel1->pObjList.GetNext(pos1);
							           if((ptempObj!=pObj)&&(ptempObj->type==G_POINT))
									   {
								            ptempObj1=ptempObj;
								            break;
									   }
								  }	 
								  ///the second step,compute;
								  if(ptempObj1==((CMyCircle*)pObj)->my_endpoint)///drag the circle's my_endpoint;
								  {
									  double dx1,dy1,dx2,dy2,dr;
									  dx1=((CMyCircle*)pObj)->my_endpoint->m_startpoint.x;
									  dy1=((CMyCircle*)pObj)->my_endpoint->m_startpoint.y;
                                      dx2=((CMyCircle*)pObj)->ABC[0];
									  dy2=((CMyCircle*)pObj)->ABC[1];
									  dr=sqrt((dx1-dx2)*(dx1-dx2)+(dy1-dy2)*(dy1-dy2));
									  ((CMyCircle*)pObj)->ABC[2]=dr;
								  }
								  else///drag the point not equal the circle's my_endpoint;
								  {
								      double x1,y1,x2,y2,xa,ya,xb,yb,r,r1,r2;
									  r=((CMyCircle*)pObj)->ABC[2];
									  x1=((CMyCircle*)pObj)->ABC[0];
									  y1=((CMyCircle*)pObj)->ABC[1];
									  x2=((CMyPoint*)ptempObj1)->m_startpoint.x;
									  y2=((CMyPoint*)ptempObj1)->m_startpoint.y;  
									  r1=0.5/(-2*y1*y2-2*x1*x2+x1*x1+x2*x2+y1*y1+y2*y2)*(2*y2*y1*y1-4*y2*y2*y1
										  +2*x2*x2*y2+2*y2*y2*y2-4*x1*y2*x2+2*x1*x1*y2+2*sqrt(4*x1*x2*r*r*y1*y2
										  +x2*x2*r*r*y2*y2+x2*x2*r*r*y1*y1-2*x2*x2*r*r*y1*y2+y1*y1*y1*y1*r*r
										  +y2*y2*y2*y2*r*r+6*y1*y1*y2*y2*r*r-4*y1*y1*y1*y2*r*r-4*y1*y2*y2*y2*r*r
										  +x1*x1*r*r*y1*y1+x1*x1*r*r*y2*y2-2*x1*x2*r*r*y1*y1-2*x1*x2*r*r*y2*y2-2*x1*x1*r*r*y1*y2));
									  r2=0.5/(-2*y1*y2-2*x1*x2+x1*x1+x2*x2+y1*y1+y2*y2)*(2*y2*y1*y1-4*y2*y2*y1
										  +2*x2*x2*y2+2*y2*y2*y2-4*x1*y2*x2+2*x1*x1*y2-2*sqrt(4*x1*x2*r*r*y1*y2
										  +x2*x2*r*r*y2*y2+x2*x2*r*r*y1*y1-2*x2*x2*r*r*y1*y2+y1*y1*y1*y1*r*r
										  +y2*y2*y2*y2*r*r+6*y1*y1*y2*y2*r*r-4*y1*y1*y1*y2*r*r-4*y1*y2*y2*y2*r*r
										  +x1*x1*r*r*y1*y1+x1*x1*r*r*y2*y2-2*x1*x2*r*r*y1*y1-2*x1*x2*r*r*y2*y2-2*x1*x1*r*r*y1*y2));								  
									  ya=r1;
									  yb=r2;
									  xa=-(x1*y2-y1*x2-ya*x1+ya*x2)/(y1-y2);
									  xb=-(x1*y2-y1*x2-yb*x1+yb*x2)/(y1-y2);									  
									  if(((xa-x1)*(xa-x1)+(ya-y1)*(ya-y1))>((xb-x1)*(xb-x1)+(yb-y1)*(yb-y1)))
									  {
									     ((CMyCircle*)pObj)->ABC[0]=xb;
										 ((CMyCircle*)pObj)->ABC[1]=yb;
										 ((CMyCircle*)pObj)->my_startpoint->m_startpoint.x=xb;
										 ((CMyCircle*)pObj)->my_startpoint->m_startpoint.y=yb;
									  }
									  else
									  {
									     ((CMyCircle*)pObj)->ABC[0]=xa;
										 ((CMyCircle*)pObj)->ABC[1]=ya;
										 ((CMyCircle*)pObj)->my_startpoint->m_startpoint.x=xa;
										 ((CMyCircle*)pObj)->my_startpoint->m_startpoint.y=ya;
									  }									  
								  }
							 }
							 break;
						};
					}
					break;             
				}
			}
			break;
		case 2://relationΨһȷ
			{				
				pos1=temp_Nlink.GetHeadPosition();				
				rel1=temp_Nlink.GetNext(pos1);
				rel2=temp_Nlink.GetNext(pos1);
				double p1x,p1y,p2x,p2y,temp_a,temp_b,temp_c;
				switch(pObj->type)
				{
				    case 1://
					{
					  BOOL temp_bool1,temp_bool2,temp_bool3,temp_bool4,temp_bool5,temp_bool6;
					  BOOL temp_bool7,temp_bool8,temp_bool9,temp_bool10,temp_bool11;
					  temp_bool1=rel1->Nconstraintype==PP_DIS&&rel2->Nconstraintype==PP_DIS;///p=pp;
					  temp_bool2=rel1->Nconstraintype==PP_DIS&&rel2->Nconstraintype==PL_DIS;///p=pl;
					  temp_bool3=rel1->Nconstraintype==PL_DIS&&rel2->Nconstraintype==PP_DIS;///p=lP;
					  temp_bool4=rel1->Nconstraintype==PL_DIS&&rel2->Nconstraintype==PL_DIS;///p=ll;
					  temp_bool5=rel1->Nconstraintype==PL_DIS&&rel2->Nconstraintype==SS_DIS;///p=lppp;
					  temp_bool6=rel1->Nconstraintype==SS_DIS&&rel2->Nconstraintype==PL_DIS;///p=pppl;
					  temp_bool7=rel1->Nconstraintype==PL_DIS&&rel2->Nconstraintype==PC_DIS;///p=lc;
					  temp_bool8=rel1->Nconstraintype==PC_DIS&&rel2->Nconstraintype==PL_DIS;///p=cl;
					  temp_bool9=rel1->Nconstraintype==PC_DIS&&rel2->Nconstraintype==PC_DIS;///p=cc;
					  ///temp_bool10,11ҪһԲͬʱľɱĵ㣻
                      temp_bool10=rel1->Nconstraintype==PC_DIS&&rel2->Nconstraintype==SS_DIS;///p=cppp;
					  temp_bool11=rel1->Nconstraintype==SS_DIS&&rel2->Nconstraintype==PC_DIS;///p=pppc;
					  if(temp_bool1)
					  {
							///the first step,get the two points;
						   pos1=rel1->pObjList.GetHeadPosition();
						   while(pos1!=NULL)
						   {
							   ptempObj=rel1->pObjList.GetNext(pos1);
							   if((ptempObj!=pObj)&&(ptempObj->type==G_POINT))
							   {
								   ptempObj1=ptempObj;
								   break;
							   }
						   }
						   pos1=rel2->pObjList.GetHeadPosition();
						   while(pos1!=NULL)
						   {
							   ptempObj=rel2->pObjList.GetNext(pos1);
							   if((ptempObj!=pObj)&&(ptempObj->type==G_POINT))
							   {
								   ptempObj2=ptempObj;
								   break;
							   }
						   }
						   /////the second step,compute the point;
						   if((ptempObj1->type==G_POINT)&&(ptempObj2->type==G_POINT))
						   {
							   	///from qlin///
						        if(pObj->bMark==2)///
								{
								    	p1x=((CMyPoint*)ptempObj1)->x();
									    p1y=((CMyPoint*)ptempObj1)->y();
									    p2x=((CMyPoint*)ptempObj2)->x();
									    p2y=((CMyPoint*)ptempObj2)->y();
										
										temp_a=2*(p2x-p1x);
										temp_b=2*(p2y-p1y);
										temp_c=p1x*p1x-p2x*p2x+p1y*p1y-p2y*p2y
											  +rel2->N_dis_clamp*rel2->N_dis_clamp
											  -rel1->N_dis_clamp*rel1->N_dis_clamp;
										CPoint2* temp_intersection=new CPoint2();
										if(sol_qmin(temp_a,temp_b,temp_c,p1x,p1y,rel1->N_dis_clamp*rel1->N_dis_clamp,
											((CMyPoint*)pObj)->m_startpoint)!=NULL)
										{
											  temp_intersection=sol_qmin(temp_a,temp_b,temp_c,p1x,p1y,rel1->N_dis_clamp*rel1->N_dis_clamp,
											  ((CMyPoint*)pObj)->m_startpoint);
										}
										if(rel1->bSJudge==1)
										{
											p1x=((CMyPoint*)ptempObj1)->x();
											p1y=((CMyPoint*)ptempObj1)->y();
											p2x=((CMyPoint*)ptempObj2)->x();
											p2y=((CMyPoint*)ptempObj2)->y();
										}
										else
										{
											p2x=((CMyPoint*)ptempObj1)->x();
											p2y=((CMyPoint*)ptempObj1)->y();
											p1x=((CMyPoint*)ptempObj2)->x();
											p1y=((CMyPoint*)ptempObj2)->y();
										}
										if((p1x*p2y+p2x*intersection1.y+intersection1.x*p1y-p1y*p2x-p2y*intersection1.x-intersection1.y*p1x)>0)
										{
											 temp_intersection->x=intersection1.x;
											 temp_intersection->y=intersection1.y;
										}
										else
										{
											 temp_intersection->x=intersection2.x;
											 temp_intersection->y=intersection2.y;
										}
										if(temp_intersection!=NULL)
										{
											((CMyPoint*)pObj)->m_startpoint=(* temp_intersection);
										}
										else
										{
											AfxMessageBox("ཻ");
										}
								}
								else
								{
									p1x=((CMyPoint*)ptempObj1)->x();
									p1y=((CMyPoint*)ptempObj1)->y();
									p2x=((CMyPoint*)ptempObj2)->x();
									p2y=((CMyPoint*)ptempObj2)->y();
									temp_a=2*(p2x-p1x);
									temp_b=2*(p2y-p1y);
									temp_c=p1x*p1x-p2x*p2x+p1y*p1y-p2y*p2y
										  +rel2->N_dis_clamp*rel2->N_dis_clamp
										  -rel1->N_dis_clamp*rel1->N_dis_clamp;
									CPoint2* temp_intersection=
										sol_qmin(temp_a,temp_b,temp_c,p1x,p1y,
										rel1->N_dis_clamp*rel1->N_dis_clamp,
										((CMyPoint*)pObj)->m_startpoint);
									if(temp_intersection!=NULL)
									{
										((CMyPoint*)pObj)->m_startpoint=(* temp_intersection);
									}
									else
									{
										AfxMessageBox("ཻ");
									}
								}
						   }
					}
					else if(temp_bool2)//һpObj1pObj2ֱ߾
					{
						///the first step,get the point and the line;
							   pos1=rel1->pObjList.GetHeadPosition();
							   while(pos1!=NULL)
							   {
								   ptempObj=rel1->pObjList.GetNext(pos1);
								   if((ptempObj!=pObj)&&(ptempObj->type==G_POINT))
								   {
									   ptempObj1=ptempObj;
									   break;
								   }
							   }
							   pos1=rel2->pObjList.GetHeadPosition();
							   while(pos1!=NULL)
							   {
								   ptempObj=rel2->pObjList.GetNext(pos1);
								   if((ptempObj!=pObj)&&(ptempObj->type==G_LINE))
								   {
									   ptempObj2=ptempObj;
									   break;
								   }
							   }
							   //////////////////////////////////////////////
							   if((ptempObj1->type==G_POINT)&&(ptempObj2->type==G_LINE))
							   {
								   CMyLine temp_line;
								   CPoint2 temp_point2;
								   ////////////ֱ߾ΪԼĵtemp_point2/////////////////////////////////
								   int k=sol_lll(((CMyLine*)ptempObj2)->ABC[0],
										((CMyLine*)ptempObj2)->ABC[1],
										((CMyLine*)ptempObj2)->ABC[2],
										((CMyLine*)ptempObj2)->ABC[1],
									   -((CMyLine*)ptempObj2)->ABC[0],
										((CMyLine*)ptempObj2)->ABC[0]*((CMyPoint*)pObj)->y()
									   -((CMyLine*)ptempObj2)->ABC[1]*((CMyPoint*)pObj)->x());
								   if(k>0)
								   {
										CPoint2 temp_direction=((CMyPoint*)pObj)->m_startpoint
																	  -(*intersection);
										double len=rel2->N_dis_clamp;
										temp_point2
									   =intersection->getPoint(temp_direction,len);
								   }
								   else
								   {
									   ASSERT(FALSE);
								   }
								   /////////////////////////////////////////////
								   temp_line.computeABC(((CMyLine*)ptempObj2)->ABC[0],
												 ((CMyLine*)ptempObj2)->ABC[1],
												 temp_point2);
								   CPoint2* temp_intersection=
										 sol_qmin(temp_line.ABC[0],
										 temp_line.ABC[1],
										 temp_line.ABC[2],
										 ((CMyPoint*)ptempObj1)->x(),
										 ((CMyPoint*)ptempObj1)->y(),
										 rel1->N_dis_clamp
										*rel1->N_dis_clamp,
										 ((CMyPoint*)pObj)->m_startpoint);
								   if(temp_intersection!=NULL)
								   {
										((CMyPoint*)pObj)->m_startpoint=(*temp_intersection);
								   }
								   else
								   {
										AfxMessageBox("ཻ");
								   }
							 }
						}
						else if(temp_bool3)//һpObj2pObj1ֱ߾
						{
							///the first step,get the point and the line;
							   pos1=rel1->pObjList.GetHeadPosition();
							   while(pos1!=NULL)
							   {
								   ptempObj=rel1->pObjList.GetNext(pos1);
								   if((ptempObj!=pObj)&&(ptempObj->type==G_LINE))
								   {
									   ptempObj1=ptempObj;
									   break;
								   }
							   }
							   pos1=rel2->pObjList.GetHeadPosition();
							   while(pos1!=NULL)
							   {
								   ptempObj=rel2->pObjList.GetNext(pos1);
								   if((ptempObj!=pObj)&&(ptempObj->type==G_POINT))
								   {
									   ptempObj2=ptempObj;
									   break;
								   }
							   }
							   if((ptempObj1->type==G_LINE)&&(ptempObj2->type==G_POINT))
							   {
								   //////////////////////////////////////////////
									CMyLine temp_line;
									CPoint2 temp_point2;
									////////////ֱ߾ΪԼĵtemp_point2/////////////////////////////////
								   int k=sol_lll(((CMyLine*)ptempObj1)->ABC[0],
												((CMyLine*)ptempObj1)->ABC[1],
												((CMyLine*)ptempObj1)->ABC[2],
												((CMyLine*)ptempObj1)->ABC[1],
											   -((CMyLine*)ptempObj1)->ABC[0],
												((CMyLine*)ptempObj1)->ABC[0]*((CMyPoint*)pObj)->y()
											   -((CMyLine*)ptempObj1)->ABC[1]*((CMyPoint*)pObj)->x());
								   if(k>0)
								   {
										CPoint2 temp_direction=((CMyPoint*)pObj)->m_startpoint
																	  -(*intersection);
										double len=rel1->N_dis_clamp;
										temp_point2
									   =intersection->getPoint(temp_direction,len);
								   }
								   else
								   {
									   ASSERT(FALSE);
								   }
									/////////////////////////////////////////////
								temp_line.computeABC(((CMyLine*)ptempObj1)->ABC[0],
													 ((CMyLine*)ptempObj1)->ABC[1],
													 temp_point2);
								CPoint2* temp_intersection=
									sol_qmin(temp_line.ABC[0],
											 temp_line.ABC[1],
											 temp_line.ABC[2],
											 ((CMyPoint*)ptempObj2)->x(),
											 ((CMyPoint*)ptempObj2)->y(),
											 rel2->N_dis_clamp
											*rel2->N_dis_clamp,
											 ((CMyPoint*)pObj)->m_startpoint);
								((CMyPoint*)pObj)->m_startpoint=(*temp_intersection);
							   }
						}
						else if(temp_bool4)//һֱ߾
						{
							///the first step,get the point and the line;
						   pos1=rel1->pObjList.GetHeadPosition();
						   while(pos1!=NULL)
						   {
							   ptempObj=rel1->pObjList.GetNext(pos1);
							   if((ptempObj!=pObj)&&(ptempObj->type==G_LINE))
							   {
								   ptempObj1=ptempObj;
								   break;
							   }
						   }
						   pos1=rel2->pObjList.GetHeadPosition();
						   while(pos1!=NULL)
						   {
							   ptempObj=rel2->pObjList.GetNext(pos1);
							   if((ptempObj!=pObj)&&(ptempObj->type==G_LINE))
							   {
								   ptempObj2=ptempObj;
								   break;
							   }
						   }
						   //////////////////////////////////////////////
						   if((ptempObj1->type==G_LINE)&&(ptempObj2->type==G_LINE))
						   {
								CMyLine line_temp1,line_temp2;
								CPoint2 temp; 
								temp.x=((CMyLine*) ptempObj1)->ABC[0];
								temp.y=((CMyLine*) ptempObj1)->ABC[1];
								//ʱtempΪֱline pObj1ʸ
								if(((CMyLine*) ptempObj1)->my_startpoint->NFlag==1)
								{						
									temp=((CMyLine*) ptempObj1)->my_startpoint->m_startpoint.getPoint(temp,rel1->N_dis_clamp);
									//ʱtempΪֱ߾Ϊtemp_relation1->N_dis_clampĵ
								}
								else//((CMyLine*) pObj1)->myendpoint->NFlag==1
								{
									temp=((CMyLine*) ptempObj1)->my_endpoint->m_startpoint.getPoint(temp,rel1->N_dis_clamp);
								}

								line_temp1.computeABC(((CMyLine*) ptempObj1)->ABC[0],
													  ((CMyLine*) ptempObj1)->ABC[1],
													  temp);						
								temp.x=((CMyLine*) ptempObj2)->ABC[0];
								temp.y=((CMyLine*) ptempObj2)->ABC[1];
								//ʱtempΪֱline pObj2ʸ
								if(((CMyLine*) ptempObj2)->my_startpoint->NFlag==1)
								{						
									temp=((CMyLine*) ptempObj2)->my_startpoint->m_startpoint.getPoint(temp,rel2->N_dis_clamp);
									//ʱtempΪֱ߾Ϊtemp_relation2->N_dis_clampĵ
								}
								else//((CMyLine*) pObj2)->myendpoint->NFlag==1
								{
									temp=((CMyLine*) ptempObj2)->my_endpoint->m_startpoint.getPoint(temp,rel2->N_dis_clamp);
								}
								line_temp2.computeABC(((CMyLine*) ptempObj2)->ABC[0],
													  ((CMyLine*) ptempObj2)->ABC[1],
													  temp);
								int k=sol_lll(line_temp1.ABC[0],line_temp1.ABC[1],line_temp1.ABC[2],
											 line_temp2.ABC[0],line_temp2.ABC[1],line_temp2.ABC[2]);
								if(k>0)
								{
									((CMyPoint*)pObj)->m_startpoint=(*intersection);
								}
								else//pObj1,pObj2ֱƽ
								{
		//							ASSERT(FALSE);
								}
								////////////////////////////////////////////////////
						   }
						}
						else if((temp_bool5)||(temp_bool6))
						{					   
							//////////////////////////
							///the first step,get the point and the line;
							if(temp_bool5)////lppp
							{
								if((rel1->pObjList.GetCount()==2)&&(rel2->pObjList.GetCount()>=3))
								{
									pos1=rel1->pObjList.GetHeadPosition();
									while(pos1!=NULL)
									{
									   ptempObj=rel1->pObjList.GetNext(pos1);
									   if((ptempObj!=pObj)&&(ptempObj->type==G_LINE))
									   {
										   ptempObj1=ptempObj;
										   break;
									   }
									}
									if(rel2->pObjList.GetCount()==3)
									{
										pos1=rel2->pObjList.GetHeadPosition();
										while(pos1!=NULL)
										{
										   ptempObj2=rel2->pObjList.GetNext(pos1);
										   ptempObj3=rel2->pObjList.GetNext(pos1);
										   ptempObj4=rel2->pObjList.GetNext(pos1);									   
										}
									}
									else if(rel2->pObjList.GetCount()==4)
									{
										pos1=rel2->pObjList.GetHeadPosition();
										while(pos1!=NULL)
										{
										   ptempObj2=rel2->pObjList.GetNext(pos1);
										   ptempObj3=rel2->pObjList.GetNext(pos1);
										   ptempObj4=rel2->pObjList.GetNext(pos1);
										   ptempObj5=rel2->pObjList.GetNext(pos1);
										}
									}
									else
									{}
									
								}
							}
							else///pppl
							{
								if((rel1->pObjList.GetCount()>=3)&&(rel2->pObjList.GetCount()==2))
								{
									pos1=rel2->pObjList.GetHeadPosition();
									while(pos1!=NULL)
									{
									   ptempObj=rel2->pObjList.GetNext(pos1);
									   if((ptempObj!=pObj)&&(ptempObj->type==G_LINE))
									   {
										   ptempObj1=ptempObj;
										   break;
									   }
									}
									if(rel1->pObjList.GetCount()==3)
									{
										pos1=rel2->pObjList.GetHeadPosition();
										while(pos1!=NULL)
										{
										   ptempObj2=rel2->pObjList.GetNext(pos1);
										   ptempObj3=rel2->pObjList.GetNext(pos1);
										   ptempObj4=rel2->pObjList.GetNext(pos1);									 
										}
									}
									else if(rel1->pObjList.GetCount()==4)
									{	pos1=rel1->pObjList.GetHeadPosition();
										while(pos1!=NULL)
										{
										   ptempObj2=rel1->pObjList.GetNext(pos1);
										   ptempObj3=rel1->pObjList.GetNext(pos1);
										   ptempObj4=rel1->pObjList.GetNext(pos1);
										   ptempObj5=rel1->pObjList.GetNext(pos1);
										}
									}
									else
									{}
								
								}
							}
							/////the second step,compute the point;
							if((rel1->pObjList.GetCount()==3)||(rel2->pObjList.GetCount()==3))
							{
								///һһֱϣͬʱõɱϵ
								if((ptempObj1->type==G_LINE)&&(ptempObj2->type==G_POINT)&&(ptempObj3->type==
									G_POINT)&&(ptempObj4->type==G_POINT))
								{						
									 if(pObj->m_listindex==ptempObj2->m_listindex)
									{
										 double a,b,c,p,q,r,s,x,y,x1,x2,y1,y2,rr;
										 a=((CMyLine*)ptempObj1)->ABC[0];
										 b=((CMyLine*)ptempObj1)->ABC[1];
										 c=((CMyLine*)ptempObj1)->ABC[2];
										 if(rel1->pObjList.GetCount()==3)
											 rr=rel1->N_dis_clamp;
										 else
											 rr=rel2->N_dis_clamp;
										 p=((CMyPoint*)ptempObj3)->m_startpoint.x;
										 q=((CMyPoint*)ptempObj3)->m_startpoint.y;
										 r=((CMyPoint*)ptempObj4)->m_startpoint.x;
										 s=((CMyPoint*)ptempObj4)->m_startpoint.y;
										 x=((CMyPoint*)ptempObj2)->m_startpoint.x;
										 y=((CMyPoint*)ptempObj2)->m_startpoint.y;
										 {
											 x1 = p+p*rr-r*rr;
											 y1 = -rr*s+q+rr*q;
											 x2 = -p*rr+p+r*rr;
											 y2 = rr*s+q-rr*q;
										 }
										///get two values,compare the two point,get the near point;
										if(((x1-x)*(x1-x)+(y1-y)*(y1-y))>((x2-x)*(x2-x)+(y2-y)*(y2-y)))
										{
											 ((CMyPoint*)ptempObj2)->m_startpoint.x=x2;
											 ((CMyPoint*)ptempObj2)->m_startpoint.y=y2;
										}
										else
										{
											 ((CMyPoint*)ptempObj2)->m_startpoint.x=x1;
											 ((CMyPoint*)ptempObj2)->m_startpoint.y=y1;
										}
									}
									else if(pObj->m_listindex==ptempObj3->m_listindex)
									{
										 double a,b,c,r,r0,r1,x,y,x1,y1,x2,y2;
										 a=((CMyLine*)ptempObj1)->ABC[0];
										 b=((CMyLine*)ptempObj1)->ABC[1];
										 c=((CMyLine*)ptempObj1)->ABC[2];
										 if(rel1->pObjList.GetCount()==3)
											 r=rel1->N_dis_clamp;
										 else
											 r=rel2->N_dis_clamp;
										 x1=((CMyPoint*)ptempObj2)->m_startpoint.x;
										 y1=((CMyPoint*)ptempObj2)->m_startpoint.y;
										 x2=((CMyPoint*)ptempObj4)->m_startpoint.x;
										 y2=((CMyPoint*)ptempObj4)->m_startpoint.y;
										 x=((CMyPoint*)ptempObj3)->m_startpoint.x;
										 y=((CMyPoint*)ptempObj3)->m_startpoint.y;
										 if((fabs(r-1))<0.000001)
										 {
											 r0 = 0.5*(a*x1*x1-x2*x2*a+a*y1*y1-y2*y2*a-2*c*x2+2*c*x1)/(-a*y2+a*y1-b*x1+x2*b);
											 x1=-(b*r0+c)/a;
											 y1=r0;
											 ((CMyPoint*)ptempObj3)->m_startpoint.x=x1;
											 ((CMyPoint*)ptempObj3)->m_startpoint.y=y1;
										 }
										 else
										 {
											 /////////////////////////////////////////////////
                                             double dsqrt;
											 dsqrt=(2*c*c*r*r*a*a+2*x2*a*a*a*c*r*r
													 +b*b*r*r*x2*x2*a*a+b*b*r*r*y2*y2*a*a+b*b*r*r*y1*y1*a*a
													 +b*b*r*r*x1*x1*a*a-2*b*c*y1*a*a-2*x1*a*a*a*b*y1-2*a*a*a*a*r*r*y1*y2
													 -2*b*b*r*r*x1*x2*a*a-a*a*c*c-r*r*r*r*a*a*a*a*x2*x2+2*r*r*y2*a*a*a*x1*b
													 -r*r*r*r*b*b*y2*y2*a*a+2*r*r*a*a*a*x1*c-2*r*r*r*r*a*a*a*x2*c
													 -r*r*r*r*a*a*c*c+2*b*c*r*r*y2*a*a-2*r*r*r*r*x2*a*a*a*b*y2
													 +2*r*r*x2*a*a*a*b*y1-2*r*r*r*r*b*c*y2*a*a+2*r*r*b*c*y1*a*a
													 -a*a*a*a*x1*x1+a*a*a*a*r*r*y1*y1+a*a*a*a*r*r*x1*x1-b*b*y1*y1*a*a
													 -2*a*a*a*x1*c+a*a*a*a*r*r*x2*x2+a*a*a*a*r*r*y2*y2);
											 if(dsqrt>=0)
											 {
                                                    ((CMyPoint*)ptempObj3)->bSqrt=0;
												    r0 =0.5/(r*r*b*b+r*r*a*a-b*b-a*a)*(2*b*c-2*r*r*x2*a*b-2*r*r*b*c
														 +2*r*r*y2*a*a+2*x1*a*b-2*y1*a*a+2*sqrt(dsqrt));
													r1 =0.5/(r*r*b*b+r*r*a*a-b*b-a*a)*(2*b*c-2*r*r*x2*a*b-2*r*r*b*c
														 +2*r*r*y2*a*a+2*x1*a*b-2*y1*a*a-2*sqrt(dsqrt));
													x1=-(b*r0+c)/a;
													x2=-(b*r1+c)/a;
													y1=r0;
													y2=r1;
													///get two values,compare the two point,get the near point;
													if(((x1-x)*(x1-x)+(y1-y)*(y1-y))>((x2-x)*(x2-x)+(y2-y)*(y2-y)))
													{
														 ((CMyPoint*)ptempObj3)->m_startpoint.x=x2;
														 ((CMyPoint*)ptempObj3)->m_startpoint.y=y2;
													}
													else
													{
														 ((CMyPoint*)ptempObj3)->m_startpoint.x=x1;
														 ((CMyPoint*)ptempObj3)->m_startpoint.y=y1;
													}
											 }
											 else
											 {
											      ((CMyPoint*)ptempObj3)->bSqrt=1;
											 }
										 }
									}
									else if(pObj->m_listindex==ptempObj4->m_listindex)
									{
										  double a,b,c,r,r0,r1,x,y,x1,y1,x2,y2;
										 a=((CMyLine*)ptempObj1)->ABC[0];
										 b=((CMyLine*)ptempObj1)->ABC[1];
										 c=((CMyLine*)ptempObj1)->ABC[2];
										 if(rel1->pObjList.GetCount()==3)
											 r=rel1->N_dis_clamp;
										 else
											 r=rel2->N_dis_clamp;
										 x1=((CMyPoint*)ptempObj2)->m_startpoint.x;
										 y1=((CMyPoint*)ptempObj2)->m_startpoint.y;
										 x2=((CMyPoint*)ptempObj3)->m_startpoint.x;
										 y2=((CMyPoint*)ptempObj3)->m_startpoint.y;
										 x=((CMyPoint*)ptempObj4)->m_startpoint.x;
										 y=((CMyPoint*)ptempObj4)->m_startpoint.y;
										 /////////////////////////////////////////////////
										 double dsqrt;
										 dsqrt=(x1*x1*a*a*b*b-2*x1*x2*a*a*b*b-2*y1*y2*a*a*b*b
											 -2*x1*x2*a*a*a*a+x2*x2*a*a*b*b+y2*y2*a*a*b*b-2*y1*y2*a*a*a*a
											 +y1*y1*a*a*a*a+x2*x2*a*a*a*a+y2*y2*a*a*a*a-c*c*r*r*a*a
											 -2*x2*a*a*a*c*r*r-b*b*r*r*y2*y2*a*a-2*b*c*r*r*y2*a*a
											 -2*r*r*x2*a*a*a*b*y2+a*a*a*a*x1*x1+b*b*y1*y1*a*a-a*a*a*a*r*r*x2*x2);
										 if(dsqrt>=0)
										 {
											 ((CMyPoint*)ptempObj4)->bSqrt=0;
											 r0 =0.5/(b*b+a*a)*(-2*r*x2*a*b-2*r*b*c+2*r*y2*a*a
												 +2*sqrt(dsqrt));
											 r1 =0.5/(b*b+a*a)*(-2*r*x2*a*b-2*r*b*c+2*r*y2*a*a
												 -2*sqrt(dsqrt));
											 x1=-(b*r0+r*c)/(r*a);
											 x2=-(b*r1+r*c)/(r*a);
											 y1=r0;
											 y2=r1;
											 ///get two values,compare the two point,get the near point;
											 if(((x1-x)*(x1-x)+(y1-y)*(y1-y))>((x2-x)*(x2-x)+(y2-y)*(y2-y)))
											 {
												 ((CMyPoint*)ptempObj4)->m_startpoint.x=x2;
												 ((CMyPoint*)ptempObj4)->m_startpoint.y=y2;
											 }
											 else
											 {
												 ((CMyPoint*)ptempObj4)->m_startpoint.x=x1;
												 ((CMyPoint*)ptempObj4)->m_startpoint.y=y1;
											 }
										 }
										 else
										 {
										     ((CMyPoint*)ptempObj4)->bSqrt=1;
										 }
									}
								
									if(ptempObj1->type==G_LINE)
									{
										int k=sol_lll(((CMyLine*)ptempObj1)->ABC[0],
												((CMyLine*)ptempObj1)->ABC[1],
												((CMyLine*)ptempObj1)->ABC[2],
												((CMyLine*)ptempObj1)->ABC[1],
											   -((CMyLine*)ptempObj1)->ABC[0],
												((CMyLine*)ptempObj1)->ABC[0]*((CMyPoint*)pObj)->y()
											   -((CMyLine*)ptempObj1)->ABC[1]*((CMyPoint*)pObj)->x());
										if(k>0)
										{
											CPoint2 temp_direction=((CMyPoint*)pObj)->m_startpoint
																  -(*intersection);
											double len=rel1->N_dis_clamp;
											((CMyPoint*)pObj)->m_startpoint
											=intersection->getPoint(temp_direction,len);
										}
										else
										{
										   // ASSERT(FALSE);
										}                           
									}  
								}
							}
							else if((rel1->pObjList.GetCount()==4)||(rel2->pObjList.GetCount()==4))
							{
								   if((ptempObj1->type==G_LINE)&&(ptempObj2->type==G_POINT)&&(ptempObj3->type==
									G_POINT)&&(ptempObj4->type==G_POINT)&&(ptempObj5->type==G_POINT))
								{						
									 if(pObj->m_listindex==ptempObj2->m_listindex)
									{
										 double dDis,dDistance,dCount,dx1,dy1,dx2,dy2;
										 dCount=rel2->N_dis_clamp;
										 dx1=((CMyPoint*)ptempObj4)->m_startpoint.x;
										 dy1=((CMyPoint*)ptempObj4)->m_startpoint.y;
										 dx2=((CMyPoint*)ptempObj5)->m_startpoint.x;
										 dy2=((CMyPoint*)ptempObj5)->m_startpoint.y;
										 dDis=sqrt((dx1-dx2)*(dx1-dx2)+(dy1-dy2)*(dy1-dy2));
										 dDistance=dDis*dCount;///õȡ
										 CPoint2 temp_direction=((CMyPoint*)ptempObj2)->m_startpoint
																  -((CMyPoint*)ptempObj3)->m_startpoint;
										 double len=dDistance;
										 ((CMyPoint*)ptempObj2)->m_startpoint
											=((CMyPoint*)ptempObj3)->m_startpoint.getPoint(temp_direction,len);
										
									}
									else if(pObj->m_listindex==ptempObj3->m_listindex)
									{
										 double dDis,dDistance,dCount,dx1,dy1,dx2,dy2;
										 dCount=rel2->N_dis_clamp;
										 dx1=((CMyPoint*)ptempObj4)->m_startpoint.x;
										 dy1=((CMyPoint*)ptempObj4)->m_startpoint.y;
										 dx2=((CMyPoint*)ptempObj5)->m_startpoint.x;
										 dy2=((CMyPoint*)ptempObj5)->m_startpoint.y;
										 dDis=sqrt((dx1-dx2)*(dx1-dx2)+(dy1-dy2)*(dy1-dy2));
										 dDistance=dDis*dCount;///õȡ
										 CPoint2 temp_direction=((CMyPoint*)ptempObj3)->m_startpoint
																  -((CMyPoint*)ptempObj2)->m_startpoint;
										 double len=dDistance;
										 ((CMyPoint*)ptempObj3)->m_startpoint
											=((CMyPoint*)ptempObj2)->m_startpoint.getPoint(temp_direction,len);
									}
									else if(pObj->m_listindex==ptempObj4->m_listindex)
									{
										 double dDis,dDistance,dCount,dx1,dy1,dx2,dy2;
										 dCount=rel2->N_dis_clamp;
										 dx1=((CMyPoint*)ptempObj2)->m_startpoint.x;
										 dy1=((CMyPoint*)ptempObj2)->m_startpoint.y;
										 dx2=((CMyPoint*)ptempObj3)->m_startpoint.x;
										 dy2=((CMyPoint*)ptempObj3)->m_startpoint.y;
										 dDis=sqrt((dx1-dx2)*(dx1-dx2)+(dy1-dy2)*(dy1-dy2));
										 dDistance=(dDis/dCount);///õȡ
										 CPoint2 temp_direction=((CMyPoint*)ptempObj4)->m_startpoint
																  -((CMyPoint*)ptempObj5)->m_startpoint;
										 double len=dDistance;
										 ((CMyPoint*)ptempObj4)->m_startpoint
											=((CMyPoint*)ptempObj5)->m_startpoint.getPoint(temp_direction,len);
									}
									else if(pObj->m_listindex==ptempObj5->m_listindex)
									{
										 double dDis,dDistance,dCount,dx1,dy1,dx2,dy2;
										 dCount=rel2->N_dis_clamp;
										 dx1=((CMyPoint*)ptempObj2)->m_startpoint.x;
										 dy1=((CMyPoint*)ptempObj2)->m_startpoint.y;
										 dx2=((CMyPoint*)ptempObj3)->m_startpoint.x;
										 dy2=((CMyPoint*)ptempObj3)->m_startpoint.y;
										 dDis=sqrt((dx1-dx2)*(dx1-dx2)+(dy1-dy2)*(dy1-dy2));
										 dDistance=dDis/dCount;///õȡ
										 CPoint2 temp_direction=((CMyPoint*)ptempObj5)->m_startpoint
																  -((CMyPoint*)ptempObj4)->m_startpoint;
										 double len=dDistance;
										 ((CMyPoint*)ptempObj5)->m_startpoint
											=((CMyPoint*)ptempObj4)->m_startpoint.getPoint(temp_direction,len);
									}
									if(ptempObj1->type==G_LINE)
									{
										int k=sol_lll(((CMyLine*)ptempObj1)->ABC[0],
												((CMyLine*)ptempObj1)->ABC[1],
												((CMyLine*)ptempObj1)->ABC[2],
												((CMyLine*)ptempObj1)->ABC[1],
											   -((CMyLine*)ptempObj1)->ABC[0],
												((CMyLine*)ptempObj1)->ABC[0]*((CMyPoint*)pObj)->y()
											   -((CMyLine*)ptempObj1)->ABC[1]*((CMyPoint*)pObj)->x());
										if(k>0)
										{
											CPoint2 temp_direction=((CMyPoint*)pObj)->m_startpoint
																  -(*intersection);
											double len=rel1->N_dis_clamp;
											((CMyPoint*)pObj)->m_startpoint
											=intersection->getPoint(temp_direction,len);
										}
										else
										{
										   // ASSERT(FALSE);
										}                           
									}  
								}
							}
							else
							{
							
							}
							
							//////////////////////////
						}				
						else if((temp_bool7)||(temp_bool8))
						{
							///the first step,get the point and the line;
							if(temp_bool7)////lc
							{
								if((rel1->pObjList.GetCount()==2)&&(rel2->pObjList.GetCount()==2))
								{
									pos1=rel1->pObjList.GetHeadPosition();
									while(pos1!=NULL)
									{
									   ptempObj=rel1->pObjList.GetNext(pos1);
									   if((ptempObj!=pObj)&&(ptempObj->type==G_LINE))
									   {
										   ptempObj1=ptempObj;
										   break;
									   }
									}
									pos1=rel2->pObjList.GetHeadPosition();
									while(pos1!=NULL)
									{
									   ptempObj=rel2->pObjList.GetNext(pos1);
									   if((ptempObj!=pObj)&&(ptempObj->type==G_CIRCLE))
									   {
											ptempObj2=ptempObj;
											break;
									   }
									}							
									
								}
								///the second step,compute the point;
								if((ptempObj1->type==G_LINE)&&(ptempObj2->type==G_CIRCLE))
								{
									 double x,y,a,b,c,x0,y0,r,temp1,temp2,x1,y1,x2,y2;
									 x=((CMyPoint*)pObj)->m_startpoint.x;
									 y=((CMyPoint*)pObj)->m_startpoint.y;
									 a=((CMyLine*)ptempObj1)->ABC[0];
									 b=((CMyLine*)ptempObj1)->ABC[1];
									 c=((CMyLine*)ptempObj1)->ABC[2];
									 x0=((CMyCircle*)ptempObj2)->ABC[0];
									 y0=((CMyCircle*)ptempObj2)->ABC[1];
									 r=((CMyCircle*)ptempObj2)->ABC[2];
									 //////////////////////////////////////////////////////////////////////////
									 double dsqrt;
									 dsqrt=(-2*x0*a*a*a*b*y0
										 -2*y0*a*a*c*b-b*b*y0*y0*a*a+b*b*r*r*a*a-2*a*a*a*x0*c-a*a*a*a*x0*x0-a*a*c*c+a*a*a*a*r*r);
									 if(dsqrt>=0)
									 {
                                         ((CMyPoint*)pObj)->bSqrt=0;
										 temp1=0.5/(b*b+a*a)*(-2*x0*a*b+2*y0*a*a-2*c*b+2*sqrt(dsqrt));
										 temp2=0.5/(b*b+a*a)*(-2*x0*a*b+2*y0*a*a-2*c*b-2*sqrt(dsqrt));
										 y1=temp1;
										 y2=temp2;
										 x1=-(b*temp1+c)/a;
										 x2=-(b*temp2+c)/a;
										 if(((x-x1)*(x-x1)+(y-y1)*(y-y1))>((x-x2)*(x-x2)+(y-y2)*(y-y2)))
										 {
											((CMyPoint*)pObj)->m_startpoint.x=x2;
											((CMyPoint*)pObj)->m_startpoint.y=y2;
										 }
										 else 
										 {
											 ((CMyPoint*)pObj)->m_startpoint.x=x1;
											 ((CMyPoint*)pObj)->m_startpoint.y=y1;
										 }
									 }
									 else
									 {
									    ((CMyPoint*)pObj)->bSqrt=1;
									 }
								}
							}
							else
							{
					    		if((rel1->pObjList.GetCount()==2)&&(rel2->pObjList.GetCount()==2))
								{
									pos1=rel1->pObjList.GetHeadPosition();
									while(pos1!=NULL)
									{
									   ptempObj=rel1->pObjList.GetNext(pos1);
									   if((ptempObj!=pObj)&&(ptempObj->type==G_CIRCLE))
									   {
										   ptempObj1=ptempObj;
										   break;
									   }
									}
									pos1=rel2->pObjList.GetHeadPosition();
									while(pos1!=NULL)
									{
									   ptempObj=rel2->pObjList.GetNext(pos1);
									   if((ptempObj!=pObj)&&(ptempObj->type==G_LINE))
									   {
											ptempObj2=ptempObj;
											break;
									   }
									}							
									
								}
								///the second step,compute the point;
								if((ptempObj2->type==G_LINE)&&(ptempObj1->type==G_CIRCLE))
								{
									 double x,y,a,b,c,x0,y0,r,temp1,temp2,x1,y1,x2,y2;
									 x=((CMyPoint*)pObj)->m_startpoint.x;
									 y=((CMyPoint*)pObj)->m_startpoint.y;
									 a=((CMyLine*)ptempObj2)->ABC[0];
									 b=((CMyLine*)ptempObj2)->ABC[1];
									 c=((CMyLine*)ptempObj2)->ABC[2];
									 x0=((CMyCircle*)ptempObj1)->ABC[0];
									 y0=((CMyCircle*)ptempObj1)->ABC[1];
									 r=((CMyCircle*)ptempObj1)->ABC[2];
									 /////////////////////////////////////////////////////////////////////////////////////////
									 double dsqrt;
									 dsqrt=(-2*x0*a*a*a*b*y0
										 -2*y0*a*a*c*b-b*b*y0*y0*a*a+b*b*r*r*a*a-2*a*a*a*x0*c-a*a*a*a*x0*x0-a*a*c*c+a*a*a*a*r*r);
									 if(dsqrt>=0)
									 {
										 ((CMyPoint*)pObj)->bSqrt=0;
										 temp1=0.5/(b*b+a*a)*(-2*x0*a*b+2*y0*a*a-2*c*b+2*sqrt(dsqrt));
										 temp2=0.5/(b*b+a*a)*(-2*x0*a*b+2*y0*a*a-2*c*b-2*sqrt(dsqrt));
										 y1=temp1;
										 y2=temp2;
										 x1=-(b*temp1+c)/a;
										 x2=-(b*temp2+c)/a;
										 if(((x-x1)*(x-x1)+(y-y1)*(y-y1))>((x-x2)*(x-x2)+(y-y2)*(y-y2)))
										 {
											((CMyPoint*)pObj)->m_startpoint.x=x2;
											((CMyPoint*)pObj)->m_startpoint.y=y2;
										 }
										 else 
										 {
											 ((CMyPoint*)pObj)->m_startpoint.x=x1;
											 ((CMyPoint*)pObj)->m_startpoint.y=y1;
										 }
									 }
									 else
									 {
									      ((CMyPoint*)pObj)->bSqrt=1;
									 }
								}
							}
						}
						else if(temp_bool9)///p=cc;һԲȷ
						{					    
							if((rel1->pObjList.GetCount()==2)&&(rel2->pObjList.GetCount()==2))
							{	
								if(rel1->N_dis_clamp<0.00001)
								{
									pos1=rel1->pObjList.GetHeadPosition();
									while(pos1!=NULL)
									{
									   ptempObj=rel1->pObjList.GetNext(pos1);
									   if((ptempObj!=pObj)&&(ptempObj->type==G_CIRCLE))
									   {
										   ptempObj1=ptempObj;
										   break;
									   }
									}
								}
								if(rel2->N_dis_clamp<0.00001)
								{
									pos1=rel2->pObjList.GetHeadPosition();
									while(pos1!=NULL)
									{
									   ptempObj=rel2->pObjList.GetNext(pos1);
									   if((ptempObj!=pObj)&&(ptempObj->type==G_CIRCLE))
									   {
											ptempObj2=ptempObj;
											break;
									   }
									}
								}
							}
							///the second step,compute the point;
							if((ptempObj1->type==G_CIRCLE)&&(ptempObj2->type==G_CIRCLE))
							{
									 double a,b,c,q,p,r,temp1,temp2,x1,y1,x2,y2,x3,y3;
									 a=((CMyCircle*)ptempObj1)->ABC[0];
									 b=((CMyCircle*)ptempObj1)->ABC[1];
									 c=((CMyCircle*)ptempObj1)->ABC[2];
									 q=((CMyCircle*)ptempObj2)->ABC[0];
									 p=((CMyCircle*)ptempObj2)->ABC[1];
									 r=((CMyCircle*)ptempObj2)->ABC[2];
									 ///////////////////////////////////////////////////////////////////////////
									 double dsqrt;
									 dsqrt=(8*r*r*b*a*q*p+2*c*c*b*b*q*q+4*p*p*p*b*q*q-6*p*p*b*b*q*q+8*a*a*a*b*b*q
										 +4*a*a*b*p*p*p-12*a*a*b*b*q*q+4*a*a*a*a*b*p+2*a*a*b*b*c*c-6*a*a*b*b*p*p
										 +2*r*r*b*b*q*q-a*a*a*a*a*a+2*r*r*b*b*a*a+2*b*b*b*b*a*q+8*c*c*b*a*q*p+4*b*b*b*q*q*p
										 +4*b*b*b*p*a*a-q*q*q*q*q*q-b*b*b*b*q*q+8*p*p*a*a*a*q+2*p*p*a*a*r*r+2*p*p*a*a*c*c
										 -12*p*p*a*a*q*q-b*b*b*b*a*a+8*q*q*q*p*p*a+2*q*q*p*p*r*r+2*q*q*p*p*c*c-4*r*r*b*q*q*p
										 +8*q*q*q*b*b*a+4*q*q*q*q*b*p-4*r*r*b*p*a*a-8*b*b*b*a*q*p+2*a*q*c*c*c*c+24*a*a*b*q*q*p
										 -8*a*q*q*q*c*c-8*a*a*a*q*r*r-4*r*r*b*b*a*q-8*a*q*q*q*r*r-8*a*a*a*q*c*c+12*a*a*q*q*c*c
										 +12*a*a*q*q*r*r+2*a*q*r*r*r*r+2*a*q*p*p*p*p-16*a*a*a*b*q*p-2*a*a*a*a*b*b
										 -4*a*a*b*p*c*c+2*q*q*r*r*c*c-p*p*p*p*a*a-2*p*p*a*a*a*a-4*c*c*b*b*a*q-4*c*c*b*q*q*p
										 +12*p*p*b*b*a*q-8*p*p*p*b*a*q-q*q*p*p*p*p-2*q*q*q*q*p*p-2*q*q*q*q*b*b+2*a*a*r*r*c*c
										 -16*q*q*q*b*a*p+6*a*q*q*q*q*q-15*a*a*a*a*q*q-15*a*a*q*q*q*q+6*a*a*a*a*a*q
										 +20*a*a*a*q*q*q-4*r*r*p*p*a*q-4*p*p*c*c*a*q-q*q*r*r*r*r-q*q*c*c*c*c+2*q*q*q*q*c*c
										 +2*q*q*q*q*r*r-a*a*c*c*c*c+2*a*a*a*a*r*r-4*a*q*r*r*c*c+2*a*a*a*a*c*c-a*a*r*r*r*r);
									 if(dsqrt>=0)
									 {
										 ((CMyPoint*)pObj)->bSqrt=0;
										 temp1=0.5/(-8*a*q-8*p*b+4*q*q+4*p*p+4*b*b+4*a*a)*(4*b*b*b+4*r*r*b+4*a*a*b-4*p*p*b
											 -4*c*c*b+4*p*a*a-4*p*b*b+4*q*q*b+4*q*q*p+4*p*c*c-4*r*r*p-8*a*q*p+4*p*p*p-8*a*q*b
											 +4*sqrt(dsqrt));
										 temp2=0.5/(-8*a*q-8*p*b+4*q*q+4*p*p+4*b*b+4*a*a)*(4*b*b*b+4*r*r*b+4*a*a*b-4*p*p*b
											 -4*c*c*b+4*p*a*a-4*p*b*b+4*q*q*b+4*q*q*p+4*p*c*c-4*r*r*p-8*a*q*p+4*p*p*p-8*a*q*b
											 -4*sqrt(dsqrt));
										 y1=temp1;
										 y2=temp2;
										 x1=0.5*(2*temp1*p-2*temp1*b-q*q-p*p+r*r+a*a+b*b-c*c)/(a-q);
										 x2=0.5*(2*temp2*p-2*temp2*b-q*q-p*p+r*r+a*a+b*b-c*c)/(a-q);
										 x3=((CMyPoint*)pObj)->m_startpoint.x;
										 y3=((CMyPoint*)pObj)->m_startpoint.y;
										 if(((y1-y3)*(y1-y3)+(x1-x3)*(x1-x3))<((y2-y3)*(y2-y3)+(x2-x3)*(x2-x3)))
										 {
											  ((CMyPoint*)pObj)->m_startpoint.x=x1;
											  ((CMyPoint*)pObj)->m_startpoint.y=y1;
										 }
										 else
										 {
											 ((CMyPoint*)pObj)->m_startpoint.x=x2;
											 ((CMyPoint*)pObj)->m_startpoint.y=y2;
										 }
									 }
									 else
									 {
									       ((CMyPoint*)pObj)->bSqrt=1;
									 }
							}
						}
						else if(temp_bool10||temp_bool11)
						{						    
							///the first step,get the point and the line;
							if(temp_bool10)////Cppp
							{
								if((rel1->pObjList.GetCount()==2)&&(rel2->pObjList.GetCount()>=3))
								{
									pos1=rel1->pObjList.GetHeadPosition();
									while(pos1!=NULL)
									{
									   ptempObj=rel1->pObjList.GetNext(pos1);
									   if((ptempObj!=pObj)&&(ptempObj->type==G_CIRCLE))
									   {
										   ptempObj1=ptempObj;
										   break;
									   }
									}
									if(rel2->pObjList.GetCount()==3)
									{
										pos1=rel2->pObjList.GetHeadPosition();
										while(pos1!=NULL)
										{
										   ptempObj2=rel2->pObjList.GetNext(pos1);
										   ptempObj3=rel2->pObjList.GetNext(pos1);
										   ptempObj4=rel2->pObjList.GetNext(pos1);									   
										}
									}
									else if(rel2->pObjList.GetCount()==4)
									{
										pos1=rel2->pObjList.GetHeadPosition();
										while(pos1!=NULL)
										{
										   ptempObj2=rel2->pObjList.GetNext(pos1);
										   ptempObj3=rel2->pObjList.GetNext(pos1);
										   ptempObj4=rel2->pObjList.GetNext(pos1);
										   ptempObj5=rel2->pObjList.GetNext(pos1);
										}
									}
									else
									{}
									
								}
							}
							else///pppC
							{
								if((rel1->pObjList.GetCount()>=3)&&(rel2->pObjList.GetCount()==2))
								{
									pos1=rel2->pObjList.GetHeadPosition();
									while(pos1!=NULL)
									{
									   ptempObj=rel2->pObjList.GetNext(pos1);
									   if((ptempObj!=pObj)&&(ptempObj->type==G_CIRCLE))
									   {
										   ptempObj1=ptempObj;
										   break;
									   }
									}
									if(rel1->pObjList.GetCount()==3)
									{
										pos1=rel2->pObjList.GetHeadPosition();
										while(pos1!=NULL)
										{
										   ptempObj2=rel2->pObjList.GetNext(pos1);
										   ptempObj3=rel2->pObjList.GetNext(pos1);
										   ptempObj4=rel2->pObjList.GetNext(pos1);									 
										}
									}
									else if(rel1->pObjList.GetCount()==4)
									{
										pos1=rel1->pObjList.GetHeadPosition();
										while(pos1!=NULL)
										{
										   ptempObj2=rel1->pObjList.GetNext(pos1);
										   ptempObj3=rel1->pObjList.GetNext(pos1);
										   ptempObj4=rel1->pObjList.GetNext(pos1);
										   ptempObj5=rel1->pObjList.GetNext(pos1);
										}
									}
									else
									{}
								
								}
							}
							/////the second step,compute the point;
							double a,b,c,p,q,r,s,t,m,n,x,y,x1,x2,y1,y2,r0,r1;
							if((rel1->pObjList.GetCount()==3)||(rel2->pObjList.GetCount()==3))
							{
								///һһֱϣͬʱõɱϵ
								if((ptempObj1->type==G_CIRCLE)&&(ptempObj2->type==G_POINT)&&(ptempObj3->type==
									G_POINT)&&(ptempObj4->type==G_POINT))
								{						
																		 
									a=((CMyLine*)ptempObj1)->ABC[0];
									b=((CMyLine*)ptempObj1)->ABC[1];
									c=((CMyLine*)ptempObj1)->ABC[2];
									if(rel1->pObjList.GetCount()==3)
									    r=rel1->N_dis_clamp;
									else
									    r=rel2->N_dis_clamp;
									p=((CMyPoint*)ptempObj2)->m_startpoint.x;
									q=((CMyPoint*)ptempObj2)->m_startpoint.y;
									s=((CMyPoint*)ptempObj3)->m_startpoint.x;
									t=((CMyPoint*)ptempObj3)->m_startpoint.y;
									m=((CMyPoint*)ptempObj4)->m_startpoint.x;
									n=((CMyPoint*)ptempObj4)->m_startpoint.y;
									if(pObj->m_listindex==ptempObj2->m_listindex)
									{
										////////////????????????????????????????????????????????????????????????????????
										///get two values,compare the two point,get the near point;
										if(((x1-x)*(x1-x)+(y1-y)*(y1-y))>((x2-x)*(x2-x)+(y2-y)*(y2-y)))
										{
											 ((CMyPoint*)ptempObj2)->m_startpoint.x=x2;
											 ((CMyPoint*)ptempObj2)->m_startpoint.y=y2;
										}
										else
										{
											 ((CMyPoint*)ptempObj2)->m_startpoint.x=x1;
											 ((CMyPoint*)ptempObj2)->m_startpoint.y=y1;
										}
									}
									else if(pObj->m_listindex==ptempObj3->m_listindex)
									{
										 
										 if((r-1)<0.000001)
										 {
											 r0 = 0.5*(a*x1*x1-x2*x2*a+a*y1*y1-y2*y2*a-2*c*x2+2*c*x1)/(-a*y2+a*y1-b*x1+x2*b);
											 x1=-(b*r0+c)/a;
											 y1=r0;
											 ((CMyPoint*)ptempObj3)->m_startpoint.x=x1;
											 ((CMyPoint*)ptempObj3)->m_startpoint.y=y1;
										 }
										 else
										 {
											 /////////////////////////////////////////////////
                                             double dsqrt;
											 dsqrt=(2*c*c*r*r*a*a+2*x2*a*a*a*c*r*r
													 +b*b*r*r*x2*x2*a*a+b*b*r*r*y2*y2*a*a+b*b*r*r*y1*y1*a*a
													 +b*b*r*r*x1*x1*a*a-2*b*c*y1*a*a-2*x1*a*a*a*b*y1-2*a*a*a*a*r*r*y1*y2
													 -2*b*b*r*r*x1*x2*a*a-a*a*c*c-r*r*r*r*a*a*a*a*x2*x2+2*r*r*y2*a*a*a*x1*b
													 -r*r*r*r*b*b*y2*y2*a*a+2*r*r*a*a*a*x1*c-2*r*r*r*r*a*a*a*x2*c
													 -r*r*r*r*a*a*c*c+2*b*c*r*r*y2*a*a-2*r*r*r*r*x2*a*a*a*b*y2
													 +2*r*r*x2*a*a*a*b*y1-2*r*r*r*r*b*c*y2*a*a+2*r*r*b*c*y1*a*a
													 -a*a*a*a*x1*x1+a*a*a*a*r*r*y1*y1+a*a*a*a*r*r*x1*x1-b*b*y1*y1*a*a
													 -2*a*a*a*x1*c+a*a*a*a*r*r*x2*x2+a*a*a*a*r*r*y2*y2);
											 if(dsqrt>=0)
											 {
												 ((CMyPoint*)ptempObj3)->bSqrt=0;
												 r0 =0.5/(r*r*b*b+r*r*a*a-b*b-a*a)*(2*b*c-2*r*r*x2*a*b-2*r*r*b*c
														 +2*r*r*y2*a*a+2*x1*a*b-2*y1*a*a+2*sqrt(dsqrt));
												 r1 =0.5/(r*r*b*b+r*r*a*a-b*b-a*a)*(2*b*c-2*r*r*x2*a*b-2*r*r*b*c
														 +2*r*r*y2*a*a+2*x1*a*b-2*y1*a*a-2*sqrt(dsqrt));
												 x1=-(b*r0+c)/a;
												 x2=-(b*r1+c)/a;
												 y1=r0;
												 y2=r1;
												 ///get two values,compare the two point,get the near point;
												 if(((x1-x)*(x1-x)+(y1-y)*(y1-y))>((x2-x)*(x2-x)+(y2-y)*(y2-y)))
												 {
													 ((CMyPoint*)ptempObj3)->m_startpoint.x=x2;
													 ((CMyPoint*)ptempObj3)->m_startpoint.y=y2;
												 }
												 else
												 {
													 ((CMyPoint*)ptempObj3)->m_startpoint.x=x1;
													 ((CMyPoint*)ptempObj3)->m_startpoint.y=y1;
												 }
											 }
											 else
											 {
											     ((CMyPoint*)ptempObj3)->bSqrt=1;
											 }
										 }
									}
									else if(pObj->m_listindex==ptempObj4->m_listindex)
									{										  
										 /////////////////////////////////////////////////
										double dsqrt;
										dsqrt=(x1*x1*a*a*b*b-2*x1*x2*a*a*b*b-2*y1*y2*a*a*b*b
											 -2*x1*x2*a*a*a*a+x2*x2*a*a*b*b+y2*y2*a*a*b*b-2*y1*y2*a*a*a*a
											 +y1*y1*a*a*a*a+x2*x2*a*a*a*a+y2*y2*a*a*a*a-c*c*r*r*a*a
											 -2*x2*a*a*a*c*r*r-b*b*r*r*y2*y2*a*a-2*b*c*r*r*y2*a*a
											 -2*r*r*x2*a*a*a*b*y2+a*a*a*a*x1*x1+b*b*y1*y1*a*a-a*a*a*a*r*r*x2*x2);
										if(dsqrt>=0)
										{
											((CMyPoint*)ptempObj4)->bSqrt=0;
											 r0 =0.5/(b*b+a*a)*(-2*r*x2*a*b-2*r*b*c+2*r*y2*a*a
												 +2*sqrt(dsqrt));
											 r1 =0.5/(b*b+a*a)*(-2*r*x2*a*b-2*r*b*c+2*r*y2*a*a
												 -2*sqrt(dsqrt));
											x1=-(b*r0+r*c)/(r*a);
											x2=-(b*r1+r*c)/(r*a);
											y1=r0;
											y2=r1;
											///get two values,compare the two point,get the near point;
											if(((x1-x)*(x1-x)+(y1-y)*(y1-y))>((x2-x)*(x2-x)+(y2-y)*(y2-y)))
											{
												 ((CMyPoint*)ptempObj4)->m_startpoint.x=x2;
												 ((CMyPoint*)ptempObj4)->m_startpoint.y=y2;
											}
											else
											{
												 ((CMyPoint*)ptempObj4)->m_startpoint.x=x1;
												 ((CMyPoint*)ptempObj4)->m_startpoint.y=y1;
											}
										}
										else
										{
										    ((CMyPoint*)ptempObj4)->bSqrt=1;
										}
									}
								
									if(ptempObj1->type==G_LINE)
									{
										int k=sol_lll(((CMyLine*)ptempObj1)->ABC[0],
												((CMyLine*)ptempObj1)->ABC[1],
												((CMyLine*)ptempObj1)->ABC[2],
												((CMyLine*)ptempObj1)->ABC[1],
											   -((CMyLine*)ptempObj1)->ABC[0],
												((CMyLine*)ptempObj1)->ABC[0]*((CMyPoint*)pObj)->y()
											   -((CMyLine*)ptempObj1)->ABC[1]*((CMyPoint*)pObj)->x());
										if(k>0)
										{
											CPoint2 temp_direction=((CMyPoint*)pObj)->m_startpoint
																  -(*intersection);
											double len=rel1->N_dis_clamp;
											((CMyPoint*)pObj)->m_startpoint
											=intersection->getPoint(temp_direction,len);
										}
										else
										{
										   // ASSERT(FALSE);
										}                           
									}  
								}
							}
							else if((rel1->pObjList.GetCount()==4)||(rel2->pObjList.GetCount()==4))
							{
								   if((ptempObj1->type==G_LINE)&&(ptempObj2->type==G_POINT)&&(ptempObj3->type==
									G_POINT)&&(ptempObj4->type==G_POINT)&&(ptempObj5->type==G_POINT))
								{						
									 if(pObj->m_listindex==ptempObj2->m_listindex)
									{
										 double dDis,dDistance,dCount,dx1,dy1,dx2,dy2;
										 dCount=rel2->N_dis_clamp;
										 dx1=((CMyPoint*)ptempObj4)->m_startpoint.x;
										 dy1=((CMyPoint*)ptempObj4)->m_startpoint.y;
										 dx2=((CMyPoint*)ptempObj5)->m_startpoint.x;
										 dy2=((CMyPoint*)ptempObj5)->m_startpoint.y;
										 dDis=sqrt((dx1-dx2)*(dx1-dx2)+(dy1-dy2)*(dy1-dy2));
										 dDistance=dDis*dCount;///õȡ
										 CPoint2 temp_direction=((CMyPoint*)ptempObj2)->m_startpoint
																  -((CMyPoint*)ptempObj3)->m_startpoint;
										 double len=dDistance;
										 ((CMyPoint*)ptempObj2)->m_startpoint
											=((CMyPoint*)ptempObj3)->m_startpoint.getPoint(temp_direction,len);
										
									}
									else if(pObj->m_listindex==ptempObj3->m_listindex)
									{
										 double dDis,dDistance,dCount,dx1,dy1,dx2,dy2;
										 dCount=rel2->N_dis_clamp;
										 dx1=((CMyPoint*)ptempObj4)->m_startpoint.x;
										 dy1=((CMyPoint*)ptempObj4)->m_startpoint.y;
										 dx2=((CMyPoint*)ptempObj5)->m_startpoint.x;
										 dy2=((CMyPoint*)ptempObj5)->m_startpoint.y;
										 dDis=sqrt((dx1-dx2)*(dx1-dx2)+(dy1-dy2)*(dy1-dy2));
										 dDistance=dDis*dCount;///õȡ
										 CPoint2 temp_direction=((CMyPoint*)ptempObj3)->m_startpoint
																  -((CMyPoint*)ptempObj2)->m_startpoint;
										 double len=dDistance;
										 ((CMyPoint*)ptempObj3)->m_startpoint
											=((CMyPoint*)ptempObj2)->m_startpoint.getPoint(temp_direction,len);
									}
									else if(pObj->m_listindex==ptempObj4->m_listindex)
									{
										 double dDis,dDistance,dCount,dx1,dy1,dx2,dy2;
										 dCount=rel2->N_dis_clamp;
										 dx1=((CMyPoint*)ptempObj2)->m_startpoint.x;
										 dy1=((CMyPoint*)ptempObj2)->m_startpoint.y;
										 dx2=((CMyPoint*)ptempObj3)->m_startpoint.x;
										 dy2=((CMyPoint*)ptempObj3)->m_startpoint.y;
										 dDis=sqrt((dx1-dx2)*(dx1-dx2)+(dy1-dy2)*(dy1-dy2));
										 dDistance=(dDis/dCount);///õȡ
										 CPoint2 temp_direction=((CMyPoint*)ptempObj4)->m_startpoint
																  -((CMyPoint*)ptempObj5)->m_startpoint;
										 double len=dDistance;
										 ((CMyPoint*)ptempObj4)->m_startpoint
											=((CMyPoint*)ptempObj5)->m_startpoint.getPoint(temp_direction,len);
									}
									else if(pObj->m_listindex==ptempObj5->m_listindex)
									{
										 double dDis,dDistance,dCount,dx1,dy1,dx2,dy2;
										 dCount=rel2->N_dis_clamp;
										 dx1=((CMyPoint*)ptempObj2)->m_startpoint.x;
										 dy1=((CMyPoint*)ptempObj2)->m_startpoint.y;
										 dx2=((CMyPoint*)ptempObj3)->m_startpoint.x;
										 dy2=((CMyPoint*)ptempObj3)->m_startpoint.y;
										 dDis=sqrt((dx1-dx2)*(dx1-dx2)+(dy1-dy2)*(dy1-dy2));
										 dDistance=dDis/dCount;///õȡ
										 CPoint2 temp_direction=((CMyPoint*)ptempObj5)->m_startpoint
																  -((CMyPoint*)ptempObj4)->m_startpoint;
										 double len=dDistance;
										 ((CMyPoint*)ptempObj5)->m_startpoint
											=((CMyPoint*)ptempObj4)->m_startpoint.getPoint(temp_direction,len);
									}
									if(ptempObj1->type==G_LINE)
									{
										int k=sol_lll(((CMyLine*)ptempObj1)->ABC[0],
												((CMyLine*)ptempObj1)->ABC[1],
												((CMyLine*)ptempObj1)->ABC[2],
												((CMyLine*)ptempObj1)->ABC[1],
											   -((CMyLine*)ptempObj1)->ABC[0],
												((CMyLine*)ptempObj1)->ABC[0]*((CMyPoint*)pObj)->y()
											   -((CMyLine*)ptempObj1)->ABC[1]*((CMyPoint*)pObj)->x());
										if(k>0)
										{
											CPoint2 temp_direction=((CMyPoint*)pObj)->m_startpoint
																  -(*intersection);
											double len=rel1->N_dis_clamp;
											((CMyPoint*)pObj)->m_startpoint
											=intersection->getPoint(temp_direction,len);
										}
										else
										{
										   // ASSERT(FALSE);
										}                           
									}  
								}
							}
							else
							{
							
							}
							
							//////////////////////////
						}
					}
					break;
				case 2://ֱ
					{
						CDrawObj*pObj1,*pObj2,*pObj3,*pObj4,*pObj5;
						BOOL temp_bool1,temp_bool2,temp_bool3,temp_bool4,temp_bool5,temp_bool6,temp_bool7,temp_bool8;
				        temp_bool1=rel1->Nconstraintype==PL_DIS&&rel2->Nconstraintype==PL_DIS;///L=pp;
				        temp_bool2=rel1->Nconstraintype==PL_DIS&&(rel2->Nconstraintype==LL_ANGLE
							||rel2->Nconstraintype==LL_PARA||rel2->Nconstraintype==LL_PERP);///L=pl;
				        temp_bool3=(rel1->Nconstraintype==LL_ANGLE||rel1->Nconstraintype==LL_PARA
							||rel1->Nconstraintype==LL_PERP)&&rel2->Nconstraintype==PL_DIS;///L=lP;
				        temp_bool4=(rel1->Nconstraintype==LL_ANGLE||rel1->Nconstraintype==LL_PARA||rel1->Nconstraintype==LL_PERP)&&
							(rel2->Nconstraintype==LL_ANGLE||rel2->Nconstraintype==LL_PARA||rel2->Nconstraintype==LL_PERP);///L=ll;
                        temp_bool5=rel1->Nconstraintype==PL_DIS&&rel2->Nconstraintype==LC_TAN;///L=pc;
                        temp_bool6=rel1->Nconstraintype==LC_TAN&&rel2->Nconstraintype==PL_DIS;///l=cp;
						temp_bool7=rel1->Nconstraintype==PL_DIS&&rel2->Nconstraintype==AA_ANGLE;///l=plll;
						temp_bool8=rel1->Nconstraintype==AA_ANGLE&&rel2->Nconstraintype==PL_DIS;///l=lllp;
						if(temp_bool1)///һֱȷ
						{
							///the first step,get the two points;
							pos1=rel1->pObjList.GetHeadPosition();
							while(pos1!=NULL)
							{
								   ptempObj=rel1->pObjList.GetNext(pos1);
								   if((ptempObj!=pObj)&&(ptempObj->type==G_POINT))
								   {
									   pObj1=ptempObj;
									   break;
								   }
							}
							pos1=rel2->pObjList.GetHeadPosition();
							while(pos1!=NULL)
							{
								   ptempObj=rel2->pObjList.GetNext(pos1);
								   if((ptempObj!=pObj)&&(ptempObj->type==G_POINT))
								   {
									   pObj2=ptempObj;
									   break;
								   }
							}
							////the second step, compute the line////////////
							{
								///Ϊ࣬һ࣬㶼ϣڶ࣬һϣһ㱣־롣࣬㶼Ϊ롣
								double drel1,drel2;
								drel1=fabs(rel1->N_dis_clamp);
								drel2=fabs(rel2->N_dis_clamp);
							    if(drel1<L_ZERO&&drel2<L_ZERO)//ֱ							    
								{
 							    	((CMyLine*)pObj)->computeABC((CMyPoint*)pObj1,(CMyPoint*)pObj2);
								}
							    else if(drel1<L_ZERO&&drel2>L_ZERO)///symbol the pobj1  in the line and pobj2 has the distance with the line;
								{
							         double x,y,s,t;
									 x=((CMyPoint*)pObj1)->m_startpoint.x;
									 y=((CMyPoint*)pObj1)->m_startpoint.y;
									 s=((CMyPoint*)pObj2)->m_startpoint.x;
									 t=((CMyPoint*)pObj2)->m_startpoint.y;
								}
							    else if(drel1>L_ZERO&&drel2<L_ZERO) ///symbol the pobj1 has distance with the line and pobj2 in the line;
								{
							   
								}
						    	else//ֱ߶һ
								{ 
									CPoint2 midpoint,midpoint1,midpoint2;
									midpoint1=0.5*(((CMyPoint*)pObj1)->m_startpoint
												  +((CMyPoint*)pObj2)->m_startpoint);
									//midpoint1ΪһԲԲ
									if(rel1->N_dis_clamp>rel2->N_dis_clamp)
									{//midpoint2ΪһԲԲ
										midpoint2=((CMyPoint*)pObj1)->m_startpoint;
										midpoint=((CMyPoint*)pObj2)->m_startpoint;
									}
									else
									{
										midpoint2=((CMyPoint*)pObj2)->m_startpoint;
										midpoint=((CMyPoint*)pObj1)->m_startpoint;
									}
									double temp_c,temp_r1,temp_r2;
									temp_r2=rel2->N_dis_clamp-rel1->N_dis_clamp;
									temp_r1=(midpoint2-midpoint1).Length();
									temp_c=midpoint1.x*midpoint1.x-midpoint2.x*midpoint2.x
										  +midpoint1.y*midpoint1.y-midpoint2.y*midpoint2.y
										  +temp_r2*temp_r2-temp_r1*temp_r1;
									CPoint2* intersect_temp=//ºִкintersection1,intersection2ֵȡһmidpoint2
									sol_qmin(2*(midpoint2.x-midpoint1.x),
										   2*(midpoint2.y-midpoint1.y),
										   temp_c,
										   midpoint2.x,
										   midpoint2.y,
										   temp_r2*temp_r2,
										   ((CMyLine*)pObj)->my_startpoint->m_startpoint);
									if(intersect_temp!=NULL)
									{
										CPoint2 temp1,temp2,temp_direction;
										temp_direction=midpoint2-(* intersect_temp);
										temp1=midpoint2.getPoint(temp_direction,rel2->N_dis_clamp);
										temp2=midpoint.getPoint(temp_direction, rel1->N_dis_clamp);
										((CMyLine*)pObj)->computeABC(temp1,temp2);

									}
									else
									{
										ASSERT(FALSE);//޽㣬ȷֱ߲
									}
								}					
							}
							
						}
						else if(temp_bool2)///һֱһһֱȷ
						{
					    	///the first step,get the point and the line;
							pos1=rel1->pObjList.GetHeadPosition();
							while(pos1!=NULL)
							{
								   ptempObj=rel1->pObjList.GetNext(pos1);
								   if((ptempObj!=pObj)&&(ptempObj->type==G_POINT))
								   {
									   pObj1=ptempObj;
									   break;
								   }
							}
							pos1=rel2->pObjList.GetHeadPosition();
							while(pos1!=NULL)
							{
								   ptempObj=rel2->pObjList.GetNext(pos1);
								   if((ptempObj!=pObj)&&(ptempObj->type==G_LINE))
								   {
									   pObj2=ptempObj;
									   break;
								   }
							}
							////the second step, compute the line////////////														
							if(fabs(rel1->N_dis_clamp)<0.00000000001)
							{
								switch(rel2->Nconstraintype)
								{
								case LL_PERP://ߴֱ
									((CMyLine*)pObj)->computeABC(-((CMyLine*)pObj2)->ABC[1],
												 ((CMyLine*)pObj2)->ABC[0],((CMyPoint*)pObj1)->m_startpoint);
									break;
								case LL_PARA://ƽ
									((CMyLine*)pObj)->computeABC(((CMyLine*)pObj2)->ABC[0],
												 ((CMyLine*)pObj2)->ABC[1],((CMyPoint*)pObj1)->m_startpoint);
		    						break;
    	 						case LL_ANGLE://н
									{
										CPoint2 point_temp(((CMyLine*)pObj2)->ABC[0],((CMyLine*)pObj2)->ABC[1]);
										CPoint2 point_temp1(cos(rel2->N_dis_clamp),sin(rel2->N_dis_clamp));
										CPoint2 point_temp2;
										point_temp2=point_temp*point_temp1;
										((CMyLine*)pObj)->computeABC(point_temp2.x,point_temp2.y,((CMyPoint*)pObj1)->m_startpoint);
								
									}
	    							break;
								default:
				    				ASSERT(FALSE);
								}
							}
							else
							{
								//㵽ȷֱ߾벻Ϊ0
							}
						
						}
						else if(temp_bool3)///һֱߵȷ
						{
						    ///the first step,get the linet and the point;
							pos1=rel1->pObjList.GetHeadPosition();
							while(pos1!=NULL)
							{
								   ptempObj=rel1->pObjList.GetNext(pos1);
								   if((ptempObj!=pObj)&&(ptempObj->type==G_LINE))
								   {
									   pObj1=ptempObj;
									   break;
								   }
							}
							pos1=rel2->pObjList.GetHeadPosition();
							while(pos1!=NULL)
							{
								   ptempObj=rel2->pObjList.GetNext(pos1);
								   if((ptempObj!=pObj)&&(ptempObj->type==G_POINT))
								   {
									   pObj2=ptempObj;
									   break;
								   }
							}
							////the second step, compute the line////////////
							if(fabs(rel2->N_dis_clamp)<0.00000000001)
							{
								switch(rel1->Nconstraintype)
								{
								case LL_PERP://ߴֱ
									((CMyLine*)pObj)->computeABC(-((CMyLine*)pObj1)->ABC[1],
												 ((CMyLine*)pObj1)->ABC[0],((CMyPoint*)pObj2)->m_startpoint);
									break;
								case LL_PARA://ƽ
									((CMyLine*)pObj)->computeABC(((CMyLine*)pObj1)->ABC[0],
												 ((CMyLine*)pObj1)->ABC[1],((CMyPoint*)pObj2)->m_startpoint);
		    						break;
    	 						case LL_ANGLE://н///ҪΪԽǵĲtanܲsin,cos
									{
										CPoint2 point_temp(((CMyLine*)pObj1)->ABC[0],((CMyLine*)pObj1)->ABC[1]);
										CPoint2 point_temp1(cos(rel1->N_dis_clamp),sin(rel1->N_dis_clamp));
										CPoint2 point_temp2;
										point_temp2=point_temp*point_temp1;
										((CMyLine*)pObj)->computeABC(point_temp2.x,point_temp2.y,((CMyPoint*)pObj2)->m_startpoint);	
									}
	    							break;
								default:
				    				ASSERT(FALSE);
								}
							}
							else
							{
							//㵽ȷֱ߾벻Ϊ0
							}
						}
						else if(temp_bool4)///һֱߺȷ
						{						    
							AfxMessageBox("zhixianxianjiao");///symbol the one line can not be decided by the other two lines;
						}
						else if(temp_bool5)///һֱɵԲȷ
						{
						    ///the first step,get the two lines;
							pos1=rel1->pObjList.GetHeadPosition();
							while(pos1!=NULL)
							{
								   ptempObj=rel1->pObjList.GetNext(pos1);
								   if((ptempObj!=pObj)&&(ptempObj->type==G_POINT))
								   {
									   pObj1=ptempObj;
									   break;
								   }
							}
							pos1=rel2->pObjList.GetHeadPosition();
							while(pos1!=NULL)
							{
								   ptempObj=rel2->pObjList.GetNext(pos1);
								   if((ptempObj!=pObj)&&(ptempObj->type==G_CIRCLE))
								   {
									   pObj2=ptempObj;
									   break;
								   }
							}							
							////the second step, compute the line////////////
							{
								 ////һΪе.
								double x,y,x0,y0,x1,y1,x2,y2,x21,y21,x22,y22,r,a,b,x3,y3;
								x0=((CMyCircle*)pObj2)->ABC[0];
								y0=((CMyCircle*)pObj2)->ABC[1];
								r=((CMyCircle*)pObj2)->ABC[2];
								x1=((CMyPoint*)pObj1)->m_startpoint.x;
								y1=((CMyPoint*)pObj1)->m_startpoint.y;
								double dsqrt;
								dsqrt=(y1*y1*x1*x1*r*r+y1*y1*r*r*x0*x0-4*x0*x1*x1*x1*r*r+2*x0*x1*r*r*r*r-4*x0*x0*x0*x1*r*r
									+6*x0*x0*x1*x1*r*r+4*y0*x0*x1*y1*r*r+r*r*y0*y0*x0*x0+x1*x1*y0*y0*r*r-2*y0*x0*x0*y1*r*r
									-2*y0*y0*x0*x1*r*r-2*x1*x1*y0*y1*r*r-2*y1*y1*r*r*x0*x1+x0*x0*x0*x0*r*r-x1*x1*r*r*r*r-x0*x0*r*r*r*r
									+x1*x1*x1*x1*r*r);
								a=(0.5)*(2*y1*y1*y0-4*y0*y0*y1+2*x1*x1*y0+2*y0*y0*y0-4*y0*x0*x1-2*r*r*y0+2*y0*x0*x0+2*y1*r*r
									+2*sqrt(dsqrt))/(-2*y0*y1-2*x0*x1+y0*y0+y1*y1+x0*x0+x1*x1);
								b=(0.5)*(2*y1*y1*y0-4*y0*y0*y1+2*x1*x1*y0+2*y0*y0*y0-4*y0*x0*x1-2*r*r*y0+2*y0*x0*x0+2*y1*r*r
									-2*sqrt(dsqrt))/(-2*y0*y1-2*x0*x1+y0*y0+y1*y1+x0*x0+x1*x1);
								y21=a;
								x21=(-a*y0-a*y1-y0*y0-x0*x0+r*r+y0*y1*x0*x1)/(-x1+x0);
								y22=b;
								x22=(-b*y0-b*y1-y0*y0-x0*x0+r*r+y0*y1*x0*x1)/(-x1+x0);
								////ڶ,жһе.
								if(pObj1->m_listindex==((CMyLine*)pObj)->my_endpoint->m_listindex)
								{
									 x=((CMyLine*)pObj)->my_startpoint->m_startpoint.x;
									 y=((CMyLine*)pObj)->my_startpoint->m_startpoint.y;								 
								}
								else
								{
									 x=((CMyLine*)pObj)->my_endpoint->m_startpoint.x;
									 y=((CMyLine*)pObj)->my_endpoint->m_startpoint.y;
								}
								if(((x21-x)*(x21-x)+(y21-y)*(y21-y))<=((x22-x)*(x22-x)+(y22-y)*(y22-y)))
								{
									 x2=x21;
									 y2=y21;
								}
								else
								{
									 x2=x22;
									 y2=y22;
								}
								///һx1,y1,x,y,x2,y2,x3,y3.
								dsqrt=(4*x1*x2*x*x*y2*y1+4*x1*x2*y*y*y2*y1+4*x1*x2*y*y1*y2*y2+y2*y2*y2*y2*y*y
								   +y1*y1*y2*y2*y2*y2+y2*y2*y2*y2*x1*x1+y1*y1*y1*y1*x*x-2*y1*y1*y1*y1*y1*y+y1*y1*y1*y1*y*y
								   +4*x1*x1*x2*x*y1*y1-2*x1*x2*y*y*y2*y2+4*x1*x1*x1*x2*y2*y1-6*y1*y1*y1*y2*x1*x1-2*y1*y1*y1*y2*x2*x2
								   +7*x1*x1*y1*y1*y2*y2-2*x1*x1*x1*x2*y2*y2-4*y2*y1*y1*y1*x*x+x2*x2*y1*y1*y2*y2+x1*x1*x1*x1*y1*y1
								   -2*y1*y1*y1*y1*x2*x1+y1*y1*y1*y1*y1*y1-4*y1*y1*y1*y1*y1*y2+x2*x2*y1*y1*x1*x1-2*x2*y1*y1*x1*x1*x1
								   +4*x2*y1*y1*y1*x1*y2-2*x1*x2*x*x*y1*y1-2*x2*y1*y1*x1*y2*y2+2*y1*y1*y1*y1*x1*x1+y1*y1*y1*y1*x2*x2
								   +6*y1*y1*y1*y1*y2*y2-4*y1*y1*y1*y2*y2*y2-2*y1*y1*y1*y1*x*x1-2*y2*y2*y2*y2*x*x1+y2*y2*y2*y2*x*x
								   +x1*x1*y*y*y1*y1-2*y2*y2*y2*y2*y*y1+x1*x1*y*y*y2*y2-2*x1*x1*x1*x1*y2*y1+x1*x1*x*x*y2*y2
								   -2*x1*x1*x1*x*y2*y2-2*x1*x1*y*y1*y1*y1+x1*x1*x1*x1*y2*y2-2*x1*x1*y*y*y2*y1+4*x1*x1*y*y1*y1*y2
								   +4*x1*x1*x1*x*y2*y1-2*x1*x1*y*y1*y2*y2+4*x2*x2*x*x1*y2*y1+x1*x1*x*x*y1*y1-2*x1*x1*x1*x*y1*y1
								   -2*x2*x2*y*y1*y2*y2-2*x2*x2*y2*x1*x1*y1+4*x2*x2*y*y1*y1*y2-2*x2*x2*x*x1*y2*y2-2*x1*x1*x*x*y2*y1
								   +x2*x2*x*x*y1*y1+x2*x2*y*y*y2*y2+x2*x2*x*x*y2*y2+x2*x2*y2*y2*x1*x1-2*x2*x2*y*y1*y1*y1
								   +x2*x2*y*y*y1*y1+8*y2*y1*y1*y1*x*x1-12*y2*y2*y1*y1*x*x1-2*x2*x2*x*x1*y1*y1-2*x2*x2*x*x*y2*y1
								   -2*x2*x2*y*y*y2*y1-2*x1*x2*x*x*y2*y2+4*x1*x1*x2*x*y2*y2+4*x1*x2*y*y1*y1*y1-2*x1*x2*y*y*y1*y1
								   -8*x1*x2*y*y1*y1*y2-8*x1*x1*x2*x*y2*y1+6*y2*y2*y1*y1*x*x+6*y2*y2*y1*y1*y*y-4*y2*y2*y2*y1*y*y
								   +8*y2*y2*y2*y1*y1*y-12*y2*y2*y1*y1*y1*y-4*y2*y2*y2*y1*x*x-4*y2*y2*y2*y1*x1*x1+8*y2*y1*y1*y1*y1*y
								   -4*y2*y1*y1*y1*y*y+8*y2*y2*y2*y1*x*x1);
								a = (0.5)*(2*y1*y1*y1-4*x2*y1*x1-4*y1*y1*y2+2*x1*x1*y1+2*x2*x2*y1+2*y1*y2*y2
								   +2*sqrt(dsqrt))/(-2*x1*x2-2*y2*y1+x2*x2+x1*x1+y2*y2+y1*y1);
								b = (0.5)*(2*y1*y1*y1-4*x2*y1*x1-4*y1*y1*y2+2*x1*x1*y1+2*x2*x2*y1+2*y1*y2*y2
								   -2*sqrt(dsqrt))/(-2*x1*x2-2*y2*y1+x2*x2+x1*x1+y2*y2+y1*y1);
								y21=a;
								x21=-(-x2*y1+y2*x1+a*x2-a*x1)/(-y2+y1);
								y22=b;
								x22=-(-x2*y1+y2*x1+b*x2-b*x1)/(-y2+y1);
								if(((x21-x2)*(x21-x2)+(y21-y2)*(y21-y2))>((x22-x2)*(x22-x2)+(y22-y2)*(y22-y2)))
								{
									x3=x22;
									y3=y22;
								}
								else
								{
									x3=x21;
									y3=y21;
								}
								if(pObj1->m_listindex==((CMyLine*)pObj)->my_endpoint->m_listindex)
								{
									 ((CMyLine*)pObj)->my_startpoint->m_startpoint.x=x3;
									 ((CMyLine*)pObj)->my_startpoint->m_startpoint.y=y3;								 
								}
								else
								{
									 ((CMyLine*)pObj)->my_endpoint->m_startpoint.x=x3;
									 ((CMyLine*)pObj)->my_endpoint->m_startpoint.y=y3;
								}
								((CMyLine*)pObj)->computeABC(((CMyLine*)pObj)->my_startpoint,((CMyLine*)pObj)->my_endpoint);
							}
						}
						else if(temp_bool6)///һֱԲ͵ȷ
						{
						    ///the first step,get the two lines;
							pos1=rel1->pObjList.GetHeadPosition();
							while(pos1!=NULL)
							{
								   ptempObj=rel1->pObjList.GetNext(pos1);
								   if((ptempObj!=pObj)&&(ptempObj->type==G_CIRCLE))
								   {
									   pObj1=ptempObj;
									   break;
								   }
							}
							pos1=rel2->pObjList.GetHeadPosition();
							while(pos1!=NULL)
							{
								   ptempObj=rel2->pObjList.GetNext(pos1);
								   if((ptempObj!=pObj)&&(ptempObj->type==G_POINT))
								   {
									   pObj2=ptempObj;
									   break;
								   }
							}							
							////the second step, compute the line////////////
							{
								double x,y,x0,y0,x1,y1,x2,y2,x21,y21,x22,y22,r,a,b,x3,y3;
								x0=((CMyCircle*)pObj1)->ABC[0];
								y0=((CMyCircle*)pObj1)->ABC[1];
								r=((CMyCircle*)pObj1)->ABC[2];
								x1=((CMyPoint*)pObj2)->m_startpoint.x;
								y1=((CMyPoint*)pObj2)->m_startpoint.y;
								double dsqrt;
								dsqrt=(y1*y1*x1*x1*r*r+y1*y1*r*r*x0*x0-4*x0*x1*x1*x1*r*r+2*x0*x1*r*r*r*r-4*x0*x0*x0*x1*r*r
									+6*x0*x0*x1*x1*r*r+4*y0*x0*x1*y1*r*r+r*r*y0*y0*x0*x0+x1*x1*y0*y0*r*r-2*y0*x0*x0*y1*r*r
									-2*y0*y0*x0*x1*r*r-2*x1*x1*y0*y1*r*r-2*y1*y1*r*r*x0*x1+x0*x0*x0*x0*r*r-x1*x1*r*r*r*r-x0*x0*r*r*r*r
									+x1*x1*x1*x1*r*r);
								a=(0.5)*(2*y1*y1*y0-4*y0*y0*y1+2*x1*x1*y0+2*y0*y0*y0-4*y0*x0*x1-2*r*r*y0+2*y0*x0*x0+2*y1*r*r
									+2*sqrt(dsqrt))/(-2*y0*y1-2*x0*x1+y0*y0+y1*y1+x0*x0+x1*x1);
								b=(0.5)*(2*y1*y1*y0-4*y0*y0*y1+2*x1*x1*y0+2*y0*y0*y0-4*y0*x0*x1-2*r*r*y0+2*y0*x0*x0+2*y1*r*r
									-2*sqrt(dsqrt))/(-2*y0*y1-2*x0*x1+y0*y0+y1*y1+x0*x0+x1*x1);
								y21=a;
								x21=-(a*y0-a*y1-y0*y0-x0*x0+r*r+y0*y1+x0*x1)/(-x1+x0);
								y22=b;
								x22=-(b*y0-b*y1-y0*y0-x0*x0+r*r+y0*y1+x0*x1)/(-x1+x0);
								////ڶ,жһе.
								if(pObj2->m_listindex==((CMyLine*)pObj)->my_endpoint->m_listindex)
								{
									 x=((CMyLine*)pObj)->my_startpoint->m_startpoint.x;
									 y=((CMyLine*)pObj)->my_startpoint->m_startpoint.y;								 
								}
								else
								{
									 x=((CMyLine*)pObj)->my_endpoint->m_startpoint.x;
									 y=((CMyLine*)pObj)->my_endpoint->m_startpoint.y;
								}
								if(((x21-x)*(x21-x)+(y21-y)*(y21-y))<=((x22-x)*(x22-x)+(y22-y)*(y22-y)))
								{
									 x2=x21;
									 y2=y21;
								}
								else
								{
									 x2=x22;
									 y2=y22;
								}
								///һx1,y1,x,y,x2,y2,x3,y3.
								dsqrt=(4*x1*x2*x*x*y2*y1+4*x1*x2*y*y*y2*y1+4*x1*x2*y*y1*y2*y2+y2*y2*y2*y2*y*y
								   +y1*y1*y2*y2*y2*y2+y2*y2*y2*y2*x1*x1+y1*y1*y1*y1*x*x-2*y1*y1*y1*y1*y1*y+y1*y1*y1*y1*y*y
								   +4*x1*x1*x2*x*y1*y1-2*x1*x2*y*y*y2*y2+4*x1*x1*x1*x2*y2*y1-6*y1*y1*y1*y2*x1*x1-2*y1*y1*y1*y2*x2*x2
								   +7*x1*x1*y1*y1*y2*y2-2*x1*x1*x1*x2*y2*y2-4*y2*y1*y1*y1*x*x+x2*x2*y1*y1*y2*y2+x1*x1*x1*x1*y1*y1
								   -2*y1*y1*y1*y1*x2*x1+y1*y1*y1*y1*y1*y1-4*y1*y1*y1*y1*y1*y2+x2*x2*y1*y1*x1*x1-2*x2*y1*y1*x1*x1*x1
								   +4*x2*y1*y1*y1*x1*y2-2*x1*x2*x*x*y1*y1-2*x2*y1*y1*x1*y2*y2+2*y1*y1*y1*y1*x1*x1+y1*y1*y1*y1*x2*x2
								   +6*y1*y1*y1*y1*y2*y2-4*y1*y1*y1*y2*y2*y2-2*y1*y1*y1*y1*x*x1-2*y2*y2*y2*y2*x*x1+y2*y2*y2*y2*x*x
								   +x1*x1*y*y*y1*y1-2*y2*y2*y2*y2*y*y1+x1*x1*y*y*y2*y2-2*x1*x1*x1*x1*y2*y1+x1*x1*x*x*y2*y2
								   -2*x1*x1*x1*x*y2*y2-2*x1*x1*y*y1*y1*y1+x1*x1*x1*x1*y2*y2-2*x1*x1*y*y*y2*y1+4*x1*x1*y*y1*y1*y2
								   +4*x1*x1*x1*x*y2*y1-2*x1*x1*y*y1*y2*y2+4*x2*x2*x*x1*y2*y1+x1*x1*x*x*y1*y1-2*x1*x1*x1*x*y1*y1
								   -2*x2*x2*y*y1*y2*y2-2*x2*x2*y2*x1*x1*y1+4*x2*x2*y*y1*y1*y2-2*x2*x2*x*x1*y2*y2-2*x1*x1*x*x*y2*y1
								   +x2*x2*x*x*y1*y1+x2*x2*y*y*y2*y2+x2*x2*x*x*y2*y2+x2*x2*y2*y2*x1*x1-2*x2*x2*y*y1*y1*y1
								   +x2*x2*y*y*y1*y1+8*y2*y1*y1*y1*x*x1-12*y2*y2*y1*y1*x*x1-2*x2*x2*x*x1*y1*y1-2*x2*x2*x*x*y2*y1
								   -2*x2*x2*y*y*y2*y1-2*x1*x2*x*x*y2*y2+4*x1*x1*x2*x*y2*y2+4*x1*x2*y*y1*y1*y1-2*x1*x2*y*y*y1*y1
								   -8*x1*x2*y*y1*y1*y2-8*x1*x1*x2*x*y2*y1+6*y2*y2*y1*y1*x*x+6*y2*y2*y1*y1*y*y-4*y2*y2*y2*y1*y*y
								   +8*y2*y2*y2*y1*y1*y-12*y2*y2*y1*y1*y1*y-4*y2*y2*y2*y1*x*x-4*y2*y2*y2*y1*x1*x1+8*y2*y1*y1*y1*y1*y
								   -4*y2*y1*y1*y1*y*y+8*y2*y2*y2*y1*x*x1);
							   a = (0.5)*(2*y1*y1*y1-4*x2*y1*x1-4*y1*y1*y2+2*x1*x1*y1+2*x2*x2*y1+2*y1*y2*y2
								   +2*sqrt(dsqrt))/(-2*x1*x2-2*y2*y1+x2*x2+x1*x1+y2*y2+y1*y1);
							   b = (0.5)*(2*y1*y1*y1-4*x2*y1*x1-4*y1*y1*y2+2*x1*x1*y1+2*x2*x2*y1+2*y1*y2*y2
								   -2*sqrt(dsqrt))/(-2*x1*x2-2*y2*y1+x2*x2+x1*x1+y2*y2+y1*y1);							
								y21=a;
								x21=-(-x2*y1+y2*x1+a*x2-a*x1)/(-y2+y1);
								y22=b;
								x22=-(-x2*y1+y2*x1+b*x2-b*x1)/(-y2+y1);
								if(((x21-x2)*(x21-x2)+(y21-y2)*(y21-y2))>((x22-x2)*(x22-x2)+(y22-y2)*(y22-y2)))
								{
									x3=x22;
									y3=y22;
								}
								else
								{
									x3=x21;
									y3=y21;
								}
								if(pObj2->m_listindex==((CMyLine*)pObj)->my_endpoint->m_listindex)
								{
									 ((CMyLine*)pObj)->my_startpoint->m_startpoint.x=x3;
									 ((CMyLine*)pObj)->my_startpoint->m_startpoint.y=y3;								 
								}
								else
								{
									 ((CMyLine*)pObj)->my_endpoint->m_startpoint.x=x3;
									 ((CMyLine*)pObj)->my_endpoint->m_startpoint.y=y3;
								}
								((CMyLine*)pObj)->computeABC(((CMyLine*)pObj)->my_startpoint,((CMyLine*)pObj)->my_endpoint);
							}
						}
						else if(temp_bool7)///һֱһֱȷ
						{
						    ///the first step,get all the Obj;
							pos1=rel1->pObjList.GetHeadPosition();
							while(pos1!=NULL)
							{
								   ptempObj=rel1->pObjList.GetNext(pos1);
								   if((ptempObj!=pObj)&&(ptempObj->type==G_POINT))
								   {
									   pObj1=ptempObj;
									   break;
								   }
							}
							pos1=rel2->pObjList.GetHeadPosition();
							while(pos1!=NULL)
							{
								   pObj2=rel2->pObjList.GetNext(pos1);
								   pObj3=rel2->pObjList.GetNext(pos1);
								   pObj4=rel2->pObjList.GetNext(pos1);
								   pObj5=rel2->pObjList.GetNext(pos1);								   
							}							
							////the second step, compute the line////////////
							if((pObj1->type==G_POINT)&&(pObj2->type==G_LINE)&&
								(pObj3->type==G_LINE)&&(pObj4->type==G_LINE)&&(pObj5->type==G_LINE))
							{
								///ȷֱߵбʣȻɵȷߡ
								double dk1,dk2,dangle;
								if(pObj->m_listindex==pObj2->m_listindex)
								{
								     dk1=((CMyLine*)pObj4)->ABC[0]/((CMyLine*)pObj4)->ABC[1];
									 dk2=((CMyLine*)pObj5)->ABC[0]/((CMyLine*)pObj5)->ABC[1];
									 //////////////////////////////////////////////////////
                                     CPoint2 point_temp(((CMyLine*)pObj3)->ABC[0],((CMyLine*)pObj3)->ABC[1]);
									 dangle=atan((dk1-dk2)/(1+dk1*dk2));
								     CPoint2 point_temp1(cos(dangle),sin(dangle));
								     CPoint2 point_temp2;
								     point_temp2=point_temp*point_temp1;
								     ((CMyLine*)pObj2)->computeABC(point_temp2.x,point_temp2.y,
									      ((CMyLine*)pObj3)->my_startpoint->m_startpoint);
								}
								else if(pObj->m_listindex==pObj3->m_listindex)
								{
								     dk1=((CMyLine*)pObj4)->ABC[0]/((CMyLine*)pObj4)->ABC[1];
									 dk2=((CMyLine*)pObj5)->ABC[0]/((CMyLine*)pObj5)->ABC[1];
									 //////////////////////////////////////////////////////
                                     CPoint2 point_temp(((CMyLine*)pObj2)->ABC[0],((CMyLine*)pObj2)->ABC[1]);
									 dangle=atan((dk1-dk2)/(1+dk1*dk2));
								     CPoint2 point_temp1(cos(dangle),sin(dangle));
								     CPoint2 point_temp2;
								     point_temp2=point_temp*point_temp1;
								     ((CMyLine*)pObj3)->computeABC(point_temp2.x,point_temp2.y,
									      ((CMyLine*)pObj2)->my_startpoint->m_startpoint);
								}
								else if(pObj->m_listindex==pObj4->m_listindex)
								{
								     dk1=((CMyLine*)pObj2)->ABC[0]/((CMyLine*)pObj2)->ABC[1];
									 dk2=((CMyLine*)pObj3)->ABC[0]/((CMyLine*)pObj3)->ABC[1];
									 //////////////////////////////////////////////////////
                                     CPoint2 point_temp(((CMyLine*)pObj5)->ABC[0],((CMyLine*)pObj5)->ABC[1]);
									 dangle=atan((dk1-dk2)/(1+dk1*dk2));
								     CPoint2 point_temp1(cos(dangle),sin(dangle));
								     CPoint2 point_temp2;
								     point_temp2=point_temp*point_temp1;
								     ((CMyLine*)pObj4)->computeABC(point_temp2.x,point_temp2.y,
									      ((CMyLine*)pObj5)->my_startpoint->m_startpoint);
								}
								else if(pObj->m_listindex==pObj5->m_listindex)
								{
								     dk1=((CMyLine*)pObj2)->ABC[0]/((CMyLine*)pObj2)->ABC[1];
									 dk2=((CMyLine*)pObj3)->ABC[0]/((CMyLine*)pObj3)->ABC[1];
									 //////////////////////////////////////////////////////
                                     CPoint2 point_temp(((CMyLine*)pObj4)->ABC[0],((CMyLine*)pObj4)->ABC[1]);
									 dangle=atan((dk1-dk2)/(1+dk1*dk2));
								     CPoint2 point_temp1(cos(dangle),sin(dangle));
								     CPoint2 point_temp2;
								     point_temp2=point_temp*point_temp1;
								     ((CMyLine*)pObj5)->computeABC(point_temp2.x,point_temp2.y,
									      ((CMyLine*)pObj4)->my_startpoint->m_startpoint);
								}
								else
								{}
								
							}
						}
						else if(temp_bool8)///LLLP
						{
						    ///the first step,get the all Obj;
							pos1=rel1->pObjList.GetHeadPosition();
							while(pos1!=NULL)
							{
								pObj1=rel1->pObjList.GetNext(pos1);
								pObj2=rel1->pObjList.GetNext(pos1);
								pObj3=rel1->pObjList.GetNext(pos1);
								pObj4=rel1->pObjList.GetNext(pos1);									   
							}
							pos1=rel2->pObjList.GetHeadPosition();
							while(pos1!=NULL)
							{
								   ptempObj=rel2->pObjList.GetNext(pos1);
								   if((ptempObj!=pObj)&&(ptempObj->type==G_POINT))
								   {
									   pObj3=ptempObj;
									   break;
								   }					   
							}							
							////the second step, compute the line////////////
							if((pObj1->type==G_LINE)&&(pObj2->type==G_LINE)&&
								(pObj3->type==G_LINE)&&(pObj4->type==G_LINE)&&(pObj5->type==G_POINT))
							{
								///ȷֱߵбʣȻɵȷߡ
								double dk1,dk2,dangle;
								if(pObj->m_listindex==pObj1->m_listindex)
								{
								     dk1=((CMyLine*)pObj3)->ABC[0]/((CMyLine*)pObj3)->ABC[1];
									 dk2=((CMyLine*)pObj4)->ABC[0]/((CMyLine*)pObj4)->ABC[1];
									 //////////////////////////////////////////////////////
                                     CPoint2 point_temp(((CMyLine*)pObj2)->ABC[0],((CMyLine*)pObj3)->ABC[1]);
									 dangle=atan((dk1-dk2)/(1+dk1*dk2));
								     CPoint2 point_temp1(cos(dangle),sin(dangle));
								     CPoint2 point_temp2;
								     point_temp2=point_temp*point_temp1;
								     ((CMyLine*)pObj1)->computeABC(point_temp2.x,point_temp2.y,
									      ((CMyLine*)pObj2)->my_startpoint->m_startpoint);
								}
								else if(pObj->m_listindex==pObj2->m_listindex)
								{
								     dk1=((CMyLine*)pObj3)->ABC[0]/((CMyLine*)pObj3)->ABC[1];
									 dk2=((CMyLine*)pObj4)->ABC[0]/((CMyLine*)pObj4)->ABC[1];
									 //////////////////////////////////////////////////////
                                     CPoint2 point_temp(((CMyLine*)pObj1)->ABC[0],((CMyLine*)pObj1)->ABC[1]);
									 dangle=atan((dk1-dk2)/(1+dk1*dk2));
								     CPoint2 point_temp1(cos(dangle),sin(dangle));
								     CPoint2 point_temp2;
								     point_temp2=point_temp*point_temp1;
								     ((CMyLine*)pObj2)->computeABC(point_temp2.x,point_temp2.y,
									      ((CMyLine*)pObj1)->my_startpoint->m_startpoint);
								}
								else if(pObj->m_listindex==pObj3->m_listindex)
								{
								     dk1=((CMyLine*)pObj1)->ABC[0]/((CMyLine*)pObj1)->ABC[1];
									 dk2=((CMyLine*)pObj2)->ABC[0]/((CMyLine*)pObj2)->ABC[1];
									 //////////////////////////////////////////////////////
                                     CPoint2 point_temp(((CMyLine*)pObj4)->ABC[0],((CMyLine*)pObj4)->ABC[1]);
									 dangle=atan((dk1-dk2)/(1+dk1*dk2));
								     CPoint2 point_temp1(cos(dangle),sin(dangle));
								     CPoint2 point_temp2;
								     point_temp2=point_temp*point_temp1;
								     ((CMyLine*)pObj3)->computeABC(point_temp2.x,point_temp2.y,
									      ((CMyLine*)pObj4)->my_startpoint->m_startpoint);
								}
								else if(pObj->m_listindex==pObj4->m_listindex)
								{
								     dk1=((CMyLine*)pObj1)->ABC[0]/((CMyLine*)pObj1)->ABC[1];
									 dk2=((CMyLine*)pObj2)->ABC[0]/((CMyLine*)pObj2)->ABC[1];
									 //////////////////////////////////////////////////////
                                     CPoint2 point_temp(((CMyLine*)pObj3)->ABC[0],((CMyLine*)pObj3)->ABC[1]);
									 dangle=atan((dk1-dk2)/(1+dk1*dk2));
								     CPoint2 point_temp1(cos(dangle),sin(dangle));
								     CPoint2 point_temp2;
								     point_temp2=point_temp*point_temp1;
								     ((CMyLine*)pObj4)->computeABC(point_temp2.x,point_temp2.y,
									      ((CMyLine*)pObj3)->my_startpoint->m_startpoint);
								}
								else
								{}
								
							}
						}
						else
						{}
					}
					break;
				case 3://Բ
					{     
						///the first step,get the point and the line;
						CDrawObj*pObj1,*pObj2;
						pos1=rel1->pObjList.GetHeadPosition();
						while(pos1!=NULL)
						{
						   ptempObj=rel1->pObjList.GetNext(pos1);
						   if(ptempObj!=pObj)
						   {
							   pObj1=ptempObj;
							   break;
						   }
					   }
					   pos1=rel2->pObjList.GetHeadPosition();
					   while(pos1!=NULL)
					   {
					       ptempObj=rel2->pObjList.GetNext(pos1);
						   if(ptempObj!=pObj)
						   {
						       pObj2=ptempObj;
							   break;
						   }
					   }
					   //////////////////////////////////////////////
				      BOOL ttemp_bool1,ttemp_bool2,ttemp_bool3,ttemp_bool4,ttemp_bool5,ttemp_bool6;
					  ttemp_bool1=pObj1->type==G_POINT&&pObj2->type==G_POINT;///Բ.
					  ttemp_bool2=pObj1->type==G_POINT&&pObj2->type==G_LINE;///Բֱ
					  ttemp_bool3=pObj1->type==G_LINE&&pObj2->type==G_POINT;///Բֱ
					  ttemp_bool4=pObj1->type==G_LINE&&pObj2->type==G_LINE;
                      ttemp_bool5=pObj1->type==G_POINT&&pObj2->type==G_CIRCLE;//ԲԲ
					  ttemp_bool6=pObj1->type==G_CIRCLE&&pObj2->type==G_POINT;//ԲԲ				
					  if(ttemp_bool1)/////˴Բ㹹.
					  {
						  double x0,y0,x1,y1,r;
                          if(rel1->Nconstraintype==PC_CEN)///pObj1ΪԲ.
						  {
							   x0=((CMyPoint*)pObj1)->m_startpoint.x;
							   y0=((CMyPoint*)pObj1)->m_startpoint.y;
							   x1=((CMyPoint*)pObj2)->m_startpoint.x;
							   y1=((CMyPoint*)pObj2)->m_startpoint.y;
							   r=sqrt((x0-x1)*(x0-x1)+(y0-y1)*(y0-y1));
							   ((CMyCircle*)pObj)->ABC[0]=x0;
							   ((CMyCircle*)pObj)->ABC[1]=y0;
							   ((CMyCircle*)pObj)->ABC[2]=r;
						  }
						  else if(rel2->Nconstraintype==PC_CEN)  ///pObj2ΪԲ.
						  {
							   x0=((CMyPoint*)pObj2)->m_startpoint.x;
							   y0=((CMyPoint*)pObj2)->m_startpoint.y;
							   x1=((CMyPoint*)pObj1)->m_startpoint.x;
							   y1=((CMyPoint*)pObj1)->m_startpoint.y;
							   r=sqrt((x0-x1)*(x0-x1)+(y0-y1)*(y0-y1));
							   ((CMyCircle*)pObj)->ABC[0]=x0;
							   ((CMyCircle*)pObj)->ABC[1]=y0;
							   ((CMyCircle*)pObj)->ABC[2]=r;
						  }
						  else///һԲȷ㶼Բġ 
						  {
						  
						  }						  
					  }
					  if(ttemp_bool2||ttemp_bool3) ////˴һԲһһ߹.
					  {      ///еΪԲ.Ϊ.
                         if(ttemp_bool2)////pObj1Ϊ,pObj2Ϊ.
						 {
							 double x,y,x1,y1,x2,y2,x3,y3,x21,y21,x22,y22,a,b,r,x0,y0;
                             x1=((CMyPoint*)pObj1)->m_startpoint.x;
							 y1=((CMyPoint*)pObj1)->m_startpoint.y;
							 x2=((CMyLine*)pObj2)->my_startpoint->m_startpoint.x;
							 y2=((CMyLine*)pObj2)->my_startpoint->m_startpoint.y;
							 x3=((CMyLine*)pObj2)->my_endpoint->m_startpoint.x;
							 y3=((CMyLine*)pObj2)->my_endpoint->m_startpoint.y; 
							 y=(-x3*y3*x2-x2*y2*x3+y1*y3*y3-2*y3*y1*y2+y3*x1*x3-y3*x1*x2+y2*x3*x3+y1*y2*y2
								 -y2*x1*x3+y2*x1*x2+y3*x2*x2)/(y3*y3-2*y3*y2+y2*y2+x3*x3-2*x2*x3+x2*x2);
							 x=(x2*y3*y3-x2*y3*y2-x3*y3*y2+x3*y3*y1-y3*x2*y1+x3*y2*y2+x1*x2*x2-x3*y1*y2+x2*y1*y2
								 +x1*x3*x3-2*x3*x1*x2)/(y3*y3-2*y3*y2+y2*y2+x3*x3-2*x2*x3+x2*x2);
							 ////////////һ㵽Ĵ,Ϊx,y...Բ.
							 x0=x1;
							 y0=y1;
							 x1=x;
							 y1=y;
							 r=((CMyCircle*)pObj)->ABC[2];
							 double dsqrt;
							 dsqrt=(y0*y0*y0*y0*r*r
								  +y1*y1*y1*y1*r*r+x0*x0*r*r*y1*y1+x0*x0*r*r*y0*y0-4*y1*y1*y1*y0*r*r-4*y1*y0*y0*y0*r*r+6*y1*y1*y0*y0*r*r
								  +x1*x1*r*r*y1*y1+x1*x1*r*r*y0*y0-2*x1*x0*r*r*y1*y1-2*x1*x0*r*r*y0*y0-2*x1*x1*r*r*y1*y0-2*x0*x0*r*r*y1*y0
								  +4*x1*x0*r*r*y1*y0);
							 a=(0.5)*(2*x0*x0*y1+2*x1*x1*y1+2*y1*y0*y0-4*y1*y1*y0-4*x1*y1*x0+2*y1*y1*y1
								 +2*sqrt(dsqrt))/(-2*x1*x0-2*y1*y0+x1*x1+x0*x0+y1*y1+y0*y0);
							 b=(0.5)*(2*x0*x0*y1+2*x1*x1*y1+2*y1*y0*y0-4*y1*y1*y0-4*x1*y1*x0+2*y1*y1*y1
								 +2*sqrt(dsqrt))/(-2*x1*x0-2*y1*y0+x1*x1+x0*x0+y1*y1+y0*y0);
							 y21=a;
							 x21=-(x1*y0-a*x1+a*x0-y1*x0)/(y1-y0);
							 y22=b;
							 x22=-(x1*y0-b*x1+b*x0-y1*x0)/(y1-y0);
                             if((x21>=x0&&x21<=x1&&y21>=y0&&y21<=y1)||(x21<=x0||x21>=x1&&y21<=y0&&y21>=y1))
							 {
								((CMyPoint*)pObj1)->m_startpoint.x=x21;
								((CMyPoint*)pObj1)->m_startpoint.y=y21;
								((CMyCircle*)pObj)->ABC[0]=x21;
								((CMyCircle*)pObj)->ABC[1]=y21;
							 }
							 else
							 {
								((CMyPoint*)pObj1)->m_startpoint.x=x22;
								((CMyPoint*)pObj1)->m_startpoint.y=y22;
								((CMyCircle*)pObj)->ABC[0]=x22;
								((CMyCircle*)pObj)->ABC[1]=y22;
							 }
						 }
						 else///pObj2Ϊ,pObj1Ϊ.
						 {
							 double x,y,x1,y1,x2,y2,x3,y3,x21,y21,x22,y22,a,b,r,x0,y0;
                             x1=((CMyPoint*)pObj2)->m_startpoint.x;
							 y1=((CMyPoint*)pObj2)->m_startpoint.y;
							 x2=((CMyLine*)pObj1)->my_startpoint->m_startpoint.x;
							 y2=((CMyLine*)pObj1)->my_startpoint->m_startpoint.y;
							 x3=((CMyLine*)pObj1)->my_endpoint->m_startpoint.x;
							 y3=((CMyLine*)pObj1)->my_endpoint->m_startpoint.y; 
							 y=(-x3*y3*x2-x2*y2*x3+y1*y3*y3-2*y3*y1*y2+y3*x1*x3-y3*x1*x2+y2*x3*x3+y1*y2*y2
								 -y2*x1*x3+y2*x1*x2+y3*x2*x2)/(y3*y3-2*y3*y2+y2*y2+x3*x3-2*x2*x3+x2*x2);
							 x=(x2*y3*y3-x2*y3*y2-x3*y3*y2+x3*y3*y1-y3*x2*y1+x3*y2*y2+x1*x2*x2-x3*y1*y2+x2*y1*y2
								 +x1*x3*x3-2*x3*x1*x2)/(y3*y3-2*y3*y2+y2*y2+x3*x3-2*x2*x3+x2*x2);
							 ////////////һ㵽Ĵ,Ϊx,y...Բ.
							 x0=x1;
							 y0=y1;
							 x1=x;
							 y1=y;
							 r=((CMyCircle*)pObj)->ABC[2];
							 double dsqrt;
							 dsqrt=(y0*y0*y0*y0*r*r
								  +y1*y1*y1*y1*r*r+x0*x0*r*r*y1*y1+x0*x0*r*r*y0*y0-4*y1*y1*y1*y0*r*r-4*y1*y0*y0*y0*r*r+6*y1*y1*y0*y0*r*r
								  +x1*x1*r*r*y1*y1+x1*x1*r*r*y0*y0-2*x1*x0*r*r*y1*y1-2*x1*x0*r*r*y0*y0-2*x1*x1*r*r*y1*y0-2*x0*x0*r*r*y1*y0
								  +4*x1*x0*r*r*y1*y0);
							 a=(0.5)*(2*x0*x0*y1+2*x1*x1*y1+2*y1*y0*y0-4*y1*y1*y0-4*x1*y1*x0+2*y1*y1*y1
								 +2*sqrt(dsqrt))/(-2*x1*x0-2*y1*y0+x1*x1+x0*x0+y1*y1+y0*y0);
							 b=(0.5)*(2*x0*x0*y1+2*x1*x1*y1+2*y1*y0*y0-4*y1*y1*y0-4*x1*y1*x0+2*y1*y1*y1
								 +2*sqrt(dsqrt))/(-2*x1*x0-2*y1*y0+x1*x1+x0*x0+y1*y1+y0*y0);
							 y21=a;
							 x21=-(x1*y0-a*x1+a*x0-y1*x0)/(y1-y0);
							 y22=b;
							 x22=-(x1*y0-b*x1+b*x0-y1*x0)/(y1-y0);
                             if((x21>=x0&&x21<=x1&&y21>=y0&&y21<=y1)||(x21<=x0||x21>=x1&&y21<=y0&&y21>=y1))
							 {
								((CMyPoint*)pObj2)->m_startpoint.x=x21;
								((CMyPoint*)pObj2)->m_startpoint.y=y21;
								((CMyCircle*)pObj)->ABC[0]=x21;
								((CMyCircle*)pObj)->ABC[1]=y21;
							 }
							 else
							 {
								((CMyPoint*)pObj2)->m_startpoint.x=x22;
								((CMyPoint*)pObj2)->m_startpoint.y=y22;
								((CMyCircle*)pObj)->ABC[0]=x22;
								((CMyCircle*)pObj)->ABC[1]=y22;
							 }
						 }
					  }
					  if(ttemp_bool5||ttemp_bool6) ////˴һԲһһԲ.
					  {
						  if(ttemp_bool5)///pObj1Ϊ.pObj2ΪԲ.
						  {
							  double x1,y1,x21,y21,x22,y22,a,b,r1,r2,x0,y0;
                              //x1=((CMyPoint*)pObj1)->m_startpoint.x;//û
							  //y1=((CMyPoint*)pObj1)->m_startpoint.y;//û
							  x1=((CMyCircle*)pObj2)->ABC[0];
							  y1=((CMyCircle*)pObj2)->ABC[1];
							  r1=((CMyCircle*)pObj2)->ABC[2];
							  x0=((CMyCircle*)pObj)->ABC[0];
							  y0=((CMyCircle*)pObj)->ABC[1];
							  r2=((CMyCircle*)pObj)->ABC[2];
                              if(rel2->Nconstraintype==CC_OUTTAN)///Բ.
							  {
								  double dsqrt;
								  dsqrt=(-2*x1*x0*r1*r1*y0*y0-2*x1*x0*r1*r1*y1*y1-2*x1*x0*r2*r2*y1*y1
									-8*y0*y0*y0*y1*r1*r2+y0*y0*y0*y0*r1*r1+y0*y0*y0*y0*r2*r2+y1*y1*y1*y1*r1*r1
									+y1*y1*y1*y1*r2*r2-4*x0*x0*r1*r2*y0*y1+2*y0*y0*y0*y0*r1*r2+2*y1*y1*y1*y1*r1*r2
									+x1*x1*r2*r2*y1*y1-4*x1*x1*r1*r2*y0*y1+4*x1*x0*r2*r2*y0*y1+4*x1*x0*r1*r1*y0*y1
									-2*x1*x0*r2*r2*y0*y0+2*x0*x0*r1*r2*y1*y1+2*x1*x1*r1*r2*y0*y0-2*x1*x1*r2*r2*y0*y1
									-2*x1*x1*r1*r1*y0*y1+2*x1*x1*r1*r2*y1*y1-4*x1*x0*r1*r2*y0*y0-4*x1*x0*r1*r2*y1*y1
									-8*y0*y1*y1*y1*r1*r2+12*y0*y0*y1*y1*r1*r2+2*x0*x0*r1*r2*y0*y0-2*x0*x0*r2*r2*y0*y1
									-2*x0*x0*r1*r1*y0*y1+8*x1*x0*r1*r2*y0*y1-4*y0*y0*y0*y1*r1*r1-4*y0*y1*y1*y1*r1*r1
									+6*y0*y0*y1*y1*r2*r2+6*y0*y0*y1*y1*r1*r1-4*y0*y0*y0*y1*r2*r2-4*y0*y1*y1*y1*r2*r2
									+x0*x0*r1*r1*y0*y0+x0*x0*r1*r1*y1*y1+x0*x0*r2*r2*y0*y0+x0*x0*r2*r2*y1*y1
									+x1*x1*r1*r1*y0*y0+x1*x1*r1*r1*y1*y1+x1*x1*r2*r2*y0*y0);
								a = (0.5)*(2*y1*y0*y0+2*y1*y1*y1-4*y1*y1*y0-4*x0*y1*x1+2*x0*x0*y1+2*x1*x1*y1
									+2*sqrt(dsqrt))/(-2*x1*x0-2*y0*y1+x0*x0+x1*x1+y0*y0+y1*y1);
								b = (0.5)*(2*y1*y0*y0+2*y1*y1*y1-4*y1*y1*y0-4*x0*y1*x1+2*x0*x0*y1+2*x1*x1*y1
									-2*sqrt(dsqrt))/(-2*x1*x0-2*y0*y1+x0*x0+x1*x1+y0*y0+y1*y1);
								x21=-(-x0*y1+y0*x1+a*x0-a*x1)/(-y0+y1);
								y21=a;
								x22=-(-x0*y1+y0*x1+b*x0-b*x1)/(-y0+y1);
								y22=b;
								//////Ȼһxo,yoȷõ.
								if(((x21-x0)*(x21-x0)+(y21-y0)*(y21-y0))<((x22-x0)*(x22-x0)+(y22-y0)*(y22-y0)))
								{
									 ((CMyCircle*)pObj)->ABC[0]=x21;
									 ((CMyCircle*)pObj)->ABC[1]=y21;
									 ((CMyPoint*)pObj1)->m_startpoint.x=x21;
									 ((CMyPoint*)pObj1)->m_startpoint.y=y21;
								}
								else
								{
									 ((CMyCircle*)pObj)->ABC[0]=x22;
									 ((CMyCircle*)pObj)->ABC[1]=y22;
									 ((CMyPoint*)pObj1)->m_startpoint.x=x22;
									 ((CMyPoint*)pObj1)->m_startpoint.y=y22;
								}
							  }
							  else///Բ.
							  {
								  double dsqrt;
								  dsqrt=(-2*x1*x0*r1*r1*y0*y0-2*x1*x0*r1*r1*y1*y1-2*x1*x0*r2*r2*y1*y1
								  +8*y0*y0*y0*y1*r1*r2+y0*y0*y0*y0*r1*r1+y0*y0*y0*y0*r2*r2+y1*y1*y1*y1*r1*r1
								  +y1*y1*y1*y1*r2*r2+4*x0*x0*r1*r2*y0*y1-2*y0*y0*y0*y0*r1*r2-2*y1*y1*y1*y1*r1*r2
								  +x1*x1*r2*r2*y1*y1+4*x1*x1*r1*r2*y0*y1+4*x1*x0*r2*r2*y0*y1+4*x1*x0*r1*r1*y0*y1
								  -2*x1*x0*r2*r2*y0*y0-2*x0*x0*r1*r2*y1*y1-2*x1*x1*r1*r2*y0*y0-2*x1*x1*r2*r2*y0*y1
								  -2*x1*x1*r1*r1*y0*y1-2*x1*x1*r1*r2*y1*y1+4*x1*x0*r1*r2*y0*y0+4*x1*x0*r1*r2*y1*y1
								  +8*y0*y1*y1*y1*r1*r2-12*y0*y0*y1*y1*r1*r2-2*x0*x0*r1*r2*y0*y0-2*x0*x0*r2*r2*y0*y1
								  -2*x0*x0*r1*r1*y0*y1-8*x1*x0*r1*r2*y0*y1-4*y0*y0*y0*y1*r1*r1-4*y0*y1*y1*y1*r1*r1
								  +6*y0*y0*y1*y1*r2*r2+6*y0*y0*y1*y1*r1*r1-4*y0*y0*y0*y1*r2*r2-4*y0*y1*y1*y1*r2*r2
								  +x0*x0*r1*r1*y0*y0+x0*x0*r1*r1*y1*y1+x0*x0*r2*r2*y0*y0+x0*x0*r2*r2*y1*y1
								  +x1*x1*r1*r1*y0*y0+x1*x1*r1*r1*y1*y1+x1*x1*r2*r2*y0*y0);
							   a = (0.5)*(2*y1*y0*y0+2*y1*y1*y1-4*y1*y1*y0-4*x0*y1*x1+2*x0*x0*y1+2*x1*x1*y1
								  +2*sqrt(dsqrt))/(-2*x1*x0-2*y0*y1+x0*x0+x1*x1+y0*y0+y1*y1);
							   b = (0.5)*(2*y1*y0*y0+2*y1*y1*y1-4*y1*y1*y0-4*x0*y1*x1+2*x0*x0*y1+2*x1*x1*y1
								  -2*sqrt(dsqrt))/(-2*x1*x0-2*y0*y1+x0*x0+x1*x1+y0*y0+y1*y1);
							   x21=(x0*y1-y0*x1-a*x0+a*x1)/(-y0+y1);
							   y21=a;
							   x22=(x0*y1-y0*x1-b*x0+b*x1)/(-y0+y1);
							   y22=b;
							   if(((x21-x0)*(x21-x0)+(y21-y0)*(y21-y0))<((x22-x0)*(x22-x0)+(y22-y0)*(y22-y0)))
								{
									 ((CMyCircle*)pObj)->ABC[0]=x21;
									 ((CMyCircle*)pObj)->ABC[1]=y21;
									 ((CMyPoint*)pObj1)->m_startpoint.x=x21;
									 ((CMyPoint*)pObj1)->m_startpoint.y=y21;
								}
								else
								{
									 ((CMyCircle*)pObj)->ABC[0]=x22;
									 ((CMyCircle*)pObj)->ABC[1]=y22;
									 ((CMyPoint*)pObj1)->m_startpoint.x=x22;
									 ((CMyPoint*)pObj1)->m_startpoint.y=y22;
								}
							  }
						  }
						  else ///pObj1ΪԲ,pObj2Ϊ.
						  {
							  double x1,y1,x21,y21,x22,y22,a,b,r1,r2,x0,y0;
                              //x1=((CMyPoint*)pObj2)->m_startpoint.x;//û
							  //y1=((CMyPoint*)pObj2)->m_startpoint.y;//û
							  x1=((CMyCircle*)pObj1)->ABC[0];
							  y1=((CMyCircle*)pObj1)->ABC[1];
							  r1=((CMyCircle*)pObj1)->ABC[2];
							  x0=((CMyCircle*)pObj)->ABC[0];
							  y0=((CMyCircle*)pObj)->ABC[1];
							  r2=((CMyCircle*)pObj)->ABC[2];
							  if(rel1->Nconstraintype==CC_OUTTAN)///Բ.
							  {
								  double dsqrt;
								  dsqrt=(-2*x1*x0*r1*r1*y0*y0-2*x1*x0*r1*r1*y1*y1-2*x1*x0*r2*r2*y1*y1
									-8*y0*y0*y0*y1*r1*r2+y0*y0*y0*y0*r1*r1+y0*y0*y0*y0*r2*r2+y1*y1*y1*y1*r1*r1
									+y1*y1*y1*y1*r2*r2-4*x0*x0*r1*r2*y0*y1+2*y0*y0*y0*y0*r1*r2+2*y1*y1*y1*y1*r1*r2
									+x1*x1*r2*r2*y1*y1-4*x1*x1*r1*r2*y0*y1+4*x1*x0*r2*r2*y0*y1+4*x1*x0*r1*r1*y0*y1
									-2*x1*x0*r2*r2*y0*y0+2*x0*x0*r1*r2*y1*y1+2*x1*x1*r1*r2*y0*y0-2*x1*x1*r2*r2*y0*y1
									-2*x1*x1*r1*r1*y0*y1+2*x1*x1*r1*r2*y1*y1-4*x1*x0*r1*r2*y0*y0-4*x1*x0*r1*r2*y1*y1
									-8*y0*y1*y1*y1*r1*r2+12*y0*y0*y1*y1*r1*r2+2*x0*x0*r1*r2*y0*y0-2*x0*x0*r2*r2*y0*y1
									-2*x0*x0*r1*r1*y0*y1+8*x1*x0*r1*r2*y0*y1-4*y0*y0*y0*y1*r1*r1-4*y0*y1*y1*y1*r1*r1
									+6*y0*y0*y1*y1*r2*r2+6*y0*y0*y1*y1*r1*r1-4*y0*y0*y0*y1*r2*r2-4*y0*y1*y1*y1*r2*r2
									+x0*x0*r1*r1*y0*y0+x0*x0*r1*r1*y1*y1+x0*x0*r2*r2*y0*y0+x0*x0*r2*r2*y1*y1
									+x1*x1*r1*r1*y0*y0+x1*x1*r1*r1*y1*y1+x1*x1*r2*r2*y0*y0);
							   a = (0.5)*(2*y1*y0*y0+2*y1*y1*y1-4*y1*y1*y0-4*x0*y1*x1+2*x0*x0*y1+2*x1*x1*y1
									+2*sqrt(dsqrt))/(-2*x1*x0-2*y0*y1+x0*x0+x1*x1+y0*y0+y1*y1);
								b = (0.5)*(2*y1*y0*y0+2*y1*y1*y1-4*y1*y1*y0-4*x0*y1*x1+2*x0*x0*y1+2*x1*x1*y1
									-2*sqrt(dsqrt))/(-2*x1*x0-2*y0*y1+x0*x0+x1*x1+y0*y0+y1*y1);
								x21=-(-x0*y1+y0*x1+a*x0-a*x1)/(-y0+y1);
								y21=a;
								x22=-(-x0*y1+y0*x1+b*x0-b*x1)/(-y0+y1);
								y22=b;
								//////Ȼһxo,yoȷõ.
								if(((x21-x0)*(x21-x0)+(y21-y0)*(y21-y0))<((x22-x0)*(x22-x0)+(y22-y0)*(y22-y0)))
								{
									 ((CMyCircle*)pObj)->ABC[0]=x21;
									 ((CMyCircle*)pObj)->ABC[1]=y21;
									 ((CMyPoint*)pObj2)->m_startpoint.x=x21;
									 ((CMyPoint*)pObj2)->m_startpoint.y=y21;
								}
								else
								{
									 ((CMyCircle*)pObj)->ABC[0]=x22;
									 ((CMyCircle*)pObj)->ABC[1]=y22;
									 ((CMyPoint*)pObj2)->m_startpoint.x=x22;
									 ((CMyPoint*)pObj2)->m_startpoint.y=y22;
								}
							  }
							  else///Բ.
							  {
								  double dsqrt;
								  dsqrt=(-2*x1*x0*r1*r1*y0*y0-2*x1*x0*r1*r1*y1*y1-2*x1*x0*r2*r2*y1*y1
								  +8*y0*y0*y0*y1*r1*r2+y0*y0*y0*y0*r1*r1+y0*y0*y0*y0*r2*r2+y1*y1*y1*y1*r1*r1
								  +y1*y1*y1*y1*r2*r2+4*x0*x0*r1*r2*y0*y1-2*y0*y0*y0*y0*r1*r2-2*y1*y1*y1*y1*r1*r2
								  +x1*x1*r2*r2*y1*y1+4*x1*x1*r1*r2*y0*y1+4*x1*x0*r2*r2*y0*y1+4*x1*x0*r1*r1*y0*y1
								  -2*x1*x0*r2*r2*y0*y0-2*x0*x0*r1*r2*y1*y1-2*x1*x1*r1*r2*y0*y0-2*x1*x1*r2*r2*y0*y1
								  -2*x1*x1*r1*r1*y0*y1-2*x1*x1*r1*r2*y1*y1+4*x1*x0*r1*r2*y0*y0+4*x1*x0*r1*r2*y1*y1
								  +8*y0*y1*y1*y1*r1*r2-12*y0*y0*y1*y1*r1*r2-2*x0*x0*r1*r2*y0*y0-2*x0*x0*r2*r2*y0*y1
								  -2*x0*x0*r1*r1*y0*y1-8*x1*x0*r1*r2*y0*y1-4*y0*y0*y0*y1*r1*r1-4*y0*y1*y1*y1*r1*r1
								  +6*y0*y0*y1*y1*r2*r2+6*y0*y0*y1*y1*r1*r1-4*y0*y0*y0*y1*r2*r2-4*y0*y1*y1*y1*r2*r2
								  +x0*x0*r1*r1*y0*y0+x0*x0*r1*r1*y1*y1+x0*x0*r2*r2*y0*y0+x0*x0*r2*r2*y1*y1
								  +x1*x1*r1*r1*y0*y0+x1*x1*r1*r1*y1*y1+x1*x1*r2*r2*y0*y0);
							  a = (0.5)*(2*y1*y0*y0+2*y1*y1*y1-4*y1*y1*y0-4*x0*y1*x1+2*x0*x0*y1+2*x1*x1*y1
								  +2*sqrt(dsqrt))/(-2*x1*x0-2*y0*y1+x0*x0+x1*x1+y0*y0+y1*y1);
							   b = (0.5)*(2*y1*y0*y0+2*y1*y1*y1-4*y1*y1*y0-4*x0*y1*x1+2*x0*x0*y1+2*x1*x1*y1
								  -2*sqrt(dsqrt))/(-2*x1*x0-2*y0*y1+x0*x0+x1*x1+y0*y0+y1*y1);
							   x21=(x0*y1-y0*x1-a*x0+a*x1)/(-y0+y1);
							   y21=a;
							   x22=(x0*y1-y0*x1-b*x0+b*x1)/(-y0+y1);
							   y22=b;
							   if(((x21-x0)*(x21-x0)+(y21-y0)*(y21-y0))<((x22-x0)*(x22-x0)+(y22-y0)*(y22-y0)))
								{
									 ((CMyCircle*)pObj)->ABC[0]=x21;
									 ((CMyCircle*)pObj)->ABC[1]=y21;
									 ((CMyPoint*)pObj2)->m_startpoint.x=x21;
									 ((CMyPoint*)pObj2)->m_startpoint.y=y21;
								}
								else
								{
									 ((CMyCircle*)pObj)->ABC[0]=x22;
									 ((CMyCircle*)pObj)->ABC[1]=y22;
									 ((CMyPoint*)pObj2)->m_startpoint.x=x22;
									 ((CMyPoint*)pObj2)->m_startpoint.y=y22;
								}
							  }
						  }
					  }					 
                    }
					break;			
				}
			}
			break;	
			case 3:///һObjrelationȷ
			{			
                BOOL bool1,bool2,bool3,bool4;				
			    pos1=temp_Nlink.GetHeadPosition();
                rel1=temp_Nlink.GetNext(pos1);
				rel2=temp_Nlink.GetNext(pos1);
				rel3=temp_Nlink.GetNext(pos1);
				switch(pObj->type)
				{
				    case G_CIRCLE:///to the circle,begin judge the three relation;
					{
					    
						bool1=rel1->Nconstraintype==PC_DIS&&rel2->Nconstraintype==PC_DIS&&rel3->Nconstraintype==PC_DIS;
						bool2=rel1->Nconstraintype==LC_TAN&&rel2->Nconstraintype==LC_TAN&&rel3->Nconstraintype==PC_DIS;
						bool3=rel1->Nconstraintype==CC_INTAN&&rel2->Nconstraintype==CC_INTAN&&rel3->Nconstraintype==CC_INTAN;
						bool4=rel1->Nconstraintype==CC_OUTTAN&&rel2->Nconstraintype==CC_OUTTAN&&rel3->Nconstraintype==CC_OUTTAN;
						if(bool1)///ppp;ȷһԲ
						{
							///the first step,get the three points;
                            pos1=rel1->pObjList.GetHeadPosition();
							while(pos1!=NULL)
							{
							   ptempObj=rel1->pObjList.GetNext(pos1);
							   if((ptempObj!=pObj)&&(ptempObj->type==G_POINT))
							   {
								   pObj1=ptempObj;
								   break;
							   }
							}
						   pos1=rel2->pObjList.GetHeadPosition();
						   while(pos1!=NULL)
						   {
							   ptempObj=rel2->pObjList.GetNext(pos1);
							   if((ptempObj!=pObj)&&(ptempObj->type==G_POINT))
							   {
								   pObj2=ptempObj;
								   break;
							   }
						   }
						   pos1=rel3->pObjList.GetHeadPosition();
						   while(pos1!=NULL)
						   {
							   ptempObj=rel3->pObjList.GetNext(pos1);
							   if((ptempObj!=pObj)&&(ptempObj->type==G_POINT))
							   {
								   pObj3=ptempObj;
								   break;
							   }
						   }
							/// the second step,compute the circle;
						   if((pObj1->type==G_POINT)&&(pObj2->type==G_POINT)&&(pObj3->type==G_POINT))
						   {
						      double x1,y1,x2,y2,x3,y3,x,y;
							  x1=((CMyPoint*)pObj1)->m_startpoint.x;
							  y1=((CMyPoint*)pObj1)->m_startpoint.y;
							  x2=((CMyPoint*)pObj2)->m_startpoint.x;
							  y2=((CMyPoint*)pObj2)->m_startpoint.y;
							  x3=((CMyPoint*)pObj3)->m_startpoint.x;
							  y3=((CMyPoint*)pObj3)->m_startpoint.y;
							  ///compute the circle point of the circle frop the three points;
							  x = 0.5*(-y1*x2*x2+y3*x2*x2+y2*y2*y3+y1*x3*x3-y2*y3*y3-x3*x3*y2-x1*x1*y3-y2*y2*y1+x1*x1*y2
								  +y3*y3*y1+y2*y1*y1-y3*y1*y1)/(x1*y2-x1*y3-y1*x2+y1*x3-x3*y2+y3*x2);
							  y = -0.5*(-x1*x2*x2-x1*y2*y2+x1*x3*x3+x1*y3*y3+x1*x1*x2-x1*x1*x3+y1*y1*x2-y1*y1*x3+x3*x2*x2
								  +x3*y2*y2-x3*x3*x2-y3*y3*x2)/(x1*y2-x1*y3-y1*x2+y1*x3-x3*y2+y3*x2);
							  ((CMyCircle*)pObj)->ABC[0]=x;
							  ((CMyCircle*)pObj)->ABC[1]=y;
							  ((CMyCircle*)pObj)->ABC[2]=sqrt((x-x1)*(x-x1)+(y-y1)*(y-y1));
							  ((CMyCircle*)pObj)->my_startpoint->m_startpoint.x=x;
                              ((CMyCircle*)pObj)->my_startpoint->m_startpoint.y=y;
						   }
						      
						}
						
					}
					break;
				}
			}
			break;
		}
		pObj->NFlag=1;
	}

	pos = m_transformedlist.GetHeadPosition();
	while(pos != NULL)
	{
	    pObj = m_transformedlist.GetNext(pos);
	    pObj->NFlag=0;//visited flag λ
	}
	Invalidate(TRUE);
	//////////////////////////////////////////////////////////////////////	
}
////////////////////////////////////////////////////////////
///*************************************************///
void CDrawView::Select(CDrawObj* pObj, BOOL bAdd)
{
	if (!bAdd)
	{
		OnUpdate(NULL, HINT_UPDATE_SELECTION, NULL);
		m_selection.RemoveAll();
	}

	if (pObj == NULL || IsSelected(pObj))
		return;

	m_selection.AddTail(pObj);
	InvalObj(pObj);
}
///*************************************************///
void CDrawView::Remove(CDrawObj* pObj)
{
	POSITION pos = m_selection.Find(pObj);
	if (pos != NULL)
	{
		m_selection.RemoveAt(pos);
	    delete pObj;
	}
}
///////////////////////////////////////////////////////
CMyPoint* CDrawView::Intersection(CMyLine* tline1,
                                  CMyLine* tline2)
//p1  line1ƽеֱp2tline2ƽеĽ㱻  
{ 
	return Intersection_Paral_Paral(tline1->my_startpoint,tline1,
		                     tline2->my_startpoint,tline2);
}
///////////////////////////////////////////////////////
CMyPoint* CDrawView::Intersection_Paral_Paral(CMyPoint* p1, CMyLine* tline1,
                                              CMyPoint* p4, CMyLine* tline4)
{
    CMyPoint* p2=tline1->my_startpoint;
	CMyPoint* p3=tline1->my_endpoint;
	//CPoint2 intersection;

	CMyPoint* p5=tline4->my_startpoint;
	CMyPoint* p6=tline4->my_endpoint;

	int k=sol_lll(p3->y() - p2->y(),
	       p2->x()-p3->x(),
	       p1->y()*(p3->x()-p2->x())-p1->x()*(p3->y()-p2->y()),
		   p6->y()-p5->y(),
		   p5->x()-p6->x(),
		   p4->y()*(p6->x()-p5->x())-p4->x()*(p6->y()-p5->y())
		   );
    if (k>0) 
    {
        //X(ptn) = sol_x;  Y(ptn) = sol_y;  
		m_intersection=new CMyPoint(intersection);
		m_intersection->ptype=1;     //ptype=1ʾֱֱߵĽ
		
		m_intersection->m_conect1=tline1;
		m_intersection->m_conect2=tline4;
		return m_intersection;
    }
	else
	{
	    return NULL;
	}
}
CPoint2* CDrawView::Intersection_Paral_Verti(CMyPoint* p1, CMyLine* tline1,
                                              CMyPoint* p4, CMyLine* tline4,int PType)
//p1  line1ƽеֱp4tline4ֱĽ㱻  
{ 
    CMyPoint* p2=tline1->my_startpoint;
	CMyPoint* p3=tline1->my_endpoint;
	
		
    CMyPoint* p5=tline4->my_startpoint;
	CMyPoint* p6=tline4->my_endpoint;

	int k=sol_lll(p3->y()-p2->y(),
	       p2->x()-p3->x(),
	       p1->y()*(p3->x()-p2->x())-p1->x()*(p3->y()-p2->y()),
		   p6->x()-p5->x(),
		   p6->y()-p5->y(),
		   p4->y()*(p5->y()-p6->y())-p4->x()*(p5->x()-p6->x())
		   );
    if (k>0) 
    {
        //X(ptn) = sol_x;  Y(ptn) = sol_y;  
		//m_intersection=new CMyPoint(intersection);
		//m_intersection->ptype=PType;     //ptype=1ʾֱֱߵĽ
		return intersection;
    }
	else
	{
	    return NULL;
	}
}
CPoint2* CDrawView::Intersection_Paral_Verti(CPoint2 p1, CMyLine* tline1,
                                              CPoint2 p4, CMyLine* tline4,int PType)
//p1 this lineƽеֱp4tlineֱĽ㱻  
{ 
    CMyPoint* p2=tline1->my_startpoint;
	CMyPoint* p3=tline1->my_endpoint;
	
	
    CMyPoint* p5=tline4->my_startpoint;
	CMyPoint* p6=tline4->my_endpoint;

	int k=sol_lll(p3->y()-p2->y(),
	       p2->x()-p3->x(),
	       p1.y*(p3->x()-p2->x())-p1.x*(p3->y()-p2->y()),
		   p6->x()-p5->x(),
		   p6->y()-p5->y(),
		   p4.y*(p5->y()-p6->y())+p4.x*(p5->x()-p6->x())
		   );
    if (k>0) 
    {
        //X(ptn) = sol_x;  Y(ptn) = sol_y;  
		//m_intersection=new CMyPoint(intersection);
		//m_intersection->ptype=PType;     //ptype=1ʾֱֱߵĽ
		return intersection;
    }
	else
	{
	    return NULL;
	}
}

BOOL CDrawView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// default preparation
	return DoPreparePrinting(pInfo);
}

void CDrawView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add extra initialization before printing
	GetDocument()->ComputePageSize();
}

void CDrawView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add cleanup after printing
}

void CDrawView::OnDestroy()
{
	// Deactivate the item on destruction; this is important
	// when a splitter view is being used.
   CScrollView::OnDestroy();
   COleClientItem* pActiveItem = GetDocument()->GetInPlaceActiveItem(this);
   if (pActiveItem != NULL && pActiveItem->GetActiveView() == this)
   {
      pActiveItem->Deactivate();
      ASSERT(GetDocument()->GetInPlaceActiveItem(this) == NULL);
   }
}


/////////////////////////////////////////////////////////////////////////////
// OLE Client support and commands

BOOL CDrawView::IsSelected(const CObject* pDocItem) const
{
	CDrawObj* pDrawObj = (CDrawObj*)pDocItem;
	if (pDocItem->IsKindOf(RUNTIME_CLASS(CDrawItem)))
		pDrawObj = ((CDrawItem*)pDocItem)->m_pDrawObj;
	return m_selection.Find(pDrawObj) != NULL;
}
void CDrawView::OnInsertObject()
{
	// Invoke the standard Insert Object dialog box to obtain information
	//  for new CDrawItem object.
	COleInsertDialog dlg;
	if (dlg.DoModal() != IDOK)
		return;

	BeginWaitCursor();

	CDrawItem* pItem = NULL;
	TRY
	{
		// Create new item connected to this document.
		CDrawDoc* pDoc = GetDocument();
		ASSERT_VALID(pDoc);
		pItem = new CDrawItem(pDoc);
		ASSERT_VALID(pItem);

		// Initialize the item from the dialog data.
		if (!dlg.CreateItem(pItem))
			AfxThrowMemoryException();  // any exception will do
		ASSERT_VALID(pItem);
		
        if (dlg.GetSelectionType() == COleInsertDialog::createNewItem)
			pItem->DoVerb(OLEIVERB_SHOW, this);

		ASSERT_VALID(pItem);

		// As an arbitrary user interface design, this sets the selection
		//  to the last item inserted.

		// TODO: reimplement selection as appropriate for your application

		m_pSelection = pItem;   // set selection to last inserted item
		pDoc->UpdateAllViews(NULL);
	}
	CATCH(CException, e)
	{
		if (pItem != NULL)
		{
			ASSERT_VALID(pItem);
			pItem->Delete();
		}
		AfxMessageBox(IDP_FAILED_TO_CREATE);
	}
	END_CATCH

	EndWaitCursor();
}
void CDrawView::Intersection1(CMyLine* tline1,
                                  CMyLine* tline2)
//to avoid new allocate CMyPoint once drawing 
{
	if((tline1!=NULL)&&(tline2!=NULL))
	{
		int icount=GetDocument()->GetObjects()->GetCount();
		if((tline1->m_listindex>0)&&(tline1->m_listindex<icount)&&(tline2->m_listindex>0)&&(tline2->m_listindex<icount))
        {
			CMyPoint* p1=tline1->my_startpoint;
			CMyPoint* p2=tline1->my_startpoint;
			CMyPoint* p3=tline1->my_endpoint;
			//CPoint2 intersection;

			CMyPoint* p4=tline2->my_startpoint;
			CMyPoint* p5=tline2->my_startpoint;
			CMyPoint* p6=tline2->my_endpoint;

			int k=sol_lll(p3->y()-p2->y(), p2->x()-p3->x(),
				   p1->y()*(p3->x()-p2->x())-p1->x()*(p3->y()-p2->y()),
				   p6->y()-p5->y(), p5->x()-p6->x(),
				   p4->y()*(p6->x()-p5->x())-p4->x()*(p6->y()-p5->y()));
		}
	}
}

// The following command handler provides the standard keyboard
//  user interface to cancel an in-place editing session.  Here,
//  the container (not the server) causes the deactivation.
void CDrawView::OnCancelEditCntr()
{
	// Close any in-place active item on this view.
	COleClientItem* pActiveItem = GetDocument()->GetInPlaceActiveItem(this);
	if (pActiveItem != NULL)
	{
		pActiveItem->Close();
	}
	ASSERT(GetDocument()->GetInPlaceActiveItem(this) == NULL);
}

// Special handling of OnSetFocus and OnSize are required for a container
//  when an object is being edited in-place.
void CDrawView::OnSetFocus(CWnd* pOldWnd)
{
	COleClientItem* pActiveItem = GetDocument()->GetInPlaceActiveItem(this);
	if (pActiveItem != NULL &&
		pActiveItem->GetItemState() == COleClientItem::activeUIState)
	{
		// need to set focus to this item if it is in the same view
		CWnd* pWnd = pActiveItem->GetInPlaceWindow();
		if (pWnd != NULL)
		{
			pWnd->SetFocus();   // don't call the base class
			return;
		}
	}

	CScrollView::OnSetFocus(pOldWnd);
}

void CDrawView::OnSize(UINT nType, int cx, int cy)
{
	CScrollView::OnSize(nType, cx, cy);
	CDrawDoc* pDoc = GetDocument();
	COleClientItem* pActiveItem = GetDocument()->GetInPlaceActiveItem(this);
	if (pActiveItem != NULL)
		pActiveItem->SetItemRects();
}
/////////////////////////////////////////////////////////////////////////////
// CDrawView diagnostics
#ifdef _DEBUG
void CDrawView::AssertValid() const
{
	CScrollView::AssertValid();
}
void CDrawView::Dump(CDumpContext& dc) const
{
	CScrollView::Dump(dc);
}
//////////////////////////////////////////////////////////////////
CDrawDoc* CDrawView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CDrawDoc)));
	return (CDrawDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CDrawView message handlers

void CDrawView::OnContextMenu(CWnd* pWnd, CPoint point) 
{
	// TODO: Add your message handler code here
	// make sure window is active
	GetParentFrame()->ActivateFrame();

	CPoint local = point;
	ScreenToClient(&local);
	ClientToDoc(local);

	CDrawObj* pObj;
	pObj = GetDocument()->ObjectAt(local);
	if(pObj != NULL)
	{
	    if(!IsSelected(pObj))
			Select( pObj, FALSE );			// reselect item if appropriate
		UpdateWindow();

		CMenu menu;
		if (menu.LoadMenu(ID_POPUP_MENU))
		{
			CMenu* pPopup = menu.GetSubMenu(0);
			ASSERT(pPopup != NULL);

			pPopup->TrackPopupMenu(TPM_RIGHTBUTTON | TPM_LEFTALIGN,
								   point.x, point.y,
								   AfxGetMainWnd()); // route commands through main window
		}
	}
	else
	{
	    	COleClientItem* pActiveItem = GetDocument()->GetInPlaceActiveItem(this);
	        if (pActiveItem != NULL)
			{
		        // if we found one, deactivate it
		        pActiveItem->Close();
			}
	        ASSERT(GetDocument()->GetInPlaceActiveItem(this) == NULL);

	        // escape also brings us back into select mode
	        //ReleaseCapture();

	        CDrawTool* pTool = CDrawTool::FindTool(CDrawTool::c_drawShape);
	        if (pTool != NULL)
		    pTool->OnCancel();
			//////////the same function with Esc//////////////////////////
			m_selection.RemoveAll();
	        OnUpdate(NULL, HINT_UPDATE_WINDOW, NULL);
			///////////////////////////////////
			//SetCapture();

	        //CDrawTool::c_drawShape = selection;
	}
}

void CDrawView::OnDrawMycircle() 
{
	// TODO: Add your command handler code here
	CDrawTool::c_drawShape = mycircle;
}

void CDrawView::OnDrawMyline() 
{
	// TODO: Add your command handler code here
	CDrawTool::c_drawShape = myline;
}

void CDrawView::OnDrawMypoint() 
{
	// TODO: Add your command handler code here
	CDrawTool::c_drawShape = mypoint;
}

void CDrawView::OnDrawPolygon() 
{
	// TODO: Add your command handler code here
	CDrawTool::c_drawShape = poly;
}

void CDrawView::OnDrawSelect() 
{
	// TODO: Add your command handler code here
	CDrawTool::c_drawShape = selection;
}


/////úɾ
void CDrawView::OnEditClear() 
{
	// TODO: Add your command handler code here
	// update all the views before the selection goes away
	GetDocument()->UpdateAllViews(NULL, HINT_DELETE_SELECTION, &m_selection);
	OnUpdate(NULL, HINT_UPDATE_SELECTION, NULL);
	///because we change the link relation,so we must change the delete function.
	///according the principle(1:delete the point after delete the line,
	///2,to a point,if its natural_relation>=2,cannot be deleted,or its link--line
	///'s natural_relation<=2,can not be delete.
	////ȻԼ,ɾ
	POSITION pos,pos1,pos11,pos2,ppos,ppos1,ppos2;
	CDrawObj*ptempObj ,*pObj;
	RELATION *rel,*temprel,*rel1;
	pos1= m_selection.GetHeadPosition();
	while (pos1 != NULL)
	{
		pos2=pos1;
		pObj = m_selection.GetNext(pos1); 
		int iJudge1(0),iJudge2(0);
		if(((pObj->type==1)&&(pObj->Nlink.GetCount()>0)))
		{
		   AfxMessageBox("ɾӦɾֱ֮"); 
		}
		else
		{
			///׼ɾ1,the first step,delete the relation,
			///2,the second step,delete the obj;		
            pos=pObj->Nlink.GetHeadPosition();
			while(pos!=NULL)
			{    
				 pos11=pos;
			     rel=pObj->Nlink.GetNext(pos);
				 pObj->Nlink.RemoveAt(pos11);
				 ///delete the relation who in the nlink of other obj;
                 ppos=GetDocument()->m_objects.GetHeadPosition();
				 while(ppos!=NULL)
				 {
				      ptempObj=GetDocument()->m_objects.GetNext(ppos);
					  ppos1=ptempObj->Nlink.GetHeadPosition();
					  while(ppos1!=NULL)
					  {
					     ppos2=ppos1;
						 rel1=ptempObj->Nlink.GetNext(ppos1);
						 if(rel1==rel)
						 {
						     ptempObj->Nlink.RemoveAt(ppos2);
						 }
					  }
				 }
				 ////delete the relation who in the m_relationlist.
				 ppos=GetDocument()->m_RelationList.GetHeadPosition();
				 while(ppos!=NULL)
				 {
					 ppos1=ppos;
				     temprel=GetDocument()->m_RelationList.GetNext(ppos);
					 if(temprel==rel)
					 {
						 GetDocument()->m_RelationList.RemoveAt(ppos1);
					 }
				 }
				 delete rel;
			}
			m_selection.RemoveAt(pos2);
			///delete the obj who in the m_objects;
			ppos=GetDocument()->m_objects.GetHeadPosition();
			while(ppos!=NULL)
			{
			    ppos1=ppos;
			    ptempObj=GetDocument()->m_objects.GetNext(ppos);
				if(ptempObj==pObj)
				{
				     GetDocument()->m_objects.RemoveAt(ppos1);
				}
			}
			delete pObj;
			//////ɾıԡ			
		}
	}
	m_selection.RemoveAll();
}

void CDrawView::OnEditConstruction() 
{
	// TODO: Add your command handler code here
	 ///ȶl_AddRelationListгʼ.***************/
	   int k=l_AddRelationList.GetCount(); 
       POSITION Gaoposition=GetDocument()->GetObjects()->GetHeadPosition();
	   while(Gaoposition!=NULL)
	   {
	       CDrawObj* GaoObj=GetDocument()->GetObjects()->GetNext(Gaoposition);
		   if((GaoObj->m_listindex>=k))
		   {		   
			   l_AddRelationList.AddTail(GaoObj);
		   }
	   }	   
	///Լ**************************///
	//ȷȻϵĵһߵǰ
	// TODO: Add your command handler code here
	
	//AbstractLinesFrom(m_selection);
    int temp_choosed=m_selection.GetCount();
	if((temp_choosed==3)||(temp_choosed==4))
    {
		if(temp_choosed==3)
		{
		   	POSITION pos=m_selection.GetHeadPosition();
			CDrawObj* pObj1 = m_selection.GetNext(pos);
			CDrawObj* pObj2 = m_selection.GetNext(pos);
			CDrawObj* pObj3 = m_selection.GetNext(pos);
			BOOL temp_bool=(pObj1->type==G_POINT&&pObj2->type==G_POINT
				&&pObj3->type==G_POINT);
			BOOL temp_bool1=(pObj1->type==G_LINE&&pObj2->type==G_LINE
				&&pObj3->type==G_LINE);
			if(temp_bool)///symbol the four point,the distance of two point equal the 
						////distance of the other two point;
			{
				CConstruction mydlg;		   
    	   		int id=mydlg.DoModal();
				if(id==IDOK)
				{
					if(mydlg.m_para_perp==6) 
					{
						 AddRelation(SS_DIS,1,mydlg.m_dis_clamp,I_ZERO,CDD(pObj1),CDD(pObj2),CDD(pObj3));
					}
				}			
			}
			else if(temp_bool1)///symbol the angle of two line equal the angle of the other line.
			{
				CConstruction mydlg;		   
           		int id=mydlg.DoModal();
				if(id==IDOK)
				{
					if(mydlg.m_para_perp==6) 
					{
						 AddRelation(AA_ANGLE,1,mydlg.m_dis_clamp,I_ZERO,CDD(pObj1),CDD(pObj2),CDD(pObj3));
					}
				}	
			}
			else {}
		}
		else 
		{
			POSITION pos=m_selection.GetHeadPosition();
			CDrawObj* pObj1 = m_selection.GetNext(pos);
			CDrawObj* pObj2 = m_selection.GetNext(pos);
			CDrawObj* pObj3 = m_selection.GetNext(pos);
			CDrawObj* pObj4 = m_selection.GetNext(pos);
			BOOL temp_bool=(pObj1->type==G_POINT&&pObj2->type==G_POINT
				&&pObj3->type==G_POINT&&pObj4->type==G_POINT);
			BOOL temp_bool1=(pObj1->type==G_LINE&&pObj2->type==G_LINE
				&&pObj3->type==G_LINE&&pObj4->type==G_LINE);
			if(temp_bool)///symbol the four point,the distance of two point equal the 
						////distance of the other two point;
			{
				CConstruction mydlg;		   
    	   		int id=mydlg.DoModal();
				if(id==IDOK)
				{
					if(mydlg.m_para_perp==6) 
					{
						 AddRelation(SS_DIS,1,mydlg.m_dis_clamp,I_ZERO,CDD(pObj1),CDD(pObj2),CDD(pObj3),CDD(pObj4));
					}
				}			
			}
			else if(temp_bool1)///symbol the angle of two line equal the angle of the other line.
			{
				CConstruction mydlg;		   
           		int id=mydlg.DoModal();
				if(id==IDOK)
				{
					if(mydlg.m_para_perp==6) 
					{
						 AddRelation(AA_ANGLE,1,mydlg.m_dis_clamp,I_ZERO,CDD(pObj1),CDD(pObj2),CDD(pObj3),CDD(pObj4));
					}
				}	
			}
			else {}
		}
	}	
	else if(temp_choosed==2)
	{
    	POSITION pos = m_selection.GetHeadPosition();
		CDrawObj* pObj1 = m_selection.GetNext(pos);
        CDrawObj* pObj2 = m_selection.GetNext(pos);
	    BOOL temp_bool=(pObj1->type==G_POINT&&pObj2->type==G_LINE)||(pObj1->type==G_LINE&&pObj2->type==G_POINT);
        //ѡеǵֱ
		if(temp_bool)//¼ѡobjͬһʱֻһֹϵ
		{            //ûйϵnew֮
	        CConstruction mydlg;
		    RELATION * TEMP=pObj1->PrepareConstruction(pObj2);
		    //mydlg.m_dis_clamp//ʼֵķΧʸСɽ
    		RELATION * temp1;
            RELATION * temp2;
        	if(TEMP==NULL)//pObj1,pObj2ûϵ
			{
				int id=mydlg.DoModal();
		        if(id==IDOK)
				{	
					if(mydlg.m_para_perp==7)///Եֱֹϵϵеϵ
					{
					      ///ӵֱߵеԼжϸõ
						  ///ֱǷоԼУɾȻеԼ
                          int iJudge(0),iFound(0);
						  POSITION pos=GetDocument()->m_RelationList.GetHeadPosition();
						  while(pos!=NULL)
						  {
						      RELATION* rel=GetDocument()->m_RelationList.GetNext(pos);
							  iFound=0;
							  POSITION pos1=rel->pObjList.GetHeadPosition();
							  while(pos1!=NULL)
							  {
							       CDrawObj*ptempObj=rel->pObjList.GetNext(pos1);
								   if((ptempObj==pObj1)||(ptempObj==pObj2))
								   {
									   iFound++;
								   }
							  }
							  if(iFound==2)
							  {
                                  GetDocument()->DeleteRelation(rel);
							      break;
							  }
						  }
						  if(pObj1->type==G_POINT)
						  {
							  ((CMyPoint*)pObj1)->ptype=5;
						      AddRelation(PL_MID,1,0,I_ZERO,pObj1,pObj2);
						  }
						  else
						  {
							  ((CMyPoint*)pObj2)->ptype=5;
							  AddRelation(PL_MID,1,0,I_ZERO,pObj2,pObj1);
						  }
					}
					else
					{
					     AddRelation(PL_DIS,1,mydlg.m_dis_clamp,I_ZERO,pObj1,pObj2);
					}
				}
				
			}
			else if(TEMP->Nconstraintype!=0)//Ȼϵ
			{                               //¹ϵ
			   temp1=TEMP;
			   temp2=pObj2->PrepareConstruction(pObj1);
			
               int id=mydlg.DoModal();
		       if(id==IDOK)
			   {				   
				   AddRelation(PL_DIS,1,0,I_ZERO,pObj1,pObj2);
			   }
			}
		}


        temp_bool=pObj1->type==1 && pObj2->type==1;
		if(temp_bool)//
		{
		    CConstruction mydlg;
			int id=mydlg.DoModal();
			if(id==IDOK)
			{
			    //mydlg.m_dis_clamp//ʼֵķΧʸСɽ
				///************************************************///
				AddRelation(PP_DIS,1,mydlg.m_dis_clamp,I_ZERO,CDD(pObj1),CDD(pObj2));
			}
		}
        temp_bool=pObj1->type==2 && pObj2->type==2;
	    if(temp_bool)
		{
		    CConstruction mydlg;
	        int id=mydlg.DoModal();
	        if(id==IDOK)
			{  	
	             switch(mydlg.m_para_perp)
				 {
	              case 0:// ߴֱ
		              ///////////////////////////from lhuang
					  {
					     AddRelation(LL_PERP,1,90,I_ZERO,CDD(pObj1),CDD(pObj2));
					     AddConstructionToList(pObj1,pObj2,2,mydlg.m_dis_clamp);
					  }				
					  /////////////////////////from lhuang////////////
		              break;
	              case 1:// ƽ
                      ///////////////////////////from lhuang
					  {						 
					    AddRelation(LL_PARA,1,0,I_ZERO,CDD(pObj1),CDD(pObj2));
					    AddConstructionToList(pObj1,pObj2,3,mydlg.m_dis_clamp);
					  }					 
		              break;
				  case 2://ƽзǴֱ
					  {					
					     AddRelation(LL_ANGLE,1,mydlg.m_dis_clamp*PI/180,I_ZERO,CDD(pObj1),CDD(pObj2));
					     AddConstructionToList(pObj1,pObj2,4,mydlg.m_dis_clamp);
					  }
					  break;
	              default:
		              break;
				 }
			}
		}
		////////////Add by qlin begin for circle/////////
		///////ӵԲԼ.Բ.
		temp_bool=(pObj1->type==3 && pObj2->type==1)||(pObj1->type==1 && pObj2->type==3);
		if(temp_bool)
		{		   
            CConstruction mydlg;
		    RELATION * TEMP=pObj1->PrepareConstruction(pObj2);
		    //mydlg.m_dis_clamp//ʼֵķΧʸСɽ
    		RELATION * temp1;
            RELATION * temp2;
        	if(TEMP==NULL)//pObj1,pObj2ûϵ
			{
				int id=mydlg.DoModal();
		        if(id==IDOK)
				{
					if(mydlg.m_para_perp==3)/////ôԲ.
					{
						AddRelation(PC_DIS,1,0,I_ZERO,CDD(pObj1),CDD(pObj2));
					} 
				}				
			}
			else if(TEMP->Nconstraintype!=0)//Ȼϵ
			{                               //¹ϵ
			   temp1=TEMP;
			   temp2=pObj2->PrepareConstruction(pObj1);			
               int id=mydlg.DoModal();
		       if(id==IDOK)
			   {
				   if(mydlg.m_para_perp==3)
				   {					   
					   AddRelation(PC_DIS,1,0,I_ZERO,CDD(pObj1),CDD(pObj2));
				   }
			   }
			}           
		}
		//////Բֱ֮Լ.
        temp_bool=((pObj1->type==3 && pObj2->type==2)||(pObj1->type==2 && pObj2->type==3));
		if(temp_bool)
		{
		    CConstruction mydlg;
		    RELATION * TEMP=pObj1->PrepareConstruction(pObj2);
		   	RELATION * temp1;
            RELATION * temp2;
        	if(TEMP==NULL)//pObj1,pObj2ûϵ
			{
				int id=mydlg.DoModal();
		        if(id==IDOK)
				{
					if((mydlg.m_para_perp==4)||(mydlg.m_para_perp==5))/////ôֱߺԲ.
					{
						AddRelation(LC_TAN,1,0,I_ZERO,CDD(pObj1),CDD(pObj2));
					} 
				}				
			}
			else if(TEMP->Nconstraintype!=0)//Ȼϵ
			{                               //¹ϵ
			   temp1=TEMP;
			   temp2=pObj2->PrepareConstruction(pObj1);			
               int id=mydlg.DoModal();
		       if(id==IDOK)
			   {
				   if(mydlg.m_para_perp==4)
				   {					  
					   AddRelation(LC_TAN,1,0,I_ZERO,CDD(pObj1),CDD(pObj2));
				   }
			   }
			}           
		}
		//////ԲԲ֮Լ.
		temp_bool=pObj1->type==3 && pObj2->type==3;
	    if(temp_bool)
		{
		    CConstruction mydlg;
		    RELATION * TEMP=pObj1->PrepareConstruction(pObj2);
		   	RELATION * temp1;
            RELATION * temp2;
        	if(TEMP==NULL)//pObj1,pObj2ûϵ
			{
				int id=mydlg.DoModal();
		        if(id==IDOK)
				{
					if(mydlg.m_para_perp==4)/////ôԲԲ.
					{					
						AddRelation(CC_OUTTAN,1,0,I_ZERO,CDD(pObj1),CDD(pObj2));
					} 
					if(mydlg.m_para_perp==5)/////ôԲԲ.
					{						
						 AddRelation(CC_INTAN,1,0,I_ZERO,CDD(pObj1),CDD(pObj2));
					} 
				}				
			}
			else if(TEMP->Nconstraintype!=0)//Ȼϵ
			{                               //¹ϵ
			   temp1=TEMP;
			   temp2=pObj2->PrepareConstruction(pObj1);			
               int id=mydlg.DoModal();
		       if(id==IDOK)
			   {
				   if(mydlg.m_para_perp==4)
				   {					  
						AddRelation(CC_OUTTAN,1,0,I_ZERO,CDD(pObj1),CDD(pObj2));
				   }
				   if(mydlg.m_para_perp==5)
				   {					   
						AddRelation(CC_INTAN,1,0,I_ZERO,CDD(pObj1),CDD(pObj2));
				   }
			   }
			} 
		}
		////////////Add by qlin end for circle///////////		
	}
	else if(temp_choosed==1)
	{
		POSITION pos = m_selection.GetHeadPosition();
		CDrawObj* pObj = m_selection.GetNext(pos);
		//if the chosen one was a line
		BOOL temp_bool=pObj->type;		
		//////////////////////by qlin begin////////////////////////////
		/////////////////˴Ϊ޸Բİ뾶.
		if(temp_bool==G_CIRCLE)
		{		   
			CConstruction mydlg;
			int id=mydlg.DoModal();
			if(id==IDOK)
			{				
                ((CMyCircle*)pObj)->m_radius=mydlg.m_dis_clamp;
				((CMyCircle*)pObj)->ABC[2]=mydlg.m_dis_clamp;
			}
		}
		else if(temp_bool==G_POINT)
		{
		     CConstruction mydlg;
			 mydlg.m_bStatic=pObj->bStatic;
			 int id=mydlg.DoModal();
			 if(id==IDOK)
			 { 
				 pObj->bStatic=mydlg.m_bStatic;			           			  
			 }
		}
		//////////////////////by qlin end///////////////////////////
	}
	CDrawObjList* m_objects= GetDocument()->GetObjects();
	//GetTranformedList(m_objects,1);
	GetConstraintList(m_objects);//Ϊm_objects,Ϊm_transformedlist	
//	Invalidate(TRUE);
}

void CDrawView::OnEditCopy() 
{
	// TODO: Add your command handler code here
	ASSERT_VALID(this);
	ASSERT(m_cfDraw != NULL);

	// Create a shared file and associate a CArchive with it
	CSharedFile file;
	CArchive ar(&file, CArchive::store);

	// Serialize selected objects to the archive
	m_selection.Serialize(ar);
	ar.Close();

	COleDataSource* pDataSource = NULL;
	TRY
	{
		pDataSource = new COleDataSource;
		// put on local format instead of or in addation to
		pDataSource->CacheGlobalData(m_cfDraw, file.Detach());

		// if only one item and it is a COleClientItem then also
		// paste in that format
		CDrawObj* pDrawObj = m_selection.GetHead();
		if (m_selection.GetCount() == 1 &&
			pDrawObj->IsKindOf(RUNTIME_CLASS(CDrawOleObj)))
		{
			CDrawOleObj* pDrawOle = (CDrawOleObj*)pDrawObj;
			pDrawOle->m_pClientItem->GetClipboardData(pDataSource, FALSE);
		}
		pDataSource->SetClipboard();
	}
	CATCH_ALL(e)
	{
		delete pDataSource;
		THROW_LAST();
	}
	END_CATCH_ALL
}

void CDrawView::OnEditCut() 
{
	// TODO: Add your command handler code here
	OnEditCopy();
	OnEditClear();
}

void CDrawView::OnEditIntsction() 
{
    ///˴Ϊֱཻߡ
	///޸ģҪһֱߺһԲĽ㣻
	AbstractLinesFrom(m_selection);
    if(m_abstractofline.GetCount()==2)
	{
    	POSITION pos = m_abstractofline.GetHeadPosition();
		CDrawObj* pObj1 = m_abstractofline.GetNext(pos);
        CDrawObj* pObj2 = m_abstractofline.GetNext(pos);
	
	    if(pObj1->type==G_LINE && pObj2->type==G_LINE&& 
		    (NULL!=Intersection((CMyLine*)pObj1,(CMyLine*)pObj2)))
		{
		    GetDocument()->Add(m_intersection);
			//////////add by qlin begin/////////////////////////////////
			{              
				AddRelation(PL_DIS,1,0,I_ZERO,CDD(pObj1),CDD(m_intersection));
				AddRelation(PL_DIS,1,0,I_ZERO,CDD(pObj2),CDD(m_intersection));				
			}
			////////////add by qlin end////////////////////////////////////////////////	
			///////////////////////////////////////////////////////////////////////////
            Select(m_intersection,TRUE);
		    m_lineofintersection1 = new CMyLine(m_intersection,((CMyLine*)pObj1)->my_startpoint);
		    m_lineofintersection2 = new CMyLine(m_intersection,((CMyLine*)pObj2)->my_startpoint);		 
	        Select(m_lineofintersection1,TRUE);		  
	        Select(m_lineofintersection2,TRUE);			
            GetTransformedList(GetDocument()->GetObjects(),2);
            ////////////////////////////////////////////////////////////////////////////////////
		}
	}
	else if(m_selection.GetCount()==2)
	{
	    POSITION pos = m_selection.GetHeadPosition();
		CDrawObj* pObj1 = m_selection.GetNext(pos);
        CDrawObj* pObj2 = m_selection.GetNext(pos);
        if((pObj1->type==G_LINE && pObj2->type==G_CIRCLE)||(pObj1->type==G_CIRCLE&&pObj2->type==G_LINE))
		{              
	        ///////////////////////////////////////
            int iEnd=IntersectionLineAndCircle(pObj1,pObj2);
			if(iEnd==1)
			{
				CDrawObj*pObjLine,*pObjCircle;
				if(pObj1->type==G_LINE)
				{
					 pObjLine=pObj1;
					 pObjCircle=pObj2;
				}
				else
				{
					pObjLine=pObj2;
					pObjCircle=pObj1;
				}
				GetDocument()->Add(m_intersection);
				{
					AddRelation(PL_DIS,1,0,I_ZERO,CDD(pObjLine),CDD(m_intersection));
					AddRelation(PC_DIS,1,0,I_ZERO,CDD(pObjCircle),CDD(m_intersection));	
				}
			}
		}
	}
	else
	{
	    m_abstractofline.RemoveAll();//please select two lines with shift
	}
}
void CDrawView::OnEditMidpoint() 
{
	// TODO: Add your command handler code here
	CDrawTool::c_drawShape = mypoint;
    m_bool_midpoint=TRUE;
}

void CDrawView::OnEditParalle() 
{
	// TODO: Add your command handler code here
	CMyLine* pObj=Paralle(m_selection);
	if(pObj!=NULL)
	{
	    /*GetDocument()->Add(pObj->my_endpoint);
        Select(pObj->my_endpoint,TRUE);*/
	    GetDocument()->Add(pObj);
        Select(pObj,TRUE);
	    Invalidate();
	}
	else
	{
	    ;//please select a point and a line with shift
	}
}

void CDrawView::OnEditPaste() 
{
	// TODO: Add your command handler code here
	COleDataObject dataObject;
	dataObject.AttachClipboard();

	// invalidate current selection since it will be deselected
	OnUpdate(NULL, HINT_UPDATE_SELECTION, NULL);
	m_selection.RemoveAll();
	if (dataObject.IsDataAvailable(m_cfDraw))
	{
		PasteNative(dataObject);

		// now add all items in m_selection to document
		POSITION pos = m_selection.GetHeadPosition();
		while (pos != NULL)
			GetDocument()->Add(m_selection.GetNext(pos));
	}
	else
		PasteEmbedded(dataObject, GetInitialPosition().TopLeft() );

	GetDocument()->SetModifiedFlag();

	// invalidate new pasted stuff
	GetDocument()->UpdateAllViews(NULL, HINT_UPDATE_SELECTION, &m_selection);
}

void CDrawView::OnEditProperties() 
{
	// TODO: Add your command handler code here
	if (m_selection.GetCount() == 1 && CDrawTool::c_drawShape == selection)
	{
		CDrawTool* pTool = CDrawTool::FindTool(CDrawTool::c_drawShape);
		ASSERT(pTool != NULL);
		pTool->OnEditProperties(this);
	}
}

void CDrawView::OnEditSelectAll() 
{
	// TODO: Add your command handler code here
	CDrawObjList* pObList = GetDocument()->GetObjects();
	POSITION pos = pObList->GetHeadPosition();
	while (pos != NULL)
		Select(pObList->GetNext(pos), TRUE);
}

void CDrawView::OnEditVertical() 
{
	// TODO: Add your command handler code here
	CMyLine* pObj=Vertical(m_selection);
	if(pObj!=NULL)
	{	    
	    GetDocument()->Add(pObj);
        Select(pObj,TRUE);
	    Invalidate();
	}
	else
	{
	    ;//please select a point and a line with shift
	}
}

void CDrawView::OnEditVerticalfoot() 
{
	// TODO: Add your command handler code here
	CMyLine* pObj=VerticalFoot(m_selection);
	if(pObj!=NULL)
	{
	    /*GetDocument()->Add(pObj->my_endpoint);
        Select(pObj->my_endpoint,TRUE);*/
	    GetDocument()->Add(pObj);
        Select(pObj,TRUE);
	    Invalidate();
	}
	else
	{
	    ;//please select a point and a line with shift
	}
}

BOOL CDrawView::OnEraseBkgnd(CDC* pDC) 
{
	// TODO: Add your message handler code here and/or call default
	
	return TRUE;
}

void CDrawView::OnLButtonDblClk(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
	if (!m_bActive)
		return;
	CDrawTool* pTool = CDrawTool::FindTool(CDrawTool::c_drawShape);
	if (pTool != NULL)
		pTool->OnLButtonDblClk(this, nFlags, point);
}

void CDrawView::OnLButtonDown(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
	CPoint local = point;
	ClientToDoc(local);
	//////////////////////////////////////////////////////////////
	if (!m_bActive)
		return;
	CDrawTool* pTool = CDrawTool::FindTool(CDrawTool::c_drawShape);
	if (pTool != NULL)
		pTool->OnLButtonDown(this, nFlags, point);
	switch(m_CurrentMove)
	{
	   case 0:
		   {}
		   break;
	   case 1:
		   {		  
	             m_PointOld=local;
	             m_Dragging=1;			
		   }
		   break;
	   case 2:
		   {
	              m_PointOld=local;
	              m_Dragging=1;
		   }
		   break;
	   case 3:
		   {
		          m_PointOld=local;
	              m_Dragging=1;
		   }
		   break;
	   case 10:////ѡ㡣
		   {		       	
				CDrawObj* pObj;
				POSITION pos=m_selection.GetHeadPosition();
				while(pos!=NULL)
				{
					pObj=m_selection.GetNext(pos);
					if(pObj->type==1)
					{
						int itemp(0);
						POSITION pp=GetDocument()->m_ObjDriveList.GetHeadPosition();
						while(pp!=NULL)
						{
							CDrawObj*ptemp=GetDocument()->m_ObjDriveList.GetNext(pp);
							if(pObj->m_listindex==ptemp->m_listindex)
							{
								 itemp=1;
							}
						}
						if(itemp==0)
							GetDocument()->m_ObjDriveList.AddTail(pObj);
					}
				}
		   }
		   break;
	   case 11:
		   { 
			   CDrawObj*pObj;
			   POSITION pos=m_selection.GetHeadPosition();
			   while(pos!=NULL)
			   {
					 CDrawObj*ptempObj=m_selection.GetNext(pos);
					 if(ptempObj->type==2)
					 {
						  pObj=ptempObj;
						  pos=GetDocument()->m_ObjDriveList.GetTailPosition();
						  while(pos!=NULL)
						  {
							  CDrawObj*ptemp=GetDocument()->m_ObjDriveList.GetPrev(pos);
							  if(ptemp->iDriveTrace==-1)
							  {
								   ptemp->iDriveTrace=pObj->m_listindex;
								   break;
							  }
						  }
					 }
				 }
		   }
		   break;
	   case 12:///·ΪԲ
		   {
				 CDrawObj*pObj;
				 POSITION pos=m_selection.GetHeadPosition();
				 while(pos!=NULL)
				 {
					 CDrawObj*ptempObj=m_selection.GetNext(pos);
					 if(ptempObj->type==3)
					 {
						  pObj=ptempObj;
						  pos=GetDocument()->m_ObjDriveList.GetTailPosition();
						  while(pos!=NULL)
						  {
							  CDrawObj*ptemp=GetDocument()->m_ObjDriveList.GetPrev(pos);
							  if(ptemp->iDriveTrace==-1)
							  {
								   ptemp->iDriveTrace=pObj->m_listindex;
								   break;
							  }
						  }
					 }
				 }		 				
		   }
		   break;
	   case 13:///·ΪԻͼΡ
		   {
		  
		   }
		   break;
	   case 14:///켣Ϊ㡣
		   { 	    
				 POSITION pos=m_selection.GetHeadPosition();
				 while(pos!=NULL)
				 {
					 CDrawObj*ptempObj=m_selection.GetNext(pos);
					 if(ptempObj->type==1)
					 {
						 int itemp(0);
						 POSITION pp=GetDocument()->m_LocusList.GetHeadPosition();
						 while(pp!=NULL)
						 {
							 CDrawObj*ptemp=GetDocument()->m_LocusList.GetNext(pp);
							 if(ptemp->m_listindex==ptempObj->m_listindex)
								 itemp=1;
						 }
						 if(itemp==0)
							   GetDocument()->m_LocusList.AddTail(ptempObj);                 
					 }
				 }
		   }
		   break;
	   case 15:///켣Ϊߡ
		   {
				 POSITION pos=m_selection.GetHeadPosition();
				 while(pos!=NULL)
				 {
					 CDrawObj*ptempObj=m_selection.GetNext(pos);
					 if(ptempObj->type==2)
					 {
						 int itemp(0);
						 POSITION pp=GetDocument()->m_LocusList.GetHeadPosition();
						 while(pp!=NULL)
						 {
							 CDrawObj*ptemp=GetDocument()->m_LocusList.GetNext(pp);
							 if(ptemp->m_listindex==ptempObj->m_listindex)
								 itemp=1;
						 }
						 if(itemp==0)
							   GetDocument()->m_LocusList.AddTail(ptempObj);  
					 }
				 }
		   }
		   break;
	   case 16:///켣ΪԲ
		   {	
				 POSITION pos=m_selection.GetHeadPosition();
				 while(pos!=NULL)
				 {
					 CDrawObj*ptempObj=m_selection.GetNext(pos);
					 if(ptempObj->type==3)
					 {
						 int itemp(0);
						 POSITION pp=GetDocument()->m_LocusList.GetHeadPosition();
						 while(pp!=NULL)
						 {
							 CDrawObj*ptemp=GetDocument()->m_LocusList.GetNext(pp);
							 if(ptemp->m_listindex==ptempObj->m_listindex)
								 itemp=1;
						 }
						 if(itemp==0)
							   GetDocument()->m_LocusList.AddTail(ptempObj);  
					 }
				 }						
		   }
		   break;
	   case T_TAN_CENTR:////εġ
		   {
		        CDrawObj* pObj1,*pObj2,*pObj3;		        
		        if(m_selection.GetCount()==3)
				{
					POSITION pos=m_selection.GetHeadPosition();
					while(pos!=NULL)
					{
			    		pObj1=m_selection.GetNext(pos);
						pObj2=m_selection.GetNext(pos);
						pObj3=m_selection.GetNext(pos);
					}
					if((pObj1->type==G_POINT)&&(pObj2->type==G_POINT)&&(pObj3->type==G_POINT))
					{
						CMyPoint*ptempPoint=new CMyPoint;
						GetDocument()->Add(ptempPoint);					
						double x1,y1,x2,y2,x3,y3,x,y;
						x1=((CMyPoint*)pObj1)->m_startpoint.x;
						y1=((CMyPoint*)pObj1)->m_startpoint.y;
						x2=((CMyPoint*)pObj2)->m_startpoint.x;
						y2=((CMyPoint*)pObj2)->m_startpoint.y;
						x3=((CMyPoint*)pObj3)->m_startpoint.x;
						y3=((CMyPoint*)pObj3)->m_startpoint.y;
						x=(x1+x2+x3)/3;
						y=(y1+y2+y3)/3;
						ptempPoint->m_startpoint.x=x;
						ptempPoint->m_startpoint.y=y;
						AddRelation(PPPP_CENTR,2,0,I_ZERO,CDD(pObj1),CDD(pObj2),CDD(pObj3),CDD(ptempPoint));					
					}
			   }
		   }
		   break;
	   case T_TAN_CIRCUM:///ġ
		   {		                   
					CDrawObj* pObj1,*pObj2,*pObj3;
					if(m_selection.GetCount()==3)
					{
						POSITION pos=m_selection.GetHeadPosition();
						while(pos!=NULL)
						{
						    pObj1=m_selection.GetNext(pos);
						    pObj2=m_selection.GetNext(pos);
							pObj3=m_selection.GetNext(pos);						
						}
						if((pObj1->type==G_POINT)&&(pObj2->type==G_POINT)&&(pObj3->type==G_POINT))
						{
								CMyPoint*ptempPoint=new CMyPoint;
								GetDocument()->Add(ptempPoint);							
								double x1,y1,x2,y2,x3,y3,x,y;
								x1=((CMyPoint*)pObj1)->m_startpoint.x;
								y1=((CMyPoint*)pObj1)->m_startpoint.y;
								x2=((CMyPoint*)pObj2)->m_startpoint.x;
								y2=((CMyPoint*)pObj2)->m_startpoint.y;
								x3=((CMyPoint*)pObj3)->m_startpoint.x;
								y3=((CMyPoint*)pObj3)->m_startpoint.y;
								x = 0.5*(x1*x1*y2-x1*x1*y3+y1*x3*x3+x2*x2*y3+y1*y3*y3+y2*y2*y3-y1*x2*x2+y1*y1*y2
								-y1*y2*y2-y2*y3*y3-y2*x3*x3-y1*y1*y3)/(-x1*y3-x2*y1+x2*y3+x1*y2+x3*y1-x3*y2);
								y = 0.5*(-x1*x3*x3+x3*y1*y1-x1*y3*y3-x2*x1*x1-x3*y2*y2-x2*y1*y1+x2*x3*x3+x1*y2*y2
								+x2*y3*y3+x1*x2*x2-x3*x2*x2+x3*x1*x1)/(-x1*y3-x2*y1+x2*y3+x1*y2+x3*y1-x3*y2);
								ptempPoint->m_startpoint.x=x;
								ptempPoint->m_startpoint.y=y;
		                        AddRelation(PPPP_CIRCUM,2,0,I_ZERO,CDD(pObj1),CDD(pObj2),CDD(pObj3),CDD(ptempPoint)); 					
						}
				   }
		   }
		   break;
	   case T_TAN_ORTHO:///δġ
		   {	
				CDrawObj* pObj1,*pObj2,*pObj3;
				if(m_selection.GetCount()==3)
				{
					POSITION pos=m_selection.GetHeadPosition();
					while(pos!=NULL)
					{
					   pObj1=m_selection.GetNext(pos);
					   pObj2=m_selection.GetNext(pos);
					   pObj3=m_selection.GetNext(pos);
					}
					if((pObj1->type==G_POINT)&&(pObj2->type==G_POINT)&&(pObj3->type==G_POINT))
					{						
							CMyPoint*ptempPoint=new CMyPoint;
							GetDocument()->Add(ptempPoint);
							double x1,y1,x2,y2,x3,y3,x,y;
							x1=((CMyPoint*)pObj1)->m_startpoint.x;
							y1=((CMyPoint*)pObj1)->m_startpoint.y;
							x2=((CMyPoint*)pObj2)->m_startpoint.x;
							y2=((CMyPoint*)pObj2)->m_startpoint.y;
							x3=((CMyPoint*)pObj3)->m_startpoint.x;
							y3=((CMyPoint*)pObj3)->m_startpoint.y;
							x=(-x1*x2*y1-x3*x1*y3+x1*x3*y1+x1*y2*x2+y1*y1*y3-y1*y3*y3+x2*x3*y3
							-x2*x3*y2-y1*y1*y2+y1*y2*y2+y2*y3*y3-y2*y2*y3)/(-x1*y3-x2*y1+x2*y3+x1*y2+x3*y1-x3*y2);
							y=-(x3*x1*x1+x2*y2*y1-x1*y2*y1+x1*y1*y3-x1*x3*x3-x2*x1*x1+x3*y2*y3-x3*y1*y3+x1*x2*x2
							-x3*x2*x2+x2*x3*x3-x2*y2*y3)/(-x1*y3-x2*y1+x2*y3+x1*y2+x3*y1-x3*y2);
							ptempPoint->m_startpoint.x=x;
							ptempPoint->m_startpoint.y=y;
							AddRelation(PPPP_ORTHO,2,0,I_ZERO,CDD(pObj1),CDD(pObj2),CDD(pObj3),CDD(ptempPoint));											
					}
			   }			    			
		   }
		   break;
	   case T_TAN_INCEN:///
		   {				
				CDrawObj* pObj1,*pObj2,*pObj3;
				if(m_selection.GetCount()==3)
				{
					POSITION pos=m_selection.GetHeadPosition();
					while(pos!=NULL)
					{			
					    pObj1=m_selection.GetNext(pos);
					    pObj2=m_selection.GetNext(pos);
						pObj3=m_selection.GetNext(pos);						
					}
					if((pObj1->type==G_POINT)&&(pObj2->type==G_POINT)&&(pObj3->type==G_POINT))
					{						
							CMyPoint*ptempPoint=new CMyPoint;
							GetDocument()->Add(ptempPoint);
							double x1,y1,x2,y2,x3,y3,x,y;
							x1=((CMyPoint*)pObj1)->m_startpoint.x;
							y1=((CMyPoint*)pObj1)->m_startpoint.y;
							x2=((CMyPoint*)pObj2)->m_startpoint.x;
							y2=((CMyPoint*)pObj2)->m_startpoint.y;
							x3=((CMyPoint*)pObj3)->m_startpoint.x;
							y3=((CMyPoint*)pObj3)->m_startpoint.y;
							/////////////////////////////////////////////////////////////////
							y=-0.5*(sqrt(x1*x1-2*x1*x2+x2*x2+y1*y1-2*y1*y2+y2*y2)
						   *sqrt(x1*x1-2*x1*x3+x3*x3+y1*y1-2*y1*y3+y3*y3)*x3-sqrt(x1*x1-2*x1*x2+x2*x2+y1*y1-2*y1*y2+y2*y2)
						   *sqrt(x1*x1-2*x1*x3+x3*x3+y1*y1-2*y1*y3+y3*y3)*x2-x3*sqrt(x1*x1-2*x1*x2+x2*x2+y1*y1-2*y1*y2+y2*y2)
						   *sqrt(x2*x2-2*x2*x3+x3*x3+y2*y2-2*y2*y3+y3*y3)+x1*sqrt(x1*x1-2*x1*x2+x2*x2+y1*y1-2*y1*y2+y2*y2)
						   *sqrt(x2*x2-2*x2*x3+x3*x3+y2*y2-2*y2*y3+y3*y3)-x1*sqrt(x1*x1-2*x1*x3+x3*x3+y1*y1-2*y1*y3+y3*y3)
						   *sqrt(x2*x2-2*x2*x3+x3*x3+y2*y2-2*y2*y3+y3*y3)+sqrt(x1*x1-2*x1*x3+x3*x3+y1*y1-2*y1*y3+y3*y3)
						   *sqrt(x2*x2-2*x2*x3+x3*x3+y2*y2-2*y2*y3+y3*y3)*x2-x1*x2*x2+x1*x3*x3-x1*y2*y2+x1*y3*y3+x3*y2*y2+x3*x2*x2
						   -x1*x1*x3+x1*x1*x2-x3*x3*x2-y3*y3*x2-y1*y1*x3+y1*y1*x2)/(y1*x3-y1*x2-x3*y2-x1*y3+x1*y2+y3*x2);
						  x=0.5*(y3*x2*x2-y1*x2*x2+sqrt(x1*x1-2*x1*x2+x2*x2+y1*y1-2*y1*y2+y2*y2)
						   *sqrt(x2*x2-2*x2*x3+x3*x3+y2*y2-2*y2*y3+y3*y3)*y1+y1*x3*x3-y2*y3*y3-x3*x3*y2
						   -y3*y1*y1+y2*y1*y1+y3*y3*y1-y3*x1*x1+y2*y2*y3-sqrt(x1*x1-2*x1*x3+x3*x3+y1*y1-2*y1*y3+y3*y3)
						   *sqrt(x2*x2-2*x2*x3+x3*x3+y2*y2-2*y2*y3+y3*y3)*y1-sqrt(x1*x1-2*x1*x2+x2*x2+y1*y1-2*y1*y2+y2*y2)
						   *sqrt(x2*x2-2*x2*x3+x3*x3+y2*y2-2*y2*y3+y3*y3)*y3+y3*sqrt(x1*x1-2*x1*x2+x2*x2+y1*y1-2*y1*y2+y2*y2)
						   *sqrt(x1*x1-2*x1*x3+x3*x3+y1*y1-2*y1*y3+y3*y3)+y2*x1*x1-y2*sqrt(x1*x1-2*x1*x2+x2*x2+y1*y1-2*y1*y2+y2*y2)
						   *sqrt(x1*x1-2*x1*x3+x3*x3+y1*y1-2*y1*y3+y3*y3)-y2*y2*y1+y2*sqrt(x1*x1-2*x1*x3+x3*x3+y1*y1-2*y1*y3+y3*y3)
						   *sqrt(x2*x2-2*x2*x3+x3*x3+y2*y2-2*y2*y3+y3*y3))/(y1*x3-y1*x2-x3*y2-x1*y3+x1*y2+y3*x2);
					   ///////////////////////////////////////////////////////////////////////////////////////////
							ptempPoint->m_startpoint.x=x;
							ptempPoint->m_startpoint.y=y;
							AddRelation(PPPP_INCEN,2,0,I_ZERO,CDD(pObj1),CDD(pObj2),CDD(pObj3),CDD(ptempPoint));							
					}
			   }	   			
		   }
		   break;
	   case T_TAN_VERTEX:///һ㡣
		   { 
				CDrawObj* pObj1,*pObj2,*pObj3;			
				if(m_selection.GetCount()==3)
				{
					POSITION pos=m_selection.GetHeadPosition();
					while(pos!=NULL)
					{
					   pObj1=m_selection.GetNext(pos);
					   pObj2=m_selection.GetNext(pos);
					   pObj3=m_selection.GetNext(pos);					
					}
					///pObj1 ,pObj2 the vertex,pObj3 the inCenter;
					if((pObj1->type==G_POINT)&&(pObj2->type==G_POINT)&&(pObj3->type==G_POINT))
					{
						CMyPoint*ptempPoint=new CMyPoint;
						GetDocument()->Add(ptempPoint);
						
						double x1,y1,x2,y2,x0,y0,x,y;
						x1=((CMyPoint*)pObj1)->m_startpoint.x;
						y1=((CMyPoint*)pObj1)->m_startpoint.y;
						x2=((CMyPoint*)pObj2)->m_startpoint.x;
						y2=((CMyPoint*)pObj2)->m_startpoint.y;
						x0=((CMyPoint*)pObj3)->m_startpoint.x;
						y0=((CMyPoint*)pObj3)->m_startpoint.y;	

						y=-(-2*y1*y0*y0*x2*x2-y1*y2*y2*y2*y0+2*y1*x2*x0*y2*y0-y1*y2*y2*y0*y0
							+2*y1*x2*x2*x0*x0-y1*x0*x0*x0*x2-y1*x2*x2*x2*x0+2*y1*y2*y0*y0*y0+y1*y1*x0*x0*y0
							+y1*y1*x0*x0*y2-y1*y1*y0*y0*y2-2*y1*x0*x0*y2*y0+2*y1*y1*y2*y2*y0+3*y1*x0*y0*y0*x2
							-y1*y1*x2*x0*y2-y1*y1*y1*y2*y0+2*y1*y1*y1*x2*x0-y1*y2*y0*x2*x2+y1*x0*x0*y2*y2
							-y1*y2*y2*x2*x0+x2*x2*y2*y0*y0+y2*y2*y0*x0*x0-y2*y2*y0*y0*y0+2*y2*y2*x2*x0*y0
							+3*y1*y1*y0*x2*x2-4*y1*y1*x2*x0*y0-2*x0*x0*y0*x2*x2+y2*y2*y2*y0*y0+2*x1*y2*y2*y2*x0
							+2*x1*x1*x2*x0*y1-x1*x1*x2*x0*y2-2*x1*x1*y0*y0*y2-x1*x1*y2*y1*y0-2*x1*x1*x0*x0*y0
							+x1*x1*y1*y0*y0-x1*x1*y1*x2*x2-x1*x1*y1*x0*x0+4*x1*x1*y0*x2*x2+2*x1*x1*x0*x0*y2
							-x1*x1*y2*x2*x2+3*x1*x1*y2*y2*y0-2*x1*x1*x1*x2*y0+2*x1*x1*x1*y0*x0-x1*x1*x1*x0*y2+x1*x1*x1*x2*y2
							-x1*x1*y2*y2*y2+2*x1*y1*y1*y0*x0+4*x1*x0*x0*x2*y0+x1*y1*x0*x0*x0-3*x1*y1*x0*y0*y0
							+x1*y1*x2*x2*x2-x1*y1*x2*x0*x0-x1*x2*x2*x0*y1-2*x1*x0*y0*x2*x2-2*x1*y1*y1*y0*x2
							+x1*y1*y0*y0*x2+3*x1*y2*y0*y0*x0-x1*x2*x0*x0*y2+x1*y1*y1*y2*x2-x1*y1*y1*y2*x0
							+2*x1*x2*x2*x0*y2+x1*y2*y0*y0*x2-x1*x0*x0*x0*y2-2*x1*x2*x2*x2*y0-x1*y1*y2*y2*x0
							-2*x1*y2*y2*y0*x2+x1*y1*y2*y2*x2+2*x1*y1*y2*y0*x0-4*x1*y2*y2*x0*y0-2*x1*x1*x2*x0*y0
							-y2*y2*y2*x0*x0+y2*x0*x0*x0*x2+2*x2*x2*x2*x0*y0-3*y2*x0*y0*y0*x2-y1*y1*y0*y0*y0+y1*y1*y1*y0*y0-y1*y1*y1*x0*x0
							-y1*y1*y1*x2*x2-x2*x2*x0*x0*y2)/(x1*x1-2*x1*x2+x2*x2+y1*y1-2*y2*y1+y2*y2)/(x1*x2-x1*x0
							-y2*y0+x0*x0-y1*y0+y0*y0+y2*y1-x2*x0);
					  x = (2*x2*x2*x0*y2*y1-x2*x0*x0*y2*y1+y2*y1*y0*y0*x2+4*x0*y1*y0*x2*x2-2*x1*x1*x0*y1*y0
						  +x1*y1*y1*x2*x0+x1*x2*x2*y1*y0+2*y1*y2*y2*x0*y0+x1*y2*y2*x2*x0-2*y2*y2*y0*y1*x2
						  +y2*y0*y1*y1*x2+y2*y1*y0*y0*x1-x2*x2*y1*x1*y2-x2*y1*x1*x1*y2+y2*y0*x1*x1*x2
						  -2*y2*y0*y1*y1*x1+y2*y0*x1*x2*x2+x2*x1*x1*y1*y0+4*y2*y0*x1*x1*x0-2*x2*x2*x0*y2*y0
						  +2*x1*x1*y2*y1*x0-y1*y2*x0*x0*x1+2*y1*y1*y2*x0*y0-2*x1*x0*y1*y0*x2-2*y2*y0*x1*x0*x2
						  +x2*x2*x2*y1*y1+x1*x1*x1*y2*y2+2*y1*y1*x0*y0*y0-4*y1*y1*y2*y2*x0+y2*y2*y0*y1*x1+y1*y1*y2*y2*x2
						  -y2*y1*y1*y1*x2+2*y2*y1*y1*y1*x0+2*y1*y2*y2*y2*x0-2*y1*y1*y0*y0*x2+2*y2*y2*x0*x0*x1-y2*y2*x0*x0*x2
						  +y2*y2*y0*y0*x2-2*y1*y0*x2*x2*x2+x1*y2*y2*y2*y0-y1*y1*x0*x0*x1-2*y1*y1*y1*x0*y0-2*y2*y2*y0*y0*x1
						  +2*x0*x0*y1*y1*x2+y1*y1*y1*y0*x2+y1*y1*y0*y0*x1-3*x2*x2*x0*y1*y1-3*x1*x1*y2*y2*x0-2*x1*x1*x1*y2*y0
						  -2*y2*y2*y2*x0*y0-y2*x2*y0*y2*y2-4*y1*y2*y0*y0*x0+3*y2*y0*x2*x0*x0-3*x2*y1*y0*x0*x0
						  +y1*x2*y0*y0*y0+2*y2*y2*y0*y0*x0-x1*y2*y2*y2*y1+x1*y1*y1*y2*y2-x2*x2*x2*x0*x0-x1*x1*x1*x0*x0+x1*x1*x1*x2*x0
						  +x1*x2*x2*x0*x0+x1*x2*x2*x2*x0+x1*x1*x0*x0*x2+x0*x0*x0*x2*x2-y0*y0*x0*x2*x2+y0*y0*x2*x2*x2+x1*x1*x1*y0*y0
						  +x1*x1*x0*x0*x0-2*x1*x1*x2*x2*x0-x1*y0*y0*x2*x2+x1*y2*y0*y0*y0-x1*y1*y0*y0*y0-2*x1*x0*x0*x0*x2
						  +3*x1*x0*x0*y1*y0-3*x1*x0*x0*y2*y0+2*x1*y0*y0*x0*x2-x1*x1*x0*y0*y0-x1*x1*y0*y0*x2)/(x1*x1
						  -2*x1*x2+x2*x2+y1*y1-2*y2*y1+y2*y2)/(x1*x2-x1*x0-y2*y0+x0*x0-y1*y0+y0*y0+y2*y1-x2*x0);
						ptempPoint->m_startpoint.x=x;
						ptempPoint->m_startpoint.y=y;
						AddRelation(PPPP_VERTEX,2,0,I_ZERO,CDD(pObj1),CDD(pObj2),CDD(pObj3),CDD(ptempPoint));
						/////////////////////////////////////////////////						
					}
				}			
	   }
	   break;
	   case T_TAN_EQUIL:///ȱΡ
	   {
		  
	   }
	   break;
	   case P_NEW_CIRCLE:///ԲԵһΪԲģΪ뾶
	   {
	        CDrawObj *pObj1,*pObj2;
			if(m_selection.GetCount()==2)
			{
			     POSITION pos=m_selection.GetHeadPosition();
				 while(pos!=NULL)
				 {
				      pObj1=m_selection.GetNext(pos);
					  pObj2=m_selection.GetNext(pos);			
				 }
				 if((pObj1->type==G_POINT)&&(pObj2->type==G_POINT))
				 {
				      CMyCircle*ptempCircle=new CMyCircle;
					  GetDocument()->Add(ptempCircle);
                      double x1,y1,x2,y2,r;
					  x1=((CMyPoint*)pObj1)->m_startpoint.x;
					  y1=((CMyPoint*)pObj1)->m_startpoint.y;
					  x2=((CMyPoint*)pObj2)->m_startpoint.x;
					  y2=((CMyPoint*)pObj2)->m_startpoint.y;
					  r=sqrt((x1-x2)*(x1-x2)+(y1-y2)*(y1-y2));
					  ptempCircle->ABC[0]=x1;
					  ptempCircle->ABC[1]=y1;
					  ptempCircle->ABC[2]=r;                      
					  ///add the constraint of the three points and the circle;
					  AddRelation(PC_DIS,1,0,I_ZERO,CDD(pObj2),CDD(ptempCircle));
					  AddRelation(PC_CEN,2,0,I_ZERO,CDD(pObj1),CDD(ptempCircle));
				 }   
			}
	   }
	   break;
	   case R_NEW_CIRCLE:///ԲԵһΪԲģΪ뾶
	   {
	        CDrawObj *pObj1,*pObj2,*pObj3;
			if(m_selection.GetCount()==3)
			{
			     POSITION pos=m_selection.GetHeadPosition();
				 while(pos!=NULL)
				 {
				      pObj1=m_selection.GetNext(pos);
					  pObj2=m_selection.GetNext(pos);
					  pObj3=m_selection.GetNext(pos);
				 }
				 if((pObj1->type==G_POINT)&&(pObj2->type==G_POINT)&&(pObj3->type==G_POINT))
				 {
				      CMyCircle*ptempCircle=new CMyCircle;
					  GetDocument()->Add(ptempCircle);
                      double x1,y1,x2,y2,x3,y3,r;
					  x1=((CMyPoint*)pObj1)->m_startpoint.x;
					  y1=((CMyPoint*)pObj1)->m_startpoint.y;
					  x2=((CMyPoint*)pObj2)->m_startpoint.x;
					  y2=((CMyPoint*)pObj2)->m_startpoint.y;
					  x3=((CMyPoint*)pObj3)->m_startpoint.x;
					  y3=((CMyPoint*)pObj3)->m_startpoint.y;
					  r=sqrt((x2-x3)*(x2-x3)+(y2-y2)*(y1-y2));
					  ptempCircle->ABC[0]=x1;
					  ptempCircle->ABC[1]=y1;
					  ptempCircle->ABC[2]=r;                      
					  ///add the constraint of the three points and the circle;
					  AddRelation(PC_CEN,2,0,I_ZERO,CDD(pObj1),CDD(ptempCircle));
				 }   
			}
	   }
	   break;
	   case T_NEW_CIRCLE:///һԲ
	   {
           CDrawObj* pObj1,*pObj2,*pObj3;
		   if(m_selection.GetCount()==3)
		   {
		         POSITION pos=m_selection.GetHeadPosition();
				 while(pos!=NULL)
				 {
				      pObj1=m_selection.GetNext(pos);
					  pObj2=m_selection.GetNext(pos);
					  pObj3=m_selection.GetNext(pos);
				 }
				 if((pObj1->type==G_POINT)&&(pObj2->type==G_POINT)&&(pObj3->type==G_POINT))
				 {
				      CMyCircle*ptempCircle=new CMyCircle;
					  GetDocument()->Add(ptempCircle);
                      
                      CMyPoint *pObj=new CMyPoint;
					  GetDocument()->Add(pObj);

					  double x1,y1,x2,y2,x3,y3,x,y;
					  x1=((CMyPoint*)pObj1)->m_startpoint.x;
					  y1=((CMyPoint*)pObj1)->m_startpoint.y;
                      x2=((CMyPoint*)pObj2)->m_startpoint.x;
					  y2=((CMyPoint*)pObj2)->m_startpoint.y;
					  x3=((CMyPoint*)pObj3)->m_startpoint.x;
					  y3=((CMyPoint*)pObj3)->m_startpoint.y;
                      ///compute the circle point of the circle frop the three points;
					  x = 0.5*(-y1*x2*x2+y3*x2*x2+y2*y2*y3+y1*x3*x3-y2*y3*y3-x3*x3*y2-x1*x1*y3-y2*y2*y1+x1*x1*y2
						  +y3*y3*y1+y2*y1*y1-y3*y1*y1)/(x1*y2-x1*y3-y1*x2+y1*x3-x3*y2+y3*x2);
					  y = -0.5*(-x1*x2*x2-x1*y2*y2+x1*x3*x3+x1*y3*y3+x1*x1*x2-x1*x1*x3+y1*y1*x2-y1*y1*x3+x3*x2*x2
						  +x3*y2*y2-x3*x3*x2-y3*y3*x2)/(x1*y2-x1*y3-y1*x2+y1*x3-x3*y2+y3*x2);
					  ptempCircle->ABC[0]=x;
					  ptempCircle->ABC[1]=y;
					  ptempCircle->ABC[2]=sqrt((x-x1)*(x-x1)+(y-y1)*(y-y1));
					  ptempCircle->my_startpoint=pObj;
					  ///add the constraint of the three points and the circle;
					  AddRelation(PC_DIS,1,0,I_ZERO,CDD(pObj1),CDD(ptempCircle));
					  AddRelation(PC_DIS,1,0,I_ZERO,CDD(pObj2),CDD(ptempCircle));
					  AddRelation(PC_DIS,1,0,I_ZERO,CDD(pObj3),CDD(ptempCircle));

					  pObj->m_startpoint.x=x;
					  pObj->m_startpoint.y=y;
					  AddRelation(PC_CEN,2,0,I_ZERO,CDD(pObj),CDD(ptempCircle));
				 }
		   }
	   }
	   break;
	   case CO_PX:///֤ĽΪƽС
		   {}
		   break;
	   case CO_CZ:///֤ĽΪֱ
		   {}
		   break;
	   case CO_MID:///֤ĽΪһΪе㡣
		   {
		        CDrawObj* pObj1,*pObj2,*pObj3;
		        if(m_selection.GetCount()==3)
				{
		             POSITION pos=m_selection.GetHeadPosition();
    				 while(pos!=NULL)
					 {
				          pObj1=m_selection.GetNext(pos);
					      pObj2=m_selection.GetNext(pos);
					      pObj3=m_selection.GetNext(pos);
						  GetDocument()->r_CO.Nconstraintype=PL_MID;
						  GetDocument()->r_CO.pObjList.AddTail(pObj1);
						  GetDocument()->r_CO.pObjList.AddTail(pObj2);
						  GetDocument()->r_CO.pObjList.AddTail(pObj3);
					 }
				}
		   }
	}
}

void CDrawView::OnLButtonUp(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default	
	if(m_Dragging)
	{
	   m_Dragging=0;
	} 
	//////////////////////////////////////////////////////////
	if((m_CurrentMove>=10)&&(m_CurrentMove<=16))
		m_CurrentMove=0;
	if (!m_bActive)
		return;
	m_combineobject.RemoveAll();
	CDrawTool* pTool = CDrawTool::FindTool(CDrawTool::c_drawShape);
	if (pTool != NULL)
		pTool->OnLButtonUp(this, nFlags, point);
    HWND hWnd;
	hWnd=hhh;
	CDrawDoc*pDoc=GetDocument();
	///***********************************************///
	::SendMessage(hWnd,WM_MESSAGEADD,0,(long)pDoc);
	//////////////////////////////////////////////////////	
    DrawAnimation();
}

void CDrawView::OnMouseMove(UINT nFlags, CPoint point) 
{	
	//////////////////////////////////////////////
	CPoint local = point;
	ClientToDoc(local);
  
	if(m_CurrentMove==1)///ͼƽƲ
	{
		OnTransfer(point);		
	 }
	 else if(m_CurrentMove==2)///ͼת
	 {
		 OnRotate(point);		
	 }
	 else if(m_CurrentMove==3)///ͼŲ
	 {
		 OnZoom(point);	
	 }	
	//////////////////////////////////////////////
	m_mouseposition=point;
	ClientToDoc(m_mouseposition);
	if (!m_bActive)
		return;
	CDrawTool* pTool = CDrawTool::FindTool(CDrawTool::c_drawShape);
	if (pTool != NULL)
		pTool->OnMouseMove(this, nFlags, point);	
    Invalidate();
}

void CDrawView::OnObjectFillcolor() 
{
	// TODO: Add your command handler code here
	CColorDialog dlg;
	if (dlg.DoModal() != IDOK)
		return;

	COLORREF color = dlg.GetColor();

	POSITION pos = m_selection.GetHeadPosition();
	while (pos != NULL)
	{
		CDrawObj* pObj = m_selection.GetNext(pos);
		pObj->SetFillColor(color);
	}
}

void CDrawView::OnObjectLinecolor() 
{
	// TODO: Add your command handler code here
	CColorDialog dlg;
	if (dlg.DoModal() != IDOK)
		return;

	COLORREF color = dlg.GetColor();

	POSITION pos = m_selection.GetHeadPosition();
	while (pos != NULL)
	{
		CDrawObj* pObj = m_selection.GetNext(pos);
		pObj->SetLineColor(color);
	}
}

void CDrawView::OnObjectMoveback() 
{
	// TODO: Add your command handler code here
	CDrawDoc* pDoc = GetDocument();
	CDrawObj* pObj = m_selection.GetHead();
	CDrawObjList* pObjects = pDoc->GetObjects();
	POSITION pos = pObjects->Find(pObj);
	ASSERT(pos != NULL);
	if (pos != pObjects->GetHeadPosition())
	{
		POSITION posPrev = pos;
		pObjects->GetPrev(posPrev);
		pObjects->RemoveAt(pos);
		pObjects->InsertBefore(posPrev, pObj);
		InvalObj(pObj);
	}
}

void CDrawView::OnObjectMoveforward() 
{
	// TODO: Add your command handler code here
	CDrawDoc* pDoc = GetDocument();
	CDrawObj* pObj = m_selection.GetHead();
	CDrawObjList* pObjects = pDoc->GetObjects();
	POSITION pos = pObjects->Find(pObj);
	ASSERT(pos != NULL);
	if (pos != pObjects->GetTailPosition())
	{
		POSITION posNext = pos;
		pObjects->GetNext(posNext);
		pObjects->RemoveAt(pos);
		pObjects->InsertAfter(posNext, pObj);
		InvalObj(pObj);
	}
}

void CDrawView::OnObjectMovetoback() 
{
	// TODO: Add your command handler code here
	CDrawDoc* pDoc = GetDocument();
	CDrawObj* pObj = m_selection.GetHead();
	CDrawObjList* pObjects = pDoc->GetObjects();
	POSITION pos = pObjects->Find(pObj);
	ASSERT(pos != NULL);
	pObjects->RemoveAt(pos);
	pObjects->AddHead(pObj);
	InvalObj(pObj);
}

void CDrawView::OnObjectMovetofront() 
{
	// TODO: Add your command handler code here
	CDrawDoc* pDoc = GetDocument();
	CDrawObj* pObj = m_selection.GetHead();
	CDrawObjList* pObjects = pDoc->GetObjects();
	POSITION pos = pObjects->Find(pObj);
	ASSERT(pos != NULL);
	pObjects->RemoveAt(pos);
	pObjects->AddTail(pObj);
	InvalObj(pObj);
}

void CDrawView::OnUpdateEditClear(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	
}

void CDrawView::OnUpdateEditConstruction(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	
}

void CDrawView::OnUpdateEditCopy(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	pCmdUI->Enable(!m_selection.IsEmpty());
}

void CDrawView::OnUpdateEditCut(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	pCmdUI->Enable(!m_selection.IsEmpty());
}

void CDrawView::OnUpdateEditIntsction(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	pCmdUI->Enable(!m_selection.IsEmpty());
}

void CDrawView::OnUpdateEditMidpoint(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	pCmdUI->Enable(!m_selection.IsEmpty());
}

void CDrawView::OnUpdateEditParalle(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	pCmdUI->Enable(!m_selection.IsEmpty());
}

void CDrawView::OnUpdateEditPaste(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	COleDataObject dataObject;
	BOOL bEnable = dataObject.AttachClipboard() &&
		(dataObject.IsDataAvailable(m_cfDraw) ||
		 COleClientItem::CanCreateFromData(&dataObject));

	// enable command based on availability
	pCmdUI->Enable(bEnable);
}

void CDrawView::OnUpdateEditProperties(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	pCmdUI->Enable(m_selection.GetCount() == 1 &&
				   CDrawTool::c_drawShape == selection);
}

void CDrawView::OnUpdateEditSelectAll(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	pCmdUI->Enable(GetDocument()->GetObjects()->GetCount() != 0);
}

void CDrawView::OnUpdateEditVertical(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	pCmdUI->Enable(!m_selection.IsEmpty());
}

void CDrawView::OnUpdateEditVerticalfoot(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	pCmdUI->Enable(!m_selection.IsEmpty());
}

void CDrawView::OnUpdateObjectMoveback(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	
}

void CDrawView::OnUpdateObjectMoveforward(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	
}

void CDrawView::OnUpdateObjectMovetoback(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	
}

void CDrawView::OnUpdateObjectMovetofront(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	
}

void CDrawView::OnUpdateViewGrid(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	pCmdUI->SetCheck(m_bGrid);
}

void CDrawView::OnUpdateViewShowobjects(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	pCmdUI->SetCheck(CDrawOleObj::c_bShowItems);
}

void CDrawView::OnViewGrid() 
{
	// TODO: Add your command handler code here
	m_bGrid = !m_bGrid;
	Invalidate(FALSE);
}

void CDrawView::OnViewShowobjects() 
{
	// TODO: Add your command handler code here
	CDrawOleObj::c_bShowItems = !CDrawOleObj::c_bShowItems;
	GetDocument()->UpdateAllViews(NULL, HINT_UPDATE_OLE_ITEMS, NULL);
}

int CDrawView::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CScrollView::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	// TODO: Add your specialized creation code here
	if( m_dropTarget.Register( this ) )
		return 0;
	else
		return -1;
}

void CDrawView::OnDrawEllipse() 
{
	// TODO: Add your command handler code here
	CDrawTool::c_drawShape = ellipse;
}

void CDrawView::OnDrawLine() 
{
	// TODO: Add your command handler code here
	CDrawTool::c_drawShape = line;
}

void CDrawView::OnDrawRect() 
{
	// TODO: Add your command handler code here
	CDrawTool::c_drawShape = rect;
}

void CDrawView::OnDrawRoundrect() 
{
	// TODO: Add your command handler code here
	CDrawTool::c_drawShape = roundRect;
}

void CDrawView::OnUpdateDrawEllipse(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	pCmdUI->SetRadio(CDrawTool::c_drawShape == ellipse);
}

void CDrawView::OnUpdateDrawLine(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	pCmdUI->SetRadio(CDrawTool::c_drawShape == line);
}

void CDrawView::OnUpdateDrawPolygon(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	pCmdUI->SetRadio(CDrawTool::c_drawShape == poly);
}

void CDrawView::OnUpdateDrawRect(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	pCmdUI->SetRadio(CDrawTool::c_drawShape == rect);
}

void CDrawView::OnUpdateDrawRoundrect(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	pCmdUI->SetRadio(CDrawTool::c_drawShape == roundRect);
}

void CDrawView::OnUpdateDrawSelect(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	pCmdUI->SetRadio(CDrawTool::c_drawShape == selection);
}


CPoint2 * CDrawView::sol_qmin(double a, double b, double c, double m, double n, double r, CPoint2 p)
{ ///ֱ(a,b,c)Բ(m,n,r)оpһ㡣 
   int k;
   k=sol_lq(a,b,c,m,n,r);//ؽintersection1,intersection2
   if(k>0) 
   {
      CPoint2 temp1,temp2;
	  temp1=p-intersection1;
	  temp2=p-intersection2;
      if(temp1.squareLength()<temp2.squareLength()) //ȽϾСķ
	  {
		  intersection->x = intersection1.x;
		  intersection->y = intersection1.y;
	  }
      else 
	  {
	      intersection->x = intersection2.x;
		  intersection->y = intersection2.y;
	  }
	  return intersection;
  }
  else
  {
      return NULL;
  }
}



CPoint2* CDrawView::sol_qmax(double a, double b, double c, double m, double n, double r, CPoint2 p)
{  
   int k;
   k=sol_lq(a,b,c,m,n,r);
   if(k>0) 
   {
      CPoint2 temp1,temp2;
	  temp1=p-intersection1;
	  temp2=p-intersection2;
      if(temp1.squareLength()<temp2.squareLength()) //ȽϾķ
	  {
		  intersection->x = intersection2.x;
		  intersection->y = intersection2.y;
	  }
      else 
	  {
		  intersection->x = intersection1.x;
		  intersection->y = intersection1.y;
	  }
	  return intersection;
  }
  else
  {
      return NULL;
  }
}
/////////////////////////////////////////////////////////////////////


////////////////////////////////////////////////////////////////////////
double CDrawView::getSquareDistance(CMyPoint * temp1, CMyLine * temp2)
{
    int k//ֱһ㣬intersection
    =sol_lll(temp2->ABC[0], temp2->ABC[1],
            temp2->ABC[2], temp2->ABC[1],
           -temp2->ABC[0],
            temp2->ABC[0]*temp1->y()
           -temp2->ABC[1]*temp1->x());
	if(k>0)
	{
	    CPoint2 temp1_point2;
		temp1_point2=temp1->m_startpoint-(*intersection);
		double cc;
		cc=temp1_point2.squareLength();
		return cc;
	}
	else
	{
		return -1;
	}
}
int CDrawView::sol_lq(double a, double b, double c, double m, double n, double r)
//1Ч-1Ч
{ double a1,b1,c1,d,x1,x2,y1,y2;
  if (fabs(b) < 0.00001)
	 {
		if (fabs(a) < 0.00001) { return(-1); }
		else
	{
	  d=r - (c/a+m)*(c/a+m);
	  if (d>=0)
		 { d=sqrt(d);
			intersection1.x = -c/a;
			intersection1.y = n + d;
			intersection2.x = intersection1.x;
			intersection2.y = n - d;
		 }
	  else { return(-1); }
	}
	 }
  else if (fabs(b)>fabs(a))
	 { a=a/b; c=c/b; b=1.0;
		a1 = a*a + 1.0;
		b1 = 2.0*a*(c+n)-2.0*m;
		c1 = (c+n)*(c+n)+m*m-r;
		d=b1*b1 - 4.0*a1*c1;
		if (d>=0.0)
	{ d=sqrt(d);
	  intersection1.x=x1= (-b1 + d)/ (2.0*a1);
	  intersection1.y   = -c-a*x1;
	  intersection2.x=x2 = (-b1 - d)/ (2.0*a1);
	  intersection2.y = -c-a*x2;
	}
		else { return(-1); }
	 }
  else
	 { b=b/a; c=c/a; a=1.0;
		a1 = 1.0 + b*b;
		b1 = 2.0*b*(c+m)-2.0*n;
		c1 = (c+m)*(c+m)+n*n-r;
		d=b1*b1 - 4.0*a1*c1;
		if (d>=0.0)
	{ d=sqrt(d);
	  intersection1.y=y1=(-b1 + d)/ (2.0*a1);
	  intersection1.x   = -c-b*y1;
	  intersection2.y=y2=(-b1 - d)/ (2.0*a1);
	  intersection2.x   = -c-b*y2;
	}
		else { return(-1); }
	 }
  return(1);
}



void CDrawView::OnPrepareDC(CDC* pDC, CPrintInfo* pInfo) 
{
	// TODO: Add your specialized code here and/or call the base class
	
	CScrollView::OnPrepareDC(pDC, pInfo);
		// mapping mode is MM_ANISOTROPIC
	// these extents setup a mode similar to MM_LOENGLISH
	// MM_LOENGLISH is in .01 physical inches
	// these extents provide .01 logical inches
   
	pDC->SetMapMode(MM_ANISOTROPIC);
	pDC->SetViewportExt(pDC->GetDeviceCaps(LOGPIXELSX),
		pDC->GetDeviceCaps(LOGPIXELSY));
	pDC->SetWindowExt(100, -100);

	// set the origin of the coordinate system to the center of the page
	CPoint ptOrg;
	ptOrg.x = GetDocument()->GetSize().cx / 2;
	ptOrg.y = GetDocument()->GetSize().cy / 2;

	// ptOrg is in logical coordinates
	pDC->OffsetWindowOrg(-ptOrg.x,ptOrg.y);
}

void CDrawView::OnShowName() 
{
	// TODO: Add your command handler code here
	bShowName=!bShowName;
	Invalidate();
}

void CDrawView::OnShowScale() 
{
	// TODO: Add your command handler code here
	bShowScale=!bShowScale;
	Invalidate();
}

void CDrawView::OnUpdateDrawMyline(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	pCmdUI->SetRadio(CDrawTool::c_drawShape == myline);
}

void CDrawView::OnUpdateDrawMypoint(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	pCmdUI->SetRadio(CDrawTool::c_drawShape == mypoint);
}

void CDrawView::OnUpdateDrawMycircle(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	pCmdUI->SetRadio(CDrawTool::c_drawShape == mycircle);
}

void CDrawView::OnRButtonDown(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
	/////////////////////////////
	m_CurrentMove=0;
    KillTimer(1);
 	/////////////һҼȡǰ˶˶͡
	CScrollView::OnRButtonDown(nFlags, point);
}

void CDrawView::OnRButtonUp(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
	
	CScrollView::OnRButtonUp(nFlags, point);
}

void CDrawView::OnRotate() 
{
	// TODO: Add your command handler code here
	m_CurrentMove=2;
}

void CDrawView::OnUpdateRotate(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	pCmdUI->SetCheck(m_CurrentMove==2?1:0);
}

void CDrawView::OnTranslate() 
{
	// TODO: Add your command handler code here
	m_CurrentMove=1;
}

void CDrawView::OnUpdateTranslate(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	pCmdUI->SetCheck(m_CurrentMove==1?1:0);
}

void CDrawView::OnZoom() 
{
	// TODO: Add your command handler code here
	m_CurrentMove=3;
}

void CDrawView::OnUpdateZoom(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	pCmdUI->SetCheck(m_CurrentMove==3?1:0);
}

void CDrawView::OnDplay() 
{
	// TODO: Add your command handler code here
	int nTimer=SetTimer(1,50,NULL);
	ASSERT(nTimer!=0);
}

void CDrawView::OnTimer(UINT nIDEvent) 
{
	// TODO: Add your message handler code here and/or call default
	///SetTimerõУЧ·켣
	CDrawObj*pObj1,*pObj2;
	CClientDC ClientDC(this);
	POSITION pos=GetDocument()->m_ObjDriveList.GetHeadPosition();
	while(pos!=NULL)
	{
		pObj1=GetDocument()->m_ObjDriveList.GetNext(pos);  
		int ispeed=pObj1->iStep;
		int icount=pObj1->iCount;
		BOOL bOn=pObj1->On;
		int itemp=pObj1->iDriveTrace;
		if(itemp>-1)
		{
			////get the trace of the DrivePoint;
			CDrawObjList* m_objects= GetDocument()->GetObjects();
	   		POSITION pos1=m_objects->FindIndex(itemp);
			pObj2=m_objects->GetAt(pos1);
			/////////////////////////////////////
      		double dx1,dy1,dx2,dy2,dx3,dy3,dr;
			double dx,dy;		
			if(pObj2->type==2)///the trace is line;
			{
				 if(((CMyLine*)pObj2)->my_startpoint->m_listindex>((CMyLine*)pObj2)->my_endpoint->m_listindex)
				 {
					 dx1=((CMyLine*)pObj2)->my_startpoint->m_startpoint.x;
					 dy1=((CMyLine*)pObj2)->my_startpoint->m_startpoint.y;
					 dx2=((CMyLine*)pObj2)->my_endpoint->m_startpoint.x;
					 dy2=((CMyLine*)pObj2)->my_endpoint->m_startpoint.y;
				 }
				 else
				 {
					 dx2=((CMyLine*)pObj2)->my_startpoint->m_startpoint.x;
					 dy2=((CMyLine*)pObj2)->my_startpoint->m_startpoint.y;
					 dx1=((CMyLine*)pObj2)->my_endpoint->m_startpoint.x;
					 dy1=((CMyLine*)pObj2)->my_endpoint->m_startpoint.y;
				 }
			 
				 dx=(dx1-dx2)/ispeed;
				 dy=(dy1-dy2)/ispeed;
				 if((icount==ispeed)||(icount==0))
				 {
					 pObj1->On=!pObj1->On;					
				 }
				 if(pObj1->On==0)
				 {	
					 if(icount<0)
						 pObj1->iCount=0;
					 if(icount>=ispeed)
						 pObj1->iCount=0;
					 dx3=dx2+icount*dx;
					 dy3=dy2+icount*dy;				  
					 pObj1->iCount++;
				 }
				 if(pObj1->On==1)
				 {			 
					 if(icount<=0)
						 pObj1->iCount=ispeed;
					 if(icount>ispeed)
						 pObj1->iCount=ispeed;
					 dx3=dx2+(icount)*dx;
					 dy3=dy2+(icount)*dy;				 			  
					 pObj1->iCount--;
				 }
				 ((CMyPoint*)pObj1)->m_startpoint.x=dx3;
				 ((CMyPoint*)pObj1)->m_startpoint.y=dy3;			
			}
			else if(pObj2->type==3)//////the trace is circle;
			{
				 dx1=((CMyCircle*)pObj2)->ABC[0];
				 dy1=((CMyCircle*)pObj2)->ABC[1];                         
				 dr=((CMyCircle*)pObj2)->ABC[2];
           		 {
					 if(icount<0)
						 pObj1->iCount=0;
					 dx3=dx1+dr*cos(icount*PI/ispeed);
					 dy3=dy1+dr*sin(icount*PI/ispeed);			  
					 pObj1->iCount++;
				 }			
				 ((CMyPoint*)pObj1)->m_startpoint.x=dx3;
				 ((CMyPoint*)pObj1)->m_startpoint.y=dy3;
			}
							
		}
	}
	ComputeTransformedlist();
	CScrollView::OnTimer(nIDEvent);
}

void CDrawView::OnDline()///켣Ϊߡ 
{
	// TODO: Add your command handler code here
	m_CurrentMove=11;
}
void CDrawView::OnDpoint() ///
{
	// TODO: Add your command handler code here
	m_CurrentMove=10;
}
void CDrawView::OnDcircle() ///켣ΪԲ
{
	// TODO: Add your command handler code here
	m_CurrentMove=12;
}

void CDrawView::OnDselfdraw() ///켣ΪԻͼΡ
{
	// TODO: Add your command handler code here
	m_CurrentMove=13;
}

void CDrawView::OnStylepoint() ///켣Ϊ㡣
{
	// TODO: Add your command handler code here
    m_CurrentMove=14;	
}

void CDrawView::OnStyleline() ///켣Ϊߡ
{
	// TODO: Add your command handler code here
	m_CurrentMove=15;
}

void CDrawView::OnStylecircle() ///켣ΪԲ
{
	// TODO: Add your command handler code here
	m_CurrentMove=16;
}

void CDrawView::OnUpdateDpoint(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
//	int icount=GetDocument()->m_objects.GetCount();
//	pCmdUI->SetCheck(icount>0?1:0);
}

void CDrawView::OnTrCentriod() 
{
	// TODO: Add your command handler code here
	m_CurrentMove=T_TAN_CENTR;///ġ
	CDrawTool::c_drawShape = selection;
}

void CDrawView::OnTrCircumcenter() ///ģ
{
	// TODO: Add your command handler code here
	m_CurrentMove=T_TAN_CIRCUM;
	CDrawTool::c_drawShape = selection;
}

void CDrawView::OnTrEquilateral() ///ȱΡ
{
	// TODO: Add your command handler code here
	m_CurrentMove=T_TAN_EQUIL;
	CDrawTool::c_drawShape = selection;
}

void CDrawView::OnTrIncenter() ///ģ
{
	// TODO: Add your command handler code here
	m_CurrentMove=T_TAN_INCEN;
	CDrawTool::c_drawShape = selection;
}

void CDrawView::OnTrOrthocenter() ///ġ
{
	// TODO: Add your command handler code here
	m_CurrentMove=T_TAN_ORTHO;
	CDrawTool::c_drawShape = selection;
}

void CDrawView::OnTrVertex() ///һ㡣
{
	// TODO: Add your command handler code here
	m_CurrentMove=T_TAN_VERTEX;
	CDrawTool::c_drawShape = selection;
}

void CDrawView::OnAspeed() 
{
	// TODO: Add your command handler code here
/*	  int ispeed;
      AnimationSpeed  Aspeed;
	  UpdateData(FALSE);
	   Aspeed.m_radio=(istep/30-1);        
	  if(Aspeed.DoModal()==IDOK)
	  {
		  ispeed=Aspeed.m_radio;
		  UpdateData(TRUE);
	  }					
      istep=(ispeed+1)*30; 
	  DrawAnimation();
*/
}

void CDrawView::DrawAnimation()
{
    ///compute the trace of locus begin
	///first,delete the before locus
	if((GetDocument()->m_LocusList.GetCount()>0)&&(GetDocument()->m_ObjDriveList.GetCount()>0))
	{
		POSITION pos,pos1,pos2,ptemp,pos3;
		CDrawObj*pObj,*pObj1,*pObj2,*pObj3;
		ptemp=GetDocument()->m_LocusList.GetHeadPosition();
		while(ptemp!=NULL)
		{
			pObj=GetDocument()->m_LocusList.GetNext(ptemp);
			if(pObj->type==G_POINT)
			{
				pos1=((CMyPoint*)pObj)->lpoints.GetHeadPosition();
				while(pos1!=NULL)
				{
					CLPoint*lp=((CMyPoint*)pObj)->lpoints.GetAt(pos1);
					pos2=pos1;
					((CMyPoint*)pObj)->lpoints.GetNext(pos1);
					((CMyPoint*)pObj)->lpoints.RemoveAt(pos2);
					delete lp;
				}		   
			}
			else if(pObj->type==G_LINE)
			{
			     pos1=((CMyLine*)pObj)->Alines.GetHeadPosition();
				 while(pos1!=NULL)
				 {
				      CALine*line=((CMyLine*)pObj)->Alines.GetAt(pos1);
					  pos2=pos1;
                      ((CMyLine*)pObj)->Alines.GetNext(pos1);
					  ((CMyLine*)pObj)->Alines.RemoveAt(pos2);
					  delete line;
				 }
			}
		}
		//////////////////////////////////////////
		 CClientDC ClientDC(this);
		 pos=GetDocument()->m_ObjDriveList.GetHeadPosition();
		 while(pos!=NULL)
		 {
				pObj1=GetDocument()->m_ObjDriveList.GetNext(pos);  
				int itemp=pObj1->iDriveTrace;
				int iSpeed=pObj1->iStep;
				if((itemp!=-1)&&(GetDocument()->m_LocusList.GetCount()>0))
				{
					////get the trace of the DrivePoint;
					CDrawObjList* m_objects= GetDocument()->GetObjects();
	   				POSITION pos1=m_objects->FindIndex(itemp);
					pObj2=m_objects->GetAt(pos1);
					/////////////////////////////////////
      				double dx1,dy1,dx2,dy2,dx3,dy3,dr;
					double dx,dy;
					if(pObj2->type==G_LINE)
					{
						 if(((CMyLine*)pObj2)->my_startpoint->m_listindex>((CMyLine*)pObj2)->my_endpoint->m_listindex)
						 {
							 dx1=((CMyLine*)pObj2)->my_startpoint->m_startpoint.x;
							 dy1=((CMyLine*)pObj2)->my_startpoint->m_startpoint.y;
							 dx2=((CMyLine*)pObj2)->my_endpoint->m_startpoint.x;
							 dy2=((CMyLine*)pObj2)->my_endpoint->m_startpoint.y;
						 }
						 else
						 {
							 dx2=((CMyLine*)pObj2)->my_startpoint->m_startpoint.x;
							 dy2=((CMyLine*)pObj2)->my_startpoint->m_startpoint.y;
							 dx1=((CMyLine*)pObj2)->my_endpoint->m_startpoint.x;
							 dy1=((CMyLine*)pObj2)->my_endpoint->m_startpoint.y;
						 }
						 dx3=((CMyPoint*)pObj1)->m_startpoint.x;
						 dy3=((CMyPoint*)pObj1)->m_startpoint.y;
						 dx=(dx1-dx2)/iSpeed;
						 dy=(dy1-dy2)/iSpeed;
						 for(int iCount=0;iCount<=iSpeed;iCount++)
						 {
							 dx3=dx2+iCount*dx;
							 dy3=dy2+iCount*dy;	
							 ((CMyPoint*)pObj1)->m_startpoint.x=dx3;
							 ((CMyPoint*)pObj1)->m_startpoint.y=dy3;
							 ////////////////////////////////////////////////////
							 if(m_transformedlist.GetCount()>L_ZERO)
                             {
							      ComputeTransformedlist();	
							 }
							 else
							 {
								 GetTransformedList(GetDocument()->GetObjects(),2);
							     ComputeTransformedlist();	
							 }
							 //////////////////////////////////////////////////////
							 pos3=GetDocument()->m_LocusList.GetHeadPosition();
							 while(pos3!=NULL)
							 {
								pObj3=GetDocument()->m_LocusList.GetNext(pos3);
								////////////////////////the locus is point!
								if(pObj3->type==G_POINT)
								{
									CPoint2 ptemppoint;
									ptemppoint.x=((CMyPoint*)pObj3)->m_startpoint.x;
									ptemppoint.y=((CMyPoint*)pObj3)->m_startpoint.y;
									CLPoint *lp=new CLPoint();
									lp->lpoint=ptemppoint;
									((CMyPoint*)pObj3)->lpoints.AddTail(lp); 
								}
								/////////////////////////the locus is line!
								else if(pObj3->type==G_LINE)
								{
	                                CPoint2 point1,point2;
									point1.x=((CMyLine*)pObj3)->my_startpoint->m_startpoint.x;
									point1.y=((CMyLine*)pObj3)->my_startpoint->m_startpoint.y;
									point2.x=((CMyLine*)pObj3)->my_endpoint->m_startpoint.x;
									point2.y=((CMyLine*)pObj3)->my_endpoint->m_startpoint.y;
									CALine*line=new CALine();
									line->FirstPoint=point1;
									line->SecondPoint=point2;
									((CMyLine*)pObj3)->Alines.AddTail(line);
								}
							}

						 }
				 					
					}
					else if(pObj2->type==G_CIRCLE)//////the trace is circle;
					{
					     dx1=((CMyCircle*)pObj2)->ABC[0];
						 dy1=((CMyCircle*)pObj2)->ABC[1];                         
						 dr=((CMyCircle*)pObj2)->ABC[2];
						 for(int iCount=0;iCount<=2*iSpeed;iCount++)
						 {
						     dx3=dx1+dr*cos(iCount*PI/iSpeed);
							 dy3=dy1+dr*sin(iCount*PI/iSpeed);
							 ((CMyPoint*)pObj1)->m_startpoint.x=dx3;
							 ((CMyPoint*)pObj1)->m_startpoint.y=dy3;
							 /////////////////////////////////////////////
							 if(m_transformedlist.GetCount()>L_ZERO)
                             {
							      ComputeTransformedlist();	
							 }
							 else
							 {
								 GetTransformedList(GetDocument()->GetObjects(),2);
							     ComputeTransformedlist();	
							 }	
							 /////////////////////////////////////////////////////
							 pos3=GetDocument()->m_LocusList.GetHeadPosition();
							 while(pos3!=NULL)
							 {
								pObj3=GetDocument()->m_LocusList.GetNext(pos3);
								////////////////////////the locus is point!
								if(pObj3->type==G_POINT)
								{
									CPoint2 ptemppoint;
									ptemppoint.x=((CMyPoint*)pObj3)->m_startpoint.x;
									ptemppoint.y=((CMyPoint*)pObj3)->m_startpoint.y;
									CLPoint *lp=new CLPoint();
									lp->lpoint=ptemppoint;
									((CMyPoint*)pObj3)->lpoints.AddTail(lp); 
								}
								/////////////////////////the locus is line!
								else if(pObj3->type==G_LINE)
								{
	                                CPoint2 point1,point2;
									point1.x=((CMyLine*)pObj3)->my_startpoint->m_startpoint.x;
									point1.y=((CMyLine*)pObj3)->my_startpoint->m_startpoint.y;
									point2.x=((CMyLine*)pObj3)->my_endpoint->m_startpoint.x;
									point2.y=((CMyLine*)pObj3)->my_endpoint->m_startpoint.y;
									CALine*line=new CALine();
									line->FirstPoint=point1;
									line->SecondPoint=point2;
									((CMyLine*)pObj3)->Alines.AddTail(line);
								}
							}
						 }
					}
				}
				
			}			
			Invalidate(TRUE);
	}
    ///compute the trace of locus end    
}

void CDrawView::DropAnimation()
{
 	///not let the locus show
	if((GetDocument()->m_LocusList.GetCount()>0)&&(GetDocument()->m_ObjDriveList.GetCount()>0))
	{
		POSITION pos1,pos2;
		POSITION ptemp=GetDocument()->m_LocusList.GetHeadPosition();
		while(ptemp!=NULL)
		{
			CDrawObj*ptempObj=GetDocument()->m_LocusList.GetNext(ptemp);
			if(ptempObj->type==1)
			{
				pos1=((CMyPoint*)ptempObj)->lpoints.GetHeadPosition();
				while(pos1!=NULL)
				{
					CLPoint*lp=((CMyPoint*)ptempObj)->lpoints.GetAt(pos1);
					pos2=pos1;
					((CMyPoint*)ptempObj)->lpoints.GetNext(pos1);
					((CMyPoint*)ptempObj)->lpoints.RemoveAt(pos2);
					delete lp;
				}		   
			}
			else if(ptempObj->type==2)
			{
			     pos1=((CMyLine*)ptempObj)->Alines.GetHeadPosition();
				 while(pos1!=NULL)
				 {
				      CALine*line=((CMyLine*)ptempObj)->Alines.GetAt(pos1);
					  pos2=pos1;
                      ((CMyLine*)ptempObj)->Alines.GetNext(pos1);
					  ((CMyLine*)ptempObj)->Alines.RemoveAt(pos2);
					  delete line;
				 }
			}
		}
	}
}

void CDrawView::OnCreateangle() 
{
	// TODO: Add your command handler code here
	m_CurrentMove=21;///һǶȡ
}

CString CDrawView::GetTrangleName(CDrawObj *pObj1, CDrawObj *pObj2, CDrawObj *pObj3)
{
      CString sTemp;
	  BOOL b1,b2,b3,b4,b5,b6;
	  b1=(pObj1->m_listindex>pObj2->m_listindex)&&(pObj1->m_listindex>pObj3->m_listindex)&&(pObj2->m_listindex>pObj3->m_listindex);///p1,p2,p3
	  b2=(pObj1->m_listindex>pObj2->m_listindex)&&(pObj1->m_listindex>pObj3->m_listindex)&&(pObj2->m_listindex<pObj3->m_listindex);///p1,p3,p2
	  b3=(pObj2->m_listindex>pObj1->m_listindex)&&(pObj2->m_listindex>pObj3->m_listindex)&&(pObj1->m_listindex>pObj3->m_listindex);///p2.p1,p3
	  b4=(pObj2->m_listindex>pObj1->m_listindex)&&(pObj2->m_listindex>pObj3->m_listindex)&&(pObj1->m_listindex<pObj3->m_listindex);///p2,p3,p1
	  b5=(pObj3->m_listindex>pObj1->m_listindex)&&(pObj3->m_listindex>pObj2->m_listindex)&&(pObj2->m_listindex>pObj1->m_listindex);///p3,p2,p1
	  b6=(pObj3->m_listindex>pObj1->m_listindex)&&(pObj3->m_listindex>pObj2->m_listindex)&&(pObj2->m_listindex<pObj1->m_listindex);///p3,p1,p2
	  if(b1)
	  {
	     sTemp=pObj1->sName+pObj2->sName+pObj3->sName;
	  }
	  else if(b2)
	  {
	     sTemp=pObj1->sName+pObj3->sName+pObj2->sName;
	  }
	  else if(b3)
	  {
	     sTemp=pObj2->sName+pObj1->sName+pObj3->sName;
	  }
	  else if(b4)
	  {
	     sTemp=pObj2->sName+pObj3->sName+pObj1->sName;
	  }
	  else if(b5)
	  {
	     sTemp=pObj3->sName+pObj2->sName+pObj1->sName;
	  }
	  else if(b6)
	  {
	     sTemp=pObj3->sName+pObj1->sName+pObj2->sName;
	  }                 
	  return sTemp;
}

RELATION* CDrawView::AddRelation(int temp, int iDeg, double f, bool bAdd,CDrawObj *O1, CDrawObj *O2, CDrawObj *O3, CDrawObj *O4)
{
    ////˴Ӵ룬жǷѾԼڣӣڣıԼ
	RELATION* pRel;
	CDrawObj*pObj1,*pObj2,*pObj3,*pObj4;
	int itemp(0),iJudge(0);
	POSITION pos,pos1;
	pos=GetDocument()->m_RelationList.GetHeadPosition();
	while(pos!=NULL)
	{
	    pRel=GetDocument()->m_RelationList.GetNext(pos);
		itemp=0;
		if(pRel->Nconstraintype==temp) ///жԼ͡ȻжϸǷһ
		{
			itemp=pRel->pObjList.GetCount();
		    pos1=pRel->pObjList.GetHeadPosition();
			switch(itemp)
			{
			case 2:
				{
				     pObj1=pRel->pObjList.GetNext(pos1);
					 pObj2=pRel->pObjList.GetNext(pos1);
				}
				break;
			case 3:
				{
				     pObj1=pRel->pObjList.GetNext(pos1);
					 pObj2=pRel->pObjList.GetNext(pos1);
					 pObj3=pRel->pObjList.GetNext(pos1);
				}
				break;
			case 4:
				{
				     pObj1=pRel->pObjList.GetNext(pos1);
					 pObj2=pRel->pObjList.GetNext(pos1);				
					 pObj3=pRel->pObjList.GetNext(pos1);
					 pObj4=pRel->pObjList.GetNext(pos1);
				}
				break;
				
			}
		    if(O4!=NULL)
			{
			     if(itemp==4)///֤Ϊĸ
				 {
				     ///ж϶ȡ
					 if((JudgeRelation(pObj1,O1,O2,O3,O4))&&(JudgeRelation(pObj2,O1,O2,O3,O4))&&(JudgeRelation(pObj3,O1,O2,O3,O4))&&(JudgeRelation(pObj4,O1,O2,O3,O4)))
					 {
					     ///ѾڸԼ
						 iJudge=1;
						 break;
					 }
				 }
			}
			else if(O3!=NULL)
			{
                 if(itemp==3)
				 {
				     if((JudgeRelation(pObj1,O1,O2,O3))&&(JudgeRelation(pObj2,O1,O2,O3))&&(JudgeRelation(pObj3,O1,O2,O3)))
					 {
					     ///ѾڸԼ
						 iJudge=1;
						 break;
					 }
				 }
			}
			else
			{
			      if(itemp==2)
				  {
				      if((JudgeRelation(pObj1,O1,O2))&&(JudgeRelation(pObj2,O1,O2))) 
					  {
					      iJudge=1;
						  break;
					  }
				  }
			}
			
		}
	}

	/////////////////////////////////////////////////////
	if(iJudge==1)
	{
	    pRel->N_dis_clamp=f;
		pRel->cDeg=iDeg;
        pRel->bAdjust=bAdd;
		return pRel;
	}
	else 
	{
		//////һжϣΪNlinkBдڵģ޸ģ
		CDrawObj*pObj;
		RELATION*rel;
		pos=O1->NlinkB.GetHeadPosition();
		while(pos!=NULL)
		{
		   rel=O1->NlinkB.GetNext(pos);
		   if(rel->Nconstraintype==temp)
		   {
		       pos1=rel->pObjList.GetHeadPosition();
			   while(pos1!=NULL)
			   {
			       pObj=rel->pObjList.GetNext(pos1);
				   if(pObj->m_listindex==O2->m_listindex)
				   {
				        iJudge=1;
							break;
				   }
			   }
		   }
		   if(iJudge==1)
			   break;
		}
		if(iJudge==1)
		{
			if(GetDocument()->m_RelationList.Find(rel)!=NULL)
			{
				 rel->N_dis_clamp=f;
				 rel->cDeg=iDeg;
				 rel->bAdjust=bAdd;				 
			}
			else
			{
			     rel->N_dis_clamp=f;
				 rel->cDeg=iDeg;
				 rel->bAdjust=bAdd;
                 GetDocument()->m_RelationList.AddTail(rel);				 
			}
			return rel;
		}
		else
		{
			/////////////////////////////////////////////////
			RELATION * Temp1;
			Temp1= new RELATION();
			Temp1->Nconstraintype=temp;      
			Temp1->cDeg=iDeg;		 		 

			Temp1->N_dis_clamp=f;
			Temp1->pObjList.AddTail(O1);
			O1->Nlink.AddTail(Temp1);
			if(bAdd==I_ZERO)
				O1->NlinkB.AddTail(Temp1);

			if(O2!=NULL)
			{
			   Temp1->pObjList.AddTail(O2);
			   O2->Nlink.AddTail(Temp1);
			   if(bAdd==I_ZERO)
				   O2->NlinkB.AddTail(Temp1);
			}
			if(O3!=NULL)
			{
				Temp1->pObjList.AddTail(O3);
				O3->Nlink.AddTail(Temp1);
				if(bAdd==I_ZERO)
					 O3->NlinkB.AddTail(Temp1);
			}
			if(O4!=NULL)
			{
				Temp1->pObjList.AddTail(O4);
				O4->Nlink.AddTail(Temp1);
				if(bAdd==I_ZERO)
					 O4->NlinkB.AddTail(Temp1);
			}
			GetDocument()->m_RelationList.AddTail(Temp1);
			Temp1->bAdjust=bAdd;
			return Temp1;	
		}
	}
	////////////////////////////////////////////////////////
}

BOOL CDrawView::JudgeRelation(CDrawObj *pObj1, CDrawObj *pObj2, CDrawObj *pObj3, CDrawObj *pObj4, CDrawObj *pObj5)
{
       if((pObj1==pObj2)||(pObj1==pObj3)||(pObj1==pObj4)||(pObj1==pObj5))
		   return TRUE;
	   else 
		   return FALSE;
}
void CDrawView::OnCreatePcircle() 
{
	// TODO: Add your command handler code here
    m_CurrentMove=P_NEW_CIRCLE;	
}

void CDrawView::OnCreateRcircle() 
{
	// TODO: Add your command handler code here
	m_CurrentMove=R_NEW_CIRCLE;
}

void CDrawView::OnCreateTcircle() 
{
	// TODO: Add your command handler code here
	m_CurrentMove=T_NEW_CIRCLE;
}

void CDrawView::GetTransformedList(CDrawObjList *temp,int itemp,CDrawObj *pObj1)
{
	////////////////////////////////////////////////////////////////
	//////for the debug//////////////////////////////////////////
	{
		FILE*tout_file;
		tout_file=fopen("tiao.txt","w");
		POSITION position = temp->GetHeadPosition();
		while(position != NULL)
		{
			CDrawObj* temp4 = temp->GetNext(position);
			{
				fprintf(tout_file,"\n %s:: \n",temp4->sName);
			}
			POSITION position_temp=temp4->Nlink.GetHeadPosition();
			while(position_temp!=NULL)
			{
				RELATION *temp=temp4->Nlink.GetNext(position_temp);
				fprintf(tout_file,"  Link=  ");
				POSITION pp=temp->pObjList.GetHeadPosition();
				while(pp!=NULL)
				{
					CDrawObj*ptempObj=temp->pObjList.GetNext(pp);
					if(ptempObj!=temp4)
					    fprintf(tout_file," %s",ptempObj->sName);
				}			
				fprintf(tout_file,"     %f",temp->N_dis_clamp);
 			}	    	
		}
		fclose(tout_file);
	}
	///úȡƵĳҪǼpObj1,϶Եġ
	CDrawObjList pObjStatic;///רű̶ģ
	POSITION position,pos;
    CDrawObjList templist;///ȡĵ
	CDrawObj* temp1,*pObj;
	if(pObj1==NULL)///not drag ;
	{
		CDrawObj * tempObj;
		RELATION *ptemprel;
		int idoc;
		POSITION position12,position13;
		position12=temp->GetHeadPosition();
		while(position12!=NULL)
		{
		   tempObj=temp->GetNext(position12);
		   idoc=0;
		   position13=tempObj->Nlink.GetHeadPosition();
		   while(position13!=NULL)
		   {
			   ptemprel=tempObj->Nlink.GetNext(position13);
			   idoc+=ptemprel->cDeg;
		   }
		   tempObj->Ndoc=idoc;//Ndocʼ
		   tempObj->NFlag=0;		 
		}
		///first ,initiate update;
		if(itemp==1)
		{
		    m_transformedlist.RemoveAll();
		}
		else
		{
		   pos=m_transformedlist.GetHeadPosition();
		   while(pos!=NULL)
		   {
		       pObj=m_transformedlist.GetNext(pos);
		   }
		}
		///һǷ̶⣻
        position=temp->GetHeadPosition();
		while(position!=NULL)
		{
		     temp1=temp->GetNext(position);
			 if((temp1->type==G_POINT)&&(temp1->bStatic==TRUE))
			 {			      
				   pObjStatic.AddHead(temp1);				   
			 }
		}
        ////////////////////////////////////  		
		position = temp->GetTailPosition();
		while(position != NULL)
		{
			temp1= temp->GetPrev(position);	
			if((temp1->Ndoc<=temp1->Ndof)&&(temp1->bStatic==FALSE)&&(temp1->bMark==I_ZERO))///the angle question can not decide
			{			
				if(temp1->type==G_POINT)
					templist.AddTail(temp1);           //////accomdated the point;ǰӡ 				
				else if((temp1->type!=G_POINT))
				    m_transformedlist.AddHead(temp1);   //////accomdated the others;ɺǰӡ						
				temp1->NFlag=1;
			}		
		}
		///ʼ
		POSITION position3 = templist.GetHeadPosition();   /// ȡеȼ˵Ķ
		POSITION position1 = m_transformedlist.GetTailPosition();   ///ȡ
		int flag=0;
		while(position3 != NULL||position1 != NULL)
		{
       		POSITION record3 = position3;
            if(m_transformedlist.GetCount()==temp->GetCount())
				break;
			while(position1 != NULL)
			{
				POSITION record1=position1;
				if(m_transformedlist.GetCount()==temp->GetCount())
		    		break;
				CDrawObj* temp2 = m_transformedlist.GetPrev(position1);			
				if(temp2->bMark==I_ZERO)
				{
				   POSITION position2 = temp2->Nlink.GetHeadPosition();
				   while(position2 !=NULL)
				   {
						RELATION* temp_relation = temp2->Nlink.GetNext(position2);
						/////////////////add by 4/19 begin/////
						CDrawObj*pObj;
						POSITION poss=temp_relation->pObjList.GetHeadPosition();
						while(poss!=NULL)
						{
							pObj=temp_relation->pObjList.GetNext(poss);
							///////////////////////////////////////////////////////
			    			if((pObj!=temp2)&&(pObj->NFlag!=1)&&(pObj->bStatic==false)&&(pObj->bMark==I_ZERO))
							{
				    			pObj->Ndoc-=temp_relation->cDeg;//////
								if(((pObj->Ndoc)<=pObj->Ndof))	                           
								{   
									if(pObj->type==G_LINE)//objΪֱߵȡ
									{
										CRelationlist temp_relationlist;                                          
										POSITION pos = pObj->Nlink.GetHeadPosition();
										while(pos !=NULL)//ʱpObjNlinkСڵ2
										{
											  RELATION *pRelate =pObj->Nlink.GetNext(pos);
											  if((pRelate->Nconstraintype>=LL_ANGLE)&&(pRelate->Nconstraintype<=LL_PERP))
												  //pObjNlinkнڵΪֱߵָΪpObj1
											  {
												   POSITION ppp=pRelate->pObjList.GetHeadPosition();
												   while(ppp!=NULL)
												   {
														CDrawObj*pObjj=pRelate->pObjList.GetNext(ppp);
                                                        if((pObjj->NFlag!=1)&&(pObjj!=pObj))//Ϊδȷֱ							
														{
													        temp_relationlist.AddTail(pRelate);
														}
												   }
												   
											  }							  
										}
										if(temp_relationlist.GetCount()!=2)//Ϊ2һֱpObjδֱ߾
										{    
											m_transformedlist.AddHead(pObj);
											pObj->NFlag=1;//pObjȡ
										}
										else 
										{
											pObj->NFlag=0;//AfxMessageBox("kjd");
										}							
									}//////////////////////////////һֱֱ߾
									else if(pObj->type==G_POINT)////objΪȡ
									{   
										POSITION temp_pos=templist.AddTail(pObj);
										if(position3==NULL)
										{
											position3=temp_pos;
											record3=temp_pos;
										}
										pObj->NFlag=1;								
									}
									else
									{
										  templist.AddTail(pObj);
										  pObj->NFlag=1;							
									}
								}
							}
						}
				   }
				}
				m_transformedlist.GetPrev(record1);//ʱΪpostion1=nullrecord1
				if(record1 != NULL)
				{
					position1=record1;//record1¼position1Աǰȡһ¼Ԫ
				}
			}

			//33333333333/////////ʵпȡֱߣposition1nlinkеԪȡѭ
			if(flag==0)//////////////////////////////////////////////////////////
			{
				flag=1;
			}
			else//////////////////ȷһposition3ÿָһλ
			{
				templist.GetNext(record3);
				position3=record3;
			}
			if(position3!=NULL)
			{
				CDrawObj* temppoint = templist.GetNext(position3);
				position3=record3;//////////////////ȷһposition3ÿָһλ
				m_transformedlist.AddHead(temppoint);//ʱposition1= null
				position1=m_transformedlist.GetHeadPosition();//templistȡһԪأ㣩		                                  
			}
		}//ѭposition1,position3!=null
		position = temp->GetHeadPosition();
		while(position != NULL)
		{
			CDrawObj* temp3 = temp->GetNext(position);
			temp3->NFlag=0;//visited flag λ
		}		
	}
	else  ///drag;
	{
        ///ŶpObj1϶ȻĵС
		CDrawObj * tempObj;
		RELATION *ptemprel;
		int idoc;
		POSITION position12,position13;
		position12=temp->GetHeadPosition();
		while(position12!=NULL)
		{
		   tempObj=temp->GetNext(position12);
		   idoc=0;
		   position13=tempObj->Nlink.GetHeadPosition();
		   while(position13!=NULL)
		   {
			   ptemprel=tempObj->Nlink.GetNext(position13);
			   idoc+=ptemprel->cDeg;
		   }
		   tempObj->Ndoc=idoc;//Ndocʼ
		   tempObj->NFlag=0;		 
		}
		if(itemp==1)
		{
	    	m_transformedlist.RemoveAll();
		}
		///һǷ̶⣻
        position=temp->GetHeadPosition();
		while(position!=NULL)
		{
		     temp1=temp->GetNext(position);
			 if((temp1->type==G_POINT)&&(temp1->bStatic==TRUE))
			 {			      
				   pObjStatic.AddHead(temp1);				   
			 }
		}          
        ////////////////////////////////////  
		///because Drag,add the point the most before;
		///xgao:һܹ²϶
		if(pObj1->Ndoc<=pObj1->Ndof)
		{
			temp1->NFlag=1;
		}
		//////////////////////////////////////////////////////////////////////////////////////////
	    position = temp->GetTailPosition();
		while(position != NULL)
		{
			temp1= temp->GetPrev(position);	
			if((temp1->Ndoc<=temp1->Ndof)&&(temp1->m_listindex!=pObj1->m_listindex)&&(temp1->bStatic==false))///the angle question can not decide
			{			
				if(temp1->type==G_POINT)
				{					
					templist.AddTail(temp1);           //////accomdated the point;ǰӡ 
				}
				else if((temp1->type!=G_POINT))
				{
					m_transformedlist.AddHead(temp1);   //////accomdated the others;ɺǰӡ
				}		
				temp1->NFlag=1;
			}		
		}
		///ʼ
		POSITION position3 = templist.GetHeadPosition();   /// ȡеȼ˵Ķ
		POSITION position1 = m_transformedlist.GetTailPosition();   ///ȡ
		int flag=0;
		while(position3 != NULL||position1 != NULL)
		{
       		POSITION record3 = position3;
			if(m_transformedlist.GetCount()==temp->GetCount()-1)
				break;
			while(position1 != NULL)
			{
				POSITION record1=position1;
				if(m_transformedlist.GetCount()==temp->GetCount()-1)
				     break;
				CDrawObj* temp2 = m_transformedlist.GetPrev(position1);								
				POSITION position2 = temp2->Nlink.GetHeadPosition();
				while(position2 !=NULL)
				{
					RELATION* temp_relation = temp2->Nlink.GetNext(position2);
					/////////////////add by 4/19 begin/////
					CDrawObj*pObj;
					POSITION poss=temp_relation->pObjList.GetHeadPosition();
					while(poss!=NULL)
					{
						pObj=temp_relation->pObjList.GetNext(poss);
			    		if((pObj!=temp2)&&(pObj->NFlag!=1)&&(pObj->bStatic==false))
						{
				   			pObj->Ndoc-=temp_relation->cDeg;//////
							if((pObj->Ndoc)<=pObj->Ndof)	                           
							{   
								if(pObj->type==G_LINE)//objΪֱߵȡ
								{
									CRelationlist temp_relationlist;    
									POSITION pos = pObj->Nlink.GetHeadPosition();
									while(pos !=NULL)//ʱpObjNlinkСڵ2
									{
										  RELATION *pRelate =pObj->Nlink.GetNext(pos);
										  if((pRelate->Nconstraintype>=LL_ANGLE)&&(pRelate->Nconstraintype<=LL_PERP))
											  //pObjNlinkнڵΪֱߵָΪpObj1
										  {
											   POSITION ppp=pRelate->pObjList.GetHeadPosition();
											   while(ppp!=NULL)
											   {
											        CDrawObj*pObjj=pRelate->pObjList.GetNext(ppp);
													if((pObjj->NFlag!=1)&&(pObjj!=pObj))//Ϊδȷֱ							
													{
												          temp_relationlist.AddTail(pRelate);
													}
											   }		
										   }
											   					  
									}
									if(temp_relationlist.GetCount()!=2)//Ϊ2һֱpObjδֱ߾
									{    
										m_transformedlist.AddHead(pObj);
										pObj->NFlag=1;//pObjȡ
									}
									else 
									{
										pObj->NFlag=0;//AfxMessageBox("kjd");
									}
								}//////////////////////////////һֱֱ߾
								else if(pObj->type==G_POINT)////objΪȡ
								{   
									POSITION temp_pos=templist.AddTail(pObj);
									if(position3==NULL)
									{
										position3=temp_pos;
										record3=temp_pos;
									}
									pObj->NFlag=1;									
								}
								else
								{
									  templist.AddTail(pObj);
									  pObj->NFlag=1;
								}
							}
						}
					}
				}				
				m_transformedlist.GetPrev(record1);//ʱΪpostion1=nullrecord1
				if(record1 != NULL)
				{
					position1=record1;//record1¼position1Աǰȡһ¼Ԫ
				}
			}

			//33333333333/////////ʵпȡֱߣposition1nlinkеԪȡѭ
			if(flag==0)//////////////////////////////////////////////////////////
			{
				flag=1;
			}
			else//////////////////ȷһposition3ÿָһλ
			{
				templist.GetNext(record3);
				position3=record3;
			}
			if(position3!=NULL)
			{
				CDrawObj* temppoint = templist.GetNext(position3);
				position3=record3;//////////////////ȷһposition3ÿָһλ
				m_transformedlist.AddHead(temppoint);//ʱposition1= null
				position1=m_transformedlist.GetHeadPosition();//templistȡһԪأ㣩		                                  
			}
		}//ѭposition1,position3!=null
		if(pObj1->NFlag==1)
		     m_transformedlist.AddHead(pObj1);
		//////////////////////////////////////////////
		position = temp->GetHeadPosition();
		while(position != NULL)
		{
			CDrawObj* temp3 = temp->GetNext(position);
			temp3->NFlag=0;//visited flag λ
		}	
	}
    ////////////////////////////////////////////////////////////////
    //////////̶ڹеǰ/////////////////////
    position=pObjStatic.GetHeadPosition();
	while(position!=NULL)
	{
	    pObj=pObjStatic.GetNext(position);
		m_transformedlist.AddHead(pObj);
	}
	///////////////////////////////////////////////////////////////
	////Add by qlin for sendMessage begin
	CDrawDoc*pDoc=GetDocument();
	HWND hpWnd;
	hpWnd=Ghwnd;
	::SendMessage(hpWnd,WM_MESSAGESEND,0,(LONG)pDoc);
	////Add by qlin for sendMessage end
}

void CDrawView::OnCoCz() 
{
	// TODO: Add your command handler code here
	m_CurrentMove=CO_CZ;
}

void CDrawView::OnCoMid() 
{
	// TODO: Add your command handler code here
	m_CurrentMove=CO_MID;
}

void CDrawView::OnCoPx() 
{
	// TODO: Add your command handler code here
	m_CurrentMove=CO_PX;
}

int CDrawView::sol_lll(double a, double b, double c, double a1, double b1, double c1)
{
    ///ֱabcֱa1b1c1Ľ㡣
    double temp;
    temp = a*b1 - a1*b;
	int itemp(0);
    if (temp < 0.00000001 && temp > -0.00000001)
    { 
		itemp=-1;
		//return -1;    //غϻƽУ޽
	}else
	{
		double temp1,temp2;
		temp1=b*c1 - c*b1;
		temp2=a1*c - a*c1;
		intersection->x = temp1/temp;
		intersection->y = temp2/temp;
		itemp=1;
		//return 1;
	}
	return itemp;
}

CMyLine* CDrawView::Vertical(CDrawObjList &temp)
{
 if(temp.GetCount()>1)
	{
	    POSITION pos = temp.GetTailPosition();
	    CDrawObj* pObj1 = temp.GetPrev(pos);
        CDrawObj* pObj2 = temp.GetPrev(pos);
		CPoint2 temp,temp1,temp2,temp3,temp4;
		if(pObj1->type==1&&pObj2->type==2)
		{
		    temp1=((CMyPoint*)pObj1)->m_startpoint;
			temp2=((CMyLine*)pObj2)->my_startpoint->m_startpoint;
			temp3=((CMyLine*)pObj2)->my_endpoint->m_startpoint;
			temp4=CPoint2(0,1);
            temp=temp1-temp4*(temp3-temp2);
			CMyPoint* pObjpoint=new CMyPoint(&temp);
			pObjpoint->ptype=4;//ʾֱֱϵ
			pObjpoint->m_scale=1;
			m_paralleline=new CMyLine((CMyPoint*)pObj1,pObjpoint);
			pObjpoint->m_startpoint=m_paralleline->getPointByScale(pObjpoint->m_scale);
			pObjpoint->m_conect1=m_paralleline;
            pObjpoint->m_conect2=(CMyLine*)pObj2;
            GetDocument()->Add(pObjpoint);
			CMyPoint *tmp=new CMyPoint(&temp);
			CMyPoint *tmp1=new CMyPoint(&temp1);
            pObjpoint->m_conectrecord=new CMyLine(tmp1,tmp);
            
			return m_paralleline;
            
		}
		else if(pObj1->type==2&&pObj2->type==1)
		{
		    temp1=((CMyPoint*)pObj2)->m_startpoint;
			temp2=((CMyLine*)pObj1)->my_startpoint->m_startpoint;
			temp3=((CMyLine*)pObj1)->my_endpoint->m_startpoint;
			temp4=CPoint2(0,1);
            temp=temp1-temp4*(temp3-temp2);
			CMyPoint* pObjpoint=new CMyPoint(&temp);
			pObjpoint->ptype=4;//ʾֱֱϵ
            pObjpoint->m_scale=1;
			m_paralleline=new CMyLine((CMyPoint*)pObj2,pObjpoint);
			pObjpoint->m_startpoint=m_paralleline->getPointByScale(pObjpoint->m_scale);
			pObjpoint->m_conect1=m_paralleline;
			pObjpoint->m_conect2=(CMyLine*)pObj1;
            GetDocument()->Add(pObjpoint);
			CMyPoint *tmp=new CMyPoint(&temp);
			CMyPoint *tmp1=new CMyPoint(&temp1);
            pObjpoint->m_conectrecord=new CMyLine(tmp1,tmp);
			return m_paralleline;
		}

		return NULL;
	}
	else
	{
	    return NULL;
	}
}

CMyLine* CDrawView::VerticalFoot(CDrawObjList &temp)
{
    if(temp.GetCount()>1)
	{
	    POSITION pos = temp.GetTailPosition();
	    CDrawObj* pObj1 = temp.GetPrev(pos);
        CDrawObj* pObj2 = temp.GetPrev(pos);
		CPoint2 temp1,temp2,ttemp;
		if(pObj1->type==1&&pObj2->type==2)
		{
		    temp1=((CMyPoint*)pObj1)->m_startpoint;
			temp2=((CMyLine*)pObj2)->my_startpoint->m_startpoint;
			CPoint2 * footpoint=Intersection_Paral_Verti(temp2,(CMyLine*)pObj2,temp1, (CMyLine*)pObj2,6);
			
			ttemp=(* footpoint);
			CMyPoint* pObjpoint=new CMyPoint(&ttemp);				                             
			pObjpoint->ptype=6;//ʾ
			m_paralleline=new CMyLine((CMyPoint*)pObj1,pObjpoint);
			pObjpoint->m_conect1=m_paralleline;
            pObjpoint->m_conect2=(CMyLine*)pObj2;
            GetDocument()->Add(pObjpoint);
			/*CMyPoint *tmp=new CMyPoint(&temp);
			CMyPoint *tmp1=new CMyPoint(&temp1);
            pObjpoint->m_conectrecord=new CMyLine(tmp1,tmp);*/
            
			return m_paralleline;
            
		}
		else if(pObj1->type==2&&pObj2->type==1)
		{
		    temp1=((CMyPoint*)pObj2)->m_startpoint;
			temp2=((CMyLine*)pObj1)->my_startpoint->m_startpoint;
			CPoint2 * footpoint=Intersection_Paral_Verti(temp2,(CMyLine*)pObj1,temp1, (CMyLine*)pObj1,6);
			ttemp=(* footpoint);
			CMyPoint* pObjpoint=new CMyPoint(&ttemp);
			pObjpoint->ptype=6;//ʾ
			m_paralleline=new CMyLine((CMyPoint*)pObj2,pObjpoint);
			pObjpoint->m_conect1=m_paralleline;
            pObjpoint->m_conect2=(CMyLine*)pObj1;
            GetDocument()->Add(pObjpoint);
			
			return m_paralleline;
		}

		return NULL;
	}
	else
	{
	    return NULL;
	}
}

///add by qlin,ΪɾԼɾpObj1ϵԼԼΪpObj1 and pObj2;
void CDrawView::DeleteRelation(CDrawObj *pObj1, CDrawObj *pObj2)
{
	POSITION pos,pos1;
	CDrawObj*pObj;
	RELATION* temp_rel;
	int iJudge(0);
    pos=pObj1->Nlink.GetHeadPosition();
	while(pos!=NULL)
	{
		 POSITION pos33=pos;
		 temp_rel=pObj1->Nlink.GetAt(pos33);
		 pos1=temp_rel->pObjList.GetHeadPosition();
		 while(pos1!=NULL)
		 {
		      pObj=temp_rel->pObjList.GetNext(pos1);
              if(pObj->m_listindex==pObj2->m_listindex)
			  {
			      iJudge=1;
				  break;
			  }
		 }
		 if(iJudge==1)				
		 {
			  pObj1->Nlink.RemoveAt(pos33);
			  pObj1->Ndoc--;
			  break;
		 }
		 pObj1->Nlink.GetNext(pos);
	}	
}

CDrawObj* CDrawView::FindTheLineFromTwoPoints(CDrawObj *pObj1, CDrawObj *pObj2)
{
	///this function is according two point in order to find the line which has the two point;
	if((pObj1->type==G_POINT)&&(pObj2->type==G_POINT))
	{
		POSITION pos,pos1,pos2,pos3;
		RELATION *rel1,*rel2;
		CDrawObj *pObj,*ppObj;
		int ijudge(0);

		pos=pObj1->Nlink.GetHeadPosition();
		while(pos!=NULL)
		{
			  rel1=pObj1->Nlink.GetNext(pos);
			  pos1=rel1->pObjList.GetHeadPosition();
			  while(pos1!=NULL)
			  {
				  pObj=rel1->pObjList.GetNext(pos1);
				  if((pObj->type==G_LINE)&&(rel1->Nconstraintype==PL_DIS)&&(rel1->N_dis_clamp<L_ZERO))
				  {
					   pos2=pObj->Nlink.GetHeadPosition();
					   while(pos2!=NULL)
					   {
							rel2=pObj->Nlink.GetNext(pos2);
							pos3=rel2->pObjList.GetHeadPosition();
							while(pos3!=NULL)
							{
								ppObj=rel2->pObjList.GetNext(pos3);
								if((ppObj==pObj2)&&(ppObj->type==G_POINT)&&(rel2->Nconstraintype==PL_DIS)&&(rel2->N_dis_clamp<L_ZERO))
								{
									ijudge=1;								
								}
								if(ijudge==1)
									break;
							}
							if(ijudge==1)
								break;
					   }
				  }			 
				  if(ijudge==1)
					  break;
			  }
			  if(ijudge==1)
				  break;
		  }
		 return pObj;
	}
	else
	{
	    return NULL;
	}
}
///ǷԼ⣬úΪpObj3ΪһԲɵpObj1,pObj2ȷ
///ΪһԲϵ㣬һ̶һ϶϶ʱԲ
void CDrawView::ComputeCirclebytwopoint(CDrawObj*pObj1,CDrawObj*pObj2,CDrawObj*pObj3)
{
	if((pObj1->type==G_POINT)&&(pObj2->type==G_POINT)&&(pObj3->type==G_CIRCLE))
	{
	      double x1,y1,x2,y2,x,y,r,x3,y3,x4,y4,x0,y0,rr;
		  if((pObj1->bStatic==TRUE)&&(pObj2->bStatic==FALSE))
		  {
		       x1=((CMyPoint*)pObj1)->m_startpoint.x;
		       y1=((CMyPoint*)pObj1)->m_startpoint.y;
			   x2=((CMyPoint*)pObj2)->m_startpoint.x;
		       y2=((CMyPoint*)pObj2)->m_startpoint.y;
		  }
		  else if((pObj2->bStatic==TRUE)&&(pObj1->bStatic==FALSE))
		  {
		       x1=((CMyPoint*)pObj2)->m_startpoint.x;
		       y1=((CMyPoint*)pObj2)->m_startpoint.y;
			   x2=((CMyPoint*)pObj1)->m_startpoint.x;
		       y2=((CMyPoint*)pObj1)->m_startpoint.y;
		  }    
		  else 
		  {}
		  x=((CMyCircle*)pObj3)->ABC[0];
		  y=((CMyCircle*)pObj3)->ABC[1];
		  r=((CMyCircle*)pObj3)->ABC[2];
          double a,b;
		  a=sqrt((x1-x)*(x1-x)+(y1-y)*(y1-y));
		  b=sqrt((x2-x)*(x2-x)+(y2-y)*(y2-y));
		  /////////////////////ʼȷԲ
		  /////////һõʼλã(x3-x)^2+(y3-y)^2=r^2,(x3-x1)/(x2-x1)=(y3-y1)/(y2-y1);
		  y3=0.5/(-2*y2*y1-2*x2*x1+x2*x2+x1*x1+y2*y2+y1*y1)*(-2*x*x1*y2
			  +2*y2*y2*y-4*y*y2*y1+2*x1*x1*y2+2*x2*x2*y1-2*x1*y1*x2+2*y1*y1*y
			  -2*y1*x2*x-2*x1*y2*x2+2*y1*x1*x+2*x*x2*y2-2*sqrt(2*y2*y2*y2*y*x1*x1
			  +2*y2*y2*y2*y1*x1*x1+4*y2*y1*y1*y1*x*x+4*y2*y2*y2*y1*x*x+6*y2*y2*y1*y1*r*r
			  -6*y2*y2*y1*y1*x*x+6*y*y2*y1*y1*x2*x+2*y*y2*y1*y1*x1*x2+2*x2*x2*y1*y1*y1*y
			  -6*y2*y2*y*y1*x2*x-6*x*x1*y2*y1*y1*y-y1*y1*x1*x1*y2*y2+2*y1*y1*y1*y1*x*x2
			  +4*x2*x1*r*r*y2*y1-4*x2*x1*y*y*y2*y1-y2*y2*y1*y1*x2*x2+2*y2*y2*y2*y2*x*x1
			  +x1*x1*r*r*y1*y1+x1*x1*r*r*y2*y2-x1*x1*y*y*y1*y1-x1*x1*y*y*y2*y2+x2*x2*r*r*y1*y1
			  +x2*x2*r*r*y2*y2-x2*x2*y*y*y1*y1-x2*x2*y*y*y2*y2-4*y2*y1*y1*y1*r*r-4*y2*y2*y2*y1*r*r
			  +2*y2*y1*y1*y1*x2*x2+2*y2*y2*y*x1*y1*x2-2*x*x1*y2*y2*y2*y+2*x1*x1*y2*y1*y1*y
			  -4*y*y2*y1*y1*x2*x2-4*y*y2*y2*y1*x1*x1+2*y2*y2*y2*y*x*x2-2*y2*y2*y2*y*x1*x2
			  +2*y2*y2*y*x2*x2*y1+2*y1*y1*y1*y*x1*x-2*y1*y1*y1*y*x2*x-2*x1*y1*y1*y1*x2*y
			  -4*y2*y2*y1*y1*x1*x2-6*y2*y1*y1*y1*x*x2-6*y2*y2*y2*y1*x*x1-2*x2*x2*r*r*y2*y1+2*x2*x2*y*y*y2*y1
			  -2*x2*x1*r*r*y1*y1-2*x2*x1*r*r*y2*y2+2*x2*x1*y*y*y1*y1+2*x2*x1*y*y*y2*y2+6*y2*y2*y1*y1*x*x2
			  +6*y2*y2*y1*y1*x*x1-2*x1*x1*r*r*y2*y1+2*x1*x1*y*y*y2*y1-2*y1*y1*y1*x*x1*y2+2*y1*y1*y1*x1*y2*x2
			  -2*y2*y2*y2*x*y1*x2+2*y2*y2*y2*x1*y1*x2-y2*y2*y2*y2*x*x+y2*y2*y2*y2*r*r
			  +6*x*x1*y2*y2*y*y1-y2*y2*y2*y2*x1*x1-y1*y1*y1*y1*x2*x2-y1*y1*y1*y1*x*x+y1*y1*y1*y1*r*r));	  
		  y4=0.5/(-2*y2*y1-2*x2*x1+x2*x2+x1*x1+y2*y2+y1*y1)*(-2*x*x1*y2
			  +2*y2*y2*y-4*y*y2*y1+2*x1*x1*y2+2*x2*x2*y1-2*x1*y1*x2+2*y1*y1*y
			  -2*y1*x2*x-2*x1*y2*x2+2*y1*x1*x+2*x*x2*y2+2*sqrt(2*y2*y2*y2*y*x1*x1
			  +2*y2*y2*y2*y1*x1*x1+4*y2*y1*y1*y1*x*x+4*y2*y2*y2*y1*x*x+6*y2*y2*y1*y1*r*r
			  -6*y2*y2*y1*y1*x*x+6*y*y2*y1*y1*x2*x+2*y*y2*y1*y1*x1*x2+2*x2*x2*y1*y1*y1*y
			  -6*y2*y2*y*y1*x2*x-6*x*x1*y2*y1*y1*y-y1*y1*x1*x1*y2*y2+2*y1*y1*y1*y1*x*x2
			  +4*x2*x1*r*r*y2*y1-4*x2*x1*y*y*y2*y1-y2*y2*y1*y1*x2*x2+2*y2*y2*y2*y2*x*x1
			  +x1*x1*r*r*y1*y1+x1*x1*r*r*y2*y2-x1*x1*y*y*y1*y1-x1*x1*y*y*y2*y2+x2*x2*r*r*y1*y1
			  +x2*x2*r*r*y2*y2-x2*x2*y*y*y1*y1-x2*x2*y*y*y2*y2-4*y2*y1*y1*y1*r*r-4*y2*y2*y2*y1*r*r
			  +2*y2*y1*y1*y1*x2*x2+2*y2*y2*y*x1*y1*x2-2*x*x1*y2*y2*y2*y+2*x1*x1*y2*y1*y1*y
			  -4*y*y2*y1*y1*x2*x2-4*y*y2*y2*y1*x1*x1+2*y2*y2*y2*y*x*x2-2*y2*y2*y2*y*x1*x2
			  +2*y2*y2*y*x2*x2*y1+2*y1*y1*y1*y*x1*x-2*y1*y1*y1*y*x2*x-2*x1*y1*y1*y1*x2*y
			  -4*y2*y2*y1*y1*x1*x2-6*y2*y1*y1*y1*x*x2-6*y2*y2*y2*y1*x*x1-2*x2*x2*r*r*y2*y1+2*x2*x2*y*y*y2*y1
			  -2*x2*x1*r*r*y1*y1-2*x2*x1*r*r*y2*y2+2*x2*x1*y*y*y1*y1+2*x2*x1*y*y*y2*y2+6*y2*y2*y1*y1*x*x2
			  +6*y2*y2*y1*y1*x*x1-2*x1*x1*r*r*y2*y1+2*x1*x1*y*y*y2*y1-2*y1*y1*y1*x*x1*y2+2*y1*y1*y1*x1*y2*x2
			  -2*y2*y2*y2*x*y1*x2+2*y2*y2*y2*x1*y1*x2-y2*y2*y2*y2*x*x+y2*y2*y2*y2*r*r
			  +6*x*x1*y2*y2*y*y1-y2*y2*y2*y2*x1*x1-y1*y1*y1*y1*x2*x2-y1*y1*y1*y1*x*x+y1*y1*y1*y1*r*r));	  
         x3 = -(x1*y2+y3*x2-y3*x1-y1*x2)/(-y2+y1);
		 x4 = -(x1*y2+y4*x2-y4*x1-y1*x2)/(-y2+y1);
         if(((x3-x2)*(x3-x2)+(y3-y2)*(y3-y2))>((x4-x2)*(x4-x2)+(y4-y2)*(y4-y2)))
		 {
		    x0=x4;
			y0=y4;
		 }
		 else
		 {
		    x0=x3;
			y0=y3;
		 }
		 /////ڶȷԲİ뾶
		 rr=(r*sqrt((x1-x2)*(x1-x2)+(y1-y2)*(y1-y2)))/(sqrt((x1-x0)*(x1-x0)+(y1-y0)*(y1-y0)));
		 ////ȷԲģɰ뾶Բ㣻rr,x1,y1,x2,y2;,(x-x1)^2+(y-y1)^2=rr^2,(x-x2)^2+(y-y2)^2=rr^2;
		 y3=0.5/(-8*y2*y1+4*x2*x2+4*x1*x1-8*x2*x1+4*y2*y2+4*y1*y1)*(4*x1*x1*y1+4*x2*x2*y2-4*y2*y1*y1
			 -8*x1*y1*x2+4*x1*x1*y2-8*x1*y2*x2+4*y1*y1*y1-4*y2*y2*y1+4*y2*y2*y2+4*x2*x2*y1+4*sqrt(4*y2*y2*y2*y1*x1*x1
			 -6*y1*y1*x1*x1*y2*y2-6*y2*y2*y1*y1*x2*x2+4*y2*y1*y1*y1*x2*x2+12*y2*y2*y1*y1*x1*x2-x1*x1*y1*y1*y1*y1
			 -2*x2*x2*x2*x2*y2*y2-2*x2*x2*x2*x2*y1*y1-15*x2*x2*x1*x1*x1*x1-15*x2*x2*x2*x2*x1*x1+6*x2*x2*x2*x2*x2*x1
			 +20*x2*x2*x2*x1*x1*x1+4*x2*x2*x2*x2*rr*rr+6*x1*x1*x1*x1*x1*x2+4*x1*x1*x1*x1*rr*rr+4*y2*y2*rr*rr*x2*x2
			 +4*y2*y2*rr*rr*x1*x1+4*y1*y1*rr*rr*x2*x2+4*y1*y1*rr*rr*x1*x1-16*x2*x2*x2*rr*rr*x1+24*x2*x2*rr*rr*x1*x1
			 +4*x2*x2*y2*y2*y2*y1-x2*x2*y2*y2*y2*y2-2*x1*x1*x1*x1*y1*y1+4*x2*x2*x2*x2*y2*y1+2*x1*y1*y1*y1*y1*x2
			 +8*x1*y1*y1*x2*x2*x2+8*x1*x1*x1*y2*y2*x2+2*x1*y2*y2*y2*y2*x2-2*x1*x1*x1*x1*y2*y2+24*x1*x1*y1*x2*x2*y2
			 -16*x1*x1*x1*y1*y2*x2-16*x2*x2*x2*y2*x1*y1+4*x1*x1*y1*y1*y1*y2+8*x1*x1*x1*y1*y1*x2+4*x1*x1*x1*x1*y1*y2
			 -12*x1*x1*y1*y1*x2*x2-12*x2*x2*y2*y2*x1*x1+8*x2*x2*x2*y2*y2*x1-x2*x2*x2*x2*x2*x2-x1*x1*x1*x1*x1*x1
			 -8*y1*y1*y1*x1*y2*x2-8*y2*y2*y2*x1*y1*x2-y2*y2*y2*y2*x1*x1-y1*y1*y1*y1*x2*x2+16*y2*y1*rr*rr*x2*x1
			 -16*x1*x1*x1*rr*rr*x2-8*y2*y1*rr*rr*x2*x2-8*y2*y1*rr*rr*x1*x1-8*y2*y2*rr*rr*x2*x1-8*y1*y1*rr*rr*x2*x1));
		  y4=0.5/(-8*y2*y1+4*x2*x2+4*x1*x1-8*x2*x1+4*y2*y2+4*y1*y1)*(4*x1*x1*y1+4*x2*x2*y2-4*y2*y1*y1
			 -8*x1*y1*x2+4*x1*x1*y2-8*x1*y2*x2+4*y1*y1*y1-4*y2*y2*y1+4*y2*y2*y2+4*x2*x2*y1-4*sqrt(4*y2*y2*y2*y1*x1*x1
			 -6*y1*y1*x1*x1*y2*y2-6*y2*y2*y1*y1*x2*x2+4*y2*y1*y1*y1*x2*x2+12*y2*y2*y1*y1*x1*x2-x1*x1*y1*y1*y1*y1
			 -2*x2*x2*x2*x2*y2*y2-2*x2*x2*x2*x2*y1*y1-15*x2*x2*x1*x1*x1*x1-15*x2*x2*x2*x2*x1*x1+6*x2*x2*x2*x2*x2*x1
			 +20*x2*x2*x2*x1*x1*x1+4*x2*x2*x2*x2*rr*rr+6*x1*x1*x1*x1*x1*x2+4*x1*x1*x1*x1*rr*rr+4*y2*y2*rr*rr*x2*x2
			 +4*y2*y2*rr*rr*x1*x1+4*y1*y1*rr*rr*x2*x2+4*y1*y1*rr*rr*x1*x1-16*x2*x2*x2*rr*rr*x1+24*x2*x2*rr*rr*x1*x1
			 +4*x2*x2*y2*y2*y2*y1-x2*x2*y2*y2*y2*y2-2*x1*x1*x1*x1*y1*y1+4*x2*x2*x2*x2*y2*y1+2*x1*y1*y1*y1*y1*x2
			 +8*x1*y1*y1*x2*x2*x2+8*x1*x1*x1*y2*y2*x2+2*x1*y2*y2*y2*y2*x2-2*x1*x1*x1*x1*y2*y2+24*x1*x1*y1*x2*x2*y2
			 -16*x1*x1*x1*y1*y2*x2-16*x2*x2*x2*y2*x1*y1+4*x1*x1*y1*y1*y1*y2+8*x1*x1*x1*y1*y1*x2+4*x1*x1*x1*x1*y1*y2
			 -12*x1*x1*y1*y1*x2*x2-12*x2*x2*y2*y2*x1*x1+8*x2*x2*x2*y2*y2*x1-x2*x2*x2*x2*x2*x2-x1*x1*x1*x1*x1*x1
			 -8*y1*y1*y1*x1*y2*x2-8*y2*y2*y2*x1*y1*x2-y2*y2*y2*y2*x1*x1-y1*y1*y1*y1*x2*x2+16*y2*y1*rr*rr*x2*x1
			 -16*x1*x1*x1*rr*rr*x2-8*y2*y1*rr*rr*x2*x2-8*y2*y1*rr*rr*x1*x1-8*y2*y2*rr*rr*x2*x1-8*y1*y1*rr*rr*x2*x1));
		  x3=-0.5*(-2*y3*y2+2*y3*y1+x2*x2+y2*y2-x1*x1-y1*y1)/(-x2+x1);
		  x4=-0.5*(-2*y4*y2+2*y4*y1+x2*x2+y2*y2-x1*x1-y1*y1)/(-x2+x1);
		  //////////////////////////////////////////////////////////////
		  ///add the judge of which point of 3,4;
		  if(((x3-x)*(x3-x)+(y3-y)*(y3-y))>((x4-x)*(x4-x)+(y4-y)*(y4-y)))
		 {
		    x3=x4;
			y3=y4;
		 }
		 else
		 {
		    x3=x3;
			y3=y3;
		 }
		  ((CMyCircle*)pObj3)->ABC[0]=x3;
		  ((CMyCircle*)pObj3)->ABC[1]=y3;
		  ((CMyCircle*)pObj3)->ABC[2]=r;         
          ((CMyCircle*)pObj3)->my_startpoint->m_startpoint.x=x3;
          ((CMyCircle*)pObj3)->my_startpoint->m_startpoint.y=y3;
	}    
}
///the function of ChangeNlink in order to change the function of GetConstraintList
///delete the anximity relation and remove the Nlink and copy the NlinkB;
void CDrawView::ChangeNlink(CDrawObjList *temp)
{	
	CDrawObj *pppObj,*pTempObj;
	POSITION pos,ppos,pos1;
	RELATION *rel;
	///the first step,delete the anximity relation;
	pos=GetDocument()->m_RelationList.GetHeadPosition();
    while(pos!=NULL)
	{       
	   ppos=pos;
	   rel=GetDocument()->m_RelationList.GetAt(ppos);
	   GetDocument()->m_RelationList.GetNext(pos);	  
	   if((rel->bAdjust>I_ZERO)&&(rel->bAdjust<10))
	   {
		   GetDocument()->m_RelationList.RemoveAt(ppos);
		   delete rel;
	   }       
	}
	//////////////////////////////////////////////////////////
	pos=temp->GetHeadPosition();
	while(pos!=NULL)
	{
		ppos=pos;
		pTempObj=temp->GetNext(pos);
		if(pTempObj->bDraw==I_ZERO)///öΪûģɾ
		{		
			pTempObj->bMark=0;						
			pTempObj->Nlink.RemoveAll();
			///ڴй¶
			pos1=pTempObj->NlinkB.GetHeadPosition();
			while(pos1!=NULL)
			{
				  rel=pTempObj->NlinkB.GetNext(pos1);
				  if(rel->pObjList.GetCount()>I_ZERO)
				  {
				      RELATION *pTemp_rea;
				      pTemp_rea=rel;
				      pTempObj->Nlink.AddTail(pTemp_rea);				 				  
				  }
			}			
		}
		else
		{
            pppObj=temp->GetAt(ppos);
		    temp->RemoveAt(ppos);	
			delete pppObj;				
		}
	}	
}

///úһֱߺһԲཻ㱣m_intersectionУ
int CDrawView::IntersectionLineAndCircle(CDrawObj *pObj1, CDrawObj *pObj2)
{
	if((pObj1->type==G_LINE && pObj2->type==G_CIRCLE)||(pObj1->type==G_CIRCLE&&pObj2->type==G_LINE))
	{
		CDrawObj*pObjLine,*pObjCircle;
		if(pObj1->type==G_LINE)
		{
		     pObjLine=pObj1;
			 pObjCircle=pObj2;
		}
		else
		{
		     pObjLine=pObj2;
			 pObjCircle=pObj1;
		}
		///////////////////////////////////////////////////////
		double x1,y1,x2,y2,a,b,r,dy2,dy1,dx2,dx1;
		POSITION pos,pos1,pos2,pos3;
		CDrawObj*pObjtemp,*pObjtemp1;
		RELATION*rel,*rel1;
		x1=((CMyLine*)pObjLine)->my_startpoint->m_startpoint.x;
		y1=((CMyLine*)pObjLine)->my_startpoint->m_startpoint.y;
		x2=((CMyLine*)pObjLine)->my_endpoint->m_startpoint.x;
		y2=((CMyLine*)pObjLine)->my_endpoint->m_startpoint.y;
		a=((CMyCircle*)pObjCircle)->ABC[0];
		b=((CMyCircle*)pObjCircle)->ABC[1];
		r=((CMyCircle*)pObjCircle)->ABC[2];		
		///////////////////////////////////////////////////////////
		///the first step, judge the line and the circle has the point of the intersection;
		CDrawObj*pSaveObj1,*pSaveObj2;
		int iJudge(0);
		pos=pObjLine->Nlink.GetHeadPosition();
		while(pos!=NULL)
		{
		    rel=pObjLine->Nlink.GetNext(pos);
			pos1=rel->pObjList.GetHeadPosition();
			while(pos1!=NULL)
            {
			    pObjtemp=rel->pObjList.GetNext(pos1);
				if((pObjtemp->type==G_POINT)&&(pObjtemp!=pObjLine))
				{
				     pos2=pObjtemp->Nlink.GetHeadPosition();
					 while(pos2!=NULL)
					 {
					      rel1=pObjtemp->Nlink.GetNext(pos2);
						  pos3=rel1->pObjList.GetHeadPosition();
						  while(pos3!=NULL)
						  {
						      pObjtemp1=rel1->pObjList.GetNext(pos3);
							  if(pObjtemp1==pObjCircle)
							  {
								  iJudge++;
								  if(iJudge==1)
									  pSaveObj1=pObjtemp;
								  else if(iJudge==2)
								  {
								      pSaveObj2=pObjtemp;
									  AfxMessageBox("ֱߺԲѾ");
									  return 0;
								  }
								  else
								  {}
								  break;
							  }
						  }						 
					 }
				}				
			}			
		}		
        //////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
		///solve the equation: solve({(x-a)^2+(y-b)^2=r^2,(x2-x1)/(x-x1)=(y2-y1)/(y-y1)},{x,y});//////////////////////////////////////
		double dsqrt;
		dsqrt=(2*y2*y1*y1*y1*x2*x2
			+y2*y2*y2*y2*r*r-y1*y1*y1*y1*x2*x2-y1*y1*y1*y1*a*a+y1*y1*y1*y1*r*r-4*x1*x1*y2*y2*b*y1-4*x2*x2*y1*y1*b*y2
			+2*b*y2*y2*x2*y1*x1+6*b*y2*y2*a*x1*y1-6*b*y2*y2*a*x2*y1-2*b*y2*y2*y2*x2*x1+2*b*y2*y2*y2*a*x2+6*b*y1*y1*a*x2*y2
			+2*b*y1*y1*y1*a*x1-6*b*y1*y1*a*x1*y2+2*b*y1*y1*x2*y2*x1+2*b*y2*y2*x2*x2*y1-2*b*y2*y2*y2*a*x1+2*b*y1*y1*x1*x1*y2
			-2*b*y1*y1*y1*a*x2-2*b*y1*y1*y1*x2*x1+2*b*y1*y1*y1*x2*x2+2*b*y2*y2*y2*x1*x1+2*x1*x1*b*b*y2*y1+2*y2*y2*y2*x2*y1*x1
			-2*y2*y2*y2*a*x2*y1+2*x2*x1*b*b*y2*y2-2*x2*x1*r*r*y1*y1+4*x2*x1*r*r*y2*y1-4*x2*x1*b*b*y2*y1-y2*y2*y2*y2*x1*x1
			-6*y2*y2*y2*y1*a*x1-4*y2*y2*y1*y1*x2*x1+6*y2*y2*y1*y1*a*x2-6*y2*y1*y1*y1*a*x2+4*y2*y2*y2*y1*a*a+2*y2*y2*y2*y1*x1*x1
			+6*y2*y2*y1*y1*a*x1-2*y1*y1*y1*a*y2*x1+2*y1*y1*y1*x2*y2*x1-y1*y1*y2*y2*x1*x1+2*y1*y1*y1*y1*a*x2-y2*y2*x2*x2*y1*y1
			+2*y2*y2*y2*y2*a*x1-x1*x1*b*b*y2*y2+x1*x1*r*r*y1*y1-x1*x1*b*b*y1*y1+x1*x1*r*r*y2*y2-2*x1*x1*r*r*y2*y1+2*x2*x2*b*b*y2*y1
			+2*x2*x1*b*b*y1*y1-2*x2*x2*r*r*y2*y1-2*x2*x1*r*r*y2*y2-6*y2*y2*y1*y1*a*a-4*y2*y1*y1*y1*r*r-4*y2*y2*y2*y1*r*r
			-x2*x2*b*b*y2*y2+x2*x2*r*r*y1*y1-x2*x2*b*b*y1*y1+x2*x2*r*r*y2*y2+4*y2*y1*y1*y1*a*a+6*y2*y2*y1*y1*r*r-y2*y2*y2*y2*a*a);
        if(dsqrt>0)
		{
			dy2=0.5/(-2*y2*y1-2*x2*x1+x2*x2+x1*x1+y2*y2+y1*y1)*(2*b*y1*y1+2*b*y2*y2+2*x2*x2*y1+2*x1*x1*y2
				-2*a*x2*y1-2*a*x1*y2-2*x2*y2*x1-2*x2*y1*x1+2*a*x2*y2+2*a*x1*y1-4*b*y2*y1+2*sqrt(dsqrt));
			dy1=0.5/(-2*y2*y1-2*x2*x1+x2*x2+x1*x1+y2*y2+y1*y1)*(2*b*y1*y1+2*b*y2*y2+2*x2*x2*y1+2*x1*x1*y2
				-2*a*x2*y1-2*a*x1*y2-2*x2*y2*x1-2*x2*y1*x1+2*a*x2*y2+2*a*x1*y1-4*b*y2*y1-2*sqrt(dsqrt));
			dx1=(x2*dy1-x2*y1-x1*dy1+y2*x1)/(y2-y1);
			dx2=(x2*dy2-x2*y1-x1*dy2+y2*x1)/(y2-y1);
			///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
			double dis1,dis2;
			if(iJudge==0)///simple no intersection of the line and the circle;so we seek the nearest point;
			{		
				dis1=sqrt((dy1-y1)*(dy1-y1)+(dx1-x1)*(dx1-x1))+sqrt((dy1-y2)*(dy1-y2)+(dx1-x2)*(dx1-x2));
				dis2=sqrt((dy2-y1)*(dy2-y1)+(dx2-x1)*(dx2-x1))+sqrt((dy2-y2)*(dy2-y2)+(dx2-x2)*(dx2-x2));
				if(dis1>dis2)
				{
					 m_intersection=new CMyPoint(intersection);	            
					 m_intersection->m_startpoint.x=dx2;
					 m_intersection->m_startpoint.y=dy2;
				}
				else
				{
					 m_intersection=new CMyPoint(intersection);		       
					 m_intersection->m_startpoint.x=dx1;
					 m_intersection->m_startpoint.y=dy1;
				}
			}
			else
			{
				double dx,dy;
				dx=((CMyPoint*)pSaveObj1)->m_startpoint.x;
				dy=((CMyPoint*)pSaveObj1)->m_startpoint.y;
				dis1=sqrt((dy1-dy)*(dy1-dy)+(dx1-dx)*(dx1-dx));
				dis2=sqrt((dy2-dy)*(dy2-dy)+(dx2-dx)*(dx2-dx));
				if(dis1>dis2)
				{
					 m_intersection=new CMyPoint(intersection);		       
					 m_intersection->m_startpoint.x=dx1;
					 m_intersection->m_startpoint.y=dy1;
				}
				else
				{
					 m_intersection=new CMyPoint(intersection);		       
					 m_intersection->m_startpoint.x=dx2;
					 m_intersection->m_startpoint.y=dy2;
				}
			}
		}
		else
		{
		     AfxMessageBox("ûн");
			 return 0;
		}
	}
	return 1;
}

/////ͼεƽƲ
void CDrawView::OnTransfer(CPoint point)
{
	//////////////////////////////////////////////
	POSITION pos;
	CPoint local = point;
	ClientToDoc(local);

	CDrawTool::c_drawShape=selection;
	if(m_Dragging)
	{
		 int dx,dy;
		 dx=local.x-m_PointOld.x;
		 dy=local.y-m_PointOld.y;
         pos=GetDocument()->GetObjects()->GetHeadPosition();
		 while(pos!=NULL)
		 {
			 CDrawObj*pObj=GetDocument()->GetObjects()->GetNext(pos);
             if(pObj->type==G_POINT)
			 {
				   ((CMyPoint*)pObj)->m_startpoint.x+=dx;
                   ((CMyPoint*)pObj)->m_startpoint.y+=dy;
			 }
			 else if(pObj->type==G_CIRCLE)
			 {
				   ((CMyCircle*)pObj)->ABC[0]=((CMyCircle*)pObj)->my_startpoint->m_startpoint.x;
                   ((CMyCircle*)pObj)->ABC[1]=((CMyCircle*)pObj)->my_startpoint->m_startpoint.y;
			 }
		 }
		 m_PointOld=local;
	 }	 
}
///ͼת
void CDrawView::OnRotate(CPoint point)
{
    //////////////////////////////////////////////
	POSITION pos;
	CPoint local = point;
	ClientToDoc(local);
    CDrawTool::c_drawShape=selection;
    if(m_Dragging)
	{
		  double dtempx,dtempy,angle,dx0,dy0,dx1,dy1,dx2,dy2,dx3,dy3,da,db,dc,dx,dy;
		  ///ɻõתǡ
		  int icount(0);
		  dtempx=0;
		  dtempy=0;
		  pos=GetDocument()->GetObjects()->GetHeadPosition();
		  while(pos!=NULL)
		  {
			   CDrawObj*pObj=GetDocument()->GetObjects()->GetNext(pos);
			   if(pObj->type==G_POINT)
			   {
				     dtempx+=((CMyPoint*)pObj)->m_startpoint.x;
					 dtempy+=((CMyPoint*)pObj)->m_startpoint.y;
					 icount++;
			   }
		  }
		  dx1=dtempx/icount;
		  dy1=dtempy/icount;
		  dx2=m_PointOld.x;
		  dy2=m_PointOld.y;
		  dx3=local.x;
		  dy3=local.y;
		  da=sqrt((dx3-dx2)*(dx3-dx2)+(dy3-dy2)*(dy3-dy2));
		  db=sqrt((dx2-dx1)*(dx2-dx1)+(dy2-dy1)*(dy2-dy1));
		  dc=sqrt((dx3-dx1)*(dx3-dx1)+(dy3-dy1)*(dy3-dy1));
		  if((db>5)&&(dc>5)&&(da>5))
		  {
			  angle=acos((db*db+dc*dc-da*da)/(2*db*dc));
			  angle=-angle;
			  pos=GetDocument()->GetObjects()->GetHeadPosition();
			  while(pos!=NULL)
			  {
				  CDrawObj*pObj=GetDocument()->GetObjects()->GetNext(pos);
				  if(pObj->type==G_POINT)
				  {							   
					   dx=((CMyPoint*)pObj)->m_startpoint.x;
					   dy=((CMyPoint*)pObj)->m_startpoint.y;
					   dx=dx-dx1;
					   dy=dy-dy1;
					   dx0=dx*cos(angle)-dy*sin(angle);
					   dy0=dx*sin(angle)+dy*cos(angle);
					   dx=dx0+dx1;
					   dy=dy0+dy1;
					   ((CMyPoint*)pObj)->m_startpoint.x=dx;
					   ((CMyPoint*)pObj)->m_startpoint.y=dy;							
				  }
				  else if(pObj->type==G_CIRCLE)
				  {
					  ((CMyCircle*)pObj)->ABC[0]=((CMyCircle*)pObj)->my_startpoint->m_startpoint.x;
					  ((CMyCircle*)pObj)->ABC[1]=((CMyCircle*)pObj)->my_startpoint->m_startpoint.y;
				  }
			  }					  
			  m_PointOld=local;
		  }
	 }
}
///ͼεŲ
void CDrawView::OnZoom(CPoint point)
{
	 //////////////////////////////////////////////
	POSITION pos;
	CPoint local = point;
	ClientToDoc(local);
	///////////////////////////////////////////////
    CDrawTool::c_drawShape=selection;		 
	if(m_Dragging)
	{
		   double dtempx,dtempy,dx,dy,dx0,dy0,dx1,dy1,dx2,dy2,dx3,dy3,da,dr1,dr2;
		   int icount(0);
		   dtempx=0.0;
		   dtempy=0.0;
		   pos=GetDocument()->GetObjects()->GetHeadPosition();
		   while(pos!=NULL)
		   {
			   CDrawObj*pObj=GetDocument()->GetObjects()->GetNext(pos);
			   if(pObj->type==G_POINT)
			   {
				   dtempx+=((CMyPoint*)pObj)->m_startpoint.x;
				   dtempy+=((CMyPoint*)pObj)->m_startpoint.y;
				   icount++;
			   }
		   }
		   dx1=dtempx/icount;
		   dy1=dtempy/icount;
		   dx2=m_PointOld.x;
		   dy2=m_PointOld.y;
		   dx3=local.x;
		   dy3=local.y;
		   dr1=sqrt((dx2-dx1)*(dx2-dx1)+(dy2-dy1)*(dy2-dy1));
		   dr2=sqrt((dx3-dx1)*(dx3-dx1)+(dy3-dy1)*(dy3-dy1));
		   da=dr2/dr1;
		   if((dr1>10)&&(dr2>10))
		   {
			   pos=GetDocument()->GetObjects()->GetHeadPosition();
			   while(pos!=NULL)
			   {
				   CDrawObj*pObj=GetDocument()->GetObjects()->GetNext(pos);
				   if(pObj->type==G_POINT)
				   {
						 dx=((CMyPoint*)pObj)->m_startpoint.x;
						 dy=((CMyPoint*)pObj)->m_startpoint.y;
						 dx=dx-dx1;
						 dy=dy-dy1;
						 dx0=dx*da;
						 dy0=dy*da;
						 dx=dx0+dx1;
						 dy=dy0+dy1;
						 ((CMyPoint*)pObj)->m_startpoint.x=dx;
						 ((CMyPoint*)pObj)->m_startpoint.y=dy;
				   }
				   else if(pObj->type==G_CIRCLE)
				   {
					   ((CMyCircle*)pObj)->ABC[0]=((CMyCircle*)pObj)->my_startpoint->m_startpoint.x;
					   ((CMyCircle*)pObj)->ABC[1]=((CMyCircle*)pObj)->my_startpoint->m_startpoint.y;
					   double dd;
					   dd=((CMyCircle*)pObj)->ABC[2];
					   ((CMyCircle*)pObj)->ABC[2]=dd*da;
				   }
			   }
			   m_PointOld=local;
		   }
	  }	 	
}
